/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/base/common/arrays","vs/base/common/network","vs/base/common/resources","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/json","vs/base/common/process","os","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/base/common/jsonEdit","vs/base/common/map","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/files/common/watcher","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","path","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(J){for(var e=[],T=0,_=J.length;T<_;T++)e[T]=te[J[T]];return e};define(te[99],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function T(_,D){if(!_)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=T}),define(te[66],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const T=Object.prototype.hasOwnProperty;function _(I){const C=[];for(let d in I)T.call(I,d)&&C.push(I[d]);return C}e.values=_;function D(I,C){for(let d in I)if(T.call(I,d)&&C({key:d,value:I[d]},function(){delete I[d]})===!1)return}e.forEach=D;function L(I,C){const d=Object.create(null);for(const m of I){const u=C(m);let S=d[u];S||(S=d[u]=[]),S.push(m)}return d}e.groupBy=L;function i(I){const C=Object.create(null);return I&&I.forEach((d,m)=>{C[m]=d}),C}e.fromMap=i;function R(I,C){const d=[],m=[];for(let u of I)C.has(u)||d.push(u);for(let u of C)I.has(u)||m.push(u);return{removed:d,added:m}}e.diffSets=R;function E(I,C){const d=[],m=[];for(let[u,S]of I)C.has(u)||d.push(S);for(let[u,S]of C)I.has(u)||m.push(S);return{removed:d,added:m}}e.diffMaps=E;class b{constructor(){this.map=new Map}add(C,d){let m=this.map.get(C);m||(m=new Set,this.map.set(C,m)),m.add(d)}delete(C,d){const m=this.map.get(C);!m||(m.delete(d),m.size===0&&this.map.delete(C))}forEach(C,d){const m=this.map.get(C);!m||m.forEach(d)}}e.SetMap=b}),define(te[67],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function T(i){return(R,E,b)=>{let I=null,C=null;if(typeof b.value=="function"?(I="value",C=b.value):typeof b.get=="function"&&(I="get",C=b.get),!C)throw new Error("not supported");b[I]=i(C,E)}}e.createDecorator=T;function _(i,R,E){let b=null,I=null;if(typeof E.value=="function"?(b="value",I=E.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(b="get",I=E.get),!I)throw new Error("not supported");const C=`$memoize$${R}`;E[b]=function(...d){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,d)}),this[C]}}e.memoize=_;function D(i,R,E){return T((b,I)=>{const C=`$debounce$${I}`,d=`$debounce$result$${I}`;return function(...m){this[d]||(this[d]=E?E():void 0),clearTimeout(this[C]),R&&(this[d]=R(this[d],...m),m=[this[d]]),this[C]=setTimeout(()=>{b.apply(this,m),this[d]=E?E():void 0},i)}})}e.debounce=D;function L(i,R,E){return T((b,I)=>{const C=`$throttle$timer$${I}`,d=`$throttle$result$${I}`,m=`$throttle$lastRun$${I}`,u=`$throttle$pending$${I}`;return function(...S){if(this[d]||(this[d]=E?E():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),R&&(this[d]=R(this[d],...S)),this[u])return;const v=this[m]+i;v<=Date.now()?(this[m]=Date.now(),b.apply(this,[this[d]]),this[d]=E?E():void 0):(this[u]=!0,this[C]=setTimeout(()=>{this[u]=!1,this[m]=Date.now(),b.apply(this,[this[d]]),this[d]=E?E():void 0},v-Date.now()))}})}e.throttle=L}),define(te[7],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class T{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(a=>{a(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=T,e.errorHandler=new T;function _(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=_;function D(l){E(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function L(l){E(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=L;function i(l){if(l instanceof Error){let{name:r,message:a}=l;const n=l.stacktrace||l.stack;return{$isError:!0,name:r,message:a,stack:n}}return l}e.transformErrorForSerialization=i;const R="Canceled";function E(l){return l instanceof Error&&l.name===R&&l.message===R}e.isPromiseCanceledError=E;class b extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=b;function I(){const l=new Error(R);return l.name=l.message,l}e.canceled=I;function C(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=C;function d(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=d;function m(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function u(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}e.disposed=u;function S(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=S;class v extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=v;class g extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=g;class y extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=y;function f(l){const r=l;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=f;function c(l,r=Object.create(null)){const a=new Error(l);return r.actions&&(a.actions=r.actions),a}e.createErrorWithActions=c}),define(te[16],ne([0,1,7]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function _(U,N=0){return U[U.length-(1+N)]}e.tail=_;function D(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=D;function L(U,N,W=(V,G)=>V===G){if(U===N)return!0;if(!U||!N||U.length!==N.length)return!1;for(let V=0,G=U.length;V<G;V++)if(!W(U[V],N[V]))return!1;return!0}e.equals=L;function i(U,N,W){let V=0,G=U.length-1;for(;V<=G;){const ee=(V+G)/2|0,H=W(U[ee],N);if(H<0)V=ee+1;else if(H>0)G=ee-1;else return ee}return-(V+1)}e.binarySearch=i;function R(U,N){let W=0,V=U.length;if(V===0)return 0;for(;W<V;){const G=Math.floor((W+V)/2);N(U[G])?V=G:W=G+1}return W}e.findFirstInSorted=R;function E(U,N,W){if(U=U|0,U>=N.length)throw new TypeError("invalid index");let V=N[Math.floor(N.length*Math.random())],G=[],ee=[],H=[];for(let Q of N){const re=W(Q,V);re<0?G.push(Q):re>0?ee.push(Q):H.push(Q)}return U<G.length?E(U,G,W):U<G.length+H.length?H[0]:E(U-(G.length+H.length),ee,W)}e.quickSelect=E;function b(U,N){const W=[];let V;for(const G of U.slice(0).sort(N))!V||N(V[0],G)!==0?(V=[G],W.push(V)):V.push(G);return W}e.groupBy=b;function I(U,N,W){const V=[];function G(Q,re,oe){if(re===0&&oe.length===0)return;const ce=V[V.length-1];ce&&ce.start+ce.deleteCount===Q?(ce.deleteCount+=re,ce.toInsert.push(...oe)):V.push({start:Q,deleteCount:re,toInsert:oe})}let ee=0,H=0;for(;;){if(ee===U.length){G(ee,0,N.slice(H));break}if(H===N.length){G(ee,U.length-ee,[]);break}const Q=U[ee],re=N[H],oe=W(Q,re);oe===0?(ee+=1,H+=1):oe<0?(G(ee,1,[]),ee+=1):oe>0&&(G(ee,0,[re]),H+=1)}return V}e.sortedDiff=I;function C(U,N,W){const V=I(U,N,W),G=[],ee=[];for(const H of V)G.push(...U.slice(H.start,H.start+H.deleteCount)),ee.push(...H.toInsert);return{removed:G,added:ee}}e.delta=C;function d(U,N,W){if(W===0)return[];const V=U.slice(0,W).sort(N);return u(U,N,V,W,U.length),V}e.top=d;function m(U,N,W,V,G){return W===0?Promise.resolve([]):new Promise((ee,H)=>{(async()=>{const Q=U.length,re=U.slice(0,W).sort(N);for(let oe=W,ce=Math.min(W+V,Q);oe<Q;oe=ce,ce=Math.min(ce+V,Q)){if(oe>W&&await new Promise(he=>setTimeout(he)),G&&G.isCancellationRequested)throw(0,T.canceled)();u(U,N,re,oe,ce)}return re})().then(ee,H)})}e.topAsync=m;function u(U,N,W,V,G){for(const ee=W.length;V<G;V++){const H=U[V];if(N(H,W[ee-1])<0){W.pop();const Q=R(W,re=>N(H,re)<0);W.splice(Q,0,H)}}}function S(U){return U.filter(N=>!!N)}e.coalesce=S;function v(U){let N=0;for(let W=0;W<U.length;W++)U[W]&&(U[N]=U[W],N+=1);U.length=N}e.coalesceInPlace=v;function g(U,N,W){U.splice(W,0,U.splice(N,1)[0])}e.move=g;function y(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=y;function f(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=f;function c(U,N=W=>W){const W=new Set;return U.filter(V=>{const G=N(V);return W.has(G)?!1:(W.add(G),!0)})}e.distinct=c;function l(U){const N=Object.create(null);return W=>{const V=U(W);return N[V]?!1:(N[V]=!0,!0)}}e.uniqueFilter=l;function r(U,N){const W=a(U,N);if(W!==-1)return U[W]}e.findLast=r;function a(U,N){for(let W=U.length-1;W>=0;W--){const V=U[W];if(N(V))return W}return-1}e.lastIndex=a;function n(U,N){return U.length>0?U[0]:N}e.firstOrDefault=n;function t(U,N,W=(V,G)=>V===G){let V=0;for(let G=0,ee=Math.min(U.length,N.length);G<ee&&W(U[G],N[G]);G++)V++;return V}e.commonPrefixLength=t;function s(U){return[].concat(...U)}e.flatten=s;function o(U,N){let W=typeof N=="number"?U:0;typeof N=="number"?W=U:(W=0,N=U);const V=[];if(W<=N)for(let G=W;G<N;G++)V.push(G);else for(let G=W;G>N;G--)V.push(G);return V}e.range=o;function h(U,N,W){return U.reduce((V,G)=>(V[N(G)]=W?W(G):G,V),Object.create(null))}e.index=h;function p(U,N){return U.push(N),()=>w(U,N)}e.insert=p;function w(U,N){const W=U.indexOf(N);if(W>-1)return U.splice(W,1),N}e.remove=w;function P(U,N,W){const V=U.slice(0,N),G=U.slice(N);return V.concat(W,G)}e.arrayInsert=P;function M(U,N){let W;if(typeof N=="number"){let V=N;W=()=>{const G=Math.sin(V++)*179426549;return G-Math.floor(G)}}else W=Math.random;for(let V=U.length-1;V>0;V-=1){const G=Math.floor(W()*(V+1)),ee=U[V];U[V]=U[G],U[G]=ee}}e.shuffle=M;function O(U,N){const W=U.indexOf(N);W>-1&&(U.splice(W,1),U.unshift(N))}e.pushToStart=O;function q(U,N){const W=U.indexOf(N);W>-1&&(U.splice(W,1),U.push(N))}e.pushToEnd=q;function $(U,N){return Array.isArray(U)?U.map(N):N(U)}e.mapArrayOrNot=$;function k(U){return Array.isArray(U)?U:[U]}e.asArray=k;function z(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=z;function A(U,N){for(const W of U){const V=N(W);if(V!==void 0)return V}}e.mapFind=A;function F(U,N,W){const V=Z(U,N),G=U.length,ee=W.length;U.length=G+ee;for(let H=G-1;H>=V;H--)U[H+ee]=U[H];for(let H=0;H<ee;H++)U[H+V]=W[H]}e.insertInto=F;function x(U,N,W,V){const G=Z(U,N),ee=U.splice(G,W);return F(U,G,V),ee}e.splice=x;function Z(U,N){return N<0?Math.max(N+U.length,0):Math.min(N,U.length)}function B(U,N){let W=Number.MAX_SAFE_INTEGER,V=0;return U.forEach((G,ee)=>{const H=N(G);H<W&&(W=H,V=ee)}),V}e.minIndex=B;function j(U,N){let W=Number.MIN_SAFE_INTEGER,V=0;return U.forEach((G,ee)=>{const H=N(G);H>W&&(W=H,V=ee)}),V}e.maxIndex=j;class X{constructor(N){this.items=N,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(N){let W=this.firstIdx;for(;W<this.items.length&&N(this.items[W]);)W++;const V=W===this.firstIdx?null:this.items.slice(this.firstIdx,W);return this.firstIdx=W,V}takeFromEndWhile(N){let W=this.lastIdx;for(;W>=0&&N(this.items[W]);)W--;const V=W===this.lastIdx?null:this.items.slice(W+1,this.lastIdx+1);return this.lastIdx=W,V}peek(){return this.items[this.firstIdx]}dequeue(){const N=this.items[this.firstIdx];return this.firstIdx++,N}takeCount(N){const W=this.items.slice(this.firstIdx,this.firstIdx+N);return this.firstIdx+=N,W}}e.ArrayQueue=X}),define(te[68],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function T(_){const D=this;let L=!1,i;return function(){return L||(L=!0,i=_.apply(D,arguments)),i}}e.once=T}),define(te[54],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var T;(function(_){function D(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}_.is=D;const L=Object.freeze([]);function i(){return L}_.empty=i;function*R(l){yield l}_.single=R;function E(l){return l||L}_.from=E;function b(l){return!l||l[Symbol.iterator]().next().done===!0}_.isEmpty=b;function I(l){return l[Symbol.iterator]().next().value}_.first=I;function C(l,r){for(const a of l)if(r(a))return!0;return!1}_.some=C;function d(l,r){for(const a of l)if(r(a))return a}_.find=d;function*m(l,r){for(const a of l)r(a)&&(yield a)}_.filter=m;function*u(l,r){let a=0;for(const n of l)yield r(n,a++)}_.map=u;function*S(...l){for(const r of l)for(const a of r)yield a}_.concat=S;function*v(l){for(const r of l)for(const a of r)yield a}_.concatNested=v;function g(l,r,a){let n=a;for(const t of l)n=r(n,t);return n}_.reduce=g;function*y(l,r,a=l.length){for(r<0&&(r+=l.length),a<0?a+=l.length:a>l.length&&(a=l.length);r<a;r++)yield l[r]}_.slice=y;function f(l,r=Number.POSITIVE_INFINITY){const a=[];if(r===0)return[a,l];const n=l[Symbol.iterator]();for(let t=0;t<r;t++){const s=n.next();if(s.done)return[a,_.empty()];a.push(s.value)}return[a,{[Symbol.iterator](){return n}}]}_.consume=f;function c(l,r,a=(n,t)=>n===t){const n=l[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const s=n.next(),o=t.next();if(s.done!==o.done)return!1;if(s.done)return!0;if(!a(s.value,o.value))return!1}}_.equals=c})(T=e.Iterable||(e.Iterable={}))}),define(te[31],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(T=e.ScanError||(e.ScanError={}));var _;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(_=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(r){r.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function i(r,a=!1){let n=0,t=r.length,s="",o=0,h=16,p=0;function w(z){let A=0,F=0;for(;A<z;){const x=r.charCodeAt(n);if(x>=48&&x<=57)F=F*16+x-48;else if(x>=65&&x<=70)F=F*16+x-65+10;else if(x>=97&&x<=102)F=F*16+x-97+10;else break;n++,A++}return A<z&&(F=-1),F}function P(z){n=z,s="",o=0,h=16,p=0}function M(){const z=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&b(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&b(r.charCodeAt(n)))for(n++;n<r.length&&b(r.charCodeAt(n));)n++;else return p=3,r.substring(z,n);let A=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&b(r.charCodeAt(n))){for(n++;n<r.length&&b(r.charCodeAt(n));)n++;A=n}else p=3;return r.substring(z,A)}function O(){let z="",A=n;for(;;){if(n>=t){z+=r.substring(A,n),p=2;break}const F=r.charCodeAt(n);if(F===34){z+=r.substring(A,n),n++;break}if(F===92){if(z+=r.substring(A,n),n++,n>=t){p=2;break}switch(r.charCodeAt(n++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const Z=w(4);Z>=0?z+=String.fromCharCode(Z):p=4;break;default:p=5}A=n;continue}if(F>=0&&F<=31)if(E(F)){z+=r.substring(A,n),p=2;break}else p=6;n++}return z}function q(){if(s="",p=0,o=n,n>=t)return o=t,h=17;let z=r.charCodeAt(n);if(R(z)){do n++,s+=String.fromCharCode(z),z=r.charCodeAt(n);while(R(z));return h=15}if(E(z))return n++,s+=String.fromCharCode(z),z===13&&r.charCodeAt(n)===10&&(n++,s+=`
`),h=14;switch(z){case 123:return n++,h=1;case 125:return n++,h=2;case 91:return n++,h=3;case 93:return n++,h=4;case 58:return n++,h=6;case 44:return n++,h=5;case 34:return n++,s=O(),h=10;case 47:const A=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<t&&!E(r.charCodeAt(n));)n++;return s=r.substring(A,n),h=12}if(r.charCodeAt(n+1)===42){n+=2;const F=t-1;let x=!1;for(;n<F;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,p=1),s=r.substring(A,n),h=13}return s+=String.fromCharCode(z),n++,h=16;case 45:if(s+=String.fromCharCode(z),n++,n===t||!b(r.charCodeAt(n)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=M(),h=11;default:for(;n<t&&$(z);)n++,z=r.charCodeAt(n);if(o!==n){switch(s=r.substring(o,n),s){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return s+=String.fromCharCode(z),n++,h=16}}function $(z){if(R(z)||E(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function k(){let z;do z=q();while(z>=12&&z<=15);return z}return{setPosition:P,getPosition:()=>n,scan:a?k:q,getToken:()=>h,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>p}}e.createScanner=i;function R(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function E(r){return r===10||r===13||r===8232||r===8233}function b(r){return r>=48&&r<=57}var I;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(I||(I={}));function C(r,a){const n=[],t=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function p(w,P,M,O){o.value=w,o.offset=P,o.length=M,o.type=O,o.colonOffset=void 0,s=o}try{f(r,{onObjectBegin:(w,P)=>{if(a<=w)throw t;s=void 0,h=a>w,n.push("")},onObjectProperty:(w,P,M)=>{if(a<P||(p(w,P,M,"property"),n[n.length-1]=w,a<=P+M))throw t},onObjectEnd:(w,P)=>{if(a<=w)throw t;s=void 0,n.pop()},onArrayBegin:(w,P)=>{if(a<=w)throw t;s=void 0,n.push(0)},onArrayEnd:(w,P)=>{if(a<=w)throw t;s=void 0,n.pop()},onLiteralValue:(w,P,M)=>{if(a<P||(p(w,P,M,l(w)),a<=P+M))throw t},onSeparator:(w,P,M)=>{if(a<=P)throw t;if(w===":"&&s&&s.type==="property")s.colonOffset=P,h=!1,s=void 0;else if(w===","){const O=n[n.length-1];typeof O=="number"?n[n.length-1]=O+1:(h=!0,n[n.length-1]=""),s=void 0}}})}catch(w){if(w!==t)throw w}return{path:n,previousNode:s,isAtPropertyKey:h,matches:w=>{let P=0;for(let M=0;P<w.length&&M<n.length;M++)if(w[P]===n[M]||w[P]==="*")P++;else if(w[P]!=="**")return!1;return P===w.length}}}e.getLocation=C;function d(r,a=[],n=L.DEFAULT){let t=null,s=[];const o=[];function h(w){Array.isArray(s)?s.push(w):t!==null&&(s[t]=w)}return f(r,{onObjectBegin:()=>{const w={};h(w),o.push(s),s=w,t=null},onObjectProperty:w=>{t=w},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const w=[];h(w),o.push(s),s=w,t=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:h,onError:(w,P,M)=>{a.push({error:w,offset:P,length:M})}},n),s[0]}e.parse=d;function m(r,a=[],n=L.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(w){t.type==="property"&&(t.length=w-t.offset,t=t.parent)}function o(w){return t.children.push(w),w}f(r,{onObjectBegin:w=>{t=o({type:"object",offset:w,length:-1,parent:t,children:[]})},onObjectProperty:(w,P,M)=>{t=o({type:"property",offset:P,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:w,offset:P,length:M,parent:t})},onObjectEnd:(w,P)=>{t.length=w+P-t.offset,t=t.parent,s(w+P)},onArrayBegin:(w,P)=>{t=o({type:"array",offset:w,length:-1,parent:t,children:[]})},onArrayEnd:(w,P)=>{t.length=w+P-t.offset,t=t.parent,s(w+P)},onLiteralValue:(w,P,M)=>{o({type:l(w),offset:P,length:M,parent:t,value:w}),s(P+M)},onSeparator:(w,P,M)=>{t.type==="property"&&(w===":"?t.colonOffset=P:w===","&&s(P))},onError:(w,P,M)=>{a.push({error:w,offset:P,length:M})}},n);const p=t.children[0];return p&&delete p.parent,p}e.parseTree=m;function u(r,a){if(!r)return;let n=r;for(let t of a)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===t){n=o.children[1],s=!0;break}if(!s)return}else{const s=t;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=u;function S(r){if(!r.parent||!r.parent.children)return[];const a=S(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;a.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&a.push(n)}return a}e.getNodePath=S;function v(r){switch(r.type){case"array":return r.children.map(v);case"object":const a=Object.create(null);for(let n of r.children){const t=n.children[1];t&&(a[n.children[0].value]=v(t))}return a;case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=v;function g(r,a,n=!1){return a>=r.offset&&a<r.offset+r.length||n&&a===r.offset+r.length}e.contains=g;function y(r,a,n=!1){if(g(r,a,n)){const t=r.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=a;s++){const o=y(t[s],a,n);if(o)return o}return r}}e.findNodeAtOffset=y;function f(r,a,n=L.DEFAULT){const t=i(r,!1);function s(W){return W?()=>W(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(W){return W?V=>W(V,t.getTokenOffset(),t.getTokenLength()):()=>!0}const h=s(a.onObjectBegin),p=o(a.onObjectProperty),w=s(a.onObjectEnd),P=s(a.onArrayBegin),M=s(a.onArrayEnd),O=o(a.onLiteralValue),q=o(a.onSeparator),$=s(a.onComment),k=o(a.onError),z=n&&n.disallowComments,A=n&&n.allowTrailingComma;function F(){for(;;){const W=t.scan();switch(t.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:z||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(W){case 12:case 13:z?x(10):$();break;case 16:x(1);break;case 15:case 14:break;default:return W}}}function x(W,V=[],G=[]){if(k(W),V.length+G.length>0){let ee=t.getToken();for(;ee!==17;){if(V.indexOf(ee)!==-1){F();break}else if(G.indexOf(ee)!==-1)break;ee=F()}}}function Z(W){const V=t.getTokenValue();return W?O(V):p(V),F(),!0}function B(){switch(t.getToken()){case 11:let W=0;try{W=JSON.parse(t.getTokenValue()),typeof W!="number"&&(x(2),W=0)}catch(V){x(2)}O(W);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return F(),!0}function j(){return t.getToken()!==10?(x(3,[],[2,5]),!1):(Z(!1),t.getToken()===6?(q(":"),F(),N()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function X(){h(),F();let W=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(W||x(4,[],[]),q(","),F(),t.getToken()===2&&A)break}else W&&x(6,[],[]);j()||x(4,[],[2,5]),W=!0}return w(),t.getToken()!==2?x(7,[2],[]):F(),!0}function U(){P(),F();let W=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(W||x(4,[],[]),q(","),F(),t.getToken()===4&&A)break}else W&&x(6,[],[]);N()||x(4,[],[4,5]),W=!0}return M(),t.getToken()!==4?x(8,[4],[]):F(),!0}function N(){switch(t.getToken()){case 3:return U();case 1:return X();case 10:return Z(!0);default:return B()}}return F(),t.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):N()?(t.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.visit=f;function c(r,a){let n=i(r),t=[],s,o=0,h;do switch(h=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:o!==h&&t.push(r.substring(o,h)),a!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,a)),o=n.getPosition();break}while(s!==17);return t.join("")}e.stripComments=c;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(te[48],ne([0,1,31]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function _(E,b,I){let C,d,m,u,S;if(b){for(u=b.offset,S=u+b.length,m=u;m>0&&!R(E,m-1);)m--;let o=S;for(;o<E.length&&!R(E,o);)o++;d=E.substring(m,o),C=L(d,I)}else d=E,C=0,m=0,u=0,S=E.length;const v=i(I,E);let g=!1,y=0,f;I.insertSpaces?f=D(" ",I.tabSize||4):f="	";const c=(0,T.createScanner)(d,!1);let l=!1;function r(){return v+D(f,C+y)}function a(){let o=c.scan();for(g=!1;o===15||o===14;)g=g||o===14,o=c.scan();return l=o===16||c.getTokenError()!==0,o}const n=[];function t(o,h,p){!l&&h<S&&p>u&&E.substring(h,p)!==o&&n.push({offset:h,length:p-h,content:o})}let s=a();if(s!==17){const o=c.getTokenOffset()+m,h=D(f,C);t(h,m,o)}for(;s!==17;){let o=c.getTokenOffset()+c.getTokenLength()+m,h=a(),p="";for(;!g&&(h===12||h===13);){const P=c.getTokenOffset()+m;t(" ",o,P),o=c.getTokenOffset()+c.getTokenLength()+m,p=h===12?r():"",h=a()}if(h===2)s!==1&&(y--,p=r());else if(h===4)s!==3&&(y--,p=r());else{switch(s){case 3:case 1:y++,p=r();break;case 5:case 12:p=r();break;case 13:g?p=r():p=" ";break;case 6:p=" ";break;case 10:if(h===6){p="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?p=" ":h!==5&&h!==17&&(l=!0);break;case 16:l=!0;break}g&&(h===12||h===13)&&(p=r())}const w=c.getTokenOffset()+m;t(p,o,w),s=h}return n}e.format=_;function D(E,b){let I="";for(let C=0;C<b;C++)I+=E;return I}function L(E,b){let I=0,C=0;const d=b.tabSize||4;for(;I<E.length;){const m=E.charAt(I);if(m===" ")C++;else if(m==="	")C+=d;else break;I++}return Math.floor(C/d)}function i(E,b){for(let I=0;I<b.length;I++){const C=b.charAt(I);if(C==="\r")return I+1<b.length&&b.charAt(I+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=i;function R(E,b){return`\r
`.indexOf(E.charAt(b))!==-1}e.isEOL=R}),define(te[39],ne([0,1,31,48]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(b,I,C){return L(b,I,void 0,C)}e.removeProperty=D;function L(b,I,C,d,m){const u=I.slice(),S=[],v=(0,T.parseTree)(b,S);let g,y;for(;u.length>0&&(y=u.pop(),g=(0,T.findNodeAtLocation)(v,u),g===void 0&&C!==void 0);)typeof y=="string"?C={[y]:C}:C=[C];if(g)if(g.type==="object"&&typeof y=="string"&&Array.isArray(g.children)){const f=(0,T.findNodeAtLocation)(g,[y]);if(f!==void 0)if(C===void 0){if(!f.parent)throw new Error("Malformed AST");const c=g.children.indexOf(f.parent);let l,r=f.parent.offset+f.parent.length;if(c>0){const a=g.children[c-1];l=a.offset+a.length}else l=g.offset+1,g.children.length>1&&(r=g.children[1].offset);return i(b,{offset:l,length:r-l,content:""},d)}else return i(b,{offset:f.offset,length:f.length,content:JSON.stringify(C)},d);else{if(C===void 0)return[];const c=`${JSON.stringify(y)}: ${JSON.stringify(C)}`,l=m?m(g.children.map(a=>a.children[0].value)):g.children.length;let r;if(l>0){const a=g.children[l-1];r={offset:a.offset+a.length,length:0,content:","+c}}else g.children.length===0?r={offset:g.offset+1,length:0,content:c}:r={offset:g.offset+1,length:0,content:c+","};return i(b,r,d)}}else if(g.type==="array"&&typeof y=="number"&&Array.isArray(g.children))if(C!==void 0){const f=`${JSON.stringify(C)}`;let c;if(g.children.length===0||y===0)c={offset:g.offset+1,length:0,content:g.children.length===0?f:f+","};else{const l=y===-1||y>g.children.length?g.children.length:y,r=g.children[l-1];c={offset:r.offset+r.length,length:0,content:","+f}}return i(b,c,d)}else{const f=y,c=g.children[f];let l;if(g.children.length===1)l={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===f){const r=g.children[f-1],a=r.offset+r.length,n=g.offset+g.length;l={offset:a,length:n-2-a,content:""}}else l={offset:c.offset,length:g.children[f+1].offset-c.offset,content:""};return i(b,l,d)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${g.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return i(b,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(C)},d)}}e.setProperty=L;function i(b,I,C){let d=R(b,I),m=I.offset,u=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;m>0&&!(0,_.isEOL)(d,m-1);)m--;for(;u<d.length&&!(0,_.isEOL)(d,u);)u++}const S=(0,_.format)(d,{offset:m,length:u-m},C);for(let g=S.length-1;g>=0;g--){const y=S[g];d=R(d,y),m=Math.min(m,y.offset),u=Math.max(u,y.offset+y.length),u+=y.content.length-y.length}const v=b.length-(d.length-u)-m;return[{offset:m,length:v,content:d.substring(m,u)}]}e.withFormatting=i;function R(b,I){return b.substring(0,I.offset)+I.content+b.substring(I.offset+I.length)}e.applyEdit=R;function E(b,I){let C=I.slice(0).sort((m,u)=>{const S=m.offset-u.offset;return S===0?m.length-u.length:S}),d=b.length;for(let m=C.length-1;m>=0;m--){let u=C[m];if(u.offset+u.length<=d)b=R(b,u);else throw new Error("Overlapping edit");d=u.offset}return b}e.applyEdits=E}),define(te[2],ne([0,1,68,54]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let L=null;function i(t){L=t}if(e.setDisposableTracker=i,D){const t="__is_disposable_tracked__";i(new class{trackDisposable(s){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[t]||console.log(o)},3e3)}setParent(s,o){if(s&&s!==y.None)try{s[t]=!0}catch{}}markAsDisposed(s){if(s&&s!==y.None)try{s[t]=!0}catch{}}markAsSingleton(s){}})}function R(t){return L?.trackDisposable(t),t}function E(t){L?.markAsDisposed(t)}function b(t,s){L?.setParent(t,s)}function I(t,s){if(!!L)for(const o of t)L.setParent(o,s)}function C(t){return L?.markAsSingleton(t),t}e.markAsSingleton=C;class d extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=d;function m(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=m;function u(t){if(_.Iterable.is(t)){let s=[];for(const o of t)if(o)try{o.dispose()}catch(h){s.push(h)}if(s.length===1)throw s[0];if(s.length>1)throw new d(s);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=u;function S(...t){const s=v(()=>u(t));return I(t,s),s}e.combinedDisposable=S;function v(t){const s=R({dispose:(0,T.once)(()=>{E(s),t()})});return s}e.toDisposable=v;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return b(s,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new g,R(this),b(this._store,this)}dispose(){E(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=y,y.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&b(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&b(s,null),s}}e.MutableDisposable=f;class c{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class l{constructor(){this.references=new Map}acquire(s,...o){let h=this.references.get(s);h||(h={counter:0,object:this.createReferencedObject(s,...o)},this.references.set(s,h));const{object:p}=h,w=(0,T.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(s,h.object),this.references.delete(s))});return h.counter++,{object:p,dispose:w}}}e.ReferenceCollection=l;class r{constructor(s){this.referenceCollection=s}async acquire(s,...o){const h=this.referenceCollection.acquire(s,...o);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(p){throw h.dispose(),p}}}e.AsyncReferenceCollection=r;class a{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=a;function n(t){const s=new g;try{t(s)}finally{s.dispose()}}e.disposeOnReturn=n}),define(te[100],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class T{constructor(L){this.element=L,this.next=T.Undefined,this.prev=T.Undefined}}T.Undefined=new T(void 0);class _{constructor(){this._first=T.Undefined,this._last=T.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===T.Undefined}clear(){let L=this._first;for(;L!==T.Undefined;){const i=L.next;L.prev=T.Undefined,L.next=T.Undefined,L=i}this._first=T.Undefined,this._last=T.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,i){const R=new T(L);if(this._first===T.Undefined)this._first=R,this._last=R;else if(i){const b=this._last;this._last=R,R.prev=b,b.next=R}else{const b=this._first;this._first=R,R.next=b,b.prev=R}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(R))}}shift(){if(this._first!==T.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==T.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==T.Undefined&&L.next!==T.Undefined){const i=L.prev;i.next=L.next,L.next.prev=i}else L.prev===T.Undefined&&L.next===T.Undefined?(this._first=T.Undefined,this._last=T.Undefined):L.next===T.Undefined?(this._last=this._last.prev,this._last.next=T.Undefined):L.prev===T.Undefined&&(this._first=this._first.next,this._first.prev=T.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==T.Undefined;)yield L.element,L=L.next}}e.LinkedList=_}),function(){function J(D){const L=[];typeof D=="number"&&L.push("code/timeOrigin",D);function i(E){L.push(E,Date.now())}function R(){const E=[];for(let b=0;b<L.length;b+=2)E.push({name:L[b],startTime:L[b+1]});return E}return{mark:i,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const i of performance.getEntriesByType("mark"))L.push({name:i.name,startTime:Math.round(D+i.startTime)});return L}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function T(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var _;typeof global=="object"?_=global:typeof self=="object"?_=self:_={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(_)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(_):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),_.perf=T(_))}(),define(te[4],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const T="en";let _=!1,D=!1,L=!1,i=!1,R=!1,E=!1,b=!1,I=!1,C,d=T,m,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let S;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?S=e.globals.vscode.process:typeof process!="undefined"&&(S=process);const v=typeof S?.versions?.electron=="string",g=v&&S?.type==="renderer";if(e.isElectronSandboxed=g&&S?.sandboxed,typeof navigator=="object"&&!g)u=navigator.userAgent,_=u.indexOf("Windows")>=0,D=u.indexOf("Macintosh")>=0,I=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=u.indexOf("Linux")>=0,E=!0,C=navigator.language,d=C;else if(typeof S=="object"){_=S.platform==="win32",D=S.platform==="darwin",L=S.platform==="linux",i=L&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,b=v,C=T,d=T;const s=S.env.VSCODE_NLS_CONFIG;if(s)try{const o=JSON.parse(s),h=o.availableLanguages["*"];C=o.locale,d=h||T,m=o._translationsConfigFile}catch(o){}R=!0}else console.error("Unable to resolve platform.");var y;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function f(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=f;let c=0;D?c=1:_?c=3:L&&(c=2),e.isWindows=_,e.isMacintosh=D,e.isLinux=L,e.isLinuxSnap=i,e.isNative=R,e.isElectron=b,e.isWeb=E,e.isIOS=I,e.platform=c,e.userAgent=u,e.language=d;var l;(function(s){function o(){return e.language}s.value=o;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=h;function p(){return e.language==="en"}s.isDefault=p})(l=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=m,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let p=0,w=s.length;p<w;p++){const P=s[p];if(P.id===h.data.vscodeScheduleAsyncWork){s.splice(p,1),P.callback();return}}});let o=0;return h=>{const p=++o;s.push({id:p,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:p},"*")}}return s=>setTimeout(s)})();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||I?2:_?1:3;let a=!0,n=!1;function t(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,a=new Uint16Array(s.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=t}),define(te[32],ne([0,1,4]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let _;if(typeof T.globals.vscode!="undefined"&&typeof T.globals.vscode.process!="undefined"){const D=T.globals.vscode.process;_={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?_={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:_={get platform(){return T.isWindows?"win32":T.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=_.cwd,e.env=_.env,e.platform=_.platform,e.arch=_.arch}),define(te[10],ne([0,1,32]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const _=65,D=97,L=90,i=122,R=46,E=47,b=92,I=58,C=63;class d extends Error{constructor(c,l,r){let a;typeof l=="string"&&l.indexOf("not ")===0?(a="must not be",l=l.replace(/^not /,"")):a="must be";const n=c.indexOf(".")!==-1?"property":"argument";let t=`The "${c}" ${n} ${a} of type ${l}`;t+=`. Received type ${typeof r}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function m(f,c){if(typeof f!="string")throw new d(c,"string",f)}function u(f){return f===E||f===b}function S(f){return f===E}function v(f){return f>=_&&f<=L||f>=D&&f<=i}function g(f,c,l,r){let a="",n=0,t=-1,s=0,o=0;for(let h=0;h<=f.length;++h){if(h<f.length)o=f.charCodeAt(h);else{if(r(o))break;o=E}if(r(o)){if(!(t===h-1||s===1))if(s===2){if(a.length<2||n!==2||a.charCodeAt(a.length-1)!==R||a.charCodeAt(a.length-2)!==R){if(a.length>2){const p=a.lastIndexOf(l);p===-1?(a="",n=0):(a=a.slice(0,p),n=a.length-1-a.lastIndexOf(l)),t=h,s=0;continue}else if(a.length!==0){a="",n=0,t=h,s=0;continue}}c&&(a+=a.length>0?`${l}..`:"..",n=2)}else a.length>0?a+=`${l}${f.slice(t+1,h)}`:a=f.slice(t+1,h),n=h-t-1;t=h,s=0}else o===R&&s!==-1?++s:s=-1}return a}function y(f,c){if(c===null||typeof c!="object")throw new d("pathObject","Object",c);const l=c.dir||c.root,r=c.base||`${c.name||""}${c.ext||""}`;return l?l===c.root?`${l}${r}`:`${l}${f}${r}`:r}e.win32={resolve(...f){let c="",l="",r=!1;for(let a=f.length-1;a>=-1;a--){let n;if(a>=0){if(n=f[a],m(n,"path"),n.length===0)continue}else c.length===0?n=T.cwd():(n=T.env[`=${c}`]||T.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==c.toLowerCase()&&n.charCodeAt(2)===b)&&(n=`${c}\\`));const t=n.length;let s=0,o="",h=!1;const p=n.charCodeAt(0);if(t===1)u(p)&&(s=1,h=!0);else if(u(p))if(h=!0,u(n.charCodeAt(1))){let w=2,P=w;for(;w<t&&!u(n.charCodeAt(w));)w++;if(w<t&&w!==P){const M=n.slice(P,w);for(P=w;w<t&&u(n.charCodeAt(w));)w++;if(w<t&&w!==P){for(P=w;w<t&&!u(n.charCodeAt(w));)w++;(w===t||w!==P)&&(o=`\\\\${M}\\${n.slice(P,w)}`,s=w)}}}else s=1;else v(p)&&n.charCodeAt(1)===I&&(o=n.slice(0,2),s=2,t>2&&u(n.charCodeAt(2))&&(h=!0,s=3));if(o.length>0)if(c.length>0){if(o.toLowerCase()!==c.toLowerCase())continue}else c=o;if(r){if(c.length>0)break}else if(l=`${n.slice(s)}\\${l}`,r=h,h&&c.length>0)break}return l=g(l,!r,"\\",u),r?`${c}\\${l}`:`${c}${l}`||"."},normalize(f){m(f,"path");const c=f.length;if(c===0)return".";let l=0,r,a=!1;const n=f.charCodeAt(0);if(c===1)return S(n)?"\\":f;if(u(n))if(a=!0,u(f.charCodeAt(1))){let s=2,o=s;for(;s<c&&!u(f.charCodeAt(s));)s++;if(s<c&&s!==o){const h=f.slice(o,s);for(o=s;s<c&&u(f.charCodeAt(s));)s++;if(s<c&&s!==o){for(o=s;s<c&&!u(f.charCodeAt(s));)s++;if(s===c)return`\\\\${h}\\${f.slice(o)}\\`;s!==o&&(r=`\\\\${h}\\${f.slice(o,s)}`,l=s)}}}else l=1;else v(n)&&f.charCodeAt(1)===I&&(r=f.slice(0,2),l=2,c>2&&u(f.charCodeAt(2))&&(a=!0,l=3));let t=l<c?g(f.slice(l),!a,"\\",u):"";return t.length===0&&!a&&(t="."),t.length>0&&u(f.charCodeAt(c-1))&&(t+="\\"),r===void 0?a?`\\${t}`:t:a?`${r}\\${t}`:`${r}${t}`},isAbsolute(f){m(f,"path");const c=f.length;if(c===0)return!1;const l=f.charCodeAt(0);return u(l)||c>2&&v(l)&&f.charCodeAt(1)===I&&u(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let c,l;for(let n=0;n<f.length;++n){const t=f[n];m(t,"path"),t.length>0&&(c===void 0?c=l=t:c+=`\\${t}`)}if(c===void 0)return".";let r=!0,a=0;if(typeof l=="string"&&u(l.charCodeAt(0))){++a;const n=l.length;n>1&&u(l.charCodeAt(1))&&(++a,n>2&&(u(l.charCodeAt(2))?++a:r=!1))}if(r){for(;a<c.length&&u(c.charCodeAt(a));)a++;a>=2&&(c=`\\${c.slice(a)}`)}return e.win32.normalize(c)},relative(f,c){if(m(f,"from"),m(c,"to"),f===c)return"";const l=e.win32.resolve(f),r=e.win32.resolve(c);if(l===r||(f=l.toLowerCase(),c=r.toLowerCase(),f===c))return"";let a=0;for(;a<f.length&&f.charCodeAt(a)===b;)a++;let n=f.length;for(;n-1>a&&f.charCodeAt(n-1)===b;)n--;const t=n-a;let s=0;for(;s<c.length&&c.charCodeAt(s)===b;)s++;let o=c.length;for(;o-1>s&&c.charCodeAt(o-1)===b;)o--;const h=o-s,p=t<h?t:h;let w=-1,P=0;for(;P<p;P++){const O=f.charCodeAt(a+P);if(O!==c.charCodeAt(s+P))break;O===b&&(w=P)}if(P!==p){if(w===-1)return r}else{if(h>p){if(c.charCodeAt(s+P)===b)return r.slice(s+P+1);if(P===2)return r.slice(s+P)}t>p&&(f.charCodeAt(a+P)===b?w=P:P===2&&(w=3)),w===-1&&(w=0)}let M="";for(P=a+w+1;P<=n;++P)(P===n||f.charCodeAt(P)===b)&&(M+=M.length===0?"..":"\\..");return s+=w,M.length>0?`${M}${r.slice(s,o)}`:(r.charCodeAt(s)===b&&++s,r.slice(s,o))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const c=e.win32.resolve(f);if(c.length<=2)return f;if(c.charCodeAt(0)===b){if(c.charCodeAt(1)===b){const l=c.charCodeAt(2);if(l!==C&&l!==R)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(v(c.charCodeAt(0))&&c.charCodeAt(1)===I&&c.charCodeAt(2)===b)return`\\\\?\\${c}`;return f},dirname(f){m(f,"path");const c=f.length;if(c===0)return".";let l=-1,r=0;const a=f.charCodeAt(0);if(c===1)return u(a)?f:".";if(u(a)){if(l=r=1,u(f.charCodeAt(1))){let s=2,o=s;for(;s<c&&!u(f.charCodeAt(s));)s++;if(s<c&&s!==o){for(o=s;s<c&&u(f.charCodeAt(s));)s++;if(s<c&&s!==o){for(o=s;s<c&&!u(f.charCodeAt(s));)s++;if(s===c)return f;s!==o&&(l=r=s+1)}}}}else v(a)&&f.charCodeAt(1)===I&&(l=c>2&&u(f.charCodeAt(2))?3:2,r=l);let n=-1,t=!0;for(let s=c-1;s>=r;--s)if(u(f.charCodeAt(s))){if(!t){n=s;break}}else t=!1;if(n===-1){if(l===-1)return".";n=l}return f.slice(0,n)},basename(f,c){c!==void 0&&m(c,"ext"),m(f,"path");let l=0,r=-1,a=!0,n;if(f.length>=2&&v(f.charCodeAt(0))&&f.charCodeAt(1)===I&&(l=2),c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let t=c.length-1,s=-1;for(n=f.length-1;n>=l;--n){const o=f.charCodeAt(n);if(u(o)){if(!a){l=n+1;break}}else s===-1&&(a=!1,s=n+1),t>=0&&(o===c.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=s))}return l===r?r=s:r===-1&&(r=f.length),f.slice(l,r)}for(n=f.length-1;n>=l;--n)if(u(f.charCodeAt(n))){if(!a){l=n+1;break}}else r===-1&&(a=!1,r=n+1);return r===-1?"":f.slice(l,r)},extname(f){m(f,"path");let c=0,l=-1,r=0,a=-1,n=!0,t=0;f.length>=2&&f.charCodeAt(1)===I&&v(f.charCodeAt(0))&&(c=r=2);for(let s=f.length-1;s>=c;--s){const o=f.charCodeAt(s);if(u(o)){if(!n){r=s+1;break}continue}a===-1&&(n=!1,a=s+1),o===R?l===-1?l=s:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||a===-1||t===0||t===1&&l===a-1&&l===r+1?"":f.slice(l,a)},format:y.bind(null,"\\"),parse(f){m(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const l=f.length;let r=0,a=f.charCodeAt(0);if(l===1)return u(a)?(c.root=c.dir=f,c):(c.base=c.name=f,c);if(u(a)){if(r=1,u(f.charCodeAt(1))){let w=2,P=w;for(;w<l&&!u(f.charCodeAt(w));)w++;if(w<l&&w!==P){for(P=w;w<l&&u(f.charCodeAt(w));)w++;if(w<l&&w!==P){for(P=w;w<l&&!u(f.charCodeAt(w));)w++;w===l?r=w:w!==P&&(r=w+1)}}}}else if(v(a)&&f.charCodeAt(1)===I){if(l<=2)return c.root=c.dir=f,c;if(r=2,u(f.charCodeAt(2))){if(l===3)return c.root=c.dir=f,c;r=3}}r>0&&(c.root=f.slice(0,r));let n=-1,t=r,s=-1,o=!0,h=f.length-1,p=0;for(;h>=r;--h){if(a=f.charCodeAt(h),u(a)){if(!o){t=h+1;break}continue}s===-1&&(o=!1,s=h+1),a===R?n===-1?n=h:p!==1&&(p=1):n!==-1&&(p=-1)}return s!==-1&&(n===-1||p===0||p===1&&n===s-1&&n===t+1?c.base=c.name=f.slice(t,s):(c.name=f.slice(t,n),c.base=f.slice(t,s),c.ext=f.slice(n,s))),t>0&&t!==r?c.dir=f.slice(0,t-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let c="",l=!1;for(let r=f.length-1;r>=-1&&!l;r--){const a=r>=0?f[r]:T.cwd();m(a,"path"),a.length!==0&&(c=`${a}/${c}`,l=a.charCodeAt(0)===E)}return c=g(c,!l,"/",S),l?`/${c}`:c.length>0?c:"."},normalize(f){if(m(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===E,l=f.charCodeAt(f.length-1)===E;return f=g(f,!c,"/",S),f.length===0?c?"/":l?"./":".":(l&&(f+="/"),c?`/${f}`:f)},isAbsolute(f){return m(f,"path"),f.length>0&&f.charCodeAt(0)===E},join(...f){if(f.length===0)return".";let c;for(let l=0;l<f.length;++l){const r=f[l];m(r,"path"),r.length>0&&(c===void 0?c=r:c+=`/${r}`)}return c===void 0?".":e.posix.normalize(c)},relative(f,c){if(m(f,"from"),m(c,"to"),f===c||(f=e.posix.resolve(f),c=e.posix.resolve(c),f===c))return"";const l=1,r=f.length,a=r-l,n=1,t=c.length-n,s=a<t?a:t;let o=-1,h=0;for(;h<s;h++){const w=f.charCodeAt(l+h);if(w!==c.charCodeAt(n+h))break;w===E&&(o=h)}if(h===s)if(t>s){if(c.charCodeAt(n+h)===E)return c.slice(n+h+1);if(h===0)return c.slice(n+h)}else a>s&&(f.charCodeAt(l+h)===E?o=h:h===0&&(o=0));let p="";for(h=l+o+1;h<=r;++h)(h===r||f.charCodeAt(h)===E)&&(p+=p.length===0?"..":"/..");return`${p}${c.slice(n+o)}`},toNamespacedPath(f){return f},dirname(f){if(m(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===E;let l=-1,r=!0;for(let a=f.length-1;a>=1;--a)if(f.charCodeAt(a)===E){if(!r){l=a;break}}else r=!1;return l===-1?c?"/":".":c&&l===1?"//":f.slice(0,l)},basename(f,c){c!==void 0&&m(c,"ext"),m(f,"path");let l=0,r=-1,a=!0,n;if(c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let t=c.length-1,s=-1;for(n=f.length-1;n>=0;--n){const o=f.charCodeAt(n);if(o===E){if(!a){l=n+1;break}}else s===-1&&(a=!1,s=n+1),t>=0&&(o===c.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=s))}return l===r?r=s:r===-1&&(r=f.length),f.slice(l,r)}for(n=f.length-1;n>=0;--n)if(f.charCodeAt(n)===E){if(!a){l=n+1;break}}else r===-1&&(a=!1,r=n+1);return r===-1?"":f.slice(l,r)},extname(f){m(f,"path");let c=-1,l=0,r=-1,a=!0,n=0;for(let t=f.length-1;t>=0;--t){const s=f.charCodeAt(t);if(s===E){if(!a){l=t+1;break}continue}r===-1&&(a=!1,r=t+1),s===R?c===-1?c=t:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||r===-1||n===0||n===1&&c===r-1&&c===l+1?"":f.slice(c,r)},format:y.bind(null,"/"),parse(f){m(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const l=f.charCodeAt(0)===E;let r;l?(c.root="/",r=1):r=0;let a=-1,n=0,t=-1,s=!0,o=f.length-1,h=0;for(;o>=r;--o){const p=f.charCodeAt(o);if(p===E){if(!s){n=o+1;break}continue}t===-1&&(s=!1,t=o+1),p===R?a===-1?a=o:h!==1&&(h=1):a!==-1&&(h=-1)}if(t!==-1){const p=n===0&&l?1:n;a===-1||h===0||h===1&&a===t-1&&a===n+1?c.base=c.name=f.slice(p,t):(c.name=f.slice(p,a),c.base=f.slice(p,t),c.ext=f.slice(a,t))}return n>0?c.dir=f.slice(0,n-1):l&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=T.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=T.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=T.platform==="win32"?e.win32.join:e.posix.join,e.resolve=T.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=T.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=T.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=T.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=T.platform==="win32"?e.win32.extname:e.posix.extname,e.format=T.platform==="win32"?e.win32.format:e.posix.format,e.parse=T.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=T.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=T.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=T.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[101],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var T;(function(L){L[L.stdout=0]="stdout",L[L.stderr=1]="stderr"})(T=e.Source||(e.Source={}));var _;(function(L){L[L.Success=0]="Success",L[L.Unknown=1]="Unknown",L[L.AccessDenied=2]="AccessDenied",L[L.ProcessNotFound=3]="ProcessNotFound"})(_=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(L,...i){const R=i.reduce((I,C)=>(I[C]=!0,I),{}),E=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(L).filter(I=>!R[I]).forEach(I=>{for(let C=0;C<E.length;C++)if(I.search(E[C])!==-1){delete L[I];break}})}e.sanitizeProcessEnvironment=D}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var _ in T)(typeof exports=="object"?exports:J)[_]=T[_]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function T(_){if(e[_])return e[_].exports;var D=e[_]={i:_,l:!1,exports:{}};return J[_].call(D.exports,D,D.exports,T),D.l=!0,D.exports}return T.m=J,T.c=e,T.d=function(_,D,L){T.o(_,D)||Object.defineProperty(_,D,{enumerable:!0,get:L})},T.r=function(_){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(_,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(_,"__esModule",{value:!0})},T.t=function(_,D){if(1&D&&(_=T(_)),8&D||4&D&&typeof _=="object"&&_&&_.__esModule)return _;var L=Object.create(null);if(T.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:_}),2&D&&typeof _!="string")for(var i in _)T.d(L,i,function(R){return _[R]}.bind(null,i));return L},T.n=function(_){var D=_&&_.__esModule?function(){return _.default}:function(){return _};return T.d(D,"a",D),D},T.o=function(_,D){return Object.prototype.hasOwnProperty.call(_,D)},T.p="",T(T.s=0)}([function(J,e,T){(function(_){var D;e=J.exports=G,D=typeof _=="object"&&_.env&&_.env.NODE_DEBUG&&/\bsemver\b/i.test(_.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,i=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],E=e.src=[],b=0,I=b++;E[I]="0|[1-9]\\d*";var C=b++;E[C]="[0-9]+";var d=b++;E[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=b++;E[m]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var u=b++;E[u]="("+E[C]+")\\.("+E[C]+")\\.("+E[C]+")";var S=b++;E[S]="(?:"+E[I]+"|"+E[d]+")";var v=b++;E[v]="(?:"+E[C]+"|"+E[d]+")";var g=b++;E[g]="(?:-("+E[S]+"(?:\\."+E[S]+")*))";var y=b++;E[y]="(?:-?("+E[v]+"(?:\\."+E[v]+")*))";var f=b++;E[f]="[0-9A-Za-z-]+";var c=b++;E[c]="(?:\\+("+E[f]+"(?:\\."+E[f]+")*))";var l=b++,r="v?"+E[m]+E[g]+"?"+E[c]+"?";E[l]="^"+r+"$";var a="[v=\\s]*"+E[u]+E[y]+"?"+E[c]+"?",n=b++;E[n]="^"+a+"$";var t=b++;E[t]="((?:<|>)?=?)";var s=b++;E[s]=E[C]+"|x|X|\\*";var o=b++;E[o]=E[I]+"|x|X|\\*";var h=b++;E[h]="[v=\\s]*("+E[o]+")(?:\\.("+E[o]+")(?:\\.("+E[o]+")(?:"+E[g]+")?"+E[c]+"?)?)?";var p=b++;E[p]="[v=\\s]*("+E[s]+")(?:\\.("+E[s]+")(?:\\.("+E[s]+")(?:"+E[y]+")?"+E[c]+"?)?)?";var w=b++;E[w]="^"+E[t]+"\\s*"+E[h]+"$";var P=b++;E[P]="^"+E[t]+"\\s*"+E[p]+"$";var M=b++;E[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=b++;E[O]="(?:~>?)";var q=b++;E[q]="(\\s*)"+E[O]+"\\s+",R[q]=new RegExp(E[q],"g");var $=b++;E[$]="^"+E[O]+E[h]+"$";var k=b++;E[k]="^"+E[O]+E[p]+"$";var z=b++;E[z]="(?:\\^)";var A=b++;E[A]="(\\s*)"+E[z]+"\\s+",R[A]=new RegExp(E[A],"g");var F=b++;E[F]="^"+E[z]+E[h]+"$";var x=b++;E[x]="^"+E[z]+E[p]+"$";var Z=b++;E[Z]="^"+E[t]+"\\s*("+a+")$|^$";var B=b++;E[B]="^"+E[t]+"\\s*("+r+")$|^$";var j=b++;E[j]="(\\s*)"+E[t]+"\\s*("+a+"|"+E[h]+")",R[j]=new RegExp(E[j],"g");var X=b++;E[X]="^\\s*("+E[h]+")\\s+-\\s+("+E[h]+")\\s*$";var U=b++;E[U]="^\\s*("+E[p]+")\\s+-\\s+("+E[p]+")\\s*$";var N=b++;E[N]="(<|>)?=?\\s*\\*";for(var W=0;W<35;W++)D(W,E[W]),R[W]||(R[W]=new RegExp(E[W]));function V(ie,ae){if(ie instanceof G)return ie;if(typeof ie!="string"||ie.length>L||!(ae?R[n]:R[l]).test(ie))return null;try{return new G(ie,ae)}catch(le){return null}}function G(ie,ae){if(ie instanceof G){if(ie.loose===ae)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof G))return new G(ie,ae);D("SemVer",ie,ae),this.loose=ae;var le=ie.trim().match(ae?R[n]:R[l]);if(!le)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+le[1],this.minor=+le[2],this.patch=+le[3],this.major>i||this.major<0)throw new TypeError("Invalid major version");if(this.minor>i||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>i||this.patch<0)throw new TypeError("Invalid patch version");le[4]?this.prerelease=le[4].split(".").map(function(we){if(/^[0-9]+$/.test(we)){var Ce=+we;if(Ce>=0&&Ce<i)return Ce}return we}):this.prerelease=[],this.build=le[5]?le[5].split("."):[],this.format()}e.parse=V,e.valid=function(ie,ae){var le=V(ie,ae);return le?le.version:null},e.clean=function(ie,ae){var le=V(ie.trim().replace(/^[=v]+/,""),ae);return le?le.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(ie){return D("SemVer.compare",this.version,this.loose,ie),ie instanceof G||(ie=new G(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},G.prototype.compareMain=function(ie){return ie instanceof G||(ie=new G(ie,this.loose)),H(this.major,ie.major)||H(this.minor,ie.minor)||H(this.patch,ie.patch)},G.prototype.comparePre=function(ie){if(ie instanceof G||(ie=new G(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var ae=0;do{var le=this.prerelease[ae],we=ie.prerelease[ae];if(D("prerelease compare",ae,le,we),le===void 0&&we===void 0)return 0;if(we===void 0)return 1;if(le===void 0)return-1;if(le!==we)return H(le,we)}while(++ae)},G.prototype.inc=function(ie,ae){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var le=this.prerelease.length;--le>=0;)typeof this.prerelease[le]=="number"&&(this.prerelease[le]++,le=-2);le===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,ae,le,we){typeof le=="string"&&(we=le,le=void 0);try{return new G(ie,le).inc(ae,we).version}catch(Ce){return null}},e.diff=function(ie,ae){if(ce(ie,ae))return null;var le=V(ie),we=V(ae);if(le.prerelease.length||we.prerelease.length){for(var Ce in le)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&le[Ce]!==we[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in le)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&le[Ce]!==we[Ce])return Ce},e.compareIdentifiers=H;var ee=/^[0-9]+$/;function H(ie,ae){var le=ee.test(ie),we=ee.test(ae);return le&&we&&(ie=+ie,ae=+ae),le&&!we?-1:we&&!le?1:ie<ae?-1:ie>ae?1:0}function Q(ie,ae,le){return new G(ie,le).compare(new G(ae,le))}function re(ie,ae,le){return Q(ie,ae,le)>0}function oe(ie,ae,le){return Q(ie,ae,le)<0}function ce(ie,ae,le){return Q(ie,ae,le)===0}function he(ie,ae,le){return Q(ie,ae,le)!==0}function be(ie,ae,le){return Q(ie,ae,le)>=0}function Ie(ie,ae,le){return Q(ie,ae,le)<=0}function Se(ie,ae,le,we){var Ce;switch(ae){case"===":typeof ie=="object"&&(ie=ie.version),typeof le=="object"&&(le=le.version),Ce=ie===le;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof le=="object"&&(le=le.version),Ce=ie!==le;break;case"":case"=":case"==":Ce=ce(ie,le,we);break;case"!=":Ce=he(ie,le,we);break;case">":Ce=re(ie,le,we);break;case">=":Ce=be(ie,le,we);break;case"<":Ce=oe(ie,le,we);break;case"<=":Ce=Ie(ie,le,we);break;default:throw new TypeError("Invalid operator: "+ae)}return Ce}function ve(ie,ae){if(ie instanceof ve){if(ie.loose===ae)return ie;ie=ie.value}if(!(this instanceof ve))return new ve(ie,ae);D("comparator",ie,ae),this.loose=ae,this.parse(ie),this.semver===Re?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ie,ae){return H(ae,ie)},e.major=function(ie,ae){return new G(ie,ae).major},e.minor=function(ie,ae){return new G(ie,ae).minor},e.patch=function(ie,ae){return new G(ie,ae).patch},e.compare=Q,e.compareLoose=function(ie,ae){return Q(ie,ae,!0)},e.rcompare=function(ie,ae,le){return Q(ae,ie,le)},e.sort=function(ie,ae){return ie.sort(function(le,we){return e.compare(le,we,ae)})},e.rsort=function(ie,ae){return ie.sort(function(le,we){return e.rcompare(le,we,ae)})},e.gt=re,e.lt=oe,e.eq=ce,e.neq=he,e.gte=be,e.lte=Ie,e.cmp=Se,e.Comparator=ve;var Re={};function ye(ie,ae){if(ie instanceof ye)return ie.loose===ae?ie:new ye(ie.raw,ae);if(ie instanceof ve)return new ye(ie.value,ae);if(!(this instanceof ye))return new ye(ie,ae);if(this.loose=ae,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(le){return this.parseRange(le.trim())},this).filter(function(le){return le.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function De(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function Le(ie,ae,le,we,Ce,Oe,Te,Ne,Ae,Me,K,se,ue){return((ae=De(le)?"":De(we)?">="+le+".0.0":De(Ce)?">="+le+"."+we+".0":">="+ae)+" "+(Ne=De(Ae)?"":De(Me)?"<"+(+Ae+1)+".0.0":De(K)?"<"+Ae+"."+(+Me+1)+".0":se?"<="+Ae+"."+Me+"."+K+"-"+se:"<="+Ne)).trim()}function Fe(ie,ae){for(var le=0;le<ie.length;le++)if(!ie[le].test(ae))return!1;if(ae.prerelease.length){for(le=0;le<ie.length;le++)if(D(ie[le].semver),ie[le].semver!==Re&&ie[le].semver.prerelease.length>0){var we=ie[le].semver;if(we.major===ae.major&&we.minor===ae.minor&&we.patch===ae.patch)return!0}return!1}return!0}function $e(ie,ae,le){try{ae=new ye(ae,le)}catch(we){return!1}return ae.test(ie)}function ze(ie,ae,le,we){var Ce,Oe,Te,Ne,Ae;switch(ie=new G(ie,we),ae=new ye(ae,we),le){case">":Ce=re,Oe=Ie,Te=oe,Ne=">",Ae=">=";break;case"<":Ce=oe,Oe=be,Te=re,Ne="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(ie,ae,we))return!1;for(var Me=0;Me<ae.set.length;++Me){var K=ae.set[Me],se=null,ue=null;if(K.forEach(function(fe){fe.semver===Re&&(fe=new ve(">=0.0.0")),se=se||fe,ue=ue||fe,Ce(fe.semver,se.semver,we)?se=fe:Te(fe.semver,ue.semver,we)&&(ue=fe)}),se.operator===Ne||se.operator===Ae||(!ue.operator||ue.operator===Ne)&&Oe(ie,ue.semver)||ue.operator===Ae&&Te(ie,ue.semver))return!1}return!0}ve.prototype.parse=function(ie){var ae=this.loose?R[Z]:R[B],le=ie.match(ae);if(!le)throw new TypeError("Invalid comparator: "+ie);this.operator=le[1],this.operator==="="&&(this.operator=""),le[2]?this.semver=new G(le[2],this.loose):this.semver=Re},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ie){return D("Comparator.test",ie,this.loose),this.semver===Re||(typeof ie=="string"&&(ie=new G(ie,this.loose)),Se(ie,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ie,ae){if(!(ie instanceof ve))throw new TypeError("a Comparator is required");var le;if(this.operator==="")return le=new ye(ie.value,ae),$e(this.value,le,ae);if(ie.operator==="")return le=new ye(this.value,ae),$e(ie.semver,le,ae);var we=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),Oe=this.semver.version===ie.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),Ne=Se(this.semver,"<",ie.semver,ae)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),Ae=Se(this.semver,">",ie.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return we||Ce||Oe&&Te||Ne||Ae},e.Range=ye,ye.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},ye.prototype.toString=function(){return this.range},ye.prototype.parseRange=function(ie){var ae=this.loose;ie=ie.trim(),D("range",ie,ae);var le=ae?R[U]:R[X];ie=ie.replace(le,Le),D("hyphen replace",ie),ie=ie.replace(R[j],"$1$2$3"),D("comparator trim",ie,R[j]),ie=(ie=(ie=ie.replace(R[q],"$1~")).replace(R[A],"$1^")).split(/\s+/).join(" ");var we=ae?R[Z]:R[B],Ce=ie.split(" ").map(function(Oe){return function(Te,Ne){return D("comp",Te),Te=function(Ae,Me){return Ae.trim().split(/\s+/).map(function(K){return function(se,ue){D("caret",se,ue);var fe=ue?R[x]:R[F];return se.replace(fe,function(pe,ge,Ee,Pe,ke){var _e;return D("caret",se,pe,ge,Ee,Pe,ke),De(ge)?_e="":De(Ee)?_e=">="+ge+".0.0 <"+(+ge+1)+".0.0":De(Pe)?_e=ge==="0"?">="+ge+"."+Ee+".0 <"+ge+"."+(+Ee+1)+".0":">="+ge+"."+Ee+".0 <"+(+ge+1)+".0.0":ke?(D("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),_e=ge==="0"?Ee==="0"?">="+ge+"."+Ee+"."+Pe+ke+" <"+ge+"."+Ee+"."+(+Pe+1):">="+ge+"."+Ee+"."+Pe+ke+" <"+ge+"."+(+Ee+1)+".0":">="+ge+"."+Ee+"."+Pe+ke+" <"+(+ge+1)+".0.0"):(D("no pr"),_e=ge==="0"?Ee==="0"?">="+ge+"."+Ee+"."+Pe+" <"+ge+"."+Ee+"."+(+Pe+1):">="+ge+"."+Ee+"."+Pe+" <"+ge+"."+(+Ee+1)+".0":">="+ge+"."+Ee+"."+Pe+" <"+(+ge+1)+".0.0"),D("caret return",_e),_e})}(K,Me)}).join(" ")}(Te,Ne),D("caret",Te),Te=function(Ae,Me){return Ae.trim().split(/\s+/).map(function(K){return function(se,ue){var fe=ue?R[k]:R[$];return se.replace(fe,function(pe,ge,Ee,Pe,ke){var _e;return D("tilde",se,pe,ge,Ee,Pe,ke),De(ge)?_e="":De(Ee)?_e=">="+ge+".0.0 <"+(+ge+1)+".0.0":De(Pe)?_e=">="+ge+"."+Ee+".0 <"+ge+"."+(+Ee+1)+".0":ke?(D("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),_e=">="+ge+"."+Ee+"."+Pe+ke+" <"+ge+"."+(+Ee+1)+".0"):_e=">="+ge+"."+Ee+"."+Pe+" <"+ge+"."+(+Ee+1)+".0",D("tilde return",_e),_e})}(K,Me)}).join(" ")}(Te,Ne),D("tildes",Te),Te=function(Ae,Me){return D("replaceXRanges",Ae,Me),Ae.split(/\s+/).map(function(K){return function(se,ue){se=se.trim();var fe=ue?R[P]:R[w];return se.replace(fe,function(pe,ge,Ee,Pe,ke,_e){D("xRange",se,pe,ge,Ee,Pe,ke,_e);var We=De(Ee),He=We||De(Pe),Ye=He||De(ke);return ge==="="&&Ye&&(ge=""),We?pe=ge===">"||ge==="<"?"<0.0.0":"*":ge&&Ye?(He&&(Pe=0),Ye&&(ke=0),ge===">"?(ge=">=",He?(Ee=+Ee+1,Pe=0,ke=0):Ye&&(Pe=+Pe+1,ke=0)):ge==="<="&&(ge="<",He?Ee=+Ee+1:Pe=+Pe+1),pe=ge+Ee+"."+Pe+"."+ke):He?pe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Ye&&(pe=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),D("xRange return",pe),pe})}(K,Me)}).join(" ")}(Te,Ne),D("xrange",Te),Te=function(Ae,Me){return D("replaceStars",Ae,Me),Ae.trim().replace(R[N],"")}(Te,Ne),D("stars",Te),Te}(Oe,ae)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Oe){return!!Oe.match(we)})),Ce=Ce.map(function(Oe){return new ve(Oe,ae)})},ye.prototype.intersects=function(ie,ae){if(!(ie instanceof ye))throw new TypeError("a Range is required");return this.set.some(function(le){return le.every(function(we){return ie.set.some(function(Ce){return Ce.every(function(Oe){return we.intersects(Oe,ae)})})})})},e.toComparators=function(ie,ae){return new ye(ie,ae).set.map(function(le){return le.map(function(we){return we.value}).join(" ").trim().split(" ")})},ye.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new G(ie,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Fe(this.set[ae],ie))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(ie,ae,le){var we=null,Ce=null;try{var Oe=new ye(ae,le)}catch(Te){return null}return ie.forEach(function(Te){Oe.test(Te)&&(we&&Ce.compare(Te)!==-1||(Ce=new G(we=Te,le)))}),we},e.minSatisfying=function(ie,ae,le){var we=null,Ce=null;try{var Oe=new ye(ae,le)}catch(Te){return null}return ie.forEach(function(Te){Oe.test(Te)&&(we&&Ce.compare(Te)!==1||(Ce=new G(we=Te,le)))}),we},e.validRange=function(ie,ae){try{return new ye(ie,ae).range||"*"}catch(le){return null}},e.ltr=function(ie,ae,le){return ze(ie,ae,"<",le)},e.gtr=function(ie,ae,le){return ze(ie,ae,">",le)},e.outside=ze,e.prerelease=function(ie,ae){var le=V(ie,ae);return le&&le.prerelease.length?le.prerelease:null},e.intersects=function(ie,ae,le){return ie=new ye(ie,le),ae=new ye(ae,le),ie.intersects(ae)},e.coerce=function(ie){if(ie instanceof G)return ie;if(typeof ie!="string")return null;var ae=ie.match(R[M]);return ae==null?null:V((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,T(1))},function(J,e){var T,_,D=J.exports={};function L(){throw new Error("setTimeout has not been defined")}function i(){throw new Error("clearTimeout has not been defined")}function R(v){if(T===setTimeout)return setTimeout(v,0);if((T===L||!T)&&setTimeout)return T=setTimeout,setTimeout(v,0);try{return T(v,0)}catch(g){try{return T.call(null,v,0)}catch(y){return T.call(this,v,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:L}catch(v){T=L}try{_=typeof clearTimeout=="function"?clearTimeout:i}catch(v){_=i}})();var E,b=[],I=!1,C=-1;function d(){I&&E&&(I=!1,E.length?b=E.concat(b):C=-1,b.length&&m())}function m(){if(!I){var v=R(d);I=!0;for(var g=b.length;g;){for(E=b,b=[];++C<g;)E&&E[C].run();C=-1,g=b.length}E=null,I=!1,function(y){if(_===clearTimeout)return clearTimeout(y);if((_===i||!_)&&clearTimeout)return _=clearTimeout,clearTimeout(y);try{_(y)}catch(f){try{return _.call(null,y)}catch(c){return _.call(this,y)}}}(v)}}function u(v,g){this.fun=v,this.array=g}function S(){}D.nextTick=function(v){var g=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)g[y-1]=arguments[y];b.push(new u(v,g)),b.length!==1||I||R(m)},u.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=S,D.addListener=S,D.once=S,D.off=S,D.removeListener=S,D.removeAllListeners=S,D.emit=S,D.prependListener=S,D.prependOnceListener=S,D.listeners=function(v){return[]},D.binding=function(v){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(v){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(te[102],ne([0,1]),function(J,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class _{constructor(R,E,b){this.level=R,this.key=E,this.value=b,this.forward=[]}}const D=void 0;class L{constructor(R,E=2**16){this.comparator=R,this[T]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(E)|0),this._header=new _(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new _(this._maxLevel,D,D)}has(R){return Boolean(L._search(this,R,this.comparator))}get(R){return L._search(this,R,this.comparator)?.value}set(R,E){return L._insert(this,R,E,this.comparator)&&(this._size+=1),this}delete(R){const E=L._delete(this,R,this.comparator);return E&&(this._size-=1),E}forEach(R,E){let b=this._header.forward[0];for(;b;)R.call(E,b.value,b.key,this),b=b.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",E=this._header.forward[0];for(;E;)R+=`node(${E.key}, ${E.value}, lvl:${E.level})`,E=E.forward[0];return R}static _search(R,E,b){let I=R._header;for(let C=R._level-1;C>=0;C--)for(;I.forward[C]&&b(I.forward[C].key,E)<0;)I=I.forward[C];if(I=I.forward[0],I&&b(I.key,E)===0)return I}static _insert(R,E,b,I){let C=[],d=R._header;for(let m=R._level-1;m>=0;m--){for(;d.forward[m]&&I(d.forward[m].key,E)<0;)d=d.forward[m];C[m]=d}if(d=d.forward[0],d&&I(d.key,E)===0)return d.value=b,!1;{let m=L._randomLevel(R);if(m>R._level){for(let u=R._level;u<m;u++)C[u]=R._header;R._level=m}d=new _(m,E,b);for(let u=0;u<m;u++)d.forward[u]=C[u].forward[u],C[u].forward[u]=d;return!0}}static _randomLevel(R,E=.5){let b=1;for(;Math.random()<E&&b<R._maxLevel;)b+=1;return b}static _delete(R,E,b){let I=[],C=R._header;for(let d=R._level-1;d>=0;d--){for(;C.forward[d]&&b(C.forward[d].key,E)<0;)C=C.forward[d];I[d]=C}if(C=C.forward[0],!C||b(C.key,E)!==0)return!1;for(let d=0;d<R._level&&I[d].forward[d]===C;d++)I[d].forward[d]=C.forward[d];for(;R._level>0&&R._header.forward[R._level-1]===D;)R._level-=1;return!0}}e.SkipList=L}),define(te[103],ne([0,1,4]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const _=T.globals.performance&&typeof T.globals.performance.now=="function";class D{constructor(i){this._highResolution=_&&i,this._startTime=this._now(),this._stopTime=-1}static create(i=!0){return new D(i)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?T.globals.performance.now():Date.now()}}e.StopWatch=D}),define(te[3],ne([0,1,7,68,2,100,103]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(c){c.None=()=>D.Disposable.None;function l(A){return(F,x=null,Z)=>{let B=!1,j;return j=A(X=>{if(!B)return j?j.dispose():B=!0,F.call(x,X)},null,Z),B&&j.dispose(),j}}c.once=l;function r(A,F){return h((x,Z=null,B)=>A(j=>x.call(Z,F(j)),null,B))}c.map=r;function a(A,F){return h((x,Z=null,B)=>A(j=>{F(j),x.call(Z,j)},null,B))}c.forEach=a;function n(A,F){return h((x,Z=null,B)=>A(j=>F(j)&&x.call(Z,j),null,B))}c.filter=n;function t(A){return A}c.signal=t;function s(...A){return(F,x=null,Z)=>(0,D.combinedDisposable)(...A.map(B=>B(j=>F.call(x,j),null,Z)))}c.any=s;function o(A,F,x){let Z=x;return r(A,B=>(Z=F(Z,B),Z))}c.reduce=o;function h(A){let F;const x=new d({onFirstListenerAdd(){F=A(x.fire,x)},onLastListenerRemove(){F.dispose()}});return x.event}function p(A,F,x=100,Z=!1,B){let j,X,U,N=0;const W=new d({leakWarningThreshold:B,onFirstListenerAdd(){j=A(V=>{N++,X=F(X,V),Z&&!U&&(W.fire(X),X=void 0),clearTimeout(U),U=setTimeout(()=>{const G=X;X=void 0,U=void 0,(!Z||N>1)&&W.fire(G),N=0},x)})},onLastListenerRemove(){j.dispose()}});return W.event}c.debounce=p;function w(A,F=(x,Z)=>x===Z){let x=!0,Z;return n(A,B=>{const j=x||!F(B,Z);return x=!1,Z=B,j})}c.latch=w;function P(A,F){return[c.filter(A,F),c.filter(A,x=>!F(x))]}c.split=P;function M(A,F=!1,x=[]){let Z=x.slice(),B=A(U=>{Z?Z.push(U):X.fire(U)});const j=()=>{Z&&Z.forEach(U=>X.fire(U)),Z=null},X=new d({onFirstListenerAdd(){B||(B=A(U=>X.fire(U)))},onFirstListenerDidAdd(){Z&&(F?setTimeout(j):j())},onLastListenerRemove(){B&&B.dispose(),B=null}});return X.event}c.buffer=M;class O{constructor(F){this.event=F}map(F){return new O(r(this.event,F))}forEach(F){return new O(a(this.event,F))}filter(F){return new O(n(this.event,F))}reduce(F,x){return new O(o(this.event,F,x))}latch(){return new O(w(this.event))}debounce(F,x=100,Z=!1,B){return new O(p(this.event,F,x,Z,B))}on(F,x,Z){return this.event(F,x,Z)}once(F,x,Z){return l(this.event)(F,x,Z)}}function q(A){return new O(A)}c.chain=q;function $(A,F,x=Z=>Z){const Z=(...U)=>X.fire(x(...U)),B=()=>A.on(F,Z),j=()=>A.removeListener(F,Z),X=new d({onFirstListenerAdd:B,onLastListenerRemove:j});return X.event}c.fromNodeEventEmitter=$;function k(A,F,x=Z=>Z){const Z=(...U)=>X.fire(x(...U)),B=()=>A.addEventListener(F,Z),j=()=>A.removeEventListener(F,Z),X=new d({onFirstListenerAdd:B,onLastListenerRemove:j});return X.event}c.fromDOMEventEmitter=k;function z(A){return new Promise(F=>l(A)(F))}c.toPromise=z})(R=e.Event||(e.Event={}));class E{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${E._idPool++}`}start(l){this._stopWatch=new i.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let b=-1;function I(c){const l=b;return b=c,{dispose(){b=l}}}e.setGlobalLeakWarningThreshold=I;class C{constructor(l,r=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let r=b;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||l<r)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(a)||0;if(this._stacks.set(a,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,s=0;for(const[o,h]of this._stacks)(!t||s<h)&&(t=o,s=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${s}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}class d{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=b>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0}get event(){return this._event||(this._event=(l,r,a)=>{this._listeners||(this._listeners=new L.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[l,r]:l);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,r);const s=this._leakageMon?.check(this._listeners.size),o=(0,D.toDisposable)(()=>{s&&s(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof D.DisposableStore?a.add(o):Array.isArray(a)&&a.push(o),o}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new L.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,a]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(n){(0,T.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=d;class m extends d{async fireAsync(l,r,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,l]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),s=[],o={...t,waitUntil:h=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");a&&(h=a(h,typeof n=="function"?n:n[0])),s.push(h)}};try{typeof n=="function"?n.call(void 0,o):n[0].call(n[1],o)}catch(h){(0,T.onUnexpectedError)(h);continue}Object.freeze(s),await Promise.allSettled(s).then(h=>{for(const p of h)p.status==="rejected"&&(0,T.onUnexpectedError)(p.reason)})}}}}e.AsyncEmitter=m;class u extends d{constructor(l){super(l);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=u;class S extends u{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=S;class v extends d{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=v;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const r={event:l,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const a=()=>{this.hasListeners&&this.unhook(r);const n=this.events.indexOf(r);this.events.splice(n,1)};return(0,D.toDisposable)((0,_.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(r=>this.emitter.fire(r))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=g;class y{constructor(){this.buffers=[]}wrapEvent(l){return(r,a,n)=>l(t=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>r.call(a,t)):r.call(a,t)},void 0,n)}bufferEvents(l){const r=[];this.buffers.push(r);const a=l();return this.buffers.pop(),r.forEach(n=>n()),a}}e.EventBufferer=y;class f{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=D.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=f}),define(te[26],ne([0,1,3]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const _=Object.freeze(function(R,E){const b=setTimeout(R.bind(E),0);return{dispose(){clearTimeout(b)}}});var D;(function(R){function E(b){return b===R.None||b===R.Cancelled||b instanceof L?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}R.isCancellationToken=E,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:T.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:_})})(D=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?_:(this._emitter||(this._emitter=new T.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class i{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=D.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=i}),define(te[49],ne([0,1,3]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class _{constructor(){this._icons=new Map,this._onDidRegister=new T.Emitter}add(I){const C=this._icons.get(I.id);C?I.description?C.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new _;e.iconRegistry=D;function L(b){return b?b.replace(/\$\((.*?)\)/g,(I,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=L;class i{constructor(I,C,d){this.id=I,this.definition=C,this.description=d,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=i,i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function R(b,I){const C=["codicon","codicon-"+b];return I&&C.push("codicon-modifier-"+I),C}e.getClassNamesArray=R;var E;(function(b){b.iconNameSegment="[A-Za-z0-9]+",b.iconNameExpression="[A-Za-z0-9-]+",b.iconModifierExpression="~[A-Za-z]+",b.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${b.iconNameExpression})(${b.iconModifierExpression})?$`);function C(u){if(u instanceof i)return["codicon","codicon-"+u.id];const S=I.exec(u.id);if(!S)return C(i.error);let[,v,g]=S;const y=["codicon","codicon-"+v];return g&&y.push("codicon-modifier-"+g.substr(1)),y}b.asClassNameArray=C;function d(u){return C(u).join(" ")}b.asClassName=d;function m(u){return"."+C(u).join(".")}b.asCSSSelector=m})(E=e.CSSIcon||(e.CSSIcon={}))}),define(te[50],ne([0,1,7,2]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(f){const c=f;return c?[c.on,c.pause,c.resume,c.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=D;function L(f){const c=f;return c?D(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=L;function i(f,c){return new R(f,c)}e.newWriteableStream=i;class R{constructor(c,l){this.reducer=c,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(l=>l(c))}emitError(c){this.listeners.error.length===0?(0,T.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(l=>l(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,l){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(c,l){if(this.state.destroyed)return;let r;switch(c){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const a=r.indexOf(l);a>=0&&r.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(f,c){const l=[];let r;for(;(r=f.read())!==null;)l.push(r);return c(l)}e.consumeReadable=E;function b(f,c,l){const r=[];let a;for(;(a=f.read())!==null&&r.length<l;)r.push(a);return a===null&&r.length>0?c(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a!="undefined"){const n=a;return a=void 0,n}return f.read()}}}e.peekReadable=b;function I(f,c){return new Promise((l,r)=>{const a=[];C(f,{onData:n=>{c&&a.push(n)},onError:n=>{c?r(n):l(void 0)},onEnd:()=>{l(c?c(a):void 0)}})})}e.consumeStream=I;function C(f,c){f.on("error",l=>c.onError(l)),f.on("end",()=>c.onEnd()),f.on("data",l=>c.onData(l))}e.listenStream=C;function d(f,c){return new Promise((l,r)=>{const a=new _.DisposableStore,n=[],t=h=>{if(n.push(h),n.length>c)return a.dispose(),f.pause(),l({stream:f,buffer:n,ended:!1})},s=h=>r(h),o=()=>l({stream:f,buffer:n,ended:!0});a.add((0,_.toDisposable)(()=>f.removeListener("error",s))),f.on("error",s),a.add((0,_.toDisposable)(()=>f.removeListener("end",o))),f.on("end",o),a.add((0,_.toDisposable)(()=>f.removeListener("data",t))),f.on("data",t)})}e.peekStream=d;function m(f,c){const l=i(c);return l.end(f),l}e.toStream=m;function u(){const f=i(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=u;function S(f){let c=!1;return{read:()=>c?null:(c=!0,f)}}e.toReadable=S;function v(f,c,l){const r=i(l);return C(f,{onData:a=>r.write(c.data(a)),onError:a=>r.error(c.error?c.error(a):a),onEnd:()=>r.end()}),r}e.transform=v;function g(f,c,l){let r=!1;return{read:()=>{const a=c.read();return r?a:(r=!0,a!==null?l([f,a]):f)}}}e.prefixedReadable=g;function y(f,c,l){let r=!1;const a=i(l);return C(c,{onData:n=>r?a.write(n):(r=!0,a.write(l([f,n]))),onError:n=>a.error(n),onEnd:()=>{r||(r=!0,a.write(f)),a.end()}}),a}e.prefixedStream=y}),define(te[19],ne([0,1,50]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const _=typeof Buffer!="undefined";let D,L;class i{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return _?new i(Buffer.allocUnsafe(t)):new i(new Uint8Array(t))}static wrap(t){return _&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new i(t)}static fromString(t,s){return!(s?.dontUseNodeBuffer||!1)&&_?new i(Buffer.from(t)):(D||(D=new TextEncoder),new i(D.encode(t)))}static fromByteArray(t){const s=i.alloc(t.length);for(let o=0,h=t.length;o<h;o++)s.buffer[o]=t[o];return s}static concat(t,s){if(typeof s=="undefined"){s=0;for(let p=0,w=t.length;p<w;p++)s+=t[p].byteLength}const o=i.alloc(s);let h=0;for(let p=0,w=t.length;p<w;p++){const P=t[p];o.set(P,h),h+=P.byteLength}return o}clone(){const t=i.alloc(this.byteLength);return t.set(this),t}toString(){return _?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(t,s){return new i(this.buffer.subarray(t,s))}set(t,s){if(t instanceof i)this.buffer.set(t.buffer,s);else if(t instanceof Uint8Array)this.buffer.set(t,s);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),s);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),s);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return b(this.buffer,t)}writeUInt32BE(t,s){I(this.buffer,t,s)}readUInt32LE(t){return C(this.buffer,t)}writeUInt32LE(t,s){d(this.buffer,t,s)}readUInt8(t){return m(this.buffer,t)}writeUInt8(t,s){u(this.buffer,t,s)}}e.VSBuffer=i;function R(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=R;function E(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255}e.writeUInt16LE=E;function b(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=b;function I(n,t,s){n[s+3]=t,t=t>>>8,n[s+2]=t,t=t>>>8,n[s+1]=t,t=t>>>8,n[s]=t}e.writeUInt32BE=I;function C(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=C;function d(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255,t=t>>>8,n[s+2]=t&255,t=t>>>8,n[s+3]=t&255}e.writeUInt32LE=d;function m(n,t){return n[t]}e.readUInt8=m;function u(n,t,s){n[s]=t}e.writeUInt8=u;function S(n){return T.consumeReadable(n,t=>i.concat(t))}e.readableToBuffer=S;function v(n){return T.toReadable(n)}e.bufferToReadable=v;function g(n){return T.consumeStream(n,t=>i.concat(t))}e.streamToBuffer=g;async function y(n){return n.ended?i.concat(n.buffer):i.concat([...n.buffer,await g(n.stream)])}e.bufferedStreamToBuffer=y;function f(n){return T.toStream(n,t=>i.concat(t))}e.bufferToStream=f;function c(n){return T.transform(n,{data:t=>typeof t=="string"?i.fromString(t):i.wrap(t)},t=>i.concat(t))}e.streamToBufferReadableStream=c;function l(n){return T.newWriteableStream(t=>i.concat(t),n)}e.newWriteableBufferStream=l;function r(n,t){return T.prefixedReadable(n,t,s=>i.concat(s))}e.prefixedBufferReadable=r;function a(n,t){return T.prefixedStream(n,t,s=>i.concat(s))}e.prefixedBufferStream=a}),define(te[25],ne([0,1,4]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function _(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=_;const D=/{(\d+)}/g;function L(K,...se){return se.length===0?K:K.replace(D,function(ue,fe){const pe=parseInt(fe,10);return isNaN(pe)||pe<0||pe>=se.length?ue:se[pe]})}e.format=L;const i=/{([^}]+)}/g;function R(K,se){return K.replace(i,(ue,fe)=>se[fe]??ue)}e.format2=R;function E(K){return K.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=E;function b(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function I(K,se){let ue=0;const fe=se.charCodeAt(0);for(let pe=K.length-1;pe>=0;pe--)K.charCodeAt(pe)===fe&&ue++;return ue}e.count=I;function C(K,se,ue="\u2026"){return K.length<=se?K:`${K.substr(0,se)}${ue}`}e.truncate=C;function d(K,se=" "){const ue=m(K,se);return u(ue,se)}e.trim=d;function m(K,se){if(!K||!se)return K;const ue=se.length;if(ue===0||K.length===0)return K;let fe=0;for(;K.indexOf(se,fe)===fe;)fe=fe+ue;return K.substring(fe)}e.ltrim=m;function u(K,se){if(!K||!se)return K;const ue=se.length,fe=K.length;if(ue===0||fe===0)return K;let pe=fe,ge=-1;for(;ge=K.lastIndexOf(se,pe-1),!(ge===-1||ge+ue!==pe);){if(ge===0)return"";pe=ge}return K.substring(0,pe)}e.rtrim=u;function S(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=S;function v(K){return K.replace(/\*/g,"")}e.stripWildcards=v;function g(K,se,ue={}){if(!K)throw new Error("Cannot create regex from empty string");se||(K=b(K)),ue.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let fe="";return ue.global&&(fe+="g"),ue.matchCase||(fe+="i"),ue.multiline&&(fe+="m"),ue.unicode&&(fe+="u"),new RegExp(K,fe)}e.createRegExp=g;function y(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function f(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function c(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=c;function l(K){return K.split(/\r\n|\r|\n/)}e.splitLines=l;function r(K){for(let se=0,ue=K.length;se<ue;se++){const fe=K.charCodeAt(se);if(fe!==32&&fe!==9)return se}return-1}e.firstNonWhitespaceIndex=r;function a(K,se=0,ue=K.length){for(let fe=se;fe<ue;fe++){const pe=K.charCodeAt(fe);if(pe!==32&&pe!==9)return K.substring(se,fe)}return K.substring(se,ue)}e.getLeadingWhitespace=a;function n(K,se=K.length-1){for(let ue=se;ue>=0;ue--){const fe=K.charCodeAt(ue);if(fe!==32&&fe!==9)return ue}return-1}e.lastNonWhitespaceIndex=n;function t(K,se){return K<se?-1:K>se?1:0}e.compare=t;function s(K,se,ue=0,fe=K.length,pe=0,ge=se.length){for(;ue<fe&&pe<ge;ue++,pe++){let ke=K.charCodeAt(ue),_e=se.charCodeAt(pe);if(ke<_e)return-1;if(ke>_e)return 1}const Ee=fe-ue,Pe=ge-pe;return Ee<Pe?-1:Ee>Pe?1:0}e.compareSubstring=s;function o(K,se){return h(K,se,0,K.length,0,se.length)}e.compareIgnoreCase=o;function h(K,se,ue=0,fe=K.length,pe=0,ge=se.length){for(;ue<fe&&pe<ge;ue++,pe++){let ke=K.charCodeAt(ue),_e=se.charCodeAt(pe);if(ke===_e)continue;if(ke>=128||_e>=128)return s(K.toLowerCase(),se.toLowerCase(),ue,fe,pe,ge);p(ke)&&(ke-=32),p(_e)&&(_e-=32);const We=ke-_e;if(We!==0)return We}const Ee=fe-ue,Pe=ge-pe;return Ee<Pe?-1:Ee>Pe?1:0}e.compareSubstringIgnoreCase=h;function p(K){return K>=97&&K<=122}e.isLowerAsciiLetter=p;function w(K){return K>=65&&K<=90}e.isUpperAsciiLetter=w;function P(K,se){return K.length===se.length&&h(K,se)===0}e.equalsIgnoreCase=P;function M(K,se){const ue=se.length;return se.length>K.length?!1:h(K,se,0,ue)===0}e.startsWithIgnoreCase=M;function O(K,se){let ue,fe=Math.min(K.length,se.length);for(ue=0;ue<fe;ue++)if(K.charCodeAt(ue)!==se.charCodeAt(ue))return ue;return fe}e.commonPrefixLength=O;function q(K,se){let ue,fe=Math.min(K.length,se.length);const pe=K.length-1,ge=se.length-1;for(ue=0;ue<fe;ue++)if(K.charCodeAt(pe-ue)!==se.charCodeAt(ge-ue))return ue;return fe}e.commonSuffixLength=q;function $(K){return 55296<=K&&K<=56319}e.isHighSurrogate=$;function k(K){return 56320<=K&&K<=57343}e.isLowSurrogate=k;function z(K,se){return(K-55296<<10)+(se-56320)+65536}e.computeCodePoint=z;function A(K,se,ue){const fe=K.charCodeAt(ue);if($(fe)&&ue+1<se){const pe=K.charCodeAt(ue+1);if(k(pe))return z(fe,pe)}return fe}e.getNextCodePoint=A;function F(K,se){const ue=K.charCodeAt(se-1);if(k(ue)&&se>1){const fe=K.charCodeAt(se-2);if($(fe))return z(fe,ue)}return ue}function x(K,se){const ue=ae.getInstance(),fe=se,pe=K.length,ge=A(K,pe,se);se+=ge>=65536?2:1;let Ee=ue.getGraphemeBreakType(ge);for(;se<pe;){const Pe=A(K,pe,se),ke=ue.getGraphemeBreakType(Pe);if(ze(Ee,ke))break;se+=Pe>=65536?2:1,Ee=ke}return se-fe}e.nextCharLength=x;function Z(K,se){const ue=ae.getInstance(),fe=se,pe=F(K,se);se-=pe>=65536?2:1;let ge=ue.getGraphemeBreakType(pe);for(;se>0;){const Ee=F(K,se),Pe=ue.getGraphemeBreakType(Ee);if(ze(Pe,ge))break;se-=Ee>=65536?2:1,ge=Pe}return fe-se}e.prevCharLength=Z;function B(K,se){const ue=ae.getInstance(),fe=K.length,pe=se,ge=A(K,fe,se),Ee=ue.getGraphemeBreakType(ge);se+=ge>=65536?2:1;let Pe=Ee;for(;se<fe;){const _e=A(K,fe,se),We=ue.getGraphemeBreakType(_e);if(ze(Pe,We))break;se+=_e>=65536?2:1,Pe=We}const ke=se;for(se=pe,Pe=Ee;se>0;){const _e=F(K,se),We=ue.getGraphemeBreakType(_e);if(ze(We,Pe))break;se-=_e>=65536?2:1,Pe=We}return[se,ke]}function j(K,se){return se>0&&k(K.charCodeAt(se))?B(K,se-1):B(K,se)}e.getCharContainingOffset=j;const X=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function U(K){return X.test(K)}e.containsRTL=U;const N=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function W(K){return N.test(K)}e.containsEmoji=W;const V=/^[\t\n\r\x20-\x7E]*$/;function G(K){return V.test(K)}e.isBasicASCII=G,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ee(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=ee;function H(K){for(let se=0,ue=K.length;se<ue;se++)if(Q(K.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=H;function Q(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=Q;function re(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=re;function oe(K,se){if(K.length<se)return K;const ue=/\b/g;let fe=0;for(;ue.test(K)&&!(K.length-ue.lastIndex<se);)fe=ue.lastIndex,ue.lastIndex+=1;return K.substring(fe).replace(/^\s/,"")}e.lcut=oe;const ce=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,be=/\x1b\[0?m/g;function Ie(K){return K&&(K=K.replace(ce,""),K=K.replace(he,""),K=K.replace(be,"")),K}e.removeAnsiEscapeCodes=Ie,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Se(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Se;function ve(K){return Se(K)?K.substr(1):K}e.stripUTF8BOM=ve;function Re(K,se){if(!K||!se||K.length<se.length)return!1;const ue=se.length,fe=K.toLowerCase();let pe=0,ge=-1;for(;pe<ue;){const Ee=fe.indexOf(se[pe],ge+1);if(Ee<0)return!1;ge=Ee,pe++}return!0}e.fuzzyContains=Re;function ye(K,se=!1){return K?(se&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=ye;function De(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=De;function Le(K,se=1){if(se===0)return"";let ue=-1;do ue=K.indexOf(`
`,ue+1),se--;while(se>0&&ue>=0);return ue===-1?K:(K[ue-1]==="\r"&&ue--,K.substr(0,ue))}e.getNLines=Le;function Fe(K){const se=90-65+1;return K=K%(2*se),K<se?String.fromCharCode(97+K):String.fromCharCode(65+K-se)}e.singleLetterHash=Fe;function $e(K){return ae.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=$e;function ze(K,se){return K===0?se!==5&&se!==7:K===2&&se===3?!1:K===4||K===2||K===3||se===4||se===2||se===3?!0:!(K===8&&(se===8||se===9||se===11||se===12)||(K===11||K===9)&&(se===9||se===10)||(K===12||K===10)&&se===10||se===5||se===13||se===7||K===1||K===13&&se===14||K===6&&se===6)}e.breakBetweenGraphemeBreakType=ze;var ie;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=le()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ue=this._data,fe=ue.length/3;let pe=1;for(;pe<=fe;)if(se<ue[3*pe])pe=2*pe;else if(se>ue[3*pe+1])pe=2*pe+1;else return ue[3*pe+2];return 0}}ae._INSTANCE=null;function le(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function we(K,se){if(K===0)return 0;const ue=Ce(K,se);if(ue!==void 0)return ue;const fe=F(se,K);return K-=Oe(fe),K}e.getLeftDeleteOffset=we;function Ce(K,se){let ue=F(se,K);for(K-=Oe(ue);Te(ue)||ue===65039||ue===8419;){if(K===0)return;ue=F(se,K),K-=Oe(ue)}if(!!re(ue)){if(K>=0){const fe=F(se,K);fe===8205&&(K-=Oe(fe))}return K}}function Oe(K){return K>=65536?2:1}function Te(K){return 127995<=K&&K<=127999}var Ne;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Ne||(Ne={})),e.noBreakWhitespace="\xA0";class Ae{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!Ae.map){let fe=function(Ee){const Pe=new Map;for(let ke=0;ke<Ee.length;ke+=2)Pe.set(Ee[ke],Ee[ke+1]);return Pe};const se=Ae.getData();let ue=T.locale;(!ue||!(ue in se))&&(ue=T.language),(!ue||!(ue in se))&&(ue="_default");const pe=fe(se._common),ge=fe(se[ue]);for(const[Ee,Pe]of ge)pe.set(Ee,Pe);Ae.map=pe}return Ae.map}static isAmbiguous(se){return Ae.getConfusablesForCurrentLocale().has(se)}static getPrimaryConfusable(se){return Ae.getConfusablesForCurrentLocale().get(se)}static getPrimaryConfusableCodePoints(){return new Set(Ae.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=Ae;class Me{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Me.getRawData())),this._data}static isInvisibleCharacter(se){return Me.getData().has(se)}static get codePoints(){return Me.getData()}}e.InvisibleCharacters=Me,Me._data=void 0}),define(te[104],ne([0,1,25]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function _(g){return D(g,0)}e.hash=_;function D(g,y){switch(typeof g){case"object":return g===null?L(349,y):Array.isArray(g)?E(g,y):b(g,y);case"string":return R(g,y);case"boolean":return i(g,y);case"number":return L(g,y);case"undefined":return L(937,y);default:return L(617,y)}}e.doHash=D;function L(g,y){return(y<<5)-y+g|0}e.numberHash=L;function i(g,y){return L(g?433:863,y)}function R(g,y){y=L(149417,y);for(let f=0,c=g.length;f<c;f++)y=L(g.charCodeAt(f),y);return y}e.stringHash=R;function E(g,y){return y=L(104579,y),g.reduce((f,c)=>D(c,f),y)}function b(g,y){return y=L(181387,y),Object.keys(g).sort().reduce((f,c)=>(f=R(c,f),D(g[c],f)),y)}class I{constructor(){this._value=0}get value(){return this._value}hash(y){return this._value=D(y,this._value),this._value}}e.Hasher=I;var C;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function d(g,y,f=32){const c=f-y,l=~((1<<c)-1);return(g<<y|(l&g)>>>c)>>>0}function m(g,y=0,f=g.byteLength,c=0){for(let l=0;l<f;l++)g[y+l]=c}function u(g,y,f="0"){for(;g.length<y;)g=f+g;return g}function S(g,y=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(f=>f.toString(16).padStart(2,"0")).join(""):u((g>>>0).toString(16),y/4)}e.toHexString=S;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(y){const f=y.length;if(f===0)return;const c=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,a,n;for(r!==0?(a=r,n=-1,r=0):(a=y.charCodeAt(0),n=0);;){let t=a;if(T.isHighSurrogate(a))if(n+1<f){const s=y.charCodeAt(n+1);T.isLowSurrogate(s)?(n++,t=T.computeCodePoint(a,s)):t=65533}else{r=a;break}else T.isLowSurrogate(a)&&(t=65533);if(l=this._push(c,l,t),n++,n<f)a=y.charCodeAt(n);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(y,f,c){return c<128?y[f++]=c:c<2048?(y[f++]=192|(c&1984)>>>6,y[f++]=128|(c&63)>>>0):c<65536?(y[f++]=224|(c&61440)>>>12,y[f++]=128|(c&4032)>>>6,y[f++]=128|(c&63)>>>0):(y[f++]=240|(c&1835008)>>>18,y[f++]=128|(c&258048)>>>12,y[f++]=128|(c&4032)>>>6,y[f++]=128|(c&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const y=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(y/4294967296),!1),this._buffDV.setUint32(60,y%4294967296,!1),this._step()}_step(){const y=v._bigBlock32,f=this._buffDV;for(let h=0;h<64;h+=4)y.setUint32(h,f.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)y.setUint32(h,d(y.getUint32(h-12,!1)^y.getUint32(h-32,!1)^y.getUint32(h-56,!1)^y.getUint32(h-64,!1),1),!1);let c=this._h0,l=this._h1,r=this._h2,a=this._h3,n=this._h4,t,s,o;for(let h=0;h<80;h++)h<20?(t=l&r|~l&a,s=1518500249):h<40?(t=l^r^a,s=1859775393):h<60?(t=l&r|l&a|r&a,s=2400959708):(t=l^r^a,s=3395469782),o=d(c,5)+t+n+s+y.getUint32(h*4,!1)&4294967295,n=a,a=r,r=d(l,30),l=c,c=o;this._h0=this._h0+c&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var bt=this&&this.__classPrivateFieldSet||function(J,e,T,_,D){if(_==="m")throw new TypeError("Private method is not writable");if(_==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return _==="a"?D.call(J,T):D?D.value=T:e.set(J,T),T},Ve=this&&this.__classPrivateFieldGet||function(J,e,T,_){if(T==="a"&&!_)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!_:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return T==="m"?_:T==="a"?_.call(J):_?_.value:e.get(J)};define(te[40],ne([0,1,16,25]),function(J,e,T,_){"use strict";var D,L,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(n,t,s){let o=n.get(t);return o===void 0&&(o=s,n.set(t,o)),o}e.getOrSet=R;function E(n){const t=[];return n.forEach((s,o)=>{t.push(`${o} => ${s}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=E;function b(n){const t=[];return n.forEach(s=>{t.push(s)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=b;class I{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=I;class C{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,_.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,_.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class d{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let s=t.length-1;s>=0;s--,this._valueLen--){const o=this._value.charCodeAt(s);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,_.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,_.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var m;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(m||(m={}));class u{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,_.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,_.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,_.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,_.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(v||(v={}));class g{constructor(t){this._iter=t}static forUris(t=()=>!1){return new g(new u(t))}static forPaths(){return new g(new d)}static forStrings(){return new g(new I)}static forConfigKeys(){return new g(new C)}clear(){this._root=void 0}fill(t,s){if(s){const o=s.slice(0);(0,T.shuffle)(o);for(let h of o)this.set(h,t)}else{const o=t.slice(0);(0,T.shuffle)(o);for(let h of o)this.set(h[0],h[1])}}set(t,s){const o=this._iter.reset(t);let h;this._root||(this._root=new S,this._root.segment=o.value());const p=[];for(h=this._root;;){const P=o.cmp(h.segment);if(P>0)h.left||(h.left=new S,h.left.segment=o.value()),p.push([-1,h]),h=h.left;else if(P<0)h.right||(h.right=new S,h.right.segment=o.value()),p.push([1,h]),h=h.right;else if(o.hasNext())o.next(),h.mid||(h.mid=new S,h.mid.segment=o.value()),p.push([0,h]),h=h.mid;else break}const w=h.value;h.value=s,h.key=t;for(let P=p.length-1;P>=0;P--){const M=p[P][1];M.updateHeight();const O=M.balanceFactor();if(O<-1||O>1){const q=p[P][0],$=p[P+1][0];if(q===1&&$===1)p[P][1]=M.rotateLeft();else if(q===-1&&$===-1)p[P][1]=M.rotateRight();else if(q===1&&$===-1)M.right=p[P+1][1]=p[P+1][1].rotateRight(),p[P][1]=M.rotateLeft();else if(q===-1&&$===1)M.left=p[P+1][1]=p[P+1][1].rotateLeft(),p[P][1]=M.rotateRight();else throw new Error;if(P>0)switch(p[P-1][0]){case-1:p[P-1][1].left=p[P][1];break;case 1:p[P-1][1].right=p[P][1];break;case 0:p[P-1][1].mid=p[P][1];break}else this._root=p[0][1]}}return w}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const o=this._iter.reset(t),h=[];let p=this._root;for(;p;){const w=o.cmp(p.segment);if(w>0)h.push([-1,p]),p=p.left;else if(w<0)h.push([1,p]),p=p.right;else if(o.hasNext())o.next(),h.push([0,p]),p=p.mid;else break}if(!!p){if(s?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const w=this._min(p.right),{key:P,value:M,segment:O}=w;this._delete(w.key,!1),p.key=P,p.value=M,p.segment=O}else{const w=p.left??p.right;if(h.length>0){const[P,M]=h[h.length-1];switch(P){case-1:M.left=w;break;case 0:M.mid=w;break;case 1:M.right=w;break}}else this._root=w}for(let w=h.length-1;w>=0;w--){const P=h[w][1];P.updateHeight();const M=P.balanceFactor();if(M>1?(P.right.balanceFactor()>=0||(P.right=P.right.rotateRight()),h[w][1]=P.rotateLeft()):M<-1&&(P.left.balanceFactor()<=0||(P.left=P.left.rotateLeft()),h[w][1]=P.rotateRight()),w>0)switch(h[w-1][0]){case-1:h[w-1][1].left=h[w][1];break;case 1:h[w-1][1].right=h[w][1];break;case 0:h[w-1][1].mid=h[w][1];break}else this._root=h[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let o=this._root,h;for(;o;){const p=s.cmp(o.segment);if(p>0)o=o.left;else if(p<0)o=o.right;else if(s.hasNext())s.next(),h=o.value||h,o=o.mid;else break}return o&&o.value||h}findSuperstr(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[s,o]of this)t(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=g;class y{constructor(t,s){this.uri=t,this.value=s}}class f{constructor(t,s){this[D]="ResourceMap",t instanceof f?(this.map=new Map(t.map),this.toKey=s??f.defaultToKey):(this.map=new Map,this.toKey=t??f.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new y(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[o,h]of this.map)t(h.value,h.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=f,f.defaultToKey=n=>n.toString();var c;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class l{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const o=this._map.get(t);if(!!o)return s!==0&&this.touch(o,s),o.value}set(t,s,o=0){let h=this._map.get(t);if(h)h.value=s,o!==0&&this.touch(h,o);else{switch(h={key:t,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(t,h),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const o=this._state;let h=this._head;for(;h;){if(s?t.bind(s)(h.value,h.key,this):t(h.value,h.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const t=this,s=this._state;let o=this._head;const h={[Symbol.iterator](){return h},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:o.key,done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return h}values(){const t=this,s=this._state;let o=this._head;const h={[Symbol.iterator](){return h},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:o.value,done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return h}entries(){const t=this,s=this._state;let o=this._head;const h={[Symbol.iterator](){return h},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:[o.key,o.value],done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return h}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>t;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,o=t.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const o=t.next,h=t.previous;t===this._tail?(h.next=void 0,this._tail=h):(o.previous=h,h.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const o=t.next,h=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=h,h.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,o)=>{t.push([o,s])}),t}fromJSON(t){this.clear();for(const[s,o]of t)this.set(s,o)}}e.LinkedMap=l;class r extends l{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class a{constructor(t){i.set(this,void 0),bt(this,i,t,"f")}get size(){return Ve(this,i,"f").size}forEach(t,s){Ve(this,i,"f").forEach(t,s)}get(t){return Ve(this,i,"f").get(t)}has(t){return Ve(this,i,"f").has(t)}entries(){return Ve(this,i,"f").entries()}keys(){return Ve(this,i,"f").keys()}values(){return Ve(this,i,"f").values()}[(i=new WeakMap,Symbol.iterator)](){return Ve(this,i,"f").entries()}}e.ReadonlyMapView=a}),define(te[69],ne([0,1,40]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const _=new T.LRUCache(1e4);function D(b){return E(b,"NFC",_)}e.normalizeNFC=D;const L=new T.LRUCache(1e4);function i(b){return E(b,"NFD",L)}e.normalizeNFD=i;const R=/[^\u0000-\u0080]/;function E(b,I,C){if(!b)return b;const d=C.get(b);if(d)return d;let m;return R.test(b)?m=b.normalize(I):m=b,C.set(b,m),m}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(I){return i(I).replace(b,"")}}()}),define(te[15],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function T(p){return Array.isArray(p)}e.isArray=T;function _(p){return typeof p=="string"}e.isString=_;function D(p){return Array.isArray(p)&&p.every(w=>_(w))}e.isStringArray=D;function L(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}e.isObject=L;function i(p){return typeof p=="number"&&!isNaN(p)}e.isNumber=i;function R(p){return!!p&&typeof p[Symbol.iterator]=="function"}e.isIterable=R;function E(p){return p===!0||p===!1}e.isBoolean=E;function b(p){return typeof p=="undefined"}e.isUndefined=b;function I(p){return!C(p)}e.isDefined=I;function C(p){return b(p)||p===null}e.isUndefinedOrNull=C;function d(p,w){if(!p)throw new Error(w?`Unexpected type, expected '${w}'`:"Unexpected type")}e.assertType=d;function m(p){if(C(p))throw new Error("Assertion Failed: argument is undefined or null");return p}e.assertIsDefined=m;function u(...p){const w=[];for(let P=0;P<p.length;P++){const M=p[P];if(C(M))throw new Error(`Assertion Failed: argument at index ${P} is undefined or null`);w.push(M)}return w}e.assertAllDefined=u;const S=Object.prototype.hasOwnProperty;function v(p){if(!L(p))return!1;for(let w in p)if(S.call(p,w))return!1;return!0}e.isEmptyObject=v;function g(p){return typeof p=="function"}e.isFunction=g;function y(...p){return p.length>0&&p.every(g)}e.areFunctions=y;function f(p,w){const P=Math.min(p.length,w.length);for(let M=0;M<P;M++)c(p[M],w[M])}e.validateConstraints=f;function c(p,w){if(_(w)){if(typeof p!==w)throw new Error(`argument does not match constraint: typeof ${w}`)}else if(g(w)){try{if(p instanceof w)return}catch{}if(!C(p)&&p.constructor===w||w.length===1&&w.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function l(p){let w=[],P=Object.getPrototypeOf(p);for(;Object.prototype!==P;)w=w.concat(Object.getOwnPropertyNames(P)),P=Object.getPrototypeOf(P);return w}e.getAllPropertyNames=l;function r(p){const w=[];for(const P of l(p))typeof p[P]=="function"&&w.push(P);return w}e.getAllMethodNames=r;function a(p,w){const P=O=>function(){const q=Array.prototype.slice.call(arguments,0);return w(O,q)};let M={};for(const O of p)M[O]=P(O);return M}e.createProxyObject=a;function n(p){return p===null?void 0:p}e.withNullAsUndefined=n;function t(p){return typeof p=="undefined"?null:p}e.withUndefinedAsNull=t;function s(p){return class{constructor(){return new Proxy({},{get(w,P){if(w[P])return w[P];throw new Error(`Not Implemented: ${p}->${String(P)}`)}})}}}e.NotImplementedProxy=s;function o(p,w="Unreachable"){throw new Error(w)}e.assertNever=o;function h(p){return!!p&&typeof p.then=="function"&&typeof p.catch=="function"}e.isPromise=h}),define(te[41],ne([0,1,10,4,25,15]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function i(n){return n===47||n===92}e.isPathSeparator=i;function R(n){return n.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=R;function E(n){return n.indexOf("/")===-1&&(n=R(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=E;function b(n,t=T.posix.sep){if(!n)return"";const s=n.length,o=n.charCodeAt(0);if(i(o)){if(i(n.charCodeAt(1))&&!i(n.charCodeAt(2))){let p=3;const w=p;for(;p<s&&!i(n.charCodeAt(p));p++);if(w!==p&&!i(n.charCodeAt(p+1))){for(p+=1;p<s;p++)if(i(n.charCodeAt(p)))return n.slice(0,p+1).replace(/[\\/]/g,t)}}return t}else if(g(o)&&n.charCodeAt(1)===58)return i(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let h=n.indexOf("://");if(h!==-1){for(h+=3;h<s;h++)if(i(n.charCodeAt(h)))return n.slice(0,h+1)}return""}e.getRoot=b;function I(n){if(!_.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let s=2;const o=s;for(;s<n.length&&(t=n.charCodeAt(s),t!==92);s++);return!(o===s||(t=n.charCodeAt(s+1),isNaN(t)||t===92))}e.isUNC=I;const C=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(n,t=_.isWindows){const s=t?C:d;return!(!n||n.length===0||/^\s+$/.test(n)||(s.lastIndex=0,s.test(n))||t&&m.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=u;function S(n,t,s){const o=n===t;return!s||o?o:!n||!t?!1:(0,D.equalsIgnoreCase)(n,t)}e.isEqual=S;function v(n,t,s,o=T.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(s){if(!(0,D.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let p=t.length;return t.charAt(t.length-1)===o&&p--,n.charAt(p)===o}return t.charAt(t.length-1)!==o&&(t+=o),n.indexOf(t)===0}e.isEqualOrParent=v;function g(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=g;function y(n,t){return _.isWindows&&n.endsWith(":")&&(n+=T.sep),(0,T.isAbsolute)(n)||(n=(0,T.join)(t,n)),n=(0,T.normalize)(n),_.isWindows?(n=(0,D.rtrim)(n,T.sep),n.endsWith(":")&&(n+=T.sep)):(n=(0,D.rtrim)(n,T.sep),n||(n=T.sep)),n}e.sanitizeFilePath=y;function f(n){const t=(0,T.normalize)(n);return _.isWindows?n.length>3?!1:c(t)&&(n.length===2||t.charCodeAt(2)===92):t===T.posix.sep}e.isRootOrDriveLetter=f;function c(n,t){return(t!==void 0?t:_.isWindows)?g(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function l(n){return c(n)?n[0]:void 0}e.getDriveLetter=l;function r(n,t,s){return t.length>n.length?-1:n===t?0:(s&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=r;function a(n){const t=n.split(":");let s,o,h;if(t.forEach(p=>{const w=Number(p);(0,L.isNumber)(w)?o===void 0?o=w:h===void 0&&(h=w):s=s?[s,p].join(":"):p}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:o!==void 0?o:void 0,column:h!==void 0?h:o!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(te[28],ne([0,1,15]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function _(S){if(!S||typeof S!="object"||S instanceof RegExp)return S;const v=Array.isArray(S)?[]:{};return Object.keys(S).forEach(g=>{S[g]&&typeof S[g]=="object"?v[g]=_(S[g]):v[g]=S[g]}),v}e.deepClone=_;function D(S){if(!S||typeof S!="object")return S;const v=[S];for(;v.length>0;){const g=v.shift();Object.freeze(g);for(const y in g)if(L.call(g,y)){const f=g[y];typeof f=="object"&&!Object.isFrozen(f)&&v.push(f)}}return S}e.deepFreeze=D;const L=Object.prototype.hasOwnProperty;function i(S,v){return R(S,v,new Set)}e.cloneAndChange=i;function R(S,v,g){if((0,T.isUndefinedOrNull)(S))return S;const y=v(S);if(typeof y!="undefined")return y;if((0,T.isArray)(S)){const f=[];for(const c of S)f.push(R(c,v,g));return f}if((0,T.isObject)(S)){if(g.has(S))throw new Error("Cannot clone recursive data-structure");g.add(S);const f={};for(let c in S)L.call(S,c)&&(f[c]=R(S[c],v,g));return g.delete(S),f}return S}function E(S,v,g=!0){return(0,T.isObject)(S)?((0,T.isObject)(v)&&Object.keys(v).forEach(y=>{y in S?g&&((0,T.isObject)(S[y])&&(0,T.isObject)(v[y])?E(S[y],v[y],g):S[y]=v[y]):S[y]=v[y]}),S):v}e.mixin=E;function b(S,v){if(S===v)return!0;if(S==null||v===null||v===void 0||typeof S!=typeof v||typeof S!="object"||Array.isArray(S)!==Array.isArray(v))return!1;let g,y;if(Array.isArray(S)){if(S.length!==v.length)return!1;for(g=0;g<S.length;g++)if(!b(S[g],v[g]))return!1}else{const f=[];for(y in S)f.push(y);f.sort();const c=[];for(y in v)c.push(y);if(c.sort(),!b(f,c))return!1;for(g=0;g<f.length;g++)if(!b(S[f[g]],v[f[g]]))return!1}return!0}e.equals=b;function I(S){const v=new Set;return JSON.stringify(S,(g,y)=>{if((0,T.isObject)(y)||Array.isArray(y)){if(v.has(y))return"[Circular]";v.add(y)}return y})}e.safeStringify=I;function C(S,v,g){const y=v(S);return typeof y=="undefined"?g:y}e.getOrDefault=C;function d(S,v){const g=Object.create(null);return!S||!v||Object.keys(v).forEach(f=>{const c=S[f],l=v[f];b(c,l)||(g[f]=l)}),g}e.distinct=d;function m(S,v){const g=v.toLowerCase(),y=Object.keys(S).find(f=>f.toLowerCase()===g);return y?S[y]:S[v]}e.getCaseInsensitive=m;function u(S,v){const g=Object.create(null);for(const[y,f]of Object.entries(S))v(y,f)&&(g[y]=f);return g}e.filter=u}),define(te[8],ne([0,1,10,4]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,L=/^\//,i=/^\/\//;function R(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!L.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(i.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(n,t){return!n&&!t?"file":n}function b(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==C&&(t=C+t):t=C;break}return t}const I="",C="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(t,s,o,h,p,w=!1){typeof t=="object"?(this.scheme=t.scheme||I,this.authority=t.authority||I,this.path=t.path||I,this.query=t.query||I,this.fragment=t.fragment||I):(this.scheme=E(t,w),this.authority=s||I,this.path=b(this.scheme,o||I),this.query=h||I,this.fragment=p||I,R(this,w))}static isUri(t){return t instanceof m?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return f(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:o,path:h,query:p,fragment:w}=t;return s===void 0?s=this.scheme:s===null&&(s=I),o===void 0?o=this.authority:o===null&&(o=I),h===void 0?h=this.path:h===null&&(h=I),p===void 0?p=this.query:p===null&&(p=I),w===void 0?w=this.fragment:w===null&&(w=I),s===this.scheme&&o===this.authority&&h===this.path&&p===this.query&&w===this.fragment?this:new S(s,o,h,p,w)}static parse(t,s=!1){const o=d.exec(t);return o?new S(o[2]||I,a(o[4]||I),a(o[5]||I),a(o[7]||I),a(o[9]||I),s):new S(I,I,I,I,I)}static file(t){let s=I;if(_.isWindows&&(t=t.replace(/\\/g,C)),t[0]===C&&t[1]===C){const o=t.indexOf(C,2);o===-1?(s=t.substring(2),t=C):(s=t.substring(2,o),t=t.substring(o)||C)}return new S("file",s,t,I,I)}static from(t){const s=new S(t.scheme,t.authority,t.path,t.query,t.fragment);return R(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return _.isWindows&&t.scheme==="file"?o=m.file(T.win32.join(f(t,!0),...s)).path:o=T.posix.join(t.path,...s),t.with({path:o})}toString(t=!1){return c(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof m)return t;{const s=new S(t);return s._formatted=t.external,s._fsPath=t._sep===u?t.fsPath:null,s}}else return t}}e.URI=m;const u=_.isWindows?1:void 0;class S extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(t=!1){return t?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=u),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(n,t){let s,o=-1;for(let h=0;h<n.length;h++){const p=n.charCodeAt(h);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||t&&p===47)o!==-1&&(s+=encodeURIComponent(n.substring(o,h)),o=-1),s!==void 0&&(s+=n.charAt(h));else{s===void 0&&(s=n.substr(0,h));const w=v[p];w!==void 0?(o!==-1&&(s+=encodeURIComponent(n.substring(o,h)),o=-1),s+=w):o===-1&&(o=h)}}return o!==-1&&(s+=encodeURIComponent(n.substring(o))),s!==void 0?s:n}function y(n){let t;for(let s=0;s<n.length;s++){const o=n.charCodeAt(s);o===35||o===63?(t===void 0&&(t=n.substr(0,s)),t+=v[o]):t!==void 0&&(t+=n[s])}return t!==void 0?t:n}function f(n,t){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,_.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=f;function c(n,t){const s=t?y:g;let o="",{scheme:h,authority:p,path:w,query:P,fragment:M}=n;if(h&&(o+=h,o+=":"),(p||h==="file")&&(o+=C,o+=C),p){let O=p.indexOf("@");if(O!==-1){const q=p.substr(0,O);p=p.substr(O+1),O=q.indexOf(":"),O===-1?o+=s(q,!1):(o+=s(q.substr(0,O),!1),o+=":",o+=s(q.substr(O+1),!1)),o+="@"}p=p.toLowerCase(),O=p.indexOf(":"),O===-1?o+=s(p,!1):(o+=s(p.substr(0,O),!1),o+=p.substr(O))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const O=w.charCodeAt(1);O>=65&&O<=90&&(w=`/${String.fromCharCode(O+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const O=w.charCodeAt(0);O>=65&&O<=90&&(w=`${String.fromCharCode(O+32)}:${w.substr(2)}`)}o+=s(w,!0)}return P&&(o+="?",o+=s(P,!1)),M&&(o+="#",o+=t?M:g(M,!1)),o}function l(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+l(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(n){return n.match(r)?n.replace(r,t=>l(t)):n}}),define(te[105],ne([0,1,8]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function _(b){const I=b;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=_;function D(b){const I=[];let C;try{const d=JSON.parse(b.arguments),m=d[d.length-1];m&&m.__$stack&&(d.pop(),C=m.__$stack),I.push(...d)}catch(d){I.push("Unable to log remote console arguments",b.arguments)}return{args:I,stack:C}}e.parse=D;function L(b){if(typeof b!="string")return L(D(b).stack);const I=b;if(I){const C=i(I),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(d&&d.length===4)return{uri:T.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=L;function i(b){if(!b)return b;const I=b.indexOf(`
`);return I===-1?b:b.substring(0,I)}function R(b,I){const{args:C,stack:d}=D(b),m=typeof C[0]=="string"&&C.length===1;let u=i(d);u&&(u=`(${u.trim()})`);let S=[];if(typeof C[0]=="string"?u&&m?S=[`%c[${I}] %c${C[0]} %c${u}`,E("blue"),E(""),E("grey")]:S=[`%c[${I}] %c${C[0]}`,E("blue"),E(""),...C.slice(1)]:S=[`%c[${I}]%`,E("blue"),...C],u&&!m&&S.push(u),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,S)}e.log=R;function E(b){return`color: ${b}`}}),define(te[106],ne([0,1,19,25,8]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function L(I){return JSON.stringify(I,E)}e.stringify=L;function i(I){let C=JSON.parse(I);return C=b(C),C}e.parse=i;var R;(function(I){I[I.Uri=1]="Uri",I[I.Regexp=2]="Regexp",I[I.ScmResource=3]="ScmResource",I[I.ScmResourceGroup=4]="ScmResourceGroup",I[I.ScmProvider=5]="ScmProvider",I[I.CommentController=6]="CommentController",I[I.CommentThread=7]="CommentThread",I[I.CommentThreadReply=8]="CommentThreadReply",I[I.CommentNode=9]="CommentNode",I[I.CommentThreadNode=10]="CommentThreadNode",I[I.TimelineActionContext=11]="TimelineActionContext",I[I.NotebookCellActionContext=12]="NotebookCellActionContext",I[I.TestItemContext=13]="TestItemContext"})(R=e.MarshalledId||(e.MarshalledId={}));function E(I,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,_.regExpFlags)(C)}:C}function b(I,C=0){if(!I||C>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return D.URI.revive(I);case 2:return new RegExp(I.source,I.flags)}if(I instanceof T.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let d=0;d<I.length;++d)I[d]=b(I[d],C+1);else for(const d in I)Object.hasOwnProperty.call(I,d)&&(I[d]=b(I[d],C+1))}return I}e.revive=b}),define(te[17],ne([0,1,4,8]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}set(E,b,I){this._hosts[E]=b,this._ports[E]=I}setConnectionToken(E,b){this._connectionTokens[E]=b}rewrite(E){if(this._delegate)return this._delegate(E);const b=E.authority;let I=this._hosts[b];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const C=this._ports[b],d=this._connectionTokens[b];let m=`path=${encodeURIComponent(E.path)}`;return typeof d=="string"&&(m+=`&tkn=${encodeURIComponent(d)}`),_.URI.from({scheme:T.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${I}:${C}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new L;class i{asBrowserUri(E,b){const I=this.toUri(E,b);return I.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===D.file&&(T.isNative||typeof T.globals.importScripts=="function"&&T.globals.origin===`${D.vscodeFileResource}://${i.FALLBACK_AUTHORITY}`)?I.with({scheme:D.vscodeFileResource,authority:I.authority||i.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(E,b){const I=this.toUri(E,b);return I.scheme===D.vscodeFileResource?I.with({scheme:D.file,authority:I.authority!==i.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(E,b){return _.URI.isUri(E)?E:_.URI.parse(b.toUrl(E))}}i.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new i}),define(te[18],ne([0,1,41,17,10,4,25,8]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(m){return(0,R.uriToFsPath)(m,!0)}e.originalFSPath=E;class b{constructor(u){this._ignorePathCasing=u}compare(u,S,v=!1){return u===S?0:(0,i.compare)(this.getComparisonKey(u,v),this.getComparisonKey(S,v))}isEqual(u,S,v=!1){return u===S?!0:!u||!S?!1:this.getComparisonKey(u,v)===this.getComparisonKey(S,v)}getComparisonKey(u,S=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,S,v=!1){if(u.scheme===S.scheme){if(u.scheme===_.Schemas.file)return T.isEqualOrParent(E(u),E(S),this._ignorePathCasing(u))&&u.query===S.query&&(v||u.fragment===S.fragment);if((0,e.isEqualAuthority)(u.authority,S.authority))return T.isEqualOrParent(u.path,S.path,this._ignorePathCasing(u),"/")&&u.query===S.query&&(v||u.fragment===S.fragment)}return!1}joinPath(u,...S){return R.URI.joinPath(u,...S)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return D.posix.basename(u.path)}extname(u){return D.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let S;return u.scheme===_.Schemas.file?S=R.URI.file(D.dirname(E(u))).path:(S=D.posix.dirname(u.path),u.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),S="/")),u.with({path:S})}normalizePath(u){if(!u.path.length)return u;let S;return u.scheme===_.Schemas.file?S=R.URI.file(D.normalize(E(u))).path:S=D.posix.normalize(u.path),u.with({path:S})}relativePath(u,S){if(u.scheme!==S.scheme||!(0,e.isEqualAuthority)(u.authority,S.authority))return;if(u.scheme===_.Schemas.file){const y=D.relative(E(u),E(S));return L.isWindows?T.toSlashes(y):y}let v=u.path||"/",g=S.path||"/";if(this._ignorePathCasing(u)){let y=0;for(const f=Math.min(v.length,g.length);y<f&&!(v.charCodeAt(y)!==g.charCodeAt(y)&&v.charAt(y).toLowerCase()!==g.charAt(y).toLowerCase());y++);v=g.substr(0,y)+v.substr(y)}return D.posix.relative(v,g)}resolvePath(u,S){if(u.scheme===_.Schemas.file){const v=R.URI.file(D.resolve(E(u),S));return u.with({authority:v.authority,path:v.path})}return S=T.toPosixPath(S),u.with({path:D.posix.resolve(u.path,S)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,S){return u===S||u!==void 0&&S!==void 0&&(0,i.equalsIgnoreCase)(u,S)}hasTrailingPathSeparator(u,S=D.sep){if(u.scheme===_.Schemas.file){const v=E(u);return v.length>T.getRoot(v).length&&v[v.length-1]===S}else{const v=u.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,S=D.sep){return(0,e.hasTrailingPathSeparator)(u,S)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,S=D.sep){let v=!1;if(u.scheme===_.Schemas.file){const g=E(u);v=g!==void 0&&g.length===T.getRoot(g).length&&g[g.length-1]===S}else{S="/";const g=u.path;v=g.length===1&&g.charCodeAt(g.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(u,S)?u.with({path:u.path+"/"}):u}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(m=>m.scheme===_.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new b(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(m,u){const S=[];for(let v=0;v<m.length;v++){const g=u(m[v]);m.some((y,f)=>f===v?!1:(0,e.isEqualOrParent)(g,u(y)))||S.push(m[v])}return S}e.distinctParents=I;var C;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function u(S){const v=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(f=>{const[c,l]=f.split(":");c&&l&&v.set(c,l)});const y=S.path.substring(0,S.path.indexOf(";"));return y&&v.set(m.META_DATA_MIME,y),v}m.parseMetaData=u})(C=e.DataUri||(e.DataUri={}));function d(m,u,S){if(u){let v=m.path;return v&&v[0]!==D.posix.sep&&(v=D.posix.sep+v),m.with({scheme:S,authority:u,path:v})}return m.with({scheme:S})}e.toLocalResource=d}),define(te[5],ne([0,1,26,7,3,2,18,4]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(U){return!!U&&typeof U.then=="function"}e.isThenable=E;function b(U){const N=new T.CancellationTokenSource,W=U(N.token),V=new Promise((G,ee)=>{const H=N.token.onCancellationRequested(()=>{H.dispose(),N.dispose(),ee((0,_.canceled)())});Promise.resolve(W).then(Q=>{H.dispose(),N.dispose(),G(Q)},Q=>{H.dispose(),N.dispose(),ee(Q)})});return new class{cancel(){N.cancel()}then(G,ee){return V.then(G,ee)}catch(G){return this.then(void 0,G)}finally(G){return V.finally(G)}}}e.createCancelablePromise=b;function I(U,N,W){return Promise.race([U,new Promise(V=>N.onCancellationRequested(()=>V(W)))])}e.raceCancellation=I;async function C(U){let N=-1;const W=U.map((G,ee)=>G.then(H=>(N=ee,H))),V=await Promise.race(W);return U.forEach((G,ee)=>{ee!==N&&G.cancel()}),V}e.raceCancellablePromises=C;function d(U,N,W){let V;const G=setTimeout(()=>{V?.(void 0),W?.()},N);return Promise.race([U.finally(()=>clearTimeout(G)),new Promise(ee=>V=ee)])}e.raceTimeout=d;function m(U){return new Promise((N,W)=>{const V=U();E(V)?V.then(N,W):N(V)})}e.asPromise=m;class u{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(W,W).then(V)})}return new Promise((W,V)=>{this.queuedPromise.then(W,V)})}return this.activePromise=N(),new Promise((W,V)=>{this.activePromise.then(G=>{this.activePromise=null,W(G)},G=>{this.activePromise=null,V(G)})})}}e.Throttler=u;class S{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=S;class v{constructor(){this.promiseMap=new Map}queue(N,W){const G=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(N)===G&&this.promiseMap.delete(N)});return this.promiseMap.set(N,G),G}}e.SequencerByKey=v;class g{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,W=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,G)=>{this.doResolve=V,this.doReject=G}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},W),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,_.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=g;class y{constructor(N){this.delayer=new g(N),this.throttler=new u}trigger(N,W){return this.delayer.trigger(()=>this.throttler.queue(N),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=y;class f{constructor(){this._isOpen=!1,this._promise=new Promise((N,W)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=f;class c extends f{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function l(U,N){return N?new Promise((W,V)=>{const G=setTimeout(()=>{ee.dispose(),W()},U),ee=N.onCancellationRequested(()=>{clearTimeout(G),ee.dispose(),V((0,_.canceled)())})}):b(W=>l(U,W))}e.timeout=l;function r(U,N=0){const W=setTimeout(U,N);return(0,L.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=r;function a(U){const N=[];let W=0;const V=U.length;function G(){return W<V?U[W++]():null}function ee(H){H!=null&&N.push(H);const Q=G();return Q?Q.then(ee):Promise.resolve(N)}return Promise.resolve(null).then(ee)}e.sequence=a;function n(U,N=V=>!!V,W=null){let V=0;const G=U.length,ee=()=>{if(V>=G)return Promise.resolve(W);const H=U[V++];return Promise.resolve(H()).then(re=>N(re)?Promise.resolve(re):ee())};return ee()}e.first=n;function t(U,N=V=>!!V,W=null){if(U.length===0)return Promise.resolve(W);let V=U.length;const G=()=>{V=-1;for(const ee of U)ee.cancel?.()};return new Promise((ee,H)=>{for(const Q of U)Q.then(re=>{--V>=0&&N(re)?(G(),ee(re)):V===0&&ee(W)}).catch(re=>{--V>=0&&(G(),H(re))})})}e.firstParallel=t;class s{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((W,V)=>{this.outstandingPromises.push({factory:N,c:W,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const W=N.factory();W.then(N.c,N.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class o extends s{constructor(){super(1)}}e.Queue=o;class h{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const N=new F;return this.drainers.add(N),N.p}isDrained(){for(const[,N]of this.queues)if(N.size>0)return!1;return!0}queueFor(N,W=i.extUri){const V=W.getComparisonKey(N);let G=this.queues.get(V);return G||(G=new o,D.Event.once(G.onFinished)(()=>{G?.dispose(),this.queues.delete(V),this.onDidQueueFinish()}),this.queues.set(V,G)),G}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const N of this.drainers)N.complete();this.drainers.clear()}dispose(){for(const[,N]of this.queues)N.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=h;class p{constructor(N,W){this._token=-1,typeof N=="function"&&typeof W=="number"&&this.setIfNotSet(N,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},W)}setIfNotSet(N,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},W))}}e.TimeoutTimer=p;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,W){this.cancel(),this._token=setInterval(()=>{N()},W)}}e.IntervalTimer=w;class P{constructor(N,W){this.timeoutToken=-1,this.runner=N,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class M{constructor(N,W){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=N,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(N=this.timeout){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(N/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=M;class O extends P{constructor(N,W){super(N,W);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class q extends L.Disposable{constructor(N,W,V,G){super();this.maxWorkChunkSize=N,this.maxPendingWork=W,this.throttleDelay=V,this.handler=G,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.maxPendingWork)return!1}else if(this.pending+N.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...N),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new P(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=U=>{(0,R.setTimeout0)(()=>{if(N)return;const W=Date.now()+3;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(U,N)=>{const W=requestIdleCallback(U,typeof N=="number"?{timeout:N}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(W))}}}}();class ${constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function k(U,N,W){let V;for(let G=0;G<W;G++)try{return await U()}catch(ee){V=ee,await l(N)}throw V}e.retry=k;class z{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(N,W,V){return this._pending={taskId:N,cancel:()=>V?.(),promise:W},W.then(()=>this.donePending(N),()=>this.donePending(N)),W}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let W,V;const G=new Promise((ee,H)=>{W=ee,V=H});this._next={run:N,promise:G,promiseResolve:W,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=z;class A{constructor(N,W=()=>Date.now()){this.interval=N,this.nowFn=W,this.lastIncrementTime=0,this.value=0}increment(){const N=this.nowFn();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=A;class F{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,W)=>{this.completeCallback=N,this.errorCallback=W})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(W=>{this.completeCallback(N),this.resolved=!0,W()})}error(N){return new Promise(W=>{this.errorCallback(N),this.rejected=!0,W()})}cancel(){new Promise(N=>{this.errorCallback((0,_.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=F;var x;(function(U){async function N(V){let G;const ee=await Promise.all(V.map(H=>H.then(Q=>Q,Q=>{G||(G=Q)})));if(typeof G!="undefined")throw G;return ee}U.settled=N;function W(V){return new Promise(async(G,ee)=>{try{await V(G,ee)}catch(H){ee(H)}})}U.withAsyncBody=W})(x=e.Promises||(e.Promises={}));var Z;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(Z||(Z={}));class B{constructor(N){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const W={emitOne:V=>this.emitOne(V),emitMany:V=>this.emitMany(V),reject:V=>this.reject(V)};try{await Promise.resolve(N(W)),this.resolve()}catch(V){this.reject(V)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}static fromArray(N){return new B(W=>{W.emitMany(N)})}static fromPromise(N){return new B(async W=>{W.emitMany(await N)})}static fromPromises(N){return new B(async W=>{await Promise.all(N.map(async V=>W.emitOne(await V)))})}static merge(N){return new B(async W=>{await Promise.all(N.map(async V=>{for await(const G of V)W.emitOne(G)}))})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(N<this._results.length)return{done:!1,value:this._results[N++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(N,W){return new B(async V=>{for await(const G of N)V.emitOne(W(G))})}map(N){return B.map(this,N)}static filter(N,W){return new B(async V=>{for await(const G of N)W(G)&&V.emitOne(G)})}filter(N){return B.filter(this,N)}static coalesce(N){return B.filter(N,W=>!!W)}coalesce(){return B.coalesce(this)}static async toPromise(N){const W=[];for await(const V of N)W.push(V);return W}toPromise(){return B.toPromise(this)}emitOne(N){this._state===0&&(this._results.push(N),this._onStateChanged.fire())}emitMany(N){this._state===0&&(this._results=this._results.concat(N),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(N){this._state===0&&(this._state=2,this._error=N,this._onStateChanged.fire())}}e.AsyncIterableObject=B,B.EMPTY=B.fromArray([]);class j extends B{constructor(N,W){super(W);this._source=N}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=j;function X(U){const N=new T.CancellationTokenSource,W=U(N.token);return new j(N,async V=>{const G=N.token.onCancellationRequested(()=>{G.dispose(),N.dispose(),V.reject((0,_.canceled)())});try{for await(const ee of W){if(N.token.isCancellationRequested)return;V.emitOne(ee)}G.dispose(),N.dispose()}catch(ee){G.dispose(),N.dispose(),V.reject(ee)}})}e.createCancelableAsyncIterable=X}),define(te[107],ne([0,1,5,41,40,10,25]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R;const E="**",b="/",I="[/\\\\]",C="[^/\\\\]",d=/\//g;function m(j){switch(j){case 0:return"";case 1:return`${C}*?`;default:return`(?:${I}|${C}+${I}|${I}${C}+)*?`}}function u(j,X){if(!j)return[];const U=[];let N=!1,W=!1,V="";for(const G of j){switch(G){case X:if(!N&&!W){U.push(V),V="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":W=!0;break;case"]":W=!1;break}V+=G}return V&&U.push(V),U}e.splitGlobAware=u;function S(j){if(!j)return"";let X="";const U=u(j,b);if(U.every(N=>N===E))X=".*";else{let N=!1;U.forEach((W,V)=>{if(W===E){N||(X+=m(2),N=!0);return}let G=!1,ee="",H=!1,Q="";for(const re of W){if(re!=="}"&&G){ee+=re;continue}if(H&&(re!=="]"||!Q)){let oe;re==="-"?oe=re:(re==="^"||re==="!")&&!Q?oe="^":re===b?oe="":oe=i.escapeRegExpCharacters(re),Q+=oe;continue}switch(re){case"{":G=!0;continue;case"[":H=!0;continue;case"}":X+=`(?:${u(ee,",").map(he=>S(he)).join("|")})`,G=!1,ee="";break;case"]":X+="["+Q+"]",H=!1,Q="";break;case"?":X+=C;continue;case"*":X+=m(1);continue;default:X+=i.escapeRegExpCharacters(re)}}V<U.length-1&&(U[V+1]!==E||V+2<U.length)&&(X+=I),N=!1})}return X}const v=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new D.LRUCache(1e4),a=function(){return!1},n=function(){return null};function t(j,X){if(!j)return n;let U;typeof j!="string"?U=j.pattern:U=j,U=U.trim();const N=`${U}_${!!X.trimForExclusions}`;let W=r.get(N);if(W)return s(W,j);let V;if(v.test(U)){const G=U.substr(4);W=function(ee,H){return typeof ee=="string"&&ee.endsWith(G)?U:null}}else(V=g.exec(o(U,X)))?W=h(V[1],U):(X.trimForExclusions?f:y).test(U)?W=p(U,X):(V=c.exec(o(U,X)))?W=w(V[1].substr(1),U,!0):(V=l.exec(o(U,X)))?W=w(V[1],U,!1):W=P(U);return r.set(N,W),s(W,j)}function s(j,X){return typeof X=="string"?j:function(U,N){return _.isEqualOrParent(U,X.base)?j(L.relative(X.base,U),N):null}}function o(j,X){return X.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function h(j,X){const U=`/${j}`,N=`\\${j}`,W=function(G,ee){return typeof G!="string"?null:ee?ee===j?X:null:G===j||G.endsWith(U)||G.endsWith(N)?X:null},V=[j];return W.basenames=V,W.patterns=[X],W.allBasenames=V,W}function p(j,X){const U=B(j.slice(1,-1).split(",").map(ee=>t(ee,X)).filter(ee=>ee!==n),j),N=U.length;if(!N)return n;if(N===1)return U[0];const W=function(ee,H){for(let Q=0,re=U.length;Q<re;Q++)if(U[Q](ee,H))return j;return null},V=U.find(ee=>!!ee.allBasenames);V&&(W.allBasenames=V.allBasenames);const G=U.reduce((ee,H)=>H.allPaths?ee.concat(H.allPaths):ee,[]);return G.length&&(W.allPaths=G),W}function w(j,X,U){const N=L.sep===L.posix.sep,W=N?j:j.replace(d,L.sep),V=L.sep+W,G=L.posix.sep+j,ee=U?function(H,Q){return typeof H=="string"&&(H===W||H.endsWith(V)||!N&&(H===j||H.endsWith(G)))?X:null}:function(H,Q){return typeof H=="string"&&(H===W||!N&&H===j)?X:null};return ee.allPaths=[(U?"*/":"./")+j],ee}function P(j){try{const X=new RegExp(`^${S(j)}$`);return function(U){return X.lastIndex=0,typeof U=="string"&&X.test(U)?j:null}}catch(X){return n}}function M(j,X,U){return!j||typeof X!="string"?!1:O(j)(X,void 0,U)}e.match=M;function O(j,X={}){if(!j)return a;if(typeof j=="string"||z(j)){const U=t(j,X);if(U===n)return a;const N=function(W,V){return!!U(W,V)};return U.allBasenames&&(N.allBasenames=U.allBasenames),U.allPaths&&(N.allPaths=U.allPaths),N}return x(j,X)}e.parse=O;function q(j){if(!j)return;let X;return U=>(X||(X=(j()||Promise.resolve([])).then(N=>N?k(N):{})),X.then(N=>!!N[U]))}e.hasSiblingPromiseFn=q;function $(j){if(!j)return;let X;return U=>{if(!X){const N=j();X=N?k(N):{}}return!!X[U]}}e.hasSiblingFn=$;function k(j){const X={};for(const U of j)X[U]=!0;return X}function z(j){const X=j;return X&&typeof X.base=="string"&&typeof X.pattern=="string"}e.isRelativePattern=z;function A(j){return j.allBasenames||[]}e.getBasenameTerms=A;function F(j){return j.allPaths||[]}e.getPathTerms=F;function x(j,X){const U=B(Object.getOwnPropertyNames(j).map(ee=>Z(ee,j[ee],X)).filter(ee=>ee!==n)),N=U.length;if(!N)return n;if(!U.some(ee=>!!ee.requiresSiblings)){if(N===1)return U[0];const ee=function(re,oe){for(let ce=0,he=U.length;ce<he;ce++){const be=U[ce](re,oe);if(be)return be}return null},H=U.find(re=>!!re.allBasenames);H&&(ee.allBasenames=H.allBasenames);const Q=U.reduce((re,oe)=>oe.allPaths?re.concat(oe.allPaths):re,[]);return Q.length&&(ee.allPaths=Q),ee}const W=function(ee,H,Q){let re;for(let oe=0,ce=U.length;oe<ce;oe++){const he=U[oe];he.requiresSiblings&&Q&&(H||(H=L.basename(ee)),re||(re=H.substr(0,H.length-L.extname(ee).length)));const be=he(ee,H,re,Q);if(be)return be}return null},V=U.find(ee=>!!ee.allBasenames);V&&(W.allBasenames=V.allBasenames);const G=U.reduce((ee,H)=>H.allPaths?ee.concat(H.allPaths):ee,[]);return G.length&&(W.allPaths=G),W}function Z(j,X,U){if(X===!1)return n;const N=t(j,U);if(N===n)return n;if(typeof X=="boolean")return N;if(X){const W=X.when;if(typeof W=="string"){const V=(G,ee,H,Q)=>{if(!Q||!N(G,ee))return null;const re=W.replace("$(basename)",H),oe=Q(re);return(0,T.isThenable)(oe)?oe.then(ce=>ce?j:null):oe?j:null};return V.requiresSiblings=!0,V}}return N}function B(j,X){const U=j.filter(ee=>!!ee.basenames);if(U.length<2)return j;const N=U.reduce((ee,H)=>{const Q=H.basenames;return Q?ee.concat(Q):ee},[]);let W;if(X){W=[];for(let ee=0,H=N.length;ee<H;ee++)W.push(X)}else W=U.reduce((ee,H)=>{const Q=H.patterns;return Q?ee.concat(Q):ee},[]);const V=function(ee,H){if(typeof ee!="string")return null;if(!H){let re;for(re=ee.length;re>0;re--){const oe=ee.charCodeAt(re-1);if(oe===47||oe===92)break}H=ee.substr(re)}const Q=N.indexOf(H);return Q!==-1?W[Q]:null};V.basenames=N,V.patterns=W,V.allBasenames=N;const G=j.filter(ee=>!ee.basenames);return G.push(V),G}}),define(te[108],ne([0,1,107,17,10,18,25]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var R;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(R=e.Mimes||(e.Mimes={}));let E=[],b=[],I=[];function C(t,s=!1){const o=d(t);E.push(o),o.userConfigured?I.push(o):b.push(o),s&&!o.userConfigured&&E.forEach(h=>{h.mime===o.mime||h.userConfigured||(o.extension&&h.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&h.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&h.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&h.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=C;function d(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,T.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(D.posix.sep)>=0:!1}}function m(t){t?(E=E.filter(s=>!s.userConfigured),I=[]):(E=[],b=[],I=[])}e.clearTextMimes=m;function u(t,s){let o;if(t)switch(t.scheme){case _.Schemas.file:o=t.fsPath;break;case _.Schemas.data:o=L.DataUri.parseMetaData(t).get(L.DataUri.META_DATA_LABEL);break;default:o=t.path}if(!o)return[R.unknown];o=o.toLowerCase();const h=(0,D.basename)(o),p=S(o,h,I);if(p)return[p,R.text];const w=S(o,h,b);if(w)return[w,R.text];if(s){const P=v(s);if(P)return[P,R.text]}return[R.unknown]}e.guessMimeTypes=u;function S(t,s,o){let h=null,p=null,w=null;for(let P=o.length-1;P>=0;P--){const M=o[P];if(s===M.filenameLowercase){h=M;break}if(M.filepattern&&(!p||M.filepattern.length>p.filepattern.length)){const O=M.filepatternOnPath?t:s;M.filepatternLowercase?.(O)&&(p=M)}M.extension&&(!w||M.extension.length>w.extension.length)&&s.endsWith(M.extensionLowercase)&&(w=M)}return h?h.mime:p?p.mime:w?w.mime:null}function v(t){if((0,i.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let s=E.length-1;s>=0;s--){const o=E[s];if(!o.firstline)continue;const h=t.match(o.firstline);if(h&&h.length>0)return o.mime}return null}function g(t){return t?typeof t=="string"?t===R.binary||t===R.text||t===R.unknown:t.length===1&&g(t[0]):!0}e.isUnspecific=g;const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(t){const s=(0,D.extname)(t),o=y[s.toLowerCase()];return o!==void 0?o:l(t)}e.getMediaOrTextMime=c;function l(t){const s=(0,D.extname)(t);return f[s.toLowerCase()]}e.getMediaMime=l;function r(t){for(const s in f)if(f[s]===t)return s}e.getExtensionForMimeType=r;const a=/^(.+)\/(.+?)(;.+)?$/;function n(t,s){const o=a.exec(t);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:s?void 0:t}e.normalizeMimeType=n}),define(te[109],ne([0,1,8]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function _(I){return I.toJSON()}class D{constructor(C){this._uriTransformer=C}transformIncoming(C){const d=this._uriTransformer.transformIncoming(C);return d===C?C:_(T.URI.from(d))}transformOutgoing(C){const d=this._uriTransformer.transformOutgoing(C);return d===C?C:_(T.URI.from(d))}transformOutgoingURI(C){const d=this._uriTransformer.transformOutgoing(C);return d===C?C:T.URI.from(d)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function L(I,C,d){if(!I||d>200)return null;if(typeof I=="object"){if(I instanceof T.URI)return C.transformOutgoing(I);for(let m in I)if(Object.hasOwnProperty.call(I,m)){const u=L(I[m],C,d+1);u!==null&&(I[m]=u)}}return null}function i(I,C){const d=L(I,C,0);return d===null?I:d}e.transformOutgoingURIs=i;function R(I,C,d,m){if(!I||m>200)return null;if(typeof I=="object"){if(I.$mid===1)return d?T.URI.revive(C.transformIncoming(I)):C.transformIncoming(I);for(let u in I)if(Object.hasOwnProperty.call(I,u)){const S=R(I[u],C,d,m+1);S!==null&&(I[u]=S)}}return null}function E(I,C){const d=R(I,C,!1,0);return d===null?I:d}e.transformIncomingURIs=E;function b(I,C){const d=R(I,C,!0,0);return d===null?I:d}e.transformAndReviveIncomingURIs=b}),define(te[29],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function _(E){return T.test(E)}e.isUUID=_;const D=new Uint8Array(16),L=[];for(let E=0;E<256;E++)L.push(E.toString(16).padStart(2,"0"));let i;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?i=crypto.getRandomValues.bind(crypto):i=function(E){for(let b=0;b<E.length;b++)E[b]=Math.floor(Math.random()*256);return E};function R(){i(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let E=0,b="";return b+=L[D[E++]],b+=L[D[E++]],b+=L[D[E++]],b+=L[D[E++]],b+="-",b+=L[D[E++]],b+=L[D[E++]],b+="-",b+=L[D[E++]],b+=L[D[E++]],b+="-",b+=L[D[E++]],b+=L[D[E++]],b+="-",b+=L[D[E++]],b+=L[D[E++]],b+=L[D[E++]],b+=L[D[E++]],b+=L[D[E++]],b+=L[D[E++]],b}e.generateUuid=R}),define(te[110],ne([0,1,241]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class _{constructor(L="utf8"){this.stringDecoder=new T.StringDecoder(L),this.remaining=null}write(L){const i=[],R=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(R.length<1)return i;let E=0,b,I=E;for(;I<R.length;)if(b=R.charCodeAt(I),b===13||b===10){if(i.push(R.substring(E,I)),I++,I<R.length){const C=b;b=R.charCodeAt(I),(C===13&&b===10||C===10&&b===13)&&I++}E=I}else I++;return this.remaining=E<R.length?R.substr(E):null,i}end(){return this.remaining}}e.LineDecoder=_}),define(te[111],ne([0,1,33]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const _=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(i){const R=i.replace(/\-/g,":").toLowerCase();return!_.has(R)}function L(){const i=(0,T.networkInterfaces)();for(let R in i){const E=i[R];if(E){for(const{mac:b}of E)if(D(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(te[112],ne([0,1,33,7,40,29,111]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,C=0;const d=(0,T.networkInterfaces)();for(let m in d){const u=d[m];if(u)for(const{mac:S,internal:v}of u)v||(C+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(I+=1))}this._value=C>0?I/C:0}return this._value}};let R;async function E(){return R||(R=(async()=>await b()||L.generateUuid())()),R}e.getMachineId=E;async function b(){try{const I=await new Promise((d,m)=>{J(["crypto"],d,m)}),C=(0,i.getMac)();return I.createHash("sha256").update(C,"utf8").digest("hex")}catch(I){_.onUnexpectedError(I);return}}}),define(te[20],ne([0,1,51,33,242,5,41,69,10,4,18,8,29]),function(J,e,T,_,D,L,i,R,E,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(A){A[A.UNLINK=0]="UNLINK",A[A.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function u(A,F=m.UNLINK){if((0,i.isRootOrDriveLetter)(A))throw new Error("rimraf - will refuse to recursively delete root");return F===m.UNLINK?v(A):S(A)}async function S(A){try{const F=(0,E.join)((0,_.tmpdir)(),(0,d.generateUuid)());try{await e.Promises.rename(A,F)}catch(x){return v(A)}v(F).catch(x=>{})}catch(F){if(F.code!=="ENOENT")throw F}}async function v(A){return(0,D.promisify)(T.rm)(A,{recursive:!0,force:!0,maxRetries:3})}function g(A){if((0,i.isRootOrDriveLetter)(A))throw new Error("rimraf - will refuse to recursively delete root");T.rmSync(A,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function y(A,F){return l(await(F?f(A):(0,D.promisify)(T.readdir)(A)))}async function f(A){try{return await(0,D.promisify)(T.readdir)(A,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const F=[],x=await y(A);for(const Z of x){let B=!1,j=!1,X=!1;try{const U=await e.Promises.lstat((0,E.join)(A,Z));B=U.isFile(),j=U.isDirectory(),X=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}F.push({name:Z,isFile:()=>B,isDirectory:()=>j,isSymbolicLink:()=>X})}return F}function c(A){return l(T.readdirSync(A))}e.readdirSync=c;function l(A){return A.map(F=>typeof F=="string"?b.isMacintosh?(0,R.normalizeNFC)(F):F:(F.name=b.isMacintosh?(0,R.normalizeNFC)(F.name):F.name,F))}async function r(A){const F=await y(A),x=[];for(const Z of F)await n.existsDirectory((0,E.join)(A,Z))&&x.push(Z);return x}function a(A,F=1e3){return new Promise(x=>{let Z=!1;const B=setInterval(()=>{Z||(Z=!0,T.access(A,j=>{Z=!1,j&&(clearInterval(B),x(void 0))}))},F)})}e.whenDeleted=a;var n;(function(A){async function F(B){let j;try{if(j=await e.Promises.lstat(B),!j.isSymbolicLink())return{stat:j}}catch(X){}try{return{stat:await e.Promises.stat(B),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(b.isWindows&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw U}throw X}}A.stat=F;async function x(B){try{const{stat:j,symbolicLink:X}=await A.stat(B);return j.isFile()&&X?.dangling!==!0}catch(j){}return!1}A.existsFile=x;async function Z(B){try{const{stat:j,symbolicLink:X}=await A.stat(B);return j.isDirectory()&&X?.dangling!==!0}catch(j){}return!1}A.existsDirectory=Z})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new L.ResourceQueue;function s(A,F,x){return t.queueFor(C.URI.file(A),I.extUriBiasedIgnorePathCase).queue(()=>{const Z=w(x);return new Promise((B,j)=>h(A,F,Z,X=>X?j(X):B()))})}let o=!0;function h(A,F,x,Z){if(!o)return T.writeFile(A,F,{mode:x.mode,flag:x.flag},Z);T.open(A,x.flag,x.mode,(B,j)=>{if(B)return Z(B);T.writeFile(j,F,X=>{if(X)return T.close(j,()=>Z(X));T.fdatasync(j,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),o=!1),T.close(j,N=>Z(N))))})})}function p(A,F,x){const Z=w(x);if(!o)return T.writeFileSync(A,F,{mode:Z.mode,flag:Z.flag});const B=T.openSync(A,Z.flag,Z.mode);try{T.writeFileSync(B,F);try{T.fdatasyncSync(B)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),o=!1}}finally{T.closeSync(B)}}e.writeFileSync=p;function w(A){return A?{mode:typeof A.mode=="number"?A.mode:438,flag:typeof A.flag=="string"?A.flag:"w"}:{mode:438,flag:"w"}}async function P(A,F){if(A===F)return;async function x(Z){try{const B=await e.Promises.lstat(Z);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(Z,B.atime,new Date)}catch(B){}}try{await e.Promises.rename(A,F),await x(F)}catch(Z){if(A.toLowerCase()!==F.toLowerCase()&&Z.code==="EXDEV"||A.endsWith("."))await M(A,F,{preserveSymlinks:!1}),await u(A,m.MOVE),await x(F);else throw Z}}async function M(A,F,x){return q(A,F,{root:{source:A,target:F},options:x,handledSourcePaths:new Set})}const O=511;async function q(A,F,x){if(x.handledSourcePaths.has(A))return;x.handledSourcePaths.add(A);const{stat:Z,symbolicLink:B}=await n.stat(A);if(B){if(x.options.preserveSymlinks)try{return await z(A,F,x)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(B.dangling)return}return Z.isDirectory()?$(A,F,Z.mode&O,x):k(A,F,Z.mode&O)}async function $(A,F,x,Z){await e.Promises.mkdir(F,{recursive:!0,mode:x});const B=await y(A);for(const j of B)await q((0,E.join)(A,j),(0,E.join)(F,j),Z)}async function k(A,F,x){await e.Promises.copyFile(A,F),await e.Promises.chmod(F,x)}async function z(A,F,x){let Z=await e.Promises.readlink(A);(0,i.isEqualOrParent)(Z,x.root.source,!b.isLinux)&&(Z=(0,E.join)(x.root.target,Z.substr(x.root.source.length+1))),await e.Promises.symlink(Z,F)}e.Promises=new class{get access(){return(0,D.promisify)(T.access)}get stat(){return(0,D.promisify)(T.stat)}get lstat(){return(0,D.promisify)(T.lstat)}get utimes(){return(0,D.promisify)(T.utimes)}get read(){return(0,D.promisify)(T.read)}get readFile(){return(0,D.promisify)(T.readFile)}get write(){return(0,D.promisify)(T.write)}get appendFile(){return(0,D.promisify)(T.appendFile)}get fdatasync(){return(0,D.promisify)(T.fdatasync)}get truncate(){return(0,D.promisify)(T.truncate)}get rename(){return(0,D.promisify)(T.rename)}get copyFile(){return(0,D.promisify)(T.copyFile)}get open(){return(0,D.promisify)(T.open)}get close(){return(0,D.promisify)(T.close)}get symlink(){return(0,D.promisify)(T.symlink)}get readlink(){return(0,D.promisify)(T.readlink)}get chmod(){return(0,D.promisify)(T.chmod)}get mkdir(){return(0,D.promisify)(T.mkdir)}get unlink(){return(0,D.promisify)(T.unlink)}get rmdir(){return(0,D.promisify)(T.rmdir)}get realpath(){return(0,D.promisify)(T.realpath)}async exists(A){try{return await e.Promises.access(A),!0}catch{return!1}}get readdir(){return y}get readDirsInDir(){return r}get writeFile(){return s}get rm(){return u}get move(){return P}get copy(){return M}}}),define(te[113],ne([0,1,51,10,25,20]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function i(I){const C=(0,_.dirname)(I);if(I===C)return I;const d=((0,_.basename)(I)||I).toLowerCase();try{const u=(0,L.readdirSync)(C).filter(S=>S.toLowerCase()===d);if(u.length===1){const S=i(C);if(S)return(0,_.join)(S,u[0])}else if(u.length>1){const S=u.indexOf(d);if(S>=0){const v=i(C);if(v)return(0,_.join)(v,u[S])}}}catch(m){}return null}e.realcaseSync=i;async function R(I){try{return await L.Promises.realpath(I)}catch(C){const d=b(I);return await L.Promises.access(d,T.constants.R_OK),d}}e.realpath=R;function E(I){try{return T.realpathSync(I)}catch(C){const d=b(I);return T.accessSync(d,T.constants.R_OK),d}}e.realpathSync=E;function b(I){return(0,D.rtrim)((0,_.normalize)(I),_.sep)}}),define(te[114],ne([0,1,55]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function _(R,E,b,I=1){let C=!1;return new Promise(d=>{const m=setTimeout(()=>{if(!C)return C=!0,d(0)},b);D(R,E,I,u=>{if(!C)return C=!0,clearTimeout(m),d(u)})})}e.findFreePort=_;function D(R,E,b,I){if(E===0)return I(0);const C=new T.Socket;C.once("connect",()=>(i(C),D(R+b,E-1,b,I))),C.once("data",()=>{}),C.once("error",d=>(i(C),d.code!=="ECONNREFUSED"?D(R+b,E-1,b,I):I(R))),C.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(R,E,b){let I=!1,C,d=1;const m=T.createServer({pauseOnConnect:!0});function u(S,v){I||(I=!0,m.removeAllListeners(),m.close(),C&&clearTimeout(C),v(S))}return new Promise(S=>{C=setTimeout(()=>{u(0,S)},b),m.on("listening",()=>{u(R,S)}),m.on("error",v=>{v&&(v.code==="EADDRINUSE"||v.code==="EACCES")&&d<E?(R++,d++,m.listen(R,"127.0.0.1")):u(0,S)}),m.on("close",()=>{u(0,S)}),m.listen(R,"127.0.0.1")})}e.findFreePortFaster=L;function i(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(E){console.error(E)}}}),define(te[70],ne([0,1,33,10,20]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,i=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var E;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(E||(E={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class C{constructor(l,r,a){this.exePath=l,this.displayName=r,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:c=!1}={}){return c?b===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:c=!1,findPreview:l=!1}={}){const r=d({useAlternateBitness:c});if(!r)return null;const a=_.join(r,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(a))return null;let n=-1,t=null;for(const h of await D.Promises.readdir(a)){let p=-1;if(l){const P=h.indexOf("-");if(P<0)continue;const M=h.substring(0,P);if(!L.test(M)||h.substring(P+1)!=="preview")continue;p=parseInt(M,10)}else{if(!L.test(h))continue;p=parseInt(h,10)}if(p<=n)continue;const w=_.join(a,h,"pwsh.exe");!await D.SymlinkSupport.existsFile(w)||(t=w,n=p)}if(!t)return null;const s=r.includes("x86")?" (x86)":"",o=l?" Preview":"";return new C(t,`PowerShell${o}${s}`,!0)}async function u({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const l=_.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:r,pwshMsixName:a}=c?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:i,pwshMsixName:"PowerShell (Store)"};for(const n of await D.Promises.readdir(l))if(r.test(n)){const t=_.join(l,n,"pwsh.exe");return new C(t,a)}return null}function S(){const c=_.join(T.homedir(),".dotnet","tools","pwsh.exe");return new C(c,".NET Core PowerShell Global Tool")}function v(){const c=_.join(process.env.windir,b===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(c,"Windows PowerShell",!0)}async function*g(){let c=await m();c&&(yield c),c=await m({useAlternateBitness:!0}),c&&(yield c),c=await u(),c&&(yield c),c=S(),c&&(yield c),c=await m({findPreview:!0}),c&&(yield c),c=await u({findPreview:!0}),c&&(yield c),c=await m({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=v(),c&&(yield c)}async function*y(){for await(const c of g())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=y;async function f(){for await(const c of y())return c;return null}e.getFirstAvailablePowerShellInstallation=f}),define(te[115],ne([0,1,45,17]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(i){return new Promise((R,E)=>{let b;const I=new Map;function C(m,u,S,v,g){const y=I.get(u);if(m===i||y){const f={name:d(S),cmd:S,pid:m,ppid:u,load:v,mem:g};I.set(m,f),m===i&&(b=f),y&&(y.children||(y.children=[]),y.children.push(f),y.children.length>1&&(y.children=y.children.sort((c,l)=>c.pid-l.pid)))}}function d(m){const u=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,v=/--vscode-window-kind=process-explorer/,g=/--utility-sub-type=network/,y=/--crashes-directory/,f=/\\pipe\\winpty-control/,c=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(y.exec(m))return"electron-crash-reporter";if(f.exec(m))return"winpty-process";if(c.exec(m))return"console-window-host (Windows internal process)";let r=l.exec(m);if(r&&r.length===2)return r[1]==="renderer"?u.exec(m)?"shared-process":S.exec(m)?"issue-reporter":v.exec(m)?"process-explorer":"window":r[1]==="utility"&&g.exec(m)?"utility-network-service":r[1];const a=/[a-zA-Z-]+\.js/g;let n="";do r=a.exec(m),r&&(n+=r+" ");while(r);return n&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron_node ${n}`:m}if(process.platform==="win32"){const m=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,S)=>{J(["windows-process-tree"],u,S)}).then(u=>{u.getProcessList(i,S=>{u.getProcessCpuUsage(S,v=>{const g=new Map;v.forEach(y=>{const f=m(y.commandLine||"");g.set(y.pid,{name:d(f),cmd:f,pid:y.pid,ppid:y.ppid,load:y.cpu||0,mem:y.memory||0})}),b=g.get(i),b?(g.forEach(y=>{const f=g.get(y.ppid);f&&(f.children||(f.children=[]),f.children.push(y))}),g.forEach(y=>{y.children&&(y.children=y.children.sort((f,c)=>f.pid-c.pid))}),R(b)):E(new Error(`Root process ${i} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let m=function(){let u=[b];const S=[];for(;u.length;){const g=u.shift();g&&(S.push(g.pid),g.children&&(u=u.concat(g.children)))}let v=JSON.stringify(_.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);v+=" "+S.join(" "),(0,T.exec)(v,{},(g,y,f)=>{if(g||f)E(g||new Error(f.toString()));else{const c=y.toString().split(`
`);for(let l=0;l<S.length;l++){const r=I.get(S[l]);r.load=parseFloat(c[l])}if(!b){E(new Error(`Root process ${i} not found`));return}R(b)}})};(0,T.exec)("which ps",{},(u,S,v)=>{if(u||v)if(process.platform!=="linux")E(u||new Error(v.toString()));else{const g=JSON.stringify(_.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,T.exec)(g,{},(y,f,c)=>{y||c?E(y||new Error(c.toString())):(L(f,C),m())})}else{const g=S.toString().trim(),y="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,T.exec)(`${g} ${y}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,c,l)=>{f||l&&!l.includes("screen size is bogus")?E(f||new Error(l.toString())):(L(c,C),process.platform==="linux"?m():b?R(b):E(new Error(`Root process ${i} not found`)))})}})}})}e.listProcesses=D;function L(i,R){const E=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=i.toString().split(`
`);for(const I of b){const C=E.exec(I.trim());C&&C.length===6&&R(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(te[116],ne([0,1,51,26,41,2,69,10,4,20]),function(J,e,T,_,D,L,i,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function I(u,S,v){return d({path:u,isDirectory:!1},S,v)}e.watchFile=I;function C(u,S,v){return d({path:u,isDirectory:!0},S,v)}e.watchFolder=C,e.CHANGE_BUFFER_DELAY=100;function d(u,S,v){if(E.isMacintosh&&(0,D.isEqualOrParent)(u.path,"/Volumes/"))return v(`Refusing to watch ${u.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.Disposable.None;const g=(0,R.basename)(u.path),y=new Map;let f=!1,c=[(0,L.toDisposable)(()=>{y.forEach(l=>(0,L.dispose)(l)),y.clear()})];try{const l=(0,T.watch)(u.path);c.push((0,L.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const r=new Set;u.isDirectory&&b.Promises.readdir(u.path).then(a=>a.forEach(n=>r.add(n))),l.on("error",(a,n)=>{f||v(`Failed to watch ${u.path} for changes using fs.watch() (${a}, ${n})`)}),l.on("change",(a,n)=>{if(f)return;let t="";if(n&&(t=n.toString(),E.isMacintosh&&(t=(0,i.normalizeNFC)(t))),!t||a!=="change"&&a!=="rename")return;const s=u.isDirectory?(0,R.join)(u.path,t):u.path;if(u.isDirectory)if(a==="rename"){const o=y.get(s);o&&(0,L.dispose)(o);const h=setTimeout(async()=>{y.delete(s);const p=await b.Promises.exists(s);if(f)return;let w;p?r.has(t)?w="changed":(w="added",r.add(t)):(r.delete(t),w="deleted"),S(w,s)},e.CHANGE_BUFFER_DELAY);y.set(s,(0,L.toDisposable)(()=>clearTimeout(h)))}else{let o;r.has(t)?o="changed":(o="added",r.add(t)),S(o,s)}else if(a==="rename"||t!==g){const o=setTimeout(async()=>{const h=await b.Promises.exists(s);f||(h?(S("changed",s),c=[d(u,S,v)]):S("deleted",s))},e.CHANGE_BUFFER_DELAY);(0,L.dispose)(c),c=[(0,L.toDisposable)(()=>clearTimeout(o))]}else S("changed",s)})}catch(l){b.Promises.exists(u.path).then(r=>{r&&!f&&v(`Failed to watch ${u.path} for changes using fs.watch() (${l.toString()})`)})}return(0,L.toDisposable)(()=>{f=!0,c=(0,L.dispose)(c)})}async function m(u,S,v,g=512){const y=await b.Promises.open(u,"r"),f=Buffer.allocUnsafe(g),c=new _.CancellationTokenSource(v);let l,r=!1;const a=I(u,async n=>{if(n==="changed"){if(r)return;r=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:t}=await b.Promises.read(y,f,0,g,null);if(!t||c.token.isCancellationRequested)break;S(f.slice(0,t))}}catch(t){l=new Error(t),c.dispose(!0)}finally{r=!1}}},n=>{l=new Error(n),c.dispose(!0)});return new Promise((n,t)=>{c.token.onCancellationRequested(async()=>{a.dispose(),await b.Promises.close(y),l?t(l):n()})})}e.watchFileContents=m});var de=this&&this.__decorate||function(J,e,T,_){var D=arguments.length,L=D<3?e:_===null?_=Object.getOwnPropertyDescriptor(e,T):_,i;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(J,e,T,_);else for(var R=J.length-1;R>=0;R--)(i=J[R])&&(L=(D<3?i(L):D>3?i(e,T,L):i(e,T))||L);return D>3&&L&&Object.defineProperty(e,T,L),L};define(te[36],ne([0,1,16,5,19,26,67,7,3,2,106,25,15]),function(J,e,T,_,D,L,i,R,E,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function u(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function v(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(g||(g={}));class y{constructor(j){this.buffer=j,this.pos=0}read(j){const X=this.buffer.slice(this.pos,this.pos+j);return this.pos+=X.byteLength,X}}class f{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var c;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(c||(c={}));function l(B){const j=D.VSBuffer.alloc(4);return j.writeUInt32BE(B,0),j}function r(B){return B.read(4).readUInt32BE(0)}function a(B){const j=D.VSBuffer.alloc(1);return j.writeUInt8(B,0),j}const n={Undefined:a(c.Undefined),String:a(c.String),Buffer:a(c.Buffer),VSBuffer:a(c.VSBuffer),Array:a(c.Array),Object:a(c.Object)},t=typeof Buffer!="undefined";function s(B,j){if(typeof j=="undefined")B.write(n.Undefined);else if(typeof j=="string"){const X=D.VSBuffer.fromString(j);B.write(n.String),B.write(l(X.byteLength)),B.write(X)}else if(t&&Buffer.isBuffer(j)){const X=D.VSBuffer.wrap(j);B.write(n.Buffer),B.write(l(X.byteLength)),B.write(X)}else if(j instanceof D.VSBuffer)B.write(n.VSBuffer),B.write(l(j.byteLength)),B.write(j);else if(Array.isArray(j)){B.write(n.Array),B.write(l(j.length));for(const X of j)s(B,X)}else{const X=D.VSBuffer.fromString(JSON.stringify(j));B.write(n.Object),B.write(l(X.byteLength)),B.write(X)}}function o(B){switch(B.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return B.read(r(B)).toString();case c.Buffer:return B.read(r(B)).buffer;case c.VSBuffer:return B.read(r(B));case c.Array:{const X=r(B),U=[];for(let N=0;N<X;N++)U.push(o(B));return U}case c.Object:return JSON.parse(B.read(r(B)).toString())}}class h{constructor(j,X,U=null,N=1e3){this.protocol=j,this.ctx=X,this.logger=U,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(j,X){this.channels.set(j,X),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const X=this.send([j.type]);this.logger&&this.logger.logOutgoing(X,0,1,v(j.type));return}case 201:case 202:case 204:case 203:{const X=this.send([j.type,j.id],j.data);this.logger&&this.logger.logOutgoing(X,j.id,1,v(j.type),j.data);return}}}send(j,X=void 0){const U=new f;return s(U,j),s(U,X),this.sendBuffer(U.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch(X){return 0}}onRawMessage(j){const X=new y(j),U=o(X),N=o(X),W=U[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(j.byteLength,U[1],1,`${u(W)}: ${U[2]}.${U[3]}`,N),this.onPromise({type:W,id:U[1],channelName:U[2],name:U[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(j.byteLength,U[1],1,`${u(W)}: ${U[2]}.${U[3]}`,N),this.onEventListen({type:W,id:U[1],channelName:U[2],name:U[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(j.byteLength,U[1],1,`${u(W)}`),this.disposeActiveRequest({type:W,id:U[1]});case 103:return this.logger&&this.logger.logIncoming(j.byteLength,U[1],1,`${u(W)}`),this.disposeActiveRequest({type:W,id:U[1]})}}onPromise(j){const X=this.channels.get(j.channelName);if(!X){this.collectPendingRequest(j);return}const U=new L.CancellationTokenSource;let N;try{N=X.call(this.ctx,j.name,j.arg,U.token)}catch(G){N=Promise.reject(G)}const W=j.id;N.then(G=>{this.sendResponse({id:W,data:G,type:201}),this.activeRequests.delete(j.id)},G=>{G instanceof Error?this.sendResponse({id:W,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:W,data:G,type:203}),this.activeRequests.delete(j.id)});const V=(0,b.toDisposable)(()=>U.cancel());this.activeRequests.set(j.id,V)}onEventListen(j){const X=this.channels.get(j.channelName);if(!X){this.collectPendingRequest(j);return}const U=j.id,W=X.listen(this.ctx,j.name,j.arg)(V=>this.sendResponse({id:U,data:V,type:204}));this.activeRequests.set(j.id,W)}disposeActiveRequest(j){const X=this.activeRequests.get(j.id);X&&(X.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let X=this.pendingRequests.get(j.channelName);X||(X=[],this.pendingRequests.set(j.channelName,X));const U=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:j,timeoutTimer:U})}flushPendingRequests(j){const X=this.pendingRequests.get(j);if(X){for(const U of X)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var p;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(j,X=null){this.protocol=j,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=X}getChannel(j){const X=this;return{call(U,N,W){return X.isDisposed?Promise.reject(R.canceled()):X.requestPromise(j,U,N,W)},listen(U,N){return X.isDisposed?Promise.reject(R.canceled()):X.requestEvent(j,U,N)}}}requestPromise(j,X,U,N=L.CancellationToken.None){const W=this.lastRequestId++,G={id:W,type:100,channelName:j,name:X,arg:U};if(N.isCancellationRequested)return Promise.reject(R.canceled());let ee;return new Promise((Q,re)=>{if(N.isCancellationRequested)return re(R.canceled());const oe=()=>{const Ie=Se=>{switch(Se.type){case 201:this.handlers.delete(W),Q(Se.data);break;case 202:this.handlers.delete(W);const ve=new Error(Se.data.message);ve.stack=Se.data.stack,ve.name=Se.data.name,re(ve);break;case 203:this.handlers.delete(W),re(Se.data);break}};this.handlers.set(W,Ie),this.sendRequest(G)};let ce=null;this.state===g.Idle?oe():(ce=(0,_.createCancelablePromise)(Ie=>this.whenInitialized()),ce.then(()=>{ce=null,oe()}));const he=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:W,type:101}),re(R.canceled())},be=N.onCancellationRequested(he);ee=(0,b.combinedDisposable)((0,b.toDisposable)(he),be),this.activeRequests.add(ee)}).finally(()=>{this.activeRequests.delete(ee)})}requestEvent(j,X,U){const N=this.lastRequestId++,V={id:N,type:102,channelName:j,name:X,arg:U};let G=null;const ee=new E.Emitter({onFirstListenerAdd:()=>{G=(0,_.createCancelablePromise)(Q=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(ee),this.sendRequest(V)})},onLastListenerRemove:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(ee),this.sendRequest({id:N,type:103}))}}),H=Q=>ee.fire(Q.data);return this.handlers.set(N,H),ee.event}sendRequest(j){switch(j.type){case 100:case 102:{const X=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger&&this.logger.logOutgoing(X,j.id,0,`${u(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const X=this.send([j.type,j.id]);this.logger&&this.logger.logOutgoing(X,j.id,0,u(j.type));return}}}send(j,X=void 0){const U=new f;return s(U,j),s(U,X),this.sendBuffer(U.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch(X){return 0}}onBuffer(j){const X=new y(j),U=o(X),N=o(X),W=U[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(j.byteLength,0,0,v(W)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(j.byteLength,U[1],0,v(W),N),this.onResponse({type:U[0],id:U[1],data:N})}}onResponse(j){if(j.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}const X=this.handlers.get(j.id);X&&X(j)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}de([i.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class P{constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:X,onDidClientDisconnect:U})=>{E.Event.once(X.onMessage)(W=>{const V=new y(W),G=o(V),ee=new h(X,G),H=new w(X);this.channels.forEach((re,oe)=>ee.registerChannel(oe,re));const Q={channelServer:ee,channelClient:H,ctx:G};this._connections.add(Q),this._onDidAddConnection.fire(Q),U(()=>{ee.dispose(),H.dispose(),this._connections.delete(Q),this._onDidRemoveConnection.fire(Q)})})})}get connections(){const j=[];return this._connections.forEach(X=>j.push(X)),j}getChannel(j,X){const U=this;return{call(N,W,V){let G;if((0,d.isFunction)(X)){let H=(0,T.getRandomElement)(U.connections.filter(X));G=H?Promise.resolve(H):E.Event.toPromise(E.Event.filter(U.onDidAddConnection,X))}else G=X.routeCall(U,N,W);const ee=G.then(H=>H.channelClient.getChannel(j));return O(ee).call(N,W,V)},listen(N,W){if((0,d.isFunction)(X))return U.getMulticastEvent(j,X,N,W);const V=X.routeEvent(U,N,W).then(G=>G.channelClient.getChannel(j));return O(V).listen(N,W)}}}getMulticastEvent(j,X,U,N){const W=this;let V=new b.DisposableStore;const G=new E.Emitter({onFirstListenerAdd:()=>{V=new b.DisposableStore;const ee=new E.EventMultiplexer,H=new Map,Q=oe=>{const he=oe.channelClient.getChannel(j).listen(U,N),be=ee.add(he);H.set(oe,be)},re=oe=>{const ce=H.get(oe);!ce||(ce.dispose(),H.delete(oe))};W.connections.filter(X).forEach(Q),E.Event.filter(W.onDidAddConnection,X)(Q,void 0,V),W.onDidRemoveConnection(re,void 0,V),ee.event(G.fire,G,V),V.add(ee)},onLastListenerRemove:()=>{V.dispose()}});return G.event}registerChannel(j,X){this.channels.set(j,X),this._connections.forEach(U=>{U.channelServer.registerChannel(j,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=P;class M{constructor(j,X,U=null){const N=new f;s(N,X),j.send(N.buffer),this.channelClient=new w(j,U),this.channelServer=new h(j,X,U)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,X){this.channelServer.registerChannel(j,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=M;function O(B){return{call(j,X,U){return B.then(N=>N.call(j,X,U))},listen(j,X){const U=new E.Relay;return B.then(N=>U.input=N.listen(j,X)),U.event}}}e.getDelayedChannel=O;function q(B){let j=!1;return{call(X,U,N){return j?B.call(X,U,N):(0,_.timeout)(0).then(()=>j=!0).then(()=>B.call(X,U,N))},listen(X,U){if(j)return B.listen(X,U);const N=new E.Relay;return(0,_.timeout)(0).then(()=>j=!0).then(()=>N.input=B.listen(X,U)),N.event}}}e.getNextTickChannel=q;class ${constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const X of j.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await E.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=$;var k;(function(B){function j(W,V){const G=W,ee=V&&V.disableMarshalling,H=new Map;for(const Q in G)U(Q)&&H.set(Q,E.Event.buffer(G[Q],!0));return new class{listen(Q,re,oe){const ce=H.get(re);if(ce)return ce;if(N(re)){const he=G[re];if(typeof he=="function")return he.call(G,oe)}throw new Error(`Event not found: ${re}`)}call(Q,re,oe){const ce=G[re];if(typeof ce=="function"){if(!ee&&Array.isArray(oe))for(let he=0;he<oe.length;he++)oe[he]=(0,I.revive)(oe[he]);return ce.apply(G,oe)}throw new Error(`Method not found: ${re}`)}}}B.fromService=j;function X(W,V){const G=V&&V.disableMarshalling;return new Proxy({},{get(ee,H){if(typeof H=="string")return V?.properties?.has(H)?V.properties.get(H):N(H)?function(Q){return W.listen(H,Q)}:U(H)?W.listen(H):async function(...Q){let re;V&&!(0,d.isUndefinedOrNull)(V.context)?re=[V.context,...Q]:re=Q;const oe=await W.call(H,re);return G?oe:(0,I.revive)(oe)};throw new Error(`Property not found: ${String(H)}`)}})}B.toService=X;function U(W){return W[0]==="o"&&W[1]==="n"&&C.isUpperAsciiLetter(W.charCodeAt(2))}function N(W){return/^onDynamic/.test(W)&&C.isUpperAsciiLetter(W.charCodeAt(9))}})(k=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function A(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let j=B.toString();if(j!=="[object Object]")return j}return B}function F(B){return Array.isArray(B)?B.map(A):A(B)}function x(B,j,X,U,N,W,V){V=F(V);const G=z[N],ee=G[U%G.length];let H=[`%c[${B}]%c[${String(j).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${ee}`];/\($/.test(W)?(H=H.concat(V),H.push(")")):H.push(V),console.log.apply(console,H)}e.logWithColors=x;class Z{constructor(j,X){this._outgoingPrefix=j,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,X,U,N,W){this._totalOutgoing+=j,x(this._outgoingPrefix,this._totalOutgoing,j,X,U,N,W)}logIncoming(j,X,U,N,W){this._totalIncoming+=j,x(this._incomingPrefix,this._totalIncoming,j,X,U,N,W)}}e.IPCLogger=Z}),define(te[117],ne([0,1,19,3,36]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(E){this.port=E,this.onMessage=_.Event.fromDOMEventEmitter(this.port,"message",b=>T.VSBuffer.wrap(b.data)),E.start()}send(E){this.port.postMessage(E.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class i extends D.IPCClient{constructor(E,b){const I=new L(E);super(I,b);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=i}),define(te[71],ne([0,1,19,3,2,36]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var i;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(i=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let o=0;function h(w,P){if(!s.has(w)){const M=String(++o);s.set(w,M)}return s.get(w)}function p(w,P,M,O){if(!t.enableDiagnostics)return;const q=h(w,P);if(O instanceof T.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const $=T.VSBuffer.alloc(O.byteLength);$.set(O),t.records.push({timestamp:Date.now(),id:q,label:P,type:M,buff:$})}else t.records.push({timestamp:Date.now(),id:q,label:P,type:M,data:O})}t.traceSocketEvent=p})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function I(){return b||(b=T.VSBuffer.alloc(0)),b}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return I();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const P=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),P}if(this._chunks[0].byteLength>s){const P=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),P}let h=T.VSBuffer.alloc(s),p=0,w=0;for(;s>0;){const P=this._chunks[w];if(P.byteLength>s){const M=P.slice(0,s);h.set(M,p),p+=s,o&&(this._chunks[w]=P.slice(s),this._totalLength-=s),s-=s}else h.set(P,p),p+=P.byteLength,o?(this._chunks.shift(),this._totalLength-=P.byteLength):w++,s-=P.byteLength}return h}}e.ChunkStream=C;var d;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(d||(d={}));function m(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var u;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(u=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(s,o,h,p){this.type=s,this.id=o,this.ack=h,this.data=p,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends D.Disposable{constructor(s){super();this._onMessage=this._register(new _.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:m(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const h=this._state.messageType,p=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new S(h,p,w,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=T.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:m(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(o,s.data)}_bufferAdd(s,o){const h=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,h}_bufferTake(){const s=T.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class y extends D.Disposable{constructor(s){super();this._onMessage=new _.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new S(1,0,0,s))}}e.Protocol=y;class f extends L.IPCClient{constructor(s,o,h=null){super(s,o,h);this.protocol=s}static fromSocket(s,o){return new f(new y(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=f;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new _.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class l{constructor(s){this.data=s,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,h=this._first;for(;h;)s[o++]=h.data,h=h.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new l(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class a{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<a._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=a._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const s=Date.now(),o=(1+a._HISTORY_LENGTH)*1e3;let h=0;for(let p=0;p<a._HISTORY_LENGTH;p++)s-this.lastRuns[p]<=o&&h++;return 1-h/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class n{constructor(s,o=null,h=a.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=h,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.push(this._socket.onClose(p=>this._onSocketClose.fire(p))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new S(5,0,0,I());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new S(7,0,0,I());this._socketWriter.write(s)}sendResume(){const s=new S(8,0,0,I());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new S(3,0,this._incomingAckId,I());this._socketWriter.write(s);const o=this._outgoingUnackMsg.toArray();for(let h=0,p=o.length;h<p;h++)this._socketWriter.write(o[h]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new S(6,0,0,I())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let h=0,p=o.length;h<p;h++)this._socketWriter.write(o[h]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new S(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(s){const o=new S(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime,h=Date.now()-this._socketReader.lastReadTime,p=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&h>=2e4&&p>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const w=Math.max(2e4-o,2e4-h,2e4-p,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},w)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new S(3,0,this._incomingAckId,I());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(te[118],ne([0,1,72,3,36,117]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class i extends D.IPCServer{static getOnDidClientConnect(){const E=_.Event.fromNodeEventEmitter(T.ipcRenderer,"vscode:createMessageChannel",(b,I)=>I);return _.Event.map(E,b=>{const{port1:I,port2:C}=new MessageChannel,m={protocol:new L.Protocol(I),onDidClientDisconnect:_.Event.fromDOMEventEmitter(I,"close")};return T.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[C]),m})}constructor(){super(i.getOnDidClientConnect())}}e.Server=i}),define(te[119],ne([0,1,19,7]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function D(R,E){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((I,C)=>{b.open(R.type||"GET",R.url||"",!0,R.user,R.password),L(b,R),b.responseType="arraybuffer",b.onerror=d=>C(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=d=>{I({res:{statusCode:b.status,headers:i(b)},stream:(0,T.bufferToStream)(T.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=d=>C(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(b.timeout=R.timeout),b.send(R.data),E.onCancellationRequested(()=>{b.abort(),C((0,_.canceled)())})})}e.request=D;function L(R,E){if(E.headers){e:for(let b in E.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(b,E.headers[b])}}}function i(R){const E=Object.create(null);for(const b of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const I=b.indexOf(":");E[b.substr(0,I).trim().toLowerCase()]=b.substr(I+1).trim()}return E}}),define(te[73],ne([0,1,5,3,2,15]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var i;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(i=e.StorageHint||(e.StorageHint={}));function R(C){const d=C;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var E;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(E||(E={}));class b extends D.Disposable{constructor(d,m=Object.create(null)){super();this.database=d,this.options=m,this._onDidChangeStorage=this._register(new _.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=E.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((m,u)=>this.accept(u,m)),d.deleted?.forEach(m=>this.accept(m,void 0))}accept(d,m){if(this.state===E.Closed)return;let u=!1;(0,L.isUndefinedOrNull)(m)?u=this.cache.delete(d):this.cache.get(d)!==m&&(this.cache.set(d,m),u=!0),u&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===E.None&&(this.state=E.Initialized,this.options.hint!==i.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,m){const u=this.cache.get(d);return(0,L.isUndefinedOrNull)(u)?m:u}getBoolean(d,m){const u=this.get(d);return(0,L.isUndefinedOrNull)(u)?m:u==="true"}getNumber(d,m){const u=this.get(d);return(0,L.isUndefinedOrNull)(u)?m:parseInt(u,10)}async set(d,m){if(this.state===E.Closed)return;if((0,L.isUndefinedOrNull)(m))return this.delete(d);const u=String(m);if(this.cache.get(d)!==u)return this.cache.set(d,u),this.pendingInserts.set(d,u),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===E.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=E.Closed;try{await this.doFlush(0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=_.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((m,u)=>this.items.set(u,m)),d.delete&&d.delete.forEach(m=>this.items.delete(m))}async close(){}}e.InMemoryStorageDatabase=I}),define(te[120],ne([11,12]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[56],ne([0,1,120]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const _=60,D=_*60,L=D*24,i=L*7,R=L*30,E=L*365;function b(C,d){typeof C!="number"&&(C=C.getTime());const m=Math.round((new Date().getTime()-C)/1e3);if(m<-30)return(0,T.localize)(0,null,b(new Date().getTime()+m*1e3,!1));if(m<30)return(0,T.localize)(1,null);let u;return m<_?(u=m,d?u===1?(0,T.localize)(2,null,u):(0,T.localize)(3,null,u):u===1?(0,T.localize)(4,null,u):(0,T.localize)(5,null,u)):m<D?(u=Math.floor(m/_),d?u===1?(0,T.localize)(6,null,u):(0,T.localize)(7,null,u):u===1?(0,T.localize)(8,null,u):(0,T.localize)(9,null,u)):m<L?(u=Math.floor(m/D),d?u===1?(0,T.localize)(10,null,u):(0,T.localize)(11,null,u):u===1?(0,T.localize)(12,null,u):(0,T.localize)(13,null,u)):m<i?(u=Math.floor(m/L),d?u===1?(0,T.localize)(14,null,u):(0,T.localize)(15,null,u):u===1?(0,T.localize)(16,null,u):(0,T.localize)(17,null,u)):m<R?(u=Math.floor(m/i),d?u===1?(0,T.localize)(18,null,u):(0,T.localize)(19,null,u):u===1?(0,T.localize)(20,null,u):(0,T.localize)(21,null,u)):m<E?(u=Math.floor(m/R),d?u===1?(0,T.localize)(22,null,u):(0,T.localize)(23,null,u):u===1?(0,T.localize)(24,null,u):(0,T.localize)(25,null,u)):(u=Math.floor(m/E),d?u===1?(0,T.localize)(26,null,u):(0,T.localize)(27,null,u):u===1?(0,T.localize)(28,null,u):(0,T.localize)(29,null,u))}e.fromNow=b;function I(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(te[121],ne([11,12]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[38],ne([0,1,16,15,121]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function L(b,I){return I&&(b.stack||b.stacktrace)?D.localize(0,null,R(b),i(b.stack)||i(b.stacktrace)):R(b)}function i(b){return Array.isArray(b)?b.join(`
`):b}function R(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?D.localize(1,null,b.message):b.message||D.localize(2,null)}function E(b=null,I=!1){if(!b)return D.localize(3,null);if(Array.isArray(b)){const C=T.coalesce(b),d=E(C[0],I);return C.length>1?D.localize(4,null,d,C.length):d}if(_.isString(b))return b;if(b.detail){const C=b.detail;if(C.error)return L(C.error,I);if(C.exception)return L(C.exception,I)}return b.stack?L(b,I):b.message?b.message:D.localize(5,null)}e.toErrorMessage=E}),define(te[122],ne([11,12]),function(J,e){return J.create("vs/base/node/processes",e)}),define(te[74],ne([0,1,45,41,17,28,10,4,32,101,15,110,20,122]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function u(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function S(r,a){if(R.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};a&&(n.cwd=a);const t=T.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],n);return new Promise(s=>{t.once("error",o=>{s({success:!1,error:o})}),t.once("exit",(o,h)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?u(n.status):1})}else if(R.isLinux||R.isMacintosh)try{const n=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(t=>{T.execFile(n,[r.pid.toString()],{encoding:"utf8",shell:!0},(s,o,h)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function v(r){!r||(delete r.DEBUG,R.isMacintosh&&delete r.DYLD_LIBRARY_PATH,R.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function g(r=E.env){return r.comspec||"cmd.exe"}e.getWindowsShell=g;class y{constructor(a,n,t,s){if(n!==void 0&&t!==void 0&&s!==void 0)this.cmd=a,this.args=n,this.shell=t,this.options=s;else{const o=a;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(E.env).forEach(h=>{o[h]=E.env[h]}),Object.keys(this.options.env).forEach(h=>{o[h]=this.options.env[h]}),this.options.env=o}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const n=a.lastIndexOf(i.sep);return n!==-1&&(a=a.substring(n+1)),y.WellKnowCommands[a]?a:"other"}start(a){return R.isWindows&&(this.options&&this.options.cwd&&_.isUNC(this.options.cwd)||!this.options&&_.isUNC(E.cwd()))?Promise.reject(new Error(m.localize(0,null))):this.useExec().then(n=>{let t,s;const o=new Promise((h,p)=>{t=h,s=p});if(n){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=T.exec(h,this.options,(p,w,P)=>{this.childProcess=null;const M=p;M&&M.killed?s({killed:this.terminateRequested,stdout:w.toString(),stderr:P.toString()}):this.handleExec(t,a,p,w,P)})}else{let h=null;const p=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,t,a,s);const P={terminated:this.terminateRequested};I.isNumber(w)&&(P.cmdCode=w),t(P)};if(this.shell&&R.isWindows){const w=L.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let P=!1,M=!1;const O=[];let q=this.ensureQuotes(this.cmd);O.push(q.value),P=q.quoted,this.args&&this.args.forEach(k=>{q=this.ensureQuotes(k),O.push(q.value),M=M&&q.quoted});const $=["/s","/c"];P?M?$.push('"'+O.join(" ")+'"'):O.length>1?$.push('"'+O[0]+'" '+O.slice(1).join(" ")):$.push('"'+O[0]+'"'):$.push(O.join(" ")),h=T.spawn(g(),$,w)}else this.cmd&&(h=T.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(I.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",w=>{this.childProcess=null,s({terminated:this.terminateRequested,error:w})}),h.pid&&(this.childProcess.on("close",p),this.handleSpawn(h,t,a,s,!0)))}return o})}handleClose(a,n,t,s){}ensureQuotes(a){return y.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,S(a,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!R.isWindows)return a(!1);const n=T.spawn(g(),["/s","/c"]);n.on("error",t=>a(!0)),n.on("exit",t=>a(!1))})}}e.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class f extends y{constructor(a,n,t,s){super(a,n,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,n,t,s,o){[s,o].forEach((h,p)=>{const w=new C.LineDecoder;w.write(h).forEach(O=>{n({line:O,source:p===0?0:1})});const M=w.end();M&&n({line:M,source:p===0?0:1})}),a({terminated:this.terminateRequested,error:t})}handleSpawn(a,n,t,s,o){const h=new C.LineDecoder,p=new C.LineDecoder;a.stdout.on("data",w=>{h.write(w).forEach(M=>t({line:M,source:0}))}),a.stderr.on("data",w=>{p.write(w).forEach(M=>t({line:M,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=p}handleClose(a,n,t,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&t({line:h,source:1})}}e.LineProcess=f;function c(r){let a=[],n=!1;const t=function(s){if(n){a.push(s);return}(!r.send(s,h=>{if(h&&console.error(h),n=!1,a.length>0){const p=a.slice(0);a=[],p.forEach(w=>t(w))}})||R.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=c;var l;(function(r){async function a(n,t,s){if(i.isAbsolute(n))return n;if(t===void 0&&(t=E.cwd()),i.dirname(n)!=="."||(s===void 0&&I.isString(E.env.PATH)&&(s=E.env.PATH.split(i.delimiter)),s===void 0||s.length===0))return i.join(t,n);async function h(p){if(await d.Promises.exists(p)){let w;try{w=await d.Promises.stat(p)}catch(P){P.message.startsWith("EACCES")&&(w=await d.Promises.lstat(p))}return w?!w.isDirectory():!1}return!1}for(let p of s){let w;if(i.isAbsolute(p)?w=i.join(p,n):w=i.join(t,p,n),await h(w))return w;let P=w+".com";if(await h(P)||(P=w+".exe",await h(P)))return P}return i.join(t,n)}r.findExecutable=a})(l=e.win32||(e.win32={}))}),define(te[123],ne([0,1,33,4,70,74]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function i(m,u){return m===1?_.isWindows?C():L.getWindowsShell(u):b(m,u)}e.getSystemShell=i;function R(m,u){return m===1?_.isWindows?d(u):L.getWindowsShell(u):b(m,u)}e.getSystemShellSync=R;let E=null;function b(m,u){if(_.isLinux&&m===2||_.isMacintosh&&m===3)return"/bin/bash";if(!E){let S;if(_.isWindows)S="/bin/bash";else{if(S=u.SHELL,!S)try{S=(0,T.userInfo)().shell}catch(v){}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}E=S}return E}let I=null;async function C(){return I||(I=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),I}function d(m){if(I)return I;const u=_.isWindows&&parseFloat((0,T.release)())>=10,S=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${m.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?v:L.getWindowsShell(m)}}),define(te[57],ne([0,1,45,5,19,26,105,7,3,2,28,74,36]),function(J,e,T,_,D,L,i,R,E,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends d.ChannelServer{constructor(v){super({send:g=>{try{process.send&&process.send(g.buffer.toString("base64"))}catch(y){}},onMessage:E.Event.fromNodeEventEmitter(process,"message",g=>D.VSBuffer.wrap(Buffer.from(g,"base64")))},v);process.once("disconnect",()=>this.dispose())}}e.Server=m;class u{constructor(v,g){this.modulePath=v,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new _.Delayer(y),this.child=null,this._client=null}getChannel(v){const g=this;return{call(y,f,c){return g.requestPromise(v,y,f,c)},listen(y,f){return g.requestEvent(v,y,f)}}}requestPromise(v,g,y,f=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(v),l=(0,_.createCancelablePromise)(n=>c.call(g,y,n)),r=f.onCancellationRequested(()=>l.cancel()),a=(0,b.toDisposable)(()=>l.cancel());return this.activeRequests.add(a),l.finally(()=>{r.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(v,g,y){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let f;const c=new E.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(v).listen(g,y)(c.fire,c),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,C.removeDangerousEnvVariables)(g.env),this.child=(0,T.fork)(this.modulePath,v,g);const y=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,i.isRemoteConsoleLog)(t)){(0,i.log)(t,`IPC Library: ${this.options.serverName}`);return}y.fire(D.VSBuffer.wrap(Buffer.from(t,"base64")))});const c=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&c.send(t.buffer.toString("base64")),r=y.event,a={send:l,onMessage:r};this._client=new d.ChannelClient(a);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,s)=>{process.removeListener("exit",n),this.activeRequests.forEach(o=>(0,b.dispose)(o)),this.activeRequests.clear(),t!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:s})})}return this._client}getCachedChannel(v){let g=this.channels.get(v);return g||(g=this.client.getChannel(v),this.channels.set(v,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=u}),define(te[124],ne([11,12]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[125],ne([11,12]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[126],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(te[127],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(te[128],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(te[129],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[130],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[131],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[132],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[133],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[134],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[135],ne([11,12]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[136],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[137],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(te[138],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[139],ne([11,12]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[140],ne([11,12]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[141],ne([11,12]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[142],ne([11,12]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[143],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[144],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[145],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[146],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[147],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[148],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[149],ne([0,1,4]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var _;(function(i){i.Team="team",i.Internal="internal",i.Insiders="insider",i.Public="public"})(_=e.TargetPopulation||(e.TargetPopulation={}));var D;(function(i){i.Market="X-MSEdge-Market",i.CorpNet="X-FD-Corpnet",i.ApplicationVersion="X-VSCode-AppVersion",i.Build="X-VSCode-Build",i.ClientId="X-MSEdge-ClientId",i.ExtensionName="X-VSCode-ExtensionName",i.Language="X-VSCode-Language",i.TargetPopulation="X-VSCode-TargetPopulation"})(D=e.Filters||(e.Filters={}));class L{constructor(R,E,b,I){this.version=R,this.appName=E,this.machineId=b,this.targetPopulation=I}getFilterValue(R){switch(R){case D.ApplicationVersion:return this.version;case D.Build:return this.appName;case D.ClientId:return this.machineId;case D.Language:return T.language;case D.ExtensionName:return"vscode-core";case D.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,E=Object.values(D);for(let b of E)R.set(b,this.getFilterValue(b));return R}}e.AssignmentFilterProvider=L}),define(te[75],ne([0,1,56,67,17,10,32,18,8]),function(J,e,T,_,D,L,i,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(S,v,g){this._args=S,this.paths=v,this.productService=g}get appRoot(){return(0,L.dirname)(D.FileAccess.asFileUri("",J).fsPath)}get userHome(){return E.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return E.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return E.URI.file(this.paths.tmpDir)}get cacheHome(){return E.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return E.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(E.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return E.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return E.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=i.env.VSCODE_PORTABLE;return S?E.URI.file((0,L.join)(S,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return E.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,L.resolve)(S):(0,L.normalize)((0,L.join)(D.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,L.resolve)(S):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,L.resolve)(S);const v=i.env.VSCODE_EXTENSIONS;if(v)return v;const g=i.env.VSCODE_PORTABLE;return g?(0,L.join)(g,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(v=>/^[^:/?#]+?:\/\//.test(v)?E.URI.parse(v):E.URI.file((0,L.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?E.URI.parse(S):E.URI.file((0,L.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!i.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(E.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return E.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([_.memoize],b.prototype,"appRoot",null),de([_.memoize],b.prototype,"userHome",null),de([_.memoize],b.prototype,"userDataPath",null),de([_.memoize],b.prototype,"appSettingsHome",null),de([_.memoize],b.prototype,"tmpDir",null),de([_.memoize],b.prototype,"cacheHome",null),de([_.memoize],b.prototype,"userRoamingDataHome",null),de([_.memoize],b.prototype,"settingsResource",null),de([_.memoize],b.prototype,"userDataSyncHome",null),de([_.memoize],b.prototype,"userDataSyncLogResource",null),de([_.memoize],b.prototype,"sync",null),de([_.memoize],b.prototype,"machineSettingsResource",null),de([_.memoize],b.prototype,"globalStorageHome",null),de([_.memoize],b.prototype,"workspaceStorageHome",null),de([_.memoize],b.prototype,"keybindingsResource",null),de([_.memoize],b.prototype,"keyboardLayoutResource",null),de([_.memoize],b.prototype,"argvResource",null),de([_.memoize],b.prototype,"snippetsHome",null),de([_.memoize],b.prototype,"isExtensionDevelopment",null),de([_.memoize],b.prototype,"untitledWorkspacesHome",null),de([_.memoize],b.prototype,"installSourcePath",null),de([_.memoize],b.prototype,"builtinExtensionsPath",null),de([_.memoize],b.prototype,"extensionsPath",null),de([_.memoize],b.prototype,"extensionDevelopmentLocationURI",null),de([_.memoize],b.prototype,"extensionDevelopmentKind",null),de([_.memoize],b.prototype,"extensionTestsLocationURI",null),de([_.memoize],b.prototype,"debugExtensionHost",null),de([_.memoize],b.prototype,"serviceMachineIdResource",null),de([_.memoize],b.prototype,"telemetryLogResource",null),de([_.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function I(u,S){return m(u["inspect-extensions"],u["inspect-brk-extensions"],5870,S,u.debugId,u.extensionEnvironment)}e.parseExtensionHostPort=I;function C(u,S){return m(u["inspect-search"],u["inspect-brk-search"],5876,S,u.extensionEnvironment)}e.parseSearchPort=C;function d(u,S){return m(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,S,u.extensionEnvironment)}e.parsePtyHostPort=d;function m(u,S,v,g,y,f){const l=Number(S||u)||(g?null:v),r=l?Boolean(!!S):!1;let a;if(f)try{a=JSON.parse(f)}catch{}return{port:l,break:r,debugId:y,env:a}}}),define(te[150],ne([0,1,243,4,126]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const i={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(u,S,v=i){const g={},y=[],f=[];for(let a in S){const n=S[a];n.alias&&(g[a]=n.alias),n.type==="string"||n.type==="string[]"?(y.push(a),n.deprecates&&y.push(n.deprecates)):n.type==="boolean"&&(f.push(a),n.deprecates&&f.push(n.deprecates))}const c=T(u,{string:y,boolean:f,alias:g}),l={},r=c;l._=c._.map(a=>String(a)).filter(a=>a.length>0),delete r._;for(let a in S){const n=S[a];n.alias&&delete r[n.alias];let t=r[a];n.deprecates&&r.hasOwnProperty(n.deprecates)&&(t||(t=r[n.deprecates],t&&v.onDeprecatedOption(n.deprecates,a)),delete r[n.deprecates]),typeof t!="undefined"&&(n.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):n.type==="string"&&Array.isArray(t)&&(t=t.pop(),v.onMultipleValues(a,t)),l[a]=t),delete r[a]}for(let a in r)v.onUnknownOption(a);return l}e.parseArgs=R;function E(u,S){let v="";return S.args&&(Array.isArray(S.args)?v=` <${S.args.join("> <")}>`:v=` <${S.args}>`),S.alias?`-${S.alias} --${u}${v}`:`--${u}${v}`}function b(u,S){let v=0,g=[];for(const l in u){const r=u[l],a=E(l,r);v=Math.max(v,a.length),g.push([a,r.description])}let y=v+2+1;if(S-y<25)return g.reduce((l,r)=>l.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let f=S-y-1,c=[];for(const l of g){let r=l[0],a=C(l[1],f),n=I(y-r.length-2);c.push("  "+r+n+a[0]);for(let t=1;t<a.length;t++)c.push(I(y)+a[t])}return c}e.formatOptions=b;function I(u){return" ".repeat(u)}function C(u,S){let v=[];for(;u.length;){let g=u.length<S?u.length:u.lastIndexOf(" ",S),y=u.slice(0,g).trim();u=u.slice(g),v.push(y)}return v}function d(u,S,v,g,y){const f=process.stdout.isTTY&&process.stdout.columns||80,c=y?.noInputFiles!==!0?`[${(0,D.localize)(33,null)}...]`:"",l=[`${u} ${v}`];l.push(""),l.push(`${(0,D.localize)(34,null)}: ${S} [${(0,D.localize)(35,null)}]${c}`),l.push(""),y?.noPipe!==!0&&(_.isWindows?l.push((0,D.localize)(36,null,S)):l.push((0,D.localize)(37,null,S)),l.push(""));const r={};for(const a in g){const n=g[a];if(n.description&&n.cat){let t=r[n.cat];t||(r[n.cat]=t={}),t[a]=n}}for(let a in r){const n=a;let t=r[n];t&&(l.push(L[n]),l.push(...b(t,f)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=d;function m(u,S){return`${u||(0,D.localize)(38,null)}
${S||(0,D.localize)(39,null)}
${process.arch}`}e.buildVersionMessage=m}),function(){"use strict";function J(e,T,_,D){function L(R){const E=i(R),b=[E];return e.isAbsolute(E)||b.unshift(D),e.resolve(...b)}function i(R){const E=process.env.VSCODE_PORTABLE;if(E)return e.join(E,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,_);const I=R["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(C,"AppData","Roaming")}break;case"darwin":b=e.join(T.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,_)}return{getUserDataPath:L}}if(typeof define=="function")define(te[151],ne([0,244,33,17,18,32]),function(e,T,_,D,L,i){const R=L.dirname(D.FileAccess.asFileUri("",e)),E=e.__$__nodeRequire(L.joinPath(R,"package.json").fsPath);return J(T,_,E.name,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),T=require("path"),_=require("os");module.exports=J(T,_,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[152],ne([0,1,33,75,151]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends _.AbstractNativeEnvironmentService{constructor(R,E){super(R,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,D.getUserDataPath)(R)},E)}}e.NativeEnvironmentService=L}),define(te[153],ne([0,1,8]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const _=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,i=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,E=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(v){const g=v.match(i);return g?g[1]:null}function I(v){if(v.indexOf("://")===-1){const g=v.match(_);return g?b(g[2]):null}try{const g=T.URI.parse(v);if(g.authority)return b(g.authority)}catch(g){}return null}function C(v,g){const y=new Set;let f;for(;f=R.exec(v);){const l=I(f[1]);l&&y.add(l)}const c=new Set(g);return Array.from(y).map(l=>c.has(l)?l:l.replace(E,"a"))}e.getDomainsOfRemotes=C;function d(v){const g=v.match(L);return g?g[2]:null}function m(v,g,y){return v&&g?(y&&g.endsWith(".git")&&(g=g.substr(0,g.length-4)),g.indexOf("/")===0?`${v}${g}`:`${v}/${g}`):null}function u(v,g){if(v.indexOf("://")===-1){const y=v.match(D);if(y)return m(y[2],y[3],g)}try{const y=T.URI.parse(v);if(y.authority)return m(d(y.authority),y.path,g)}catch(y){}return null}function S(v,g=!1){const y=[];let f;for(;f=R.exec(v);){const c=u(f[1],g);c&&y.push(c)}return y}e.getRemotes=S}),define(te[154],ne([0,1,28]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const _=/^%([\w\d.-]+)%$/i;function D(L,i){const R=E=>{if(typeof E!="string")return;const b=_.exec(E);if(!b)return;const I=i[b[1]]??E;return typeof I=="string"?I:typeof I.message=="string"?I.message:E};return(0,T.cloneAndChange)(L,R)}e.localizeManifest=D}),define(te[155],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class T{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,i,R,E){return this.channel.call("promptImportantExtensionsInstallNotification",[L,i,R,E])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=T;class _{constructor(L){this.service=L}listen(L,i){throw new Error(`Event not found: ${i}`)}call(L,i,R){switch(i){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${i}`)}}e.ExtensionRecommendationNotificationServiceChannel=_}),define(te[76],ne([0,1,135]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function L(d){return d=d.trim(),d==="*"||_.test(d)}e.isValidVersionStr=L;function i(d){if(!L(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=d.match(_);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=i;function R(d){if(!d)return null;let m=d.majorBase,u=d.majorMustEqual,S=d.minorBase,v=d.minorMustEqual,g=d.patchBase,y=d.patchMustEqual;d.hasCaret&&(m===0||(v=!1),y=!1);let f=0;if(d.preRelease){const c=D.exec(d.preRelease);if(c){const[,l,r,a]=c;f=Date.UTC(Number(l),Number(r)-1,Number(a))}}return{majorBase:m,majorMustEqual:u,minorBase:S,minorMustEqual:v,patchBase:g,patchMustEqual:y,isMinimum:d.hasGreaterEquals,notBefore:f}}e.normalizeVersion=R;function E(d,m,u){let S;typeof d=="string"?S=R(i(d)):S=d;let v;m instanceof Date?v=m.getTime():typeof m=="string"&&(v=new Date(m).getTime());let g;if(typeof u=="string"?g=R(i(u)):g=u,!S||!g)return!1;let y=S.majorBase,f=S.minorBase,c=S.patchBase,l=g.majorBase,r=g.minorBase,a=g.patchBase,n=g.notBefore,t=g.majorMustEqual,s=g.minorMustEqual,o=g.patchMustEqual;return g.isMinimum?y>l?!0:y<l?!1:f>r?!0:f<r||v&&v<n?!1:c>=a:(y===1&&l===0&&(!t||!s||!o)&&(l=1,r=0,a=0,t=!0,s=!1,o=!1),y<l?!1:y>l?!t:f<r?!1:f>r?!s:c<a?!1:c>a?!o:!(v&&v<n))}e.isValidVersion=E;function b(d,m,u,S){return u.isBuiltin||typeof u.main=="undefined"?!0:C(d,m,u.engines.vscode,S)}e.isValidExtensionVersion=b;function I(d,m,u){return d==="*"||C(m,u,d)}e.isEngineValid=I;function C(d,m,u,S=[]){let v=R(i(u));if(!v)return S.push(T.localize(0,null,u)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return S.push(T.localize(1,null,u)),!1}else if(!v.majorMustEqual)return S.push(T.localize(2,null,u)),!1;return E(d,m,v)?!0:(S.push(T.localize(3,null,d,u)),!1)}}),define(te[52],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(D,L=[],i=!1){this.ctor=D,this.staticArguments=L,this.supportsDelayedInstantiation=i}}e.SyncDescriptor=T}),define(te[77],ne([0,1,52]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const _=[];function D(i,R,E){R instanceof T.SyncDescriptor||(R=new T.SyncDescriptor(R,[],E)),_.push([i,R])}e.registerSingleton=D;function L(){return _}e.getSingletonServiceDescriptors=L}),define(te[156],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=T;class _{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let i of this._nodes.values())i.outgoing.size===0&&L.push(i);return L}insertEdge(L,i){const R=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(i);R.outgoing.set(this._hashFn(i),E),E.incoming.set(this._hashFn(L),R)}removeNode(L){const i=this._hashFn(L);this._nodes.delete(i);for(let R of this._nodes.values())R.outgoing.delete(i),R.incoming.delete(i)}lookupOrInsertNode(L){const i=this._hashFn(L);let R=this._nodes.get(i);return R||(R=new T(L),this._nodes.set(i,R)),R}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[i,R]of this._nodes)L.push(`${i}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,i]of this._nodes){const R=new Set([L]),E=this._findCycle(i,R);if(E)return E}}_findCycle(L,i){for(let[R,E]of L.outgoing){if(i.has(R))return[...i,R].join(" -> ");i.add(R);const b=this._findCycle(E,i);if(b)return b;i.delete(R)}}}e.Graph=_}),define(te[6],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var T;(function(i){i.serviceIds=new Map,i.DI_TARGET="$di$target",i.DI_DEPENDENCIES="$di$dependencies";function R(E){return E[i.DI_DEPENDENCIES]||[]}i.getServiceDependencies=R})(T=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function _(i,R,E,b){R[T.DI_TARGET]===R?R[T.DI_DEPENDENCIES].push({id:i,index:E,optional:b}):(R[T.DI_DEPENDENCIES]=[{id:i,index:E,optional:b}],R[T.DI_TARGET]=R)}function D(i){if(T.serviceIds.has(i))return T.serviceIds.get(i);const R=function(E,b,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");_(R,E,I,!1)};return R.toString=()=>i,T.serviceIds.set(i,R),R}e.createDecorator=D;function L(i){return i}e.refineServiceDecorator=L}),define(te[157],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,T.createDecorator)("checksumService")}),define(te[21],ne([0,1,15,8,6]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function L(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof _.URI)}e.isConfigurationOverrides=L;function i(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||T.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof _.URI)}e.isConfigurationUpdateOverrides=i;var R;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=E;function b(v,g){const y=Object.create(null);for(let f in v)I(y,f,v[f],g);return y}e.toValuesTree=b;function I(v,g,y,f){const c=g.split("."),l=c.pop();let r=v;for(let a=0;a<c.length;a++){let n=c[a],t=r[n];switch(typeof t){case"undefined":t=r[n]=Object.create(null);break;case"object":break;default:f(`Ignoring ${g} as ${c.slice(0,a+1).join(".")} is ${JSON.stringify(t)}`);return}r=t}if(typeof r=="object"&&r!==null)try{r[l]=y}catch(a){f(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(r)}`)}else f(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=I;function C(v,g){const y=g.split(".");d(v,y)}e.removeFromValueTree=C;function d(v,g){const y=g.shift();if(g.length===0){delete v[y];return}if(Object.keys(v).indexOf(y)!==-1){const f=v[y];typeof f=="object"&&!Array.isArray(f)&&(d(f,g),Object.keys(f).length===0&&delete v[y])}}function m(v,g,y){function f(r,a){let n=r;for(const t of a){if(typeof n!="object"||n===null)return;n=n[t]}return n}const c=g.split("."),l=f(v,c);return typeof l=="undefined"?y:l}e.getConfigurationValue=m;function u(v,g,y){Object.keys(g).forEach(f=>{f!=="__proto__"&&(f in v?T.isObject(v[f])&&T.isObject(g[f])?u(v[f],g[f],y):y&&(v[f]=g[f]):v[f]=g[f])})}e.merge=u;function S(v,g,y){const f=v.inspect(g),c=v.inspect(y);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:f.defaultValue}e.getMigratedSettingValue=S}),define(te[158],ne([0,1,4,25,6]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let L=T.userAgent||"";const i=new Map;i.set("false",!1),i.set("true",!0),i.set("isMac",T.isMacintosh),i.set("isLinux",T.isLinux),i.set("isWindows",T.isWindows),i.set("isWeb",T.isWeb),i.set("isMacNative",T.isMacintosh&&!T.isWeb),i.set("isEdge",L.indexOf("Edg/")>=0),i.set("isFirefox",L.indexOf("Firefox")>=0),i.set("isChrome",L.indexOf("Chrome")>=0),i.set("isSafari",L.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var E;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return d.INSTANCE}static true(){return m.INSTANCE}static has(k){return u.create(k)}static equals(k,z){return S.create(k,z)}static notEquals(k,z){return y.create(k,z)}static regex(k,z){return t.create(k,z)}static in(k,z){return v.create(k,z)}static not(k){return f.create(k)}static and(...k){return h.create(k,null)}static or(...k){return p.create(k,null,!0)}static greater(k,z){return l.create(k,z)}static greaterEquals(k,z){return r.create(k,z)}static smaller(k,z){return a.create(k,z)}static smallerEquals(k,z){return n.create(k,z)}static deserialize(k,z=!1){if(!!k)return this._deserializeOrExpression(k,z)}static _deserializeOrExpression(k,z){let A=k.split("||");return p.create(A.map(F=>this._deserializeAndExpression(F,z)),null,!0)}static _deserializeAndExpression(k,z){let A=k.split("&&");return h.create(A.map(F=>this._deserializeOne(F,z)),null)}static _deserializeOne(k,z){if(k=k.trim(),k.indexOf("!=")>=0){let A=k.split("!=");return y.create(A[0].trim(),this._deserializeValue(A[1],z))}if(k.indexOf("==")>=0){let A=k.split("==");return S.create(A[0].trim(),this._deserializeValue(A[1],z))}if(k.indexOf("=~")>=0){let A=k.split("=~");return t.create(A[0].trim(),this._deserializeRegexValue(A[1],z))}if(k.indexOf(" in ")>=0){let A=k.split(" in ");return v.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const A=k.split(">=");return r.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const A=k.split(">");return l.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const A=k.split("<=");return n.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const A=k.split("<");return a.create(A[0].trim(),A[1].trim())}return/^\!\s*/.test(k)?f.create(k.substr(1).trim()):u.create(k)}static _deserializeValue(k,z){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;let A=/^'([^']*)'$/.exec(k);return A?A[1].trim():k}static _deserializeRegexValue(k,z){if((0,_.isFalsyOrWhitespace)(k)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let A=k.indexOf("/"),F=k.lastIndexOf("/");if(A===F||A<0){if(z)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}let x=k.slice(A+1,F),Z=k[F+1]==="i"?"i":"";try{return new RegExp(x,Z)}catch(B){if(z)throw new Error(`bad regexp-value '${k}', parse error: ${B}`);return console.warn(`bad regexp-value '${k}', parse error: ${B}`),null}}}e.ContextKeyExpr=b;function I($,k){const z=$?$.substituteConstants():void 0,A=k?k.substituteConstants():void 0;return!z&&!A?!0:!z||!A?!1:z.equals(A)}e.expressionsAreEqualWithConstantSubstitution=I;function C($,k){return $.cmp(k)}class d{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=d,d.INSTANCE=new d;class m{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return d.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class u{constructor(k,z){this.key=k,this.negated=z,this.type=2}static create(k,z=null){const A=i.get(k);return typeof A=="boolean"?A?m.INSTANCE:d.INSTANCE:new u(k,z)}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=i.get(this.key);return typeof k=="boolean"?k?m.INSTANCE:d.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=u;class S{constructor(k,z,A){this.key=k,this.value=z,this.negated=A,this.type=4}static create(k,z,A=null){if(typeof z=="boolean")return z?u.create(k,A):f.create(k,A);const F=i.get(k);return typeof F=="boolean"?z===(F?"true":"false")?m.INSTANCE:d.INSTANCE:new S(k,z,A)}cmp(k){return k.type!==this.type?this.type-k.type:M(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=i.get(this.key);if(typeof k=="boolean"){const z=k?"true":"false";return this.value===z?m.INSTANCE:d.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=S;class v{constructor(k,z){this.key=k,this.valueKey=z,this.type=10,this.negated=null}static create(k,z){return new v(k,z)}cmp(k){return k.type!==this.type?this.type-k.type:M(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const z=k.getValue(this.valueKey),A=k.getValue(this.key);return Array.isArray(z)?z.indexOf(A)>=0:typeof A=="string"&&typeof z=="object"&&z!==null?R.call(z,A):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this)),this.negated}}e.ContextKeyInExpr=v;class g{constructor(k){this._actual=k,this.type=11}static create(k){return new g(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new g(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotInExpr=g;class y{constructor(k,z,A){this.key=k,this.value=z,this.negated=A,this.type=5}static create(k,z,A=null){if(typeof z=="boolean")return z?f.create(k,A):u.create(k,A);const F=i.get(k);return typeof F=="boolean"?z===(F?"true":"false")?d.INSTANCE:m.INSTANCE:new y(k,z,A)}cmp(k){return k.type!==this.type?this.type-k.type:M(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=i.get(this.key);if(typeof k=="boolean"){const z=k?"true":"false";return this.value===z?d.INSTANCE:m.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=y;class f{constructor(k,z){this.key=k,this.negated=z,this.type=3}static create(k,z=null){const A=i.get(k);return typeof A=="boolean"?A?d.INSTANCE:m.INSTANCE:new f(k,z)}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=i.get(this.key);return typeof k=="boolean"?k?d.INSTANCE:m.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=u.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=f;function c($,k){if(typeof $=="string"){const z=parseFloat($);isNaN(z)||($=z)}return typeof $=="string"||typeof $=="number"?k($):d.INSTANCE}class l{constructor(k,z,A){this.key=k,this.value=z,this.negated=A,this.type=12}static create(k,z,A=null){return c(z,F=>new l(k,F,A))}cmp(k){return k.type!==this.type?this.type-k.type:M(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class r{constructor(k,z,A){this.key=k,this.value=z,this.negated=A,this.type=13}static create(k,z,A=null){return c(z,F=>new r(k,F,A))}cmp(k){return k.type!==this.type?this.type-k.type:M(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class a{constructor(k,z,A){this.key=k,this.value=z,this.negated=A,this.type=14}static create(k,z,A=null){return c(z,F=>new a(k,F,A))}cmp(k){return k.type!==this.type?this.type-k.type:M(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class n{constructor(k,z,A){this.key=k,this.value=z,this.negated=A,this.type=15}static create(k,z,A=null){return c(z,F=>new n(k,F,A))}cmp(k){return k.type!==this.type?this.type-k.type:M(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(k,z){this.key=k,this.regexp=z,this.type=7,this.negated=null}static create(k,z){return new t(k,z)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const z=this.regexp?this.regexp.source:"",A=k.regexp?k.regexp.source:"";return z<A?-1:z>A?1:0}equals(k){if(k.type===this.type){const z=this.regexp?this.regexp.source:"",A=k.regexp?k.regexp.source:"";return this.key===k.key&&z===A}return!1}substituteConstants(){return this}evaluate(k){let z=k.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{constructor(k){this._actual=k,this.type=8}static create(k){return new s(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new s(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function o($){let k=null;for(let z=0,A=$.length;z<A;z++){const F=$[z].substituteConstants();if($[z]!==F&&k===null){k=[];for(let x=0;x<z;x++)k[x]=$[x]}k!==null&&(k[z]=F)}return k===null?$:k}class h{constructor(k,z){this.expr=k,this.negated=z,this.type=6}static create(k,z){return h._normalizeArr(k,z)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let z=0,A=this.expr.length;z<A;z++){const F=C(this.expr[z],k.expr[z]);if(F!==0)return F}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let z=0,A=this.expr.length;z<A;z++)if(!this.expr[z].equals(k.expr[z]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:h.create(k,this.negated)}evaluate(k){for(let z=0,A=this.expr.length;z<A;z++)if(!this.expr[z].evaluate(k))return!1;return!0}static _normalizeArr(k,z){const A=[];let F=!1;for(const x of k)if(!!x){if(x.type===1){F=!0;continue}if(x.type===0)return d.INSTANCE;if(x.type===6){A.push(...x.expr);continue}A.push(x)}if(A.length===0&&F)return m.INSTANCE;if(A.length!==0){if(A.length===1)return A[0];A.sort(C);for(let x=1;x<A.length;x++)A[x-1].equals(A[x])&&(A.splice(x,1),x--);if(A.length===1)return A[0];for(;A.length>1;){const x=A[A.length-1];if(x.type!==9)break;A.pop();const Z=A.pop(),B=A.length===0,j=p.create(x.expr.map(X=>h.create([X,Z],null)),null,B);j&&(A.push(j),A.sort(C))}return A.length===1?A[0]:new h(A,z)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(let z of this.expr)k.push(...z.keys());return k}map(k){return new h(this.expr.map(z=>z.map(k)),null)}negate(){if(!this.negated){const k=[];for(let z of this.expr)k.push(z.negate());this.negated=p.create(k,this,!0)}return this.negated}}class p{constructor(k,z){this.expr=k,this.negated=z,this.type=9}static create(k,z,A){return p._normalizeArr(k,z,A)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let z=0,A=this.expr.length;z<A;z++){const F=C(this.expr[z],k.expr[z]);if(F!==0)return F}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let z=0,A=this.expr.length;z<A;z++)if(!this.expr[z].equals(k.expr[z]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:p.create(k,this.negated,!1)}evaluate(k){for(let z=0,A=this.expr.length;z<A;z++)if(this.expr[z].evaluate(k))return!0;return!1}static _normalizeArr(k,z,A){let F=[],x=!1;if(k){for(let Z=0,B=k.length;Z<B;Z++){const j=k[Z];if(!!j){if(j.type===0){x=!0;continue}if(j.type===1)return m.INSTANCE;if(j.type===9){F=F.concat(j.expr);continue}F.push(j)}}if(F.length===0&&x)return d.INSTANCE;F.sort(C)}if(F.length!==0){if(F.length===1)return F[0];for(let Z=1;Z<F.length;Z++)F[Z-1].equals(F[Z])&&(F.splice(Z,1),Z--);if(F.length===1)return F[0];if(A){for(let Z=0;Z<F.length;Z++)for(let B=Z+1;B<F.length;B++)O(F[Z],F[B])&&(F.splice(B,1),B--);if(F.length===1)return F[0]}return new p(F,z)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(let z of this.expr)k.push(...z.keys());return k}map(k){return new p(this.expr.map(z=>z.map(k)),null)}negate(){if(!this.negated){let k=[];for(let z of this.expr)k.push(z.negate());for(;k.length>1;){const z=k.shift(),A=k.shift(),F=[];for(const Z of q(z))for(const B of q(A))F.push(h.create([Z,B],null));const x=k.length===0;k.unshift(p.create(F,null,x))}this.negated=k[0]}return this.negated}}class w extends u{constructor(k,z,A){super(k,null);this._defaultValue=z,typeof A=="object"?w._info.push({...A,key:k}):A!==!0&&w._info.push({key:k,description:A,type:z!=null?typeof z:void 0})}static all(){return w._info.values()}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return S.create(this.key,k)}notEqualsTo(k){return y.create(this.key,k)}}e.RawContextKey=w,w._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function P($,k){return $<k?-1:$>k?1:0}function M($,k,z,A){return $<z?-1:$>z?1:k<A?-1:k>A?1:0}function O($,k){if(k.type===6&&$.type!==9&&$.type!==6){for(const F of k.expr)if($.equals(F))return!0}const z=$.negate(),A=q(z).concat(q(k));A.sort(C);for(let F=0;F<A.length;F++){const Z=A[F].negate();for(let B=F+1;B<A.length;B++){const j=A[B];if(Z.equals(j))return!0}}return!1}e.implies=O;function q($){return $.type===9?$.expr:[$]}}),define(te[78],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,T.createDecorator)(e.ID);function _(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=_}),define(te[79],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(te[13],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(te[30],ne([0,1,17,130,6]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var L;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(L=e.TargetPlatform||(e.TargetPlatform={}));function i(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=i;function R(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function E(f,c){switch(f){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=E;function b(f,c){return c==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function I(f,c,l){return b(c,l)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===l?!0:C(l).includes(f)}e.isTargetPlatformCompatible=I;function C(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function d(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=d;var m;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(m=e.SortBy||(e.SortBy={}));var u;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(u=e.SortOrder||(e.SortOrder={}));var S;(function(f){f.Install="install",f.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var v;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var g;(function(f){f.Unsupported="Unsupported",f.UnsupportedPreRelease="UnsupportedPreRelease",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(c,l){super(c);this.code=l,this.name=l}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,_.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,_.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")});var Y=this&&this.__param||function(J,e){return function(T,_){e(T,_,J)}};define(te[159],ne([0,1,2,30]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let D=class extends T.Disposable{constructor(i){super();i.removeDeprecatedExtensions(),i.migrateUnsupportedExtensions()}};D=de([Y(0,_.IExtensionManagementService)],D),e.ExtensionsCleaner=D}),define(te[160],ne([0,1,3,2,28,8,109,30]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function E(S,v){return L.URI.revive(v?v.transformIncoming(S):S)}function b(S,v){return v?v.transformOutgoingURI(S):S}function I(S,v){v=v||i.DefaultURITransformer;const g=S.manifest;return{...(0,i.transformAndReviveIncomingURIs)({...S,manifest:void 0},v),manifest:g}}function C(S,v){return v?(0,D.cloneAndChange)(S,g=>g instanceof L.URI?v.transformOutgoingURI(g):void 0):S}class d{constructor(v,g){this.service=v,this.getUriTransformer=g,this.onInstallExtension=T.Event.buffer(v.onInstallExtension,!0),this.onDidInstallExtensions=T.Event.buffer(v.onDidInstallExtensions,!0),this.onUninstallExtension=T.Event.buffer(v.onUninstallExtension,!0),this.onDidUninstallExtension=T.Event.buffer(v.onDidUninstallExtension,!0)}listen(v,g){const y=this.getUriTransformer(v);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return T.Event.map(this.onDidInstallExtensions,f=>f.map(c=>({...c,local:c.local?C(c.local,y):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(v,g,y){const f=this.getUriTransformer(v);switch(g){case"zip":return this.service.zip(I(y[0],f)).then(c=>b(c,f));case"unzip":return this.service.unzip(E(y[0],f));case"install":return this.service.install(E(y[0],f),y[1]);case"getManifest":return this.service.getManifest(E(y[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(y[0]);case"installFromGallery":return this.service.installFromGallery(y[0],y[1]);case"uninstall":return this.service.uninstall(I(y[0],f),y[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(I(y[0],f));case"getInstalled":return this.service.getInstalled(y[0]).then(c=>c.map(l=>C(l,f)));case"updateMetadata":return this.service.updateMetadata(I(y[0],f),y[1]).then(c=>C(c,f));case"updateExtensionScope":return this.service.updateExtensionScope(I(y[0],f),y[1]).then(c=>C(c,f));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class m extends _.Disposable{constructor(v){super();this.channel=v,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?L.URI.revive(g.source):g.source}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(y=>({...y,local:y.local?I(y.local,null):y.local,source:this.isUriComponents(y.source)?L.URI.revive(y.source):y.source}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire(g))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire(g)))}isUriComponents(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(v){const g=await this.getTargetPlatform();return v.allTargetPlatforms.some(y=>(0,R.isTargetPlatformCompatible)(y,v.allTargetPlatforms,g))}zip(v){return Promise.resolve(this.channel.call("zip",[v]).then(g=>L.URI.revive(g)))}unzip(v){return Promise.resolve(this.channel.call("unzip",[v]))}install(v,g){return Promise.resolve(this.channel.call("install",[v,g])).then(y=>I(y,null))}getManifest(v){return Promise.resolve(this.channel.call("getManifest",[v]))}installFromGallery(v,g){return Promise.resolve(this.channel.call("installFromGallery",[v,g])).then(y=>I(y,null))}uninstall(v,g){return Promise.resolve(this.channel.call("uninstall",[v,g]))}reinstallFromGallery(v){return Promise.resolve(this.channel.call("reinstallFromGallery",[v]))}getInstalled(v=null){return Promise.resolve(this.channel.call("getInstalled",[v])).then(g=>g.map(y=>I(y,null)))}updateMetadata(v,g){return Promise.resolve(this.channel.call("updateMetadata",[v,g])).then(y=>I(y,null))}updateExtensionScope(v,g){return Promise.resolve(this.channel.call("updateExtensionScope",[v,g])).then(y=>I(y,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=m;class u{constructor(v){this.service=v}listen(v,g){throw new Error("Invalid listen")}call(v,g,y){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(y[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=u}),define(te[80],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var _;(function(i){i[i.FILE=1]="FILE",i[i.WORKSPACE=2]="WORKSPACE",i[i.EXE=3]="EXE"})(_=e.RecommendationSource||(e.RecommendationSource={}));function D(i){switch(i){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var L;(function(i){i.Ignored="ignored",i.Cancelled="cancelled",i.TooMany="toomany",i.IncompatibleWindow="incompatibleWindow",i.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,T.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[14],ne([0,1,40,10,25,15,8,137,6]),function(J,e,T,_,D,L,i,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function b(A){return A.create===!0}e.isFileOpenForWriteOptions=b;var I;(function(A){A[A.Unknown=0]="Unknown",A[A.File=1]="File",A[A.Directory=2]="Directory",A[A.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var C;(function(A){A[A.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var d;(function(A){A[A.FileReadWrite=2]="FileReadWrite",A[A.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",A[A.FileReadStream=16]="FileReadStream",A[A.FileFolderCopy=8]="FileFolderCopy",A[A.PathCaseSensitive=1024]="PathCaseSensitive",A[A.Readonly=2048]="Readonly",A[A.Trash=4096]="Trash",A[A.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(A){return!!(A.capabilities&2)}e.hasReadWriteCapability=m;function u(A){return!!(A.capabilities&8)}e.hasFileFolderCopyCapability=u;function S(A){return!!(A.capabilities&4)}e.hasOpenReadWriteCloseCapability=S;function v(A){return!!(A.capabilities&16)}e.hasFileReadStreamCapability=v;var g;(function(A){A.FileExists="EntryExists",A.FileNotFound="EntryNotFound",A.FileNotADirectory="EntryNotADirectory",A.FileIsADirectory="EntryIsADirectory",A.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",A.FileTooLarge="EntryTooLarge",A.FileWriteLocked="EntryWriteLocked",A.NoPermissions="NoPermissions",A.Unavailable="Unavailable",A.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(F,x){super(F);this.code=x}}e.FileSystemProviderError=y;function f(A,F){const x=new y(A.toString(),F);return l(x,F),x}e.createFileSystemProviderError=f;function c(A){return A||f((0,R.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=c;function l(A,F){return A.name=F?`${F} (FileSystemError)`:"FileSystemError",A}e.markAsFileSystemProviderError=l;function r(A){if(!A)return g.Unknown;if(A instanceof y)return A.code;const F=/^(.+) \(FileSystemError\)$/.exec(A.name);if(!F)return g.Unknown;switch(F[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=r;function a(A){if(A instanceof p)return A.fileOperationResult;switch(r(A)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var n;(function(A){A[A.CREATE=0]="CREATE",A[A.DELETE=1]="DELETE",A[A.MOVE=2]="MOVE",A[A.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(F,x,Z){this.resource=F,this.operation=x,this.target=Z}isOperation(F){return this.operation===F}}e.FileOperationEvent=t;var s;(function(A){A[A.UPDATED=0]="UPDATED",A[A.ADDED=1]="ADDED",A[A.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class o{constructor(F,x){this.added=void 0,this.updated=void 0,this.deleted=void 0;const Z=new Map;for(const B of F){const j=Z.get(B.type);j?j.push([B.resource,B]):Z.set(B.type,[[B.resource,B]])}for(const[B,j]of Z)switch(B){case 1:this.added=T.TernarySearchTree.forUris(()=>x),this.added.fill(j);break;case 0:this.updated=T.TernarySearchTree.forUris(()=>x),this.updated.fill(j);break;case 2:this.deleted=T.TernarySearchTree.forUris(()=>x),this.deleted.fill(j);break}}contains(F,...x){return this.doContains(F,{includeChildren:!1},...x)}affects(F,...x){return this.doContains(F,{includeChildren:!0},...x)}doContains(F,x,...Z){if(!F)return!1;const B=Z.length>0;return!!((!B||Z.includes(1))&&(this.added?.get(F)||x.includeChildren&&this.added?.findSuperstr(F))||(!B||Z.includes(0))&&(this.updated?.get(F)||x.includeChildren&&this.updated?.findSuperstr(F))||(!B||Z.includes(2))&&(this.deleted?.findSubstr(F)||x.includeChildren&&this.deleted?.findSuperstr(F)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function h(A,F,x){return!A||!F||A===F||F.length>A.length?!1:(F.charAt(F.length-1)!==_.sep&&(F+=_.sep),x?(0,D.startsWithIgnoreCase)(A,F):A.indexOf(F)===0)}e.isParent=h;class p extends Error{constructor(F,x,Z){super(F);this.fileOperationResult=x,this.options=Z}}e.FileOperationError=p;class w extends p{constructor(F,x,Z){super(F,2,Z);this.stat=x}}e.NotModifiedSinceFileOperationError=w;var P;(function(A){A[A.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",A[A.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",A[A.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",A[A.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",A[A.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",A[A.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",A[A.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",A[A.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",A[A.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",A[A.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",A[A.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",A[A.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(P=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var M;(function(A){A[A.FILE=0]="FILE",A[A.FOLDER=1]="FOLDER",A[A.ROOT_FOLDER=2]="ROOT_FOLDER"})(M=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(A){if(!(typeof A.size!="number"||typeof A.mtime!="number"))return A.mtime.toString(29)+A.size.toString(31)}e.etag=O;async function q(A,F){if(!F.hasProvider(i.URI.from({scheme:A.scheme})))return new Promise(x=>{const Z=F.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===A.scheme&&B.added&&(Z.dispose(),x())})})}e.whenProviderRegistered=q,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(F){return(0,L.isNumber)(F)||(F=0),F<$.KB?(0,R.localize)(1,null,F.toFixed(0)):F<$.MB?(0,R.localize)(2,null,(F/$.KB).toFixed(2)):F<$.GB?(0,R.localize)(3,null,(F/$.MB).toFixed(2)):F<$.TB?(0,R.localize)(4,null,(F/$.GB).toFixed(2)):(0,R.localize)(5,null,(F/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var k;(function(A){A[A.IA32=0]="IA32",A[A.OTHER=1]="OTHER"})(k=e.Arch||(e.Arch={}));function z(A){return{maxFileSize:A===0?300*$.MB:16*$.GB,maxHeapSize:A===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=z}),define(te[161],ne([0,1,81,50,14]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(R){this.fileService=R}async checksum(R){const E=(await this.fileService.readFileStream(R)).value;return new Promise((b,I)=>{const C=(0,T.createHash)("md5");(0,_.listenStream)(E,{onData:d=>C.update(d.buffer),onError:d=>I(d),onEnd:()=>b(C.digest("base64").replace(/=+$/,""))})})}};L=de([Y(0,D.IFileService)],L),e.ChecksumService=L}),define(te[162],ne([0,1,245,127,150,14]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function i(d,m){const u={onUnknownOption:v=>{console.warn((0,_.localize)(0,null,v))},onMultipleValues:(v,g)=>{console.warn((0,_.localize)(1,null,v,g))},onDeprecatedOption:(v,g)=>{console.warn((0,_.localize)(2,null,v,g))}},S=(0,D.parseArgs)(d,D.OPTIONS,m?u:void 0);return S.goto&&S._.forEach(v=>T(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,_.localize)(3,null))),S["max-memory"]&&T(parseInt(S["max-memory"])>=L.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${L.MIN_MAX_MEMORY_SIZE_MB} MB.`),S}function R(d){const m=d.findIndex(u=>!/^-/.test(u));if(m>-1)return[...d.slice(0,m),...d.slice(m+1)]}function E(d){let[,...m]=d;process.env.VSCODE_DEV&&(m=R(m)||[]);const u=!C(process.env);return i(m,u)}e.parseMainProcessArgv=E;function b(d){const[,,...m]=d;return i(m,!0)}e.parseCLIProcessArgv=b;function I(d,...m){const u=d.indexOf("--");return u===-1?d.push(...m):d.splice(u,0,...m),d}e.addArg=I;function C(d){return d.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),define(te[163],ne([0,1,45,10,128,26,38,7,4,29,123,162,5]),function(J,e,T,_,D,L,i,R,E,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const m=1e4;let u;async function S(g,y,f){return y["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):E.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(f)&&!y["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(f)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=d.Promises.withAsyncBody(async(c,l)=>{const r=new L.CancellationTokenSource,a=setTimeout(()=>{r.dispose(!0),l(new Error((0,D.localize)(0,null)))},m);try{c(await v(g,r.token))}catch(n){!(0,R.isPromiseCanceledError)(n)&&!r.token.isCancellationRequested?l(new Error((0,D.localize)(1,null,(0,i.toErrorMessage)(n)))):c({})}finally{clearTimeout(a),r.dispose()}})),u)}e.getResolvedShellEnv=S;async function v(g,y){const f=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",f);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",c);const l=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(l+"(.*)"+l),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};g.trace("getUnixShellEnvironment#env",a);const n=await(0,I.getSystemShell)(E.OS,a);return g.trace("getUnixShellEnvironment#shell",n),new Promise((t,s)=>{if(y.isCancellationRequested)return s((0,R.canceled)());const o=(0,_.basename)(n);let h,p;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(h=`& '${process.execPath}' ${w} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,p=["-Login","-Command"]):(h=`'${process.execPath}' ${w} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,o==="tcsh"?p=["-ic"]:p=["-ilc"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(p),h);const P=(0,T.spawn)(n,[...p,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});y.onCancellationRequested(()=>(P.kill(),s((0,R.canceled)()))),P.on("error",q=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,i.toErrorMessage)(q)),s(q)});const M=[];P.stdout.on("data",q=>M.push(q));const O=[];P.stderr.on("data",q=>O.push(q)),P.on("close",(q,$)=>{const k=Buffer.concat(M).toString("utf8");g.trace("getUnixShellEnvironment#raw",k);const z=Buffer.concat(O).toString("utf8");if(z.trim()&&g.trace("getUnixShellEnvironment#stderr",z),q||$)return s(new Error((0,D.localize)(2,null,q,$)));const A=r.exec(k),F=A?A[1]:"{}";try{const x=JSON.parse(F);f?x.ELECTRON_RUN_AS_NODE=f:delete x.ELECTRON_RUN_AS_NODE,c?x.ELECTRON_NO_ATTACH_CONSOLE=c:delete x.ELECTRON_NO_ATTACH_CONSOLE,delete x.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",x),t(x)}catch(x){g.error("getUnixShellEnvironment#errorCaught",(0,i.toErrorMessage)(x)),s(x)}})})}}),define(te[82],ne([0,1,19,7,138,14]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function i(I,C,d,m,u,S){let v;try{await R(I,C,d,m,u,S)}catch(g){v=g}finally{v&&u.errorTransformer&&(v=u.errorTransformer(v)),typeof v!="undefined"&&d.error(v),d.end()}}e.readFileIntoStream=i;async function R(I,C,d,m,u,S){E(S);const v=await I.open(C,{create:!1});try{E(S);let g=0,y=0,f=u&&typeof u.length=="number"?u.length:void 0,c=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof f=="number"?f:u.bufferSize)),l=u&&typeof u.position=="number"?u.position:0,r=0;do y=await I.read(v,l,c.buffer,r,c.byteLength-r),l+=y,r+=y,g+=y,typeof f=="number"&&(f-=y),r===c.byteLength&&(await d.write(m(c)),c=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof f=="number"?f:u.bufferSize)),r=0);while(y>0&&(typeof f!="number"||f>0)&&E(S)&&b(g,u));if(r>0){let a=r;typeof f=="number"&&(a=Math.min(r,f)),d.write(m(c.slice(0,a)))}}catch(g){throw(0,L.ensureFileSystemProviderError)(g)}finally{await I.close(v)}}function E(I){if(I.isCancellationRequested)throw(0,_.canceled)();return!0}function b(I,C){if(C?.limits){if(typeof C.limits.memory=="number"&&I>C.limits.memory)throw(0,L.createFileSystemProviderError)((0,D.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&I>C.limits.size)throw(0,L.createFileSystemProviderError)((0,D.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[58],ne([0,1,2,4,8,14]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractRecursiveWatcherClient=void 0;class i extends T.Disposable{constructor(C,d,m){super();this.onFileChanges=C,this.onLogMessage=d,this.verboseLogging=m,this.watcherDisposables=this._register(new T.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const C=new T.DisposableStore;this.watcherDisposables.value=C,this.watcher=this.createWatcher(C),this.watcher.setVerboseLogging(this.verboseLogging),C.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),C.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),C.add(this.watcher.onDidError(d=>this.onError(d)))}onError(C){this.restartCounter<i.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${C}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${C}`)}restart(C){this.restartCounter++,this.init(),this.watch(C)}async watch(C){this.requests=C,await this.watcher?.watch(C)}async setVerboseLogging(C){this.verboseLogging=C,await this.watcher?.setVerboseLogging(C)}error(C){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${C}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractRecursiveWatcherClient=i,i.MAX_RESTARTS=5;function R(I){return I.map(C=>({type:C.type,resource:D.URI.file(C.path)}))}e.toFileChanges=R;function E(I){const C=new b;for(const d of I)C.processEvent(d);return C.coalesce()}e.coalesceEvents=E;class b{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(C){return _.isLinux?C.path:C.path.toLowerCase()}processEvent(C){const d=this.mapPathToChange.get(this.toKey(C));let m=!1;if(d){const u=d.type,S=C.type;d.path!==C.path&&C.type===2?m=!0:u===1&&S===2?(this.mapPathToChange.delete(this.toKey(C)),this.coalesced.delete(d)):u===2&&S===1?d.type=0:u===1&&S===0||(d.type=S)}else m=!0;m&&(this.coalesced.add(C),this.mapPathToChange.set(this.toKey(C),C))}coalesce(){const C=[],d=[];return Array.from(this.coalesced).filter(m=>m.type!==2?(C.push(m),!1):!0).sort((m,u)=>m.path.length-u.path.length).filter(m=>d.some(u=>(0,L.isParent)(m.path,u,!_.isLinux))?!1:(d.push(m.path),!0)).concat(C)}}}),define(te[164],ne([0,1,5,7,2,10,113,20,116,58]),function(J,e,T,_,D,L,i,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcher=void 0;class I extends D.Disposable{constructor(d,m,u,S){super();this.path=d,this.onDidFilesChange=m,this.onLogMessage=u,this.verboseLogging=S,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(E.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(d){this.verboseLogging=d}async startWatching(){try{const{stat:d,symbolicLink:m}=await R.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let u=this.path;if(m)try{u=await(0,i.realpath)(u)}catch(S){if(this.onError(S),m.dangling)return}d.isDirectory()?this._register((0,E.watchFolder)(u,(S,v)=>{this.onFileChange({type:S==="changed"?0:S==="added"?1:2,path:(0,L.join)(this.path,(0,L.basename)(v))})},S=>this.onError(S))):this._register((0,E.watchFile)(u,S=>{this.onFileChange({type:S==="changed"?0:2,path:this.path})},S=>this.onError(S)))}catch(d){d.code!=="ENOENT"&&this.onError(d)}}onFileChange(d){this.fileChangesBuffer.push(d),this.verboseLogging&&this.onVerbose(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const u=(0,b.coalesceEvents)(m);if(this.verboseLogging)for(const S of u)this.onVerbose(`>> normalized ${S.type===1?"[ADDED]":S.type===2?"[DELETED]":"[CHANGED]"} ${S.path}`);u.length>0&&this.onDidFilesChange(u)}).catch(m=>(0,_.onUnexpectedError)(m))}onError(d){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${d}`})}onVerbose(d){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.NodeJSFileWatcher=I}),define(te[165],ne([0,1,17,36,57,58]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcherClient=void 0;class i extends L.AbstractRecursiveWatcherClient{constructor(E,b,I){super(E,b,I);this.init()}createWatcher(E){const b=E.add(new D.Client(T.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(b.onDidProcessExit(({code:I,signal:C})=>this.onError(`terminated by itself with code ${I}, signal: ${C}`))),_.ProxyChannel.toService((0,_.getNextTickChannel)(b.getChannel("watcher")))}}e.ParcelWatcherClient=i}),define(te[83],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...D){this._entries=new Map;for(let[L,i]of D)this.set(L,i)}set(D,L){const i=this._entries.get(D);return this._entries.set(D,L),i}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=T}),define(te[166],ne([0,1,5,7,52,156,6,83]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const E=!1;class b extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class I{constructor(u=new R.ServiceCollection,S=!1,v){this._activeInstantiations=new Set,this._services=u,this._strict=S,this._parent=v,this._services.set(i.IInstantiationService,this)}createChild(u){return new I(u,this._strict,this)}invokeFunction(u,...S){let v=d.traceInvocation(u),g=!1;try{return u({get:f=>{if(g)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(f,v);if(!c)throw new Error(`[invokeFunction] unknown service '${f}'`);return c}},...S)}finally{g=!0,v.stop()}}createInstance(u,...S){let v,g;return u instanceof D.SyncDescriptor?(v=d.traceCreation(u.ctor),g=this._createInstance(u.ctor,u.staticArguments.concat(S),v)):(v=d.traceCreation(u),g=this._createInstance(u,S,v)),v.stop(),g}_createInstance(u,S=[],v){let g=i._util.getServiceDependencies(u).sort((c,l)=>c.index-l.index),y=[];for(const c of g){let l=this._getOrCreateServiceInstance(c.id,v);if(!l&&this._strict&&!c.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${c.id}.`);y.push(l)}let f=g.length>0?g[0].index:S.length;if(S.length!==f){console.warn(`[createInstance] First service dependency of ${u.name} at position ${f+1} conflicts with ${S.length} static arguments`);let c=f-S.length;c>0?S=S.concat(new Array(c)):S=S.slice(0,f)}return new u(...[...S,...y])}_setServiceInstance(u,S){if(this._services.get(u)instanceof D.SyncDescriptor)this._services.set(u,S);else if(this._parent)this._parent._setServiceInstance(u,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let S=this._services.get(u);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):S}_getOrCreateServiceInstance(u,S){let v=this._getServiceInstanceOrDescriptor(u);return v instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,v,S.branch(u,!0)):(S.branch(u,!1),v)}_safeCreateAndCacheServiceInstance(u,S,v){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,S,v)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,S,v){const g=new L.Graph(c=>c.id.toString());let y=0;const f=[{id:u,desc:S,_trace:v}];for(;f.length;){const c=f.pop();if(g.lookupOrInsertNode(c),y++>1e3)throw new b(g);for(let l of i._util.getServiceDependencies(c.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(l.id);if(!r&&!l.optional&&console.warn(`[createInstance] ${u} depends on ${l.id} which is NOT registered.`),r instanceof D.SyncDescriptor){const a={id:l.id,desc:r,_trace:c._trace.branch(l.id,!0)};g.insertEdge(c,a),f.push(a)}}}for(;;){const c=g.roots();if(c.length===0){if(!g.isEmpty())throw new b(g);break}for(const{data:l}of c){if(this._getServiceInstanceOrDescriptor(l.id)instanceof D.SyncDescriptor){const a=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,a)}g.removeNode(l)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,S,v=[],g,y){if(this._services.get(u)instanceof D.SyncDescriptor)return this._createServiceInstance(S,v,g,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,S,v,g,y);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(u,S=[],v,g){if(v){const y=new T.IdleValue(()=>this._createInstance(u,S,g));return new Proxy(Object.create(null),{get(f,c){if(c in f)return f[c];let l=y.value,r=l[c];return typeof r!="function"||(r=r.bind(l),f[c]=r),r},set(f,c,l){return y.value[c]=l,!0}})}else return this._createInstance(u,S,g)}}e.InstantiationService=I;var C;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(C||(C={}));class d{constructor(u,S){this.type=u,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return E?new d(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(u){return E?new d(0,u.name):d._None}branch(u,S){let v=new d(2,u.toString());return this._dep.push([u,S,v]),v}stop(){let u=Date.now()-this._start;d._totals+=u;let S=!1;function v(y,f){let c=[],l=new Array(y+1).join("	");for(const[r,a,n]of f._dep)if(a&&n){S=!0,c.push(`${l}CREATES -> ${r}`);let t=v(y+1,n);t&&c.push(t)}else c.push(`${l}uses -> ${r}`);return c.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(u>2||S)&&console.log(g.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(te[167],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class T{constructor(D,L){this.server=D,this.router=L}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,L){this.server.registerChannel(D,L)}}e.MessagePortMainProcessService=T}),define(te[168],ne([0,1,36,52,77,6]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class i{constructor(m,u,S){const v=S.getChannel(m);return R(u)?new u.channelClientCtor(v):T.ProxyChannel.toService(v,u?.proxyOptions)}}function R(d){return!!d?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let E=class extends i{constructor(m,u,S){super(m,u,S)}};E=de([Y(2,e.IMainProcessService)],E);function b(d,m,u){(0,D.registerSingleton)(d,new _.SyncDescriptor(E,[m,u],u?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let I=class extends i{constructor(m,u,S){super(m,u,S)}};I=de([Y(2,e.ISharedProcessService)],I);function C(d,m,u){(0,D.registerSingleton)(d,new _.SyncDescriptor(I,[m,u],u?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=C}),define(te[59],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,T.createDecorator)("localizationsService");function _(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const L of D.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}e.isValidLocalization=_}),define(te[169],ne([0,1,2,59]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends T.Disposable{constructor(i){super();this.localizationsService=i,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=de([Y(0,_.ILocalizationsService)],D),e.LocalizationsUpdater=D}),define(te[9],ne([0,1,38,3,2,4,6]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,i.createDecorator)("logService"),e.ILoggerService=(0,i.createDecorator)("loggerService");function R(){return new Date().toISOString()}var E;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function b(a,n,t){switch(n){case E.Trace:a.trace(t);break;case E.Debug:a.debug(t);break;case E.Info:a.info(t);break;case E.Warning:a.warn(t);break;case E.Error:a.error(t);break;case E.Critical:a.critical(t);break;default:throw new Error("Invalid log level")}}e.log=b;function I(a){let n="";for(let t=0;t<a.length;t++){let s=a[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch(o){}n+=(t>0?" ":"")+s}return n}e.format=I;class C extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class d extends C{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(E.Trace)&&this.log(E.Trace,I([n,...t]))}debug(n,...t){this.checkLogLevel(E.Debug)&&this.log(E.Debug,I([n,...t]))}info(n,...t){this.checkLogLevel(E.Info)&&this.log(E.Info,I([n,...t]))}warn(n,...t){this.checkLogLevel(E.Warning)&&this.log(E.Warning,I([n,...t]))}error(n,...t){if(this.checkLogLevel(E.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(E.Error,I(s))}else this.log(E.Error,I([n,...t]))}critical(n,...t){this.checkLogLevel(E.Critical)&&this.log(E.Critical,I([n,...t]))}flush(){}}e.AbstractMessageLogger=d;class m extends C{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!L.isWindows}trace(n,...t){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...t):console.log(`[main ${R()}]`,n,...t))}debug(n,...t){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...t):console.log(`[main ${R()}]`,n,...t))}info(n,...t){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...t):console.log(`[main ${R()}]`,n,...t))}warn(n,...t){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,n,...t):console.warn(`[main ${R()}]`,n,...t))}error(n,...t){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,n,...t):console.error(`[main ${R()}]`,n,...t))}critical(n,...t){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,n,...t):console.error(`[main ${R()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class u extends C{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=u;class S extends C{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,T.toErrorMessage)(n,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class v extends C{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const s of this.logServices)s.trace(n,...t)}debug(n,...t){for(const s of this.logServices)s.debug(n,...t)}info(n,...t){for(const s of this.logServices)s.info(n,...t)}warn(n,...t){for(const s of this.logServices)s.warn(n,...t)}error(n,...t){for(const s of this.logServices)s.error(n,...t)}critical(n,...t){for(const s of this.logServices)s.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=v;class g extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=g;class y extends D.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,t?.always?E.Trace:this.logLevel,t),this.loggers.set(n.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class f{constructor(){this.onDidChangeLogLevel=new _.Emitter().event}setLevel(n){}getLevel(){return E.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=f;function c(a){if(a.verbose)return E.Trace;if(typeof a.logLevel=="string"){const n=l(a.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function l(a){switch(a){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=l;function r(a){switch(a){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=r}),define(te[170],ne([0,1,5,7,2,10,20,13,9]),function(J,e,T,_,D,L,i,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends D.Disposable{constructor(C,d){super();this.environmentService=C,this.logService=d,this._register(new T.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,L.basename)(this.environmentService.logsPath),d=(0,L.dirname)(this.environmentService.logsPath),S=(await i.Promises.readdir(d)).filter(g=>/^\d{8}T\d{6}$/.test(g)).sort().filter(g=>g!==C),v=S.slice(0,Math.max(0,S.length-9));v.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${v.join(", ")}'`),await Promise.all(v.map(g=>i.Promises.rm((0,L.join)(d,g)))))}catch(C){(0,_.onUnexpectedError)(C)}}};b=de([Y(0,R.IEnvironmentService),Y(1,E.ILogService)],b),e.LogsDataCleaner=b}),define(te[171],ne([0,1,5,7,2,10,20,13,9]),function(J,e,T,_,D,L,i,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let b=class gt extends D.Disposable{constructor(C,d,m){super();this.backupWorkspacesPath=C,this.environmentService=d,this.logService=m,this._register(new T.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const C=await i.Promises.readFile(this.backupWorkspacesPath,"utf8"),m=JSON.parse(C).emptyWorkspaceInfos.map(S=>S.backupFolder),u=await i.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(u.map(async S=>{S.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||S===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||m.indexOf(S)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${S}.`),await i.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(C){(0,_.onUnexpectedError)(C)}}};b.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,b.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",b=de([Y(1,R.INativeEnvironmentService),Y(2,E.ILogService)],b),e.StorageDataCleaner=b}),define(te[84],ne([0,1,5,19,31,39,13,14,6,9]),function(J,e,T,_,D,L,i,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var I;(function(d){d.ERROR_INVALID_FILE="ERROR_INVALID_FILE",d.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(I=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,E.createDecorator)(e.UserConfigurationFileServiceId);let C=class{constructor(m,u,S){this.environmentService=m,this.fileService=u,this.logService=S,this.queue=new T.Queue}async updateSettings(m,u){return this.queue.queue(()=>this.doWrite(m,u))}async doWrite(m,u){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),m);const{value:S,mtime:v,etag:g}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let y=S.toString();const f=[];if((0,D.parse)(y,f,{allowTrailingComma:!0,allowEmptyContent:!0}),f.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(m,y,u)[0];if(c){y=y.substring(0,c.offset)+c.content+y.substring(c.offset+c.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,_.VSBuffer.fromString(y),{etag:g,mtime:v})}catch(l){if(l.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(m,u){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,m,u)})}getEdits({value:m,path:u},S,v){return u.length?(0,L.setProperty)(S,u,m,v):[{content:JSON.stringify(m,null,v.insertSpaces&&v.tabSize?" ".repeat(v.tabSize):"	"),length:S.length,offset:0}]}};C=de([Y(0,i.IEnvironmentService),Y(1,R.IFileService),Y(2,b.ILogService)],C),e.UserConfigurationFileService=C}),define(te[172],ne([0,1,45,5,38,3,2,17,10,20,13,9]),function(J,e,T,_,D,L,i,R,E,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends i.Disposable{constructor(u,S){super();this.environmentService=u,this.logService=S,this.processesLimiter=new _.Limiter(5)}async postUninstall(u){const S=this.parseScript(u,"uninstall");return S&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${v}`)))),b.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(u,S){const v=`vscode:${S}`;if(u.location.scheme===R.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[v]=="string"){const g=u.manifest.scripts[v].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${v} should be a node script`),null):{script:(0,E.join)(u.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(u,S,v,g,y){return new Promise((f,c)=>{const l=this.start(u,S,v,y);let r;const a=n=>{r&&(clearTimeout(r),r=null),n?c(n):f(void 0)};l.on("error",n=>{a((0,D.toErrorMessage)(n)||"Unknown")}),l.on("exit",(n,t)=>{a(n?`post-${S} process exited with code ${n}`:void 0)}),g&&(r=setTimeout(()=>{r=null,l.kill(),c("timed out")},5e3))})}start(u,S,v,g){const y={silent:!0,execArgv:void 0},f=(0,T.fork)(u,[`--type=extension-post-${S}`,...v],y);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const c=L.Event.fromNodeEventEmitter(f.stdout,"data"),l=L.Event.fromNodeEventEmitter(f.stderr,"data");c(n=>this.logService.info(g.identifier.id,g.manifest.version,`post-${S}`,n)),l(n=>this.logService.error(g.identifier.id,g.manifest.version,`post-${S}`,n));const r=L.Event.any(L.Event.map(c,n=>({data:`%c${n}`,format:[""]})),L.Event.map(l,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(r,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100)(n=>{console.group(g.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(u){return(0,E.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};d=de([Y(0,I.IEnvironmentService),Y(1,C.ILogService)],d),e.ExtensionsLifecycle=d}),define(te[173],ne([0,1,16,5,7,3,2,10,58,9]),function(J,e,T,_,D,L,i,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends i.Disposable{constructor(d){super();this.logService=d,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new _.ThrottledDelayer(0))}watch(d,m){return m.recursive?this.watchRecursive(d,m):this.watchNonRecursive(d)}watchRecursive(d,m){const u={path:this.toFilePath(d),excludes:m.excludes},S=(0,T.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,i.toDisposable)(()=>{S(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(d=>(0,D.onUnexpectedError)(d))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(d=>this._onDidChangeFile.fire((0,E.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(d,m){return d.watch(m)}watchNonRecursive(d){const m=this.createNonRecursiveWatcher(this.toFilePath(d),S=>this._onDidChangeFile.fire((0,E.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===b.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{m.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return(0,i.combinedDisposable)(m,u)}onWatcherLogMessage(d){d.type==="error"&&this._onDidWatchError.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,R.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(te[174],ne([0,1,16,5,19,26,3,54,2,40,17,175,18,50,136,14,82,9]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class Ke extends E.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new i.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new i.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new i.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new i.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new i.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new i.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new i.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new _.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new S.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new _.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new S.FileChangesEvent(l,!0)))),this.watchedResources=b.TernarySearchTree.forUris(l=>{const r=this.getProvider(l.scheme);return r?!this.isPathCaseSensitive(r):!1}),this.writeQueue=this._register(new _.ResourceQueue)}registerProvider(c,l){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:l});const r=new E.DisposableStore;return r.add(l.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(l)))),r.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:c}))),typeof l.onDidWatchError=="function"&&r.add(l.onDidWatchError(a=>this._onDidWatchError.fire(new Error(a)))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:l}),this.provider.delete(c),(0,E.dispose)(r)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(r){l.push(r)}}),!this.provider.has(c)&&await _.Promises.settled(l)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,l){const r=this.provider.get(c.scheme);return!!(r&&r.capabilities&l)}listCapabilities(){return R.Iterable.map(this.provider,([c,l])=>({scheme:c,capabilities:l.capabilities}))}async withProvider(c){if(!(0,d.isAbsolutePath)(c))throw new S.FileOperationError((0,u.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const l=this.provider.get(c.scheme);if(!l){const r=new Error;throw r.name="ENOPRO",r.message=(0,u.localize)(1,null,c.toString()),r}return l}async withReadProvider(c){const l=await this.withProvider(c);if((0,S.hasOpenReadWriteCloseCapability)(l)||(0,S.hasReadWriteCapability)(l)||(0,S.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const l=await this.withProvider(c);if((0,S.hasOpenReadWriteCloseCapability)(l)||(0,S.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,l){try{return await this.doResolveFile(c,l)}catch(r){throw(0,S.toFileSystemProviderErrorCode)(r)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,u.localize)(2,null,this.resourceForError(c)),1):(0,S.ensureFileSystemProviderError)(r)}}async doResolveFile(c,l){const r=await this.withProvider(c),a=this.isPathCaseSensitive(r),n=l?.resolveTo,t=l?.resolveSingleChildDescendants,s=l?.resolveMetadata,o=await r.stat(c);let h;return this.toFileStat(r,c,o,void 0,!!s,(p,w)=>(h||(h=b.TernarySearchTree.forUris(()=>!a),h.set(c,!0),n&&h.fill(!0,n)),h.get(p.resource)||h.findSuperstr(p.resource.with({query:null,fragment:null}))?!0:p.isDirectory&&t?w===1:!1))}async toFileStat(c,l,r,a,n,t){const{providerExtUri:s}=this.getExtUri(c),o={resource:l,name:s.basename(l),isFile:(r.type&S.FileType.File)!=0,isDirectory:(r.type&S.FileType.Directory)!=0,isSymbolicLink:(r.type&S.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&S.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,S.etag)({mtime:r.mtime,size:r.size})};if(o.isDirectory&&t(o,a)){try{const h=await c.readdir(l),p=await _.Promises.settled(h.map(async([w,P])=>{try{const M=s.joinPath(l,w),O=n?await c.stat(M):{type:P};return await this.toFileStat(c,M,O,h.length,n,t)}catch(M){return this.logService.trace(M),null}}));o.children=(0,T.coalesce)(p)}catch(h){this.logService.trace(h),o.children=[]}return o}return o}async resolveAll(c){return _.Promises.settled(c.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(c){const l=await this.withProvider(c);try{return!!await l.stat(c)}catch(r){return!1}}async canCreateFile(c,l){try{await this.doValidateCreateFile(c,l)}catch(r){return r}return!0}async doValidateCreateFile(c,l){if(!l?.overwrite&&await this.exists(c))throw new S.FileOperationError((0,u.localize)(3,null,this.resourceForError(c)),3,l)}async createFile(c,l=D.VSBuffer.fromString(""),r){await this.doValidateCreateFile(c,r);const a=await this.writeFile(c,l);return this._onDidRunOperation.fire(new S.FileOperationEvent(c,0,a)),a}async writeFile(c,l,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(a);try{await this.validateWriteFile(a,c,r)||await this.mkdirp(a,n.dirname(c));let s;if((0,S.hasReadWriteCapability)(a)&&!(l instanceof D.VSBuffer))if((0,m.isReadableStream)(l)){const o=await(0,m.peekStream)(l,3);o.ended?s=D.VSBuffer.concat(o.buffer):s=o}else s=(0,m.peekReadable)(l,o=>D.VSBuffer.concat(o),3);else s=l;!(0,S.hasOpenReadWriteCloseCapability)(a)||(0,S.hasReadWriteCapability)(a)&&s instanceof D.VSBuffer?await this.doWriteUnbuffered(a,c,r,s):await this.doWriteBuffered(a,c,r,s instanceof D.VSBuffer?(0,D.bufferToReadable)(s):s)}catch(t){throw new S.FileOperationError((0,u.localize)(4,null,this.resourceForError(c),(0,S.ensureFileSystemProviderError)(t).toString()),(0,S.toFileOperationResult)(t),r)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,l,r){if(!!r?.unlock&&!(c.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(l)));let n;try{n=await c.stat(l)}catch(t){return}if((n.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,u.localize)(6,null,this.resourceForError(l)),0,r);if(this.throwIfFileIsReadonly(l,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==S.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,S.etag)({mtime:r.mtime,size:n.size}))throw new S.FileOperationError((0,u.localize)(7,null),3,r);return n}async readFile(c,l){const r=await this.withReadProvider(c);return l?.atomic?this.doReadFileAtomic(r,c,l):this.doReadFile(r,c,l)}async doReadFileAtomic(c,l,r){return new Promise((a,n)=>{this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{try{const t=await this.doReadFile(c,l,r);a(t)}catch(t){n(t)}})})}async doReadFile(c,l,r){const a=await this.doReadFileStream(c,l,{...r,preferUnbuffered:!0});return{...a,value:await(0,D.streamToBuffer)(a.value)}}async readFileStream(c,l){const r=await this.withReadProvider(c);return this.doReadFileStream(r,c,l)}async doReadFileStream(c,l,r){const a=new L.CancellationTokenSource,n=this.validateReadFile(l,r).then(s=>s,s=>{throw a.cancel(),s});let t;try{return typeof r?.etag=="string"&&r.etag!==S.ETAG_DISABLED&&await n,!((0,S.hasOpenReadWriteCloseCapability)(c)||(0,S.hasFileReadStreamCapability)(c))||(0,S.hasReadWriteCapability)(c)&&r?.preferUnbuffered?t=this.readFileUnbuffered(c,l,r):(0,S.hasFileReadStreamCapability)(c)?t=this.readFileStreamed(c,l,a.token,r):t=this.readFileBuffered(c,l,a.token,r),{...await n,value:t}}catch(s){t&&await(0,m.consumeStream)(t);const o=(0,u.localize)(8,null,this.resourceForError(l),(0,S.ensureFileSystemProviderError)(s).toString());throw s instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(o,s.stat,r):new S.FileOperationError(o,(0,S.toFileOperationResult)(s),r)}}readFileStreamed(c,l,r,a=Object.create(null)){const n=c.readFileStream(l,a,r);return(0,m.transform)(n,{data:t=>t instanceof D.VSBuffer?t:D.VSBuffer.wrap(t),error:t=>new S.FileOperationError((0,u.localize)(9,null,this.resourceForError(l),(0,S.ensureFileSystemProviderError)(t).toString()),(0,S.toFileOperationResult)(t),a)},t=>D.VSBuffer.concat(t))}readFileBuffered(c,l,r,a=Object.create(null)){const n=(0,D.newWriteableBufferStream)();return(0,v.readFileIntoStream)(c,l,n,t=>t,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new S.FileOperationError((0,u.localize)(10,null,this.resourceForError(l),(0,S.ensureFileSystemProviderError)(t).toString()),(0,S.toFileOperationResult)(t),a)},r),n}readFileUnbuffered(c,l,r){const a=(0,m.newWriteableStream)(n=>D.VSBuffer.concat(n));return(async()=>{try{let n=await c.readFile(l);typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(l,n.byteLength,r),a.end(D.VSBuffer.wrap(n))}catch(n){a.error(n),a.end()}})(),a}async validateReadFile(c,l){const r=await this.resolve(c,{resolveMetadata:!0});if(r.isDirectory)throw new S.FileOperationError((0,u.localize)(11,null,this.resourceForError(c)),0,l);if(typeof l?.etag=="string"&&l.etag!==S.ETAG_DISABLED&&l.etag===r.etag)throw new S.NotModifiedSinceFileOperationError((0,u.localize)(12,null),r,l);return this.validateReadFileLimits(c,r.size,l),r}validateReadFileLimits(c,l,r){if(r?.limits){let a;if(typeof r.limits.memory=="number"&&l>r.limits.memory&&(a=9),typeof r.limits.size=="number"&&l>r.limits.size&&(a=7),typeof a=="number")throw new S.FileOperationError((0,u.localize)(13,null,this.resourceForError(c)),a)}}async canMove(c,l,r){return this.doCanMoveCopy(c,l,"move",r)}async canCopy(c,l,r){return this.doCanMoveCopy(c,l,"copy",r)}async doCanMoveCopy(c,l,r,a){if(c.toString()!==l.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(n,c,t,l,r,a)}catch(n){return n}return!0}async move(c,l,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(a,c,n,l,"move",!!r),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,t==="move"?2:3,s)),s}async copy(c,l,r){const a=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(a,c,n,l,"copy",!!r),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,t==="copy"?3:2,s)),s}async doMoveCopy(c,l,r,a,n,t){if(l.toString()===a.toString())return n;const{exists:s,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(c,l,r,a,n,t);if(s&&!o&&t&&await this.del(a,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(a)),n==="copy"){if(c===r&&(0,S.hasFileFolderCopyCapability)(c))await c.copy(l,a,{overwrite:t});else{const h=await this.resolve(l);h.isDirectory?await this.doCopyFolder(c,h,r,a):await this.doCopyFile(c,l,r,a)}return n}else return c===r?(await c.rename(l,a,{overwrite:t}),n):(await this.doMoveCopy(c,l,r,a,"copy",t),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(c,l,r,a){if((0,S.hasOpenReadWriteCloseCapability)(c)&&(0,S.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(c,l,r,a);if((0,S.hasOpenReadWriteCloseCapability)(c)&&(0,S.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(c,l,r,a);if((0,S.hasReadWriteCapability)(c)&&(0,S.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(c,l,r,a);if((0,S.hasReadWriteCapability)(c)&&(0,S.hasReadWriteCapability)(r))return this.doPipeUnbuffered(c,l,r,a)}async doCopyFolder(c,l,r,a){await r.mkdir(a),Array.isArray(l.children)&&await _.Promises.settled(l.children.map(async n=>{const t=this.getExtUri(r).providerExtUri.joinPath(a,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),r,t):this.doCopyFile(c,n.resource,r,t)}))}async doValidateMoveCopy(c,l,r,a,n,t){let s=!1;if(c===r){const{providerExtUri:h,isPathCaseSensitive:p}=this.getExtUri(c);if(p||(s=h.isEqual(l,a)),s&&n==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(l),this.resourceForError(a)));if(!s&&h.isEqualOrParent(a,l))throw new Error((0,u.localize)(15,null,this.resourceForError(l),this.resourceForError(a)))}const o=await this.exists(a);if(o&&!s){if(!t)throw new S.FileOperationError((0,u.localize)(16,null,this.resourceForError(l),this.resourceForError(a)),4);if(c===r){const{providerExtUri:h}=this.getExtUri(c);if(h.isEqualOrParent(l,a))throw new Error((0,u.localize)(17,null,this.resourceForError(l),this.resourceForError(a)))}}return{exists:o,isSameResourceWithDifferentPathCase:s}}getExtUri(c){const l=this.isPathCaseSensitive(c);return{providerExtUri:l?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(l,c);const r=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,0,r)),r}async mkdirp(c,l){const r=[],{providerExtUri:a}=this.getExtUri(c);for(;!a.isEqual(l,a.dirname(l));)try{if(((await c.stat(l)).type&S.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(l)));break}catch(n){if((0,S.toFileSystemProviderErrorCode)(n)!==S.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(a.basename(l)),l=a.dirname(l)}for(let n=r.length-1;n>=0;n--){l=a.joinPath(l,r[n]);try{await c.mkdir(l)}catch(t){if((0,S.toFileSystemProviderErrorCode)(t)!==S.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(c,l){try{await this.doValidateDelete(c,l)}catch(r){return r}return!0}async doValidateDelete(c,l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!l?.useTrash&&!(r.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(c)));let n;try{n=await r.stat(c)}catch(s){}if(n)this.throwIfFileIsReadonly(c,n);else throw new S.FileOperationError((0,u.localize)(20,null,this.resourceForError(c)),1);if(!!!l?.recursive){const s=await this.resolve(c);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(c)))}return r}async del(c,l){const r=await this.doValidateDelete(c,l),a=!!l?.useTrash,n=!!l?.recursive;await r.delete(c,{recursive:n,useTrash:a}),this._onDidRunOperation.fire(new S.FileOperationEvent(c,1))}onDidChangeFile(c,l){this._onDidChangeFilesRaw.fire({changes:c});let r,a;{for(const n of c)this.watchedResources.has(n.resource)?(r||(r=[]),r.push(n)):(a||(a=[]),a.push(n));r&&this._onDidFilesChange.fire(new S.FileChangesEvent(r,!l))}if(a){const n=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(a)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(c,l={recursive:!1,excludes:[]}){const r=new E.DisposableStore;let a=!1,n=()=>{a=!0};return r.add((0,E.toDisposable)(()=>n())),this.doWatch(c,l).then(t=>{a?(0,E.dispose)(t):n=()=>(0,E.dispose)(t)},t=>this.logService.error(t)),l.recursive||(this.watchedResources.set(c,(this.watchedResources.get(c)??0)+1),r.add((0,E.toDisposable)(()=>{const t=this.watchedResources.get(c);typeof t=="number"&&(t<=1?this.watchedResources.delete(c):this.watchedResources.set(c,t-1))}))),r}async doWatch(c,l){const r=await this.withProvider(c),a=this.toWatchKey(r,c,l);let n=this.activeWatchers.get(a);return n||(n={count:0,disposable:r.watch(c,l)},this.activeWatchers.set(a,n)),n.count+=1,(0,E.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,E.dispose)(n.disposable),this.activeWatchers.delete(a)))})}toWatchKey(c,l,r){const{providerExtUri:a}=this.getExtUri(c);return[a.getComparisonKey(l),String(r.recursive),r.excludes.join()].join()}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,E.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,l,r,a){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(l,{create:!0,unlock:r?.unlock??!1});try{(0,m.isReadableStream)(a)||(0,m.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(c,n,a):await this.doWriteReadableBufferedQueued(c,n,a)}catch(t){throw(0,S.ensureFileSystemProviderError)(t)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,l,r){let a=0,n;if((0,m.isReadableBufferedStream)(r)){if(r.buffer.length>0){const t=D.VSBuffer.concat(r.buffer);await this.doWriteBuffer(c,l,t,t.byteLength,a,0),a+=t.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((t,s)=>{(0,m.listenStream)(n,{onData:async o=>{n.pause();try{await this.doWriteBuffer(c,l,o,o.byteLength,a,0)}catch(h){return s(h)}a+=o.byteLength,setTimeout(()=>n.resume())},onError:o=>s(o),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(c,l,r){let a=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(c,l,n,n.byteLength,a,0),a+=n.byteLength}async doWriteBuffer(c,l,r,a,n,t){let s=0;for(;s<a;)s+=await c.write(l,n+s,r.buffer,t+s,a-s)}async doWriteUnbuffered(c,l,r,a){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,l,r,a))}async doWriteUnbufferedQueued(c,l,r,a){let n;a instanceof D.VSBuffer?n=a:(0,m.isReadableStream)(a)?n=await(0,D.streamToBuffer)(a):(0,m.isReadableBufferedStream)(a)?n=await(0,D.bufferedStreamToBuffer)(a):n=(0,D.readableToBuffer)(a),await c.writeFile(l,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(c,l,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,l,r,a))}async doPipeBufferedQueued(c,l,r,a){let n,t;try{n=await c.open(l,{create:!1}),t=await r.open(a,{create:!0,unlock:!1});const s=D.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,h=0,p=0;do p=await c.read(n,o,s.buffer,h,s.byteLength-h),await this.doWriteBuffer(r,t,s,p,o,h),o+=p,h+=p,h===s.byteLength&&(h=0);while(p>0)}catch(s){throw(0,S.ensureFileSystemProviderError)(s)}finally{await _.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof t=="number"?r.close(t):Promise.resolve()])}}async doPipeUnbuffered(c,l,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,l,r,a))}async doPipeUnbufferedQueued(c,l,r,a){return r.writeFile(a,await c.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,l,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,l,r,a))}async doPipeUnbufferedToBufferedQueued(c,l,r,a){const n=await r.open(a,{create:!0,unlock:!1});try{const t=await c.readFile(l);await this.doWriteBuffer(r,n,D.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,S.ensureFileSystemProviderError)(t)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(c,l,r,a){const n=await(0,D.streamToBuffer)(this.readFileBuffered(c,l,L.CancellationToken.None));await this.doWriteUnbuffered(r,a,void 0,n)}throwIfFileSystemIsReadonly(c,l){if(c.capabilities&2048)throw new S.FileOperationError((0,u.localize)(22,null,this.resourceForError(l)),6);return c}throwIfFileIsReadonly(c,l){if((l.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,u.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===I.Schemas.file?c.fsPath:c.toString(!0)}};y.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},y=de([Y(0,g.ILogService)],y),e.FileService=y}),define(te[176],ne([0,1,51,246,5,19,3,41,10,4,18,50,20,139,14,82,164,165,173,38]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v,g,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,_.gracefulify)(T)}catch(l){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(l)}`)}})();class c extends y.AbstractDiskFileSystemProvider{constructor(r,a){super(r);this.options=a,this.onDidChangeCapabilities=i.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:n}=await d.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,n),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await d.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),n=[];return await Promise.all(a.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,I.joinPath)(r,t.name))).type:s=this.toType(t),n.push([t.name,s])}catch(s){this.logService.trace(s)}})),n}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let n;return a?.dangling?n=u.FileType.Unknown:r.isFile()?n=u.FileType.File:r.isDirectory()?n=u.FileType.Directory:n=u.FileType.Unknown,a&&(n|=u.FileType.SymbolicLink),n}async readFile(r){try{const a=this.toFilePath(r);return await d.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,n){const t=(0,C.newWriteableStream)(s=>L.VSBuffer.concat(s.map(o=>L.VSBuffer.wrap(o))).buffer);return(0,S.readFileIntoStream)(this,r,t,s=>s.buffer,{...a,bufferSize:256*1024},n),t}async writeFile(r,a,n){let t;try{const s=this.toFilePath(r);if(!n.create||!n.overwrite){if(await d.Promises.exists(s)){if(!n.overwrite)throw(0,u.createFileSystemProviderError)((0,m.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,u.createFileSystemProviderError)((0,m.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}t=await this.open(r,{create:!0,unlock:n.unlock}),await this.write(t,0,a,0,a.byteLength)}catch(s){throw await this.toFileSystemProviderWriteError(r,s)}finally{typeof t=="number"&&await this.close(t)}}async open(r,a){try{const n=this.toFilePath(r);if((0,u.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:o}=await d.SymlinkSupport.stat(n);o.mode&128||await d.Promises.chmod(n,o.mode|128)}catch(o){this.logService.trace(o)}let t;if((0,u.isFileOpenForWriteOptions)(a)){if(b.isWindows)try{await d.Promises.truncate(n,0),t="r+"}catch(o){o.code!=="ENOENT"&&this.logService.trace(o)}t||(t="w")}else t="r";const s=await d.Promises.open(n,t);return this.mapHandleToPos.set(s,0),(0,u.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(s,r),s}catch(n){throw(0,u.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,n):this.toFileSystemProviderError(n)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await d.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await d.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,n,t,s){const o=this.normalizePos(r,a);let h=null;try{const p=await d.Promises.read(r,n,t,s,o);return typeof p=="number"?h=p:h=p.bytesRead,h}catch(p){throw this.toFileSystemProviderError(p)}finally{this.updatePos(r,o,h)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,n){const t=this.mapHandleToPos.get(r);typeof t=="number"&&(typeof a=="number"||(typeof n=="number"?this.mapHandleToPos.set(r,t+n):this.mapHandleToPos.delete(r)))}async write(r,a,n,t,s){return(0,D.retry)(()=>this.doWrite(r,a,n,t,s),100,3)}async doWrite(r,a,n,t,s){const o=this.normalizePos(r,a);let h=null;try{const p=await d.Promises.write(r,n,t,s,o);return typeof p=="number"?h=p:h=p.bytesWritten,h}catch(p){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),p)}finally{this.updatePos(r,o,h)}}async mkdir(r){try{await d.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const n=this.toFilePath(r);a.recursive?await d.Promises.rm(n,d.RimRafMode.MOVE):await d.Promises.unlink(n)}catch(n){throw this.toFileSystemProviderError(n)}}async rename(r,a,n){const t=this.toFilePath(r),s=this.toFilePath(a);if(t!==s)try{await this.validateTargetDeleted(r,a,"move",n.overwrite),await d.Promises.move(t,s)}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,m.localize)(2,null,(0,E.basename)(t),(0,E.basename)((0,E.dirname)(s)),o.toString()))),this.toFileSystemProviderError(o)}}async copy(r,a,n){const t=this.toFilePath(r),s=this.toFilePath(a);if(t!==s)try{await this.validateTargetDeleted(r,a,"copy",n.overwrite),await d.Promises.copy(t,s,{preserveSymlinks:!0})}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,m.localize)(3,null,(0,E.basename)(t),(0,E.basename)((0,E.dirname)(s)),o.toString()))),this.toFileSystemProviderError(o)}}async validateTargetDeleted(r,a,n,t){const s=this.toFilePath(r),o=this.toFilePath(a);let h=!1;if(!!(this.capabilities&1024)||(h=(0,R.isEqual)(s,o,!0)),h&&n==="copy")throw(0,u.createFileSystemProviderError)((0,m.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!h&&await d.Promises.exists(o)){if(!t)throw(0,u.createFileSystemProviderError)((0,m.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(r,a,n){return new g.ParcelWatcherClient(t=>r(t),t=>a(t),n)}doWatch(r,a){const n=this.options?.watcher?.usePolling;if(n===!0)for(const t of a)t.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(n))for(const t of a)n.includes(t.path)&&(t.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(r,a)}createNonRecursiveWatcher(r,a,n,t){return new v.NodeJSFileWatcher(r,s=>a(s),s=>n(s),t)}toFileSystemProviderError(r){if(r instanceof u.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=u.FileSystemProviderErrorCode.NoPermissions;break;default:a=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let n=this.toFileSystemProviderError(a);if(r&&n.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await d.SymlinkSupport.stat(this.toFilePath(r));t.mode&128||(n=(0,u.createFileSystemProviderError)(a,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.logService.trace(t)}return n}}e.DiskFileSystemProvider=c}),define(te[85],ne([0,1,3,8,9]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(d){this.service=d,this.onDidChangeLogLevel=T.Event.buffer(d.onDidChangeLogLevel,!0)}listen(d,m){switch(m){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${m}`)}async call(d,m,u){switch(m){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${m}`)}}e.LogLevelChannel=L;class i{constructor(d){this.channel=d}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(d){i.setLevel(this.channel,d)}static setLevel(d,m){return d.call("setLevel",m)}}e.LogLevelChannelClient=i;class R{constructor(d){this.loggerService=d,this.loggers=new Map}listen(d,m){throw new Error(`Event not found: ${m}`)}async call(d,m,u){switch(m){case"createLogger":this.createLogger(_.URI.revive(u[0]),u[1]);return;case"log":return this.log(_.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${m}`)}createLogger(d,m){this.loggers.set(d.toString(),this.loggerService.createLogger(d,m))}consoleLog(d,m){let u=console.log;switch(d){case D.LogLevel.Error:u=console.error;break;case D.LogLevel.Warning:u=console.warn;break;case D.LogLevel.Info:u=console.info;break}u.call(console,...m)}log(d,m){const u=this.loggers.get(d.toString());if(!u)throw new Error("Create the logger before logging");for(const[S,v]of m)(0,D.log)(u,S,v)}}e.LoggerChannel=R;class E extends D.AbstractLoggerService{constructor(d,m,u){super(d,m);this.channel=u}createConsoleMainLogger(){return new D.AdapterLogger({log:(d,m)=>{this.channel.call("consoleLog",[d,m])}})}doCreateLogger(d,m,u){return new b(this.channel,d,m,u)}}e.LoggerChannelClient=E;class b extends D.AbstractMessageLogger{constructor(d,m,u,S){super(S?.always);this.channel=d,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[m,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(d,m){const u=[[d,m]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(d){this.channel.call("log",[this.file,d])}}class I extends D.LogService{constructor(d,m){super(m);this.parent=d,this._register(d.onDidChangeLogLevel(u=>m.setLevel(u)))}setLevel(d){super.setLevel(d),this.parent.setLevel(d)}}e.FollowerLogService=I}),define(te[60],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,T.createDecorator)("nativeHostService")}),define(te[86],ne([0,1,17,4,32,18]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let i;if(typeof _.globals.vscode!="undefined"&&typeof _.globals.vscode.context!="undefined"){const R=_.globals.vscode.context.configuration();if(R)i=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const R=(0,L.dirname)(T.FileAccess.asFileUri("",J));i=J.__$__nodeRequire((0,L.joinPath)(R,"product.json").fsPath);const E=J.__$__nodeRequire((0,L.joinPath)(R,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(i,{nameShort:`${i.nameShort} Dev`,nameLong:`${i.nameLong} Dev`,dataFolderName:`${i.dataFolderName}-dev`}),Object.assign(i,{version:E.version})}else i={},Object.keys(i).length===0&&Object.assign(i,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=i}),define(te[27],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService")}),define(te[177],ne([0,1,5,7,2,10,20,9,27]),function(J,e,T,_,D,L,i,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends D.Disposable{constructor(C,d,m){super();this.productService=d,this.logService=m,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new T.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},30*1e3)).schedule()}async cleanUpCodeCaches(C){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const d=Date.now(),m=(0,L.dirname)(C),u=(0,L.basename)(C),S=await i.Promises.readdir(m);await Promise.all(S.map(async v=>{if(v===u)return;const g=(0,L.join)(m,v),y=await i.Promises.stat(g);if(y.isDirectory()&&d-y.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),i.Promises.rm(g)}))}catch(d){(0,_.onUnexpectedError)(d)}}};b=de([Y(1,E.IProductService),Y(2,R.ILogService)],b),e.CodeCacheCleaner=b}),define(te[178],ne([0,1,5,7,2,10,20,13,9,27]),function(J,e,T,_,D,L,i,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends D.Disposable{constructor(d,m,u){super();this.environmentService=d,this.logService=m,this.productService=u,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new T.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const d=Object.create(null),m=JSON.parse(await i.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let y of Object.keys(m)){const f=m[y];d[`${f.hash}.${y}`]=!0}const u=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await i.Promises.exists(u))return;const v=await i.Promises.readdir(u);for(const y of v){if(d[y]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${y}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${y}`),await i.Promises.rm((0,L.join)(u,y))}const g=Date.now();for(const y of Object.keys(d)){const f=(0,L.join)(u,y),c=await i.Promises.readdir(f);for(const l of c){if(l==="tcf.json")continue;const r=(0,L.join)(f,l),a=await i.Promises.stat(r);a.isDirectory()&&g-a.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(y,l)}`),await i.Promises.rm(r))}}}catch(d){(0,_.onUnexpectedError)(d)}}};I=de([Y(0,R.INativeEnvironmentService),Y(1,E.ILogService),Y(2,b.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(te[37],ne([0,1,99,15]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(i,R){T.ok(_.isString(i)),T.ok(_.isObject(R)),T.ok(!this.data.has(i),"There is already an extension with this id"),this.data.set(i,R)}knows(i){return this.data.has(i)}as(i){return this.data.get(i)||null}}e.Registry=new D}),define(te[87],ne([0,1,3,37]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class L{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,b){this.schemasById[D(E)]=b,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const i=new L;_.Registry.add(e.Extensions.JSONContribution,i)}),define(te[42],ne([0,1,16,3,15,125,87,37]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=R.Registry.as(i.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new _.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new _.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,r=!0){this.registerConfigurations([l],r)}registerConfigurations(l,r=!0){const a=this.doRegisterConfigurations(l,r);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(l){const r=this.doDeregisterConfigurations(l);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:l,remove:r}){const a=[];a.push(...this.doDeregisterConfigurations(r)),a.push(...this.doRegisterConfigurations(l,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,T.distinct)(a)})}registerDefaultConfigurations(l){const r=[],a=[];for(const{overrides:n,source:t}of l)for(const s in n)if(r.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const o={...this.configurationDefaultsOverrides.get(s)?.value||{},...n[s]};this.configurationDefaultsOverrides.set(s,{source:t,value:o});const h={type:"object",default:o,description:L.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:D.isString(t)?void 0:t};a.push(...u(s)),this.configurationProperties[s]=h,this.defaultLanguageConfigurationOverridesNode.properties[s]=h}else{this.configurationDefaultsOverrides.set(s,{value:n[s],source:t});const o=this.configurationProperties[s];o&&(this.updatePropertyDefaultValue(s,o),this.updateSchema(s,o))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const r=[];for(const{overrides:a,source:n}of l)for(const t in a){const s=this.configurationDefaultsOverrides.get(t),o=D.isString(n)?n:n?.id,h=D.isString(s?.source)?s?.source:s?.source?.id;if(o===h)if(r.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const p=this.configurationProperties[t];p&&(this.updatePropertyDefaultValue(t,p),this.updateSchema(t,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const r of l)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,r){const a=[];return l.forEach(n=>{a.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),a}doDeregisterConfigurations(l){const r=[],a=n=>{if(n.properties)for(const t in n.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>a(t))};for(const n of l){a(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(l,r=!0,a,n,t=3){t=D.isUndefinedOrNull(l.scope)?t:l.scope;let s=[],o=l.properties;if(o)for(let p in o){if(r&&y(p)){delete o[p];continue}const w=o[p];if(w.source=a,w.defaultDefaultValue=o[p].default,this.updatePropertyDefaultValue(p,w),e.OVERRIDE_PROPERTY_REGEX.test(p)?w.scope=void 0:(w.scope=D.isUndefinedOrNull(w.scope)?t:w.scope,w.restricted=D.isUndefinedOrNull(w.restricted)?!!n?.includes(p):w.restricted),o[p].hasOwnProperty("included")&&!o[p].included){this.excludedConfigurationProperties[p]=o[p],delete o[p];continue}else this.configurationProperties[p]=o[p];!o[p].deprecationMessage&&o[p].markdownDeprecationMessage&&(o[p].deprecationMessage=o[p].markdownDeprecationMessage),s.push(p)}let h=l.allOf;if(h)for(let p of h)s.push(...this.validateAndRegisterProperties(p,r,a,n,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const r=a=>{let n=a.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let t=a.allOf;t&&t.forEach(r)};r(l)}updateSchema(l,r){switch(e.allSettings.properties[l]=r,r.scope){case 1:e.applicationSettings.properties[l]=r;break;case 2:e.machineSettings.properties[l]=r;break;case 6:e.machineOverridableSettings.properties[l]=r;break;case 3:e.windowSettings.properties[l]=r;break;case 4:e.resourceSettings.properties[l]=r;break;case 5:e.resourceSettings.properties[l]=r,this.resourceLanguageSettingsSchema.properties[l]=r;break}}removeFromSchema(l,r){switch(delete e.allSettings.properties[l],r.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const r=`[${l}]`,a={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,r){const a=this.configurationDefaultsOverrides.get(l);let n=a?.value,t=a?.source;D.isUndefined(n)&&(n=r.defaultDefaultValue,t=void 0),D.isUndefined(n)&&(n=v(r.type)),r.default=n,r.defaultValueSource=t}}const d="\\[([^\\]]+)\\]",m=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function u(c){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let r=m.exec(c);for(;r?.length;){const a=r[1].trim();a&&l.push(a),r=m.exec(c)}}return(0,T.distinct)(l)}e.overrideIdentifiersFromKey=u;function S(c){return c.reduce((l,r)=>`${l}[${r}]`,"")}e.keyFromOverrideIdentifiers=S;function v(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const g=new C;R.Registry.add(e.Extensions.Configuration,g);function y(c){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?L.localize(7,null,c):g.getConfigurationProperties()[c]!==void 0?L.localize(8,null,c):null:L.localize(6,null)}e.validateProperty=y;function f(){const c=[],l=g.getConfigurationProperties();for(const r of Object.keys(l))c.push([r,l[r].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=f}),define(te[88],ne([0,1,16,3,31,2,40,28,15,8,21,42,37]),function(J,e,T,_,D,L,i,R,E,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(n={},t=[],s=[]){this._contents=n,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const s=this.getContentsForOverrideIdentifer(t);return s?n?(0,I.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const s of this.overrides)s.identifiers.includes(n)&&t.push(...s.keys);return T.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return T.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=R.deepClone(this.contents),s=R.deepClone(this.overrides),o=[...this.keys];for(const h of n){this.mergeContents(t,h.contents);for(const p of h.overrides){const[w]=s.filter(P=>T.equals(P.identifiers,p.identifiers));w?(this.mergeContents(w.contents,p.contents),w.keys.push(...p.keys),w.keys=T.distinct(w.keys)):s.push(R.deepClone(p))}for(const p of h.keys)o.indexOf(p)===-1&&o.push(p)}return new m(t,o,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const o of T.distinct([...Object.keys(this.contents),...Object.keys(t)])){let h=this.contents[o],p=t[o];p&&(typeof h=="object"&&typeof p=="object"?(h=R.deepClone(h),this.mergeContents(h,p)):h=p),s[o]=h}return new m(s,this.keys,this.overrides)}mergeContents(n,t){for(const s of Object.keys(t)){if(s in n&&E.isObject(n[s])&&E.isObject(t[s])){this.mergeContents(n[s],t[s]);continue}n[s]=R.deepClone(t[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?R.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,s=null;const o=h=>{h&&(s?this.mergeContents(s,h):s=R.deepClone(h))};for(const h of this.overrides)T.equals(h.identifiers,[n])?t=h.contents:h.identifiers.includes(n)&&o(h.contents);return o(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,I.addToValueTree)(this.contents,n,t,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,I.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let s=0;s<t;s++)n.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=m;class u extends m{constructor(n={}){const t=d.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(t),o=Object.create(null),h=[];for(const p in t){const w=n[p],P=w!==void 0?w:t[p].default;(0,I.addToValueTree)(o,p,P,M=>console.error(`Conflict in default settings: ${M}`))}for(const p of Object.keys(o))C.OVERRIDE_PROPERTY_REGEX.test(p)&&h.push({identifiers:(0,C.overrideIdentifiersFromKey)(p),keys:Object.keys(o[p]),contents:(0,I.toValuesTree)(o[p],w=>console.error(`Conflict in default settings file: ${w}`))});super(o,s,h)}}e.DefaultConfigurationModel=u;class S{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!E.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:s,keys:o,overrides:h,restricted:p}=this.doParseRaw(n,t);this._configurationModel=new m(s,o,h),this._restrictedConfigurations=p||[]}doParseContent(n){let t={},s=null,o=[],h=[],p=[];function w(M){Array.isArray(o)?o.push(M):s!==null&&(o[s]=M)}let P={onObjectBegin:()=>{let M={};w(M),h.push(o),o=M,s=null},onObjectProperty:M=>{s=M},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{let M=[];w(M),h.push(o),o=M,s=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:w,onError:(M,O,q)=>{p.push({error:M,offset:O,length:q})}};if(n)try{D.visit(n,P),t=o[0]||{}}catch(M){console.error(`Error while parsing settings file ${this._name}: ${M}`),this._parseErrors=[M]}return t}doParseRaw(n,t){const s=d.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,s,!0,t);n=o.raw;const h=(0,I.toValuesTree)(n,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),p=Object.keys(n),w=this.toOverrides(n,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:h,keys:p,overrides:w,restricted:o.restricted}}filter(n,t,s,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[]};const h={},p=[];for(let w in n)if(C.OVERRIDE_PROPERTY_REGEX.test(w)&&s){const P=this.filter(n[w],t,!1,o);h[w]=P.raw,p.push(...P.restricted)}else{const P=t[w],M=P?typeof P.scope!="undefined"?P.scope:3:void 0;P?.restricted&&p.push(w),(M===void 0||o.scopes===void 0||o.scopes.includes(M))&&(o.skipRestricted&&P?.restricted||(h[w]=n[w]))}return{raw:h,restricted:p}}toOverrides(n,t){const s=[];for(const o of Object.keys(n))if(C.OVERRIDE_PROPERTY_REGEX.test(o)){const h={};for(const p in n[o])h[p]=n[o][p];s.push({identifiers:(0,C.overrideIdentifiersFromKey)(o),keys:Object.keys(h),contents:(0,I.toValuesTree)(h,t)})}return s}}e.ConfigurationModelParser=S;class v extends L.Disposable{constructor(n,t,s,o){super();this.userSettingsResource=n,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new _.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(_.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class g{constructor(n,t,s=new m,o=new m,h=new i.ResourceMap,p=new m,w=new i.ResourceMap,P=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=h,this._memoryConfiguration=p,this._memoryConfigurationByResource=w,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new i.ResourceMap,this._userConfiguration=null}getValue(n,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(n)}updateValue(n,t,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new m,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(n):o.setValue(n,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,s){const o=this.getConsolidateConfigurationModel(t,s),h=this.getFolderConfigurationModelForResource(t.resource,s),p=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,w=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),P=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),M=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),O=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),q=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,$=h?t.overrideIdentifier?h.freeze().override(t.overrideIdentifier).getValue(n):h.freeze().getValue(n):void 0,k=t.overrideIdentifier?p.override(t.overrideIdentifier).getValue(n):p.getValue(n),z=o.getValue(n),A=T.distinct(T.flatten(o.overrides.map(F=>F.identifiers))).filter(F=>o.getOverrideValue(n,F)!==void 0);return{defaultValue:w,userValue:P,userLocalValue:M,userRemoteValue:O,workspaceValue:q,workspaceFolderValue:$,memoryValue:k,value:z,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:M!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:h?.freeze().getValue(n),override:t.overrideIdentifier?h?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:k!==void 0?{value:p.getValue(n),override:t.overrideIdentifier?p.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:A.length?A:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const s=[];if(!t){const{added:o,updated:h,removed:p}=l(this._defaultConfiguration,n);t=[...o,...h,...p]}for(const o of t)for(const h of(0,C.overrideIdentifiersFromKey)(o)){const p=this._defaultConfiguration.getKeysForOverrideIdentifier(h),w=n.getKeysForOverrideIdentifier(h),P=[...w.filter(M=>p.indexOf(M)===-1),...p.filter(M=>w.indexOf(M)===-1),...p.filter(M=>!R.equals(this._defaultConfiguration.override(h).getValue(M),n.override(h).getValue(M)))];s.push([h,P])}return this.updateDefaultConfiguration(n),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:s,removed:o,overrides:h}=l(this.localUserConfiguration,n),p=[...t,...s,...o];return p.length&&this.updateLocalUserConfiguration(n),{keys:p,overrides:h}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:s,removed:o,overrides:h}=l(this.remoteUserConfiguration,n);let p=[...t,...s,...o];return p.length&&this.updateRemoteUserConfiguration(n),{keys:p,overrides:h}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:s,removed:o,overrides:h}=l(this.workspaceConfiguration,n);let p=[...t,...s,...o];return p.length&&this.updateWorkspaceConfiguration(n),{keys:p,overrides:h}}compareAndUpdateFolderConfiguration(n,t){const s=this.folderConfigurations.get(n),{added:o,updated:h,removed:p,overrides:w}=l(s,t);let P=[...o,...h,...p];return(P.length||!s)&&this.updateFolderConfiguration(n,t),{keys:P,overrides:w}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:o,removed:h,overrides:p}=l(t,void 0);return{keys:[...s,...o,...h],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let s=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const o=t.getFolder(n);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const h=this._memoryConfigurationByResource.get(n);h&&(s=s.merge(h))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(t=s.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=s}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const s=t.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:s,overrides:o,keys:h}=this._folderConfigurations.get(t);return n.push([t,{contents:s,overrides:o,keys:h}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),o=this.parseConfigurationModel(n.workspace),h=n.folders.reduce((p,w)=>(p.set(b.URI.revive(w[0]),this.parseConfigurationModel(w[1])),p),new i.ResourceMap);return new g(t,s,new m,o,h,new m,new i.ResourceMap,!1)}static parseConfigurationModel(n){return new m(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=g;function y(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,t=new Map;for(const o of a)o.keys.forEach(h=>n.add(h)),o.overrides.forEach(([h,p])=>{const w=(0,i.getOrSet)(t,h,new Set);p.forEach(P=>w.add(P))});const s=[];return t.forEach((o,h)=>s.push([h,[...o.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=y;class f{constructor(n,t,s,o){this.change=n,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const h=new Set;n.keys.forEach(w=>h.add(w)),n.overrides.forEach(([,w])=>w.forEach(P=>h.add(P))),this.affectedKeys=[...h.values()];const p=new m;this.affectedKeys.forEach(w=>p.setValue(w,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!R.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let s=(0,I.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(n=n[o],!n)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=f;class c extends f{constructor(n,t,s,o){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=c;function l(a,n){const{added:t,removed:s,updated:o}=r(n,a),h=[],p=a?.getAllOverrideIdentifiers()||[],w=n?.getAllOverrideIdentifiers()||[];if(n){const P=w.filter(M=>!p.includes(M));for(const M of P)h.push([M,n.getKeysForOverrideIdentifier(M)])}if(a){const P=p.filter(M=>!w.includes(M));for(const M of P)h.push([M,a.getKeysForOverrideIdentifier(M)])}if(n&&a){for(const P of p)if(w.includes(P)){const M=r({contents:a.getOverrideValue(void 0,P)||{},keys:a.getKeysForOverrideIdentifier(P)},{contents:n.getOverrideValue(void 0,P)||{},keys:n.getKeysForOverrideIdentifier(P)});h.push([P,[...M.added,...M.removed,...M.updated]])}}return{added:t,removed:s,updated:o,overrides:h}}function r(a,n){const t=a?n?a.keys.filter(h=>n.keys.indexOf(h)===-1):[...a.keys]:[],s=n?a?n.keys.filter(h=>a.keys.indexOf(h)===-1):[...n.keys]:[],o=[];if(a&&n){for(const h of n.keys)if(a.keys.indexOf(h)!==-1){const p=(0,I.getConfigurationValue)(n.contents,h),w=(0,I.getConfigurationValue)(a.contents,h);R.equals(p,w)||o.push(h)}}return{added:t,removed:s,updated:o}}}),define(te[179],ne([0,1,5,3,2,18,21,88,42,37]),function(J,e,T,_,D,L,i,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends D.Disposable{constructor(d,m){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new _.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,m)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(E.Extensions.Configuration).onDidUpdateConfiguration(({properties:u})=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,m){const u=typeof d=="string"?d:void 0,S=(0,i.isConfigurationOverrides)(d)?d:(0,i.isConfigurationOverrides)(m)?m:{};return this.configuration.getValue(u,S,void 0)}updateValue(d,m,u,S){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const m=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(u,m,1)}onDidDefaultConfigurationChange(d){const m=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,d);this.trigger(u,m,6)}trigger(d,m,u){const S=new R.ConfigurationChangeEvent(d,{data:m},this.configuration);S.source=u,S.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(te[180],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var _;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound"})(_=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(i,R=_.Unknown,E){super(i);this._message=i,this._code=R,this._detail=E,this.isHandled=R===_.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(i){return i instanceof D&&i._code===_.TemporarilyNotAvailable}static isNoResolverFound(i){return i instanceof D&&i._code===_.NoResolverFound}static isHandled(i){return i instanceof D&&i.isHandled}}e.RemoteAuthorityResolverError=D}),define(te[181],ne([0,1,5,19,26,7,3,2,29,71,180]),function(J,e,T,_,D,L,i,R,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var d;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(d=e.ConnectionType||(e.ConnectionType={}));function m(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(U){const N=new D.CancellationTokenSource;return setTimeout(()=>N.cancel(),U),N.token}function S(U,N){if(U.isCancellationRequested||N.isCancellationRequested)return D.CancellationToken.Cancelled;const W=new D.CancellationTokenSource;return U.onCancellationRequested(()=>W.cancel()),N.onCancellationRequested(()=>W.cancel()),W.token}class v{constructor(N){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((W,V)=>{this._resolvePromise=W,this._rejectPromise=V}),N.isCancellationRequested?this._timeout():this._disposables.add(N.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(N){this._state==="pending"?this._disposables.add(N):N.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const N=new Error("Time limit reached");return N.code="ETIMEDOUT",N.syscall="connect",N}resolve(N){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(N))}reject(N){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(N))}}function g(U,N){const W=new v(N);return W.registerDisposable(U.onControlMessage(V=>{const G=JSON.parse(V.toString()),ee=x(G);ee?W.reject(ee):W.resolve(G)})),W.promise}function y(U,N,W,V,G,ee,H){const Q=new v(H);return N.connect(W,V,G,ee,(re,oe)=>{Q.didTimeout?(re&&U.error(re),oe?.dispose()):re||!oe?Q.reject(re):Q.resolve(oe)}),Q.promise}function f(U,N){const W=new v(N);return U.then(V=>{W.didTimeout||W.resolve(V)},V=>{W.didTimeout||W.reject(V)}),W.promise}async function c(U,N,W,V){const G=j(U,N);U.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let ee;try{ee=await y(U.logService,U.socketFactory,U.host,U.port,`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,`renderer-${m(N)}-${U.reconnectionToken}`,V)}catch(ce){throw U.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),U.logService.error(ce),ce}U.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let H,Q;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(ee,null),H=U.reconnectionProtocol,Q=!1):(H=new b.PersistentProtocol(ee,null),Q=!0),U.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const re=await f(U.signService.createNewMessage((0,E.generateUuid)()),V),oe={type:"auth",auth:U.connectionToken||"00000000000000000000",data:re.data};H.sendControl(_.VSBuffer.fromString(JSON.stringify(oe)));try{const ce=await g(H,S(V,u(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(U.logService.trace(`${G} 4/6. received SignRequest control message.`),!await f(U.signService.validate(re,ce.signedData),V)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const be=await f(U.signService.sign(ce.data),V),Ie={type:"connectionType",commit:U.commit,signedData:be,desiredConnectionType:N};return W&&(Ie.args=W),U.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(_.VSBuffer.fromString(JSON.stringify(Ie))),{protocol:H,ownsProtocol:Q}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(U.logService.error(`${G} the handshake timed out. Error:`),U.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${G} received error control message when negotiating connection. Error:`),U.logService.error(ce)),Q&&F(H),ce}}async function l(U,N,W,V){const G=Date.now(),ee=j(U,N),{protocol:H,ownsProtocol:Q}=await c(U,N,W,V),re=new v(V);return re.registerDisposable(H.onControlMessage(oe=>{const ce=JSON.parse(oe.toString()),he=x(ce);he?(U.logService.error(`${ee} received error control message when negotiating connection. Error:`),U.logService.error(he),Q&&F(H),re.reject(he)):(U.reconnectionProtocol&&U.reconnectionProtocol.endAcceptReconnection(),U.logService.trace(`${ee} 6/6. handshake finished, connection is up and running after ${X(G)}!`),re.resolve({protocol:H,firstMessage:ce}))})),re.promise}async function r(U,N){const{protocol:W}=await l(U,1,void 0,N);return{protocol:W}}async function a(U,N,W){const{protocol:V,firstMessage:G}=await l(U,2,N,W),ee=G&&G.debugPort;return{protocol:V,debugPort:ee}}async function n(U,N,W){const V=Date.now(),G=j(U,3),{protocol:ee}=await c(U,3,N,W);return U.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${X(V)}!`),ee}async function t(U,N,W){const{host:V,port:G,connectionToken:ee}=await U.addressProvider.getAddress();return{commit:U.commit,host:V,port:G,connectionToken:ee,reconnectionToken:N,reconnectionProtocol:W,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function s(U,N,W){try{const V=(0,E.generateUuid)(),G=await t(U,V,null),{protocol:ee}=await r(G,D.CancellationToken.None);return new z(U,N,W,V,ee)}catch(V){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(V),k.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(V)),V}}e.connectRemoteAgentManagement=s;async function o(U,N){try{const W=(0,E.generateUuid)(),V=await t(U,W,null),{protocol:G,debugPort:ee}=await a(V,N,D.CancellationToken.None);return new A(U,N,W,G,ee)}catch(W){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(W),k.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentExtensionHost=o;async function h(U,N,W){const V=await t(U,(0,E.generateUuid)(),null);return await n(V,{host:N,port:W},D.CancellationToken.None)}e.connectRemoteAgentTunnel=h;function p(U){return(0,T.createCancelablePromise)(N=>new Promise((W,V)=>{const G=setTimeout(W,U*1e3);N.onCancellationRequested(()=>{clearTimeout(G),W()})}))}var w;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(w=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class P{constructor(N,W){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=P;class M{constructor(N,W,V,G){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.durationSeconds=V,this.cancellableTimer=G,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=M;class O{constructor(N,W,V){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.attempt=V,this.type=2}}e.ReconnectionRunningEvent=O;class q{constructor(N,W,V){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.attempt=V,this.type=4}}e.ConnectionGainEvent=q;class ${constructor(N,W,V,G){this.reconnectionToken=N,this.millisSinceLastIncomingData=W,this.attempt=V,this.handled=G,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class k extends R.Disposable{constructor(N,W,V,G){super();this._connectionType=N,this._onDidStateChange=this._register(new i.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=W,this.reconnectionToken=V,this.protocol=G,this._isReconnecting=!1,this._onDidStateChange.fire(new q(this.reconnectionToken,0,0)),this._register(G.onSocketClose(ee=>{const H=B(this._connectionType,this.reconnectionToken,!0);ee?ee.type===0?(this._options.logService.info(`${H} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this._options.logService.error(ee.error)):(this._options.logService.info(`${H} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this._options.logService.error(ee.event)):this._options.logService.info(`${H} received socket close event.`),this._beginReconnecting()})),this._register(G.onSocketTimeout(()=>{const ee=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ee} received socket timeout event.`),this._beginReconnecting()})),k._instances.push(this),k._permanentFailure&&this._gotoPermanentFailure(k._permanentFailureMillisSinceLastIncomingData,k._permanentFailureAttempt,k._permanentFailureHandled)}static triggerPermanentFailure(N,W,V){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=N,this._permanentFailureAttempt=W,this._permanentFailureHandled=V,this._instances.forEach(G=>G._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(N=>N._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(N=>N._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(k._permanentFailure)return;const N=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${N} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new P(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let V=-1;do{V++;const G=V<W.length?W[V]:W[W.length-1];try{if(G>0){const H=p(G);this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G,H)),this._options.logService.info(`${N} waiting for ${G} seconds before reconnecting...`);try{await H}catch{}}if(k._permanentFailure){this._options.logService.error(`${N} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1)),this._options.logService.info(`${N} resolving connection...`);const ee=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${N} connecting to ${ee.host}:${ee.port}...`),await this._reconnect(ee,u(C)),this._options.logService.info(`${N} reconnected!`),this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${N} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(ee),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(V>360){this._options.logService.error(`${N} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(ee),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ee)){this._options.logService.info(`${N} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this._options.logService.info(`${N} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((0,L.isPromiseCanceledError)(ee)){this._options.logService.info(`${N} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if(ee instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${N} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(ee),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),V+1,I.RemoteAuthorityResolverError.isHandled(ee));break}this._options.logService.error(`${N} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(ee),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}}while(!k._permanentFailure)}_gotoPermanentFailure(N,W,V){this._onDidStateChange.fire(new $(this.reconnectionToken,N,W,V)),F(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=k,k._permanentFailure=!1,k._permanentFailureMillisSinceLastIncomingData=0,k._permanentFailureAttempt=0,k._permanentFailureHandled=!1,k._instances=[];class z extends k{constructor(N,W,V,G,ee){super(1,N,G,ee);this.client=this._register(new b.Client(ee,{remoteAuthority:W,clientId:V},N.ipcLogger))}async _reconnect(N,W){await r(N,W)}}e.ManagementPersistentConnection=z;class A extends k{constructor(N,W,V,G,ee){super(2,N,V,G);this._startArguments=W,this.debugPort=ee}async _reconnect(N,W){await a(N,this._startArguments,W)}}e.ExtensionHostPersistentConnection=A;function F(U){try{U.acceptDisconnect();const N=U.getSocket();U.dispose(),N.dispose()}catch(N){(0,L.onUnexpectedError)(N)}}function x(U){if(U&&U.type==="error"){const N=new Error(`Connection error: ${U.reason}`);return N.code="VSCODE_CONNECTION_ERROR",N}return null}function Z(U,N){for(;U.length<N;)U+=" ";return U}function B(U,N,W){return`[remote-connection][${Z(m(U),13)}][${N.substr(0,5)}\u2026][${W?"reconnect":"initial"}]`}function j(U,N){return`${B(N,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function X(U){return`${Date.now()-U} ms`}}),define(te[182],ne([0,1,17]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function _(b){return b.scheme===T.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=_;function D(b){if(!b)return;const I=b.indexOf("+");return I<0?b:b.substr(0,I)}e.getRemoteName=D;function L(b){return b.scheme!==T.Schemas.file&&b.scheme!==T.Schemas.vscodeRemote}e.isVirtualResource=L;function i(b){if(b.folders.length)return b.folders.every(I=>L(I.uri))?b.folders[0].uri:void 0;if(b.configuration&&L(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=i;function R(b){return i(b)?.scheme}e.getVirtualWorkspaceScheme=R;function E(b){return i(b)!==void 0}e.isVirtualWorkspace=E}),define(te[89],ne([0,1,25,6,182]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=L;function i(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=i,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class E{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,u){if(typeof m=="undefined"||m===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof m=="string"||typeof u=="string"){let S=typeof m=="string"?m:m.value,v=typeof u=="string"?u:u.value;return T.equalsIgnoreCase(S,v)}return m._lower===u._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=E;function b(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function I(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function C(d,m){if(m){const u=`onResolveRemoteAuthority:${(0,D.getRemoteName)(m)}`;return d.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,_.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[34],ne([0,1,25,89]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(u,S){return u.uuid&&S.uuid?u.uuid===S.uuid:u.id===S.id?!0:(0,T.compareIgnoreCase)(u.id,S.id)===0}e.areSameExtensions=D;class L{constructor(S,v){this.version=v,this.id=S.id,this.uuid=S.uuid}key(){return`${this.id}-${this.version}`}equals(S){return S instanceof L?D(this,S)&&this.version===S.version:!1}}e.ExtensionIdentifierWithVersion=L;function i(u,S){return`${u}.${S}`}e.getExtensionId=i;function R(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function E(u,S){return R(i(u,S))}e.getGalleryExtensionId=E;function b(u,S){const v=[],g=y=>{for(const f of v)if(f.some(c=>D(S(c),S(y))))return f;return null};for(const y of u){const f=g(y);f?f.push(y):v.push([y])}return v}e.groupByExtension=b;function I(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=I;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new _.ExtensionIdentifier("pprice.better-merge");function d(u){const S=new Set;if(u.malicious)for(const v of u.malicious)S.add(v.id);return S}e.getMaliciousExtensionsSet=d;function m(u,S){const v=[],g=S.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const y=g.shift();if(y&&v.every(f=>!D(f.identifier,{id:y}))){const f=u.filter(c=>D(c.identifier,{id:y}));f.length===1&&(v.push(f[0]),g.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=m}),define(te[183],ne([0,1,5,7,2,4,18,61,8,29,20,13,30,34,14,9]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let g=class extends D.Disposable{constructor(f,c,l,r){super();this.fileService=c,this.extensionGalleryService=l,this.logService=r,this.extensionsDownloadDir=E.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,c){await this.cleanUpPromise;const l=this.getName(f),r=(0,i.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(r)){const a=(0,i.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(a)||await this.extensionGalleryService.download(f,a,c);try{await this.rename(a,r,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(a)}catch(t){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,_.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,a.path),n}}return r}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,c,l){try{await I.Promises.rename(f.fsPath,c.fsPath)}catch(r){if(L.isWindows&&r&&r.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${f} to ${c} with 'EPERM' error. Trying again...`),this.rename(f,c,l);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const c=[],l=[];for(const n of f.children){const t=this.parse(n.name);t&&l.push([t,n])}const r=(0,m.groupByExtension)(l,([n])=>n),a=[];for(const n of r)n.sort((t,s)=>R.rcompare(t[0].version,s[0].version)),c.push(...n.slice(1).map(t=>t[1].resource)),a.push(n[0][1]);a.sort((n,t)=>n.mtime-t.mtime),c.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(n=>n.resource)),await T.Promises.settled(c.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?`${new m.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase()}${f.properties.targetPlatform!=="undefined"?`-${f.properties.targetPlatform}`:""}`:(0,b.generateUuid)()}parse(f){const c=v.exec(f);return c&&c[1]&&c[2]?new m.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};g=de([Y(0,C.INativeEnvironmentService),Y(1,u.IFileService),Y(2,d.IExtensionGalleryService),Y(3,S.ILogService)],g),e.ExtensionsDownloader=g}),define(te[184],ne([0,1,2,10,20,89]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class i extends T.Disposable{constructor(E,b){super();this.environmentService=E,this.extensionsManifestCache=(0,_.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(b.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(E){E.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(E){E.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=i}),define(te[185],ne([0,1,81,16,5,2,17,10,20,13,30,34,59,9]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let u=class extends L.Disposable{constructor(g,y,f){super();this.extensionManagementService=g,this.logService=f,this.cache=this._register(new S(y,f)),this.extensionManagementService.registerParticipant({postInstall:async c=>this.postInstallExtension(c),postUninstall:async c=>this.postUninstallExtension(c)})}async getLanguageIds(){const g=await this.cache.getLanguagePacks(),y=["en",...Object.keys(g)];return(0,_.distinct)(y)}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const y=await this.cache.getLanguagePacks();Object.keys(y).some(f=>y[f]&&y[f].extensions.some(c=>(0,C.areSameExtensions)(c.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(y);return!(0,_.equals)(Object.keys(g),Object.keys(f))}};u=de([Y(0,I.IExtensionManagementService),Y(1,b.INativeEnvironmentService),Y(2,m.ILogService)],u),e.LocalizationsService=u;let S=class extends L.Disposable{constructor(g,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(y=>{Object.keys(y).forEach(f=>delete y[f]),this.createLanguagePacksFromExtensions(y,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...y){for(const f of y)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,f);Object.keys(g).forEach(f=>this.updateHash(g[f]))}createLanguagePacksFromExtension(g,y){const f=y.identifier,c=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const l of c)if(y.location.scheme===i.Schemas.file&&(0,d.isValidLocalization)(l)){let r=g[l.languageId];r||(r={hash:"",extensions:[],translations:{}},g[l.languageId]=r);let a=r.extensions.filter(n=>(0,C.areSameExtensions)(n.extensionIdentifier,f))[0];a?a.version=y.manifest.version:r.extensions.push({extensionIdentifier:f,version:y.manifest.version});for(const n of l.translations)r.translations[n.id]=(0,R.join)(y.location.fsPath,n.path)}}updateHash(g){if(g){const y=(0,T.createHash)("md5");for(const f of g.extensions)y.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);g.hash=y.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return E.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(c){return{}}}).then(f=>(y=g(f),f)).then(f=>{for(const l of Object.keys(f))f[l]||delete f[l];this.languagePacks=f,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),E.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>y,f=>this.logService.error(f))})}};S=de([Y(0,b.INativeEnvironmentService),Y(1,m.ILogService)],S)}),define(te[186],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,T.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[62],ne([0,1,3,4,6,9]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var i;(function(u){u.Http="http",u.Https="https"})(i=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const S=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(!!S)return{address:S[1],port:+S[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(u){return e.LOCALHOST_ADDRESSES.indexOf(u)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(u){return e.ALL_INTERFACES_ADDRESSES.indexOf(u)>=0}e.isAllInterfaces=C;function d(u,S){return S?S!==1&&u<1024:!_.isWindows&&u<1024}e.isPortPrivileged=d;let m=class{constructor(S){this.logService=S,this._onTunnelOpened=new T.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new T.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new T.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(S,v){return this._tunnelProvider=S,S?(this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const S=[],v=Array.from(this._tunnels.values());for(let g of v){const y=Array.from(g.values());for(let f of y){const c=await f.value;c&&S.push(c)}}return S}async dispose(){for(const S of this._tunnels.values()){for(const{value:v}of S.values())await v.then(g=>g?.dispose());S.clear()}this._tunnels.clear()}openTunnel(S,v,g,y,f=!1,c=R.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${g} on local port ${y}.`),!S)return;v||(v="localhost");const r=this.retainOrCreateTunnel(S,v,g,y,f,c,l);return r?r.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(a);return(a.tunnelRemoteHost!==v||a.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(S){return{tunnelRemotePort:S.tunnelRemotePort,tunnelRemoteHost:S.tunnelRemoteHost,tunnelLocalPort:S.tunnelLocalPort,localAddress:S.localAddress,privacy:S.privacy,protocol:S.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${S.tunnelRemoteHost}:${S.tunnelRemotePort} `);const v=this._tunnels.get(S.tunnelRemoteHost);if(v){const g=v.get(S.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(S.tunnelRemoteHost,S.tunnelRemotePort,g))}}}}async tryDisposeTunnel(S,v,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${S}:${v}.`);const y=g.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(S)&&this._tunnels.get(S).delete(v),y}}async closeTunnel(S,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${S}:${v} `);const g=this._tunnels.get(S);if(g&&g.has(v)){const y=g.get(v);y.refcount=0,await this.tryDisposeTunnel(S,v,y)}}addTunnelToMap(S,v,g){this._tunnels.has(S)||this._tunnels.set(S,new Map),this._tunnels.get(S).set(v,{refcount:1,value:g})}async removeEmptyTunnelFromMap(S,v){const g=this._tunnels.get(S);g&&(await g.get(v)||g.delete(v),g.size===0&&this._tunnels.delete(S))}getTunnelFromMap(S,v){let g=[S];I(S)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):C(S)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const y=g.map(f=>this._tunnels.get(f));for(const f of y){const c=f?.get(v);if(c)return c}}canTunnel(S){return!!b(S)}createWithProvider(S,v,g,y,f,c,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${g} on local port ${y}.`);const a={elevationRequired:f?d(y===void 0?g:y):!1},n={remoteAddress:{host:v,port:g},localAddressPort:y,privacy:c,public:c!==R.Private,protocol:l},t=S.forwardPort(n,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(v,g,t),t}};m=de([Y(0,L.ILogService)],m),e.AbstractTunnelService=m}),define(te[187],ne([0,1,9,62,2,7,5]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends D.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new i.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let E=class Et extends D.Disposable{constructor(I,C){super();this._tunnelService=I,this._logService=C,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Et._lastId)}}async startTunnel(I,C,d,m,u,S){const v=new R,g=await Promise.resolve(this._tunnelService.openTunnel(I,v,d,m,u,S));if(!g)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${d}:${m} (remote).`),v.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(C))throw this._disposedTunnels.delete(C),v.dispose(),await g.dispose(),(0,L.canceled)();return v.setTunnel(g),this._tunnels.set(C,v),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${C}: ${g.localAddress} (local) to ${d}:${m} (remote).`),{tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress}}async setAddress(I,C){const d=this._tunnels.get(I);!d||d.setAddress(C)}async destroyTunnel(I){const C=this._tunnels.get(I);if(C){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await C.dispose();return}this._disposedTunnels.add(I)}};E._lastId=0,E=de([Y(0,_.ISharedTunnelsService),Y(1,T.ILogService)],E),e.SharedProcessTunnelService=E}),define(te[188],ne([0,1,119,21,9]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(R,E){this.configurationService=R,this.logService=E}request(R,E){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,T.request)(R,E)}async resolveProxy(R){}};L=de([Y(0,_.IConfigurationService),Y(1,D.ILogService)],L),e.RequestService=L}),define(te[43],ne([0,1,19,140,42,6,37]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function R(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=R;function E(u){return u.res.statusCode===204}async function b(u){if(!R(u))throw new Error("Server returned "+u.res.statusCode);return E(u)?null:(await(0,T.streamToBuffer)(u.stream)).toString()}e.asText=b;async function I(u){if(!R(u))throw new Error("Server returned "+u.res.statusCode);if(E(u))return null;const v=(await(0,T.streamToBuffer)(u.stream)).toString();try{return JSON.parse(v)}catch(g){throw g.message+=`:
`+v,g}}e.asJson=I;function C(u){m(u)}e.updateProxyConfigurationsScope=C;let d;function m(u){const S=i.Registry.as(D.Extensions.Configuration),v=d;d={id:"http",order:15,title:(0,_.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,_.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,_.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,_.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,_.localize)(4,null),(0,_.localize)(5,null),(0,_.localize)(6,null),(0,_.localize)(7,null)],default:"override",description:(0,_.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,_.localize)(9,null),restricted:!0}}},S.updateConfigurations({add:[d],remove:v?[v]:[]})}m(2)}),define(te[189],ne([0,1,26,17,14,43]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let i=class{constructor(E,b){this.requestService=E,this.fileService=b}async download(E,b,I=T.CancellationToken.None){if(E.scheme===_.Schemas.file||E.scheme===_.Schemas.vscodeRemote){await this.fileService.copy(E,b);return}const C={type:"GET",url:E.toString()},d=await this.requestService.request(C,I);if(d.res.statusCode===200)await this.fileService.writeFile(b,d.stream);else{const m=await(0,L.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${m}`)}}};i=de([Y(0,L.IRequestService),Y(1,D.IFileService)],i),e.DownloadService=i}),define(te[190],ne([0,1,16,26,66,2,18,153,14,9,27,43]),function(J,e,T,_,D,L,i,R,E,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let d=class extends L.Disposable{constructor(u,S,v,g){super();this.fileService=u,this.productService=S,this.requestService=v,this.logService=g,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,D.forEach)(this.productService.configBasedExtensionTips,({value:y})=>this.allConfigBasedTips.set(y.configPath,y))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const S=[];for(const[v,g]of this.allConfigBasedTips)if(!(g.configScheme&&g.configScheme!==u.scheme))try{const y=await this.fileService.readFile((0,i.joinPath)(u,v)),f=new Map;(0,D.forEach)(g.recommendations,({key:l,value:r})=>{if((0,T.isNonEmptyArray)(r.remotes))for(const a of r.remotes)f.set(a,{extensionId:l,extensionName:r.name,configName:g.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else S.push({extensionId:l,extensionName:r.name,configName:g.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const c=(0,R.getDomainsOfRemotes)(y.value.toString(),[...f.keys()]);for(const l of c){const r=f.get(l);r&&S.push(r)}}catch(y){}return S}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const u=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},_.CancellationToken.None);if(u.res.statusCode!==200)return[];const S=await(0,C.asJson)(u);return S?S.workspaceRecommendations||[]:[]}catch(u){return this.logService.error(u),[]}}};d=de([Y(0,E.IFileService),Y(1,I.IProductService),Y(2,C.IRequestService),Y(3,b.ILogService)],d),e.ExtensionTipsService=d}),define(te[46],ne([0,1,19,29]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(L,i,R){let E=R&&R.get("storage.serviceMachineId",0)||null;if(E)return E;try{const I=(await i.readFile(L.serviceMachineIdResource)).value.toString();E=(0,_.isUUID)(I)?I:null}catch(b){E=null}if(!E){E=(0,_.generateUuid)();try{await i.writeFile(L.serviceMachineIdResource,T.VSBuffer.fromString(E))}catch(b){}}return R&&R.store("storage.serviceMachineId",E,0,1),E}e.getServiceMachineId=D}),define(te[90],ne([0,1,104,6]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(L){return(0,T.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,_.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[191],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var T;(function(_){_.Spawn="vscode:shared-process->shared-process-worker=spawn",_.Terminate="vscode:shared-process->shared-process-worker=terminate",_.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",_.Ready="vscode:shared-process-worker->shared-process=ready",_.Ack="vscode:shared-process-worker->shared-process=ack",_.Trace="vscode:shared-process-worker->shared-process=trace",_.Info="vscode:shared-process-worker->shared-process=info",_.Warn="vscode:shared-process-worker->shared-process=warn",_.Error="vscode:shared-process-worker->shared-process=error"})(T=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[192],ne([0,1,72,5,26,3,2,17,29,9,90,191]),function(J,e,T,_,D,L,i,R,E,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let d=class{constructor(S){this.logService=S,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(S){const v=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${v})`);const g=(0,I.hash)(S);this.processeDisposables.has(g)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${v})`),this.doDisposeWorker(S));const y=new D.CancellationTokenSource;let f,c,l;this.processeDisposables.set(g,t=>{y.dispose(!0),f?.terminate(S,D.CancellationToken.None),c?.close(),l?.close(),this.processeDisposables.delete(g);const s=this.processResolvers.get(g);s&&(this.processResolvers.delete(g),s({reason:t}))}),f=await this.getOrCreateWebWorker(S);const r=new Promise(t=>{this.processResolvers.set(g,t)});if(y.token.isCancellationRequested)return r;const{port1:a,port2:n}=new MessageChannel;return c=a,l=n,await f.spawn(S,l,y.token),y.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${v})`),T.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",S,[c])),r}getOrCreateWebWorker(S){let v=this.workers.get(S.process.moduleId);if(!v){this.logService.trace(`SharedProcess: creating new web worker (${S.process.moduleId})`);const g=new m(S.process.type,this.logService);v=g.init(),g.onDidProcessSelfTerminate(({configuration:y,reason:f})=>{this.doDisposeWorker(y,f)}),this.workers.set(S.process.moduleId,v)}return v}async disposeWorker(S){return this.doDisposeWorker(S)}doDisposeWorker(S,v){const g=this.processeDisposables.get((0,I.hash)(S));g&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),g(v))}};d=de([Y(0,b.ILogService)],d),e.SharedProcessWorkerService=d;class m extends i.Disposable{constructor(S,v){super();this.type=S,this.logService=v,this._onDidProcessSelfTerminate=this._register(new L.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const S=new _.DeferredPromise,v=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return v.onerror=g=>{this.logService.error(`SharedProcess: worker error (${this.type})`,g.message)},v.onmessageerror=g=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,g)},v.onmessage=g=>{const{id:y,message:f,configuration:c,nonce:l}=g.data;switch(y){case C.SharedProcessWorkerMessages.Ready:S.complete(v);break;case C.SharedProcessWorkerMessages.Ack:if(l){const r=this.mapMessageNonceToPendingMessageResolve.get(l);r&&(this.mapMessageNonceToPendingMessageResolve.delete(l),r())}break;case C.SharedProcessWorkerMessages.SelfTerminated:c&&f&&this._onDidProcessSelfTerminate.fire({configuration:c,reason:JSON.parse(f)});break;case C.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,f);break;case C.SharedProcessWorkerMessages.Info:f&&this.logService.info(f);break;case C.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,f);break;case C.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,f);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,g)}},v.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S.p}async send(S,v,g){const y=await this.workerReady;if(!v.isCancellationRequested)return new Promise(f=>{const c=(0,E.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(c,f);const l={...S,nonce:c};g?y.postMessage(l,[g]):y.postMessage(l),v.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(c)&&f()})})}spawn(S,v,g){const y={id:C.SharedProcessWorkerMessages.Spawn,configuration:S,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork",J).fsPath}};return this.send(y,g,v)}terminate(S,v){const g={id:C.SharedProcessWorkerMessages.Terminate,configuration:S};return this.send(g,v)}}}),define(te[91],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,T.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[193],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class T{constructor(){this.validators=new Map}vsda(){return new Promise((D,L)=>J(["vsda"],D,L))}async createNewMessage(D){try{const L=await this.vsda(),i=new L.validator;if(i){const R=String(T._nextId++);return this.validators.set(R,i),{id:R,data:i.createNewMessage(D)}}}catch(L){}return{id:"",data:D}}async validate(D,L){if(!D.id)return!0;const i=this.validators.get(D.id);if(!i)return!1;this.validators.delete(D.id);try{return i.validate(L)==="ok"}catch(R){return!1}}async sign(D){try{const L=await this.vsda(),i=new L.signer;if(i)return i.sign(D)}catch(L){}return D}}e.SignService=T,T._nextId=1}),define(te[23],ne([0,1,5,3,2,175,15,73,6]),function(J,e,T,_,D,L,i,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const b="__$__targetStorageMarker";e.IStorageService=(0,E.createDecorator)("storageService");var I;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var d;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));class m extends D.Disposable{constructor(g={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new _.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new _.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new _.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,y){y===b?(g===0?this._globalKeyTargets=void 0:g===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:g})):this._onDidChangeValue.fire({scope:g,key:y,target:this.getKeyTargets(g)[y]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,y,f){return this.getStorage(y)?.get(g,f)}getBoolean(g,y,f){return this.getStorage(y)?.getBoolean(g,f)}getNumber(g,y,f){return this.getStorage(y)?.getNumber(g,f)}store(g,y,f,c){if((0,i.isUndefinedOrNull)(y)){this.remove(g,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,f,c),this.getStorage(f)?.set(g,y)})}remove(g,y){this.withPausedEmitters(()=>{this.updateKeyTarget(g,y,void 0),this.getStorage(y)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,y){const f=[],c=this.getKeyTargets(g);for(const l of Object.keys(c))c[l]===y&&f.push(l);return f}updateKeyTarget(g,y,f){const c=this.getKeyTargets(y);typeof f=="number"?c[g]!==f&&(c[g]=f,this.getStorage(y)?.set(b,JSON.stringify(c))):typeof c[g]=="number"&&(delete c[g],this.getStorage(y)?.set(b,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(g){return g===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(g){const y=this.get(b,g);if(y)try{return JSON.parse(y)}catch(f){}return Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=I.NONE){this._onWillSaveState.fire({reason:g});const y=this.getStorage(0),f=this.getStorage(1);switch(g){case I.NONE:await T.Promises.settled([y?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await T.Promises.settled([y?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve()]);break}}async logStorage(){const g=this.getStorage(0)?.items??new Map,y=this.getStorage(1)?.items??new Map;return S(g,y,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=m,m.DEFAULT_FLUSH_INTERVAL=60*1e3;class u extends m{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.globalStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g)))}getStorage(g){return g===0?this.globalStorage:this.workspaceStorage}getLogDetails(g){return g===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(g){}}e.InMemoryStorageService=u;async function S(v,g,y,f){const c=o=>{try{return JSON.parse(o)}catch(h){return o}},l=new Map,r=new Map;v.forEach((o,h)=>{l.set(h,o),r.set(h,c(o))});const a=new Map,n=new Map;g.forEach((o,h)=>{a.set(h,o),n.set(h,c(o))}),console.group(`Storage: Global (path: ${y})`);let t=[];l.forEach((o,h)=>{t.push({key:h,value:o})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${f})`);let s=[];a.forEach((o,h)=>{s.push({key:h,value:o})}),console.table(s),console.groupEnd(),console.log(n)}e.logStorage=S}),define(te[194],ne([0,1,3,2,15,30,34,23]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let E=class extends _.Disposable{constructor(C,d){super();this._onDidChangeEnablement=new T.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(C)),this._register(this.storageManger.onDidChange(m=>this._onDidChangeEnablement.fire({extensions:m,source:"storage"}))),this._register(d.onDidInstallExtensions(m=>m.forEach(({local:u,operation:S})=>{u&&S===4&&this._removeFromDisabledExtensions(u.identifier)})))}async enableExtension(C,d){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:d}),!0):!1}async disableExtension(C,d){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:d}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){let d=this.getDisabledExtensions();return d.every(m=>!(0,i.areSameExtensions)(m,C))?(d.push(C),this._setDisabledExtensions(d),!0):!1}_removeFromDisabledExtensions(C){let d=this.getDisabledExtensions();for(let m=0;m<d.length;m++){const u=d[m];if((0,i.areSameExtensions)(u,C))return d.splice(m,1),this._setDisabledExtensions(d),!0}return!1}_setDisabledExtensions(C){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,d){this.storageManger.set(C,d,0)}};E=de([Y(0,R.IStorageService),Y(1,L.IExtensionManagementService)],E),e.GlobalExtensionEnablementService=E;class b extends _.Disposable{constructor(C){super();this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(d=>this.onDidStorageChange(d)))}get(C,d){let m;return d===0?((0,D.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,d)),m=this.storage[C]):m=this._get(C,d),JSON.parse(m)}set(C,d,m){let u=JSON.stringify(d.map(({id:v,uuid:g})=>({id:v,uuid:g})));this._get(C,m)!==u&&(m===0&&(d.length?this.storage[C]=u:delete this.storage[C]),this._set(C,d.length?u:void 0,m))}onDidStorageChange(C){if(C.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const m=this.get(C.key,C.scope);delete this.storage[C.key];const u=this.get(C.key,C.scope),S=m.filter(g=>!u.some(y=>(0,i.areSameExtensions)(g,y))),v=u.filter(g=>!m.some(y=>(0,i.areSameExtensions)(y,g)));(S.length||v.length)&&this._onDidChange.fire([...S,...v])}}_get(C,d){return this.storageService.get(C,d,"[]")}_set(C,d,m){d?this.storageService.store(C,d,m,1):this.storageService.remove(C,m)}}e.StorageManager=b}),define(te[195],ne([0,1,3,2]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class D extends _.Disposable{constructor(b,I){super();this.channel=b,this.workspace=I}async getItems(){const b={workspace:this.workspace},I=await this.channel.call("getItems",b);return new Map(I)}updateItems(b){const I={workspace:this.workspace};return b.insert&&(I.insert=Array.from(b.insert.entries())),b.delete&&(I.delete=Array.from(b.delete.values())),this.channel.call("updateItems",I)}}class L extends D{constructor(b){super(b,void 0);this._onDidChangeItemsExternal=this._register(new T.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(b=>this.onDidChangeGlobalStorage(b)))}onDidChangeGlobalStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}async close(){this.dispose()}}class i extends D{constructor(b,I){super(b,I);this.onDidChangeItemsExternal=T.Event.None}async close(){const b={workspace:this.workspace};return this.channel.call("close",b)}}class R extends _.Disposable{constructor(b,I){super();this.channel=b,this.workspace=I,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new L(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new i(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(te[196],ne([0,1,5,2,18,73,23,195]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends i.AbstractStorageService{constructor(I,C,d){super();this.mainProcessService=C,this.environmentService=d,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new _.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),C=new L.Storage(I.globalStorage);return this._register(C.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),C}createWorkspaceStorage(I){const C=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(C.workspaceStorage){const d=new L.Storage(C.workspaceStorage);return this.workspaceStorageDisposable.value=d.onDidChangeStorage(m=>this.emitDidChangeValue(1,m)),this.workspaceStorageId=I?.id,d}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await T.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,D.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(i.WillSaveStateReason.SHUTDOWN),await T.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const C=this.workspaceStorage,d=C?.items??new Map;C&&(await C.close(),C.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[m,u]of d)this.workspaceStorage.set(m,u)}}e.NativeStorageService=E}),define(te[197],ne([0,1,4,32,8,29]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function i(b){if(T.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function R(b,I,C,d,m,u,S,v,g,y){const f=Object.create(null);f["common.machineId"]=S,f.sessionID=(0,L.generateUuid)()+Date.now(),f.commitHash=m,f.version=u,f["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,T.PlatformToString)(T.platform),f["common.nodePlatform"]=_.platform,f["common.nodeArch"]=d,f["common.product"]=y||"desktop";const c=E(v||[]);c&&(f["common.msftInternal"]=c);let l=0;const r=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),T.isLinuxSnap&&(f["common.snap"]="true");const a=i(C);a&&(f["common.platformDetail"]=a);try{const n=await b.readFile(D.URI.file(g));f["common.source"]=n.value.toString().slice(0,30)}catch(n){}return f}e.resolveCommonProperties=R;function E(b){const I=_.env.USERDNSDOMAIN;if(!I)return!1;const C=I.toLowerCase();return b.some(d=>C===d)}e.verifyMicrosoftInternalDomain=E}),define(te[22],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var _;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(_=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[198],ne([0,1,33,54,5,31,17,10,4,8,112,20,115,78,14,27,22]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function g(r,a){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let t;const s=T.homedir().toLowerCase();switch(process.platform){case"win32":t=[{tag:"gdrive",matcher:O=>/^[a-z]:\\(my drive|shared drives)\\/.test(O)||O.startsWith(s+"\\my drive\\")},{tag:"dropbox",matcher:O=>O.startsWith(s+"\\dropbox")},{tag:"onedrive",matcher:O=>O.startsWith(s+"\\onedrive")},{tag:"box",matcher:O=>O.startsWith(s+"\\box\\")},{tag:"nextcloud",matcher:O=>O.startsWith(s+"\\nextcloud\\")},{tag:"owncloud",matcher:O=>O.startsWith(s+"\\owncloud\\")}];break;case"darwin":t=[{tag:"gdrive",matcher:O=>O.startsWith("/volumes/googledrive/")||O.startsWith(s+"/my drive/")},{tag:"dropbox",matcher:O=>O.startsWith(s+"/dropbox")},{tag:"onedrive",matcher:O=>O.startsWith(s+"/onedrive")||O.startsWith(s+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:O=>O.startsWith(s+"/library/mobile documents/")},{tag:"box",matcher:O=>O.startsWith(s+"/box/")},{tag:"nextcloud",matcher:O=>O.startsWith(s+"/nextcloud/")},{tag:"owncloud",matcher:O=>O.startsWith(s+"/owncloud/")}];break}const o=new Map,h=new Map,p=2e4;function w(O,q,$,k){for(const A of t){const F=O.toLowerCase();A.matcher(F)&&h.set(A.tag,1)}const z=q.substring(O.length+1);return D.Promises.withAsyncBody(async A=>{let F;try{F=await C.Promises.readdir(q,{withFileTypes:!0})}catch(B){A();return}if(k.count>=p){k.count+=F.length,k.maxReached=!0,A();return}let x=F.length;if(x===0){A();return}let Z=F;k.count+F.length>p&&(k.maxReached=!0,x=p-k.count,Z=F.slice(0,x)),k.count+=F.length;for(const B of Z)if(B.isDirectory()){if($.includes(B.name)||await w(O,(0,R.join)(q,B.name),$,k),--x==0){A();return}}else{const j=B.name.lastIndexOf(".");if(j>=0){const X=B.name.substring(j+1);X&&o.set(X,(o.get(X)??0)+1)}for(const X of n)X.relativePathPattern?.test(z)!==!1&&X.filePattern.test(B.name)&&h.set(X.tag,(h.get(X.tag)??0)+1);if(--x==0){A();return}}})}const P={count:0,maxReached:!1};await w(r,r,a,P);const M=await c(r);return{configFiles:y(h),fileTypes:y(o),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:M}}e.collectWorkspaceStats=g;function y(r){return[..._.Iterable.map(r.entries(),([a,n])=>({name:a,count:n}))].sort((a,n)=>n.count-a.count)}function f(){const r={os:`${T.type()} ${T.arch()} ${T.release()}`,memory:`${(T.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(T.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},a=T.cpus();return a&&a.length>0&&(r.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),r}e.getMachineInfo=f;async function c(r){try{const a=new Map,n=(0,R.join)(r,".vscode","launch.json"),t=await C.Promises.readFile(n),s=[],o=(0,L.parse)(t.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),[];if((0,L.getNodeType)(o)==="object"&&o.configurations)for(const h of o.configurations){const p=h.type;p&&(a.has(p)?a.set(p,a.get(p)+1):a.set(p,1))}return y(a)}catch(a){return[]}}e.collectLaunchConfigs=c;let l=class{constructor(a,n){this.telemetryService=a,this.productService=n}formatMachineInfo(a){const n=[];return n.push(`OS Version:       ${a.os}`),n.push(`CPUs:             ${a.cpus}`),n.push(`Memory (System):  ${a.memory}`),n.push(`VM:               ${a.vmHint}`),n.join(`
`)}formatEnvironment(a){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${T.type()} ${T.arch()} ${T.release()}`);const t=T.cpus();return t&&t.length>0&&n.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),n.push(`Memory (System):  ${(T.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(T.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),E.isWindows||n.push(`Load (avg):       ${T.loadavg().map(s=>Math.round(s)).join(", ")}`),n.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${a.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(a,n){return Promise.all([(0,d.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async t=>{let[s,o]=t,h=this.formatProcessList(a,s);return n.forEach(p=>{if((0,m.isRemoteDiagnosticError)(p))h+=`
${p.errorMessage}`,o+=`
${p.errorMessage}`;else if(h+=`

Remote: ${p.hostName}`,p.processes&&(h+=`
${this.formatProcessList(a,p.processes)}`),p.workspaceMetadata){o+=`
|  Remote: ${p.hostName}`;for(const w of Object.keys(p.workspaceMetadata)){const P=p.workspaceMetadata[w];let M=`${P.fileCount} files`;P.maxFilesReached&&(M=`more than ${M}`),o+=`|    Folder (${w}): ${M}`,o+=this.formatWorkspaceStats(P)}}}),{processInfo:h,workspaceInfo:o}})}async getSystemInfo(a,n){const{memory:t,vmHint:s,os:o,cpus:h}=f(),p={os:o,memory:t,cpus:h,vmHint:s,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:n};return E.isWindows||(p.load=`${T.loadavg().map(w=>Math.round(w)).join(", ")}`),E.isLinux&&(p.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(p)}async getDiagnostics(a,n){const t=[];return(0,d.listProcesses)(a.mainPID).then(async s=>(t.push(""),t.push(this.formatEnvironment(a)),t.push(""),t.push(this.formatProcessList(a,s)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(a))),n.forEach(o=>{if((0,m.isRemoteDiagnosticError)(o))t.push(`
${o.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${o.hostName}`),t.push(this.formatMachineInfo(o.machineInfo)),o.processes&&t.push(this.formatProcessList(a,o.processes)),o.workspaceMetadata)for(const h of Object.keys(o.workspaceMetadata)){const p=o.workspaceMetadata[h];let w=`${p.fileCount} files`;p.maxFilesReached&&(w=`more than ${w}`),t.push(`Folder (${h}): ${w}`),t.push(this.formatWorkspaceStats(p))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(a){const n=[],t=60;let s=0;const o=(P,M)=>{const O=` ${P}(${M})`;s+O.length>t?(n.push(h),h="|                 ",s=h.length):s+=O.length,h+=O};let h="|      File types:";const p=10;let w=a.fileTypes.length>p?p:a.fileTypes.length;for(let P=0;P<w;P++){const M=a.fileTypes[P];o(M.name,M.count)}if(n.push(h),a.configFiles.length>=0&&(h="|      Conf files:",s=0,a.configFiles.forEach(P=>{o(P.name,P.count)}),n.push(h)),a.launchConfigFiles.length>0){let P="|      Launch Configs:";a.launchConfigFiles.forEach(M=>{P+=M.count>1?` ${M.name}(${M.count})`:` ${M.name}`}),n.push(P)}return n.join(`
`)}expandGPUFeatures(a){const n=Math.max(...Object.keys(a).map(t=>t.length));return Object.keys(a).map(t=>`${t}:  ${" ".repeat(n-t.length)}  ${a[t]}`).join(`
                  `)}formatWorkspaceMetadata(a){const n=[],t=[];return a.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(n.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const h=b.URI.revive(o);if(h.scheme===i.Schemas.file){const p=h.fsPath;t.push(g(p,["node_modules",".git"]).then(w=>{let P=`${w.fileCount} files`;w.maxFilesReached&&(P=`more than ${P}`),n.push(`|    Folder (${(0,R.basename)(p)}): ${P}`),n.push(this.formatWorkspaceStats(w))}).catch(w=>{n.push(`|      Error: Unable to collect workspace stats for folder ${p} (${w.toString()})`)}))}else n.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(s=>n.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(a,n){const t=new Map;a.windows.forEach(o=>t.set(o.pid,o.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(a.mainPID,t,s,n,0),s.join(`
`)}formatProcessItem(a,n,t,s,o){const h=o===0;let p;h?p=s.pid===a?`${this.productService.applicationName} main`:"remote agent":(p=`${"  ".repeat(o)} ${s.name}`,s.name==="window"&&(p=`${p} (${n.get(s.pid)})`));const w=process.platform==="win32"?s.mem:T.totalmem()*(s.mem/100);t.push(`${s.load.toFixed(0).padStart(5," ")}	${(w/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${p}`),Array.isArray(s.children)&&s.children.forEach(P=>this.formatProcessItem(a,n,t,P,o+1))}async reportWorkspaceStats(a){for(const{uri:n}of a.folders){const t=b.URI.revive(n);if(t.scheme!==i.Schemas.file)continue;const s=t.fsPath;try{const o=await g(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:h.name,count:h.count})}),o.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:h.name,count:h.count})}),o.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:h.name,count:h.count})})}catch{}}}};l=de([Y(0,v.ITelemetryService),Y(1,S.IProductService)],l),e.DiagnosticsService=l}),define(te[199],ne([0,1,16,5,26,7,3,2,4,15,8,129,30,34,9,27,22]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends R.Disposable{constructor(a,n,t,s){super();this.galleryService=a,this.telemetryService=n,this.logService=t,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new i.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new i.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new i.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new i.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const n=await this.getTargetPlatform();return a.allTargetPlatforms.some(t=>(0,d.isTargetPlatformCompatible)(t,a.allTargetPlatforms,n))}async installFromGallery(a,n={}){try{if(!this.galleryService.isEnabled())throw new d.ExtensionManagementError(C.localize(0,null),d.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(a,!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,n)}catch(t){throw c(this.telemetryService,"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(a),void 0,t),this.logService.error("Failed to install extension.",a.identifier.id),this.logService.error(t),f(t)}}async migrateUnsupportedExtensions(){try{const a=await this.getExtensionsControlManifest();if(!a.unsupportedPreReleaseExtensions)return;const n=await this.getInstalled(1);for(const[t,s]of Object.entries(a.unsupportedPreReleaseExtensions)){const o=n.find(w=>(0,m.areSameExtensions)(w.identifier,{id:t}));if(!o)continue;const h=await this.galleryService.getCompatibleExtension({id:s.id},!0,await this.getTargetPlatform());if(!h){this.logService.info(`Skipping migrating '${o.identifier.id}' extension because, the comaptible target '${s.id}' extension is not found`);continue}const p=await this.galleryService.getManifest(h,D.CancellationToken.None);if(!p){this.logService.info(`Skipping migrating '${o.identifier.id}' extension because, the manifest for '${s.id}' extension is not found`);continue}try{this.logService.info(`Migrating '${o.identifier.id}' extension to '${s.id}' extension...`),await Promise.allSettled([this.uninstall(o),this.installExtension(p,h,{installPreReleaseVersion:!0,isMachineScoped:o.isMachineScoped,operation:4})]),this.logService.info(`Migrated '${o.identifier.id}' extension to '${s.id}' extension.`)}catch(w){this.logService.error(w)}}}catch(a){this.logService.error(a)}}async uninstall(a,n={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,n)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const n=await this.findGalleryExtension(a);if(!n)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const a=new Date().getTime();return(!this.extensionsControlManifest||a-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=a),this.extensionsControlManifest}registerParticipant(a){this.participants.push(a)}async installExtension(a,n,t){if(!I.URI.isUri(n)){let w=this.installingExtensions.get(new m.ExtensionIdentifierWithVersion(n.identifier,n.version).key());if(w)return this.logService.info("Extensions is already requested to install",n.identifier.id),w.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],o=[],h=this.createInstallExtensionTask(a,n,t);I.URI.isUri(n)||this.installingExtensions.set(new m.ExtensionIdentifierWithVersion(h.identifier,a.version).key(),h),this._onInstallExtension.fire({identifier:h.identifier,source:n}),this.logService.info("Installing extension:",h.identifier.id),s.push({task:h,manifest:a});let p=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",h.identifier.id);else try{const P=await this.getAllDepsAndPackExtensionsToInstall(h.identifier,a,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:M,manifest:O}of P)if(p=p||!!O.extensionDependencies?.some(q=>(0,m.areSameExtensions)({id:q},h.identifier)),this.installingExtensions.has(new m.ExtensionIdentifierWithVersion(M.identifier,M.version).key()))this.logService.info("Extension is already requested to install",M.identifier.id);else{const q=this.createInstallExtensionTask(O,M,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new m.ExtensionIdentifierWithVersion(q.identifier,O.version).key(),q),this._onInstallExtension.fire({identifier:q.identifier,source:M}),this.logService.info("Installing extension:",q.identifier.id),s.push({task:q,manifest:O})}}catch(P){if(I.URI.isUri(h.source))(0,T.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",h.identifier.id,P.message),(0,T.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",h.identifier.id,P.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",h.identifier.id),P}const w=s.reduce((P,{task:M,manifest:O})=>(P.set(M.identifier.id.toLowerCase(),{task:M,manifest:O}),P),new Map);for(;w.size;){let P;const M=[...w.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(q=>w.has(q.toLowerCase())));M.length?P=w.size===1?M:M.filter(({task:O})=>!(O===h&&!p)):(this.logService.info("Found extensions with circular dependencies",M.map(({task:O})=>O.identifier.id)),P=[...w.values()]),await this.joinAllSettled(P.map(async({task:O})=>{const q=new Date().getTime(),$=(0,b.isUndefined)(t.operation)?O.operation:t.operation;try{const k=await O.run();if(await this.joinAllSettled(this.participants.map(z=>z.postInstall(k,O.source,t,D.CancellationToken.None))),!I.URI.isUri(O.source)&&(c(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-q,void 0),E.isWeb&&$!==3))try{await this.galleryService.reportStatistic(k.manifest.publisher,k.manifest.name,k.manifest.version,"install")}catch(z){}o.push({local:k,identifier:O.identifier,operation:$,source:O.source})}catch(k){throw I.URI.isUri(O.source)||c(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-q,k),this.logService.error("Error while installing the extension:",O.identifier.id),k}finally{w.delete(O.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:P})=>this.logService.info("Extension installed successfully:",P.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:P})=>(0,m.areSameExtensions)(P,h.identifier))[0].local}catch(w){if(s.forEach(({task:P})=>P.cancel()),o.length)try{const P=await Promise.allSettled(o.map(({local:M})=>this.createUninstallExtensionTask(M,{versionOnly:!0}).run()));for(let M=0;M<P.length;M++){const O=P[M],{identifier:q}=o[M];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",q.id):this.logService.warn("Rollback: Error while uninstalling extension",q.id,(0,L.getErrorMessage)(O.reason))}}catch(P){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(P),o.map(({identifier:M})=>M.id))}throw this._onDidInstallExtensions.fire(s.map(({task:P})=>({identifier:P.identifier,operation:2,source:P.source}))),w}finally{for(const{task:w,manifest:P}of s)if(!I.URI.isUri(w.source)){const M=new m.ExtensionIdentifierWithVersion(w.identifier,P.version).key();this.installingExtensions.delete(M)||this.logService.warn("Installation task is not found in the cache",M)}}}async joinAllSettled(a){const n=[],t=[],s=await Promise.allSettled(a);for(const o of s)o.status==="fulfilled"?n.push(o.value):t.push(o.reason);if(t.length)throw y(t);return n}async getAllDepsAndPackExtensionsToInstall(a,n,t,s){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const h=[a,...o.map(P=>P.identifier)],p=[],w=async(P,M)=>{const O=M.extensionDependencies||[],q=[...O];if(M.extensionPack){const $=t?o.find(k=>(0,m.areSameExtensions)(k.identifier,P)):void 0;for(const k of M.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(z=>(0,m.areSameExtensions)({id:z},{id:k}))||q.every(z=>!(0,m.areSameExtensions)({id:z},{id:k}))&&q.push(k)}if(q.length){const $=[...h,...p.map(z=>z.gallery.identifier)],k=q.filter(z=>$.every(A=>!(0,m.areSameExtensions)(A,{id:z})));if(k.length){const z=await this.galleryService.query({names:k,pageSize:q.length},D.CancellationToken.None);for(const A of z.firstPage){if($.find(Z=>(0,m.areSameExtensions)(Z,A.identifier)))continue;const F=O.some(Z=>(0,m.areSameExtensions)({id:Z},A.identifier));let x;try{x=await this.checkAndGetCompatibleVersion(A,!0,s)}catch(Z){if(Z instanceof d.ExtensionManagementError&&Z.code===d.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!F){this.logService.info("Skipping the packed extension as it cannot be installed",A.identifier.id);continue}else throw Z}p.push({gallery:x.extension,manifest:x.manifest}),await w(x.extension.identifier,M)}}}};return await w(a,n),o=await this.getInstalled(),p.filter(P=>!o.some(M=>(0,m.areSameExtensions)(M.identifier,P.gallery.identifier)))}async checkAndGetCompatibleVersion(a,n,t){const s=await this.getExtensionsControlManifest();if((0,m.getMaliciousExtensionsSet)(s).has(a.identifier.id))throw new d.ExtensionManagementError(C.localize(3,null,a.identifier.id),d.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[a.identifier.id])throw new d.ExtensionManagementError(C.localize(4,null,a.identifier.id,s.unsupportedPreReleaseExtensions[a.identifier.id].displayName),d.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(a)){const p=await this.getTargetPlatform();throw new d.ExtensionManagementError(C.localize(5,null,a.identifier.id,this.productService.nameLong,(0,d.TargetPlatformToString)(p)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(a,n,t);if(o){if(t&&a.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new d.ExtensionManagementError(C.localize(6,null,a.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new d.ExtensionManagementError(C.localize(7,null,a.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.Incompatible);const h=await this.galleryService.getManifest(o,D.CancellationToken.None);if(h===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(h.version!==o.version)throw new d.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:h}}async getCompatibleVersion(a,n,t){const s=await this.getTargetPlatform();let o=null;return n&&a.hasPreReleaseVersion&&a.properties.isPreReleaseVersion!==t&&(o=await this.galleryService.getCompatibleExtension(a.identifier,t,s)),!o&&await this.galleryService.isExtensionCompatible(a,t,s)&&(o=a),!o&&n&&(o=await this.galleryService.getCompatibleExtension(a,t,s)),o}async unininstallExtension(a,n){const t=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),t.waitUntilTaskIsFinished();const s=(w,P)=>{const M=this.createUninstallExtensionTask(w,P);return this.uninstallingExtensions.set(M.extension.identifier.id.toLowerCase(),M),this.logService.info("Uninstalling extension:",w.identifier.id),this._onUninstallExtension.fire(w.identifier),M},o=(w,P)=>{P?this.logService.error("Failed to uninstall extension:",w.identifier.id,P.message):this.logService.info("Successfully uninstalled extension:",w.identifier.id),c(this.telemetryService,"extensionGallery:uninstall",(0,m.getLocalExtensionTelemetryData)(w),void 0,P),this._onDidUninstallExtension.fire({identifier:w.identifier,error:P?.code})},h=[],p=[];try{h.push(s(a,{}));const w=await this.getInstalled(1);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const P=this.getAllPackExtensionsToUninstall(a,w);for(const M of P)this.uninstallingExtensions.has(M.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",M.identifier.id):h.push(s(M,{}))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(h.map(P=>P.extension),w,a),await this.joinAllSettled(h.map(async P=>{try{if(await P.run(),await this.joinAllSettled(this.participants.map(M=>M.postUninstall(P.extension,n,D.CancellationToken.None))),P.extension.identifier.uuid)try{await this.galleryService.reportStatistic(P.extension.manifest.publisher,P.extension.manifest.name,P.extension.manifest.version,"uninstall")}catch(M){}o(P.extension)}catch(M){const O=M instanceof d.ExtensionManagementError?M:new d.ExtensionManagementError((0,L.getErrorMessage)(M),d.ExtensionManagementErrorCode.Internal);throw o(P.extension,O),O}finally{p.push(P)}}))}catch(w){const P=w instanceof d.ExtensionManagementError?w:new d.ExtensionManagementError((0,L.getErrorMessage)(w),d.ExtensionManagementErrorCode.Internal);for(const M of h){try{M.cancel()}catch(O){}p.includes(M)||o(M.extension,P)}throw P}finally{for(const w of h)this.uninstallingExtensions.delete(w.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",w.extension.identifier.id)}}checkForDependents(a,n,t){for(const s of a){const o=this.getDependents(s,n);if(o.length){const h=o.filter(p=>!a.some(w=>(0,m.areSameExtensions)(w.identifier,p.identifier)));if(h.length)throw new Error(this.getDependentsErrorMessage(s,h,t))}}}getDependentsErrorMessage(a,n,t){return t===a?n.length===1?C.localize(8,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?C.localize(9,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):C.localize(10,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?C.localize(11,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?C.localize(12,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):C.localize(13,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(a,n,t=[]){if(t.indexOf(a)!==-1)return[];t.push(a);const s=a.manifest.extensionPack?a.manifest.extensionPack:[];if(s.length){const o=n.filter(p=>!p.isBuiltin&&s.some(w=>(0,m.areSameExtensions)({id:w},p.identifier))),h=[];for(const p of o)h.push(...this.getAllPackExtensionsToUninstall(p,n,t));return[...o,...h]}return[]}getDependents(a,n){return n.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(s=>(0,m.areSameExtensions)({id:s},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const n=await this.findGalleryExtensionById(a.identifier.uuid);return n||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},D.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},D.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",a),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};g=de([Y(0,d.IExtensionGalleryService),Y(1,v.ITelemetryService),Y(2,u.ILogService),Y(3,S.IProductService)],g),e.AbstractExtensionManagementService=g;function y(r){const a=Array.isArray(r)?r:[r];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((n,t)=>new Error(`${n.message}${n.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=y;function f(r){if(r instanceof d.ExtensionManagementError)return r;const a=new d.ExtensionManagementError(r.message,d.ExtensionManagementErrorCode.Internal);return a.stack=r.stack,a}function c(r,a,n,t,s){const o=s?s instanceof d.ExtensionManagementError?s.code:d.ExtensionManagementErrorCode.Internal:void 0;r.publicLogError(a,{...n,success:!s,duration:t,errorcode:o})}e.reportTelemetry=c;class l{constructor(){this.barrier=new _.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,_.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,_.createCancelablePromise)(a=>new Promise((n,t)=>{const s=a.onCancellationRequested(()=>{s.dispose(),t((0,L.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=l}),define(te[200],ne([0,1,16,5,66,3,10,4,32,8,131,13,30,190,80,14,9,60,27,43,23,22]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v,g,y,f,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";let n=class extends m.ExtensionTipsService{constructor(s,o,h,p,w,P,M,O,q,$){super(M,O,q,$);this.environmentService=s,this.telemetryService=o,this.extensionManagementService=h,this.storageService=p,this.nativeHostService=w,this.extensionRecommendationNotificationService=P,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,D.forEach)(O.exeBasedExtensionTips,({key:k,value:z})=>{const A=[],F=[],x=[];(0,D.forEach)(z.recommendations,({key:Z,value:B})=>{B.important?z.important?A.push({extensionId:Z,extensionName:B.name,isExtensionPack:!!B.isExtensionPack}):F.push({extensionId:Z,extensionName:B.name,isExtensionPack:!!B.isExtensionPack}):x.push({extensionId:Z,extensionName:B.name,isExtensionPack:!!B.isExtensionPack})}),A.length&&this.highImportanceExecutableTips.set(k,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:A}),F.length&&this.mediumImportanceExecutableTips.set(k,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:F}),x.length&&this.allOtherExecutableTips.set(k,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:x})}),(0,_.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),h=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,h),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,h)}groupImportantTipsByExe(s,o){const h=new Map;s.forEach(O=>h.set(O.extensionId.toLowerCase(),O));const{installed:p,uninstalled:w}=this.groupByInstalled([...h.keys()],o);for(const O of p){const q=h.get(O);q&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:q.exeName})}for(const O of w){const q=h.get(O);q&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:q.exeName})}const P=this.getPromptedExecutableTips(),M=new Map;for(const O of w){const q=h.get(O);if(q&&(!P[q.exeName]||!P[q.exeName].includes(q.extensionId))){let $=M.get(q.exeName);$||($=[],M.set(q.exeName,$)),$.push(q)}}return M}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(h=>{switch(h){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":const p=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(p(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const w=this._register((0,_.disposableTimeout)(()=>{w.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),o=Date.now()-s,h=7*24*60*60*1e3;if(o<h){const P=this._register((0,_.disposableTimeout)(()=>{P.dispose(),this.promptMediumImportanceExeBasedTip()},h-o));return}const[p,w]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(w).then(P=>{switch(P){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(p),this.addToRecommendedExecutables(w[0].exeName,w);const M=this._register((0,_.disposableTimeout)(()=>{M.dispose(),this.promptMediumImportanceExeBasedTip()},h));break;case"ignored":this.mediumImportanceTipsByExe.delete(p),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const q=this._register((0,_.disposableTimeout)(()=>{q.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(s){const o=s.map(({extensionId:p})=>p.toLowerCase()),h=(0,I.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,h,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(a,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(a,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(s,o){const h=this.getPromptedExecutableTips();h[s]=o.map(({extensionId:p})=>p.toLowerCase()),this.storageService.store(r,JSON.stringify(h),0,0)}groupByInstalled(s,o){const h=[],p=[],w=o.reduce((P,M)=>(P.add(M.identifier.id.toLowerCase()),P),new Set);return s.forEach(P=>{w.has(P.toLowerCase())?h.push(P):p.push(P)}),{installed:h,uninstalled:p}}async getValidExecutableBasedExtensionTips(s){const o=[],h=new Map;for(const p of s.keys()){const w=s.get(p);if(!w||!(0,T.isNonEmptyArray)(w.recommendations))continue;const P=[];R.isWindows?w.windowsPath&&P.push(w.windowsPath.replace("%USERPROFILE%",E.env.USERPROFILE).replace("%ProgramFiles(x86)%",E.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",E.env.ProgramFiles).replace("%APPDATA%",E.env.APPDATA).replace("%WINDIR%",E.env.WINDIR)):(P.push((0,i.join)("/usr/local/bin",p)),P.push((0,i.join)("/usr/bin",p)),P.push((0,i.join)(this.environmentService.userHome.fsPath,p)));for(const M of P){let O=h.get(M);if(O===void 0&&(O=await this.fileService.exists(b.URI.file(M)),h.set(M,O)),O)for(const{extensionId:q,extensionName:$,isExtensionPack:k}of w.recommendations)o.push({extensionId:q,extensionName:$,isExtensionPack:k,exeName:p,exeFriendlyName:w.exeFriendlyName,windowsPath:w.windowsPath})}}return o}};n=de([Y(0,C.INativeEnvironmentService),Y(1,l.ITelemetryService),Y(2,d.IExtensionManagementService),Y(3,c.IStorageService),Y(4,g.INativeHostService),Y(5,u.IExtensionRecommendationNotificationService),Y(6,S.IFileService),Y(7,y.IProductService),Y(8,f.IRequestService),Y(9,v.ILogService)],n),e.ExtensionTipsService=n}),define(te[92],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class T{constructor(L){this.appenders=L}listen(L,i){throw new Error(`Event not found: ${i}`)}call(L,i,{eventName:R,data:E}){return this.appenders.forEach(b=>b.log(R,E)),Promise.resolve(null)}}e.TelemetryAppenderChannel=T;class _{constructor(L){this.channel=L}log(L,i){return this.channel.call("log",{eventName:L,data:i}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=_}),define(te[44],ne([0,1,28,15,21,22]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class i{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(g,y){return Promise.resolve(void 0)}publicLog2(g,y){return this.publicLog(g,y)}publicLogError(g,y){return Promise.resolve(void 0)}publicLogError2(g,y){return this.publicLogError(g,y)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=i,e.NullTelemetryService=new i;class R{async publicLog(g,y,f){}async publicLogError(g,y,f){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(v,g){return g.onDidChangeConfiguration(y=>{y.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(y.source),configurationKeys:u(y.sourceConfig)})})}e.configurationTelemetry=E;function b(v,g){return!(g.disableTelemetry||!v.enableTelemetry)}e.supportsTelemetry=b;function I(v){const g=v.getValue(L.TELEMETRY_SETTING_ID),y=v.getValue("telemetry.enableCrashReporter");if(v.getValue(L.TELEMETRY_OLD_SETTING_ID)===!1||y===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=I;function C(v){const g=Object.create(null),y=Object.create(null),f=Object.create(null);m(v,f);for(let c in f){c=c.length>150?c.substr(c.length-149):c;const l=f[c];typeof l=="number"?y[c]=l:typeof l=="boolean"?y[c]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${l.length}`),g[c]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(g[c]=l)}return{properties:g,measurements:y}}e.validateTelemetryData=C;function d(v){if(!v)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(f=>{v.indexOf(`${f}+`)===0&&(g=f)}),g}e.cleanRemoteAuthority=d;function m(v,g,y=0,f){if(!!v)for(let c of Object.getOwnPropertyNames(v)){const l=v[c],r=f?f+c:c;Array.isArray(l)?g[r]=(0,T.safeStringify)(l):l instanceof Date?g[r]=l.toISOString():(0,_.isObject)(l)?y<2?m(l,g,y+1,r+"."):g[r]=(0,T.safeStringify)(l):g[r]=l}}function u(v){if(!v)return[];const g=[];return S(g,"",v),g}function S(v,g,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(f=>S(v,g?`${g}.${f}`:f,y[f])):v.push(g)}}),define(te[201],ne([0,1,44,149]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class D{constructor(){}setSharedProperty(E,b){}postEvent(E,b){}}class L{constructor(E,b,I,C,d){this.getMachineId=E,this.configurationService=b,this.productService=I,this.telemetry=C,this.keyValueStorage=d,this.networkInitialized=!1,I.tasConfig&&this.experimentsEnabled&&(0,T.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const m=this.configurationService.getValue("experiments.overrideDelay"),u=typeof m=="number"?m:0;this.overrideInitDelay=new Promise(S=>setTimeout(S,u))}get experimentsEnabled(){return!0}async getTreatment(E){await this.overrideInitDelay;const b=this.configurationService.getValue("experiments.override."+E);if(b!==void 0)return b;if(!this.tasClient||!this.experimentsEnabled)return;let I;const C=await this.tasClient;return this.networkInitialized?I=C.getTreatmentVariable("vscode",E):I=await C.getTreatmentVariableAsync("vscode",E,!0),I=C.getTreatmentVariable("vscode",E),I}async setupTASClient(){const E=this.productService.quality==="stable"?_.TargetPopulation.Public:_.TargetPopulation.Insiders,b=await this.getMachineId(),I=new _.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,b,E),C=this.productService.tasConfig,d=new(await new Promise((m,u)=>{J(["tas-client-umd"],m,u)})).ExperimentationService({filterProviders:[I],telemetry:this.telemetry,storageKey:_.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:C.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:C.assignmentContextTelemetryPropertyName,telemetryEventName:C.telemetryEventName,endpoint:C.endpoint,refetchInterval:_.ASSIGNMENT_REFETCH_INTERVAL});return await d.initializePromise,d.initialFetch.then(()=>this.networkInitialized=!0),d}}e.BaseAssignmentService=L;class i extends L{constructor(E,b,I){super(()=>Promise.resolve(E),b,I,new D)}}e.AssignmentService=i}),define(te[202],ne([0,1,16,26,7,28,4,32,15,8,21,13,30,34,76,14,9,27,43,46,23,22,44]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v,g,y,f,c,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const a=i.isWeb?"web":(0,d.getTargetPlatform)(i.platform,R.arch);var n;(function(H){H[H.None=0]="None",H[H.IncludeVersions=1]="IncludeVersions",H[H.IncludeFiles=2]="IncludeFiles",H[H.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",H[H.IncludeSharedAccounts=8]="IncludeSharedAccounts",H[H.IncludeVersionProperties=16]="IncludeVersionProperties",H[H.ExcludeNonValidated=32]="ExcludeNonValidated",H[H.IncludeInstallationTargets=64]="IncludeInstallationTargets",H[H.IncludeAssetUri=128]="IncludeAssetUri",H[H.IncludeStatistics=256]="IncludeStatistics",H[H.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",H[H.Unpublished=4096]="Unpublished"})(n||(n={}));function t(...H){return String(H.reduce((Q,re)=>Q|re,0))}var s;(function(H){H[H.Tag=1]="Tag",H[H.ExtensionId=4]="ExtensionId",H[H.Category=5]="Category",H[H.ExtensionName=7]="ExtensionName",H[H.Target=8]="Target",H[H.Featured=9]="Featured",H[H.SearchText=10]="SearchText",H[H.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},h={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class P{constructor(Q=w){this.state=Q}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(Q,re=this.state.pageSize){return new P({...this.state,pageNumber:Q,pageSize:re})}withFilter(Q,...re){const oe=[...this.state.criteria,...re.length?re.map(ce=>({filterType:Q,value:ce})):[{filterType:Q}]];return new P({...this.state,criteria:oe})}withSortBy(Q){return new P({...this.state,sortBy:Q})}withSortOrder(Q){return new P({...this.state,sortOrder:Q})}withFlags(...Q){return new P({...this.state,flags:Q.reduce((re,oe)=>re|oe,0)})}withAssetTypes(...Q){return new P({...this.state,assetTypes:Q})}get raw(){const{criteria:Q,pageNumber:re,pageSize:oe,sortBy:ce,sortOrder:he,flags:be,assetTypes:Ie}=this.state;return{filters:[{criteria:Q,pageNumber:re,pageSize:oe,sortBy:ce,sortOrder:he}],assetTypes:Ie,flags:be}}get searchText(){const Q=this.state.criteria.filter(re=>re.filterType===s.SearchText)[0];return Q&&Q.value?Q.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(Q=>String(Q.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function M(H,Q){const re=(H||[]).filter(oe=>oe.statisticName===Q)[0];return re?re.value:0}function O(H){const Q="Microsoft.VisualStudio.Code.Translation.";return H.files.filter(oe=>oe.assetType.indexOf(Q)===0).reduce((oe,ce)=>{const he=z(H,ce.assetType);return he&&oe.push([ce.assetType.substring(Q.length),he]),oe},[])}function q(H){if(H.properties){const Q=H.properties.filter(ce=>ce.key===o.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),oe=Q.filter(ce=>re.test(ce.value))[0];return oe?{uri:oe.value,fallbackUri:oe.value}:null}return z(H,o.Repository)}function $(H){return{uri:`${H.fallbackAssetUri}/${o.VSIX}?redirect=true${H.targetPlatform?`&targetPlatform=${H.targetPlatform}`:""}`,fallbackUri:`${H.fallbackAssetUri}/${o.VSIX}${H.targetPlatform?`?targetPlatform=${H.targetPlatform}`:""}`}}function k(H){const Q=z(H,o.Icon);if(Q)return Q;const re=d.DefaultIconPath;return{uri:re,fallbackUri:re}}function z(H,Q){return H.files.filter(oe=>oe.assetType===Q)[0]?{uri:`${H.assetUri}/${Q}`,fallbackUri:`${H.fallbackAssetUri}/${Q}`}:null}function A(H,Q){const re=H.properties?H.properties.filter(ce=>ce.key===Q):[],oe=re.length>0&&re[0].value;return oe?oe.split(",").map(ce=>(0,m.adoptToGalleryExtensionId)(ce)):[]}function F(H){const Q=H.properties?H.properties.filter(re=>re.key===h.Engine):[];return Q.length>0&&Q[0].value||""}function x(H){const Q=H.properties?H.properties.filter(re=>re.key===h.PreRelease):[];return Q.length>0&&Q[0].value==="true"}function Z(H){const Q=H.properties?H.properties.filter(oe=>oe.key===h.LocalizedLanguages):[],re=Q.length>0&&Q[0].value||"";return re?re.split(","):[]}function B(H){return H.indexOf("preview")!==-1}function j(H){return H.targetPlatform?(0,d.toTargetPlatform)(H.targetPlatform):"undefined"}function X(H){const Q=(0,T.distinct)(H.versions.map(j)),re=!!H.tags?.includes(d.WEB_EXTENSION_TAG),oe=Q.indexOf("web");return re?oe===-1&&Q.push("web"):oe!==-1&&Q.splice(oe,1),Q}function U(H,Q){const re=(0,d.getFallbackTargetPlarforms)(Q);for(let oe=0;oe<H.length;oe++){const ce=H[oe];if(ce.version===H[oe-1]?.version){let he=oe;const be=j(ce);if(be===Q)for(;he>0&&H[he-1].version===ce.version;)he--;else if(re.includes(be))for(;he>0&&H[he-1].version===ce.version&&j(H[he-1])!==Q;)he--;he!==oe&&(H.splice(oe,1),H.splice(he,0,ce))}}return H}e.sortExtensionVersions=U;function N(H,Q,re,oe,ce){const he=H.versions[0],be={manifest:z(Q,o.Manifest),readme:z(Q,o.Details),changelog:z(Q,o.Changelog),license:z(Q,o.License),repository:q(Q),download:$(Q),icon:k(Q),coreTranslations:O(Q)};return{identifier:{id:(0,m.getGalleryExtensionId)(H.publisher.publisherName,H.extensionName),uuid:H.extensionId},name:H.extensionName,version:Q.version,displayName:H.displayName,publisherId:H.publisher.publisherId,publisher:H.publisher.publisherName,publisherDisplayName:H.publisher.displayName,publisherDomain:H.publisher.domain?{link:H.publisher.domain,verified:!!H.publisher.isDomainVerified}:void 0,description:H.shortDescription||"",installCount:M(H.statistics,"install"),rating:M(H.statistics,"averagerating"),ratingCount:M(H.statistics,"ratingcount"),categories:H.categories||[],tags:H.tags||[],releaseDate:Date.parse(H.releaseDate),lastUpdated:Date.parse(H.lastUpdated),allTargetPlatforms:re,assets:be,properties:{dependencies:A(Q,h.Dependency),extensionPack:A(Q,h.ExtensionPack),engine:F(Q),localizedLanguages:Z(Q),targetPlatform:j(Q),isPreReleaseVersion:x(Q)},hasPreReleaseVersion:x(he),hasReleaseVersion:oe,preview:B(H.flags),telemetryData:ce}}let W=class{constructor(Q,re,oe,ce,he,be,Ie,Se){this.requestService=re,this.logService=oe,this.environmentService=ce,this.telemetryService=he,this.fileService=be,this.productService=Ie,this.configurationService=Se;const ve=Ie.extensionsGallery;this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=ee(Ie.version,Ie,this.environmentService,this.configurationService,this.fileService,Q)}api(Q=""){return`${this.extensionsGalleryUrl}${Q}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(Q,re,oe){const ce=(0,E.isBoolean)(re)?re:!1,he=(0,E.isBoolean)(re)?oe:re;let be=new P().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,Q.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...Q.map(({id:ve})=>ve.toLowerCase()));Q.every(ve=>!ve.version)&&(be=be.withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties,n.IncludeLatestVersionOnly));const{galleryExtensions:Ie}=await this.queryGallery(be,a,_.CancellationToken.None),Se=Ie.map(ve=>{const Re=(0,m.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName);return{rawGalleryExtension:ve,version:Q.find(ye=>(0,m.areSameExtensions)(ye,{id:Re}))?.version}});return this.converToGalleryExtensions(Se,ce,a,()=>{},he)}async getCompatibleExtension(Q,re,oe){const ce=(0,d.isIExtensionIdentifier)(Q)?null:Q;if(ce){if((0,d.isNotWebExtensionInWebTargetPlatform)(ce.allTargetPlatforms,oe))return null;if(await this.isExtensionCompatible(ce,re,oe))return ce}const{id:he,uuid:be}=ce?ce.identifier:Q;let Ie=new P().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");be?Ie=Ie.withFilter(s.ExtensionId,be):Ie=Ie.withFilter(s.ExtensionName,he);const{galleryExtensions:Se}=await this.queryGallery(Ie,oe,_.CancellationToken.None),[ve]=Se;if(!ve||!ve.versions.length)return null;const Re=X(ve);if((0,d.isNotWebExtensionInWebTargetPlatform)(Re,oe))return null;for(let ye of ve.versions){if(!F(ye)){const De=await this.getEngine(ye);ye={...ye,properties:[...ye.properties||[],{key:h.Engine,value:De}]}}if(await this.isRawExtensionVersionCompatible(ye,re,Re,oe)){const De=ve.versions.some(Le=>!x(Le));return N(ve,ye,Re,De)}}return null}async isExtensionCompatible(Q,re,oe){if(!(0,d.isTargetPlatformCompatible)(Q.properties.targetPlatform,Q.allTargetPlatforms,oe)||!re&&Q.properties.isPreReleaseVersion)return!1;let ce=Q.properties.engine;if(!ce){const he=await this.getManifest(Q,_.CancellationToken.None);if(!he)throw new Error("Manifest was not found");ce=he.engines.vscode}return(0,u.isEngineValid)(ce,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(Q,re,oe,ce){if(!(0,d.isTargetPlatformCompatible)(j(Q),oe,ce)||!re&&x(Q))return!1;const he=await this.getEngine(Q);return(0,u.isEngineValid)(he,this.productService.version,this.productService.date)}async query(Q,re){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let oe=Q.text||"";const ce=(0,L.getOrDefault)(Q,ye=>ye.pageSize,50);let he=new P().withFlags(n.IncludeLatestVersionOnly,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,ce).withFilter(s.Target,"Microsoft.VisualStudio.Code");oe?(oe=oe.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,De,Le)=>(he=he.withFilter(s.Category,Le||De),"")),oe=oe.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,De,Le)=>(he=he.withFilter(s.Tag,Le||De),"")),oe=oe.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(s.Featured),"")),oe=oe.trim(),oe&&(oe=oe.length<200?oe:oe.substring(0,200),he=he.withFilter(s.SearchText,oe)),he=he.withSortBy(0)):Q.ids?he=he.withFilter(s.ExtensionId,...Q.ids):Q.names?he=he.withFilter(s.ExtensionName,...Q.names):he=he.withSortBy(4),typeof Q.sortBy=="number"&&(he=he.withSortBy(Q.sortBy)),typeof Q.sortOrder=="number"&&(he=he.withSortOrder(Q.sortOrder));const{galleryExtensions:be,total:Ie}=await this.queryGallery(he,a,re),Se=ye=>({index:(he.pageNumber-1)*he.pageSize+ye,querySource:Q.source}),ve=await this.converToGalleryExtensions(be.map(ye=>({rawGalleryExtension:ye})),!!Q.includePreRelease,a,Se,re),Re=async(ye,De)=>{if(De.isCancellationRequested)throw(0,D.canceled)();const Le=he.withPage(ye+1),{galleryExtensions:Fe}=await this.queryGallery(Le,a,De);return await this.converToGalleryExtensions(Fe.map($e=>({rawGalleryExtension:$e})),!!Q.includePreRelease,a,Se,re)};return{firstPage:ve,total:Ie,pageSize:he.pageSize,getPage:Re}}async converToGalleryExtensions(Q,re,oe,ce,he){const be=(ve,Re,ye)=>{const De=X(ve);let Le=ve.versions[0];return Le=ve.versions.find(Fe=>Fe.version===Le.version&&(0,d.isTargetPlatformCompatible)(j(Fe),De,oe))||Le,x(Le)&&!re&&(Le=ve.versions.find(Fe=>Fe.version!==Le.version&&!x(Fe))||Le),N(ve,Le,De,ye,ce(Re))},Ie=[],Se=new Map;for(let ve=0;ve<Q.length;ve++){const{rawGalleryExtension:Re,version:ye}=Q[ve],De=Re.versions.some(Le=>!x(Le));if(ye){const Le=Re.versions.find(Fe=>Fe.version===ye);Le&&Ie.push([ve,N(Re,Le,X(Re),De)])}else{const Le=be(Re,ve,De);Le.properties.isPreReleaseVersion?Se.set(Le.identifier.uuid,ve):Ie.push([ve,Le])}}if(Se.size){const ve=new Date().getTime(),Re=new P().withFlags(n.IncludeVersions,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,Se.size).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionId,...Se.keys()),{galleryExtensions:ye}=await this.queryGallery(Re,oe,he);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-ve,count:Se.size}),ye.length!==Se.size)throw new Error("Not all extensions with latest versions are returned");for(const De of ye){const Le=De.versions.some(ze=>!x(ze)),Fe=Se.get(De.extensionId),$e=be(De,Fe,Le);Ie.push([Fe,$e])}}return Ie.sort((ve,Re)=>ve[0]-Re[0]).map(([,ve])=>ve)}async queryGallery(Q,re,oe){if(!this.isEnabled())throw new Error("No extension gallery service configured.");Q=Q.withFlags(Q.flags,n.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,t(n.Unpublished));const ce=await this.commonHeadersPromise,he=JSON.stringify(Q.raw),be={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(he.length)},Ie=new Date().getTime();let Se,ve,Re=0;try{if(Se=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:he,headers:be},oe),Se.res.statusCode&&Se.res.statusCode>=400&&Se.res.statusCode<500)return{galleryExtensions:[],total:Re};const ye=await(0,y.asJson)(Se);if(ye){const De=ye.results[0],Le=De.extensions;Le.forEach($e=>U($e.versions,re));const Fe=De.resultMetadata&&De.resultMetadata.filter($e=>$e.metadataType==="ResultCount")[0];return Re=Fe&&Fe.metadataItems.filter($e=>$e.name==="TotalCount")[0].count||0,{galleryExtensions:Le,total:Re}}return{galleryExtensions:[],total:Re}}catch(ye){throw ve=ye,ye}finally{this.telemetryService.publicLog2("galleryService:query",{...Q.telemetryData,requestBodySize:String(he.length),duration:new Date().getTime()-Ie,success:!!Se&&(0,y.isSuccess)(Se),responseBodySize:Se?.res.headers["Content-Length"],statusCode:Se?String(Se.res.statusCode):void 0,errorCode:ve?(0,D.isPromiseCanceledError)(ve)?"canceled":(0,D.getErrorMessage)(ve).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Re)})}}async reportStatistic(Q,re,oe,ce){if(!this.isEnabled())return;const he=i.isWeb?this.api(`/itemName/${Q}.${re}/version/${oe}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${Q}/extensions/${re}/${oe}/stats?statType=${ce}`),be=i.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Se={...await this.commonHeadersPromise,Accept:be};try{await this.requestService.request({type:"POST",url:he,headers:Se},_.CancellationToken.None)}catch(ve){}}async download(Q,re,oe){this.logService.trace("ExtensionGalleryService#download",Q.identifier.id);const ce=(0,m.getGalleryExtensionTelemetryData)(Q),he=new Date().getTime(),be=Re=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Re}),Ie=oe===2?"install":oe===3?"update":"",Se=Ie?{uri:`${Q.assets.download.uri}${b.URI.parse(Q.assets.download.uri).query?"&":"?"}${Ie}=true`,fallbackUri:`${Q.assets.download.fallbackUri}${b.URI.parse(Q.assets.download.fallbackUri).query?"&":"?"}${Ie}=true`}:Q.assets.download,ve=await this.getAsset(Se);await this.fileService.writeFile(re,ve.stream),be(new Date().getTime()-he)}async getReadme(Q,re){if(Q.assets.readme){const oe=await this.getAsset(Q.assets.readme,{},re);return await(0,y.asText)(oe)||""}return""}async getManifest(Q,re){if(Q.assets.manifest){const oe=await this.getAsset(Q.assets.manifest,{},re),ce=await(0,y.asText)(oe);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(Q,re){const oe=z(Q,o.Manifest);if(!oe)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},he=await this.getAsset(oe,{headers:ce});return await(0,y.asJson)(he)}async getCoreTranslation(Q,re){const oe=Q.assets.coreTranslations.filter(ce=>ce[0]===re.toUpperCase())[0];if(oe){const ce=await this.getAsset(oe[1]),he=await(0,y.asText)(ce);return he?JSON.parse(he):null}return null}async getChangelog(Q,re){if(Q.assets.changelog){const oe=await this.getAsset(Q.assets.changelog,{},re);return await(0,y.asText)(oe)||""}return""}async getAllCompatibleVersions(Q,re,oe){let ce=new P().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");Q.identifier.uuid?ce=ce.withFilter(s.ExtensionId,Q.identifier.uuid):ce=ce.withFilter(s.ExtensionName,Q.identifier.id);const{galleryExtensions:he}=await this.queryGallery(ce,oe,_.CancellationToken.None);if(!he.length)return[];const be=X(he[0]);if((0,d.isNotWebExtensionInWebTargetPlatform)(be,oe))return[];const Ie=[];for(const Se of he[0].versions)try{Ie[Ie.length-1]?.version!==Se.version&&await this.isRawExtensionVersionCompatible(Se,re,be,oe)&&Ie.push({version:Se.version,date:Se.lastUpdated,isPreReleaseVersion:x(Se)})}catch(ve){}return Ie}async getAsset(Q,re={},oe=_.CancellationToken.None){const ce=await this.commonHeadersPromise,he={type:"GET"},be={...ce,...re.headers||{}};re={...re,...he,headers:be};const Ie=Q.uri,Se=Q.fallbackUri,ve={...re,url:Ie};try{const Re=await this.requestService.request(ve,oe);if(Re.res.statusCode===200)return Re;const ye=await(0,y.asText)(Re);throw new Error(`Expected 200, got back ${Re.res.statusCode} instead.

${ye}`)}catch(Re){if((0,D.isPromiseCanceledError)(Re))throw Re;const ye=(0,D.getErrorMessage)(Re);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Ie,message:ye});const De={...re,url:Se};return this.requestService.request(De,oe)}}async getEngine(Q){let re=F(Q);if(!re){const oe=await this.getManifestFromRawExtensionVersion(Q,_.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");re=oe.engines.vscode}return re}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const Q=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},_.CancellationToken.None);if(Q.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,y.asJson)(Q),oe=[],ce={};if(re){for(const he of re.malicious)oe.push({id:he});if(re.unsupported)for(const he of Object.keys(re.unsupported)){const be=re.unsupported[he];(0,E.isBoolean)(be)||(ce[he.toLowerCase()]=be.preReleaseExtension)}}return{malicious:oe,unsupportedPreReleaseExtensions:ce}}};W=de([Y(1,y.IRequestService),Y(2,v.ILogService),Y(3,C.IEnvironmentService),Y(4,l.ITelemetryService),Y(5,S.IFileService),Y(6,g.IProductService),Y(7,I.IConfigurationService)],W);let V=class extends W{constructor(Q,re,oe,ce,he,be,Ie,Se){super(Q,re,oe,ce,he,be,Ie,Se)}};V=de([Y(0,c.IStorageService),Y(1,y.IRequestService),Y(2,v.ILogService),Y(3,C.IEnvironmentService),Y(4,l.ITelemetryService),Y(5,S.IFileService),Y(6,g.IProductService),Y(7,I.IConfigurationService)],V),e.ExtensionGalleryService=V;let G=class extends W{constructor(Q,re,oe,ce,he,be,Ie){super(void 0,Q,re,oe,ce,he,be,Ie)}};G=de([Y(0,y.IRequestService),Y(1,v.ILogService),Y(2,C.IEnvironmentService),Y(3,l.ITelemetryService),Y(4,S.IFileService),Y(5,g.IProductService),Y(6,I.IConfigurationService)],G),e.ExtensionGalleryServiceWithNoStorageService=G;async function ee(H,Q,re,oe,ce,he){const be={"X-Market-Client-Id":`VSCode ${H}`,"User-Agent":`VSCode ${H}`},Ie=await(0,f.getServiceMachineId)(re,ce,he);return(0,r.supportsTelemetry)(Q,re)&&(0,r.getTelemetryLevel)(oe)===3&&(be["X-Market-User-Id"]=Ie),be}e.resolveMarketplaceHeaders=ee}),define(te[93],ne([0,1,2,13,9,44]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let i=class extends T.Disposable{constructor(E,b,I=""){super();this.prefix=I;const C=E.getLogger(b.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(E.createLogger(b.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(E,b){this.logger.trace(`${this.prefix}telemetry/${E}`,(0,L.validateTelemetryData)(b))}};i=de([Y(0,D.ILoggerService),Y(1,_.IEnvironmentService)],i),e.TelemetryLogAppender=i}),define(te[94],ne([0,1,2,28,4,25,141,21,42,86,37,22,44]),function(J,e,T,_,D,L,i,R,E,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(v,g){this._configurationService=g,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(y),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(y=>{const f=/^[a-f0-9]+$/i.test(y["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!f})})}setExperimentProperty(v,g){this._experimentProperties[v]=g}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const v=await this._commonProperties;let g=v.sessionID,y=v["common.machineId"],f=v["common.firstSessionDate"],c=v["common.msftInternal"];return{sessionId:g,machineId:y,firstSessionDate:f,msftInternal:c}}dispose(){this._disposables.dispose()}_log(v,g,y,f){return this.telemetryLevel<g?Promise.resolve(void 0):this._commonProperties.then(c=>{y=(0,_.mixin)(y,c),y=(0,_.mixin)(y,this._experimentProperties),y=(0,_.cloneAndChange)(y,l=>{if(typeof l=="string")return this._cleanupInfo(l,f)}),this._appenders.forEach(l=>l.log(v,y))},c=>{console.error(c)})}publicLog(v,g,y){return this._log(v,3,g,y)}publicLog2(v,g,y){return this.publicLog(v,g,y)}publicLogError(v,g){return this.sendErrorTelemetry?this._log(v,2,g,!0):Promise.resolve(void 0)}publicLogError2(v,g){return this.publicLogError(v,g)}_anonymizeFilePaths(v){let g=v;const y=[];for(let r of this._cleanupPatterns)for(;;){const a=r.exec(v);if(!a)break;y.push([a.index,r.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(g="";;){const r=c.exec(v);if(!r)break;!f.test(r[0])&&y.every(([a,n])=>r.index<a||r.index>=n)&&(g+=v.substring(l,r.index)+"<REDACTED: user-file-path>",l=c.lastIndex)}return l<v.length&&(g+=v.substr(l)),g}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const g=v.toLowerCase(),y=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(g)?"<REDACTED: secret>":y.test(g)?"<REDACTED: email>":v}_cleanupInfo(v,g){let y=v;g&&(y=this._anonymizeFilePaths(y));for(let f of this._cleanupPatterns)y=y.replace(f,"");return y=this._removePropertiesWithPossibleUserInfo(y),y}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=de([Y(1,R.IConfigurationService)],m),e.TelemetryService=m;function u(){const S=(0,i.localize)(0,null,b.default.nameLong),v=b.default.privacyStatementUrl?(0,i.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,i.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=D.isWeb?"":(0,i.localize)(3,null),y=(0,i.localize)(4,null),f=(0,i.localize)(5,null),c=(0,i.localize)(6,null),l=(0,i.localize)(7,null),r=`
|       | ${y} | ${f} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,i.localize)(8,null);return`
${S} ${v} ${g}

&nbsp;

${l}
${r}

&nbsp;

${a}
`}I.Registry.as(E.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,i.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,i.localize)(10,null),(0,i.localize)(11,null),(0,i.localize)(12,null),(0,i.localize)(13,null)],markdownDescription:u(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(E.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,i.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,i.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,i.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,i.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[203],ne([0,1,7,28,44]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function L(R,E){const b=await new Promise((C,d)=>{J(["applicationinsights"],C,d)});let I;return b.defaultClient?(I=new b.TelemetryClient(R),I.channel.setUseDiskRetryCaching(!0)):(b.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=b.defaultClient),R.indexOf("AIF-")===0&&(I.config.endpointUrl=E?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),I}class i{constructor(E,b,I,C,d){this._eventPrefix=E,this._defaultData=b,this.testCollector=C,this.mirrored=d,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(E){if(!!this._aiClient){if(typeof this._aiClient!="string"){E(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(b=>{E(b)},b=>{(0,T.onUnexpectedError)(b),console.error(b)})}}log(E,b){!this._aiClient||(b=(0,_.mixin)(b,this._defaultData),b=(0,D.validateTelemetryData)(b),this.testCollector&&(b.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+E,properties:b.properties,measurements:b.measurements})))}flush(){return this._aiClient?new Promise(E=>{this._withAIClient(b=>{b.flush({callback:()=>{this._aiClient=void 0,E(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=i}),define(te[204],ne([0,1,17,57,21,13,9,22,92,93,94]),function(J,e,T,_,D,L,i,R,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let C=class{constructor(m,u,S,v){this.configurationService=m,this.telemetryService=u,this.loggerService=S,this.environmentService=v,this.customTelemetryServices=new Map}async getCustomTelemetryService(m){if(!this.customTelemetryServices.has(m.id)){const{machineId:u,sessionId:S}=await this.telemetryService.getTelemetryInfo(),v=Object.create(null);v["common.vscodemachineid"]=u,v["common.vscodesessionid"]=S;const g=[m.id,JSON.stringify(v),m.aiKey],f=new _.Client(T.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new E.TelemetryAppenderClient(f),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${m.id}] `)];this.customTelemetryServices.set(m.id,new I.TelemetryService({appenders:c,sendErrorTelemetry:m.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(m.id)}async publicLog(m,u,S){await(await this.getCustomTelemetryService(m)).publicLog(u,S)}async publicLogError(m,u,S){await(await this.getCustomTelemetryService(m)).publicLogError(u,S)}};C=de([Y(0,D.IConfigurationService),Y(1,R.ITelemetryService),Y(2,i.ILoggerService),Y(3,L.IEnvironmentService)],C),e.CustomEndpointTelemetryService=C}),define(te[205],ne([0,1,5,26,3,2,9]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends L.Disposable{constructor(b,I){super();this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((I,C)=>{const d=++this._lastRequestId;this._pendingRequests.set(d,I),this._onCreateRequest.fire({requestId:d,...b});const m=new _.CancellationTokenSource;(0,T.timeout)(this._timeout,m.token).then(()=>C(`Request ${d} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(d,[(0,L.toDisposable)(()=>m.cancel())])})}acceptReply(b,I){const C=this._pendingRequests.get(b);C?(this._pendingRequests.delete(b),(0,L.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),C(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};R=de([Y(1,i.ILogService)],R),e.RequestStore=R}),define(te[95],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var _;(function(v){v.Shell="terminal.integrated.shell.",v.ShellArgs="terminal.integrated.shellArgs.",v.DefaultProfile="terminal.integrated.defaultProfile.",v.Profiles="terminal.integrated.profiles."})(_=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(v){v.ShellLinux="terminal.integrated.shell.linux",v.ShellMacOs="terminal.integrated.shell.osx",v.ShellWindows="terminal.integrated.shell.windows",v.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",v.AutomationShellLinux="terminal.integrated.automationShell.linux",v.AutomationShellMacOs="terminal.integrated.automationShell.osx",v.AutomationShellWindows="terminal.integrated.automationShell.windows",v.AutomationProfileLinux="terminal.integrated.automationProfile.linux",v.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",v.AutomationProfileWindows="terminal.integrated.automationProfile.windows",v.ShellArgsLinux="terminal.integrated.shellArgs.linux",v.ShellArgsMacOs="terminal.integrated.shellArgs.osx",v.ShellArgsWindows="terminal.integrated.shellArgs.windows",v.ProfilesWindows="terminal.integrated.profiles.windows",v.ProfilesMacOs="terminal.integrated.profiles.osx",v.ProfilesLinux="terminal.integrated.profiles.linux",v.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",v.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",v.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",v.UseWslProfiles="terminal.integrated.useWslProfiles",v.TabsEnabled="terminal.integrated.tabs.enabled",v.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",v.TabsHideCondition="terminal.integrated.tabs.hideCondition",v.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",v.TabsShowActions="terminal.integrated.tabs.showActions",v.TabsLocation="terminal.integrated.tabs.location",v.TabsFocusMode="terminal.integrated.tabs.focusMode",v.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",v.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",v.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",v.CopyOnSelection="terminal.integrated.copyOnSelection",v.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",v.FontFamily="terminal.integrated.fontFamily",v.FontSize="terminal.integrated.fontSize",v.LetterSpacing="terminal.integrated.letterSpacing",v.LineHeight="terminal.integrated.lineHeight",v.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",v.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",v.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",v.BellDuration="terminal.integrated.bellDuration",v.FontWeight="terminal.integrated.fontWeight",v.FontWeightBold="terminal.integrated.fontWeightBold",v.CursorBlinking="terminal.integrated.cursorBlinking",v.CursorStyle="terminal.integrated.cursorStyle",v.CursorWidth="terminal.integrated.cursorWidth",v.Scrollback="terminal.integrated.scrollback",v.DetectLocale="terminal.integrated.detectLocale",v.DefaultLocation="terminal.integrated.defaultLocation",v.GpuAcceleration="terminal.integrated.gpuAcceleration",v.TerminalTitleSeparator="terminal.integrated.tabs.separator",v.TerminalTitle="terminal.integrated.tabs.title",v.TerminalDescription="terminal.integrated.tabs.description",v.RightClickBehavior="terminal.integrated.rightClickBehavior",v.Cwd="terminal.integrated.cwd",v.ConfirmOnExit="terminal.integrated.confirmOnExit",v.ConfirmOnKill="terminal.integrated.confirmOnKill",v.EnableBell="terminal.integrated.enableBell",v.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",v.AllowChords="terminal.integrated.allowChords",v.AllowMnemonics="terminal.integrated.allowMnemonics",v.EnvMacOs="terminal.integrated.env.osx",v.EnvLinux="terminal.integrated.env.linux",v.EnvWindows="terminal.integrated.env.windows",v.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",v.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",v.ShowExitAlert="terminal.integrated.showExitAlert",v.SplitCwd="terminal.integrated.splitCwd",v.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",v.WordSeparators="terminal.integrated.wordSeparators",v.EnableFileLinks="terminal.integrated.enableFileLinks",v.UnicodeVersion="terminal.integrated.unicodeVersion",v.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",v.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",v.LocalEchoEnabled="terminal.integrated.localEchoEnabled",v.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",v.LocalEchoStyle="terminal.integrated.localEchoStyle",v.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",v.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",v.CustomGlyphs="terminal.integrated.customGlyphs",v.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",v.InheritEnv="terminal.integrated.inheritEnv",v.ShowLinkHover="terminal.integrated.showLinkHover",v.IgnoreProcessNames="terminal.integrated.ignoreProcessNames"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(v){v.CommandPrompt="cmd",v.PowerShell="pwsh",v.Wsl="wsl",v.GitBash="gitbash"})(L=e.WindowsShellType||(e.WindowsShellType={}));var i;(function(v){v[v.Api=0]="Api",v[v.Process=1]="Process",v[v.Sequence=2]="Sequence",v[v.Config=3]="Config"})(i=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(v){v.LocalPty="localPty",v.PtyHost="ptyHost",v.Log="log",v.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,T.createDecorator)("ptyService");var E;(function(v){v.Cwd="cwd",v.InitialCwd="initialCwd",v.FixedDimensions="fixedDimensions",v.Title="title",v.ShellType="shellType",v.HasChildProcesses="hasChildProcesses",v.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",v.OverrideDimensions="overrideDimensions"})(E=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(v){v[v.BeatInterval=5e3]="BeatInterval",v[v.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",v[v.SecondWaitMultiplier=1]="SecondWaitMultiplier",v[v.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var I;(function(v){v[v.Panel=1]="Panel",v[v.Editor=2]="Editor"})(I=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(v){v.TerminalView="view",v.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(v){v.CwdDetection="cwdDetection"})(d=e.ProcessCapability||(e.ProcessCapability={}));var m;(function(v){v[v.GraceTime=6e4]="GraceTime",v[v.ShortGraceTime=6e3]="ShortGraceTime"})(m=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var u;(function(v){v[v.HighWatermarkChars=1e5]="HighWatermarkChars",v[v.LowWatermarkChars=5e3]="LowWatermarkChars",v[v.CharCountAckSize=5e3]="CharCountAckSize"})(u=e.FlowControlConstants||(e.FlowControlConstants={}));var S;(function(v){v.GitBash="Git Bash",v.Pwsh="PowerShell"})(S=e.ProfileSource||(e.ProfileSource={}))}),define(te[206],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,T.createDecorator)("localPtyService")}),define(te[207],ne([0,1,33,28,10,4,32,15,20]),function(J,e,T,_,D,L,i,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(T.release());let d=0;return C&&C.length===4&&(d=parseInt(C[3])),d}e.getWindowsBuildNumber=b;async function I(C,d,m,u=i.env,S=E.Promises.exists){if(D.isAbsolute(C))return await S(C)?C:void 0;if(d===void 0&&(d=i.cwd()),D.dirname(C)!=="."){const f=D.join(d,C);return await S(f)?f:void 0}const g=(0,_.getCaseInsensitive)(u,"PATH");if(m===void 0&&(0,R.isString)(g)&&(m=g.split(D.delimiter)),m===void 0||m.length===0){const f=D.join(d,C);return await S(f)?f:void 0}for(let f of m){let c;if(D.isAbsolute(f)?c=D.join(f,C):c=D.join(d,f,C),await S(c))return c;if(L.isWindows){let l=c+".com";if(await S(l)||(l=c+".exe",await S(l)))return l}}const y=D.join(d,C);return await S(y)?y:void 0}e.findExecutable=I}),define(te[208],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var T;(function(_){_.DARK="dark",_.LIGHT="light",_.HIGH_CONTRAST="hc"})(T=e.ColorScheme||(e.ColorScheme={}))}),define(te[96],ne([0,1,49,3,2,6,37,208]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var E;(function(v){function g(y){return y&&typeof y=="object"&&typeof y.id=="string"}v.isThemeColor=g})(E=e.ThemeColor||(e.ThemeColor={}));function b(v){return{id:v}}e.themeColorFromId=b;var I;(function(v){function g(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||E.isThemeColor(n.color))}v.isThemeIcon=g;const y=new RegExp(`^\\$\\((${T.CSSIcon.iconNameExpression}(?:${T.CSSIcon.iconModifierExpression})?)\\)$`);function f(n){const t=y.exec(n);if(!t)return;let[,s]=t;return{id:s}}v.fromString=f;function c(n,t){let s=n.id;const o=s.lastIndexOf("~");return o!==-1&&(s=s.substring(0,o)),t&&(s=`${s}~${t}`),{id:s}}v.modify=c;function l(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}v.getModifier=l;function r(n,t){return n.id===t.id&&n.color?.id===t.color?.id}v.isEqual=r;function a(n,t){return{id:n.id,color:t?b(t):void 0}}v.asThemeIcon=a,v.asClassNameArray=T.CSSIcon.asClassNameArray,v.asClassName=T.CSSIcon.asClassName,v.asCSSSelector=T.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=T.Codicon.file,e.FolderThemeIcon=T.Codicon.folder;function C(v){switch(v){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new _.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,D.toDisposable)(()=>{const y=this.themingParticipants.indexOf(g);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new d;i.Registry.add(e.Extensions.ThemingContribution,m);function u(v){return m.onColorThemeChange(v)}e.registerThemingParticipant=u;class S extends D.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,y){let f=this.theme.getColor(g);return f&&y&&(f=y(f,this.theme)),f?f.toString():null}}e.Themable=S}),define(te[209],ne([0,1,49,8,96]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function L(C,d){const m=C.map(u=>({name:u.profileName,description:i(u)}));return d&&m.push(...d.map(u=>({name:u.title,description:R(u)}))),{values:m.map(u=>u.name),markdownDescriptions:m.map(u=>u.description)}}e.createProfileSchemaEnums=L;function i(C){let d=`$(${D.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:T.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?d+=`
- args: "${C.args}"`:d+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(d+=`
- overrideName: ${C.overrideName}`),C.color&&(d+=`
- color: ${C.color}`),C.env&&(d+=`
- env: ${JSON.stringify(C.env)}`),d}function R(C){return`$(${D.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:T.Codicon.terminal.id}) ${C.title}
- extensionIdenfifier: ${C.extensionIdentifier}`}function E(C,d){if(!C&&!d)return!0;if(typeof C=="string"&&typeof d=="string")return C===d;if(Array.isArray(C)&&Array.isArray(d)){if(C.length!==d.length)return!1;for(let m=0;m<C.length;m++)if(C[m]!==d[m])return!1;return!0}return!1}e.terminalProfileArgsMatch=E;function b(C,d){if(!C&&!d)return!0;if(!C||!d)return!1;if(D.ThemeIcon.isThemeIcon(C)&&D.ThemeIcon.isThemeIcon(d))return C.id===d.id&&C.color===d.color;if(typeof C=="object"&&C&&"light"in C&&"dark"in C&&typeof d=="object"&&d&&"light"in d&&"dark"in d){const m=C,u=d;if((_.URI.isUri(m.light)||I(m.light))&&(_.URI.isUri(m.dark)||I(m.dark))&&(_.URI.isUri(u.light)||I(u.light))&&(_.URI.isUri(u.dark)||I(u.dark)))return m.light.path===u.light.path&&m.dark.path===u.dark.path}if(_.URI.isUri(C)&&_.URI.isUri(d)||I(C)||I(d)){const m=C,u=d;return m.path===u.path&&m.scheme===u.scheme}return!1}e.terminalIconsEqual=b;function I(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}e.isUriComponents=I}),define(te[210],ne([0,1,49,142,42,37,209]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,_.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,_.localize)(1,null),type:"boolean"},icon:{description:(0,_.localize)(2,null),type:"string",enum:Array.from(T.iconRegistry.all,c=>c.id),markdownEnumDescriptions:Array.from(T.iconRegistry.all,c=>`$(${c.id})`)},color:{description:(0,_.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,_.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},E={type:"object",required:["path"],properties:{path:{description:(0,_.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},b={type:"object",required:["path"],properties:{path:{description:(0,_.localize)(6,null),type:["string"],items:{type:"string"}},...R}},I=(0,_.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),C=(0,_.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),d=(0,_.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m=(0,_.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),u=(0,_.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,_.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),v={id:"terminal",order:100,title:(0,_.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:u},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,_.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,_.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,_.localize)(26,null)}},{type:"string",markdownDescription:(0,_.localize)(27,null)}],default:[],markdownDeprecationMessage:d},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,_.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(30,null),type:"string"},id:{description:(0,_.localize)(31,null),type:"string"},title:{description:(0,_.localize)(32,null),type:"string"},...R}},{type:"null"},E]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(34,null),type:"string"},id:{description:(0,_.localize)(35,null),type:"string"},title:{description:(0,_.localize)(36,null),type:"string"},...R}},{type:"null"},E]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(38,null),type:"string"},id:{description:(0,_.localize)(39,null),type:"string"},title:{description:(0,_.localize)(40,null),type:"string"},...R}},{type:"null"},E]}},["terminal.integrated.useWslProfiles"]:{description:(0,_.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,_.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,_.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,_.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,_.localize)(45,null),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){L.Registry.as(D.Extensions.Configuration).registerConfiguration(v),f()}e.registerTerminalPlatformConfiguration=g;let y;function f(c,l){const r=L.Registry.as(D.Extensions.Configuration);let a;c&&(a=(0,i.createProfileSchemaEnums)(c?.profiles,l));const n=y;y={id:"terminal",order:100,title:(0,_.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:c?.os===3?a?.values:void 0,markdownEnumDescriptions:c?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:c?.os===2?a?.values:void 0,markdownEnumDescriptions:c?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:c?.os===1?a?.values:void 0,markdownEnumDescriptions:c?.os===1?a?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[y],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=f}),define(te[211],ne([0,1,45,49,10,4,20,70,207,96]),function(J,e,T,_,D,L,i,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,C=!0;function d(a,n,t,s,o=process.env,h,p,w,P){return h=h||{existsFile:i.SymlinkSupport.existsFile,readFile:i.Promises.readFile},L.isWindows?m(t,h,o,p,s.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:s.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:s.getValue("terminal.integrated.defaultProfile.windows"),P,w):c(h,p,t,a&&typeof a=="object"?{...a}:s.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:s.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),P,w,o)}e.detectAvailableProfiles=d;async function m(a,n,t,s,o,h,p,w,P){const M=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${M?"Sysnative":"System32"}`;let q=!1;(0,E.getWindowsBuildNumber)()>=16299&&(q=!0),await v(w);const $=new Map;a&&($.set("PowerShell",{source:"PowerShell",icon:_.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:_.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),$.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),$.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:_.Codicon.terminalCmd,isAutoDetected:!0})),l(h,$);const k=await u($.entries(),p,n,t,s,P);if(a||!a&&o)try{const z=await y(`${O}\\${q?"wsl":"bash"}.exe`,p);for(const A of z)(!h||!(A.profileName in h))&&k.push(A)}catch(z){C&&(s?.info("WSL is not installed, so could not detect WSL profiles"),C=!1)}return k}async function u(a,n,t,s=process.env,o,h){const p=[];for(const[w,P]of a){if(P===null)continue;let M,O,q;if("source"in P){const z=I?.get(P.source);if(!z)continue;M=z.paths,O=P.args||z.args,P.icon?q=S(P.icon):z.icon&&(q=z.icon)}else M=Array.isArray(P.path)?P.path:[P.path],O=L.isWindows||Array.isArray(P.args)?P.args:void 0,q=S(P.icon)||void 0;const $=await h?.(M)||M.slice(),k=await r(w,n,$,t,s,O,P.env,P.overrideName,P.isAutoDetected,o);k?(k.isAutoDetected=P.isAutoDetected,k.icon=q,k.color=P.color,p.push(k)):o?.trace("profile not validated",w,M)}return p}function S(a){return typeof a=="string"?{id:a}:a}async function v(a){I&&!a||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),I.set("PowerShell",{profileName:"PowerShell",paths:a||await g(),icon:b.ThemeIcon.asThemeIcon(_.Codicon.terminalPowershell)}))}async function g(){const a=[];for await(const n of(0,R.enumeratePowerShellInstallations)())a.push(n.exePath);return a}async function y(a,n){const t=[],s=await new Promise((p,w)=>{T.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(P,M)=>{if(P)return w("Problem occurred when getting wsl distros");p(M)})});if(!s)return[];const o=new RegExp(/[\r?\n]/),h=s.split(o).filter(p=>p.trim().length>0&&p!=="");for(const p of h){if(p===""||p.startsWith("docker-desktop"))continue;const w=`${p} (WSL)`,P={profileName:w,path:a,args:["-d",`${p}`],isDefault:w===n,icon:f(p)};t.push(P)}return t}function f(a){return a.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(_.Codicon.terminalUbuntu):a.includes("Debian")?b.ThemeIcon.asThemeIcon(_.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(_.Codicon.terminalLinux)}async function c(a,n,t,s,o,h,p,w){const P=new Map;if(t){const M=(await a.readFile("/etc/shells")).toString(),O=h||M.split(`
`).filter($=>$.trim().indexOf("#")!==0&&$.trim().length>0),q=new Map;for(const $ of O){let k=(0,D.basename)($),z=q.get(k)||0;z++,z>1&&(k=`${k} (${z})`),q.set(k,z),P.set(k,{path:$,isAutoDetected:!0})}}return l(s,P),await u(P.entries(),o,a,w,n,p)}function l(a,n){if(!!a)for(const[t,s]of Object.entries(a))s===null||!("path"in s)&&!("source"in s)?n.delete(t):n.set(t,s)}async function r(a,n,t,s,o,h,p,w,P,M){if(t.length===0)return Promise.resolve(void 0);const O=t.shift();if(O==="")return r(a,n,t,s,o,h,p,w,P);const q={profileName:a,path:O,args:h,env:p,overrideName:w,isAutoDetected:P,isDefault:a===n};if((0,D.basename)(O)===O){const k=o.PATH?o.PATH.split(D.delimiter):void 0;return await(0,E.findExecutable)(O,void 0,k,void 0,s.existsFile)?q:r(a,n,t,s,o,h)}return await s.existsFile((0,D.normalize)(O))?q:r(a,n,t,s,o,h,p,w,P)}}),define(te[212],ne([0,1,3,2,17,4,36,57,21,13,75,163,9,85,22,205,95,210,211]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var f;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let c=0,l=class extends _.Disposable{constructor(a,n,t,s,o){super();this._reconnectConstants=a,this._configurationService=n,this._environmentService=t,this._logService=s,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new T.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new T.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new T.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new T.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new T.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new T.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new T.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new T.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new T.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new T.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new T.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new T.Emitter),this.onProcessExit=this._onProcessExit.event,(0,g.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,_.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new S.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async h=>{h.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,C.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},n=(0,I.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);n&&(n.break&&n.port?a.debugBrk=n.port:!n.break&&n.port&&(a.debug=n.port));const t=new R.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,a);this._onPtyHostStart.fire(),i.ProxyChannel.toService(t.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(p=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(p.code),this._isDisposed||(this._restartCount<=f.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${p.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${p.code}, giving up`))}));const o=t.getChannel(v.TerminalIpcChannels.Log);m.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{m.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const h=i.ProxyChannel.toService(t.getChannel(v.TerminalIpcChannels.PtyHost));return this._register(h.onProcessData(p=>this._onProcessData.fire(p))),this._register(h.onProcessReady(p=>this._onProcessReady.fire(p))),this._register(h.onProcessExit(p=>this._onProcessExit.fire(p))),this._register(h.onDidChangeProperty(p=>this._onDidChangeProperty.fire(p))),this._register(h.onProcessReplay(p=>this._onProcessReplay.fire(p))),this._register(h.onProcessOrphanQuestion(p=>this._onProcessOrphanQuestion.fire(p))),this._register(h.onDidRequestDetach(p=>this._onDidRequestDetach.fire(p))),[t,h]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,n,t,s,o,h,p,w,P,M,O){const q=setTimeout(()=>this._handleUnresponsiveCreateProcess(),v.HeartbeatConstants.CreateProcessTimeout),$=await this._proxy.createProcess(a,n,t,s,o,h,p,w,P,M,O);return clearTimeout(q),c=Math.max(c,$),$}updateTitle(a,n,t){return this._proxy.updateTitle(a,n,t)}updateIcon(a,n,t){return this._proxy.updateIcon(a,n,t)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,n){return this._proxy.shutdown(a,n)}input(a,n){return this._proxy.input(a,n)}processBinary(a,n){return this._proxy.processBinary(a,n)}resize(a,n,t){return this._proxy.resize(a,n,t)}acknowledgeDataEvent(a,n){return this._proxy.acknowledgeDataEvent(a,n)}setUnicodeVersion(a,n){return this._proxy.setUnicodeVersion(a,n)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,n,t,s=!1){const o=await this._shellEnv;return(0,y.detectAvailableProfiles)(n,t,s,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,n){return this._proxy.requestDetachInstance(a,n)}async acceptDetachInstanceReply(a,n){return this._proxy.acceptDetachInstanceReply(a,n)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,n){return this._proxy.reviveTerminalProcesses(a,n)}async refreshProperty(a,n){return this._proxy.refreshProperty(a,n)}async updateProperty(a,n,t){return this._proxy.updateProperty(a,n,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,n){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:n})}async acceptPtyHostResolvedVariables(a,n){this._resolveVariablesRequestStore.acceptReply(a,n)}};l=de([Y(1,E.IConfigurationService),Y(2,b.IEnvironmentService),Y(3,d.ILogService),Y(4,u.ITelemetryService)],l),e.PtyHostService=l}),define(te[35],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(te[213],ne([0,1,3,2,8,13,34,14,9,35]),function(J,e,T,_,D,L,i,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let I=class extends _.Disposable{constructor(d,m,u,S,v){super();this.extensionsManagementService=d,this.logService=S,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(y=>{this.installedExtensions=y.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(y=>this.onInstallExtension(y))),this._register(d.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(d.onDidUninstallExtension(y=>this.onDidUninstallExtension(y)));const g=D.URI.file(u.extensionsPath);this._register(m.watch(g)),this._register(T.Event.filter(m.onDidChangeFilesRaw,y=>y.changes.some(f=>this.doesChangeAffects(f,g)))(()=>this.onDidChange()))}doesChangeAffects(d,m){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),m)?this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(m,".obsolete"))?!0:!(d.type!==1&&d.type!==2||this.uriIdentityService.extUri.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const m of d)this.removeInstallingExtension(m.identifier),m.local&&this.addInstalledExtension(m.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(m=>!(0,i.areSameExtensions)(m,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(m=>!(0,i.areSameExtensions)(m,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),m=d.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,i.areSameExtensions)(v,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),u=this.installedExtensions.filter(S=>this.installingExtensions.some(v=>(0,i.areSameExtensions)(v,S))?!1:d.every(v=>!(0,i.areSameExtensions)(v.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=d.map(S=>S.identifier),(m.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:m,removed:u})}}};I=de([Y(1,R.IFileService),Y(2,L.INativeEnvironmentService),Y(3,E.ILogService),Y(4,b.IUriIdentityService)],I),e.ExtensionsWatcher=I}),define(te[214],ne([0,1,35,77,14,18,102,3,2]),function(J,e,T,_,D,L,i,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(d){this.uri=d,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let I=class{constructor(d){this._fileService=d,this._dispooables=new E.DisposableStore,this._limit=2**16;const m=new Map,u=S=>{let v=m.get(S.scheme);return v===void 0&&(v=d.hasProvider(S)&&!this._fileService.hasCapability(S,1024),m.set(S.scheme,v)),v};this._dispooables.add(R.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(S=>{m.delete(S.scheme)})),this.extUri=new L.ExtUri(u),this._canonicalUris=new i.SkipList((S,v)=>this.extUri.compare(S,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,L.normalizePath)(d));let m=this._canonicalUris.get(d);return m?m.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new b(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((u,S)=>u[1].touch<S[1].touch?1:u[1].touch>S[1].touch?-1:0);b._clock=0,this._canonicalUris.clear();const m=this._limit*.5;for(let u=0;u<m;u++)this._canonicalUris.set(d[u][0],d[u][1].touch())}};I=de([Y(0,D.IFileService)],I),e.UriIdentityService=I,(0,_.registerSingleton)(T.IUriIdentityService,I,!0)}),define(te[53],ne([0,1,39]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function _(i,R,E,b){const I=(0,T.setProperty)(i,R,E,b)[0];return I&&(i=i.substring(0,I.offset)+I.content+i.substring(I.offset+I.length)),i}e.edit=_;function D(i,R,E){let b=E;for(;b>=0;){if(i.charAt(b)===R.charAt(R.length-1)&&R.length===1)return b+1;if(b--,R.length===2&&b>=0&&i.charAt(b)===R.charAt(0))return b+2}return 0}e.getLineStartOffset=D;function L(i,R,E){let b=E;for(;b>=0;)if(i.charAt(b)===R.charAt(R.length-1)&&R.length===1||(b++,R.length===2&&b>=0&&i.charAt(b)===R.charAt(1)))return b;return i.length-1}e.getLineEndOffset=L}),define(te[215],ne([0,1,28,61,15]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(d,m,u,S,v){const g=[],y=[],f=[];if(!m){const O=d.filter(({identifier:q})=>v.every($=>$.toLowerCase()!==q.id.toLowerCase()));return{local:{added:g,removed:y,updated:f},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}d=d.map(I),m=m.map(I),u=u?u.map(I):null;const c=new Map,l=O=>{O.uuid&&c.set(O.id.toLowerCase(),O.uuid)};d.forEach(({identifier:O})=>l(O)),m.forEach(({identifier:O})=>l(O)),u&&u.forEach(({identifier:O})=>l(O));const r=O=>{const q=O.identifier.uuid||c.get(O.identifier.id.toLowerCase());return q?`uuid:${q}`:`id:${O.identifier.id.toLowerCase()}`},a=(O,q)=>(O.set(r(q),q),O),n=d.reduce(a,new Map),t=m.reduce(a,new Map),s=m.reduce((O,q)=>{const $=r(q);q=(0,T.deepClone)(q);const k=n.get($);return k&&(k.installed&&(q.installed=!0),q.version||(q.version=k.version)),a(O,q)},new Map),o=u?u.reduce(a,new Map):null,h=S.reduce(a,new Map),p=v.reduce((O,q)=>{const $=c.get(q.toLowerCase());return O.add($?`uuid:${$}`:`id:${q.toLowerCase()}`)},new Set),w=i(n,t,p);if(w.added.size>0||w.removed.size>0||w.updated.size>0){const O=i(o,n,p),q=i(o,t,p),$=(k,z)=>{const A=n.get(k);if(A){const F=t.get(k),x=z?F:A;return{...x,version:(F.version&&_.gt(F.version,A.version),A.version),state:R(A,F,o?.get(k)),preRelease:(0,D.isUndefined)(x.preRelease)?A.preRelease:x.preRelease}}};for(const k of q.removed.values()){const z=n.get(k);z&&y.push(z.identifier)}for(const k of q.added.values())if(O.added.has(k)){if(w.updated.has(k)){const z=$(k,!0);z&&(f.push(C(z,k)),s.set(k,z))}}else{const z=t.get(k);z.installed&&g.push(C(z,k))}for(const k of q.updated.values()){const z=$(k,!0);z&&(f.push(C(z,k)),s.set(k,z))}for(const k of O.added.values())q.added.has(k)||s.set(k,n.get(k));for(const k of O.updated.values())if(!q.removed.has(k)&&!q.updated.has(k)){const z=$(k,!1);z&&(s.get(k)?.installed&&(z.installed=!0),s.set(k,z))}for(const k of O.removed.values())!h.has(k)&&!q.updated.has(k)&&o?.get(k)?.installed&&s.delete(k)}const P=[],M=i(t,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(M.added.size>0||M.updated.size>0||M.removed.size>0)&&s.forEach((O,q)=>P.push(C(O,q))),{local:{added:g,removed:y,updated:f},remote:P.length?{added:[...M.added].map(O=>s.get(O)),updated:[...M.updated].map(O=>s.get(O)),removed:[...M.removed].map(O=>t.get(O)),all:P}:null}}e.merge=L;function i(d,m,u,{checkInstalledProperty:S,checkVersionProperty:v}={checkInstalledProperty:!1,checkVersionProperty:!1}){const g=d?[...d.keys()].filter(r=>!u.has(r)):[],y=[...m.keys()].filter(r=>!u.has(r)),f=y.filter(r=>g.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),c=g.filter(r=>y.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),l=new Set;for(const r of g){if(c.has(r))continue;const a=d.get(r),n=m.get(r);(!n||a.disabled!==n.disabled||a.preRelease!==n.preRelease||!b(a.state,n.state)||v&&a.version!==n.version||S&&a.installed!==n.installed)&&l.add(r)}return{added:f,removed:c,updated:l}}function R(d,m,u){const S=d.state,v=m.state,g=u?.state;if(!m.version||S&&_.gt(d.version,m.version))return S;if(v&&_.gt(m.version,d.version)||!S)return v;if(!v)return S;const y=(0,T.deepClone)(S),f=g?E(g,v):{added:Object.keys(v).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set},c=g?E(g,S):{added:Object.keys(S).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set};for(const l of[...f.added.values(),...f.updated.values()])y[l]=v[l];for(const l of f.removed.values())c.updated.has(l)||delete y[l];return y}function E(d,m){const u=Object.keys(d),S=Object.keys(m),v=S.filter(f=>u.indexOf(f)===-1).reduce((f,c)=>(f.add(c),f),new Set),g=u.filter(f=>S.indexOf(f)===-1).reduce((f,c)=>(f.add(c),f),new Set),y=new Set;for(const f of u){if(g.has(f))continue;const c=d[f],l=m[f];(0,T.equals)(c,l)||y.add(f)}return{added:v,removed:g,updated:y}}function b(d={},m={}){const{added:u,removed:S,updated:v}=E(d,m);return u.size===0&&S.size===0&&v.size===0}function I(d){return{...d,disabled:!!d.disabled,installed:!!d.installed}}function C(d,m){const u={identifier:{id:d.identifier.id,uuid:m.startsWith("uuid:")?m.substring("uuid:".length):void 0},preRelease:!!d.preRelease};return d.version&&(u.version=d.version),d.disabled&&(u.disabled=!0),d.installed&&(u.installed=!0),d.state&&(u.state=d.state),u}}),define(te[97],ne([0,1,16,3,2,34,6,27,23]),function(J,e,T,_,D,L,i,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,i.createDecorator)("IExtensionsStorageSyncService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let I=class it extends D.Disposable{constructor(d,m){super();this.storageService=d,this.productService=m,this._onDidChangeExtensionsStorage=this._register(new _.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}static toKey(d){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const m=b.exec(d);if(m&&m[1])return{id:m[1],version:m[2]}}initialize(){const d=this.storageService.keys(0,1);for(const m of d){const u=it.fromKey(m);u&&this.extensionsWithKeysForSync.add(u.id.toLowerCase())}}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const m=it.fromKey(d.key);if(m){this.extensionsWithKeysForSync.add(m.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(d,m){this.storageService.store(it.toKey(d),JSON.stringify(m),0,1)}getKeysForSync(d){const m=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],u=this.storageService.get(it.toKey(d),0),S=u?JSON.parse(u):void 0;return S&&m?(0,T.distinct)([...S,...m]):S||m}};I=de([Y(0,E.IStorageService),Y(1,R.IProductService)],I),e.ExtensionsStorageSyncService=I}),define(te[98],ne([0,1,16,21,6]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,E){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==R&&I!==`-${R}`),E&&b.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}updateSynchronizedExtensions(R,E){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==R&&I!==`-${R}`),E&&b.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}getIgnoredExtensions(R){const E=R.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(d=>d.toLowerCase()),I=[],C=[];if(Array.isArray(b))for(const d of b)d.startsWith("-")?C.push(d.substring(1)):I.push(d);return(0,T.distinct)([...E,...I].filter(d=>C.indexOf(d)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(E=>E.toLowerCase())}};L=de([Y(0,_.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(te[216],ne([0,1,16,31,28,158,53]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(c){return(0,_.parse)(c)||[]}e.parseKeybindings=R;async function E(c,l,r,a,n){const t=R(c),s=R(l),o=r?R(r):null,h=[...t,...s,...o||[]].map(F=>F.key),p=await n.resolveUserBindings(h);let w=I(t,s,o,p);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const P=d(t),M=d(s),O=o?d(o):null,q=u(P,M,p),$=O?u(O,P,p):{added:[...P.keys()].reduce((F,x)=>(F.add(x),F),new Set),removed:new Set,updated:new Set},k=O?u(O,M,p):{added:[...M.keys()].reduce((F,x)=>(F.add(x),F),new Set),removed:new Set,updated:new Set},z=b(q,$,k);let A=c;for(const F of z.removed.values())z.conflicts.has(F)||(A=y(A,F,a));for(const F of z.added.values()){if(z.conflicts.has(F))continue;const x=M.get(F);if(x.some(Z=>Z.command!==`-${F}`&&w.conflicts.has(p[Z.key]))){z.conflicts.add(F);continue}A=g(A,x,a)}for(const F of z.updated.values()){if(z.conflicts.has(F))continue;const x=M.get(F);if(x.some(Z=>Z.command!==`-${F}`&&w.conflicts.has(p[Z.key]))){z.conflicts.add(F);continue}A=f(A,F,x,a)}return{mergeContent:A,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.merge=E;function b(c,l,r){const a=new Set,n=new Set,t=new Set,s=new Set;for(const o of l.removed.values())r.updated.has(o)&&s.add(o);for(const o of r.removed.values())s.has(o)||(l.updated.has(o)?s.add(o):n.add(o));for(const o of l.added.values())s.has(o)||r.added.has(o)&&c.updated.has(o)&&s.add(o);for(const o of r.added.values())s.has(o)||(l.added.has(o)?c.updated.has(o)&&s.add(o):a.add(o));for(const o of l.updated.values())s.has(o)||r.updated.has(o)&&c.updated.has(o)&&s.add(o);for(const o of r.updated.values())s.has(o)||(l.updated.has(o)?c.updated.has(o)&&s.add(o):t.add(o));return{added:a,removed:n,updated:t,conflicts:s}}function I(c,l,r,a){const n=new Set,t=C(c,a),s=C(l,a),o=r?C(r,a):null,h=m(t,s);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const p=o?m(o,t):{added:[...t.keys()].reduce(($,k)=>($.add(k),$),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=o?m(o,s):{added:[...s.keys()].reduce(($,k)=>($.add(k),$),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:P,removed:M,updated:O,conflicts:q}=b(h,p,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:P,removed:M,updated:O,conflicts:q}}function C(c,l){const r=new Map;for(const a of c){const n=l[a.key];let t=r.get(n);t||(t=[],r.set(n,t)),t.push(a)}return r}function d(c){const l=new Map;for(const r of c){const a=r.command[0]==="-"?r.command.substring(1):r.command;let n=l.get(a);n||(n=[],l.set(a,n)),n.push(r)}return l}function m(c,l){const r=[...c.keys()],a=[...l.keys()],n=a.filter(o=>r.indexOf(o)===-1).reduce((o,h)=>(o.add(h),o),new Set),t=r.filter(o=>a.indexOf(o)===-1).reduce((o,h)=>(o.add(h),o),new Set),s=new Set;for(const o of r){if(t.has(o))continue;const h=c.get(o).map(w=>({...w,key:o})),p=l.get(o).map(w=>({...w,key:o}));(0,T.equals)(h,p,(w,P)=>v(w,P))||s.add(o)}return{added:n,removed:t,updated:s}}function u(c,l,r){const a=[...c.keys()],n=[...l.keys()],t=n.filter(h=>a.indexOf(h)===-1).reduce((h,p)=>(h.add(p),h),new Set),s=a.filter(h=>n.indexOf(h)===-1).reduce((h,p)=>(h.add(p),h),new Set),o=new Set;for(const h of a){if(s.has(h))continue;const p=c.get(h).map(P=>({...P,key:r[P.key]})),w=l.get(h).map(P=>({...P,key:r[P.key]}));S(p,w)||o.add(h)}return{added:t,removed:s,updated:o}}function S(c,l){return!(!(0,T.equals)(c.filter(({command:r})=>r[0]!=="-"),l.filter(({command:r})=>r[0]!=="-"),(r,a)=>v(r,a))||!(0,T.equals)(c.filter(({command:r})=>r[0]==="-"),l.filter(({command:r})=>r[0]==="-"),(r,a)=>v(r,a)))}function v(c,l){if(c.command!==l.command||c.key!==l.key)return!1;const r=L.ContextKeyExpr.deserialize(c.when),a=L.ContextKeyExpr.deserialize(l.when);return!(r&&!a||!r&&a||r&&a&&!r.equals(a)||!D.equals(c.args,l.args))}function g(c,l,r){for(const a of l)c=i.edit(c,[-1],a,r);return c}function y(c,l,r){const a=R(c);for(let n=a.length-1;n>=0;n--)(a[n].command===l||a[n].command===`-${l}`)&&(c=i.edit(c,[n],void 0,r));return c}function f(c,l,r,a){const n=R(c),t=n.findIndex(s=>s.command===l||s.command===`-${l}`);for(let s=n.length-1;s>=0;s--)(n[s].command===l||n[s].command===`-${l}`)&&(c=i.edit(c,[s],void 0,a));for(let s=r.length-1;s>=0;s--)c=i.edit(c,[t],r[s],a);return c}}),define(te[217],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function T(L,i,R){const E={},b={},I=new Set;if(!i)return{local:{added:E,updated:b,removed:[...I.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const C=_(L,i);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:E,updated:b,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=_(R,L),m=_(R,i),u={},S={},v=new Set,g=new Set;for(const y of d.removed.values())m.updated.has(y)?E[y]=i[y]:v.add(y);for(const y of m.removed.values())g.has(y)||(d.updated.has(y)?g.add(y):I.add(y));for(const y of d.updated.values())g.has(y)||(m.updated.has(y)?C.updated.has(y)&&g.add(y):S[y]=L[y]);for(const y of m.updated.values())g.has(y)||(d.updated.has(y)?C.updated.has(y)&&g.add(y):L[y]!==void 0&&(b[y]=i[y]));for(const y of d.added.values())g.has(y)||(m.added.has(y)?C.updated.has(y)&&g.add(y):u[y]=L[y]);for(const y of m.added.values())g.has(y)||(d.added.has(y)?C.updated.has(y)&&g.add(y):E[y]=i[y]);return{local:{added:E,removed:[...I.values()],updated:b},remote:{added:u,removed:[...v.values()],updated:S},conflicts:[...g.values()]}}e.merge=T;function _(L,i){const R=L?Object.keys(L):[],E=i?Object.keys(i):[],b=E.filter(d=>R.indexOf(d)===-1).reduce((d,m)=>(d.add(m),d),new Set),I=R.filter(d=>E.indexOf(d)===-1).reduce((d,m)=>(d.add(m),d),new Set),C=new Set;for(const d of R){if(I.has(d))continue;const m=L[d],u=i[d];m!==u&&C.add(d)}return{added:b,removed:I,updated:C}}function D(L,i){const{added:R,removed:E,updated:b}=_(L,i);return R.size===0&&E.size===0&&b.size===0}e.areSame=D}),define(te[24],ne([0,1,16,18,15,147,42,30,6,87,37]),function(J,e,T,_,D,L,i,R,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const o=I.Registry.as(i.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(h=>!!o[h].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function d(){const o=I.Registry.as(i.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(o).filter(P=>!!o[P].ignoreSync),p=Object.keys(o).filter(P=>o[P].scope===2||o[P].scope===6),w=C();return(0,T.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...h,...p,...w])}e.getDefaultIgnoredSettings=d,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function m(){const o="vscode://schemas/ignoredSettings",h=I.Registry.as(i.Extensions.Configuration);h.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const p=I.Registry.as(b.Extensions.JSONContribution),w=()=>{const P=C(),M=d().filter(k=>k!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(i.allSettings.properties).filter(k=>M.indexOf(k)===-1),q=M.filter(k=>P.indexOf(k)===-1),$={items:{type:"string",enum:[...O,...q.map(k=>`-${k}`)]}};p.registerSchema(o,$)};return h.onDidUpdateConfiguration(()=>w())}e.registerConfiguration=m;function u(o){return o&&(0,D.isObject)(o)&&(0,D.isString)(o.id)&&(0,D.isArray)(o.scopes)}e.isAuthenticationProvider=u;var S;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function v(o,h,p){return p.joinPath(h.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=v,e.IUserDataSyncStoreManagementService=(0,E.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,E.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,E.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function g(o){const h={};return h[e.HEADER_EXECUTION_ID]=o,h}e.createSyncHeaders=g;var y;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(y=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class f extends Error{constructor(h,p,w,P){super(h);this.code=p,this.resource=w,this.operationId=P,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=f;class c extends f{constructor(h,p,w,P,M){super(h,w,void 0,M);this.url=p,this.serverCode=P}}e.UserDataSyncStoreError=c;class l extends f{constructor(h,p){super(h,p)}}e.UserDataAutoSyncError=l,function(o){function h(p){if(p instanceof o)return p;const w=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(p.name);if(w&&w[1]){const P=w[2]==="unknown"?void 0:w[2],M=w[3]==="unknown"?void 0:w[3];return new o(p.message,w[1],P,M)}return new o(p.message,"Unknown")}o.toUserDataSyncError=h}(f=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var a;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var n;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(o){return`sync.enable.${o}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,E.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,E.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,E.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,E.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,E.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function s(o,h){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:h.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(p=>(0,_.isEqualOrParent)(o,(0,_.joinPath)(h.userDataSyncHome,p,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=s}),define(te[47],ne([0,1,16,5,19,26,3,31,2,25,15,8,143,21,13,14,9,46,23,22,35,24]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v,g,y,f,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=r;let a=class extends E.Disposable{constructor(h,p,w,P,M,O,q,$,k,z,A){super();this.resource=h,this.fileService=p,this.environmentService=w,this.userDataSyncStoreService=M,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=q,this.telemetryService=$,this.logService=k,this.configurationService=z,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new i.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new i.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new _.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new i.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,b.uppercaseFirstLetter)(this.resource),this.extUri=A.extUri,this.syncFolder=this.extUri.joinPath(w.userDataSyncHome,h),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(h,w,this.extUri),this.currentMachineIdPromise=(0,g.getServiceMachineId)(w,p,P)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const h=await this.syncPreviewPromise;this.syncPreviewPromise=null;const p=await this.performSync(h.remoteUserData,h.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(p)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const h=await this.getLastSyncUserData();(h?(await this.doGenerateSyncResourcePreview(h,h,!0,this.getUserDataSyncConfiguration(),L.CancellationToken.None)).resourcePreviews.some(({remoteChange:w})=>w!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(h){if(this._status!==h){const p=this._status;h==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),p==="hasConflicts"&&h==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=h,this._onDidChangStatus.fire(h)}}async sync(h,p={}){await this._sync(h,!0,this.getUserDataSyncConfiguration(),p)}async preview(h,p,w={}){return this._sync(h,!1,p,w)}async apply(h,p={}){try{this.syncHeaders={...p};const w=await this.doApply(h);return this.setStatus(w),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(h,p,w,P){try{if(this.syncHeaders={...P},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let M="idle";try{const O=await this.getLastSyncUserData(),q=await this.getLatestRemoteUserData(h,O);return M=await this.performSync(q,O,p,w),M==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):M==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(M)}}finally{this.syncHeaders={}}}async replace(h){const p=await this.resolveContent(h);if(!p)return!1;const w=this.parseSyncData(p);if(!w)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const P=await this.getLastSyncUserData(),M=await this.getLatestRemoteUserData(null,P),O=await this.isRemoteDataFromCurrentMachine(M),q=await this.generateSyncPreview({ref:M.ref,syncData:w},P,O,this.getUserDataSyncConfiguration(),L.CancellationToken.None),$=[];for(const k of q){const z=await this.getAcceptResult(k,k.remoteResource,void 0,L.CancellationToken.None),{remoteChange:A}=await this.getAcceptResult(k,k.previewResource,k.remoteContent,L.CancellationToken.None);$.push([k,{...z,remoteChange:A!==0?A:2}])}await this.applyResult(M,P,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(h){const p=await this.currentMachineIdPromise;return!!h.syncData?.machineId&&h.syncData.machineId===p}async getLatestRemoteUserData(h,p){if(p){const w=h&&h.latest?h.latest[this.resource]:void 0;if(p.ref===w||w===void 0&&p.syncData===null)return p}return this.getRemoteUserData(p)}async performSync(h,p,w,P){if(h.syncData&&h.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,d.localize)(0,null,this.resource,this.version,h.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(h,p,w,P)}catch(M){if(M instanceof l.UserDataSyncError)switch(M.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(h,p,w,P);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),h=await this.getRemoteUserData(null),p=await this.getLastSyncUserData(),this.performSync(h,p,w,P)}throw M}}async doSync(h,p,w,P){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,_.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(h,p,w,P,O)));const M=await this.syncPreviewPromise;return this.updateConflicts(M.resourcePreviews),M.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":w?await this.doApply(!1):"syncing"}catch(M){throw this.syncPreviewPromise=null,M}}async merge(h){return await this.updateSyncResourcePreview(h,async p=>{const w=await this.getMergeResult(p,L.CancellationToken.None);await this.fileService.writeFile(p.previewResource,D.VSBuffer.fromString(w?.content||""));const P=w&&!w.hasConflicts?await this.getAcceptResult(p,p.previewResource,void 0,L.CancellationToken.None):void 0;return p.acceptResult=P,p.mergeState=w.hasConflicts?"conflict":P?"accepted":"preview",p.localChange=P?P.localChange:w.localChange,p.remoteChange=P?P.remoteChange:w.remoteChange,p}),this.syncPreviewPromise}async accept(h,p){return await this.updateSyncResourcePreview(h,async w=>{const P=await this.getAcceptResult(w,h,p,L.CancellationToken.None);return w.acceptResult=P,w.mergeState="accepted",w.localChange=P.localChange,w.remoteChange=P.remoteChange,w}),this.syncPreviewPromise}async discard(h){return await this.updateSyncResourcePreview(h,async p=>{const w=await this.getMergeResult(p,L.CancellationToken.None);return await this.fileService.writeFile(p.previewResource,D.VSBuffer.fromString(w.content||"")),p.acceptResult=void 0,p.mergeState="preview",p.localChange=w.localChange,p.remoteChange=w.remoteChange,p}),this.syncPreviewPromise}async updateSyncResourcePreview(h,p){if(!this.syncPreviewPromise)return;let w=await this.syncPreviewPromise;const P=w.resourcePreviews.findIndex(({localResource:M,remoteResource:O,previewResource:q})=>this.extUri.isEqual(M,h)||this.extUri.isEqual(O,h)||this.extUri.isEqual(q,h));P!==-1&&(this.syncPreviewPromise=(0,_.createCancelablePromise)(async M=>{const O=[...w.resourcePreviews];return O[P]=await p(O[P]),{...w,resourcePreviews:O}}),w=await this.syncPreviewPromise,this.updateConflicts(w.resourcePreviews),w.resourcePreviews.some(({mergeState:M})=>M==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(h){if(!this.syncPreviewPromise)return"idle";const p=await this.syncPreviewPromise;return p.resourcePreviews.some(({mergeState:w})=>w==="conflict")?"hasConflicts":p.resourcePreviews.some(({mergeState:w})=>w!=="accepted")?"syncing":(await this.applyResult(p.remoteUserData,p.lastSyncUserData,p.resourcePreviews.map(w=>[w,w.acceptResult]),h),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(h){}}updateConflicts(h){const p=h.filter(({mergeState:w})=>w==="conflict");(0,T.equals)(this._conflicts,p,(w,P)=>this.extUri.isEqual(w.previewResource,P.previewResource))||(this._conflicts=p,this._onDidChangeConflicts.fire(p))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:p,ref:w})=>({created:p,uri:this.toRemoteBackupResource(w)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:p,ref:w})=>({created:p,uri:this.toLocalBackupResource(w)}))}toRemoteBackupResource(h){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${h}`})}toLocalBackupResource(h){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${h}`})}async getMachineId({uri:h}){const p=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(p))){const{content:w}=await this.getUserData(p);if(w)return this.parseSyncData(w)?.machineId}}async resolveContent(h){const p=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(p))){const{content:w}=await this.getUserData(p);return w}return this.extUri.isEqual(h,this.toLocalBackupResource(p))?this.userDataSyncBackupStoreService.resolveContent(this.resource,p):null}async resolvePreviewContent(h){const p=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(p)for(const w of p.resourcePreviews){if(this.extUri.isEqual(w.acceptedResource,h))return w.acceptResult?w.acceptResult.content:null;if(this.extUri.isEqual(w.remoteResource,h))return w.remoteContent;if(this.extUri.isEqual(w.localResource,h))return w.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(h){}}async doGenerateSyncResourcePreview(h,p,w,P,M){const O=await this.isRemoteDataFromCurrentMachine(h),q=await this.generateSyncPreview(h,p,O,P,M),$=[];for(const k of q){const z=k.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(k.localChange===0&&k.remoteChange===0)$.push({...k,acceptedResource:z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const A=w?await this.getMergeResult(k,M):void 0;if(M.isCancellationRequested)break;await this.fileService.writeFile(k.previewResource,D.VSBuffer.fromString(A?.content||""));const F=A&&!A.hasConflicts?await this.getAcceptResult(k,k.previewResource,void 0,M):void 0;$.push({...k,acceptResult:F,mergeState:A?.hasConflicts?"conflict":F?"accepted":"preview",localChange:F?F.localChange:A?A.localChange:k.localChange,remoteChange:F?F.remoteChange:A?A.remoteChange:k.remoteChange})}}return{remoteUserData:h,lastSyncUserData:p,resourcePreviews:$,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const h=await this.fileService.readFile(this.lastSyncResource),p=JSON.parse(h.value.toString()),w=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=p.version&&w&&p.version!==w,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${p.version} is not compatible with current sync state version ${w}.`),await this.resetLocal(),null;const P=p;if(P.content===null)return{ref:p.ref,syncData:null};const M=JSON.parse(P.content);if(r(M))return{...p,syncData:M,content:void 0}}catch(h){h instanceof S.FileOperationError&&h.fileOperationResult===1||this.logService.error(h)}return null}async updateLastSyncUserData(h,p={}){if(p.ref||p.content||p.version)throw new Error("Cannot have core properties as additional");const w=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),P={ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null,version:w,...p};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(P)))}async getRemoteUserData(h){const{ref:p,content:w}=await this.getUserData(h);let P=null;return w!==null&&(P=this.parseSyncData(w)),{ref:p,syncData:P}}parseSyncData(h){try{const p=JSON.parse(h);if(r(p))return p}catch(p){this.logService.error(p)}throw new l.UserDataSyncError((0,d.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(h){if((0,I.isString)(h)){const p=await this.userDataSyncStoreService.resolveContent(this.resource,h);return{ref:h,content:p}}else{const p=h?{ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,p,this.syncHeaders)}}async updateRemoteUserData(h,p){const w=await this.currentMachineIdPromise,P={version:this.version,machineId:w,content:h};return p=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(P),p,this.syncHeaders),{ref:p,syncData:P}}async backupLocal(h){const p={version:this.version,content:h};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(p))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=de([Y(1,S.IFileService),Y(2,u.IEnvironmentService),Y(3,y.IStorageService),Y(4,l.IUserDataSyncStoreService),Y(5,l.IUserDataSyncBackupStoreService),Y(6,l.IUserDataSyncEnablementService),Y(7,f.ITelemetryService),Y(8,l.IUserDataSyncLogService),Y(9,m.IConfigurationService),Y(10,c.IUriIdentityService)],a),e.AbstractSynchroniser=a;let n=class extends a{constructor(h,p,w,P,M,O,q,$,k,z,A,F){super(p,w,P,M,O,q,$,k,z,A,F);this.file=h,this._register(this.fileService.watch(this.extUri.dirname(h))),this._register(this.fileService.onDidFilesChange(x=>this.onFileChanges(x)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(h){return null}}async updateLocalFileContent(h,p,w){try{p?await this.writeFileContent(h,p,w):await this.fileService.createFile(this.file,D.VSBuffer.fromString(h),{overwrite:w})}catch(P){throw P instanceof S.FileOperationError&&P.fileOperationResult===1||P instanceof S.FileOperationError&&P.fileOperationResult===3?new l.UserDataSyncError(P.message,"LocalPreconditionFailed"):P}}async writeFileContent(h,p,w){await this.fileService.writeFile(this.file,D.VSBuffer.fromString(h),w?void 0:p)}onFileChanges(h){!h.contains(this.file)||this.triggerLocalChange()}};n=de([Y(2,S.IFileService),Y(3,u.IEnvironmentService),Y(4,y.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncBackupStoreService),Y(7,l.IUserDataSyncEnablementService),Y(8,f.ITelemetryService),Y(9,l.IUserDataSyncLogService),Y(10,m.IConfigurationService),Y(11,c.IUriIdentityService)],n),e.AbstractFileSynchroniser=n;let t=class extends n{constructor(h,p,w,P,M,O,q,$,k,z,A,F,x){super(h,p,w,P,M,O,q,$,k,z,F,x);this.userDataSyncUtilService=A,this._formattingOptions=void 0}hasErrors(h){const p=[];return(0,R.parse)(h,p,{allowEmptyContent:!0,allowTrailingComma:!0}),p.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([Y(2,S.IFileService),Y(3,u.IEnvironmentService),Y(4,y.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncBackupStoreService),Y(7,l.IUserDataSyncEnablementService),Y(8,f.ITelemetryService),Y(9,l.IUserDataSyncLogService),Y(10,l.IUserDataSyncUtilService),Y(11,m.IConfigurationService),Y(12,c.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let s=class{constructor(h,p,w,P,M){this.resource=h,this.environmentService=p,this.logService=w,this.fileService=P,this.extUri=M.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,p,this.extUri)}async initialize({ref:h,content:p}){if(!p){this.logService.info("Remote content does not exist.",this.resource);return}const w=this.parseSyncData(p);if(!!w)try{await this.doInitialize({ref:h,syncData:w})}catch(P){this.logService.error(P)}}parseSyncData(h){try{const p=JSON.parse(h);if(r(p))return p}catch(p){this.logService.error(p)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(h,p={}){const w={ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null,...p};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(w)))}};s=de([Y(1,u.IEnvironmentService),Y(2,v.ILogService),Y(3,S.IFileService),Y(4,c.IUriIdentityService)],s),e.AbstractInitializer=s}),define(te[218],ne([0,1,5,26,7,3,39,48,25,8,21,13,30,34,14,9,23,22,35,47,215,97,98,24]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v,g,y,f,c,l,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function n(p,w){const P=JSON.parse(p.content);if(p.version===1||p.version===2){const M=(await w.getInstalled(0)).filter(O=>O.isBuiltin);for(const O of P)p.version===1&&(O.enabled===!1&&(O.disabled=!0),delete O.enabled),p.version===2&&M.every(q=>!(0,m.areSameExtensions)(q.identifier,O.identifier))&&(O.installed=!0)}return P}function t(p,w,P){const M=P.get((0,m.getExtensionId)(p,w),0)||"{}";return JSON.parse(M)}e.getExtensionStorageState=t;function s(p,w,P,M){M.store((0,m.getExtensionId)(p,w),JSON.stringify(P),0,1)}e.storeExtensionStorageState=s;let o=class mt extends f.AbstractSynchroniser{constructor(w,P,M,O,q,$,k,z,A,F,x,Z,B,j,X){super("extensions",P,w,M,O,q,Z,B,A,x,X);this.storageService=M,this.extensionManagementService=$,this.extensionEnablementService=k,this.ignoredExtensionsManagementService=z,this.extensionGalleryService=F,this.extensionsStorageSyncService=j,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.debounce(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,U=>U.some(({local:N})=>!!N)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,U=>!U.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(w,P){const M=w.syncData?await n(w.syncData,this.extensionManagementService):null,O=P?.skippedExtensions||[],q=P?.syncData?await n(P.syncData,this.extensionManagementService):null,$=await this.extensionManagementService.getInstalled(void 0,!0),k=this.getLocalExtensions($),z=this.ignoredExtensionsManagementService.getIgnoredExtensions($);M?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:A,remote:F}=(0,c.merge)(k,M,q,O,z),x={local:A,remote:F,content:this.getPreviewContent(k,A.added,A.updated,A.removed),localChange:A.added.length>0||A.removed.length>0||A.updated.length>0?2:0,remoteChange:F!==null?2:0};return[{skippedExtensions:O,localResource:this.localResource,localContent:this.format(k),localExtensions:k,remoteResource:this.remoteResource,remoteContent:M?this.format(M):null,previewResource:this.previewResource,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(w,P,M,O){const q=[...P,...M],$=new Set,k=z=>{$.add(z.id.toLowerCase()),z.uuid&&$.add(z.uuid)};q.forEach(({identifier:z})=>k(z)),O.forEach(k);for(const z of w)$.has(z.identifier.id.toLowerCase())||z.identifier.uuid&&$.has(z.identifier.uuid)||q.push(z);return this.format(q)}async getMergeResult(w,P){return{...w.previewResult,hasConflicts:!1}}async getAcceptResult(w,P,M,O){if(this.extUri.isEqual(P,this.localResource))return this.acceptLocal(w);if(this.extUri.isEqual(P,this.remoteResource))return this.acceptRemote(w);if(this.extUri.isEqual(P,this.previewResource))return w.previewResult;throw new Error(`Invalid Resource: ${P.toString()}`)}async acceptLocal(w){const P=await this.extensionManagementService.getInstalled(),M=this.ignoredExtensionsManagementService.getIgnoredExtensions(P),O=(0,c.merge)(w.localExtensions,null,null,w.skippedExtensions,M),{local:q,remote:$}=O;return{content:w.localContent,local:q,remote:$,localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:$!==null?2:0}}async acceptRemote(w){const P=await this.extensionManagementService.getInstalled(),M=this.ignoredExtensionsManagementService.getIgnoredExtensions(P),O=w.remoteContent?JSON.parse(w.remoteContent):null;if(O!==null){const q=(0,c.merge)(w.localExtensions,O,w.localExtensions,[],M),{local:$,remote:k}=q;return{content:w.remoteContent,local:$,remote:k,localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:k!==null?2:0}}else return{content:w.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(w,P,M,O){let{skippedExtensions:q,localExtensions:$}=M[0][0],{local:k,remote:z,localChange:A,remoteChange:F}=M[0][1];if(A===0&&F===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),A!==0&&(await this.backupLocal(JSON.stringify($)),q=await this.updateLocalExtensions(k.added,k.removed,k.updated,q)),z){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const x=JSON.stringify(z.all);w=await this.updateRemoteUserData(x,O?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(Z=>Z.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(Z=>Z.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(Z=>Z.identifier.id))}.`:""}`)}P?.ref!==w.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(w,{skippedExtensions:q}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${q.length?` Skipped: ${JSON.stringify(q.map(x=>x.identifier.id))}.`:""}`))}async getAssociatedResources({uri:w}){return[{resource:this.extUri.joinPath(w,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(w){if(this.extUri.isEqual(w,mt.EXTENSIONS_DATA_URI)){const M=await this.extensionManagementService.getInstalled(),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(M),q=this.getLocalExtensions(M).filter($=>!O.some(k=>(0,m.areSameExtensions)({id:k},$.identifier)));return this.format(q)}if(this.extUri.isEqual(this.remoteResource,w)||this.extUri.isEqual(this.localResource,w)||this.extUri.isEqual(this.acceptedResource,w))return this.resolvePreviewContent(w);let P=await super.resolveContent(w);if(P)return P;if(P=await super.resolveContent(this.extUri.dirname(w)),P){const M=this.parseSyncData(P);if(M)switch(this.extUri.basename(w)){case"extensions.json":return this.format(this.parseExtensions(M))}}return null}format(w){w.sort((O,q)=>!O.identifier.uuid&&q.identifier.uuid?-1:O.identifier.uuid&&!q.identifier.uuid?1:(0,E.compare)(O.identifier.id,q.identifier.id));const P=JSON.stringify(w),M=(0,R.format)(P,void 0,{});return(0,i.applyEdits)(P,M)}async hasLocalData(){try{const w=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(w).some(M=>M.installed||M.disabled))return!0}catch(w){}return!1}async updateLocalExtensions(w,P,M,O){const q=[],$=[],k=await this.extensionManagementService.getInstalled();if(P.length){const A=k.filter(({identifier:F,isBuiltin:x})=>!x&&P.some(Z=>(0,m.areSameExtensions)(F,Z)));await T.Promises.settled(A.map(async F=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,F.identifier.id),await this.extensionManagementService.uninstall(F,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,F.identifier.id),q.push(F.identifier)}))}(w.length||M.length)&&await T.Promises.settled([...w,...M].map(async A=>{const F=k.find(Z=>(0,m.areSameExtensions)(Z.identifier,A.identifier));if(F&&F.isBuiltin){A.state&&F.manifest.version===A.version&&this.updateExtensionState(A.state,F.manifest.publisher,F.manifest.name,F.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(B=>(0,m.areSameExtensions)(B,A.identifier))!==!!A.disabled&&(A.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,A.identifier.id),await this.extensionEnablementService.disableExtension(A.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,A.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,A.identifier.id),await this.extensionEnablementService.enableExtension(A.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,A.identifier.id))),q.push(A.identifier);return}const x=(await this.extensionGalleryService.getExtensions([A.identifier],!!A.preRelease,_.CancellationToken.None))[0];if(A.state&&(F?F.manifest.version===A.version:!!x)){const Z=F?F.manifest.publisher:x.publisher,B=F?F.manifest.name:x.name;this.updateExtensionState(A.state,Z,B,F?.manifest.version)}if(x)try{this.extensionEnablementService.getDisabledExtensions().some(B=>(0,m.areSameExtensions)(B,A.identifier))!==!!A.disabled&&(A.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,A.identifier.id,x.version),await this.extensionEnablementService.disableExtension(x.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,A.identifier.id,x.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,A.identifier.id,x.version),await this.extensionEnablementService.enableExtension(x.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,A.identifier.id,x.version))),(!F||F.preRelease!==A.preRelease)&&(await this.extensionManagementService.canInstall(x)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,A.identifier.id,x.version),await this.extensionManagementService.installFromGallery(x,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:A.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,A.identifier.id,x.version),q.push(x.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,x.displayName||x.identifier.id),$.push(A)))}catch(Z){$.push(A),Z instanceof d.ExtensionManagementError&&[d.ExtensionManagementErrorCode.Incompatible,d.ExtensionManagementErrorCode.IncompatiblePreRelease,d.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(Z.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,x.displayName||x.identifier.id):(this.logService.error(Z),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,x.displayName||x.identifier.id))}else $.push(A),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,A.identifier.id)}));const z=[];for(const A of O)q.some(F=>(0,m.areSameExtensions)(F,A.identifier))||z.push(A);for(const A of $)z.some(F=>(0,m.areSameExtensions)(F.identifier,A.identifier))||z.push(A);return z}updateExtensionState(w,P,M,O){const q=t(P,M,this.storageService),$=O?this.extensionsStorageSyncService.getKeysForSync({id:(0,m.getGalleryExtensionId)(P,M),version:O}):void 0;$?$.forEach(k=>{q[k]=w[k]}):Object.keys(w).forEach(k=>q[k]=w[k]),s(P,M,q,this.storageService)}parseExtensions(w){return JSON.parse(w.content)}getLocalExtensions(w){const P=this.extensionEnablementService.getDisabledExtensions();return w.map(({identifier:M,isBuiltin:O,manifest:q,preRelease:$})=>{const k={identifier:M,version:q.version,preRelease:$};P.some(z=>(0,m.areSameExtensions)(z,M))&&(k.disabled=!0),O||(k.installed=!0);try{const z=this.extensionsStorageSyncService.getKeysForSync({id:M.id,version:q.version});if(z){const A=t(q.publisher,q.name,this.storageService);k.state=Object.keys(A).reduce((F,x)=>(z.includes(x)&&(F[x]=A[x]),F),{})}}catch(z){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(z))}return k})}};o.EXTENSIONS_DATA_URI=b.URI.from({scheme:a.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),o=de([Y(0,C.IEnvironmentService),Y(1,u.IFileService),Y(2,v.IStorageService),Y(3,a.IUserDataSyncStoreService),Y(4,a.IUserDataSyncBackupStoreService),Y(5,d.IExtensionManagementService),Y(6,d.IGlobalExtensionEnablementService),Y(7,r.IIgnoredExtensionsManagementService),Y(8,a.IUserDataSyncLogService),Y(9,d.IExtensionGalleryService),Y(10,I.IConfigurationService),Y(11,a.IUserDataSyncEnablementService),Y(12,g.ITelemetryService),Y(13,l.IExtensionsStorageSyncService),Y(14,y.IUriIdentityService)],o),e.ExtensionsSynchroniser=o;let h=class extends f.AbstractInitializer{constructor(w,P,M,O,q,$){super("extensions",O,q,M,$);this.extensionManagementService=w,this.ignoredExtensionsManagementService=P}async parseExtensions(w){return w.syncData?await n(w.syncData,this.extensionManagementService):null}generatePreview(w,P){const M=[],O=[],q=[];for(const $ of w){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension($.identifier.id))continue;const k=P.find(z=>(0,m.areSameExtensions)(z.identifier,$.identifier));k?(M.push(k),$.disabled&&q.push($.identifier)):$.installed&&(O.push($.identifier),$.disabled&&q.push($.identifier))}return{installedExtensions:M,newExtensions:O,disabledExtensions:q,remoteExtensions:w}}};h=de([Y(0,d.IExtensionManagementService),Y(1,r.IIgnoredExtensionsManagementService),Y(2,u.IFileService),Y(3,C.IEnvironmentService),Y(4,S.ILogService),Y(5,y.IUriIdentityService)],h),e.AbstractExtensionsInitializer=h}),define(te[219],ne([0,1,28,24]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(R,E,b,I,C){if(!E)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const d=L(R,E);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const m=b?L(b,E):{added:Object.keys(E).reduce((y,f)=>(y.add(f),y),new Set),removed:new Set,updated:new Set},u=b?L(b,R):{added:Object.keys(R).reduce((y,f)=>(y.add(f),y),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},v=T.deepClone(E),g=!b;for(const y of u.added.values())y!==_.SYNC_SERVICE_URL_TYPE&&g&&m.added.has(y)||(v[y]=R[y]);for(const y of u.updated.values())v[y]=R[y];for(const y of u.removed.values())I.unregistered.includes(y)||delete v[y];for(const y of m.added.values()){const f=E[y];if(I.machine.includes(y)){C.info(`GlobalState: Skipped adding ${y} in local storage because it is declared as machine scoped.`);continue}if(b&&u.added.has(y))continue;const c=R[y];c&&c.value===f.value||y===_.SYNC_SERVICE_URL_TYPE&&g&&u.added.has(y)||(c?S.updated[y]=f:S.added[y]=f)}for(const y of m.updated.values()){const f=E[y];if(I.machine.includes(y)){C.info(`GlobalState: Skipped updating ${y} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(y)||u.removed.has(y))continue;const c=R[y];c&&c.value===f.value||(S.updated[y]=f)}for(const y of m.removed.values()){if(I.machine.includes(y)){C.trace(`GlobalState: Skipped removing ${y} in local storage because it is declared as machine scoped.`);continue}u.updated.has(y)||u.removed.has(y)||S.removed.push(y)}return{local:S,remote:i(v,E)?null:v}}e.merge=D;function L(R,E){const b=Object.keys(R),I=Object.keys(E),C=I.filter(u=>b.indexOf(u)===-1).reduce((u,S)=>(u.add(S),u),new Set),d=b.filter(u=>I.indexOf(u)===-1).reduce((u,S)=>(u.add(S),u),new Set),m=new Set;for(const u of b){if(d.has(u))continue;const S=R[u],v=E[u];T.equals(S,v)||m.add(u)}return{added:C,removed:d,updated:m}}function i(R,E){const{added:b,removed:I,updated:C}=L(R,E);return b.size===0&&I.size===0&&C.size===0}}),define(te[220],ne([0,1,19,7,3,31,39,48,4,8,29,21,13,14,9,46,23,22,35,47,53,219,24]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v,g,y,f,c,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const a="globalState.argv.",n=["locale"];function t(w){const P=w.storage?Object.keys(w.storage).sort():[],M={};P.forEach($=>M[$]=w.storage[$]),w.storage=M;const O=JSON.stringify(w),q=(0,R.format)(O,void 0,{});return(0,i.applyEdits)(O,q)}const s=1;let o=class vt extends f.AbstractSynchroniser{constructor(P,M,O,q,$,k,z,A,F,x){super("globalState",P,$,F,M,O,k,z,q,A,x);this.storageService=F,this.version=s,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(P.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(D.Event.any(D.Event.filter(P.onDidFilesChange,Z=>Z.contains(this.environmentService.argvResource)),D.Event.filter(F.onDidChangeValue,Z=>Z.scope===0&&Z.target!==void 0?Z.target===0:F.keys(0,0).includes(Z.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(P,M,O){const q=P.syncData?JSON.parse(P.syncData.content):null;M=M===null&&O?P:M;const $=M&&M.syncData?JSON.parse(M.syncData.content):null,k=await this.getLocalGlobalState();q?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const z=this.getStorageKeys($),{local:A,remote:F}=(0,l.merge)(k.storage,q?q.storage:null,$?$.storage:null,z,this.logService),x={content:null,local:A,remote:F,localChange:Object.keys(A.added).length>0||Object.keys(A.updated).length>0||A.removed.length>0?2:0,remoteChange:F!==null?2:0};return[{localResource:this.localResource,localContent:t(k),localUserData:k,remoteResource:this.remoteResource,remoteContent:q?t(q):null,previewResource:this.previewResource,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.acceptedResource,storageKeys:z}]}async getMergeResult(P,M){return{...P.previewResult,hasConflicts:!1}}async getAcceptResult(P,M,O,q){if(this.extUri.isEqual(M,this.localResource))return this.acceptLocal(P);if(this.extUri.isEqual(M,this.remoteResource))return this.acceptRemote(P);if(this.extUri.isEqual(M,this.previewResource))return P.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async acceptLocal(P){return{content:P.localContent,local:{added:{},removed:[],updated:{}},remote:P.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(P){if(P.remoteContent!==null){const M=JSON.parse(P.remoteContent),{local:O,remote:q}=(0,l.merge)(P.localUserData.storage,M.storage,null,P.storageKeys,this.logService);return{content:P.remoteContent,local:O,remote:q,localChange:Object.keys(O.added).length>0||Object.keys(O.updated).length>0||O.removed.length>0?2:0,remoteChange:q!==null?2:0}}else return{content:P.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(P,M,O,q){let{localUserData:$}=O[0][0],{local:k,remote:z,localChange:A,remoteChange:F}=O[0][1];if(A===0&&F===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),A!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify($)),await this.writeLocalGlobalState(k),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),F!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const x=JSON.stringify({storage:z});P=await this.updateRemoteUserData(x,q?null:P.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}M?.ref!==P.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(P),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:P}){return[{resource:this.extUri.joinPath(P,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(P){if(this.extUri.isEqual(P,vt.GLOBAL_STATE_DATA_URI)){const O=await this.getLocalGlobalState();return t(O)}if(this.extUri.isEqual(this.remoteResource,P)||this.extUri.isEqual(this.localResource,P)||this.extUri.isEqual(this.acceptedResource,P))return this.resolvePreviewContent(P);let M=await super.resolveContent(P);if(M)return M;if(M=await super.resolveContent(this.extUri.dirname(P)),M){const O=this.parseSyncData(M);if(O)switch(this.extUri.basename(P)){case"globalState.json":return t(JSON.parse(O.content))}}return null}async hasLocalData(){try{const{storage:P}=await this.getLocalGlobalState();if(Object.keys(P).length>1||P[`${a}.locale`]?.value!=="en")return!0}catch(P){}return!1}async getLocalGlobalState(){const P={},M=await this.getLocalArgvContent(),O=(0,L.parse)(M);for(const q of n)O[q]!==void 0&&(P[`${a}${q}`]={version:1,value:O[q]});for(const q of this.storageService.keys(0,0)){const $=this.storageService.get(q,0);$&&(P[q]={version:1,value:$})}return{storage:P}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const P=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),P.value.toString()}catch(P){this.logService.debug((0,_.getErrorMessage)(P))}return"{}"}async writeLocalGlobalState({added:P,removed:M,updated:O}){const q={},$={},k=(A,F)=>{for(const x of A){if(x.startsWith(a)){q[x.substring(a.length)]=F?F[x].value:void 0;continue}if(F){const Z=F[x];Z.value!==String(this.storageService.get(x,0))&&($[x]=Z.value)}else this.storageService.get(x,0)!==void 0&&($[x]=void 0)}};if(k(Object.keys(P),P),k(Object.keys(O),O),k(M),Object.keys(q).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(q),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys($).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const A of Object.keys($))this.storageService.store(A,$[A],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys($))}}async updateArgv(P){const M=await this.getLocalArgvContent();let O=M;for(const q of Object.keys(P))O=(0,c.edit)(O,[q],P[q],{});M!==O&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,T.VSBuffer.fromString(O)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(P){const M=this.storageService.keys(0,0),O=this.storageService.keys(0,1),q=[...M,...O],$=P?.storage?Object.keys(P.storage).filter(k=>!k.startsWith(a)&&!q.includes(k)&&this.storageService.get(k,0)!==void 0):[];if(!E.isWeb){const k=[...r.ALL_SYNC_RESOURCES.map(z=>(0,r.getEnablementKey)(z)),r.SYNC_SERVICE_URL_TYPE];$.push(...k),O.push(...k)}return{user:M,machine:O,unregistered:$}}};o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=de([Y(0,m.IFileService),Y(1,r.IUserDataSyncStoreService),Y(2,r.IUserDataSyncBackupStoreService),Y(3,r.IUserDataSyncLogService),Y(4,d.IEnvironmentService),Y(5,r.IUserDataSyncEnablementService),Y(6,g.ITelemetryService),Y(7,C.IConfigurationService),Y(8,v.IStorageService),Y(9,y.IUriIdentityService)],o),e.GlobalStateSynchroniser=o;let h=class extends f.AbstractInitializer{constructor(P,M,O,q,$){super("globalState",O,q,M,$);this.storageService=P}async doInitialize(P){const M=P.syncData?JSON.parse(P.syncData.content):null;if(!M){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const O={},q={};for(const $ of Object.keys(M.storage))$.startsWith(a)?O[$.substring(a.length)]=M.storage[$].value:this.storageService.get($,0)===void 0&&(q[$]=M.storage[$].value);if(Object.keys(O).length){let $="{}";try{$=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(k){}for(const k of Object.keys(O))$=(0,c.edit)($,[k],O[k],{});await this.fileService.writeFile(this.environmentService.argvResource,T.VSBuffer.fromString($))}if(Object.keys(q).length)for(const $ of Object.keys(q))this.storageService.store($,q[$],0,0)}};h=de([Y(0,v.IStorageService),Y(1,m.IFileService),Y(2,d.IEnvironmentService),Y(3,r.IUserDataSyncLogService),Y(4,y.IUriIdentityService)],h),e.GlobalStateInitializer=h;let p=class{constructor(P,M,O,q,$){this.userDataSyncStoreClient=P,this.storageService=M,this.environmentService=O,this.fileService=q,this.logService=$}getSyncStoreType(P){return this.parseGlobalState(P)?.storage[r.SYNC_SERVICE_URL_TYPE]?.value}async sync(P){const M=(0,r.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(P,M)}catch(O){if(O instanceof r.UserDataSyncError)switch(O.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(P,M)}throw O}}async doSync(P,M){const O=await this.userDataSyncStoreClient.read("globalState",null,M),q=this.parseGlobalState(O)||{storage:{}};q.storage[r.SYNC_SERVICE_URL_TYPE]={value:P,version:s};const $=await(0,S.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),k={version:s,machineId:$,content:t(q)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(k),O.ref,M)}parseGlobalState({content:P}){if(!P)return null;const M=JSON.parse(P);if((0,f.isSyncData)(M))return M?JSON.parse(M.content):null;throw new Error("Invalid remote data")}};p=de([Y(1,v.IStorageService),Y(2,d.IEnvironmentService),Y(3,m.IFileService),Y(4,u.ILogService)],p),e.UserDataSyncStoreTypeSynchronizer=p}),define(te[221],ne([0,1,16,19,3,31,4,15,144,21,13,14,23,22,35,47,216,24]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function y(l,r,a){try{const n=JSON.parse(l);if(!r)return(0,R.isUndefined)(n.all)?null:n.all;switch(i.OS){case 2:return(0,R.isUndefined)(n.mac)?null:n.mac;case 3:return(0,R.isUndefined)(n.linux)?null:n.linux;case 1:return(0,R.isUndefined)(n.windows)?null:n.windows}}catch(n){return a.error(n),null}}e.getKeybindingsContentFromSyncContent=y;let f=class extends S.AbstractJsonFileSynchroniser{constructor(r,a,n,t,s,o,h,p,w,P,M){super(h.keybindingsResource,"keybindings",o,h,p,r,a,s,P,n,w,t,M);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(t.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,a,n,t){const s=r.syncData?y(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;a=a===null&&n?r:a;const o=a?this.getKeybindingsContentFromLastSyncUserData(a):null,h=await this.getLocalFileContent(),p=await this.getFormattingOptions();let w=null,P=!1,M=!1,O=!1;if(s){let $=h?h.value.toString():"[]";if($=$||"[]",this.hasErrors($))throw new g.UserDataSyncError((0,E.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==$||o!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const k=await(0,v.merge)($,s,o,p,this.userDataSyncUtilService);k.hasChanges&&(w=k.mergeContent,O=k.hasConflicts,P=O||k.mergeContent!==$,M=O||k.mergeContent!==s)}}else h&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),w=h.value.toString(),M=!0);const q={content:w,localChange:P?h?2:1:0,remoteChange:M?2:0,hasConflicts:O};return[{fileContent:h,localResource:this.localResource,localContent:h?h.value.toString():null,localChange:q.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:q.remoteChange,previewResource:this.previewResource,previewResult:q,acceptedResource:this.acceptedResource}]}async getMergeResult(r,a){return r.previewResult}async getAcceptResult(r,a,n,t){if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return n===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,n,t){const{fileContent:s}=n[0][0];let{content:o,localChange:h,remoteChange:p}=n[0][1];if(h===0&&p===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new g.UserDataSyncError((0,E.localize)(1,null),"LocalInvalidContent",this.resource);if(h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(o||"[]",s,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),p!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const w=this.toSyncContent(o||"[]",r.syncData?.content);r=await this.updateRemoteUserData(w,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(w){}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=(0,L.parse)(r.value.toString());if((0,T.isNonEmptyArray)(a))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const n=this.parseSyncData(a);if(n)switch(this.extUri.basename(r)){case"keybindings.json":return y(n.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:y(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,a){let n={};try{n=JSON.parse(a||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=r,i.OS){case 2:n.mac=r;break;case 3:n.linux=r;break;case 1:n.windows=r;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};f=de([Y(0,g.IUserDataSyncStoreService),Y(1,g.IUserDataSyncBackupStoreService),Y(2,g.IUserDataSyncLogService),Y(3,b.IConfigurationService),Y(4,g.IUserDataSyncEnablementService),Y(5,C.IFileService),Y(6,I.IEnvironmentService),Y(7,d.IStorageService),Y(8,g.IUserDataSyncUtilService),Y(9,m.ITelemetryService),Y(10,u.IUriIdentityService)],f),e.KeybindingsSynchroniser=f;let c=class extends S.AbstractInitializer{constructor(r,a,n,t){super("keybindings",a,n,r,t)}async doInitialize(r){const a=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,_.VSBuffer.fromString(a)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),a=(0,L.parse)(r.value.toString());return!(0,T.isNonEmptyArray)(a)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return y(r,!0,this.logService)}catch(a){return this.logService.error(a),null}}};c=de([Y(0,C.IFileService),Y(1,I.IEnvironmentService),Y(2,g.IUserDataSyncLogService),Y(3,u.IUriIdentityService)],c),e.KeybindingsInitializer=c}),define(te[222],ne([0,1,16,31,39,48,28,53,24]),function(J,e,T,_,D,L,i,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function b(o,h,p){let w=[];p?w=C(p):w=I(h);const P=[],M=[...(0,E.getDisallowedIgnoredSettings)()];if(Array.isArray(w))for(const O of w)O.startsWith("-")?M.push(O.substring(1)):P.push(O);return(0,T.distinct)([...o,...P].filter(O=>M.indexOf(O)===-1))}e.getIgnoredSettings=b;function I(o){let h=o.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=o.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:o.getValue("settingsSync.ignoredSettings")||[]}function C(o){const h=(0,_.parse)(o);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function d(o,h,p,w){if(p.length){const P=s(h),M=(0,_.parse)(h),O=(0,_.parse)(o),q=[];for(const $ of p){const k=M[$],z=O[$];k===void 0?o=R.edit(o,[$],void 0,w):z!==void 0?o=R.edit(o,[$],k,w):q.push(l($,P))}q.sort(($,k)=>$.startOffset-k.startOffset),q.forEach($=>o=g($.setting.key,h,o,w))}return o}e.updateIgnoredSettings=d;function m(o,h,p,w,P,M){const O=d(o,h,w,M),q=p!==O,$=p!==h;if(!q&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(q&&!$)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if($&&!q)return{conflictsSettings:[],localContent:d(h,o,w,M),remoteContent:null,hasConflicts:!1};if(p===null&&S(o)){const H=u(o,h,w)?null:d(h,o,w,M);return{conflictsSettings:[],localContent:H,remoteContent:null,hasConflicts:!1}}let k=o,z=h;const A=(0,_.parse)(o),F=(0,_.parse)(h),x=p?(0,_.parse)(p):null,Z=w.reduce((H,Q)=>(H.add(Q),H),new Set),B=v(A,F,Z),j=v(x,A,Z),X=v(x,F,Z),U=new Map,N=new Set,W=H=>{N.add(H);const Q=P.filter(({key:re})=>re===H)[0];Q?(k=R.edit(k,[H],Q.value,M),z=R.edit(z,[H],Q.value,M)):U.set(H,{key:H,localValue:A[H],remoteValue:F[H]})};for(const H of j.removed.values())X.updated.has(H)?W(H):z=R.edit(z,[H],void 0,M);for(const H of X.removed.values())N.has(H)||(j.updated.has(H)?W(H):k=R.edit(k,[H],void 0,M));for(const H of j.updated.values())N.has(H)||(X.updated.has(H)?B.updated.has(H)&&W(H):z=R.edit(z,[H],A[H],M));for(const H of X.updated.values())N.has(H)||(j.updated.has(H)?B.updated.has(H)&&W(H):k=R.edit(k,[H],F[H],M));for(const H of j.added.values())N.has(H)||(X.added.has(H)?B.updated.has(H)&&W(H):z=g(H,k,z,M));for(const H of X.added.values())N.has(H)||(j.added.has(H)?B.updated.has(H)&&W(H):k=g(H,z,k,M));const V=U.size>0||!u(k,z,w),G=V||!u(k,o,[]),ee=V||!u(z,h,[]);return{localContent:G?k:null,remoteContent:ee?z:null,conflictsSettings:[...U.values()],hasConflicts:V}}e.merge=m;function u(o,h,p){if(o===h)return!0;const w=(0,_.parse)(o),P=(0,_.parse)(h),M=p.reduce(($,k)=>($.add(k),$),new Set),O=s(o).filter($=>!($.setting&&M.has($.setting.key))),q=s(h).filter($=>!($.setting&&M.has($.setting.key)));if(O.length!==q.length)return!1;for(let $=0;$<O.length;$++){const k=O[$],z=q[$];if(k.setting&&z.setting){if(k.setting.key!==z.setting.key||!i.equals(w[k.setting.key],P[k.setting.key]))return!1}else if(!k.setting&&!z.setting){if(k.value!==z.value)return!1}else return!1}return!0}e.areSame=u;function S(o){return o?s(o).length===0:!0}e.isEmpty=S;function v(o,h,p){const w=o?Object.keys(o).filter($=>!p.has($)):[],P=Object.keys(h).filter($=>!p.has($)),M=P.filter($=>w.indexOf($)===-1).reduce(($,k)=>($.add(k),$),new Set),O=w.filter($=>P.indexOf($)===-1).reduce(($,k)=>($.add(k),$),new Set),q=new Set;if(o)for(const $ of w){if(O.has($))continue;const k=o[$],z=h[$];i.equals(k,z)||q.add($)}return{added:M,removed:O,updated:q}}function g(o,h,p,w){const P=(0,_.parse)(h),M=s(h),O=s(p),q=y(o,M,O);return f(p,o,P[o],q,O,w)}e.addSetting=g;function y(o,h,p){const w=h.findIndex(M=>M.setting?.key===o),P=h[w-1];if(P){if(P.setting){const O=l(P.setting.key,p);if(O)return{index:p.indexOf(O),insertAfter:!0}}else{const O=r(w,h);if(O){const q=l(O.setting.key,p);if(q){const $=a(p.indexOf(q),p),k=n(h,O,h[w]);if($){const z=n(p,q,$),A=t(k,z);return A?{index:p.indexOf(A),insertAfter:!0}:{index:p.indexOf($),insertAfter:!1}}else{const z=n(p,q,p[p.length-1]),A=t(k,z);return A?{index:p.indexOf(A),insertAfter:!0}:{index:p.length-1,insertAfter:!0}}}}}const M=h[w+1];if(M)if(M.setting){const O=l(M.setting.key,p);if(O)return{index:p.indexOf(O),insertAfter:!1}}else{const O=a(w,h);if(O){const q=l(O.setting.key,p);if(q){const $=r(p.indexOf(q),p),k=n(h,h[w],O);if($){const z=n(p,$,q),A=t(k.reverse(),z.reverse());return A?{index:p.indexOf(A),insertAfter:!1}:{index:p.indexOf($),insertAfter:!0}}else{const z=n(p,p[0],q),A=t(k.reverse(),z.reverse());return A?{index:p.indexOf(A),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:p.length-1,insertAfter:!0}}function f(o,h,p,w,P,M){let O;return w.index===-1?O=(0,D.setProperty)(o,[h],p,M):O=c(o,h,p,w,P,M).map(q=>(0,D.withFormatting)(o,q,M)[0]),(0,D.applyEdits)(o,O)}function c(o,h,p,w,P,M){const O=`${JSON.stringify(h)}: ${JSON.stringify(p)}`,q=(0,L.getEOL)(M,o),$=P[w.index];if(w.insertAfter){const k=[];if($.setting)k.push({offset:$.endOffset,length:0,content:","+O});else{const z=a(w.index,P),A=r(w.index,P),F=A?.setting?.commaOffset;A&&F===void 0&&k.push({offset:A.endOffset,length:0,content:","});const x=F!==void 0&&F>$.endOffset;k.push({offset:x?F+1:$.endOffset,length:0,content:z?q+O+",":q+O})}return k}else{if($.setting)return[{offset:$.startOffset,length:0,content:O+","}];const k=(P[w.index-1]&&!P[w.index-1].setting?q:"")+O+(a(w.index,P)?",":"")+q;return[{offset:$.startOffset,length:0,content:k}]}}function l(o,h){return h.filter(p=>p.setting?.key===o)[0]}function r(o,h){for(let p=o-1;p>=0;p--)if(h[p].setting)return h[p]}function a(o,h){for(let p=o+1;p<h.length;p++)if(h[p].setting)return h[p]}function n(o,h,p){const w=o.indexOf(h),P=o.indexOf(p);return o.filter((M,O)=>w<O&&O<P)}function t(o,h){if(o.length&&h.length){let p=0;for(;p<h.length&&p<o.length;p++)if(o[p].value!==h[p].value)return h[p-1];return h[p-1]}}function s(o){const h=[];let p=-1,w,P;const M={onObjectBegin:O=>{p++},onObjectProperty:(O,q,$)=>{p===0&&(w=q,P=O)},onObjectEnd:(O,q)=>{p--,p===0&&h.push({startOffset:w,endOffset:O+q,value:o.substring(w,O+q),setting:{key:P,commaOffset:void 0}})},onArrayBegin:(O,q)=>{p++},onArrayEnd:(O,q)=>{p--,p===0&&h.push({startOffset:w,endOffset:O+q,value:o.substring(w,O+q),setting:{key:P,commaOffset:void 0}})},onLiteralValue:(O,q,$)=>{p===0&&h.push({startOffset:w,endOffset:q+$,value:o.substring(w,q+$),setting:{key:P,commaOffset:void 0}})},onSeparator:(O,q,$)=>{if(p===0&&O===","){let k=h.length-1;for(;k>=0&&!h[k].setting;k--);const z=h[k];z&&h.splice(k,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:q}})}},onComment:(O,q)=>{p===0&&h.push({startOffset:O,endOffset:O+q,value:o.substring(O,O+q)})}};return(0,_.visit)(o,M),h}}),define(te[223],ne([0,1,19,3,39,145,21,88,84,13,30,14,23,22,35,47,53,222,24]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function f(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function c(n){const t=JSON.parse(n);return f(t)?t:{settings:n}}e.parseSettingsSyncContent=c;let l=class extends S.AbstractJsonFileSynchroniser{constructor(t,s,o,h,p,w,P,M,O,q,$,k,z){super(s.settingsResource,"settings",t,s,o,h,p,O,q,w,P,M,z);this.extensionManagementService=$,this.userConfigurationFileService=k,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(t){const s=await this.getLastSyncUserData(),o=await this.getLatestRemoteUserData(t,s),h=this.getSettingsSyncContent(o),p=new R.ConfigurationModelParser(y.USER_DATA_SYNC_CONFIGURATION_SCOPE);return h?.settings&&p.parse(h.settings),p.configurationModel.getValue(y.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(t,s,o){const h=await this.getLocalFileContent(),p=await this.getFormattingOptions(),w=this.getSettingsSyncContent(t);s=s===null&&o?t:s;const P=s?this.getSettingsSyncContent(s):null,M=await this.getIgnoredSettings();let O=null,q=!1,$=!1,k=!1;if(w){let A=h?h.value.toString().trim():"{}";A=A||"{}",this.validateContent(A),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const F=(0,g.merge)(A,w.settings,P?P.settings:null,M,[],p);O=F.localContent||F.remoteContent,q=F.localContent!==null,$=F.remoteContent!==null,k=F.hasConflicts}else h&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),O=h.value.toString(),$=!0);const z={content:O,localChange:q?2:0,remoteChange:$?2:0,hasConflicts:k};return[{fileContent:h,localResource:this.localResource,localContent:h?h.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:w?w.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,s){const o=await this.getFormattingOptions(),h=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,g.updateIgnoredSettings)(t.previewResult.content,"{}",h,o):null}}async getAcceptResult(t,s,o,h){const p=await this.getFormattingOptions(),w=await this.getIgnoredSettings();if(this.extUri.isEqual(s,this.localResource))return{content:t.fileContent?(0,g.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",w,p):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(s,this.remoteResource))return{content:t.remoteContent!==null?(0,g.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",w,p):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(s,this.previewResource))return o===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:o!==null?(0,g.updateIgnoredSettings)(o,t.fileContent?t.fileContent.value.toString():"{}",w,p):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async applyResult(t,s,o,h){const{fileContent:p}=o[0][0];let{content:w,localChange:P,remoteChange:M}=o[0][1];if(P===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),w=w?w.trim():"{}",w=w||"{}",this.validateContent(w),P!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),p&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(p.value.toString()))),await this.updateLocalFileContent(w,p,h),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),M!==0){const O=await this.getFormattingOptions(),q=this.getSettingsSyncContent(t),$=await this.getIgnoredSettings(w);w=(0,g.updateIgnoredSettings)(w,q?q.settings:"{}",$,O),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(w)),h?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(O){}s?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const s=await this.getFormattingOptions(),o=(0,v.edit)(t.value.toString(),[y.CONFIGURATION_SYNC_STORE_KEY],void 0,s);return!(0,g.isEmpty)(o)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const s=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:s}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let s=await super.resolveContent(t);if(s)return s;if(s=await super.resolveContent(this.extUri.dirname(t)),s){const o=this.parseSyncData(s);if(o){const h=this.parseSettingsSyncContent(o.content);if(h)switch(this.extUri.basename(t)){case"settings.json":return h.settings}}}return null}async resolvePreviewContent(t){let s=await super.resolvePreviewContent(t);if(s){const o=await this.getFormattingOptions(),h=await this.getIgnoredSettings();s=(0,g.updateIgnoredSettings)(s,"{}",h,o)}return s}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return c(t)}catch(s){this.logService.error(s)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const o=_.Event.any(_.Event.filter(this.extensionManagementService.onDidInstallExtensions,h=>h.some(({local:p})=>!!p)),_.Event.filter(this.extensionManagementService.onDidUninstallExtension,h=>!h.error))(()=>{o.dispose(),this._defaultIgnoredSettings=void 0})}const s=await this._defaultIgnoredSettings;return(0,g.getIgnoredSettings)(s,this.configurationService,t)}async writeFileContent(t,s,o){await this.userConfigurationFileService.write(T.VSBuffer.fromString(t),o?void 0:{etag:s.etag,mtime:s.mtime})}validateContent(t){if(this.hasErrors(t))throw new y.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const s=JSON.parse(t.value.toString());if(!a(s))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const o=this.parseSettingsSyncContent(s.content);if(!o||!o.settings)return;let h=o.settings;const p=await this.getFormattingOptions();for(const w in s)if(["version","content","machineId"].indexOf(w)===-1&&s[w]!==void 0){const P=(0,D.setProperty)(h,[w],s[w],p);P.length&&(h=(0,D.applyEdits)(h,P))}await this.fileService.writeFile(this.file,T.VSBuffer.fromString(h))}catch(t){}}};l=de([Y(0,C.IFileService),Y(1,b.IEnvironmentService),Y(2,d.IStorageService),Y(3,y.IUserDataSyncStoreService),Y(4,y.IUserDataSyncBackupStoreService),Y(5,y.IUserDataSyncLogService),Y(6,y.IUserDataSyncUtilService),Y(7,i.IConfigurationService),Y(8,y.IUserDataSyncEnablementService),Y(9,m.ITelemetryService),Y(10,I.IExtensionManagementService),Y(11,E.IUserConfigurationFileService),Y(12,u.IUriIdentityService)],l),e.SettingsSynchroniser=l;let r=class extends S.AbstractInitializer{constructor(t,s,o,h){super("settings",s,o,t,h)}async doInitialize(t){const s=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!s){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,T.VSBuffer.fromString(s.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,g.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return c(t)}catch(s){this.logService.error(s)}return null}};r=de([Y(0,C.IFileService),Y(1,b.IEnvironmentService),Y(2,y.IUserDataSyncLogService),Y(3,u.IUriIdentityService)],r),e.SettingsInitializer=r;function a(n){return!!(n&&n.version!==void 0&&typeof n.version=="number"&&n.content!==void 0&&typeof n.content=="string"&&n.machineId!==void 0&&typeof n.machineId=="string")}}),define(te[224],ne([0,1,19,3,28,21,13,14,23,22,35,47,217,24]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let u=class extends C.AbstractSynchroniser{constructor(g,y,f,c,l,r,a,n,t,s){super("snippets",y,g,f,c,l,n,t,r,a,s);this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(g.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(_.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,y,f){const c=await this.getSnippetsFileContents(),l=this.toSnippetsContents(c),r=g.syncData?this.parseSnippets(g.syncData):null;y=y===null&&f?g:y;const a=y&&y.syncData?this.parseSnippets(y.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,d.merge)(l,r,a);return this.getResourcePreviews(n,c,r||{})}async getMergeResult(g,y){return g.previewResult}async getAcceptResult(g,y,f,c){if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder))return f===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:f,localChange:f===null?g.fileContent!==null?3:0:2,remoteChange:f===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${y.toString()}`)}async applyResult(g,y,f,c){const l=f.map(([r,a])=>({...r,acceptResult:a}));l.every(({localChange:r,remoteChange:a})=>r===0&&a===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,c)),l.some(({remoteChange:r})=>r!==0)&&(g=await this.updateRemoteSnippets(l,g,c)),y?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of l)try{await this.fileService.del(r)}catch(a){}}getResourcePreviews(g,y,f){const c=new Map;for(const l of Object.keys(g.local.added)){const r={content:g.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};c.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.local.updated)){const r={content:g.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[l],localContent:y[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[l],localContent:y[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.remote.added)){const r={content:g.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[l],localContent:y[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.remote.updated)){const r={content:g.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[l],localContent:y[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.conflicts){const r={content:y[l]?y[l].value.toString():null,hasConflicts:!0,localChange:y[l]?2:1,remoteChange:f[l]?2:1};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[l]||null,localContent:y[l]?y[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(y))if(!c.has(l)){const r={content:y[l]?y[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[l]||null,localContent:y[l]?y[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...c.values()]}async getAssociatedResources({uri:g}){let y=await super.resolveContent(g);if(y){const f=this.parseSyncData(y);if(f){const c=this.parseSnippets(f),l=[];for(const r of Object.keys(c)){const a=this.extUri.joinPath(g,r),n=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(n);l.push({resource:a,comparableResource:t?n:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let y=await super.resolveContent(g);if(y)return y;if(y=await super.resolveContent(this.extUri.dirname(g)),y){const f=this.parseSyncData(y);if(f)return this.parseSnippets(f)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch(g){}return!1}async updateLocalBackup(g){const y={};for(const f of g)f.fileContent&&(y[this.extUri.basename(f.localResource)]=f.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(y)))}async updateLocalSnippets(g,y){for(const{fileContent:f,acceptResult:c,localResource:l,remoteResource:r,localChange:a}of g)if(a!==0){const n=r?this.extUri.basename(r):this.extUri.basename(l),t=this.extUri.joinPath(this.snippetsFolder,n);a===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):a===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,T.VSBuffer.fromString(c.content),{overwrite:y}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,T.VSBuffer.fromString(c.content),y?void 0:f),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(g,y,f){const c=y.syncData?this.parseSnippets(y.syncData):{},l=(0,D.deepClone)(c);for(const{acceptResult:r,localResource:a,remoteResource:n,remoteChange:t}of g)if(t!==0){const s=a?this.extUri.basename(a):this.extUri.basename(n);t===3?delete l[s]:l[s]=r.content}return(0,d.areSame)(c,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),y=await this.updateRemoteUserData(JSON.stringify(l),f?null:y.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),y}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const y={};for(const f of Object.keys(g))y[f]=g[f].value.toString();return y}async getSnippetsFileContents(){const g={};let y;try{y=await this.fileService.resolve(this.snippetsFolder)}catch(f){if(f instanceof R.FileOperationError&&f.fileOperationResult===1)return g;throw f}for(const f of y.children||[]){const c=f.resource,l=this.extUri.extname(c);if(l===".json"||l===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,c),a=await this.fileService.readFile(c);g[r]=a}}return g}};u=de([Y(0,i.IEnvironmentService),Y(1,R.IFileService),Y(2,E.IStorageService),Y(3,m.IUserDataSyncStoreService),Y(4,m.IUserDataSyncBackupStoreService),Y(5,m.IUserDataSyncLogService),Y(6,L.IConfigurationService),Y(7,m.IUserDataSyncEnablementService),Y(8,b.ITelemetryService),Y(9,I.IUriIdentityService)],u),e.SnippetsSynchroniser=u;let S=class extends C.AbstractInitializer{constructor(g,y,f,c){super("snippets",y,f,g,c)}async doInitialize(g){const y=g.syncData?JSON.parse(g.syncData.content):null;if(!y){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const c of Object.keys(y)){const l=y[c];if(l){const r=this.extUri.joinPath(this.environmentService.snippetsHome,c);await this.fileService.createFile(r,T.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};S=de([Y(0,R.IFileService),Y(1,i.IEnvironmentService),Y(2,m.IUserDataSyncLogService),Y(3,I.IUriIdentityService)],S),e.SnippetsInitializer=S}),define(te[63],ne([0,1,3,2,6,24]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let i=class extends _.Disposable{constructor(E,b){super();this.userDataSyncStoreService=E,this.logService=b,this._onDidChangeAccount=this._register(new T.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(E.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(E.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(E){(E&&this._account?E.token!==this._account.token||E.authenticationProviderId!==this._account.authenticationProviderId:E!==this._account)&&(this._account=E,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(E))}};i=de([Y(0,L.IUserDataSyncStoreService),Y(1,L.IUserDataSyncLogService)],i),e.UserDataSyncAccountService=i}),define(te[225],ne([0,1,5,19,56,2,18,21,13,14,24]),function(J,e,T,_,D,L,i,R,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let C=class extends L.Disposable{constructor(m,u,S,v){super();this.environmentService=m,this.fileService=u,this.configurationService=S,this.logService=v,I.ALL_SYNC_RESOURCES.forEach(g=>this.cleanUpBackup(g))}async getAllRefs(m){const u=(0,i.joinPath)(this.environmentService.userDataSyncHome,m),S=await this.fileService.resolve(u);return S.children?S.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort().reverse().map(g=>({ref:g.name,created:this.getCreationTime(g)})):[]}async resolveContent(m,u){if(!u){const S=await this.getAllRefs(m);S.length&&(u=S[S.length-1].ref)}if(u){const S=(0,i.joinPath)(this.environmentService.userDataSyncHome,m,u);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(m,u){const S=(0,i.joinPath)(this.environmentService.userDataSyncHome,m),v=(0,i.joinPath)(S,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(v,_.VSBuffer.fromString(u))}catch(g){this.logService.error(g)}try{this.cleanUpBackup(m)}catch(g){}}async cleanUpBackup(m){const u=(0,i.joinPath)(this.environmentService.userDataSyncHome,m);try{try{if(!await this.fileService.exists(u))return}catch(v){return}const S=await this.fileService.resolve(u);if(S.children){const v=S.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),g=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let y=v.filter(c=>Date.now()-this.getCreationTime(c)>g);const f=v.length-y.length;f<10&&(y=y.slice(10-f)),await T.Promises.settled(y.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(m){return m.ctime||new Date(parseInt(m.name.substring(0,4)),parseInt(m.name.substring(4,6))-1,parseInt(m.name.substring(6,8)),parseInt(m.name.substring(9,11)),parseInt(m.name.substring(11,13)),parseInt(m.name.substring(13,15))).getTime()}};C=de([Y(0,E.IEnvironmentService),Y(1,b.IFileService),Y(2,R.IConfigurationService),Y(3,I.IUserDataSyncLogService)],C),e.UserDataSyncBackupStoreService=C}),define(te[226],ne([0,1,3,2,4,13,23,22,24]),function(J,e,T,_,D,L,i,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const b="sync.enable";let I=class extends _.Disposable{constructor(d,m,u,S){super();this.storageService=d,this.telemetryService=m,this.environmentService=u,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new T.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new T.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(d.onDidChangeValue(v=>this.onDidStorageChange(v)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(b,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(d){d&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(b,{enabled:d}),this.storageService.store(b,d,0,1))}isResourceEnabled(d){return this.storageService.getBoolean((0,E.getEnablementKey)(d),0,!0)}setResourceEnablement(d,m){if(this.isResourceEnabled(d)!==m){const u=(0,E.getEnablementKey)(d);this.telemetryService.publicLog2(u,{enabled:m}),this.storeResourceEnablement(u,m)}}getResourceSyncStateVersion(d){}storeResourceEnablement(d,m){this.storageService.store(d,m,0,D.isWeb?0:1)}onDidStorageChange(d){if(d.scope!==0)return;if(b===d.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const m=E.ALL_SYNC_RESOURCES.filter(u=>(0,E.getEnablementKey)(u)===d.key)[0];if(m){this._onDidChangeResourceEnablement.fire([m,this.isResourceEnabled(m)]);return}}};I=de([Y(0,i.IStorageService),Y(1,R.ITelemetryService),Y(2,L.IEnvironmentService),Y(3,E.IUserDataSyncStoreManagementService)],I),e.UserDataSyncEnablementService=I}),define(te[227],ne([0,1,2,8]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(d){this.service=d}listen(d,m){switch(m){case"onError":return this.service.onError}throw new Error(`Event not found: ${m}`)}call(d,m,u){switch(m){case"triggerSync":return this.service.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class L{constructor(d){this.service=d}listen(d,m){throw new Error(`Event not found: ${m}`)}call(d,m,u){switch(m){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(_.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class i{constructor(d){this.channel=d}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(d){return this.channel.call("resolveUserKeybindings",[d])}async resolveFormattingOptions(d){return this.channel.call("resolveFormattingOptions",[d])}}e.UserDataSyncUtilServiceClient=i;class R{constructor(d){this.service=d}listen(d,m){switch(m){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${m}`)}async call(d,m,u){switch(m){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(u[0],u[1]);case"setEnablement":return this.service.setEnablement(u[0],u[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class E{constructor(d){this.service=d}listen(d,m){switch(m){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${m}`)}call(d,m,u){switch(m){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=E;class b{constructor(d){this.service=d}listen(d,m){switch(m){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${m}`)}call(d,m,u){switch(m){case"switch":return this.service.switch(u[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class I extends T.Disposable{constructor(d){super();this.channel=d,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(d){return this.channel.call("switch",[d])}async getPreviousUserDataSyncStore(){const d=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(d)}revive(d){return{url:_.URI.revive(d.url),type:d.type,defaultUrl:_.URI.revive(d.defaultUrl),insidersUrl:_.URI.revive(d.insidersUrl),stableUrl:_.URI.revive(d.stableUrl),canSwitch:d.canSwitch,authenticationProviders:d.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(te[228],ne([0,1,13,9]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends _.AbstractLogger{constructor(i,R){super();this.logger=this._register(i.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(i,...R){this.logger.trace(i,...R)}debug(i,...R){this.logger.debug(i,...R)}info(i,...R){this.logger.info(i,...R)}warn(i,...R){this.logger.warn(i,...R)}error(i,...R){this.logger.error(i,...R)}critical(i,...R){this.logger.critical(i,...R)}flush(){this.logger.flush()}};D=de([Y(0,_.ILoggerService),Y(1,T.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(te[64],ne([0,1,3,2,4,25,148,13,14,6,27,46,23,24]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const u="sync.currentMachineName";let S=class et extends _.Disposable{constructor(g,y,f,c,l,r){super();this.storageService=f,this.userDataSyncStoreService=c,this.logService=l,this.productService=r,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(g,y,f)}async getMachines(g){const y=await this.currentMachineIdPromise;return(await this.readMachinesData(g)).machines.map(c=>({...c,isCurrent:c.id===y}))}async addCurrentMachine(g){const y=await this.currentMachineIdPromise,f=await this.readMachinesData(g);f.machines.some(({id:c})=>c===y)||(f.machines.push({id:y,name:this.computeCurrentMachineName(f.machines)}),await this.writeMachinesData(f))}async removeCurrentMachine(g){const y=await this.currentMachineIdPromise,f=await this.readMachinesData(g),c=f.machines.filter(({id:l})=>l!==y);c.length!==f.machines.length&&(f.machines=c,await this.writeMachinesData(f))}async renameMachine(g,y,f){const c=await this.currentMachineIdPromise,l=await this.readMachinesData(f),r=l.machines.find(({id:a})=>a===g);r&&(r.name=y,await this.writeMachinesData(l),l.machines.some(({id:a})=>a===c)&&this.storageService.store(u,y,0,1))}async setEnablement(g,y){const f=await this.readMachinesData(),c=f.machines.find(({id:l})=>l===g);c&&(c.disabled=y?void 0:!0,await this.writeMachinesData(f))}computeCurrentMachineName(g){const y=this.storageService.get(u,0);if(y)return y;const f=`${this.productService.nameLong} (${(0,D.PlatformToString)(D.isWeb?0:D.platform)})`,c=new RegExp(`${(0,L.escapeRegExpCharacters)(f)}\\s#(\\d+)`);let l=0;for(const r of g){const a=c.exec(r.name),n=a?parseInt(a[1]):0;l=n>l?n:l}return`${f} #${l+1}`}async readMachinesData(g){this.userData=await this.readUserData(g);const y=this.parse(this.userData);if(y.version!==et.VERSION)throw new Error((0,i.localize)(0,null,this.productService.nameLong));return y}async writeMachinesData(g){const y=JSON.stringify(g),f=await this.userDataSyncStoreService.write(et.RESOURCE,y,this.userData?.ref||null);this.userData={ref:f,content:y},this._onDidChange.fire()}async readUserData(g){if(this.userData){const y=g&&g.latest?g.latest[et.RESOURCE]:void 0;if(this.userData.ref===y)return this.userData;if(y===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(et.RESOURCE,this.userData)}parse(g){if(g.content!==null)try{return JSON.parse(g.content)}catch(y){this.logService.error(y)}return{version:et.VERSION,machines:[]}}};S.VERSION=1,S.RESOURCE="machines",S=de([Y(0,R.IEnvironmentService),Y(1,E.IFileService),Y(2,d.IStorageService),Y(3,m.IUserDataSyncStoreService),Y(4,m.IUserDataSyncLogService),Y(5,I.IProductService)],S),e.UserDataSyncMachinesService=S}),define(te[229],ne([0,1,5,56,38,7,3,2,4,18,8,146,27,23,22,24,63,64]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const y="sync.disableMachineEventually",f="sync.sessionId",c="sync.storeUrl",l="sync.productQuality";let r=class extends R.Disposable{constructor(t,s,o,h,p,w,P,M,O,q){super();this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=h,this.userDataSyncService=p,this.logService=w,this.userDataSyncAccountService=P,this.telemetryService=M,this.userDataSyncMachinesService=O,this.storageService=q,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new i.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new T.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(P.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(i.Event.debounce(p.onDidChangeLocal,($,k)=>$?[...$,k]:[k],1e3)($=>this.triggerSync($,!1,!1))),this._register(i.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const t=this.storageService.get(c,0);return t?I.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(c,t.toString(),0,1):this.storageService.remove(c,0)}get productQuality(){return this.storageService.get(l,0)}set productQuality(t){t?this.storageService.store(l,t,0,1):this.storageService.remove(l,0)}updateAutoSync(){const{enabled:t,message:s}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,_.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,s,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(f,0),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(h){if(s)this.logService.error(h),this.updateEnablement(!1);else throw h}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const s=S.UserDataSyncError.toUserDataSyncError(t);s instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"||s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?E.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(y,!0,0,1),await(0,T.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(y,0,!1)}stopDisableMachineEventually(){this.storageService.remove(y,0)}async triggerSync(t,s,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([Y(0,d.IProductService),Y(1,S.IUserDataSyncStoreManagementService),Y(2,S.IUserDataSyncStoreService),Y(3,S.IUserDataSyncEnablementService),Y(4,S.IUserDataSyncService),Y(5,S.IUserDataSyncLogService),Y(6,v.IUserDataSyncAccountService),Y(7,u.ITelemetryService),Y(8,g.IUserDataSyncMachinesService),Y(9,m.IStorageService)],r),e.UserDataAutoSyncService=r;class a extends R.Disposable{constructor(t,s,o,h,p,w,P,M){super();this.lastSyncUrl=t,this.interval=s,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=h,this.userDataSyncService=p,this.userDataSyncMachinesService=w,this.logService=P,this.storageService=M,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new i.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new i.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,T.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(t,s){const o=(0,T.createCancelablePromise)(async h=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(p){if((0,L.isPromiseCanceledError)(p))return}return this.doSync(t,s,h)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!t&&(!(0,b.isEqual)(s.defaultUrl,t.defaultUrl)||!(0,b.isEqual)(s.insidersUrl,t.insidersUrl)||!(0,b.isEqual)(s.stableUrl,t.stableUrl))}async doSync(t,s,o){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let h;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),o.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const p=this.storageService.get(f,0);if(p&&this.manifest&&p!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const w=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(o.isCancellationRequested)return;const P=w.find(M=>M.isCurrent);if(P?.disabled)throw new S.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(M){throw new S.UserDataAutoSyncError((0,D.toErrorMessage)(M),M instanceof S.UserDataSyncError?M.code:"Unknown")}if(this.manifest&&this.manifest.session!==p&&this.storageService.store(f,this.manifest.session,0,1),o.isCancellationRequested)return;P||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(p){this.logService.error(p),h=p}this._onDidFinishSync.fire(h)}register(t){return super._register(t)}}a.INTERVAL_SYNCING="Interval"}),define(te[230],ne([0,1,16,5,38,7,3,2,18,29,21,6,23,22,218,220,221,223,224,24]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v,g,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const c="sync.lastSyncTime";let l=class extends R.Disposable{constructor(t,s,o,h,p,w,P){super();this.userDataSyncStoreService=t,this.userDataSyncStoreManagementService=s,this.instantiationService=o,this.configurationService=h,this.logService=p,this.telemetryService=w,this.storageService=P,this._status="uninitialized",this._onDidChangeStatus=this._register(new i.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new i.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new i.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new i.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new i.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new i.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(g.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(v.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(y.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(S.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(u.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(i.Event.any(...this.synchronisers.map(M=>i.Event.map(M.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(i.Event.any(...this.synchronisers.map(M=>i.Event.map(M.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(c,0,void 0),this.onDidChangeLocal=i.Event.any(...this.synchronisers.map(M=>i.Event.map(M.onDidChangeLocal,()=>M.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(t,s){await this.checkEnablement();const o=(0,b.generateUuid)();try{const P=(0,f.createSyncHeaders)(o);s&&(P["Cache-Control"]="no-cache"),t=await this.userDataSyncStoreService.manifest(t,P)}catch(P){const M=f.UserDataSyncError.toUserDataSyncError(P);throw this.reportUserDataSyncError(M,o),M}let h=!1;const p=this;let w;return{manifest:t,run(){if(h)throw new Error("Can run a task only once");return w=(0,_.createCancelablePromise)(P=>p.sync(t,o,P)),w.finally(()=>w=void 0)},async stop(){if(w&&w.cancel(),p.status!=="idle")return p.stop()}}}async createManualSyncTask(){await this.checkEnablement();const t=(0,b.generateUuid)(),s=(0,f.createSyncHeaders)(t);let o;try{o=await this.userDataSyncStoreService.manifest(null,s)}catch(h){const p=f.UserDataSyncError.toUserDataSyncError(h);throw this.reportUserDataSyncError(p,t),p}return new r(t,o,s,this.synchronisers,this.configurationService,this.logService)}async sync(t,s,o){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),o.isCancellationRequested)return;const h=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const p=(0,f.createSyncHeaders)(s);for(const w of this.synchronisers){if(o.isCancellationRequested)return;try{await w.sync(t,p)}catch(P){let M=!1;if(P instanceof f.UserDataSyncError)switch(P.code){case"TooLarge":P=new f.UserDataSyncError(P.message,P.code,w.resource),M=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":M=!0;break}const O=f.UserDataSyncError.toUserDataSyncError(P);if(this.reportUserDataSyncError(O,s),M)throw O;this.logService.error(P),this.logService.error(`${w.resource}: ${(0,D.toErrorMessage)(P)}`),this._syncErrors.push([w.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-h}ms`),this.updateLastSyncTime()}catch(p){const w=f.UserDataSyncError.toUserDataSyncError(p);throw this.reportUserDataSyncError(w,s),w}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const t of this.synchronisers)try{t.status!=="idle"&&await t.stop()}catch(s){this.logService.error(s)}}async replace(t){await this.checkEnablement();for(const s of this.synchronisers)if(await s.replace(t))return}async accept(t,s,o,h){await this.checkEnablement();const p=this.getSynchroniser(t);await p.accept(s,o),h&&await p.apply(!1,(0,f.createSyncHeaders)((0,b.generateUuid)()))}async resolveContent(t){for(const s of this.synchronisers){const o=await s.resolveContent(t);if(o)return o}return null}getRemoteSyncResourceHandles(t){return this.getSynchroniser(t).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(t){return this.getSynchroniser(t).getLocalSyncResourceHandles()}getAssociatedResources(t,s){return this.getSynchroniser(t).getAssociatedResources(s)}getMachineId(t,s){return this.getSynchroniser(t).getMachineId(s)}async hasLocalData(){const t=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const s of t)if(await s.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(t){this.logService.error(t)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(c,0);for(const t of this.synchronisers)try{await t.resetLocal()}catch(s){this.logService.error(`${t.resource}: ${(0,D.toErrorMessage)(s)}`),this.logService.error(s)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const t of this.synchronisers)if(await t.hasPreviouslySynced())return!0;return!1}setStatus(t){const s=this._status;this._status!==t&&(this._status=t,this._onDidChangeStatus.fire(t),s==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const t=this.computeStatus();this.setStatus(t)}updateConflicts(){const t=this.computeConflicts();(0,T.equals)(this._conflicts,t,([s,o],[h,p])=>s===s&&(0,T.equals)(o,p,(w,P)=>(0,E.isEqual)(w.previewResource,P.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(t))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(c,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(t,s){this.telemetryService.publicLog2("sync/error",{code:t.code,serverCode:t instanceof f.UserDataSyncStoreError?String(t.serverCode):void 0,url:t instanceof f.UserDataSyncStoreError?t.url:void 0,resource:t.resource,executionId:s,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(t=>t.status==="hasConflicts").map(t=>[t.resource,t.conflicts.map(a)])}getSynchroniser(t){return this.synchronisers.find(s=>s.resource===t)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};l=de([Y(0,f.IUserDataSyncStoreService),Y(1,f.IUserDataSyncStoreManagementService),Y(2,C.IInstantiationService),Y(3,I.IConfigurationService),Y(4,f.IUserDataSyncLogService),Y(5,m.ITelemetryService),Y(6,d.IStorageService)],l),e.UserDataSyncService=l;class r extends R.Disposable{constructor(t,s,o,h,p,w){super();this.id=t,this.manifest=s,this.syncHeaders=o,this.synchronisers=h,this.configurationService=p,this.logService=w,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new i.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,_.createCancelablePromise)(t=>this.getPreviews(t))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(t){throw this.logService.error(t),t}}async accept(t,s){try{return await this.performAction(t,o=>o.accept(t,s))}catch(o){throw this.logService.error(o),o}}async merge(t){try{return t?await this.performAction(t,s=>s.merge(t)):await this.mergeAll()}catch(s){throw this.logService.error(s),s}}async discard(t){try{return await this.performAction(t,s=>s.discard(t))}catch(s){throw this.logService.error(s),s}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const t=[];for(const[,s]of this.previews)for(const o of s.resourcePreviews)o.mergeState==="conflict"&&t.push(o.previewResource);for(const s of t)await this.discard(s);return this.previews}catch(t){throw this.logService.error(t),t}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const t=[];for(const[s,o]of this.previews){this.synchronizingResources.push([s,o.resourcePreviews.map(w=>w.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(w=>w.resource===s);for(const w of o.resourcePreviews)(w.localChange!==0||w.remoteChange!==0)&&w.mergeState==="preview"&&await h.merge(w.previewResource);const p=await h.apply(!1,this.syncHeaders);p&&t.push(this.toSyncResourcePreview(h.resource,p)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(w=>w[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}catch(t){throw this.logService.error(t),t}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,s]of this.previews){this.synchronizingResources.push([t,s.resourcePreviews.map(h=>h.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(h=>h.resource===t);for(const h of s.resourcePreviews)await o.accept(h.remoteResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(h=>h[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,s]of this.previews){this.synchronizingResources.push([t,s.resourcePreviews.map(h=>h.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(h=>h.resource===t);for(const h of s.resourcePreviews)await o.accept(h.localResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(h=>h[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async stop(){for(const t of this.synchronisers)try{await t.stop()}catch(s){(0,L.isPromiseCanceledError)(s)||this.logService.error(s)}this.reset()}async performAction(t,s){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const o=this.previews.findIndex(([,$])=>$.resourcePreviews.some(({localResource:k,previewResource:z,remoteResource:A})=>(0,E.isEqual)(t,k)||(0,E.isEqual)(t,z)||(0,E.isEqual)(t,A)));if(o===-1)return this.previews;const[h,p]=this.previews[o],w=p.resourcePreviews.find(({localResource:$,remoteResource:k,previewResource:z})=>(0,E.isEqual)($,t)||(0,E.isEqual)(k,t)||(0,E.isEqual)(z,t));if(!w)return this.previews;let P=this.synchronizingResources.find($=>$[0]===h);P||(P=[h,[]],this.synchronizingResources.push(P)),P[1].some($=>(0,E.isEqual)($,w.localResource))||(P[1].push(w.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const M=this.synchronisers.find($=>$.resource===this.previews[o][0]),O=await s(M);O?this.previews.splice(o,1,this.toSyncResourcePreview(M.resource,O)):this.previews.splice(o,1);const q=this.synchronizingResources.findIndex($=>$[0]===h);return this.synchronizingResources[q][1].splice(P[1].findIndex($=>(0,E.isEqual)($,w.localResource)),1),P[1].length||(this.synchronizingResources.splice(q,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const t=[];for(const[s,o]of this.previews){this.synchronizingResources.push([s,o.resourcePreviews.map(w=>w.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(w=>w.resource===s);let p=o;for(const w of o.resourcePreviews)(w.localChange!==0||w.remoteChange!==0)&&w.mergeState==="preview"&&(p=await h.merge(w.previewResource));p&&t.push(this.toSyncResourcePreview(h.resource,p)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(w=>w[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}async getPreviews(t){const s=[],o=await this.getUserDataSyncConfiguration();for(const h of this.synchronisers){if(t.isCancellationRequested)return[];const p=await h.preview(this.manifest,o,this.syncHeaders);p&&s.push(this.toSyncResourcePreview(h.resource,p))}return s}async getUserDataSyncConfiguration(){const t=this.configurationService.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE),s=await this.synchronisers.find(o=>o instanceof g.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...t,...s}}toSyncResourcePreview(t,s){return[t,{isLastSyncFromCurrentMachine:s.isLastSyncFromCurrentMachine,resourcePreviews:s.resourcePreviews.map(a)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function a(n){return{localResource:n.localResource,previewResource:n.previewResource,remoteResource:n.remoteResource,acceptedResource:n.acceptedResource,localChange:n.localChange,remoteChange:n.remoteChange,mergeState:n.mergeState}}}),define(te[231],ne([0,1,3,2,15,8,24]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(C,d){this.service=C,this.logService=d,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new T.Emitter}listen(C,d){switch(d){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${d}`)}async call(C,d,m){try{return await this._call(C,d,m)}catch(u){throw this.logService.error(u),u}}async _call(C,d,m){switch(d){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(m[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(m[0],L.URI.revive(m[1]),m[2],m[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(m[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(m[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(m[0]);case"getAssociatedResources":return this.service.getAssociatedResources(m[0],{created:m[1].created,uri:L.URI.revive(m[1].uri)});case"getMachineId":return this.service.getMachineId(m[0],{created:m[1].created,uri:L.URI.revive(m[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(d.startsWith("manualSync/")){const u=d.substring("manualSync/".length),S=m[0],v=this.getManualSyncTask(S);switch(m=m.slice(1),u){case"preview":return v.preview();case"accept":return v.accept(L.URI.revive(m[0]),m[1]);case"merge":return v.merge(L.URI.revive(m[0]));case"discard":return v.discard(L.URI.revive(m[0]));case"discardConflicts":return v.discardConflicts();case"apply":return v.apply();case"pull":return v.pull();case"push":return v.push();case"stop":return v.stop();case"_getStatus":return v.status;case"dispose":return this.disposeManualSyncTask(v)}}throw new Error("Invalid call")}getManualSyncTask(C){const d=this.manualSyncTasks.get(this.createKey(C));if(!d)throw new Error(`Manual sync taks not found: ${C}`);return d.manualSyncTask}async createManualSyncTask(){const C=new _.DisposableStore,d=C.add(await this.service.createManualSyncTask());return C.add(d.onSynchronizeResources(m=>this.onManualSynchronizeResources.fire({manualSyncTaskId:d.id,data:m}))),this.manualSyncTasks.set(this.createKey(d.id),{manualSyncTask:d,disposables:C}),{id:d.id,manifest:d.manifest,status:d.status}}disposeManualSyncTask(C){C.dispose();const d=this.createKey(C.id);this.manualSyncTasks.get(d)?.disposables.dispose(),this.manualSyncTasks.delete(d)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=R;class E extends _.Disposable{constructor(C){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(d,m,u){return C.call(d,m,u).then(null,S=>{throw i.UserDataSyncError.toUserDataSyncError(S)})},listen(d,m){return C.listen(d,m)}},this.channel.call("_getInitialData").then(([d,m,u])=>{this.updateStatus(d),this.updateConflicts(m),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(d=>this.updateConflicts(d))),this._register(this.channel.listen("onSyncErrors")(d=>this._onSyncErrors.fire(d.map(([m,u])=>[m,i.UserDataSyncError.toUserDataSyncError(u)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:d,status:m}=await this.channel.call("createManualSyncTask"),u=this,S=new b(C,d,m,{async call(v,g,y){return u.channel.call(`manualSync/${v}`,[C,...(0,D.isArray)(g)?g:[g]],y)},listen(v,g){return T.Event.map(T.Event.filter(u.channel.listen(`manualSync/${v}`,g),y=>!S.isDiposed()&&y.manualSyncTaskId===C),y=>y.data)}});return S}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,d,m,u){return this.channel.call("accept",[C,d,m,u])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:m,uri:u})=>({created:m,uri:L.URI.revive(u)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:m,uri:u})=>({created:m,uri:L.URI.revive(u)}))}async getAssociatedResources(C,d){return(await this.channel.call("getAssociatedResources",[C,d])).map(({resource:u,comparableResource:S})=>({resource:L.URI.revive(u),comparableResource:L.URI.revive(S)}))}async getMachineId(C,d){return this.channel.call("getMachineId",[C,d])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([d,m])=>[d,m.map(u=>({...u,localResource:L.URI.revive(u.localResource),remoteResource:L.URI.revive(u.remoteResource),previewResource:L.URI.revive(u.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=E;class b extends _.Disposable{constructor(C,d,m,u){super();this.id=C,this.manifest=d,this._disposed=!1,this._status=m;const S=this;this.channel={async call(v,g,y){try{const f=await u.call(v,g,y);return S.isDiposed()||(S._status=await u.call("_getStatus")),f}catch(f){throw i.UserDataSyncError.toUserDataSyncError(f)}},listen(v,g){return u.listen(v,g)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,d){const m=await this.channel.call("accept",[C,d]);return this.deserializePreviews(m)}async merge(C){const d=await this.channel.call("merge",[C]);return this.deserializePreviews(d)}async discard(C){const d=await this.channel.call("discard",[C]);return this.deserializePreviews(d)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([d,m])=>[d,{isLastSyncFromCurrentMachine:m.isLastSyncFromCurrentMachine,resourcePreviews:m.resourcePreviews.map(u=>({...u,localResource:L.URI.revive(u.localResource),remoteResource:L.URI.revive(u.remoteResource),previewResource:L.URI.revive(u.previewResource),acceptedResource:L.URI.revive(u.acceptedResource)}))}])}}}),define(te[232],ne([0,1,5,26,7,3,2,108,4,18,15,8,29,21,13,14,27,43,46,23,24]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v,g,y,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",r="sync.donot-make-requests-until",a="sync.user-session-id",n="sync.machine-session-id",t=100,s=1e3*60*5;let o=class extends i.Disposable{constructor(O,q,$){super();this.productService=O,this.configurationService=q,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter($.onDidChangeValue,k=>k.key===c.SYNC_SERVICE_URL_TYPE&&k.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,O,0,E.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,q){O=E.isWeb&&O?.web?{...O,...O.web}:O;const $={...O||{},...q||{}};if($&&(0,I.isString)($.url)&&(0,I.isObject)($.authenticationProviders)&&Object.keys($.authenticationProviders).every(k=>(0,I.isArray)($.authenticationProviders[k].scopes))){const k=$,z=!!k.canSwitch&&!q?.url,A=k.url===k.insidersUrl?"insiders":"stable",F=(z?this.userDataSyncStoreType:void 0)||A,x=q?.url||(F==="insiders"?k.insidersUrl:F==="stable"?k.stableUrl:k.url);return{url:C.URI.parse(x),type:F,defaultType:A,defaultUrl:C.URI.parse(k.url),stableUrl:C.URI.parse(k.stableUrl),insidersUrl:C.URI.parse(k.insidersUrl),canSwitch:z,authenticationProviders:Object.keys(k.authenticationProviders).reduce((Z,B)=>(Z.push({id:B,scopes:k.authenticationProviders[B].scopes}),Z),[])}}}};o=de([Y(0,v.IProductService),Y(1,m.IConfigurationService),Y(2,f.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let h=class extends o{constructor(O,q,$){super(O,q,$);const k=this.storageService.get(l,0);k&&(this.previousConfigurationSyncStore=JSON.parse(k));const z=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];z?this.storageService.store(l,JSON.stringify(z),0,1):this.storageService.remove(l,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};h=de([Y(0,v.IProductService),Y(1,m.IConfigurationService),Y(2,f.IStorageService)],h),e.UserDataSyncStoreManagementService=h;let p=class extends i.Disposable{constructor(O,q,$,k,z,A,F){super();this.requestService=$,this.logService=k,this.storageService=F,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,y.getServiceMachineId)(z,A,F).then(x=>{const Z={"X-Client-Name":`${q.applicationName}${E.isWeb?"-web":""}`,"X-Client-Version":q.version};return q.commit&&(Z["X-Client-Commit"]=q.commit),Z}),this.session=new P(t,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,i.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,q){this.authToken={token:O,type:q}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,b.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(r,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,T.createCancelablePromise)(q=>(0,T.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),q).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,q=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O),$={},k=await this.request(q.toString(),{type:"GET",headers:$},[],_.CancellationToken.None);return(await(0,g.asJson)(k)||[]).map(({url:A,created:F})=>({ref:(0,b.relativePath)(q,q.with({path:A})),created:F*1e3}))}async resolveContent(O,q){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O,q).toString(),k={};k["Cache-Control"]="no-cache";const z=await this.request($,{type:"GET",headers:k},[],_.CancellationToken.None);return await(0,g.asText)(z)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),$={};await this.request(q,{type:"DELETE",headers:$},[],_.CancellationToken.None)}async read(O,q,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();$={...$},$["Cache-Control"]="no-cache",q&&($["If-None-Match"]=q.ref);const z=await this.request(k,{type:"GET",headers:$},[304],_.CancellationToken.None);let A=null;if(z.res.statusCode===304&&(A=q),A===null){const F=z.res.headers.etag;if(!F)throw new c.UserDataSyncStoreError("Server did not return the ref",k,"NoRef",z.res.statusCode,z.res.headers[c.HEADER_OPERATION_ID]);const x=await(0,g.asText)(z);if(!x&&z.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",k,"EmptyResponse",z.res.statusCode,z.res.headers[c.HEADER_OPERATION_ID]);A={ref:F,content:x}}return A}async write(O,q,$,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();k={...k},k["Content-Type"]=R.Mimes.text,$&&(k["If-Match"]=$);const A=await this.request(z,{type:"POST",data:q,headers:k},[],_.CancellationToken.None),F=A.res.headers.etag;if(!F)throw new c.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",A.res.statusCode,A.res.headers[c.HEADER_OPERATION_ID]);return F}async manifest(O,q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();q={...q},q["Content-Type"]="application/json",O&&(q["If-None-Match"]=O.ref);const k=await this.request($,{type:"GET",headers:q},[304],_.CancellationToken.None);let z=null;if(k.res.statusCode===304&&(z=O),!z){const F=k.res.headers.etag;if(!F)throw new c.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",k.res.statusCode,k.res.headers[c.HEADER_OPERATION_ID]);const x=await(0,g.asText)(k);if(!x&&k.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",$,"EmptyResponse",k.res.statusCode,k.res.headers[c.HEADER_OPERATION_ID]);x&&(z={...JSON.parse(x),ref:F})}const A=this.storageService.get(a,0);return A&&z&&A!==z.session&&this.clearSession(),z===null&&A&&this.clearSession(),z&&this.storageService.store(a,z.session,0,1),z}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),q={"Content-Type":R.Mimes.text};await this.request(O,{type:"DELETE",headers:q},[],_.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(a,0),this.storageService.remove(n,0)}async request(O,q,$,k){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${q.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const z=await this.commonHeadersPromise;q.headers={...q.headers||{},...z,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(q.headers),this.logService.trace("Sending request to server",{url:O,type:q.type,headers:{...q.headers,authorization:void 0}});let A;try{A=await this.session.request(O,q,k)}catch(B){if(!(B instanceof c.UserDataSyncStoreError)){let j="RequestFailed";const X=(0,D.getErrorMessage)(B).toLowerCase();X.includes("xhr timeout")?j="RequestTimeout":X.includes("protocol")&&X.includes("not supported")?j="RequestProtocolNotSupported":X.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":X.includes("headers must be an object")?j="RequestHeadersNotObject":(0,D.isPromiseCanceledError)(B)&&(j="RequestCanceled"),B=new c.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,j,void 0,void 0)}throw this.logService.info("Request failed",O),B}const F=A.res.headers[c.HEADER_OPERATION_ID],x={url:O,status:A.res.statusCode,"execution-id":q.headers[c.HEADER_EXECUTION_ID],"operation-id":F},Z=(0,g.isSuccess)(A)||A.res.statusCode&&$.indexOf(A.res.statusCode)!==-1;if(Z?this.logService.trace("Request succeeded",x):this.logService.info("Request failed",x),A.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",A.res.statusCode,F);if(this._onTokenSucceed.fire(),A.res.statusCode===409)throw new c.UserDataSyncStoreError(`${q.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",A.res.statusCode,F);if(A.res.statusCode===410)throw new c.UserDataSyncStoreError(`${q.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",A.res.statusCode,F);if(A.res.statusCode===412)throw new c.UserDataSyncStoreError(`${q.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",A.res.statusCode,F);if(A.res.statusCode===413)throw new c.UserDataSyncStoreError(`${q.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",A.res.statusCode,F);if(A.res.statusCode===426)throw new c.UserDataSyncStoreError(`${q.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",A.res.statusCode,F);if(A.res.statusCode===429){const B=A.res.headers["retry-after"];throw B?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(B)*1e3)),new c.UserDataSyncStoreError(`${q.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",A.res.statusCode,F)):new c.UserDataSyncStoreError(`${q.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",A.res.statusCode,F)}if(!Z)throw new c.UserDataSyncStoreError("Server returned "+A.res.statusCode,O,"Unknown",A.res.statusCode,F);return A}addSessionHeaders(O){let q=this.storageService.get(n,0);q===void 0&&(q=(0,d.generateUuid)(),this.storageService.store(n,q,0,1)),O["X-Machine-Session-Id"]=q;const $=this.storageService.get(a,0);$!==void 0&&(O["X-User-Session-Id"]=$)}};p=de([Y(1,v.IProductService),Y(2,g.IRequestService),Y(3,c.IUserDataSyncLogService),Y(4,u.IEnvironmentService),Y(5,S.IFileService),Y(6,f.IStorageService)],p),e.UserDataSyncStoreClient=p;let w=class extends p{constructor(O,q,$,k,z,A,F){super(O.userDataSyncStore?.url,q,$,k,z,A,F);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};w=de([Y(0,c.IUserDataSyncStoreManagementService),Y(1,v.IProductService),Y(2,g.IRequestService),Y(3,c.IUserDataSyncLogService),Y(4,u.IEnvironmentService),Y(5,S.IFileService),Y(6,f.IStorageService)],w),e.UserDataSyncStoreService=w;class P{constructor(O,q,$,k){this.limit=O,this.interval=q,this.requestService=$,this.logService=k,this.requests=[],this.startTime=void 0}request(O,q,$){if(this.isExpired()&&this.reset(),q.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(q,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=P}),define(te[233],ne([0,1,3,60,27,23,22,229,24,63,64]),function(J,e,T,_,D,L,i,R,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends R.UserDataAutoSyncService{constructor(m,u,S,v,g,y,f,c,l,r,a){super(m,u,S,v,g,f,c,l,r,a);this._register(T.Event.debounce(T.Event.any(T.Event.map(y.onDidFocusWindow,()=>"windowFocus"),T.Event.map(y.onDidOpenWindow,()=>"windowOpen")),(n,t)=>n?[...n,t]:[t],1e3)(n=>this.triggerSync(n,!0,!1)))}};C=de([Y(0,D.IProductService),Y(1,E.IUserDataSyncStoreManagementService),Y(2,E.IUserDataSyncStoreService),Y(3,E.IUserDataSyncEnablementService),Y(4,E.IUserDataSyncService),Y(5,_.INativeHostService),Y(6,E.IUserDataSyncLogService),Y(7,b.IUserDataSyncAccountService),Y(8,i.ITelemetryService),Y(9,I.IUserDataSyncMachinesService),Y(10,L.IStorageService)],C),e.UserDataAutoSyncService=C}),define(te[234],ne([0,1,5,3,2]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends D.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:E,getActiveWindowId:b}){super();this.disposables=this._register(new D.DisposableStore),_.Event.latch(_.Event.any(R,E))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,T.createCancelablePromise)(()=>b()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch(C){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(te[65],ne([0,1,51,5,10,15,20,124,247,248]),function(J,e,T,_,D,L,i,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(r,a){let n=a.message;switch(r){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=r,this.cause=a}}e.ExtractError=I;function C(l){const r=l.externalFileAttributes>>16||33188;return[448,56,7].map(a=>r&a).reduce((a,n)=>a+n,r&61440)}function d(l){if(l instanceof I)return l;let r;return/end of central directory record signature not found/.test(l.message)&&(r="CorruptZip"),new I(r,l)}function m(l,r,a,n,t,s){const o=D.dirname(r),h=D.join(n,o);if(!h.startsWith(n))return Promise.reject(new Error(R.localize(0,null,r)));const p=D.join(n,r);let w;return s.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(i.Promises.mkdir(h,{recursive:!0})).then(()=>new Promise((P,M)=>{if(!s.isCancellationRequested)try{w=(0,T.createWriteStream)(p,{mode:a}),w.once("close",()=>P()),w.once("error",M),l.once("error",M),l.pipe(w)}catch(O){M(O)}}))}function u(l,r,a,n){let t=(0,_.createCancelablePromise)(()=>Promise.resolve()),s=0;return n.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((o,h)=>{const p=new _.Sequencer,w=P=>{P.isCancellationRequested||(s++,l.readEntry())};l.once("error",h),l.once("close",()=>t.then(()=>{n.isCancellationRequested||l.entryCount===s?o():h(new I("Incomplete",new Error(R.localize(1,null,s,l.entryCount))))},h)),l.readEntry(),l.on("entry",P=>{if(n.isCancellationRequested)return;if(!a.sourcePathRegex.test(P.fileName)){w(n);return}const M=P.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(M)){const $=D.join(r,M);t=(0,_.createCancelablePromise)(k=>i.Promises.mkdir($,{recursive:!0}).then(()=>w(k)).then(void 0,h));return}const O=v(l,P),q=C(P);t=(0,_.createCancelablePromise)($=>p.queue(()=>O.then(k=>m(k,M,q,r,a,$).then(()=>w($)))).then(null,h))})})}function S(l,r=!1){return new Promise((a,n)=>{(0,E.open)(l,r?{lazyEntries:!0}:void 0,(t,s)=>{t?n(d(t)):a((0,L.assertIsDefined)(s))})})}function v(l,r){return new Promise((a,n)=>{l.openReadStream(r,(t,s)=>{t?n(d(t)):a((0,L.assertIsDefined)(s))})})}function g(l,r){return new Promise((a,n)=>{const t=new b.ZipFile;r.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,T.createWriteStream)(l);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>a(l))})}e.zip=g;function y(l,r,a={},n){const t=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let s=S(l,!0);return a.overwrite&&(s=s.then(o=>i.Promises.rm(r).then(()=>o))),s.then(o=>u(o,r,{sourcePathRegex:t},n))}e.extract=y;function f(l,r){return S(l).then(a=>new Promise((n,t)=>{a.on("entry",s=>{s.fileName===r&&v(a,s).then(o=>n(o),o=>t(o))}),a.once("close",()=>t(new Error(R.localize(2,null,r))))}))}function c(l,r){return f(l,r).then(a=>new Promise((n,t)=>{const s=[];a.once("error",t),a.on("data",o=>s.push(o)),a.on("end",()=>n(Buffer.concat(s)))}))}e.buffer=c}),define(te[235],ne([0,1,65,133]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(L){return(0,T.buffer)(L,"extension/package.json").then(i=>{try{return JSON.parse(i.toString("utf8"))}catch(R){throw new Error((0,_.localize)(0,null))}})}e.getManifest=D}),define(te[236],ne([0,1,16,5,7,2,17,10,4,18,61,8,29,20,65,134,13,30,34,154,14,9,27]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v,g,y,f,c,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let a=class extends L.Disposable{constructor(t,s,o,h,p){super();this.beforeRemovingExtension=t,this.fileService=s,this.logService=o,this.environmentService=h,this.productService=p,this._devSystemExtensionsPath=null,this.systemExtensionsPath=h.builtinExtensionsPath,this.extensionsPath=h.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new _.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const s=[];(t===null||t===0)&&s.push(this.scanSystemExtensions().then(null,o=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(o).message,g.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&s.push(this.scanUserExtensions(!0).then(null,o=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(o).message,g.ExtensionManagementErrorCode.Internal))));try{const o=await Promise.all(s);return(0,T.flatten)(o)}catch(o){throw this.joinErrors(o)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[s,o]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return o=o.filter(h=>!s[new y.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).key()]),t&&(o=(0,y.groupByExtension)(o,p=>p.identifier).map(p=>p.sort((w,P)=>I.rcompare(w.manifest.version,P.manifest.version))[0])),this.logService.trace("Scanned user extensions:",o.length),o}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,s,o,h){const p=t.key(),w=R.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),P=R.join(this.extensionsPath,p);try{await m.Promises.rm(P)}catch(O){try{await m.Promises.rm(P)}catch(q){}throw new g.ExtensionManagementError((0,S.localize)(0,null,P,t.id),g.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,s,w,h);let M=await this.scanExtension(C.URI.file(w),1);if(!M)throw new Error((0,S.localize)(1,null,w));await this.storeMetadata(M,{...o,installedTimestamp:Date.now()});try{await this.rename(t,w,P,Date.now()+2*60*1e3),this.logService.info("Renamed to",P)}catch(O){try{await m.Promises.rm(w)}catch(q){}if(O.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(O)}. Deleted from extracted location`,w),O}try{M=await this.scanExtension(C.URI.file(P),1)}catch(O){}if(M)return M;throw new Error((0,S.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,s){return this.setMetadata(t,s),await this.storeMetadata(t,{...s,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const o=R.join(t.location.fsPath,"package.json"),h=await m.Promises.readFile(o,"utf8"),{manifest:p}=await this.parseManifest(h);return p.__metadata=s,await m.Promises.writeFile(o,JSON.stringify(p,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const s=t.map(o=>new y.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version));await this.withUninstalledExtensions(o=>{s.forEach(h=>o[h.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(h=>delete h[t.key()]);const o=(await this.scanExtensions(1)).find(h=>new y.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).equals(t))||null;return o?(await this.storeMetadata(o,{installedTimestamp:Date.now()}),this.scanExtension(o.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await m.Promises.readFile(this.uninstalledPath,"utf8")}catch(h){if(h.code!=="ENOENT")throw h}let o={};if(s)try{o=JSON.parse(s)}catch(h){}return t&&(t(o),Object.keys(o).length?await m.Promises.writeFile(this.uninstalledPath,JSON.stringify(o)):await m.Promises.rm(this.uninstalledPath)),o})}async removeExtension(t,s){this.logService.trace(`Deleting ${s} extension from disk`,t.identifier.id,t.location.fsPath),await m.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new y.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,s,o,h){this.logService.trace(`Started extracting the extension from ${s} to ${o}`);try{await m.Promises.rm(o)}catch(p){throw new g.ExtensionManagementError(this.joinErrors(p).message,g.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(s,o,{sourcePath:"extension",overwrite:!0},h),this.logService.info(`Extracted extension to ${o}:`,t.id)}catch(p){try{await m.Promises.rm(o)}catch(P){}let w=g.ExtensionManagementErrorCode.Extract;throw p instanceof u.ExtractError&&(p.type==="CorruptZip"?w=g.ExtensionManagementErrorCode.CorruptZip:p.type==="Incomplete"&&(w=g.ExtensionManagementErrorCode.IncompleteZip)),new g.ExtensionManagementError(p.message,w)}}async rename(t,s,o,h){try{await m.Promises.rename(s,o)}catch(p){if(E.isWindows&&p&&p.code==="EPERM"&&Date.now()<h)return this.logService.info(`Failed renaming ${s} to ${o} with 'EPERM' error. Trying again...`,t.id),this.rename(t,s,o,h);throw new g.ExtensionManagementError(p.message||(0,S.localize)(3,null,s,o),p.code||g.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const s=this.scanDevSystemExtensions(),[o,h]=await Promise.all([t,s]);return[...o,...h]}async scanExtensionsInDir(t,s){const o=new _.Limiter(10),h=await this.fileService.resolve(C.URI.file(t));return h.children?(await Promise.all(h.children.filter(w=>w.isDirectory).map(w=>o.queue(async()=>s===1&&(0,b.basename)(w.resource).indexOf(".")===0?null:this.scanExtension(w.resource,s))))).filter(w=>w&&w.identifier):[]}async scanExtension(t,s){try{const o=await this.fileService.resolve(t);if(o.children){const{manifest:h,metadata:p}=await this.readManifest(t.fsPath),w=o.children.find(({name:q})=>/^readme(\.txt|\.md|)$/i.test(q))?.resource,P=o.children.find(({name:q})=>/^changelog(\.txt|\.md|)$/i.test(q))?.resource,M={id:(0,y.getGalleryExtensionId)(h.publisher,h.name)},O={type:s,identifier:M,manifest:h,location:t,readmeUrl:w,changelogUrl:P,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(O,p),O}}catch(o){s!==0&&this.logService.trace(o)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(o=>t.some(h=>(0,y.areSameExtensions)(o.identifier,{id:h})))}else return[]}setMetadata(t,s){t.publisherDisplayName=s?.publisherDisplayName||null,t.publisherId=s?.publisherId||null,t.identifier.uuid=s?.id,t.isMachineScoped=!!s?.isMachineScoped,t.isPreReleaseVersion=!!s?.isPreReleaseVersion,t.preRelease=!!s?.preRelease,t.isBuiltin=t.type===0||!!s?.isBuiltin,t.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),o=new Set;for(const w of s)t[new y.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()]||o.add(w.identifier.id.toLowerCase());const h=(0,y.groupByExtension)(s,w=>w.identifier);await _.Promises.settled(h.map(async w=>{const P=w.sort((M,O)=>I.rcompare(M.manifest.version,O.manifest.version))[0];o.has(P.identifier.id.toLowerCase())||await this.beforeRemovingExtension(P)}));const p=s.filter(w=>t[new y.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()]);await _.Promises.settled(p.map(w=>this.removeUninstalledExtension(w)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),s=[],o=(0,y.groupByExtension)(t,h=>h.identifier);s.push(...(0,T.flatten)(o.map(h=>h.sort((p,w)=>I.rcompare(p.manifest.version,w.manifest.version)).slice(1)))),await _.Promises.settled(s.map(h=>this.removeExtension(h,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,h)=>new Error(`${o.message}${o.message?",":""}${h instanceof Error?h.message:h}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(i.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const s=[m.Promises.readFile(R.join(t,"package.json"),"utf8").then(w=>this.parseManifest(w)),m.Promises.readFile(R.join(t,"package.nls.json"),"utf8").then(void 0,w=>w.code!=="ENOENT"?Promise.reject(w):"{}").then(w=>JSON.parse(w))],[{manifest:o,metadata:h},p]=await Promise.all(s);return{manifest:(0,f.localizeManifest)(o,p),metadata:h}}parseManifest(t){return new Promise((s,o)=>{try{const h=JSON.parse(t),p=h.__metadata||null;s({manifest:h,metadata:p})}catch(h){o(new Error((0,S.localize)(4,null)))}})}};a=de([Y(1,c.IFileService),Y(2,l.ILogService),Y(3,v.INativeEnvironmentService),Y(4,r.IProductService)],a),e.ExtensionsScanner=a}),define(te[237],ne([0,1,38,7,17,10,4,32,18,61,8,29,20,65,132,79,13,199,30,34,183,172,235,184,236,213,76,14,6,9,27,22,35]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v,g,y,f,c,l,r,a,n,t,s,o,h,p,w,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let O=class extends g.AbstractExtensionManagementService{constructor(F,x,Z,B,j,X,U,N,W){super(F,x,Z,N);this.environmentService=B,this.downloadService=j,this.fileService=U;const V=this._register(X.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(n.ExtensionsScanner,ee=>V.postUninstall(ee))),this.manifestCache=this._register(new a.ExtensionsManifestCache(B,this)),this.extensionsDownloader=this._register(X.createInstance(c.ExtensionsDownloader));const G=this._register(new t.ExtensionsWatcher(this,U,B,Z,W));this._register(G.onDidChangeExtensionsByAnotherSource(({added:ee,removed:H})=>{ee.length&&this._onDidInstallExtensions.fire(ee.map(Q=>({identifier:Q.identifier,operation:1,local:Q}))),H.forEach(Q=>this._onDidUninstallExtension.fire({identifier:Q}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const F=await this.isAlpineLinux(),x=(0,y.getTargetPlatform)(F?"alpine":i.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",x),x})()),this._targetPlatformPromise}async isAlpineLinux(){if(!i.isLinux)return!1;let F;try{F=(await this.fileService.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch(x){try{F=(await this.fileService.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(Z){this.logService.debug("Error while getting the os-release file.",(0,_.getErrorMessage)(Z))}}return!!F&&(F.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(F){this.logService.trace("ExtensionManagementService#zip",F.identifier.id);const x=await this.collectFiles(F),Z=await(0,m.zip)((0,E.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,x);return I.URI.file(Z)}async unzip(F){return this.logService.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const x=await this.downloadVsix(F),Z=L.resolve(x.fsPath);return(0,r.getManifest)(Z)}getInstalled(F=null){return this.extensionsScanner.scanExtensions(F)}async install(F,x={}){this.logService.trace("ExtensionManagementService#install",F.toString());const Z=await this.downloadVsix(F),B=await(0,r.getManifest)(L.resolve(Z.fsPath));if(B.engines&&B.engines.vscode&&!(0,s.isEngineValid)(B.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,(0,f.getGalleryExtensionId)(B.publisher,B.name),this.productService.version));return this.installExtension(B,Z,x)}async updateMetadata(F,x){this.logService.trace("ExtensionManagementService#updateMetadata",F.identifier.id);const Z={...F.manifest.__metadata||{},...x};return x.isPreReleaseVersion&&(Z.preRelease=!0),F=await this.extensionsScanner.saveMetadataForLocalExtension(F,Z),this.manifestCache.invalidate(),F}async updateExtensionScope(F,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",F.identifier.id),F=await this.extensionsScanner.saveMetadataForLocalExtension(F,{...F.manifest.__metadata||{},isMachineScoped:x}),this.manifestCache.invalidate(),F}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(F){if(F.scheme===D.Schemas.file)return F;const x=(0,E.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(F,x),x}createInstallExtensionTask(F,x,Z){return I.URI.isUri(x)?new k(F,x,Z,this.galleryService,this.extensionsScanner,this.logService):new $(x,Z,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(F,x){return new z(F,x,this.extensionsScanner)}async collectFiles(F){const x=async B=>{let j=await d.Promises.readdir(B);j=j.map(N=>L.join(B,N));const X=await Promise.all(j.map(N=>d.Promises.stat(N)));let U=Promise.resolve([]);return X.forEach((N,W)=>{const V=j[W];N.isFile()&&(U=U.then(G=>[...G,V])),N.isDirectory()&&(U=U.then(G=>x(V).then(ee=>[...G,...ee])))}),U};return(await x(F.location.fsPath)).map(B=>({path:`extension/${L.relative(F.location.fsPath,B)}`,localPath:B}))}};O=de([Y(0,y.IExtensionGalleryService),Y(1,P.ITelemetryService),Y(2,p.ILogService),Y(3,v.INativeEnvironmentService),Y(4,S.IDownloadService),Y(5,h.IInstantiationService),Y(6,o.IFileService),Y(7,w.IProductService),Y(8,M.IUriIdentityService)],O),e.ExtensionManagementService=O;class q extends g.AbstractExtensionTask{constructor(F,x,Z,B){super();this.identifier=F,this.source=x,this.extensionsScanner=Z,this.logService=B,this._operation=2}get operation(){return this._operation}async installExtension(F,x){try{const Z=await this.unsetUninstalledAndGetLocal(F.identifierWithVersion);if(Z)return F.metadata?this.extensionsScanner.saveMetadataForLocalExtension(Z,{...Z.manifest.__metadata||{},...F.metadata}):Z}catch(Z){throw i.isMacintosh?new y.ExtensionManagementError(u.localize(1,null),y.ExtensionManagementErrorCode.Internal):new y.ExtensionManagementError(u.localize(2,null),y.ExtensionManagementErrorCode.Internal)}return this.extract(F,x)}async unsetUninstalledAndGetLocal(F){if(!await this.isUninstalled(F))return null;this.logService.trace("Removing the extension from uninstalled list:",F.id);const Z=await this.extensionsScanner.setInstalled(F);return this.logService.info("Removed the extension from uninstalled list:",F.id),Z}async isUninstalled(F){return!!(await this.extensionsScanner.getUninstalledExtensions())[F.key()]}async extract({zipPath:F,identifierWithVersion:x,metadata:Z},B){let j=await this.extensionsScanner.extractUserExtension(x,F,Z,B);return this.logService.info("Extracting completed.",x.id),j}}class $ extends q{constructor(F,x,Z,B,j){super(F.identifier,F,B,j);this.gallery=F,this.options=x,this.extensionsDownloader=Z}async doRun(F){const Z=(await this.extensionsScanner.scanExtensions(null)).find(j=>(0,f.areSameExtensions)(j.identifier,this.gallery.identifier));Z&&(this._operation=3);const B=await this.downloadInstallableExtension(this.gallery,this._operation);B.metadata.isMachineScoped=this.options.isMachineScoped||Z?.isMachineScoped,B.metadata.isBuiltin=this.options.isBuiltin||Z?.isBuiltin,B.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,B.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:Z?.preRelease;try{const j=await this.installExtension(B,F);return Z&&b.neq(Z.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(Z),j}catch(j){throw await this.deleteDownloadedVSIX(B.zipPath),j}}async deleteDownloadedVSIX(F){try{await this.extensionsDownloader.delete(I.URI.file(F))}catch(x){this.logService.warn("Error while deleting the downloaded vsix",F.toString(),(0,_.getErrorMessage)(x))}}async downloadInstallableExtension(F,x){const Z={id:F.identifier.uuid,publisherId:F.publisherId,publisherDisplayName:F.publisherDisplayName};let B;try{this.logService.trace("Started downloading extension:",F.identifier.id),B=(await this.extensionsDownloader.downloadExtension(F,x)).fsPath,this.logService.info("Downloaded extension:",F.identifier.id,B)}catch(j){throw new y.ExtensionManagementError((0,g.joinErrors)(j).message,y.ExtensionManagementErrorCode.Download)}try{const j=await(0,r.getManifest)(B);return{zipPath:B,identifierWithVersion:new f.ExtensionIdentifierWithVersion(F.identifier,j.version),metadata:Z}}catch(j){throw await this.deleteDownloadedVSIX(B),new y.ExtensionManagementError((0,g.joinErrors)(j).message,y.ExtensionManagementErrorCode.Invalid)}}}class k extends q{constructor(F,x,Z,B,j,X){super({id:(0,f.getGalleryExtensionId)(F.publisher,F.name)},x,j,X);this.manifest=F,this.location=x,this.options=Z,this.galleryService=B}async doRun(F){const x=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),B=(await this.extensionsScanner.scanExtensions(1)).find(X=>(0,f.areSameExtensions)(this.identifier,X.identifier)),j=await this.getMetadata(this.identifier.id,this.manifest.version,F);if(j.isMachineScoped=this.options.isMachineScoped||B?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||B?.isBuiltin,B)if(this._operation=3,x.equals(new f.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version)))try{await this.extensionsScanner.removeExtension(B,"existing")}catch(X){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else b.gt(B.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(B);else{const X=await this.unsetUninstalledAndGetLocal(x);if(X)try{await this.extensionsScanner.removeExtension(X,"existing")}catch(U){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:L.resolve(this.location.fsPath),identifierWithVersion:x,metadata:j},F)}async getMetadata(F,x,Z){try{let[B]=await this.galleryService.getExtensions([{id:F,version:x}],Z);if(B||([B]=await this.galleryService.getExtensions([{id:F}],Z)),B)return{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId,isPreReleaseVersion:B.properties.isPreReleaseVersion,preRelease:B.properties.isPreReleaseVersion}}catch(B){}return{}}}class z extends g.AbstractExtensionTask{constructor(F,x,Z){super();this.extension=F,this.options=x,this.extensionsScanner=Z}async doRun(F){const x=[],Z=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const B=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);x.push(...Z.filter(j=>B.equals(new f.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version))))}else x.push(...Z.filter(B=>(0,f.areSameExtensions)(B.identifier,this.extension.identifier)));if(!x.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const B of x)try{F.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(B)}catch(j){throw new Error(u.localize(6,null,(0,T.toErrorMessage)(j)))}}}}),define(te[238],ne([0,1,81,55,33,19,7,3,2,10,4,29,36,71,249]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class S{constructor(P,M=""){this.debugLabel=M,this.socket=P,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,i.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(P,M){m.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,P,M)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(P){const M=O=>{this.traceSocketEvent("read",O),P(L.VSBuffer.wrap(O))};return this.socket.on("data",M),{dispose:()=>this.socket.off("data",M)}}onClose(P){const M=O=>{this.traceSocketEvent("close",{hadError:O}),P({type:0,hadError:O,error:void 0})};return this.socket.on("close",M),{dispose:()=>this.socket.off("close",M)}}onEnd(P){const M=()=>{this.traceSocketEvent("nodeEndReceived"),P()};return this.socket.on("end",M),{dispose:()=>this.socket.off("end",M)}}write(P){if(!this.socket.destroyed)try{this.traceSocketEvent("write",P),this.socket.write(P.buffer,M=>{if(M){if(M.code==="EPIPE")return;(0,i.onUnexpectedError)(M)}})}catch(M){if(M.code==="EPIPE")return;(0,i.onUnexpectedError)(M)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((P,M)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),P();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),P()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=S;var v;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var g;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(g||(g={}));class y extends E.Disposable{constructor(P,M,O,q){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=P,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:M,inflateBytesLength:O?.byteLength||0,recordInflateBytes:q}),this._flowManager=this._register(new f(this,M,O,q,this._onData,($,k)=>this._write($,k))),this._register(this._flowManager.onError($=>{console.error($),(0,i.onUnexpectedError)($),this._onClose.fire({type:0,hadError:!0,error:$})})),this._incomingData=new m.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose($=>this._onClose.fire($)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(P,M){this.socket.traceSocketEvent(P,M)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this._onData.event(P)}onClose(P){return this._onClose.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){this._flowManager.writeMessage(P)}_write(P,M){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",P);let O=2;P.byteLength<126?O+=0:P.byteLength<2**16?O+=2:O+=8;const q=L.VSBuffer.alloc(O);if(M?q.writeUInt8(194,0):q.writeUInt8(130,0),P.byteLength<126)q.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){q.writeUInt8(126,1);let $=1;q.writeUInt8(P.byteLength>>>8&255,++$),q.writeUInt8(P.byteLength>>>0&255,++$)}else{q.writeUInt8(127,1);let $=1;q.writeUInt8(0,++$),q.writeUInt8(0,++$),q.writeUInt8(0,++$),q.writeUInt8(0,++$),q.writeUInt8(P.byteLength>>>24&255,++$),q.writeUInt8(P.byteLength>>>16&255,++$),q.writeUInt8(P.byteLength>>>8&255,++$),q.writeUInt8(P.byteLength>>>0&255,++$)}this.socket.write(L.VSBuffer.concat([q,P]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(P){if(P.byteLength!==0){for(this._incomingData.acceptChunk(P);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const M=this._incomingData.peek(this._state.readLen),O=M.readUInt8(0),q=(O&128)>>>7,$=(O&64)>>>6,k=M.readUInt8(1),z=(k&128)>>>7,A=k&127;this._state.state=2,this._state.readLen=2+(z?4:0)+(A===126?2:0)+(A===127?8:0),this._state.fin=q,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean($)),this._state.firstFrameOfMessage=Boolean(q),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const M=this._incomingData.read(this._state.readLen),O=M.readUInt8(1),q=(O&128)>>>7;let $=O&127,k=1;$===126?$=M.readUInt8(++k)*2**8+M.readUInt8(++k):$===127&&($=M.readUInt8(++k)*0+M.readUInt8(++k)*0+M.readUInt8(++k)*0+M.readUInt8(++k)*0+M.readUInt8(++k)*2**24+M.readUInt8(++k)*2**16+M.readUInt8(++k)*2**8+M.readUInt8(++k));let z=0;q&&(z=M.readUInt8(++k)*2**24+M.readUInt8(++k)*2**16+M.readUInt8(++k)*2**8+M.readUInt8(++k)),this._state.state=3,this._state.readLen=$,this._state.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const M=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",M),r(M,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",M),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(M,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class f extends E.Disposable{constructor(P,M,O,q,$,k){super();this._tracer=P,this._onData=$,this._writeFn=k,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,M?(this._zlibInflateStream=this._register(new c(this._tracer,q,O,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(z=>this._onError.fire(z))),this._register(this._zlibDeflateStream.onError(z=>this._onError.fire(z)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}writeMessage(P){this._writeQueue.push(P),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const P=this._writeQueue.shift();if(this._zlibDeflateStream){const M=await this._deflateMessage(this._zlibDeflateStream,P);this._writeFn(M,!0)}else this._writeFn(P,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(P,M){return new Promise((O,q)=>{P.write(M),P.flush($=>O($))})}acceptFrame(P,M,O){this._readQueue.push({data:P,isCompressed:M,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const P=this._readQueue.shift();if(this._zlibInflateStream&&P.isCompressed){const M=await this._inflateFrame(this._zlibInflateStream,P.data,P.isLastFrameOfMessage);this._onData.fire(M)}else this._onData.fire(P.data)}this._isProcessingReadQueue=!1}}_inflateFrame(P,M,O){return new Promise((q,$)=>{P.write(M),O&&P.write(L.VSBuffer.fromByteArray([0,0,255,255])),P.flush(k=>q(k))})}}class c extends E.Disposable{constructor(P,M,O,q){super();this._tracer=P,this._recordInflateBytes=M,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=u.createInflateRaw(q),this._zlibInflate.on("error",$=>{this._tracer.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibInflate.on("data",$=>{this._tracer.traceSocketEvent("zlibInflateData",$),this._pendingInflateData.push(L.VSBuffer.wrap($))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}write(P){this._recordInflateBytes&&this._recordedInflateBytes.push(P.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",P),this._zlibInflate.write(P.buffer)}flush(P){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const M=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,P(M)})}}class l extends E.Disposable{constructor(P,M){super();this._tracer=P,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=u.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(L.VSBuffer.wrap(O))})}write(P){this._tracer.traceSocketEvent("zlibDeflateWrite",P.buffer),this._zlibDeflate.write(P.buffer)}flush(P){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let M=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,M=M.slice(0,M.byteLength-4),P(M)})}}function r(w,P){if(P===0)return;let M=w.byteLength>>>2;for(let A=0;A<M;A++){const F=w.readUInt32BE(A*4);w.writeUInt32BE(F^P,A*4)}let O=M*4,q=w.byteLength-O;const $=P>>>24&255,k=P>>>16&255,z=P>>>8&255;q>=1&&w.writeUInt8(w.readUInt8(O)^$,O),q>=2&&w.writeUInt8(w.readUInt8(O+1)^k,O+1),q>=3&&w.writeUInt8(w.readUInt8(O+2)^z,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const w=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;let P;return e.XDG_RUNTIME_DIR?P=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${w}.sock`):P=(0,b.join)((0,D.tmpdir)(),`vscode-ipc-${w}.sock`),s(P),P}e.createRandomIPCHandle=n;function t(w,P,M){const O=(0,T.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${M}-${P}-sock`;let q;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?q=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${M}-${P}.sock`):q=(0,b.join)(w,`${M}-${P}.sock`),s(q),q}e.createStaticIPCHandle=t;function s(w){const P=a[I.platform];typeof P=="number"&&w.length>=P&&console.warn(`WARNING: IPC handle "${w}" is longer than ${P} chars, try a shorter --user-data-dir`)}class o extends d.IPCServer{constructor(P){super(o.toClientConnectionEvent(P));this.server=P}static toClientConnectionEvent(P){const M=R.Event.fromNodeEventEmitter(P,"connection");return R.Event.map(M,O=>({protocol:new m.Protocol(new S(O,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function h(w){return new Promise((P,M)=>{const O=(0,_.createServer)();O.on("error",M),O.listen(w,()=>{O.removeListener("error",M),P(new o(O))})})}e.serve=h;function p(w,P){return new Promise((M,O)=>{const q=(0,_.createConnection)(w,()=>{q.removeListener("error",O),M(m.Client.fromSocket(new S(q,`ipc-client${P}`),P))});q.once("error",O)})}e.connect=p}),define(te[239],ne([0,1,55,238]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,L,i,R,E){const b=C=>E(C,void 0),I=T.createConnection({host:D,port:L},()=>{I.removeListener("error",b);const C=Buffer.alloc(16);for(let S=0;S<16;S++)C[S]=Math.round(Math.random()*256);const d=C.toString("base64"),m=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${L}/?${i}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];I.write(m.join(`\r
`)+`\r
\r
`);const u=S=>{S.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",u),E(void 0,new _.NodeSocket(I,R)))};I.on("data",u)});I.setNoDelay(!0),I.once("error",b)}}}),define(te[240],ne([0,1,55,114,239,5,2,21,9,27,181,62,91]),function(J,e,T,_,D,L,i,R,E,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function m(y,f,c,l,r){let a;for(let n=3;n&&(a&&a.dispose(),a=await new u(y,f,c,l,r).waitForReady(),!(r&&_.BROWSER_RESTRICTED_PORTS[r]||!_.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));n--);return a}class u extends i.Disposable{constructor(f,c,l,r,a){super();this.defaultTunnelHost=c,this.suggestedLocalPort=a,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=f,this._server=T.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(c=>{c()})}async waitForReady(){let f=await(0,_.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),c=null;return this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address(),c||(f=0,this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(f){f.pause();const c=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,I.connectRemoteAgentTunnel)(this._options,c,this.tunnelRemotePort),r=l.getSocket().socket,a=l.readEntireBuffer();l.dispose(),a.byteLength>0&&f.write(a.buffer),f.on("end",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),r.end()}),f.on("close",()=>r.end()),f.on("error",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),r.destroy()}),r.on("end",()=>f.end()),r.on("close",()=>f.end()),r.on("error",()=>{f.destroy()}),f.pipe(r),r.pipe(f),f.localAddress&&this._socketsDispose.set(f.localAddress,()=>{f.end(),r.end()})}}let S=class extends C.AbstractTunnelService{constructor(f,c,l,r,a){super(c);this.socketFactory=f,this.signService=l,this.productService=r,this.configurationService=a}get defaultTunnelHost(){const f=this.configurationService.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(f,c,l,r,a,n,t){const s=this.getTunnelFromMap(c,l);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,c,l,r,a,n,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${l} on local port ${r}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:f,signService:this.signService,logService:this.logService,ipcLogger:null},h=m(o,this.defaultTunnelHost,c,l,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(c,l,h),h}}};S=de([Y(1,E.ILogService),Y(2,d.ISignService),Y(3,b.IProductService),Y(4,R.IConfigurationService)],S),e.BaseTunnelService=S;let v=class extends S{constructor(f,c,l,r){super(D.nodeSocketFactory,f,c,l,r)}};v=de([Y(0,E.ILogService),Y(1,d.ISignService),Y(2,b.IProductService),Y(3,R.IConfigurationService)],v),e.TunnelService=v;let g=class extends i.Disposable{constructor(f,c,l,r){super();this.logService=f,this.productService=c,this.signService=l,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(f,c,l,r,a,n,t,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${r} on local port ${a}.`),!this._tunnelServices.has(f)){const o=new v(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(f,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(f))})}return this._tunnelServices.get(f).openTunnel(c,l,r,a,n,t,s)}};g=de([Y(0,E.ILogService),Y(1,b.IProductService),Y(2,d.ISignService),Y(3,R.IConfigurationService)],g),e.SharedTunnelsService=g}),define(te[250],ne([0,1,72,33,38,7,2,17,18,8,36,118,177,159,178,169,170,171,157,161,21,179,78,198,79,189,13,152,194,202,30,160,200,237,80,155,14,174,176,52,6,166,83,167,168,59,185,9,85,60,86,27,188,43,23,196,197,22,92,93,94,44,203,204,95,206,212,97,98,24,63,225,227,228,64,226,230,231,232,233,234,91,193,62,240,186,187,90,192,84,201,35,214]),function(J,e,T,_,D,L,i,R,E,b,I,C,d,m,u,S,v,g,y,f,c,l,r,a,n,t,s,o,h,p,w,P,M,O,q,$,k,z,A,F,x,Z,B,j,X,U,N,W,V,G,ee,H,Q,re,oe,ce,he,be,Ie,Se,ve,Re,ye,De,Le,Fe,$e,ze,ie,ae,le,we,Ce,Oe,Te,Ne,Ae,Me,K,se,ue,fe,pe,ge,Ee,Pe,ke,_e,We,He,Ye,Ct,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Pt extends i.Disposable{constructor(me){super();this.configuration=me,this.server=this._register(new C.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const me=()=>this.dispose();process.once("exit",me),T.ipcRenderer.once("vscode:electron-main->shared-process=exit",me);const Ue="vscode:electron-main->shared-process=disposeWorker",qe=(Ge,je)=>this.onDisposeWorker(je);T.ipcRenderer.on(Ue,qe),this._register((0,i.toDisposable)(()=>T.ipcRenderer.removeListener(Ue,qe)))}onDisposeWorker(me){this.sharedProcessWorkerService?.disposeWorker(me)}async open(){const me=await this.initServices();(0,ae.registerConfiguration)(),me.invokeFunction(Ue=>{const qe=Ue.get(W.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(qe)}),this._register((0,i.combinedDisposable)(me.createInstance(d.CodeCacheCleaner,this.configuration.codeCachePath),me.createInstance(u.LanguagePackCachedDataCleaner),me.createInstance(g.StorageDataCleaner,this.configuration.backupWorkspacesPath),me.createInstance(v.LogsDataCleaner),me.createInstance(S.LocalizationsUpdater),me.createInstance(m.ExtensionsCleaner)))}async initServices(){const me=new B.ServiceCollection,Ue={_serviceBrand:void 0,...ee.default};me.set(H.IProductService,Ue);const qe=new I.StaticRouter(Be=>Be==="main"),Ge=new j.MessagePortMainProcessService(this.server,qe);me.set(X.IMainProcessService,Ge);const je=new o.NativeEnvironmentService(this.configuration.args,Ue);me.set(s.INativeEnvironmentService,je);const rt=new V.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),Qe=new V.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Ge.getChannel("logger"));me.set(W.ILoggerService,Qe);const at=this._register(new W.MultiplexLogService([this._register(new W.ConsoleLogger(this.configuration.logLevel)),this._register(Qe.createLogger((0,E.joinPath)(b.URI.file(je.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Je=this._register(new V.FollowerLogService(rt,at));me.set(W.ILogService,Je),this.sharedProcessWorkerService=new We.SharedProcessWorkerService(Je),me.set(_e.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Xe=this._register(new z.FileService(Je));me.set(k.IFileService,Xe);const ct=this._register(new A.DiskFileSystemProvider(Je));Xe.registerProvider(R.Schemas.file,ct);const xe=this._register(new l.ConfigurationService(je.settingsResource,Xe));me.set(c.IConfigurationService,xe);const tt=new ce.NativeStorageService(void 0,Ge,je);me.set(oe.IStorageService,tt),this._register((0,i.toDisposable)(()=>tt.flush())),await Promise.all([xe.initialize(),tt.initialize()]),me.set(He.IUserConfigurationFileService,I.ProxyChannel.toService(Ge.getChannel(He.UserConfigurationFileServiceId))),me.set(Ct.IUriIdentityService,new It.UriIdentityService(Xe)),me.set(re.IRequestService,new F.SyncDescriptor(Q.RequestService)),me.set(y.IChecksumService,new F.SyncDescriptor(f.ChecksumService));const st=I.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});me.set(G.INativeHostService,st),me.set(n.IDownloadService,new F.SyncDescriptor(t.DownloadService));const lt=this._register(new ue.ActiveWindowManager(st)),ut=new I.StaticRouter(Be=>lt.getActiveClientId().then(dt=>Be===dt));me.set(q.IExtensionRecommendationNotificationService,new $.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new Ye.AssignmentService(this.configuration.machineId,xe,Ue);let nt;const Ze=[];if((0,Re.supportsTelemetry)(Ue,je)){const Be=new Se.TelemetryLogAppender(Qe,je);Ze.push(Be);const{appRoot:dt,extensionsPath:kt,installSourcePath:Tt}=je;if(Ue.aiConfig&&Ue.aiConfig.asimovKey){const ot=await ht.getTreatment("telemetryMigration")??!1,ft=Ue.quality!=="stable";if(ft&&ot){const wt=new ye.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,ot,!0);this._register((0,i.toDisposable)(()=>wt.flush())),Ze.push(wt)}const yt=new ye.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,ft?!1:ot,ot&&ft);this._register((0,i.toDisposable)(()=>yt.flush())),Ze.push(yt)}nt=new ve.TelemetryService({appenders:Ze,commonProperties:(0,he.resolveCommonProperties)(Xe,(0,_.release)(),(0,_.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,Tt),sendErrorTelemetry:!0,piiPaths:[dt,kt]},xe)}else{nt=Re.NullTelemetryService;const Be=Re.NullAppender;Ze.push(Be)}this.server.registerChannel("telemetryAppender",new Ie.TelemetryAppenderChannel(Ze)),me.set(be.ITelemetryService,nt);const Dt=new De.CustomEndpointTelemetryService(xe,nt,Qe,je);me.set(be.ICustomEndpointTelemetryService,Dt),me.set(w.IExtensionManagementService,new F.SyncDescriptor(O.ExtensionManagementService)),me.set(w.IExtensionGalleryService,new F.SyncDescriptor(p.ExtensionGalleryService)),me.set(w.IExtensionTipsService,new F.SyncDescriptor(M.ExtensionTipsService)),me.set(U.ILocalizationsService,new F.SyncDescriptor(N.LocalizationsService)),me.set(r.IDiagnosticsService,new F.SyncDescriptor(a.DiagnosticsService)),me.set(le.IUserDataSyncAccountService,new F.SyncDescriptor(le.UserDataSyncAccountService)),me.set(ae.IUserDataSyncLogService,new F.SyncDescriptor(Oe.UserDataSyncLogService)),me.set(ae.IUserDataSyncUtilService,new Ce.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),me.set(w.IGlobalExtensionEnablementService,new F.SyncDescriptor(h.GlobalExtensionEnablementService)),me.set(ie.IIgnoredExtensionsManagementService,new F.SyncDescriptor(ie.IgnoredExtensionsManagementService)),me.set(ze.IExtensionsStorageSyncService,new F.SyncDescriptor(ze.ExtensionsStorageSyncService)),me.set(ae.IUserDataSyncStoreManagementService,new F.SyncDescriptor(K.UserDataSyncStoreManagementService)),me.set(ae.IUserDataSyncStoreService,new F.SyncDescriptor(K.UserDataSyncStoreService)),me.set(Te.IUserDataSyncMachinesService,new F.SyncDescriptor(Te.UserDataSyncMachinesService)),me.set(ae.IUserDataSyncBackupStoreService,new F.SyncDescriptor(we.UserDataSyncBackupStoreService)),me.set(ae.IUserDataSyncEnablementService,new F.SyncDescriptor(Ne.UserDataSyncEnablementService)),me.set(ae.IUserDataSyncService,new F.SyncDescriptor(Ae.UserDataSyncService));const St=new $e.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:xe.getValue("terminal.integrated.persistentSessionScrollback")??100},xe,je,Je,nt);return await St.initialize(),me.set(Fe.ILocalPtyService,this._register(St)),me.set(fe.ISignService,new F.SyncDescriptor(pe.SignService)),me.set(ge.ISharedTunnelsService,new F.SyncDescriptor(Ee.SharedTunnelsService)),me.set(Pe.ISharedProcessTunnelService,new F.SyncDescriptor(ke.SharedProcessTunnelService)),new Z.InstantiationService(me)}initChannels(me){const Ue=new P.ExtensionManagementChannel(me.get(w.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const qe=I.ProxyChannel.fromService(me.get(U.ILocalizationsService));this.server.registerChannel("localizations",qe);const Ge=I.ProxyChannel.fromService(me.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Ge);const je=new P.ExtensionTipsChannel(me.get(w.IExtensionTipsService));this.server.registerChannel("extensionTipsService",je);const rt=I.ProxyChannel.fromService(me.get(y.IChecksumService));this.server.registerChannel("checksum",rt);const Qe=new Ce.UserDataSyncMachinesServiceChannel(me.get(Te.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Qe);const at=I.ProxyChannel.fromService(me.get(be.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const Je=new Ce.UserDataSyncAccountServiceChannel(me.get(le.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Je);const Xe=new Ce.UserDataSyncStoreManagementServiceChannel(me.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Xe);const ct=new Me.UserDataSyncChannel(me.get(ae.IUserDataSyncService),me.get(W.ILogService));this.server.registerChannel("userDataSync",ct);const xe=this._register(me.get(x.IInstantiationService).createInstance(se.UserDataAutoSyncService)),tt=new Ce.UserDataAutoSyncChannel(xe);this.server.registerChannel("userDataAutoSync",tt);const st=me.get(Fe.ILocalPtyService),lt=I.ProxyChannel.fromService(st);this.server.registerChannel(Le.TerminalIpcChannels.LocalPty,lt);const ut=I.ProxyChannel.fromService(me.get(Pe.ISharedProcessTunnelService));this.server.registerChannel(Pe.ipcSharedProcessTunnelChannelName,ut);const ht=I.ProxyChannel.fromService(me.get(_e.ISharedProcessWorkerService));this.server.registerChannel(_e.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(me){window.addEventListener("unhandledrejection",Ue=>{(0,L.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Ue=>{const qe=(0,D.toErrorMessage)(Ue,!0);!qe||me.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function Rt(pt){const me=new Pt(pt);T.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await me.open(),T.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Rt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/658e5c951e45a6df3591f82a3961cec49924ed9a/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
