/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/errors","vs/base/common/resources","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","fs","vs/platform/telemetry/common/telemetry","vs/platform/workspaces/common/workspaces","vs/base/common/arrays","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/labels","vs/base/common/process","vs/platform/windows/electron-main/windows","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","child_process","vs/base/common/errorMessage","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/objects","vs/platform/environment/common/environment","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/backup/electron-main/backup","vs/platform/environment/node/argvHelper","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/base/parts/ipc/node/ipc.net","vs/base/common/keybindings","vs/base/common/stream","crypto","net","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/keybindingParser","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/diskFileSystemProviderIpc","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","worker_threads","vs/code/electron-main/main"],x=function(q){for(var e=[],w=0,R=q.length;w<R;w++)e[w]=Z[q[w]];return e};define(Z[103],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(R,D){if(!R)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=w}),define(Z[46],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function w(n){return(I,d,g)=>{let y=null,E=null;if(typeof g.value=="function"?(y="value",E=g.value):typeof g.get=="function"&&(y="get",E=g.get),!E)throw new Error("not supported");g[y]=n(E,d)}}e.createDecorator=w;function R(n,I,d){let g=null,y=null;if(typeof d.value=="function"?(g="value",y=d.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(g="get",y=d.get),!y)throw new Error("not supported");const E=`$memoize$${I}`;d[g]=function(...m){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,m)}),this[E]}}e.memoize=R;function D(n,I,d){return w((g,y)=>{const E=`$debounce$${y}`,m=`$debounce$result$${y}`;return function(...S){this[m]||(this[m]=d?d():void 0),clearTimeout(this[E]),I&&(this[m]=I(this[m],...S),S=[this[m]]),this[E]=setTimeout(()=>{g.apply(this,S),this[m]=d?d():void 0},n)}})}e.debounce=D;function k(n,I,d){return w((g,y)=>{const E=`$throttle$timer$${y}`,m=`$throttle$result$${y}`,S=`$throttle$lastRun$${y}`,t=`$throttle$pending$${y}`;return function(...f){if(this[m]||(this[m]=d?d():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...f)),this[t])return;const b=this[S]+n;b<=Date.now()?(this[S]=Date.now(),g.apply(this,[this[m]]),this[m]=d?d():void 0):(this[t]=!0,this[E]=setTimeout(()=>{this[t]=!1,this[S]=Date.now(),g.apply(this,[this[m]]),this[m]=d?d():void 0},b-Date.now()))}})}e.throttle=k}),define(Z[15],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(u=>{u(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=w,e.errorHandler=new w;function R(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=R;function D(l){d(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function k(l){d(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=k;function n(l){if(l instanceof Error){let{name:s,message:u}=l;const r=l.stacktrace||l.stack;return{$isError:!0,name:s,message:u,stack:r}}return l}e.transformErrorForSerialization=n;const I="Canceled";function d(l){return l instanceof Error&&l.name===I&&l.message===I}e.isPromiseCanceledError=d;class g extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=g;function y(){const l=new Error(I);return l.name=l.message,l}e.canceled=y;function E(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=E;function m(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=m;function S(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function t(l){const s=new Error(`${l} has been disposed`);return s.name="DISPOSED",s}e.disposed=t;function f(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=f;class b extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=b;class p extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=p;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function c(l){const s=l;return s instanceof Error&&Array.isArray(s.actions)}e.isErrorWithActions=c;function a(l,s=Object.create(null)){const u=new Error(l);return s.actions&&(u.actions=s.actions),u}e.createErrorWithActions=a}),define(Z[30],x([0,1,15]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(W,C=0){return W[W.length-(1+C)]}e.tail=R;function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=D;function k(W,C,T=(_,z)=>_===z){if(W===C)return!0;if(!W||!C||W.length!==C.length)return!1;for(let _=0,z=W.length;_<z;_++)if(!T(W[_],C[_]))return!1;return!0}e.equals=k;function n(W,C,T){let _=0,z=W.length-1;for(;_<=z;){const Y=(_+z)/2|0,N=T(W[Y],C);if(N<0)_=Y+1;else if(N>0)z=Y-1;else return Y}return-(_+1)}e.binarySearch=n;function I(W,C){let T=0,_=W.length;if(_===0)return 0;for(;T<_;){const z=Math.floor((T+_)/2);C(W[z])?_=z:T=z+1}return T}e.findFirstInSorted=I;function d(W,C,T){if(W=W|0,W>=C.length)throw new TypeError("invalid index");let _=C[Math.floor(C.length*Math.random())],z=[],Y=[],N=[];for(let j of C){const ne=T(j,_);ne<0?z.push(j):ne>0?Y.push(j):N.push(j)}return W<z.length?d(W,z,T):W<z.length+N.length?N[0]:d(W-(z.length+N.length),Y,T)}e.quickSelect=d;function g(W,C){const T=[];let _;for(const z of W.slice(0).sort(C))!_||C(_[0],z)!==0?(_=[z],T.push(_)):_.push(z);return T}e.groupBy=g;function y(W,C,T){const _=[];function z(j,ne,se){if(ne===0&&se.length===0)return;const oe=_[_.length-1];oe&&oe.start+oe.deleteCount===j?(oe.deleteCount+=ne,oe.toInsert.push(...se)):_.push({start:j,deleteCount:ne,toInsert:se})}let Y=0,N=0;for(;;){if(Y===W.length){z(Y,0,C.slice(N));break}if(N===C.length){z(Y,W.length-Y,[]);break}const j=W[Y],ne=C[N],se=T(j,ne);se===0?(Y+=1,N+=1):se<0?(z(Y,1,[]),Y+=1):se>0&&(z(Y,0,[ne]),N+=1)}return _}e.sortedDiff=y;function E(W,C,T){const _=y(W,C,T),z=[],Y=[];for(const N of _)z.push(...W.slice(N.start,N.start+N.deleteCount)),Y.push(...N.toInsert);return{removed:z,added:Y}}e.delta=E;function m(W,C,T){if(T===0)return[];const _=W.slice(0,T).sort(C);return t(W,C,_,T,W.length),_}e.top=m;function S(W,C,T,_,z){return T===0?Promise.resolve([]):new Promise((Y,N)=>{(async()=>{const j=W.length,ne=W.slice(0,T).sort(C);for(let se=T,oe=Math.min(T+_,j);se<j;se=oe,oe=Math.min(oe+_,j)){if(se>T&&await new Promise(J=>setTimeout(J)),z&&z.isCancellationRequested)throw(0,w.canceled)();t(W,C,ne,se,oe)}return ne})().then(Y,N)})}e.topAsync=S;function t(W,C,T,_,z){for(const Y=T.length;_<z;_++){const N=W[_];if(C(N,T[Y-1])<0){T.pop();const j=I(T,ne=>C(N,ne)<0);T.splice(j,0,N)}}}function f(W){return W.filter(C=>!!C)}e.coalesce=f;function b(W){let C=0;for(let T=0;T<W.length;T++)W[T]&&(W[C]=W[T],C+=1);W.length=C}e.coalesceInPlace=b;function p(W,C,T){W.splice(T,0,W.splice(C,1)[0])}e.move=p;function P(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=P;function c(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=c;function a(W,C=T=>T){const T=new Set;return W.filter(_=>{const z=C(_);return T.has(z)?!1:(T.add(z),!0)})}e.distinct=a;function l(W){const C=Object.create(null);return T=>{const _=W(T);return C[_]?!1:(C[_]=!0,!0)}}e.uniqueFilter=l;function s(W,C){const T=u(W,C);if(T!==-1)return W[T]}e.findLast=s;function u(W,C){for(let T=W.length-1;T>=0;T--){const _=W[T];if(C(_))return T}return-1}e.lastIndex=u;function r(W,C){return W.length>0?W[0]:C}e.firstOrDefault=r;function i(W,C,T=(_,z)=>_===z){let _=0;for(let z=0,Y=Math.min(W.length,C.length);z<Y&&T(W[z],C[z]);z++)_++;return _}e.commonPrefixLength=i;function o(W){return[].concat(...W)}e.flatten=o;function h(W,C){let T=typeof C=="number"?W:0;typeof C=="number"?T=W:(T=0,C=W);const _=[];if(T<=C)for(let z=T;z<C;z++)_.push(z);else for(let z=T;z>C;z--)_.push(z);return _}e.range=h;function v(W,C,T){return W.reduce((_,z)=>(_[C(z)]=T?T(z):z,_),Object.create(null))}e.index=v;function M(W,C){return W.push(C),()=>A(W,C)}e.insert=M;function A(W,C){const T=W.indexOf(C);if(T>-1)return W.splice(T,1),C}e.remove=A;function L(W,C,T){const _=W.slice(0,C),z=W.slice(C);return _.concat(T,z)}e.arrayInsert=L;function F(W,C){let T;if(typeof C=="number"){let _=C;T=()=>{const z=Math.sin(_++)*179426549;return z-Math.floor(z)}}else T=Math.random;for(let _=W.length-1;_>0;_-=1){const z=Math.floor(T()*(_+1)),Y=W[_];W[_]=W[z],W[z]=Y}}e.shuffle=F;function U(W,C){const T=W.indexOf(C);T>-1&&(W.splice(T,1),W.unshift(C))}e.pushToStart=U;function Q(W,C){const T=W.indexOf(C);T>-1&&(W.splice(T,1),W.push(C))}e.pushToEnd=Q;function ie(W,C){return Array.isArray(W)?W.map(C):C(W)}e.mapArrayOrNot=ie;function re(W){return Array.isArray(W)?W:[W]}e.asArray=re;function G(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=G;function O(W,C){for(const T of W){const _=C(T);if(_!==void 0)return _}}e.mapFind=O;function B(W,C,T){const _=X(W,C),z=W.length,Y=T.length;W.length=z+Y;for(let N=z-1;N>=_;N--)W[N+Y]=W[N];for(let N=0;N<Y;N++)W[N+_]=T[N]}e.insertInto=B;function V(W,C,T,_){const z=X(W,C),Y=W.splice(z,T);return B(W,z,_),Y}e.splice=V;function X(W,C){return C<0?Math.max(C+W.length,0):Math.min(C,W.length)}function $(W,C){let T=Number.MAX_SAFE_INTEGER,_=0;return W.forEach((z,Y)=>{const N=C(z);N<T&&(T=N,_=Y)}),_}e.minIndex=$;function H(W,C){let T=Number.MIN_SAFE_INTEGER,_=0;return W.forEach((z,Y)=>{const N=C(z);N>T&&(T=N,_=Y)}),_}e.maxIndex=H;class ee{constructor(C){this.items=C,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(C){let T=this.firstIdx;for(;T<this.items.length&&C(this.items[T]);)T++;const _=T===this.firstIdx?null:this.items.slice(this.firstIdx,T);return this.firstIdx=T,_}takeFromEndWhile(C){let T=this.lastIdx;for(;T>=0&&C(this.items[T]);)T--;const _=T===this.lastIdx?null:this.items.slice(T+1,this.lastIdx+1);return this.lastIdx=T,_}peek(){return this.items[this.firstIdx]}dequeue(){const C=this.items[this.firstIdx];return this.firstIdx++,C}takeCount(C){const T=this.items.slice(this.firstIdx,this.firstIdx+C);return this.firstIdx+=C,T}}e.ArrayQueue=ee}),define(Z[42],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(R){const D=this;let k=!1,n;return function(){return k||(k=!0,n=R.apply(D,arguments)),n}}e.once=w}),define(Z[69],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(R){function D(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}R.is=D;const k=Object.freeze([]);function n(){return k}R.empty=n;function*I(l){yield l}R.single=I;function d(l){return l||k}R.from=d;function g(l){return!l||l[Symbol.iterator]().next().done===!0}R.isEmpty=g;function y(l){return l[Symbol.iterator]().next().value}R.first=y;function E(l,s){for(const u of l)if(s(u))return!0;return!1}R.some=E;function m(l,s){for(const u of l)if(s(u))return u}R.find=m;function*S(l,s){for(const u of l)s(u)&&(yield u)}R.filter=S;function*t(l,s){let u=0;for(const r of l)yield s(r,u++)}R.map=t;function*f(...l){for(const s of l)for(const u of s)yield u}R.concat=f;function*b(l){for(const s of l)for(const u of s)yield u}R.concatNested=b;function p(l,s,u){let r=u;for(const i of l)r=s(r,i);return r}R.reduce=p;function*P(l,s,u=l.length){for(s<0&&(s+=l.length),u<0?u+=l.length:u>l.length&&(u=l.length);s<u;s++)yield l[s]}R.slice=P;function c(l,s=Number.POSITIVE_INFINITY){const u=[];if(s===0)return[u,l];const r=l[Symbol.iterator]();for(let i=0;i<s;i++){const o=r.next();if(o.done)return[u,R.empty()];u.push(o.value)}return[u,{[Symbol.iterator](){return r}}]}R.consume=c;function a(l,s,u=(r,i)=>r===i){const r=l[Symbol.iterator](),i=s[Symbol.iterator]();for(;;){const o=r.next(),h=i.next();if(o.done!==h.done)return!1;if(o.done)return!0;if(!u(o.value,h.value))return!1}}R.equals=a})(w=e.Iterable||(e.Iterable={}))}),define(Z[38],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var R;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(s){s.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function n(s,u=!1){let r=0,i=s.length,o="",h=0,v=16,M=0;function A(G){let O=0,B=0;for(;O<G;){const V=s.charCodeAt(r);if(V>=48&&V<=57)B=B*16+V-48;else if(V>=65&&V<=70)B=B*16+V-65+10;else if(V>=97&&V<=102)B=B*16+V-97+10;else break;r++,O++}return O<G&&(B=-1),B}function L(G){r=G,o="",h=0,v=16,M=0}function F(){const G=r;if(s.charCodeAt(r)===48)r++;else for(r++;r<s.length&&g(s.charCodeAt(r));)r++;if(r<s.length&&s.charCodeAt(r)===46)if(r++,r<s.length&&g(s.charCodeAt(r)))for(r++;r<s.length&&g(s.charCodeAt(r));)r++;else return M=3,s.substring(G,r);let O=r;if(r<s.length&&(s.charCodeAt(r)===69||s.charCodeAt(r)===101))if(r++,(r<s.length&&s.charCodeAt(r)===43||s.charCodeAt(r)===45)&&r++,r<s.length&&g(s.charCodeAt(r))){for(r++;r<s.length&&g(s.charCodeAt(r));)r++;O=r}else M=3;return s.substring(G,O)}function U(){let G="",O=r;for(;;){if(r>=i){G+=s.substring(O,r),M=2;break}const B=s.charCodeAt(r);if(B===34){G+=s.substring(O,r),r++;break}if(B===92){if(G+=s.substring(O,r),r++,r>=i){M=2;break}switch(s.charCodeAt(r++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:const X=A(4);X>=0?G+=String.fromCharCode(X):M=4;break;default:M=5}O=r;continue}if(B>=0&&B<=31)if(d(B)){G+=s.substring(O,r),M=2;break}else M=6;r++}return G}function Q(){if(o="",M=0,h=r,r>=i)return h=i,v=17;let G=s.charCodeAt(r);if(I(G)){do r++,o+=String.fromCharCode(G),G=s.charCodeAt(r);while(I(G));return v=15}if(d(G))return r++,o+=String.fromCharCode(G),G===13&&s.charCodeAt(r)===10&&(r++,o+=`
`),v=14;switch(G){case 123:return r++,v=1;case 125:return r++,v=2;case 91:return r++,v=3;case 93:return r++,v=4;case 58:return r++,v=6;case 44:return r++,v=5;case 34:return r++,o=U(),v=10;case 47:const O=r-1;if(s.charCodeAt(r+1)===47){for(r+=2;r<i&&!d(s.charCodeAt(r));)r++;return o=s.substring(O,r),v=12}if(s.charCodeAt(r+1)===42){r+=2;const B=i-1;let V=!1;for(;r<B;){if(s.charCodeAt(r)===42&&s.charCodeAt(r+1)===47){r+=2,V=!0;break}r++}return V||(r++,M=1),o=s.substring(O,r),v=13}return o+=String.fromCharCode(G),r++,v=16;case 45:if(o+=String.fromCharCode(G),r++,r===i||!g(s.charCodeAt(r)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=F(),v=11;default:for(;r<i&&ie(G);)r++,G=s.charCodeAt(r);if(h!==r){switch(o=s.substring(h,r),o){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return o+=String.fromCharCode(G),r++,v=16}}function ie(G){if(I(G)||d(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let G;do G=Q();while(G>=12&&G<=15);return G}return{setPosition:L,getPosition:()=>r,scan:u?re:Q,getToken:()=>v,getTokenValue:()=>o,getTokenOffset:()=>h,getTokenLength:()=>r-h,getTokenError:()=>M}}e.createScanner=n;function I(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function d(s){return s===10||s===13||s===8232||s===8233}function g(s){return s>=48&&s<=57}var y;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(y||(y={}));function E(s,u){const r=[],i=new Object;let o;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function M(A,L,F,U){h.value=A,h.offset=L,h.length=F,h.type=U,h.colonOffset=void 0,o=h}try{c(s,{onObjectBegin:(A,L)=>{if(u<=A)throw i;o=void 0,v=u>A,r.push("")},onObjectProperty:(A,L,F)=>{if(u<L||(M(A,L,F,"property"),r[r.length-1]=A,u<=L+F))throw i},onObjectEnd:(A,L)=>{if(u<=A)throw i;o=void 0,r.pop()},onArrayBegin:(A,L)=>{if(u<=A)throw i;o=void 0,r.push(0)},onArrayEnd:(A,L)=>{if(u<=A)throw i;o=void 0,r.pop()},onLiteralValue:(A,L,F)=>{if(u<L||(M(A,L,F,l(A)),u<=L+F))throw i},onSeparator:(A,L,F)=>{if(u<=L)throw i;if(A===":"&&o&&o.type==="property")o.colonOffset=L,v=!1,o=void 0;else if(A===","){const U=r[r.length-1];typeof U=="number"?r[r.length-1]=U+1:(v=!0,r[r.length-1]=""),o=void 0}}})}catch(A){if(A!==i)throw A}return{path:r,previousNode:o,isAtPropertyKey:v,matches:A=>{let L=0;for(let F=0;L<A.length&&F<r.length;F++)if(A[L]===r[F]||A[L]==="*")L++;else if(A[L]!=="**")return!1;return L===A.length}}}e.getLocation=E;function m(s,u=[],r=k.DEFAULT){let i=null,o=[];const h=[];function v(A){Array.isArray(o)?o.push(A):i!==null&&(o[i]=A)}return c(s,{onObjectBegin:()=>{const A={};v(A),h.push(o),o=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const A=[];v(A),h.push(o),o=A,i=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:v,onError:(A,L,F)=>{u.push({error:A,offset:L,length:F})}},r),o[0]}e.parse=m;function S(s,u=[],r=k.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(A){i.type==="property"&&(i.length=A-i.offset,i=i.parent)}function h(A){return i.children.push(A),A}c(s,{onObjectBegin:A=>{i=h({type:"object",offset:A,length:-1,parent:i,children:[]})},onObjectProperty:(A,L,F)=>{i=h({type:"property",offset:L,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:A,offset:L,length:F,parent:i})},onObjectEnd:(A,L)=>{i.length=A+L-i.offset,i=i.parent,o(A+L)},onArrayBegin:(A,L)=>{i=h({type:"array",offset:A,length:-1,parent:i,children:[]})},onArrayEnd:(A,L)=>{i.length=A+L-i.offset,i=i.parent,o(A+L)},onLiteralValue:(A,L,F)=>{h({type:l(A),offset:L,length:F,parent:i,value:A}),o(L+F)},onSeparator:(A,L,F)=>{i.type==="property"&&(A===":"?i.colonOffset=L:A===","&&o(L))},onError:(A,L,F)=>{u.push({error:A,offset:L,length:F})}},r);const M=i.children[0];return M&&delete M.parent,M}e.parseTree=S;function t(s,u){if(!s)return;let r=s;for(let i of u)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const h of r.children)if(Array.isArray(h.children)&&h.children[0].value===i){r=h.children[1],o=!0;break}if(!o)return}else{const o=i;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=t;function f(s){if(!s.parent||!s.parent.children)return[];const u=f(s.parent);if(s.parent.type==="property"){const r=s.parent.children[0].value;u.push(r)}else if(s.parent.type==="array"){const r=s.parent.children.indexOf(s);r!==-1&&u.push(r)}return u}e.getNodePath=f;function b(s){switch(s.type){case"array":return s.children.map(b);case"object":const u=Object.create(null);for(let r of s.children){const i=r.children[1];i&&(u[r.children[0].value]=b(i))}return u;case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=b;function p(s,u,r=!1){return u>=s.offset&&u<s.offset+s.length||r&&u===s.offset+s.length}e.contains=p;function P(s,u,r=!1){if(p(s,u,r)){const i=s.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=u;o++){const h=P(i[o],u,r);if(h)return h}return s}}e.findNodeAtOffset=P;function c(s,u,r=k.DEFAULT){const i=n(s,!1);function o(T){return T?()=>T(i.getTokenOffset(),i.getTokenLength()):()=>!0}function h(T){return T?_=>T(_,i.getTokenOffset(),i.getTokenLength()):()=>!0}const v=o(u.onObjectBegin),M=h(u.onObjectProperty),A=o(u.onObjectEnd),L=o(u.onArrayBegin),F=o(u.onArrayEnd),U=h(u.onLiteralValue),Q=h(u.onSeparator),ie=o(u.onComment),re=h(u.onError),G=r&&r.disallowComments,O=r&&r.allowTrailingComma;function B(){for(;;){const T=i.scan();switch(i.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:G||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(T){case 12:case 13:G?V(10):ie();break;case 16:V(1);break;case 15:case 14:break;default:return T}}}function V(T,_=[],z=[]){if(re(T),_.length+z.length>0){let Y=i.getToken();for(;Y!==17;){if(_.indexOf(Y)!==-1){B();break}else if(z.indexOf(Y)!==-1)break;Y=B()}}}function X(T){const _=i.getTokenValue();return T?U(_):M(_),B(),!0}function $(){switch(i.getToken()){case 11:let T=0;try{T=JSON.parse(i.getTokenValue()),typeof T!="number"&&(V(2),T=0)}catch(_){V(2)}U(T);break;case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return B(),!0}function H(){return i.getToken()!==10?(V(3,[],[2,5]),!1):(X(!1),i.getToken()===6?(Q(":"),B(),C()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function ee(){v(),B();let T=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(T||V(4,[],[]),Q(","),B(),i.getToken()===2&&O)break}else T&&V(6,[],[]);H()||V(4,[],[2,5]),T=!0}return A(),i.getToken()!==2?V(7,[2],[]):B(),!0}function W(){L(),B();let T=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(T||V(4,[],[]),Q(","),B(),i.getToken()===4&&O)break}else T&&V(6,[],[]);C()||V(4,[],[4,5]),T=!0}return F(),i.getToken()!==4?V(8,[4],[]):B(),!0}function C(){switch(i.getToken()){case 3:return W();case 1:return ee();case 10:return X(!0);default:return $()}}return B(),i.getToken()===17?r.allowEmptyContent?!0:(V(4,[],[]),!1):C()?(i.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=c;function a(s,u){let r=n(s),i=[],o,h=0,v;do switch(v=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:h!==v&&i.push(s.substring(h,v)),u!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,u)),h=r.getPosition();break}while(o!==17);return i.join("")}e.stripComments=a;function l(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(Z[104],x([0,1,38]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(d,g,y){let E,m,S,t,f;if(g){for(t=g.offset,f=t+g.length,S=t;S>0&&!I(d,S-1);)S--;let h=f;for(;h<d.length&&!I(d,h);)h++;m=d.substring(S,h),E=k(m,y)}else m=d,E=0,S=0,t=0,f=d.length;const b=n(y,d);let p=!1,P=0,c;y.insertSpaces?c=D(" ",y.tabSize||4):c="	";const a=(0,w.createScanner)(m,!1);let l=!1;function s(){return b+D(c,E+P)}function u(){let h=a.scan();for(p=!1;h===15||h===14;)p=p||h===14,h=a.scan();return l=h===16||a.getTokenError()!==0,h}const r=[];function i(h,v,M){!l&&v<f&&M>t&&d.substring(v,M)!==h&&r.push({offset:v,length:M-v,content:h})}let o=u();if(o!==17){const h=a.getTokenOffset()+S,v=D(c,E);i(v,S,h)}for(;o!==17;){let h=a.getTokenOffset()+a.getTokenLength()+S,v=u(),M="";for(;!p&&(v===12||v===13);){const L=a.getTokenOffset()+S;i(" ",h,L),h=a.getTokenOffset()+a.getTokenLength()+S,M=v===12?s():"",v=u()}if(v===2)o!==1&&(P--,M=s());else if(v===4)o!==3&&(P--,M=s());else{switch(o){case 3:case 1:P++,M=s();break;case 5:case 12:M=s();break;case 13:p?M=s():M=" ";break;case 6:M=" ";break;case 10:if(v===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?M=" ":v!==5&&v!==17&&(l=!0);break;case 16:l=!0;break}p&&(v===12||v===13)&&(M=s())}const A=a.getTokenOffset()+S;i(M,h,A),o=v}return r}e.format=R;function D(d,g){let y="";for(let E=0;E<g;E++)y+=d;return y}function k(d,g){let y=0,E=0;const m=g.tabSize||4;for(;y<d.length;){const S=d.charAt(y);if(S===" ")E++;else if(S==="	")E+=m;else break;y++}return Math.floor(E/m)}function n(d,g){for(let y=0;y<g.length;y++){const E=g.charAt(y);if(E==="\r")return y+1<g.length&&g.charAt(y+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return d&&d.eol||`
`}e.getEOL=n;function I(d,g){return`\r
`.indexOf(d.charAt(g))!==-1}e.isEOL=I}),define(Z[78],x([0,1,38,104]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(g,y,E){return k(g,y,void 0,E)}e.removeProperty=D;function k(g,y,E,m,S){const t=y.slice(),f=[],b=(0,w.parseTree)(g,f);let p,P;for(;t.length>0&&(P=t.pop(),p=(0,w.findNodeAtLocation)(b,t),p===void 0&&E!==void 0);)typeof P=="string"?E={[P]:E}:E=[E];if(p)if(p.type==="object"&&typeof P=="string"&&Array.isArray(p.children)){const c=(0,w.findNodeAtLocation)(p,[P]);if(c!==void 0)if(E===void 0){if(!c.parent)throw new Error("Malformed AST");const a=p.children.indexOf(c.parent);let l,s=c.parent.offset+c.parent.length;if(a>0){const u=p.children[a-1];l=u.offset+u.length}else l=p.offset+1,p.children.length>1&&(s=p.children[1].offset);return n(g,{offset:l,length:s-l,content:""},m)}else return n(g,{offset:c.offset,length:c.length,content:JSON.stringify(E)},m);else{if(E===void 0)return[];const a=`${JSON.stringify(P)}: ${JSON.stringify(E)}`,l=S?S(p.children.map(u=>u.children[0].value)):p.children.length;let s;if(l>0){const u=p.children[l-1];s={offset:u.offset+u.length,length:0,content:","+a}}else p.children.length===0?s={offset:p.offset+1,length:0,content:a}:s={offset:p.offset+1,length:0,content:a+","};return n(g,s,m)}}else if(p.type==="array"&&typeof P=="number"&&Array.isArray(p.children))if(E!==void 0){const c=`${JSON.stringify(E)}`;let a;if(p.children.length===0||P===0)a={offset:p.offset+1,length:0,content:p.children.length===0?c:c+","};else{const l=P===-1||P>p.children.length?p.children.length:P,s=p.children[l-1];a={offset:s.offset+s.length,length:0,content:","+c}}return n(g,a,m)}else{const c=P,a=p.children[c];let l;if(p.children.length===1)l={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===c){const s=p.children[c-1],u=s.offset+s.length,r=p.offset+p.length;l={offset:u,length:r-2-u,content:""}}else l={offset:a.offset,length:p.children[c+1].offset-a.offset,content:""};return n(g,l,m)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${p.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return n(g,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(E)},m)}}e.setProperty=k;function n(g,y,E){let m=I(g,y),S=y.offset,t=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;S>0&&!(0,R.isEOL)(m,S-1);)S--;for(;t<m.length&&!(0,R.isEOL)(m,t);)t++}const f=(0,R.format)(m,{offset:S,length:t-S},E);for(let p=f.length-1;p>=0;p--){const P=f[p];m=I(m,P),S=Math.min(S,P.offset),t=Math.max(t,P.offset+P.length),t+=P.content.length-P.length}const b=g.length-(m.length-t)-S;return[{offset:S,length:b,content:m.substring(S,t)}]}e.withFormatting=n;function I(g,y){return g.substring(0,y.offset)+y.content+g.substring(y.offset+y.length)}e.applyEdit=I;function d(g,y){let E=y.slice(0).sort((S,t)=>{const f=S.offset-t.offset;return f===0?S.length-t.length:f}),m=g.length;for(let S=E.length-1;S>=0;S--){let t=E[S];if(t.offset+t.length<=m)g=I(g,t);else throw new Error("Overlapping edit");m=t.offset}return g}e.applyEdits=d}),define(Z[79],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var w;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(w=e.KeyCode||(e.KeyCode={}));var R;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(R=e.ScanCode||(e.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(f,b){this._keyCodeToStr[f]=b,this._strToKeyCode[b.toLowerCase()]=f}keyCodeToStr(f){return this._keyCodeToStr[f]}strToKeyCode(f){return this._strToKeyCode[f.toLowerCase()]||0}}const k=new D,n=new D,I=new D;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const d=[],g=Object.create(null),y=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>y[t]||0,toEnum:t=>g[t]||0,toString:t=>d[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",f=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let b=[],p=[];for(const P of f){const[c,a,l,s,u,r,i,o,h,v]=P;if(p[l]||(p[l]=!0,d[l]=s,g[s]=l,y[s.toLowerCase()]=l,a&&(e.IMMUTABLE_CODE_TO_KEY_CODE[l]=u,u!==0&&u!==3&&u!==5&&u!==4&&u!==6&&u!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[u]=l))),!b[u]){if(b[u]=!0,!r)throw new Error(`String representation missing for key code ${u} around scan code ${s}`);k.define(u,r),n.define(u,h||r),I.define(u,v||h||r)}i&&(e.EVENT_KEY_CODE_MAP[i]=u),o&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[o]=u)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var E;(function(t){function f(l){return k.keyCodeToStr(l)}t.toString=f;function b(l){return k.strToKeyCode(l)}t.fromString=b;function p(l){return n.keyCodeToStr(l)}t.toUserSettingsUS=p;function P(l){return I.keyCodeToStr(l)}t.toUserSettingsGeneral=P;function c(l){return n.strToKeyCode(l)||I.strToKeyCode(l)}t.fromUserSettings=c;function a(l){if(l>=93&&l<=108)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return k.keyCodeToStr(l)}t.toElectronAccelerator=a})(E=e.KeyCodeUtils||(e.KeyCodeUtils={}));var m;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(m=e.KeyMod||(e.KeyMod={}));function S(t,f){const b=(f&65535)<<16>>>0;return(t|b)>>>0}e.KeyChord=S}),define(Z[58],x([0,1,15]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var R;(function(E){E[E.CtrlCmd=2048]="CtrlCmd",E[E.Shift=1024]="Shift",E[E.Alt=512]="Alt",E[E.WinCtrl=256]="WinCtrl",E[E.KeyCode=255]="KeyCode"})(R||(R={}));function D(E,m){if(E===0)return null;const S=(E&65535)>>>0,t=(E&4294901760)>>>16;return t!==0?new I([k(S,m),k(t,m)]):new I([k(S,m)])}e.createKeybinding=D;function k(E,m){const S=!!(E&2048),t=!!(E&256),f=m===2?t:S,b=!!(E&1024),p=!!(E&512),P=m===2?S:t,c=E&255;return new n(f,b,p,P,c)}e.createSimpleKeybinding=k;class n{constructor(m,S,t,f,b){this.ctrlKey=m,this.shiftKey=S,this.altKey=t,this.metaKey=f,this.keyCode=b}equals(m){return this.ctrlKey===m.ctrlKey&&this.shiftKey===m.shiftKey&&this.altKey===m.altKey&&this.metaKey===m.metaKey&&this.keyCode===m.keyCode}getHashCode(){const m=this.ctrlKey?"1":"0",S=this.shiftKey?"1":"0",t=this.altKey?"1":"0",f=this.metaKey?"1":"0";return`${m}${S}${t}${f}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new I([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=n;class I{constructor(m){if(m.length===0)throw(0,w.illegalArgument)("parts");this.parts=m}getHashCode(){let m="";for(let S=0,t=this.parts.length;S<t;S++)S!==0&&(m+=";"),m+=this.parts[S].getHashCode();return m}equals(m){if(m===null||this.parts.length!==m.parts.length)return!1;for(let S=0;S<this.parts.length;S++)if(!this.parts[S].equals(m.parts[S]))return!1;return!0}}e.ChordKeybinding=I;class d{constructor(m,S,t,f,b){this.ctrlKey=m,this.shiftKey=S,this.altKey=t,this.metaKey=f,this.scanCode=b}equals(m){return this.ctrlKey===m.ctrlKey&&this.shiftKey===m.shiftKey&&this.altKey===m.altKey&&this.metaKey===m.metaKey&&this.scanCode===m.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=d;class g{constructor(m,S,t,f,b,p){this.ctrlKey=m,this.shiftKey=S,this.altKey=t,this.metaKey=f,this.keyLabel=b,this.keyAriaLabel=p}}e.ResolvedKeybindingPart=g;class y{}e.ResolvedKeybinding=y}),define(Z[105],x([0,1,79,58]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(n){n=n.toLowerCase().trim();let I=!1,d=!1,g=!1,y=!1,E;do E=!1,/^ctrl(\+|\-)/.test(n)&&(I=!0,n=n.substr("ctrl-".length),E=!0),/^shift(\+|\-)/.test(n)&&(d=!0,n=n.substr("shift-".length),E=!0),/^alt(\+|\-)/.test(n)&&(g=!0,n=n.substr("alt-".length),E=!0),/^meta(\+|\-)/.test(n)&&(y=!0,n=n.substr("meta-".length),E=!0),/^win(\+|\-)/.test(n)&&(y=!0,n=n.substr("win-".length),E=!0),/^cmd(\+|\-)/.test(n)&&(y=!0,n=n.substr("cmd-".length),E=!0);while(E);let m;const S=n.indexOf(" ");return S>0?(m=n.substring(0,S),n=n.substring(S)):(m=n,n=""),{remains:n,ctrl:I,shift:d,alt:g,meta:y,key:m}}static parseSimpleKeybinding(n){const I=this._readModifiers(n),d=w.KeyCodeUtils.fromUserSettings(I.key);return[new R.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,d),I.remains]}static parseKeybinding(n,I){if(!n)return null;const d=[];let g;do[g,n]=this.parseSimpleKeybinding(n),d.push(g);while(n.length>0);return new R.ChordKeybinding(d)}static parseSimpleUserBinding(n){const I=this._readModifiers(n),d=I.key.match(/^\[([^\]]+)\]$/);if(d){const y=d[1],E=w.ScanCodeUtils.lowerCaseToEnum(y);return[new R.ScanCodeBinding(I.ctrl,I.shift,I.alt,I.meta,E),I.remains]}const g=w.KeyCodeUtils.fromUserSettings(I.key);return[new R.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,g),I.remains]}static parseUserBinding(n){if(!n)return[];const I=[];let d;for(;n.length>0;)[d,n]=this.parseSimpleUserBinding(n),I.push(d);return I}}e.KeybindingParser=D}),define(Z[2],x([0,1,42,69]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let k=null;function n(i){k=i}if(e.setDisposableTracker=n,D){const i="__is_disposable_tracked__";n(new class{trackDisposable(o){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[i]||console.log(h)},3e3)}setParent(o,h){if(o&&o!==P.None)try{o[i]=!0}catch{}}markAsDisposed(o){if(o&&o!==P.None)try{o[i]=!0}catch{}}markAsSingleton(o){}})}function I(i){return k?.trackDisposable(i),i}function d(i){k?.markAsDisposed(i)}function g(i,o){k?.setParent(i,o)}function y(i,o){if(!!k)for(const h of i)k.setParent(h,o)}function E(i){return k?.markAsSingleton(i),i}e.markAsSingleton=E;class m extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=m;function S(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=S;function t(i){if(R.Iterable.is(i)){let o=[];for(const h of i)if(h)try{h.dispose()}catch(v){o.push(v)}if(o.length===1)throw o[0];if(o.length>1)throw new m(o);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=t;function f(...i){const o=b(()=>t(i));return y(i,o),o}e.combinedDisposable=f;function b(i){const o=I({dispose:(0,w.once)(()=>{d(o),i()})});return o}e.toDisposable=b;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return g(o,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new p,I(this),g(this._store,this)}dispose(){d(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&g(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&g(o,null),o}}e.MutableDisposable=c;class a{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class l{constructor(){this.references=new Map}acquire(o,...h){let v=this.references.get(o);v||(v={counter:0,object:this.createReferencedObject(o,...h)},this.references.set(o,v));const{object:M}=v,A=(0,w.once)(()=>{--v.counter==0&&(this.destroyReferencedObject(o,v.object),this.references.delete(o))});return v.counter++,{object:M,dispose:A}}}e.ReferenceCollection=l;class s{constructor(o){this.referenceCollection=o}async acquire(o,...h){const v=this.referenceCollection.acquire(o,...h);try{return{object:await v.object,dispose:()=>v.dispose()}}catch(M){throw v.dispose(),M}}}e.AsyncReferenceCollection=s;class u{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=u;function r(i){const o=new p;try{i(o)}finally{o.dispose()}}e.disposeOnReturn=r}),define(Z[106],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(k){this.element=k,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class R{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let k=this._first;for(;k!==w.Undefined;){const n=k.next;k.prev=w.Undefined,k.next=w.Undefined,k=n}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,n){const I=new w(k);if(this._first===w.Undefined)this._first=I,this._last=I;else if(n){const g=this._last;this._last=I,I.prev=g,g.next=I}else{const g=this._first;this._first=I,I.next=g,g.prev=I}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(I))}}shift(){if(this._first!==w.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==w.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==w.Undefined&&k.next!==w.Undefined){const n=k.prev;n.next=k.next,k.next.prev=n}else k.prev===w.Undefined&&k.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):k.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):k.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==w.Undefined;)yield k.element,k=k.next}}e.LinkedList=R}),function(){function q(D){const k=[];typeof D=="number"&&k.push("code/timeOrigin",D);function n(d){k.push(d,Date.now())}function I(){const d=[];for(let g=0;g<k.length;g+=2)d.push({name:k[g],startTime:k[g+1]});return d}return{mark:n,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const n of performance.getEntriesByType("mark"))k.push({name:n.name,startTime:Math.round(D+n.startTime)});return k}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function w(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=w(R))}(),define(Z[3],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const w="en";let R=!1,D=!1,k=!1,n=!1,I=!1,d=!1,g=!1,y=!1,E,m=w,S,t;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const b=typeof f?.versions?.electron=="string",p=b&&f?.type==="renderer";if(e.isElectronSandboxed=p&&f?.sandboxed,typeof navigator=="object"&&!p)t=navigator.userAgent,R=t.indexOf("Windows")>=0,D=t.indexOf("Macintosh")>=0,y=(t.indexOf("Macintosh")>=0||t.indexOf("iPad")>=0||t.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=t.indexOf("Linux")>=0,d=!0,E=navigator.language,m=E;else if(typeof f=="object"){R=f.platform==="win32",D=f.platform==="darwin",k=f.platform==="linux",n=k&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,g=b,E=w,m=w;const o=f.env.VSCODE_NLS_CONFIG;if(o)try{const h=JSON.parse(o),v=h.availableLanguages["*"];E=h.locale,m=v||w,S=h._translationsConfigFile}catch(h){}I=!0}else console.error("Unable to resolve platform.");var P;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function c(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let a=0;D?a=1:R?a=3:k&&(a=2),e.isWindows=R,e.isMacintosh=D,e.isLinux=k,e.isLinuxSnap=n,e.isNative=I,e.isElectron=g,e.isWeb=d,e.isIOS=y,e.platform=a,e.userAgent=t,e.language=m;var l;(function(o){function h(){return e.language}o.value=h;function v(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=v;function M(){return e.language==="en"}o.isDefault=M})(l=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=S,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let M=0,A=o.length;M<A;M++){const L=o[M];if(L.id===v.data.vscodeScheduleAsyncWork){o.splice(M,1),L.callback();return}}});let h=0;return v=>{const M=++h;o.push({id:M,callback:v}),e.globals.postMessage({vscodeScheduleAsyncWork:M},"*")}}return o=>setTimeout(o)})();var s;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||y?2:R?1:3;let u=!0,r=!1;function i(){if(!r){r=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,u=new Uint16Array(o.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=i}),define(Z[34],x([0,1,3]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let R;if(typeof w.globals.vscode!="undefined"&&typeof w.globals.vscode.process!="undefined"){const D=w.globals.vscode.process;R={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.arch=R.arch}),define(Z[9],x([0,1,34]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,D=97,k=90,n=122,I=46,d=47,g=92,y=58,E=63;class m extends Error{constructor(a,l,s){let u;typeof l=="string"&&l.indexOf("not ")===0?(u="must not be",l=l.replace(/^not /,"")):u="must be";const r=a.indexOf(".")!==-1?"property":"argument";let i=`The "${a}" ${r} ${u} of type ${l}`;i+=`. Received type ${typeof s}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function S(c,a){if(typeof c!="string")throw new m(a,"string",c)}function t(c){return c===d||c===g}function f(c){return c===d}function b(c){return c>=R&&c<=k||c>=D&&c<=n}function p(c,a,l,s){let u="",r=0,i=-1,o=0,h=0;for(let v=0;v<=c.length;++v){if(v<c.length)h=c.charCodeAt(v);else{if(s(h))break;h=d}if(s(h)){if(!(i===v-1||o===1))if(o===2){if(u.length<2||r!==2||u.charCodeAt(u.length-1)!==I||u.charCodeAt(u.length-2)!==I){if(u.length>2){const M=u.lastIndexOf(l);M===-1?(u="",r=0):(u=u.slice(0,M),r=u.length-1-u.lastIndexOf(l)),i=v,o=0;continue}else if(u.length!==0){u="",r=0,i=v,o=0;continue}}a&&(u+=u.length>0?`${l}..`:"..",r=2)}else u.length>0?u+=`${l}${c.slice(i+1,v)}`:u=c.slice(i+1,v),r=v-i-1;i=v,o=0}else h===I&&o!==-1?++o:o=-1}return u}function P(c,a){if(a===null||typeof a!="object")throw new m("pathObject","Object",a);const l=a.dir||a.root,s=a.base||`${a.name||""}${a.ext||""}`;return l?l===a.root?`${l}${s}`:`${l}${c}${s}`:s}e.win32={resolve(...c){let a="",l="",s=!1;for(let u=c.length-1;u>=-1;u--){let r;if(u>=0){if(r=c[u],S(r,"path"),r.length===0)continue}else a.length===0?r=w.cwd():(r=w.env[`=${a}`]||w.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${a}\\`));const i=r.length;let o=0,h="",v=!1;const M=r.charCodeAt(0);if(i===1)t(M)&&(o=1,v=!0);else if(t(M))if(v=!0,t(r.charCodeAt(1))){let A=2,L=A;for(;A<i&&!t(r.charCodeAt(A));)A++;if(A<i&&A!==L){const F=r.slice(L,A);for(L=A;A<i&&t(r.charCodeAt(A));)A++;if(A<i&&A!==L){for(L=A;A<i&&!t(r.charCodeAt(A));)A++;(A===i||A!==L)&&(h=`\\\\${F}\\${r.slice(L,A)}`,o=A)}}}else o=1;else b(M)&&r.charCodeAt(1)===y&&(h=r.slice(0,2),o=2,i>2&&t(r.charCodeAt(2))&&(v=!0,o=3));if(h.length>0)if(a.length>0){if(h.toLowerCase()!==a.toLowerCase())continue}else a=h;if(s){if(a.length>0)break}else if(l=`${r.slice(o)}\\${l}`,s=v,v&&a.length>0)break}return l=p(l,!s,"\\",t),s?`${a}\\${l}`:`${a}${l}`||"."},normalize(c){S(c,"path");const a=c.length;if(a===0)return".";let l=0,s,u=!1;const r=c.charCodeAt(0);if(a===1)return f(r)?"\\":c;if(t(r))if(u=!0,t(c.charCodeAt(1))){let o=2,h=o;for(;o<a&&!t(c.charCodeAt(o));)o++;if(o<a&&o!==h){const v=c.slice(h,o);for(h=o;o<a&&t(c.charCodeAt(o));)o++;if(o<a&&o!==h){for(h=o;o<a&&!t(c.charCodeAt(o));)o++;if(o===a)return`\\\\${v}\\${c.slice(h)}\\`;o!==h&&(s=`\\\\${v}\\${c.slice(h,o)}`,l=o)}}}else l=1;else b(r)&&c.charCodeAt(1)===y&&(s=c.slice(0,2),l=2,a>2&&t(c.charCodeAt(2))&&(u=!0,l=3));let i=l<a?p(c.slice(l),!u,"\\",t):"";return i.length===0&&!u&&(i="."),i.length>0&&t(c.charCodeAt(a-1))&&(i+="\\"),s===void 0?u?`\\${i}`:i:u?`${s}\\${i}`:`${s}${i}`},isAbsolute(c){S(c,"path");const a=c.length;if(a===0)return!1;const l=c.charCodeAt(0);return t(l)||a>2&&b(l)&&c.charCodeAt(1)===y&&t(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let a,l;for(let r=0;r<c.length;++r){const i=c[r];S(i,"path"),i.length>0&&(a===void 0?a=l=i:a+=`\\${i}`)}if(a===void 0)return".";let s=!0,u=0;if(typeof l=="string"&&t(l.charCodeAt(0))){++u;const r=l.length;r>1&&t(l.charCodeAt(1))&&(++u,r>2&&(t(l.charCodeAt(2))?++u:s=!1))}if(s){for(;u<a.length&&t(a.charCodeAt(u));)u++;u>=2&&(a=`\\${a.slice(u)}`)}return e.win32.normalize(a)},relative(c,a){if(S(c,"from"),S(a,"to"),c===a)return"";const l=e.win32.resolve(c),s=e.win32.resolve(a);if(l===s||(c=l.toLowerCase(),a=s.toLowerCase(),c===a))return"";let u=0;for(;u<c.length&&c.charCodeAt(u)===g;)u++;let r=c.length;for(;r-1>u&&c.charCodeAt(r-1)===g;)r--;const i=r-u;let o=0;for(;o<a.length&&a.charCodeAt(o)===g;)o++;let h=a.length;for(;h-1>o&&a.charCodeAt(h-1)===g;)h--;const v=h-o,M=i<v?i:v;let A=-1,L=0;for(;L<M;L++){const U=c.charCodeAt(u+L);if(U!==a.charCodeAt(o+L))break;U===g&&(A=L)}if(L!==M){if(A===-1)return s}else{if(v>M){if(a.charCodeAt(o+L)===g)return s.slice(o+L+1);if(L===2)return s.slice(o+L)}i>M&&(c.charCodeAt(u+L)===g?A=L:L===2&&(A=3)),A===-1&&(A=0)}let F="";for(L=u+A+1;L<=r;++L)(L===r||c.charCodeAt(L)===g)&&(F+=F.length===0?"..":"\\..");return o+=A,F.length>0?`${F}${s.slice(o,h)}`:(s.charCodeAt(o)===g&&++o,s.slice(o,h))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const a=e.win32.resolve(c);if(a.length<=2)return c;if(a.charCodeAt(0)===g){if(a.charCodeAt(1)===g){const l=a.charCodeAt(2);if(l!==E&&l!==I)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(b(a.charCodeAt(0))&&a.charCodeAt(1)===y&&a.charCodeAt(2)===g)return`\\\\?\\${a}`;return c},dirname(c){S(c,"path");const a=c.length;if(a===0)return".";let l=-1,s=0;const u=c.charCodeAt(0);if(a===1)return t(u)?c:".";if(t(u)){if(l=s=1,t(c.charCodeAt(1))){let o=2,h=o;for(;o<a&&!t(c.charCodeAt(o));)o++;if(o<a&&o!==h){for(h=o;o<a&&t(c.charCodeAt(o));)o++;if(o<a&&o!==h){for(h=o;o<a&&!t(c.charCodeAt(o));)o++;if(o===a)return c;o!==h&&(l=s=o+1)}}}}else b(u)&&c.charCodeAt(1)===y&&(l=a>2&&t(c.charCodeAt(2))?3:2,s=l);let r=-1,i=!0;for(let o=a-1;o>=s;--o)if(t(c.charCodeAt(o))){if(!i){r=o;break}}else i=!1;if(r===-1){if(l===-1)return".";r=l}return c.slice(0,r)},basename(c,a){a!==void 0&&S(a,"ext"),S(c,"path");let l=0,s=-1,u=!0,r;if(c.length>=2&&b(c.charCodeAt(0))&&c.charCodeAt(1)===y&&(l=2),a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let i=a.length-1,o=-1;for(r=c.length-1;r>=l;--r){const h=c.charCodeAt(r);if(t(h)){if(!u){l=r+1;break}}else o===-1&&(u=!1,o=r+1),i>=0&&(h===a.charCodeAt(i)?--i==-1&&(s=r):(i=-1,s=o))}return l===s?s=o:s===-1&&(s=c.length),c.slice(l,s)}for(r=c.length-1;r>=l;--r)if(t(c.charCodeAt(r))){if(!u){l=r+1;break}}else s===-1&&(u=!1,s=r+1);return s===-1?"":c.slice(l,s)},extname(c){S(c,"path");let a=0,l=-1,s=0,u=-1,r=!0,i=0;c.length>=2&&c.charCodeAt(1)===y&&b(c.charCodeAt(0))&&(a=s=2);for(let o=c.length-1;o>=a;--o){const h=c.charCodeAt(o);if(t(h)){if(!r){s=o+1;break}continue}u===-1&&(r=!1,u=o+1),h===I?l===-1?l=o:i!==1&&(i=1):l!==-1&&(i=-1)}return l===-1||u===-1||i===0||i===1&&l===u-1&&l===s+1?"":c.slice(l,u)},format:P.bind(null,"\\"),parse(c){S(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const l=c.length;let s=0,u=c.charCodeAt(0);if(l===1)return t(u)?(a.root=a.dir=c,a):(a.base=a.name=c,a);if(t(u)){if(s=1,t(c.charCodeAt(1))){let A=2,L=A;for(;A<l&&!t(c.charCodeAt(A));)A++;if(A<l&&A!==L){for(L=A;A<l&&t(c.charCodeAt(A));)A++;if(A<l&&A!==L){for(L=A;A<l&&!t(c.charCodeAt(A));)A++;A===l?s=A:A!==L&&(s=A+1)}}}}else if(b(u)&&c.charCodeAt(1)===y){if(l<=2)return a.root=a.dir=c,a;if(s=2,t(c.charCodeAt(2))){if(l===3)return a.root=a.dir=c,a;s=3}}s>0&&(a.root=c.slice(0,s));let r=-1,i=s,o=-1,h=!0,v=c.length-1,M=0;for(;v>=s;--v){if(u=c.charCodeAt(v),t(u)){if(!h){i=v+1;break}continue}o===-1&&(h=!1,o=v+1),u===I?r===-1?r=v:M!==1&&(M=1):r!==-1&&(M=-1)}return o!==-1&&(r===-1||M===0||M===1&&r===o-1&&r===i+1?a.base=a.name=c.slice(i,o):(a.name=c.slice(i,r),a.base=c.slice(i,o),a.ext=c.slice(r,o))),i>0&&i!==s?a.dir=c.slice(0,i-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let a="",l=!1;for(let s=c.length-1;s>=-1&&!l;s--){const u=s>=0?c[s]:w.cwd();S(u,"path"),u.length!==0&&(a=`${u}/${a}`,l=u.charCodeAt(0)===d)}return a=p(a,!l,"/",f),l?`/${a}`:a.length>0?a:"."},normalize(c){if(S(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===d,l=c.charCodeAt(c.length-1)===d;return c=p(c,!a,"/",f),c.length===0?a?"/":l?"./":".":(l&&(c+="/"),a?`/${c}`:c)},isAbsolute(c){return S(c,"path"),c.length>0&&c.charCodeAt(0)===d},join(...c){if(c.length===0)return".";let a;for(let l=0;l<c.length;++l){const s=c[l];S(s,"path"),s.length>0&&(a===void 0?a=s:a+=`/${s}`)}return a===void 0?".":e.posix.normalize(a)},relative(c,a){if(S(c,"from"),S(a,"to"),c===a||(c=e.posix.resolve(c),a=e.posix.resolve(a),c===a))return"";const l=1,s=c.length,u=s-l,r=1,i=a.length-r,o=u<i?u:i;let h=-1,v=0;for(;v<o;v++){const A=c.charCodeAt(l+v);if(A!==a.charCodeAt(r+v))break;A===d&&(h=v)}if(v===o)if(i>o){if(a.charCodeAt(r+v)===d)return a.slice(r+v+1);if(v===0)return a.slice(r+v)}else u>o&&(c.charCodeAt(l+v)===d?h=v:v===0&&(h=0));let M="";for(v=l+h+1;v<=s;++v)(v===s||c.charCodeAt(v)===d)&&(M+=M.length===0?"..":"/..");return`${M}${a.slice(r+h)}`},toNamespacedPath(c){return c},dirname(c){if(S(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===d;let l=-1,s=!0;for(let u=c.length-1;u>=1;--u)if(c.charCodeAt(u)===d){if(!s){l=u;break}}else s=!1;return l===-1?a?"/":".":a&&l===1?"//":c.slice(0,l)},basename(c,a){a!==void 0&&S(a,"ext"),S(c,"path");let l=0,s=-1,u=!0,r;if(a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let i=a.length-1,o=-1;for(r=c.length-1;r>=0;--r){const h=c.charCodeAt(r);if(h===d){if(!u){l=r+1;break}}else o===-1&&(u=!1,o=r+1),i>=0&&(h===a.charCodeAt(i)?--i==-1&&(s=r):(i=-1,s=o))}return l===s?s=o:s===-1&&(s=c.length),c.slice(l,s)}for(r=c.length-1;r>=0;--r)if(c.charCodeAt(r)===d){if(!u){l=r+1;break}}else s===-1&&(u=!1,s=r+1);return s===-1?"":c.slice(l,s)},extname(c){S(c,"path");let a=-1,l=0,s=-1,u=!0,r=0;for(let i=c.length-1;i>=0;--i){const o=c.charCodeAt(i);if(o===d){if(!u){l=i+1;break}continue}s===-1&&(u=!1,s=i+1),o===I?a===-1?a=i:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||s===-1||r===0||r===1&&a===s-1&&a===l+1?"":c.slice(a,s)},format:P.bind(null,"/"),parse(c){S(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const l=c.charCodeAt(0)===d;let s;l?(a.root="/",s=1):s=0;let u=-1,r=0,i=-1,o=!0,h=c.length-1,v=0;for(;h>=s;--h){const M=c.charCodeAt(h);if(M===d){if(!o){r=h+1;break}continue}i===-1&&(o=!1,i=h+1),M===I?u===-1?u=h:v!==1&&(v=1):u!==-1&&(v=-1)}if(i!==-1){const M=r===0&&l?1:r;u===-1||v===0||v===1&&u===i-1&&u===r+1?a.base=a.name=c.slice(M,i):(a.name=c.slice(M,u),a.base=c.slice(M,i),a.ext=c.slice(u,i))}return r>0?a.dir=c.slice(0,r-1):l&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[80],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var w;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(w=e.Source||(e.Source={}));var R;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(k,...n){const I=n.reduce((y,E)=>(y[E]=!0,y),{}),d=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(y=>!I[y]).forEach(y=>{for(let E=0;E<d.length;E++)if(y.search(d[E])!==-1){delete k[y];break}})}e.sanitizeProcessEnvironment=D}),define(Z[107],x([0,1,3]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=w.globals.performance&&typeof w.globals.performance.now=="function";class D{constructor(n){this._highResolution=R&&n,this._startTime=this._now(),this._stopTime=-1}static create(n=!0){return new D(n)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Z[4],x([0,1,15,42,2,106,107]),function(q,e,w,R,D,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(a){a.None=()=>D.Disposable.None;function l(O){return(B,V=null,X)=>{let $=!1,H;return H=O(ee=>{if(!$)return H?H.dispose():$=!0,B.call(V,ee)},null,X),$&&H.dispose(),H}}a.once=l;function s(O,B){return v((V,X=null,$)=>O(H=>V.call(X,B(H)),null,$))}a.map=s;function u(O,B){return v((V,X=null,$)=>O(H=>{B(H),V.call(X,H)},null,$))}a.forEach=u;function r(O,B){return v((V,X=null,$)=>O(H=>B(H)&&V.call(X,H),null,$))}a.filter=r;function i(O){return O}a.signal=i;function o(...O){return(B,V=null,X)=>(0,D.combinedDisposable)(...O.map($=>$(H=>B.call(V,H),null,X)))}a.any=o;function h(O,B,V){let X=V;return s(O,$=>(X=B(X,$),X))}a.reduce=h;function v(O){let B;const V=new m({onFirstListenerAdd(){B=O(V.fire,V)},onLastListenerRemove(){B.dispose()}});return V.event}function M(O,B,V=100,X=!1,$){let H,ee,W,C=0;const T=new m({leakWarningThreshold:$,onFirstListenerAdd(){H=O(_=>{C++,ee=B(ee,_),X&&!W&&(T.fire(ee),ee=void 0),clearTimeout(W),W=setTimeout(()=>{const z=ee;ee=void 0,W=void 0,(!X||C>1)&&T.fire(z),C=0},V)})},onLastListenerRemove(){H.dispose()}});return T.event}a.debounce=M;function A(O,B=(V,X)=>V===X){let V=!0,X;return r(O,$=>{const H=V||!B($,X);return V=!1,X=$,H})}a.latch=A;function L(O,B){return[a.filter(O,B),a.filter(O,V=>!B(V))]}a.split=L;function F(O,B=!1,V=[]){let X=V.slice(),$=O(W=>{X?X.push(W):ee.fire(W)});const H=()=>{X&&X.forEach(W=>ee.fire(W)),X=null},ee=new m({onFirstListenerAdd(){$||($=O(W=>ee.fire(W)))},onFirstListenerDidAdd(){X&&(B?setTimeout(H):H())},onLastListenerRemove(){$&&$.dispose(),$=null}});return ee.event}a.buffer=F;class U{constructor(B){this.event=B}map(B){return new U(s(this.event,B))}forEach(B){return new U(u(this.event,B))}filter(B){return new U(r(this.event,B))}reduce(B,V){return new U(h(this.event,B,V))}latch(){return new U(A(this.event))}debounce(B,V=100,X=!1,$){return new U(M(this.event,B,V,X,$))}on(B,V,X){return this.event(B,V,X)}once(B,V,X){return l(this.event)(B,V,X)}}function Q(O){return new U(O)}a.chain=Q;function ie(O,B,V=X=>X){const X=(...W)=>ee.fire(V(...W)),$=()=>O.on(B,X),H=()=>O.removeListener(B,X),ee=new m({onFirstListenerAdd:$,onLastListenerRemove:H});return ee.event}a.fromNodeEventEmitter=ie;function re(O,B,V=X=>X){const X=(...W)=>ee.fire(V(...W)),$=()=>O.addEventListener(B,X),H=()=>O.removeEventListener(B,X),ee=new m({onFirstListenerAdd:$,onLastListenerRemove:H});return ee.event}a.fromDOMEventEmitter=re;function G(O){return new Promise(B=>l(O)(B))}a.toPromise=G})(I=e.Event||(e.Event={}));class d{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${d._idPool++}`}start(l){this._stopWatch=new n.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}d._idPool=0;let g=-1;function y(a){const l=g;return g=a,{dispose(){g=l}}}e.setGlobalLeakWarningThreshold=y;class E{constructor(l,s=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let s=g;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||l<s)return;this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(u)||0;if(this._stacks.set(u,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let i,o=0;for(const[h,v]of this._stacks)(!i||o<v)&&(i=h,o=v);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${o}):`),console.warn(i)}return()=>{const i=this._stacks.get(u)||0;this._stacks.set(u,i-1)}}}class m{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=g>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new d(this._options._profName):void 0}get event(){return this._event||(this._event=(l,s,u)=>{this._listeners||(this._listeners=new k.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(s?[l,s]:l);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,s);const o=this._leakageMon?.check(this._listeners.size),h=(0,D.toDisposable)(()=>{o&&o(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return u instanceof D.DisposableStore?u.add(h):Array.isArray(u)&&u.push(h),h}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,u]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,u):s[0].call(s[1],u)}catch(r){(0,w.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=m;class S extends m{async fireAsync(l,s,u){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,l]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),o=[],h={...i,waitUntil:v=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");u&&(v=u(v,typeof r=="function"?r:r[0])),o.push(v)}};try{typeof r=="function"?r.call(void 0,h):r[0].call(r[1],h)}catch(v){(0,w.onUnexpectedError)(v);continue}Object.freeze(o),await Promise.allSettled(o).then(v=>{for(const M of v)M.status==="rejected"&&(0,w.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=S;class t extends m{constructor(l){super(l);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=t;class f extends t{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=f;class b extends m{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]})}}e.MicrotaskEmitter=b;class p{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const s={event:l,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const u=()=>{this.hasListeners&&this.unhook(s);const r=this.events.indexOf(s);this.events.splice(r,1)};return(0,D.toDisposable)((0,R.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(s=>this.emitter.fire(s))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=p;class P{constructor(){this.buffers=[]}wrapEvent(l){return(s,u,r)=>l(i=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>s.call(u,i)):s.call(u,i)},void 0,r)}bufferEvents(l){const s=[];this.buffers.push(s);const u=l();return this.buffers.pop(),s.forEach(r=>r()),u}}e.EventBufferer=P;class c{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=D.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(Z[23],x([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(I,d){const g=setTimeout(I.bind(d),0);return{dispose(){clearTimeout(g)}}});var D;(function(I){function d(g){return g===I.None||g===I.Cancelled||g instanceof k?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}I.isCancellationToken=d,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(D=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class n{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=D.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=n}),define(Z[108],x([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new w.Emitter}add(y){const E=this._icons.get(y.id);E?y.description?E.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new R;e.iconRegistry=D;function k(g){return g?g.replace(/\$\((.*?)\)/g,(y,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=k;class n{constructor(y,E,m){this.id=y,this.definition=E,this.description=m,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n,n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function I(g,y){const E=["codicon","codicon-"+g];return y&&E.push("codicon-modifier-"+y),E}e.getClassNamesArray=I;var d;(function(g){g.iconNameSegment="[A-Za-z0-9]+",g.iconNameExpression="[A-Za-z0-9-]+",g.iconModifierExpression="~[A-Za-z]+",g.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${g.iconNameExpression})(${g.iconModifierExpression})?$`);function E(t){if(t instanceof n)return["codicon","codicon-"+t.id];const f=y.exec(t.id);if(!f)return E(n.error);let[,b,p]=f;const P=["codicon","codicon-"+b];return p&&P.push("codicon-modifier-"+p.substr(1)),P}g.asClassNameArray=E;function m(t){return E(t).join(" ")}g.asClassName=m;function S(t){return"."+E(t).join(".")}g.asCSSSelector=S})(d=e.CSSIcon||(e.CSSIcon={}))}),define(Z[59],x([0,1,15,2]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(c){const a=c;return a?[a.on,a.pause,a.resume,a.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=D;function k(c){const a=c;return a?D(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=k;function n(c,a){return new I(c,a)}e.newWriteableStream=n;class I{constructor(a,l){this.reducer=a,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(l=>l(a))}emitError(a){this.listeners.error.length===0?(0,w.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(l=>l(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,l){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(a,l){if(this.state.destroyed)return;let s;switch(a){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const u=s.indexOf(l);u>=0&&s.splice(u,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(c,a){const l=[];let s;for(;(s=c.read())!==null;)l.push(s);return a(l)}e.consumeReadable=d;function g(c,a,l){const s=[];let u;for(;(u=c.read())!==null&&s.length<l;)s.push(u);return u===null&&s.length>0?a(s):{read:()=>{if(s.length>0)return s.shift();if(typeof u!="undefined"){const r=u;return u=void 0,r}return c.read()}}}e.peekReadable=g;function y(c,a){return new Promise((l,s)=>{const u=[];E(c,{onData:r=>{a&&u.push(r)},onError:r=>{a?s(r):l(void 0)},onEnd:()=>{l(a?a(u):void 0)}})})}e.consumeStream=y;function E(c,a){c.on("error",l=>a.onError(l)),c.on("end",()=>a.onEnd()),c.on("data",l=>a.onData(l))}e.listenStream=E;function m(c,a){return new Promise((l,s)=>{const u=new R.DisposableStore,r=[],i=v=>{if(r.push(v),r.length>a)return u.dispose(),c.pause(),l({stream:c,buffer:r,ended:!1})},o=v=>s(v),h=()=>l({stream:c,buffer:r,ended:!0});u.add((0,R.toDisposable)(()=>c.removeListener("error",o))),c.on("error",o),u.add((0,R.toDisposable)(()=>c.removeListener("end",h))),c.on("end",h),u.add((0,R.toDisposable)(()=>c.removeListener("data",i))),c.on("data",i)})}e.peekStream=m;function S(c,a){const l=n(a);return l.end(c),l}e.toStream=S;function t(){const c=n(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=t;function f(c){let a=!1;return{read:()=>a?null:(a=!0,c)}}e.toReadable=f;function b(c,a,l){const s=n(l);return E(c,{onData:u=>s.write(a.data(u)),onError:u=>s.error(a.error?a.error(u):u),onEnd:()=>s.end()}),s}e.transform=b;function p(c,a,l){let s=!1;return{read:()=>{const u=a.read();return s?u:(s=!0,u!==null?l([c,u]):c)}}}e.prefixedReadable=p;function P(c,a,l){let s=!1;const u=n(l);return E(a,{onData:r=>s?u.write(r):(s=!0,u.write(l([c,r]))),onError:r=>u.error(r),onEnd:()=>{s||(s=!0,u.write(c)),u.end()}}),u}e.prefixedStream=P}),define(Z[17],x([0,1,59]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined";let D,k;class n{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return R?new n(Buffer.allocUnsafe(i)):new n(new Uint8Array(i))}static wrap(i){return R&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new n(i)}static fromString(i,o){return!(o?.dontUseNodeBuffer||!1)&&R?new n(Buffer.from(i)):(D||(D=new TextEncoder),new n(D.encode(i)))}static fromByteArray(i){const o=n.alloc(i.length);for(let h=0,v=i.length;h<v;h++)o.buffer[h]=i[h];return o}static concat(i,o){if(typeof o=="undefined"){o=0;for(let M=0,A=i.length;M<A;M++)o+=i[M].byteLength}const h=n.alloc(o);let v=0;for(let M=0,A=i.length;M<A;M++){const L=i[M];h.set(L,v),v+=L.byteLength}return h}clone(){const i=n.alloc(this.byteLength);return i.set(this),i}toString(){return R?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(i,o){return new n(this.buffer.subarray(i,o))}set(i,o){if(i instanceof n)this.buffer.set(i.buffer,o);else if(i instanceof Uint8Array)this.buffer.set(i,o);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),o);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),o);else throw new Error("Unkown argument 'array'")}readUInt32BE(i){return g(this.buffer,i)}writeUInt32BE(i,o){y(this.buffer,i,o)}readUInt32LE(i){return E(this.buffer,i)}writeUInt32LE(i,o){m(this.buffer,i,o)}readUInt8(i){return S(this.buffer,i)}writeUInt8(i,o){t(this.buffer,i,o)}}e.VSBuffer=n;function I(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=I;function d(r,i,o){r[o+0]=i&255,i=i>>>8,r[o+1]=i&255}e.writeUInt16LE=d;function g(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=g;function y(r,i,o){r[o+3]=i,i=i>>>8,r[o+2]=i,i=i>>>8,r[o+1]=i,i=i>>>8,r[o]=i}e.writeUInt32BE=y;function E(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=E;function m(r,i,o){r[o+0]=i&255,i=i>>>8,r[o+1]=i&255,i=i>>>8,r[o+2]=i&255,i=i>>>8,r[o+3]=i&255}e.writeUInt32LE=m;function S(r,i){return r[i]}e.readUInt8=S;function t(r,i,o){r[o]=i}e.writeUInt8=t;function f(r){return w.consumeReadable(r,i=>n.concat(i))}e.readableToBuffer=f;function b(r){return w.toReadable(r)}e.bufferToReadable=b;function p(r){return w.consumeStream(r,i=>n.concat(i))}e.streamToBuffer=p;async function P(r){return r.ended?n.concat(r.buffer):n.concat([...r.buffer,await p(r.stream)])}e.bufferedStreamToBuffer=P;function c(r){return w.toStream(r,i=>n.concat(i))}e.bufferToStream=c;function a(r){return w.transform(r,{data:i=>typeof i=="string"?n.fromString(i):n.wrap(i)},i=>n.concat(i))}e.streamToBufferReadableStream=a;function l(r){return w.newWriteableStream(i=>n.concat(i),r)}e.newWriteableBufferStream=l;function s(r,i){return w.prefixedReadable(r,i,o=>n.concat(o))}e.prefixedBufferReadable=s;function u(r,i){return w.prefixedStream(r,i,o=>n.concat(o))}e.prefixedBufferStream=u}),define(Z[25],x([0,1,3]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function k(K,...ae){return ae.length===0?K:K.replace(D,function(ue,ve){const Ie=parseInt(ve,10);return isNaN(Ie)||Ie<0||Ie>=ae.length?ue:ae[Ie]})}e.format=k;const n=/{([^}]+)}/g;function I(K,ae){return K.replace(n,(ue,ve)=>ae[ve]??ue)}e.format2=I;function d(K){return K.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=d;function g(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=g;function y(K,ae){let ue=0;const ve=ae.charCodeAt(0);for(let Ie=K.length-1;Ie>=0;Ie--)K.charCodeAt(Ie)===ve&&ue++;return ue}e.count=y;function E(K,ae,ue="\u2026"){return K.length<=ae?K:`${K.substr(0,ae)}${ue}`}e.truncate=E;function m(K,ae=" "){const ue=S(K,ae);return t(ue,ae)}e.trim=m;function S(K,ae){if(!K||!ae)return K;const ue=ae.length;if(ue===0||K.length===0)return K;let ve=0;for(;K.indexOf(ae,ve)===ve;)ve=ve+ue;return K.substring(ve)}e.ltrim=S;function t(K,ae){if(!K||!ae)return K;const ue=ae.length,ve=K.length;if(ue===0||ve===0)return K;let Ie=ve,Ce=-1;for(;Ce=K.lastIndexOf(ae,Ie-1),!(Ce===-1||Ce+ue!==Ie);){if(Ce===0)return"";Ie=Ce}return K.substring(0,Ie)}e.rtrim=t;function f(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function b(K){return K.replace(/\*/g,"")}e.stripWildcards=b;function p(K,ae,ue={}){if(!K)throw new Error("Cannot create regex from empty string");ae||(K=g(K)),ue.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let ve="";return ue.global&&(ve+="g"),ue.matchCase||(ve+="i"),ue.multiline&&(ve+="m"),ue.unicode&&(ve+="u"),new RegExp(K,ve)}e.createRegExp=p;function P(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=P;function c(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function a(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=a;function l(K){return K.split(/\r\n|\r|\n/)}e.splitLines=l;function s(K){for(let ae=0,ue=K.length;ae<ue;ae++){const ve=K.charCodeAt(ae);if(ve!==32&&ve!==9)return ae}return-1}e.firstNonWhitespaceIndex=s;function u(K,ae=0,ue=K.length){for(let ve=ae;ve<ue;ve++){const Ie=K.charCodeAt(ve);if(Ie!==32&&Ie!==9)return K.substring(ae,ve)}return K.substring(ae,ue)}e.getLeadingWhitespace=u;function r(K,ae=K.length-1){for(let ue=ae;ue>=0;ue--){const ve=K.charCodeAt(ue);if(ve!==32&&ve!==9)return ue}return-1}e.lastNonWhitespaceIndex=r;function i(K,ae){return K<ae?-1:K>ae?1:0}e.compare=i;function o(K,ae,ue=0,ve=K.length,Ie=0,Ce=ae.length){for(;ue<ve&&Ie<Ce;ue++,Ie++){let Oe=K.charCodeAt(ue),Ne=ae.charCodeAt(Ie);if(Oe<Ne)return-1;if(Oe>Ne)return 1}const Te=ve-ue,We=Ce-Ie;return Te<We?-1:Te>We?1:0}e.compareSubstring=o;function h(K,ae){return v(K,ae,0,K.length,0,ae.length)}e.compareIgnoreCase=h;function v(K,ae,ue=0,ve=K.length,Ie=0,Ce=ae.length){for(;ue<ve&&Ie<Ce;ue++,Ie++){let Oe=K.charCodeAt(ue),Ne=ae.charCodeAt(Ie);if(Oe===Ne)continue;if(Oe>=128||Ne>=128)return o(K.toLowerCase(),ae.toLowerCase(),ue,ve,Ie,Ce);M(Oe)&&(Oe-=32),M(Ne)&&(Ne-=32);const je=Oe-Ne;if(je!==0)return je}const Te=ve-ue,We=Ce-Ie;return Te<We?-1:Te>We?1:0}e.compareSubstringIgnoreCase=v;function M(K){return K>=97&&K<=122}e.isLowerAsciiLetter=M;function A(K){return K>=65&&K<=90}e.isUpperAsciiLetter=A;function L(K,ae){return K.length===ae.length&&v(K,ae)===0}e.equalsIgnoreCase=L;function F(K,ae){const ue=ae.length;return ae.length>K.length?!1:v(K,ae,0,ue)===0}e.startsWithIgnoreCase=F;function U(K,ae){let ue,ve=Math.min(K.length,ae.length);for(ue=0;ue<ve;ue++)if(K.charCodeAt(ue)!==ae.charCodeAt(ue))return ue;return ve}e.commonPrefixLength=U;function Q(K,ae){let ue,ve=Math.min(K.length,ae.length);const Ie=K.length-1,Ce=ae.length-1;for(ue=0;ue<ve;ue++)if(K.charCodeAt(Ie-ue)!==ae.charCodeAt(Ce-ue))return ue;return ve}e.commonSuffixLength=Q;function ie(K){return 55296<=K&&K<=56319}e.isHighSurrogate=ie;function re(K){return 56320<=K&&K<=57343}e.isLowSurrogate=re;function G(K,ae){return(K-55296<<10)+(ae-56320)+65536}e.computeCodePoint=G;function O(K,ae,ue){const ve=K.charCodeAt(ue);if(ie(ve)&&ue+1<ae){const Ie=K.charCodeAt(ue+1);if(re(Ie))return G(ve,Ie)}return ve}e.getNextCodePoint=O;function B(K,ae){const ue=K.charCodeAt(ae-1);if(re(ue)&&ae>1){const ve=K.charCodeAt(ae-2);if(ie(ve))return G(ve,ue)}return ue}function V(K,ae){const ue=ze.getInstance(),ve=ae,Ie=K.length,Ce=O(K,Ie,ae);ae+=Ce>=65536?2:1;let Te=ue.getGraphemeBreakType(Ce);for(;ae<Ie;){const We=O(K,Ie,ae),Oe=ue.getGraphemeBreakType(We);if(Fe(Te,Oe))break;ae+=We>=65536?2:1,Te=Oe}return ae-ve}e.nextCharLength=V;function X(K,ae){const ue=ze.getInstance(),ve=ae,Ie=B(K,ae);ae-=Ie>=65536?2:1;let Ce=ue.getGraphemeBreakType(Ie);for(;ae>0;){const Te=B(K,ae),We=ue.getGraphemeBreakType(Te);if(Fe(We,Ce))break;ae-=Te>=65536?2:1,Ce=We}return ve-ae}e.prevCharLength=X;function $(K,ae){const ue=ze.getInstance(),ve=K.length,Ie=ae,Ce=O(K,ve,ae),Te=ue.getGraphemeBreakType(Ce);ae+=Ce>=65536?2:1;let We=Te;for(;ae<ve;){const Ne=O(K,ve,ae),je=ue.getGraphemeBreakType(Ne);if(Fe(We,je))break;ae+=Ne>=65536?2:1,We=je}const Oe=ae;for(ae=Ie,We=Te;ae>0;){const Ne=B(K,ae),je=ue.getGraphemeBreakType(Ne);if(Fe(je,We))break;ae-=Ne>=65536?2:1,We=je}return[ae,Oe]}function H(K,ae){return ae>0&&re(K.charCodeAt(ae))?$(K,ae-1):$(K,ae)}e.getCharContainingOffset=H;const ee=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(K){return ee.test(K)}e.containsRTL=W;const C=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function T(K){return C.test(K)}e.containsEmoji=T;const _=/^[\t\n\r\x20-\x7E]*$/;function z(K){return _.test(K)}e.isBasicASCII=z,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Y(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Y;function N(K){for(let ae=0,ue=K.length;ae<ue;ae++)if(j(K.charCodeAt(ae)))return!0;return!1}e.containsFullWidthCharacter=N;function j(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=j;function ne(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=ne;function se(K,ae){if(K.length<ae)return K;const ue=/\b/g;let ve=0;for(;ue.test(K)&&!(K.length-ue.lastIndex<ae);)ve=ue.lastIndex,ue.lastIndex+=1;return K.substring(ve).replace(/^\s/,"")}e.lcut=se;const oe=/\x1B\x5B[12]?K/g,J=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function le(K){return K&&(K=K.replace(oe,""),K=K.replace(J,""),K=K.replace(ce,"")),K}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function he(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=he;function ge(K){return he(K)?K.substr(1):K}e.stripUTF8BOM=ge;function be(K,ae){if(!K||!ae||K.length<ae.length)return!1;const ue=ae.length,ve=K.toLowerCase();let Ie=0,Ce=-1;for(;Ie<ue;){const Te=ve.indexOf(ae[Ie],Ce+1);if(Te<0)return!1;Ce=Te,Ie++}return!0}e.fuzzyContains=be;function fe(K,ae=!1){return K?(ae&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=fe;function me(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=me;function pe(K,ae=1){if(ae===0)return"";let ue=-1;do ue=K.indexOf(`
`,ue+1),ae--;while(ae>0&&ue>=0);return ue===-1?K:(K[ue-1]==="\r"&&ue--,K.substr(0,ue))}e.getNLines=pe;function Pe(K){const ae=90-65+1;return K=K%(2*ae),K<ae?String.fromCharCode(97+K):String.fromCharCode(65+K-ae)}e.singleLetterHash=Pe;function Re(K){return ze.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=Re;function Fe(K,ae){return K===0?ae!==5&&ae!==7:K===2&&ae===3?!1:K===4||K===2||K===3||ae===4||ae===2||ae===3?!0:!(K===8&&(ae===8||ae===9||ae===11||ae===12)||(K===11||K===9)&&(ae===9||ae===10)||(K===12||K===10)&&ae===10||ae===5||ae===13||ae===7||K===1||K===13&&ae===14||K===6&&ae===6)}e.breakBetweenGraphemeBreakType=Fe;var $e;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})($e=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=Qe()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const ue=this._data,ve=ue.length/3;let Ie=1;for(;Ie<=ve;)if(ae<ue[3*Ie])Ie=2*Ie;else if(ae>ue[3*Ie+1])Ie=2*Ie+1;else return ue[3*Ie+2];return 0}}ze._INSTANCE=null;function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(K,ae){if(K===0)return 0;const ue=gt(K,ae);if(ue!==void 0)return ue;const ve=B(ae,K);return K-=Je(ve),K}e.getLeftDeleteOffset=Ge;function gt(K,ae){let ue=B(ae,K);for(K-=Je(ue);at(ue)||ue===65039||ue===8419;){if(K===0)return;ue=B(ae,K),K-=Je(ue)}if(!!ne(ue)){if(K>=0){const ve=B(ae,K);ve===8205&&(K-=Je(ve))}return K}}function Je(K){return K>=65536?2:1}function at(K){return 127995<=K&&K<=127999}var ct;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(ct||(ct={})),e.noBreakWhitespace="\xA0";class Ve{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!Ve.map){let ve=function(Te){const We=new Map;for(let Oe=0;Oe<Te.length;Oe+=2)We.set(Te[Oe],Te[Oe+1]);return We};const ae=Ve.getData();let ue=w.locale;(!ue||!(ue in ae))&&(ue=w.language),(!ue||!(ue in ae))&&(ue="_default");const Ie=ve(ae._common),Ce=ve(ae[ue]);for(const[Te,We]of Ce)Ie.set(Te,We);Ve.map=Ie}return Ve.map}static isAmbiguous(ae){return Ve.getConfusablesForCurrentLocale().has(ae)}static getPrimaryConfusable(ae){return Ve.getConfusablesForCurrentLocale().get(ae)}static getPrimaryConfusableCodePoints(){return new Set(Ve.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=Ve;class He{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(He.getRawData())),this._data}static isInvisibleCharacter(ae){return He.getData().has(ae)}static get codePoints(){return He.getData()}}e.InvisibleCharacters=He,He._data=void 0}),define(Z[81],x([0,1,25]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(p){return D(p,0)}e.hash=R;function D(p,P){switch(typeof p){case"object":return p===null?k(349,P):Array.isArray(p)?d(p,P):g(p,P);case"string":return I(p,P);case"boolean":return n(p,P);case"number":return k(p,P);case"undefined":return k(937,P);default:return k(617,P)}}e.doHash=D;function k(p,P){return(P<<5)-P+p|0}e.numberHash=k;function n(p,P){return k(p?433:863,P)}function I(p,P){P=k(149417,P);for(let c=0,a=p.length;c<a;c++)P=k(p.charCodeAt(c),P);return P}e.stringHash=I;function d(p,P){return P=k(104579,P),p.reduce((c,a)=>D(a,c),P)}function g(p,P){return P=k(181387,P),Object.keys(p).sort().reduce((c,a)=>(c=I(a,c),D(p[a],c)),P)}class y{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=D(P,this._value),this._value}}e.Hasher=y;var E;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function m(p,P,c=32){const a=c-P,l=~((1<<a)-1);return(p<<P|(l&p)>>>a)>>>0}function S(p,P=0,c=p.byteLength,a=0){for(let l=0;l<c;l++)p[P+l]=a}function t(p,P,c="0"){for(;p.length<P;)p=c+p;return p}function f(p,P=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(c=>c.toString(16).padStart(2,"0")).join(""):t((p>>>0).toString(16),P/4)}e.toHexString=f;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const c=P.length;if(c===0)return;const a=this._buff;let l=this._buffLen,s=this._leftoverHighSurrogate,u,r;for(s!==0?(u=s,r=-1,s=0):(u=P.charCodeAt(0),r=0);;){let i=u;if(w.isHighSurrogate(u))if(r+1<c){const o=P.charCodeAt(r+1);w.isLowSurrogate(o)?(r++,i=w.computeCodePoint(u,o)):i=65533}else{s=u;break}else w.isLowSurrogate(u)&&(i=65533);if(l=this._push(a,l,i),r++,r<c)u=P.charCodeAt(r);else break}this._buffLen=l,this._leftoverHighSurrogate=s}_push(P,c,a){return a<128?P[c++]=a:a<2048?(P[c++]=192|(a&1984)>>>6,P[c++]=128|(a&63)>>>0):a<65536?(P[c++]=224|(a&61440)>>>12,P[c++]=128|(a&4032)>>>6,P[c++]=128|(a&63)>>>0):(P[c++]=240|(a&1835008)>>>18,P[c++]=128|(a&258048)>>>12,P[c++]=128|(a&4032)>>>6,P[c++]=128|(a&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=b._bigBlock32,c=this._buffDV;for(let v=0;v<64;v+=4)P.setUint32(v,c.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)P.setUint32(v,m(P.getUint32(v-12,!1)^P.getUint32(v-32,!1)^P.getUint32(v-56,!1)^P.getUint32(v-64,!1),1),!1);let a=this._h0,l=this._h1,s=this._h2,u=this._h3,r=this._h4,i,o,h;for(let v=0;v<80;v++)v<20?(i=l&s|~l&u,o=1518500249):v<40?(i=l^s^u,o=1859775393):v<60?(i=l&s|l&u|s&u,o=2400959708):(i=l^s^u,o=3395469782),h=m(a,5)+i+r+o+P.getUint32(v*4,!1)&4294967295,r=u,u=s,s=m(l,30),l=a,a=h;this._h0=this._h0+a&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))});var kt=this&&this.__classPrivateFieldSet||function(q,e,w,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?q!==e||!D:!e.has(q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(q,w):D?D.value=w:e.set(q,w),w},Ke=this&&this.__classPrivateFieldGet||function(q,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?q!==e||!R:!e.has(q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(q):R?R.value:e.get(q)};define(Z[39],x([0,1,30,25]),function(q,e,w,R){"use strict";var D,k,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(r,i,o){let h=r.get(i);return h===void 0&&(h=o,r.set(i,h)),h}e.getOrSet=I;function d(r){const i=[];return r.forEach((o,h)=>{i.push(`${h} => ${o}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=d;function g(r){const i=[];return r.forEach(o=>{i.push(o)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=g;class y{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const o=i.charCodeAt(0),h=this._value.charCodeAt(this._pos);return o-h}value(){return this._value[this._pos]}}e.StringIterator=y;class E{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,R.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class m{constructor(i=!0,o=!0){this._splitOnBackslash=i,this._caseSensitive=o}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let o=i.length-1;o>=0;o--,this._valueLen--){const h=this._value.charCodeAt(o);if(!(h===47||this._splitOnBackslash&&h===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,R.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var S;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(S||(S={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,R.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(b||(b={}));class p{constructor(i){this._iter=i}static forUris(i=()=>!1){return new p(new t(i))}static forPaths(){return new p(new m)}static forStrings(){return new p(new y)}static forConfigKeys(){return new p(new E)}clear(){this._root=void 0}fill(i,o){if(o){const h=o.slice(0);(0,w.shuffle)(h);for(let v of h)this.set(v,i)}else{const h=i.slice(0);(0,w.shuffle)(h);for(let v of h)this.set(v[0],v[1])}}set(i,o){const h=this._iter.reset(i);let v;this._root||(this._root=new f,this._root.segment=h.value());const M=[];for(v=this._root;;){const L=h.cmp(v.segment);if(L>0)v.left||(v.left=new f,v.left.segment=h.value()),M.push([-1,v]),v=v.left;else if(L<0)v.right||(v.right=new f,v.right.segment=h.value()),M.push([1,v]),v=v.right;else if(h.hasNext())h.next(),v.mid||(v.mid=new f,v.mid.segment=h.value()),M.push([0,v]),v=v.mid;else break}const A=v.value;v.value=o,v.key=i;for(let L=M.length-1;L>=0;L--){const F=M[L][1];F.updateHeight();const U=F.balanceFactor();if(U<-1||U>1){const Q=M[L][0],ie=M[L+1][0];if(Q===1&&ie===1)M[L][1]=F.rotateLeft();else if(Q===-1&&ie===-1)M[L][1]=F.rotateRight();else if(Q===1&&ie===-1)F.right=M[L+1][1]=M[L+1][1].rotateRight(),M[L][1]=F.rotateLeft();else if(Q===-1&&ie===1)F.left=M[L+1][1]=M[L+1][1].rotateLeft(),M[L][1]=F.rotateRight();else throw new Error;if(L>0)switch(M[L-1][0]){case-1:M[L-1][1].left=M[L][1];break;case 1:M[L-1][1].right=M[L][1];break;case 0:M[L-1][1].mid=M[L][1];break}else this._root=M[0][1]}}return A}get(i){return this._getNode(i)?.value}_getNode(i){const o=this._iter.reset(i);let h=this._root;for(;h;){const v=o.cmp(h.segment);if(v>0)h=h.left;else if(v<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else break}return h}has(i){const o=this._getNode(i);return!(o?.value===void 0&&o?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,o){const h=this._iter.reset(i),v=[];let M=this._root;for(;M;){const A=h.cmp(M.segment);if(A>0)v.push([-1,M]),M=M.left;else if(A<0)v.push([1,M]),M=M.right;else if(h.hasNext())h.next(),v.push([0,M]),M=M.mid;else break}if(!!M){if(o?(M.left=void 0,M.mid=void 0,M.right=void 0,M.height=1):(M.key=void 0,M.value=void 0),!M.mid&&!M.value)if(M.left&&M.right){const A=this._min(M.right),{key:L,value:F,segment:U}=A;this._delete(A.key,!1),M.key=L,M.value=F,M.segment=U}else{const A=M.left??M.right;if(v.length>0){const[L,F]=v[v.length-1];switch(L){case-1:F.left=A;break;case 0:F.mid=A;break;case 1:F.right=A;break}}else this._root=A}for(let A=v.length-1;A>=0;A--){const L=v[A][1];L.updateHeight();const F=L.balanceFactor();if(F>1?(L.right.balanceFactor()>=0||(L.right=L.right.rotateRight()),v[A][1]=L.rotateLeft()):F<-1&&(L.left.balanceFactor()<=0||(L.left=L.left.rotateLeft()),v[A][1]=L.rotateRight()),A>0)switch(v[A-1][0]){case-1:v[A-1][1].left=v[A][1];break;case 1:v[A-1][1].right=v[A][1];break;case 0:v[A-1][1].mid=v[A][1];break}else this._root=v[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const o=this._iter.reset(i);let h=this._root,v;for(;h;){const M=o.cmp(h.segment);if(M>0)h=h.left;else if(M<0)h=h.right;else if(o.hasNext())o.next(),v=h.value||v,h=h.mid;else break}return h&&h.value||v}findSuperstr(i){const o=this._iter.reset(i);let h=this._root;for(;h;){const v=o.cmp(h.segment);if(v>0)h=h.left;else if(v<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(i){for(const[o,h]of this)i(h,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=o=>{if(!o)return!0;const h=o.balanceFactor();return h<-1||h>1?!1:i(o.left)&&i(o.right)};return i(this._root)}}e.TernarySearchTree=p;class P{constructor(i,o){this.uri=i,this.value=o}}class c{constructor(i,o){this[D]="ResourceMap",i instanceof c?(this.map=new Map(i.map),this.toKey=o??c.defaultToKey):(this.map=new Map,this.toKey=i??c.defaultToKey)}set(i,o){return this.map.set(this.toKey(i),new P(i,o)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,o){typeof o!="undefined"&&(i=i.bind(o));for(let[h,v]of this.map)i(v.value,v.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=c,c.defaultToKey=r=>r.toString();var a;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class l{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,o=0){const h=this._map.get(i);if(!!h)return o!==0&&this.touch(h,o),h.value}set(i,o,h=0){let v=this._map.get(i);if(v)v.value=o,h!==0&&this.touch(v,h);else{switch(v={key:i,value:o,next:void 0,previous:void 0},h){case 0:this.addItemLast(v);break;case 1:this.addItemFirst(v);break;case 2:this.addItemLast(v);break;default:this.addItemLast(v);break}this._map.set(i,v),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const o=this._map.get(i);if(!!o)return this._map.delete(i),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,o){const h=this._state;let v=this._head;for(;v;){if(o?i.bind(o)(v.value,v.key,this):i(v.value,v.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const i=this,o=this._state;let h=this._head;const v={[Symbol.iterator](){return v},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const M={value:h.key,done:!1};return h=h.next,M}else return{value:void 0,done:!0}}};return v}values(){const i=this,o=this._state;let h=this._head;const v={[Symbol.iterator](){return v},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const M={value:h.value,done:!1};return h=h.next,M}else return{value:void 0,done:!0}}};return v}entries(){const i=this,o=this._state;let h=this._head;const v={[Symbol.iterator](){return v},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const M={value:[h.key,h.value],done:!1};return h=h.next,M}else return{value:void 0,done:!0}}};return v}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let o=this._head,h=this.size;for(;o&&h>i;)this._map.delete(o.key),o=o.next,h--;this._head=o,this._size=h,o&&(o.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const o=i.next,h=i.previous;if(!o||!h)throw new Error("Invalid list");o.previous=h,h.next=o}i.next=void 0,i.previous=void 0,this._state++}touch(i,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(i===this._head)return;const h=i.next,v=i.previous;i===this._tail?(v.next=void 0,this._tail=v):(h.previous=v,v.next=h),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(o===2){if(i===this._tail)return;const h=i.next,v=i.previous;i===this._head?(h.previous=void 0,this._head=h):(h.previous=v,v.next=h),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((o,h)=>{i.push([h,o])}),i}fromJSON(i){this.clear();for(const[o,h]of i)this.set(o,h)}}e.LinkedMap=l;class s extends l{constructor(i,o=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,o=2){return super.get(i,o)}peek(i){return super.get(i,0)}set(i,o){return super.set(i,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class u{constructor(i){n.set(this,void 0),kt(this,n,i,"f")}get size(){return Ke(this,n,"f").size}forEach(i,o){Ke(this,n,"f").forEach(i,o)}get(i){return Ke(this,n,"f").get(i)}has(i){return Ke(this,n,"f").has(i)}entries(){return Ke(this,n,"f").entries()}keys(){return Ke(this,n,"f").keys()}values(){return Ke(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return Ke(this,n,"f").entries()}}e.ReadonlyMapView=u}),define(Z[70],x([0,1,39]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new w.LRUCache(1e4);function D(g){return d(g,"NFC",R)}e.normalizeNFC=D;const k=new w.LRUCache(1e4);function n(g){return d(g,"NFD",k)}e.normalizeNFD=n;const I=/[^\u0000-\u0080]/;function d(g,y,E){if(!g)return g;const m=E.get(g);if(m)return m;let S;return I.test(g)?S=g.normalize(y):S=g,E.set(g,S),S}e.removeAccents=function(){const g=/[\u0300-\u036f]/g;return function(y){return n(y).replace(g,"")}}()}),define(Z[13],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(M){return Array.isArray(M)}e.isArray=w;function R(M){return typeof M=="string"}e.isString=R;function D(M){return Array.isArray(M)&&M.every(A=>R(A))}e.isStringArray=D;function k(M){return typeof M=="object"&&M!==null&&!Array.isArray(M)&&!(M instanceof RegExp)&&!(M instanceof Date)}e.isObject=k;function n(M){return typeof M=="number"&&!isNaN(M)}e.isNumber=n;function I(M){return!!M&&typeof M[Symbol.iterator]=="function"}e.isIterable=I;function d(M){return M===!0||M===!1}e.isBoolean=d;function g(M){return typeof M=="undefined"}e.isUndefined=g;function y(M){return!E(M)}e.isDefined=y;function E(M){return g(M)||M===null}e.isUndefinedOrNull=E;function m(M,A){if(!M)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}e.assertType=m;function S(M){if(E(M))throw new Error("Assertion Failed: argument is undefined or null");return M}e.assertIsDefined=S;function t(...M){const A=[];for(let L=0;L<M.length;L++){const F=M[L];if(E(F))throw new Error(`Assertion Failed: argument at index ${L} is undefined or null`);A.push(F)}return A}e.assertAllDefined=t;const f=Object.prototype.hasOwnProperty;function b(M){if(!k(M))return!1;for(let A in M)if(f.call(M,A))return!1;return!0}e.isEmptyObject=b;function p(M){return typeof M=="function"}e.isFunction=p;function P(...M){return M.length>0&&M.every(p)}e.areFunctions=P;function c(M,A){const L=Math.min(M.length,A.length);for(let F=0;F<L;F++)a(M[F],A[F])}e.validateConstraints=c;function a(M,A){if(R(A)){if(typeof M!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(p(A)){try{if(M instanceof A)return}catch{}if(!E(M)&&M.constructor===A||A.length===1&&A.call(void 0,M)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function l(M){let A=[],L=Object.getPrototypeOf(M);for(;Object.prototype!==L;)A=A.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return A}e.getAllPropertyNames=l;function s(M){const A=[];for(const L of l(M))typeof M[L]=="function"&&A.push(L);return A}e.getAllMethodNames=s;function u(M,A){const L=U=>function(){const Q=Array.prototype.slice.call(arguments,0);return A(U,Q)};let F={};for(const U of M)F[U]=L(U);return F}e.createProxyObject=u;function r(M){return M===null?void 0:M}e.withNullAsUndefined=r;function i(M){return typeof M=="undefined"?null:M}e.withUndefinedAsNull=i;function o(M){return class{constructor(){return new Proxy({},{get(A,L){if(A[L])return A[L];throw new Error(`Not Implemented: ${M}->${String(L)}`)}})}}}e.NotImplementedProxy=o;function h(M,A="Unreachable"){throw new Error(A)}e.assertNever=h;function v(M){return!!M&&typeof M.then=="function"&&typeof M.catch=="function"}e.isPromise=v}),define(Z[32],x([0,1,9,3,25,13]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function n(r){return r===47||r===92}e.isPathSeparator=n;function I(r){return r.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=I;function d(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=d;function g(r,i=w.posix.sep){if(!r)return"";const o=r.length,h=r.charCodeAt(0);if(n(h)){if(n(r.charCodeAt(1))&&!n(r.charCodeAt(2))){let M=3;const A=M;for(;M<o&&!n(r.charCodeAt(M));M++);if(A!==M&&!n(r.charCodeAt(M+1))){for(M+=1;M<o;M++)if(n(r.charCodeAt(M)))return r.slice(0,M+1).replace(/[\\/]/g,i)}}return i}else if(p(h)&&r.charCodeAt(1)===58)return n(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let v=r.indexOf("://");if(v!==-1){for(v+=3;v<o;v++)if(n(r.charCodeAt(v)))return r.slice(0,v+1)}return""}e.getRoot=g;function y(r){if(!R.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let o=2;const h=o;for(;o<r.length&&(i=r.charCodeAt(o),i!==92);o++);return!(h===o||(i=r.charCodeAt(o+1),isNaN(i)||i===92))}e.isUNC=y;const E=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(r,i=R.isWindows){const o=i?E:m;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||i&&S.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=t;function f(r,i,o){const h=r===i;return!o||h?h:!r||!i?!1:(0,D.equalsIgnoreCase)(r,i)}e.isEqual=f;function b(r,i,o,h=w.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(o){if(!(0,D.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let M=i.length;return i.charAt(i.length-1)===h&&M--,r.charAt(M)===h}return i.charAt(i.length-1)!==h&&(i+=h),r.indexOf(i)===0}e.isEqualOrParent=b;function p(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=p;function P(r,i){return R.isWindows&&r.endsWith(":")&&(r+=w.sep),(0,w.isAbsolute)(r)||(r=(0,w.join)(i,r)),r=(0,w.normalize)(r),R.isWindows?(r=(0,D.rtrim)(r,w.sep),r.endsWith(":")&&(r+=w.sep)):(r=(0,D.rtrim)(r,w.sep),r||(r=w.sep)),r}e.sanitizeFilePath=P;function c(r){const i=(0,w.normalize)(r);return R.isWindows?r.length>3?!1:a(i)&&(r.length===2||i.charCodeAt(2)===92):i===w.posix.sep}e.isRootOrDriveLetter=c;function a(r,i){return(i!==void 0?i:R.isWindows)?p(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function l(r){return a(r)?r[0]:void 0}e.getDriveLetter=l;function s(r,i,o){return i.length>r.length?-1:r===i?0:(o&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=s;function u(r){const i=r.split(":");let o,h,v;if(i.forEach(M=>{const A=Number(M);(0,k.isNumber)(A)?h===void 0?h=A:v===void 0&&(v=A):o=o?[o,M].join(":"):M}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:h!==void 0?h:void 0,column:v!==void 0?v:h!==void 0?1:void 0}}e.parseLineAndColumnAware=u}),define(Z[47],x([0,1,13]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const b=Array.isArray(f)?[]:{};return Object.keys(f).forEach(p=>{f[p]&&typeof f[p]=="object"?b[p]=R(f[p]):b[p]=f[p]}),b}e.deepClone=R;function D(f){if(!f||typeof f!="object")return f;const b=[f];for(;b.length>0;){const p=b.shift();Object.freeze(p);for(const P in p)if(k.call(p,P)){const c=p[P];typeof c=="object"&&!Object.isFrozen(c)&&b.push(c)}}return f}e.deepFreeze=D;const k=Object.prototype.hasOwnProperty;function n(f,b){return I(f,b,new Set)}e.cloneAndChange=n;function I(f,b,p){if((0,w.isUndefinedOrNull)(f))return f;const P=b(f);if(typeof P!="undefined")return P;if((0,w.isArray)(f)){const c=[];for(const a of f)c.push(I(a,b,p));return c}if((0,w.isObject)(f)){if(p.has(f))throw new Error("Cannot clone recursive data-structure");p.add(f);const c={};for(let a in f)k.call(f,a)&&(c[a]=I(f[a],b,p));return p.delete(f),c}return f}function d(f,b,p=!0){return(0,w.isObject)(f)?((0,w.isObject)(b)&&Object.keys(b).forEach(P=>{P in f?p&&((0,w.isObject)(f[P])&&(0,w.isObject)(b[P])?d(f[P],b[P],p):f[P]=b[P]):f[P]=b[P]}),f):b}e.mixin=d;function g(f,b){if(f===b)return!0;if(f==null||b===null||b===void 0||typeof f!=typeof b||typeof f!="object"||Array.isArray(f)!==Array.isArray(b))return!1;let p,P;if(Array.isArray(f)){if(f.length!==b.length)return!1;for(p=0;p<f.length;p++)if(!g(f[p],b[p]))return!1}else{const c=[];for(P in f)c.push(P);c.sort();const a=[];for(P in b)a.push(P);if(a.sort(),!g(c,a))return!1;for(p=0;p<c.length;p++)if(!g(f[c[p]],b[c[p]]))return!1}return!0}e.equals=g;function y(f){const b=new Set;return JSON.stringify(f,(p,P)=>{if((0,w.isObject)(P)||Array.isArray(P)){if(b.has(P))return"[Circular]";b.add(P)}return P})}e.safeStringify=y;function E(f,b,p){const P=b(f);return typeof P=="undefined"?p:P}e.getOrDefault=E;function m(f,b){const p=Object.create(null);return!f||!b||Object.keys(b).forEach(c=>{const a=f[c],l=b[c];g(a,l)||(p[c]=l)}),p}e.distinct=m;function S(f,b){const p=b.toLowerCase(),P=Object.keys(f).find(c=>c.toLowerCase()===p);return P?f[P]:f[b]}e.getCaseInsensitive=S;function t(f,b){const p=Object.create(null);for(const[P,c]of Object.entries(f))b(P,c)&&(p[P]=c);return p}e.filter=t}),define(Z[7],x([0,1,9,3]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,k=/^\//,n=/^\/\//;function I(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!D.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!k.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(n.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(r,i){return!r&&!i?"file":r}function g(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==E&&(i=E+i):i=E;break}return i}const y="",E="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(i,o,h,v,M,A=!1){typeof i=="object"?(this.scheme=i.scheme||y,this.authority=i.authority||y,this.path=i.path||y,this.query=i.query||y,this.fragment=i.fragment||y):(this.scheme=d(i,A),this.authority=o||y,this.path=g(this.scheme,h||y),this.query=v||y,this.fragment=M||y,I(this,A))}static isUri(i){return i instanceof S?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return c(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:h,path:v,query:M,fragment:A}=i;return o===void 0?o=this.scheme:o===null&&(o=y),h===void 0?h=this.authority:h===null&&(h=y),v===void 0?v=this.path:v===null&&(v=y),M===void 0?M=this.query:M===null&&(M=y),A===void 0?A=this.fragment:A===null&&(A=y),o===this.scheme&&h===this.authority&&v===this.path&&M===this.query&&A===this.fragment?this:new f(o,h,v,M,A)}static parse(i,o=!1){const h=m.exec(i);return h?new f(h[2]||y,u(h[4]||y),u(h[5]||y),u(h[7]||y),u(h[9]||y),o):new f(y,y,y,y,y)}static file(i){let o=y;if(R.isWindows&&(i=i.replace(/\\/g,E)),i[0]===E&&i[1]===E){const h=i.indexOf(E,2);h===-1?(o=i.substring(2),i=E):(o=i.substring(2,h),i=i.substring(h)||E)}return new f("file",o,i,y,y)}static from(i){const o=new f(i.scheme,i.authority,i.path,i.query,i.fragment);return I(o,!0),o}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return R.isWindows&&i.scheme==="file"?h=S.file(w.win32.join(c(i,!0),...o)).path:h=w.posix.join(i.path,...o),i.with({path:h})}toString(i=!1){return a(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof S)return i;{const o=new f(i);return o._formatted=i.external,o._fsPath=i._sep===t?i.fsPath:null,o}}else return i}}e.URI=S;const t=R.isWindows?1:void 0;class f extends S{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(i=!1){return i?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(r,i){let o,h=-1;for(let v=0;v<r.length;v++){const M=r.charCodeAt(v);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||i&&M===47)h!==-1&&(o+=encodeURIComponent(r.substring(h,v)),h=-1),o!==void 0&&(o+=r.charAt(v));else{o===void 0&&(o=r.substr(0,v));const A=b[M];A!==void 0?(h!==-1&&(o+=encodeURIComponent(r.substring(h,v)),h=-1),o+=A):h===-1&&(h=v)}}return h!==-1&&(o+=encodeURIComponent(r.substring(h))),o!==void 0?o:r}function P(r){let i;for(let o=0;o<r.length;o++){const h=r.charCodeAt(o);h===35||h===63?(i===void 0&&(i=r.substr(0,o)),i+=b[h]):i!==void 0&&(i+=r[o])}return i!==void 0?i:r}function c(r,i){let o;return r.authority&&r.path.length>1&&r.scheme==="file"?o=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?o=r.path.substr(1):o=r.path[1].toLowerCase()+r.path.substr(2):o=r.path,R.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=c;function a(r,i){const o=i?P:p;let h="",{scheme:v,authority:M,path:A,query:L,fragment:F}=r;if(v&&(h+=v,h+=":"),(M||v==="file")&&(h+=E,h+=E),M){let U=M.indexOf("@");if(U!==-1){const Q=M.substr(0,U);M=M.substr(U+1),U=Q.indexOf(":"),U===-1?h+=o(Q,!1):(h+=o(Q.substr(0,U),!1),h+=":",h+=o(Q.substr(U+1),!1)),h+="@"}M=M.toLowerCase(),U=M.indexOf(":"),U===-1?h+=o(M,!1):(h+=o(M.substr(0,U),!1),h+=M.substr(U))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const U=A.charCodeAt(1);U>=65&&U<=90&&(A=`/${String.fromCharCode(U+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const U=A.charCodeAt(0);U>=65&&U<=90&&(A=`${String.fromCharCode(U+32)}:${A.substr(2)}`)}h+=o(A,!0)}return L&&(h+="?",h+=o(L,!1)),F&&(h+="#",h+=i?F:p(F,!1)),h}function l(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+l(r.substr(3)):r}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(r){return r.match(s)?r.replace(s,i=>l(i)):r}}),define(Z[109],x([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(g){const y=g;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=R;function D(g){const y=[];let E;try{const m=JSON.parse(g.arguments),S=m[m.length-1];S&&S.__$stack&&(m.pop(),E=S.__$stack),y.push(...m)}catch(m){y.push("Unable to log remote console arguments",g.arguments)}return{args:y,stack:E}}e.parse=D;function k(g){if(typeof g!="string")return k(D(g).stack);const y=g;if(y){const E=n(y),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(m&&m.length===4)return{uri:w.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=k;function n(g){if(!g)return g;const y=g.indexOf(`
`);return y===-1?g:g.substring(0,y)}function I(g,y){const{args:E,stack:m}=D(g),S=typeof E[0]=="string"&&E.length===1;let t=n(m);t&&(t=`(${t.trim()})`);let f=[];if(typeof E[0]=="string"?t&&S?f=[`%c[${y}] %c${E[0]} %c${t}`,d("blue"),d(""),d("grey")]:f=[`%c[${y}] %c${E[0]}`,d("blue"),d(""),...E.slice(1)]:f=[`%c[${y}]%`,d("blue"),...E],t&&!S&&f.push(t),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,f)}e.log=I;function d(g){return`color: ${g}`}}),define(Z[110],x([0,1,17,25,7]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(y){return JSON.stringify(y,d)}e.stringify=k;function n(y){let E=JSON.parse(y);return E=g(E),E}e.parse=n;var I;(function(y){y[y.Uri=1]="Uri",y[y.Regexp=2]="Regexp",y[y.ScmResource=3]="ScmResource",y[y.ScmResourceGroup=4]="ScmResourceGroup",y[y.ScmProvider=5]="ScmProvider",y[y.CommentController=6]="CommentController",y[y.CommentThread=7]="CommentThread",y[y.CommentThreadReply=8]="CommentThreadReply",y[y.CommentNode=9]="CommentNode",y[y.CommentThreadNode=10]="CommentThreadNode",y[y.TimelineActionContext=11]="TimelineActionContext",y[y.NotebookCellActionContext=12]="NotebookCellActionContext",y[y.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function d(y,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,R.regExpFlags)(E)}:E}function g(y,E=0){if(!y||E>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return D.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof w.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let m=0;m<y.length;++m)y[m]=g(y[m],E+1);else for(const m in y)Object.hasOwnProperty.call(y,m)&&(y[m]=g(y[m],E+1))}return y}e.revive=g}),define(Z[10],x([0,1,3,7]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}set(d,g,y){this._hosts[d]=g,this._ports[d]=y}setConnectionToken(d,g){this._connectionTokens[d]=g}rewrite(d){if(this._delegate)return this._delegate(d);const g=d.authority;let y=this._hosts[g];y&&y.indexOf(":")!==-1&&(y=`[${y}]`);const E=this._ports[g],m=this._connectionTokens[g];let S=`path=${encodeURIComponent(d.path)}`;return typeof m=="string"&&(S+=`&tkn=${encodeURIComponent(m)}`),R.URI.from({scheme:w.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${y}:${E}`,path:"/vscode-remote-resource",query:S})}}e.RemoteAuthorities=new k;class n{asBrowserUri(d,g){const y=this.toUri(d,g);return y.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===D.file&&(w.isNative||typeof w.globals.importScripts=="function"&&w.globals.origin===`${D.vscodeFileResource}://${n.FALLBACK_AUTHORITY}`)?y.with({scheme:D.vscodeFileResource,authority:y.authority||n.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(d,g){const y=this.toUri(d,g);return y.scheme===D.vscodeFileResource?y.with({scheme:D.file,authority:y.authority!==n.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(d,g){return R.URI.isUri(d)?d:R.URI.parse(g.toUrl(d))}}n.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new n}),define(Z[16],x([0,1,32,10,9,3,25,7]),function(q,e,w,R,D,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(S){return(0,I.uriToFsPath)(S,!0)}e.originalFSPath=d;class g{constructor(t){this._ignorePathCasing=t}compare(t,f,b=!1){return t===f?0:(0,n.compare)(this.getComparisonKey(t,b),this.getComparisonKey(f,b))}isEqual(t,f,b=!1){return t===f?!0:!t||!f?!1:this.getComparisonKey(t,b)===this.getComparisonKey(f,b)}getComparisonKey(t,f=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,f,b=!1){if(t.scheme===f.scheme){if(t.scheme===R.Schemas.file)return w.isEqualOrParent(d(t),d(f),this._ignorePathCasing(t))&&t.query===f.query&&(b||t.fragment===f.fragment);if((0,e.isEqualAuthority)(t.authority,f.authority))return w.isEqualOrParent(t.path,f.path,this._ignorePathCasing(t),"/")&&t.query===f.query&&(b||t.fragment===f.fragment)}return!1}joinPath(t,...f){return I.URI.joinPath(t,...f)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return D.posix.basename(t.path)}extname(t){return D.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let f;return t.scheme===R.Schemas.file?f=I.URI.file(D.dirname(d(t))).path:(f=D.posix.dirname(t.path),t.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),f="/")),t.with({path:f})}normalizePath(t){if(!t.path.length)return t;let f;return t.scheme===R.Schemas.file?f=I.URI.file(D.normalize(d(t))).path:f=D.posix.normalize(t.path),t.with({path:f})}relativePath(t,f){if(t.scheme!==f.scheme||!(0,e.isEqualAuthority)(t.authority,f.authority))return;if(t.scheme===R.Schemas.file){const P=D.relative(d(t),d(f));return k.isWindows?w.toSlashes(P):P}let b=t.path||"/",p=f.path||"/";if(this._ignorePathCasing(t)){let P=0;for(const c=Math.min(b.length,p.length);P<c&&!(b.charCodeAt(P)!==p.charCodeAt(P)&&b.charAt(P).toLowerCase()!==p.charAt(P).toLowerCase());P++);b=p.substr(0,P)+b.substr(P)}return D.posix.relative(b,p)}resolvePath(t,f){if(t.scheme===R.Schemas.file){const b=I.URI.file(D.resolve(d(t),f));return t.with({authority:b.authority,path:b.path})}return f=w.toPosixPath(f),t.with({path:D.posix.resolve(t.path,f)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,f){return t===f||t!==void 0&&f!==void 0&&(0,n.equalsIgnoreCase)(t,f)}hasTrailingPathSeparator(t,f=D.sep){if(t.scheme===R.Schemas.file){const b=d(t);return b.length>w.getRoot(b).length&&b[b.length-1]===f}else{const b=t.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,f=D.sep){return(0,e.hasTrailingPathSeparator)(t,f)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,f=D.sep){let b=!1;if(t.scheme===R.Schemas.file){const p=d(t);b=p!==void 0&&p.length===w.getRoot(p).length&&p[p.length-1]===f}else{f="/";const p=t.path;b=p.length===1&&p.charCodeAt(p.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(t,f)?t.with({path:t.path+"/"}):t}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(S=>S.scheme===R.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new g(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(S,t){const f=[];for(let b=0;b<S.length;b++){const p=t(S[b]);S.some((P,c)=>c===b?!1:(0,e.isEqualOrParent)(p,t(P)))||f.push(S[b])}return f}e.distinctParents=y;var E;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function t(f){const b=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(c=>{const[a,l]=c.split(":");a&&l&&b.set(a,l)});const P=f.path.substring(0,f.path.indexOf(";"));return P&&b.set(S.META_DATA_MIME,P),b}S.parseMetaData=t})(E=e.DataUri||(e.DataUri={}));function m(S,t,f){if(t){let b=S.path;return b&&b[0]!==D.posix.sep&&(b=D.posix.sep+b),S.with({scheme:f,authority:t,path:b})}return S.with({scheme:f})}e.toLocalResource=m}),define(Z[8],x([0,1,23,15,4,2,16,3]),function(q,e,w,R,D,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function d(W){return!!W&&typeof W.then=="function"}e.isThenable=d;function g(W){const C=new w.CancellationTokenSource,T=W(C.token),_=new Promise((z,Y)=>{const N=C.token.onCancellationRequested(()=>{N.dispose(),C.dispose(),Y((0,R.canceled)())});Promise.resolve(T).then(j=>{N.dispose(),C.dispose(),z(j)},j=>{N.dispose(),C.dispose(),Y(j)})});return new class{cancel(){C.cancel()}then(z,Y){return _.then(z,Y)}catch(z){return this.then(void 0,z)}finally(z){return _.finally(z)}}}e.createCancelablePromise=g;function y(W,C,T){return Promise.race([W,new Promise(_=>C.onCancellationRequested(()=>_(T)))])}e.raceCancellation=y;async function E(W){let C=-1;const T=W.map((z,Y)=>z.then(N=>(C=Y,N))),_=await Promise.race(T);return W.forEach((z,Y)=>{Y!==C&&z.cancel()}),_}e.raceCancellablePromises=E;function m(W,C,T){let _;const z=setTimeout(()=>{_?.(void 0),T?.()},C);return Promise.race([W.finally(()=>clearTimeout(z)),new Promise(Y=>_=Y)])}e.raceTimeout=m;function S(W){return new Promise((C,T)=>{const _=W();d(_)?_.then(C,T):C(_)})}e.asPromise=S;class t{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(C){if(this.activePromise){if(this.queuedPromiseFactory=C,!this.queuedPromise){const T=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(T,T).then(_)})}return new Promise((T,_)=>{this.queuedPromise.then(T,_)})}return this.activePromise=C(),new Promise((T,_)=>{this.activePromise.then(z=>{this.activePromise=null,T(z)},z=>{this.activePromise=null,_(z)})})}}e.Throttler=t;class f{constructor(){this.current=Promise.resolve(null)}queue(C){return this.current=this.current.then(()=>C(),()=>C())}}e.Sequencer=f;class b{constructor(){this.promiseMap=new Map}queue(C,T){const z=(this.promiseMap.get(C)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(C)===z&&this.promiseMap.delete(C)});return this.promiseMap.set(C,z),z}}e.SequencerByKey=b;class p{constructor(C){this.defaultDelay=C,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(C,T=this.defaultDelay){return this.task=C,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,z)=>{this.doResolve=_,this.doReject=z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},T),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=p;class P{constructor(C){this.delayer=new p(C),this.throttler=new t}trigger(C,T){return this.delayer.trigger(()=>this.throttler.queue(C),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=P;class c{constructor(){this._isOpen=!1,this._promise=new Promise((C,T)=>{this._completePromise=C})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class a extends c{constructor(C){super();this._timeout=setTimeout(()=>this.open(),C)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function l(W,C){return C?new Promise((T,_)=>{const z=setTimeout(()=>{Y.dispose(),T()},W),Y=C.onCancellationRequested(()=>{clearTimeout(z),Y.dispose(),_((0,R.canceled)())})}):g(T=>l(W,T))}e.timeout=l;function s(W,C=0){const T=setTimeout(W,C);return(0,k.toDisposable)(()=>clearTimeout(T))}e.disposableTimeout=s;function u(W){const C=[];let T=0;const _=W.length;function z(){return T<_?W[T++]():null}function Y(N){N!=null&&C.push(N);const j=z();return j?j.then(Y):Promise.resolve(C)}return Promise.resolve(null).then(Y)}e.sequence=u;function r(W,C=_=>!!_,T=null){let _=0;const z=W.length,Y=()=>{if(_>=z)return Promise.resolve(T);const N=W[_++];return Promise.resolve(N()).then(ne=>C(ne)?Promise.resolve(ne):Y())};return Y()}e.first=r;function i(W,C=_=>!!_,T=null){if(W.length===0)return Promise.resolve(T);let _=W.length;const z=()=>{_=-1;for(const Y of W)Y.cancel?.()};return new Promise((Y,N)=>{for(const j of W)j.then(ne=>{--_>=0&&C(ne)?(z(),Y(ne)):_===0&&Y(T)}).catch(ne=>{--_>=0&&(z(),N(ne))})})}e.firstParallel=i;class o{constructor(C){this._size=0,this.maxDegreeOfParalellism=C,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(C){return this._size++,new Promise((T,_)=>{this.outstandingPromises.push({factory:C,c:T,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const C=this.outstandingPromises.shift();this.runningPromises++;const T=C.factory();T.then(C.c,C.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class h extends o{constructor(){super(1)}}e.Queue=h;class v{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const C=new B;return this.drainers.add(C),C.p}isDrained(){for(const[,C]of this.queues)if(C.size>0)return!1;return!0}queueFor(C,T=n.extUri){const _=T.getComparisonKey(C);let z=this.queues.get(_);return z||(z=new h,D.Event.once(z.onFinished)(()=>{z?.dispose(),this.queues.delete(_),this.onDidQueueFinish()}),this.queues.set(_,z)),z}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const C of this.drainers)C.complete();this.drainers.clear()}dispose(){for(const[,C]of this.queues)C.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=v;class M{constructor(C,T){this._token=-1,typeof C=="function"&&typeof T=="number"&&this.setIfNotSet(C,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(C,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,C()},T)}setIfNotSet(C,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,C()},T))}}e.TimeoutTimer=M;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(C,T){this.cancel(),this._token=setInterval(()=>{C()},T)}}e.IntervalTimer=A;class L{constructor(C,T){this.timeoutToken=-1,this.runner=C,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(C=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,C)}get delay(){return this.timeout}set delay(C){this.timeout=C}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class F{constructor(C,T){T%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.runner=C,this.timeout=T,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(C=this.timeout){C%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${C}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(C/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=F;class U extends L{constructor(C,T){super(C,T);this.units=[]}work(C){this.units.push(C),this.isScheduled()||this.schedule()}doRun(){const C=this.units;this.units=[],this.runner&&this.runner(C)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class Q extends k.Disposable{constructor(C,T,_,z){super();this.maxWorkChunkSize=C,this.maxPendingWork=T,this.throttleDelay=_,this.handler=z,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(C){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+C.length>this.maxPendingWork)return!1}else if(this.pending+C.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...C),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new L(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{(0,I.setTimeout0)(()=>{if(C)return;const T=Date.now()+3;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,T-Date.now())}}))});let C=!1;return{dispose(){C||(C=!0)}}}:e.runWhenIdle=(W,C)=>{const T=requestIdleCallback(W,typeof C=="number"?{timeout:C}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(T))}}}}();class ie{constructor(C){this._didRun=!1,this._executor=()=>{try{this._value=C()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ie;async function re(W,C,T){let _;for(let z=0;z<T;z++)try{return await W()}catch(Y){_=Y,await l(C)}throw _}e.retry=re;class G{hasPending(C){return this._pending?typeof C=="number"?this._pending.taskId===C:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(C,T,_){return this._pending={taskId:C,cancel:()=>_?.(),promise:T},T.then(()=>this.donePending(C),()=>this.donePending(C)),T}donePending(C){this._pending&&C===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const C=this._next;this._next=void 0,C.run().then(C.promiseResolve,C.promiseReject)}}setNext(C){if(this._next)this._next.run=C;else{let T,_;const z=new Promise((Y,N)=>{T=Y,_=N});this._next={run:C,promise:z,promiseResolve:T,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=G;class O{constructor(C,T=()=>Date.now()){this.interval=C,this.nowFn=T,this.lastIncrementTime=0,this.value=0}increment(){const C=this.nowFn();return C-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=C,this.value=0),this.value++,this.value}}e.IntervalCounter=O;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((C,T)=>{this.completeCallback=C,this.errorCallback=T})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(C){return new Promise(T=>{this.completeCallback(C),this.resolved=!0,T()})}error(C){return new Promise(T=>{this.errorCallback(C),this.rejected=!0,T()})}cancel(){new Promise(C=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,C()})}}e.DeferredPromise=B;var V;(function(W){async function C(_){let z;const Y=await Promise.all(_.map(N=>N.then(j=>j,j=>{z||(z=j)})));if(typeof z!="undefined")throw z;return Y}W.settled=C;function T(_){return new Promise(async(z,Y)=>{try{await _(z,Y)}catch(N){Y(N)}})}W.withAsyncBody=T})(V=e.Promises||(e.Promises={}));var X;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(X||(X={}));class ${constructor(C){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const T={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(C(T)),this.resolve()}catch(_){this.reject(_)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}static fromArray(C){return new $(T=>{T.emitMany(C)})}static fromPromise(C){return new $(async T=>{T.emitMany(await C)})}static fromPromises(C){return new $(async T=>{await Promise.all(C.map(async _=>T.emitOne(await _)))})}static merge(C){return new $(async T=>{await Promise.all(C.map(async _=>{for await(const z of _)T.emitOne(z)}))})}[Symbol.asyncIterator](){let C=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(C<this._results.length)return{done:!1,value:this._results[C++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(C,T){return new $(async _=>{for await(const z of C)_.emitOne(T(z))})}map(C){return $.map(this,C)}static filter(C,T){return new $(async _=>{for await(const z of C)T(z)&&_.emitOne(z)})}filter(C){return $.filter(this,C)}static coalesce(C){return $.filter(C,T=>!!T)}coalesce(){return $.coalesce(this)}static async toPromise(C){const T=[];for await(const _ of C)T.push(_);return T}toPromise(){return $.toPromise(this)}emitOne(C){this._state===0&&(this._results.push(C),this._onStateChanged.fire())}emitMany(C){this._state===0&&(this._results=this._results.concat(C),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(C){this._state===0&&(this._state=2,this._error=C,this._onStateChanged.fire())}}e.AsyncIterableObject=$,$.EMPTY=$.fromArray([]);class H extends ${constructor(C,T){super(T);this._source=C}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=H;function ee(W){const C=new w.CancellationTokenSource,T=W(C.token);return new H(C,async _=>{const z=C.token.onCancellationRequested(()=>{z.dispose(),C.dispose(),_.reject((0,R.canceled)())});try{for await(const Y of T){if(C.token.isCancellationRequested)return;_.emitOne(Y)}z.dispose(),C.dispose()}catch(Y){z.dispose(),C.dispose(),_.reject(Y)}})}e.createCancelableAsyncIterable=ee}),define(Z[33],x([0,1,32,10,9,3,16,25,7]),function(q,e,w,R,D,k,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function g(i,o,h){if(typeof i=="string"&&(i=d.URI.file(i)),h){const M=h.getWorkspaceFolder(i);if(M){const A=h.getWorkspace().folders.length>1;let L;if((0,n.isEqual)(M.uri,i)?L="":L=(0,n.relativePath)(M.uri,i),A){const F=M.name?M.name:(0,n.basename)(M.uri);L=L?F+" \u2022 "+L:F}return L}}if(i.scheme!==R.Schemas.file&&i.scheme!==R.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,w.hasDriveLetter)(i.fsPath))return(0,D.normalize)(E(i.fsPath));let v=(0,D.normalize)(i.fsPath);return!k.isWindows&&o?.userHome&&(v=S(v,o.userHome.fsPath)),v}e.getPathLabel=g;function y(i){if(!i)return;typeof i=="string"&&(i=d.URI.file(i));const o=(0,n.basename)(i)||(i.scheme===R.Schemas.file?i.fsPath:i.path);return k.isWindows&&(0,w.isRootOrDriveLetter)(o)?E(o):o}e.getBaseLabel=y;function E(i,o){return(0,w.hasDriveLetter)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=E;let m=Object.create(null);function S(i,o){if(k.isWindows||!i||!o)return i;let h=m.original===o?m.normalized:void 0;return h||(h=`${(0,I.rtrim)(o,D.posix.sep)}${D.posix.sep}`,m={original:o,normalized:h}),(k.isLinux?i.startsWith(h):(0,I.startsWithIgnoreCase)(i,h))&&(i=`~/${i.substr(h.length)}`),i}e.tildify=S;function t(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=t;const f="\u2026",b="\\\\",p="~";function P(i,o=D.sep){const h=new Array(i.length);let v=!1;for(let M=0;M<i.length;M++){let A=i[M];if(A===""){h[M]=`.${o}`;continue}if(!A){h[M]=A;continue}v=!0;let L="";A.indexOf(b)===0?(L=A.substr(0,A.indexOf(b)+b.length),A=A.substr(A.indexOf(b)+b.length)):A.indexOf(o)===0?(L=A.substr(0,A.indexOf(o)+o.length),A=A.substr(A.indexOf(o)+o.length)):A.indexOf(p)===0&&(L=A.substr(0,A.indexOf(p)+p.length),A=A.substr(A.indexOf(p)+p.length));const F=A.split(o);for(let U=1;v&&U<=F.length;U++)for(let Q=F.length-U;v&&Q>=0;Q--){v=!1;let ie=F.slice(Q,Q+U).join(o);for(let re=0;!v&&re<i.length;re++)if(re!==M&&i[re]&&i[re].indexOf(ie)>-1){const G=Q+U===F.length,O=Q>0&&i[re].indexOf(o)>-1?o+ie:ie,B=i[re].endsWith(O);v=!G||B}if(!v){let re="";(F[0].endsWith(":")||L!=="")&&(Q===1&&(Q=0,U++,ie=F[0]+o+ie),Q>0&&(re=F[0]+o),re=L+re),Q>0&&(re=re+f+o),re=re+ie,Q+U<F.length&&(re=re+o+f),h[M]=re}}v&&(h[M]=A)}return h}e.shorten=P;var c;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function a(i,o=Object.create(null)){const h=[];let v=!1,M="";for(const A of i)if(A==="$"||v&&A==="{")M&&h.push({value:M,type:c.TEXT}),M="",v=!0;else if(A==="}"&&v){const L=o[M];if(typeof L=="string")L.length&&h.push({value:L,type:c.VARIABLE});else if(L){const F=h[h.length-1];(!F||F.type!==c.SEPARATOR)&&h.push({value:L.label,type:c.SEPARATOR})}M="",v=!1}else M+=A;return M&&!v&&h.push({value:M,type:c.TEXT}),h.filter((A,L)=>{if(A.type===c.SEPARATOR){const F=h[L-1],U=h[L+1];return[F,U].every(Q=>Q&&(Q.type===c.VARIABLE||Q.type===c.TEXT)&&Q.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=a;function l(i,o){return k.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):i.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function s(i,o){return k.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,""):k.isWindows?i.replace(/&&|&/g,h=>h==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=s;function u(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=u;function r(i){const o=i.indexOf("/")!==-1?D.posix:D.win32,h=o.basename(i),v=o.dirname(i);return h.length?{name:h,parentPath:v}:{name:v,parentPath:""}}e.splitName=r}),define(Z[111],x([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(y){return y.toJSON()}class D{constructor(E){this._uriTransformer=E}transformIncoming(E){const m=this._uriTransformer.transformIncoming(E);return m===E?E:R(w.URI.from(m))}transformOutgoing(E){const m=this._uriTransformer.transformOutgoing(E);return m===E?E:R(w.URI.from(m))}transformOutgoingURI(E){const m=this._uriTransformer.transformOutgoing(E);return m===E?E:w.URI.from(m)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function k(y,E,m){if(!y||m>200)return null;if(typeof y=="object"){if(y instanceof w.URI)return E.transformOutgoing(y);for(let S in y)if(Object.hasOwnProperty.call(y,S)){const t=k(y[S],E,m+1);t!==null&&(y[S]=t)}}return null}function n(y,E){const m=k(y,E,0);return m===null?y:m}e.transformOutgoingURIs=n;function I(y,E,m,S){if(!y||S>200)return null;if(typeof y=="object"){if(y.$mid===1)return m?w.URI.revive(E.transformIncoming(y)):E.transformIncoming(y);for(let t in y)if(Object.hasOwnProperty.call(y,t)){const f=I(y[t],E,m,S+1);f!==null&&(y[t]=f)}}return null}function d(y,E){const m=I(y,E,!1,0);return m===null?y:m}e.transformIncomingURIs=d;function g(y,E){const m=I(y,E,!0,0);return m===null?y:m}e.transformAndReviveIncomingURIs=g}),define(Z[31],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(d){return w.test(d)}e.isUUID=R;const D=new Uint8Array(16),k=[];for(let d=0;d<256;d++)k.push(d.toString(16).padStart(2,"0"));let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(d){for(let g=0;g<d.length;g++)d[g]=Math.floor(Math.random()*256);return d};function I(){n(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let d=0,g="";return g+=k[D[d++]],g+=k[D[d++]],g+=k[D[d++]],g+=k[D[d++]],g+="-",g+=k[D[d++]],g+=k[D[d++]],g+="-",g+=k[D[d++]],g+=k[D[d++]],g+="-",g+=k[D[d++]],g+=k[D[d++]],g+="-",g+=k[D[d++]],g+=k[D[d++]],g+=k[D[d++]],g+=k[D[d++]],g+=k[D[d++]],g+=k[D[d++]],g}e.generateUuid=I}),define(Z[112],x([0,1,15,4,2,3,13,25]),function(q,e,w,R,D,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const d="$initialize";let g=!1;function y(r){!k.isWeb||(g||(g=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(r.message))}e.logOnceWebWorkerWarning=y;var E;(function(r){r[r.Request=0]="Request",r[r.Reply=1]="Reply",r[r.SubscribeEvent=2]="SubscribeEvent",r[r.Event=3]="Event",r[r.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class m{constructor(i,o,h,v){this.vsWorker=i,this.req=o,this.method=h,this.args=v,this.type=0}}class S{constructor(i,o,h,v){this.vsWorker=i,this.seq=o,this.res=h,this.err=v,this.type=1}}class t{constructor(i,o,h,v){this.vsWorker=i,this.req=o,this.eventName=h,this.arg=v,this.type=2}}class f{constructor(i,o,h){this.vsWorker=i,this.req=o,this.event=h,this.type=3}}class b{constructor(i,o){this.vsWorker=i,this.req=o,this.type=4}}class p{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,o){const h=String(++this._lastSentReq);return new Promise((v,M)=>{this._pendingReplies[h]={resolve:v,reject:M},this._send(new m(this._workerId,h,i,o))})}listen(i,o){let h=null;const v=new R.Emitter({onFirstListenerAdd:()=>{h=String(++this._lastSentReq),this._pendingEmitters.set(h,v),this._send(new t(this._workerId,h,i,o))},onLastListenerRemove:()=>{this._pendingEmitters.delete(h),this._send(new b(this._workerId,h)),h=null}});return v.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let o=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let h=i.err;i.err.$isError&&(h=new Error,h.name=i.err.name,h.message=i.err.message,h.stack=i.err.stack),o.reject(h);return}o.resolve(i.res)}_handleRequestMessage(i){let o=i.req;this._handler.handleMessage(i.method,i.args).then(v=>{this._send(new S(this._workerId,o,v,void 0))},v=>{v.detail instanceof Error&&(v.detail=(0,w.transformErrorForSerialization)(v.detail)),this._send(new S(this._workerId,o,void 0,(0,w.transformErrorForSerialization)(v)))})}_handleSubscribeEventMessage(i){const o=i.req,h=this._handler.handleEvent(i.eventName,i.arg)(v=>{this._send(new f(this._workerId,o,v))});this._pendingEvents.set(o,h)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let o=[];if(i.type===0)for(let h=0;h<i.args.length;h++)i.args[h]instanceof ArrayBuffer&&o.push(i.args[h]);else i.type===1&&i.res instanceof ArrayBuffer&&o.push(i.res);this._handler.sendMessage(i,o)}}class P extends D.Disposable{constructor(i,o,h){super();let v=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",U=>{this._protocol.handleMessage(U)},U=>{v&&v(U)})),this._protocol=new p({sendMessage:(U,Q)=>{this._worker.postMessage(U,Q)},handleMessage:(U,Q)=>{if(typeof h[U]!="function")return Promise.reject(new Error("Missing method "+U+" on main thread host."));try{return Promise.resolve(h[U].apply(h,Q))}catch(ie){return Promise.reject(ie)}},handleEvent:(U,Q)=>{if(a(U)){const ie=h[U].call(h,Q);if(typeof ie!="function")throw new Error(`Missing dynamic event ${U} on main thread host.`);return ie}if(c(U)){const ie=h[U];if(typeof ie!="function")throw new Error(`Missing event ${U} on main thread host.`);return ie}throw new Error(`Malformed event name ${U}`)}}),this._protocol.setWorkerId(this._worker.getId());let M=null;typeof k.globals.require!="undefined"&&typeof k.globals.require.getConfig=="function"?M=k.globals.require.getConfig():typeof k.globals.requirejs!="undefined"&&(M=k.globals.requirejs.s.contexts._.config);const A=n.getAllMethodNames(h);this._onModuleLoaded=this._protocol.sendMessage(d,[this._worker.getId(),JSON.parse(JSON.stringify(M)),o,A]);const L=(U,Q)=>this._request(U,Q),F=(U,Q)=>this._protocol.listen(U,Q);this._lazyProxy=new Promise((U,Q)=>{v=Q,this._onModuleLoaded.then(ie=>{U(l(ie,L,F))},ie=>{Q(ie),this._onError("Worker failed to load "+o,ie)})})}getProxyObject(){return this._lazyProxy}_request(i,o){return new Promise((h,v)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,o).then(h,v)},v)})}_onError(i,o){console.error(i),console.info(o)}}e.SimpleWorkerClient=P;function c(r){return r[0]==="o"&&r[1]==="n"&&I.isUpperAsciiLetter(r.charCodeAt(2))}function a(r){return/^onDynamic/.test(r)&&I.isUpperAsciiLetter(r.charCodeAt(9))}function l(r,i,o){const h=A=>function(){const L=Array.prototype.slice.call(arguments,0);return i(A,L)},v=A=>function(L){return o(A,L)};let M={};for(const A of r){if(a(A)){M[A]=v(A);continue}if(c(A)){M[A]=o(A,void 0);continue}M[A]=h(A)}return M}class s{constructor(i,o){this._requestHandlerFactory=o,this._requestHandler=null,this._protocol=new p({sendMessage:(h,v)=>{i(h,v)},handleMessage:(h,v)=>this._handleMessage(h,v),handleEvent:(h,v)=>this._handleEvent(h,v)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,o){if(i===d)return this.initialize(o[0],o[1],o[2],o[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,o))}catch(h){return Promise.reject(h)}}_handleEvent(i,o){if(!this._requestHandler)throw new Error("Missing requestHandler");if(a(i)){const h=this._requestHandler[i].call(this._requestHandler,o);if(typeof h!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return h}if(c(i)){const h=this._requestHandler[i];if(typeof h!="function")throw new Error(`Missing event ${i} on request handler.`);return h}throw new Error(`Malformed event name ${i}`)}initialize(i,o,h,v){this._protocol.setWorkerId(i);const L=l(v,(F,U)=>this._protocol.sendMessage(F,U),(F,U)=>this._protocol.listen(F,U));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(L),Promise.resolve(n.getAllMethodNames(this._requestHandler))):(o&&(typeof o.baseUrl!="undefined"&&delete o.baseUrl,typeof o.paths!="undefined"&&typeof o.paths.vs!="undefined"&&delete o.paths.vs,typeof o.trustedTypesPolicy!==void 0&&delete o.trustedTypesPolicy,o.catchError=!0,k.globals.require.config(o)),new Promise((F,U)=>{(k.globals.require||q)([h],ie=>{if(this._requestHandler=ie.create(L),!this._requestHandler){U(new Error("No RequestHandler!"));return}F(n.getAllMethodNames(this._requestHandler))},U)}))}}e.SimpleWorkerServer=s;function u(r){return new s(r,null)}e.create=u}),define(Z[113],x([0,1,60,27,42]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function k(n,I){if(await new Promise((y,E)=>{const m=R.createReadStream(n),S=w.createHash("sha1");m.pipe(S);const t=(0,D.once)((f,b)=>{m.removeAllListeners(),S.removeAllListeners(),f?E(f):y(b)});m.once("error",t),m.once("end",t),S.once("error",t),S.once("data",f=>t(void 0,f.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=k}),define(Z[114],x([0,1,245]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(k="utf8"){this.stringDecoder=new w.StringDecoder(k),this.remaining=null}write(k){const n=[],I=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(I.length<1)return n;let d=0,g,y=d;for(;y<I.length;)if(g=I.charCodeAt(y),g===13||g===10){if(n.push(I.substring(d,y)),y++,y<I.length){const E=g;g=I.charCodeAt(y),(E===13&&g===10||E===10&&g===13)&&y++}d=y}else y++;return this.remaining=d<I.length?I.substr(d):null,n}end(){return this.remaining}}e.LineDecoder=R}),define(Z[115],x([0,1,26]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(n){const I=n.replace(/\-/g,":").toLowerCase();return!R.has(I)}function k(){const n=(0,w.networkInterfaces)();for(let I in n){const d=n[I];if(d){for(const{mac:g}of d)if(D(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=k}),define(Z[71],x([0,1,26,15,39,31,115]),function(q,e,w,R,D,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(y){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(y)}value(){if(this._value===void 0){let y=0,E=0;const m=(0,w.networkInterfaces)();for(let S in m){const t=m[S];if(t)for(const{mac:f,internal:b}of t)b||(E+=1,this._isVirtualMachineMacAddress(f.toUpperCase())&&(y+=1))}this._value=E>0?y/E:0}return this._value}};let I;async function d(){return I||(I=(async()=>await g()||k.generateUuid())()),I}e.getMachineId=d;async function g(){try{const y=await new Promise((m,S)=>{q(["crypto"],m,S)}),E=(0,n.getMac)();return y.createHash("sha256").update(E,"utf8").digest("hex")}catch(y){R.onUnexpectedError(y);return}}}),define(Z[21],x([0,1,27,26,116,8,32,70,9,3,16,7,31]),function(q,e,w,R,D,k,n,I,d,g,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function t(O,B=S.UNLINK){if((0,n.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return B===S.UNLINK?b(O):f(O)}async function f(O){try{const B=(0,d.join)((0,R.tmpdir)(),(0,m.generateUuid)());try{await e.Promises.rename(O,B)}catch(V){return b(O)}b(B).catch(V=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function b(O){return(0,D.promisify)(w.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function p(O){if((0,n.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");w.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function P(O,B){return l(await(B?c(O):(0,D.promisify)(w.readdir)(O)))}async function c(O){try{return await(0,D.promisify)(w.readdir)(O,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const B=[],V=await P(O);for(const X of V){let $=!1,H=!1,ee=!1;try{const W=await e.Promises.lstat((0,d.join)(O,X));$=W.isFile(),H=W.isDirectory(),ee=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}B.push({name:X,isFile:()=>$,isDirectory:()=>H,isSymbolicLink:()=>ee})}return B}function a(O){return l(w.readdirSync(O))}e.readdirSync=a;function l(O){return O.map(B=>typeof B=="string"?g.isMacintosh?(0,I.normalizeNFC)(B):B:(B.name=g.isMacintosh?(0,I.normalizeNFC)(B.name):B.name,B))}async function s(O){const B=await P(O),V=[];for(const X of B)await r.existsDirectory((0,d.join)(O,X))&&V.push(X);return V}function u(O,B=1e3){return new Promise(V=>{let X=!1;const $=setInterval(()=>{X||(X=!0,w.access(O,H=>{X=!1,H&&(clearInterval($),V(void 0))}))},B)})}e.whenDeleted=u;var r;(function(O){async function B($){let H;try{if(H=await e.Promises.lstat($),!H.isSymbolicLink())return{stat:H}}catch(ee){}try{return{stat:await e.Promises.stat($),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(g.isWindows&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw W}throw ee}}O.stat=B;async function V($){try{const{stat:H,symbolicLink:ee}=await O.stat($);return H.isFile()&&ee?.dangling!==!0}catch(H){}return!1}O.existsFile=V;async function X($){try{const{stat:H,symbolicLink:ee}=await O.stat($);return H.isDirectory()&&ee?.dangling!==!0}catch(H){}return!1}O.existsDirectory=X})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new k.ResourceQueue;function o(O,B,V){return i.queueFor(E.URI.file(O),y.extUriBiasedIgnorePathCase).queue(()=>{const X=A(V);return new Promise(($,H)=>v(O,B,X,ee=>ee?H(ee):$()))})}let h=!0;function v(O,B,V,X){if(!h)return w.writeFile(O,B,{mode:V.mode,flag:V.flag},X);w.open(O,V.flag,V.mode,($,H)=>{if($)return X($);w.writeFile(H,B,ee=>{if(ee)return w.close(H,()=>X(ee));w.fdatasync(H,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),h=!1),w.close(H,C=>X(C))))})})}function M(O,B,V){const X=A(V);if(!h)return w.writeFileSync(O,B,{mode:X.mode,flag:X.flag});const $=w.openSync(O,X.flag,X.mode);try{w.writeFileSync($,B);try{w.fdatasyncSync($)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),h=!1}}finally{w.closeSync($)}}e.writeFileSync=M;function A(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function L(O,B){if(O===B)return;async function V(X){try{const $=await e.Promises.lstat(X);if($.isDirectory()||$.isSymbolicLink())return;await e.Promises.utimes(X,$.atime,new Date)}catch($){}}try{await e.Promises.rename(O,B),await V(B)}catch(X){if(O.toLowerCase()!==B.toLowerCase()&&X.code==="EXDEV"||O.endsWith("."))await F(O,B,{preserveSymlinks:!1}),await t(O,S.MOVE),await V(B);else throw X}}async function F(O,B,V){return Q(O,B,{root:{source:O,target:B},options:V,handledSourcePaths:new Set})}const U=511;async function Q(O,B,V){if(V.handledSourcePaths.has(O))return;V.handledSourcePaths.add(O);const{stat:X,symbolicLink:$}=await r.stat(O);if($){if(V.options.preserveSymlinks)try{return await G(O,B,V)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if($.dangling)return}return X.isDirectory()?ie(O,B,X.mode&U,V):re(O,B,X.mode&U)}async function ie(O,B,V,X){await e.Promises.mkdir(B,{recursive:!0,mode:V});const $=await P(O);for(const H of $)await Q((0,d.join)(O,H),(0,d.join)(B,H),X)}async function re(O,B,V){await e.Promises.copyFile(O,B),await e.Promises.chmod(B,V)}async function G(O,B,V){let X=await e.Promises.readlink(O);(0,n.isEqualOrParent)(X,V.root.source,!g.isLinux)&&(X=(0,d.join)(V.root.target,X.substr(V.root.source.length+1))),await e.Promises.symlink(X,B)}e.Promises=new class{get access(){return(0,D.promisify)(w.access)}get stat(){return(0,D.promisify)(w.stat)}get lstat(){return(0,D.promisify)(w.lstat)}get utimes(){return(0,D.promisify)(w.utimes)}get read(){return(0,D.promisify)(w.read)}get readFile(){return(0,D.promisify)(w.readFile)}get write(){return(0,D.promisify)(w.write)}get appendFile(){return(0,D.promisify)(w.appendFile)}get fdatasync(){return(0,D.promisify)(w.fdatasync)}get truncate(){return(0,D.promisify)(w.truncate)}get rename(){return(0,D.promisify)(w.rename)}get copyFile(){return(0,D.promisify)(w.copyFile)}get open(){return(0,D.promisify)(w.open)}get close(){return(0,D.promisify)(w.close)}get symlink(){return(0,D.promisify)(w.symlink)}get readlink(){return(0,D.promisify)(w.readlink)}get chmod(){return(0,D.promisify)(w.chmod)}get mkdir(){return(0,D.promisify)(w.mkdir)}get unlink(){return(0,D.promisify)(w.unlink)}get rmdir(){return(0,D.promisify)(w.rmdir)}get realpath(){return(0,D.promisify)(w.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return P}get readDirsInDir(){return s}get writeFile(){return o}get rm(){return t}get move(){return L}get copy(){return F}}}),define(Z[82],x([0,1,27,9,25,21]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function n(y){const E=(0,R.dirname)(y);if(y===E)return y;const m=((0,R.basename)(y)||y).toLowerCase();try{const t=(0,k.readdirSync)(E).filter(f=>f.toLowerCase()===m);if(t.length===1){const f=n(E);if(f)return(0,R.join)(f,t[0])}else if(t.length>1){const f=t.indexOf(m);if(f>=0){const b=n(E);if(b)return(0,R.join)(b,t[f])}}}catch(S){}return null}e.realcaseSync=n;async function I(y){try{return await k.Promises.realpath(y)}catch(E){const m=g(y);return await k.Promises.access(m,w.constants.R_OK),m}}e.realpath=I;function d(y){try{return w.realpathSync(y)}catch(E){const m=g(y);return w.accessSync(m,w.constants.R_OK),m}}e.realpathSync=d;function g(y){return(0,D.rtrim)((0,R.normalize)(y),R.sep)}}),define(Z[117],x([0,1,61]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function R(I,d,g,y=1){let E=!1;return new Promise(m=>{const S=setTimeout(()=>{if(!E)return E=!0,m(0)},g);D(I,d,y,t=>{if(!E)return E=!0,clearTimeout(S),m(t)})})}e.findFreePort=R;function D(I,d,g,y){if(d===0)return y(0);const E=new w.Socket;E.once("connect",()=>(n(E),D(I+g,d-1,g,y))),E.once("data",()=>{}),E.once("error",m=>(n(E),m.code!=="ECONNREFUSED"?D(I+g,d-1,g,y):y(I))),E.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(I,d,g){let y=!1,E,m=1;const S=w.createServer({pauseOnConnect:!0});function t(f,b){y||(y=!0,S.removeAllListeners(),S.close(),E&&clearTimeout(E),b(f))}return new Promise(f=>{E=setTimeout(()=>{t(0,f)},g),S.on("listening",()=>{t(I,f)}),S.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&m<d?(I++,m++,S.listen(I,"127.0.0.1")):t(0,f)}),S.on("close",()=>{t(0,f)}),S.listen(I,"127.0.0.1")})}e.findFreePortFaster=k;function n(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(d){console.error(d)}}}),define(Z[118],x([0,1,26,9,21]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,n=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var d;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(d||(d={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class E{constructor(l,s,u){this.exePath=l,this.displayName=s,this.knownToExist=u}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:a=!1}={}){return a?g===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:a=!1,findPreview:l=!1}={}){const s=m({useAlternateBitness:a});if(!s)return null;const u=R.join(s,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(u))return null;let r=-1,i=null;for(const v of await D.Promises.readdir(u)){let M=-1;if(l){const L=v.indexOf("-");if(L<0)continue;const F=v.substring(0,L);if(!k.test(F)||v.substring(L+1)!=="preview")continue;M=parseInt(F,10)}else{if(!k.test(v))continue;M=parseInt(v,10)}if(M<=r)continue;const A=R.join(u,v,"pwsh.exe");!await D.SymlinkSupport.existsFile(A)||(i=A,r=M)}if(!i)return null;const o=s.includes("x86")?" (x86)":"",h=l?" Preview":"";return new E(i,`PowerShell${h}${o}`,!0)}async function t({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const l=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:s,pwshMsixName:u}=a?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:n,pwshMsixName:"PowerShell (Store)"};for(const r of await D.Promises.readdir(l))if(s.test(r)){const i=R.join(l,r,"pwsh.exe");return new E(i,u)}return null}function f(){const a=R.join(w.homedir(),".dotnet","tools","pwsh.exe");return new E(a,".NET Core PowerShell Global Tool")}function b(){const a=R.join(process.env.windir,g===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(a,"Windows PowerShell",!0)}async function*p(){let a=await S();a&&(yield a),a=await S({useAlternateBitness:!0}),a&&(yield a),a=await t(),a&&(yield a),a=f(),a&&(yield a),a=await S({findPreview:!0}),a&&(yield a),a=await t({findPreview:!0}),a&&(yield a),a=await S({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=b(),a&&(yield a)}async function*P(){for await(const a of p())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=P;async function c(){for await(const a of P())return a;return null}e.getFirstAvailablePowerShellInstallation=c}),define(Z[83],x([0,1,43,10]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(n){return new Promise((I,d)=>{let g;const y=new Map;function E(S,t,f,b,p){const P=y.get(t);if(S===n||P){const c={name:m(f),cmd:f,pid:S,ppid:t,load:b,mem:p};y.set(S,c),S===n&&(g=c),P&&(P.children||(P.children=[]),P.children.push(c),P.children.length>1&&(P.children=P.children.sort((a,l)=>a.pid-l.pid)))}}function m(S){const t=/--vscode-window-kind=shared-process/,f=/--vscode-window-kind=issue-reporter/,b=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,P=/--crashes-directory/,c=/\\pipe\\winpty-control/,a=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(P.exec(S))return"electron-crash-reporter";if(c.exec(S))return"winpty-process";if(a.exec(S))return"console-window-host (Windows internal process)";let s=l.exec(S);if(s&&s.length===2)return s[1]==="renderer"?t.exec(S)?"shared-process":f.exec(S)?"issue-reporter":b.exec(S)?"process-explorer":"window":s[1]==="utility"&&p.exec(S)?"utility-network-service":s[1];const u=/[a-zA-Z-]+\.js/g;let r="";do s=u.exec(S),s&&(r+=s+" ");while(s);return r&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${r}`:S}if(process.platform==="win32"){const S=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,f)=>{q(["windows-process-tree"],t,f)}).then(t=>{t.getProcessList(n,f=>{t.getProcessCpuUsage(f,b=>{const p=new Map;b.forEach(P=>{const c=S(P.commandLine||"");p.set(P.pid,{name:m(c),cmd:c,pid:P.pid,ppid:P.ppid,load:P.cpu||0,mem:P.memory||0})}),g=p.get(n),g?(p.forEach(P=>{const c=p.get(P.ppid);c&&(c.children||(c.children=[]),c.children.push(P))}),p.forEach(P=>{P.children&&(P.children=P.children.sort((c,a)=>c.pid-a.pid))}),I(g)):d(new Error(`Root process ${n} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let S=function(){let t=[g];const f=[];for(;t.length;){const p=t.shift();p&&(f.push(p.pid),p.children&&(t=t.concat(p.children)))}let b=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",q).fsPath);b+=" "+f.join(" "),(0,w.exec)(b,{},(p,P,c)=>{if(p||c)d(p||new Error(c.toString()));else{const a=P.toString().split(`
`);for(let l=0;l<f.length;l++){const s=y.get(f[l]);s.load=parseFloat(a[l])}if(!g){d(new Error(`Root process ${n} not found`));return}I(g)}})};(0,w.exec)("which ps",{},(t,f,b)=>{if(t||b)if(process.platform!=="linux")d(t||new Error(b.toString()));else{const p=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh",q).fsPath);(0,w.exec)(p,{},(P,c,a)=>{P||a?d(P||new Error(a.toString())):(k(c,E),S())})}else{const p=f.toString().trim(),P="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${p} ${P}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,a,l)=>{c||l&&!l.includes("screen size is bogus")?d(c||new Error(l.toString())):(k(a,E),process.platform==="linux"?S():g?I(g):d(new Error(`Root process ${n} not found`)))})}})}})}e.listProcesses=D;function k(n,I){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=n.toString().split(`
`);for(const y of g){const E=d.exec(y.trim());E&&E.length===6&&I(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(Z[119],x([0,1,27,23,32,2,70,9,3,21]),function(q,e,w,R,D,k,n,I,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function y(t,f,b){return m({path:t,isDirectory:!1},f,b)}e.watchFile=y;function E(t,f,b){return m({path:t,isDirectory:!0},f,b)}e.watchFolder=E,e.CHANGE_BUFFER_DELAY=100;function m(t,f,b){if(d.isMacintosh&&(0,D.isEqualOrParent)(t.path,"/Volumes/"))return b(`Refusing to watch ${t.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const p=(0,I.basename)(t.path),P=new Map;let c=!1,a=[(0,k.toDisposable)(()=>{P.forEach(l=>(0,k.dispose)(l)),P.clear()})];try{const l=(0,w.watch)(t.path);a.push((0,k.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const s=new Set;t.isDirectory&&g.Promises.readdir(t.path).then(u=>u.forEach(r=>s.add(r))),l.on("error",(u,r)=>{c||b(`Failed to watch ${t.path} for changes using fs.watch() (${u}, ${r})`)}),l.on("change",(u,r)=>{if(c)return;let i="";if(r&&(i=r.toString(),d.isMacintosh&&(i=(0,n.normalizeNFC)(i))),!i||u!=="change"&&u!=="rename")return;const o=t.isDirectory?(0,I.join)(t.path,i):t.path;if(t.isDirectory)if(u==="rename"){const h=P.get(o);h&&(0,k.dispose)(h);const v=setTimeout(async()=>{P.delete(o);const M=await g.Promises.exists(o);if(c)return;let A;M?s.has(i)?A="changed":(A="added",s.add(i)):(s.delete(i),A="deleted"),f(A,o)},e.CHANGE_BUFFER_DELAY);P.set(o,(0,k.toDisposable)(()=>clearTimeout(v)))}else{let h;s.has(i)?h="changed":(h="added",s.add(i)),f(h,o)}else if(u==="rename"||i!==p){const h=setTimeout(async()=>{const v=await g.Promises.exists(o);c||(v?(f("changed",o),a=[m(t,f,b)]):f("deleted",o))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(a),a=[(0,k.toDisposable)(()=>clearTimeout(h))]}else f("changed",o)})}catch(l){g.Promises.exists(t.path).then(s=>{s&&!c&&b(`Failed to watch ${t.path} for changes using fs.watch() (${l.toString()})`)})}return(0,k.toDisposable)(()=>{c=!0,a=(0,k.dispose)(a)})}async function S(t,f,b,p=512){const P=await g.Promises.open(t,"r"),c=Buffer.allocUnsafe(p),a=new R.CancellationTokenSource(b);let l,s=!1;const u=y(t,async r=>{if(r==="changed"){if(s)return;s=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:i}=await g.Promises.read(P,c,0,p,null);if(!i||a.token.isCancellationRequested)break;f(c.slice(0,i))}}catch(i){l=new Error(i),a.dispose(!0)}finally{s=!1}}},r=>{l=new Error(r),a.dispose(!0)});return new Promise((r,i)=>{a.token.onCancellationRequested(async()=>{u.dispose(),await g.Promises.close(P),l?i(l):r()})})}e.watchFileContents=S}),define(Z[120],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[121],x([0,1,14,13,120]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function k(){w.ipcMain.on(D.CONTEXT_MENU_CHANNEL,(I,d,g,y,E)=>{const m=n(I,y,g);m.popup({window:(0,R.withNullAsUndefined)(w.BrowserWindow.fromWebContents(I.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{m&&I.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,d)}})})}e.registerContextMenuListener=k;function n(I,d,g){const y=new w.Menu;return g.forEach(E=>{let m;E.type==="separator"?m=new w.MenuItem({type:E.type}):Array.isArray(E.submenu)?m=new w.MenuItem({submenu:n(I,d,E.submenu),label:E.label}):m=new w.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(S,t,f)=>I.sender.send(d,E.id,f)}),y.append(m)}),y}});var de=this&&this.__decorate||function(q,e,w,R){var D=arguments.length,k=D<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,w):R,n;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(q,e,w,R);else for(var I=q.length-1;I>=0;I--)(n=q[I])&&(k=(D<3?n(k):D>3?n(e,w,k):n(e,w))||k);return D>3&&k&&Object.defineProperty(e,w,k),k};define(Z[36],x([0,1,30,8,17,23,46,15,4,2,110,25,13]),function(q,e,w,R,D,k,n,I,d,g,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function t($){switch($){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(f=e.ResponseType||(e.ResponseType={}));function b($){switch($){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(p||(p={}));class P{constructor(H){this.buffer=H,this.pos=0}read(H){const ee=this.buffer.slice(this.pos,this.pos+H);return this.pos+=ee.byteLength,ee}}class c{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(H){this.buffers.push(H)}}var a;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object"})(a||(a={}));function l($){const H=D.VSBuffer.alloc(4);return H.writeUInt32BE($,0),H}function s($){return $.read(4).readUInt32BE(0)}function u($){const H=D.VSBuffer.alloc(1);return H.writeUInt8($,0),H}const r={Undefined:u(a.Undefined),String:u(a.String),Buffer:u(a.Buffer),VSBuffer:u(a.VSBuffer),Array:u(a.Array),Object:u(a.Object)},i=typeof Buffer!="undefined";function o($,H){if(typeof H=="undefined")$.write(r.Undefined);else if(typeof H=="string"){const ee=D.VSBuffer.fromString(H);$.write(r.String),$.write(l(ee.byteLength)),$.write(ee)}else if(i&&Buffer.isBuffer(H)){const ee=D.VSBuffer.wrap(H);$.write(r.Buffer),$.write(l(ee.byteLength)),$.write(ee)}else if(H instanceof D.VSBuffer)$.write(r.VSBuffer),$.write(l(H.byteLength)),$.write(H);else if(Array.isArray(H)){$.write(r.Array),$.write(l(H.length));for(const ee of H)o($,ee)}else{const ee=D.VSBuffer.fromString(JSON.stringify(H));$.write(r.Object),$.write(l(ee.byteLength)),$.write(ee)}}function h($){switch($.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return $.read(s($)).toString();case a.Buffer:return $.read(s($)).buffer;case a.VSBuffer:return $.read(s($));case a.Array:{const ee=s($),W=[];for(let C=0;C<ee;C++)W.push(h($));return W}case a.Object:return JSON.parse($.read(s($)).toString())}}class v{constructor(H,ee,W=null,C=1e3){this.protocol=H,this.ctx=ee,this.logger=W,this.timeoutDelay=C,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(T=>this.onRawMessage(T)),this.sendResponse({type:200})}registerChannel(H,ee){this.channels.set(H,ee),setTimeout(()=>this.flushPendingRequests(H),0)}sendResponse(H){switch(H.type){case 200:{const ee=this.send([H.type]);this.logger&&this.logger.logOutgoing(ee,0,1,b(H.type));return}case 201:case 202:case 204:case 203:{const ee=this.send([H.type,H.id],H.data);this.logger&&this.logger.logOutgoing(ee,H.id,1,b(H.type),H.data);return}}}send(H,ee=void 0){const W=new c;return o(W,H),o(W,ee),this.sendBuffer(W.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch(ee){return 0}}onRawMessage(H){const ee=new P(H),W=h(ee),C=h(ee),T=W[0];switch(T){case 100:return this.logger&&this.logger.logIncoming(H.byteLength,W[1],1,`${t(T)}: ${W[2]}.${W[3]}`,C),this.onPromise({type:T,id:W[1],channelName:W[2],name:W[3],arg:C});case 102:return this.logger&&this.logger.logIncoming(H.byteLength,W[1],1,`${t(T)}: ${W[2]}.${W[3]}`,C),this.onEventListen({type:T,id:W[1],channelName:W[2],name:W[3],arg:C});case 101:return this.logger&&this.logger.logIncoming(H.byteLength,W[1],1,`${t(T)}`),this.disposeActiveRequest({type:T,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(H.byteLength,W[1],1,`${t(T)}`),this.disposeActiveRequest({type:T,id:W[1]})}}onPromise(H){const ee=this.channels.get(H.channelName);if(!ee){this.collectPendingRequest(H);return}const W=new k.CancellationTokenSource;let C;try{C=ee.call(this.ctx,H.name,H.arg,W.token)}catch(z){C=Promise.reject(z)}const T=H.id;C.then(z=>{this.sendResponse({id:T,data:z,type:201}),this.activeRequests.delete(H.id)},z=>{z instanceof Error?this.sendResponse({id:T,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.sendResponse({id:T,data:z,type:203}),this.activeRequests.delete(H.id)});const _=(0,g.toDisposable)(()=>W.cancel());this.activeRequests.set(H.id,_)}onEventListen(H){const ee=this.channels.get(H.channelName);if(!ee){this.collectPendingRequest(H);return}const W=H.id,T=ee.listen(this.ctx,H.name,H.arg)(_=>this.sendResponse({id:W,data:_,type:204}));this.activeRequests.set(H.id,T)}disposeActiveRequest(H){const ee=this.activeRequests.get(H.id);ee&&(ee.dispose(),this.activeRequests.delete(H.id))}collectPendingRequest(H){let ee=this.pendingRequests.get(H.channelName);ee||(ee=[],this.pendingRequests.set(H.channelName,ee));const W=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.sendResponse({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ee.push({request:H,timeoutTimer:W})}flushPendingRequests(H){const ee=this.pendingRequests.get(H);if(ee){for(const W of ee)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(H)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(H=>H.dispose()),this.activeRequests.clear()}}e.ChannelServer=v;var M;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(M=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(H,ee=null){this.protocol=H,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=ee}getChannel(H){const ee=this;return{call(W,C,T){return ee.isDisposed?Promise.reject(I.canceled()):ee.requestPromise(H,W,C,T)},listen(W,C){return ee.isDisposed?Promise.reject(I.canceled()):ee.requestEvent(H,W,C)}}}requestPromise(H,ee,W,C=k.CancellationToken.None){const T=this.lastRequestId++,z={id:T,type:100,channelName:H,name:ee,arg:W};if(C.isCancellationRequested)return Promise.reject(I.canceled());let Y;return new Promise((j,ne)=>{if(C.isCancellationRequested)return ne(I.canceled());const se=()=>{const le=he=>{switch(he.type){case 201:this.handlers.delete(T),j(he.data);break;case 202:this.handlers.delete(T);const ge=new Error(he.data.message);ge.stack=he.data.stack,ge.name=he.data.name,ne(ge);break;case 203:this.handlers.delete(T),ne(he.data);break}};this.handlers.set(T,le),this.sendRequest(z)};let oe=null;this.state===p.Idle?se():(oe=(0,R.createCancelablePromise)(le=>this.whenInitialized()),oe.then(()=>{oe=null,se()}));const J=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:T,type:101}),ne(I.canceled())},ce=C.onCancellationRequested(J);Y=(0,g.combinedDisposable)((0,g.toDisposable)(J),ce),this.activeRequests.add(Y)}).finally(()=>{this.activeRequests.delete(Y)})}requestEvent(H,ee,W){const C=this.lastRequestId++,_={id:C,type:102,channelName:H,name:ee,arg:W};let z=null;const Y=new d.Emitter({onFirstListenerAdd:()=>{z=(0,R.createCancelablePromise)(j=>this.whenInitialized()),z.then(()=>{z=null,this.activeRequests.add(Y),this.sendRequest(_)})},onLastListenerRemove:()=>{z?(z.cancel(),z=null):(this.activeRequests.delete(Y),this.sendRequest({id:C,type:103}))}}),N=j=>Y.fire(j.data);return this.handlers.set(C,N),Y.event}sendRequest(H){switch(H.type){case 100:case 102:{const ee=this.send([H.type,H.id,H.channelName,H.name],H.arg);this.logger&&this.logger.logOutgoing(ee,H.id,0,`${t(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const ee=this.send([H.type,H.id]);this.logger&&this.logger.logOutgoing(ee,H.id,0,t(H.type));return}}}send(H,ee=void 0){const W=new c;return o(W,H),o(W,ee),this.sendBuffer(W.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch(ee){return 0}}onBuffer(H){const ee=new P(H),W=h(ee),C=h(ee),T=W[0];switch(T){case 200:return this.logger&&this.logger.logIncoming(H.byteLength,0,0,b(T)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(H.byteLength,W[1],0,b(T),C),this.onResponse({type:W[0],id:W[1],data:C})}}onResponse(H){if(H.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const ee=this.handlers.get(H.id);ee&&ee(H)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(H=>H.dispose()),this.activeRequests.clear()}}de([n.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class L{constructor(H){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,H(({protocol:ee,onDidClientDisconnect:W})=>{d.Event.once(ee.onMessage)(T=>{const _=new P(T),z=h(_),Y=new v(ee,z),N=new A(ee);this.channels.forEach((ne,se)=>Y.registerChannel(se,ne));const j={channelServer:Y,channelClient:N,ctx:z};this._connections.add(j),this._onDidAddConnection.fire(j),W(()=>{Y.dispose(),N.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const H=[];return this._connections.forEach(ee=>H.push(ee)),H}getChannel(H,ee){const W=this;return{call(C,T,_){let z;if((0,m.isFunction)(ee)){let N=(0,w.getRandomElement)(W.connections.filter(ee));z=N?Promise.resolve(N):d.Event.toPromise(d.Event.filter(W.onDidAddConnection,ee))}else z=ee.routeCall(W,C,T);const Y=z.then(N=>N.channelClient.getChannel(H));return U(Y).call(C,T,_)},listen(C,T){if((0,m.isFunction)(ee))return W.getMulticastEvent(H,ee,C,T);const _=ee.routeEvent(W,C,T).then(z=>z.channelClient.getChannel(H));return U(_).listen(C,T)}}}getMulticastEvent(H,ee,W,C){const T=this;let _=new g.DisposableStore;const z=new d.Emitter({onFirstListenerAdd:()=>{_=new g.DisposableStore;const Y=new d.EventMultiplexer,N=new Map,j=se=>{const J=se.channelClient.getChannel(H).listen(W,C),ce=Y.add(J);N.set(se,ce)},ne=se=>{const oe=N.get(se);!oe||(oe.dispose(),N.delete(se))};T.connections.filter(ee).forEach(j),d.Event.filter(T.onDidAddConnection,ee)(j,void 0,_),T.onDidRemoveConnection(ne,void 0,_),Y.event(z.fire,z,_),_.add(Y)},onLastListenerRemove:()=>{_.dispose()}});return z.event}registerChannel(H,ee){this.channels.set(H,ee),this._connections.forEach(W=>{W.channelServer.registerChannel(H,ee)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class F{constructor(H,ee,W=null){const C=new c;o(C,ee),H.send(C.buffer),this.channelClient=new A(H,W),this.channelServer=new v(H,ee,W)}getChannel(H){return this.channelClient.getChannel(H)}registerChannel(H,ee){this.channelServer.registerChannel(H,ee)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function U($){return{call(H,ee,W){return $.then(C=>C.call(H,ee,W))},listen(H,ee){const W=new d.Relay;return $.then(C=>W.input=C.listen(H,ee)),W.event}}}e.getDelayedChannel=U;function Q($){let H=!1;return{call(ee,W,C){return H?$.call(ee,W,C):(0,R.timeout)(0).then(()=>H=!0).then(()=>$.call(ee,W,C))},listen(ee,W){if(H)return $.listen(ee,W);const C=new d.Relay;return(0,R.timeout)(0).then(()=>H=!0).then(()=>C.input=$.listen(ee,W)),C.event}}}e.getNextTickChannel=Q;class ie{constructor(H){this.fn=H}routeCall(H){return this.route(H)}routeEvent(H){return this.route(H)}async route(H){for(const ee of H.connections)if(await Promise.resolve(this.fn(ee.ctx)))return Promise.resolve(ee);return await d.Event.toPromise(H.onDidAddConnection),await this.route(H)}}e.StaticRouter=ie;var re;(function($){function H(T,_){const z=T,Y=_&&_.disableMarshalling,N=new Map;for(const j in z)W(j)&&N.set(j,d.Event.buffer(z[j],!0));return new class{listen(j,ne,se){const oe=N.get(ne);if(oe)return oe;if(C(ne)){const J=z[ne];if(typeof J=="function")return J.call(z,se)}throw new Error(`Event not found: ${ne}`)}call(j,ne,se){const oe=z[ne];if(typeof oe=="function"){if(!Y&&Array.isArray(se))for(let J=0;J<se.length;J++)se[J]=(0,y.revive)(se[J]);return oe.apply(z,se)}throw new Error(`Method not found: ${ne}`)}}}$.fromService=H;function ee(T,_){const z=_&&_.disableMarshalling;return new Proxy({},{get(Y,N){if(typeof N=="string")return _?.properties?.has(N)?_.properties.get(N):C(N)?function(j){return T.listen(N,j)}:W(N)?T.listen(N):async function(...j){let ne;_&&!(0,m.isUndefinedOrNull)(_.context)?ne=[_.context,...j]:ne=j;const se=await T.call(N,ne);return z?se:(0,y.revive)(se)};throw new Error(`Property not found: ${String(N)}`)}})}$.toService=ee;function W(T){return T[0]==="o"&&T[1]==="n"&&E.isUpperAsciiLetter(T.charCodeAt(2))}function C(T){return/^onDynamic/.test(T)&&E.isUpperAsciiLetter(T.charCodeAt(9))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){let H=$.toString();if(H!=="[object Object]")return H}return $}function B($){return Array.isArray($)?$.map(O):O($)}function V($,H,ee,W,C,T,_){_=B(_);const z=G[C],Y=z[W%z.length];let N=[`%c[${$}]%c[${String(H).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${T}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(T)?(N=N.concat(_),N.push(")")):N.push(_),console.log.apply(console,N)}e.logWithColors=V;class X{constructor(H,ee){this._outgoingPrefix=H,this._incomingPrefix=ee,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(H,ee,W,C,T){this._totalOutgoing+=H,V(this._outgoingPrefix,this._totalOutgoing,H,ee,W,C,T)}logIncoming(H,ee,W,C,T){this._totalIncoming+=H,V(this._incomingPrefix,this._totalIncoming,H,ee,W,C,T)}}e.IPCLogger=X}),define(Z[122],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class w{constructor(D,k){this.sender=D,this.onMessage=k}send(D){try{this.sender.send("vscode:message",D.buffer)}catch(k){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=w}),define(Z[123],x([0,1,17,4,36]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(d){this.port=d,this.onMessage=R.Event.fromDOMEventEmitter(this.port,"message",g=>w.VSBuffer.wrap(g.data)),d.start()}send(d){this.port.postMessage(d.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class n extends D.IPCClient{constructor(d,g){const y=new k(d);super(y,g);this.protocol=y}dispose(){this.protocol.disconnect()}}e.Client=n}),define(Z[84],x([0,1,17,4,2,36]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var n;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(n=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const o=new WeakMap;let h=0;function v(A,L){if(!o.has(A)){const F=String(++h);o.set(A,F)}return o.get(A)}function M(A,L,F,U){if(!i.enableDiagnostics)return;const Q=v(A,L);if(U instanceof w.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const ie=w.VSBuffer.alloc(U.byteLength);ie.set(U),i.records.push({timestamp:Date.now(),id:Q,label:L,type:F,buff:ie})}else i.records.push({timestamp:Date.now(),id:Q,label:L,type:F,data:U})}i.traceSocketEvent=M})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var d;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let g=null;function y(){return g||(g=w.VSBuffer.alloc(0)),g}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,h){if(o===0)return y();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const L=this._chunks[0];return h&&(this._chunks.shift(),this._totalLength-=o),L}if(this._chunks[0].byteLength>o){const L=this._chunks[0].slice(0,o);return h&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),L}let v=w.VSBuffer.alloc(o),M=0,A=0;for(;o>0;){const L=this._chunks[A];if(L.byteLength>o){const F=L.slice(0,o);v.set(F,M),M+=o,h&&(this._chunks[A]=L.slice(o),this._totalLength-=o),o-=o}else v.set(L,M),M+=L.byteLength,h?(this._chunks.shift(),this._totalLength-=L.byteLength):A++,o-=L.byteLength}return v}}e.ChunkStream=E;var m;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(m||(m={}));function S(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(o,h,v,M){this.type=o,this.id=h,this.ack=v,this.data=M,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends D.Disposable{constructor(o){super();this._onMessage=this._register(new R.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const h=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=h.readUInt32BE(9),this._state.messageType=h.readUInt8(0),this._state.id=h.readUInt32BE(1),this._state.ack=h.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const v=this._state.messageType,M=this._state.id,A=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",h),this._onMessage.fire(new f(v,M,A,h)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=w.VSBuffer.alloc(13);h.writeUInt8(o.type,0),h.writeUInt32BE(o.id,1),h.writeUInt32BE(o.ack,5),h.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(h,o.data)}_bufferAdd(o,h){const v=this._totalLength===0;return this._data.push(o,h),this._totalLength+=o.byteLength+h.byteLength,v}_bufferTake(){const o=w.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,h){this._bufferAdd(o,h)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class P extends D.Disposable{constructor(o){super();this._onMessage=new R.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new b(this._socket)),this._register(this._socketReader.onMessage(h=>{h.type===1&&this._onMessage.fire(h.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new f(1,0,0,o))}}e.Protocol=P;class c extends k.IPCClient{constructor(o,h,v=null){super(o,h,v);this.protocol=o}static fromSocket(o,h){return new c(new P(o),h)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=c;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new R.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class l{constructor(o){this.data=o,this.next=null}}class s{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],h=0,v=this._first;for(;v;)o[h++]=v.data,v=v.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const h=new l(o);if(!this._first){this._first=h,this._last=h;return}this._last.next=h,this._last=h}}class u{constructor(){this.lastRuns=[];const o=Date.now();for(let h=0;h<u._HISTORY_LENGTH;h++)this.lastRuns[h]=o-1e3*h;setInterval(()=>{for(let h=u._HISTORY_LENGTH;h>=1;h--)this.lastRuns[h]=this.lastRuns[h-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}load(){const o=Date.now(),h=(1+u._HISTORY_LENGTH)*1e3;let v=0;for(let M=0;M<u._HISTORY_LENGTH;M++)o-this.lastRuns[M]<=h&&v++;return 1-v/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}u._HISTORY_LENGTH=10,u._INSTANCE=null;class r{constructor(o,h=null,v=u.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=v,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(M=>this._receiveMessage(M))),this._socketDisposables.push(this._socket.onClose(M=>this._onSocketClose.fire(M))),h&&this._socketReader.acceptChunk(h)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new f(5,0,0,y());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new f(7,0,0,y());this._socketWriter.write(o)}sendResume(){const o=new f(8,0,0,y());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,h){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),this._socketReader.acceptChunk(h)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new f(3,0,this._incomingAckId,y());this._socketWriter.write(o);const h=this._outgoingUnackMsg.toArray();for(let v=0,M=h.length;v<M;v++)this._socketWriter.write(h[v]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const h=this._outgoingUnackMsg.peek();if(h&&h.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const h=Date.now();h-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=h,this._socketWriter.write(new f(6,0,0,y())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const h=this._outgoingUnackMsg.toArray();for(let v=0,M=h.length;v<M;v++)this._socketWriter.write(h[v]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const h=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const v=new f(1,h,this._incomingAckId,o);this._outgoingUnackMsg.push(v),this._isReconnecting||(this._socketWriter.write(v),this._recvAckCheck())}sendControl(o){const h=new f(2,0,0,o);this._socketWriter.write(h)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),h=Date.now()-o.writtenTime,v=Date.now()-this._socketReader.lastReadTime,M=Date.now()-this._lastSocketTimeoutTime;if(h>=2e4&&v>=2e4&&M>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const A=Math.max(2e4-h,2e4-v,2e4-M,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},A)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new f(3,0,this._incomingAckId,y());this._socketWriter.write(o)}}e.PersistentProtocol=r}),define(Z[124],x([0,1,14,17,4,2,36,122]),function(q,e,w,R,D,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function d(y,E){const m=D.Event.fromNodeEventEmitter(w.ipcMain,E,(t,f)=>({event:t,message:f})),S=D.Event.filter(m,({event:t})=>t.sender.id===y);return D.Event.map(S,({message:t})=>t&&R.VSBuffer.wrap(t))}class g extends n.IPCServer{constructor(){super(g.getOnDidClientConnect())}static getOnDidClientConnect(){const E=D.Event.fromNodeEventEmitter(w.ipcMain,"vscode:hello",({sender:m})=>m);return D.Event.map(E,m=>{const S=m.id,t=g.Clients.get(S);t&&t.dispose();const f=new D.Emitter;g.Clients.set(S,(0,k.toDisposable)(()=>f.fire()));const b=d(S,"vscode:message"),p=D.Event.any(D.Event.signal(d(S,"vscode:disconnect")),f.event);return{protocol:new I.Protocol(m,b),onDidClientDisconnect:p}})}}e.Server=g,g.Clients=new Map}),define(Z[85],x([0,1,14,4,31,123]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class n extends k.Client{constructor(g,y){super({addEventListener:(E,m)=>g.addListener(E,m),removeEventListener:(E,m)=>g.removeListener(E,m),postMessage:E=>g.postMessage(E),start:()=>g.start(),close:()=>g.close()},y)}}e.Client=n;async function I(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const g=(0,D.generateUuid)();d.webContents.send("vscode:createMessageChannel",g);const y=R.Event.fromNodeEventEmitter(w.ipcMain,"vscode:createMessageChannelResult",(m,S)=>({nonce:S,port:m.ports[0]})),{port:E}=await R.Event.toPromise(R.Event.once(R.Event.filter(y,m=>m.nonce===g)));return E}e.connect=I}),define(Z[86],x([0,1,8,4,2,13]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var n;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(n=e.StorageHint||(e.StorageHint={}));function I(E){const m=E;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var d;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(d||(d={}));class g extends D.Disposable{constructor(m,S=Object.create(null)){super();this.database=m,this.options=S,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=d.None,this.cache=new Map,this.flushDelayer=new w.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((S,t)=>this.accept(t,S)),m.deleted?.forEach(S=>this.accept(S,void 0))}accept(m,S){if(this.state===d.Closed)return;let t=!1;(0,k.isUndefinedOrNull)(S)?t=this.cache.delete(m):this.cache.get(m)!==S&&(this.cache.set(m,S),t=!0),t&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===d.None&&(this.state=d.Initialized,this.options.hint!==n.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,S){const t=this.cache.get(m);return(0,k.isUndefinedOrNull)(t)?S:t}getBoolean(m,S){const t=this.get(m);return(0,k.isUndefinedOrNull)(t)?S:t==="true"}getNumber(m,S){const t=this.get(m);return(0,k.isUndefinedOrNull)(t)?S:parseInt(t,10)}async set(m,S){if(this.state===d.Closed)return;if((0,k.isUndefinedOrNull)(S))return this.delete(m);const t=String(S);if(this.cache.get(m)!==t)return this.cache.set(m,t),this.pendingInserts.set(m,t),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===d.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=d.Closed;try{await this.doFlush(0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((S,t)=>this.items.set(t,S)),m.delete&&m.delete.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=y}),define(Z[125],x([0,1,8,4,39,9,21]),function(q,e,w,R,D,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{constructor(y,E=Object.create(null)){this.path=y,this.options=E,this.name=(0,k.basename)(this.path),this.logger=new d(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return R.Event.None}async getItems(){const y=await this.whenConnected,E=new Map;return(await this.all(y,"SELECT * FROM ItemTable")).forEach(S=>E.set(S.key,S.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(y){const E=await this.whenConnected;return this.doUpdateItems(E,y)}doUpdateItems(y,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?(0,D.mapToString)(E.insert):"0"}), delete(${E.delete?(0,D.setToString)(E.delete):"0"})`),this.transaction(y,()=>{const m=E.insert,S=E.delete;if(m&&m.size>0){const t=[];t.push([]);let f=0;m.forEach((b,p)=>{let P=t[f];P.length>I.MAX_HOST_PARAMETERS&&(f++,P=[],t.push(P)),P.push(p,b)}),t.forEach(b=>{this.prepare(y,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,p=>p.run(b),()=>{const p=[];let P=0;return m.forEach((c,a)=>{p.push(a),P+=c.length}),`Keys: ${p.join(", ")} Length: ${P}`})})}if(S&&S.size){const t=[];t.push([]);let f=0;S.forEach(b=>{let p=t[f];p.length>I.MAX_HOST_PARAMETERS&&(f++,p=[],t.push(p)),p.push(b)}),t.forEach(b=>{this.prepare(y,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,p=>p.run(b),()=>{const p=[];return S.forEach(P=>{p.push(P)}),`Keys: ${p.join(", ")}`})})}})}async close(y){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,y)}doClose(y,E){return new Promise((m,S)=>{y.db.close(t=>(t&&this.handleSQLiteError(y,`[storage ${this.name}] close(): ${t}`),this.path===I.IN_MEMORY_PATH?m():!y.isErroneous&&!y.isInMemory?this.backup().then(m,f=>(this.logger.error(`[storage ${this.name}] backup(): ${f}`),m())):typeof E=="function"?n.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(f=>{const b=()=>this.doClose(f,void 0);return this.doUpdateItems(f,{insert:E()}).then(()=>b(),p=>(b(),Promise.reject(p)))})).then(m,S):S(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const y=this.toBackupPath(this.path);return n.Promises.copy(this.path,y,{preserveSymlinks:!1})}toBackupPath(y){return`${y}.backup`}async checkIntegrity(y){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${y})`);const E=await this.whenConnected,m=await this.get(E,y?"PRAGMA integrity_check":"PRAGMA quick_check"),S=y?m.integrity_check:m.quick_check;return E.isErroneous?`${S} (last error: ${E.lastError})`:E.isInMemory?`${S} (in-memory!)`:S}async connect(y,E=!0){this.logger.trace(`[storage ${this.name}] open(${y}, retryOnBusy: ${E})`);try{return await this.doConnect(y)}catch(m){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${m}`),m.code==="SQLITE_BUSY"&&E)return await(0,w.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(y,!1);try{await n.Promises.unlink(y);try{await n.Promises.rename(this.toBackupPath(y),y)}catch(S){}return await this.doConnect(y)}catch(S){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${S}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(y,E){y.isErroneous=!0,y.lastError=E,this.logger.error(E)}doConnect(y){return new Promise((E,m)=>{new Promise((S,t)=>{q(["@vscode/sqlite3"],S,t)}).then(S=>{const t={db:new(this.logger.isTracing?S.verbose().Database:S.Database)(y,f=>f?t.db?t.db.close(()=>m(f)):m(f):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(t),b=>t.db.close(()=>m(b)))),isInMemory:y===I.IN_MEMORY_PATH};t.db.on("error",f=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${f}`)),this.logger.isTracing&&t.db.on("trace",f=>this.logger.trace(`[storage ${this.name}] Trace (event): ${f}`))},m)})}exec(y,E){return new Promise((m,S)=>{y.db.exec(E,t=>t?(this.handleSQLiteError(y,`[storage ${this.name}] exec(): ${t}`),S(t)):m())})}get(y,E){return new Promise((m,S)=>{y.db.get(E,(t,f)=>t?(this.handleSQLiteError(y,`[storage ${this.name}] get(): ${t}`),S(t)):m(f))})}all(y,E){return new Promise((m,S)=>{y.db.all(E,(t,f)=>t?(this.handleSQLiteError(y,`[storage ${this.name}] all(): ${t}`),S(t)):m(f))})}transaction(y,E){return new Promise((m,S)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),E(),y.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(y,`[storage ${this.name}] transaction(): ${t}`),S(t)):m())})})}prepare(y,E,m,S){const t=y.db.prepare(E),f=b=>{this.handleSQLiteError(y,`[storage ${this.name}] prepare(): ${b} (${E}). Details: ${S()}`)};t.on("error",f),m(t),t.finalize(b=>{b&&f(b),t.removeListener("error",f)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.BUSY_OPEN_TIMEOUT=2e3,I.MAX_HOST_PARAMETERS=256;class d{constructor(y){y&&typeof y.logTrace=="function"&&process.env[d.VSCODE_TRACE_STORAGE]&&(this.logTrace=y.logTrace),y&&typeof y.logError=="function"&&(this.logError=y.logError)}get isTracing(){return!!this.logTrace}trace(y){this.logTrace&&this.logTrace(y)}error(y){this.logError&&this.logError(y)}}d.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[126],x([12,11]),function(q,e){return q.create("vs/base/common/date",e)}),define(Z[127],x([0,1,126]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,D=R*60,k=D*24,n=k*7,I=k*30,d=k*365;function g(E,m){typeof E!="number"&&(E=E.getTime());const S=Math.round((new Date().getTime()-E)/1e3);if(S<-30)return(0,w.localize)(0,null,g(new Date().getTime()+S*1e3,!1));if(S<30)return(0,w.localize)(1,null);let t;return S<R?(t=S,m?t===1?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):t===1?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t)):S<D?(t=Math.floor(S/R),m?t===1?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):t===1?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):S<k?(t=Math.floor(S/D),m?t===1?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):t===1?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t)):S<n?(t=Math.floor(S/k),m?t===1?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):t===1?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):S<I?(t=Math.floor(S/n),m?t===1?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):t===1?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t)):S<d?(t=Math.floor(S/I),m?t===1?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):t===1?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):(t=Math.floor(S/d),m?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t))}e.fromNow=g;function y(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=y}),define(Z[128],x([12,11]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(Z[44],x([0,1,30,13,128]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(g,y){return y&&(g.stack||g.stacktrace)?D.localize(0,null,I(g),n(g.stack)||n(g.stacktrace)):I(g)}function n(g){return Array.isArray(g)?g.join(`
`):g}function I(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?D.localize(1,null,g.message):g.message||D.localize(2,null)}function d(g=null,y=!1){if(!g)return D.localize(3,null);if(Array.isArray(g)){const E=w.coalesce(g),m=d(E[0],y);return E.length>1?D.localize(4,null,m,E.length):m}if(R.isString(g))return g;if(g.detail){const E=g.detail;if(E.error)return k(E.error,y);if(E.exception)return k(E.exception,y)}return g.stack?k(g,y):g.message?g.message:D.localize(5,null)}e.toErrorMessage=d}),define(Z[129],x([12,11]),function(q,e){return q.create("vs/base/common/keybindingLabels",e)}),define(Z[130],x([0,1,129]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class R{constructor(n,I,d=I){this.modifierLabels=[null],this.modifierLabels[2]=n,this.modifierLabels[1]=I,this.modifierLabels[3]=d}toLabel(n,I,d){if(I.length===0)return null;const g=[];for(let y=0,E=I.length;y<E;y++){const m=I[y],S=d(m);if(S===null)return null;g[y]=D(m,S,this.modifierLabels[n])}return g.join(" ")}}e.ModifierLabelProvider=R,e.UILabelProvider=new R({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:w.localize(0,null),shiftKey:w.localize(1,null),altKey:w.localize(2,null),metaKey:w.localize(3,null),separator:"+"},{ctrlKey:w.localize(4,null),shiftKey:w.localize(5,null),altKey:w.localize(6,null),metaKey:w.localize(7,null),separator:"+"}),e.AriaLabelProvider=new R({ctrlKey:w.localize(8,null),shiftKey:w.localize(9,null),altKey:w.localize(10,null),metaKey:w.localize(11,null),separator:"+"},{ctrlKey:w.localize(12,null),shiftKey:w.localize(13,null),altKey:w.localize(14,null),metaKey:w.localize(15,null),separator:"+"},{ctrlKey:w.localize(16,null),shiftKey:w.localize(17,null),altKey:w.localize(18,null),metaKey:w.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new R({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new R({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(k,n,I){if(n===null)return"";const d=[];return k.ctrlKey&&d.push(I.ctrlKey),k.shiftKey&&d.push(I.shiftKey),k.altKey&&d.push(I.altKey),k.metaKey&&d.push(I.metaKey),n!==""&&d.push(n),d.join(I.separator)}}),define(Z[131],x([12,11]),function(q,e){return q.create("vs/base/node/processes",e)}),define(Z[72],x([0,1,43,32,10,47,9,3,34,80,13,114,21,131]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return g.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return g.TerminateResponseCode}});function t(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function f(s,u){if(I.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};u&&(r.cwd=u);const i=w.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],r);return new Promise(o=>{i.once("error",h=>{o({success:!1,error:h})}),i.once("exit",(h,v)=>{o(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?t(r.status):1})}else if(I.isLinux||I.isMacintosh)try{const r=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",q).fsPath;return new Promise(i=>{w.execFile(r,[s.pid.toString()],{encoding:"utf8",shell:!0},(o,h,v)=>{i(o?{success:!1,error:o}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function b(s){!s||(delete s.DEBUG,I.isMacintosh&&delete s.DYLD_LIBRARY_PATH,I.isLinux&&delete s.LD_PRELOAD)}e.removeDangerousEnvVariables=b;function p(s=d.env){return s.comspec||"cmd.exe"}e.getWindowsShell=p;class P{constructor(u,r,i,o){if(r!==void 0&&i!==void 0&&o!==void 0)this.cmd=u,this.args=r,this.shell=i,this.options=o;else{const h=u;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(d.env).forEach(v=>{h[v]=d.env[v]}),Object.keys(this.options.env).forEach(v=>{h[v]=this.options.env[v]}),this.options.env=h}}getSanitizedCommand(){let u=this.cmd.toLowerCase();const r=u.lastIndexOf(n.sep);return r!==-1&&(u=u.substring(r+1)),P.WellKnowCommands[u]?u:"other"}start(u){return I.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(d.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(r=>{let i,o;const h=new Promise((v,M)=>{i=v,o=M});if(r){let v=this.cmd;this.args&&(v=v+" "+this.args.join(" ")),this.childProcess=w.exec(v,this.options,(M,A,L)=>{this.childProcess=null;const F=M;F&&F.killed?o({killed:this.terminateRequested,stdout:A.toString(),stderr:L.toString()}):this.handleExec(i,u,M,A,L)})}else{let v=null;const M=A=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(A,i,u,o);const L={terminated:this.terminateRequested};y.isNumber(A)&&(L.cmdCode=A),i(L)};if(this.shell&&I.isWindows){const A=k.deepClone(this.options);A.windowsVerbatimArguments=!0,A.detached=!1;let L=!1,F=!1;const U=[];let Q=this.ensureQuotes(this.cmd);U.push(Q.value),L=Q.quoted,this.args&&this.args.forEach(re=>{Q=this.ensureQuotes(re),U.push(Q.value),F=F&&Q.quoted});const ie=["/s","/c"];L?F?ie.push('"'+U.join(" ")+'"'):U.length>1?ie.push('"'+U[0]+'" '+U.slice(1).join(" ")):ie.push('"'+U[0]+'"'):ie.push(U.join(" ")),v=w.spawn(p(),ie,A)}else this.cmd&&(v=w.spawn(this.cmd,this.args,this.options));v&&(this.childProcess=v,this.childProcessPromise=Promise.resolve(v),this.pidResolve&&(this.pidResolve(y.isNumber(v.pid)?v.pid:-1),this.pidResolve=void 0),v.on("error",A=>{this.childProcess=null,o({terminated:this.terminateRequested,error:A})}),v.pid&&(this.childProcess.on("close",M),this.handleSpawn(v,i,u,o,!0)))}return h})}handleClose(u,r,i,o){}ensureQuotes(u){return P.regexp.test(u)?{value:'"'+u+'"',quoted:!0}:{value:u,quoted:u.length>0&&u[0]==='"'&&u[u.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(u=>u.pid,u=>-1):new Promise(u=>{this.pidResolve=u})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(u=>(this.terminateRequested=!0,f(u,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),u=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(u=>{if(!this.shell||!I.isWindows)return u(!1);const r=w.spawn(p(),["/s","/c"]);r.on("error",i=>u(!0)),r.on("exit",i=>u(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class c extends P{constructor(u,r,i,o){super(u,r,i,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(u,r,i,o,h){[o,h].forEach((v,M)=>{const A=new E.LineDecoder;A.write(v).forEach(U=>{r({line:U,source:M===0?0:1})});const F=A.end();F&&r({line:F,source:M===0?0:1})}),u({terminated:this.terminateRequested,error:i})}handleSpawn(u,r,i,o,h){const v=new E.LineDecoder,M=new E.LineDecoder;u.stdout.on("data",A=>{v.write(A).forEach(F=>i({line:F,source:0}))}),u.stderr.on("data",A=>{M.write(A).forEach(F=>i({line:F,source:1}))}),this.stdoutLineDecoder=v,this.stderrLineDecoder=M}handleClose(u,r,i,o){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&i({line:h,source:0});const v=this.stderrLineDecoder?this.stderrLineDecoder.end():null;v&&i({line:v,source:1})}}e.LineProcess=c;function a(s){let u=[],r=!1;const i=function(o){if(r){u.push(o);return}(!s.send(o,v=>{if(v&&console.error(v),r=!1,u.length>0){const M=u.slice(0);u=[],M.forEach(A=>i(A))}})||I.isWindows)&&(r=!0)};return{send:i}}e.createQueuedSender=a;var l;(function(s){async function u(r,i,o){if(n.isAbsolute(r))return r;if(i===void 0&&(i=d.cwd()),n.dirname(r)!=="."||(o===void 0&&y.isString(d.env.PATH)&&(o=d.env.PATH.split(n.delimiter)),o===void 0||o.length===0))return n.join(i,r);async function v(M){if(await m.Promises.exists(M)){let A;try{A=await m.Promises.stat(M)}catch(L){L.message.startsWith("EACCES")&&(A=await m.Promises.lstat(M))}return A?!A.isDirectory():!1}return!1}for(let M of o){let A;if(n.isAbsolute(M)?A=n.join(M,r):A=n.join(i,M,r),await v(A))return A;let L=A+".com";if(await v(L)||(L=A+".exe",await v(L)))return L}return n.join(i,r)}s.findExecutable=u})(l=e.win32||(e.win32={}))}),define(Z[132],x([0,1,26,3,118,72]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function n(S,t){return S===1?R.isWindows?E():k.getWindowsShell(t):g(S,t)}e.getSystemShell=n;function I(S,t){return S===1?R.isWindows?m(t):k.getWindowsShell(t):g(S,t)}e.getSystemShellSync=I;let d=null;function g(S,t){if(R.isLinux&&S===2||R.isMacintosh&&S===3)return"/bin/bash";if(!d){let f;if(R.isWindows)f="/bin/bash";else{if(f=t.SHELL,!f)try{f=(0,w.userInfo)().shell}catch(b){}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}d=f}return d}let y=null;async function E(){return y||(y=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),y}function m(S){if(y)return y;const t=R.isWindows&&parseFloat((0,w.release)())>=10,f=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${S.windir}\\${f?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?b:k.getWindowsShell(S)}}),define(Z[133],x([0,1,43,8,17,23,109,15,4,2,47,72,36]),function(q,e,w,R,D,k,n,I,d,g,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends m.ChannelServer{constructor(b){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch(P){}},onMessage:d.Event.fromNodeEventEmitter(process,"message",p=>D.VSBuffer.wrap(Buffer.from(p,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=S;class t{constructor(b,p){this.modulePath=b,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const P=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new R.Delayer(P),this.child=null,this._client=null}getChannel(b){const p=this;return{call(P,c,a){return p.requestPromise(b,P,c,a)},listen(P,c){return p.requestEvent(b,P,c)}}}requestPromise(b,p,P,c=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(b),l=(0,R.createCancelablePromise)(r=>a.call(p,P,r)),s=c.onCancellationRequested(()=>l.cancel()),u=(0,g.toDisposable)(()=>l.cancel());return this.activeRequests.add(u),l.finally(()=>{s.dispose(),this.activeRequests.delete(u),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(b,p,P){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let c;const a=new d.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(b).listen(p,P)(a.fire,a),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,E.removeDangerousEnvVariables)(p.env),this.child=(0,w.fork)(this.modulePath,b,p);const P=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,n.isRemoteConsoleLog)(i)){(0,n.log)(i,`IPC Library: ${this.options.serverName}`);return}P.fire(D.VSBuffer.wrap(Buffer.from(i,"base64")))});const a=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,l=i=>this.child&&this.child.connected&&a.send(i.buffer.toString("base64")),s=P.event,u={send:l,onMessage:s};this._client=new m.ChannelClient(u);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,o)=>{process.removeListener("exit",r),this.activeRequests.forEach(h=>(0,g.dispose)(h)),this.activeRequests.clear(),i!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:o})})}return this._client}getCachedChannel(b){let p=this.channels.get(b);return p||(p=this.client.getChannel(b),this.channels.set(b,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(Z[134],x([12,11]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(Z[135],x([12,11]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[136],x([12,11]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[137],x([12,11]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(Z[138],x([12,11]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(Z[139],x([12,11]),function(q,e){return q.create("vs/platform/environment/node/shellEnv",e)}),define(Z[140],x([12,11]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[141],x([12,11]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[142],x([12,11]),function(q,e){return q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[143],x([12,11]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(Z[144],x([12,11]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(Z[145],x([12,11]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(Z[146],x([12,11]),function(q,e){return q.create("vs/platform/files/electron-main/diskFileSystemProviderIpc",e)}),define(Z[147],x([12,11]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[148],x([12,11]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[149],x([12,11]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[150],x([12,11]),function(q,e){return q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[151],x([12,11]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(Z[152],x([12,11]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[153],x([12,11]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[154],x([12,11]),function(q,e){return q.create("vs/platform/windows/electron-main/window",e)}),define(Z[155],x([12,11]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[156],x([12,11]),function(q,e){return q.create("vs/platform/workspaces/common/workspaces",e)}),define(Z[157],x([12,11]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[158],x([12,11]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[159],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function w(R){return typeof R?.backupFolder=="string"}e.isEmptyWindowBackupInfo=w}),define(Z[160],x([0,1,4,2]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new w.Emitter,this._onReloadEmitter=new w.Emitter,this._onTerminateEmitter=new w.Emitter,this._onAttachEmitter=new w.Emitter}call(I,d,g){switch(d){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:g[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:g[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:g[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:g[0],port:g[1],subId:g[2]}))}throw new Error("Method not implemented.")}listen(I,d,g){switch(d){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class k extends R.Disposable{constructor(I){super();this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,d,g){this.channel.call("attach",[I,d,g])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,d){this.channel.call("terminate",[I,d])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,d){return this.channel.call("openExtensionDevelopmentHostWindow",[I,d])}}e.ExtensionHostDebugChannelClient=k}),define(Z[161],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class w{constructor(n){this.driver=n}listen(n,I){throw new Error(`No event found: ${I}`)}call(n,I,d){switch(I){case"click":return this.driver.click(d[0],d[1],d[2]);case"doubleClick":return this.driver.doubleClick(d);case"setValue":return this.driver.setValue(d[0],d[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(d);case"getElements":return this.driver.getElements(d[0],d[1]);case"getElementXY":return this.driver.getElementXY(d[0],d[1],d[2]);case"typeInEditor":return this.driver.typeInEditor(d[0],d[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(d);case"writeInTerminal":return this.driver.writeInTerminal(d[0],d[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${I}`)}}e.WindowDriverChannel=w;class R{constructor(n){this.channel=n}click(n,I,d){return this.channel.call("click",[n,I,d])}doubleClick(n){return this.channel.call("doubleClick",n)}setValue(n,I){return this.channel.call("setValue",[n,I])}getTitle(){return this.channel.call("getTitle")}isActiveElement(n){return this.channel.call("isActiveElement",n)}getElements(n,I){return this.channel.call("getElements",[n,I])}getElementXY(n,I,d){return this.channel.call("getElementXY",[n,I,d])}typeInEditor(n,I){return this.channel.call("typeInEditor",[n,I])}getTerminalBuffer(n){return this.channel.call("getTerminalBuffer",n)}writeInTerminal(n,I){return this.channel.call("writeInTerminal",[n,I])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=R;class D{constructor(n){this.channel=n}registerWindowDriver(n){return this.channel.call("registerWindowDriver",n)}reloadWindowDriver(n){return this.channel.call("reloadWindowDriver",n)}}e.WindowDriverRegistryChannelClient=D}),define(Z[162],x([0,1,127,46,10,9,34,16,7]),function(q,e,w,R,D,k,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class g{constructor(f,b,p){this._args=f,this.paths=b,this.productService=p}get appRoot(){return(0,k.dirname)(D.FileAccess.asFileUri("",q).fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(d.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return d.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return d.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=n.env.VSCODE_PORTABLE;return f?d.URI.file((0,k.join)(f,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,k.resolve)(f):(0,k.normalize)((0,k.join)(D.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const f=this.args["extensions-download-dir"];return f?(0,k.resolve)(f):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,k.resolve)(f);const b=n.env.VSCODE_EXTENSIONS;if(b)return b;const p=n.env.VSCODE_PORTABLE;return p?(0,k.join)(p,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(b=>/^[^:/?#]+?:\/\//.test(b)?d.URI.parse(b):d.URI.file((0,k.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?d.URI.parse(f):d.URI.file((0,k.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!n.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return d.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([R.memoize],g.prototype,"appRoot",null),de([R.memoize],g.prototype,"userHome",null),de([R.memoize],g.prototype,"userDataPath",null),de([R.memoize],g.prototype,"appSettingsHome",null),de([R.memoize],g.prototype,"tmpDir",null),de([R.memoize],g.prototype,"cacheHome",null),de([R.memoize],g.prototype,"userRoamingDataHome",null),de([R.memoize],g.prototype,"settingsResource",null),de([R.memoize],g.prototype,"userDataSyncHome",null),de([R.memoize],g.prototype,"userDataSyncLogResource",null),de([R.memoize],g.prototype,"sync",null),de([R.memoize],g.prototype,"machineSettingsResource",null),de([R.memoize],g.prototype,"globalStorageHome",null),de([R.memoize],g.prototype,"workspaceStorageHome",null),de([R.memoize],g.prototype,"keybindingsResource",null),de([R.memoize],g.prototype,"keyboardLayoutResource",null),de([R.memoize],g.prototype,"argvResource",null),de([R.memoize],g.prototype,"snippetsHome",null),de([R.memoize],g.prototype,"isExtensionDevelopment",null),de([R.memoize],g.prototype,"untitledWorkspacesHome",null),de([R.memoize],g.prototype,"installSourcePath",null),de([R.memoize],g.prototype,"builtinExtensionsPath",null),de([R.memoize],g.prototype,"extensionsPath",null),de([R.memoize],g.prototype,"extensionDevelopmentLocationURI",null),de([R.memoize],g.prototype,"extensionDevelopmentKind",null),de([R.memoize],g.prototype,"extensionTestsLocationURI",null),de([R.memoize],g.prototype,"debugExtensionHost",null),de([R.memoize],g.prototype,"serviceMachineIdResource",null),de([R.memoize],g.prototype,"telemetryLogResource",null),de([R.memoize],g.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=g;function y(t,f){return S(t["inspect-extensions"],t["inspect-brk-extensions"],5870,f,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=y;function E(t,f){return S(t["inspect-search"],t["inspect-brk-search"],5876,f,t.extensionEnvironment)}e.parseSearchPort=E;function m(t,f){return S(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,f,t.extensionEnvironment)}e.parsePtyHostPort=m;function S(t,f,b,p,P,c){const l=Number(f||t)||(p?null:b),s=l?Boolean(!!f):!1;let u;if(c)try{u=JSON.parse(c)}catch{}return{port:l,break:s,debugId:P,env:u}}}),define(Z[87],x([0,1,246,3,137]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const n={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function I(t,f,b=n){const p={},P=[],c=[];for(let u in f){const r=f[u];r.alias&&(p[u]=r.alias),r.type==="string"||r.type==="string[]"?(P.push(u),r.deprecates&&P.push(r.deprecates)):r.type==="boolean"&&(c.push(u),r.deprecates&&c.push(r.deprecates))}const a=w(t,{string:P,boolean:c,alias:p}),l={},s=a;l._=a._.map(u=>String(u)).filter(u=>u.length>0),delete s._;for(let u in f){const r=f[u];r.alias&&delete s[r.alias];let i=s[u];r.deprecates&&s.hasOwnProperty(r.deprecates)&&(i||(i=s[r.deprecates],i&&b.onDeprecatedOption(r.deprecates,u)),delete s[r.deprecates]),typeof i!="undefined"&&(r.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):r.type==="string"&&Array.isArray(i)&&(i=i.pop(),b.onMultipleValues(u,i)),l[u]=i),delete s[u]}for(let u in s)b.onUnknownOption(u);return l}e.parseArgs=I;function d(t,f){let b="";return f.args&&(Array.isArray(f.args)?b=` <${f.args.join("> <")}>`:b=` <${f.args}>`),f.alias?`-${f.alias} --${t}${b}`:`--${t}${b}`}function g(t,f){let b=0,p=[];for(const l in t){const s=t[l],u=d(l,s);b=Math.max(b,u.length),p.push([u,s.description])}let P=b+2+1;if(f-P<25)return p.reduce((l,s)=>l.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);let c=f-P-1,a=[];for(const l of p){let s=l[0],u=E(l[1],c),r=y(P-s.length-2);a.push("  "+s+r+u[0]);for(let i=1;i<u.length;i++)a.push(y(P)+u[i])}return a}e.formatOptions=g;function y(t){return" ".repeat(t)}function E(t,f){let b=[];for(;t.length;){let p=t.length<f?t.length:t.lastIndexOf(" ",f),P=t.slice(0,p).trim();t=t.slice(p),b.push(P)}return b}function m(t,f,b,p,P){const c=process.stdout.isTTY&&process.stdout.columns||80,a=P?.noInputFiles!==!0?`[${(0,D.localize)(33,null)}...]`:"",l=[`${t} ${b}`];l.push(""),l.push(`${(0,D.localize)(34,null)}: ${f} [${(0,D.localize)(35,null)}]${a}`),l.push(""),P?.noPipe!==!0&&(R.isWindows?l.push((0,D.localize)(36,null,f)):l.push((0,D.localize)(37,null,f)),l.push(""));const s={};for(const u in p){const r=p[u];if(r.description&&r.cat){let i=s[r.cat];i||(s[r.cat]=i={}),i[u]=r}}for(let u in s){const r=u;let i=s[r];i&&(l.push(k[r]),l.push(...g(i,c)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=m;function S(t,f){return`${t||(0,D.localize)(38,null)}
${f||(0,D.localize)(39,null)}
${process.arch}`}e.buildVersionMessage=S}),define(Z[163],x([0,1,61,160,87]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class k extends R.ExtensionHostDebugBroadcastChannel{constructor(I){super();this.windowsMainService=I}call(I,d,g){return d==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(g[0],g[1]):super.call(I,d,g)}async openExtensionDevelopmentHostWindow(I,d){const g=(0,D.parseArgs)(I,D.OPTIONS);g.debugRenderer=d;const y=g.extensionDevelopmentPath;if(!y)return{success:!1};const[E]=this.windowsMainService.openExtensionDevelopmentHostWindow(y,{context:5,cli:g});if(!d)return{success:!0};const m=E.win;if(!m)return{success:!0};const S=m.webContents.debugger;let t=S.isAttached()?Infinity:0;const f=(0,w.createServer)(b=>{t++==0&&S.attach();let p=!1;const P=l=>{p||b.write(JSON.stringify(l)+"\0")},c=(l,s,u,r)=>P({method:s,params:u,sessionId:r});m.on("close",()=>{S.removeListener("message",c),b.end(),p=!0}),S.addListener("message",c);let a=Buffer.alloc(0);b.on("data",l=>{a=Buffer.concat([a,l]);for(let s=a.indexOf(0);s!==-1;s=a.indexOf(0)){let u;try{const r=a.slice(0,s).toString("utf8");a=a.slice(s+1),u=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}S.sendCommand(u.method,u.params,u.sessionId).then(r=>P({id:u.id,sessionId:u.sessionId,result:r})).catch(r=>P({id:u.id,sessionId:u.sessionId,error:{code:0,message:r.message}}))}}),b.on("error",l=>{console.error("error on cdp pipe:",l)}),b.on("close",()=>{p=!0,--t==0&&S.detach()})});return await new Promise(b=>f.listen(0,b)),m.on("close",()=>f.close()),{rendererDebugPort:f.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=k}),function(){"use strict";function q(e,w,R,D){function k(I){const d=n(I),g=[d];return e.isAbsolute(d)||g.unshift(D),e.resolve(...g)}function n(I){const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,R);const y=I["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(E,"AppData","Roaming")}break;case"darwin":g=e.join(w.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,R)}return{getUserDataPath:k}}if(typeof define=="function")define(Z[164],x([0,247,26,10,16,34]),function(e,w,R,D,k,n){const I=k.dirname(D.FileAccess.asFileUri("",e)),d=e.__$__nodeRequire(k.joinPath(I,"package.json").fsPath);return q(w,R,d.name,n.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),w=require("path"),R=require("os");module.exports=q(w,R,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[165],x([0,1,26,162,164]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends R.AbstractNativeEnvironmentService{constructor(I,d){super(I,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,D.getUserDataPath)(I)},d)}}e.NativeEnvironmentService=k}),define(Z[166],x([0,1,27,26,9]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function k(n){const I=(0,D.join)((0,R.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return w.writeFileSync(I,""),n&&console.log(`Marker file for --wait created: ${I}`),I}catch(d){n&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.createWaitMarkerFile=k}),define(Z[167],x([0,1,141]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function k(m){return m=m.trim(),m==="*"||R.test(m)}e.isValidVersionStr=k;function n(m){if(!k(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=m.match(R);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=n;function I(m){if(!m)return null;let S=m.majorBase,t=m.majorMustEqual,f=m.minorBase,b=m.minorMustEqual,p=m.patchBase,P=m.patchMustEqual;m.hasCaret&&(S===0||(b=!1),P=!1);let c=0;if(m.preRelease){const a=D.exec(m.preRelease);if(a){const[,l,s,u]=a;c=Date.UTC(Number(l),Number(s)-1,Number(u))}}return{majorBase:S,majorMustEqual:t,minorBase:f,minorMustEqual:b,patchBase:p,patchMustEqual:P,isMinimum:m.hasGreaterEquals,notBefore:c}}e.normalizeVersion=I;function d(m,S,t){let f;typeof m=="string"?f=I(n(m)):f=m;let b;S instanceof Date?b=S.getTime():typeof S=="string"&&(b=new Date(S).getTime());let p;if(typeof t=="string"?p=I(n(t)):p=t,!f||!p)return!1;let P=f.majorBase,c=f.minorBase,a=f.patchBase,l=p.majorBase,s=p.minorBase,u=p.patchBase,r=p.notBefore,i=p.majorMustEqual,o=p.minorMustEqual,h=p.patchMustEqual;return p.isMinimum?P>l?!0:P<l?!1:c>s?!0:c<s||b&&b<r?!1:a>=u:(P===1&&l===0&&(!i||!o||!h)&&(l=1,s=0,u=0,i=!0,o=!1,h=!1),P<l?!1:P>l?!i:c<s?!1:c>s?!o:a<u?!1:a>u?!h:!(b&&b<r))}e.isValidVersion=d;function g(m,S,t,f){return t.isBuiltin||typeof t.main=="undefined"?!0:E(m,S,t.engines.vscode,f)}e.isValidExtensionVersion=g;function y(m,S,t){return m==="*"||E(S,t,m)}e.isEngineValid=y;function E(m,S,t,f=[]){let b=I(n(t));if(!b)return f.push(w.localize(0,null,t)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return f.push(w.localize(1,null,t)),!1}else if(!b.majorMustEqual)return f.push(w.localize(2,null,t)),!1;return d(m,S,b)?!0:(f.push(w.localize(3,null,m,t)),!1)}}),define(Z[168],x([0,1,4,2,17,59,23]),function(q,e,w,R,D,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProviderChannel=void 0;class I extends R.Disposable{constructor(g,y){super();this.provider=g,this.logService=y,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(g,y,E){const m=this.getUriTransformer(g);switch(y){case"stat":return this.stat(m,E[0]);case"readdir":return this.readdir(m,E[0]);case"open":return this.open(m,E[0],E[1]);case"close":return this.close(E[0]);case"read":return this.read(E[0],E[1],E[2]);case"readFile":return this.readFile(m,E[0]);case"write":return this.write(E[0],E[1],E[2],E[3],E[4]);case"writeFile":return this.writeFile(m,E[0],E[1],E[2]);case"rename":return this.rename(m,E[0],E[1],E[2]);case"copy":return this.copy(m,E[0],E[1],E[2]);case"mkdir":return this.mkdir(m,E[0]);case"delete":return this.delete(m,E[0],E[1]);case"watch":return this.watch(m,E[0],E[1],E[2],E[3]);case"unwatch":return this.unwatch(E[0],E[1])}throw new Error(`IPC Command ${y} not found`)}listen(g,y,E){const m=this.getUriTransformer(g);switch(y){case"fileChange":return this.onFileChange(m,E[0]);case"readFileStream":return this.onReadFileStream(m,E[0],E[1])}throw new Error(`Unknown event ${y}`)}stat(g,y){const E=this.transformIncoming(g,y,!0);return this.provider.stat(E)}readdir(g,y){const E=this.transformIncoming(g,y);return this.provider.readdir(E)}async readFile(g,y){const E=this.transformIncoming(g,y,!0),m=await this.provider.readFile(E);return D.VSBuffer.wrap(m)}onReadFileStream(g,y,E){const m=this.transformIncoming(g,y,!0),S=new n.CancellationTokenSource,t=new w.Emitter({onLastListenerRemove:()=>{S.cancel()}}),f=this.provider.readFileStream(m,E,S.token);return(0,k.listenStream)(f,{onData:b=>t.fire(D.VSBuffer.wrap(b)),onError:b=>t.fire(b),onEnd:()=>{t.fire("end"),t.dispose(),S.dispose()}}),t.event}writeFile(g,y,E,m){const S=this.transformIncoming(g,y);return this.provider.writeFile(S,E.buffer,m)}open(g,y,E){const m=this.transformIncoming(g,y,!0);return this.provider.open(m,E)}close(g){return this.provider.close(g)}async read(g,y,E){const m=D.VSBuffer.alloc(E),S=0,t=await this.provider.read(g,y,m.buffer,S,E);return[m,t]}write(g,y,E,m,S){return this.provider.write(g,y,E.buffer,m,S)}mkdir(g,y){const E=this.transformIncoming(g,y);return this.provider.mkdir(E)}delete(g,y,E){const m=this.transformIncoming(g,y);return this.provider.delete(m,E)}rename(g,y,E,m){const S=this.transformIncoming(g,y),t=this.transformIncoming(g,E);return this.provider.rename(S,t,m)}copy(g,y,E,m){const S=this.transformIncoming(g,y),t=this.transformIncoming(g,E);return this.provider.copy(S,t,m)}onFileChange(g,y){const E=new w.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(y,this.createSessionFileWatcher(g,E))},onLastListenerRemove:()=>{(0,R.dispose)(this.sessionToWatcher.get(y)),this.sessionToWatcher.delete(y)}});return E.event}async watch(g,y,E,m,S){const t=this.sessionToWatcher.get(y);if(t){const f=this.transformIncoming(g,m),b=t.watch(E,f,S);this.watchRequests.set(y+E,b)}}async unwatch(g,y){const E=g+y,m=this.watchRequests.get(E);m&&((0,R.dispose)(m),this.watchRequests.delete(E))}dispose(){super.dispose(),this.watchRequests.forEach(g=>(0,R.dispose)(g)),this.watchRequests.clear(),this.sessionToWatcher.forEach(g=>(0,R.dispose)(g)),this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=I}),define(Z[73],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(D,k=[],n=!1){this.ctor=D,this.staticArguments=k,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=w}),define(Z[169],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=w;class R{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let n of this._nodes.values())n.outgoing.size===0&&k.push(n);return k}insertEdge(k,n){const I=this.lookupOrInsertNode(k),d=this.lookupOrInsertNode(n);I.outgoing.set(this._hashFn(n),d),d.incoming.set(this._hashFn(k),I)}removeNode(k){const n=this._hashFn(k);this._nodes.delete(n);for(let I of this._nodes.values())I.outgoing.delete(n),I.incoming.delete(n)}lookupOrInsertNode(k){const n=this._hashFn(k);let I=this._nodes.get(n);return I||(I=new w(k),this._nodes.set(n,I)),I}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[n,I]of this._nodes)k.push(`${n}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,n]of this._nodes){const I=new Set([k]),d=this._findCycle(n,I);if(d)return d}}_findCycle(k,n){for(let[I,d]of k.outgoing){if(n.has(I))return[...n,I].join(" -> ");n.add(I);const g=this._findCycle(d,n);if(g)return g;n.delete(I)}}}e.Graph=R}),define(Z[5],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function I(d){return d[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=I})(w=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function R(n,I,d,g){I[w.DI_TARGET]===I?I[w.DI_DEPENDENCIES].push({id:n,index:d,optional:g}):(I[w.DI_DEPENDENCIES]=[{id:n,index:d,optional:g}],I[w.DI_TARGET]=I)}function D(n){if(w.serviceIds.has(n))return w.serviceIds.get(n);const I=function(d,g,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(I,d,y,!1)};return I.toString=()=>n,w.serviceIds.set(n,I),I}e.createDecorator=D;function k(n){return n}e.refineServiceDecorator=k}),define(Z[52],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,w.createDecorator)("backupMainService")}),define(Z[18],x([0,1,13,7,5]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function k(b){return b&&typeof b=="object"&&(!b.overrideIdentifier||typeof b.overrideIdentifier=="string")&&(!b.resource||b.resource instanceof R.URI)}e.isConfigurationOverrides=k;function n(b){return b&&typeof b=="object"&&(!b.overrideIdentifiers||w.isArray(b.overrideIdentifiers))&&!b.overrideIdentifier&&(!b.resource||b.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=n;var I;(function(b){b[b.USER=1]="USER",b[b.USER_LOCAL=2]="USER_LOCAL",b[b.USER_REMOTE=3]="USER_REMOTE",b[b.WORKSPACE=4]="WORKSPACE",b[b.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",b[b.DEFAULT=6]="DEFAULT",b[b.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(b){switch(b){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=d;function g(b,p){const P=Object.create(null);for(let c in b)y(P,c,b[c],p);return P}e.toValuesTree=g;function y(b,p,P,c){const a=p.split("."),l=a.pop();let s=b;for(let u=0;u<a.length;u++){let r=a[u],i=s[r];switch(typeof i){case"undefined":i=s[r]=Object.create(null);break;case"object":break;default:c(`Ignoring ${p} as ${a.slice(0,u+1).join(".")} is ${JSON.stringify(i)}`);return}s=i}if(typeof s=="object"&&s!==null)try{s[l]=P}catch(u){c(`Ignoring ${p} as ${a.join(".")} is ${JSON.stringify(s)}`)}else c(`Ignoring ${p} as ${a.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=y;function E(b,p){const P=p.split(".");m(b,P)}e.removeFromValueTree=E;function m(b,p){const P=p.shift();if(p.length===0){delete b[P];return}if(Object.keys(b).indexOf(P)!==-1){const c=b[P];typeof c=="object"&&!Array.isArray(c)&&(m(c,p),Object.keys(c).length===0&&delete b[P])}}function S(b,p,P){function c(s,u){let r=s;for(const i of u){if(typeof r!="object"||r===null)return;r=r[i]}return r}const a=p.split("."),l=c(b,a);return typeof l=="undefined"?P:l}e.getConfigurationValue=S;function t(b,p,P){Object.keys(p).forEach(c=>{c!=="__proto__"&&(c in b?w.isObject(b[c])&&w.isObject(p[c])?t(b[c],p[c],P):P&&(b[c]=p[c]):b[c]=p[c])})}e.merge=t;function f(b,p,P){const c=b.inspect(p),a=b.inspect(P);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:c.defaultValue}e.getMigratedSettingValue=f}),define(Z[74],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function R(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=R}),define(Z[88],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService");class R{constructor(k){this.machineId=k}encryption(){return new Promise((k,n)=>q(["vscode-encrypt"],k,n))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch(n){return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch(n){return k}}}e.EncryptionMainService=R}),define(Z[48],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[170],x([0,1,10,140,5]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var k;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));function n(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function I(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function d(c,a){switch(c){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=d;function g(c,a){return a==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=g;function y(c,a,l){return g(a,l)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===l?!0:E(l).includes(c)}e.isTargetPlatformCompatible=y;function E(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function m(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=m;var S;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var t;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var f;(function(c){c.Install="install",c.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var b;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(b=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var p;(function(c){c.Unsupported="Unsupported",c.UnsupportedPreRelease="UnsupportedPreRelease",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class P extends Error{constructor(a,l){super(a);this.code=l,this.name=l}}e.ExtensionManagementError=P,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=w.FileAccess.asBrowserUri("./media/defaultIcon.png",q).toString(!0),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,R.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(Z[171],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,w.createDecorator)("extensionUrlTrustService")}),define(Z[172],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,w.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[89],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,w.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,w.createDecorator)("externalTerminal")}),define(Z[173],x([0,1,43,10,9,3,80,21,72,142,89]),function(q,e,w,R,D,k,n,I,d,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const E=g.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends m{openTerminal(a,l){return this.spawnTerminal(w,a,d.getWindowsShell(),l)}spawnTerminal(a,l,s,u){const r=l.windowsExec||S.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const i=D.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return a.spawn(r,u?[u]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return r.indexOf(" ")>=0&&o.push('""'),o.push(r),(i==="wt"||i==="wt.exe")&&o.push("-d ."),new Promise((h,v)=>{const M=b(process),A=a.spawn(s,o,{cwd:u,env:M});A.on("error",v),A.on("exit",()=>h())})}runInTerminal(a,l,s,u,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:S.getDefaultTerminalWindows();return new Promise((o,h)=>{const v=`"${l} - ${E}"`,M=`""${s.join('" "')}" & pause"`,A=["/c","start",v,"/wait",i,"/c",M],L=Object.assign({},b(process),u);Object.keys(L).filter(Q=>L[Q]===null).forEach(Q=>delete L[Q]);const F={cwd:l,env:L,windowsVerbatimArguments:!0};w.spawn(S.CMD,A,F).on("error",Q=>{h(p(Q))}),o(void 0)})}static getDefaultTerminalWindows(){if(!S._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return S._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=S,S.CMD="cmd.exe";class t extends m{openTerminal(a,l){return this.spawnTerminal(w,a,l)}runInTerminal(a,l,s,u,r){const i=r.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((o,h)=>{if(i===y.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const v=i===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",A=[R.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${v}.scpt`,q).fsPath,"-t",a||E,"-w",l];for(let U of s)A.push("-a"),A.push(U);if(u){const U=Object.assign({},b(process),u);for(let Q in U){const ie=U[Q];ie===null?(A.push("-u"),A.push(Q)):(A.push("-e"),A.push(`${Q}=${ie}`))}}let L="";const F=w.spawn(t.OSASCRIPT,A);F.on("error",U=>{h(p(U))}),F.stderr.on("data",U=>{L+=U.toString()}),F.on("exit",U=>{if(U===0)o(void 0);else if(L){const Q=L.split(`
`,1);h(new Error(Q[0]))}else h(new Error(g.localize(1,null,v,U)))})}else h(new Error(g.localize(2,null,i)))})}spawnTerminal(a,l,s){const u=l.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const o=["-a",u];s&&o.push(s);const h=b(process),v=a.spawn("/usr/bin/open",o,{cwd:s,env:h});v.on("error",i),v.on("exit",()=>r())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class f extends m{openTerminal(a,l){return this.spawnTerminal(w,a,l)}runInTerminal(a,l,s,u,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((o,h)=>{let v=[];i.then(M=>{M.indexOf("gnome-terminal")>=0?v.push("-x"):v.push("-e"),v.push("bash"),v.push("-c");const A=`${P(s)}; echo; read -p "${f.WAIT_MESSAGE}" -n1;`;v.push(`''${A}''`);const L=Object.assign({},b(process),u);Object.keys(L).filter(ie=>L[ie]===null).forEach(ie=>delete L[ie]);const F={cwd:l,env:L};let U="";const Q=w.spawn(M,v,F);Q.on("error",ie=>{h(p(ie))}),Q.stderr.on("data",ie=>{U+=ie.toString()}),Q.on("exit",ie=>{if(ie===0)o(void 0);else if(U){const re=U.split(`
`,1);h(new Error(re[0]))}else h(new Error(g.localize(4,null,M,ie)))})})})}static async getDefaultTerminalLinuxReady(){if(!f._DEFAULT_TERMINAL_LINUX_READY)if(!k.isLinux)f._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await I.Promises.exists("/etc/debian_version");f._DEFAULT_TERMINAL_LINUX_READY=new Promise(l=>{a?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return f._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,l,s){const u=l.linuxExec?Promise.resolve(l.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{u.then(o=>{const h=b(process),v=a.spawn(o,[],{cwd:s,env:h});v.on("error",i),v.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=f,f.WAIT_MESSAGE=g.localize(3,null);function b(c){const a={...c.env};return(0,n.sanitizeProcessEnvironment)(a),a}function p(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(g.localize(5,null,c.path)):c}function P(c){let a="";for(let l of c)l.indexOf(" ")>=0?a+='"'+l+'"':a+=l,a+=" ";return a}}),define(Z[19],x([0,1,39,9,25,13,7,144,5]),function(q,e,w,R,D,k,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function g(O){return O.create===!0}e.isFileOpenForWriteOptions=g;var y;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var E;(function(O){O[O.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var m;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=S;function t(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=t;function f(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function b(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=b;var p;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor(B,V){super(B);this.code=V}}e.FileSystemProviderError=P;function c(O,B){const V=new P(O.toString(),B);return l(V,B),V}e.createFileSystemProviderError=c;function a(O){return O||c((0,I.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=a;function l(O,B){return O.name=B?`${B} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=l;function s(O){if(!O)return p.Unknown;if(O instanceof P)return O.code;const B=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!B)return p.Unknown;switch(B[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=s;function u(O){if(O instanceof M)return O.fileOperationResult;switch(s(O)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var r;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(B,V,X){this.resource=B,this.operation=V,this.target=X}isOperation(B){return this.operation===B}}e.FileOperationEvent=i;var o;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class h{constructor(B,V){this.added=void 0,this.updated=void 0,this.deleted=void 0;const X=new Map;for(const $ of B){const H=X.get($.type);H?H.push([$.resource,$]):X.set($.type,[[$.resource,$]])}for(const[$,H]of X)switch($){case 1:this.added=w.TernarySearchTree.forUris(()=>V),this.added.fill(H);break;case 0:this.updated=w.TernarySearchTree.forUris(()=>V),this.updated.fill(H);break;case 2:this.deleted=w.TernarySearchTree.forUris(()=>V),this.deleted.fill(H);break}}contains(B,...V){return this.doContains(B,{includeChildren:!1},...V)}affects(B,...V){return this.doContains(B,{includeChildren:!0},...V)}doContains(B,V,...X){if(!B)return!1;const $=X.length>0;return!!((!$||X.includes(1))&&(this.added?.get(B)||V.includeChildren&&this.added?.findSuperstr(B))||(!$||X.includes(0))&&(this.updated?.get(B)||V.includeChildren&&this.updated?.findSuperstr(B))||(!$||X.includes(2))&&(this.deleted?.findSubstr(B)||V.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function v(O,B,V){return!O||!B||O===B||B.length>O.length?!1:(B.charAt(B.length-1)!==R.sep&&(B+=R.sep),V?(0,D.startsWithIgnoreCase)(O,B):O.indexOf(B)===0)}e.isParent=v;class M extends Error{constructor(B,V,X){super(B);this.fileOperationResult=V,this.options=X}}e.FileOperationError=M;class A extends M{constructor(B,V,X){super(B,2,X);this.stat=V}}e.NotModifiedSinceFileOperationError=A;var L;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(L=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=U;async function Q(O,B){if(!B.hasProvider(n.URI.from({scheme:O.scheme})))return new Promise(V=>{const X=B.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===O.scheme&&$.added&&(X.dispose(),V())})})}e.whenProviderRegistered=Q,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ie{static formatSize(B){return(0,k.isNumber)(B)||(B=0),B<ie.KB?(0,I.localize)(1,null,B.toFixed(0)):B<ie.MB?(0,I.localize)(2,null,(B/ie.KB).toFixed(2)):B<ie.GB?(0,I.localize)(3,null,(B/ie.MB).toFixed(2)):B<ie.TB?(0,I.localize)(4,null,(B/ie.GB).toFixed(2)):(0,I.localize)(5,null,(B/ie.TB).toFixed(2))}}e.ByteSize=ie,ie.KB=1024,ie.MB=ie.KB*ie.KB,ie.GB=ie.MB*ie.KB,ie.TB=ie.GB*ie.KB;var re;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(re=e.Arch||(e.Arch={}));function G(O){return{maxFileSize:O===0?300*ie.MB:16*ie.GB,maxHeapSize:O===0?700*ie.MB:2*700*ie.MB}}e.getPlatformLimits=G}),define(Z[53],x([0,1,248,138,87,19]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function n(m,S){const t={onUnknownOption:b=>{console.warn((0,R.localize)(0,null,b))},onMultipleValues:(b,p)=>{console.warn((0,R.localize)(1,null,b,p))},onDeprecatedOption:(b,p)=>{console.warn((0,R.localize)(2,null,b,p))}},f=(0,D.parseArgs)(m,D.OPTIONS,S?t:void 0);return f.goto&&f._.forEach(b=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,R.localize)(3,null))),f["max-memory"]&&w(parseInt(f["max-memory"])>=k.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${k.MIN_MAX_MEMORY_SIZE_MB} MB.`),f}function I(m){const S=m.findIndex(t=>!/^-/.test(t));if(S>-1)return[...m.slice(0,S),...m.slice(S+1)]}function d(m){let[,...S]=m;process.env.VSCODE_DEV&&(S=I(S)||[]);const t=!E(process.env);return n(S,t)}e.parseMainProcessArgv=d;function g(m){const[,,...S]=m;return n(S,!0)}e.parseCLIProcessArgv=g;function y(m,...S){const t=m.indexOf("--");return t===-1?m.push(...S):m.splice(t,0,...S),m}e.addArg=y;function E(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(Z[90],x([0,1,43,9,139,23,44,15,3,31,132,53,8]),function(q,e,w,R,D,k,n,I,d,g,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const S=1e4;let t;async function f(p,P,c){return P["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(c)&&!P["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(c)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=m.Promises.withAsyncBody(async(a,l)=>{const s=new k.CancellationTokenSource,u=setTimeout(()=>{s.dispose(!0),l(new Error((0,D.localize)(0,null)))},S);try{a(await b(p,s.token))}catch(r){!(0,I.isPromiseCanceledError)(r)&&!s.token.isCancellationRequested?l(new Error((0,D.localize)(1,null,(0,n.toErrorMessage)(r)))):a({})}finally{clearTimeout(u),s.dispose()}})),t)}e.getResolvedShellEnv=f;async function b(p,P){const c=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",c);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",a);const l=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(l+"(.*)"+l),u={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",u);const r=await(0,y.getSystemShell)(d.OS,u);return p.trace("getUnixShellEnvironment#shell",r),new Promise((i,o)=>{if(P.isCancellationRequested)return o((0,I.canceled)());const h=(0,R.basename)(r);let v,M;const A=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(h)?(v=`& '${process.execPath}' ${A} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,M=["-Login","-Command"]):(v=`'${process.execPath}' ${A} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,h==="tcsh"?M=["-ic"]:M=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(M),v);const L=(0,w.spawn)(r,[...M,v],{detached:!0,stdio:["ignore","pipe","pipe"],env:u});P.onCancellationRequested(()=>(L.kill(),o((0,I.canceled)()))),L.on("error",Q=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,n.toErrorMessage)(Q)),o(Q)});const F=[];L.stdout.on("data",Q=>F.push(Q));const U=[];L.stderr.on("data",Q=>U.push(Q)),L.on("close",(Q,ie)=>{const re=Buffer.concat(F).toString("utf8");p.trace("getUnixShellEnvironment#raw",re);const G=Buffer.concat(U).toString("utf8");if(G.trim()&&p.trace("getUnixShellEnvironment#stderr",G),Q||ie)return o(new Error((0,D.localize)(2,null,Q,ie)));const O=s.exec(re),B=O?O[1]:"{}";try{const V=JSON.parse(B);c?V.ELECTRON_RUN_AS_NODE=c:delete V.ELECTRON_RUN_AS_NODE,a?V.ELECTRON_NO_ATTACH_CONSOLE=a:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",V),i(V)}catch(V){p.error("getUnixShellEnvironment#errorCaught",(0,n.toErrorMessage)(V)),o(V)}})})}}),define(Z[91],x([0,1,17,15,145,19]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(y,E,m,S,t,f){let b;try{await I(y,E,m,S,t,f)}catch(p){b=p}finally{b&&t.errorTransformer&&(b=t.errorTransformer(b)),typeof b!="undefined"&&m.error(b),m.end()}}e.readFileIntoStream=n;async function I(y,E,m,S,t,f){d(f);const b=await y.open(E,{create:!1});try{d(f);let p=0,P=0,c=t&&typeof t.length=="number"?t.length:void 0,a=w.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),l=t&&typeof t.position=="number"?t.position:0,s=0;do P=await y.read(b,l,a.buffer,s,a.byteLength-s),l+=P,s+=P,p+=P,typeof c=="number"&&(c-=P),s===a.byteLength&&(await m.write(S(a)),a=w.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),s=0);while(P>0&&(typeof c!="number"||c>0)&&d(f)&&g(p,t));if(s>0){let u=s;typeof c=="number"&&(u=Math.min(s,c)),m.write(S(a.slice(0,u)))}}catch(p){throw(0,k.ensureFileSystemProviderError)(p)}finally{await y.close(b)}}function d(y){if(y.isCancellationRequested)throw(0,R.canceled)();return!0}function g(y,E){if(E?.limits){if(typeof E.limits.memory=="number"&&y>E.limits.memory)throw(0,k.createFileSystemProviderError)((0,D.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&y>E.limits.size)throw(0,k.createFileSystemProviderError)((0,D.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[62],x([0,1,2,3,7,19]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractRecursiveWatcherClient=void 0;class n extends w.Disposable{constructor(E,m,S){super();this.onFileChanges=E,this.onLogMessage=m,this.verboseLogging=S,this.watcherDisposables=this._register(new w.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const E=new w.DisposableStore;this.watcherDisposables.value=E,this.watcher=this.createWatcher(E),this.watcher.setVerboseLogging(this.verboseLogging),E.add(this.watcher.onDidChangeFile(m=>this.onFileChanges(m))),E.add(this.watcher.onDidLogMessage(m=>this.onLogMessage(m))),E.add(this.watcher.onDidError(m=>this.onError(m)))}onError(E){this.restartCounter<n.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${E}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${E}`)}restart(E){this.restartCounter++,this.init(),this.watch(E)}async watch(E){this.requests=E,await this.watcher?.watch(E)}async setVerboseLogging(E){this.verboseLogging=E,await this.watcher?.setVerboseLogging(E)}error(E){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${E}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractRecursiveWatcherClient=n,n.MAX_RESTARTS=5;function I(y){return y.map(E=>({type:E.type,resource:D.URI.file(E.path)}))}e.toFileChanges=I;function d(y){const E=new g;for(const m of y)E.processEvent(m);return E.coalesce()}e.coalesceEvents=d;class g{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(E){return R.isLinux?E.path:E.path.toLowerCase()}processEvent(E){const m=this.mapPathToChange.get(this.toKey(E));let S=!1;if(m){const t=m.type,f=E.type;m.path!==E.path&&E.type===2?S=!0:t===1&&f===2?(this.mapPathToChange.delete(this.toKey(E)),this.coalesced.delete(m)):t===2&&f===1?m.type=0:t===1&&f===0||(m.type=f)}else S=!0;S&&(this.coalesced.add(E),this.mapPathToChange.set(this.toKey(E),E))}coalesce(){const E=[],m=[];return Array.from(this.coalesced).filter(S=>S.type!==2?(E.push(S),!1):!0).sort((S,t)=>S.path.length-t.path.length).filter(S=>m.some(t=>(0,k.isParent)(S.path,t,!R.isLinux))?!1:(m.push(S.path),!0)).concat(E)}}}),define(Z[92],x([0,1,8,15,2,9,82,21,119,62]),function(q,e,w,R,D,k,n,I,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcher=void 0;class y extends D.Disposable{constructor(m,S,t,f){super();this.path=m,this.onDidFilesChange=S,this.onLogMessage=t,this.verboseLogging=f,this.fileChangesDelayer=this._register(new w.ThrottledDelayer(d.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(m){this.verboseLogging=m}async startWatching(){try{const{stat:m,symbolicLink:S}=await I.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let t=this.path;if(S)try{t=await(0,n.realpath)(t)}catch(f){if(this.onError(f),S.dangling)return}m.isDirectory()?this._register((0,d.watchFolder)(t,(f,b)=>{this.onFileChange({type:f==="changed"?0:f==="added"?1:2,path:(0,k.join)(this.path,(0,k.basename)(b))})},f=>this.onError(f))):this._register((0,d.watchFile)(t,f=>{this.onFileChange({type:f==="changed"?0:2,path:this.path})},f=>this.onError(f)))}catch(m){m.code!=="ENOENT"&&this.onError(m)}}onFileChange(m){this.fileChangesBuffer.push(m),this.verboseLogging&&this.onVerbose(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),this.fileChangesDelayer.trigger(async()=>{const S=this.fileChangesBuffer;this.fileChangesBuffer=[];const t=(0,g.coalesceEvents)(S);if(this.verboseLogging)for(const f of t)this.onVerbose(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);t.length>0&&this.onDidFilesChange(t)}).catch(S=>(0,R.onUnexpectedError)(S))}onError(m){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${m}`})}onVerbose(m){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.NodeJSFileWatcher=y}),define(Z[174],x([0,1,10,36,133,62]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcherClient=void 0;class n extends k.AbstractRecursiveWatcherClient{constructor(d,g,y){super(d,g,y);this.init()}createWatcher(d){const g=d.add(new D.Client(w.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(g.onDidProcessExit(({code:y,signal:E})=>this.onError(`terminated by itself with code ${y}, signal: ${E}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(g.getChannel("watcher")))}}e.ParcelWatcherClient=n}),define(Z[75],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...D){this._entries=new Map;for(let[k,n]of D)this.set(k,n)}set(D,k){const n=this._entries.get(D);return this._entries.set(D,k),n}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=w}),define(Z[175],x([0,1,8,15,73,169,5,75]),function(q,e,w,R,D,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const d=!1;class g extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class y{constructor(t=new I.ServiceCollection,f=!1,b){this._activeInstantiations=new Set,this._services=t,this._strict=f,this._parent=b,this._services.set(n.IInstantiationService,this)}createChild(t){return new y(t,this._strict,this)}invokeFunction(t,...f){let b=m.traceInvocation(t),p=!1;try{return t({get:c=>{if(p)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(c,b);if(!a)throw new Error(`[invokeFunction] unknown service '${c}'`);return a}},...f)}finally{p=!0,b.stop()}}createInstance(t,...f){let b,p;return t instanceof D.SyncDescriptor?(b=m.traceCreation(t.ctor),p=this._createInstance(t.ctor,t.staticArguments.concat(f),b)):(b=m.traceCreation(t),p=this._createInstance(t,f,b)),b.stop(),p}_createInstance(t,f=[],b){let p=n._util.getServiceDependencies(t).sort((a,l)=>a.index-l.index),P=[];for(const a of p){let l=this._getOrCreateServiceInstance(a.id,b);if(!l&&this._strict&&!a.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${a.id}.`);P.push(l)}let c=p.length>0?p[0].index:f.length;if(f.length!==c){console.warn(`[createInstance] First service dependency of ${t.name} at position ${c+1} conflicts with ${f.length} static arguments`);let a=c-f.length;a>0?f=f.concat(new Array(a)):f=f.slice(0,c)}return new t(...[...f,...P])}_setServiceInstance(t,f){if(this._services.get(t)instanceof D.SyncDescriptor)this._services.set(t,f);else if(this._parent)this._parent._setServiceInstance(t,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let f=this._services.get(t);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):f}_getOrCreateServiceInstance(t,f){let b=this._getServiceInstanceOrDescriptor(t);return b instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,b,f.branch(t,!0)):(f.branch(t,!1),b)}_safeCreateAndCacheServiceInstance(t,f,b){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,f,b)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,f,b){const p=new k.Graph(a=>a.id.toString());let P=0;const c=[{id:t,desc:f,_trace:b}];for(;c.length;){const a=c.pop();if(p.lookupOrInsertNode(a),P++>1e3)throw new g(p);for(let l of n._util.getServiceDependencies(a.desc.ctor)){let s=this._getServiceInstanceOrDescriptor(l.id);if(!s&&!l.optional&&console.warn(`[createInstance] ${t} depends on ${l.id} which is NOT registered.`),s instanceof D.SyncDescriptor){const u={id:l.id,desc:s,_trace:a._trace.branch(l.id,!0)};p.insertEdge(a,u),c.push(u)}}}for(;;){const a=p.roots();if(a.length===0){if(!p.isEmpty())throw new g(p);break}for(const{data:l}of a){if(this._getServiceInstanceOrDescriptor(l.id)instanceof D.SyncDescriptor){const u=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,u)}p.removeNode(l)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,f,b=[],p,P){if(this._services.get(t)instanceof D.SyncDescriptor)return this._createServiceInstance(f,b,p,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,f,b,p,P);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(t,f=[],b,p){if(b){const P=new w.IdleValue(()=>this._createInstance(t,f,p));return new Proxy(Object.create(null),{get(c,a){if(a in c)return c[a];let l=P.value,s=l[a];return typeof s!="function"||(s=s.bind(l),c[a]=s),s},set(c,a,l){return P.value[a]=l,!0}})}else return this._createInstance(t,f,p)}}e.InstantiationService=y;var E;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(E||(E={}));class m{constructor(t,f){this.type=t,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return d?new m(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(t){return d?new m(0,t.name):m._None}branch(t,f){let b=new m(2,t.toString());return this._dep.push([t,f,b]),b}stop(){let t=Date.now()-this._start;m._totals+=t;let f=!1;function b(P,c){let a=[],l=new Array(P+1).join("	");for(const[s,u,r]of c._dep)if(u&&r){f=!0,a.push(`${l}CREATES -> ${s}`);let i=b(P+1,r);i&&a.push(i)}else a.push(`${l}uses -> ${s}`);return a.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(t>2||f)&&console.log(p.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Z[176],x([0,1,15,130,58]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class k extends D.ResolvedKeybinding{constructor(I,d){super();if(d.length===0)throw(0,w.illegalArgument)("parts");this._os=I,this._parts=d}getLabel(){return R.UILabelProvider.toLabel(this._os,this._parts,I=>this._getLabel(I))}getAriaLabel(){return R.AriaLabelProvider.toLabel(this._os,this._parts,I=>this._getAriaLabel(I))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:R.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,I=>this._getElectronAccelerator(I))}getUserSettingsLabel(){return R.UserSettingsLabelProvider.toLabel(this._os,this._parts,I=>this._getUserSettingsLabel(I))}isWYSIWYG(){return this._parts.every(I=>this._isWYSIWYG(I))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(I=>this._getPart(I))}_getPart(I){return new D.ResolvedKeybindingPart(I.ctrlKey,I.shiftKey,I.altKey,I.metaKey,this._getLabel(I),this._getAriaLabel(I))}getDispatchParts(){return this._parts.map(I=>this._getDispatchPart(I))}getSingleModifierDispatchParts(){return this._parts.map(I=>this._getSingleModifierDispatchPart(I))}}e.BaseResolvedKeybinding=k}),define(Z[177],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class w{constructor(k,n,I,d,g,y,E){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=k,this.keypressParts=k?R(k.getDispatchParts()):[],k&&this.keypressParts.length===0&&(this.keypressParts=R(k.getSingleModifierDispatchParts())),this.bubble=n?n.charCodeAt(0)===94:!1,this.command=this.bubble?n.substr(1):n,this.commandArgs=I,this.when=d,this.isDefault=g,this.extensionId=y,this.isBuiltinExtension=E}}e.ResolvedKeybindingItem=w;function R(D){let k=[];for(let n=0,I=D.length;n<I;n++){const d=D[n];if(!d)return k;k.push(d)}return k}e.removeElementsAfterNulls=R}),define(Z[178],x([0,1,79,58,176,177]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class n extends D.BaseResolvedKeybinding{constructor(d,g){super(g,d.parts)}_keyCodeToUILabel(d){if(this._os===2)switch(d){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return w.KeyCodeUtils.toString(d)}_getLabel(d){return d.isDuplicateModifierCase()?"":this._keyCodeToUILabel(d.keyCode)}_getAriaLabel(d){return d.isDuplicateModifierCase()?"":w.KeyCodeUtils.toString(d.keyCode)}_getElectronAccelerator(d){return w.KeyCodeUtils.toElectronAccelerator(d.keyCode)}_getUserSettingsLabel(d){if(d.isDuplicateModifierCase())return"";const g=w.KeyCodeUtils.toUserSettingsUS(d.keyCode);return g&&g.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(d){return n.getDispatchStr(d)}static getDispatchStr(d){if(d.isModifierKey())return null;let g="";return d.ctrlKey&&(g+="ctrl+"),d.shiftKey&&(g+="shift+"),d.altKey&&(g+="alt+"),d.metaKey&&(g+="meta+"),g+=w.KeyCodeUtils.toString(d.keyCode),g}_getSingleModifierDispatchPart(d){return d.keyCode===5&&!d.shiftKey&&!d.altKey&&!d.metaKey?"ctrl":d.keyCode===4&&!d.ctrlKey&&!d.altKey&&!d.metaKey?"shift":d.keyCode===6&&!d.ctrlKey&&!d.shiftKey&&!d.metaKey?"alt":d.keyCode===57&&!d.ctrlKey&&!d.shiftKey&&!d.altKey?"meta":null}static _scanCodeToKeyCode(d){const g=w.IMMUTABLE_CODE_TO_KEY_CODE[d];if(g!==-1)return g;switch(d){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(d){if(!d)return null;if(d instanceof R.SimpleKeybinding)return d;const g=this._scanCodeToKeyCode(d.scanCode);return g===0?null:new R.SimpleKeybinding(d.ctrlKey,d.shiftKey,d.altKey,d.metaKey,g)}static resolveUserBinding(d,g){const y=(0,k.removeElementsAfterNulls)(d.map(E=>this._resolveSimpleUserBinding(E)));return y.length>0?[new n(new R.ChordKeybinding(y),g)]:[]}}e.USLayoutResolvedKeybinding=n}),define(Z[179],x([0,1,8]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function R(D,k){if(D.length===0)return Promise.resolve(!1);const n=[];let I=!1;for(let d of D){if(d===!0)return Promise.resolve(!0);(0,w.isThenable)(d)&&n.push(d.then(g=>{g&&(I=!0)},g=>{k(g),I=!0}))}return w.Promises.settled(n).then(()=>I)}e.handleVetos=R}),define(Z[6],x([0,1,44,4,2,3,5]),function(q,e,w,R,D,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,n.createDecorator)("logService"),e.ILoggerService=(0,n.createDecorator)("loggerService");function I(){return new Date().toISOString()}var d;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function g(u,r,i){switch(r){case d.Trace:u.trace(i);break;case d.Debug:u.debug(i);break;case d.Info:u.info(i);break;case d.Warning:u.warn(i);break;case d.Error:u.error(i);break;case d.Critical:u.critical(i);break;default:throw new Error("Invalid log level")}}e.log=g;function y(u){let r="";for(let i=0;i<u.length;i++){let o=u[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch(h){}r+=(i>0?" ":"")+o}return r}e.format=y;class E extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class m extends E{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(d.Trace)&&this.log(d.Trace,y([r,...i]))}debug(r,...i){this.checkLogLevel(d.Debug)&&this.log(d.Debug,y([r,...i]))}info(r,...i){this.checkLogLevel(d.Info)&&this.log(d.Info,y([r,...i]))}warn(r,...i){this.checkLogLevel(d.Warning)&&this.log(d.Warning,y([r,...i]))}error(r,...i){if(this.checkLogLevel(d.Error))if(r instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=r.stack,this.log(d.Error,y(o))}else this.log(d.Error,y([r,...i]))}critical(r,...i){this.checkLogLevel(d.Critical)&&this.log(d.Critical,y([r,...i]))}flush(){}}e.AbstractMessageLogger=m;class S extends E{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!k.isWindows}trace(r,...i){this.getLevel()<=d.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}debug(r,...i){this.getLevel()<=d.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}info(r,...i){this.getLevel()<=d.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}warn(r,...i){this.getLevel()<=d.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,r,...i):console.warn(`[main ${I()}]`,r,...i))}error(r,...i){this.getLevel()<=d.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,r,...i):console.error(`[main ${I()}]`,r,...i))}critical(r,...i){this.getLevel()<=d.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,r,...i):console.error(`[main ${I()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class t extends E{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=d.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=d.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=d.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=d.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=d.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=d.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class f extends E{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=d.Trace&&this.adapter.log(d.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=d.Debug&&this.adapter.log(d.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=d.Info&&this.adapter.log(d.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=d.Warning&&this.adapter.log(d.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=d.Error&&this.adapter.log(d.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=d.Critical&&this.adapter.log(d.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,w.toErrorMessage)(r,this.getLevel()<=d.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class b extends E{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const o of this.logServices)o.trace(r,...i)}debug(r,...i){for(const o of this.logServices)o.debug(r,...i)}info(r,...i){for(const o of this.logServices)o.info(r,...i)}warn(r,...i){for(const o of this.logServices)o.warn(r,...i)}error(r,...i){for(const o of this.logServices)o.error(r,...i)}critical(r,...i){for(const o of this.logServices)o.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=b;class p extends D.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=p;class P extends D.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(h=>h.setLevel(o))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let o=this.loggers.get(r.toString());return o||(o=this.doCreateLogger(r,i?.always?d.Trace:this.logLevel,i),this.loggers.set(r.toString(),o),i?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class c{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(r){}getLevel(){return d.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=c;function a(u){if(u.verbose)return d.Trace;if(typeof u.logLevel=="string"){const r=l(u.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function l(u){switch(u){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Critical;case"off":return d.Off}}e.parseLogLevel=l;function s(u){switch(u){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Critical:return"critical";case d.Off:return"off"}}e.LogLevelToString=s});var te=this&&this.__param||function(q,e){return function(w,R){e(w,R,q)}};define(Z[180],x([0,1,8,17,38,78,48,19,5,6]),function(q,e,w,R,D,k,n,I,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var y;(function(m){m.ERROR_INVALID_FILE="ERROR_INVALID_FILE",m.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(y=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,d.createDecorator)(e.UserConfigurationFileServiceId);let E=class{constructor(S,t,f){this.environmentService=S,this.fileService=t,this.logService=f,this.queue=new w.Queue}async updateSettings(S,t){return this.queue.queue(()=>this.doWrite(S,t))}async doWrite(S,t){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),S);const{value:f,mtime:b,etag:p}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let P=f.toString();const c=[];if((0,D.parse)(P,c,{allowTrailingComma:!0,allowEmptyContent:!0}),c.length)throw new Error("ERROR_INVALID_FILE");const a=this.getEdits(S,P,t)[0];if(a){P=P.substring(0,a.offset)+a.content+P.substring(a.offset+a.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,R.VSBuffer.fromString(P),{etag:p,mtime:b})}catch(l){if(l.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(S,t){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,S,t)})}getEdits({value:S,path:t},f,b){return t.length?(0,k.setProperty)(f,t,S,b):[{content:JSON.stringify(S,null,b.insertSpaces&&b.tabSize?" ".repeat(b.tabSize):"	"),length:f.length,offset:0}]}};E=de([te(0,n.IEnvironmentService),te(1,I.IFileService),te(2,g.ILogService)],E),e.UserConfigurationFileService=E}),define(Z[181],x([0,1,30,8,15,4,2,9,62,6]),function(q,e,w,R,D,k,n,I,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends n.Disposable{constructor(m){super();this.logService=m,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}watch(m,S){return S.recursive?this.watchRecursive(m,S):this.watchNonRecursive(m)}watchRecursive(m,S){const t={path:this.toFilePath(m),excludes:S.excludes},f=(0,w.insert)(this.recursiveFoldersToWatch,t);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{f(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(m=>(0,D.onUnexpectedError)(m))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(m=>this._onDidChangeFile.fire((0,d.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(m,S){return m.watch(S)}watchNonRecursive(m){const S=this.createNonRecursiveWatcher(this.toFilePath(m),f=>this._onDidChangeFile.fire((0,d.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===g.LogLevel.Trace),t=this.logService.onDidChangeLogLevel(()=>{S.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)});return(0,n.combinedDisposable)(S,t)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,I.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(Z[182],x([0,1,30,8,17,23,4,69,2,39,10,63,16,59,143,19,91,6]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let P=class Ye extends d.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new n.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new n.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new n.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new n.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new n.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new n.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new n.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new R.ThrottledWorker(Ye.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ye.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ye.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new f.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new R.ThrottledWorker(Ye.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ye.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ye.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new f.FileChangesEvent(l,!0)))),this.watchedResources=g.TernarySearchTree.forUris(l=>{const s=this.getProvider(l.scheme);return s?!this.isPathCaseSensitive(s):!1}),this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(a,l){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:l});const s=new d.DisposableStore;return s.add(l.onDidChangeFile(u=>this.onDidChangeFile(u,this.isPathCaseSensitive(l)))),s.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:a}))),typeof l.onDidWatchError=="function"&&s.add(l.onDidWatchError(u=>this._onDidWatchError.fire(new Error(u)))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:l}),this.provider.delete(a),(0,d.dispose)(s)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(s){l.push(s)}}),!this.provider.has(a)&&await R.Promises.settled(l)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,l){const s=this.provider.get(a.scheme);return!!(s&&s.capabilities&l)}listCapabilities(){return I.Iterable.map(this.provider,([a,l])=>({scheme:a,capabilities:l.capabilities}))}async withProvider(a){if(!(0,m.isAbsolutePath)(a))throw new f.FileOperationError((0,t.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const l=this.provider.get(a.scheme);if(!l){const s=new Error;throw s.name="ENOPRO",s.message=(0,t.localize)(1,null,a.toString()),s}return l}async withReadProvider(a){const l=await this.withProvider(a);if((0,f.hasOpenReadWriteCloseCapability)(l)||(0,f.hasReadWriteCapability)(l)||(0,f.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const l=await this.withProvider(a);if((0,f.hasOpenReadWriteCloseCapability)(l)||(0,f.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,l){try{return await this.doResolveFile(a,l)}catch(s){throw(0,f.toFileSystemProviderErrorCode)(s)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,t.localize)(2,null,this.resourceForError(a)),1):(0,f.ensureFileSystemProviderError)(s)}}async doResolveFile(a,l){const s=await this.withProvider(a),u=this.isPathCaseSensitive(s),r=l?.resolveTo,i=l?.resolveSingleChildDescendants,o=l?.resolveMetadata,h=await s.stat(a);let v;return this.toFileStat(s,a,h,void 0,!!o,(M,A)=>(v||(v=g.TernarySearchTree.forUris(()=>!u),v.set(a,!0),r&&v.fill(!0,r)),v.get(M.resource)||v.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&i?A===1:!1))}async toFileStat(a,l,s,u,r,i){const{providerExtUri:o}=this.getExtUri(a),h={resource:l,name:o.basename(l),isFile:(s.type&f.FileType.File)!=0,isDirectory:(s.type&f.FileType.Directory)!=0,isSymbolicLink:(s.type&f.FileType.SymbolicLink)!=0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&f.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,f.etag)({mtime:s.mtime,size:s.size})};if(h.isDirectory&&i(h,u)){try{const v=await a.readdir(l),M=await R.Promises.settled(v.map(async([A,L])=>{try{const F=o.joinPath(l,A),U=r?await a.stat(F):{type:L};return await this.toFileStat(a,F,U,v.length,r,i)}catch(F){return this.logService.trace(F),null}}));h.children=(0,w.coalesce)(M)}catch(v){this.logService.trace(v),h.children=[]}return h}return h}async resolveAll(a){return R.Promises.settled(a.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async exists(a){const l=await this.withProvider(a);try{return!!await l.stat(a)}catch(s){return!1}}async canCreateFile(a,l){try{await this.doValidateCreateFile(a,l)}catch(s){return s}return!0}async doValidateCreateFile(a,l){if(!l?.overwrite&&await this.exists(a))throw new f.FileOperationError((0,t.localize)(3,null,this.resourceForError(a)),3,l)}async createFile(a,l=D.VSBuffer.fromString(""),s){await this.doValidateCreateFile(a,s);const u=await this.writeFile(a,l);return this._onDidRunOperation.fire(new f.FileOperationEvent(a,0,u)),u}async writeFile(a,l,s){const u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:r}=this.getExtUri(u);try{await this.validateWriteFile(u,a,s)||await this.mkdirp(u,r.dirname(a));let o;if((0,f.hasReadWriteCapability)(u)&&!(l instanceof D.VSBuffer))if((0,S.isReadableStream)(l)){const h=await(0,S.peekStream)(l,3);h.ended?o=D.VSBuffer.concat(h.buffer):o=h}else o=(0,S.peekReadable)(l,h=>D.VSBuffer.concat(h),3);else o=l;!(0,f.hasOpenReadWriteCloseCapability)(u)||(0,f.hasReadWriteCapability)(u)&&o instanceof D.VSBuffer?await this.doWriteUnbuffered(u,a,s,o):await this.doWriteBuffered(u,a,s,o instanceof D.VSBuffer?(0,D.bufferToReadable)(o):o)}catch(i){throw new f.FileOperationError((0,t.localize)(4,null,this.resourceForError(a),(0,f.ensureFileSystemProviderError)(i).toString()),(0,f.toFileOperationResult)(i),s)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,l,s){if(!!s?.unlock&&!(a.capabilities&8192))throw new Error((0,t.localize)(5,null,this.resourceForError(l)));let r;try{r=await a.stat(l)}catch(i){return}if((r.type&f.FileType.Directory)!=0)throw new f.FileOperationError((0,t.localize)(6,null,this.resourceForError(l)),0,s);if(this.throwIfFileIsReadonly(l,r),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==f.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&s.mtime<r.mtime&&s.etag!==(0,f.etag)({mtime:s.mtime,size:r.size}))throw new f.FileOperationError((0,t.localize)(7,null),3,s);return r}async readFile(a,l){const s=await this.withReadProvider(a);return l?.atomic?this.doReadFileAtomic(s,a,l):this.doReadFile(s,a,l)}async doReadFileAtomic(a,l,s){return new Promise((u,r)=>{this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{try{const i=await this.doReadFile(a,l,s);u(i)}catch(i){r(i)}})})}async doReadFile(a,l,s){const u=await this.doReadFileStream(a,l,{...s,preferUnbuffered:!0});return{...u,value:await(0,D.streamToBuffer)(u.value)}}async readFileStream(a,l){const s=await this.withReadProvider(a);return this.doReadFileStream(s,a,l)}async doReadFileStream(a,l,s){const u=new k.CancellationTokenSource,r=this.validateReadFile(l,s).then(o=>o,o=>{throw u.cancel(),o});let i;try{return typeof s?.etag=="string"&&s.etag!==f.ETAG_DISABLED&&await r,!((0,f.hasOpenReadWriteCloseCapability)(a)||(0,f.hasFileReadStreamCapability)(a))||(0,f.hasReadWriteCapability)(a)&&s?.preferUnbuffered?i=this.readFileUnbuffered(a,l,s):(0,f.hasFileReadStreamCapability)(a)?i=this.readFileStreamed(a,l,u.token,s):i=this.readFileBuffered(a,l,u.token,s),{...await r,value:i}}catch(o){i&&await(0,S.consumeStream)(i);const h=(0,t.localize)(8,null,this.resourceForError(l),(0,f.ensureFileSystemProviderError)(o).toString());throw o instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(h,o.stat,s):new f.FileOperationError(h,(0,f.toFileOperationResult)(o),s)}}readFileStreamed(a,l,s,u=Object.create(null)){const r=a.readFileStream(l,u,s);return(0,S.transform)(r,{data:i=>i instanceof D.VSBuffer?i:D.VSBuffer.wrap(i),error:i=>new f.FileOperationError((0,t.localize)(9,null,this.resourceForError(l),(0,f.ensureFileSystemProviderError)(i).toString()),(0,f.toFileOperationResult)(i),u)},i=>D.VSBuffer.concat(i))}readFileBuffered(a,l,s,u=Object.create(null)){const r=(0,D.newWriteableBufferStream)();return(0,b.readFileIntoStream)(a,l,r,i=>i,{...u,bufferSize:this.BUFFER_SIZE,errorTransformer:i=>new f.FileOperationError((0,t.localize)(10,null,this.resourceForError(l),(0,f.ensureFileSystemProviderError)(i).toString()),(0,f.toFileOperationResult)(i),u)},s),r}readFileUnbuffered(a,l,s){const u=(0,S.newWriteableStream)(r=>D.VSBuffer.concat(r));return(async()=>{try{let r=await a.readFile(l);typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.validateReadFileLimits(l,r.byteLength,s),u.end(D.VSBuffer.wrap(r))}catch(r){u.error(r),u.end()}})(),u}async validateReadFile(a,l){const s=await this.resolve(a,{resolveMetadata:!0});if(s.isDirectory)throw new f.FileOperationError((0,t.localize)(11,null,this.resourceForError(a)),0,l);if(typeof l?.etag=="string"&&l.etag!==f.ETAG_DISABLED&&l.etag===s.etag)throw new f.NotModifiedSinceFileOperationError((0,t.localize)(12,null),s,l);return this.validateReadFileLimits(a,s.size,l),s}validateReadFileLimits(a,l,s){if(s?.limits){let u;if(typeof s.limits.memory=="number"&&l>s.limits.memory&&(u=9),typeof s.limits.size=="number"&&l>s.limits.size&&(u=7),typeof u=="number")throw new f.FileOperationError((0,t.localize)(13,null,this.resourceForError(a)),u)}}async canMove(a,l,s){return this.doCanMoveCopy(a,l,"move",s)}async canCopy(a,l,s){return this.doCanMoveCopy(a,l,"copy",s)}async doCanMoveCopy(a,l,s,u){if(a.toString()!==l.toString())try{const r=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(r,a,i,l,s,u)}catch(r){return r}return!0}async move(a,l,s){const u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=await this.doMoveCopy(u,a,r,l,"move",!!s),o=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(a,i==="move"?2:3,o)),o}async copy(a,l,s){const u=await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=await this.doMoveCopy(u,a,r,l,"copy",!!s),o=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(a,i==="copy"?3:2,o)),o}async doMoveCopy(a,l,s,u,r,i){if(l.toString()===u.toString())return r;const{exists:o,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(a,l,s,u,r,i);if(o&&!h&&i&&await this.del(u,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(u)),r==="copy"){if(a===s&&(0,f.hasFileFolderCopyCapability)(a))await a.copy(l,u,{overwrite:i});else{const v=await this.resolve(l);v.isDirectory?await this.doCopyFolder(a,v,s,u):await this.doCopyFile(a,l,s,u)}return r}else return a===s?(await a.rename(l,u,{overwrite:i}),r):(await this.doMoveCopy(a,l,s,u,"copy",i),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(a,l,s,u){if((0,f.hasOpenReadWriteCloseCapability)(a)&&(0,f.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(a,l,s,u);if((0,f.hasOpenReadWriteCloseCapability)(a)&&(0,f.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(a,l,s,u);if((0,f.hasReadWriteCapability)(a)&&(0,f.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(a,l,s,u);if((0,f.hasReadWriteCapability)(a)&&(0,f.hasReadWriteCapability)(s))return this.doPipeUnbuffered(a,l,s,u)}async doCopyFolder(a,l,s,u){await s.mkdir(u),Array.isArray(l.children)&&await R.Promises.settled(l.children.map(async r=>{const i=this.getExtUri(s).providerExtUri.joinPath(u,r.name);return r.isDirectory?this.doCopyFolder(a,await this.resolve(r.resource),s,i):this.doCopyFile(a,r.resource,s,i)}))}async doValidateMoveCopy(a,l,s,u,r,i){let o=!1;if(a===s){const{providerExtUri:v,isPathCaseSensitive:M}=this.getExtUri(a);if(M||(o=v.isEqual(l,u)),o&&r==="copy")throw new Error((0,t.localize)(14,null,this.resourceForError(l),this.resourceForError(u)));if(!o&&v.isEqualOrParent(u,l))throw new Error((0,t.localize)(15,null,this.resourceForError(l),this.resourceForError(u)))}const h=await this.exists(u);if(h&&!o){if(!i)throw new f.FileOperationError((0,t.localize)(16,null,this.resourceForError(l),this.resourceForError(u)),4);if(a===s){const{providerExtUri:v}=this.getExtUri(a);if(v.isEqualOrParent(l,u))throw new Error((0,t.localize)(17,null,this.resourceForError(l),this.resourceForError(u)))}}return{exists:h,isSameResourceWithDifferentPathCase:o}}getExtUri(a){const l=this.isPathCaseSensitive(a);return{providerExtUri:l?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(l,a);const s=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(a,0,s)),s}async mkdirp(a,l){const s=[],{providerExtUri:u}=this.getExtUri(a);for(;!u.isEqual(l,u.dirname(l));)try{if(((await a.stat(l)).type&f.FileType.Directory)==0)throw new Error((0,t.localize)(18,null,this.resourceForError(l)));break}catch(r){if((0,f.toFileSystemProviderErrorCode)(r)!==f.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(u.basename(l)),l=u.dirname(l)}for(let r=s.length-1;r>=0;r--){l=u.joinPath(l,s[r]);try{await a.mkdir(l)}catch(i){if((0,f.toFileSystemProviderErrorCode)(i)!==f.FileSystemProviderErrorCode.FileExists)throw i}}}async canDelete(a,l){try{await this.doValidateDelete(a,l)}catch(s){return s}return!0}async doValidateDelete(a,l){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!l?.useTrash&&!(s.capabilities&4096))throw new Error((0,t.localize)(19,null,this.resourceForError(a)));let r;try{r=await s.stat(a)}catch(o){}if(r)this.throwIfFileIsReadonly(a,r);else throw new f.FileOperationError((0,t.localize)(20,null,this.resourceForError(a)),1);if(!!!l?.recursive){const o=await this.resolve(a);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,t.localize)(21,null,this.resourceForError(a)))}return s}async del(a,l){const s=await this.doValidateDelete(a,l),u=!!l?.useTrash,r=!!l?.recursive;await s.delete(a,{recursive:r,useTrash:u}),this._onDidRunOperation.fire(new f.FileOperationEvent(a,1))}onDidChangeFile(a,l){this._onDidChangeFilesRaw.fire({changes:a});let s,u;{for(const r of a)this.watchedResources.has(r.resource)?(s||(s=[]),s.push(r)):(u||(u=[]),u.push(r));s&&this._onDidFilesChange.fire(new f.FileChangesEvent(s,!l))}if(u){const r=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(u)&&Ye.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${u[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,l={recursive:!1,excludes:[]}){const s=new d.DisposableStore;let u=!1,r=()=>{u=!0};return s.add((0,d.toDisposable)(()=>r())),this.doWatch(a,l).then(i=>{u?(0,d.dispose)(i):r=()=>(0,d.dispose)(i)},i=>this.logService.error(i)),l.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),s.add((0,d.toDisposable)(()=>{const i=this.watchedResources.get(a);typeof i=="number"&&(i<=1?this.watchedResources.delete(a):this.watchedResources.set(a,i-1))}))),s}async doWatch(a,l){const s=await this.withProvider(a),u=this.toWatchKey(s,a,l);let r=this.activeWatchers.get(u);return r||(r={count:0,disposable:s.watch(a,l)},this.activeWatchers.set(u,r)),r.count+=1,(0,d.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,d.dispose)(r.disposable),this.activeWatchers.delete(u)))})}toWatchKey(a,l,s){const{providerExtUri:u}=this.getExtUri(a);return[u.getComparisonKey(l),String(s.recursive),s.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,d.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,l,s,u){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{const r=await a.open(l,{create:!0,unlock:s?.unlock??!1});try{(0,S.isReadableStream)(u)||(0,S.isReadableBufferedStream)(u)?await this.doWriteStreamBufferedQueued(a,r,u):await this.doWriteReadableBufferedQueued(a,r,u)}catch(i){throw(0,f.ensureFileSystemProviderError)(i)}finally{await a.close(r)}})}async doWriteStreamBufferedQueued(a,l,s){let u=0,r;if((0,S.isReadableBufferedStream)(s)){if(s.buffer.length>0){const i=D.VSBuffer.concat(s.buffer);await this.doWriteBuffer(a,l,i,i.byteLength,u,0),u+=i.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((i,o)=>{(0,S.listenStream)(r,{onData:async h=>{r.pause();try{await this.doWriteBuffer(a,l,h,h.byteLength,u,0)}catch(v){return o(v)}u+=h.byteLength,setTimeout(()=>r.resume())},onError:h=>o(h),onEnd:()=>i()})})}async doWriteReadableBufferedQueued(a,l,s){let u=0,r;for(;(r=s.read())!==null;)await this.doWriteBuffer(a,l,r,r.byteLength,u,0),u+=r.byteLength}async doWriteBuffer(a,l,s,u,r,i){let o=0;for(;o<u;)o+=await a.write(l,r+o,s.buffer,i+o,u-o)}async doWriteUnbuffered(a,l,s,u){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,l,s,u))}async doWriteUnbufferedQueued(a,l,s,u){let r;u instanceof D.VSBuffer?r=u:(0,S.isReadableStream)(u)?r=await(0,D.streamToBuffer)(u):(0,S.isReadableBufferedStream)(u)?r=await(0,D.bufferedStreamToBuffer)(u):r=(0,D.readableToBuffer)(u),await a.writeFile(l,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(a,l,s,u){return this.writeQueue.queueFor(u,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,l,s,u))}async doPipeBufferedQueued(a,l,s,u){let r,i;try{r=await a.open(l,{create:!1}),i=await s.open(u,{create:!0,unlock:!1});const o=D.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,v=0,M=0;do M=await a.read(r,h,o.buffer,v,o.byteLength-v),await this.doWriteBuffer(s,i,o,M,h,v),h+=M,v+=M,v===o.byteLength&&(v=0);while(M>0)}catch(o){throw(0,f.ensureFileSystemProviderError)(o)}finally{await R.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof i=="number"?s.close(i):Promise.resolve()])}}async doPipeUnbuffered(a,l,s,u){return this.writeQueue.queueFor(u,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,l,s,u))}async doPipeUnbufferedQueued(a,l,s,u){return s.writeFile(u,await a.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,l,s,u){return this.writeQueue.queueFor(u,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,l,s,u))}async doPipeUnbufferedToBufferedQueued(a,l,s,u){const r=await s.open(u,{create:!0,unlock:!1});try{const i=await a.readFile(l);await this.doWriteBuffer(s,r,D.VSBuffer.wrap(i),i.byteLength,0,0)}catch(i){throw(0,f.ensureFileSystemProviderError)(i)}finally{await s.close(r)}}async doPipeBufferedToUnbuffered(a,l,s,u){const r=await(0,D.streamToBuffer)(this.readFileBuffered(a,l,k.CancellationToken.None));await this.doWriteUnbuffered(s,u,void 0,r)}throwIfFileSystemIsReadonly(a,l){if(a.capabilities&2048)throw new f.FileOperationError((0,t.localize)(22,null,this.resourceForError(l)),6);return a}throwIfFileIsReadonly(a,l){if((l.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,t.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===y.Schemas.file?a.fsPath:a.toString(!0)}};P.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},P=de([te(0,p.ILogService)],P),e.FileService=P}),define(Z[183],x([0,1,14,146,3,7,19,92,9,2,62,6,168,111]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class t extends m.AbstractDiskFileSystemProviderChannel{constructor(p,P){super(p,P)}getUriTransformer(p){return S.DefaultURITransformer}transformIncoming(p,P){return k.URI.revive(P)}async delete(p,P,c){if(!c.useTrash)return super.delete(p,P,c);const a=this.transformIncoming(p,P),l=(0,d.normalize)(a.fsPath);try{await w.shell.trashItem(l)}catch(s){throw(0,n.createFileSystemProviderError)(D.isWindows?(0,R.localize)(0,null,(0,d.basename)(l)):(0,R.localize)(1,null,(0,d.basename)(l)),n.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(p,P){return new f(P,this.logService)}}e.DiskFileSystemProviderChannel=t;class f extends g.Disposable{constructor(p,P){super();this.sessionEmitter=p,this.logService=P,this.watcherRequests=new Map}watch(p,P,c){if(c.recursive)throw(0,n.createFileSystemProviderError)("Recursive watcher is not supported from main process",n.FileSystemProviderErrorCode.Unavailable);const a=new g.DisposableStore;this.watcherRequests.set(p,a),a.add((0,g.toDisposable)(()=>this.watcherRequests.delete(p)));const l=a.add(new I.NodeJSFileWatcher((0,d.normalize)(P.fsPath),s=>this.sessionEmitter.fire((0,y.toFileChanges)(s)),s=>this.onWatcherLogMessage(s),this.logService.getLevel()===E.LogLevel.Trace));return a.add(this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})),a}onWatcherLogMessage(p){p.type==="error"&&this.sessionEmitter.fire(p.message),this.logService[p.type](p.message)}dispose(){super.dispose(),this.watcherRequests.forEach(p=>(0,g.dispose)(p)),this.watcherRequests.clear()}}}),define(Z[93],x([0,1,27,249,8,17,4,32,9,3,16,59,21,147,19,91,92,174,181,44]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b,p,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(w)}catch(l){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(l)}`)}})();class a extends P.AbstractDiskFileSystemProvider{constructor(s,u){super(s);this.options=u,this.onDidChangeCapabilities=n.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,g.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:u,symbolicLink:r}=await m.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(u,r),ctime:u.birthtime.getTime(),mtime:u.mtime.getTime(),size:u.size}}catch(u){throw this.toFileSystemProviderError(u)}}async readdir(s){try{const u=await m.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),r=[];return await Promise.all(u.map(async i=>{try{let o;i.isSymbolicLink()?o=(await this.stat((0,y.joinPath)(s,i.name))).type:o=this.toType(i),r.push([i.name,o])}catch(o){this.logService.trace(o)}})),r}catch(u){throw this.toFileSystemProviderError(u)}}toType(s,u){let r;return u?.dangling?r=t.FileType.Unknown:s.isFile()?r=t.FileType.File:s.isDirectory()?r=t.FileType.Directory:r=t.FileType.Unknown,u&&(r|=t.FileType.SymbolicLink),r}async readFile(s){try{const u=this.toFilePath(s);return await m.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}}readFileStream(s,u,r){const i=(0,E.newWriteableStream)(o=>k.VSBuffer.concat(o.map(h=>k.VSBuffer.wrap(h))).buffer);return(0,f.readFileIntoStream)(this,s,i,o=>o.buffer,{...u,bufferSize:256*1024},r),i}async writeFile(s,u,r){let i;try{const o=this.toFilePath(s);if(!r.create||!r.overwrite){if(await m.Promises.exists(o)){if(!r.overwrite)throw(0,t.createFileSystemProviderError)((0,S.localize)(0,null),t.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,t.createFileSystemProviderError)((0,S.localize)(1,null),t.FileSystemProviderErrorCode.FileNotFound)}i=await this.open(s,{create:!0,unlock:r.unlock}),await this.write(i,0,u,0,u.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(s,o)}finally{typeof i=="number"&&await this.close(i)}}async open(s,u){try{const r=this.toFilePath(s);if((0,t.isFileOpenForWriteOptions)(u)&&u.unlock)try{const{stat:h}=await m.SymlinkSupport.stat(r);h.mode&128||await m.Promises.chmod(r,h.mode|128)}catch(h){this.logService.trace(h)}let i;if((0,t.isFileOpenForWriteOptions)(u)){if(g.isWindows)try{await m.Promises.truncate(r,0),i="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}i||(i="w")}else i="r";const o=await m.Promises.open(r,i);return this.mapHandleToPos.set(o,0),(0,t.isFileOpenForWriteOptions)(u)&&this.writeHandles.set(o,s),o}catch(r){throw(0,t.isFileOpenForWriteOptions)(u)?await this.toFileSystemProviderWriteError(s,r):this.toFileSystemProviderError(r)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await m.Promises.fdatasync(s)}catch(u){this.canFlush=!1,this.logService.error(u)}return await m.Promises.close(s)}catch(u){throw this.toFileSystemProviderError(u)}}async read(s,u,r,i,o){const h=this.normalizePos(s,u);let v=null;try{const M=await m.Promises.read(s,r,i,o,h);return typeof M=="number"?v=M:v=M.bytesRead,v}catch(M){throw this.toFileSystemProviderError(M)}finally{this.updatePos(s,h,v)}}normalizePos(s,u){return u===this.mapHandleToPos.get(s)?null:u}updatePos(s,u,r){const i=this.mapHandleToPos.get(s);typeof i=="number"&&(typeof u=="number"||(typeof r=="number"?this.mapHandleToPos.set(s,i+r):this.mapHandleToPos.delete(s)))}async write(s,u,r,i,o){return(0,D.retry)(()=>this.doWrite(s,u,r,i,o),100,3)}async doWrite(s,u,r,i,o){const h=this.normalizePos(s,u);let v=null;try{const M=await m.Promises.write(s,r,i,o,h);return typeof M=="number"?v=M:v=M.bytesWritten,v}catch(M){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),M)}finally{this.updatePos(s,h,v)}}async mkdir(s){try{await m.Promises.mkdir(this.toFilePath(s))}catch(u){throw this.toFileSystemProviderError(u)}}async delete(s,u){try{const r=this.toFilePath(s);u.recursive?await m.Promises.rm(r,m.RimRafMode.MOVE):await m.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(s,u,r){const i=this.toFilePath(s),o=this.toFilePath(u);if(i!==o)try{await this.validateTargetDeleted(s,u,"move",r.overwrite),await m.Promises.move(i,o)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(2,null,(0,d.basename)(i),(0,d.basename)((0,d.dirname)(o)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(s,u,r){const i=this.toFilePath(s),o=this.toFilePath(u);if(i!==o)try{await this.validateTargetDeleted(s,u,"copy",r.overwrite),await m.Promises.copy(i,o,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(3,null,(0,d.basename)(i),(0,d.basename)((0,d.dirname)(o)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(s,u,r,i){const o=this.toFilePath(s),h=this.toFilePath(u);let v=!1;if(!!(this.capabilities&1024)||(v=(0,I.isEqual)(o,h,!0)),v&&r==="copy")throw(0,t.createFileSystemProviderError)((0,S.localize)(4,null),t.FileSystemProviderErrorCode.FileExists);if(!v&&await m.Promises.exists(h)){if(!i)throw(0,t.createFileSystemProviderError)((0,S.localize)(5,null),t.FileSystemProviderErrorCode.FileExists);await this.delete(u,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(s,u,r){return new p.ParcelWatcherClient(i=>s(i),i=>u(i),r)}doWatch(s,u){const r=this.options?.watcher?.usePolling;if(r===!0)for(const i of u)i.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(r))for(const i of u)r.includes(i.path)&&(i.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(s,u)}createNonRecursiveWatcher(s,u,r,i){return new b.NodeJSFileWatcher(s,o=>u(o),o=>r(o),i)}toFileSystemProviderError(s){if(s instanceof t.FileSystemProviderError)return s;let u;switch(s.code){case"ENOENT":u=t.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":u=t.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":u=t.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":u=t.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":u=t.FileSystemProviderErrorCode.NoPermissions;break;default:u=t.FileSystemProviderErrorCode.Unknown}return(0,t.createFileSystemProviderError)(s,u)}async toFileSystemProviderWriteError(s,u){let r=this.toFileSystemProviderError(u);if(s&&r.code===t.FileSystemProviderErrorCode.NoPermissions)try{const{stat:i}=await m.SymlinkSupport.stat(this.toFilePath(s));i.mode&128||(r=(0,t.createFileSystemProviderError)(u,t.FileSystemProviderErrorCode.FileWriteLocked))}catch(i){this.logService.trace(i)}return r}}e.DiskFileSystemProvider=a}),define(Z[94],x([0,1,6]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function R(k,n){switch(n){case w.LogLevel.Trace:return k.trace;case w.LogLevel.Debug:return k.debug;case w.LogLevel.Info:return k.info;case w.LogLevel.Warning:return k.warn;case w.LogLevel.Error:return k.error;case w.LogLevel.Critical:return k.critical;default:throw new Error("Invalid log level")}}class D extends w.AbstractLogger{constructor(n=w.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(n),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}set logger(n){this._logger=n;for(const{level:I,args:d}of this.buffer)R(n,I).apply(n,d);this.buffer=[]}_log(n,...I){this._logger?R(this._logger,n).apply(this._logger,I):this.getLevel()<=n&&this.buffer.push({level:n,args:I})}trace(n,...I){this._log(w.LogLevel.Trace,n,...I)}debug(n,...I){this._log(w.LogLevel.Debug,n,...I)}info(n,...I){this._log(w.LogLevel.Info,n,...I)}warn(n,...I){this._log(w.LogLevel.Warning,n,...I)}error(n,...I){this._log(w.LogLevel.Error,n,...I)}critical(n,...I){this._log(w.LogLevel.Critical,n,...I)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(Z[184],x([0,1,8,17,16,19,5,94,6]),function(q,e,w,R,D,k,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const g=5*k.ByteSize.MB;let y=class extends d.AbstractLogger{constructor(S,t,f,b,p){super();this.name=S,this.resource=t,this.donotUseFormatters=b,this.fileService=p,this.backupIndex=1,this.setLevel(f),this.queue=this._register(new w.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=d.LogLevel.Trace&&this._log(d.LogLevel.Trace,(0,d.format)(arguments))}debug(){this.getLevel()<=d.LogLevel.Debug&&this._log(d.LogLevel.Debug,(0,d.format)(arguments))}info(){this.getLevel()<=d.LogLevel.Info&&this._log(d.LogLevel.Info,(0,d.format)(arguments))}warn(){this.getLevel()<=d.LogLevel.Warning&&this._log(d.LogLevel.Warning,(0,d.format)(arguments))}error(){if(this.getLevel()<=d.LogLevel.Error){const S=arguments[0];if(S instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=S.stack,this._log(d.LogLevel.Error,(0,d.format)(t))}else this._log(d.LogLevel.Error,(0,d.format)(arguments))}}critical(){this.getLevel()<=d.LogLevel.Critical&&this._log(d.LogLevel.Critical,(0,d.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(S){if(S.fileOperationResult!==3)throw S}}_log(S,t){this.queue.queue(async()=>{await this.initializePromise;let f=await this.loadContent();f.length>g&&(await this.fileService.writeFile(this.getBackupResource(),R.VSBuffer.fromString(f)),f=""),this.donotUseFormatters?f+=t:f+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(S)}] ${t}
`,await this.fileService.writeFile(this.resource,R.VSBuffer.fromString(f))})}getCurrentTimestamp(){const S=b=>b<10?`0${b}`:b,t=b=>b<10?`00${b}`:b<100?`0${b}`:b,f=new Date;return`${f.getFullYear()}-${S(f.getMonth()+1)}-${S(f.getDate())} ${S(f.getHours())}:${S(f.getMinutes())}:${S(f.getSeconds())}.${t(f.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(S){return""}}stringifyLogLevel(S){switch(S){case d.LogLevel.Critical:return"critical";case d.LogLevel.Debug:return"debug";case d.LogLevel.Error:return"error";case d.LogLevel.Info:return"info";case d.LogLevel.Trace:return"trace";case d.LogLevel.Warning:return"warning"}return""}};y=de([te(4,k.IFileService)],y),e.FileLogger=y;let E=class extends d.AbstractLoggerService{constructor(S,t,f){super(S.getLevel(),S.onDidChangeLogLevel);this.instantiationService=t,this.fileService=f}doCreateLogger(S,t,f){const b=new I.BufferLogService(t);return(0,k.whenProviderRegistered)(S,this.fileService).then(()=>b.logger=this.instantiationService.createInstance(y,f?.name||(0,D.basename)(S),S,b.getLevel(),!!f?.donotUseFormatters)),b}};E=de([te(0,d.ILogService),te(1,n.IInstantiationService),te(2,k.IFileService)],E),e.FileLoggerService=E}),define(Z[185],x([0,1,4,7,6]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(m){this.service=m,this.onDidChangeLogLevel=w.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(m,S,t){switch(S){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=k;class n{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){n.setLevel(this.channel,m)}static setLevel(m,S){return m.call("setLevel",S)}}e.LogLevelChannelClient=n;class I{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,S){throw new Error(`Event not found: ${S}`)}async call(m,S,t){switch(S){case"createLogger":this.createLogger(R.URI.revive(t[0]),t[1]);return;case"log":return this.log(R.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${S}`)}createLogger(m,S){this.loggers.set(m.toString(),this.loggerService.createLogger(m,S))}consoleLog(m,S){let t=console.log;switch(m){case D.LogLevel.Error:t=console.error;break;case D.LogLevel.Warning:t=console.warn;break;case D.LogLevel.Info:t=console.info;break}t.call(console,...S)}log(m,S){const t=this.loggers.get(m.toString());if(!t)throw new Error("Create the logger before logging");for(const[f,b]of S)(0,D.log)(t,f,b)}}e.LoggerChannel=I;class d extends D.AbstractLoggerService{constructor(m,S,t){super(m,S);this.channel=t}createConsoleMainLogger(){return new D.AdapterLogger({log:(m,S)=>{this.channel.call("consoleLog",[m,S])}})}doCreateLogger(m,S,t){return new g(this.channel,m,S,t)}}e.LoggerChannelClient=d;class g extends D.AbstractMessageLogger{constructor(m,S,t,f){super(f?.always);this.channel=m,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[S,f]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,S){const t=[[m,S]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(m){this.channel.call("log",[this.file,m])}}class y extends D.LogService{constructor(m,S){super(S);this.parent=m,this._register(m.onDidChangeLogLevel(t=>S.setLevel(t)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=y}),define(Z[95],x([0,1,19,6]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(I,d,g,y,E){try{const m=await new Promise((t,f)=>{q(["spdlog"],t,f)});m.setFlushOn(R.LogLevel.Trace);const S=await m.createAsyncRotatingLogger(I,d,g,y);return E&&S.clearFormatters(),S}catch(m){console.error(m)}return null}function k(I,d,g){switch(d){case R.LogLevel.Trace:I.trace(g);break;case R.LogLevel.Debug:I.debug(g);break;case R.LogLevel.Info:I.info(g);break;case R.LogLevel.Warning:I.warn(g);break;case R.LogLevel.Error:I.error(g);break;case R.LogLevel.Critical:I.critical(g);break;default:throw new Error("Invalid log level")}}class n extends R.AbstractMessageLogger{constructor(d,g,y,E,m){super();this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(d,g,y,E),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}async _createSpdLogLogger(d,g,y,E){const m=y?6:1,S=30/m*w.ByteSize.MB,t=await D(d,g,S,m,E);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:f,message:b}of this.buffer)k(this._logger,f,b);this.buffer=[]}}log(d,g){this._logger?k(this._logger,d,g):this.getLevel()<=d&&this.buffer.push({level:d,message:g})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(Z[186],x([0,1,10,16,31,19,184,6,95]),function(q,e,w,R,D,k,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let g=class extends I.AbstractLoggerService{constructor(E,m){super(E.getLevel(),E.onDidChangeLogLevel);this.fileService=m}doCreateLogger(E,m,S){return E.scheme===w.Schemas.file?new d.SpdLogLogger(S?.name||(0,D.generateUuid)(),E.fsPath,!S?.donotRotate,!!S?.donotUseFormatters,m):new n.FileLogger(S?.name??(0,R.basename)(E),E,m,!!S?.donotUseFormatters,this.fileService)}};g=de([te(0,I.ILogService),te(1,k.IFileService)],g),e.LoggerService=g}),define(Z[187],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function w(n){return n.submenu!==void 0}e.isMenubarMenuItemSubmenu=w;function R(n){return n.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=R;function D(n){return n.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function k(n){return!w(n)&&!R(n)&&!D(n)}e.isMenubarMenuItemAction=k}),define(Z[54],x([0,1,10,3,34,16]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const I=R.globals.vscode.context.configuration();if(I)n=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof q?.__$__nodeRequire=="function"){const I=(0,k.dirname)(w.FileAccess.asFileUri("",q));n=q.__$__nodeRequire((0,k.joinPath)(I,"product.json").fsPath);const d=q.__$__nodeRequire((0,k.joinPath)(I,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`}),Object.assign(n,{version:d.version})}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=n}),define(Z[22],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService")}),define(Z[188],x([0,1,60,6,22]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let k=class{constructor(I,d){this.productService=I,this.logService=d,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(I,d){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const g=/^(.*)#([^#]+)$/.exec(d);if(!g)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",d),!1;const[,y,E]=g;let m=this.trustedExtensionUrlPublicKeys.get(I);if(!m){if(m=this.productService.trustedExtensionUrlPublicKeys[I],!m||m.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.trustedExtensionUrlPublicKeys.set(I,[...m])}const S=Buffer.from(decodeURIComponent(E),"base64");if(S.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",d),!1;const t=S.slice(0,6),f=S.readUIntBE(0,6),b=Date.now()-f;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",d),!1;const p=S.slice(6),P=w.createVerify("SHA256");P.write(t),P.write(Buffer.from(y)),P.end();for(let c=0;c<m.length;c++){let a=m[c];if(a!==null){if(typeof a=="string")try{a=w.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),m[c]=a}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${I}:`,l),m[c]=null;continue}if(P.verify(a,p))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",d),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",d),!1}};k=de([te(0,D.IProductService),te(1,R.ILogService)],k),e.ExtensionUrlTrustService=k}),define(Z[55],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,w.createDecorator)("protocolMainService")}),define(Z[189],x([0,1,14,2,39,10,3,16,7,31,48,6]),function(q,e,w,R,D,k,n,I,d,g,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let m=class extends R.Disposable{constructor(t,f){super();this.logService=f,this.validRoots=D.TernarySearchTree.forUris(()=>!n.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(d.URI.file(t.appRoot)),this.addValidFileRoot(d.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=w.session;t.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(f,b)=>this.handleResourceRequest(f,b)),t.protocol.interceptFileProtocol(k.Schemas.file,(f,b)=>this.handleFileRequest(f,b)),this._register((0,R.toDisposable)(()=>{t.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?R.Disposable.None:(this.validRoots.set(t,!0),(0,R.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,f){const b=d.URI.parse(t.url);return this.logService.error(`Refused to load resource ${b.fsPath} from ${k.Schemas.file}: protocol (original URL: ${t.url})`),f({error:-3})}handleResourceRequest(t,f){const b=d.URI.parse(t.url),p=k.FileAccess.asFileUri(b);return this.validRoots.findSubstr(p)?f({path:p.fsPath}):this.validExtensions.has((0,I.extname)(p))?f({path:p.fsPath}):(this.logService.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${p.fsPath} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),f({error:-3}))}createIPCObjectUrl(){let t;const f=d.URI.from({scheme:"vscode",path:(0,g.generateUuid)()}),b=f.toString(),p=async()=>t;return w.ipcMain.handle(b,p),this.logService.trace(`IPC Object URL: Registered new channel ${b}.`),{resource:f,update:P=>t=P,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${b}.`),w.ipcMain.removeHandler(b)}}}};m=de([te(0,y.INativeEnvironmentService),te(1,E.ILogService)],m),e.ProtocolMainService=m}),define(Z[40],x([0,1,103,13]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(n,I){w.ok(R.isString(n)),w.ok(R.isObject(I)),w.ok(!this.data.has(n),"There is already an extension with this id"),this.data.set(n,I)}knows(n){return this.data.has(n)}as(n){return this.data.get(n)||null}}e.Registry=new D}),define(Z[190],x([0,1,4,40]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class k{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,g){this.schemasById[D(d)]=g,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const n=new k;R.Registry.add(e.Extensions.JSONContribution,n)}),define(Z[56],x([0,1,30,4,13,135,190,40]),function(q,e,w,R,D,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(d=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var g;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=I.Registry.as(n.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,s=!0){this.registerConfigurations([l],s)}registerConfigurations(l,s=!0){const u=this.doRegisterConfigurations(l,s);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}deregisterConfigurations(l){const s=this.doDeregisterConfigurations(l);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:l,remove:s}){const u=[];u.push(...this.doDeregisterConfigurations(s)),u.push(...this.doRegisterConfigurations(l,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,w.distinct)(u)})}registerDefaultConfigurations(l){const s=[],u=[];for(const{overrides:r,source:i}of l)for(const o in r)if(s.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const h={...this.configurationDefaultsOverrides.get(o)?.value||{},...r[o]};this.configurationDefaultsOverrides.set(o,{source:i,value:h});const v={type:"object",default:h,description:k.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:D.isString(i)?void 0:i};u.push(...t(o)),this.configurationProperties[o]=v,this.defaultLanguageConfigurationOverridesNode.properties[o]=v}else{this.configurationDefaultsOverrides.set(o,{value:r[o],source:i});const h=this.configurationProperties[o];h&&(this.updatePropertyDefaultValue(o,h),this.updateSchema(o,h))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const s=[];for(const{overrides:u,source:r}of l)for(const i in u){const o=this.configurationDefaultsOverrides.get(i),h=D.isString(r)?r:r?.id,v=D.isString(o?.source)?o?.source:o?.source?.id;if(h===v)if(s.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const M=this.configurationProperties[i];M&&(this.updatePropertyDefaultValue(i,M),this.updateSchema(i,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const s of l)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,s){const u=[];return l.forEach(r=>{u.push(...this.validateAndRegisterProperties(r,s,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),u}doDeregisterConfigurations(l){const s=[],u=r=>{if(r.properties)for(const i in r.properties)s.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>u(i))};for(const r of l){u(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return s}validateAndRegisterProperties(l,s=!0,u,r,i=3){i=D.isUndefinedOrNull(l.scope)?i:l.scope;let o=[],h=l.properties;if(h)for(let M in h){if(s&&P(M)){delete h[M];continue}const A=h[M];if(A.source=u,A.defaultDefaultValue=h[M].default,this.updatePropertyDefaultValue(M,A),e.OVERRIDE_PROPERTY_REGEX.test(M)?A.scope=void 0:(A.scope=D.isUndefinedOrNull(A.scope)?i:A.scope,A.restricted=D.isUndefinedOrNull(A.restricted)?!!r?.includes(M):A.restricted),h[M].hasOwnProperty("included")&&!h[M].included){this.excludedConfigurationProperties[M]=h[M],delete h[M];continue}else this.configurationProperties[M]=h[M];!h[M].deprecationMessage&&h[M].markdownDeprecationMessage&&(h[M].deprecationMessage=h[M].markdownDeprecationMessage),o.push(M)}let v=l.allOf;if(v)for(let M of v)o.push(...this.validateAndRegisterProperties(M,s,u,r,i));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const s=u=>{let r=u.properties;if(r)for(const o in r)this.updateSchema(o,r[o]);let i=u.allOf;i&&i.forEach(s)};s(l)}updateSchema(l,s){switch(e.allSettings.properties[l]=s,s.scope){case 1:e.applicationSettings.properties[l]=s;break;case 2:e.machineSettings.properties[l]=s;break;case 6:e.machineOverridableSettings.properties[l]=s;break;case 3:e.windowSettings.properties[l]=s;break;case 4:e.resourceSettings.properties[l]=s;break;case 5:e.resourceSettings.properties[l]=s,this.resourceLanguageSettingsSchema.properties[l]=s;break}}removeFromSchema(l,s){switch(delete e.allSettings.properties[l],s.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const s=`[${l}]`,u={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,u),e.allSettings.properties[s]=u,e.applicationSettings.properties[s]=u,e.machineSettings.properties[s]=u,e.machineOverridableSettings.properties[s]=u,e.windowSettings.properties[s]=u,e.resourceSettings.properties[s]=u}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,s){const u=this.configurationDefaultsOverrides.get(l);let r=u?.value,i=u?.source;D.isUndefined(r)&&(r=s.defaultDefaultValue,i=void 0),D.isUndefined(r)&&(r=b(s.type)),s.default=r,s.defaultValueSource=i}}const m="\\[([^\\]]+)\\]",S=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(a){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let s=S.exec(a);for(;s?.length;){const u=s[1].trim();u&&l.push(u),s=S.exec(a)}}return(0,w.distinct)(l)}e.overrideIdentifiersFromKey=t;function f(a){return a.reduce((l,s)=>`${l}[${s}]`,"")}e.keyFromOverrideIdentifiers=f;function b(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const p=new E;I.Registry.add(e.Extensions.Configuration,p);function P(a){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?k.localize(7,null,a):p.getConfigurationProperties()[a]!==void 0?k.localize(8,null,a):null:k.localize(6,null)}e.validateProperty=P;function c(){const a=[],l=p.getConfigurationProperties();for(const s of Object.keys(l))a.push([s,l[s].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=c}),define(Z[191],x([0,1,30,4,38,2,39,47,13,7,18,56,40]),function(q,e,w,R,D,k,n,I,d,g,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class S{constructor(r={},i=[],o=[]){this._contents=r,this._keys=i,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,y.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const o=this.getContentsForOverrideIdentifer(i);return o?r?(0,y.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const o of this.overrides)o.identifiers.includes(r)&&i.push(...o.keys);return w.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return w.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=I.deepClone(this.contents),o=I.deepClone(this.overrides),h=[...this.keys];for(const v of r){this.mergeContents(i,v.contents);for(const M of v.overrides){const[A]=o.filter(L=>w.equals(L.identifiers,M.identifiers));A?(this.mergeContents(A.contents,M.contents),A.keys.push(...M.keys),A.keys=w.distinct(A.keys)):o.push(I.deepClone(M))}for(const M of v.keys)h.indexOf(M)===-1&&h.push(M)}return new S(i,h,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let o={};for(const h of w.distinct([...Object.keys(this.contents),...Object.keys(i)])){let v=this.contents[h],M=i[h];M&&(typeof v=="object"&&typeof M=="object"?(v=I.deepClone(v),this.mergeContents(v,M)):v=M),o[h]=v}return new S(o,this.keys,this.overrides)}mergeContents(r,i){for(const o of Object.keys(i)){if(o in r&&d.isObject(r[o])&&d.isObject(i[o])){this.mergeContents(r[o],i[o]);continue}r[o]=I.deepClone(i[o])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?I.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,o=null;const h=v=>{v&&(o?this.mergeContents(o,v):o=I.deepClone(v))};for(const v of this.overrides)w.equals(v.identifiers,[r])?i=v.contents:v.identifiers.includes(r)&&h(v.contents);return h(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,y.addToValueTree)(this.contents,r,i,o=>{throw new Error(o)})}removeValue(r){this.removeKey(r)&&(0,y.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let o=0;o<i;o++)r.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=S;class t extends S{constructor(r={}){const i=m.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(i),h=Object.create(null),v=[];for(const M in i){const A=r[M],L=A!==void 0?A:i[M].default;(0,y.addToValueTree)(h,M,L,F=>console.error(`Conflict in default settings: ${F}`))}for(const M of Object.keys(h))E.OVERRIDE_PROPERTY_REGEX.test(M)&&v.push({identifiers:(0,E.overrideIdentifiersFromKey)(M),keys:Object.keys(h[M]),contents:(0,y.toValuesTree)(h[M],A=>console.error(`Conflict in default settings file: ${A}`))});super(h,o,v)}}e.DefaultConfigurationModel=t;class f{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!d.isUndefinedOrNull(r)){const o=this.doParseContent(r);this.parseRaw(o,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:o,keys:h,overrides:v,restricted:M}=this.doParseRaw(r,i);this._configurationModel=new S(o,h,v),this._restrictedConfigurations=M||[]}doParseContent(r){let i={},o=null,h=[],v=[],M=[];function A(F){Array.isArray(h)?h.push(F):o!==null&&(h[o]=F)}let L={onObjectBegin:()=>{let F={};A(F),v.push(h),h=F,o=null},onObjectProperty:F=>{o=F},onObjectEnd:()=>{h=v.pop()},onArrayBegin:()=>{let F=[];A(F),v.push(h),h=F,o=null},onArrayEnd:()=>{h=v.pop()},onLiteralValue:A,onError:(F,U,Q)=>{M.push({error:F,offset:U,length:Q})}};if(r)try{D.visit(r,L),i=h[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return i}doParseRaw(r,i){const o=m.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),h=this.filter(r,o,!0,i);r=h.raw;const v=(0,y.toValuesTree)(r,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),M=Object.keys(r),A=this.toOverrides(r,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:v,keys:M,overrides:A,restricted:h.restricted}}filter(r,i,o,h){if(!h?.scopes&&!h?.skipRestricted)return{raw:r,restricted:[]};const v={},M=[];for(let A in r)if(E.OVERRIDE_PROPERTY_REGEX.test(A)&&o){const L=this.filter(r[A],i,!1,h);v[A]=L.raw,M.push(...L.restricted)}else{const L=i[A],F=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&M.push(A),(F===void 0||h.scopes===void 0||h.scopes.includes(F))&&(h.skipRestricted&&L?.restricted||(v[A]=r[A]))}return{raw:v,restricted:M}}toOverrides(r,i){const o=[];for(const h of Object.keys(r))if(E.OVERRIDE_PROPERTY_REGEX.test(h)){const v={};for(const M in r[h])v[M]=r[h][M];o.push({identifiers:(0,E.overrideIdentifiersFromKey)(h),keys:Object.keys(v),contents:(0,y.toValuesTree)(v,i)})}return o}}e.ConfigurationModelParser=f;class b extends k.Disposable{constructor(r,i,o,h){super();this.userSettingsResource=r,this.scopes=i,this.fileService=h,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.filter(this.fileService.onDidFilesChange,v=>v.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(r){return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class p{constructor(r,i,o=new S,h=new S,v=new n.ResourceMap,M=new S,A=new n.ResourceMap,L=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=o,this._workspaceConfiguration=h,this._folderConfigurations=v,this._memoryConfiguration=M,this._memoryConfigurationByResource=A,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new n.ResourceMap,this._userConfiguration=null}getValue(r,i,o){return this.getConsolidateConfigurationModel(i,o).getValue(r)}updateValue(r,i,o={}){let h;o.resource?(h=this._memoryConfigurationByResource.get(o.resource),h||(h=new S,this._memoryConfigurationByResource.set(o.resource,h))):h=this._memoryConfiguration,i===void 0?h.removeValue(r):h.setValue(r,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,o){const h=this.getConsolidateConfigurationModel(i,o),v=this.getFolderConfigurationModelForResource(i.resource,o),M=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,A=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),L=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),F=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),U=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),Q=o?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,ie=v?i.overrideIdentifier?v.freeze().override(i.overrideIdentifier).getValue(r):v.freeze().getValue(r):void 0,re=i.overrideIdentifier?M.override(i.overrideIdentifier).getValue(r):M.getValue(r),G=h.getValue(r),O=w.distinct(w.flatten(h.overrides.map(B=>B.identifiers))).filter(B=>h.getOverrideValue(r,B)!==void 0);return{defaultValue:A,userValue:L,userLocalValue:F,userRemoteValue:U,workspaceValue:Q,workspaceFolderValue:ie,memoryValue:re,value:G,default:A!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:ie!==void 0?{value:v?.freeze().getValue(r),override:i.overrideIdentifier?v?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:re!==void 0?{value:M.getValue(r),override:i.overrideIdentifier?M.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:O.length?O:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const o=[];if(!i){const{added:h,updated:v,removed:M}=l(this._defaultConfiguration,r);i=[...h,...v,...M]}for(const h of i)for(const v of(0,E.overrideIdentifiersFromKey)(h)){const M=this._defaultConfiguration.getKeysForOverrideIdentifier(v),A=r.getKeysForOverrideIdentifier(v),L=[...A.filter(F=>M.indexOf(F)===-1),...M.filter(F=>A.indexOf(F)===-1),...M.filter(F=>!I.equals(this._defaultConfiguration.override(v).getValue(F),r.override(v).getValue(F)))];o.push([v,L])}return this.updateDefaultConfiguration(r),{keys:i,overrides:o}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:o,removed:h,overrides:v}=l(this.localUserConfiguration,r),M=[...i,...o,...h];return M.length&&this.updateLocalUserConfiguration(r),{keys:M,overrides:v}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:o,removed:h,overrides:v}=l(this.remoteUserConfiguration,r);let M=[...i,...o,...h];return M.length&&this.updateRemoteUserConfiguration(r),{keys:M,overrides:v}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:o,removed:h,overrides:v}=l(this.workspaceConfiguration,r);let M=[...i,...o,...h];return M.length&&this.updateWorkspaceConfiguration(r),{keys:M,overrides:v}}compareAndUpdateFolderConfiguration(r,i){const o=this.folderConfigurations.get(r),{added:h,updated:v,removed:M,overrides:A}=l(o,i);let L=[...h,...v,...M];return(L.length||!o)&&this.updateFolderConfiguration(r,i),{keys:L,overrides:A}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:h,removed:v,overrides:M}=l(i,void 0);return{keys:[...o,...h,...v],overrides:M}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let o=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?o.override(r.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:r},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const h=i.getFolder(r);h&&(o=this.getFolderConsolidatedConfiguration(h.uri)||o);const v=this._memoryConfigurationByResource.get(r);v&&(o=o.merge(v))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),h=this._folderConfigurations.get(r);h?(i=o.merge(h),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=o}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const o=i.getFolder(r);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:o,overrides:h,keys:v}=this._folderConfigurations.get(i);return r.push([i,{contents:o,overrides:h,keys:v}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>r.add(o))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(h=>i.add(h))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),o=this.parseConfigurationModel(r.user),h=this.parseConfigurationModel(r.workspace),v=r.folders.reduce((M,A)=>(M.set(g.URI.revive(A[0]),this.parseConfigurationModel(A[1])),M),new n.ResourceMap);return new p(i,o,new S,h,v,new S,new n.ResourceMap,!1)}static parseConfigurationModel(r){return new S(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=p;function P(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const r=new Set,i=new Map;for(const h of u)h.keys.forEach(v=>r.add(v)),h.overrides.forEach(([v,M])=>{const A=(0,n.getOrSet)(i,v,new Set);M.forEach(L=>A.add(L))});const o=[];return i.forEach((h,v)=>o.push([v,[...h.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=P;class c{constructor(r,i,o,h){this.change=r,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=h,this._previousConfiguration=void 0;const v=new Set;r.keys.forEach(A=>v.add(A)),r.overrides.forEach(([,A])=>A.forEach(L=>v.add(L))),this.affectedKeys=[...v.values()];const M=new S;this.affectedKeys.forEach(A=>M.setValue(A,{})),this.affectedKeysTree=M.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!I.equals(o,h)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let o=(0,y.toValuesTree)({[i]:!0},()=>{}),h;for(;typeof o=="object"&&(h=Object.keys(o)[0]);){if(r=r[h],!r)return!1;o=o[h]}return!0}}e.ConfigurationChangeEvent=c;class a extends c{constructor(r,i,o,h){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=o,this.sourceConfig=h}}e.AllKeysConfigurationChangeEvent=a;function l(u,r){const{added:i,removed:o,updated:h}=s(r,u),v=[],M=u?.getAllOverrideIdentifiers()||[],A=r?.getAllOverrideIdentifiers()||[];if(r){const L=A.filter(F=>!M.includes(F));for(const F of L)v.push([F,r.getKeysForOverrideIdentifier(F)])}if(u){const L=M.filter(F=>!A.includes(F));for(const F of L)v.push([F,u.getKeysForOverrideIdentifier(F)])}if(r&&u){for(const L of M)if(A.includes(L)){const F=s({contents:u.getOverrideValue(void 0,L)||{},keys:u.getKeysForOverrideIdentifier(L)},{contents:r.getOverrideValue(void 0,L)||{},keys:r.getKeysForOverrideIdentifier(L)});v.push([L,[...F.added,...F.removed,...F.updated]])}}return{added:i,removed:o,updated:h,overrides:v}}function s(u,r){const i=u?r?u.keys.filter(v=>r.keys.indexOf(v)===-1):[...u.keys]:[],o=r?u?r.keys.filter(v=>u.keys.indexOf(v)===-1):[...r.keys]:[],h=[];if(u&&r){for(const v of r.keys)if(u.keys.indexOf(v)!==-1){const M=(0,y.getConfigurationValue)(r.contents,v),A=(0,y.getConfigurationValue)(u.contents,v);I.equals(M,A)||h.push(v)}}return{added:i,removed:o,updated:h}}}),define(Z[192],x([0,1,8,4,2,16,18,191,56,40]),function(q,e,w,R,D,k,n,I,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class y extends D.Disposable{constructor(m,S){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,S)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,S){const t=typeof m=="string"?m:void 0,f=(0,n.isConfigurationOverrides)(m)?m:(0,n.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(t,f,void 0)}updateValue(m,S,t,f){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const S=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(t,S,1)}onDidDefaultConfigurationChange(m){const S=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,m);this.trigger(t,S,6)}trigger(m,S,t){const f=new I.ConfigurationChangeEvent(m,{data:S},this.configuration);f.source=t,f.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(f)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=y}),define(Z[193],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var R;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(n,I=R.Unknown,d){super(n);this._message=n,this._code=I,this._detail=d,this.isHandled=I===R.NotAvailable&&d===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(n){return n instanceof D&&n._code===R.TemporarilyNotAvailable}static isNoResolverFound(n){return n instanceof D&&n._code===R.NoResolverFound}static isHandled(n){return n instanceof D&&n.isHandled}}e.RemoteAuthorityResolverError=D}),define(Z[194],x([0,1,8,17,23,15,4,2,31,84,193]),function(q,e,w,R,D,k,n,I,d,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var m;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function S(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(W){const C=new D.CancellationTokenSource;return setTimeout(()=>C.cancel(),W),C.token}function f(W,C){if(W.isCancellationRequested||C.isCancellationRequested)return D.CancellationToken.Cancelled;const T=new D.CancellationTokenSource;return W.onCancellationRequested(()=>T.cancel()),C.onCancellationRequested(()=>T.cancel()),T.token}class b{constructor(C){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((T,_)=>{this._resolvePromise=T,this._rejectPromise=_}),C.isCancellationRequested?this._timeout():this._disposables.add(C.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(C){this._state==="pending"?this._disposables.add(C):C.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const C=new Error("Time limit reached");return C.code="ETIMEDOUT",C.syscall="connect",C}resolve(C){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(C))}reject(C){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(C))}}function p(W,C){const T=new b(C);return T.registerDisposable(W.onControlMessage(_=>{const z=JSON.parse(_.toString()),Y=V(z);Y?T.reject(Y):T.resolve(z)})),T.promise}function P(W,C,T,_,z,Y,N){const j=new b(N);return C.connect(T,_,z,Y,(ne,se)=>{j.didTimeout?(ne&&W.error(ne),se?.dispose()):ne||!se?j.reject(ne):j.resolve(se)}),j.promise}function c(W,C){const T=new b(C);return W.then(_=>{T.didTimeout||T.resolve(_)},_=>{T.didTimeout||T.reject(_)}),T.promise}async function a(W,C,T,_){const z=H(W,C);W.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await P(W.logService,W.socketFactory,W.host,W.port,`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,`renderer-${S(C)}-${W.reconnectionToken}`,_)}catch(oe){throw W.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),W.logService.error(oe),oe}W.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let N,j;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(Y,null),N=W.reconnectionProtocol,j=!1):(N=new g.PersistentProtocol(Y,null),j=!0),W.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const ne=await c(W.signService.createNewMessage((0,d.generateUuid)()),_),se={type:"auth",auth:W.connectionToken||"00000000000000000000",data:ne.data};N.sendControl(R.VSBuffer.fromString(JSON.stringify(se)));try{const oe=await p(N,f(_,t(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const he=new Error("Unexpected handshake message");throw he.code="VSCODE_CONNECTION_ERROR",he}if(W.logService.trace(`${z} 4/6. received SignRequest control message.`),!await c(W.signService.validate(ne,oe.signedData),_)){const he=new Error("Refused to connect to unsupported server");throw he.code="VSCODE_CONNECTION_ERROR",he}const ce=await c(W.signService.sign(oe.data),_),le={type:"connectionType",commit:W.commit,signedData:ce,desiredConnectionType:C};return T&&(le.args=T),W.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(R.VSBuffer.fromString(JSON.stringify(le))),{protocol:N,ownsProtocol:j}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(W.logService.error(`${z} the handshake timed out. Error:`),W.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${z} received error control message when negotiating connection. Error:`),W.logService.error(oe)),j&&B(N),oe}}async function l(W,C,T,_){const z=Date.now(),Y=H(W,C),{protocol:N,ownsProtocol:j}=await a(W,C,T,_),ne=new b(_);return ne.registerDisposable(N.onControlMessage(se=>{const oe=JSON.parse(se.toString()),J=V(oe);J?(W.logService.error(`${Y} received error control message when negotiating connection. Error:`),W.logService.error(J),j&&B(N),ne.reject(J)):(W.reconnectionProtocol&&W.reconnectionProtocol.endAcceptReconnection(),W.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${ee(z)}!`),ne.resolve({protocol:N,firstMessage:oe}))})),ne.promise}async function s(W,C){const{protocol:T}=await l(W,1,void 0,C);return{protocol:T}}async function u(W,C,T){const{protocol:_,firstMessage:z}=await l(W,2,C,T),Y=z&&z.debugPort;return{protocol:_,debugPort:Y}}async function r(W,C,T){const _=Date.now(),z=H(W,3),{protocol:Y}=await a(W,3,C,T);return W.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${ee(_)}!`),Y}async function i(W,C,T){const{host:_,port:z,connectionToken:Y}=await W.addressProvider.getAddress();return{commit:W.commit,host:_,port:z,connectionToken:Y,reconnectionToken:C,reconnectionProtocol:T,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function o(W,C,T){try{const _=(0,d.generateUuid)(),z=await i(W,_,null),{protocol:Y}=await s(z,D.CancellationToken.None);return new G(W,C,T,_,Y)}catch(_){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(_),re.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(_)),_}}e.connectRemoteAgentManagement=o;async function h(W,C){try{const T=(0,d.generateUuid)(),_=await i(W,T,null),{protocol:z,debugPort:Y}=await u(_,C,D.CancellationToken.None);return new O(W,C,T,z,Y)}catch(T){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(T),re.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(T)),T}}e.connectRemoteAgentExtensionHost=h;async function v(W,C,T){const _=await i(W,(0,d.generateUuid)(),null);return await r(_,{host:C,port:T},D.CancellationToken.None)}e.connectRemoteAgentTunnel=v;function M(W){return(0,w.createCancelablePromise)(C=>new Promise((T,_)=>{const z=setTimeout(T,W*1e3);C.onCancellationRequested(()=>{clearTimeout(z),T()})}))}var A;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(A=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class L{constructor(C,T){this.reconnectionToken=C,this.millisSinceLastIncomingData=T,this.type=0}}e.ConnectionLostEvent=L;class F{constructor(C,T,_,z){this.reconnectionToken=C,this.millisSinceLastIncomingData=T,this.durationSeconds=_,this.cancellableTimer=z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class U{constructor(C,T,_){this.reconnectionToken=C,this.millisSinceLastIncomingData=T,this.attempt=_,this.type=2}}e.ReconnectionRunningEvent=U;class Q{constructor(C,T,_){this.reconnectionToken=C,this.millisSinceLastIncomingData=T,this.attempt=_,this.type=4}}e.ConnectionGainEvent=Q;class ie{constructor(C,T,_,z){this.reconnectionToken=C,this.millisSinceLastIncomingData=T,this.attempt=_,this.handled=z,this.type=3}}e.ReconnectionPermanentFailureEvent=ie;class re extends I.Disposable{constructor(C,T,_,z){super();this._connectionType=C,this._onDidStateChange=this._register(new n.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=T,this.reconnectionToken=_,this.protocol=z,this._isReconnecting=!1,this._onDidStateChange.fire(new Q(this.reconnectionToken,0,0)),this._register(z.onSocketClose(Y=>{const N=$(this._connectionType,this.reconnectionToken,!0);Y?Y.type===0?(this._options.logService.info(`${N} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this._options.logService.error(Y.error)):(this._options.logService.info(`${N} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this._options.logService.error(Y.event)):this._options.logService.info(`${N} received socket close event.`),this._beginReconnecting()})),this._register(z.onSocketTimeout(()=>{const Y=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Y} received socket timeout event.`),this._beginReconnecting()})),re._instances.push(this),re._permanentFailure&&this._gotoPermanentFailure(re._permanentFailureMillisSinceLastIncomingData,re._permanentFailureAttempt,re._permanentFailureHandled)}static triggerPermanentFailure(C,T,_){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=C,this._permanentFailureAttempt=T,this._permanentFailureHandled=_,this._instances.forEach(z=>z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(C=>C._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(C=>C._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(re._permanentFailure)return;const C=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${C} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const z=_<T.length?T[_]:T[T.length-1];try{if(z>0){const N=M(z);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,N)),this._options.logService.info(`${C} waiting for ${z} seconds before reconnecting...`);try{await N}catch{}}if(re._permanentFailure){this._options.logService.error(`${C} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this._options.logService.info(`${C} resolving connection...`);const Y=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${C} connecting to ${Y.host}:${Y.port}...`),await this._reconnect(Y,t(E)),this._options.logService.info(`${C} reconnected!`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(Y){if(Y.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${C} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(Y),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this._options.logService.error(`${C} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(Y),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Y)){this._options.logService.info(`${C} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Y);continue}if((Y.code==="ETIMEDOUT"||Y.code==="ENETUNREACH"||Y.code==="ECONNREFUSED"||Y.code==="ECONNRESET")&&Y.syscall==="connect"){this._options.logService.info(`${C} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Y);continue}if((0,k.isPromiseCanceledError)(Y)){this._options.logService.info(`${C} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Y);continue}if(Y instanceof y.RemoteAuthorityResolverError){this._options.logService.error(`${C} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(Y),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),_+1,y.RemoteAuthorityResolverError.isHandled(Y));break}this._options.logService.error(`${C} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(Y),re.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!re._permanentFailure)}_gotoPermanentFailure(C,T,_){this._onDidStateChange.fire(new ie(this.reconnectionToken,C,T,_)),B(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=re,re._permanentFailure=!1,re._permanentFailureMillisSinceLastIncomingData=0,re._permanentFailureAttempt=0,re._permanentFailureHandled=!1,re._instances=[];class G extends re{constructor(C,T,_,z,Y){super(1,C,z,Y);this.client=this._register(new g.Client(Y,{remoteAuthority:T,clientId:_},C.ipcLogger))}async _reconnect(C,T){await s(C,T)}}e.ManagementPersistentConnection=G;class O extends re{constructor(C,T,_,z,Y){super(2,C,_,z);this._startArguments=T,this.debugPort=Y}async _reconnect(C,T){await u(C,this._startArguments,T)}}e.ExtensionHostPersistentConnection=O;function B(W){try{W.acceptDisconnect();const C=W.getSocket();W.dispose(),C.dispose()}catch(C){(0,k.onUnexpectedError)(C)}}function V(W){if(W&&W.type==="error"){const C=new Error(`Connection error: ${W.reason}`);return C.code="VSCODE_CONNECTION_ERROR",C}return null}function X(W,C){for(;W.length<C;)W+=" ";return W}function $(W,C,T){return`[remote-connection][${X(S(W),13)}][${C.substr(0,5)}\u2026][${T?"reconnect":"initial"}]`}function H(W,C){return`${$(C,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function ee(W){return`${Date.now()-W} ms`}}),define(Z[64],x([0,1,10]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(g){return g.scheme===w.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=R;function D(g){if(!g)return;const y=g.indexOf("+");return y<0?g:g.substr(0,y)}e.getRemoteName=D;function k(g){return g.scheme!==w.Schemas.file&&g.scheme!==w.Schemas.vscodeRemote}e.isVirtualResource=k;function n(g){if(g.folders.length)return g.folders.every(y=>k(y.uri))?g.folders[0].uri:void 0;if(g.configuration&&k(g.configuration))return g.configuration}e.getVirtualWorkspaceLocation=n;function I(g){return n(g)?.scheme}e.getVirtualWorkspaceScheme=I;function d(g){return n(g)!==void 0}e.isVirtualWorkspace=d}),define(Z[195],x([0,1,25,5,64]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=k;function n(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=n,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class d{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,t){if(typeof S=="undefined"||S===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof S=="string"||typeof t=="string"){let f=typeof S=="string"?S:S.value,b=typeof t=="string"?t:t.value;return w.equalsIgnoreCase(f,b)}return S._lower===t._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=d;function g(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=g;function y(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function E(m,S){if(S){const t=`onResolveRemoteAuthority:${(0,D.getRemoteName)(S)}`;return m.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[196],x([0,1,25,195]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(t,f){return t.uuid&&f.uuid?t.uuid===f.uuid:t.id===f.id?!0:(0,w.compareIgnoreCase)(t.id,f.id)===0}e.areSameExtensions=D;class k{constructor(f,b){this.version=b,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof k?D(this,f)&&this.version===f.version:!1}}e.ExtensionIdentifierWithVersion=k;function n(t,f){return`${t}.${f}`}e.getExtensionId=n;function I(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function d(t,f){return I(n(t,f))}e.getGalleryExtensionId=d;function g(t,f){const b=[],p=P=>{for(const c of b)if(c.some(a=>D(f(a),f(P))))return c;return null};for(const P of t){const c=p(P);c?c.push(P):b.push([P])}return b}e.groupByExtension=g;function y(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function E(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function m(t){const f=new Set;if(t.malicious)for(const b of t.malicious)f.add(b.id);return f}e.getMaliciousExtensionsSet=m;function S(t,f){const b=[],p=f.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const P=p.shift();if(P&&b.every(c=>!D(c.identifier,{id:P}))){const c=t.filter(a=>D(a.identifier,{id:P}));c.length===1&&(b.push(c[0]),p.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=S}),define(Z[96],x([0,1,4,3,5,6]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var n;(function(t){t.Http="http",t.Https="https"})(n=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var d;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(d=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function g(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!f)return{address:f[1],port:+f[2]}}e.extractLocalHostUriMetaDataForPortMapping=g,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=E;function m(t,f){return f?f!==1&&t<1024:!R.isWindows&&t<1024}e.isPortPrivileged=m;let S=class{constructor(f){this.logService=f,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(f,b){return this._tunnelProvider=f,f?(this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const f=[],b=Array.from(this._tunnels.values());for(let p of b){const P=Array.from(p.values());for(let c of P){const a=await c.value;a&&f.push(a)}}return f}async dispose(){for(const f of this._tunnels.values()){for(const{value:b}of f.values())await b.then(p=>p?.dispose());f.clear()}this._tunnels.clear()}openTunnel(f,b,p,P,c=!1,a=I.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${b}:${p} on local port ${P}.`),!f)return;b||(b="localhost");const s=this.retainOrCreateTunnel(f,b,p,P,c,a,l);return s?s.then(u=>{if(!u){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(b,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(u);return(u.tunnelRemoteHost!==b||u.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,privacy:f.privacy,protocol:f.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${f.tunnelRemoteHost}:${f.tunnelRemotePort} `);const b=this._tunnels.get(f.tunnelRemoteHost);if(b){const p=b.get(f.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(f.tunnelRemoteHost,f.tunnelRemotePort,p))}}}}async tryDisposeTunnel(f,b,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${f}:${b}.`);const P=p.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(f)&&this._tunnels.get(f).delete(b),P}}async closeTunnel(f,b){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${f}:${b} `);const p=this._tunnels.get(f);if(p&&p.has(b)){const P=p.get(b);P.refcount=0,await this.tryDisposeTunnel(f,b,P)}}addTunnelToMap(f,b,p){this._tunnels.has(f)||this._tunnels.set(f,new Map),this._tunnels.get(f).set(b,{refcount:1,value:p})}async removeEmptyTunnelFromMap(f,b){const p=this._tunnels.get(f);p&&(await p.get(b)||p.delete(b),p.size===0&&this._tunnels.delete(f))}getTunnelFromMap(f,b){let p=[f];y(f)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):E(f)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const P=p.map(c=>this._tunnels.get(c));for(const c of P){const a=c?.get(b);if(a)return a}}canTunnel(f){return!!g(f)}createWithProvider(f,b,p,P,c,a,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${b}:${p} on local port ${P}.`);const u={elevationRequired:c?m(P===void 0?p:P):!1},r={remoteAddress:{host:b,port:p},localAddressPort:P,privacy:a,public:a!==I.Private,protocol:l},i=f.forwardPort(r,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(b,p,i),i}};S=de([te(0,k.ILogService)],S),e.AbstractTunnelService=S}),define(Z[49],x([0,1,17,151,56,5,40]),function(q,e,w,R,D,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function I(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=I;function d(t){return t.res.statusCode===204}async function g(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);return d(t)?null:(await(0,w.streamToBuffer)(t.stream)).toString()}e.asText=g;async function y(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);if(d(t))return null;const b=(await(0,w.streamToBuffer)(t.stream)).toString();try{return JSON.parse(b)}catch(p){throw p.message+=`:
`+b,p}}e.asJson=y;function E(t){S(t)}e.updateProxyConfigurationsScope=E;let m;function S(t){const f=n.Registry.as(D.Extensions.Configuration),b=m;m={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[m],remove:b?[b]:[]})}S(2)}),define(Z[197],x([0,1,198,13]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(n,I){return n.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:n.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function k(n,I,d={}){const g=(0,w.parse)(n),y=d.proxyUrl||D(g,I);if(!y)return null;const E=(0,w.parse)(y);if(!/^https?:$/.test(E.protocol||""))return null;const m={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,R.isBoolean)(d.strictSSL)?d.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((S,t)=>{q(["http-proxy-agent"],S,t)}))(m):new(await new Promise((S,t)=>{q(["https-proxy-agent"],S,t)}))(m)}e.getProxyAgent=k}),define(Z[199],x([0,1,17,31]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(k,n,I){let d=I&&I.get("storage.serviceMachineId",0)||null;if(d)return d;try{const y=(await n.readFile(k.serviceMachineIdResource)).value.toString();d=(0,R.isUUID)(y)?y:null}catch(g){d=null}if(!d){d=(0,R.generateUuid)();try{await n.writeFile(k.serviceMachineIdResource,w.VSBuffer.fromString(d))}catch(g){}}return I&&I.store("storage.serviceMachineId",d,0,1),d}e.getServiceMachineId=D}),define(Z[76],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,w.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[200],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{constructor(){this.validators=new Map}vsda(){return new Promise((D,k)=>q(["vsda"],D,k))}async createNewMessage(D){try{const k=await this.vsda(),n=new k.validator;if(n){const I=String(w._nextId++);return this.validators.set(I,n),{id:I,data:n.createNewMessage(D)}}}catch(k){}return{id:"",data:D}}async validate(D,k){if(!D.id)return!0;const n=this.validators.get(D.id);if(!n)return!1;this.validators.delete(D.id);try{return n.validate(k)==="ok"}catch(I){return!1}}async sign(D){try{const k=await this.vsda(),n=new k.signer;if(n)return n.sign(D)}catch(k){}return D}}e.SignService=w,w._nextId=1}),define(Z[37],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,w.createDecorator)("stateMainService")}),define(Z[20],x([0,1,14,8,4,2,3,34,13,5,179,6,37]),function(q,e,w,R,D,k,n,I,d,g,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,g.createDecorator)("lifecycleMainService");var S;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen"})(S=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class dt extends k.Disposable{constructor(b,p){super();this.logService=b,this.stateMainService=p,this._onBeforeShutdown=this._register(new D.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new D.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new D.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new D.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(dt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(dt.QUIT_AND_RESTART_KEY)}registerListeners(){const b=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),n.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};w.app.addListener("before-quit",b);const p=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!n.isMacintosh)&&w.app.quit()};w.app.addListener("window-all-closed",p),w.app.once("will-quit",P=>{this.logService.trace("Lifecycle#app.on(will-quit)"),P.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),w.app.removeListener("before-quit",b),w.app.removeListener("window-all-closed",p),w.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const b=[];return this._onWillShutdown.fire({join(p){b.push(p)}}),this.pendingWillShutdownPromise=(async()=>{try{await R.Promises.settled(b)}catch(p){this.logService.error(p)}try{await this.stateMainService.close()}catch(p){this.logService.error(p)}})(),this.pendingWillShutdownPromise}set phase(b){if(b<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===b)return;this.logService.trace(`lifecycle (main): phase changed (value: ${b})`),this._phase=b;const p=this.phaseWhen.get(this._phase);p&&(p.open(),this.phaseWhen.delete(this._phase))}async when(b){if(b<=this._phase)return;let p=this.phaseWhen.get(b);p||(p=new R.Barrier,this.phaseWhen.set(b,p)),await p.wait()}registerWindow(b){const p=new k.DisposableStore;this.windowCounter++,p.add(b.onWillLoad(c=>this._onWillLoadWindow.fire({window:b,workspace:c.workspace,reason:c.reason})));const P=(0,d.assertIsDefined)(b.win);P.on("close",c=>{const a=b.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${b.id}`),c.preventDefault(),this.unload(b,1).then(l=>{if(l){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(b),b.close()})}),P.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${b.id}`),this.windowCounter--,p.dispose(),this.windowCounter===0&&(!n.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(b,p){await this.unload(b,3)||b.reload(p)}async unload(b,p){if(!b.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${b.id}`);const P=this._quitRequested?2:p;let c=await this.onBeforeUnloadWindowInRenderer(b,P);return c?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${b.id})`),this.handleWindowUnloadVeto(c)):(c=await this.onBeforeUnloadWindowInMain(b,P),c?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${b.id})`),this.handleWindowUnloadVeto(c)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${b.id})`),await this.onWillUnloadWindowInRenderer(b,P),!1))}handleWindowUnloadVeto(b){return b?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(b){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(b),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(b,p){return new Promise(P=>{const c=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${c}`,l=`vscode:cancel${c}`;w.ipcMain.once(a,()=>{P(!1)}),w.ipcMain.once(l,()=>{P(!0)}),b.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:l,reason:p})})}onBeforeUnloadWindowInMain(b,p){const P=[];return this._onBeforeUnloadWindow.fire({reason:p,window:b,veto(c){P.push(c)}}),(0,y.handleVetos)(P,c=>this.logService.error(c))}onWillUnloadWindowInRenderer(b,p){return new Promise(P=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;w.ipcMain.once(a,()=>P()),b.send("vscode:onWillUnload",{replyChannel:a,reason:p})})}quit(b){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${b}`),b&&this.stateMainService.setItem(dt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(p=>{this.pendingQuitPromiseResolve=p,this.logService.trace("Lifecycle#quit() - calling app.quit()"),w.app.quit()}),this.pendingQuitPromise)}async relaunch(b){this.logService.trace("Lifecycle#relaunch()");const p=process.argv.slice(1);if(b?.addArgs&&p.push(...b.addArgs),b?.removeArgs)for(const a of b.removeArgs){const l=p.indexOf(a);l>=0&&p.splice(l,1)}const P=()=>{try{if(n.isWindows){const a=(0,I.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),w.app.relaunch({args:p})};w.app.once("quit",P),await this.quit(!0)&&w.app.removeListener("quit",P)}async kill(b){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,R.timeout)(1e3),(async()=>{for(const p of w.BrowserWindow.getAllWindows())if(p&&!p.isDestroyed()){let P;p.webContents&&!p.webContents.isDestroyed()?P=new Promise(c=>p.once("closed",c)):P=Promise.resolve(),p.destroy(),await P}})()]),w.app.exit(b)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=de([te(0,E.ILogService),te(1,m.IStateMainService)],t),e.LifecycleMainService=t}),define(Z[201],x([0,1,4,2,5,20]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let n=class extends R.Disposable{constructor(g){super();this._onDidChangeKeyboardLayout=this._register(new w.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,g.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const g=await new Promise((y,E)=>{q(["native-keymap"],y,E)});this._keyboardLayoutData=I(g),g.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=I(g),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};n=de([te(0,k.ILifecycleMainService)],n),e.KeyboardLayoutMainService=n;function I(d){const g=d.getKeyMap(),y=d.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:y}}}),define(Z[97],x([0,1,8,4,2,63,13,86,5]),function(q,e,w,R,D,k,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const g="__$__targetStorageMarker";e.IStorageService=(0,d.createDecorator)("storageService");var y;(function(b){b[b.NONE=0]="NONE",b[b.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(b){b[b.GLOBAL=0]="GLOBAL",b[b.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var m;(function(b){b[b.USER=0]="USER",b[b.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class S extends D.Disposable{constructor(p={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=p,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new w.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,w.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(p,P){P===g?(p===0?this._globalKeyTargets=void 0:p===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:p})):this._onDidChangeValue.fire({scope:p,key:P,target:this.getKeyTargets(p)[P]})}emitWillSaveState(p){this._onWillSaveState.fire({reason:p})}get(p,P,c){return this.getStorage(P)?.get(p,c)}getBoolean(p,P,c){return this.getStorage(P)?.getBoolean(p,c)}getNumber(p,P,c){return this.getStorage(P)?.getNumber(p,c)}store(p,P,c,a){if((0,n.isUndefinedOrNull)(P)){this.remove(p,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(p,c,a),this.getStorage(c)?.set(p,P)})}remove(p,P){this.withPausedEmitters(()=>{this.updateKeyTarget(p,P,void 0),this.getStorage(P)?.delete(p)})}withPausedEmitters(p){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{p()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(p,P){const c=[],a=this.getKeyTargets(p);for(const l of Object.keys(a))a[l]===P&&c.push(l);return c}updateKeyTarget(p,P,c){const a=this.getKeyTargets(P);typeof c=="number"?a[p]!==c&&(a[p]=c,this.getStorage(P)?.set(g,JSON.stringify(a))):typeof a[p]=="number"&&(delete a[p],this.getStorage(P)?.set(g,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(p){return p===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(p){const P=this.get(g,p);if(P)try{return JSON.parse(P)}catch(c){}return Object.create(null)}isNew(p){return this.getBoolean(e.IS_NEW_KEY,p)===!0}async flush(p=y.NONE){this._onWillSaveState.fire({reason:p});const P=this.getStorage(0),c=this.getStorage(1);switch(p){case y.NONE:await w.Promises.settled([P?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await w.Promises.settled([P?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve()]);break}}async logStorage(){const p=this.getStorage(0)?.items??new Map,P=this.getStorage(1)?.items??new Map;return f(p,P,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends S{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(p=>this.emitDidChangeValue(1,p))),this._register(this.globalStorage.onDidChangeStorage(p=>this.emitDidChangeValue(0,p)))}getStorage(p){return p===0?this.globalStorage:this.workspaceStorage}getLogDetails(p){return p===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(p){}}e.InMemoryStorageService=t;async function f(b,p,P,c){const a=h=>{try{return JSON.parse(h)}catch(v){return h}},l=new Map,s=new Map;b.forEach((h,v)=>{l.set(v,h),s.set(v,a(h))});const u=new Map,r=new Map;p.forEach((h,v)=>{u.set(v,h),r.set(v,a(h))}),console.group(`Storage: Global (path: ${P})`);let i=[];l.forEach((h,v)=>{i.push({key:v,value:h})}),console.table(i),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${c})`);let o=[];u.forEach((h,v)=>{o.push({key:v,value:h})}),console.table(o),console.groupEnd(),console.log(r)}e.logStorage=f}),define(Z[202],x([0,1,3,34,7,31]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function n(g){if(w.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function I(g,y,E,m,S,t,f,b,p,P){const c=Object.create(null);c["common.machineId"]=f,c.sessionID=(0,k.generateUuid)()+Date.now(),c.commitHash=S,c.version=t,c["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,w.PlatformToString)(w.platform),c["common.nodePlatform"]=R.platform,c["common.nodeArch"]=m,c["common.product"]=P||"desktop";const a=d(b||[]);a&&(c["common.msftInternal"]=a);let l=0;const s=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),w.isLinuxSnap&&(c["common.snap"]="true");const u=n(E);u&&(c["common.platformDetail"]=u);try{const r=await g.readFile(D.URI.file(p));c["common.source"]=r.value.toString().slice(0,30)}catch(r){}return c}e.resolveCommonProperties=I;function d(g){const y=R.env.USERDNSDOMAIN;if(!y)return!1;const E=y.toLowerCase();return g.some(m=>E===m)}e.verifyMicrosoftInternalDomain=d}),define(Z[28],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[203],x([0,1,26,69,8,38,10,9,3,7,71,21,83,74,19,22,28]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function p(s,u){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let i;const o=w.homedir().toLowerCase();switch(process.platform){case"win32":i=[{tag:"gdrive",matcher:U=>/^[a-z]:\\(my drive|shared drives)\\/.test(U)||U.startsWith(o+"\\my drive\\")},{tag:"dropbox",matcher:U=>U.startsWith(o+"\\dropbox")},{tag:"onedrive",matcher:U=>U.startsWith(o+"\\onedrive")},{tag:"box",matcher:U=>U.startsWith(o+"\\box\\")},{tag:"nextcloud",matcher:U=>U.startsWith(o+"\\nextcloud\\")},{tag:"owncloud",matcher:U=>U.startsWith(o+"\\owncloud\\")}];break;case"darwin":i=[{tag:"gdrive",matcher:U=>U.startsWith("/volumes/googledrive/")||U.startsWith(o+"/my drive/")},{tag:"dropbox",matcher:U=>U.startsWith(o+"/dropbox")},{tag:"onedrive",matcher:U=>U.startsWith(o+"/onedrive")||U.startsWith(o+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:U=>U.startsWith(o+"/library/mobile documents/")},{tag:"box",matcher:U=>U.startsWith(o+"/box/")},{tag:"nextcloud",matcher:U=>U.startsWith(o+"/nextcloud/")},{tag:"owncloud",matcher:U=>U.startsWith(o+"/owncloud/")}];break}const h=new Map,v=new Map,M=2e4;function A(U,Q,ie,re){for(const O of i){const B=U.toLowerCase();O.matcher(B)&&v.set(O.tag,1)}const G=Q.substring(U.length+1);return D.Promises.withAsyncBody(async O=>{let B;try{B=await E.Promises.readdir(Q,{withFileTypes:!0})}catch($){O();return}if(re.count>=M){re.count+=B.length,re.maxReached=!0,O();return}let V=B.length;if(V===0){O();return}let X=B;re.count+B.length>M&&(re.maxReached=!0,V=M-re.count,X=B.slice(0,V)),re.count+=B.length;for(const $ of X)if($.isDirectory()){if(ie.includes($.name)||await A(U,(0,I.join)(Q,$.name),ie,re),--V==0){O();return}}else{const H=$.name.lastIndexOf(".");if(H>=0){const ee=$.name.substring(H+1);ee&&h.set(ee,(h.get(ee)??0)+1)}for(const ee of r)ee.relativePathPattern?.test(G)!==!1&&ee.filePattern.test($.name)&&v.set(ee.tag,(v.get(ee.tag)??0)+1);if(--V==0){O();return}}})}const L={count:0,maxReached:!1};await A(s,s,u,L);const F=await a(s);return{configFiles:P(v),fileTypes:P(h),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:F}}e.collectWorkspaceStats=p;function P(s){return[...R.Iterable.map(s.entries(),([u,r])=>({name:u,count:r}))].sort((u,r)=>r.count-u.count)}function c(){const s={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.virtualMachineHint.value()*100)}%`},u=w.cpus();return u&&u.length>0&&(s.cpus=`${u[0].model} (${u.length} x ${u[0].speed})`),s}e.getMachineInfo=c;async function a(s){try{const u=new Map,r=(0,I.join)(s,".vscode","launch.json"),i=await E.Promises.readFile(r),o=[],h=(0,k.parse)(i.toString(),o);if(o.length)return console.log(`Unable to parse ${r}`),[];if((0,k.getNodeType)(h)==="object"&&h.configurations)for(const v of h.configurations){const M=v.type;M&&(u.has(M)?u.set(M,u.get(M)+1):u.set(M,1))}return P(u)}catch(u){return[]}}e.collectLaunchConfigs=a;let l=class{constructor(u,r){this.telemetryService=u,this.productService=r}formatMachineInfo(u){const r=[];return r.push(`OS Version:       ${u.os}`),r.push(`CPUs:             ${u.cpus}`),r.push(`Memory (System):  ${u.memory}`),r.push(`VM:               ${u.vmHint}`),r.join(`
`)}formatEnvironment(u){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const i=w.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(w.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),d.isWindows||r.push(`Load (avg):       ${w.loadavg().map(o=>Math.round(o)).join(", ")}`),r.push(`VM:               ${Math.round(y.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${u.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${u.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(u.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(u,r){return Promise.all([(0,m.listProcesses)(u.mainPID),this.formatWorkspaceMetadata(u)]).then(async i=>{let[o,h]=i,v=this.formatProcessList(u,o);return r.forEach(M=>{if((0,S.isRemoteDiagnosticError)(M))v+=`
${M.errorMessage}`,h+=`
${M.errorMessage}`;else if(v+=`

Remote: ${M.hostName}`,M.processes&&(v+=`
${this.formatProcessList(u,M.processes)}`),M.workspaceMetadata){h+=`
|  Remote: ${M.hostName}`;for(const A of Object.keys(M.workspaceMetadata)){const L=M.workspaceMetadata[A];let F=`${L.fileCount} files`;L.maxFilesReached&&(F=`more than ${F}`),h+=`|    Folder (${A}): ${F}`,h+=this.formatWorkspaceStats(L)}}}),{processInfo:v,workspaceInfo:h}})}async getSystemInfo(u,r){const{memory:i,vmHint:o,os:h,cpus:v}=c(),M={os:h,memory:i,cpus:v,vmHint:o,processArgs:`${u.mainArguments.join(" ")}`,gpuStatus:u.gpuFeatureStatus,screenReader:`${u.screenReader?"yes":"no"}`,remoteData:r};return d.isWindows||(M.load=`${w.loadavg().map(A=>Math.round(A)).join(", ")}`),d.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(u,r){const i=[];return(0,m.listProcesses)(u.mainPID).then(async o=>(i.push(""),i.push(this.formatEnvironment(u)),i.push(""),i.push(this.formatProcessList(u,o)),u.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(u))),r.forEach(h=>{if((0,S.isRemoteDiagnosticError)(h))i.push(`
${h.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${h.hostName}`),i.push(this.formatMachineInfo(h.machineInfo)),h.processes&&i.push(this.formatProcessList(u,h.processes)),h.workspaceMetadata)for(const v of Object.keys(h.workspaceMetadata)){const M=h.workspaceMetadata[v];let A=`${M.fileCount} files`;M.maxFilesReached&&(A=`more than ${A}`),i.push(`Folder (${v}): ${A}`),i.push(this.formatWorkspaceStats(M))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(u){const r=[],i=60;let o=0;const h=(L,F)=>{const U=` ${L}(${F})`;o+U.length>i?(r.push(v),v="|                 ",o=v.length):o+=U.length,v+=U};let v="|      File types:";const M=10;let A=u.fileTypes.length>M?M:u.fileTypes.length;for(let L=0;L<A;L++){const F=u.fileTypes[L];h(F.name,F.count)}if(r.push(v),u.configFiles.length>=0&&(v="|      Conf files:",o=0,u.configFiles.forEach(L=>{h(L.name,L.count)}),r.push(v)),u.launchConfigFiles.length>0){let L="|      Launch Configs:";u.launchConfigFiles.forEach(F=>{L+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),r.push(L)}return r.join(`
`)}expandGPUFeatures(u){const r=Math.max(...Object.keys(u).map(i=>i.length));return Object.keys(u).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${u[i]}`).join(`
                  `)}formatWorkspaceMetadata(u){const r=[],i=[];return u.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(r.push(`|  Window (${o.title})`),o.folderURIs.forEach(h=>{const v=g.URI.revive(h);if(v.scheme===n.Schemas.file){const M=v.fsPath;i.push(p(M,["node_modules",".git"]).then(A=>{let L=`${A.fileCount} files`;A.maxFilesReached&&(L=`more than ${L}`),r.push(`|    Folder (${(0,I.basename)(M)}): ${L}`),r.push(this.formatWorkspaceStats(A))}).catch(A=>{r.push(`|      Error: Unable to collect workspace stats for folder ${M} (${A.toString()})`)}))}else r.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>r.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(u,r){const i=new Map;u.windows.forEach(h=>i.set(h.pid,h.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(u.mainPID,i,o,r,0),o.join(`
`)}formatProcessItem(u,r,i,o,h){const v=h===0;let M;v?M=o.pid===u?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(h)} ${o.name}`,o.name==="window"&&(M=`${M} (${r.get(o.pid)})`));const A=process.platform==="win32"?o.mem:w.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(A/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(o.children)&&o.children.forEach(L=>this.formatProcessItem(u,r,i,L,h+1))}async reportWorkspaceStats(u){for(const{uri:r}of u.folders){const i=g.URI.revive(r);if(i.scheme!==n.Schemas.file)continue;const o=i.fsPath;try{const h=await p(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":u.telemetryId,rendererSessionId:u.rendererSessionId}),h.fileTypes.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:u.rendererSessionId,type:v.name,count:v.count})}),h.launchConfigFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:u.rendererSessionId,type:v.name,count:v.count})}),h.configFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:u.rendererSessionId,type:v.name,count:v.count})})}catch{}}}};l=de([te(0,b.ITelemetryService),te(1,f.IProductService)],l),e.DiagnosticsService=l}),define(Z[204],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class w{constructor(k){this.appenders=k}listen(k,n){throw new Error(`Event not found: ${n}`)}call(k,n,{eventName:I,data:d}){return this.appenders.forEach(g=>g.log(I,d)),Promise.resolve(null)}}e.TelemetryAppenderChannel=w;class R{constructor(k){this.channel=k}log(k,n){return this.channel.call("log",{eventName:k,data:n}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=R}),define(Z[65],x([0,1,47,13,18,28]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class n{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(p,P){return Promise.resolve(void 0)}publicLog2(p,P){return this.publicLog(p,P)}publicLogError(p,P){return Promise.resolve(void 0)}publicLogError2(p,P){return this.publicLogError(p,P)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=n,e.NullTelemetryService=new n;class I{async publicLog(p,P,c){}async publicLogError(p,P,c){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(b,p){return p.onDidChangeConfiguration(P=>{P.source!==6&&b.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(P.source),configurationKeys:t(P.sourceConfig)})})}e.configurationTelemetry=d;function g(b,p){return!(p.disableTelemetry||!b.enableTelemetry)}e.supportsTelemetry=g;function y(b){const p=b.getValue(k.TELEMETRY_SETTING_ID),P=b.getValue("telemetry.enableCrashReporter");if(b.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||P===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function E(b){const p=Object.create(null),P=Object.create(null),c=Object.create(null);S(b,c);for(let a in c){a=a.length>150?a.substr(a.length-149):a;const l=c[a];typeof l=="number"?P[a]=l:typeof l=="boolean"?P[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),p[a]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(p[a]=l)}return{properties:p,measurements:P}}e.validateTelemetryData=E;function m(b){if(!b)return"none";let p="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(c=>{b.indexOf(`${c}+`)===0&&(p=c)}),p}e.cleanRemoteAuthority=m;function S(b,p,P=0,c){if(!!b)for(let a of Object.getOwnPropertyNames(b)){const l=b[a],s=c?c+a:a;Array.isArray(l)?p[s]=(0,w.safeStringify)(l):l instanceof Date?p[s]=l.toISOString():(0,R.isObject)(l)?P<2?S(l,p,P+1,s+"."):p[s]=(0,w.safeStringify)(l):p[s]=l}}function t(b){if(!b)return[];const p=[];return f(p,"",b),p}function f(b,p,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(c=>f(b,p?`${p}.${c}`:c,P[c])):b.push(p)}}),define(Z[205],x([0,1,30,23,15,47,3,34,13,7,18,48,170,196,167,19,6,22,49,199,97,28,65]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b,p,P,c,a,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const u=n.isWeb?"web":(0,m.getTargetPlatform)(n.platform,I.arch);var r;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished"})(r||(r={}));function i(...N){return String(N.reduce((j,ne)=>j|ne,0))}var o;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const h={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},v={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},A={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class L{constructor(j=A){this.state=j}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(j,ne=this.state.pageSize){return new L({...this.state,pageNumber:j,pageSize:ne})}withFilter(j,...ne){const se=[...this.state.criteria,...ne.length?ne.map(oe=>({filterType:j,value:oe})):[{filterType:j}]];return new L({...this.state,criteria:se})}withSortBy(j){return new L({...this.state,sortBy:j})}withSortOrder(j){return new L({...this.state,sortOrder:j})}withFlags(...j){return new L({...this.state,flags:j.reduce((ne,se)=>ne|se,0)})}withAssetTypes(...j){return new L({...this.state,assetTypes:j})}get raw(){const{criteria:j,pageNumber:ne,pageSize:se,sortBy:oe,sortOrder:J,flags:ce,assetTypes:le}=this.state;return{filters:[{criteria:j,pageNumber:ne,pageSize:se,sortBy:oe,sortOrder:J}],assetTypes:le,flags:ce}}get searchText(){const j=this.state.criteria.filter(ne=>ne.filterType===o.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(j=>String(j.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function F(N,j){const ne=(N||[]).filter(se=>se.statisticName===j)[0];return ne?ne.value:0}function U(N){const j="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(se=>se.assetType.indexOf(j)===0).reduce((se,oe)=>{const J=G(N,oe.assetType);return J&&se.push([oe.assetType.substring(j.length),J]),se},[])}function Q(N){if(N.properties){const j=N.properties.filter(oe=>oe.key===h.Repository),ne=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),se=j.filter(oe=>ne.test(oe.value))[0];return se?{uri:se.value,fallbackUri:se.value}:null}return G(N,h.Repository)}function ie(N){return{uri:`${N.fallbackAssetUri}/${h.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${h.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function re(N){const j=G(N,h.Icon);if(j)return j;const ne=m.DefaultIconPath;return{uri:ne,fallbackUri:ne}}function G(N,j){return N.files.filter(se=>se.assetType===j)[0]?{uri:`${N.assetUri}/${j}`,fallbackUri:`${N.fallbackAssetUri}/${j}`}:null}function O(N,j){const ne=N.properties?N.properties.filter(oe=>oe.key===j):[],se=ne.length>0&&ne[0].value;return se?se.split(",").map(oe=>(0,S.adoptToGalleryExtensionId)(oe)):[]}function B(N){const j=N.properties?N.properties.filter(ne=>ne.key===v.Engine):[];return j.length>0&&j[0].value||""}function V(N){const j=N.properties?N.properties.filter(ne=>ne.key===v.PreRelease):[];return j.length>0&&j[0].value==="true"}function X(N){const j=N.properties?N.properties.filter(se=>se.key===v.LocalizedLanguages):[],ne=j.length>0&&j[0].value||"";return ne?ne.split(","):[]}function $(N){return N.indexOf("preview")!==-1}function H(N){return N.targetPlatform?(0,m.toTargetPlatform)(N.targetPlatform):"undefined"}function ee(N){const j=(0,w.distinct)(N.versions.map(H)),ne=!!N.tags?.includes(m.WEB_EXTENSION_TAG),se=j.indexOf("web");return ne?se===-1&&j.push("web"):se!==-1&&j.splice(se,1),j}function W(N,j){const ne=(0,m.getFallbackTargetPlarforms)(j);for(let se=0;se<N.length;se++){const oe=N[se];if(oe.version===N[se-1]?.version){let J=se;const ce=H(oe);if(ce===j)for(;J>0&&N[J-1].version===oe.version;)J--;else if(ne.includes(ce))for(;J>0&&N[J-1].version===oe.version&&H(N[J-1])!==j;)J--;J!==se&&(N.splice(se,1),N.splice(J,0,oe))}}return N}e.sortExtensionVersions=W;function C(N,j,ne,se,oe){const J=N.versions[0],ce={manifest:G(j,h.Manifest),readme:G(j,h.Details),changelog:G(j,h.Changelog),license:G(j,h.License),repository:Q(j),download:ie(j),icon:re(j),coreTranslations:U(j)};return{identifier:{id:(0,S.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:j.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,description:N.shortDescription||"",installCount:F(N.statistics,"install"),rating:F(N.statistics,"averagerating"),ratingCount:F(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:ne,assets:ce,properties:{dependencies:O(j,v.Dependency),extensionPack:O(j,v.ExtensionPack),engine:B(j),localizedLanguages:X(j),targetPlatform:H(j),isPreReleaseVersion:V(j)},hasPreReleaseVersion:V(J),hasReleaseVersion:se,preview:$(N.flags),telemetryData:oe}}let T=class{constructor(j,ne,se,oe,J,ce,le,he){this.requestService=ne,this.logService=se,this.environmentService=oe,this.telemetryService=J,this.fileService=ce,this.productService=le,this.configurationService=he;const ge=le.extensionsGallery;this.extensionsGalleryUrl=ge&&ge.serviceUrl,this.extensionsControlUrl=ge&&ge.controlUrl,this.commonHeadersPromise=Y(le.version,le,this.environmentService,this.configurationService,this.fileService,j)}api(j=""){return`${this.extensionsGalleryUrl}${j}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(j,ne,se){const oe=(0,d.isBoolean)(ne)?ne:!1,J=(0,d.isBoolean)(ne)?se:ne;let ce=new L().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,j.length).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExtensionName,...j.map(({id:ge})=>ge.toLowerCase()));j.every(ge=>!ge.version)&&(ce=ce.withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties,r.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,u,R.CancellationToken.None),he=le.map(ge=>{const be=(0,S.getGalleryExtensionId)(ge.publisher.publisherName,ge.extensionName);return{rawGalleryExtension:ge,version:j.find(fe=>(0,S.areSameExtensions)(fe,{id:be}))?.version}});return this.converToGalleryExtensions(he,oe,u,()=>{},J)}async getCompatibleExtension(j,ne,se){const oe=(0,m.isIExtensionIdentifier)(j)?null:j;if(oe){if((0,m.isNotWebExtensionInWebTargetPlatform)(oe.allTargetPlatforms,se))return null;if(await this.isExtensionCompatible(oe,ne,se))return oe}const{id:J,uuid:ce}=oe?oe.identifier:j;let le=new L().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");ce?le=le.withFilter(o.ExtensionId,ce):le=le.withFilter(o.ExtensionName,J);const{galleryExtensions:he}=await this.queryGallery(le,se,R.CancellationToken.None),[ge]=he;if(!ge||!ge.versions.length)return null;const be=ee(ge);if((0,m.isNotWebExtensionInWebTargetPlatform)(be,se))return null;for(let fe of ge.versions){if(!B(fe)){const me=await this.getEngine(fe);fe={...fe,properties:[...fe.properties||[],{key:v.Engine,value:me}]}}if(await this.isRawExtensionVersionCompatible(fe,ne,be,se)){const me=ge.versions.some(pe=>!V(pe));return C(ge,fe,be,me)}}return null}async isExtensionCompatible(j,ne,se){if(!(0,m.isTargetPlatformCompatible)(j.properties.targetPlatform,j.allTargetPlatforms,se)||!ne&&j.properties.isPreReleaseVersion)return!1;let oe=j.properties.engine;if(!oe){const J=await this.getManifest(j,R.CancellationToken.None);if(!J)throw new Error("Manifest was not found");oe=J.engines.vscode}return(0,t.isEngineValid)(oe,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(j,ne,se,oe){if(!(0,m.isTargetPlatformCompatible)(H(j),se,oe)||!ne&&V(j))return!1;const J=await this.getEngine(j);return(0,t.isEngineValid)(J,this.productService.version,this.productService.date)}async query(j,ne){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=j.text||"";const oe=(0,k.getOrDefault)(j,fe=>fe.pageSize,50);let J=new L().withFlags(r.IncludeLatestVersionOnly,r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,oe).withFilter(o.Target,"Microsoft.VisualStudio.Code");se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,pe)=>(J=J.withFilter(o.Category,pe||me),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,pe)=>(J=J.withFilter(o.Tag,pe||me),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(J=J.withFilter(o.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),J=J.withFilter(o.SearchText,se)),J=J.withSortBy(0)):j.ids?J=J.withFilter(o.ExtensionId,...j.ids):j.names?J=J.withFilter(o.ExtensionName,...j.names):J=J.withSortBy(4),typeof j.sortBy=="number"&&(J=J.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(J=J.withSortOrder(j.sortOrder));const{galleryExtensions:ce,total:le}=await this.queryGallery(J,u,ne),he=fe=>({index:(J.pageNumber-1)*J.pageSize+fe,querySource:j.source}),ge=await this.converToGalleryExtensions(ce.map(fe=>({rawGalleryExtension:fe})),!!j.includePreRelease,u,he,ne),be=async(fe,me)=>{if(me.isCancellationRequested)throw(0,D.canceled)();const pe=J.withPage(fe+1),{galleryExtensions:Pe}=await this.queryGallery(pe,u,me);return await this.converToGalleryExtensions(Pe.map(Re=>({rawGalleryExtension:Re})),!!j.includePreRelease,u,he,ne)};return{firstPage:ge,total:le,pageSize:J.pageSize,getPage:be}}async converToGalleryExtensions(j,ne,se,oe,J){const ce=(ge,be,fe)=>{const me=ee(ge);let pe=ge.versions[0];return pe=ge.versions.find(Pe=>Pe.version===pe.version&&(0,m.isTargetPlatformCompatible)(H(Pe),me,se))||pe,V(pe)&&!ne&&(pe=ge.versions.find(Pe=>Pe.version!==pe.version&&!V(Pe))||pe),C(ge,pe,me,fe,oe(be))},le=[],he=new Map;for(let ge=0;ge<j.length;ge++){const{rawGalleryExtension:be,version:fe}=j[ge],me=be.versions.some(pe=>!V(pe));if(fe){const pe=be.versions.find(Pe=>Pe.version===fe);pe&&le.push([ge,C(be,pe,ee(be),me)])}else{const pe=ce(be,ge,me);pe.properties.isPreReleaseVersion?he.set(pe.identifier.uuid,ge):le.push([ge,pe])}}if(he.size){const ge=new Date().getTime(),be=new L().withFlags(r.IncludeVersions,r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,he.size).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExtensionId,...he.keys()),{galleryExtensions:fe}=await this.queryGallery(be,se,J);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-ge,count:he.size}),fe.length!==he.size)throw new Error("Not all extensions with latest versions are returned");for(const me of fe){const pe=me.versions.some(Fe=>!V(Fe)),Pe=he.get(me.extensionId),Re=ce(me,Pe,pe);le.push([Pe,Re])}}return le.sort((ge,be)=>ge[0]-be[0]).map(([,ge])=>ge)}async queryGallery(j,ne,se){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,r.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,i(r.Unpublished));const oe=await this.commonHeadersPromise,J=JSON.stringify(j.raw),ce={...oe,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},le=new Date().getTime();let he,ge,be=0;try{if(he=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:J,headers:ce},se),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:be};const fe=await(0,P.asJson)(he);if(fe){const me=fe.results[0],pe=me.extensions;pe.forEach(Re=>W(Re.versions,ne));const Pe=me.resultMetadata&&me.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return be=Pe&&Pe.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:be}}return{galleryExtensions:[],total:be}}catch(fe){throw ge=fe,fe}finally{this.telemetryService.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(J.length),duration:new Date().getTime()-le,success:!!he&&(0,P.isSuccess)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:ge?(0,D.isPromiseCanceledError)(ge)?"canceled":(0,D.getErrorMessage)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(be)})}}async reportStatistic(j,ne,se,oe){if(!this.isEnabled())return;const J=n.isWeb?this.api(`/itemName/${j}.${ne}/version/${se}/statType/${oe==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${j}/extensions/${ne}/${se}/stats?statType=${oe}`),ce=n.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",he={...await this.commonHeadersPromise,Accept:ce};try{await this.requestService.request({type:"POST",url:J,headers:he},R.CancellationToken.None)}catch(ge){}}async download(j,ne,se){this.logService.trace("ExtensionGalleryService#download",j.identifier.id);const oe=(0,S.getGalleryExtensionTelemetryData)(j),J=new Date().getTime(),ce=be=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...oe,duration:be}),le=se===2?"install":se===3?"update":"",he=le?{uri:`${j.assets.download.uri}${g.URI.parse(j.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${j.assets.download.fallbackUri}${g.URI.parse(j.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:j.assets.download,ge=await this.getAsset(he);await this.fileService.writeFile(ne,ge.stream),ce(new Date().getTime()-J)}async getReadme(j,ne){if(j.assets.readme){const se=await this.getAsset(j.assets.readme,{},ne);return await(0,P.asText)(se)||""}return""}async getManifest(j,ne){if(j.assets.manifest){const se=await this.getAsset(j.assets.manifest,{},ne),oe=await(0,P.asText)(se);return oe?JSON.parse(oe):null}return null}async getManifestFromRawExtensionVersion(j,ne){const se=G(j,h.Manifest);if(!se)throw new Error("Manifest was not found");const oe={"Accept-Encoding":"gzip"},J=await this.getAsset(se,{headers:oe});return await(0,P.asJson)(J)}async getCoreTranslation(j,ne){const se=j.assets.coreTranslations.filter(oe=>oe[0]===ne.toUpperCase())[0];if(se){const oe=await this.getAsset(se[1]),J=await(0,P.asText)(oe);return J?JSON.parse(J):null}return null}async getChangelog(j,ne){if(j.assets.changelog){const se=await this.getAsset(j.assets.changelog,{},ne);return await(0,P.asText)(se)||""}return""}async getAllCompatibleVersions(j,ne,se){let oe=new L().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");j.identifier.uuid?oe=oe.withFilter(o.ExtensionId,j.identifier.uuid):oe=oe.withFilter(o.ExtensionName,j.identifier.id);const{galleryExtensions:J}=await this.queryGallery(oe,se,R.CancellationToken.None);if(!J.length)return[];const ce=ee(J[0]);if((0,m.isNotWebExtensionInWebTargetPlatform)(ce,se))return[];const le=[];for(const he of J[0].versions)try{le[le.length-1]?.version!==he.version&&await this.isRawExtensionVersionCompatible(he,ne,ce,se)&&le.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:V(he)})}catch(ge){}return le}async getAsset(j,ne={},se=R.CancellationToken.None){const oe=await this.commonHeadersPromise,J={type:"GET"},ce={...oe,...ne.headers||{}};ne={...ne,...J,headers:ce};const le=j.uri,he=j.fallbackUri,ge={...ne,url:le};try{const be=await this.requestService.request(ge,se);if(be.res.statusCode===200)return be;const fe=await(0,P.asText)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${fe}`)}catch(be){if((0,D.isPromiseCanceledError)(be))throw be;const fe=(0,D.getErrorMessage)(be);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:fe});const me={...ne,url:he};return this.requestService.request(me,se)}}async getEngine(j){let ne=B(j);if(!ne){const se=await this.getManifestFromRawExtensionVersion(j,R.CancellationToken.None);if(!se)throw new Error("Manifest was not found");ne=se.engines.vscode}return ne}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const j=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const ne=await(0,P.asJson)(j),se=[],oe={};if(ne){for(const J of ne.malicious)se.push({id:J});if(ne.unsupported)for(const J of Object.keys(ne.unsupported)){const ce=ne.unsupported[J];(0,d.isBoolean)(ce)||(oe[J.toLowerCase()]=ce.preReleaseExtension)}}return{malicious:se,unsupportedPreReleaseExtensions:oe}}};T=de([te(1,P.IRequestService),te(2,b.ILogService),te(3,E.IEnvironmentService),te(4,l.ITelemetryService),te(5,f.IFileService),te(6,p.IProductService),te(7,y.IConfigurationService)],T);let _=class extends T{constructor(j,ne,se,oe,J,ce,le,he){super(j,ne,se,oe,J,ce,le,he)}};_=de([te(0,a.IStorageService),te(1,P.IRequestService),te(2,b.ILogService),te(3,E.IEnvironmentService),te(4,l.ITelemetryService),te(5,f.IFileService),te(6,p.IProductService),te(7,y.IConfigurationService)],_),e.ExtensionGalleryService=_;let z=class extends T{constructor(j,ne,se,oe,J,ce,le){super(void 0,j,ne,se,oe,J,ce,le)}};z=de([te(0,P.IRequestService),te(1,b.ILogService),te(2,E.IEnvironmentService),te(3,l.ITelemetryService),te(4,f.IFileService),te(5,p.IProductService),te(6,y.IConfigurationService)],z),e.ExtensionGalleryServiceWithNoStorageService=z;async function Y(N,j,ne,se,oe,J){const ce={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N}`},le=await(0,c.getServiceMachineId)(ne,oe,J);return(0,s.supportsTelemetry)(j,ne)&&(0,s.getTelemetryLevel)(se)===3&&(ce["X-Market-User-Id"]=le),ce}e.resolveMarketplaceHeaders=Y}),define(Z[206],x([0,1,2,47,3,25,152,18,56,54,40,28,65]),function(q,e,w,R,D,k,n,I,d,g,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(b,p){this._configurationService=p,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appenders=b.appenders,this._commonProperties=b.commonProperties||Promise.resolve({}),this._piiPaths=b.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!b.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(P),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(P=>{const c=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!c})})}setExperimentProperty(b,p){this._experimentProperties[b]=p}_updateTelemetryLevel(){this._telemetryLevel=(0,m.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const b=await this._commonProperties;let p=b.sessionID,P=b["common.machineId"],c=b["common.firstSessionDate"],a=b["common.msftInternal"];return{sessionId:p,machineId:P,firstSessionDate:c,msftInternal:a}}dispose(){this._disposables.dispose()}_log(b,p,P,c){return this.telemetryLevel<p?Promise.resolve(void 0):this._commonProperties.then(a=>{P=(0,R.mixin)(P,a),P=(0,R.mixin)(P,this._experimentProperties),P=(0,R.cloneAndChange)(P,l=>{if(typeof l=="string")return this._cleanupInfo(l,c)}),this._appenders.forEach(l=>l.log(b,P))},a=>{console.error(a)})}publicLog(b,p,P){return this._log(b,3,p,P)}publicLog2(b,p,P){return this.publicLog(b,p,P)}publicLogError(b,p){return this.sendErrorTelemetry?this._log(b,2,p,!0):Promise.resolve(void 0)}publicLogError2(b,p){return this.publicLogError(b,p)}_anonymizeFilePaths(b){let p=b;const P=[];for(let s of this._cleanupPatterns)for(;;){const u=s.exec(b);if(!u)break;P.push([u.index,s.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(p="";;){const s=a.exec(b);if(!s)break;!c.test(s[0])&&P.every(([u,r])=>s.index<u||s.index>=r)&&(p+=b.substring(l,s.index)+"<REDACTED: user-file-path>",l=a.lastIndex)}return l<b.length&&(p+=b.substr(l)),p}_removePropertiesWithPossibleUserInfo(b){if(!b)return b;const p=b.toLowerCase(),P=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(p)?"<REDACTED: secret>":P.test(p)?"<REDACTED: email>":b}_cleanupInfo(b,p){let P=b;p&&(P=this._anonymizeFilePaths(P));for(let c of this._cleanupPatterns)P=P.replace(c,"");return P=this._removePropertiesWithPossibleUserInfo(P),P}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=de([te(1,I.IConfigurationService)],S),e.TelemetryService=S;function t(){const f=(0,n.localize)(0,null,g.default.nameLong),b=g.default.privacyStatementUrl?(0,n.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,n.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=D.isWeb?"":(0,n.localize)(3,null),P=(0,n.localize)(4,null),c=(0,n.localize)(5,null),a=(0,n.localize)(6,null),l=(0,n.localize)(7,null),s=`
|       | ${P} | ${c} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,u=(0,n.localize)(8,null);return`
${f} ${b} ${p}

&nbsp;

${l}
${s}

&nbsp;

${u}
`}y.Registry.as(d.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,n.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,n.localize)(10,null),(0,n.localize)(11,null),(0,n.localize)(12,null),(0,n.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(d.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,n.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,n.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,n.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,n.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[207],x([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(Z[208],x([0,1,108,4,2,5,40,207]),function(q,e,w,R,D,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var d;(function(b){function p(P){return P&&typeof P=="object"&&typeof P.id=="string"}b.isThemeColor=p})(d=e.ThemeColor||(e.ThemeColor={}));function g(b){return{id:b}}e.themeColorFromId=g;var y;(function(b){function p(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||d.isThemeColor(r.color))}b.isThemeIcon=p;const P=new RegExp(`^\\$\\((${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?)\\)$`);function c(r){const i=P.exec(r);if(!i)return;let[,o]=i;return{id:o}}b.fromString=c;function a(r,i){let o=r.id;const h=o.lastIndexOf("~");return h!==-1&&(o=o.substring(0,h)),i&&(o=`${o}~${i}`),{id:o}}b.modify=a;function l(r){const i=r.id.lastIndexOf("~");if(i!==-1)return r.id.substring(i+1)}b.getModifier=l;function s(r,i){return r.id===i.id&&r.color?.id===i.color?.id}b.isEqual=s;function u(r,i){return{id:r.id,color:i?g(i):void 0}}b.asThemeIcon=u,b.asClassNameArray=w.CSSIcon.asClassNameArray,b.asClassName=w.CSSIcon.asClassName,b.asCSSSelector=w.CSSIcon.asCSSSelector})(y=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=w.Codicon.file,e.FolderThemeIcon=w.Codicon.folder;function E(b){switch(b){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new R.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,D.toDisposable)(()=>{const P=this.themingParticipants.indexOf(p);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new m;n.Registry.add(e.Extensions.ThemingContribution,S);function t(b){return S.onColorThemeChange(b)}e.registerThemingParticipant=t;class f extends D.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,P){let c=this.theme.getColor(p);return c&&P&&(c=P(c,this.theme)),c?c.toString():null}}e.Themable=f}),define(Z[66],x([0,1,14,3,5,37]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const n="#FFFFFF",I="#1E1E1E",d="#000000",g="theme",y="themeBackground",E="windowSplash";e.IThemeMainService=(0,D.createDecorator)("themeMainService");let m=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((R.isWindows||R.isMacintosh)&&w.nativeTheme.shouldUseInvertedColorScheme)return d;let t=this.stateMainService.getItem(y,null);if(!t){let f;(R.isWindows||R.isMacintosh)&&w.nativeTheme.shouldUseInvertedColorScheme?f="hc-black":f=this.stateMainService.getItem(g,"vs-dark").split(" ")[0],t=f==="hc-black"?d:f==="vs"?n:I}return R.isMacintosh&&t.toUpperCase()===I&&(t="#171717"),t}saveWindowSplash(t,f){this.stateMainService.setItems([{key:g,data:f.baseTheme},{key:y,data:f.colorInfo.background},{key:E,data:f}]),typeof t=="number"&&this.updateBackgroundColor(t,f)}updateBackgroundColor(t,f){for(const b of w.BrowserWindow.getAllWindows())if(b.id===t){b.setBackgroundColor(f.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(E)}};m=de([te(0,k.IStateMainService)],m),e.ThemeMainService=m}),define(Z[41],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var R;(function(k){k.Uninitialized="uninitialized",k.Idle="idle",k.CheckingForUpdates="checking for updates",k.AvailableForDownload="available for download",k.Downloading="downloading",k.Downloaded="downloaded",k.Updating="updating",k.Ready="ready"})(R=e.StateType||(e.StateType={}));var D;(function(k){k[k.Setup=0]="Setup",k[k.Archive=1]="Archive",k[k.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(k,n)=>({type:"idle",updateType:k,error:n}),CheckingForUpdates:k=>({type:"checking for updates",explicit:k}),AvailableForDownload:k=>({type:"available for download",update:k}),Downloading:k=>({type:"downloading",update:k}),Downloaded:k=>({type:"downloaded",update:k}),Updating:k=>({type:"updating",update:k}),Ready:k=>({type:"ready",update:k})},e.IUpdateService=(0,w.createDecorator)("updateService")}),define(Z[209],x([0,1,3,153,56,40]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),k.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:w.isWindows&&!w.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[210],x([0,1,4,41]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(I){this.service=I}listen(I,d){switch(d){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${d}`)}call(I,d,g){switch(d){case"checkForUpdates":return this.service.checkForUpdates(g);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${d}`)}}e.UpdateChannel=D;class k{constructor(I){this.channel=I,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event,this._state=R.State.Uninitialized,this.channel.listen("onStateChange")(d=>this.state=d),this.channel.call("_getInitialState").then(d=>this.state=d)}get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=k}),define(Z[98],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,w.createDecorator)("urlService")}),define(Z[211],x([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class R{constructor(I){this.handler=I}listen(I,d){throw new Error(`Event not found: ${d}`)}call(I,d,g){switch(d){case"handleURL":return this.handler.handleURL(w.URI.revive(g[0]),g[1])}throw new Error(`Call not found: ${d}`)}}e.URLHandlerChannel=R;class D{constructor(I){this.channel=I}handleURL(I,d){return this.channel.call("handleURL",[I.toJSON(),d])}}e.URLHandlerChannelClient=D;class k{constructor(I){this.next=I}async routeCall(I,d,g,y){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(g){const E=w.URI.revive(g);if(E&&E.query){const m=/\bwindowId=(\d+)/.exec(E.query);if(m){const S=m[1],t=new RegExp(`window:${S}`),f=I.connections.find(b=>t.test(b.ctx));if(f)return f}}}return this.next.routeCall(I,d,g,y)}routeEvent(I,d){throw new Error(`Event not found: ${d}`)}}e.URLHandlerRouter=k}),define(Z[212],x([0,1,8,2,7,22]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class n extends R.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(g,y){const E=[...this.handlers.values()];return(0,w.first)(E.map(m=>()=>m.handleURL(g,y)),void 0,!1).then(m=>m||!1)}registerHandler(g){return this.handlers.add(g),(0,R.toDisposable)(()=>this.handlers.delete(g))}}e.AbstractURLService=n;let I=class extends n{constructor(g){super();this.productService=g}create(g){let{authority:y,path:E,query:m,fragment:S}=g||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&E&&E.indexOf("/")!==0&&(E=`/${E}`),D.URI.from({scheme:this.productService.urlProtocol,authority:y,path:E,query:m,fragment:S})}};I=de([te(0,k.IProductService)],I),e.NativeURLService=I}),define(Z[213],x([0,1,14,8,4,2,3,7]),function(q,e,w,R,D,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function d(y){try{return I.URI.parse(y)}catch(E){return null}}class g{constructor(E,m,S,t,f){if(this.urlService=m,this.uris=[],this.retryCount=0,this.flushDisposable=k.Disposable.None,this.disposables=new k.DisposableStore,this.uris=E,n.isWindows){const P=t.isBuilt?[]:[`"${t.appRoot}"`];P.push("--open-url","--"),w.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,P)}const b=D.Event.map(D.Event.fromNodeEventEmitter(w.app,"open-url",(P,c)=>({event:P,url:c})),({event:P,url:c})=>(P.preventDefault(),c));this.disposables.add(b(P=>{const c=d(P);!c||this.urlService.open(c,{originalUrl:P})})),S.getWindows().filter(P=>P.isReady).length>0?this.flush():D.Event.once(S.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const E=[];for(const m of this.uris)await this.urlService.open(m.uri,{originalUrl:m.url})||E.push(m);E.length!==0&&(this.uris=E,this.flushDisposable=(0,R.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=g}),define(Z[214],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,w.createDecorator)("webviewManagerService")}),define(Z[215],x([0,1,14,2,10,7]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class n extends R.Disposable{constructor(){super();const d=this.handleWebviewRequest.bind(this);w.protocol.registerFileProtocol(D.Schemas.vscodeWebview,d)}handleWebviewRequest(d,g){try{const y=k.URI.parse(d.url),E=n.validWebviewFilePaths.get(y.path);if(typeof E=="string"){const m=`vs/workbench/contrib/webview/browser/pre/${E}`,S=D.FileAccess.asFileUri(m,q);return g(decodeURIComponent(S.fsPath))}else return g({error:-10})}catch{}return g({error:-2})}}e.WebviewProtocolProvider=n,n.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[67],x([0,1,3]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(g){return!!g.workspaceUri}e.isWorkspaceToOpen=R;function D(g){return!!g.folderUri}e.isFolderToOpen=D;function k(g){return!!g.fileUri}e.isFileToOpen=k;function n(g){const y=I(g),E=g.getValue("window.menuBarVisibility");return E==="default"||y==="native"&&E==="compact"||w.isMacintosh&&w.isNative?"classic":E}e.getMenuBarVisibility=n;function I(g){if(w.isWeb)return"custom";const y=g.getValue("window");if(y){if(w.isMacintosh&&y.nativeTabs===!0||w.isMacintosh&&y.nativeFullScreen===!1)return"native";const S=g.getValue("workbench.colorCustomizations");if(S?.["window.activeBorder"]||S?.["window.inactiveBorder"])return"custom";const t=y.titleBarStyle;if(t==="native"||t==="custom")return t}return w.isLinux?"native":"custom"}e.getTitleBarStyle=I;function d(g=0){return Math.pow(1.2,g)}e.zoomLevelToZoomFactor=d}),define(Z[35],x([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var R;(function(g){g[g.INITIAL=1]="INITIAL",g[g.LOAD=2]="LOAD",g[g.RELOAD=3]="RELOAD"})(R=e.LoadReason||(e.LoadReason={}));var D;(function(g){g[g.CLOSE=1]="CLOSE",g[g.QUIT=2]="QUIT",g[g.RELOAD=3]="RELOAD",g[g.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var k;(function(g){g[g.CLI=0]="CLI",g[g.DOCK=1]="DOCK",g[g.MENU=2]="MENU",g[g.DIALOG=3]="DIALOG",g[g.DESKTOP=4]="DESKTOP",g[g.API=5]="API"})(k=e.OpenContext||(e.OpenContext={}));const n=function(g=1){return{width:1024,height:768,mode:g}};e.defaultWindowState=n;var I;(function(g){g[g.Maximized=0]="Maximized",g[g.Normal=1]="Normal",g[g.Minimized=2]="Minimized",g[g.Fullscreen=3]="Fullscreen"})(I=e.WindowMode||(e.WindowMode={}));var d;(function(g){g[g.UNRESPONSIVE=1]="UNRESPONSIVE",g[g.CRASHED=2]="CRASHED",g[g.LOAD=3]="LOAD"})(d=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,w.createDecorator)("windowsMainService")}),define(Z[216],x([0,1,14,4,2,215,35]),function(q,e,w,R,D,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends D.Disposable{constructor(g){super();this.windowsMainService=g,this._onFoundInFrame=this._register(new R.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new k.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(g,y){let E;if(typeof g.windowId=="number"){const{windowId:m}=g,S=this.windowsMainService.getWindowById(m);if(!S?.win)throw new Error(`Invalid windowId: ${m}`);E=S.win.webContents}else{const{webContentsId:m}=g;if(E=w.webContents.fromId(m),!E)throw new Error(`Invalid webContentsId: ${m}`)}E.isDestroyed()||E.setIgnoreMenuShortcuts(y)}async findInFrame(g,y,E,m){const t=this.getFrameByName(g,y);if(typeof t.findInFrame=="function"){t.findInFrame(E,{findNext:m.findNext,forward:m.forward});const f=(b,p)=>{p.finalUpdate&&(this._onFoundInFrame.fire(p),t.removeListener("found-in-frame",f))};t.on("found-in-frame",f)}}async stopFindInFrame(g,y,E){const S=this.getFrameByName(g,y);typeof S.stopFindInFrame=="function"&&S.stopFindInFrame(E.keepSelection?"keepSelection":"clearSelection")}getFrameByName(g,y){const E=this.windowsMainService.getWindowById(g.windowId);if(!E?.win)throw new Error(`Invalid windowId: ${g}`);const m=E.win.webContents.mainFrame.framesInSubtree.find(S=>S.name===y);if(!m)throw new Error(`Unknown frame: ${y}`);return m}};I=de([te(0,n.IWindowsMainService)],I),e.WebviewMainService=I}),define(Z[217],x([0,1,8,4,2]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends D.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:d,getActiveWindowId:g}){super();this.disposables=this._register(new D.DisposableStore),R.Event.latch(R.Event.any(I,d))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,w.createCancelablePromise)(()=>g()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch(E){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(Z[218],x([0,1,39,16,7,5]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");var n;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(n=e.WorkbenchState||(e.WorkbenchState={}));function I(m){const S=m;return!!(S&&typeof S=="object"&&typeof S.id=="string"&&Array.isArray(S.folders))}e.isWorkspace=I;function d(m){const S=m;return!!(S&&typeof S=="object"&&D.URI.isUri(S.uri)&&typeof S.name=="string"&&typeof S.toResource=="function")}e.isWorkspaceFolder=d;class g{constructor(S,t,f,b,p){this._id=S,this._transient=f,this._configuration=b,this._ignorePathCasing=p,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(S){this._id=S.id,this._configuration=S.configuration,this._transient=S.transient,this._ignorePathCasing=S._ignorePathCasing,this.folders=S.folders}get folders(){return this._folders}set folders(S){this._folders=S,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(S){this._configuration=S}getFolder(S){return S&&this._foldersMap.findSubstr(S.with({scheme:S.scheme,authority:S.authority,path:S.path}))||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing);for(const S of this.folders)this._foldersMap.set(S.uri,S)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class y{constructor(S,t){this.raw=t,this.uri=S.uri,this.index=S.index,this.name=S.name}toResource(S){return(0,R.joinPath)(this.uri,S)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=y;function E(m){return new y({uri:m,index:0,name:(0,R.basenameOrAuthority)(m)},{uri:m.toString()})}e.toWorkspaceFolder=E}),define(Z[29],x([0,1,32,38,78,33,10,9,3,16,7,156,5,64,218]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(V){return(typeof V=="string"?(0,I.extname)(V):(0,g.extname)(V))===f}e.hasWorkspaceFileExtension=b,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function p(V){return V.hasOwnProperty("workspace")}e.isRecentWorkspace=p;function P(V){return V.hasOwnProperty("folderUri")}e.isRecentFolder=P;function c(V){return V.hasOwnProperty("fileUri")}e.isRecentFile=c;function a(V){return V&&V.hasOwnProperty("folderUri")}e.isFolderBackupInfo=a;function l(V){return V&&V.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=l;function s(V){const X=V;return typeof X?.id=="string"&&y.URI.isUri(X.uri)}e.isSingleFolderWorkspaceIdentifier=s;function u(V){if(V.configuration)return{id:V.id,configPath:V.configuration};if(V.folders.length===1)return{id:V.id,uri:V.folders[0].uri}}e.toWorkspaceIdentifier=u;function r(V){const X=V;return typeof X?.id=="string"&&y.URI.isUri(X.configPath)}e.isWorkspaceIdentifier=r;function i(V){const X=V;if(X?.uri)return{id:X.id,uri:y.URI.revive(X.uri)};const $=V;if($?.configPath)return{id:$.id,configPath:y.URI.revive($.configPath)};if(V?.id)return{id:V.id}}e.reviveIdentifier=i;function o(V,X){return g.extUriBiasedIgnorePathCase.isEqualOrParent(V,X.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function h(V){return v(V)||M(V)}e.isStoredWorkspaceFolder=h;function v(V){const X=V;return typeof X?.path=="string"&&(!X.name||typeof X.name=="string")}e.isRawFileWorkspaceFolder=v;function M(V){const X=V;return typeof X?.uri=="string"&&(!X.name||typeof X.name=="string")}e.isRawUriWorkspaceFolder=M;function A(V,X,$,H,ee=!d.isWindows,W){if(V.scheme!==H.scheme)return{name:$,uri:V.toString(!0)};let C=X?void 0:W.relativePath(H,V);if(C!==void 0)C.length===0?C=".":d.isWindows&&V.scheme===n.Schemas.file&&!ee&&(C=C.replace(/\//g,"\\"));else if(V.scheme===n.Schemas.file)C=V.fsPath,d.isWindows&&(C=(0,k.normalizeDriveLetter)(C),ee&&(C=(0,w.toSlashes)(C)));else{if(!W.isEqualAuthority(V.authority,H.authority))return{name:$,uri:V.toString(!0)};C=V.path}return{name:$,path:C}}e.getStoredWorkspaceFolder=A;function L(V,X,$){let H=[],ee=new Set;const W=$.dirname(X);for(let C of V){let T;if(v(C))C.path&&(T=$.resolvePath(W,C.path));else if(M(C))try{T=y.URI.parse(C.uri),T.path[0]!=="/"&&(T=T.with({path:"/"+T.path}))}catch(_){console.warn(_)}if(T){let _=$.getComparisonKey(T);if(!ee.has(_)){ee.add(_);const z=C.name||$.basenameOrAuthority(T);H.push(new t.WorkspaceFolder({uri:T,name:z,index:H.length},C))}}}return H}e.toWorkspaceFolders=L;function F(V,X,$,H,ee){let W=U(X,V);const C=ee.dirname(X),T=ee.dirname(H),_=[],z=Q(W.folders);for(const ne of W.folders){const se=v(ne)?ee.resolvePath(C,ne.path):y.URI.parse(ne.uri);let oe;$?oe=!1:oe=!v(ne)||(0,I.isAbsolute)(ne.path),_.push(A(se,oe,ne.name,T,z,ee))}const Y={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},N=D.setProperty(V,["folders"],_,Y);let j=D.applyEdits(V,N);return(0,g.isEqualAuthority)(W.remoteAuthority,(0,S.getRemoteAuthority)(H))&&(j=D.applyEdits(j,D.removeProperty(j,["remoteAuthority"],Y))),j}e.rewriteWorkspaceFileForNewLocation=F;function U(V,X){let $=R.parse(X);if($&&Array.isArray($.folders))$.folders=$.folders.filter(H=>h(H));else throw new Error(`${V} looks like an invalid workspace file.`);return $}function Q(V){return d.isWindows?V.some(X=>v(X)&&X.path.indexOf("/")>=0):!0}e.useSlashForPath=Q;function ie(V){return V.workspace&&typeof V.workspace=="object"&&typeof V.workspace.id=="string"&&typeof V.workspace.configPath=="string"}function re(V){return typeof V.folderUri=="string"}function G(V){return typeof V.fileUri=="string"}function O(V,X){const $={workspaces:[],files:[]};if(V){const H=function(W,C){for(let T=0;T<W.length;T++)try{C(W[T],T)}catch(_){X.warn(`Error restoring recent entry ${JSON.stringify(W[T])}: ${_.toString()}. Skip entry.`)}},ee=V;if(Array.isArray(ee.entries))H(ee.entries,W=>{const C=W.label,T=W.remoteAuthority;ie(W)?$.workspaces.push({label:C,remoteAuthority:T,workspace:{id:W.workspace.id,configPath:y.URI.parse(W.workspace.configPath)}}):re(W)?$.workspaces.push({label:C,remoteAuthority:T,folderUri:y.URI.parse(W.folderUri)}):G(W)&&$.files.push({label:C,remoteAuthority:T,fileUri:y.URI.parse(W.fileUri)})});else{const W=V;Array.isArray(W.workspaces3)&&H(W.workspaces3,(C,T)=>{const _=Array.isArray(W.workspaceLabels)&&W.workspaceLabels[T]||void 0;typeof C=="object"&&typeof C.id=="string"&&typeof C.configURIPath=="string"?$.workspaces.push({label:_,workspace:{id:C.id,configPath:y.URI.parse(C.configURIPath)}}):typeof C=="string"&&$.workspaces.push({label:_,folderUri:y.URI.parse(C)})}),Array.isArray(W.files2)&&H(W.files2,(C,T)=>{const _=Array.isArray(W.fileLabels)&&W.fileLabels[T]||void 0;typeof C=="string"&&$.files.push({label:_,fileUri:y.URI.parse(C)})})}}return $}e.restoreRecentlyOpened=O;function B(V){const X={entries:[]};for(const $ of V.workspaces)P($)?X.entries.push({folderUri:$.folderUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority}):X.entries.push({workspace:{id:$.workspace.id,configPath:$.workspace.configPath.toString()},label:$.label,remoteAuthority:$.remoteAuthority});for(const $ of V.files)X.entries.push({fileUri:$.fileUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority});return X}e.toStoreData=B}),define(Z[50],x([0,1,14,8,81,33,2,70,9,3,13,21,136,5,6,37,29]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,S.createDecorator)("dialogMainService");let p=class vt{constructor(c,a){this.stateMainService=c,this.logService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new R.Queue}pickFileFolder(c,a){return this.doPick({...c,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},a)}pickFolder(c,a){return this.doPick({...c,pickFolders:!0,title:(0,m.localize)(1,null)},a)}pickFile(c,a){return this.doPick({...c,pickFiles:!0,title:(0,m.localize)(2,null)},a)}pickWorkspace(c,a){const l=(0,m.localize)(3,null),s=(0,k.mnemonicButtonLabel)((0,m.localize)(4,null)),u=b.WORKSPACE_FILTER;return this.doPick({...c,pickFiles:!0,title:l,filters:u,buttonLabel:s},a)}async doPick(c,a){const l={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};l.defaultPath=c.defaultPath||this.stateMainService.getItem(vt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(l.properties=void 0,c.pickFiles&&c.pickFolders&&(l.properties=["multiSelections","openDirectory","openFile","createDirectory"])),l.properties||(l.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),g.isMacintosh&&l.properties.push("treatPackageAsDirectory");const s=a||w.BrowserWindow.getFocusedWindow(),u=await this.showOpenDialog(l,(0,y.withNullAsUndefined)(s));if(u&&u.filePaths&&u.filePaths.length>0)return this.stateMainService.setItem(vt.workingDirPickerStorageKey,(0,d.dirname)(u.filePaths[0])),u.filePaths}getWindowDialogQueue(c){if(c){let a=this.windowDialogQueues.get(c.id);return a||(a=new R.Queue,this.windowDialogQueues.set(c.id,a)),a}else return this.noWindowDialogueQueue}showMessageBox(c,a){return this.getWindowDialogQueue(a).queue(async()=>a?w.dialog.showMessageBox(a,c):w.dialog.showMessageBox(c))}async showSaveDialog(c,a){const l=this.acquireFileDialogLock(c,a);if(!l)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(a).queue(async()=>{let s;return a?s=await w.dialog.showSaveDialog(a,c):s=await w.dialog.showSaveDialog(c),s.filePath=this.normalizePath(s.filePath),s})}finally{(0,n.dispose)(l)}}normalizePath(c){return c&&g.isMacintosh&&(c=(0,I.normalizeNFC)(c)),c}normalizePaths(c){return c.map(a=>this.normalizePath(a))}async showOpenDialog(c,a){c.defaultPath&&(await E.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const l=this.acquireFileDialogLock(c,a);if(!l)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(a).queue(async()=>{let s;return a?s=await w.dialog.showOpenDialog(a,c):s=await w.dialog.showOpenDialog(c),s.filePaths=this.normalizePaths(s.filePaths),s})}finally{(0,n.dispose)(l)}}acquireFileDialogLock(c,a){if(!a)return n.Disposable.None;let l=this.windowFileDialogLocks.get(a.id);l||(l=new Set,this.windowFileDialogLocks.set(a.id,l));const s=(0,D.hash)(c);if(!l.has(s))return l.add(s),(0,n.toDisposable)(()=>{l?.delete(s),l?.size===0&&this.windowFileDialogLocks.delete(a.id)})}};p.workingDirPickerStorageKey="pickerWorkingDir",p=de([te(0,f.IStateMainService),te(1,t.ILogService)],p),e.DialogMainService=p}),define(Z[219],x([0,1,4,2,29]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class k extends R.Disposable{constructor(I,d){super();this.logService=I,this.storageMainService=d,this._onDidChangeGlobalStorage=this._register(new w.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(w.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(I,d)=>(I?I.push(d):I=[d],I),k.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(I))}))}serializeGlobalStorageEvents(I){const d=new Map,g=new Set;return I.forEach(y=>{const E=this.storageMainService.globalStorage.get(y.key);typeof E=="string"?d.set(y.key,E):g.add(y.key)}),{changed:Array.from(d.entries()),deleted:Array.from(g.values())}}listen(I,d){switch(d){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${d}`)}async call(I,d,g){const y=(0,D.reviveIdentifier)(g.workspace),E=await this.withStorageInitialized(y);switch(d){case"getItems":return Array.from(E.items.entries());case"updateItems":{const m=g;if(m.insert)for(const[S,t]of m.insert)E.set(S,t);m.delete&&m.delete.forEach(S=>E.delete(S));break}case"close":{if(y)return E.close();break}default:throw new Error(`Call not found: ${d}`)}}async withStorageInitialized(I){const d=I?this.storageMainService.workspaceStorage(I):this.storageMainService.globalStorage;try{await d.init()}catch(g){this.logService.error(`StorageIPC#init: Unable to init ${I?"workspace":"global"} storage due to ${g}`)}return d}}e.StorageDatabaseChannel=k,k.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[220],x([0,1,8,4,2,9,21,86,125,6,97,28,29]),function(q,e,w,R,D,k,n,I,d,g,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class S extends D.Disposable{constructor(p){super();this.logService=p,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new R.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new I.Storage(new I.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new w.DeferredPromise,this.whenInit=this.whenInitPromise.p}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const p=await this.doCreate();this.storage.dispose(),this.storage=p,this._register(p.onDidChangeStorage(c=>this._onDidChangeStorage.fire({key:c}))),await this.doInit(p);const P=p.getBoolean(y.IS_NEW_KEY);P===void 0?p.set(y.IS_NEW_KEY,!0):P&&p.set(y.IS_NEW_KEY,!1)}catch(p){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${p}`)}finally{this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===g.LogLevel.Trace?p=>this.logService.trace(p):void 0,logError:p=>this.logService.error(p)}}doInit(p){return p.init()}get items(){return this.storage.items}get(p,P){return this.storage.get(p,P)}set(p,P){return this.storage.set(p,P)}delete(p){return this.storage.delete(p)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class t extends S{constructor(p,P,c){super(P);this.options=p,this.environmentService=c}async doCreate(){let p;return this.options.useInMemoryStorage?p=d.SQLiteStorageDatabase.IN_MEMORY_PATH:p=(0,k.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new I.Storage(new d.SQLiteStorageDatabase(p,{logging:this.createLoggingOptions()}))}async doInit(p){await super.doInit(p),this.updateTelemetryState(p)}updateTelemetryState(p){p.get(E.firstSessionDateStorageKey,void 0)===void 0&&p.set(E.firstSessionDateStorageKey,new Date().toUTCString());const c=p.get(E.currentSessionDateStorageKey,void 0),a=new Date().toUTCString();p.set(E.lastSessionDateStorageKey,typeof c=="undefined"?null:c),p.set(E.currentSessionDateStorageKey,a)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class f extends S{constructor(p,P,c,a){super(c);this.workspace=p,this.options=P,this.environmentService=a}async doCreate(){const{storageFilePath:p,wasCreated:P}=await this.prepareWorkspaceStorageFolder();return new I.Storage(new d.SQLiteStorageDatabase(p,{logging:this.createLoggingOptions()}),{hint:P?I.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:d.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const p=(0,k.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),P=(0,k.join)(p,f.WORKSPACE_STORAGE_NAME);return await n.Promises.exists(p)?{storageFilePath:P,wasCreated:!1}:(await n.Promises.mkdir(p,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(p),{storageFilePath:P,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(p){let P;if((0,m.isSingleFolderWorkspaceIdentifier)(this.workspace)?P={folder:this.workspace.uri.toString()}:(0,m.isWorkspaceIdentifier)(this.workspace)&&(P={workspace:this.workspace.configPath.toString()}),P)try{const c=(0,k.join)(p,f.WORKSPACE_META_NAME);await n.Promises.exists(c)||await n.Promises.writeFile(c,JSON.stringify(P,void 0,2))}catch(c){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${c}`)}}}e.WorkspaceStorageMain=f,f.WORKSPACE_STORAGE_NAME="state.vscdb",f.WORKSPACE_META_NAME="workspace.json"}),define(Z[99],x([0,1,42,2,48,5,20,6,220]),function(q,e,w,R,D,k,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,k.createDecorator)("storageMainService");let g=class extends R.Disposable{constructor(E,m,S){super();this.logService=E,this.environmentService=m,this.lifecycleMainService=S,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async E=>{E.workspace&&this.workspaceStorage(E.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(E=>{E.join(this.globalStorage.close());for(const[,m]of this.mapWorkspaceToStorage)E.join(m.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const E=new d.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,w.once)(E.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),E}createWorkspaceStorage(E){return new d.WorkspaceStorageMain(E,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(E){let m=this.mapWorkspaceToStorage.get(E.id);return m||(this.logService.trace(`StorageMainService: creating workspace storage (${E.id})`),m=this.createWorkspaceStorage(E),this.mapWorkspaceToStorage.set(E.id,m),(0,w.once)(m.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${E.id})`),this.mapWorkspaceToStorage.delete(E.id)})),m}};g=de([te(0,I.ILogService),te(1,D.IEnvironmentService),te(2,n.ILifecycleMainService)],g),e.StorageMainService=g}),define(Z[100],x([0,1,16,7,29]),function(q,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function k(d,g,y){for(const m of d){const S=m.openedWorkspace;if((0,D.isWorkspaceIdentifier)(S)){const t=y(S);if(t){if(t.folders.some(f=>w.extUriBiasedIgnorePathCase.isEqualOrParent(g,f.uri)))return m}else if(w.extUriBiasedIgnorePathCase.isEqualOrParent(g,S.configPath))return m}}const E=d.filter(m=>(0,D.isSingleFolderWorkspaceIdentifier)(m.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqualOrParent(g,m.openedWorkspace.uri));if(E.length)return E.sort((m,S)=>-(m.openedWorkspace.uri.path.length-S.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=k;function n(d,g){for(const y of d)if((0,D.isWorkspaceIdentifier)(y.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.configPath,g)||(0,D.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.uri,g))return y}e.findWindowOnWorkspaceOrFolder=n;function I(d,g){const y=E=>g.some(m=>w.extUriBiasedIgnorePathCase.isEqual(R.URI.file(m),R.URI.file(E)));for(const E of d)if(E.config?.extensionDevelopmentPath?.some(m=>y(m)))return E}e.findWindowOnExtensionDevelopmentPath=I}),define(Z[221],x([0,1,14,2,3,16,7,18,20,6,37,35,29]),function(q,e,w,R,D,k,n,I,d,g,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let S=class St extends R.Disposable{constructor(c,a,l,s,u){super();this.windowsMainService=c,this.stateMainService=a,this.lifecycleMainService=l,this.logService=s,this.configurationService=u,this._state=t(this.stateMainService.getItem(St.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){w.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let s=this.windowsMainService.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.windowsMainService.getWindows().find(u=>!u.isExtensionDevelopmentHost)),s&&(c.lastActiveWindow=this.toWindowState(s))}const a=this.windowsMainService.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);a&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>this.toWindowState(s)));const l=b(c);this.stateMainService.setItem(St.windowsStateStorageKey,l),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",l)}onBeforeCloseWindow(c){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(l=>{const s=(0,m.isWorkspaceIdentifier)(c.openedWorkspace)&&l.workspace?.id===c.openedWorkspace.id,u=(0,m.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&l.folderUri&&k.extUriBiasedIgnorePathCase.isEqual(l.folderUri,c.openedWorkspace.uri);(s||u)&&(l.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(c){return{workspace:(0,m.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,m.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const a=this.doGetNewWindowState(c),l=this.configurationService.getValue("window");let s;return a.hasDefaultState?s=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):(s=!!(this.lifecycleMainService.wasRestarted||l?.restoreFullscreen),s&&D.isMacintosh&&this.windowsMainService.getWindows().some(u=>u.isFullScreen)&&(s=!1)),a.mode===3&&!s&&(a.mode=1),a}doGetNewWindowState(c){const a=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const o=c.workspace;if((0,m.isWorkspaceIdentifier)(o)){const v=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===o.id).map(M=>M.uiState);if(v.length)return v[0]}if((0,m.isSingleFolderWorkspaceIdentifier)(o)){const v=this.state.openedWindows.filter(M=>M.folderUri&&k.extUriBiasedIgnorePathCase.isEqual(M.folderUri,o.uri)).map(M=>M.uiState);if(v.length)return v[0]}else if(c.backupPath){const v=this.state.openedWindows.filter(M=>M.backupPath===c.backupPath).map(M=>M.uiState);if(v.length)return v[0]}const h=this.lastClosedState||this.state.lastActiveWindow;if(!a&&h)return h.uiState}let l;const s=w.screen.getAllDisplays();if(s.length===1)l=s[0];else{if(D.isMacintosh){const o=w.screen.getCursorScreenPoint();l=w.screen.getDisplayNearestPoint(o)}!l&&a&&(l=w.screen.getDisplayMatching(a.getBounds())),l||(l=w.screen.getPrimaryDisplay()||s[0])}let u=(0,E.defaultWindowState)();u.x=Math.round(l.bounds.x+l.bounds.width/2-u.width/2),u.y=Math.round(l.bounds.y+l.bounds.height/2-u.height/2);const r=this.configurationService.getValue("window");let i=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")u.mode=0,i=!1;else if(r.newWindowDimensions==="fullscreen")u.mode=3,i=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&a){const o=a.serializeWindowState();o.mode===3?u.mode=3:u=o,i=u.mode!==3&&r.newWindowDimensions==="offset"}}return i&&(u=this.ensureNoOverlap(u)),u.hasDefaultState=!0,u}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const a=this.windowsMainService.getWindows().map(l=>l.getBounds());for(;a.some(l=>l.x===c.x||l.y===c.y);)c.x+=30,c.y+=30;return c}};S.windowsStateStorageKey="windowsState",S=de([te(0,E.IWindowsMainService),te(1,y.IStateMainService),te(2,d.ILifecycleMainService),te(3,g.ILogService),te(4,I.IConfigurationService)],S),e.WindowsStateHandler=S;function t(P){const c={openedWindows:[]},a=P||{openedWindows:[]};return a.lastActiveWindow&&(c.lastActiveWindow=f(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=f(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(c.openedWindows=a.openedWindows.map(l=>f(l))),c}e.restoreWindowsState=t;function f(P){const c={uiState:P.uiState};return P.backupPath&&(c.backupPath=P.backupPath),P.remoteAuthority&&(c.remoteAuthority=P.remoteAuthority),P.folder&&(c.folderUri=n.URI.parse(P.folder)),P.workspaceIdentifier&&(c.workspace={id:P.workspaceIdentifier.id,configPath:n.URI.parse(P.workspaceIdentifier.configURIPath)}),c}function b(P){return{lastActiveWindow:P.lastActiveWindow&&p(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&p(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(c=>p(c))}}e.getWindowsStateStoreData=b;function p(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(Z[101],x([0,1,60,27,10,3,16]),function(q,e,w,R,D,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function I(g){function y(){let E=g.scheme===D.Schemas.file?(0,n.originalFSPath)(g):g.toString();return k.isLinux||(E=E.toLowerCase()),(0,w.createHash)("md5").update(E).digest("hex")}return{id:y(),configPath:g}}e.getWorkspaceIdentifier=I;function d(g,y){function E(){if(g.scheme!==D.Schemas.file)return(0,w.createHash)("md5").update(g.toString()).digest("hex");if(!y)try{y=(0,R.statSync)(g.fsPath)}catch(t){return}let S;return k.isLinux?S=y.ino:k.isMacintosh?S=y.birthtime.getTime():k.isWindows&&(typeof y.birthtimeMs=="number"?S=Math.floor(y.birthtimeMs):S=y.birthtime.getTime()),(0,w.createHash)("md5").update(g.fsPath).update(S?String(S):"").digest("hex")}const m=E();if(typeof m=="string")return{id:m,uri:g}}e.getSingleFolderWorkspaceIdentifier=d}),define(Z[222],x([0,1,15,10,6,250,112,20]),function(q,e,w,R,D,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class d{constructor(m,S){this._worker=new k.Worker(R.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",q).fsPath),this._worker.on("message",m),this._worker.on("error",S)}getId(){return 1}postMessage(m,S){this._worker.postMessage(m,S)}dispose(){this._worker.terminate()}}let g=class{constructor(m){this._logService=m}async logInfo(m){this._logService.info(m)}};g=de([te(0,D.ILogService)],g);let y=class{constructor(m,S){this._logService=m,this._shutdown=!1,this._proxy=null;const t={create:(f,b,p)=>{const P=new d(b,p);return P.postMessage(f,[]),P}};this._worker=new n.SimpleWorkerClient(t,"vs/platform/extensions/node/extensionHostStarterWorker",new g(this._logService)),this._initialize(),S.onWillShutdown(f=>{this._shutdown=!0,this._proxy&&f.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(m){return this._proxy.onDynamicStdout(m)}onDynamicStderr(m){return this._proxy.onDynamicStderr(m)}onDynamicMessage(m){return this._proxy.onDynamicMessage(m)}onDynamicError(m){return this._proxy.onDynamicError(m)}onDynamicExit(m){return this._proxy.onDynamicExit(m)}async createExtensionHost(){const m=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();return m.createExtensionHost()}async start(m,S){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();return t.start(m,S)}async enableInspectPort(m){const S=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();return S.enableInspectPort(m)}async kill(m){const S=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();return S.kill(m)}};y=de([te(0,D.ILogService),te(1,I.ILifecycleMainService)],y),e.WorkerMainProcessExtensionHostStarter=y}),define(Z[57],x([0,1,60,61,26,17,15,4,2,9,3,31,36,84,223]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class f{constructor(L,F=""){this.debugLabel=F,this.socket=L,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=U=>{if(this.traceSocketEvent("error",{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,n.onUnexpectedError)(U)}},this.socket.on("error",this._errorListener)}traceSocketEvent(L,F){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,L,F)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(L){const F=U=>{this.traceSocketEvent("read",U),L(k.VSBuffer.wrap(U))};return this.socket.on("data",F),{dispose:()=>this.socket.off("data",F)}}onClose(L){const F=U=>{this.traceSocketEvent("close",{hadError:U}),L({type:0,hadError:U,error:void 0})};return this.socket.on("close",F),{dispose:()=>this.socket.off("close",F)}}onEnd(L){const F=()=>{this.traceSocketEvent("nodeEndReceived"),L()};return this.socket.on("end",F),{dispose:()=>this.socket.off("end",F)}}write(L){if(!this.socket.destroyed)try{this.traceSocketEvent("write",L),this.socket.write(L.buffer,F=>{if(F){if(F.code==="EPIPE")return;(0,n.onUnexpectedError)(F)}})}catch(F){if(F.code==="EPIPE")return;(0,n.onUnexpectedError)(F)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((L,F)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),L();return}const U=()=>{this.socket.off("close",U),this.socket.off("end",U),this.socket.off("error",U),this.socket.off("timeout",U),this.socket.off("drain",U),this.traceSocketEvent("nodeDrainEnd"),L()};this.socket.on("close",U),this.socket.on("end",U),this.socket.on("error",U),this.socket.on("timeout",U),this.socket.on("drain",U)})}}e.NodeSocket=f;var b;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize"})(b||(b={}));var p;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(p||(p={}));class P extends d.Disposable{constructor(L,F,U,Q){super();this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=L,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:F,inflateBytesLength:U?.byteLength||0,recordInflateBytes:Q}),this._flowManager=this._register(new c(this,F,U,Q,this._onData,(ie,re)=>this._write(ie,re))),this._register(this._flowManager.onError(ie=>{console.error(ie),(0,n.onUnexpectedError)(ie),this._onClose.fire({type:0,hadError:!0,error:ie})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData(ie=>this._acceptChunk(ie))),this._register(this.socket.onClose(ie=>this._onClose.fire(ie)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(L,F){this.socket.traceSocketEvent(L,F)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(L){return this._onData.event(L)}onClose(L){return this._onClose.event(L)}onEnd(L){return this.socket.onEnd(L)}write(L){this._flowManager.writeMessage(L)}_write(L,F){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",L);let U=2;L.byteLength<126?U+=0:L.byteLength<2**16?U+=2:U+=8;const Q=k.VSBuffer.alloc(U);if(F?Q.writeUInt8(194,0):Q.writeUInt8(130,0),L.byteLength<126)Q.writeUInt8(L.byteLength,1);else if(L.byteLength<2**16){Q.writeUInt8(126,1);let ie=1;Q.writeUInt8(L.byteLength>>>8&255,++ie),Q.writeUInt8(L.byteLength>>>0&255,++ie)}else{Q.writeUInt8(127,1);let ie=1;Q.writeUInt8(0,++ie),Q.writeUInt8(0,++ie),Q.writeUInt8(0,++ie),Q.writeUInt8(0,++ie),Q.writeUInt8(L.byteLength>>>24&255,++ie),Q.writeUInt8(L.byteLength>>>16&255,++ie),Q.writeUInt8(L.byteLength>>>8&255,++ie),Q.writeUInt8(L.byteLength>>>0&255,++ie)}this.socket.write(k.VSBuffer.concat([Q,L]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(L){if(L.byteLength!==0){for(this._incomingData.acceptChunk(L);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const F=this._incomingData.peek(this._state.readLen),U=F.readUInt8(0),Q=(U&128)>>>7,ie=(U&64)>>>6,re=F.readUInt8(1),G=(re&128)>>>7,O=re&127;this._state.state=2,this._state.readLen=2+(G?4:0)+(O===126?2:0)+(O===127?8:0),this._state.fin=Q,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(ie)),this._state.firstFrameOfMessage=Boolean(Q),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const F=this._incomingData.read(this._state.readLen),U=F.readUInt8(1),Q=(U&128)>>>7;let ie=U&127,re=1;ie===126?ie=F.readUInt8(++re)*2**8+F.readUInt8(++re):ie===127&&(ie=F.readUInt8(++re)*0+F.readUInt8(++re)*0+F.readUInt8(++re)*0+F.readUInt8(++re)*0+F.readUInt8(++re)*2**24+F.readUInt8(++re)*2**16+F.readUInt8(++re)*2**8+F.readUInt8(++re));let G=0;Q&&(G=F.readUInt8(++re)*2**24+F.readUInt8(++re)*2**16+F.readUInt8(++re)*2**8+F.readUInt8(++re)),this._state.state=3,this._state.readLen=ie,this._state.mask=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const F=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",F),s(F,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",F),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(F,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=P;class c extends d.Disposable{constructor(L,F,U,Q,ie,re){super();this._tracer=L,this._onData=ie,this._writeFn=re,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,F?(this._zlibInflateStream=this._register(new a(this._tracer,Q,U,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(G=>this._onError.fire(G))),this._register(this._zlibDeflateStream.onError(G=>this._onError.fire(G)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:k.VSBuffer.alloc(0)}writeMessage(L){this._writeQueue.push(L),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const L=this._writeQueue.shift();if(this._zlibDeflateStream){const F=await this._deflateMessage(this._zlibDeflateStream,L);this._writeFn(F,!0)}else this._writeFn(L,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(L,F){return new Promise((U,Q)=>{L.write(F),L.flush(ie=>U(ie))})}acceptFrame(L,F,U){this._readQueue.push({data:L,isCompressed:F,isLastFrameOfMessage:U}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const L=this._readQueue.shift();if(this._zlibInflateStream&&L.isCompressed){const F=await this._inflateFrame(this._zlibInflateStream,L.data,L.isLastFrameOfMessage);this._onData.fire(F)}else this._onData.fire(L.data)}this._isProcessingReadQueue=!1}}_inflateFrame(L,F,U){return new Promise((Q,ie)=>{L.write(F),U&&L.write(k.VSBuffer.fromByteArray([0,0,255,255])),L.flush(re=>Q(re))})}}class a extends d.Disposable{constructor(L,F,U,Q){super();this._tracer=L,this._recordInflateBytes=F,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(Q),this._zlibInflate.on("error",ie=>{this._tracer.traceSocketEvent("zlibInflateError",{message:ie?.message,code:ie?.code}),this._onError.fire(ie)}),this._zlibInflate.on("data",ie=>{this._tracer.traceSocketEvent("zlibInflateData",ie),this._pendingInflateData.push(k.VSBuffer.wrap(ie))}),U&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",U.buffer),this._zlibInflate.write(U.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.concat(this._recordedInflateBytes):k.VSBuffer.alloc(0)}write(L){this._recordInflateBytes&&this._recordedInflateBytes.push(L.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",L),this._zlibInflate.write(L.buffer)}flush(L){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const F=k.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,L(F)})}}class l extends d.Disposable{constructor(L,F){super();this._tracer=L,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibDeflate.on("data",U=>{this._tracer.traceSocketEvent("zlibDeflateData",U),this._pendingDeflateData.push(k.VSBuffer.wrap(U))})}write(L){this._tracer.traceSocketEvent("zlibDeflateWrite",L.buffer),this._zlibDeflate.write(L.buffer)}flush(L){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let F=k.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,F=F.slice(0,F.byteLength-4),L(F)})}}function s(A,L){if(L===0)return;let F=A.byteLength>>>2;for(let O=0;O<F;O++){const B=A.readUInt32BE(O*4);A.writeUInt32BE(B^L,O*4)}let U=F*4,Q=A.byteLength-U;const ie=L>>>24&255,re=L>>>16&255,G=L>>>8&255;Q>=1&&A.writeUInt8(A.readUInt8(U)^ie,U),Q>=2&&A.writeUInt8(A.readUInt8(U+1)^re,U+1),Q>=3&&A.writeUInt8(A.readUInt8(U+2)^G,U+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function r(){const A=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;let L;return e.XDG_RUNTIME_DIR?L=(0,g.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${A}.sock`):L=(0,g.join)((0,D.tmpdir)(),`vscode-ipc-${A}.sock`),o(L),L}e.createRandomIPCHandle=r;function i(A,L,F){const U=(0,w.createHash)("md5").update(A).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${F}-${L}-sock`;let Q;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Q=(0,g.join)(e.XDG_RUNTIME_DIR,`vscode-${U.substr(0,8)}-${F}-${L}.sock`):Q=(0,g.join)(A,`${F}-${L}.sock`),o(Q),Q}e.createStaticIPCHandle=i;function o(A){const L=u[y.platform];typeof L=="number"&&A.length>=L&&console.warn(`WARNING: IPC handle "${A}" is longer than ${L} chars, try a shorter --user-data-dir`)}class h extends m.IPCServer{constructor(L){super(h.toClientConnectionEvent(L));this.server=L}static toClientConnectionEvent(L){const F=I.Event.fromNodeEventEmitter(L,"connection");return I.Event.map(F,U=>({protocol:new S.Protocol(new f(U,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(U,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=h;function v(A){return new Promise((L,F)=>{const U=(0,R.createServer)();U.on("error",F),U.listen(A,()=>{U.removeListener("error",F),L(new h(U))})})}e.serve=v;function M(A,L){return new Promise((F,U)=>{const Q=(0,R.createConnection)(A,()=>{Q.removeListener("error",U),F(S.Client.fromSocket(new f(Q,`ipc-client${L}`),L))});Q.once("error",U)})}e.connect=M}),define(Z[224],x([0,1,57]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class R{constructor(d){this.driver=d}listen(d,g){throw new Error("No event found")}call(d,g,y){switch(g){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(y);case"reloadWindow":return this.driver.reloadWindow(y);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(y[0],y[1]);case"click":return this.driver.click(y[0],y[1],y[2],y[3]);case"doubleClick":return this.driver.doubleClick(y[0],y[1]);case"setValue":return this.driver.setValue(y[0],y[1],y[2]);case"getTitle":return this.driver.getTitle(y[0]);case"isActiveElement":return this.driver.isActiveElement(y[0],y[1]);case"getElements":return this.driver.getElements(y[0],y[1],y[2]);case"getElementXY":return this.driver.getElementXY(y[0],y[1],y[2]);case"typeInEditor":return this.driver.typeInEditor(y[0],y[1],y[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(y[0],y[1]);case"writeInTerminal":return this.driver.writeInTerminal(y[0],y[1],y[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(y);case"getLocalizedStrings":return this.driver.getLocalizedStrings(y)}throw new Error(`Call not found: ${g}`)}}e.DriverChannel=R;class D{constructor(d){this.channel=d}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(d){return this.channel.call("capturePage",d)}reloadWindow(d){return this.channel.call("reloadWindow",d)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(d,g){return this.channel.call("dispatchKeybinding",[d,g])}click(d,g,y,E){return this.channel.call("click",[d,g,y,E])}doubleClick(d,g){return this.channel.call("doubleClick",[d,g])}setValue(d,g,y){return this.channel.call("setValue",[d,g,y])}getTitle(d){return this.channel.call("getTitle",[d])}isActiveElement(d,g){return this.channel.call("isActiveElement",[d,g])}getElements(d,g,y){return this.channel.call("getElements",[d,g,y])}getElementXY(d,g,y,E){return this.channel.call("getElementXY",[d,g,y,E])}typeInEditor(d,g,y){return this.channel.call("typeInEditor",[d,g,y])}getTerminalBuffer(d,g){return this.channel.call("getTerminalBuffer",[d,g])}writeInTerminal(d,g,y){return this.channel.call("writeInTerminal",[d,g,y])}getLocaleInfo(d){return this.channel.call("getLocaleInfo",d)}getLocalizedStrings(d){return this.channel.call("getLocalizedStrings",d)}}e.DriverChannelClient=D;class k{constructor(d){this.registry=d}listen(d,g){throw new Error(`Event not found: ${g}`)}call(d,g,y){switch(g){case"registerWindowDriver":return this.registry.registerWindowDriver(y);case"reloadWindowDriver":return this.registry.reloadWindowDriver(y)}throw new Error(`Call not found: ${g}`)}}e.WindowDriverRegistryChannel=k;async function n(I){const d=await(0,w.connect)(I,"driverClient"),g=d.getChannel("driver"),y=new D(g);return{client:d,driver:y}}e.connect=n}),define(Z[225],x([0,1,8,4,105,58,2,3,36,57,161,224,178,20,35]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function f(P){return P<21}let b=class{constructor(c,a,l,s){this.windowServer=c,this.options=a,this.windowsMainService=l,this.lifecycleMainService=s,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new R.Emitter}async registerWindowDriver(c){return this.registeredWindowIds.add(c),this.reloadingWindowIds.delete(c),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(c){this.reloadingWindowIds.add(c)}async getWindowIds(){return this.windowsMainService.getWindows().map(c=>c.id).filter(c=>this.registeredWindowIds.has(c)&&!this.reloadingWindowIds.has(c))}async capturePage(c){await this.whenUnfrozen(c);const a=this.windowsMainService.getWindowById(c);if(!a?.win)throw new Error("Invalid window");return(await a.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(c){await this.whenUnfrozen(c);const a=this.windowsMainService.getWindowById(c);if(!a)throw new Error("Invalid window");this.reloadingWindowIds.add(c),this.lifecycleMainService.reload(a)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(c,a){await this.whenUnfrozen(c);const l=D.KeybindingParser.parseUserBinding(a);for(let s of l)await this._dispatchKeybinding(c,s)}async _dispatchKeybinding(c,a){if(a instanceof k.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const l=this.windowsMainService.getWindowById(c);if(!l?.win)throw new Error("Invalid window");const s=l.win.webContents,u=new k.SimpleKeybinding(!1,!1,!1,!1,a.keyCode),i=new m.USLayoutResolvedKeybinding(u.toChord(),I.OS).getElectronAccelerator(),o=[];a.ctrlKey&&o.push("ctrl"),a.metaKey&&o.push("meta"),a.shiftKey&&o.push("shift"),a.altKey&&o.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:i,modifiers:o}),f(a.keyCode)||s.sendInputEvent({type:"char",keyCode:i,modifiers:o}),s.sendInputEvent({type:"keyUp",keyCode:i,modifiers:o}),await(0,w.timeout)(100)}async click(c,a,l,s){await(await this.getWindowDriver(c)).click(a,l,s)}async doubleClick(c,a){await(await this.getWindowDriver(c)).doubleClick(a)}async setValue(c,a,l){await(await this.getWindowDriver(c)).setValue(a,l)}async getTitle(c){return await(await this.getWindowDriver(c)).getTitle()}async isActiveElement(c,a){return await(await this.getWindowDriver(c)).isActiveElement(a)}async getElements(c,a,l){return await(await this.getWindowDriver(c)).getElements(a,l)}async getElementXY(c,a,l,s){return await(await this.getWindowDriver(c)).getElementXY(a,l,s)}async typeInEditor(c,a,l){await(await this.getWindowDriver(c)).typeInEditor(a,l)}async getTerminalBuffer(c,a){return await(await this.getWindowDriver(c)).getTerminalBuffer(a)}async writeInTerminal(c,a,l){await(await this.getWindowDriver(c)).writeInTerminal(a,l)}async getLocaleInfo(c){return await(await this.getWindowDriver(c)).getLocaleInfo()}async getLocalizedStrings(c){return await(await this.getWindowDriver(c)).getLocalizedStrings()}async getWindowDriver(c){await this.whenUnfrozen(c);const a=`window:${c}`,l=new d.StaticRouter(u=>u===a),s=this.windowServer.getChannel("windowDriver",l);return new y.WindowDriverChannelClient(s)}async whenUnfrozen(c){for(;this.reloadingWindowIds.has(c);)await R.Event.toPromise(this.onDidReloadingChange.event)}};b=de([te(2,t.IWindowsMainService),te(3,S.ILifecycleMainService)],b),e.Driver=b;async function p(P,c,a,l){const s=a.driverVerbose,u=l.createInstance(b,P,{verbose:s}),r=new E.WindowDriverRegistryChannel(u);P.registerChannel("windowDriverRegistry",r);const i=await(0,g.serve)(c),o=new E.DriverChannel(u);return i.registerChannel("driver",o),(0,n.combinedDisposable)(i,P)}e.serve=p}),define(Z[24],x([0,1,46,9,57,48,165,5]),function(q,e,w,R,D,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(k.IEnvironmentService);class d extends n.NativeEnvironmentService{get cachedLanguagesPath(){return(0,R.join)(this.userDataPath,"clp")}get backupHome(){return(0,R.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,R.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,R.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}de([w.memoize],d.prototype,"cachedLanguagesPath",null),de([w.memoize],d.prototype,"backupHome",null),de([w.memoize],d.prototype,"backupWorkspacesPath",null),de([w.memoize],d.prototype,"mainIPCHandle",null),de([w.memoize],d.prototype,"mainLockfile",null),de([w.memoize],d.prototype,"sandbox",null),de([w.memoize],d.prototype,"driverVerbose",null),de([w.memoize],d.prototype,"disableUpdates",null),de([w.memoize],d.prototype,"disableKeytar",null),de([w.memoize],d.prototype,"codeCachePath",null),de([w.memoize],d.prototype,"useCodeCache",null),e.EnvironmentMainService=d}),define(Z[226],x([0,1,60,27,32,10,9,3,16,7,21,159,18,24,19,6,29]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let p=class{constructor(c,a,l){this.configurationService=a,this.logService=l,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=d.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(s,u)=>(0,D.isEqual)(s,u,!I.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await y.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(s){c=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos);let a=[];try{Array.isArray(c.rootURIWorkspaces)&&(a=c.rootURIWorkspaces.map(s=>({workspace:{id:s.id,configPath:g.URI.parse(s.configURIPath)},remoteAuthority:s.remoteAuthority})))}catch(s){}this.workspaces=await this.validateWorkspaces(a);let l=[];try{Array.isArray(c.folderWorkspaceInfos)?l=c.folderWorkspaceInfos.map(s=>({folderUri:g.URI.parse(s.folderUri),remoteAuthority:s.remoteAuthority})):Array.isArray(c.folderURIWorkspaces)&&(l=c.folderURIWorkspaces.map(s=>({folderUri:g.URI.parse(s),remoteAuthority:void 0})))}catch(s){}this.folders=await this.validateFolders(l),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,a){this.workspaces.some(s=>c.workspace.id===s.workspace.id)||(this.workspaces.push(c),this.saveSync());const l=this.getBackupPath(c.workspace.id);return a&&this.moveBackupFolderSync(l,a),l}moveBackupFolderSync(c,a){if(R.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),R.existsSync(a))try{R.renameSync(a,c)}catch(l){this.logService.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}unregisterWorkspaceBackupSync(c){const a=c.id,l=this.workspaces.findIndex(s=>s.workspace.id===a);l!==-1&&(this.workspaces.splice(l,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(a=>this.backupUriComparer.isEqual(c.folderUri,a.folderUri))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const a=this.folders.findIndex(l=>this.backupUriComparer.isEqual(c,l.folderUri));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(c,a){const l=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,l))||(this.emptyWindows.push({backupFolder:l,remoteAuthority:a}),this.saveSync()),this.getBackupPath(l)}unregisterEmptyWindowBackupSync(c){const a=this.emptyWindows.findIndex(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,c));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(c){return(0,n.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const a=new Set,l=[];for(let s of c){const u=s.workspace;if(!(0,b.isWorkspaceIdentifier)(u))return[];if(!a.has(u.id)){a.add(u.id);const r=this.getBackupPath(u.id);await this.doHasBackups(r)?u.configPath.scheme!==k.Schemas.file||await y.Promises.exists(u.configPath.fsPath)?l.push(s):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return l}async validateFolders(c){if(!Array.isArray(c))return[];const a=[],l=new Set;for(let s of c){const u=s.folderUri,r=this.backupUriComparer.getComparisonKey(u);if(!l.has(r)){l.add(r);const i=this.getBackupPath(this.getFolderHash(s));await this.doHasBackups(i)?u.scheme!==k.Schemas.file||await y.Promises.exists(u.fsPath)?a.push(s):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return a}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const a=[],l=new Set;for(let s of c){const u=s.backupFolder;if(typeof u!="string")return[];if(!l.has(u)){l.add(u);const r=this.getBackupPath(u);await this.doHasBackups(r)?a.push(s):await this.deleteStaleBackup(r)}}return a}async deleteStaleBackup(c){try{await y.Promises.exists(c)&&await y.Promises.rm(c,y.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{await y.Promises.rename(c,l)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{R.renameSync(c,l)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const c=[];for(const a of this.workspaces)await this.hasBackups(a)&&c.push(a);for(const a of this.folders)await this.hasBackups(a)&&c.push(a);return c}hasBackups(c){let a;return(0,E.isEmptyWindowBackupInfo)(c)?a=c.backupFolder:(0,b.isFolderBackupInfo)(c)?a=this.getBackupPath(this.getFolderHash(c)):a=this.getBackupPath(c.workspace.id),this.doHasBackups(a)}async doHasBackups(c){try{const a=await y.Promises.readdir(c);for(const l of a)try{if((await y.Promises.readdir((0,n.join)(c,l))).length>0)return!0}catch(s){}}catch(a){}return!1}saveSync(){try{(0,y.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await y.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderWorkspaceInfos:this.folders.map(c=>({folderUri:c.folderUri.toString(),remoteAuthority:c.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){const a=c.folderUri;let l;return a.scheme===k.Schemas.file?l=I.isLinux?a.fsPath:a.fsPath.toLowerCase():l=a.toString().toLowerCase(),(0,w.createHash)("md5").update(l).digest("hex")}};p=de([te(0,S.IEnvironmentMainService),te(1,m.IConfigurationService),te(2,f.ILogService)],p),e.BackupMainService=p}),define(Z[227],x([0,1,61,57]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,k,n,I,d){const g=E=>d(E,void 0),y=w.createConnection({host:D,port:k},()=>{y.removeListener("error",g);const E=Buffer.alloc(16);for(let f=0;f<16;f++)E[f]=Math.round(Math.random()*256);const m=E.toString("base64"),S=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${k}/?${n}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${m}`];y.write(S.join(`\r
`)+`\r
\r
`);const t=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",t),d(void 0,new R.NodeSocket(y,I)))};y.on("data",t)});y.setNoDelay(!0),y.once("error",g)}}}),define(Z[228],x([0,1,61,117,227,8,2,18,6,22,194,96,76]),function(q,e,w,R,D,k,n,I,d,g,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(P,c,a,l,s){let u;for(let r=3;r&&(u&&u.dispose(),u=await new t(P,c,a,l,s).waitForReady(),!(s&&R.BROWSER_RESTRICTED_PORTS[s]||!R.BROWSER_RESTRICTED_PORTS[u.tunnelLocalPort]));r--);return u}class t extends n.Disposable{constructor(c,a,l,s,u){super();this.defaultTunnelHost=a,this.suggestedLocalPort=u,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=w.createServer(),this._barrier=new k.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){let c=await(0,R.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),a=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(c){c.pause();const a=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,y.connectRemoteAgentTunnel)(this._options,a,this.tunnelRemotePort),s=l.getSocket().socket,u=l.readEntireBuffer();l.dispose(),u.byteLength>0&&c.write(u.buffer),c.on("end",()=>{c.localAddress&&this._socketsDispose.delete(c.localAddress),s.end()}),c.on("close",()=>s.end()),c.on("error",()=>{c.localAddress&&this._socketsDispose.delete(c.localAddress),s.destroy()}),s.on("end",()=>c.end()),s.on("close",()=>c.end()),s.on("error",()=>{c.destroy()}),c.pipe(s),s.pipe(c),c.localAddress&&this._socketsDispose.set(c.localAddress,()=>{c.end(),s.end()})}}let f=class extends E.AbstractTunnelService{constructor(c,a,l,s,u){super(a);this.socketFactory=c,this.signService=l,this.productService=s,this.configurationService=u}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,a,l,s,u,r,i){const o=this.getTunnelFromMap(a,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,l,s,u,r,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${l} on local port ${s}.`);const h={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},v=S(h,this.defaultTunnelHost,a,l,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,l,v),v}}};f=de([te(1,d.ILogService),te(2,m.ISignService),te(3,g.IProductService),te(4,I.IConfigurationService)],f),e.BaseTunnelService=f;let b=class extends f{constructor(c,a,l,s){super(D.nodeSocketFactory,c,a,l,s)}};b=de([te(0,d.ILogService),te(1,m.ISignService),te(2,g.IProductService),te(3,I.IConfigurationService)],b),e.TunnelService=b;let p=class extends n.Disposable{constructor(c,a,l,s){super();this.logService=c,this.productService=a,this.signService=l,this.configurationService=s,this._tunnelServices=new Map}async openTunnel(c,a,l,s,u,r,i,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${s} on local port ${u}.`),!this._tunnelServices.has(c)){const h=new b(this.logService,this.signService,this.productService,this.configurationService);this._register(h),this._tunnelServices.set(c,h),h.onTunnelClosed(async()=>{(await h.tunnels).length===0&&(h.dispose(),this._tunnelServices.delete(c))})}return this._tunnelServices.get(c).openTunnel(a,l,s,u,r,i,o)}};p=de([te(0,d.ILogService),te(1,g.IProductService),te(2,m.ISignService),te(3,I.IConfigurationService)],p),e.SharedTunnelsService=p}),define(Z[229],x([0,1,198,8,17,15,2,13,18,48,90,6,197,223]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends n.Disposable{constructor(b,p,P){super();this.environmentService=p,this.logService=P,this.configure(b.getValue()),this._register(b.onDidChangeConfiguration(()=>this.configure(b.getValue()),this))}configure(b){this.proxyUrl=b.http&&b.http.proxy,this.strictSSL=!!(b.http&&b.http.proxyStrictSSL),this.authorization=b.http&&b.http.proxyAuthorization}async request(b,p){this.logService.trace("RequestService#request",b.url);const{proxyUrl:P,strictSSL:c}=this;let a;try{a=await(0,y.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(u){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",u))}const l={...process.env,...a},s=b.agent?b.agent:await(0,m.getProxyAgent)(b.url||"",l,{proxyUrl:P,strictSSL:c});return b.agent=s,b.strictSSL=c,this.authorization&&(b.headers={...b.headers||{},"Proxy-Authorization":this.authorization}),this._request(b,p)}async getNodeRequest(b){return((0,w.parse)(b.url).protocol==="https:"?await new Promise((c,a)=>{q(["https"],c,a)}):await new Promise((c,a)=>{q(["http"],c,a)})).request}_request(b,p){return R.Promises.withAsyncBody(async(P,c)=>{let a;const l=(0,w.parse)(b.url),s=b.getRawRequest?b.getRawRequest(b):await this.getNodeRequest(b),u={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,I.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(u.auth=b.user+":"+b.password),a=s(u,r=>{const i=(0,I.isNumber)(b.followRedirects)?b.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&i>0&&r.headers.location)this._request({...b,url:r.headers.location,followRedirects:i-1},p).then(P,c);else{let o=r;r.headers["content-encoding"]==="gzip"&&(o=r.pipe((0,S.createGunzip)())),P({res:r,stream:(0,D.streamToBufferReadableStream)(o)})}}),a.on("error",c),b.timeout&&a.setTimeout(b.timeout),b.data&&typeof b.data=="string"&&a.write(b.data),a.end(),p.onCancellationRequested(()=>{a.abort(),c((0,k.canceled)())})})}async resolveProxy(b){}};t=de([te(0,d.IConfigurationService),te(1,g.INativeEnvironmentService),te(2,E.ILogService)],t),e.RequestService=t}),define(Z[230],x([0,1,14,229]),function(q,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(n){return w.net.request}class k extends R.RequestService{request(I,d){return super.request({...I||{},getRawRequest:D},d)}}e.RequestMainService=k}),define(Z[231],x([0,1,14,8,4,2,10,13,85,24,20,6,54,55,66,44]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let b=class extends k.Disposable{constructor(P,c,a,l,s,u,r){super();this.machineId=P,this.userEnv=c,this.environmentMainService=a,this.lifecycleMainService=l,this.logService=s,this.themeMainService=u,this.protocolMainService=r,this.firstWindowConnectionBarrier=new R.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new D.Emitter),this.onDidError=D.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){w.ipcMain.on("vscode:createSharedProcessMessageChannel",(P,c)=>this.onWindowConnection(P,c)),w.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(P,c)=>this.onWorkerConnection(P,c)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(P,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(P.sender.isDestroyed())return a.close();P.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[a])}onWorkerConnection(P,c){this.logService.trace("SharedProcess: onWorkerConnection",c);const a=new k.DisposableStore,l=u=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${u}')`,c),a.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",c))},s=w.BrowserWindow.fromId(c.reply.windowId);if(!s||s.isDestroyed()||s.webContents.isDestroyed()||!c.reply.channel){l("unavailable");return}a.add(D.Event.filter(this.lifecycleMainService.onWillLoadWindow,u=>u.window.win===s)(()=>l("load"))),a.add(D.Event.fromNodeEventEmitter(s,"closed")(()=>l("closed"))),s.webContents.postMessage(c.reply.channel,c.reply.nonce,P.ports)}onWillShutdown(){const P=this.window;!P||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(P.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{P.close()}catch(c){}this.window=void 0},0))}send(P,...c){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${P}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(P,...c)}catch(a){this.logService.warn(`Error sending IPC message to channel '${P}' of shared process: ${(0,f.toErrorMessage)(a)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(P=>w.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),P()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(P=>w.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),P()}))})()),this._whenIpcReady}createWindow(){const P=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new w.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:n.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${P.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),P.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(n.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",q).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=P=>{this.logService.trace("SharedProcess#close prevented"),P.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(P,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(P,c,a)=>this._onDidError.fire({type:3,details:{reason:a,exitCode:c}})))}async connect(){await this.whenIpcReady;const P=(0,I.assertIsDefined)(this.window);return(0,d.connect)(P)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const P=this.window;return P?!P.isDestroyed()&&!P.webContents.isDestroyed():!1}};b=de([te(2,g.IEnvironmentMainService),te(3,y.ILifecycleMainService),te(4,E.ILogService),te(5,t.IThemeMainService),te(6,S.IProtocolMainService)],b),e.SharedProcess=b}),define(Z[232],x([0,1,8,17,9,13,7,24,19,6]),function(q,e,w,R,D,k,n,I,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class y{constructor(S,t,f){this.storagePath=S,this.logService=t,this.fileService=f,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new w.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(S){S.fileOperationResult!==1&&this.logService.error(S)}}getItem(S,t){const f=this.storage[S];return(0,k.isUndefinedOrNull)(f)?t:f}setItem(S,t){this.setItems([{key:S,data:t}])}setItems(S){let t=!1;for(const{key:f,data:b}of S)this.storage[f]!==b&&((0,k.isUndefinedOrNull)(b)?(0,k.isUndefined)(this.storage[f])||(this.storage[f]=void 0,t=!0):(this.storage[f]=b,t=!0));t&&this.save()}removeItem(S){(0,k.isUndefined)(this.storage[S])||(this.storage[S]=void 0,this.save())}async save(S){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),S)}async doSave(){if(!this.initializing)return;await this.initializing;const S=JSON.stringify(this.storage,null,4);if(S!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,R.VSBuffer.fromString(S)),this.lastSavedStorageContents=S}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=y;let E=class It{constructor(S,t,f){this.fileStorage=new y(n.URI.file((0,D.join)(S.userDataPath,It.STATE_FILE)),t,f)}async init(){return this.fileStorage.init()}getItem(S,t){return this.fileStorage.getItem(S,t)}setItem(S,t){this.fileStorage.setItem(S,t)}setItems(S){this.fileStorage.setItems(S)}removeItem(S){this.fileStorage.removeItem(S)}close(){return this.fileStorage.close()}};E.STATE_FILE="storage.json",E=de([te(0,I.IEnvironmentMainService),te(1,g.ILogService),te(2,d.IFileService)],E),e.StateMainService=E}),define(Z[77],x([0,1,8,23,4,18,24,20,6,22,49,41]),function(q,e,w,R,D,k,n,I,d,g,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function m(t,f,b){return`${b.updateUrl}/api/update/${t}/${f}/${b.commit}`}e.createUpdateURL=m;let S=class{constructor(f,b,p,P,c,a){this.lifecycleMainService=f,this.configurationService=b,this.environmentMainService=p,this.requestService=P,this.logService=c,this.productService=a,this._state=E.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(f){this.logService.info("update#setState",f.type),this._state=f,this._onStateChange.fire(f)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const f=this.getUpdateMode(),b=this.getProductQuality(f);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(E.State.Idle(this.getUpdateType())),f==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}f==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}getUpdateMode(){return(0,k.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(f){return f==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(f=60*60*1e3){return(0,w.timeout)(f).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(f){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(f)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(f){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(f=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${f}`),!f&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},R.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};S=de([te(0,I.ILifecycleMainService),te(1,k.IConfigurationService),te(2,n.IEnvironmentMainService),te(3,y.IRequestService),te(4,d.ILogService),te(5,g.IProductService)],S),e.AbstractUpdateService=S}),define(Z[233],x([0,1,14,46,4,2,18,24,20,6,22,49,28,41,77]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let f=class extends t.AbstractUpdateService{constructor(p,P,c,a,l,s,u){super(p,P,a,l,s,u);this.telemetryService=c,this.disposables=new k.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(w.autoUpdater,"error",(p,P)=>P)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(w.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(w.autoUpdater,"update-available",(p,P,c)=>({url:P,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(w.autoUpdater,"update-downloaded",(p,P,c,a)=>({releaseNotes:P,version:c,productVersion:c,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(p){this.logService.error("UpdateService error:",p);const c=(this.state.type==="checking for updates"?this.state.explicit:!0)?p:void 0;this.setState(S.State.Idle(1,c))}buildUpdateFeedUrl(p){let P;this.productService.darwinUniversalAssetId?P=this.productService.darwinUniversalAssetId:P=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,t.createUpdateURL)(P,p,this.productService);try{w.autoUpdater.setFeedURL({url:c})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return c}doCheckForUpdates(p){this.setState(S.State.CheckingForUpdates(p)),w.autoUpdater.checkForUpdates()}onUpdateAvailable(p){this.state.type==="checking for updates"&&this.setState(S.State.Downloading(p))}onUpdateDownloaded(p){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:p.version}),this.setState(S.State.Ready(p)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(S.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),w.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};de([R.memoize],f.prototype,"onRawError",null),de([R.memoize],f.prototype,"onRawUpdateNotAvailable",null),de([R.memoize],f.prototype,"onRawUpdateAvailable",null),de([R.memoize],f.prototype,"onRawUpdateDownloaded",null),f=de([te(0,d.ILifecycleMainService),te(1,n.IConfigurationService),te(2,m.ITelemetryService),te(3,I.IEnvironmentMainService),te(4,E.IRequestService),te(5,g.ILogService),te(6,y.IProductService)],f),e.DarwinUpdateService=f}),define(Z[234],x([0,1,43,27,8,4,9,24,20,6,28,41]),function(q,e,w,R,D,k,n,I,d,g,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let m=class{constructor(f,b,p){if(this.lifecycleMainService=f,this.logService=p,this._state=E.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(E.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,P=>this.logService.error(P))}get state(){return this._state}setState(f){this.logService.info("update#setState",f.type),this._state=f,this._onStateChange.fire(f)}scheduleCheckForUpdates(f=60*60*1e3){return(0,D.timeout)(f).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(f){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(f)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(f){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(f=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${f}`),!f&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};m=de([te(0,d.ILifecycleMainService),te(1,I.IEnvironmentMainService),te(2,g.ILogService)],m);let S=class extends m{constructor(f,b,p,P,c,a){super(p,P,c);this.snap=f,this.snapRevision=b,this.telemetryService=a;const l=(0,R.watch)(n.dirname(this.snap)),s=k.Event.fromNodeEventEmitter(l,"change",(o,h)=>h),u=k.Event.filter(s,o=>o==="current"),i=k.Event.debounce(u,(o,h)=>h,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{i.dispose(),l.close()})}doCheckForUpdates(){this.setState(E.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(f=>{f?this.setState(E.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2)))},f=>{this.logService.error(f),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2,f.message||f))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,w.spawn)("sleep 3 && "+n.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const f=await new Promise((p,P)=>(0,R.realpath)(`${n.dirname(this.snap)}/current`,(c,a)=>c?P(c):p(a))),b=n.basename(f);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,f=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};S=de([te(2,d.ILifecycleMainService),te(3,I.IEnvironmentMainService),te(4,g.ILogService),te(5,y.ITelemetryService)],S),e.SnapUpdateService=S}),define(Z[45],x([0,1,14,27,4,38,33,2,10,9,3,16,13,21,158,52,50,24,5,6,22,100,29,101]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b,p,P,c,a,l,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,P.createDecorator)("workspacesManagementMainService");let r=class extends I.Disposable{constructor(o,h,v,M,A){super();this.environmentMainService=o,this.logService=h,this.backupMainService=v,this.dialogMainService=M,this.productService=A,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(o){return this.doResolveLocalWorkspace(o,h=>(0,R.readFileSync)(h,"utf8"))}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,h=>S.Promises.readFile(h,"utf8"))}doResolveLocalWorkspace(o,h){if(!!this.isWorkspacePath(o)&&o.scheme===d.Schemas.file)try{const v=h(o.fsPath);return v instanceof Promise?v.then(M=>this.doResolveWorkspace(o,M),M=>{}):this.doResolveWorkspace(o,v)}catch{return}}isWorkspacePath(o){return(0,s.isUntitledWorkspace)(o,this.environmentMainService)||(0,s.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,h){try{const v=this.doParseStoredWorkspace(o,h),M=(0,u.getWorkspaceIdentifier)(o);return{id:M.id,configPath:M.configPath,folders:(0,s.toWorkspaceFolders)(v.folders,M.configPath,E.extUriBiasedIgnorePathCase),remoteAuthority:v.remoteAuthority,transient:v.transient}}catch(v){this.logService.warn(v.toString())}}doParseStoredWorkspace(o,h){const v=(0,k.parse)(h);if(v&&Array.isArray(v.folders))v.folders=v.folders.filter(M=>(0,s.isStoredWorkspaceFolder)(M));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return v}async createUntitledWorkspace(o,h){const{workspace:v,storedWorkspace:M}=this.newUntitledWorkspace(o,h),A=v.configPath.fsPath;return await S.Promises.mkdir((0,g.dirname)(A),{recursive:!0}),await S.Promises.writeFile(A,JSON.stringify(M,null,"	")),v}createUntitledWorkspaceSync(o,h){const{workspace:v,storedWorkspace:M}=this.newUntitledWorkspace(o,h),A=v.configPath.fsPath;return(0,R.mkdirSync)((0,g.dirname)(A),{recursive:!0}),(0,S.writeFileSync)(A,JSON.stringify(M,null,"	")),v}newUntitledWorkspace(o=[],h){const v=(Date.now()+Math.round(Math.random()*1e3)).toString(),M=(0,E.joinPath)(this.untitledWorkspacesHome,v),A=(0,E.joinPath)(M,s.UNTITLED_WORKSPACE_NAME),L=[];for(const F of o)L.push((0,s.getStoredWorkspaceFolder)(F.uri,!0,F.name,M,!y.isWindows,E.extUriBiasedIgnorePathCase));return{workspace:(0,u.getWorkspaceIdentifier)(A),storedWorkspace:{folders:L,remoteAuthority:h}}}async getWorkspaceIdentifier(o){return(0,u.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,s.isUntitledWorkspace)(o.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(o){!this.isUntitledWorkspace(o)||(this.doDeleteUntitledWorkspaceSync(o),this._onDidDeleteUntitledWorkspace.fire(o))}async deleteUntitledWorkspace(o){this.deleteUntitledWorkspaceSync(o)}doDeleteUntitledWorkspaceSync(o){const h=(0,E.originalFSPath)(o.configPath);try{(0,S.rimrafSync)((0,g.dirname)(h));const v=(0,g.join)(this.environmentMainService.workspaceStorageHome.fsPath,o.id);(0,R.existsSync)(v)&&(0,S.writeFileSync)((0,g.join)(v,"obsolete"),"")}catch(v){this.logService.warn(`Unable to delete untitled workspace ${h} (${v}).`)}}getUntitledWorkspacesSync(){const o=[];try{const h=(0,S.readdirSync)(this.untitledWorkspacesHome.fsPath).map(v=>(0,E.joinPath)(this.untitledWorkspacesHome,v,s.UNTITLED_WORKSPACE_NAME));for(const v of h){const M=(0,u.getWorkspaceIdentifier)(v),A=this.resolveLocalWorkspaceSync(v);A?o.push({workspace:M,remoteAuthority:A.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(M)}}catch(h){h.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${h}).`)}return o}async enterWorkspace(o,h,v){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,h,v))return;const A=this.doEnterWorkspace(o,(0,u.getWorkspaceIdentifier)(v));if(!!A)return this._onDidEnterWorkspace.fire({window:o,workspace:A.workspace}),A}async isValidTargetWorkspacePath(o,h,v){if(!v)return!0;if((0,s.isWorkspaceIdentifier)(o.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,v))return!1;if((0,l.findWindowOnWorkspaceOrFolder)(h,v)){const M={title:this.productService.nameLong,type:"info",buttons:[(0,n.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,E.basename)(v)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(M,(0,m.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(o,h){if(!o.config)return;o.focus();let v;return o.config.extensionDevelopmentPath||(v=this.backupMainService.registerWorkspaceBackupSync({workspace:h,remoteAuthority:o.remoteAuthority},o.config.backupPath)),(0,s.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&this.deleteUntitledWorkspaceSync(o.openedWorkspace),o.config.workspace=h,o.config.backupPath=v,{workspace:h,backupPath:v}}};r=de([te(0,p.IEnvironmentMainService),te(1,c.ILogService),te(2,f.IBackupMainService),te(3,b.IDialogMainService),te(4,a.IProductService)],r),e.WorkspacesManagementMainService=r}),define(Z[102],x([0,1,14,30,23,3,13,7,21,18,53,5,6,98,35,29,45]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,E.createDecorator)(e.ID);let p=class{constructor(c,a,l,s,u){this.logService=c,this.windowsMainService=a,this.urlService=l,this.workspacesManagementMainService=s,this.configurationService=u}async start(c,a){this.logService.trace("Received data from other instance: ",c,a),k.isMacintosh&&w.app.focus({steal:!0});const l=this.parseOpenUrl(c);if(l.length){let s=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(s=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),s.then(()=>{for(const{uri:u,url:r}of l)this.urlService.open(u,{originalUrl:r})})}else return this.startOpenWindow(c,a)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,R.coalesce)(c._urls.map(a=>{try{return{uri:I.URI.parse(a),url:a}}catch(l){return null}})):[]}async startOpenWindow(c,a){const l=(0,y.isLaunchedFromCli)(a)?0:4;let s=[];const u=c.wait&&c.waitMarkerFilePath?I.URI.file(c.waitMarkerFilePath):void 0,r=c.remote||void 0,i={context:l,cli:c,userEnv:a,waitMarkerFileURI:u,remoteAuthority:r};if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,i);else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let o=!1;if(c["new-window"]||c["unity-launch"])o=!0;else if(c["reuse-window"])o=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!k.isMacintosh}if(o)s=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const h=this.windowsMainService.getLastActiveWindow();h?(this.windowsMainService.openExistingWindow(h,i),s=[h]):s=this.windowsMainService.open({...i,forceEmpty:!0})}}else s=this.windowsMainService.open({...i,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],gotoLineMode:c.goto});if(u&&s.length===1&&s[0])return Promise.race([s[0].whenClosedOrLoaded,(0,d.whenDeleted)(u.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return w.BrowserWindow.getAllWindows().forEach(a=>{const l=this.windowsMainService.getWindowById(a.id);l?c.push(this.codeWindowToInfo(l)):c.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!w.app.accessibilitySupportEnabled,gpuFeatureStatus:w.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(s=>new Promise(u=>{const r=s.remoteAuthority;if(r){const i=`vscode:getDiagnosticInfoResponse${s.id}`,o={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(s):void 0};s.sendWhenReady("vscode:getDiagnosticInfo",D.CancellationToken.None,{replyChannel:i,args:o}),w.ipcMain.once(i,(h,v)=>{v||u({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),u(v)}),setTimeout(()=>{u({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else u(void 0)})))).filter(s=>!!s)}getFolderURIs(c){const a=[],l=c.openedWorkspace;if((0,f.isSingleFolderWorkspaceIdentifier)(l))a.push(l.uri);else if((0,f.isWorkspaceIdentifier)(l)){const s=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.configPath);s&&s.folders.forEach(r=>{a.push(r.uri)})}return a}codeWindowToInfo(c){const a=this.getFolderURIs(c),l=(0,n.assertIsDefined)(c.win);return this.browserWindowToInfo(l,a,c.remoteAuthority)}browserWindowToInfo(c,a=[],l){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:a,remoteAuthority:l}}};p=de([te(0,m.ILogService),te(1,t.IWindowsMainService),te(2,S.IURLService),te(3,b.IWorkspacesManagementMainService),te(4,g.IConfigurationService)],p),e.LaunchMainService=p}),define(Z[51],x([0,1,43,14,26,116,46,4,33,2,10,9,3,7,82,71,21,150,50,24,5,20,6,22,28,66,35,29,45]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b,p,P,c,a,l,s,u,r,i,o,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let M=class ft extends g.Disposable{constructor(L,F,U,Q,ie,re,G,O,B,V){super();this.sharedProcess=L,this.windowsMainService=F,this.dialogMainService=U,this.lifecycleMainService=Q,this.environmentMainService=ie,this.telemetryService=re,this.logService=G,this.productService=O,this.themeMainService=B,this.workspacesManagementMainService=V,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,X=>X.id),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(R.app,"browser-window-maximize",(X,$)=>$.id),X=>!!this.windowsMainService.getWindowById(X)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(R.app,"browser-window-unmaximize",(X,$)=>$.id),X=>!!this.windowsMainService.getWindowById(X)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(X,$)=>$.id),X=>!!this.windowsMainService.getWindowById(X)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),X=>!!X),X=>X.id),I.Event.filter(I.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(X,$)=>$.id),X=>!!this.windowsMainService.getWindowById(X))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new I.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(X,$,H)=>H),X=>!(Array.isArray(X)&&X.length===1&&X[0]==="workArea")),I.Event.fromNodeEventEmitter(R.screen,"display-added"),I.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){R.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(F=>({id:F.id,workspace:F.openedWorkspace,title:F.win?.getTitle()??"",filename:F.getRepresentedFilename(),dirty:F.isDocumentEdited()}))}async getWindowCount(L){return this.windowsMainService.getWindowCount()}async getActiveWindowId(L){const F=R.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(F)return F.id}openWindow(L,F,U){return Array.isArray(F)?this.doOpenWindow(L,F,U):this.doOpenEmptyWindow(L,F)}async doOpenWindow(L,F,U=Object.create(null)){F.length>0&&this.windowsMainService.open({context:5,contextWindowId:L,urisToOpen:F,cli:this.environmentMainService.args,forceNewWindow:U.forceNewWindow,forceReuseWindow:U.forceReuseWindow,preferNewWindow:U.preferNewWindow,diffMode:U.diffMode,addMode:U.addMode,gotoLineMode:U.gotoLineMode,noRecentEntry:U.noRecentEntry,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:U.remoteAuthority||void 0})}async doOpenEmptyWindow(L,F){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:L},F)}async toggleFullScreen(L){const F=this.windowById(L);F&&F.toggleFullScreen()}async handleTitleDoubleClick(L){const F=this.windowById(L);F&&F.handleTitleDoubleClick()}async isMaximized(L){const F=this.windowById(L);return F?.win?F.win.isMaximized():!1}async maximizeWindow(L){const F=this.windowById(L);F?.win&&F.win.maximize()}async unmaximizeWindow(L){const F=this.windowById(L);F?.win&&F.win.unmaximize()}async minimizeWindow(L){const F=this.windowById(L);F?.win&&F.win.minimize()}async focusWindow(L,F){F&&typeof F.windowId=="number"&&(L=F.windowId);const U=this.windowById(L);U&&U.focus({force:F?.force??!1})}async setMinimumSize(L,F,U){const Q=this.windowById(L);if(Q?.win){const[ie,re]=Q.win.getSize(),[G,O]=Q.win.getMinimumSize(),[B,V]=[F??G,U??O],[X,$]=[Math.max(ie,B),Math.max(re,V)];(G!==B||O!==V)&&Q.win.setMinimumSize(B,V),(ie!==X||re!==$)&&Q.win.setSize(X,$)}}async saveWindowSplash(L,F){this.themeMainService.saveWindowSplash(L,F)}async installShellCommand(L){const{source:F,target:U}=await this.getShellCommandLink();try{const{symbolicLink:Q}=await b.SymlinkSupport.stat(F);if(Q&&!Q.dangling){const ie=await(0,t.realpath)(F);if(U===ie)return}await b.Promises.unlink(F)}catch(Q){if(Q.code!=="ENOENT")throw Q}try{await b.Promises.symlink(U,F)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="ENOENT")throw Q;const{response:ie}=await this.showMessageBox(L,{title:this.productService.nameLong,type:"info",message:(0,p.localize)(0,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,p.localize)(1,null)),(0,d.mnemonicButtonLabel)((0,p.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ie===0)try{const re=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${U}' '${F}'\\" with administrator privileges"`;await(0,k.promisify)(w.exec)(re)}catch(re){throw new Error((0,p.localize)(3,null,F))}}}async uninstallShellCommand(L){const{source:F}=await this.getShellCommandLink();try{await b.Promises.unlink(F)}catch(U){switch(U.code){case"EACCES":const{response:Q}=await this.showMessageBox(L,{title:this.productService.nameLong,type:"info",message:(0,p.localize)(4,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,p.localize)(5,null)),(0,d.mnemonicButtonLabel)((0,p.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(Q===0)try{const ie=`osascript -e "do shell script \\"rm '${F}'\\" with administrator privileges"`;await(0,k.promisify)(w.exec)(ie)}catch(ie){throw new Error((0,p.localize)(7,null,F))}break;case"ENOENT":break;default:throw U}}}async getShellCommandLink(){const L=(0,E.resolve)(this.environmentMainService.appRoot,"bin","code"),F=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(L))throw new Error((0,p.localize)(8,null,L));return{source:F,target:L}}async showMessageBox(L,F){return this.dialogMainService.showMessageBox(F,this.toBrowserWindow(L))}async showSaveDialog(L,F){return this.dialogMainService.showSaveDialog(F,this.toBrowserWindow(L))}async showOpenDialog(L,F){return this.dialogMainService.showOpenDialog(F,this.toBrowserWindow(L))}toBrowserWindow(L){const F=this.windowById(L);if(F?.win)return F.win}async pickFileFolderAndOpen(L,F){const U=await this.dialogMainService.pickFileFolder(F);U&&(this.sendPickerTelemetry(U,F.telemetryEventName||"openFileFolder",F.telemetryExtraData),this.doOpenPicked(await Promise.all(U.map(async Q=>await b.SymlinkSupport.existsDirectory(Q)?{folderUri:S.URI.file(Q)}:{fileUri:S.URI.file(Q)})),F,L))}async pickFolderAndOpen(L,F){const U=await this.dialogMainService.pickFolder(F);U&&(this.sendPickerTelemetry(U,F.telemetryEventName||"openFolder",F.telemetryExtraData),this.doOpenPicked(U.map(Q=>({folderUri:S.URI.file(Q)})),F,L))}async pickFileAndOpen(L,F){const U=await this.dialogMainService.pickFile(F);U&&(this.sendPickerTelemetry(U,F.telemetryEventName||"openFile",F.telemetryExtraData),this.doOpenPicked(U.map(Q=>({fileUri:S.URI.file(Q)})),F,L))}async pickWorkspaceAndOpen(L,F){const U=await this.dialogMainService.pickWorkspace(F);U&&(this.sendPickerTelemetry(U,F.telemetryEventName||"openWorkspace",F.telemetryExtraData),this.doOpenPicked(U.map(Q=>({workspaceUri:S.URI.file(Q)})),F,L))}doOpenPicked(L,F,U){this.windowsMainService.open({context:3,contextWindowId:U,cli:this.environmentMainService.args,urisToOpen:L,forceNewWindow:F.forceNewWindow})}sendPickerTelemetry(L,F,U){const Q=L?L.length:0;this.telemetryService.publicLog(F,{...U,outcome:Q?"success":"canceled",numberOfPaths:Q})}async showItemInFolder(L,F){R.shell.showItemInFolder(F)}async setRepresentedFilename(L,F){const U=this.windowById(L);U&&U.setRepresentedFilename(F)}async setDocumentEdited(L,F){const U=this.windowById(L);U&&U.setDocumentEdited(F)}async openExternal(L,F){return m.isLinuxSnap?this.safeSnapOpenExternal(F):R.shell.openExternal(F),!0}safeSnapOpenExternal(L){const F=process.env.GDK_PIXBUF_MODULE_FILE,U=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,R.shell.openExternal(L),process.env.GDK_PIXBUF_MODULE_FILE=F,process.env.GDK_PIXBUF_MODULEDIR=U}moveItemToTrash(L,F){return R.shell.trashItem(F)}async isAdmin(){let L;return m.isWindows?L=(await new Promise((F,U)=>{q(["native-is-elevated"],F,U)}))():L=process.getuid()===0,L}async writeElevated(L,F,U,Q){const ie=await new Promise((re,G)=>{q(["@vscode/sudo-prompt"],re,G)});return new Promise((re,G)=>{const O=[`"${this.cliPath}"`];Q?.unlock&&O.push("--file-chmod"),O.push("--file-write",`"${F.fsPath}"`,`"${U.fsPath}"`);const B={name:this.productService.nameLong.replace("-",""),icns:m.isMacintosh&&this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ie.exec(O.join(" "),B,(V,X,$)=>{X&&this.logService.trace(`[sudo-prompt] received stdout: ${X}`),$&&this.logService.trace(`[sudo-prompt] received stderr: ${$}`),V?G(V):re(void 0)})})}get cliPath(){return m.isWindows?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):m.isLinux?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,E.join)(this.environmentMainService.appRoot,"bin","code"):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return f.virtualMachineHint.value()}get osColorScheme(){return{highContrast:R.nativeTheme.shouldUseInvertedColorScheme||R.nativeTheme.shouldUseHighContrastColors,dark:R.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(L,F,U){process.kill(F,U)}async readClipboardText(L,F){return R.clipboard.readText(F)}async writeClipboardText(L,F,U){return R.clipboard.writeText(F,U)}async readClipboardFindText(L){return R.clipboard.readFindText()}async writeClipboardFindText(L,F){return R.clipboard.writeFindText(F)}async writeClipboardBuffer(L,F,U,Q){return R.clipboard.writeBuffer(F,Buffer.from(U),Q)}async readClipboardBuffer(L,F){return R.clipboard.readBuffer(F)}async hasClipboard(L,F,U){return R.clipboard.has(F,U)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,F){const U=this.windowById(L);U&&U.updateTouchBar(F)}async notifyReady(L){const F=this.windowById(L);F&&F.setReady()}async relaunch(L,F){return this.lifecycleMainService.relaunch(F)}async reload(L,F){const U=this.windowById(L);if(U){if((0,h.isWorkspaceIdentifier)(U.openedWorkspace)){const Q=U.openedWorkspace.configPath;if(Q.scheme===y.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(Q))?.transient)return this.openWindow(U.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(U,F?.disableExtensions!==void 0?{_:[],"disable-extensions":F.disableExtensions}:void 0)}}async closeWindow(L){this.closeWindowById(L,L)}async closeWindowById(L,F){const U=this.windowById(F);if(U?.win)return U.win.close()}async quit(L){const F=this.windowsMainService.getLastActiveWindow();F?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&F.win?F.win.close():this.lifecycleMainService.quit()}async exit(L,F){await this.lifecycleMainService.kill(F)}async resolveProxy(L,F){const Q=this.windowById(L)?.win?.webContents?.session;if(Q)return Q.resolveProxy(F)}async openDevTools(L,F){const U=this.windowById(L);U?.win&&U.win.webContents.openDevTools(F)}async toggleDevTools(L){const F=this.windowById(L);F?.win&&F.win.webContents.toggleDevTools()}async sendInputEvent(L,F){const U=this.windowById(L);U?.win&&(F.type==="mouseDown"||F.type==="mouseUp")&&U.win.webContents.sendInputEvent(F)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(L,F,U,Q){if(!m.isWindows)return;const ie=await new Promise((re,G)=>{q(["vscode-windows-registry"],re,G)});try{return ie.GetStringRegKey(F,U,Q)}catch{return}}async getPassword(L,F,U){const Q=await this.withKeytar(),ie=await Q.getPassword(F,U);if(ie)try{let{content:re,hasNextChunk:G}=JSON.parse(ie);if(!re||!G)return ie;let O=1;for(;G;){const B=await Q.getPassword(F,`${U}-${O}`),V=JSON.parse(B);re+=V.content,G=V.hasNextChunk,O++}return re}catch{return ie}return ie}async setPassword(L,F,U,Q){const ie=await this.withKeytar(),re=3,G=async(O,B,V)=>{let X=0,$;for(;X<re;)try{await ie.setPassword(O,B,V);return}catch(H){$=H,this.logService.warn("Error attempting to set a password: ",H),X++,await new Promise(ee=>setTimeout(ee,200))}throw $};if(m.isWindows&&Q.length>ft.MAX_PASSWORD_LENGTH){let O=0,B=0,V=!0;for(;V;){const X=Q.substring(O,O+ft.PASSWORD_CHUNK_SIZE);O+=ft.PASSWORD_CHUNK_SIZE,V=Q.length-O>0;const $={content:X,hasNextChunk:V};await G(F,B?`${U}-${B}`:U,JSON.stringify($)),B++}}else await G(F,U,Q);this._onDidChangePassword.fire({service:F,account:U})}async deletePassword(L,F,U){const ie=await(await this.withKeytar()).deletePassword(F,U);return ie&&this._onDidChangePassword.fire({service:F,account:U}),ie}async findPassword(L,F){return(await this.withKeytar()).findPassword(F)}async findCredentials(L,F){return(await this.withKeytar()).findCredentials(F)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((L,F)=>{q(["keytar"],L,F)})}windowById(L){if(typeof L=="number")return this.windowsMainService.getWindowById(L)}};M.MAX_PASSWORD_LENGTH=2500,M.PASSWORD_CHUNK_SIZE=M.MAX_PASSWORD_LENGTH-100,de([n.memoize],M.prototype,"cliPath",null),M=de([te(1,o.IWindowsMainService),te(2,P.IDialogMainService),te(3,l.ILifecycleMainService),te(4,c.IEnvironmentMainService),te(5,r.ITelemetryService),te(6,s.ILogService),te(7,u.IProductService),te(8,i.IThemeMainService),te(9,v.IWorkspacesManagementMainService)],M),e.NativeHostMainService=M}),define(Z[235],x([0,1,14,23,4,81,2,31,88,6,51,22,35]),function(q,e,w,R,D,k,n,I,d,g,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var S;(function(f){f[f.Initial=1]="Initial",f[f.StoredCredentialsUsed=2]="StoredCredentialsUsed",f[f.LoginDialogShown=3]="LoginDialogShown"})(S||(S={}));let t=class extends n.Disposable{constructor(b,p,P,c,a){super();this.logService=b,this.windowsMainService=p,this.nativeHostMainService=P,this.encryptionMainService=c,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=S.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=D.Event.fromNodeEventEmitter(w.app,"login",(p,P,c,a,l)=>({event:p,webContents:P,req:c,authInfo:a,callback:l}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:p,req:P,callback:c}){if(!p.isProxy)return;if(!this.pendingProxyResolve&&this.state===S.LoginDialogShown&&P.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(a?.username,a?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(b);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const p=String((0,k.hash)({scheme:b.scheme,host:b.host,port:b.port}));let P,c;try{const u=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,p);if(u){const r=JSON.parse(await this.encryptionMainService.decrypt(u));P=r.username,c=r.password}}catch(u){this.logService.error(u)}if(this.state!==S.StoredCredentialsUsed&&typeof P=="string"&&typeof c=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=S.StoredCredentialsUsed,{username:P,password:c};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const l={authInfo:b,username:this.sessionCredentials?.username??P,password:this.sessionCredentials?.password??c,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,l),this.state=S.LoginDialogShown;const s=await new Promise(u=>{const r=async(i,o,h)=>{if(o===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",r),h){const v={username:h.username,password:h.password};try{if(h.remember){const M=await this.encryptionMainService.encrypt(JSON.stringify(v));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,p,M)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,p)}catch(M){this.logService.error(M)}u({username:v.username,password:v.password})}else u(void 0)};a.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=s,s}};t=de([te(0,g.ILogService),te(1,m.IWindowsMainService),te(2,y.INativeHostMainService),te(3,d.IEncryptionMainService),te(4,E.IProductService)],t),e.ProxyAuthHandler=t}),define(Z[236],x([0,1,14,26,33,2,10,3,83,148,74,50,24,5,102,6,51,54,22,55,67]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b,p,P,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,S.createDecorator)("issueMainService");let l=class Pt{constructor(u,r,i,o,h,v,M,A,L){this.userEnv=u,this.environmentMainService=r,this.launchMainService=i,this.logService=o,this.diagnosticsService=h,this.dialogMainService=v,this.nativeHostMainService=M,this.protocolMainService=A,this.productService=L,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){w.ipcMain.on("vscode:issueSystemInfoRequest",async u=>{const[r,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),o=await this.diagnosticsService.getSystemInfo(r,i);this.safeSend(u,"vscode:issueSystemInfoResponse",o)}),w.ipcMain.on("vscode:listProcesses",async u=>{const r=[];try{const i=await this.launchMainService.getMainProcessId();r.push({name:(0,g.localize)(0,null),rootProcess:await(0,d.listProcesses)(i)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(h=>{(0,y.isRemoteDiagnosticError)(h)?r.push({name:h.hostName,rootProcess:h}):h.processes&&r.push({name:h.hostName,rootProcess:h.processes})})}catch(i){this.logService.error(`Listing processes failed: ${i}`)}this.safeSend(u,"vscode:listProcessesResponse",r)}),w.ipcMain.on("vscode:issueReporterClipboard",async u=>{const r={title:this.productService.nameLong,message:(0,g.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,g.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,g.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const i=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(u,"vscode:issueReporterClipboardResponse",i.response===0)}}),w.ipcMain.on("vscode:issuePerformanceInfoRequest",async u=>{const r=await this.getPerformanceInfo();this.safeSend(u,"vscode:issuePerformanceInfoResponse",r)}),w.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const u={title:this.productService.nameLong,message:(0,g.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,g.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,g.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(u,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),w.ipcMain.on("vscode:workbenchCommand",(u,r)=>{const{id:i,from:o,args:h}=r;let v;switch(o){case"issueReporter":v=this.issueReporterParentWindow;break;case"processExplorer":v=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${o}`)}v&&v.webContents.send("vscode:runAction",{id:i,from:o,args:h})}),w.ipcMain.on("vscode:openExternal",(u,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),w.ipcMain.on("vscode:closeIssueReporter",u=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),w.ipcMain.on("vscode:closeProcessExplorer",u=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),w.ipcMain.on("vscode:windowsInfoRequest",async u=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(u,"vscode:windowsInfoResponse",r.windows)})}safeSend(u,r,...i){u.sender.isDestroyed()||u.sender.send(r,...i)}async openReporter(u){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=w.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new k.DisposableStore,i=r.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(o,i,{backgroundColor:u.styles.backgroundColor,title:(0,g.localize)(7,null),zoomLevel:u.zoomLevel,alwaysOnTop:!1},"issue-reporter"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:u,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:p.default}),this.issueReporterWindow.loadURL(n.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",q).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(u){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=w.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new k.DisposableStore,i=r.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(o,i,{backgroundColor:u.styles.backgroundColor,title:(0,g.localize)(8,null),zoomLevel:u.zoomLevel,alwaysOnTop:!0},"process-explorer"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:u,product:p.default}),this.processExplorerWindow.loadURL(n.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",q).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(u){u.isMinimized()&&u.restore(),u.focus()}createBrowserWindow(u,r,i,o){const h=new w.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:u.width,height:u.height,minWidth:300,minHeight:200,x:u.x,y:u.y,title:i.title,backgroundColor:i.backgroundColor||Pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:n.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`,`--vscode-window-kind=${o}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,a.zoomLevelToZoomFactor)(i.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:i.alwaysOnTop});return h.setMenuBarVisibility(!1),h}async getSystemStatus(){const[u,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(u,r)}getWindowPosition(u,r,i){let o;const h=w.screen.getAllDisplays();if(h.length===1)o=h[0];else{if(I.isMacintosh){const A=w.screen.getCursorScreenPoint();o=w.screen.getDisplayNearestPoint(A)}!o&&u&&(o=w.screen.getDisplayMatching(u.getBounds())),o||(o=w.screen.getPrimaryDisplay()||h[0])}const v={width:r,height:i},M=o.bounds;return v.x=M.x+M.width/2-v.width/2,v.y=M.y+M.height/2-v.height/2,M.width>0&&M.height>0&&(v.x<M.x&&(v.x=M.x),v.y<M.y&&(v.y=M.y),v.x>M.x+M.width&&(v.x=M.x),v.y>M.y+M.height&&(v.y=M.y),v.width>M.width&&(v.width=M.width),v.height>M.height&&(v.height=M.height)),v}async getPerformanceInfo(){try{const[u,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(u,r)}catch(u){throw this.logService.warn("issueService#getPerformanceInfo ",u.message),u}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=de([te(1,m.IEnvironmentMainService),te(2,t.ILaunchMainService),te(3,f.ILogService),te(4,y.IDiagnosticsService),te(5,E.IDialogMainService),te(6,b.INativeHostMainService),te(7,c.IProtocolMainService),te(8,P.IProductService)],l),e.IssueMainService=l}),define(Z[237],x([0,1,23,18,24,20,6,51,22,49,28,41,77]),function(q,e,w,R,D,k,n,I,d,g,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let S=class extends m.AbstractUpdateService{constructor(f,b,p,P,c,a,l,s){super(f,b,P,c,a,s);this.telemetryService=p,this.nativeHostMainService=l}buildUpdateFeedUrl(f){return(0,m.createUpdateURL)(`linux-${process.arch}`,f,this.productService)}doCheckForUpdates(f){!this.url||(this.setState(E.State.CheckingForUpdates(f)),this.requestService.request({url:this.url},w.CancellationToken.None).then(g.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f}),this.setState(E.State.Idle(1))):this.setState(E.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f});const p=f?b.message||b:void 0;this.setState(E.State.Idle(1,p))}))}async doDownloadUpdate(f){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):f.update.url&&this.nativeHostMainService.openExternal(void 0,f.update.url),this.setState(E.State.Idle(1))}};S=de([te(0,k.ILifecycleMainService),te(1,R.IConfigurationService),te(2,y.ITelemetryService),te(3,D.IEnvironmentMainService),te(4,g.IRequestService),te(5,n.ILogService),te(6,I.INativeHostMainService),te(7,d.IProductService)],S),e.LinuxUpdateService=S}),define(Z[238],x([0,1,43,27,26,8,23,46,9,7,113,21,18,24,19,20,6,51,22,49,28,41,77]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b,p,P,c,a,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function u(h,v=1e3){for(;!h();)await(0,k.timeout)(v)}let r;function i(){return typeof r=="undefined"&&(r=R.existsSync(d.join(d.dirname(process.execPath),"unins000.exe"))?0:1),r}let o=class extends s.AbstractUpdateService{constructor(v,M,A,L,F,U,Q,ie,re){super(v,M,L,F,U,re);this.telemetryService=A,this.fileService=Q,this.nativeHostMainService=ie}get cachePath(){const v=d.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return E.Promises.mkdir(v,{recursive:!0}).then(()=>v)}initialize(){super.initialize(),i()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(v){let M="win32";return process.arch!=="ia32"&&(M+=`-${process.arch}`),i()===1?M+="-archive":this.productService.target==="user"&&(M+="-user"),(0,s.createUpdateURL)(M,v,this.productService)}doCheckForUpdates(v){!this.url||(this.setState(l.State.CheckingForUpdates(v)),this.requestService.request({url:this.url},n.CancellationToken.None).then(c.asJson).then(M=>{const A=i();return!M||!M.url||!M.version||!M.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(l.State.Idle(A)),Promise.resolve(null)):A===1?(this.setState(l.State.AvailableForDownload(M)),Promise.resolve(null)):(this.setState(l.State.Downloading(M)),this.cleanup(M.version).then(()=>this.getUpdatePackagePath(M.version).then(L=>E.Promises.exists(L).then(F=>{if(F)return Promise.resolve(L);const U=M.url,Q=M.hash,ie=`${L}.tmp`;return this.requestService.request({url:U},n.CancellationToken.None).then(re=>this.fileService.writeFile(g.URI.file(ie),re.stream)).then(Q?()=>(0,y.checksum)(ie,M.hash):()=>{}).then(()=>E.Promises.rename(ie,L)).then(()=>L)})).then(L=>{const F=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:L},F&&M.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(M)):this.setState(l.State.Ready(M))})))}).then(void 0,M=>{this.logService.error(M),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v});const A=v?M.message||M:void 0;this.setState(l.State.Idle(i(),A))}))}async doDownloadUpdate(v){v.update.url&&this.nativeHostMainService.openExternal(void 0,v.update.url),this.setState(l.State.Idle(i()))}async getUpdatePackagePath(v){const M=await this.cachePath;return d.join(M,`CodeSetup-${this.productService.quality}-${v}.exe`)}async cleanup(v=null){const M=v?U=>!new RegExp(`${this.productService.quality}-${v}\\.exe$`).test(U):()=>!0,A=await this.cachePath,F=(await E.Promises.readdir(A)).filter(M).map(async U=>{try{await E.Promises.unlink(d.join(A,U))}catch(Q){}});await Promise.all(F)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const v=this.state.update;this.setState(l.State.Updating(v));const M=await this.cachePath;this.availableUpdate.updateFilePath=d.join(M,`CodeSetup-${this.productService.quality}-${v.version}.flag`),await E.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,w.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(i()))});const L=`${this.productService.win32MutexName}-ready`,F=await new Promise((U,Q)=>{q(["windows-mutex"],U,Q)});u(()=>F.isActive(L)).then(()=>this.setState(l.State.Ready(v)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?R.unlinkSync(this.availableUpdate.updateFilePath):(0,w.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};de([I.memoize],o.prototype,"cachePath",null),o=de([te(0,f.ILifecycleMainService),te(1,m.IConfigurationService),te(2,a.ITelemetryService),te(3,S.IEnvironmentMainService),te(4,c.IRequestService),te(5,b.ILogService),te(6,t.IFileService),te(7,p.INativeHostMainService),te(8,P.IProductService)],o),e.Win32UpdateService=o}),define(Z[239],x([0,1,14,8,23,44,4,33,2,10,9,63,3,7,154,52,18,50,24,53,205,19,20,6,22,55,99,28,208,66,67,35,29,45]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b,p,P,c,a,l,s,u,r,i,o,h,v,M,A,L,F,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(re){re[re.NONE=0]="NONE",re[re.LOADING=1]="LOADING",re[re.NAVIGATING=2]="NAVIGATING",re[re.READY=3]="READY"})(Q||(Q={}));let ie=class extends d.Disposable{constructor(G,O,B,V,X,$,H,ee,W,C,T,_,z,Y,N){super();this.logService=O,this.environmentMainService=B,this.fileService=V,this.configurationService=$,this.themeMainService=H,this.workspacesManagementMainService=ee,this.backupMainService=W,this.telemetryService=C,this.dialogMainService=T,this.lifecycleMainService=_,this.productService=z,this.protocolMainService=Y,this.windowsMainService=N,this._onWillLoad=this._register(new n.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new n.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new n.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new n.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[j,ne]=this.restoreWindowState(G.state);this.windowState=j,this.logService.trace("window#ctor: using window state",j);const se=this.windowState.mode===0||this.windowState.mode===3,oe=this.configurationService.getValue("window"),J={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:A.WindowMinimumSize.WIDTH,minHeight:A.WindowMinimumSize.HEIGHT,show:!se,title:this.productService.nameLong,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,A.zoomLevelToZoomFactor)(oe?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};m.isLinux?J.icon=(0,y.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):m.isWindows&&!this.environmentMainService.isBuilt&&(J.icon=(0,y.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),m.isMacintosh&&!this.useNativeFullScreen()&&(J.fullscreenable=!1),m.isMacintosh&&(J.acceptFirstMouse=!0,oe?.clickThroughInactive===!1&&(J.acceptFirstMouse=!1));const ce=m.isMacintosh&&oe?.nativeTabs===!0;ce&&(J.tabbingIdentifier=this.productService.nameShort);const le=(0,A.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(J.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,m.isMacintosh||(J.frame=!1)),(0,E.mark)("code/willCreateCodeBrowserWindow"),this._win=new w.BrowserWindow(J),(0,E.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),m.isMacintosh&&le&&this._win.setSheetOffset(22),m.isMacintosh&&ne&&(!ce||w.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(he=>typeof he=="number")){const he=this.windowState;this._win.setBounds({width:he.width,height:he.height,x:he.x,y:he.y})}se&&((0,E.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,E.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,a.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:j=>X.globalStorage.get(j),store:(j,ne)=>X.globalStorage.set(j,ne)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(G){m.isMacintosh?this._win.setRepresentedFilename(G):this.representedFilename=G}getRepresentedFilename(){return m.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(G){m.isMacintosh&&this._win.setDocumentEdited(G),this.documentEdited=G}isDocumentEdited(){return m.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(G){m.isMacintosh&&G?.force&&w.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(G=>{if(this.isReady)return G(this);this.whenReadyCallbacks.push(G)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(G=>{function O(){B.dispose(),V.dispose(),G()}const B=this.onDidClose(()=>O()),V=this.onWillLoad(()=>O())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(X,$)=>this.onWindowError(2,$)),this._win.webContents.on("did-fail-load",(X,$,H)=>this.onWindowError(3,{reason:H,exitCode:$})),this._win.webContents.on("will-prevent-unload",X=>{X.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const G=new Set([g.Schemas.file,g.Schemas.vscodeFileResource,g.Schemas.vscodeRemoteResource,"devtools"]),O=X=>{for(let $=X;$;$=$.parent)if($.url.startsWith(`${g.Schemas.vscodeWebview}://`))return!0;return!1},B=X=>X.resourceType==="xhr"||O(X.frame);this._win.webContents.session.webRequest.onBeforeRequest((X,$)=>{const H=S.URI.parse(X.url);return H.path.endsWith(".svg")&&!G.has(H.scheme)?$({cancel:!B(X)}):$({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((X,$)=>{const H=X.responseHeaders,ee=H["content-type"]||H["Content-Type"];if(ee&&Array.isArray(ee)){const W=S.URI.parse(X.url);if(W.path.endsWith(".svg")&&G.has(W.scheme))return H["Content-Type"]=["image/svg+xml"],$({cancel:!1,responseHeaders:H});if(!W.path.includes(g.Schemas.vscodeRemoteResource)&&ee.some(C=>C.toLowerCase().includes("image/svg")))return $({cancel:!B(X)})}return $({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",X=>{this.currentConfig&&(this.currentConfig.maximized=!0),w.app.emit("browser-window-maximize",X,this._win)}),this._win.on("unmaximize",X=>{this.currentConfig&&(this.currentConfig.maximized=!1),w.app.emit("browser-window-unmaximize",X,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(X=>this.onDidDeleteUntitledWorkspace(X)));const V=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:V},async(X,$)=>{const H=await this.marketplaceHeadersPromise;$({cancel:!1,requestHeaders:Object.assign(X.requestHeaders,H)})})}async onWindowError(G,O){switch(G){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:G,reason:O?.reason,code:O?.exitCode}),G){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(G===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const B=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(B.response!==1){const V=B.response===0;this.destroyWindow(V)}}else if(G===2){let B;O?B=(0,t.localize)(6,null,O.reason,O.exitCode??"<unknown>"):B=(0,t.localize)(5,null);const X=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(8,null))],message:B,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(X)}break}}destroyWindow(G){if(this._onDidDestroy.fire(),this._win?.destroy(),G&&this.config){let O,B;(0,F.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?O={folderUri:this.openedWorkspace.uri}:(0,F.isWorkspaceIdentifier)(this.openedWorkspace)?O={workspaceUri:this.openedWorkspace.configPath}:B=!0;const[V]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:O?[O]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});V.focus()}}onDidDeleteUntitledWorkspace(G){this.openedWorkspace?.id===G.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const G=this.getMenuBarVisibility();G!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=G,this.setMenuBarVisibility(G));let O=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;O?.endsWith("/")&&(O=O.substr(0,O.length-1));const B=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((O||"").indexOf("@")===-1&&(O!==this.currentHttpProxy||B!==this.currentNoProxy)){this.currentHttpProxy=O,this.currentNoProxy=B;const V=O||"",X=B?`${B},<local>`:"<local>";this.logService.trace(`Setting proxy to '${V}', bypassing '${X}'`),this._win.webContents.session.setProxy({proxyRules:V,proxyBypassRules:X,pacScript:""})}}addTabbedWindow(G){m.isMacintosh&&G.win&&this._win.addTabbedWindow(G.win)}load(G,O=Object.create(null)){this.isDocumentEdited()&&(!O.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),O.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(G,O),this.readyState===0?this.currentConfig=G:(this.pendingLoadConfig=G,this.readyState=2),this._win.loadURL(g.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",q).toString(!0));const B=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new R.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:G.workspace,reason:O.isReload?3:B?2:1})}updateConfiguration(G,O){const B=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(B){const V=(0,c.isLaunchedFromCli)(B)&&!(0,c.isLaunchedFromCli)(G.userEnv),X=this.isExtensionDevelopmentHost;(V||X)&&(G.userEnv={...B,...G.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(G.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),O.disableExtensions!==void 0&&(G["disable-extensions"]=O.disableExtensions),G.fullscreen=this.isFullScreen,G.maximized=this._win.isMaximized(),G.partsSplash=this.themeMainService.getWindowSplash(),(0,E.mark)("code/willOpenNewWindow"),G.perfMarks=(0,E.getMarks)(),this.configObjectUrl.update(G)}async reload(G){const O=Object.assign({},this.currentConfig);O.workspace=await this.validateWorkspaceBeforeReload(O),delete O.filesToOpenOrCreate,delete O.filesToDiff,delete O.filesToWait,this.isExtensionDevelopmentHost&&G&&(O.verbose=G.verbose,O.debugId=G.debugId,O.extensionEnvironment=G.extensionEnvironment,O["inspect-extensions"]=G["inspect-extensions"],O["inspect-brk-extensions"]=G["inspect-brk-extensions"],O["extensions-dir"]=G["extensions-dir"]),O.isInitialStartup=!1,this.load(O,{isReload:!0,disableExtensions:G?.["disable-extensions"]})}async validateWorkspaceBeforeReload(G){if((0,F.isWorkspaceIdentifier)(G.workspace)){const O=G.workspace.configPath;if(O.scheme===g.Schemas.file&&!await this.fileService.exists(O))return}else if((0,F.isSingleFolderWorkspaceIdentifier)(G.workspace)){const O=G.workspace.uri;if(O.scheme===g.Schemas.file&&!await this.fileService.exists(O))return}return G.workspace}serializeWindowState(){if(!this._win)return(0,L.defaultWindowState)();if(this.isFullScreen){let B;try{B=w.screen.getDisplayMatching(this.getBounds())}catch($){}const V=(0,L.defaultWindowState)();return{mode:3,display:B?B.id:void 0,width:this.windowState.width||V.width,height:this.windowState.height||V.height,x:this.windowState.x||0,y:this.windowState.y||0}}const G=Object.create(null);let O;if(!m.isMacintosh&&this._win.isMaximized()?O=0:O=1,O===0?G.mode=0:G.mode=1,O===1||O===0){let B;O===1?B=this.getBounds():B=this._win.getNormalBounds(),G.x=B.x,G.y=B.y,G.width=B.width,G.height=B.height}return G}restoreWindowState(G){(0,E.mark)("code/willRestoreCodeWindowState");let O=!1;if(G)try{const B=w.screen.getAllDisplays();O=B.length>1,G=this.validateWindowState(G,B)}catch(B){this.logService.warn(`Unexpected error validating window state: ${B}
${B.stack}`)}return(0,E.mark)("code/didRestoreCodeWindowState"),[G||(0,L.defaultWindowState)(),O]}validateWindowState(G,O){if(this.logService.trace(`window#validateWindowState: validating window state on ${O.length} display(s)`,G),typeof G.x!="number"||typeof G.y!="number"||typeof G.width!="number"||typeof G.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(G.width<=0||G.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(O.length===1){const X=this.getWorkingArea(O[0]);if(X){let $=function(){!G||typeof G.x!="number"||typeof G.y!="number"||!X||(G.x<X.x&&(G.x=X.x),G.y<X.y&&(G.y=X.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",X),$(),G.width>X.width&&(G.width=X.width),G.height>X.height&&(G.height=X.height),G.x>X.x+X.width-128&&(G.x=X.x+X.width-G.width),G.y>X.y+X.height-128&&(G.y=X.y+X.height-G.height),$()}return G}if(G.display&&G.mode===3){const X=O.find($=>$.id===G.display);if(X&&typeof X.bounds?.x=="number"&&typeof X.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,L.defaultWindowState)(3);return $.x=X.bounds.x,$.y=X.bounds.y,$}}let B,V;try{B=w.screen.getDisplayMatching({x:G.x,y:G.y,width:G.width,height:G.height}),V=this.getWorkingArea(B)}catch(X){}if(B&&V&&G.x+G.width>V.x&&G.y+G.height>V.y&&G.x<V.x+V.width&&G.y<V.y+V.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",V),G}getWorkingArea(G){if(G.workArea.width>0&&G.workArea.height>0)return G.workArea;if(G.bounds.width>0&&G.bounds.height>0)return G.bounds}getBounds(){const[G,O]=this._win.getPosition(),[B,V]=this._win.getSize();return{x:G,y:O,width:B,height:V}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(G){this.useNativeFullScreen()?this.setNativeFullScreen(G):this.setSimpleFullScreen(G),this.sendWhenReady(G?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(G){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(G)}setSimpleFullScreen(G){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(G),this._win.webContents.focus()}useNativeFullScreen(){const G=this.configurationService.getValue("window");return!G||typeof G.nativeFullScreen!="boolean"||G.nativeTabs?!0:G.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let G=(0,A.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(G)<0&&(G="classic"),G}setMenuBarVisibility(G,O=!0){m.isMacintosh||(G==="toggle"&&O&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),G==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(G)}):this.doSetMenuBarVisibility(G))}doSetMenuBarVisibility(G){const O=this.isFullScreen;switch(G){case"classic":this._win.setMenuBarVisibility(!O),this._win.autoHideMenuBar=O;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(m.isMacintosh)switch(w.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(G,O,...B){this.isReady?this.send(G,...B):this.ready().then(()=>{O.isCancellationRequested||this.send(G,...B)})}send(G,...O){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${G}' for window that is destroyed`);return}try{this._win.webContents.send(G,...O)}catch(B){this.logService.warn(`Error sending IPC message to channel '${G}' of window ${this._id}: ${(0,k.toErrorMessage)(B)}`)}}}updateTouchBar(G){!m.isMacintosh||this.touchBarGroups.forEach((O,B)=>{const V=G[B];O.segments=this.createTouchBarGroupSegments(V)})}createTouchBar(){if(!!m.isMacintosh){for(let G=0;G<10;G++){const O=this.createTouchBarGroup();this.touchBarGroups.push(O)}this._win.setTouchBar(new w.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(G=[]){const O=this.createTouchBarGroupSegments(G),B=new w.TouchBar.TouchBarSegmentedControl({segments:O,mode:"buttons",segmentStyle:"automatic",change:V=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:B.segments[V].id,from:"touchbar"})}});return B}createTouchBarGroupSegments(G=[]){return G.map(B=>{let V;B.icon&&!v.ThemeIcon.isThemeIcon(B.icon)&&B.icon?.dark?.scheme===g.Schemas.file&&(V=w.nativeImage.createFromPath(S.URI.revive(B.icon.dark).fsPath),V.isEmpty()&&(V=void 0));let X;return typeof B.title=="string"?X=B.title:X=B.title.value,{id:B.id,label:V?void 0:X,icon:V}})}dispose(){super.dispose(),this._win=null}};ie=de([te(1,u.ILogService),te(2,P.IEnvironmentMainService),te(3,l.IFileService),te(4,o.IStorageMainService),te(5,b.IConfigurationService),te(6,M.IThemeMainService),te(7,U.IWorkspacesManagementMainService),te(8,f.IBackupMainService),te(9,h.ITelemetryService),te(10,p.IDialogMainService),te(11,s.ILifecycleMainService),te(12,r.IProductService),te(13,i.IProtocolMainService),te(14,L.IWindowsMainService)],ie),e.CodeWindow=ie}),define(Z[68],x([0,1,14,30,8,4,33,2,10,3,16,7,21,157,5,20,6,37,29,45]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b,p,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let a=class qe extends I.Disposable{constructor(s,u,r,i){super();this.stateMainService=s,this.logService=u,this.workspacesManagementMainService=r,this.lifecycleMainService=i,this._onDidChangeRecentlyOpened=this._register(new k.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace,remoteAuthority:s.window.remoteAuthority}])))}handleWindowsJumpList(){!g.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(s){const u=[],r=[];for(let i of s)if((0,P.isRecentWorkspace)(i))!this.workspacesManagementMainService.isUntitledWorkspace(i.workspace)&&this.indexOfWorkspace(u,i.workspace)===-1&&u.push(i);else if((0,P.isRecentFolder)(i))this.indexOfFolder(u,i.folderUri)===-1&&u.push(i);else{const o=this.indexOfFile(r,i.fileUri)>=0,h=i.fileUri.scheme===d.Schemas.file&&qe.COMMON_FILES_FILTER.indexOf((0,y.basename)(i.fileUri))>=0;!o&&!h&&(r.push(i),g.isWindows&&i.fileUri.scheme===d.Schemas.file&&w.app.addRecentDocument(i.fileUri.fsPath))}this.addEntriesFromStorage(u,r),u.length>qe.MAX_TOTAL_RECENT_ENTRIES&&(u.length=qe.MAX_TOTAL_RECENT_ENTRIES),r.length>qe.MAX_TOTAL_RECENT_ENTRIES&&(r.length=qe.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:u,files:r}),this._onDidChangeRecentlyOpened.fire(),g.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(s){const u=h=>{const v=this.location(h);for(const M of s)if(y.extUriBiasedIgnorePathCase.isEqual(M,v))return!1;return!0},r=this.getRecentlyOpened(),i=r.workspaces.filter(u),o=r.files.filter(u);(i.length!==r.workspaces.length||o.length!==r.files.length)&&(this.saveRecentlyOpened({files:o,workspaces:i}),this._onDidChangeRecentlyOpened.fire(),g.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!g.isMacintosh)return;w.app.clearRecentDocuments();const s=this.getRecentlyOpened(),u=[];let r=0;for(let o=0;o<s.workspaces.length&&r<qe.MAX_MACOS_DOCK_RECENT_WORKSPACES;o++){const h=this.location(s.workspaces[o]);if(h.scheme===d.Schemas.file){const v=(0,y.originalFSPath)(h);await m.Promises.exists(v)&&(u.push(v),r++)}}const i=[];for(let o=0;o<s.files.length&&r<qe.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;o++){const h=this.location(s.files[o]);if(h.scheme===d.Schemas.file){const v=(0,y.originalFSPath)(h);if(qe.COMMON_FILES_FILTER.includes((0,y.basename)(h))||u.includes(v))continue;await m.Promises.exists(v)&&(i.push(v),r++)}}i.reverse().forEach(o=>w.app.addRecentDocument(o)),u.reverse().forEach(o=>w.app.addRecentDocument(o))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),w.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(s){const u=[],r=[];if(s){const o=s.config?.workspace;(0,P.isWorkspaceIdentifier)(o)&&!this.workspacesManagementMainService.isUntitledWorkspace(o)?u.push({workspace:o,remoteAuthority:s.remoteAuthority}):(0,P.isSingleFolderWorkspaceIdentifier)(o)&&u.push({folderUri:o.uri,remoteAuthority:s.remoteAuthority})}const i=s?.config?.filesToOpenOrCreate;if(i)for(let o of i){const h=o.fileUri;h&&this.indexOfFile(r,h)===-1&&r.push({fileUri:h})}return this.addEntriesFromStorage(u,r),{workspaces:u,files:r}}addEntriesFromStorage(s,u){let r=this.getRecentlyOpenedFromStorage();for(let i of r.workspaces){let o=(0,P.isRecentFolder)(i)?this.indexOfFolder(s,i.folderUri):this.indexOfWorkspace(s,i.workspace);o>=0?s[o].label=s[o].label||i.label:s.push(i)}for(let i of r.files){let o=this.indexOfFile(u,i.fileUri);o>=0?u[o].label=u[o].label||i.label:u.push(i)}}getRecentlyOpenedFromStorage(){const s=this.stateMainService.getItem(qe.recentlyOpenedStorageKey);return(0,P.restoreRecentlyOpened)(s,this.logService)}saveRecentlyOpened(s){const u=(0,P.toStoreData)(s);this.stateMainService.setItem(qe.recentlyOpenedStorageKey,u)}updateWindowsJumpList(){if(!g.isWindows)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,S.localize)(0,null),description:(0,S.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let u=[];for(let o of w.app.getJumpListSettings().removedItems){const h=o.args;if(h){const v=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(h);v&&u.push(E.URI.parse(v[2]))}}this.removeRecentlyOpened(u);let r=!1;const i=(0,R.coalesce)(this.getRecentlyOpened().workspaces.slice(0,qe.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(o=>{const h=(0,P.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:v,description:M}=this.getWindowsJumpListLabel(h,o.label);let A;return E.URI.isUri(h)?A=`--folder-uri "${h.toString()}"`:(r=!0,A=`--file-uri "${h.configPath.toString()}"`),{type:"task",title:v.substr(0,255),description:M.substr(0,255),program:process.execPath,args:A,iconPath:"explorer.exe",iconIndex:0}}));i.length>0&&s.push({type:"custom",name:r?(0,S.localize)(2,null):(0,S.localize)(3,null),items:i})}s.push({type:"recent"});try{w.app.setJumpList(s)}catch(u){this.logService.warn("updateWindowsJumpList#setJumpList",u)}}getWindowsJumpListLabel(s,u){if(u)return{title:(0,n.splitName)(u).name,description:u};if(E.URI.isUri(s))return{title:(0,y.basename)(s),description:this.renderJumpListPathDescription(s)};if(this.workspacesManagementMainService.isUntitledWorkspace(s))return{title:(0,S.localize)(4,null),description:""};let r=(0,y.basename)(s.configPath);return r.endsWith(P.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-P.WORKSPACE_EXTENSION.length-1)),{title:(0,S.localize)(5,null,r),description:this.renderJumpListPathDescription(s.configPath)}}renderJumpListPathDescription(s){return s.scheme==="file"?(0,n.normalizeDriveLetter)(s.fsPath):s.toString()}location(s){return(0,P.isRecentFolder)(s)?s.folderUri:(0,P.isRecentFile)(s)?s.fileUri:s.workspace.configPath}indexOfWorkspace(s,u){return s.findIndex(r=>(0,P.isRecentWorkspace)(r)&&r.workspace.id===u.id)}indexOfFolder(s,u){return s.findIndex(r=>(0,P.isRecentFolder)(r)&&y.extUriBiasedIgnorePathCase.isEqual(r.folderUri,u))}indexOfFile(s,u){return s.findIndex(r=>y.extUriBiasedIgnorePathCase.isEqual(r.fileUri,u))}};a.MAX_TOTAL_RECENT_ENTRIES=500,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=de([te(0,p.IStateMainService),te(1,b.ILogService),te(2,c.IWorkspacesManagementMainService),te(3,f.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a}),define(Z[240],x([0,1,14,8,23,33,3,7,149,18,24,20,6,187,51,22,37,28,41,67,35,68]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b,p,P,c,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let u=class yt{constructor(o,h,v,M,A,L,F,U,Q,ie,re){this.updateService=o,this.configurationService=h,this.windowsMainService=v,this.environmentMainService=M,this.telemetryService=A,this.workspacesHistoryMainService=L,this.stateMainService=F,this.lifecycleMainService=U,this.logService=Q,this.nativeHostMainService=ie,this.productService=re,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new R.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new R.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(n.isMacintosh||(0,c.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(yt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(L,F,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(L,F,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(L,F,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(L,F,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const h=this.productService.requestFeatureUrl;h&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(h,"openUserVoiceUrl"));const v=this.productService.reportIssueUrl;v&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(v,"openReportIssues"));const M=this.productService.licenseUrl;M&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(n.language){const L=M.indexOf("?")>0?"&":"?";this.openUrl(`${M}${L}lang=${n.language}`,"openLicenseUrl")}else this.openUrl(M,"openLicenseUrl")});const A=this.productService.privacyStatementUrl;A&&M&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(A,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!n.isMacintosh)return!1;let o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,h){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(yt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!n.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!n.isMacintosh||(this.noActiveWindow=!w.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=w.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){w.Menu.setApplicationMenu(n.isMacintosh?new w.Menu:null);return}const h=new w.Menu;let v;if(n.isMacintosh){const A=new w.Menu;v=new w.MenuItem({label:this.productService.nameShort,submenu:A}),this.setMacApplicationMenu(A),h.append(v)}if(n.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const A=new w.Menu;A.append(new w.MenuItem({label:this.mnemonicLabel(d.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),w.app.dock.setMenu(A)}if(this.shouldDrawMenu("File")){const A=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(d.localize(1,null)),submenu:A});this.setMenuById(A,"File"),h.append(L)}if(this.shouldDrawMenu("Edit")){const A=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(d.localize(2,null)),submenu:A});this.setMenuById(A,"Edit"),h.append(L)}if(this.shouldDrawMenu("Selection")){const A=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(d.localize(3,null)),submenu:A});this.setMenuById(A,"Selection"),h.append(L)}if(this.shouldDrawMenu("View")){const A=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(d.localize(4,null)),submenu:A});this.setMenuById(A,"View"),h.append(L)}if(this.shouldDrawMenu("Go")){const A=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(d.localize(5,null)),submenu:A});this.setMenuById(A,"Go"),h.append(L)}if(this.shouldDrawMenu("Run")){const A=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(d.localize(6,null)),submenu:A});this.setMenuById(A,"Run"),h.append(L)}if(this.shouldDrawMenu("Terminal")){const A=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(d.localize(7,null)),submenu:A});this.setMenuById(A,"Terminal"),h.append(L)}let M;if(this.shouldDrawMenu("Window")){const A=new w.Menu;M=new w.MenuItem({label:this.mnemonicLabel(d.localize(8,null)),submenu:A,role:"window"}),this.setMacWindowMenu(A)}if(M&&h.append(M),this.shouldDrawMenu("Help")){const A=new w.Menu,L=new w.MenuItem({label:this.mnemonicLabel(d.localize(9,null)),submenu:A,role:"help"});this.setMenuById(A,"Help"),h.append(L)}h.items&&h.items.length>0?w.Menu.setApplicationMenu(h):w.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const h=this.createMenuItem(d.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),v=this.getUpdateMenuItems();let M;if(this.shouldDrawMenu("Preferences")){const G=new w.Menu;this.setMenuById(G,"Preferences"),M=new w.MenuItem({label:this.mnemonicLabel(d.localize(11,null)),submenu:G})}const A=new w.Menu,L=new w.MenuItem({label:d.localize(12,null),role:"services",submenu:A}),F=new w.MenuItem({label:d.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new w.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new w.MenuItem({label:d.localize(15,null),role:"unhide"}),ie=new w.MenuItem(this.likeAction("workbench.action.quit",{label:d.localize(16,null,this.productService.nameLong),click:()=>{const G=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!w.BrowserWindow.getFocusedWindow()||G?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),re=[h];re.push(...v),M&&re.push(r(),M),re.push(r(),L,r(),F,U,Q,r(),ie),re.forEach(G=>o.append(G))}shouldDrawMenu(o){if(!n.isMacintosh&&(0,c.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(n.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(n.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,h){h.forEach(v=>{if((0,S.isMenubarMenuItemSeparator)(v))o.append(r());else if((0,S.isMenubarMenuItemSubmenu)(v)){const M=new w.Menu,A=new w.MenuItem({label:this.mnemonicLabel(v.label),submenu:M});this.setMenu(M,v.submenu.items),o.append(A)}else(0,S.isMenubarMenuItemRecentAction)(v)?o.append(this.createOpenRecentMenuItem(v)):(0,S.isMenubarMenuItemAction)(v)&&(v.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),n.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[v.id]?o.append(new w.MenuItem(this.likeAction(v.id,{label:this.mnemonicLabel(v.label),click:this.fallbackMenuHandlers[v.id]}))):o.append(this.createMenuItem(v.label,v.id,!1,v.checked)):o.append(this.createMenuItem(v.label,v.id,v.enabled!==!1,!!v.checked)):o.append(this.createMenuItem(v.label,v.id,v.enabled!==!1,!!v.checked)))})}setMenuById(o,h){this.menubarMenus&&this.menubarMenus[h]&&this.setMenu(o,this.menubarMenus[h].items)}insertCheckForUpdatesItems(o){const h=this.getUpdateMenuItems();h.length&&(h.forEach(v=>o.append(v)),o.append(r()))}createOpenRecentMenuItem(o){const h=I.URI.revive(o.uri),v=o.id,M=v==="openRecentFile"?{fileUri:h}:v==="openRecentWorkspace"?{workspaceUri:h}:{folderUri:h};return new w.MenuItem(this.likeAction(v,{label:o.label,click:(A,L,F)=>{const U=this.isOptionClick(F);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[M],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([h])}},!1))}isOptionClick(o){return!!(o&&(!n.isMacintosh&&(o.ctrlKey||o.shiftKey)||n.isMacintosh&&(o.metaKey||o.altKey)))}createRoleMenuItem(o,h,v){const M={label:this.mnemonicLabel(o),role:v,enabled:!0};return new w.MenuItem(this.withKeybinding(h,M))}setMacWindowMenu(o){const h=new w.MenuItem({label:d.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),v=new w.MenuItem({label:d.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),M=new w.MenuItem({label:d.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),A=this.createMenuItem(d.localize(20,null),"workbench.action.switchWindow"),L=[];this.currentEnableNativeTabs&&(L.push(r()),L.push(this.createMenuItem(d.localize(21,null),"workbench.action.newWindowTab")),L.push(this.createRoleMenuItem(d.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.createRoleMenuItem(d.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.createRoleMenuItem(d.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.createRoleMenuItem(d.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[h,v,r(),A,...L,r(),M].forEach(F=>o.append(F))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new w.MenuItem({label:this.mnemonicLabel(d.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new w.MenuItem({label:d.localize(27,null),enabled:!1})];case"available for download":return[new w.MenuItem({label:this.mnemonicLabel(d.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new w.MenuItem({label:d.localize(29,null),enabled:!1})];case"downloaded":return[new w.MenuItem({label:this.mnemonicLabel(d.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new w.MenuItem({label:d.localize(31,null),enabled:!1})];case"ready":return[new w.MenuItem({label:this.mnemonicLabel(d.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,h,v,M){const A=this.mnemonicLabel(o),L=typeof h=="function"?h:(re,G,O)=>{const B=re?re.userSettingsLabel:null;let V=h;Array.isArray(h)&&(V=this.isOptionClick(O)?h[1]:h[0]),B&&O.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:B}):this.runActionInRenderer({type:"commandId",commandId:V})},F=typeof v=="boolean"?v:this.windowsMainService.getWindowCount()>0,U=typeof M=="boolean"?M:!1,Q={label:A,click:L,enabled:F};U&&(Q.type="checkbox",Q.checked=U);let ie;return typeof h=="string"?ie=h:Array.isArray(h)&&(ie=h[0]),n.isMacintosh&&(ie==="editor.action.clipboardCutAction"?Q.role="cut":ie==="editor.action.clipboardCopyAction"?Q.role="copy":ie==="editor.action.clipboardPasteAction"&&(Q.role="paste"),ie==="undo"?Q.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.undo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("undo:")}):ie==="redo"?Q.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.redo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("redo:")}):ie==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.selectAll(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("selectAll:")}))),new w.MenuItem(this.withKeybinding(ie,Q))}makeContextAwareClickHandler(o,h){return(v,M,A)=>{const L=w.BrowserWindow.getFocusedWindow();if(!L)return h.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return h.inDevTools(L.webContents.devToolsWebContents);o(v,M||L,A)}}runActionInRenderer(o){let h=w.BrowserWindow.getFocusedWindow();if(!h){const M=this.windowsMainService.getLastActiveWindow();M?.isMinimized()&&(h=M.win)}const v=h?this.windowsMainService.getWindowById(h.id):void 0;if(v){if(this.logService.trace("menubar#runActionInRenderer",o),n.isMacintosh&&!this.environmentMainService.isBuilt&&!v.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const M={id:o.commandId,from:"menu"};v.sendWhenReady("vscode:runAction",D.CancellationToken.None,M)}else{const M={userSettingsLabel:o.userSettingsLabel};v.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,M)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,h){const v=typeof o=="string"?this.keybindings[o]:void 0;if(v?.label){if(v.isNative!==!1)h.accelerator=v.label,h.userSettingsLabel=v.userSettingsLabel;else if(typeof h.label=="string"){const M=h.label.indexOf("[");M>=0?h.label=`${h.label.substr(0,M)} [${v.label}]`:h.label=`${h.label} [${v.label}]`}}else h.accelerator=void 0;return h}likeAction(o,h,v=!h.accelerator){v&&(h=this.withKeybinding(o,h));const M=h.click;return h.click=(A,L,F)=>{this.reportMenuActionTelemetry(o),M&&M(A,L,F)},h}openUrl(o,h){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(h)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:s})}mnemonicLabel(o){return(0,k.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};u.lastKnownMenubarStorageKey="lastKnownMenubarData",u=de([te(0,P.IUpdateService),te(1,g.IConfigurationService),te(2,a.IWindowsMainService),te(3,y.IEnvironmentMainService),te(4,p.ITelemetryService),te(5,l.IWorkspacesHistoryMainService),te(6,b.IStateMainService),te(7,E.ILifecycleMainService),te(8,m.ILogService),te(9,t.INativeHostMainService),te(10,f.IProductService)],u),e.Menubar=u;function r(){return new w.MenuItem({type:"separator"})}}),define(Z[241],x([0,1,5,20,6,240]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,w.createDecorator)("menubarMainService");let n=class{constructor(d,g,y){this.instantiationService=d,this.lifecycleMainService=g,this.logService=y,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(k.Menubar)}async updateMenubar(d,g){this.logService.trace("menubarService#updateMenubar",d),(await this.menubar).updateMenu(g,d)}};n=de([te(0,w.IInstantiationService),te(1,R.ILifecycleMainService),te(2,D.ILogService)],n),e.MenubarMainService=n}),define(Z[242],x([0,1,14,27,26,30,23,4,32,42,33,2,10,9,63,3,34,16,13,7,155,52,18,50,24,19,5,20,6,54,22,55,64,37,67,239,100,221,29,101,68,45]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b,p,P,c,a,l,s,u,r,i,o,h,v,M,A,L,F,U,Q,ie,re,G,O,B,V,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function $(W){return(0,O.isWorkspaceIdentifier)(W?.workspace)}function H(W){return(0,O.isSingleFolderWorkspaceIdentifier)(W?.workspace)}let ee=class it extends E.Disposable{constructor(C,T,_,z,Y,N,j,ne,se,oe,J,ce,le,he,ge){super();this.machineId=C,this.initialUserEnv=T,this.logService=_,this.stateMainService=z,this.environmentMainService=Y,this.lifecycleMainService=N,this.backupMainService=j,this.configurationService=ne,this.workspacesHistoryMainService=se,this.workspacesManagementMainService=oe,this.instantiationService=J,this.dialogMainService=ce,this.fileService=le,this.productService=he,this.protocolMainService=ge,this._onDidOpenWindow=this._register(new I.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new I.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new I.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new I.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new G.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(C=>this._onDidSignalReadyWindow.fire(C.window))),this._register(this.onDidSignalReadyWindow(C=>{if(C.config?.extensionDevelopmentPath||C.config?.extensionTestsPath){const T=new E.DisposableStore;if(T.add(I.Event.any(C.onDidClose,C.onDidDestroy)(()=>T.dispose())),C.config.extensionDevelopmentPath)for(const _ of C.config.extensionDevelopmentPath)T.add(this.protocolMainService.addValidFileRoot(c.URI.file(_)));C.config.extensionTestsPath&&T.add(this.protocolMainService.addValidFileRoot(c.URI.file(C.config.extensionTestsPath)))}}))}openEmptyWindow(C,T){let _=this.environmentMainService.args;const z=T?.remoteAuthority||void 0,Y=!0,N=T?.forceReuseWindow,j=!N;return this.open({...C,cli:_,forceEmpty:Y,forceNewWindow:j,forceReuseWindow:N,remoteAuthority:z})}openExistingWindow(C,T){C.focus(),this.handleWaitMarkerFile(T,[C])}open(C){this.logService.trace("windowsManager#open"),C.addMode&&(C.initialStartup||!this.getLastActiveWindow())&&(C.addMode=!1);const T=[],_=[],z=[],Y=[],N=[];let j,ne=0;const se=this.getPathsToOpen(C);this.logService.trace("windowsManager#open pathsToOpen",se);for(const le of se)H(le)?C.addMode?T.push(le):_.push(le):$(le)?z.push(le):le.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:le.remoteAuthority}),j.filesToOpenOrCreate.push(le)):le.backupPath?N.push({backupFolder:(0,S.basename)(le.backupPath),remoteAuthority:le.remoteAuthority}):ne++;C.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),j&&C.waitMarkerFileURI&&(j.filesToWait={paths:[...j.filesToDiff,...j.filesToOpenOrCreate],waitMarkerFileUri:C.waitMarkerFileURI}),C.initialStartup?(Y.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),z.push(...Y),N.push(...this.backupMainService.getEmptyWindowBackupPaths())):N.length=0;const{windows:oe,filesOpenedInWindow:J}=this.doOpen(C,z,_,N,ne,j,T);if(this.logService.trace(`windowsManager#open used window count ${oe.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${_.length}, emptyToRestore: ${N.length}, emptyToOpen: ${ne})`),oe.length>1)if(J)J.focus();else{const le=this.windowsStateHandler.state.lastActiveWindow&&!C.forceEmpty&&!C.cli._.length&&!C.cli["file-uri"]&&!C.cli["folder-uri"]&&!(C.urisToOpen&&C.urisToOpen.length);let he=!0,ge=!0;if(le){const be=oe.filter(fe=>this.windowsStateHandler.state.lastActiveWindow&&fe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);be.length&&(be[0].focus(),he=!1,ge=!1)}if(he)for(let be=oe.length-1;be>=0;be--){const fe=oe[be];if(!(fe.openedWorkspace&&Y.some(me=>fe.openedWorkspace&&me.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&N.some(me=>fe.backupPath&&me.backupFolder===(0,S.basename)(fe.backupPath)))){fe.focus(),ge=!1;break}}ge&&oe[oe.length-1].focus()}const ce=j&&j.filesToDiff.length>0;if(!oe.some(le=>le.isExtensionDevelopmentHost)&&!ce&&!C.noRecentEntry){const le=[];for(const he of se)$(he)&&!he.transient?le.push({label:he.label,workspace:he.workspace,remoteAuthority:he.remoteAuthority}):H(he)?le.push({label:he.label,folderUri:he.workspace.uri,remoteAuthority:he.remoteAuthority}):he.fileUri&&le.push({label:he.label,fileUri:he.fileUri,remoteAuthority:he.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(le)}return this.handleWaitMarkerFile(C,oe),oe}handleWaitMarkerFile(C,T){const _=C.waitMarkerFileURI;C.context===0&&_&&T.length===1&&T[0]&&(async()=>{await T[0].whenClosedOrLoaded;try{await this.fileService.del(_)}catch(z){}})()}doOpen(C,T,_,z,Y,N,j){const ne=[];let se;function oe(fe,me){ne.push(fe),me&&(se=fe,N=void 0)}let{openFolderInNewWindow:J,openFilesInNewWindow:ce}=this.shouldOpenNewWindow(C);if(!C.initialStartup&&j.length>0){const fe=j[0].remoteAuthority,me=this.getLastActiveWindowForAuthority(fe);me&&oe(this.doAddFoldersToExistingWindow(me,j.map(pe=>pe.workspace.uri)))}const le=_.length+T.length+z.length;if(N&&le===0){const fe=N.filesToOpenOrCreate[0]||N.filesToDiff[0],me=this.getWindows().filter(Pe=>N&&(0,p.isEqualAuthority)(Pe.remoteAuthority,N.remoteAuthority));let pe;fe?.fileUri&&!ce&&((C.context===4||C.context===0||C.context===1)&&(pe=(0,re.findWindowOnFile)(me,fe.fileUri,Pe=>Pe.configPath.scheme===m.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Pe.configPath):void 0)),pe||(pe=this.doGetLastActiveWindow(me))),pe?(0,O.isWorkspaceIdentifier)(pe.openedWorkspace)?T.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):(0,O.isSingleFolderWorkspaceIdentifier)(pe.openedWorkspace)?_.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):oe(this.doOpenFilesInExistingWindow(C,pe,N),!0):oe(this.openInBrowserWindow({userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:C.forceNewTabbedWindow}),!0)}const he=(0,k.distinct)(T,fe=>fe.workspace.id);if(he.length>0){const fe=(0,k.coalesce)(he.map(me=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.configPath)));if(fe.length>0){const me=fe[0],pe=(0,p.isEqualAuthority)(N?.remoteAuthority,me.remoteAuthority)?N:void 0;oe(this.doOpenFilesInExistingWindow(C,me,pe),!!pe),J=!0}he.forEach(me=>{if(fe.some(Re=>Re.openedWorkspace&&Re.openedWorkspace.id===me.workspace.id))return;const pe=me.remoteAuthority,Pe=(0,p.isEqualAuthority)(N?.remoteAuthority,pe)?N:void 0;oe(this.doOpenFolderOrWorkspace(C,me,J,Pe),!!Pe),J=!0})}const ge=(0,k.distinct)(_,fe=>p.extUriBiasedIgnorePathCase.getComparisonKey(fe.workspace.uri));if(ge.length>0){const fe=(0,k.coalesce)(ge.map(me=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.uri)));if(fe.length>0){const me=fe[0],pe=(0,p.isEqualAuthority)(N?.remoteAuthority,me.remoteAuthority)?N:void 0;oe(this.doOpenFilesInExistingWindow(C,me,pe),!!pe),J=!0}ge.forEach(me=>{if(fe.some(Re=>(0,O.isSingleFolderWorkspaceIdentifier)(Re.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(Re.openedWorkspace.uri,me.workspace.uri)))return;const pe=me.remoteAuthority,Pe=(0,p.isEqualAuthority)(N?.remoteAuthority,pe)?N:void 0;oe(this.doOpenFolderOrWorkspace(C,me,J,Pe),!!Pe),J=!0})}const be=(0,k.distinct)(z,fe=>fe.backupFolder);if(be.length>0&&be.forEach(fe=>{const me=fe.remoteAuthority,pe=(0,p.isEqualAuthority)(N?.remoteAuthority,me)?N:void 0;oe(this.doOpenEmpty(C,!0,me,pe,fe),!!pe),J=!0}),ne.length===0||N){N&&!Y&&Y++;const fe=N?N.remoteAuthority:C.remoteAuthority;for(let me=0;me<Y;me++)oe(this.doOpenEmpty(C,J,fe,N),!!N),J=!0}return{windows:(0,k.distinct)(ne),filesOpenedInWindow:se}}doOpenFilesInExistingWindow(C,T,_){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),T.focus();const z={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToWait:_?.filesToWait,termProgram:C?.userEnv?.TERM_PROGRAM};return T.sendWhenReady("vscode:openFiles",n.CancellationToken.None,z),T}doAddFoldersToExistingWindow(C,T){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:T}),C.focus();const _={foldersToAdd:T};return C.sendWhenReady("vscode:addFolders",n.CancellationToken.None,_),C}doOpenEmpty(C,T,_,z,Y){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!Y,remoteAuthority:_,filesToOpen:z,forceNewWindow:T});let N;return!T&&typeof C.contextWindowId=="number"&&(N=this.getWindowById(C.contextWindowId)),this.openInBrowserWindow({userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,remoteAuthority:_,forceNewWindow:T,forceNewTabbedWindow:C.forceNewTabbedWindow,filesToOpen:z,windowToUse:N,emptyWindowBackupInfo:Y})}doOpenFolderOrWorkspace(C,T,_,z,Y){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:T,filesToOpen:z}),!_&&!Y&&typeof C.contextWindowId=="number"&&(Y=this.getWindowById(C.contextWindowId)),this.openInBrowserWindow({workspace:T.workspace,userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,remoteAuthority:T.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:C.forceNewTabbedWindow,filesToOpen:z,windowToUse:Y})}getPathsToOpen(C){let T,_=!1,z=!1;if(C.urisToOpen&&C.urisToOpen.length>0?(T=this.doExtractPathsFromAPI(C),_=!0):C.forceEmpty?T=[Object.create(null)]:C.cli._.length||C.cli["folder-uri"]||C.cli["file-uri"]?(T=this.doExtractPathsFromCLI(C.cli),T.length===0&&T.push(Object.create(null)),_=!0):(T=this.doGetPathsFromLastSession(),T.length===0&&T.push(Object.create(null)),z=!0),!C.addMode&&_){const Y=T.filter(N=>H(N));if(Y.length>1){const N=Y[0].remoteAuthority;if(Y.every(j=>(0,p.isEqualAuthority)(j.remoteAuthority,N))){const j=this.workspacesManagementMainService.createUntitledWorkspaceSync(Y.map(ne=>({uri:ne.workspace.uri})));T.push({workspace:j,remoteAuthority:N}),T=T.filter(ne=>!H(ne))}}}return C.initialStartup&&!z&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&T.unshift(...this.doGetPathsFromLastSession().filter(Y=>$(Y)||H(Y)||Y.backupPath)),T}doExtractPathsFromAPI(C){const T=[],_={gotoLineMode:C.gotoLineMode,remoteAuthority:C.remoteAuthority};for(const z of(0,k.coalesce)(C.urisToOpen||[])){const Y=this.resolveOpenable(z,_);if(Y)Y.label=z.label,T.push(Y);else{const N=this.resourceFromOpenable(z),j={title:this.productService.nameLong,type:"info",buttons:[(0,y.mnemonicButtonLabel)((0,a.localize)(0,null))],defaultId:0,message:N.scheme===m.Schemas.file?(0,a.localize)(1,null):(0,a.localize)(2,null),detail:N.scheme===m.Schemas.file?(0,a.localize)(3,null,(0,y.getPathLabel)(N.fsPath,this.environmentMainService)):(0,a.localize)(4,null,N.toString()),noLink:!0};this.dialogMainService.showMessageBox(j,(0,P.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))}}return T}doExtractPathsFromCLI(C){const T=[],_={ignoreFileNotFound:!0,gotoLineMode:C.goto,remoteAuthority:C.remote||void 0,forceOpenWorkspaceAsFile:!1},z=C["folder-uri"];if(z)for(const j of z){const ne=this.cliArgToUri(j);if(ne){const se=this.resolveOpenable({folderUri:ne},_);se&&T.push(se)}}const Y=C["file-uri"];if(Y)for(const j of Y){const ne=this.cliArgToUri(j);if(ne){const se=this.resolveOpenable((0,O.hasWorkspaceFileExtension)(j)?{workspaceUri:ne}:{fileUri:ne},_);se&&T.push(se)}}const N=C._;for(const j of N){const ne=_.remoteAuthority?this.doResolvePathRemote(j,_):this.doResolveFilePath(j,_);ne&&T.push(ne)}return T}cliArgToUri(C){try{const T=c.URI.parse(C);if(!T.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${C}`);return}return T}catch(T){this.logService.error(`Invalid URI input string: ${C}, ${T.message}`)}}doGetPathsFromLastSession(){const C=this.getRestoreWindowsSetting();switch(C){case"none":return[];case"one":case"all":case"preserve":case"folders":const T=[];C!=="one"&&T.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&T.push(this.windowsStateHandler.state.lastActiveWindow);const _=[];for(const z of T)if(z.workspace){const Y=this.resolveOpenable({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});$(Y)&&_.push(Y)}else if(z.folderUri){const Y=this.resolveOpenable({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});H(Y)&&_.push(Y)}else C!=="folders"&&z.backupPath&&_.push({backupPath:z.backupPath,remoteAuthority:z.remoteAuthority});return _}}getRestoreWindowsSetting(){let C;return this.lifecycleMainService.wasRestarted?C="all":(C=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(C)||(C="all")),C}resolveOpenable(C,T=Object.create(null)){let _=this.resourceFromOpenable(C);return _.scheme===m.Schemas.file?((0,Q.isFileToOpen)(C)&&(T={...T,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(_.fsPath,T)):this.doResolveRemoteOpenable(C,T)}doResolveRemoteOpenable(C,T){let _=this.resourceFromOpenable(C);const z=(0,F.getRemoteAuthority)(_)||T.remoteAuthority;if(_=(0,p.removeTrailingPathSeparator)((0,p.normalizePath)(_)),(0,Q.isFileToOpen)(C)){if(T.gotoLineMode){const{path:Y,line:N,column:j}=(0,d.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:Y}),selection:N?{startLineNumber:N,startColumn:j||1}:void 0,remoteAuthority:z}}return{fileUri:_,remoteAuthority:z}}else if((0,Q.isWorkspaceToOpen)(C))return{workspace:(0,B.getWorkspaceIdentifier)(_),remoteAuthority:z};return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:z}}resourceFromOpenable(C){return(0,Q.isWorkspaceToOpen)(C)?C.workspaceUri:(0,Q.isFolderToOpen)(C)?C.folderUri:C.fileUri}doResolveFilePath(C,T){let _,z;T.gotoLineMode&&({path:C,line:_,column:z}=(0,d.parseLineAndColumnAware)(C)),C=(0,d.sanitizeFilePath)((0,S.normalize)(C),(0,b.cwd)());try{const Y=(0,R.statSync)(C);if(Y.isFile()){if(!T.forceOpenWorkspaceAsFile){const N=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.URI.file(C));if(N)return N.transient&&T.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},type:i.FileType.File,exists:!0,remoteAuthority:N.remoteAuthority,transient:N.transient}}return{fileUri:c.URI.file(C),type:i.FileType.File,exists:!0,selection:_?{startLineNumber:_,startColumn:z||1}:void 0}}else{if(Y.isDirectory())return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(c.URI.file(C),Y),type:i.FileType.Directory,exists:!0};if(!f.isWindows&&C==="/dev/null")return{fileUri:c.URI.file(C),type:i.FileType.File,exists:!0}}}catch(Y){const N=c.URI.file(C);if(this.workspacesHistoryMainService.removeRecentlyOpened([N]),T.ignoreFileNotFound)return{fileUri:N,type:i.FileType.File,exists:!1}}}doResolvePathRemote(C,T){const _=C.charCodeAt(0),z=T.remoteAuthority;let Y,N;T.gotoLineMode&&({path:C,line:Y,column:N}=(0,d.parseLineAndColumnAware)(C)),_!==47&&((0,d.isWindowsDriveLetter)(_)&&C.charCodeAt(C.charCodeAt(1))===58&&(C=(0,d.toSlashes)(C)),C=`/${C}`);const j=c.URI.from({scheme:m.Schemas.vscodeRemote,authority:z,path:C});if(C.charCodeAt(C.length-1)!==47){if((0,O.hasWorkspaceFileExtension)(C))return T.forceOpenWorkspaceAsFile?{fileUri:j,selection:Y?{startLineNumber:Y,startColumn:N||1}:void 0,remoteAuthority:T.remoteAuthority}:{workspace:(0,B.getWorkspaceIdentifier)(j),remoteAuthority:z};if(T.gotoLineMode||S.posix.basename(C).indexOf(".")!==-1)return{fileUri:j,selection:Y?{startLineNumber:Y,startColumn:N||1}:void 0,remoteAuthority:z}}return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:z}}shouldOpenNewWindow(C){const T=this.configurationService.getValue("window"),_=T?.openFoldersInNewWindow||"default",z=T?.openFilesInNewWindow||"off";let Y=(C.preferNewWindow||C.forceNewWindow)&&!C.forceReuseWindow;!C.forceNewWindow&&!C.forceReuseWindow&&(_==="on"||_==="off")&&(Y=_==="on");let N=!1;return C.forceNewWindow||C.forceReuseWindow?N=!!C.forceNewWindow&&!C.forceReuseWindow:(f.isMacintosh?C.context===1&&(N=!0):C.context!==3&&C.context!==2&&!(C.userEnv&&C.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!C.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(N=z==="on")),{openFolderInNewWindow:!!Y,openFilesInNewWindow:N}}openExtensionDevelopmentHostWindow(C,T){const _=(0,re.findWindowOnExtensionDevelopmentPath)(this.getWindows(),C);if(_)return this.lifecycleMainService.reload(_,T.cli),_.focus(),[_];let z=T.cli["folder-uri"]||[],Y=T.cli["file-uri"]||[],N=T.cli._;if(!N.length&&!z.length&&!Y.length&&!T.cli.extensionTestsPath){const oe=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,J=oe&&(oe.workspace||oe.folderUri);J&&(c.URI.isUri(J)?J.scheme===m.Schemas.file?N=[J.fsPath]:z=[J.toString()]:J.configPath.scheme===m.Schemas.file?N=[(0,p.originalFSPath)(J.configPath)]:Y=[J.configPath.toString()])}let j=T.remoteAuthority;for(const oe of C)if(oe.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const J=c.URI.parse(oe),ce=(0,F.getRemoteAuthority)(J);ce&&(j?(0,p.isEqualAuthority)(ce,j)||this.logService.error("more than one extension development path authority"):j=ce)}N=N.filter(oe=>{const J=c.URI.file(oe);return(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),J)?!1:(0,p.isEqualAuthority)((0,F.getRemoteAuthority)(J),j)}),z=z.filter(oe=>{const J=this.cliArgToUri(oe);return J&&!!(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),J)?!1:J?(0,p.isEqualAuthority)((0,F.getRemoteAuthority)(J),j):!1}),Y=Y.filter(oe=>{const J=this.cliArgToUri(oe);return J&&!!(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),J)?!1:J?(0,p.isEqualAuthority)((0,F.getRemoteAuthority)(J),j):!1}),T.cli._=N,T.cli["folder-uri"]=z,T.cli["file-uri"]=Y;const ne=!N.length&&!z.length&&!Y.length,se={context:T.context,cli:T.cli,forceNewWindow:!0,forceEmpty:ne,userEnv:T.userEnv,noRecentEntry:!0,waitMarkerFileURI:T.waitMarkerFileURI,remoteAuthority:j};return this.open(se)}openInBrowserWindow(C){const T=this.configurationService.getValue("window"),_={...this.environmentMainService.args,...C.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:C.emptyWindowBackupInfo?(0,S.join)(this.environmentMainService.backupHome,C.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:C.remoteAuthority,workspace:C.workspace,userEnv:{...this.initialUserEnv,...C.userEnv},filesToOpenOrCreate:C.filesToOpen?.filesToOpenOrCreate,filesToDiff:C.filesToOpen?.filesToDiff,filesToWait:C.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:M.default,isInitialStartup:C.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof T?.zoomLevel=="number"?T.zoomLevel:void 0,autoDetectHighContrast:T?.autoDetectHighContrast??!0,accessibilitySupport:w.app.accessibilitySupportEnabled,colorScheme:{dark:w.nativeTheme.shouldUseDarkColors,highContrast:w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors}};let z;if(!C.forceNewWindow&&!C.forceNewTabbedWindow&&(z=C.windowToUse||this.getLastActiveWindow(),z&&z.focus()),z){const Y=z.config;!_.extensionDevelopmentPath&&Y&&!!Y.extensionDevelopmentPath&&(_.extensionDevelopmentPath=Y.extensionDevelopmentPath,_.verbose=Y.verbose,_["inspect-brk-extensions"]=Y["inspect-brk-extensions"],_.debugId=Y.debugId,_.extensionEnvironment=Y.extensionEnvironment,_["inspect-extensions"]=Y["inspect-extensions"],_["extensions-dir"]=Y["extensions-dir"])}else{const Y=this.windowsStateHandler.getNewWindowState(_);(0,t.mark)("code/willCreateCodeWindow");const N=z=this.instantiationService.createInstance(ie.CodeWindow,{state:Y,extensionDevelopmentPath:_.extensionDevelopmentPath,isExtensionTestHost:!!_.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),C.forceNewTabbedWindow){const ne=this.getLastActiveWindow();ne&&ne.addTabbedWindow(N)}it.WINDOWS.push(N),this._onDidOpenWindow.fire(N),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,g.once)(N.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(N)),(0,g.once)(N.onDidClose)(()=>this.onWindowClosed(N)),(0,g.once)(N.onDidDestroy)(()=>this._onDidDestroyWindow.fire(N));const j=(0,P.assertIsDefined)(N.win?.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.lifecycleMainService.reload(N)),this.lifecycleMainService.registerWindow(N)}return _.windowId=z.id,z.isReady?this.lifecycleMainService.unload(z,4).then(Y=>{Y||this.doOpenInBrowserWindow(z,_,C)}):this.doOpenInBrowserWindow(z,_,C),z}doOpenInBrowserWindow(C,T,_){if(!T.extensionDevelopmentPath)if((0,O.isWorkspaceIdentifier)(T.workspace))T.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:T.workspace,remoteAuthority:T.remoteAuthority});else if((0,O.isSingleFolderWorkspaceIdentifier)(T.workspace))T.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:T.workspace.uri,remoteAuthority:T.remoteAuthority});else{const z=_.emptyWindowBackupInfo&&_.emptyWindowBackupInfo.backupFolder;T.backupPath=this.backupMainService.registerEmptyWindowBackupSync(z,T.remoteAuthority)}C.load(T)}onWindowClosed(C){const T=it.WINDOWS.indexOf(C);it.WINDOWS.splice(T,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const C=w.BrowserWindow.getFocusedWindow();if(C)return this.getWindowById(C.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(C){return this.doGetLastActiveWindow(this.getWindows().filter(T=>(0,p.isEqualAuthority)(T.remoteAuthority,C)))}doGetLastActiveWindow(C){const T=Math.max.apply(Math,C.map(_=>_.lastFocusTime));return C.find(_=>_.lastFocusTime===T)}sendToFocused(C,...T){const _=this.getFocusedWindow()||this.getLastActiveWindow();_&&_.sendWhenReady(C,n.CancellationToken.None,...T)}sendToAll(C,T,_){for(const z of this.getWindows())_&&_.indexOf(z.id)>=0||z.sendWhenReady(C,n.CancellationToken.None,T)}getWindows(){return it.WINDOWS}getWindowCount(){return it.WINDOWS.length}getWindowById(C){const T=this.getWindows().filter(_=>_.id===C);return(0,k.firstOrDefault)(T)}getWindowByWebContents(C){const T=w.BrowserWindow.fromWebContents(C);if(!!T)return this.getWindowById(T.id)}};ee.WINDOWS=[],ee=de([te(2,v.ILogService),te(3,U.IStateMainService),te(4,r.IEnvironmentMainService),te(5,h.ILifecycleMainService),te(6,l.IBackupMainService),te(7,s.IConfigurationService),te(8,V.IWorkspacesHistoryMainService),te(9,X.IWorkspacesManagementMainService),te(10,o.IInstantiationService),te(11,u.IDialogMainService),te(12,i.IFileService),te(13,A.IProductService),te(14,L.IProtocolMainService)],ee),e.WindowsMainService=ee}),define(Z[243],x([0,1,52,35,68,45]),function(q,e,w,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let n=class{constructor(d,g,y,E){this.workspacesManagementMainService=d,this.windowsMainService=g,this.workspacesHistoryMainService=y,this.backupMainService=E,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(d,g){const y=this.windowsMainService.getWindowById(d);if(y)return this.workspacesManagementMainService.enterWorkspace(y,this.windowsMainService.getWindows(),g)}createUntitledWorkspace(d,g,y){return this.workspacesManagementMainService.createUntitledWorkspace(g,y)}deleteUntitledWorkspace(d,g){return this.workspacesManagementMainService.deleteUntitledWorkspace(g)}getWorkspaceIdentifier(d,g){return this.workspacesManagementMainService.getWorkspaceIdentifier(g)}async getRecentlyOpened(d){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(d))}async addRecentlyOpened(d,g){return this.workspacesHistoryMainService.addRecentlyOpened(g)}async removeRecentlyOpened(d,g){return this.workspacesHistoryMainService.removeRecentlyOpened(g)}async clearRecentlyOpened(d){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};n=de([te(0,k.IWorkspacesManagementMainService),te(1,R.IWindowsMainService),te(2,D.IWorkspacesHistoryMainService),te(3,w.IBackupMainService)],n),e.WorkspacesMainService=n}),define(Z[244],x([0,1,14,27,26,17,44,15,32,42,38,33,2,10,9,3,16,13,7,31,71,121,36,124,85,235,134,52,226,18,180,163,74,50,225,88,24,53,90,171,188,172,222,89,173,19,183,93,73,5,75,236,201,102,20,6,185,241,51,22,64,231,76,37,219,99,202,28,204,206,65,41,210,233,237,234,238,98,211,212,213,214,216,35,242,217,29,68,243,45]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b,p,P,c,a,l,s,u,r,i,o,h,v,M,A,L,F,U,Q,ie,re,G,O,B,V,X,$,H,ee,W,C,T,_,z,Y,N,j,ne,se,oe,J,ce,le,he,ge,be,fe,me,pe,Pe,Re,Fe,$e,ze,Qe,Ge,gt,Je,at,ct,Ve,He,K,ae,ue,ve,Ie,Ce,Te,We,Oe,Ne,je,bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let mt=class extends m.Disposable{constructor(we,ye,Ee,Se,ke,De,Me,Le,Ae,Xe){super();this.mainProcessNodeIpcServer=we,this.userEnv=ye,this.mainInstantiationService=Ee,this.logService=Se,this.environmentMainService=ke,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Le,this.fileService=Ae,this.productService=Xe,this.configureSession(),this.registerListeners()}configureSession(){const we=Se=>Se?.startsWith(`${S.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);w.session.defaultSession.setPermissionRequestHandler((Se,ke,De,Me)=>we(Me.requestingUrl)?De(ye.has(ke)):De(!1)),w.session.defaultSession.setPermissionCheckHandler((Se,ke,De,Me)=>we(Me.requestingUrl)?ye.has(ke):!1);const Ee=w.session.defaultSession;typeof Ee.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ee.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,I.setUnexpectedErrorHandler)(Ee=>this.onUnexpectedError(Ee)),process.on("uncaughtException",Ee=>(0,I.onUnexpectedError)(Ee)),process.on("unhandledRejection",Ee=>(0,I.onUnexpectedError)(Ee)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,l.registerContextMenuListener)(),w.app.on("accessibility-support-changed",(Ee,Se)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Se)}),w.app.on("activate",(Ee,Se)=>{this.logService.trace("app#activate"),Se||this.windowsMainService?.openEmptyWindow({context:1})}),w.app.on("web-contents-created",(Ee,Se)=>{Se.on("will-navigate",ke=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),Se.setWindowOpenHandler(({url:ke})=>(this.nativeHostMainService?.openExternal(void 0,ke),{action:"deny"}))});let we=[],ye;w.app.on("open-file",(Ee,Se)=>{this.logService.trace("app#open-file: ",Se),Ee.preventDefault(),we.push(this.getWindowOpenableFromPathSync(Se)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:we,gotoLineMode:!1,preferNewWindow:!0}),we=[],ye=void 0},100)}),w.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),w.ipcMain.handle("vscode:fetchShellEnv",Ee=>{const Se=this.windowsMainService?.getWindowByWebContents(Ee.sender);let ke,De;return Se?.config?(ke=Se.config,De={...process.env,...Se.config.userEnv}):(ke=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(ke,De,!1)}),w.ipcMain.handle("vscode:writeNlsFile",(Ee,Se,ke)=>{const De=this.validateNlsPath([Se]);if(!De||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,k.VSBuffer.fromString(ke))}),w.ipcMain.handle("vscode:readNlsFile",async(Ee,...Se)=>{const ke=this.validateNlsPath(Se);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(ke)).value.toString()}),w.ipcMain.on("vscode:toggleDevTools",Ee=>Ee.sender.toggleDevTools()),w.ipcMain.on("vscode:openDevTools",Ee=>Ee.sender.openDevTools()),w.ipcMain.on("vscode:reloadWindow",Ee=>Ee.sender.reload())}validateNlsPath(we){let ye;for(const Ee of we)typeof Ee=="string"&&(typeof ye!="string"?ye=Ee:ye=(0,t.join)(ye,Ee));if(!(typeof ye!="string"||!(0,t.isAbsolute)(ye)||!(0,d.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!f.isLinux)))return P.URI.file(ye)}onUnexpectedError(we){if(we){const ye={message:`[uncaught exception in main]: ${we.message}`,stack:we.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${we}`),we.stack&&this.logService.error(we.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const we=this.productService.win32AppUserModelId;f.isWindows&&we&&w.app.setAppUserModelId(we);try{f.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!w.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&w.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ae){this.logService.error(Ae)}const ye=new u.Server;this.logService.trace("Resolving machine identifier...");const Ee=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Ee}`);const{sharedProcess:Se,sharedProcessReady:ke,sharedProcessClient:De}=this.setupSharedProcess(Ee),Me=await this.initServices(Ee,Se,ke);if(this.environmentMainService.driverHandle){const Ae=await(0,Q.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Ae)}this._register(Me.createInstance(i.ProxyAuthHandler)),Me.invokeFunction(Ae=>this.initChannels(Ae,ye,De));const Le=Me.invokeFunction(Ae=>this.openFirstWindow(Ae,ye));Me.invokeFunction(Ae=>this.afterWindowOpen(Ae,Se)),this.environmentMainService.args.trace&&Me.invokeFunction(Ae=>this.stopTracingEventually(Ae,Le))}async resolveMachineId(){let we=this.stateMainService.getItem(Fe.machineIdKey);return(!we||f.isMacintosh&&we==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(we=await(0,a.getMachineId)(),this.stateMainService.setItem(Fe.machineIdKey,we)),we}setupSharedProcess(we){const ye=this._register(this.mainInstantiationService.createInstance(be.SharedProcess,we,this.userEnv)),Ee=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new r.Client(ke,"main")})(),Se=(async()=>(await ye.whenReady(),Ee))();return{sharedProcess:ye,sharedProcessReady:Se,sharedProcessClient:Ee}}async initServices(we,ye,Ee){const Se=new Y.ServiceCollection;switch(process.platform){case"win32":Se.set(Ge.IUpdateService,new _.SyncDescriptor(Ve.Win32UpdateService));break;case"linux":f.isLinuxSnap?Se.set(Ge.IUpdateService,new _.SyncDescriptor(ct.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(Ge.IUpdateService,new _.SyncDescriptor(at.LinuxUpdateService));break;case"darwin":Se.set(Ge.IUpdateService,new _.SyncDescriptor(Je.DarwinUpdateService));break}Se.set(Ce.IWindowsMainService,new _.SyncDescriptor(Te.WindowsMainService,[we,this.userEnv])),Se.set(U.IDialogMainService,new _.SyncDescriptor(U.DialogMainService)),Se.set(ne.ILaunchMainService,new _.SyncDescriptor(ne.LaunchMainService)),Se.set(F.IDiagnosticsService,s.ProxyChannel.toService((0,s.getDelayedChannel)(Ee.then(De=>De.getChannel("diagnostics"))))),Se.set(N.IIssueMainService,new _.SyncDescriptor(N.IssueMainService,[this.userEnv])),Se.set(ie.IEncryptionMainService,new _.SyncDescriptor(ie.EncryptionMainService,[we])),Se.set(j.IKeyboardLayoutMainService,new _.SyncDescriptor(j.KeyboardLayoutMainService)),Se.set(le.INativeHostMainService,new _.SyncDescriptor(le.NativeHostMainService,[ye])),Se.set(ve.IWebviewManagerService,new _.SyncDescriptor(Ie.WebviewMainService)),Se.set(Oe.IWorkspacesService,new _.SyncDescriptor(je.WorkspacesMainService)),Se.set(bt.IWorkspacesManagementMainService,new _.SyncDescriptor(bt.WorkspacesManagementMainService)),Se.set(Ne.IWorkspacesHistoryMainService,new _.SyncDescriptor(Ne.WorkspacesHistoryMainService)),Se.set(ce.IMenubarMainService,new _.SyncDescriptor(ce.MenubarMainService)),Se.set(B.IExtensionUrlTrustService,new _.SyncDescriptor(V.ExtensionUrlTrustService)),Se.set(X.IExtensionHostStarter,new _.SyncDescriptor($.WorkerMainProcessExtensionHostStarter)),Se.set(Pe.IStorageMainService,new _.SyncDescriptor(Pe.StorageMainService)),f.isWindows?Se.set(H.IExternalTerminalMainService,new _.SyncDescriptor(ee.WindowsExternalTerminalService)):f.isMacintosh?Se.set(H.IExternalTerminalMainService,new _.SyncDescriptor(ee.MacExternalTerminalService)):f.isLinux&&Se.set(H.IExternalTerminalMainService,new _.SyncDescriptor(ee.LinuxExternalTerminalService));const ke=new v.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(Se.set(h.IBackupMainService,ke),Se.set(He.IURLService,new _.SyncDescriptor(ae.NativeURLService)),(0,Qe.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,s.getDelayedChannel)(Ee.then(Ze=>Ze.getChannel("telemetryAppender"))),Me=new $e.TelemetryAppenderClient(De),Le=(0,Re.resolveCommonProperties)(this.fileService,(0,D.release)(),(0,D.hostname)(),process.arch,this.productService.commit,this.productService.version,we,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ae=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Xe={appenders:[Me],commonProperties:Le,piiPaths:Ae,sendErrorTelemetry:!0};Se.set(Fe.ITelemetryService,new _.SyncDescriptor(ze.TelemetryService,[Xe]))}else Se.set(Fe.ITelemetryService,Qe.NullTelemetryService);return await ke.initialize(),this.mainInstantiationService.createChild(Se)}initChannels(we,ye,Ee){const Se=s.ProxyChannel.fromService(we.get(ne.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Se);const ke=this.fileService.getProvider(S.Schemas.file);(0,p.assertType)(ke instanceof T.DiskFileSystemProvider);const De=new C.DiskFileSystemProviderChannel(ke,this.logService);ye.registerChannel("localFilesystem",De);const Me=new A.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService);ye.registerChannel(A.UserConfigurationFileServiceId,s.ProxyChannel.fromService(Me)),Ee.then(Be=>Be.registerChannel(A.UserConfigurationFileServiceId,s.ProxyChannel.fromService(Me)));const Le=new gt.UpdateChannel(we.get(Ge.IUpdateService));ye.registerChannel("update",Le);const Ae=s.ProxyChannel.fromService(we.get(N.IIssueMainService));ye.registerChannel("issue",Ae);const Xe=s.ProxyChannel.fromService(we.get(ie.IEncryptionMainService));ye.registerChannel("encryption",Xe);const Ze=s.ProxyChannel.fromService(we.get(fe.ISignService));ye.registerChannel("sign",Ze);const nt=s.ProxyChannel.fromService(we.get(j.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",nt),this.nativeHostMainService=we.get(le.INativeHostMainService);const xe=s.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",xe),Ee.then(Be=>Be.registerChannel("nativeHost",xe));const wt=s.ProxyChannel.fromService(we.get(Oe.IWorkspacesService));ye.registerChannel("workspaces",wt);const Ue=s.ProxyChannel.fromService(we.get(ce.IMenubarMainService));ye.registerChannel("menubar",Ue);const lt=s.ProxyChannel.fromService(we.get(He.IURLService));ye.registerChannel("url",lt);const rt=s.ProxyChannel.fromService(we.get(B.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",rt);const st=s.ProxyChannel.fromService(we.get(ve.IWebviewManagerService));ye.registerChannel("webview",st);const ot=this._register(new pe.StorageDatabaseChannel(this.logService,we.get(Pe.IStorageMainService)));ye.registerChannel("storage",ot),Ee.then(Be=>Be.registerChannel("storage",ot));const ut=s.ProxyChannel.fromService(we.get(H.IExternalTerminalMainService));ye.registerChannel("externalTerminal",ut);const et=new J.LogLevelChannel(we.get(oe.ILogService));ye.registerChannel("logLevel",et),Ee.then(Be=>Be.registerChannel("logLevel",et));const tt=new J.LoggerChannel(we.get(oe.ILoggerService));ye.registerChannel("logger",tt),Ee.then(Be=>Be.registerChannel("logger",tt));const ht=new L.ElectronExtensionHostDebugBroadcastChannel(we.get(Ce.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",ht);const _e=s.ProxyChannel.fromService(we.get(X.IExtensionHostStarter));ye.registerChannel(X.ipcExtensionHostStarterChannelName,_e)}openFirstWindow(we,ye){const Ee=this.windowsMainService=we.get(Ce.IWindowsMainService),Se=we.get(He.IURLService),ke=we.get(le.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(_e=>{try{return{uri:P.URI.parse(_e),url:_e}}catch{return}}).filter(_e=>{if(!_e||this.shouldBlockURI(_e.uri))return!1;const Be=this.getWindowOpenableFromProtocolLink(_e.uri);return Be?(De.push(Be),!1):!0}),Le=this,Ae=this.environmentMainService,Xe=this.productService;Se.registerHandler({async handleURL(_e,Be){if(_e.scheme===Xe.urlProtocol&&_e.path==="workspace"&&(_e=_e.with({authority:"file",path:P.URI.parse(_e.query).path,query:""})),Le.shouldBlockURI(_e))return!0;const Et=Le.getWindowOpenableFromProtocolLink(_e);if(Et){const[pt]=Ee.open({context:5,cli:{...Ae.args},urisToOpen:[Et],gotoLineMode:!0});return pt.focus(),!0}if(f.isMacintosh&&Ee.getWindowCount()===0){const[pt]=Ee.open({context:5,cli:{...Ae.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ge.getRemoteAuthority)(_e)});return await pt.ready(),Se.open(_e,Be)}return!1}});const Ze=this._register(new We.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),nt=new s.StaticRouter(_e=>Ze.getActiveClientId().then(Be=>_e===Be)),xe=new K.URLHandlerRouter(nt),wt=ye.getChannel("urlHandler",xe);Se.registerHandler(new K.URLHandlerChannelClient(wt)),this._register(new ue.ElectronURLListener(Me,Se,Ee,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,lt=global.macOpenFiles,rt=(0,G.isLaunchedFromCli)(process.env)?0:4,st=Ue._.length,ot=!!Ue["folder-uri"],ut=!!Ue["file-uri"],et=Ue["skip-add-to-recently-opened"]===!0,tt=Ue.wait&&Ue.waitMarkerFilePath?P.URI.file(Ue.waitMarkerFilePath):void 0,ht=Ue.remote||void 0;return De.length>0?Ee.open({context:rt,cli:Ue,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!st&&!ot&&!ut?Ee.open({context:rt,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:et,waitMarkerFileURI:tt,initialStartup:!0,remoteAuthority:ht}):lt.length&&!st&&!ot&&!ut?Ee.open({context:1,cli:Ue,urisToOpen:lt.map(_e=>this.getWindowOpenableFromPathSync(_e)),noRecentEntry:et,waitMarkerFileURI:tt,initialStartup:!0}):Ee.open({context:rt,cli:Ue,forceNewWindow:Ue["new-window"]||!st&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:et,waitMarkerFileURI:tt,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:ht})}shouldBlockURI(we){return!!(we.authority===S.Schemas.file&&f.isWindows&&w.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,E.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,E.getPathLabel)(we.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(we){if(!!we.path){if(we.authority===S.Schemas.file){const ye=P.URI.file(we.fsPath);return(0,Oe.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(we.authority===S.Schemas.vscodeRemote){const ye=we.path.indexOf(t.posix.sep,1);if(ye!==-1){const Ee=we.path.substring(1,ye),Se=we.path.substring(ye),ke=P.URI.from({scheme:S.Schemas.vscodeRemote,authority:Ee,path:Se,query:we.query,fragment:we.fragment});return(0,Oe.hasWorkspaceFileExtension)(Se)?{workspaceUri:ke}:/:[\d]+$/.test(Se)?{fileUri:ke}:{folderUri:ke}}}}}getWindowOpenableFromPathSync(we){try{if((0,R.statSync)(we).isDirectory())return{folderUri:P.URI.file(we)};if((0,Oe.hasWorkspaceFileExtension)(we))return{workspaceUri:P.URI.file(we)}}catch(ye){}return{fileUri:P.URI.file(we)}}async afterWindowOpen(we,ye){this.lifecycleMainService.phase=3;let Ee=!1;(0,g.once)(this.lifecycleMainService.onWillShutdown)(()=>Ee=!0);const Se=we.get(Fe.ITelemetryService);this._register(ye.onDidError(({type:Me,details:Le})=>{let Ae;switch(Me){case 1:Ae="SharedProcess: detected unresponsive window";break;case 2:Ae=`SharedProcess: crashed (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break;case 3:Ae=`SharedProcess: failed to load (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(Ae)),Se.publicLog2("sharedprocesserror",{type:Me,reason:Le?.reason,code:Le?.exitCode,visible:ye.isVisible(),shuttingdown:Ee})}));const ke=this.productService.win32MutexName;if(f.isWindows&&ke)try{const Me=q.__$__nodeRequire("windows-mutex").Mutex,Le=new Me(ke);(0,g.once)(this.lifecycleMainService.onWillShutdown)(()=>Le.release())}catch(Me){this.logService.error(Me)}w.protocol.registerHttpProtocol(S.Schemas.vscodeRemoteResource,(Me,Le)=>{Le({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=we.get(Ge.IUpdateService);(De instanceof Ve.Win32UpdateService||De instanceof at.LinuxUpdateService||De instanceof Je.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Le=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,y.stripComments)(Le))["enable-crash-reporter"]===void 0){const Ze=(0,Qe.getTelemetryLevel)(this.configurationService)>=1,nt=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ze},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.generateUuid)()}"`,"}"],xe=Le.substring(0,Le.length-2).concat(`,
`,nt.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,k.VSBuffer.fromString(xe))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(we,ye,Ee){try{return await(0,O.getResolvedShellEnv)(this.logService,we,ye)}catch(Se){const ke=(0,n.toErrorMessage)(Se);Ee?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",ke):this.logService.error(ke)}return{}}stopTracingEventually(we,ye){this.logService.info("Tracing: waiting for windows to get ready...");const Ee=we.get(U.IDialogMainService);let Se=!1;const ke=async Me=>{if(Se)return;Se=!0;const Le=await w.contentTracing.stopRecording((0,b.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Le}`):Ee.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,Le),buttons:[(0,E.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,p.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>ke(!0),3e4);Promise.all(ye.map(Me=>Me.ready())).then(()=>{clearTimeout(De),ke(!1)})}};mt=de([te(2,z.IInstantiationService),te(3,oe.ILogService),te(4,re.IEnvironmentMainService),te(5,se.ILifecycleMainService),te(6,M.IConfigurationService),te(7,me.IStateMainService),te(8,W.IFileService),te(9,he.IProductService)],mt),e.CodeApplication=mt}),define(Z[251],x([0,1,14,27,30,8,44,15,32,42,33,10,9,63,3,34,25,21,36,57,244,11,18,192,203,24,53,166,19,182,93,73,175,75,20,94,6,186,95,54,22,55,189,96,228,49,230,76,200,37,232,65,66,209]),function(q,e,w,R,D,k,n,I,d,g,y,E,m,S,t,f,b,p,P,c,a,l,s,u,r,i,o,h,v,M,A,L,F,U,Q,ie,re,G,O,B,V,X,$,H,ee,W,C,T,_,z,Y,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ne{main(){try{this.startup()}catch(J){console.error(J.message),w.app.exit(1)}}async startup(){(0,I.setUnexpectedErrorHandler)(me=>console.error(me));const[J,ce,le,he,ge,be,fe]=this.createServices();try{try{await this.initServices(le,he,ge)}catch(me){throw this.handleStartupDataDirError(le,fe.nameLong,me),me}await J.invokeFunction(async me=>{const pe=me.get(re.ILogService),Pe=me.get(Q.ILifecycleMainService),Re=me.get(v.IFileService),Fe=await this.claimInstance(pe,le,Pe,J,fe,!0);return p.Promises.writeFile(le.mainLockfile,String(process.pid)).catch($e=>{pe.warn(`Error writing main lockfile: ${$e.stack}`)}),be.logger=new O.SpdLogLogger("main",(0,m.join)(le.logsPath,"main.log"),!0,!1,be.getLevel()),(0,g.once)(Pe.onWillShutdown)($e=>{Re.dispose(),he.dispose(),$e.join(p.Promises.unlink(le.mainLockfile).catch(()=>{}))}),J.createInstance(a.CodeApplication,Fe,ce).startup()})}catch(me){J.invokeFunction(this.quit,me)}}createServices(){const J=new U.ServiceCollection,ce={_serviceBrand:void 0,...B.default};J.set(V.IProductService,ce);const le=new i.EnvironmentMainService(this.resolveArgs(),ce),he=this.patchEnvironment(le);J.set(i.IEnvironmentMainService,le);const ge=new ie.BufferLogService,be=new re.MultiplexLogService([new re.ConsoleMainLogger((0,re.getLogLevel)(le)),ge]);process.once("exit",()=>be.dispose()),J.set(re.ILogService,be);const fe=new M.FileService(be);J.set(v.IFileService,fe);const me=new A.DiskFileSystemProvider(be);fe.registerProvider(E.Schemas.file,me),J.set(re.ILoggerService,new G.LoggerService(be,fe));const pe=new u.ConfigurationService(le.settingsResource,fe);J.set(s.IConfigurationService,pe),J.set(Q.ILifecycleMainService,new L.SyncDescriptor(Q.LifecycleMainService));const Pe=new Y.StateMainService(le,be,fe);return J.set(z.IStateMainService,Pe),J.set(W.IRequestService,new L.SyncDescriptor(C.RequestMainService)),J.set(j.IThemeMainService,new L.SyncDescriptor(j.ThemeMainService)),J.set(T.ISignService,new L.SyncDescriptor(_.SignService)),J.set(H.ITunnelService,new L.SyncDescriptor(ee.TunnelService)),J.set(X.IProtocolMainService,new L.SyncDescriptor($.ProtocolMainService)),[new F.InstantiationService(J,!0),he,le,pe,Pe,ge,ce]}patchEnvironment(J){const ce={VSCODE_IPC_HOOK:J.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(le=>{const he=process.env[le];typeof he=="string"&&(ce[le]=he)}),Object.assign(process.env,ce),ce}initServices(J,ce,le){return k.Promises.settled([Promise.all([J.extensionsPath,J.codeCachePath,J.logsPath,J.globalStorageHome.fsPath,J.workspaceStorageHome.fsPath,J.backupHome].map(he=>he?p.Promises.mkdir(he,{recursive:!0}):void 0)),ce.initialize(),le.init()])}async claimInstance(J,ce,le,he,ge,be){let fe;try{(0,S.mark)("code/willStartMainServer"),fe=await(0,c.serve)(ce.mainIPCHandle),(0,S.mark)("code/didStartMainServer"),(0,g.once)(le.onWillShutdown)(()=>fe.dispose())}catch(me){if(me.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ce,ge.nameLong,me),me;let pe;try{pe=await(0,c.connect)(ce.mainIPCHandle,"main")}catch(Fe){if(!be||t.isWindows||Fe.code!=="ECONNREFUSED")throw Fe.code==="EPERM"&&this.showStartupWarningDialog((0,l.localize)(0,null,ge.nameShort),(0,l.localize)(1,null),ge.nameLong),Fe;try{(0,R.unlinkSync)(ce.mainIPCHandle)}catch($e){throw J.warn("Could not delete obsolete instance handle",$e),$e}return this.claimInstance(J,ce,le,he,ge,!1)}if(ce.extensionTestsLocationURI&&!ce.debugExtensionHost.break){const Fe="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw J.error(Fe),pe.dispose(),new Error(Fe)}let Pe;!ce.args.wait&&!ce.args.status&&(Pe=setTimeout(()=>{this.showStartupWarningDialog((0,l.localize)(2,null,ge.nameShort),(0,l.localize)(3,null),ge.nameLong)},1e4));const Re=P.ProxyChannel.toService(pe.getChannel("launch"),{disableMarshalling:!0});if(ce.args.status)return he.invokeFunction(async()=>{const Fe=new r.DiagnosticsService(N.NullTelemetryService,ge),$e=await Re.getMainProcessInfo(),ze=await Re.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Qe=await Fe.getDiagnostics($e,ze);throw console.log(Qe),new I.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Re,J),J.trace("Sending env to running instance..."),await Re.start(ce.args,process.env),pe.dispose(),Pe&&clearTimeout(Pe),new I.ExpectedError("Sent env to running instance. Terminating...")}if(ce.args.status)throw J.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new I.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),fe}handleStartupDataDirError(J,ce,le){if(le.code==="EACCES"||le.code==="EPERM"){const he=(0,D.coalesce)([J.userDataPath,J.extensionsPath,c.XDG_RUNTIME_DIR]).map(ge=>(0,y.getPathLabel)(ge,J));this.showStartupWarningDialog((0,l.localize)(4,null),(0,l.localize)(5,null,(0,n.toErrorMessage)(le),he.join(`
`)),ce)}}showStartupWarningDialog(J,ce,le){w.dialog.showMessageBoxSync({title:le,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,l.localize)(6,null))],message:J,detail:ce,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(J,ce){if(t.isWindows){const le=await J.getMainProcessId();ce.trace("Sending some foreground love to the running instance:",le);try{(await new Promise((he,ge)=>{q(["windows-foreground-love"],he,ge)})).allowSetForegroundWindow(le)}catch(he){ce.error(he)}}}quit(J,ce){const le=J.get(re.ILogService),he=J.get(Q.ILifecycleMainService);let ge=0;ce&&(ce.isExpected?ce.message&&le.trace(ce.message):(ge=1,ce.stack?le.error(ce.stack):le.error(`Startup error: ${ce.toString()}`))),he.kill(ge)}resolveArgs(){const J=this.validatePaths((0,o.parseMainProcessArgv)(process.argv));if(J.wait&&!J.waitMarkerFilePath){const ce=(0,h.createWaitMarkerFile)(J.verbose);ce&&((0,o.addArg)(process.argv,"--waitMarkerFilePath",ce),J.waitMarkerFilePath=ce)}return J}validatePaths(J){if(J["open-url"]&&(J._urls=J._,J._=[]),!J.remote){const ce=this.doValidatePaths(J._,J.goto);J._=ce}return J}doValidatePaths(J,ce){const le=(0,f.cwd)(),he=J.map(fe=>{let me=String(fe),pe;ce&&(pe=(0,d.parseLineAndColumnAware)(me),me=pe.path),me&&(me=this.preparePath(le,me));const Pe=(0,d.sanitizeFilePath)(me,le),Re=(0,m.basename)(Pe);return Re&&!(0,d.isValidBasename)(Re)?null:ce&&pe?(pe.path=Pe,this.toPath(pe)):Pe}),ge=t.isWindows||t.isMacintosh,be=(0,D.distinct)(he,fe=>fe&&ge?fe.toLowerCase():fe||"");return(0,D.coalesce)(be)}preparePath(J,ce){return t.isWindows&&(ce=(0,b.rtrim)(ce,'"')),ce=(0,b.trim)((0,b.trim)(ce," "),"	"),t.isWindows&&(ce=(0,m.resolve)(J,ce),ce=(0,b.rtrim)(ce,".")),ce}toPath(J){const ce=[J.path];return typeof J.line=="number"&&ce.push(String(J.line)),typeof J.column=="number"&&ce.push(String(J.column)),ce.join(":")}}new ne().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/658e5c951e45a6df3591f82a3961cec49924ed9a/core/vs/code/electron-main/main.js.map
