/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/common/glob","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","fs","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/codicons","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ve=function(Y){for(var e=[],m=0,F=Y.length;m<F;m++)e[m]=pe[Y[m]];return e};define(pe[56],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(F,y){if(!F)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=m}),define(pe[73],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function F(R){const P=[];for(let u in R)m.call(R,u)&&P.push(R[u]);return P}e.values=F;function y(R,P){for(let u in R)if(m.call(R,u)&&P({key:u,value:R[u]},function(){delete R[u]})===!1)return}e.forEach=y;function C(R,P){const u=Object.create(null);for(const E of R){const h=P(E);let p=u[h];p||(p=u[h]=[]),p.push(E)}return u}e.groupBy=C;function i(R){const P=Object.create(null);return R&&R.forEach((u,E)=>{P[E]=u}),P}e.fromMap=i;function k(R,P){const u=[],E=[];for(let h of R)P.has(h)||u.push(h);for(let h of P)R.has(h)||E.push(h);return{removed:u,added:E}}e.diffSets=k;function S(R,P){const u=[],E=[];for(let[h,p]of R)P.has(h)||u.push(p);for(let[h,p]of P)R.has(h)||E.push(p);return{removed:u,added:E}}e.diffMaps=S;class D{constructor(){this.map=new Map}add(P,u){let E=this.map.get(P);E||(E=new Set,this.map.set(P,E)),E.add(u)}delete(P,u){const E=this.map.get(P);!E||(E.delete(u),E.size===0&&this.map.delete(P))}forEach(P,u){const E=this.map.get(P);!E||E.forEach(u)}}e.SetMap=D}),define(pe[57],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(i){return(k,S,D)=>{let R=null,P=null;if(typeof D.value=="function"?(R="value",P=D.value):typeof D.get=="function"&&(R="get",P=D.get),!P)throw new Error("not supported");D[R]=i(P,S)}}e.createDecorator=m;function F(i,k,S){let D=null,R=null;if(typeof S.value=="function"?(D="value",R=S.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(D="get",R=S.get),!R)throw new Error("not supported");const P=`$memoize$${k}`;S[D]=function(...u){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,u)}),this[P]}}e.memoize=F;function y(i,k,S){return m((D,R)=>{const P=`$debounce$${R}`,u=`$debounce$result$${R}`;return function(...E){this[u]||(this[u]=S?S():void 0),clearTimeout(this[P]),k&&(this[u]=k(this[u],...E),E=[this[u]]),this[P]=setTimeout(()=>{D.apply(this,E),this[u]=S?S():void 0},i)}})}e.debounce=y;function C(i,k,S){return m((D,R)=>{const P=`$throttle$timer$${R}`,u=`$throttle$result$${R}`,E=`$throttle$lastRun$${R}`,h=`$throttle$pending$${R}`;return function(...p){if(this[u]||(this[u]=S?S():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),k&&(this[u]=k(this[u],...p)),this[h])return;const v=this[E]+i;v<=Date.now()?(this[E]=Date.now(),D.apply(this,[this[u]]),this[u]=S?S():void 0):(this[h]=!0,this[P]=setTimeout(()=>{this[h]=!1,this[E]=Date.now(),D.apply(this,[this[u]]),this[u]=S?S():void 0},v-Date.now()))}})}e.throttle=C}),define(pe[15],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(_=>{_(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=m,e.errorHandler=new m;function F(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=F;function y(g){S(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=y;function C(g){S(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=C;function i(g){if(g instanceof Error){let{name:o,message:_}=g;const n=g.stacktrace||g.stack;return{$isError:!0,name:o,message:_,stack:n}}return g}e.transformErrorForSerialization=i;const k="Canceled";function S(g){return g instanceof Error&&g.name===k&&g.message===k}e.isPromiseCanceledError=S;class D extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=D;function R(){const g=new Error(k);return g.name=g.message,g}e.canceled=R;function P(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=P;function u(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=u;function E(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function h(g){const o=new Error(`${g} has been disposed`);return o.name="DISPOSED",o}e.disposed=h;function p(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=p;class v extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=v;class I extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=I;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function a(g){const o=g;return o instanceof Error&&Array.isArray(o.actions)}e.isErrorWithActions=a;function r(g,o=Object.create(null)){const _=new Error(g);return o.actions&&(_.actions=o.actions),_}e.createErrorWithActions=r}),define(pe[16],ve([0,1,15]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function F($,H=0){return $[$.length-(1+H)]}e.tail=F;function y($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=y;function C($,H,j=(ie,fe)=>ie===fe){if($===H)return!0;if(!$||!H||$.length!==H.length)return!1;for(let ie=0,fe=$.length;ie<fe;ie++)if(!j($[ie],H[ie]))return!1;return!0}e.equals=C;function i($,H,j){let ie=0,fe=$.length-1;for(;ie<=fe;){const ye=(ie+fe)/2|0,Ie=j($[ye],H);if(Ie<0)ie=ye+1;else if(Ie>0)fe=ye-1;else return ye}return-(ie+1)}e.binarySearch=i;function k($,H){let j=0,ie=$.length;if(ie===0)return 0;for(;j<ie;){const fe=Math.floor((j+ie)/2);H($[fe])?ie=fe:j=fe+1}return j}e.findFirstInSorted=k;function S($,H,j){if($=$|0,$>=H.length)throw new TypeError("invalid index");let ie=H[Math.floor(H.length*Math.random())],fe=[],ye=[],Ie=[];for(let Be of H){const We=j(Be,ie);We<0?fe.push(Be):We>0?ye.push(Be):Ie.push(Be)}return $<fe.length?S($,fe,j):$<fe.length+Ie.length?Ie[0]:S($-(fe.length+Ie.length),ye,j)}e.quickSelect=S;function D($,H){const j=[];let ie;for(const fe of $.slice(0).sort(H))!ie||H(ie[0],fe)!==0?(ie=[fe],j.push(ie)):ie.push(fe);return j}e.groupBy=D;function R($,H,j){const ie=[];function fe(Be,We,ze){if(We===0&&ze.length===0)return;const Q=ie[ie.length-1];Q&&Q.start+Q.deleteCount===Be?(Q.deleteCount+=We,Q.toInsert.push(...ze)):ie.push({start:Be,deleteCount:We,toInsert:ze})}let ye=0,Ie=0;for(;;){if(ye===$.length){fe(ye,0,H.slice(Ie));break}if(Ie===H.length){fe(ye,$.length-ye,[]);break}const Be=$[ye],We=H[Ie],ze=j(Be,We);ze===0?(ye+=1,Ie+=1):ze<0?(fe(ye,1,[]),ye+=1):ze>0&&(fe(ye,0,[We]),Ie+=1)}return ie}e.sortedDiff=R;function P($,H,j){const ie=R($,H,j),fe=[],ye=[];for(const Ie of ie)fe.push(...$.slice(Ie.start,Ie.start+Ie.deleteCount)),ye.push(...Ie.toInsert);return{removed:fe,added:ye}}e.delta=P;function u($,H,j){if(j===0)return[];const ie=$.slice(0,j).sort(H);return h($,H,ie,j,$.length),ie}e.top=u;function E($,H,j,ie,fe){return j===0?Promise.resolve([]):new Promise((ye,Ie)=>{(async()=>{const Be=$.length,We=$.slice(0,j).sort(H);for(let ze=j,Q=Math.min(j+ie,Be);ze<Be;ze=Q,Q=Math.min(Q+ie,Be)){if(ze>j&&await new Promise(ee=>setTimeout(ee)),fe&&fe.isCancellationRequested)throw(0,m.canceled)();h($,H,We,ze,Q)}return We})().then(ye,Ie)})}e.topAsync=E;function h($,H,j,ie,fe){for(const ye=j.length;ie<fe;ie++){const Ie=$[ie];if(H(Ie,j[ye-1])<0){j.pop();const Be=k(j,We=>H(Ie,We)<0);j.splice(Be,0,Ie)}}}function p($){return $.filter(H=>!!H)}e.coalesce=p;function v($){let H=0;for(let j=0;j<$.length;j++)$[j]&&($[H]=$[j],H+=1);$.length=H}e.coalesceInPlace=v;function I($,H,j){$.splice(j,0,$.splice(H,1)[0])}e.move=I;function w($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=w;function a($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=a;function r($,H=j=>j){const j=new Set;return $.filter(ie=>{const fe=H(ie);return j.has(fe)?!1:(j.add(fe),!0)})}e.distinct=r;function g($){const H=Object.create(null);return j=>{const ie=$(j);return H[ie]?!1:(H[ie]=!0,!0)}}e.uniqueFilter=g;function o($,H){const j=_($,H);if(j!==-1)return $[j]}e.findLast=o;function _($,H){for(let j=$.length-1;j>=0;j--){const ie=$[j];if(H(ie))return j}return-1}e.lastIndex=_;function n($,H){return $.length>0?$[0]:H}e.firstOrDefault=n;function t($,H,j=(ie,fe)=>ie===fe){let ie=0;for(let fe=0,ye=Math.min($.length,H.length);fe<ye&&j($[fe],H[fe]);fe++)ie++;return ie}e.commonPrefixLength=t;function s($){return[].concat(...$)}e.flatten=s;function d($,H){let j=typeof H=="number"?$:0;typeof H=="number"?j=$:(j=0,H=$);const ie=[];if(j<=H)for(let fe=j;fe<H;fe++)ie.push(fe);else for(let fe=j;fe>H;fe--)ie.push(fe);return ie}e.range=d;function c($,H,j){return $.reduce((ie,fe)=>(ie[H(fe)]=j?j(fe):fe,ie),Object.create(null))}e.index=c;function f($,H){return $.push(H),()=>l($,H)}e.insert=f;function l($,H){const j=$.indexOf(H);if(j>-1)return $.splice(j,1),H}e.remove=l;function b($,H,j){const ie=$.slice(0,H),fe=$.slice(H);return ie.concat(j,fe)}e.arrayInsert=b;function T($,H){let j;if(typeof H=="number"){let ie=H;j=()=>{const fe=Math.sin(ie++)*179426549;return fe-Math.floor(fe)}}else j=Math.random;for(let ie=$.length-1;ie>0;ie-=1){const fe=Math.floor(j()*(ie+1)),ye=$[ie];$[ie]=$[fe],$[fe]=ye}}e.shuffle=T;function A($,H){const j=$.indexOf(H);j>-1&&($.splice(j,1),$.unshift(H))}e.pushToStart=A;function U($,H){const j=$.indexOf(H);j>-1&&($.splice(j,1),$.push(H))}e.pushToEnd=U;function B($,H){return Array.isArray($)?$.map(H):H($)}e.mapArrayOrNot=B;function L($){return Array.isArray($)?$:[$]}e.asArray=L;function x($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=x;function M($,H){for(const j of $){const ie=H(j);if(ie!==void 0)return ie}}e.mapFind=M;function V($,H,j){const ie=W($,H),fe=$.length,ye=j.length;$.length=fe+ye;for(let Ie=fe-1;Ie>=ie;Ie--)$[Ie+ye]=$[Ie];for(let Ie=0;Ie<ye;Ie++)$[Ie+ie]=j[Ie]}e.insertInto=V;function O($,H,j,ie){const fe=W($,H),ye=$.splice(fe,j);return V($,fe,ie),ye}e.splice=O;function W($,H){return H<0?Math.max(H+$.length,0):Math.min(H,$.length)}function q($,H){let j=Number.MAX_SAFE_INTEGER,ie=0;return $.forEach((fe,ye)=>{const Ie=H(fe);Ie<j&&(j=Ie,ie=ye)}),ie}e.minIndex=q;function N($,H){let j=Number.MIN_SAFE_INTEGER,ie=0;return $.forEach((fe,ye)=>{const Ie=H(fe);Ie>j&&(j=Ie,ie=ye)}),ie}e.maxIndex=N;class G{constructor(H){this.items=H,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(H){let j=this.firstIdx;for(;j<this.items.length&&H(this.items[j]);)j++;const ie=j===this.firstIdx?null:this.items.slice(this.firstIdx,j);return this.firstIdx=j,ie}takeFromEndWhile(H){let j=this.lastIdx;for(;j>=0&&H(this.items[j]);)j--;const ie=j===this.lastIdx?null:this.items.slice(j+1,this.lastIdx+1);return this.lastIdx=j,ie}peek(){return this.items[this.firstIdx]}dequeue(){const H=this.items[this.firstIdx];return this.firstIdx++,H}takeCount(H){const j=this.items.slice(this.firstIdx,this.firstIdx+H);return this.firstIdx+=H,j}}e.ArrayQueue=G}),define(pe[74],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(F){const y=this;let C=!1,i;return function(){return C||(C=!0,i=F.apply(y,arguments)),i}}e.once=m}),define(pe[75],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(y){this._prefix=y,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(pe[76],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(F){function y(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}F.is=y;const C=Object.freeze([]);function i(){return C}F.empty=i;function*k(g){yield g}F.single=k;function S(g){return g||C}F.from=S;function D(g){return!g||g[Symbol.iterator]().next().done===!0}F.isEmpty=D;function R(g){return g[Symbol.iterator]().next().value}F.first=R;function P(g,o){for(const _ of g)if(o(_))return!0;return!1}F.some=P;function u(g,o){for(const _ of g)if(o(_))return _}F.find=u;function*E(g,o){for(const _ of g)o(_)&&(yield _)}F.filter=E;function*h(g,o){let _=0;for(const n of g)yield o(n,_++)}F.map=h;function*p(...g){for(const o of g)for(const _ of o)yield _}F.concat=p;function*v(g){for(const o of g)for(const _ of o)yield _}F.concatNested=v;function I(g,o,_){let n=_;for(const t of g)n=o(n,t);return n}F.reduce=I;function*w(g,o,_=g.length){for(o<0&&(o+=g.length),_<0?_+=g.length:_>g.length&&(_=g.length);o<_;o++)yield g[o]}F.slice=w;function a(g,o=Number.POSITIVE_INFINITY){const _=[];if(o===0)return[_,g];const n=g[Symbol.iterator]();for(let t=0;t<o;t++){const s=n.next();if(s.done)return[_,F.empty()];_.push(s.value)}return[_,{[Symbol.iterator](){return n}}]}F.consume=a;function r(g,o,_=(n,t)=>n===t){const n=g[Symbol.iterator](),t=o[Symbol.iterator]();for(;;){const s=n.next(),d=t.next();if(s.done!==d.done)return!1;if(s.done)return!0;if(!_(s.value,d.value))return!1}}F.equals=r})(m=e.Iterable||(e.Iterable={}))}),define(pe[58],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var F;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(o){o.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function i(o,_=!1){let n=0,t=o.length,s="",d=0,c=16,f=0;function l(x){let M=0,V=0;for(;M<x;){const O=o.charCodeAt(n);if(O>=48&&O<=57)V=V*16+O-48;else if(O>=65&&O<=70)V=V*16+O-65+10;else if(O>=97&&O<=102)V=V*16+O-97+10;else break;n++,M++}return M<x&&(V=-1),V}function b(x){n=x,s="",d=0,c=16,f=0}function T(){const x=n;if(o.charCodeAt(n)===48)n++;else for(n++;n<o.length&&D(o.charCodeAt(n));)n++;if(n<o.length&&o.charCodeAt(n)===46)if(n++,n<o.length&&D(o.charCodeAt(n)))for(n++;n<o.length&&D(o.charCodeAt(n));)n++;else return f=3,o.substring(x,n);let M=n;if(n<o.length&&(o.charCodeAt(n)===69||o.charCodeAt(n)===101))if(n++,(n<o.length&&o.charCodeAt(n)===43||o.charCodeAt(n)===45)&&n++,n<o.length&&D(o.charCodeAt(n))){for(n++;n<o.length&&D(o.charCodeAt(n));)n++;M=n}else f=3;return o.substring(x,M)}function A(){let x="",M=n;for(;;){if(n>=t){x+=o.substring(M,n),f=2;break}const V=o.charCodeAt(n);if(V===34){x+=o.substring(M,n),n++;break}if(V===92){if(x+=o.substring(M,n),n++,n>=t){f=2;break}switch(o.charCodeAt(n++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const W=l(4);W>=0?x+=String.fromCharCode(W):f=4;break;default:f=5}M=n;continue}if(V>=0&&V<=31)if(S(V)){x+=o.substring(M,n),f=2;break}else f=6;n++}return x}function U(){if(s="",f=0,d=n,n>=t)return d=t,c=17;let x=o.charCodeAt(n);if(k(x)){do n++,s+=String.fromCharCode(x),x=o.charCodeAt(n);while(k(x));return c=15}if(S(x))return n++,s+=String.fromCharCode(x),x===13&&o.charCodeAt(n)===10&&(n++,s+=`
`),c=14;switch(x){case 123:return n++,c=1;case 125:return n++,c=2;case 91:return n++,c=3;case 93:return n++,c=4;case 58:return n++,c=6;case 44:return n++,c=5;case 34:return n++,s=A(),c=10;case 47:const M=n-1;if(o.charCodeAt(n+1)===47){for(n+=2;n<t&&!S(o.charCodeAt(n));)n++;return s=o.substring(M,n),c=12}if(o.charCodeAt(n+1)===42){n+=2;const V=t-1;let O=!1;for(;n<V;){if(o.charCodeAt(n)===42&&o.charCodeAt(n+1)===47){n+=2,O=!0;break}n++}return O||(n++,f=1),s=o.substring(M,n),c=13}return s+=String.fromCharCode(x),n++,c=16;case 45:if(s+=String.fromCharCode(x),n++,n===t||!D(o.charCodeAt(n)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=T(),c=11;default:for(;n<t&&B(x);)n++,x=o.charCodeAt(n);if(d!==n){switch(s=o.substring(d,n),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(x),n++,c=16}}function B(x){if(k(x)||S(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let x;do x=U();while(x>=12&&x<=15);return x}return{setPosition:b,getPosition:()=>n,scan:_?L:U,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>d,getTokenLength:()=>n-d,getTokenError:()=>f}}e.createScanner=i;function k(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function S(o){return o===10||o===13||o===8232||o===8233}function D(o){return o>=48&&o<=57}var R;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(R||(R={}));function P(o,_){const n=[],t=new Object;let s;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function f(l,b,T,A){d.value=l,d.offset=b,d.length=T,d.type=A,d.colonOffset=void 0,s=d}try{a(o,{onObjectBegin:(l,b)=>{if(_<=l)throw t;s=void 0,c=_>l,n.push("")},onObjectProperty:(l,b,T)=>{if(_<b||(f(l,b,T,"property"),n[n.length-1]=l,_<=b+T))throw t},onObjectEnd:(l,b)=>{if(_<=l)throw t;s=void 0,n.pop()},onArrayBegin:(l,b)=>{if(_<=l)throw t;s=void 0,n.push(0)},onArrayEnd:(l,b)=>{if(_<=l)throw t;s=void 0,n.pop()},onLiteralValue:(l,b,T)=>{if(_<b||(f(l,b,T,g(l)),_<=b+T))throw t},onSeparator:(l,b,T)=>{if(_<=b)throw t;if(l===":"&&s&&s.type==="property")s.colonOffset=b,c=!1,s=void 0;else if(l===","){const A=n[n.length-1];typeof A=="number"?n[n.length-1]=A+1:(c=!0,n[n.length-1]=""),s=void 0}}})}catch(l){if(l!==t)throw l}return{path:n,previousNode:s,isAtPropertyKey:c,matches:l=>{let b=0;for(let T=0;b<l.length&&T<n.length;T++)if(l[b]===n[T]||l[b]==="*")b++;else if(l[b]!=="**")return!1;return b===l.length}}}e.getLocation=P;function u(o,_=[],n=C.DEFAULT){let t=null,s=[];const d=[];function c(l){Array.isArray(s)?s.push(l):t!==null&&(s[t]=l)}return a(o,{onObjectBegin:()=>{const l={};c(l),d.push(s),s=l,t=null},onObjectProperty:l=>{t=l},onObjectEnd:()=>{s=d.pop()},onArrayBegin:()=>{const l=[];c(l),d.push(s),s=l,t=null},onArrayEnd:()=>{s=d.pop()},onLiteralValue:c,onError:(l,b,T)=>{_.push({error:l,offset:b,length:T})}},n),s[0]}e.parse=u;function E(o,_=[],n=C.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(l){t.type==="property"&&(t.length=l-t.offset,t=t.parent)}function d(l){return t.children.push(l),l}a(o,{onObjectBegin:l=>{t=d({type:"object",offset:l,length:-1,parent:t,children:[]})},onObjectProperty:(l,b,T)=>{t=d({type:"property",offset:b,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:l,offset:b,length:T,parent:t})},onObjectEnd:(l,b)=>{t.length=l+b-t.offset,t=t.parent,s(l+b)},onArrayBegin:(l,b)=>{t=d({type:"array",offset:l,length:-1,parent:t,children:[]})},onArrayEnd:(l,b)=>{t.length=l+b-t.offset,t=t.parent,s(l+b)},onLiteralValue:(l,b,T)=>{d({type:g(l),offset:b,length:T,parent:t,value:l}),s(b+T)},onSeparator:(l,b,T)=>{t.type==="property"&&(l===":"?t.colonOffset=b:l===","&&s(b))},onError:(l,b,T)=>{_.push({error:l,offset:b,length:T})}},n);const f=t.children[0];return f&&delete f.parent,f}e.parseTree=E;function h(o,_){if(!o)return;let n=o;for(let t of _)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const d of n.children)if(Array.isArray(d.children)&&d.children[0].value===t){n=d.children[1],s=!0;break}if(!s)return}else{const s=t;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=h;function p(o){if(!o.parent||!o.parent.children)return[];const _=p(o.parent);if(o.parent.type==="property"){const n=o.parent.children[0].value;_.push(n)}else if(o.parent.type==="array"){const n=o.parent.children.indexOf(o);n!==-1&&_.push(n)}return _}e.getNodePath=p;function v(o){switch(o.type){case"array":return o.children.map(v);case"object":const _=Object.create(null);for(let n of o.children){const t=n.children[1];t&&(_[n.children[0].value]=v(t))}return _;case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=v;function I(o,_,n=!1){return _>=o.offset&&_<o.offset+o.length||n&&_===o.offset+o.length}e.contains=I;function w(o,_,n=!1){if(I(o,_,n)){const t=o.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=_;s++){const d=w(t[s],_,n);if(d)return d}return o}}e.findNodeAtOffset=w;function a(o,_,n=C.DEFAULT){const t=i(o,!1);function s(j){return j?()=>j(t.getTokenOffset(),t.getTokenLength()):()=>!0}function d(j){return j?ie=>j(ie,t.getTokenOffset(),t.getTokenLength()):()=>!0}const c=s(_.onObjectBegin),f=d(_.onObjectProperty),l=s(_.onObjectEnd),b=s(_.onArrayBegin),T=s(_.onArrayEnd),A=d(_.onLiteralValue),U=d(_.onSeparator),B=s(_.onComment),L=d(_.onError),x=n&&n.disallowComments,M=n&&n.allowTrailingComma;function V(){for(;;){const j=t.scan();switch(t.getTokenError()){case 4:O(14);break;case 5:O(15);break;case 3:O(13);break;case 1:x||O(11);break;case 2:O(12);break;case 6:O(16);break}switch(j){case 12:case 13:x?O(10):B();break;case 16:O(1);break;case 15:case 14:break;default:return j}}}function O(j,ie=[],fe=[]){if(L(j),ie.length+fe.length>0){let ye=t.getToken();for(;ye!==17;){if(ie.indexOf(ye)!==-1){V();break}else if(fe.indexOf(ye)!==-1)break;ye=V()}}}function W(j){const ie=t.getTokenValue();return j?A(ie):f(ie),V(),!0}function q(){switch(t.getToken()){case 11:let j=0;try{j=JSON.parse(t.getTokenValue()),typeof j!="number"&&(O(2),j=0)}catch(ie){O(2)}A(j);break;case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return V(),!0}function N(){return t.getToken()!==10?(O(3,[],[2,5]),!1):(W(!1),t.getToken()===6?(U(":"),V(),H()||O(4,[],[2,5])):O(5,[],[2,5]),!0)}function G(){c(),V();let j=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(j||O(4,[],[]),U(","),V(),t.getToken()===2&&M)break}else j&&O(6,[],[]);N()||O(4,[],[2,5]),j=!0}return l(),t.getToken()!==2?O(7,[2],[]):V(),!0}function $(){b(),V();let j=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(j||O(4,[],[]),U(","),V(),t.getToken()===4&&M)break}else j&&O(6,[],[]);H()||O(4,[],[4,5]),j=!0}return T(),t.getToken()!==4?O(8,[4],[]):V(),!0}function H(){switch(t.getToken()){case 3:return $();case 1:return G();case 10:return W(!0);default:return q()}}return V(),t.getToken()===17?n.allowEmptyContent?!0:(O(4,[],[]),!1):H()?(t.getToken()!==17&&O(9,[],[]),!0):(O(4,[],[]),!1)}e.visit=a;function r(o,_){let n=i(o),t=[],s,d=0,c;do switch(c=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:d!==c&&t.push(o.substring(d,c)),_!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,_)),d=n.getPosition();break}while(s!==17);return t.join("")}e.stripComments=r;function g(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(pe[138],ve([0,1,58]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function F(S,D,R){let P,u,E,h,p;if(D){for(h=D.offset,p=h+D.length,E=h;E>0&&!k(S,E-1);)E--;let d=p;for(;d<S.length&&!k(S,d);)d++;u=S.substring(E,d),P=C(u,R)}else u=S,P=0,E=0,h=0,p=S.length;const v=i(R,S);let I=!1,w=0,a;R.insertSpaces?a=y(" ",R.tabSize||4):a="	";const r=(0,m.createScanner)(u,!1);let g=!1;function o(){return v+y(a,P+w)}function _(){let d=r.scan();for(I=!1;d===15||d===14;)I=I||d===14,d=r.scan();return g=d===16||r.getTokenError()!==0,d}const n=[];function t(d,c,f){!g&&c<p&&f>h&&S.substring(c,f)!==d&&n.push({offset:c,length:f-c,content:d})}let s=_();if(s!==17){const d=r.getTokenOffset()+E,c=y(a,P);t(c,E,d)}for(;s!==17;){let d=r.getTokenOffset()+r.getTokenLength()+E,c=_(),f="";for(;!I&&(c===12||c===13);){const b=r.getTokenOffset()+E;t(" ",d,b),d=r.getTokenOffset()+r.getTokenLength()+E,f=c===12?o():"",c=_()}if(c===2)s!==1&&(w--,f=o());else if(c===4)s!==3&&(w--,f=o());else{switch(s){case 3:case 1:w++,f=o();break;case 5:case 12:f=o();break;case 13:I?f=o():f=" ";break;case 6:f=" ";break;case 10:if(c===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:c===12||c===13?f=" ":c!==5&&c!==17&&(g=!0);break;case 16:g=!0;break}I&&(c===12||c===13)&&(f=o())}const l=r.getTokenOffset()+E;t(f,d,l),s=c}return n}e.format=F;function y(S,D){let R="";for(let P=0;P<D;P++)R+=S;return R}function C(S,D){let R=0,P=0;const u=D.tabSize||4;for(;R<S.length;){const E=S.charAt(R);if(E===" ")P++;else if(E==="	")P+=u;else break;R++}return Math.floor(P/u)}function i(S,D){for(let R=0;R<D.length;R++){const P=D.charAt(R);if(P==="\r")return R+1<D.length&&D.charAt(R+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=i;function k(S,D){return`\r
`.indexOf(S.charAt(D))!==-1}e.isEOL=k}),define(pe[139],ve([0,1,58,138]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function y(D,R,P){return C(D,R,void 0,P)}e.removeProperty=y;function C(D,R,P,u,E){const h=R.slice(),p=[],v=(0,m.parseTree)(D,p);let I,w;for(;h.length>0&&(w=h.pop(),I=(0,m.findNodeAtLocation)(v,h),I===void 0&&P!==void 0);)typeof w=="string"?P={[w]:P}:P=[P];if(I)if(I.type==="object"&&typeof w=="string"&&Array.isArray(I.children)){const a=(0,m.findNodeAtLocation)(I,[w]);if(a!==void 0)if(P===void 0){if(!a.parent)throw new Error("Malformed AST");const r=I.children.indexOf(a.parent);let g,o=a.parent.offset+a.parent.length;if(r>0){const _=I.children[r-1];g=_.offset+_.length}else g=I.offset+1,I.children.length>1&&(o=I.children[1].offset);return i(D,{offset:g,length:o-g,content:""},u)}else return i(D,{offset:a.offset,length:a.length,content:JSON.stringify(P)},u);else{if(P===void 0)return[];const r=`${JSON.stringify(w)}: ${JSON.stringify(P)}`,g=E?E(I.children.map(_=>_.children[0].value)):I.children.length;let o;if(g>0){const _=I.children[g-1];o={offset:_.offset+_.length,length:0,content:","+r}}else I.children.length===0?o={offset:I.offset+1,length:0,content:r}:o={offset:I.offset+1,length:0,content:r+","};return i(D,o,u)}}else if(I.type==="array"&&typeof w=="number"&&Array.isArray(I.children))if(P!==void 0){const a=`${JSON.stringify(P)}`;let r;if(I.children.length===0||w===0)r={offset:I.offset+1,length:0,content:I.children.length===0?a:a+","};else{const g=w===-1||w>I.children.length?I.children.length:w,o=I.children[g-1];r={offset:o.offset+o.length,length:0,content:","+a}}return i(D,r,u)}else{const a=w,r=I.children[a];let g;if(I.children.length===1)g={offset:I.offset+1,length:I.length-2,content:""};else if(I.children.length-1===a){const o=I.children[a-1],_=o.offset+o.length,n=I.offset+I.length;g={offset:_,length:n-2-_,content:""}}else g={offset:r.offset,length:I.children[a+1].offset-r.offset,content:""};return i(D,g,u)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${I.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return i(D,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(P)},u)}}e.setProperty=C;function i(D,R,P){let u=k(D,R),E=R.offset,h=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;E>0&&!(0,F.isEOL)(u,E-1);)E--;for(;h<u.length&&!(0,F.isEOL)(u,h);)h++}const p=(0,F.format)(u,{offset:E,length:h-E},P);for(let I=p.length-1;I>=0;I--){const w=p[I];u=k(u,w),E=Math.min(E,w.offset),h=Math.max(h,w.offset+w.length),h+=w.content.length-w.length}const v=D.length-(u.length-h)-E;return[{offset:E,length:v,content:u.substring(E,h)}]}e.withFormatting=i;function k(D,R){return D.substring(0,R.offset)+R.content+D.substring(R.offset+R.length)}e.applyEdit=k;function S(D,R){let P=R.slice(0).sort((E,h)=>{const p=E.offset-h.offset;return p===0?E.length-h.length:p}),u=D.length;for(let E=P.length-1;E>=0;E--){let h=P[E];if(h.offset+h.length<=u)D=k(D,h);else throw new Error("Overlapping edit");u=h.offset}return D}e.applyEdits=S}),define(pe[140],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(y){this.executor=y,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(y){this._error=y}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(y){return new m(()=>y(this.getValue()))}}e.Lazy=m}),define(pe[6],ve([0,1,74,76]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const y=!1;let C=null;function i(t){C=t}if(e.setDisposableTracker=i,y){const t="__is_disposable_tracked__";i(new class{trackDisposable(s){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[t]||console.log(d)},3e3)}setParent(s,d){if(s&&s!==w.None)try{s[t]=!0}catch{}}markAsDisposed(s){if(s&&s!==w.None)try{s[t]=!0}catch{}}markAsSingleton(s){}})}function k(t){return C?.trackDisposable(t),t}function S(t){C?.markAsDisposed(t)}function D(t,s){C?.setParent(t,s)}function R(t,s){if(!!C)for(const d of t)C.setParent(d,s)}function P(t){return C?.markAsSingleton(t),t}e.markAsSingleton=P;class u extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=u;function E(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=E;function h(t){if(F.Iterable.is(t)){let s=[];for(const d of t)if(d)try{d.dispose()}catch(c){s.push(c)}if(s.length===1)throw s[0];if(s.length>1)throw new u(s);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function p(...t){const s=v(()=>h(t));return R(t,s),s}e.combinedDisposable=p;function v(t){const s=k({dispose:(0,m.once)(()=>{S(s),t()})});return s}e.toDisposable=v;class I{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return D(s,this),this._isDisposed?I.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=I,I.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new I,k(this),D(this._store,this)}dispose(){S(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&D(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&D(s,null),s}}e.MutableDisposable=a;class r{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=r;class g{constructor(){this.references=new Map}acquire(s,...d){let c=this.references.get(s);c||(c={counter:0,object:this.createReferencedObject(s,...d)},this.references.set(s,c));const{object:f}=c,l=(0,m.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(s,c.object),this.references.delete(s))});return c.counter++,{object:f,dispose:l}}}e.ReferenceCollection=g;class o{constructor(s){this.referenceCollection=s}async acquire(s,...d){const c=this.referenceCollection.acquire(s,...d);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(f){throw c.dispose(),f}}}e.AsyncReferenceCollection=o;class _{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=_;function n(t){const s=new I;try{t(s)}finally{s.dispose()}}e.disposeOnReturn=n}),define(pe[93],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(C){this.element=C,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class F{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let C=this._first;for(;C!==m.Undefined;){const i=C.next;C.prev=m.Undefined,C.next=m.Undefined,C=i}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,i){const k=new m(C);if(this._first===m.Undefined)this._first=k,this._last=k;else if(i){const D=this._last;this._last=k,k.prev=D,D.next=k}else{const D=this._first;this._first=k,k.next=D,D.prev=k}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(k))}}shift(){if(this._first!==m.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==m.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==m.Undefined&&C.next!==m.Undefined){const i=C.prev;i.next=C.next,C.next.prev=i}else C.prev===m.Undefined&&C.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):C.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):C.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==m.Undefined;)yield C.element,C=C.next}}e.LinkedList=F}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Te,ke){for(var Se=0;Se<ke.length;Se++){var le=ke[Se];le.enumerable=le.enumerable||!1,le.configurable=!0,"value"in le&&(le.writable=!0),Object.defineProperty(Te,le.key,le)}}function e(Te,ke,Se){return ke&&Y(Te.prototype,ke),Se&&Y(Te,Se),Te}function m(Te,ke){if(!!Te){if(typeof Te=="string")return F(Te,ke);var Se=Object.prototype.toString.call(Te).slice(8,-1);if(Se==="Object"&&Te.constructor&&(Se=Te.constructor.name),Se==="Map"||Se==="Set")return Array.from(Te);if(Se==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Se))return F(Te,ke)}}function F(Te,ke){(ke==null||ke>Te.length)&&(ke=Te.length);for(var Se=0,le=new Array(ke);Se<ke;Se++)le[Se]=Te[Se];return le}function y(Te,ke){var Se=typeof Symbol!="undefined"&&Te[Symbol.iterator]||Te["@@iterator"];if(Se)return(Se=Se.call(Te)).next.bind(Se);if(Array.isArray(Te)||(Se=m(Te))||ke&&Te&&typeof Te.length=="number"){Se&&(Te=Se);var le=0;return function(){return le>=Te.length?{done:!0}:{done:!1,value:Te[le++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function i(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Te){C.exports.defaults=Te}C.exports={defaults:i(),getDefaults:i,changeDefaults:k};var S=/[&<>"']/,D=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ke){return u[ke]};function h(Te,ke){if(ke){if(S.test(Te))return Te.replace(D,E)}else if(R.test(Te))return Te.replace(P,E);return Te}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Te){return Te.replace(p,function(ke,Se){return Se=Se.toLowerCase(),Se==="colon"?":":Se.charAt(0)==="#"?Se.charAt(1)==="x"?String.fromCharCode(parseInt(Se.substring(2),16)):String.fromCharCode(+Se.substring(1)):""})}var I=/(^|[^\[])\^/g;function w(Te,ke){Te=Te.source||Te,ke=ke||"";var Se={replace:function(ue,we){return we=we.source||we,we=we.replace(I,"$1"),Te=Te.replace(ue,we),Se},getRegex:function(){return new RegExp(Te,ke)}};return Se}var a=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(Te,ke,Se){if(Te){var le;try{le=decodeURIComponent(v(Se)).replace(a,"").toLowerCase()}catch(ue){return null}if(le.indexOf("javascript:")===0||le.indexOf("vbscript:")===0||le.indexOf("data:")===0)return null}ke&&!r.test(Se)&&(Se=s(ke,Se));try{Se=encodeURI(Se).replace(/%25/g,"%")}catch(ue){return null}return Se}var o={},_=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Te,ke){o[" "+Te]||(_.test(Te)?o[" "+Te]=Te+"/":o[" "+Te]=l(Te,"/",!0)),Te=o[" "+Te];var Se=Te.indexOf(":")===-1;return ke.substring(0,2)==="//"?Se?ke:Te.replace(n,"$1")+ke:ke.charAt(0)==="/"?Se?ke:Te.replace(t,"$1")+ke:Te+ke}var d={exec:function(){}};function c(Te){for(var ke=1,Se,le;ke<arguments.length;ke++){Se=arguments[ke];for(le in Se)Object.prototype.hasOwnProperty.call(Se,le)&&(Te[le]=Se[le])}return Te}function f(Te,ke){var Se=Te.replace(/\|/g,function(we,_e,Fe){for(var Ke=!1,$e=_e;--$e>=0&&Fe[$e]==="\\";)Ke=!Ke;return Ke?"|":" |"}),le=Se.split(/ \|/),ue=0;if(le[0].trim()||le.shift(),le[le.length-1].trim()||le.pop(),le.length>ke)le.splice(ke);else for(;le.length<ke;)le.push("");for(;ue<le.length;ue++)le[ue]=le[ue].trim().replace(/\\\|/g,"|");return le}function l(Te,ke,Se){var le=Te.length;if(le===0)return"";for(var ue=0;ue<le;){var we=Te.charAt(le-ue-1);if(we===ke&&!Se)ue++;else if(we!==ke&&Se)ue++;else break}return Te.substr(0,le-ue)}function b(Te,ke){if(Te.indexOf(ke[1])===-1)return-1;for(var Se=Te.length,le=0,ue=0;ue<Se;ue++)if(Te[ue]==="\\")ue++;else if(Te[ue]===ke[0])le++;else if(Te[ue]===ke[1]&&(le--,le<0))return ue;return-1}function T(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Te,ke){if(ke<1)return"";for(var Se="";ke>1;)ke&1&&(Se+=Te),ke>>=1,Te+=Te;return Se+Te}var U={escape:h,unescape:v,edit:w,cleanUrl:g,resolveUrl:s,noopTest:d,merge:c,splitCells:f,rtrim:l,findClosingBracket:b,checkSanitizeDeprecation:T,repeatString:A},B=C.exports.defaults,L=U.rtrim,x=U.splitCells,M=U.escape,V=U.findClosingBracket;function O(Te,ke,Se,le){var ue=ke.href,we=ke.title?M(ke.title):null,_e=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){le.state.inLink=!0;var Fe={type:"link",raw:Se,href:ue,title:we,text:_e,tokens:le.inlineTokens(_e,[])};return le.state.inLink=!1,Fe}else return{type:"image",raw:Se,href:ue,title:we,text:M(_e)}}function W(Te,ke){var Se=Te.match(/^(\s+)(?:```)/);if(Se===null)return ke;var le=Se[1];return ke.split(`
`).map(function(ue){var we=ue.match(/^\s+/);if(we===null)return ue;var _e=we[0];return _e.length>=le.length?ue.slice(le.length):ue}).join(`
`)}var q=function(){function Te(Se){this.options=Se||B}var ke=Te.prototype;return ke.space=function(le){var ue=this.rules.block.newline.exec(le);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ke.code=function(le){var ue=this.rules.block.code.exec(le);if(ue){var we=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?we:L(we,`
`)}}},ke.fences=function(le){var ue=this.rules.block.fences.exec(le);if(ue){var we=ue[0],_e=W(we,ue[3]||"");return{type:"code",raw:we,lang:ue[2]?ue[2].trim():ue[2],text:_e}}},ke.heading=function(le){var ue=this.rules.block.heading.exec(le);if(ue){var we=ue[2].trim();if(/#$/.test(we)){var _e=L(we,"#");(this.options.pedantic||!_e||/ $/.test(_e))&&(we=_e.trim())}var Fe={type:"heading",raw:ue[0],depth:ue[1].length,text:we,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},ke.hr=function(le){var ue=this.rules.block.hr.exec(le);if(ue)return{type:"hr",raw:ue[0]}},ke.blockquote=function(le){var ue=this.rules.block.blockquote.exec(le);if(ue){var we=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(we,[]),text:we}}},ke.list=function(le){var ue=this.rules.block.list.exec(le);if(ue){var we,_e,Fe,Ke,$e,Qe,st,at,de,Ce,ce=ue[1].trim(),X=ce.length>1,De={type:"list",raw:"",ordered:X,start:X?+ce.slice(0,-1):"",loose:!1,items:[]};ce=X?"\\d{1,9}\\"+ce.slice(-1):"\\"+ce,this.options.pedantic&&(ce=X?ce:"[*+-]");for(var Re=new RegExp("^( {0,3}"+ce+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");le&&!(this.rules.block.hr.test(le)||!(ue=Re.exec(le)));){de=ue[2].split(`
`),this.options.pedantic?(Ke=2,Ce=de[0].trimLeft()):(Ke=ue[2].search(/[^ ]/),Ke=ue[1].length+(Ke>4?1:Ke),Ce=de[0].slice(Ke-ue[1].length)),Qe=!1,we=ue[0],!de[0]&&/^ *$/.test(de[1])&&(we=ue[1]+de.slice(0,2).join(`
`)+`
`,De.loose=!0,de=[]);var Ze=new RegExp("^ {0,"+Math.min(3,Ke-1)+"}(?:[*+-]|\\d{1,9}[.)])");for($e=1;$e<de.length;$e++){if(at=de[$e],this.options.pedantic&&(at=at.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ze.test(at)){we=ue[1]+de.slice(0,$e).join(`
`)+`
`;break}if(!Qe){at.trim()||(Qe=!0),at.search(/[^ ]/)>=Ke?Ce+=`
`+at.slice(Ke):Ce+=`
`+at;continue}if(at.search(/[^ ]/)>=Ke||!at.trim()){Ce+=`
`+at.slice(Ke);continue}else{we=ue[1]+de.slice(0,$e).join(`
`)+`
`;break}}De.loose||(st?De.loose=!0:/\n *\n *$/.test(we)&&(st=!0)),this.options.gfm&&(_e=/^\[[ xX]\] /.exec(Ce),_e&&(Fe=_e[0]!=="[ ] ",Ce=Ce.replace(/^\[[ xX]\] +/,""))),De.items.push({type:"list_item",raw:we,task:!!_e,checked:Fe,loose:!1,text:Ce}),De.raw+=we,le=le.slice(we.length)}De.items[De.items.length-1].raw=we.trimRight(),De.items[De.items.length-1].text=Ce.trimRight(),De.raw=De.raw.trimRight();var qe=De.items.length;for($e=0;$e<qe;$e++)this.lexer.state.top=!1,De.items[$e].tokens=this.lexer.blockTokens(De.items[$e].text,[]),De.items[$e].tokens.some(function(dt){return dt.type==="space"})&&(De.loose=!0,De.items[$e].loose=!0);return De}},ke.html=function(le){var ue=this.rules.block.html.exec(le);if(ue){var we={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(we.type="paragraph",we.text=this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]),we.tokens=[],this.lexer.inline(we.text,we.tokens)),we}},ke.def=function(le){var ue=this.rules.block.def.exec(le);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var we=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:we,raw:ue[0],href:ue[2],title:ue[3]}}},ke.table=function(le){var ue=this.rules.block.table.exec(le);if(ue){var we={type:"table",header:x(ue[1]).map(function(st){return{text:st}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(we.header.length===we.align.length){we.raw=ue[0];var _e=we.align.length,Fe,Ke,$e,Qe;for(Fe=0;Fe<_e;Fe++)/^ *-+: *$/.test(we.align[Fe])?we.align[Fe]="right":/^ *:-+: *$/.test(we.align[Fe])?we.align[Fe]="center":/^ *:-+ *$/.test(we.align[Fe])?we.align[Fe]="left":we.align[Fe]=null;for(_e=we.rows.length,Fe=0;Fe<_e;Fe++)we.rows[Fe]=x(we.rows[Fe],we.header.length).map(function(st){return{text:st}});for(_e=we.header.length,Ke=0;Ke<_e;Ke++)we.header[Ke].tokens=[],this.lexer.inlineTokens(we.header[Ke].text,we.header[Ke].tokens);for(_e=we.rows.length,Ke=0;Ke<_e;Ke++)for(Qe=we.rows[Ke],$e=0;$e<Qe.length;$e++)Qe[$e].tokens=[],this.lexer.inlineTokens(Qe[$e].text,Qe[$e].tokens);return we}}},ke.lheading=function(le){var ue=this.rules.block.lheading.exec(le);if(ue){var we={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},ke.paragraph=function(le){var ue=this.rules.block.paragraph.exec(le);if(ue){var we={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},ke.text=function(le){var ue=this.rules.block.text.exec(le);if(ue){var we={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},ke.escape=function(le){var ue=this.rules.inline.escape.exec(le);if(ue)return{type:"escape",raw:ue[0],text:M(ue[1])}},ke.tag=function(le){var ue=this.rules.inline.tag.exec(le);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]):ue[0]}},ke.link=function(le){var ue=this.rules.inline.link.exec(le);if(ue){var we=ue[2].trim();if(!this.options.pedantic&&/^</.test(we)){if(!/>$/.test(we))return;var _e=L(we.slice(0,-1),"\\");if((we.length-_e.length)%2==0)return}else{var Fe=V(ue[2],"()");if(Fe>-1){var Ke=ue[0].indexOf("!")===0?5:4,$e=Ke+ue[1].length+Fe;ue[2]=ue[2].substring(0,Fe),ue[0]=ue[0].substring(0,$e).trim(),ue[3]=""}}var Qe=ue[2],st="";if(this.options.pedantic){var at=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Qe);at&&(Qe=at[1],st=at[3])}else st=ue[3]?ue[3].slice(1,-1):"";return Qe=Qe.trim(),/^</.test(Qe)&&(this.options.pedantic&&!/>$/.test(we)?Qe=Qe.slice(1):Qe=Qe.slice(1,-1)),O(ue,{href:Qe&&Qe.replace(this.rules.inline._escapes,"$1"),title:st&&st.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ke.reflink=function(le,ue){var we;if((we=this.rules.inline.reflink.exec(le))||(we=this.rules.inline.nolink.exec(le))){var _e=(we[2]||we[1]).replace(/\s+/g," ");if(_e=ue[_e.toLowerCase()],!_e||!_e.href){var Fe=we[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return O(we,_e,we[0],this.lexer)}},ke.emStrong=function(le,ue,we){we===void 0&&(we="");var _e=this.rules.inline.emStrong.lDelim.exec(le);if(!!_e&&!(_e[3]&&we.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=_e[1]||_e[2]||"";if(!Fe||Fe&&(we===""||this.rules.inline.punctuation.exec(we))){var Ke=_e[0].length-1,$e,Qe,st=Ke,at=0,de=_e[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,ue=ue.slice(-1*le.length+Ke);(_e=de.exec(ue))!=null;)if($e=_e[1]||_e[2]||_e[3]||_e[4]||_e[5]||_e[6],!!$e){if(Qe=$e.length,_e[3]||_e[4]){st+=Qe;continue}else if((_e[5]||_e[6])&&Ke%3&&!((Ke+Qe)%3)){at+=Qe;continue}if(st-=Qe,!(st>0)){if(Qe=Math.min(Qe,Qe+st+at),Math.min(Ke,Qe)%2){var Ce=le.slice(1,Ke+_e.index+Qe);return{type:"em",raw:le.slice(0,Ke+_e.index+Qe+1),text:Ce,tokens:this.lexer.inlineTokens(Ce,[])}}var ce=le.slice(2,Ke+_e.index+Qe-1);return{type:"strong",raw:le.slice(0,Ke+_e.index+Qe+1),text:ce,tokens:this.lexer.inlineTokens(ce,[])}}}}}},ke.codespan=function(le){var ue=this.rules.inline.code.exec(le);if(ue){var we=ue[2].replace(/\n/g," "),_e=/[^ ]/.test(we),Fe=/^ /.test(we)&&/ $/.test(we);return _e&&Fe&&(we=we.substring(1,we.length-1)),we=M(we,!0),{type:"codespan",raw:ue[0],text:we}}},ke.br=function(le){var ue=this.rules.inline.br.exec(le);if(ue)return{type:"br",raw:ue[0]}},ke.del=function(le){var ue=this.rules.inline.del.exec(le);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},ke.autolink=function(le,ue){var we=this.rules.inline.autolink.exec(le);if(we){var _e,Fe;return we[2]==="@"?(_e=M(this.options.mangle?ue(we[1]):we[1]),Fe="mailto:"+_e):(_e=M(we[1]),Fe=_e),{type:"link",raw:we[0],text:_e,href:Fe,tokens:[{type:"text",raw:_e,text:_e}]}}},ke.url=function(le,ue){var we;if(we=this.rules.inline.url.exec(le)){var _e,Fe;if(we[2]==="@")_e=M(this.options.mangle?ue(we[0]):we[0]),Fe="mailto:"+_e;else{var Ke;do Ke=we[0],we[0]=this.rules.inline._backpedal.exec(we[0])[0];while(Ke!==we[0]);_e=M(we[0]),we[1]==="www."?Fe="http://"+_e:Fe=_e}return{type:"link",raw:we[0],text:_e,href:Fe,tokens:[{type:"text",raw:_e,text:_e}]}}},ke.inlineText=function(le,ue){var we=this.rules.inline.text.exec(le);if(we){var _e;return this.lexer.state.inRawBlock?_e=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):M(we[0]):we[0]:_e=M(this.options.smartypants?ue(we[0]):we[0]),{type:"text",raw:we[0],text:_e}}},Te}(),N=U.noopTest,G=U.edit,$=U.merge,H={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};H._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,H._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,H.def=G(H.def).replace("label",H._label).replace("title",H._title).getRegex(),H.bullet=/(?:[*+-]|\d{1,9}[.)])/,H.listItemStart=G(/^( *)(bull) */).replace("bull",H.bullet).getRegex(),H.list=G(H.list).replace(/bull/g,H.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+H.def.source+")").getRegex(),H._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",H._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,H.html=G(H.html,"i").replace("comment",H._comment).replace("tag",H._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),H.paragraph=G(H._paragraph).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.blockquote=G(H.blockquote).replace("paragraph",H.paragraph).getRegex(),H.normal=$({},H),H.gfm=$({},H.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),H.gfm.table=G(H.gfm.table).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.pedantic=$({},H.normal,{html:G(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",H._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:G(H.normal._paragraph).replace("hr",H.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",H.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=G(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=G(H._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=G(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=G(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=G(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=G(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=G(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=G(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=G(j.reflink).replace("label",j._label).getRegex(),j.reflinkSearch=G(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=$({},j),j.pedantic=$({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:G(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:G(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=$({},j.normal,{escape:G(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=G(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=$({},j.gfm,{br:G(j.br).replace("{2,}","*").getRegex(),text:G(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ie={block:H,inline:j},fe=q,ye=C.exports.defaults,Ie=ie.block,Be=ie.inline,We=U.repeatString;function ze(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Q(Te){var ke="",Se,le,ue=Te.length;for(Se=0;Se<ue;Se++)le=Te.charCodeAt(Se),Math.random()>.5&&(le="x"+le.toString(16)),ke+="&#"+le+";";return ke}var ee=function(){function Te(Se){this.tokens=[],this.tokens.links=Object.create(null),this.options=Se||ye,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var le={block:Ie.normal,inline:Be.normal};this.options.pedantic?(le.block=Ie.pedantic,le.inline=Be.pedantic):this.options.gfm&&(le.block=Ie.gfm,this.options.breaks?le.inline=Be.breaks:le.inline=Be.gfm),this.tokenizer.rules=le}Te.lex=function(le,ue){var we=new Te(ue);return we.lex(le)},Te.lexInline=function(le,ue){var we=new Te(ue);return we.inlineTokens(le)};var ke=Te.prototype;return ke.lex=function(le){le=le.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(le,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ke.blockTokens=function(le,ue){var we=this;ue===void 0&&(ue=[]),this.options.pedantic&&(le=le.replace(/^ +$/gm,""));for(var _e,Fe,Ke,$e;le;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(st){return(_e=st.call({lexer:we},le,ue))?(le=le.substring(_e.raw.length),ue.push(_e),!0):!1}))){if(_e=this.tokenizer.space(le)){le=le.substring(_e.raw.length),_e.type&&ue.push(_e);continue}if(_e=this.tokenizer.code(le)){le=le.substring(_e.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+_e.raw,Fe.text+=`
`+_e.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(_e);continue}if(_e=this.tokenizer.fences(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.heading(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.hr(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.blockquote(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.list(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.html(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.def(le)){le=le.substring(_e.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+_e.raw,Fe.text+=`
`+_e.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[_e.tag]||(this.tokens.links[_e.tag]={href:_e.href,title:_e.title});continue}if(_e=this.tokenizer.table(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.lheading(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(Ke=le,this.options.extensions&&this.options.extensions.startBlock&&function(){var st=Infinity,at=le.slice(1),de=void 0;we.options.extensions.startBlock.forEach(function(Ce){de=Ce.call({lexer:this},at),typeof de=="number"&&de>=0&&(st=Math.min(st,de))}),st<Infinity&&st>=0&&(Ke=le.substring(0,st+1))}(),this.state.top&&(_e=this.tokenizer.paragraph(Ke))){Fe=ue[ue.length-1],$e&&Fe.type==="paragraph"?(Fe.raw+=`
`+_e.raw,Fe.text+=`
`+_e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(_e),$e=Ke.length!==le.length,le=le.substring(_e.raw.length);continue}if(_e=this.tokenizer.text(le)){le=le.substring(_e.raw.length),Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+_e.raw,Fe.text+=`
`+_e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(_e);continue}if(le){var Qe="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(Qe);break}else throw new Error(Qe)}}return this.state.top=!0,ue},ke.inline=function(le,ue){this.inlineQueue.push({src:le,tokens:ue})},ke.inlineTokens=function(le,ue){var we=this;ue===void 0&&(ue=[]);var _e,Fe,Ke,$e=le,Qe,st,at;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(Qe=this.tokenizer.rules.inline.reflinkSearch.exec($e))!=null;)de.includes(Qe[0].slice(Qe[0].lastIndexOf("[")+1,-1))&&($e=$e.slice(0,Qe.index)+"["+We("a",Qe[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Qe=this.tokenizer.rules.inline.blockSkip.exec($e))!=null;)$e=$e.slice(0,Qe.index)+"["+We("a",Qe[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Qe=this.tokenizer.rules.inline.escapedEmSt.exec($e))!=null;)$e=$e.slice(0,Qe.index)+"++"+$e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;le;)if(st||(at=""),st=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(_e=ce.call({lexer:we},le,ue))?(le=le.substring(_e.raw.length),ue.push(_e),!0):!1}))){if(_e=this.tokenizer.escape(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.tag(le)){le=le.substring(_e.raw.length),Fe=ue[ue.length-1],Fe&&_e.type==="text"&&Fe.type==="text"?(Fe.raw+=_e.raw,Fe.text+=_e.text):ue.push(_e);continue}if(_e=this.tokenizer.link(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.reflink(le,this.tokens.links)){le=le.substring(_e.raw.length),Fe=ue[ue.length-1],Fe&&_e.type==="text"&&Fe.type==="text"?(Fe.raw+=_e.raw,Fe.text+=_e.text):ue.push(_e);continue}if(_e=this.tokenizer.emStrong(le,$e,at)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.codespan(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.br(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.del(le)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(_e=this.tokenizer.autolink(le,Q)){le=le.substring(_e.raw.length),ue.push(_e);continue}if(!this.state.inLink&&(_e=this.tokenizer.url(le,Q))){le=le.substring(_e.raw.length),ue.push(_e);continue}if(Ke=le,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=Infinity,X=le.slice(1),De=void 0;we.options.extensions.startInline.forEach(function(Re){De=Re.call({lexer:this},X),typeof De=="number"&&De>=0&&(ce=Math.min(ce,De))}),ce<Infinity&&ce>=0&&(Ke=le.substring(0,ce+1))}(),_e=this.tokenizer.inlineText(Ke,ze)){le=le.substring(_e.raw.length),_e.raw.slice(-1)!=="_"&&(at=_e.raw.slice(-1)),st=!0,Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=_e.raw,Fe.text+=_e.text):ue.push(_e);continue}if(le){var Ce="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return ue},e(Te,null,[{key:"rules",get:function(){return{block:Ie,inline:Be}}}]),Te}(),re=C.exports.defaults,he=U.cleanUrl,Z=U.escape,oe=function(){function Te(Se){this.options=Se||re}var ke=Te.prototype;return ke.code=function(le,ue,we){var _e=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(le,_e);Fe!=null&&Fe!==le&&(we=!0,le=Fe)}return le=le.replace(/\n$/,"")+`
`,_e?'<pre><code class="'+this.options.langPrefix+Z(_e,!0)+'">'+(we?le:Z(le,!0))+`</code></pre>
`:"<pre><code>"+(we?le:Z(le,!0))+`</code></pre>
`},ke.blockquote=function(le){return`<blockquote>
`+le+`</blockquote>
`},ke.html=function(le){return le},ke.heading=function(le,ue,we,_e){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+_e.slug(we)+'">'+le+"</h"+ue+`>
`:"<h"+ue+">"+le+"</h"+ue+`>
`},ke.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ke.list=function(le,ue,we){var _e=ue?"ol":"ul",Fe=ue&&we!==1?' start="'+we+'"':"";return"<"+_e+Fe+`>
`+le+"</"+_e+`>
`},ke.listitem=function(le){return"<li>"+le+`</li>
`},ke.checkbox=function(le){return"<input "+(le?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ke.paragraph=function(le){return"<p>"+le+`</p>
`},ke.table=function(le,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+le+`</thead>
`+ue+`</table>
`},ke.tablerow=function(le){return`<tr>
`+le+`</tr>
`},ke.tablecell=function(le,ue){var we=ue.header?"th":"td",_e=ue.align?"<"+we+' align="'+ue.align+'">':"<"+we+">";return _e+le+"</"+we+`>
`},ke.strong=function(le){return"<strong>"+le+"</strong>"},ke.em=function(le){return"<em>"+le+"</em>"},ke.codespan=function(le){return"<code>"+le+"</code>"},ke.br=function(){return this.options.xhtml?"<br/>":"<br>"},ke.del=function(le){return"<del>"+le+"</del>"},ke.link=function(le,ue,we){if(le=he(this.options.sanitize,this.options.baseUrl,le),le===null)return we;var _e='<a href="'+Z(le)+'"';return ue&&(_e+=' title="'+ue+'"'),_e+=">"+we+"</a>",_e},ke.image=function(le,ue,we){if(le=he(this.options.sanitize,this.options.baseUrl,le),le===null)return we;var _e='<img src="'+le+'" alt="'+we+'"';return ue&&(_e+=' title="'+ue+'"'),_e+=this.options.xhtml?"/>":">",_e},ke.text=function(le){return le},Te}(),be=function(){function Te(){}var ke=Te.prototype;return ke.strong=function(le){return le},ke.em=function(le){return le},ke.codespan=function(le){return le},ke.del=function(le){return le},ke.html=function(le){return le},ke.text=function(le){return le},ke.link=function(le,ue,we){return""+we},ke.image=function(le,ue,we){return""+we},ke.br=function(){return""},Te}(),Me=function(){function Te(){this.seen={}}var ke=Te.prototype;return ke.serialize=function(le){return le.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ke.getNextSafeSlug=function(le,ue){var we=le,_e=0;if(this.seen.hasOwnProperty(we)){_e=this.seen[le];do _e++,we=le+"-"+_e;while(this.seen.hasOwnProperty(we))}return ue||(this.seen[le]=_e,this.seen[we]=0),we},ke.slug=function(le,ue){ue===void 0&&(ue={});var we=this.serialize(le);return this.getNextSafeSlug(we,ue.dryrun)},Te}(),Ve=oe,Ge=be,Je=Me,tt=C.exports.defaults,ot=U.unescape,et=function(){function Te(Se){this.options=Se||tt,this.options.renderer=this.options.renderer||new Ve,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ge,this.slugger=new Je}Te.parse=function(le,ue){var we=new Te(ue);return we.parse(le)},Te.parseInline=function(le,ue){var we=new Te(ue);return we.parseInline(le)};var ke=Te.prototype;return ke.parse=function(le,ue){ue===void 0&&(ue=!0);var we="",_e,Fe,Ke,$e,Qe,st,at,de,Ce,ce,X,De,Re,Ze,qe,dt,wt,yt,bt,ft=le.length;for(_e=0;_e<ft;_e++){if(ce=le[_e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(bt=this.options.extensions.renderers[ce.type].call({parser:this},ce),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){we+=bt||"";continue}switch(ce.type){case"space":continue;case"hr":{we+=this.renderer.hr();continue}case"heading":{we+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,ot(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{we+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(de="",at="",$e=ce.header.length,Fe=0;Fe<$e;Fe++)at+=this.renderer.tablecell(this.parseInline(ce.header[Fe].tokens),{header:!0,align:ce.align[Fe]});for(de+=this.renderer.tablerow(at),Ce="",$e=ce.rows.length,Fe=0;Fe<$e;Fe++){for(st=ce.rows[Fe],at="",Qe=st.length,Ke=0;Ke<Qe;Ke++)at+=this.renderer.tablecell(this.parseInline(st[Ke].tokens),{header:!1,align:ce.align[Ke]});Ce+=this.renderer.tablerow(at)}we+=this.renderer.table(de,Ce);continue}case"blockquote":{Ce=this.parse(ce.tokens),we+=this.renderer.blockquote(Ce);continue}case"list":{for(X=ce.ordered,De=ce.start,Re=ce.loose,$e=ce.items.length,Ce="",Fe=0;Fe<$e;Fe++)qe=ce.items[Fe],dt=qe.checked,wt=qe.task,Ze="",qe.task&&(yt=this.renderer.checkbox(dt),Re?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=yt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=yt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:yt}):Ze+=yt),Ze+=this.parse(qe.tokens,Re),Ce+=this.renderer.listitem(Ze,wt,dt);we+=this.renderer.list(Ce,X,De);continue}case"html":{we+=this.renderer.html(ce.text);continue}case"paragraph":{we+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(Ce=ce.tokens?this.parseInline(ce.tokens):ce.text;_e+1<ft&&le[_e+1].type==="text";)ce=le[++_e],Ce+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);we+=ue?this.renderer.paragraph(Ce):Ce;continue}default:{var vt='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return we},ke.parseInline=function(le,ue){ue=ue||this.renderer;var we="",_e,Fe,Ke,$e=le.length;for(_e=0;_e<$e;_e++){if(Fe=le[_e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Ke=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Ke!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){we+=Ke||"";continue}switch(Fe.type){case"escape":{we+=ue.text(Fe.text);break}case"html":{we+=ue.html(Fe.text);break}case"link":{we+=ue.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ue));break}case"image":{we+=ue.image(Fe.href,Fe.title,Fe.text);break}case"strong":{we+=ue.strong(this.parseInline(Fe.tokens,ue));break}case"em":{we+=ue.em(this.parseInline(Fe.tokens,ue));break}case"codespan":{we+=ue.codespan(Fe.text);break}case"br":{we+=ue.br();break}case"del":{we+=ue.del(this.parseInline(Fe.tokens,ue));break}case"text":{we+=ue.text(Fe.text);break}default:{var Qe='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Qe);return}else throw new Error(Qe)}}}return we},Te}(),it=ee,ct=et,pt=q,Pt=oe,Ue=be,Rt=Me,J=U.merge,ne=U.checkSanitizeDeprecation,ge=U.escape,te=C.exports.getDefaults,Ee=C.exports.changeDefaults,Le=C.exports.defaults;function Oe(Te,ke,Se){if(typeof Te=="undefined"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof ke=="function"&&(Se=ke,ke=null),ke=J({},Oe.defaults,ke||{}),ne(ke),Se){var le=ke.highlight,ue;try{ue=it.lex(Te,ke)}catch(Ke){return Se(Ke)}var we=function($e){var Qe;if(!$e)try{ke.walkTokens&&Oe.walkTokens(ue,ke.walkTokens),Qe=ct.parse(ue,ke)}catch(st){$e=st}return ke.highlight=le,$e?Se($e):Se(null,Qe)};if(!le||le.length<3||(delete ke.highlight,!ue.length))return we();var _e=0;Oe.walkTokens(ue,function(Ke){Ke.type==="code"&&(_e++,setTimeout(function(){le(Ke.text,Ke.lang,function($e,Qe){if($e)return we($e);Qe!=null&&Qe!==Ke.text&&(Ke.text=Qe,Ke.escaped=!0),_e--,_e===0&&we()})},0))}),_e===0&&we();return}try{var Fe=it.lex(Te,ke);return ke.walkTokens&&Oe.walkTokens(Fe,ke.walkTokens),ct.parse(Fe,ke)}catch(Ke){if(Ke.message+=`
Please report this to https://github.com/markedjs/marked.`,ke.silent)return"<p>An error occurred:</p><pre>"+ge(Ke.message+"",!0)+"</pre>";throw Ke}}Oe.options=Oe.setOptions=function(Te){return J(Oe.defaults,Te),Ee(Oe.defaults),Oe},Oe.getDefaults=te,Oe.defaults=Le,Oe.use=function(){for(var Te=this,ke=arguments.length,Se=new Array(ke),le=0;le<ke;le++)Se[le]=arguments[le];var ue=J.apply(void 0,[{}].concat(Se)),we=Oe.defaults.extensions||{renderers:{},childTokens:{}},_e;Se.forEach(function(Fe){if(Fe.extensions&&(_e=!0,Fe.extensions.forEach(function($e){if(!$e.name)throw new Error("extension name required");if($e.renderer){var Qe=we.renderers?we.renderers[$e.name]:null;Qe?we.renderers[$e.name]=function(){for(var st=arguments.length,at=new Array(st),de=0;de<st;de++)at[de]=arguments[de];var Ce=$e.renderer.apply(this,at);return Ce===!1&&(Ce=Qe.apply(this,at)),Ce}:we.renderers[$e.name]=$e.renderer}if($e.tokenizer){if(!$e.level||$e.level!=="block"&&$e.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");we[$e.level]?we[$e.level].unshift($e.tokenizer):we[$e.level]=[$e.tokenizer],$e.start&&($e.level==="block"?we.startBlock?we.startBlock.push($e.start):we.startBlock=[$e.start]:$e.level==="inline"&&(we.startInline?we.startInline.push($e.start):we.startInline=[$e.start]))}$e.childTokens&&(we.childTokens[$e.name]=$e.childTokens)})),Fe.renderer&&function(){var $e=Oe.defaults.renderer||new Pt,Qe=function(de){var Ce=$e[de];$e[de]=function(){for(var ce=arguments.length,X=new Array(ce),De=0;De<ce;De++)X[De]=arguments[De];var Re=Fe.renderer[de].apply($e,X);return Re===!1&&(Re=Ce.apply($e,X)),Re}};for(var st in Fe.renderer)Qe(st);ue.renderer=$e}(),Fe.tokenizer&&function(){var $e=Oe.defaults.tokenizer||new pt,Qe=function(de){var Ce=$e[de];$e[de]=function(){for(var ce=arguments.length,X=new Array(ce),De=0;De<ce;De++)X[De]=arguments[De];var Re=Fe.tokenizer[de].apply($e,X);return Re===!1&&(Re=Ce.apply($e,X)),Re}};for(var st in Fe.tokenizer)Qe(st);ue.tokenizer=$e}(),Fe.walkTokens){var Ke=Oe.defaults.walkTokens;ue.walkTokens=function($e){Fe.walkTokens.call(Te,$e),Ke&&Ke($e)}}_e&&(ue.extensions=we),Oe.setOptions(ue)})},Oe.walkTokens=function(Te,ke){for(var Se=function(){var _e=ue.value;switch(ke(_e),_e.type){case"table":{for(var Fe=y(_e.header),Ke;!(Ke=Fe()).done;){var $e=Ke.value;Oe.walkTokens($e.tokens,ke)}for(var Qe=y(_e.rows),st;!(st=Qe()).done;)for(var at=st.value,de=y(at),Ce;!(Ce=de()).done;){var ce=Ce.value;Oe.walkTokens(ce.tokens,ke)}break}case"list":{Oe.walkTokens(_e.items,ke);break}default:Oe.defaults.extensions&&Oe.defaults.extensions.childTokens&&Oe.defaults.extensions.childTokens[_e.type]?Oe.defaults.extensions.childTokens[_e.type].forEach(function(X){Oe.walkTokens(_e[X],ke)}):_e.tokens&&Oe.walkTokens(_e.tokens,ke)}},le=y(Te),ue;!(ue=le()).done;)Se()},Oe.parseInline=function(Te,ke){if(typeof Te=="undefined"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");ke=J({},Oe.defaults,ke||{}),ne(ke);try{var Se=it.lexInline(Te,ke);return ke.walkTokens&&Oe.walkTokens(Se,ke.walkTokens),ct.parseInline(Se,ke)}catch(le){if(le.message+=`
Please report this to https://github.com/markedjs/marked.`,ke.silent)return"<p>An error occurred:</p><pre>"+ge(le.message+"",!0)+"</pre>";throw le}},Oe.Parser=ct,Oe.parser=ct.parse,Oe.Renderer=Pt,Oe.TextRenderer=Ue,Oe.Lexer=it,Oe.lexer=it.lex,Oe.Tokenizer=pt,Oe.Slugger=Rt,Oe.parse=Oe;var Xe=Oe;return Xe}),define(pe[77],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(i,k,S){return Math.min(Math.max(i,k),S)}e.clamp=m;function F(i,k){return(k+i%k)%k}e.rot=F;class y{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=y;class C{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function Y(y){const C=[];typeof y=="number"&&C.push("code/timeOrigin",y);function i(S){C.push(S,Date.now())}function k(){const S=[];for(let D=0;D<C.length;D+=2)S.push({name:C[D],startTime:C[D+1]});return S}return{mark:i,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const i of performance.getEntriesByType("mark"))C.push({name:i.name,startTime:Math.round(y+i.startTime)});return C}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function m(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=m(F))}(),define(pe[12],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let F=!1,y=!1,C=!1,i=!1,k=!1,S=!1,D=!1,R=!1,P,u=m,E,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const v=typeof p?.versions?.electron=="string",I=v&&p?.type==="renderer";if(e.isElectronSandboxed=I&&p?.sandboxed,typeof navigator=="object"&&!I)h=navigator.userAgent,F=h.indexOf("Windows")>=0,y=h.indexOf("Macintosh")>=0,R=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=h.indexOf("Linux")>=0,S=!0,P=navigator.language,u=P;else if(typeof p=="object"){F=p.platform==="win32",y=p.platform==="darwin",C=p.platform==="linux",i=C&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,D=v,P=m,u=m;const s=p.env.VSCODE_NLS_CONFIG;if(s)try{const d=JSON.parse(s),c=d.availableLanguages["*"];P=d.locale,u=c||m,E=d._translationsConfigFile}catch(d){}k=!0}else console.error("Unable to resolve platform.");var w;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function a(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let r=0;y?r=1:F?r=3:C&&(r=2),e.isWindows=F,e.isMacintosh=y,e.isLinux=C,e.isLinuxSnap=i,e.isNative=k,e.isElectron=D,e.isWeb=S,e.isIOS=R,e.platform=r,e.userAgent=h,e.language=u;var g;(function(s){function d(){return e.language}s.value=d;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=c;function f(){return e.language==="en"}s.isDefault=f})(g=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=E,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let f=0,l=s.length;f<l;f++){const b=s[f];if(b.id===c.data.vscodeScheduleAsyncWork){s.splice(f,1),b.callback();return}}});let d=0;return c=>{const f=++d;s.push({id:f,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:f},"*")}}return s=>setTimeout(s)})();var o;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||R?2:F?1:3;let _=!0,n=!1;function t(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,_=new Uint16Array(s.buffer)[0]===(2<<8)+1}return _}e.isLittleEndian=t}),define(pe[40],ve([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let F;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const y=m.globals.vscode.process;F={get platform(){return y.platform},get arch(){return y.arch},get env(){return y.env},cwd(){return y.cwd()}}}else typeof process!="undefined"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.platform=F.platform,e.arch=F.arch}),define(pe[9],ve([0,1,40]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const F=65,y=97,C=90,i=122,k=46,S=47,D=92,R=58,P=63;class u extends Error{constructor(r,g,o){let _;typeof g=="string"&&g.indexOf("not ")===0?(_="must not be",g=g.replace(/^not /,"")):_="must be";const n=r.indexOf(".")!==-1?"property":"argument";let t=`The "${r}" ${n} ${_} of type ${g}`;t+=`. Received type ${typeof o}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function E(a,r){if(typeof a!="string")throw new u(r,"string",a)}function h(a){return a===S||a===D}function p(a){return a===S}function v(a){return a>=F&&a<=C||a>=y&&a<=i}function I(a,r,g,o){let _="",n=0,t=-1,s=0,d=0;for(let c=0;c<=a.length;++c){if(c<a.length)d=a.charCodeAt(c);else{if(o(d))break;d=S}if(o(d)){if(!(t===c-1||s===1))if(s===2){if(_.length<2||n!==2||_.charCodeAt(_.length-1)!==k||_.charCodeAt(_.length-2)!==k){if(_.length>2){const f=_.lastIndexOf(g);f===-1?(_="",n=0):(_=_.slice(0,f),n=_.length-1-_.lastIndexOf(g)),t=c,s=0;continue}else if(_.length!==0){_="",n=0,t=c,s=0;continue}}r&&(_+=_.length>0?`${g}..`:"..",n=2)}else _.length>0?_+=`${g}${a.slice(t+1,c)}`:_=a.slice(t+1,c),n=c-t-1;t=c,s=0}else d===k&&s!==-1?++s:s=-1}return _}function w(a,r){if(r===null||typeof r!="object")throw new u("pathObject","Object",r);const g=r.dir||r.root,o=r.base||`${r.name||""}${r.ext||""}`;return g?g===r.root?`${g}${o}`:`${g}${a}${o}`:o}e.win32={resolve(...a){let r="",g="",o=!1;for(let _=a.length-1;_>=-1;_--){let n;if(_>=0){if(n=a[_],E(n,"path"),n.length===0)continue}else r.length===0?n=m.cwd():(n=m.env[`=${r}`]||m.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==r.toLowerCase()&&n.charCodeAt(2)===D)&&(n=`${r}\\`));const t=n.length;let s=0,d="",c=!1;const f=n.charCodeAt(0);if(t===1)h(f)&&(s=1,c=!0);else if(h(f))if(c=!0,h(n.charCodeAt(1))){let l=2,b=l;for(;l<t&&!h(n.charCodeAt(l));)l++;if(l<t&&l!==b){const T=n.slice(b,l);for(b=l;l<t&&h(n.charCodeAt(l));)l++;if(l<t&&l!==b){for(b=l;l<t&&!h(n.charCodeAt(l));)l++;(l===t||l!==b)&&(d=`\\\\${T}\\${n.slice(b,l)}`,s=l)}}}else s=1;else v(f)&&n.charCodeAt(1)===R&&(d=n.slice(0,2),s=2,t>2&&h(n.charCodeAt(2))&&(c=!0,s=3));if(d.length>0)if(r.length>0){if(d.toLowerCase()!==r.toLowerCase())continue}else r=d;if(o){if(r.length>0)break}else if(g=`${n.slice(s)}\\${g}`,o=c,c&&r.length>0)break}return g=I(g,!o,"\\",h),o?`${r}\\${g}`:`${r}${g}`||"."},normalize(a){E(a,"path");const r=a.length;if(r===0)return".";let g=0,o,_=!1;const n=a.charCodeAt(0);if(r===1)return p(n)?"\\":a;if(h(n))if(_=!0,h(a.charCodeAt(1))){let s=2,d=s;for(;s<r&&!h(a.charCodeAt(s));)s++;if(s<r&&s!==d){const c=a.slice(d,s);for(d=s;s<r&&h(a.charCodeAt(s));)s++;if(s<r&&s!==d){for(d=s;s<r&&!h(a.charCodeAt(s));)s++;if(s===r)return`\\\\${c}\\${a.slice(d)}\\`;s!==d&&(o=`\\\\${c}\\${a.slice(d,s)}`,g=s)}}}else g=1;else v(n)&&a.charCodeAt(1)===R&&(o=a.slice(0,2),g=2,r>2&&h(a.charCodeAt(2))&&(_=!0,g=3));let t=g<r?I(a.slice(g),!_,"\\",h):"";return t.length===0&&!_&&(t="."),t.length>0&&h(a.charCodeAt(r-1))&&(t+="\\"),o===void 0?_?`\\${t}`:t:_?`${o}\\${t}`:`${o}${t}`},isAbsolute(a){E(a,"path");const r=a.length;if(r===0)return!1;const g=a.charCodeAt(0);return h(g)||r>2&&v(g)&&a.charCodeAt(1)===R&&h(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let r,g;for(let n=0;n<a.length;++n){const t=a[n];E(t,"path"),t.length>0&&(r===void 0?r=g=t:r+=`\\${t}`)}if(r===void 0)return".";let o=!0,_=0;if(typeof g=="string"&&h(g.charCodeAt(0))){++_;const n=g.length;n>1&&h(g.charCodeAt(1))&&(++_,n>2&&(h(g.charCodeAt(2))?++_:o=!1))}if(o){for(;_<r.length&&h(r.charCodeAt(_));)_++;_>=2&&(r=`\\${r.slice(_)}`)}return e.win32.normalize(r)},relative(a,r){if(E(a,"from"),E(r,"to"),a===r)return"";const g=e.win32.resolve(a),o=e.win32.resolve(r);if(g===o||(a=g.toLowerCase(),r=o.toLowerCase(),a===r))return"";let _=0;for(;_<a.length&&a.charCodeAt(_)===D;)_++;let n=a.length;for(;n-1>_&&a.charCodeAt(n-1)===D;)n--;const t=n-_;let s=0;for(;s<r.length&&r.charCodeAt(s)===D;)s++;let d=r.length;for(;d-1>s&&r.charCodeAt(d-1)===D;)d--;const c=d-s,f=t<c?t:c;let l=-1,b=0;for(;b<f;b++){const A=a.charCodeAt(_+b);if(A!==r.charCodeAt(s+b))break;A===D&&(l=b)}if(b!==f){if(l===-1)return o}else{if(c>f){if(r.charCodeAt(s+b)===D)return o.slice(s+b+1);if(b===2)return o.slice(s+b)}t>f&&(a.charCodeAt(_+b)===D?l=b:b===2&&(l=3)),l===-1&&(l=0)}let T="";for(b=_+l+1;b<=n;++b)(b===n||a.charCodeAt(b)===D)&&(T+=T.length===0?"..":"\\..");return s+=l,T.length>0?`${T}${o.slice(s,d)}`:(o.charCodeAt(s)===D&&++s,o.slice(s,d))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const r=e.win32.resolve(a);if(r.length<=2)return a;if(r.charCodeAt(0)===D){if(r.charCodeAt(1)===D){const g=r.charCodeAt(2);if(g!==P&&g!==k)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(v(r.charCodeAt(0))&&r.charCodeAt(1)===R&&r.charCodeAt(2)===D)return`\\\\?\\${r}`;return a},dirname(a){E(a,"path");const r=a.length;if(r===0)return".";let g=-1,o=0;const _=a.charCodeAt(0);if(r===1)return h(_)?a:".";if(h(_)){if(g=o=1,h(a.charCodeAt(1))){let s=2,d=s;for(;s<r&&!h(a.charCodeAt(s));)s++;if(s<r&&s!==d){for(d=s;s<r&&h(a.charCodeAt(s));)s++;if(s<r&&s!==d){for(d=s;s<r&&!h(a.charCodeAt(s));)s++;if(s===r)return a;s!==d&&(g=o=s+1)}}}}else v(_)&&a.charCodeAt(1)===R&&(g=r>2&&h(a.charCodeAt(2))?3:2,o=g);let n=-1,t=!0;for(let s=r-1;s>=o;--s)if(h(a.charCodeAt(s))){if(!t){n=s;break}}else t=!1;if(n===-1){if(g===-1)return".";n=g}return a.slice(0,n)},basename(a,r){r!==void 0&&E(r,"ext"),E(a,"path");let g=0,o=-1,_=!0,n;if(a.length>=2&&v(a.charCodeAt(0))&&a.charCodeAt(1)===R&&(g=2),r!==void 0&&r.length>0&&r.length<=a.length){if(r===a)return"";let t=r.length-1,s=-1;for(n=a.length-1;n>=g;--n){const d=a.charCodeAt(n);if(h(d)){if(!_){g=n+1;break}}else s===-1&&(_=!1,s=n+1),t>=0&&(d===r.charCodeAt(t)?--t==-1&&(o=n):(t=-1,o=s))}return g===o?o=s:o===-1&&(o=a.length),a.slice(g,o)}for(n=a.length-1;n>=g;--n)if(h(a.charCodeAt(n))){if(!_){g=n+1;break}}else o===-1&&(_=!1,o=n+1);return o===-1?"":a.slice(g,o)},extname(a){E(a,"path");let r=0,g=-1,o=0,_=-1,n=!0,t=0;a.length>=2&&a.charCodeAt(1)===R&&v(a.charCodeAt(0))&&(r=o=2);for(let s=a.length-1;s>=r;--s){const d=a.charCodeAt(s);if(h(d)){if(!n){o=s+1;break}continue}_===-1&&(n=!1,_=s+1),d===k?g===-1?g=s:t!==1&&(t=1):g!==-1&&(t=-1)}return g===-1||_===-1||t===0||t===1&&g===_-1&&g===o+1?"":a.slice(g,_)},format:w.bind(null,"\\"),parse(a){E(a,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return r;const g=a.length;let o=0,_=a.charCodeAt(0);if(g===1)return h(_)?(r.root=r.dir=a,r):(r.base=r.name=a,r);if(h(_)){if(o=1,h(a.charCodeAt(1))){let l=2,b=l;for(;l<g&&!h(a.charCodeAt(l));)l++;if(l<g&&l!==b){for(b=l;l<g&&h(a.charCodeAt(l));)l++;if(l<g&&l!==b){for(b=l;l<g&&!h(a.charCodeAt(l));)l++;l===g?o=l:l!==b&&(o=l+1)}}}}else if(v(_)&&a.charCodeAt(1)===R){if(g<=2)return r.root=r.dir=a,r;if(o=2,h(a.charCodeAt(2))){if(g===3)return r.root=r.dir=a,r;o=3}}o>0&&(r.root=a.slice(0,o));let n=-1,t=o,s=-1,d=!0,c=a.length-1,f=0;for(;c>=o;--c){if(_=a.charCodeAt(c),h(_)){if(!d){t=c+1;break}continue}s===-1&&(d=!1,s=c+1),_===k?n===-1?n=c:f!==1&&(f=1):n!==-1&&(f=-1)}return s!==-1&&(n===-1||f===0||f===1&&n===s-1&&n===t+1?r.base=r.name=a.slice(t,s):(r.name=a.slice(t,n),r.base=a.slice(t,s),r.ext=a.slice(n,s))),t>0&&t!==o?r.dir=a.slice(0,t-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let r="",g=!1;for(let o=a.length-1;o>=-1&&!g;o--){const _=o>=0?a[o]:m.cwd();E(_,"path"),_.length!==0&&(r=`${_}/${r}`,g=_.charCodeAt(0)===S)}return r=I(r,!g,"/",p),g?`/${r}`:r.length>0?r:"."},normalize(a){if(E(a,"path"),a.length===0)return".";const r=a.charCodeAt(0)===S,g=a.charCodeAt(a.length-1)===S;return a=I(a,!r,"/",p),a.length===0?r?"/":g?"./":".":(g&&(a+="/"),r?`/${a}`:a)},isAbsolute(a){return E(a,"path"),a.length>0&&a.charCodeAt(0)===S},join(...a){if(a.length===0)return".";let r;for(let g=0;g<a.length;++g){const o=a[g];E(o,"path"),o.length>0&&(r===void 0?r=o:r+=`/${o}`)}return r===void 0?".":e.posix.normalize(r)},relative(a,r){if(E(a,"from"),E(r,"to"),a===r||(a=e.posix.resolve(a),r=e.posix.resolve(r),a===r))return"";const g=1,o=a.length,_=o-g,n=1,t=r.length-n,s=_<t?_:t;let d=-1,c=0;for(;c<s;c++){const l=a.charCodeAt(g+c);if(l!==r.charCodeAt(n+c))break;l===S&&(d=c)}if(c===s)if(t>s){if(r.charCodeAt(n+c)===S)return r.slice(n+c+1);if(c===0)return r.slice(n+c)}else _>s&&(a.charCodeAt(g+c)===S?d=c:c===0&&(d=0));let f="";for(c=g+d+1;c<=o;++c)(c===o||a.charCodeAt(c)===S)&&(f+=f.length===0?"..":"/..");return`${f}${r.slice(n+d)}`},toNamespacedPath(a){return a},dirname(a){if(E(a,"path"),a.length===0)return".";const r=a.charCodeAt(0)===S;let g=-1,o=!0;for(let _=a.length-1;_>=1;--_)if(a.charCodeAt(_)===S){if(!o){g=_;break}}else o=!1;return g===-1?r?"/":".":r&&g===1?"//":a.slice(0,g)},basename(a,r){r!==void 0&&E(r,"ext"),E(a,"path");let g=0,o=-1,_=!0,n;if(r!==void 0&&r.length>0&&r.length<=a.length){if(r===a)return"";let t=r.length-1,s=-1;for(n=a.length-1;n>=0;--n){const d=a.charCodeAt(n);if(d===S){if(!_){g=n+1;break}}else s===-1&&(_=!1,s=n+1),t>=0&&(d===r.charCodeAt(t)?--t==-1&&(o=n):(t=-1,o=s))}return g===o?o=s:o===-1&&(o=a.length),a.slice(g,o)}for(n=a.length-1;n>=0;--n)if(a.charCodeAt(n)===S){if(!_){g=n+1;break}}else o===-1&&(_=!1,o=n+1);return o===-1?"":a.slice(g,o)},extname(a){E(a,"path");let r=-1,g=0,o=-1,_=!0,n=0;for(let t=a.length-1;t>=0;--t){const s=a.charCodeAt(t);if(s===S){if(!_){g=t+1;break}continue}o===-1&&(_=!1,o=t+1),s===k?r===-1?r=t:n!==1&&(n=1):r!==-1&&(n=-1)}return r===-1||o===-1||n===0||n===1&&r===o-1&&r===g+1?"":a.slice(r,o)},format:w.bind(null,"/"),parse(a){E(a,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return r;const g=a.charCodeAt(0)===S;let o;g?(r.root="/",o=1):o=0;let _=-1,n=0,t=-1,s=!0,d=a.length-1,c=0;for(;d>=o;--d){const f=a.charCodeAt(d);if(f===S){if(!s){n=d+1;break}continue}t===-1&&(s=!1,t=d+1),f===k?_===-1?_=d:c!==1&&(c=1):_!==-1&&(c=-1)}if(t!==-1){const f=n===0&&g?1:n;_===-1||c===0||c===1&&_===t-1&&_===n+1?r.base=r.name=a.slice(f,t):(r.name=a.slice(f,_),r.base=a.slice(f,t),r.ext=a.slice(_,t))}return n>0?r.dir=a.slice(0,n-1):g&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(pe[94],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var F;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(F=e.TerminateResponseCode||(e.TerminateResponseCode={}));function y(C,...i){const k=i.reduce((R,P)=>(R[P]=!0,R),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(R=>!k[R]).forEach(R=>{for(let P=0;P<S.length;P++)if(R.search(S[P])!==-1){delete C[R];break}})}e.sanitizeProcessEnvironment=y}),define(pe[46],ve([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const F=m.globals.performance&&typeof m.globals.performance.now=="function";class y{constructor(i){this._highResolution=F&&i,this._startTime=this._now(),this._stopTime=-1}static create(i=!0){return new y(i)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=y}),define(pe[3],ve([0,1,15,74,6,93,46]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(r){r.None=()=>y.Disposable.None;function g(M){return(V,O=null,W)=>{let q=!1,N;return N=M(G=>{if(!q)return N?N.dispose():q=!0,V.call(O,G)},null,W),q&&N.dispose(),N}}r.once=g;function o(M,V){return c((O,W=null,q)=>M(N=>O.call(W,V(N)),null,q))}r.map=o;function _(M,V){return c((O,W=null,q)=>M(N=>{V(N),O.call(W,N)},null,q))}r.forEach=_;function n(M,V){return c((O,W=null,q)=>M(N=>V(N)&&O.call(W,N),null,q))}r.filter=n;function t(M){return M}r.signal=t;function s(...M){return(V,O=null,W)=>(0,y.combinedDisposable)(...M.map(q=>q(N=>V.call(O,N),null,W)))}r.any=s;function d(M,V,O){let W=O;return o(M,q=>(W=V(W,q),W))}r.reduce=d;function c(M){let V;const O=new u({onFirstListenerAdd(){V=M(O.fire,O)},onLastListenerRemove(){V.dispose()}});return O.event}function f(M,V,O=100,W=!1,q){let N,G,$,H=0;const j=new u({leakWarningThreshold:q,onFirstListenerAdd(){N=M(ie=>{H++,G=V(G,ie),W&&!$&&(j.fire(G),G=void 0),clearTimeout($),$=setTimeout(()=>{const fe=G;G=void 0,$=void 0,(!W||H>1)&&j.fire(fe),H=0},O)})},onLastListenerRemove(){N.dispose()}});return j.event}r.debounce=f;function l(M,V=(O,W)=>O===W){let O=!0,W;return n(M,q=>{const N=O||!V(q,W);return O=!1,W=q,N})}r.latch=l;function b(M,V){return[r.filter(M,V),r.filter(M,O=>!V(O))]}r.split=b;function T(M,V=!1,O=[]){let W=O.slice(),q=M($=>{W?W.push($):G.fire($)});const N=()=>{W&&W.forEach($=>G.fire($)),W=null},G=new u({onFirstListenerAdd(){q||(q=M($=>G.fire($)))},onFirstListenerDidAdd(){W&&(V?setTimeout(N):N())},onLastListenerRemove(){q&&q.dispose(),q=null}});return G.event}r.buffer=T;class A{constructor(V){this.event=V}map(V){return new A(o(this.event,V))}forEach(V){return new A(_(this.event,V))}filter(V){return new A(n(this.event,V))}reduce(V,O){return new A(d(this.event,V,O))}latch(){return new A(l(this.event))}debounce(V,O=100,W=!1,q){return new A(f(this.event,V,O,W,q))}on(V,O,W){return this.event(V,O,W)}once(V,O,W){return g(this.event)(V,O,W)}}function U(M){return new A(M)}r.chain=U;function B(M,V,O=W=>W){const W=(...$)=>G.fire(O(...$)),q=()=>M.on(V,W),N=()=>M.removeListener(V,W),G=new u({onFirstListenerAdd:q,onLastListenerRemove:N});return G.event}r.fromNodeEventEmitter=B;function L(M,V,O=W=>W){const W=(...$)=>G.fire(O(...$)),q=()=>M.addEventListener(V,W),N=()=>M.removeEventListener(V,W),G=new u({onFirstListenerAdd:q,onLastListenerRemove:N});return G.event}r.fromDOMEventEmitter=L;function x(M){return new Promise(V=>g(M)(V))}r.toPromise=x})(k=e.Event||(e.Event={}));class S{constructor(g){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${g}_${S._idPool++}`}start(g){this._stopWatch=new i.StopWatch(!0),this._listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this._elapsedOverall+=g,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${g.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let D=-1;function R(r){const g=D;return D=r,{dispose(){D=g}}}e.setGlobalLeakWarningThreshold=R;class P{constructor(g,o=Math.random().toString(18).slice(2,5)){this.customThreshold=g,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(g){let o=D;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||g<o)return;this._stacks||(this._stacks=new Map);const _=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(_)||0;if(this._stacks.set(_,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let t,s=0;for(const[d,c]of this._stacks)(!t||s<c)&&(t=d,s=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${s}):`),console.warn(t)}return()=>{const t=this._stacks.get(_)||0;this._stacks.set(_,t-1)}}}class u{constructor(g){this._disposed=!1,this._options=g,this._leakageMon=D>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(g,o,_)=>{this._listeners||(this._listeners=new C.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(o?[g,o]:g);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,g,o);const s=this._leakageMon?.check(this._listeners.size),d=(0,y.toDisposable)(()=>{s&&s(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return _ instanceof y.DisposableStore?_.add(d):Array.isArray(_)&&_.push(d),d}),this._event}fire(g){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,g]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,_]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,_):o[0].call(o[1],_)}catch(n){(0,m.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=u;class E extends u{async fireAsync(g,o,_){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,g]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),s=[],d={...t,waitUntil:c=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");_&&(c=_(c,typeof n=="function"?n:n[0])),s.push(c)}};try{typeof n=="function"?n.call(void 0,d):n[0].call(n[1],d)}catch(c){(0,m.onUnexpectedError)(c);continue}Object.freeze(s),await Promise.allSettled(s).then(c=>{for(const f of c)f.status==="rejected"&&(0,m.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=E;class h extends u{constructor(g){super(g);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}e.PauseableEmitter=h;class p extends h{constructor(g){super(g);this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}e.DebounceEmitter=p;class v extends u{constructor(g){super(g);this._queuedEvents=[],this._mergeFn=g?.merge}fire(g){this._queuedEvents.push(g),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=v;class I{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new u({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const o={event:g,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const _=()=>{this.hasListeners&&this.unhook(o);const n=this.events.indexOf(o);this.events.splice(n,1)};return(0,y.toDisposable)((0,F.once)(_))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(o=>this.emitter.fire(o))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=I;class w{constructor(){this.buffers=[]}wrapEvent(g){return(o,_,n)=>g(t=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>o.call(_,t)):o.call(_,t)},void 0,n)}bufferEvents(g){const o=[];this.buffers.push(o);const _=g();return this.buffers.pop(),o.forEach(n=>n()),_}}e.EventBufferer=w;class a{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=y.Disposable.None,this.emitter=new u({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(pe[21],ve([0,1,3]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const F=Object.freeze(function(k,S){const D=setTimeout(k.bind(S),0);return{dispose(){clearTimeout(D)}}});var y;(function(k){function S(D){return D===k.None||D===k.Cancelled||D instanceof C?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}k.isCancellationToken=S,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(y=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class i{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=y.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=y.None}}e.CancellationTokenSource=i}),define(pe[78],ve([0,1,3]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(R){const P=this._icons.get(R.id);P?R.description?P.description=R.description:console.error(`Duplicate registration of codicon ${R.id}`):(this._icons.set(R.id,R),this._onDidRegister.fire(R))}get(R){return this._icons.get(R)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const y=new F;e.iconRegistry=y;function C(D){return D?D.replace(/\$\((.*?)\)/g,(R,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=C;class i{constructor(R,P,u){this.id=R,this.definition=P,this.description=u,y.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=i,i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function k(D,R){const P=["codicon","codicon-"+D];return R&&P.push("codicon-modifier-"+R),P}e.getClassNamesArray=k;var S;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function P(h){if(h instanceof i)return["codicon","codicon-"+h.id];const p=R.exec(h.id);if(!p)return P(i.error);let[,v,I]=p;const w=["codicon","codicon-"+v];return I&&w.push("codicon-modifier-"+I.substr(1)),w}D.asClassNameArray=P;function u(h){return P(h).join(" ")}D.asClassName=u;function E(h){return"."+P(h).join(".")}D.asCSSSelector=E})(S=e.CSSIcon||(e.CSSIcon={}))}),define(pe[95],ve([0,1,15,6]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function y(a){const r=a;return r?[r.on,r.pause,r.resume,r.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=y;function C(a){const r=a;return r?y(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}e.isReadableBufferedStream=C;function i(a,r){return new k(a,r)}e.newWriteableStream=i;class k{constructor(r,g){this.reducer=r,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(g=>g(r))}emitError(r){this.listeners.error.length===0?(0,m.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(g=>g(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,g){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(r,g){if(this.state.destroyed)return;let o;switch(r){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const _=o.indexOf(g);_>=0&&o.splice(_,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(a,r){const g=[];let o;for(;(o=a.read())!==null;)g.push(o);return r(g)}e.consumeReadable=S;function D(a,r,g){const o=[];let _;for(;(_=a.read())!==null&&o.length<g;)o.push(_);return _===null&&o.length>0?r(o):{read:()=>{if(o.length>0)return o.shift();if(typeof _!="undefined"){const n=_;return _=void 0,n}return a.read()}}}e.peekReadable=D;function R(a,r){return new Promise((g,o)=>{const _=[];P(a,{onData:n=>{r&&_.push(n)},onError:n=>{r?o(n):g(void 0)},onEnd:()=>{g(r?r(_):void 0)}})})}e.consumeStream=R;function P(a,r){a.on("error",g=>r.onError(g)),a.on("end",()=>r.onEnd()),a.on("data",g=>r.onData(g))}e.listenStream=P;function u(a,r){return new Promise((g,o)=>{const _=new F.DisposableStore,n=[],t=c=>{if(n.push(c),n.length>r)return _.dispose(),a.pause(),g({stream:a,buffer:n,ended:!1})},s=c=>o(c),d=()=>g({stream:a,buffer:n,ended:!0});_.add((0,F.toDisposable)(()=>a.removeListener("error",s))),a.on("error",s),_.add((0,F.toDisposable)(()=>a.removeListener("end",d))),a.on("end",d),_.add((0,F.toDisposable)(()=>a.removeListener("data",t))),a.on("data",t)})}e.peekStream=u;function E(a,r){const g=i(r);return g.end(a),g}e.toStream=E;function h(){const a=i(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=h;function p(a){let r=!1;return{read:()=>r?null:(r=!0,a)}}e.toReadable=p;function v(a,r,g){const o=i(g);return P(a,{onData:_=>o.write(r.data(_)),onError:_=>o.error(r.error?r.error(_):_),onEnd:()=>o.end()}),o}e.transform=v;function I(a,r,g){let o=!1;return{read:()=>{const _=r.read();return o?_:(o=!0,_!==null?g([a,_]):a)}}}e.prefixedReadable=I;function w(a,r,g){let o=!1;const _=i(g);return P(r,{onData:n=>o?_.write(n):(o=!0,_.write(g([a,n]))),onError:n=>_.error(n),onEnd:()=>{o||(o=!0,_.write(a)),_.end()}}),_}e.prefixedStream=w}),define(pe[22],ve([0,1,95]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const F=typeof Buffer!="undefined";let y,C;class i{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return F?new i(Buffer.allocUnsafe(t)):new i(new Uint8Array(t))}static wrap(t){return F&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new i(t)}static fromString(t,s){return!(s?.dontUseNodeBuffer||!1)&&F?new i(Buffer.from(t)):(y||(y=new TextEncoder),new i(y.encode(t)))}static fromByteArray(t){const s=i.alloc(t.length);for(let d=0,c=t.length;d<c;d++)s.buffer[d]=t[d];return s}static concat(t,s){if(typeof s=="undefined"){s=0;for(let f=0,l=t.length;f<l;f++)s+=t[f].byteLength}const d=i.alloc(s);let c=0;for(let f=0,l=t.length;f<l;f++){const b=t[f];d.set(b,c),c+=b.byteLength}return d}clone(){const t=i.alloc(this.byteLength);return t.set(this),t}toString(){return F?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(t,s){return new i(this.buffer.subarray(t,s))}set(t,s){if(t instanceof i)this.buffer.set(t.buffer,s);else if(t instanceof Uint8Array)this.buffer.set(t,s);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),s);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),s);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return D(this.buffer,t)}writeUInt32BE(t,s){R(this.buffer,t,s)}readUInt32LE(t){return P(this.buffer,t)}writeUInt32LE(t,s){u(this.buffer,t,s)}readUInt8(t){return E(this.buffer,t)}writeUInt8(t,s){h(this.buffer,t,s)}}e.VSBuffer=i;function k(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=k;function S(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255}e.writeUInt16LE=S;function D(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=D;function R(n,t,s){n[s+3]=t,t=t>>>8,n[s+2]=t,t=t>>>8,n[s+1]=t,t=t>>>8,n[s]=t}e.writeUInt32BE=R;function P(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=P;function u(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255,t=t>>>8,n[s+2]=t&255,t=t>>>8,n[s+3]=t&255}e.writeUInt32LE=u;function E(n,t){return n[t]}e.readUInt8=E;function h(n,t,s){n[s]=t}e.writeUInt8=h;function p(n){return m.consumeReadable(n,t=>i.concat(t))}e.readableToBuffer=p;function v(n){return m.toReadable(n)}e.bufferToReadable=v;function I(n){return m.consumeStream(n,t=>i.concat(t))}e.streamToBuffer=I;async function w(n){return n.ended?i.concat(n.buffer):i.concat([...n.buffer,await I(n.stream)])}e.bufferedStreamToBuffer=w;function a(n){return m.toStream(n,t=>i.concat(t))}e.bufferToStream=a;function r(n){return m.transform(n,{data:t=>typeof t=="string"?i.fromString(t):i.wrap(t)},t=>i.concat(t))}e.streamToBufferReadableStream=r;function g(n){return m.newWriteableStream(t=>i.concat(t),n)}e.newWriteableBufferStream=g;function o(n,t){return m.prefixedReadable(n,t,s=>i.concat(s))}e.prefixedBufferReadable=o;function _(n,t){return m.prefixedStream(n,t,s=>i.concat(s))}e.prefixedBufferStream=_}),define(pe[8],ve([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function F(te){return!te||typeof te!="string"?!0:te.trim().length===0}e.isFalsyOrWhitespace=F;const y=/{(\d+)}/g;function C(te,...Ee){return Ee.length===0?te:te.replace(y,function(Le,Oe){const Xe=parseInt(Oe,10);return isNaN(Xe)||Xe<0||Xe>=Ee.length?Le:Ee[Xe]})}e.format=C;const i=/{([^}]+)}/g;function k(te,Ee){return te.replace(i,(Le,Oe)=>Ee[Oe]??Le)}e.format2=k;function S(te){return te.replace(/[<>&]/g,function(Ee){switch(Ee){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ee}})}e.escape=S;function D(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function R(te,Ee){let Le=0;const Oe=Ee.charCodeAt(0);for(let Xe=te.length-1;Xe>=0;Xe--)te.charCodeAt(Xe)===Oe&&Le++;return Le}e.count=R;function P(te,Ee,Le="\u2026"){return te.length<=Ee?te:`${te.substr(0,Ee)}${Le}`}e.truncate=P;function u(te,Ee=" "){const Le=E(te,Ee);return h(Le,Ee)}e.trim=u;function E(te,Ee){if(!te||!Ee)return te;const Le=Ee.length;if(Le===0||te.length===0)return te;let Oe=0;for(;te.indexOf(Ee,Oe)===Oe;)Oe=Oe+Le;return te.substring(Oe)}e.ltrim=E;function h(te,Ee){if(!te||!Ee)return te;const Le=Ee.length,Oe=te.length;if(Le===0||Oe===0)return te;let Xe=Oe,Te=-1;for(;Te=te.lastIndexOf(Ee,Xe-1),!(Te===-1||Te+Le!==Xe);){if(Te===0)return"";Xe=Te}return te.substring(0,Xe)}e.rtrim=h;function p(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function v(te){return te.replace(/\*/g,"")}e.stripWildcards=v;function I(te,Ee,Le={}){if(!te)throw new Error("Cannot create regex from empty string");Ee||(te=D(te)),Le.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let Oe="";return Le.global&&(Oe+="g"),Le.matchCase||(Oe+="i"),Le.multiline&&(Oe+="m"),Le.unicode&&(Oe+="u"),new RegExp(te,Oe)}e.createRegExp=I;function w(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function a(te){return!!te.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=a;function r(te){return(te.global?"g":"")+(te.ignoreCase?"i":"")+(te.multiline?"m":"")+(te.unicode?"u":"")}e.regExpFlags=r;function g(te){return te.split(/\r\n|\r|\n/)}e.splitLines=g;function o(te){for(let Ee=0,Le=te.length;Ee<Le;Ee++){const Oe=te.charCodeAt(Ee);if(Oe!==32&&Oe!==9)return Ee}return-1}e.firstNonWhitespaceIndex=o;function _(te,Ee=0,Le=te.length){for(let Oe=Ee;Oe<Le;Oe++){const Xe=te.charCodeAt(Oe);if(Xe!==32&&Xe!==9)return te.substring(Ee,Oe)}return te.substring(Ee,Le)}e.getLeadingWhitespace=_;function n(te,Ee=te.length-1){for(let Le=Ee;Le>=0;Le--){const Oe=te.charCodeAt(Le);if(Oe!==32&&Oe!==9)return Le}return-1}e.lastNonWhitespaceIndex=n;function t(te,Ee){return te<Ee?-1:te>Ee?1:0}e.compare=t;function s(te,Ee,Le=0,Oe=te.length,Xe=0,Te=Ee.length){for(;Le<Oe&&Xe<Te;Le++,Xe++){let le=te.charCodeAt(Le),ue=Ee.charCodeAt(Xe);if(le<ue)return-1;if(le>ue)return 1}const ke=Oe-Le,Se=Te-Xe;return ke<Se?-1:ke>Se?1:0}e.compareSubstring=s;function d(te,Ee){return c(te,Ee,0,te.length,0,Ee.length)}e.compareIgnoreCase=d;function c(te,Ee,Le=0,Oe=te.length,Xe=0,Te=Ee.length){for(;Le<Oe&&Xe<Te;Le++,Xe++){let le=te.charCodeAt(Le),ue=Ee.charCodeAt(Xe);if(le===ue)continue;if(le>=128||ue>=128)return s(te.toLowerCase(),Ee.toLowerCase(),Le,Oe,Xe,Te);f(le)&&(le-=32),f(ue)&&(ue-=32);const we=le-ue;if(we!==0)return we}const ke=Oe-Le,Se=Te-Xe;return ke<Se?-1:ke>Se?1:0}e.compareSubstringIgnoreCase=c;function f(te){return te>=97&&te<=122}e.isLowerAsciiLetter=f;function l(te){return te>=65&&te<=90}e.isUpperAsciiLetter=l;function b(te,Ee){return te.length===Ee.length&&c(te,Ee)===0}e.equalsIgnoreCase=b;function T(te,Ee){const Le=Ee.length;return Ee.length>te.length?!1:c(te,Ee,0,Le)===0}e.startsWithIgnoreCase=T;function A(te,Ee){let Le,Oe=Math.min(te.length,Ee.length);for(Le=0;Le<Oe;Le++)if(te.charCodeAt(Le)!==Ee.charCodeAt(Le))return Le;return Oe}e.commonPrefixLength=A;function U(te,Ee){let Le,Oe=Math.min(te.length,Ee.length);const Xe=te.length-1,Te=Ee.length-1;for(Le=0;Le<Oe;Le++)if(te.charCodeAt(Xe-Le)!==Ee.charCodeAt(Te-Le))return Le;return Oe}e.commonSuffixLength=U;function B(te){return 55296<=te&&te<=56319}e.isHighSurrogate=B;function L(te){return 56320<=te&&te<=57343}e.isLowSurrogate=L;function x(te,Ee){return(te-55296<<10)+(Ee-56320)+65536}e.computeCodePoint=x;function M(te,Ee,Le){const Oe=te.charCodeAt(Le);if(B(Oe)&&Le+1<Ee){const Xe=te.charCodeAt(Le+1);if(L(Xe))return x(Oe,Xe)}return Oe}e.getNextCodePoint=M;function V(te,Ee){const Le=te.charCodeAt(Ee-1);if(L(Le)&&Ee>1){const Oe=te.charCodeAt(Ee-2);if(B(Oe))return x(Oe,Le)}return Le}function O(te,Ee){const Le=it.getInstance(),Oe=Ee,Xe=te.length,Te=M(te,Xe,Ee);Ee+=Te>=65536?2:1;let ke=Le.getGraphemeBreakType(Te);for(;Ee<Xe;){const Se=M(te,Xe,Ee),le=Le.getGraphemeBreakType(Se);if(ot(ke,le))break;Ee+=Se>=65536?2:1,ke=le}return Ee-Oe}e.nextCharLength=O;function W(te,Ee){const Le=it.getInstance(),Oe=Ee,Xe=V(te,Ee);Ee-=Xe>=65536?2:1;let Te=Le.getGraphemeBreakType(Xe);for(;Ee>0;){const ke=V(te,Ee),Se=Le.getGraphemeBreakType(ke);if(ot(Se,Te))break;Ee-=ke>=65536?2:1,Te=Se}return Oe-Ee}e.prevCharLength=W;function q(te,Ee){const Le=it.getInstance(),Oe=te.length,Xe=Ee,Te=M(te,Oe,Ee),ke=Le.getGraphemeBreakType(Te);Ee+=Te>=65536?2:1;let Se=ke;for(;Ee<Oe;){const ue=M(te,Oe,Ee),we=Le.getGraphemeBreakType(ue);if(ot(Se,we))break;Ee+=ue>=65536?2:1,Se=we}const le=Ee;for(Ee=Xe,Se=ke;Ee>0;){const ue=V(te,Ee),we=Le.getGraphemeBreakType(ue);if(ot(we,Se))break;Ee-=ue>=65536?2:1,Se=we}return[Ee,le]}function N(te,Ee){return Ee>0&&L(te.charCodeAt(Ee))?q(te,Ee-1):q(te,Ee)}e.getCharContainingOffset=N;const G=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function $(te){return G.test(te)}e.containsRTL=$;const H=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function j(te){return H.test(te)}e.containsEmoji=j;const ie=/^[\t\n\r\x20-\x7E]*$/;function fe(te){return ie.test(te)}e.isBasicASCII=fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ye(te){return e.UNUSUAL_LINE_TERMINATORS.test(te)}e.containsUnusualLineTerminators=ye;function Ie(te){for(let Ee=0,Le=te.length;Ee<Le;Ee++)if(Be(te.charCodeAt(Ee)))return!0;return!1}e.containsFullWidthCharacter=Ie;function Be(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}e.isFullWidthCharacter=Be;function We(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}e.isEmojiImprecise=We;function ze(te,Ee){if(te.length<Ee)return te;const Le=/\b/g;let Oe=0;for(;Le.test(te)&&!(te.length-Le.lastIndex<Ee);)Oe=Le.lastIndex,Le.lastIndex+=1;return te.substring(Oe).replace(/^\s/,"")}e.lcut=ze;const Q=/\x1B\x5B[12]?K/g,ee=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function he(te){return te&&(te=te.replace(Q,""),te=te.replace(ee,""),te=te.replace(re,"")),te}e.removeAnsiEscapeCodes=he,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Z(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Z;function oe(te){return Z(te)?te.substr(1):te}e.stripUTF8BOM=oe;function be(te,Ee){if(!te||!Ee||te.length<Ee.length)return!1;const Le=Ee.length,Oe=te.toLowerCase();let Xe=0,Te=-1;for(;Xe<Le;){const ke=Oe.indexOf(Ee[Xe],Te+1);if(ke<0)return!1;Te=ke,Xe++}return!0}e.fuzzyContains=be;function Me(te,Ee=!1){return te?(Ee&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}e.containsUppercaseCharacter=Me;function Ve(te){return te.charAt(0).toUpperCase()+te.slice(1)}e.uppercaseFirstLetter=Ve;function Ge(te,Ee=1){if(Ee===0)return"";let Le=-1;do Le=te.indexOf(`
`,Le+1),Ee--;while(Ee>0&&Le>=0);return Le===-1?te:(te[Le-1]==="\r"&&Le--,te.substr(0,Le))}e.getNLines=Ge;function Je(te){const Ee=90-65+1;return te=te%(2*Ee),te<Ee?String.fromCharCode(97+te):String.fromCharCode(65+te-Ee)}e.singleLetterHash=Je;function tt(te){return it.getInstance().getGraphemeBreakType(te)}e.getGraphemeBreakType=tt;function ot(te,Ee){return te===0?Ee!==5&&Ee!==7:te===2&&Ee===3?!1:te===4||te===2||te===3||Ee===4||Ee===2||Ee===3?!0:!(te===8&&(Ee===8||Ee===9||Ee===11||Ee===12)||(te===11||te===9)&&(Ee===9||Ee===10)||(te===12||te===10)&&Ee===10||Ee===5||Ee===13||Ee===7||te===1||te===13&&Ee===14||te===6&&Ee===6)}e.breakBetweenGraphemeBreakType=ot;var et;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class it{constructor(){this._data=ct()}static getInstance(){return it._INSTANCE||(it._INSTANCE=new it),it._INSTANCE}getGraphemeBreakType(Ee){if(Ee<32)return Ee===10?3:Ee===13?2:4;if(Ee<127)return 0;const Le=this._data,Oe=Le.length/3;let Xe=1;for(;Xe<=Oe;)if(Ee<Le[3*Xe])Xe=2*Xe;else if(Ee>Le[3*Xe+1])Xe=2*Xe+1;else return Le[3*Xe+2];return 0}}it._INSTANCE=null;function ct(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function pt(te,Ee){if(te===0)return 0;const Le=Pt(te,Ee);if(Le!==void 0)return Le;const Oe=V(Ee,te);return te-=Ue(Oe),te}e.getLeftDeleteOffset=pt;function Pt(te,Ee){let Le=V(Ee,te);for(te-=Ue(Le);Rt(Le)||Le===65039||Le===8419;){if(te===0)return;Le=V(Ee,te),te-=Ue(Le)}if(!!We(Le)){if(te>=0){const Oe=V(Ee,te);Oe===8205&&(te-=Ue(Oe))}return te}}function Ue(te){return te>=65536?2:1}function Rt(te){return 127995<=te&&te<=127999}var J;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(J||(J={})),e.noBreakWhitespace="\xA0";class ne{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!ne.map){let Oe=function(ke){const Se=new Map;for(let le=0;le<ke.length;le+=2)Se.set(ke[le],ke[le+1]);return Se};const Ee=ne.getData();let Le=m.locale;(!Le||!(Le in Ee))&&(Le=m.language),(!Le||!(Le in Ee))&&(Le="_default");const Xe=Oe(Ee._common),Te=Oe(Ee[Le]);for(const[ke,Se]of Te)Xe.set(ke,Se);ne.map=Xe}return ne.map}static isAmbiguous(Ee){return ne.getConfusablesForCurrentLocale().has(Ee)}static getPrimaryConfusable(Ee){return ne.getConfusablesForCurrentLocale().get(Ee)}static getPrimaryConfusableCodePoints(){return new Set(ne.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=ne;class ge{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ge.getRawData())),this._data}static isInvisibleCharacter(Ee){return ge.getData().has(Ee)}static get codePoints(){return ge.getData()}}e.InvisibleCharacters=ge,ge._data=void 0}),define(pe[47],ve([0,1,8]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function F(I){return y(I,0)}e.hash=F;function y(I,w){switch(typeof I){case"object":return I===null?C(349,w):Array.isArray(I)?S(I,w):D(I,w);case"string":return k(I,w);case"boolean":return i(I,w);case"number":return C(I,w);case"undefined":return C(937,w);default:return C(617,w)}}e.doHash=y;function C(I,w){return(w<<5)-w+I|0}e.numberHash=C;function i(I,w){return C(I?433:863,w)}function k(I,w){w=C(149417,w);for(let a=0,r=I.length;a<r;a++)w=C(I.charCodeAt(a),w);return w}e.stringHash=k;function S(I,w){return w=C(104579,w),I.reduce((a,r)=>y(r,a),w)}function D(I,w){return w=C(181387,w),Object.keys(I).sort().reduce((a,r)=>(a=k(r,a),y(I[r],a)),w)}class R{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=y(w,this._value),this._value}}e.Hasher=R;var P;(function(I){I[I.BLOCK_SIZE=64]="BLOCK_SIZE",I[I.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function u(I,w,a=32){const r=a-w,g=~((1<<r)-1);return(I<<w|(g&I)>>>r)>>>0}function E(I,w=0,a=I.byteLength,r=0){for(let g=0;g<a;g++)I[w+g]=r}function h(I,w,a="0"){for(;I.length<w;)I=a+I;return I}function p(I,w=32){return I instanceof ArrayBuffer?Array.from(new Uint8Array(I)).map(a=>a.toString(16).padStart(2,"0")).join(""):h((I>>>0).toString(16),w/4)}e.toHexString=p;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const a=w.length;if(a===0)return;const r=this._buff;let g=this._buffLen,o=this._leftoverHighSurrogate,_,n;for(o!==0?(_=o,n=-1,o=0):(_=w.charCodeAt(0),n=0);;){let t=_;if(m.isHighSurrogate(_))if(n+1<a){const s=w.charCodeAt(n+1);m.isLowSurrogate(s)?(n++,t=m.computeCodePoint(_,s)):t=65533}else{o=_;break}else m.isLowSurrogate(_)&&(t=65533);if(g=this._push(r,g,t),n++,n<a)_=w.charCodeAt(n);else break}this._buffLen=g,this._leftoverHighSurrogate=o}_push(w,a,r){return r<128?w[a++]=r:r<2048?(w[a++]=192|(r&1984)>>>6,w[a++]=128|(r&63)>>>0):r<65536?(w[a++]=224|(r&61440)>>>12,w[a++]=128|(r&4032)>>>6,w[a++]=128|(r&63)>>>0):(w[a++]=240|(r&1835008)>>>18,w[a++]=128|(r&258048)>>>12,w[a++]=128|(r&4032)>>>6,w[a++]=128|(r&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=v._bigBlock32,a=this._buffDV;for(let c=0;c<64;c+=4)w.setUint32(c,a.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)w.setUint32(c,u(w.getUint32(c-12,!1)^w.getUint32(c-32,!1)^w.getUint32(c-56,!1)^w.getUint32(c-64,!1),1),!1);let r=this._h0,g=this._h1,o=this._h2,_=this._h3,n=this._h4,t,s,d;for(let c=0;c<80;c++)c<20?(t=g&o|~g&_,s=1518500249):c<40?(t=g^o^_,s=1859775393):c<60?(t=g&o|g&_|o&_,s=2400959708):(t=g^o^_,s=3395469782),d=u(r,5)+t+n+s+w.getUint32(c*4,!1)&4294967295,n=_,_=o,o=u(g,30),g=r,r=d;this._h0=this._h0+r&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+_&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,F,y){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(pe[24],ve([0,1,16,8]),function(Y,e,m,F){"use strict";var y,C,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(n,t,s){let d=n.get(t);return d===void 0&&(d=s,n.set(t,d)),d}e.getOrSet=k;function S(n){const t=[];return n.forEach((s,d)=>{t.push(`${d} => ${s}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=S;function D(n){const t=[];return n.forEach(s=>{t.push(s)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=D;class R{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),d=this._value.charCodeAt(this._pos);return s-d}value(){return this._value[this._pos]}}e.StringIterator=R;class P{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,F.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class u{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let s=t.length-1;s>=0;s--,this._valueLen--){const d=this._value.charCodeAt(s);if(!(d===47||this._splitOnBackslash&&d===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,F.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=u;var E;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(E||(E={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new u(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,F.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(v||(v={}));class I{constructor(t){this._iter=t}static forUris(t=()=>!1){return new I(new h(t))}static forPaths(){return new I(new u)}static forStrings(){return new I(new R)}static forConfigKeys(){return new I(new P)}clear(){this._root=void 0}fill(t,s){if(s){const d=s.slice(0);(0,m.shuffle)(d);for(let c of d)this.set(c,t)}else{const d=t.slice(0);(0,m.shuffle)(d);for(let c of d)this.set(c[0],c[1])}}set(t,s){const d=this._iter.reset(t);let c;this._root||(this._root=new p,this._root.segment=d.value());const f=[];for(c=this._root;;){const b=d.cmp(c.segment);if(b>0)c.left||(c.left=new p,c.left.segment=d.value()),f.push([-1,c]),c=c.left;else if(b<0)c.right||(c.right=new p,c.right.segment=d.value()),f.push([1,c]),c=c.right;else if(d.hasNext())d.next(),c.mid||(c.mid=new p,c.mid.segment=d.value()),f.push([0,c]),c=c.mid;else break}const l=c.value;c.value=s,c.key=t;for(let b=f.length-1;b>=0;b--){const T=f[b][1];T.updateHeight();const A=T.balanceFactor();if(A<-1||A>1){const U=f[b][0],B=f[b+1][0];if(U===1&&B===1)f[b][1]=T.rotateLeft();else if(U===-1&&B===-1)f[b][1]=T.rotateRight();else if(U===1&&B===-1)T.right=f[b+1][1]=f[b+1][1].rotateRight(),f[b][1]=T.rotateLeft();else if(U===-1&&B===1)T.left=f[b+1][1]=f[b+1][1].rotateLeft(),f[b][1]=T.rotateRight();else throw new Error;if(b>0)switch(f[b-1][0]){case-1:f[b-1][1].left=f[b][1];break;case 1:f[b-1][1].right=f[b][1];break;case 0:f[b-1][1].mid=f[b][1];break}else this._root=f[0][1]}}return l}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let d=this._root;for(;d;){const c=s.cmp(d.segment);if(c>0)d=d.left;else if(c<0)d=d.right;else if(s.hasNext())s.next(),d=d.mid;else break}return d}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const d=this._iter.reset(t),c=[];let f=this._root;for(;f;){const l=d.cmp(f.segment);if(l>0)c.push([-1,f]),f=f.left;else if(l<0)c.push([1,f]),f=f.right;else if(d.hasNext())d.next(),c.push([0,f]),f=f.mid;else break}if(!!f){if(s?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const l=this._min(f.right),{key:b,value:T,segment:A}=l;this._delete(l.key,!1),f.key=b,f.value=T,f.segment=A}else{const l=f.left??f.right;if(c.length>0){const[b,T]=c[c.length-1];switch(b){case-1:T.left=l;break;case 0:T.mid=l;break;case 1:T.right=l;break}}else this._root=l}for(let l=c.length-1;l>=0;l--){const b=c[l][1];b.updateHeight();const T=b.balanceFactor();if(T>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),c[l][1]=b.rotateLeft()):T<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),c[l][1]=b.rotateRight()),l>0)switch(c[l-1][0]){case-1:c[l-1][1].left=c[l][1];break;case 1:c[l-1][1].right=c[l][1];break;case 0:c[l-1][1].mid=c[l][1];break}else this._root=c[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let d=this._root,c;for(;d;){const f=s.cmp(d.segment);if(f>0)d=d.left;else if(f<0)d=d.right;else if(s.hasNext())s.next(),c=d.value||c,d=d.mid;else break}return d&&d.value||c}findSuperstr(t){const s=this._iter.reset(t);let d=this._root;for(;d;){const c=s.cmp(d.segment);if(c>0)d=d.left;else if(c<0)d=d.right;else if(s.hasNext())s.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(t){for(const[s,d]of this)t(d,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const d=s.balanceFactor();return d<-1||d>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=I;class w{constructor(t,s){this.uri=t,this.value=s}}class a{constructor(t,s){this[y]="ResourceMap",t instanceof a?(this.map=new Map(t.map),this.toKey=s??a.defaultToKey):(this.map=new Map,this.toKey=t??a.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new w(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[d,c]of this.map)t(c.value,c.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=a,a.defaultToKey=n=>n.toString();var r;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class g{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const d=this._map.get(t);if(!!d)return s!==0&&this.touch(d,s),d.value}set(t,s,d=0){let c=this._map.get(t);if(c)c.value=s,d!==0&&this.touch(c,d);else{switch(c={key:t,value:s,next:void 0,previous:void 0},d){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(t,c),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const d=this._state;let c=this._head;for(;c;){if(s?t.bind(s)(c.value,c.key,this):t(c.value,c.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,s=this._state;let d=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const f={value:d.key,done:!1};return d=d.next,f}else return{value:void 0,done:!0}}};return c}values(){const t=this,s=this._state;let d=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const f={value:d.value,done:!1};return d=d.next,f}else return{value:void 0,done:!0}}};return c}entries(){const t=this,s=this._state;let d=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const f={value:[d.key,d.value],done:!1};return d=d.next,f}else return{value:void 0,done:!0}}};return c}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,d=this.size;for(;s&&d>t;)this._map.delete(s.key),s=s.next,d--;this._head=s,this._size=d,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,d=t.previous;if(!s||!d)throw new Error("Invalid list");s.previous=d,d.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const d=t.next,c=t.previous;t===this._tail?(c.next=void 0,this._tail=c):(d.previous=c,c.next=d),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const d=t.next,c=t.previous;t===this._head?(d.previous=void 0,this._head=d):(d.previous=c,c.next=d),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,d)=>{t.push([d,s])}),t}fromJSON(t){this.clear();for(const[s,d]of t)this.set(s,d)}}e.LinkedMap=g;class o extends g{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class _{constructor(t){i.set(this,void 0),nt(this,i,t,"f")}get size(){return Ne(this,i,"f").size}forEach(t,s){Ne(this,i,"f").forEach(t,s)}get(t){return Ne(this,i,"f").get(t)}has(t){return Ne(this,i,"f").has(t)}entries(){return Ne(this,i,"f").entries()}keys(){return Ne(this,i,"f").keys()}values(){return Ne(this,i,"f").values()}[(i=new WeakMap,Symbol.iterator)](){return Ne(this,i,"f").entries()}}e.ReadonlyMapView=_}),define(pe[96],ve([0,1,24,8]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...Z){return function(oe,be){for(let Me=0,Ve=Z.length;Me<Ve;Me++){const Ge=Z[Me](oe,be);if(Ge)return Ge}return null}}e.or=y,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(Z,oe,be){if(!be||be.length<oe.length)return null;let Me;return Z?Me=F.startsWithIgnoreCase(be,oe):Me=be.indexOf(oe)===0,Me?oe.length>0?[{start:0,end:oe.length}]:[]:null}function i(Z,oe){const be=oe.toLowerCase().indexOf(Z.toLowerCase());return be===-1?null:[{start:be,end:be+Z.length}]}e.matchesContiguousSubString=i;function k(Z,oe){return S(Z.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=k;function S(Z,oe,be,Me){if(be===Z.length)return[];if(Me===oe.length)return null;if(Z[be]===oe[Me]){let Ve=null;return(Ve=S(Z,oe,be+1,Me+1))?I({start:Me,end:Me+1},Ve):null}return S(Z,oe,be,Me+1)}function D(Z){return 97<=Z&&Z<=122}function R(Z){return 65<=Z&&Z<=90}e.isUpper=R;function P(Z){return 48<=Z&&Z<=57}function u(Z){return Z===32||Z===9||Z===10||Z===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>E.add(Z.charCodeAt(0)));function h(Z){return u(Z)||E.has(Z)}function p(Z,oe){return Z===oe||h(Z)&&h(oe)}function v(Z){return D(Z)||R(Z)||P(Z)}function I(Z,oe){return oe.length===0?oe=[Z]:Z.end===oe[0].start?oe[0].start=Z.start:oe.unshift(Z),oe}function w(Z,oe){for(let be=oe;be<Z.length;be++){const Me=Z.charCodeAt(be);if(R(Me)||P(Me)||be>0&&!v(Z.charCodeAt(be-1)))return be}return Z.length}function a(Z,oe,be,Me){if(be===Z.length)return[];if(Me===oe.length)return null;if(Z[be]!==oe[Me].toLowerCase())return null;{let Ve=null,Ge=Me+1;for(Ve=a(Z,oe,be+1,Me+1);!Ve&&(Ge=w(oe,Ge))<oe.length;)Ve=a(Z,oe,be+1,Ge),Ge++;return Ve===null?null:I({start:Me,end:Me+1},Ve)}}function r(Z){let oe=0,be=0,Me=0,Ve=0,Ge=0;for(let it=0;it<Z.length;it++)Ge=Z.charCodeAt(it),R(Ge)&&oe++,D(Ge)&&be++,v(Ge)&&Me++,P(Ge)&&Ve++;const Je=oe/Z.length,tt=be/Z.length,ot=Me/Z.length,et=Ve/Z.length;return{upperPercent:Je,lowerPercent:tt,alphaPercent:ot,numericPercent:et}}function g(Z){const{upperPercent:oe,lowerPercent:be}=Z;return be===0&&oe>.6}function o(Z){const{upperPercent:oe,lowerPercent:be,alphaPercent:Me,numericPercent:Ve}=Z;return be>.2&&oe<.8&&Me>.6&&Ve<.2}function _(Z){let oe=0,be=0,Me=0,Ve=0;for(let Ge=0;Ge<Z.length;Ge++)Me=Z.charCodeAt(Ge),R(Me)&&oe++,D(Me)&&be++,u(Me)&&Ve++;return(oe===0||be===0)&&Ve===0?Z.length<=30:oe<=5}function n(Z,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!_(Z)||oe.length>60)return null;const be=r(oe);if(!o(be)){if(!g(be))return null;oe=oe.toLowerCase()}let Me=null,Ve=0;for(Z=Z.toLowerCase();Ve<oe.length&&(Me=a(Z,oe,0,Ve))===null;)Ve=w(oe,Ve+1);return Me}e.matchesCamelCase=n;function t(Z,oe,be=!1){if(!oe||oe.length===0)return null;let Me=null,Ve=0;for(Z=Z.toLowerCase(),oe=oe.toLowerCase();Ve<oe.length&&(Me=s(Z,oe,0,Ve,be))===null;)Ve=d(oe,Ve+1);return Me}e.matchesWords=t;function s(Z,oe,be,Me,Ve){if(be===Z.length)return[];if(Me===oe.length)return null;if(p(Z.charCodeAt(be),oe.charCodeAt(Me))){let Ge=null,Je=Me+1;if(Ge=s(Z,oe,be+1,Me+1,Ve),!Ve)for(;!Ge&&(Je=d(oe,Je))<oe.length;)Ge=s(Z,oe,be+1,Je,Ve),Je++;return Ge===null?null:I({start:Me,end:Me+1},Ge)}else return null}function d(Z,oe){for(let be=oe;be<Z.length;be++)if(h(Z.charCodeAt(be))||be>0&&h(Z.charCodeAt(be-1)))return be;return Z.length}const c=y(e.matchesPrefix,n,i),f=y(e.matchesPrefix,n,k),l=new m.LRUCache(1e4);function b(Z,oe,be=!1){if(typeof Z!="string"||typeof oe!="string")return null;let Me=l.get(Z);Me||(Me=new RegExp(F.convertSimple2RegExpPattern(Z),"i"),l.set(Z,Me));const Ve=Me.exec(oe);return Ve?[{start:Ve.index,end:Ve.index+Ve[0].length}]:be?f(Z,oe):c(Z,oe)}e.matchesFuzzy=b;function T(Z,oe){const be=Be(Z,Z.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return be?U(be):null}e.matchesFuzzy2=T;function A(Z,oe,be,Me,Ve,Ge){const Je=Math.min(13,Z.length);for(;be<Je;be++){const tt=Be(Z,oe,be,Me,Ve,Ge,!1);if(tt)return tt}return[0,Ge]}e.anyScore=A;function U(Z){if(typeof Z=="undefined")return[];const oe=[],be=Z[1];for(let Me=Z.length-1;Me>1;Me--){const Ve=Z[Me]+be,Ge=oe[oe.length-1];Ge&&Ge.end===Ve?Ge.end=Ve+1:oe.push({start:Ve,end:Ve+1})}return oe}e.createMatches=U;const B=128;function L(){const Z=[],oe=[];for(let be=0;be<=B;be++)oe[be]=0;for(let be=0;be<=B;be++)Z.push(oe.slice(0));return Z}function x(Z){const oe=[];for(let be=0;be<=Z;be++)oe[be]=0;return oe}const M=x(2*B),V=x(2*B),O=L(),W=L(),q=L(),N=!1;function G(Z,oe,be,Me,Ve){function Ge(tt,ot,et=" "){for(;tt.length<ot;)tt=et+tt;return tt}let Je=` |   |${Me.split("").map(tt=>Ge(tt,3)).join("|")}
`;for(let tt=0;tt<=be;tt++)tt===0?Je+=" |":Je+=`${oe[tt-1]}|`,Je+=Z[tt].slice(0,Ve+1).map(ot=>Ge(ot.toString(),3)).join("|")+`
`;return Je}function $(Z,oe,be,Me){Z=Z.substr(oe),be=be.substr(Me),console.log(G(W,Z,Z.length,be,be.length)),console.log(G(q,Z,Z.length,be,be.length)),console.log(G(O,Z,Z.length,be,be.length))}function H(Z,oe){if(oe<0||oe>=Z.length)return!1;const be=Z.codePointAt(oe);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(be)}}function j(Z,oe){if(oe<0||oe>=Z.length)return!1;switch(Z.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ie(Z,oe,be){return oe[Z]!==be[Z]}function fe(Z,oe,be,Me,Ve,Ge,Je=!1){for(;oe<be&&Ve<Ge;)Z[oe]===Me[Ve]&&(Je&&(M[oe]=Ve),oe+=1),Ve+=1;return oe===be}e.isPatternInWord=fe;var ye;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var Ie;(function(Z){Z.Default=[-100,0];function oe(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}Z.isDefault=oe})(Ie=e.FuzzyScore||(e.FuzzyScore={}));function Be(Z,oe,be,Me,Ve,Ge,Je){const tt=Z.length>B?B:Z.length,ot=Me.length>B?B:Me.length;if(be>=tt||Ge>=ot||tt-be>ot-Ge||!fe(oe,be,tt,Ve,Ge,ot,!0))return;We(tt,ot,be,Ge,oe,Ve);let et=1,it=1,ct=be,pt=Ge;const Pt=[!1];for(et=1,ct=be;ct<tt;et++,ct++){const ge=M[ct],te=V[ct],Ee=ct+1<tt?V[ct+1]:ot;for(it=ge-Ge+1,pt=ge;pt<Ee;it++,pt++){let Le=Number.MIN_SAFE_INTEGER,Oe=!1;pt<=te&&(Le=ze(Z,oe,ct,be,Me,Ve,pt,ot,Ge,O[et-1][it-1]===0,Pt));let Xe=0;Le!==Number.MAX_SAFE_INTEGER&&(Oe=!0,Xe=Le+W[et-1][it-1]);const Te=pt>ge,ke=Te?W[et][it-1]+(O[et][it-1]>0?-5:0):0,Se=pt>ge+1&&O[et][it-1]>0,le=Se?W[et][it-2]+(O[et][it-2]>0?-5:0):0;if(Se&&(!Te||le>=ke)&&(!Oe||le>=Xe))W[et][it]=le,q[et][it]=3,O[et][it]=0;else if(Te&&(!Oe||ke>=Xe))W[et][it]=ke,q[et][it]=2,O[et][it]=0;else if(Oe)W[et][it]=Xe,q[et][it]=1,O[et][it]=O[et-1][it-1]+1;else throw new Error("not possible")}}if(N&&$(Z,be,Me,Ge),!Pt[0]&&!Je)return;et--,it--;const Ue=[W[et][it],Ge];let Rt=0,J=0;for(;et>=1;){let ge=it;do{const te=q[et][ge];if(te===3)ge=ge-2;else if(te===2)ge=ge-1;else break}while(ge>=1);Rt>1&&oe[be+et-1]===Ve[Ge+it-1]&&!ie(ge+Ge-1,Me,Ve)&&Rt+1>O[et][ge]&&(ge=it),ge===it?Rt++:Rt=1,J||(J=ge),et--,it=ge-1,Ue.push(it)}ot===tt&&(Ue[0]+=2);const ne=J-tt;return Ue[0]-=ne,Ue}e.fuzzyScore=Be;function We(Z,oe,be,Me,Ve,Ge){let Je=Z-1,tt=oe-1;for(;Je>=be&&tt>=Me;)Ve[Je]===Ge[tt]&&(V[Je]=tt,Je--),tt--}function ze(Z,oe,be,Me,Ve,Ge,Je,tt,ot,et,it){if(oe[be]!==Ge[Je])return Number.MIN_SAFE_INTEGER;let ct=1,pt=!1;return Je===be-Me?ct=Z[be]===Ve[Je]?7:5:ie(Je,Ve,Ge)&&(Je===0||!ie(Je-1,Ve,Ge))?(ct=Z[be]===Ve[Je]?7:5,pt=!0):H(Ge,Je)&&(Je===0||!H(Ge,Je-1))?ct=5:(H(Ge,Je-1)||j(Ge,Je-1))&&(ct=5,pt=!0),ct>1&&be===Me&&(it[0]=!0),pt||(pt=ie(Je,Ve,Ge)||H(Ge,Je-1)||j(Ge,Je-1)),be===Me?Je>ot&&(ct-=pt?3:5):et?ct+=pt?2:0:ct+=pt?0:1,Je+1===tt&&(ct-=pt?3:5),ct}function Q(Z,oe,be,Me,Ve,Ge,Je){return re(Z,oe,be,Me,Ve,Ge,!0,Je)}e.fuzzyScoreGracefulAggressive=Q;function ee(Z,oe,be,Me,Ve,Ge,Je){return re(Z,oe,be,Me,Ve,Ge,!1,Je)}e.fuzzyScoreGraceful=ee;function re(Z,oe,be,Me,Ve,Ge,Je,tt){let ot=Be(Z,oe,be,Me,Ve,Ge,tt);if(ot&&!Je)return ot;if(Z.length>=3){const et=Math.min(7,Z.length-1);for(let it=be+1;it<et;it++){const ct=he(Z,it);if(ct){const pt=Be(ct,ct.toLowerCase(),be,Me,Ve,Ge,tt);pt&&(pt[0]-=3,(!ot||pt[0]>ot[0])&&(ot=pt))}}}return ot}function he(Z,oe){if(oe+1>=Z.length)return;const be=Z[oe],Me=Z[oe+1];if(be!==Me)return Z.slice(0,oe)+Me+be+Z.slice(oe+2)}}),define(pe[141],ve([0,1,78,96,8]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),i=new RegExp(m.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${C.source}`,"g");function S(v){return v.replace(k,(I,w)=>w?I:`\\${I}`)}e.escapeIcons=S;const D=new RegExp(`\\\\${C.source}`,"g");function R(v){return v.replace(D,I=>`\\${I}`)}e.markdownEscapeEscapedIcons=R;const P=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function u(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(P,(I,w,a,r)=>a?I:w||r||"")}e.stripIcons=u;function E(v){const I=v.indexOf(e.iconStartMarker);return I===-1?{text:v}:h(v,I)}e.parseLabelWithIcons=E;function h(v,I){const w=[];let a="";function r(c){if(c){a+=c;for(const f of c)w.push(_)}}let g=-1,o="",_=0,n,t,s=I;const d=v.length;for(r(v.substr(0,I));s<d;)n=v[s],t=v[s+1],n===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(g=s,r(o),o=e.iconStartMarker,s++):n===")"&&g!==-1?(_+=s-g+1,g=-1,o=""):g!==-1?i.test(n)?o+=n:(r(o),g=-1,o=""):r(n),s++;return r(o),{text:a,iconOffsets:w}}function p(v,I,w=!1){const{text:a,iconOffsets:r}=I;if(!r||r.length===0)return(0,F.matchesFuzzy)(v,a,w);const g=(0,y.ltrim)(a," "),o=a.length-g.length,_=(0,F.matchesFuzzy)(v,g,w);if(_)for(const n of _){const t=r[n.start+o]+o;n.start+=t,n.end+=t}return _}e.matchesFuzzyIconAware=p}),define(pe[97],ve([0,1,15,141]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(E="",h=!1){if(this.value=E,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(E,h=0){return this.value+=D(this.supportThemeIcons?(0,F.escapeIcons)(E):E).replace(/([ \t]+)/g,(p,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(E){return this.value+=E,this}appendCodeblock(E,h){return this.value+="\n```",this.value+=E,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}}e.MarkdownString=C;function i(u){return k(u)?!u.value:Array.isArray(u)?u.every(i):!0}e.isEmptyMarkdownString=i;function k(u){return u instanceof C?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function S(u,E){return u===E?!0:!u||!E?!1:u.value===E.value&&u.isTrusted===E.isTrusted&&u.supportThemeIcons===E.supportThemeIcons}e.markdownStringEqual=S;function D(u){return u.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=D;function R(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=R;function P(u){const E=[],h=u.split("|").map(v=>v.trim());u=h[0];const p=h[1];if(p){const v=/height=(\d+)/.exec(p),I=/width=(\d+)/.exec(p),w=v?v[1]:"",a=I?I[1]:"",r=isFinite(parseInt(a)),g=isFinite(parseInt(w));r&&E.push(`width="${a}"`),g&&E.push(`height="${w}"`)}return{href:u,dimensions:E}}e.parseHrefAndDimensions=P}),define(pe[79],ve([0,1,24]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const F=new m.LRUCache(1e4);function y(D){return S(D,"NFC",F)}e.normalizeNFC=y;const C=new m.LRUCache(1e4);function i(D){return S(D,"NFD",C)}e.normalizeNFD=i;const k=/[^\u0000-\u0080]/;function S(D,R,P){if(!D)return D;const u=P.get(D);if(u)return u;let E;return k.test(D)?E=D.normalize(R):E=D,P.set(D,E),E}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(R){return i(R).replace(D,"")}}()}),define(pe[48],ve([0,1,8]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(F||(F={})),function(y){const C="error",i="warning",k="warn",S="info",D="ignore";function R(u){return u?m.equalsIgnoreCase(C,u)?y.Error:m.equalsIgnoreCase(i,u)||m.equalsIgnoreCase(k,u)?y.Warning:m.equalsIgnoreCase(S,u)?y.Info:y.Ignore:y.Ignore}y.fromValue=R;function P(u){switch(u){case y.Error:return C;case y.Warning:return i;case y.Info:return S;default:return D}}y.toString=P}(F||(F={})),e.default=F}),define(pe[13],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(f){return Array.isArray(f)}e.isArray=m;function F(f){return typeof f=="string"}e.isString=F;function y(f){return Array.isArray(f)&&f.every(l=>F(l))}e.isStringArray=y;function C(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=C;function i(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=i;function k(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=k;function S(f){return f===!0||f===!1}e.isBoolean=S;function D(f){return typeof f=="undefined"}e.isUndefined=D;function R(f){return!P(f)}e.isDefined=R;function P(f){return D(f)||f===null}e.isUndefinedOrNull=P;function u(f,l){if(!f)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=u;function E(f){if(P(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=E;function h(...f){const l=[];for(let b=0;b<f.length;b++){const T=f[b];if(P(T))throw new Error(`Assertion Failed: argument at index ${b} is undefined or null`);l.push(T)}return l}e.assertAllDefined=h;const p=Object.prototype.hasOwnProperty;function v(f){if(!C(f))return!1;for(let l in f)if(p.call(f,l))return!1;return!0}e.isEmptyObject=v;function I(f){return typeof f=="function"}e.isFunction=I;function w(...f){return f.length>0&&f.every(I)}e.areFunctions=w;function a(f,l){const b=Math.min(f.length,l.length);for(let T=0;T<b;T++)r(f[T],l[T])}e.validateConstraints=a;function r(f,l){if(F(l)){if(typeof f!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(I(l)){try{if(f instanceof l)return}catch{}if(!P(f)&&f.constructor===l||l.length===1&&l.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=r;function g(f){let l=[],b=Object.getPrototypeOf(f);for(;Object.prototype!==b;)l=l.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return l}e.getAllPropertyNames=g;function o(f){const l=[];for(const b of g(f))typeof f[b]=="function"&&l.push(b);return l}e.getAllMethodNames=o;function _(f,l){const b=A=>function(){const U=Array.prototype.slice.call(arguments,0);return l(A,U)};let T={};for(const A of f)T[A]=b(A);return T}e.createProxyObject=_;function n(f){return f===null?void 0:f}e.withNullAsUndefined=n;function t(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=t;function s(f){return class{constructor(){return new Proxy({},{get(l,b){if(l[b])return l[b];throw new Error(`Not Implemented: ${f}->${String(b)}`)}})}}}e.NotImplementedProxy=s;function d(f,l="Unreachable"){throw new Error(l)}e.assertNever=d;function c(f){return!!f&&typeof f.then=="function"&&typeof f.catch=="function"}e.isPromise=c}),define(pe[30],ve([0,1,9,12,8,13]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function i(n){return n===47||n===92}e.isPathSeparator=i;function k(n){return n.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=k;function S(n){return n.indexOf("/")===-1&&(n=k(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=S;function D(n,t=m.posix.sep){if(!n)return"";const s=n.length,d=n.charCodeAt(0);if(i(d)){if(i(n.charCodeAt(1))&&!i(n.charCodeAt(2))){let f=3;const l=f;for(;f<s&&!i(n.charCodeAt(f));f++);if(l!==f&&!i(n.charCodeAt(f+1))){for(f+=1;f<s;f++)if(i(n.charCodeAt(f)))return n.slice(0,f+1).replace(/[\\/]/g,t)}}return t}else if(I(d)&&n.charCodeAt(1)===58)return i(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let c=n.indexOf("://");if(c!==-1){for(c+=3;c<s;c++)if(i(n.charCodeAt(c)))return n.slice(0,c+1)}return""}e.getRoot=D;function R(n){if(!F.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let s=2;const d=s;for(;s<n.length&&(t=n.charCodeAt(s),t!==92);s++);return!(d===s||(t=n.charCodeAt(s+1),isNaN(t)||t===92))}e.isUNC=R;const P=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(n,t=F.isWindows){const s=t?P:u;return!(!n||n.length===0||/^\s+$/.test(n)||(s.lastIndex=0,s.test(n))||t&&E.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=h;function p(n,t,s){const d=n===t;return!s||d?d:!n||!t?!1:(0,y.equalsIgnoreCase)(n,t)}e.isEqual=p;function v(n,t,s,d=m.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(s){if(!(0,y.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let f=t.length;return t.charAt(t.length-1)===d&&f--,n.charAt(f)===d}return t.charAt(t.length-1)!==d&&(t+=d),n.indexOf(t)===0}e.isEqualOrParent=v;function I(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=I;function w(n,t){return F.isWindows&&n.endsWith(":")&&(n+=m.sep),(0,m.isAbsolute)(n)||(n=(0,m.join)(t,n)),n=(0,m.normalize)(n),F.isWindows?(n=(0,y.rtrim)(n,m.sep),n.endsWith(":")&&(n+=m.sep)):(n=(0,y.rtrim)(n,m.sep),n||(n=m.sep)),n}e.sanitizeFilePath=w;function a(n){const t=(0,m.normalize)(n);return F.isWindows?n.length>3?!1:r(t)&&(n.length===2||t.charCodeAt(2)===92):t===m.posix.sep}e.isRootOrDriveLetter=a;function r(n,t){return(t!==void 0?t:F.isWindows)?I(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=r;function g(n){return r(n)?n[0]:void 0}e.getDriveLetter=g;function o(n,t,s){return t.length>n.length?-1:n===t?0:(s&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=o;function _(n){const t=n.split(":");let s,d,c;if(t.forEach(f=>{const l=Number(f);(0,C.isNumber)(l)?d===void 0?d=l:c===void 0&&(c=l):s=s?[s,f].join(":"):f}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:d!==void 0?d:void 0,column:c!==void 0?c:d!==void 0?1:void 0}}e.parseLineAndColumnAware=_}),define(pe[25],ve([0,1,13]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const v=Array.isArray(p)?[]:{};return Object.keys(p).forEach(I=>{p[I]&&typeof p[I]=="object"?v[I]=F(p[I]):v[I]=p[I]}),v}e.deepClone=F;function y(p){if(!p||typeof p!="object")return p;const v=[p];for(;v.length>0;){const I=v.shift();Object.freeze(I);for(const w in I)if(C.call(I,w)){const a=I[w];typeof a=="object"&&!Object.isFrozen(a)&&v.push(a)}}return p}e.deepFreeze=y;const C=Object.prototype.hasOwnProperty;function i(p,v){return k(p,v,new Set)}e.cloneAndChange=i;function k(p,v,I){if((0,m.isUndefinedOrNull)(p))return p;const w=v(p);if(typeof w!="undefined")return w;if((0,m.isArray)(p)){const a=[];for(const r of p)a.push(k(r,v,I));return a}if((0,m.isObject)(p)){if(I.has(p))throw new Error("Cannot clone recursive data-structure");I.add(p);const a={};for(let r in p)C.call(p,r)&&(a[r]=k(p[r],v,I));return I.delete(p),a}return p}function S(p,v,I=!0){return(0,m.isObject)(p)?((0,m.isObject)(v)&&Object.keys(v).forEach(w=>{w in p?I&&((0,m.isObject)(p[w])&&(0,m.isObject)(v[w])?S(p[w],v[w],I):p[w]=v[w]):p[w]=v[w]}),p):v}e.mixin=S;function D(p,v){if(p===v)return!0;if(p==null||v===null||v===void 0||typeof p!=typeof v||typeof p!="object"||Array.isArray(p)!==Array.isArray(v))return!1;let I,w;if(Array.isArray(p)){if(p.length!==v.length)return!1;for(I=0;I<p.length;I++)if(!D(p[I],v[I]))return!1}else{const a=[];for(w in p)a.push(w);a.sort();const r=[];for(w in v)r.push(w);if(r.sort(),!D(a,r))return!1;for(I=0;I<a.length;I++)if(!D(p[a[I]],v[a[I]]))return!1}return!0}e.equals=D;function R(p){const v=new Set;return JSON.stringify(p,(I,w)=>{if((0,m.isObject)(w)||Array.isArray(w)){if(v.has(w))return"[Circular]";v.add(w)}return w})}e.safeStringify=R;function P(p,v,I){const w=v(p);return typeof w=="undefined"?I:w}e.getOrDefault=P;function u(p,v){const I=Object.create(null);return!p||!v||Object.keys(v).forEach(a=>{const r=p[a],g=v[a];D(r,g)||(I[a]=g)}),I}e.distinct=u;function E(p,v){const I=v.toLowerCase(),w=Object.keys(p).find(a=>a.toLowerCase()===I);return w?p[w]:p[v]}e.getCaseInsensitive=E;function h(p,v){const I=Object.create(null);for(const[w,a]of Object.entries(p))v(w,a)&&(I[w]=a);return I}e.filter=h}),define(pe[98],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function F(C){return C<0?0:C>255?255:C|0}e.toUint8=F;function y(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=y}),define(pe[2],ve([0,1,9,12]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const y=/^\w[\w\d+.-]*$/,C=/^\//,i=/^\/\//;function k(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!y.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!C.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(i.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(n,t){return!n&&!t?"file":n}function D(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==P&&(t=P+t):t=P;break}return t}const R="",P="/",u=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(t,s,d,c,f,l=!1){typeof t=="object"?(this.scheme=t.scheme||R,this.authority=t.authority||R,this.path=t.path||R,this.query=t.query||R,this.fragment=t.fragment||R):(this.scheme=S(t,l),this.authority=s||R,this.path=D(this.scheme,d||R),this.query=c||R,this.fragment=f||R,k(this,l))}static isUri(t){return t instanceof E?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return a(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:d,path:c,query:f,fragment:l}=t;return s===void 0?s=this.scheme:s===null&&(s=R),d===void 0?d=this.authority:d===null&&(d=R),c===void 0?c=this.path:c===null&&(c=R),f===void 0?f=this.query:f===null&&(f=R),l===void 0?l=this.fragment:l===null&&(l=R),s===this.scheme&&d===this.authority&&c===this.path&&f===this.query&&l===this.fragment?this:new p(s,d,c,f,l)}static parse(t,s=!1){const d=u.exec(t);return d?new p(d[2]||R,_(d[4]||R),_(d[5]||R),_(d[7]||R),_(d[9]||R),s):new p(R,R,R,R,R)}static file(t){let s=R;if(F.isWindows&&(t=t.replace(/\\/g,P)),t[0]===P&&t[1]===P){const d=t.indexOf(P,2);d===-1?(s=t.substring(2),t=P):(s=t.substring(2,d),t=t.substring(d)||P)}return new p("file",s,t,R,R)}static from(t){const s=new p(t.scheme,t.authority,t.path,t.query,t.fragment);return k(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return F.isWindows&&t.scheme==="file"?d=E.file(m.win32.join(a(t,!0),...s)).path:d=m.posix.join(t.path,...s),t.with({path:d})}toString(t=!1){return r(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof E)return t;{const s=new p(t);return s._formatted=t.external,s._fsPath=t._sep===h?t.fsPath:null,s}}else return t}}e.URI=E;const h=F.isWindows?1:void 0;class p extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(t=!1){return t?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function I(n,t){let s,d=-1;for(let c=0;c<n.length;c++){const f=n.charCodeAt(c);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47)d!==-1&&(s+=encodeURIComponent(n.substring(d,c)),d=-1),s!==void 0&&(s+=n.charAt(c));else{s===void 0&&(s=n.substr(0,c));const l=v[f];l!==void 0?(d!==-1&&(s+=encodeURIComponent(n.substring(d,c)),d=-1),s+=l):d===-1&&(d=c)}}return d!==-1&&(s+=encodeURIComponent(n.substring(d))),s!==void 0?s:n}function w(n){let t;for(let s=0;s<n.length;s++){const d=n.charCodeAt(s);d===35||d===63?(t===void 0&&(t=n.substr(0,s)),t+=v[d]):t!==void 0&&(t+=n[s])}return t!==void 0?t:n}function a(n,t){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,F.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=a;function r(n,t){const s=t?w:I;let d="",{scheme:c,authority:f,path:l,query:b,fragment:T}=n;if(c&&(d+=c,d+=":"),(f||c==="file")&&(d+=P,d+=P),f){let A=f.indexOf("@");if(A!==-1){const U=f.substr(0,A);f=f.substr(A+1),A=U.indexOf(":"),A===-1?d+=s(U,!1):(d+=s(U.substr(0,A),!1),d+=":",d+=s(U.substr(A+1),!1)),d+="@"}f=f.toLowerCase(),A=f.indexOf(":"),A===-1?d+=s(f,!1):(d+=s(f.substr(0,A),!1),d+=f.substr(A))}if(l){if(l.length>=3&&l.charCodeAt(0)===47&&l.charCodeAt(2)===58){const A=l.charCodeAt(1);A>=65&&A<=90&&(l=`/${String.fromCharCode(A+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===58){const A=l.charCodeAt(0);A>=65&&A<=90&&(l=`${String.fromCharCode(A+32)}:${l.substr(2)}`)}d+=s(l,!0)}return b&&(d+="?",d+=s(b,!1)),T&&(d+="#",d+=t?T:I(T,!1)),d}function g(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+g(n.substr(3)):n}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function _(n){return n.match(o)?n.replace(o,t=>g(t)):n}}),define(pe[59],ve([0,1,22,8,2]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(R){return JSON.stringify(R,S)}e.stringify=C;function i(R){let P=JSON.parse(R);return P=D(P),P}e.parse=i;var k;(function(R){R[R.Uri=1]="Uri",R[R.Regexp=2]="Regexp",R[R.ScmResource=3]="ScmResource",R[R.ScmResourceGroup=4]="ScmResourceGroup",R[R.ScmProvider=5]="ScmProvider",R[R.CommentController=6]="CommentController",R[R.CommentThread=7]="CommentThread",R[R.CommentThreadReply=8]="CommentThreadReply",R[R.CommentNode=9]="CommentNode",R[R.CommentThreadNode=10]="CommentThreadNode",R[R.TimelineActionContext=11]="TimelineActionContext",R[R.NotebookCellActionContext=12]="NotebookCellActionContext",R[R.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function S(R,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,F.regExpFlags)(P)}:P}function D(R,P=0){if(!R||P>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return y.URI.revive(R);case 2:return new RegExp(R.source,R.flags)}if(R instanceof m.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let u=0;u<R.length;++u)R[u]=D(R[u],P+1);else for(const u in R)Object.hasOwnProperty.call(R,u)&&(R[u]=D(R[u],P+1))}return R}e.revive=D}),define(pe[10],ve([0,1,12,2]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var y;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(y=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,D,R){this._hosts[S]=D,this._ports[S]=R}setConnectionToken(S,D){this._connectionTokens[S]=D}rewrite(S){if(this._delegate)return this._delegate(S);const D=S.authority;let R=this._hosts[D];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const P=this._ports[D],u=this._connectionTokens[D];let E=`path=${encodeURIComponent(S.path)}`;return typeof u=="string"&&(E+=`&tkn=${encodeURIComponent(u)}`),F.URI.from({scheme:m.isWeb?this._preferredWebSchema:y.vscodeRemoteResource,authority:`${R}:${P}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new C;class i{asBrowserUri(S,D){const R=this.toUri(S,D);return R.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===y.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${y.vscodeFileResource}://${i.FALLBACK_AUTHORITY}`)?R.with({scheme:y.vscodeFileResource,authority:R.authority||i.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(S,D){const R=this.toUri(S,D);return R.scheme===y.vscodeFileResource?R.with({scheme:y.file,authority:R.authority!==i.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(S,D){return F.URI.isUri(S)?S:F.URI.parse(D.toUrl(S))}}i.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new i}),define(pe[23],ve([0,1,30,10,9,12,8,2]),function(Y,e,m,F,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(E){return(0,k.uriToFsPath)(E,!0)}e.originalFSPath=S;class D{constructor(h){this._ignorePathCasing=h}compare(h,p,v=!1){return h===p?0:(0,i.compare)(this.getComparisonKey(h,v),this.getComparisonKey(p,v))}isEqual(h,p,v=!1){return h===p?!0:!h||!p?!1:this.getComparisonKey(h,v)===this.getComparisonKey(p,v)}getComparisonKey(h,p=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,p,v=!1){if(h.scheme===p.scheme){if(h.scheme===F.Schemas.file)return m.isEqualOrParent(S(h),S(p),this._ignorePathCasing(h))&&h.query===p.query&&(v||h.fragment===p.fragment);if((0,e.isEqualAuthority)(h.authority,p.authority))return m.isEqualOrParent(h.path,p.path,this._ignorePathCasing(h),"/")&&h.query===p.query&&(v||h.fragment===p.fragment)}return!1}joinPath(h,...p){return k.URI.joinPath(h,...p)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return y.posix.basename(h.path)}extname(h){return y.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let p;return h.scheme===F.Schemas.file?p=k.URI.file(y.dirname(S(h))).path:(p=y.posix.dirname(h.path),h.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),p="/")),h.with({path:p})}normalizePath(h){if(!h.path.length)return h;let p;return h.scheme===F.Schemas.file?p=k.URI.file(y.normalize(S(h))).path:p=y.posix.normalize(h.path),h.with({path:p})}relativePath(h,p){if(h.scheme!==p.scheme||!(0,e.isEqualAuthority)(h.authority,p.authority))return;if(h.scheme===F.Schemas.file){const w=y.relative(S(h),S(p));return C.isWindows?m.toSlashes(w):w}let v=h.path||"/",I=p.path||"/";if(this._ignorePathCasing(h)){let w=0;for(const a=Math.min(v.length,I.length);w<a&&!(v.charCodeAt(w)!==I.charCodeAt(w)&&v.charAt(w).toLowerCase()!==I.charAt(w).toLowerCase());w++);v=I.substr(0,w)+v.substr(w)}return y.posix.relative(v,I)}resolvePath(h,p){if(h.scheme===F.Schemas.file){const v=k.URI.file(y.resolve(S(h),p));return h.with({authority:v.authority,path:v.path})}return p=m.toPosixPath(p),h.with({path:y.posix.resolve(h.path,p)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,p){return h===p||h!==void 0&&p!==void 0&&(0,i.equalsIgnoreCase)(h,p)}hasTrailingPathSeparator(h,p=y.sep){if(h.scheme===F.Schemas.file){const v=S(h);return v.length>m.getRoot(v).length&&v[v.length-1]===p}else{const v=h.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,p=y.sep){return(0,e.hasTrailingPathSeparator)(h,p)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,p=y.sep){let v=!1;if(h.scheme===F.Schemas.file){const I=S(h);v=I!==void 0&&I.length===m.getRoot(I).length&&I[I.length-1]===p}else{p="/";const I=h.path;v=I.length===1&&I.charCodeAt(I.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(h,p)?h.with({path:h.path+"/"}):h}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(E=>E.scheme===F.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new D(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(E,h){const p=[];for(let v=0;v<E.length;v++){const I=h(E[v]);E.some((w,a)=>a===v?!1:(0,e.isEqualOrParent)(I,h(w)))||p.push(E[v])}return p}e.distinctParents=R;var P;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function h(p){const v=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(a=>{const[r,g]=a.split(":");r&&g&&v.set(r,g)});const w=p.path.substring(0,p.path.indexOf(";"));return w&&v.set(E.META_DATA_MIME,w),v}E.parseMetaData=h})(P=e.DataUri||(e.DataUri={}));function u(E,h,p){if(h){let v=E.path;return v&&v[0]!==y.posix.sep&&(v=y.posix.sep+v),E.with({scheme:p,authority:h,path:v})}return E.with({scheme:p})}e.toLocalResource=u}),define(pe[18],ve([0,1,21,15,3,6,23,12]),function(Y,e,m,F,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S($){return!!$&&typeof $.then=="function"}e.isThenable=S;function D($){const H=new m.CancellationTokenSource,j=$(H.token),ie=new Promise((fe,ye)=>{const Ie=H.token.onCancellationRequested(()=>{Ie.dispose(),H.dispose(),ye((0,F.canceled)())});Promise.resolve(j).then(Be=>{Ie.dispose(),H.dispose(),fe(Be)},Be=>{Ie.dispose(),H.dispose(),ye(Be)})});return new class{cancel(){H.cancel()}then(fe,ye){return ie.then(fe,ye)}catch(fe){return this.then(void 0,fe)}finally(fe){return ie.finally(fe)}}}e.createCancelablePromise=D;function R($,H,j){return Promise.race([$,new Promise(ie=>H.onCancellationRequested(()=>ie(j)))])}e.raceCancellation=R;async function P($){let H=-1;const j=$.map((fe,ye)=>fe.then(Ie=>(H=ye,Ie))),ie=await Promise.race(j);return $.forEach((fe,ye)=>{ye!==H&&fe.cancel()}),ie}e.raceCancellablePromises=P;function u($,H,j){let ie;const fe=setTimeout(()=>{ie?.(void 0),j?.()},H);return Promise.race([$.finally(()=>clearTimeout(fe)),new Promise(ye=>ie=ye)])}e.raceTimeout=u;function E($){return new Promise((H,j)=>{const ie=$();S(ie)?ie.then(H,j):H(ie)})}e.asPromise=E;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(H){if(this.activePromise){if(this.queuedPromiseFactory=H,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const ie=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ie};this.queuedPromise=new Promise(ie=>{this.activePromise.then(j,j).then(ie)})}return new Promise((j,ie)=>{this.queuedPromise.then(j,ie)})}return this.activePromise=H(),new Promise((j,ie)=>{this.activePromise.then(fe=>{this.activePromise=null,j(fe)},fe=>{this.activePromise=null,ie(fe)})})}}e.Throttler=h;class p{constructor(){this.current=Promise.resolve(null)}queue(H){return this.current=this.current.then(()=>H(),()=>H())}}e.Sequencer=p;class v{constructor(){this.promiseMap=new Map}queue(H,j){const fe=(this.promiseMap.get(H)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(H)===fe&&this.promiseMap.delete(H)});return this.promiseMap.set(H,fe),fe}}e.SequencerByKey=v;class I{constructor(H){this.defaultDelay=H,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(H,j=this.defaultDelay){return this.task=H,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ie,fe)=>{this.doResolve=ie,this.doReject=fe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ie=this.task;return this.task=null,ie()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},j),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=I;class w{constructor(H){this.delayer=new I(H),this.throttler=new h}trigger(H,j){return this.delayer.trigger(()=>this.throttler.queue(H),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class a{constructor(){this._isOpen=!1,this._promise=new Promise((H,j)=>{this._completePromise=H})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class r extends a{constructor(H){super();this._timeout=setTimeout(()=>this.open(),H)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function g($,H){return H?new Promise((j,ie)=>{const fe=setTimeout(()=>{ye.dispose(),j()},$),ye=H.onCancellationRequested(()=>{clearTimeout(fe),ye.dispose(),ie((0,F.canceled)())})}):D(j=>g($,j))}e.timeout=g;function o($,H=0){const j=setTimeout($,H);return(0,C.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=o;function _($){const H=[];let j=0;const ie=$.length;function fe(){return j<ie?$[j++]():null}function ye(Ie){Ie!=null&&H.push(Ie);const Be=fe();return Be?Be.then(ye):Promise.resolve(H)}return Promise.resolve(null).then(ye)}e.sequence=_;function n($,H=ie=>!!ie,j=null){let ie=0;const fe=$.length,ye=()=>{if(ie>=fe)return Promise.resolve(j);const Ie=$[ie++];return Promise.resolve(Ie()).then(We=>H(We)?Promise.resolve(We):ye())};return ye()}e.first=n;function t($,H=ie=>!!ie,j=null){if($.length===0)return Promise.resolve(j);let ie=$.length;const fe=()=>{ie=-1;for(const ye of $)ye.cancel?.()};return new Promise((ye,Ie)=>{for(const Be of $)Be.then(We=>{--ie>=0&&H(We)?(fe(),ye(We)):ie===0&&ye(j)}).catch(We=>{--ie>=0&&(fe(),Ie(We))})})}e.firstParallel=t;class s{constructor(H){this._size=0,this.maxDegreeOfParalellism=H,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new y.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(H){return this._size++,new Promise((j,ie)=>{this.outstandingPromises.push({factory:H,c:j,e:ie}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const H=this.outstandingPromises.shift();this.runningPromises++;const j=H.factory();j.then(H.c,H.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class d extends s{constructor(){super(1)}}e.Queue=d;class c{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const H=new V;return this.drainers.add(H),H.p}isDrained(){for(const[,H]of this.queues)if(H.size>0)return!1;return!0}queueFor(H,j=i.extUri){const ie=j.getComparisonKey(H);let fe=this.queues.get(ie);return fe||(fe=new d,y.Event.once(fe.onFinished)(()=>{fe?.dispose(),this.queues.delete(ie),this.onDidQueueFinish()}),this.queues.set(ie,fe)),fe}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const H of this.drainers)H.complete();this.drainers.clear()}dispose(){for(const[,H]of this.queues)H.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=c;class f{constructor(H,j){this._token=-1,typeof H=="function"&&typeof j=="number"&&this.setIfNotSet(H,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(H,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,H()},j)}setIfNotSet(H,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,H()},j))}}e.TimeoutTimer=f;class l{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(H,j){this.cancel(),this._token=setInterval(()=>{H()},j)}}e.IntervalTimer=l;class b{constructor(H,j){this.timeoutToken=-1,this.runner=H,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(H=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,H)}get delay(){return this.timeout}set delay(H){this.timeout=H}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=b;class T{constructor(H,j){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.runner=H,this.timeout=j,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(H=this.timeout){H%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(H/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class A extends b{constructor(H,j){super(H,j);this.units=[]}work(H){this.units.push(H),this.isScheduled()||this.schedule()}doRun(){const H=this.units;this.units=[],this.runner&&this.runner(H)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=A;class U extends C.Disposable{constructor(H,j,ie,fe){super();this.maxWorkChunkSize=H,this.maxPendingWork=j,this.throttleDelay=ie,this.handler=fe,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(H){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+H.length>this.maxPendingWork)return!1}else if(this.pending+H.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...H),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new b(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=$=>{(0,k.setTimeout0)(()=>{if(H)return;const j=Date.now()+3;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,j-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.runWhenIdle=($,H)=>{const j=requestIdleCallback($,typeof H=="number"?{timeout:H}:void 0);let ie=!1;return{dispose(){ie||(ie=!0,cancelIdleCallback(j))}}}}();class B{constructor(H){this._didRun=!1,this._executor=()=>{try{this._value=H()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function L($,H,j){let ie;for(let fe=0;fe<j;fe++)try{return await $()}catch(ye){ie=ye,await g(H)}throw ie}e.retry=L;class x{hasPending(H){return this._pending?typeof H=="number"?this._pending.taskId===H:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(H,j,ie){return this._pending={taskId:H,cancel:()=>ie?.(),promise:j},j.then(()=>this.donePending(H),()=>this.donePending(H)),j}donePending(H){this._pending&&H===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const H=this._next;this._next=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}setNext(H){if(this._next)this._next.run=H;else{let j,ie;const fe=new Promise((ye,Ie)=>{j=ye,ie=Ie});this._next={run:H,promise:fe,promiseResolve:j,promiseReject:ie}}return this._next.promise}}e.TaskSequentializer=x;class M{constructor(H,j=()=>Date.now()){this.interval=H,this.nowFn=j,this.lastIncrementTime=0,this.value=0}increment(){const H=this.nowFn();return H-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=H,this.value=0),this.value++,this.value}}e.IntervalCounter=M;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((H,j)=>{this.completeCallback=H,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(H){return new Promise(j=>{this.completeCallback(H),this.resolved=!0,j()})}error(H){return new Promise(j=>{this.errorCallback(H),this.rejected=!0,j()})}cancel(){new Promise(H=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,H()})}}e.DeferredPromise=V;var O;(function($){async function H(ie){let fe;const ye=await Promise.all(ie.map(Ie=>Ie.then(Be=>Be,Be=>{fe||(fe=Be)})));if(typeof fe!="undefined")throw fe;return ye}$.settled=H;function j(ie){return new Promise(async(fe,ye)=>{try{await ie(fe,ye)}catch(Ie){ye(Ie)}})}$.withAsyncBody=j})(O=e.Promises||(e.Promises={}));var W;(function($){$[$.Initial=0]="Initial",$[$.DoneOK=1]="DoneOK",$[$.DoneError=2]="DoneError"})(W||(W={}));class q{constructor(H){this._state=0,this._results=[],this._error=null,this._onStateChanged=new y.Emitter,queueMicrotask(async()=>{const j={emitOne:ie=>this.emitOne(ie),emitMany:ie=>this.emitMany(ie),reject:ie=>this.reject(ie)};try{await Promise.resolve(H(j)),this.resolve()}catch(ie){this.reject(ie)}finally{j.emitOne=void 0,j.emitMany=void 0,j.reject=void 0}})}static fromArray(H){return new q(j=>{j.emitMany(H)})}static fromPromise(H){return new q(async j=>{j.emitMany(await H)})}static fromPromises(H){return new q(async j=>{await Promise.all(H.map(async ie=>j.emitOne(await ie)))})}static merge(H){return new q(async j=>{await Promise.all(H.map(async ie=>{for await(const fe of ie)j.emitOne(fe)}))})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(H<this._results.length)return{done:!1,value:this._results[H++]};if(this._state===1)return{done:!0,value:void 0};await y.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(H,j){return new q(async ie=>{for await(const fe of H)ie.emitOne(j(fe))})}map(H){return q.map(this,H)}static filter(H,j){return new q(async ie=>{for await(const fe of H)j(fe)&&ie.emitOne(fe)})}filter(H){return q.filter(this,H)}static coalesce(H){return q.filter(H,j=>!!j)}coalesce(){return q.coalesce(this)}static async toPromise(H){const j=[];for await(const ie of H)j.push(ie);return j}toPromise(){return q.toPromise(this)}emitOne(H){this._state===0&&(this._results.push(H),this._onStateChanged.fire())}emitMany(H){this._state===0&&(this._results=this._results.concat(H),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(H){this._state===0&&(this._state=2,this._error=H,this._onStateChanged.fire())}}e.AsyncIterableObject=q,q.EMPTY=q.fromArray([]);class N extends q{constructor(H,j){super(j);this._source=H}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=N;function G($){const H=new m.CancellationTokenSource,j=$(H.token);return new N(H,async ie=>{const fe=H.token.onCancellationRequested(()=>{fe.dispose(),H.dispose(),ie.reject((0,F.canceled)())});try{for await(const ye of j){if(H.token.isCancellationRequested)return;ie.emitOne(ye)}fe.dispose(),H.dispose()}catch(ye){fe.dispose(),H.dispose(),ie.reject(ye)}})}e.createCancelableAsyncIterable=G}),define(pe[99],ve([0,1,18,9]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new m.IdleValue(()=>{const l=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:l,collatorIsNumeric:l.resolvedOptions().numeric}}),C=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),i=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(l,b,T=!1){const A=l||"",U=b||"",B=y.value.collator.compare(A,U);return y.value.collatorIsNumeric&&B===0&&A!==U?A<U?-1:1:B}e.compareFileNames=k;function S(l,b){const T=C.value.collator;return l=l||"",b=b||"",g(T,l,b)}e.compareFileNamesDefault=S;function D(l,b){const T=C.value.collator;return l=l||"",b=b||"",t(l,b)||g(T,l,b)}e.compareFileNamesUpper=D;function R(l,b){const T=C.value.collator;return l=l||"",b=b||"",n(l,b)||g(T,l,b)}e.compareFileNamesLower=R;function P(l,b){return l=l||"",b=b||"",l===b?0:l<b?-1:1}e.compareFileNamesUnicode=P;function u(l,b,T=!1){T||(l=l&&l.toLowerCase(),b=b&&b.toLowerCase());const[A,U]=a(l),[B,L]=a(b);return A!==B?A<B?-1:1:U===L?0:U<L?-1:1}e.noIntlCompareFileNames=u;function E(l,b){const[T,A]=a(l),[U,B]=a(b);let L=y.value.collator.compare(A,B);if(L===0){if(y.value.collatorIsNumeric&&A!==B)return A<B?-1:1;if(L=y.value.collator.compare(T,U),y.value.collatorIsNumeric&&L===0&&T!==U)return T<U?-1:1}return L}e.compareFileExtensions=E;function h(l,b){l=l||"",b=b||"";const T=r(l),A=r(b),U=C.value.collator,B=i.value.collator;return g(B,T,A)||g(U,l,b)}e.compareFileExtensionsDefault=h;function p(l,b){l=l||"",b=b||"";const T=r(l),A=r(b),U=C.value.collator,B=i.value.collator;return g(B,T,A)||t(l,b)||g(U,l,b)}e.compareFileExtensionsUpper=p;function v(l,b){l=l||"",b=b||"";const T=r(l),A=r(b),U=C.value.collator,B=i.value.collator;return g(B,T,A)||n(l,b)||g(U,l,b)}e.compareFileExtensionsLower=v;function I(l,b){l=l||"",b=b||"";const T=r(l).toLowerCase(),A=r(b).toLowerCase();return T!==A?T<A?-1:1:l!==b?l<b?-1:1:0}e.compareFileExtensionsUnicode=I;const w=/^(.*?)(\.([^.]*))?$/;function a(l,b=!1){const T=l?w.exec(l):[];let A=[T&&T[1]||"",T&&T[3]||""];return b&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function r(l){const b=l?w.exec(l):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function g(l,b,T){let A=l.compare(b,T);return A!==0?A:b.length!==T.length?b.length<T.length?-1:1:0}function o(l){const b=l.charAt(0);return b.toLocaleUpperCase()!==b}function _(l){const b=l.charAt(0);return b.toLocaleLowerCase()!==b}function n(l,b){return o(l)&&_(b)?-1:_(l)&&o(b)?1:0}function t(l,b){return _(l)&&o(b)?-1:o(l)&&_(b)?1:0}function s(l,b,T=!1){return T||(l=l&&l.toLowerCase(),b=b&&b.toLowerCase()),l===b?0:l<b?-1:1}function d(l,b,T=!1){const A=l.split(F.sep),U=b.split(F.sep),B=A.length-1,L=U.length-1;let x,M;for(let V=0;;V++){if(x=B===V,M=L===V,x&&M)return k(A[V],U[V],T);if(x)return-1;if(M)return 1;const O=s(A[V],U[V],T);if(O!==0)return O}}e.comparePaths=d;function c(l,b,T){const A=l.toLowerCase(),U=b.toLowerCase(),B=f(l,b,T);if(B)return B;const L=A.endsWith(T),x=U.endsWith(T);if(L!==x)return L?-1:1;const M=k(A,U);return M!==0?M:A.localeCompare(U)}e.compareAnything=c;function f(l,b,T){const A=l.toLowerCase(),U=b.toLowerCase(),B=A.startsWith(T),L=U.startsWith(T);if(B!==L)return B?-1:1;if(B&&L){if(A.length<U.length)return-1;if(A.length>U.length)return 1}return 0}e.compareByPrefix=f}),define(pe[100],ve([0,1,99,96,47,9,12,8]),function(Y,e,m,F,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,D=[S,[]];function R(O,W,q,N){if(!O||!W)return D;const G=O.length,$=W.length;if(G<$)return D;const H=O.toLowerCase();return P(W,q,$,O,H,G,N)}e.scoreFuzzy=R;function P(O,W,q,N,G,$,H){const j=[],ie=[];for(let Be=0;Be<q;Be++){const We=Be*$,ze=We-$,Q=Be>0,ee=O[Be],re=W[Be];for(let he=0;he<$;he++){const Z=he>0,oe=We+he,be=oe-1,Me=ze+he-1,Ve=Z?j[be]:0,Ge=Q&&Z?j[Me]:0,Je=Q&&Z?ie[Me]:0;let tt;!Ge&&Q?tt=0:tt=u(ee,re,N,G,he,Je),tt&&Ge+tt>=Ve&&(H||Q||G.startsWith(W,he))?(ie[oe]=Je+1,j[oe]=Ge+tt):(ie[oe]=S,j[oe]=Ve)}}const fe=[];let ye=q-1,Ie=$-1;for(;ye>=0&&Ie>=0;){const Be=ye*$+Ie;ie[Be]===S||(fe.push(Ie),ye--),Ie--}return[j[q*$-1],fe.reverse()]}function u(O,W,q,N,G,$){let H=0;if(!E(W,N[G]))return H;if(H+=1,$>0&&(H+=$*5),O===q[G]&&(H+=1),G===0)H+=8;else{const j=h(q.charCodeAt(G-1));j?H+=j:(0,F.isUpper)(q.charCodeAt(G))&&$===0&&(H+=2)}return H}function E(O,W){return O===W?!0:O==="/"||O==="\\"?W==="/"||W==="\\":!1}function h(O){switch(O){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function v(O,W,q=0,N=0){const G=W;return G.values&&G.values.length>1?I(O,G.values,q,N):w(O,W,q,N)}e.scoreFuzzy2=v;function I(O,W,q,N){let G=0;const $=[];for(const H of W){const[j,ie]=w(O,H,q,N);if(typeof j!="number")return p;G+=j,$.push(...ie)}return[G,f($)]}function w(O,W,q,N){const G=(0,F.fuzzyScore)(W.original,W.originalLowercase,q,O,O.toLowerCase(),N,!0);return G?[G[0],(0,F.createMatches)(G)]:p}const a=Object.freeze({score:0}),r=1<<18,g=1<<17,o=1<<16;function _(O,W,q,N){const G=N.values?N.values:[N];return(0,y.hash)({[N.normalized]:{values:G.map(H=>({value:H.normalized,expectContiguousMatch:H.expectContiguousMatch})),label:O,description:W,allowNonContiguousMatches:q}})}function n(O,W,q,N,G){if(!O||!W.normalized)return a;const $=N.getItemLabel(O);if(!$)return a;const H=N.getItemDescription(O),j=_($,H,q,W),ie=G[j];if(ie)return ie;const fe=t($,H,N.getItemPath(O),W,q);return G[j]=fe,fe}e.scoreItemFuzzy=n;function t(O,W,q,N,G){const $=!q||!N.containsPathSeparator;return q&&(i.isLinux?N.pathNormalized===q:(0,k.equalsIgnoreCase)(N.pathNormalized,q))?{score:r,labelMatch:[{start:0,end:O.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:N.values&&N.values.length>1?s(O,W,q,N.values,$,G):d(O,W,q,N,$,G)}function s(O,W,q,N,G,$){let H=0;const j=[],ie=[];for(const fe of N){const{score:ye,labelMatch:Ie,descriptionMatch:Be}=d(O,W,q,fe,G,$);if(ye===S)return a;H+=ye,Ie&&j.push(...Ie),Be&&ie.push(...Be)}return{score:H,labelMatch:f(j),descriptionMatch:f(ie)}}function d(O,W,q,N,G,$){if(G||!W){const[H,j]=R(O,N.normalized,N.normalizedLowercase,$&&!N.expectContiguousMatch);if(H){const ie=(0,F.matchesPrefix)(N.normalized,O);let fe;return ie?(fe=g,fe+=Math.round(N.normalized.length/O.length*100)):fe=o,{score:fe+H,labelMatch:ie||c(j)}}}if(W){let H=W;q&&(H=`${W}${C.sep}`);const j=H.length,ie=`${H}${O}`,[fe,ye]=R(ie,N.normalized,N.normalizedLowercase,$&&!N.expectContiguousMatch);if(fe){const Ie=c(ye),Be=[],We=[];return Ie.forEach(ze=>{ze.start<j&&ze.end>j?(Be.push({start:0,end:ze.end-j}),We.push({start:ze.start,end:j})):ze.start>=j?Be.push({start:ze.start-j,end:ze.end-j}):We.push(ze)}),{score:fe,labelMatch:Be,descriptionMatch:We}}}return a}function c(O){const W=[];if(!O)return W;let q;for(const N of O)q&&q.end===N?q.end+=1:(q={start:N,end:N+1},W.push(q));return W}function f(O){const W=O.sort((G,$)=>G.start-$.start),q=[];let N;for(const G of W)!N||!l(N,G)?(N=G,q.push(G)):(N.start=Math.min(N.start,G.start),N.end=Math.max(N.end,G.end));return q}function l(O,W){return!(O.end<W.start||W.end<O.start)}function b(O,W,q,N,G,$){const H=n(O,q,N,G,$),j=n(W,q,N,G,$),ie=H.score,fe=j.score;if((ie===r||fe===r)&&ie!==fe)return ie===r?-1:1;if(ie>o||fe>o){if(ie!==fe)return ie>fe?-1:1;if(ie<g&&fe<g){const ee=A(H.labelMatch,j.labelMatch);if(ee!==0)return ee}const ze=G.getItemLabel(O)||"",Q=G.getItemLabel(W)||"";if(ze.length!==Q.length)return ze.length-Q.length}if(ie!==fe)return ie>fe?-1:1;const ye=Array.isArray(H.labelMatch)&&H.labelMatch.length>0,Ie=Array.isArray(j.labelMatch)&&j.labelMatch.length>0;if(ye&&!Ie)return-1;if(Ie&&!ye)return 1;const Be=T(O,H,G),We=T(W,j,G);return Be&&We&&Be!==We?We>Be?-1:1:U(O,W,q,G)}e.compareItemsByFuzzyScore=b;function T(O,W,q){let N=-1,G=-1;if(W.descriptionMatch&&W.descriptionMatch.length?N=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(N=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(G=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const $=q.getItemDescription(O);$&&(G+=$.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(G=W.descriptionMatch[W.descriptionMatch.length-1].end);return G-N}function A(O,W){if(!O&&!W||(!O||!O.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!O||!O.length)return 1;const q=O[0].start,G=O[O.length-1].end-q,$=W[0].start,j=W[W.length-1].end-$;return G===j?0:j<G?1:-1}function U(O,W,q,N){const G=N.getItemLabel(O)||"",$=N.getItemLabel(W)||"",H=N.getItemDescription(O),j=N.getItemDescription(W),ie=G.length+(H?H.length:0),fe=$.length+(j?j.length:0);if(ie!==fe)return ie-fe;const ye=N.getItemPath(O),Ie=N.getItemPath(W);return ye&&Ie&&ye.length!==Ie.length?ye.length-Ie.length:G!==$?(0,m.compareAnything)(G,$,q.normalized):H&&j&&H!==j?(0,m.compareAnything)(H,j,q.normalized):ye&&Ie&&ye!==Ie?(0,m.compareAnything)(ye,Ie,q.normalized):0}function B(O){return O.startsWith('"')&&O.endsWith('"')}const L=" ";function x(O){typeof O!="string"&&(O="");const W=O.toLowerCase(),{pathNormalized:q,normalized:N,normalizedLowercase:G}=M(O),$=q.indexOf(C.sep)>=0,H=B(O);let j;const ie=O.split(L);if(ie.length>1)for(const fe of ie){const ye=B(fe),{pathNormalized:Ie,normalized:Be,normalizedLowercase:We}=M(fe);Be&&(j||(j=[]),j.push({original:fe,originalLowercase:fe.toLowerCase(),pathNormalized:Ie,normalized:Be,normalizedLowercase:We,expectContiguousMatch:ye}))}return{original:O,originalLowercase:W,pathNormalized:q,normalized:N,normalizedLowercase:G,values:j,containsPathSeparator:$,expectContiguousMatch:H}}e.prepareQuery=x;function M(O){let W;i.isWindows?W=O.replace(/\//g,C.sep):W=O.replace(/\\/g,C.sep);const q=(0,k.stripWildcards)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:q,normalizedLowercase:q.toLowerCase()}}function V(O){return Array.isArray(O)?x(O.map(W=>W.original).join(L)):x(O.original)}e.pieceToQuery=V}),define(pe[31],ve([0,1,18,30,24,9,8]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const S="**",D="/",R="[/\\\\]",P="[^/\\\\]",u=/\//g;function E(N){switch(N){case 0:return"";case 1:return`${P}*?`;default:return`(?:${R}|${P}+${R}|${R}${P}+)*?`}}function h(N,G){if(!N)return[];const $=[];let H=!1,j=!1,ie="";for(const fe of N){switch(fe){case G:if(!H&&!j){$.push(ie),ie="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":j=!0;break;case"]":j=!1;break}ie+=fe}return ie&&$.push(ie),$}e.splitGlobAware=h;function p(N){if(!N)return"";let G="";const $=h(N,D);if($.every(H=>H===S))G=".*";else{let H=!1;$.forEach((j,ie)=>{if(j===S){H||(G+=E(2),H=!0);return}let fe=!1,ye="",Ie=!1,Be="";for(const We of j){if(We!=="}"&&fe){ye+=We;continue}if(Ie&&(We!=="]"||!Be)){let ze;We==="-"?ze=We:(We==="^"||We==="!")&&!Be?ze="^":We===D?ze="":ze=i.escapeRegExpCharacters(We),Be+=ze;continue}switch(We){case"{":fe=!0;continue;case"[":Ie=!0;continue;case"}":G+=`(?:${h(ye,",").map(ee=>p(ee)).join("|")})`,fe=!1,ye="";break;case"]":G+="["+Be+"]",Ie=!1,Be="";break;case"?":G+=P;continue;case"*":G+=E(1);continue;default:G+=i.escapeRegExpCharacters(We)}}ie<$.length-1&&($[ie+1]!==S||ie+2<$.length)&&(G+=R),H=!1})}return G}const v=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,o=new y.LRUCache(1e4),_=function(){return!1},n=function(){return null};function t(N,G){if(!N)return n;let $;typeof N!="string"?$=N.pattern:$=N,$=$.trim();const H=`${$}_${!!G.trimForExclusions}`;let j=o.get(H);if(j)return s(j,N);let ie;if(v.test($)){const fe=$.substr(4);j=function(ye,Ie){return typeof ye=="string"&&ye.endsWith(fe)?$:null}}else(ie=I.exec(d($,G)))?j=c(ie[1],$):(G.trimForExclusions?a:w).test($)?j=f($,G):(ie=r.exec(d($,G)))?j=l(ie[1].substr(1),$,!0):(ie=g.exec(d($,G)))?j=l(ie[1],$,!1):j=b($);return o.set(H,j),s(j,N)}function s(N,G){return typeof G=="string"?N:function($,H){return F.isEqualOrParent($,G.base)?N(C.relative(G.base,$),H):null}}function d(N,G){return G.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function c(N,G){const $=`/${N}`,H=`\\${N}`,j=function(fe,ye){return typeof fe!="string"?null:ye?ye===N?G:null:fe===N||fe.endsWith($)||fe.endsWith(H)?G:null},ie=[N];return j.basenames=ie,j.patterns=[G],j.allBasenames=ie,j}function f(N,G){const $=q(N.slice(1,-1).split(",").map(ye=>t(ye,G)).filter(ye=>ye!==n),N),H=$.length;if(!H)return n;if(H===1)return $[0];const j=function(ye,Ie){for(let Be=0,We=$.length;Be<We;Be++)if($[Be](ye,Ie))return N;return null},ie=$.find(ye=>!!ye.allBasenames);ie&&(j.allBasenames=ie.allBasenames);const fe=$.reduce((ye,Ie)=>Ie.allPaths?ye.concat(Ie.allPaths):ye,[]);return fe.length&&(j.allPaths=fe),j}function l(N,G,$){const H=C.sep===C.posix.sep,j=H?N:N.replace(u,C.sep),ie=C.sep+j,fe=C.posix.sep+N,ye=$?function(Ie,Be){return typeof Ie=="string"&&(Ie===j||Ie.endsWith(ie)||!H&&(Ie===N||Ie.endsWith(fe)))?G:null}:function(Ie,Be){return typeof Ie=="string"&&(Ie===j||!H&&Ie===N)?G:null};return ye.allPaths=[($?"*/":"./")+N],ye}function b(N){try{const G=new RegExp(`^${p(N)}$`);return function($){return G.lastIndex=0,typeof $=="string"&&G.test($)?N:null}}catch(G){return n}}function T(N,G,$){return!N||typeof G!="string"?!1:A(N)(G,void 0,$)}e.match=T;function A(N,G={}){if(!N)return _;if(typeof N=="string"||x(N)){const $=t(N,G);if($===n)return _;const H=function(j,ie){return!!$(j,ie)};return $.allBasenames&&(H.allBasenames=$.allBasenames),$.allPaths&&(H.allPaths=$.allPaths),H}return O(N,G)}e.parse=A;function U(N){if(!N)return;let G;return $=>(G||(G=(N()||Promise.resolve([])).then(H=>H?L(H):{})),G.then(H=>!!H[$]))}e.hasSiblingPromiseFn=U;function B(N){if(!N)return;let G;return $=>{if(!G){const H=N();G=H?L(H):{}}return!!G[$]}}e.hasSiblingFn=B;function L(N){const G={};for(const $ of N)G[$]=!0;return G}function x(N){const G=N;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=x;function M(N){return N.allBasenames||[]}e.getBasenameTerms=M;function V(N){return N.allPaths||[]}e.getPathTerms=V;function O(N,G){const $=q(Object.getOwnPropertyNames(N).map(ye=>W(ye,N[ye],G)).filter(ye=>ye!==n)),H=$.length;if(!H)return n;if(!$.some(ye=>!!ye.requiresSiblings)){if(H===1)return $[0];const ye=function(We,ze){for(let Q=0,ee=$.length;Q<ee;Q++){const re=$[Q](We,ze);if(re)return re}return null},Ie=$.find(We=>!!We.allBasenames);Ie&&(ye.allBasenames=Ie.allBasenames);const Be=$.reduce((We,ze)=>ze.allPaths?We.concat(ze.allPaths):We,[]);return Be.length&&(ye.allPaths=Be),ye}const j=function(ye,Ie,Be){let We;for(let ze=0,Q=$.length;ze<Q;ze++){const ee=$[ze];ee.requiresSiblings&&Be&&(Ie||(Ie=C.basename(ye)),We||(We=Ie.substr(0,Ie.length-C.extname(ye).length)));const re=ee(ye,Ie,We,Be);if(re)return re}return null},ie=$.find(ye=>!!ye.allBasenames);ie&&(j.allBasenames=ie.allBasenames);const fe=$.reduce((ye,Ie)=>Ie.allPaths?ye.concat(Ie.allPaths):ye,[]);return fe.length&&(j.allPaths=fe),j}function W(N,G,$){if(G===!1)return n;const H=t(N,$);if(H===n)return n;if(typeof G=="boolean")return H;if(G){const j=G.when;if(typeof j=="string"){const ie=(fe,ye,Ie,Be)=>{if(!Be||!H(fe,ye))return null;const We=j.replace("$(basename)",Ie),ze=Be(We);return(0,m.isThenable)(ze)?ze.then(Q=>Q?N:null):ze?N:null};return ie.requiresSiblings=!0,ie}}return H}function q(N,G){const $=N.filter(ye=>!!ye.basenames);if($.length<2)return N;const H=$.reduce((ye,Ie)=>{const Be=Ie.basenames;return Be?ye.concat(Be):ye},[]);let j;if(G){j=[];for(let ye=0,Ie=H.length;ye<Ie;ye++)j.push(G)}else j=$.reduce((ye,Ie)=>{const Be=Ie.patterns;return Be?ye.concat(Be):ye},[]);const ie=function(ye,Ie){if(typeof ye!="string")return null;if(!Ie){let We;for(We=ye.length;We>0;We--){const ze=ye.charCodeAt(We-1);if(ze===47||ze===92)break}Ie=ye.substr(We)}const Be=H.indexOf(Ie);return Be!==-1?j[Be]:null};ie.basenames=H,ie.patterns=j,ie.allBasenames=H;const fe=N.filter(ye=>!ye.basenames);return fe.push(ie),fe}}),define(pe[80],ve([0,1,30,10,9,12,23,8,2]),function(Y,e,m,F,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function D(t,s,d){if(typeof t=="string"&&(t=S.URI.file(t)),d){const f=d.getWorkspaceFolder(t);if(f){const l=d.getWorkspace().folders.length>1;let b;if((0,i.isEqual)(f.uri,t)?b="":b=(0,i.relativePath)(f.uri,t),l){const T=f.name?f.name:(0,i.basename)(f.uri);b=b?T+" \u2022 "+b:T}return b}}if(t.scheme!==F.Schemas.file&&t.scheme!==F.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(t.fsPath))return(0,y.normalize)(P(t.fsPath));let c=(0,y.normalize)(t.fsPath);return!C.isWindows&&s?.userHome&&(c=E(c,s.userHome.fsPath)),c}e.getPathLabel=D;function R(t){if(!t)return;typeof t=="string"&&(t=S.URI.file(t));const s=(0,i.basename)(t)||(t.scheme===F.Schemas.file?t.fsPath:t.path);return C.isWindows&&(0,m.isRootOrDriveLetter)(s)?P(s):s}e.getBaseLabel=R;function P(t,s){return(0,m.hasDriveLetter)(t,s)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=P;let u=Object.create(null);function E(t,s){if(C.isWindows||!t||!s)return t;let d=u.original===s?u.normalized:void 0;return d||(d=`${(0,k.rtrim)(s,y.posix.sep)}${y.posix.sep}`,u={original:s,normalized:d}),(C.isLinux?t.startsWith(d):(0,k.startsWithIgnoreCase)(t,d))&&(t=`~/${t.substr(d.length)}`),t}e.tildify=E;function h(t,s){return t.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=h;const p="\u2026",v="\\\\",I="~";function w(t,s=y.sep){const d=new Array(t.length);let c=!1;for(let f=0;f<t.length;f++){let l=t[f];if(l===""){d[f]=`.${s}`;continue}if(!l){d[f]=l;continue}c=!0;let b="";l.indexOf(v)===0?(b=l.substr(0,l.indexOf(v)+v.length),l=l.substr(l.indexOf(v)+v.length)):l.indexOf(s)===0?(b=l.substr(0,l.indexOf(s)+s.length),l=l.substr(l.indexOf(s)+s.length)):l.indexOf(I)===0&&(b=l.substr(0,l.indexOf(I)+I.length),l=l.substr(l.indexOf(I)+I.length));const T=l.split(s);for(let A=1;c&&A<=T.length;A++)for(let U=T.length-A;c&&U>=0;U--){c=!1;let B=T.slice(U,U+A).join(s);for(let L=0;!c&&L<t.length;L++)if(L!==f&&t[L]&&t[L].indexOf(B)>-1){const x=U+A===T.length,M=U>0&&t[L].indexOf(s)>-1?s+B:B,V=t[L].endsWith(M);c=!x||V}if(!c){let L="";(T[0].endsWith(":")||b!=="")&&(U===1&&(U=0,A++,B=T[0]+s+B),U>0&&(L=T[0]+s),L=b+L),U>0&&(L=L+p+s),L=L+B,U+A<T.length&&(L=L+s+p),d[f]=L}}c&&(d[f]=l)}return d}e.shorten=w;var a;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function r(t,s=Object.create(null)){const d=[];let c=!1,f="";for(const l of t)if(l==="$"||c&&l==="{")f&&d.push({value:f,type:a.TEXT}),f="",c=!0;else if(l==="}"&&c){const b=s[f];if(typeof b=="string")b.length&&d.push({value:b,type:a.VARIABLE});else if(b){const T=d[d.length-1];(!T||T.type!==a.SEPARATOR)&&d.push({value:b.label,type:a.SEPARATOR})}f="",c=!1}else f+=l;return f&&!c&&d.push({value:f,type:a.TEXT}),d.filter((l,b)=>{if(l.type===a.SEPARATOR){const T=d[b-1],A=d[b+1];return[T,A].every(U=>U&&(U.type===a.VARIABLE||U.type===a.TEXT)&&U.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=r;function g(t,s){return C.isMacintosh||s?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):t.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function o(t,s){return C.isMacintosh||s?t.replace(/\(&&\w\)|&&/g,""):C.isWindows?t.replace(/&&|&/g,d=>d==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function _(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=_;function n(t){const s=t.indexOf("/")!==-1?y.posix:y.win32,d=s.basename(t),c=s.dirname(t);return d.length?{name:d,parentPath:c}:{name:c,parentPath:""}}e.splitName=n}),define(pe[101],ve([0,1,31,10,9,23,8]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));let S=[],D=[],R=[];function P(t,s=!1){const d=u(t);S.push(d),d.userConfigured?R.push(d):D.push(d),s&&!d.userConfigured&&S.forEach(c=>{c.mime===d.mime||c.userConfigured||(d.extension&&c.extension===d.extension&&console.warn(`Overwriting extension <<${d.extension}>> to now point to mime <<${d.mime}>>`),d.filename&&c.filename===d.filename&&console.warn(`Overwriting filename <<${d.filename}>> to now point to mime <<${d.mime}>>`),d.filepattern&&c.filepattern===d.filepattern&&console.warn(`Overwriting filepattern <<${d.filepattern}>> to now point to mime <<${d.mime}>>`),d.firstline&&c.firstline===d.firstline&&console.warn(`Overwriting firstline <<${d.firstline}>> to now point to mime <<${d.mime}>>`))})}e.registerTextMime=P;function u(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,m.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(y.posix.sep)>=0:!1}}function E(t){t?(S=S.filter(s=>!s.userConfigured),R=[]):(S=[],D=[],R=[])}e.clearTextMimes=E;function h(t,s){let d;if(t)switch(t.scheme){case F.Schemas.file:d=t.fsPath;break;case F.Schemas.data:d=C.DataUri.parseMetaData(t).get(C.DataUri.META_DATA_LABEL);break;default:d=t.path}if(!d)return[k.unknown];d=d.toLowerCase();const c=(0,y.basename)(d),f=p(d,c,R);if(f)return[f,k.text];const l=p(d,c,D);if(l)return[l,k.text];if(s){const b=v(s);if(b)return[b,k.text]}return[k.unknown]}e.guessMimeTypes=h;function p(t,s,d){let c=null,f=null,l=null;for(let b=d.length-1;b>=0;b--){const T=d[b];if(s===T.filenameLowercase){c=T;break}if(T.filepattern&&(!f||T.filepattern.length>f.filepattern.length)){const A=T.filepatternOnPath?t:s;T.filepatternLowercase?.(A)&&(f=T)}T.extension&&(!l||T.extension.length>l.extension.length)&&s.endsWith(T.extensionLowercase)&&(l=T)}return c?c.mime:f?f.mime:l?l.mime:null}function v(t){if((0,i.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let s=S.length-1;s>=0;s--){const d=S[s];if(!d.firstline)continue;const c=t.match(d.firstline);if(c&&c.length>0)return d.mime}return null}function I(t){return t?typeof t=="string"?t===k.binary||t===k.text||t===k.unknown:t.length===1&&I(t[0]):!0}e.isUnspecific=I;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},a={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function r(t){const s=(0,y.extname)(t),d=w[s.toLowerCase()];return d!==void 0?d:g(t)}e.getMediaOrTextMime=r;function g(t){const s=(0,y.extname)(t);return a[s.toLowerCase()]}e.getMediaMime=g;function o(t){for(const s in a)if(a[s]===t)return s}e.getExtensionForMimeType=o;const _=/^(.+)\/(.+?)(;.+)?$/;function n(t,s){const d=_.exec(t);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:s?void 0:t}e.normalizeMimeType=n}),define(pe[102],ve([0,1,2]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(R){return R.toJSON()}class y{constructor(P){this._uriTransformer=P}transformIncoming(P){const u=this._uriTransformer.transformIncoming(P);return u===P?P:F(m.URI.from(u))}transformOutgoing(P){const u=this._uriTransformer.transformOutgoing(P);return u===P?P:F(m.URI.from(u))}transformOutgoingURI(P){const u=this._uriTransformer.transformOutgoing(P);return u===P?P:m.URI.from(u)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function C(R,P,u){if(!R||u>200)return null;if(typeof R=="object"){if(R instanceof m.URI)return P.transformOutgoing(R);for(let E in R)if(Object.hasOwnProperty.call(R,E)){const h=C(R[E],P,u+1);h!==null&&(R[E]=h)}}return null}function i(R,P){const u=C(R,P,0);return u===null?R:u}e.transformOutgoingURIs=i;function k(R,P,u,E){if(!R||E>200)return null;if(typeof R=="object"){if(R.$mid===1)return u?m.URI.revive(P.transformIncoming(R)):P.transformIncoming(R);for(let h in R)if(Object.hasOwnProperty.call(R,h)){const p=k(R[h],P,u,E+1);p!==null&&(R[h]=p)}}return null}function S(R,P){const u=k(R,P,!1,0);return u===null?R:u}e.transformIncomingURIs=S;function D(R,P){const u=k(R,P,!0,0);return u===null?R:u}e.transformAndReviveIncomingURIs=D}),define(pe[32],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(S){return m.test(S)}e.isUUID=F;const y=new Uint8Array(16),C=[];for(let S=0;S<256;S++)C.push(S.toString(16).padStart(2,"0"));let i;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?i=crypto.getRandomValues.bind(crypto):i=function(S){for(let D=0;D<S.length;D++)S[D]=Math.floor(Math.random()*256);return S};function k(){i(y),y[6]=y[6]&15|64,y[8]=y[8]&63|128;let S=0,D="";return D+=C[y[S++]],D+=C[y[S++]],D+=C[y[S++]],D+=C[y[S++]],D+="-",D+=C[y[S++]],D+=C[y[S++]],D+="-",D+=C[y[S++]],D+=C[y[S++]],D+="-",D+=C[y[S++]],D+=C[y[S++]],D+="-",D+=C[y[S++]],D+=C[y[S++]],D+=C[y[S++]],D+=C[y[S++]],D+=C[y[S++]],D+=C[y[S++]],D}e.generateUuid=k}),define(pe[142],ve([0,1,103]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class F{constructor(C="utf8"){this.stringDecoder=new m.StringDecoder(C),this.remaining=null}write(C){const i=[],k=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(k.length<1)return i;let S=0,D,R=S;for(;R<k.length;)if(D=k.charCodeAt(R),D===13||D===10){if(i.push(k.substring(S,R)),R++,R<k.length){const P=D;D=k.charCodeAt(R),(P===13&&D===10||P===10&&D===13)&&R++}S=R}else R++;return this.remaining=S<k.length?k.substr(S):null,i}end(){return this.remaining}}e.LineDecoder=F}),define(pe[28],ve([0,1,60,81,289,18,30,79,9,12,23,2,32]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function h(M,V=E.UNLINK){if((0,i.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return V===E.UNLINK?v(M):p(M)}async function p(M){try{const V=(0,S.join)((0,F.tmpdir)(),(0,u.generateUuid)());try{await e.Promises.rename(M,V)}catch(O){return v(M)}v(V).catch(O=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function v(M){return(0,y.promisify)(m.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function I(M){if((0,i.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");m.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=I;async function w(M,V){return g(await(V?a(M):(0,y.promisify)(m.readdir)(M)))}async function a(M){try{return await(0,y.promisify)(m.readdir)(M,{withFileTypes:!0})}catch(W){console.warn("[node.js fs] readdir with filetypes failed with error: ",W)}const V=[],O=await w(M);for(const W of O){let q=!1,N=!1,G=!1;try{const $=await e.Promises.lstat((0,S.join)(M,W));q=$.isFile(),N=$.isDirectory(),G=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}V.push({name:W,isFile:()=>q,isDirectory:()=>N,isSymbolicLink:()=>G})}return V}function r(M){return g(m.readdirSync(M))}e.readdirSync=r;function g(M){return M.map(V=>typeof V=="string"?D.isMacintosh?(0,k.normalizeNFC)(V):V:(V.name=D.isMacintosh?(0,k.normalizeNFC)(V.name):V.name,V))}async function o(M){const V=await w(M),O=[];for(const W of V)await n.existsDirectory((0,S.join)(M,W))&&O.push(W);return O}function _(M,V=1e3){return new Promise(O=>{let W=!1;const q=setInterval(()=>{W||(W=!0,m.access(M,N=>{W=!1,N&&(clearInterval(q),O(void 0))}))},V)})}e.whenDeleted=_;var n;(function(M){async function V(q){let N;try{if(N=await e.Promises.lstat(q),!N.isSymbolicLink())return{stat:N}}catch(G){}try{return{stat:await e.Promises.stat(q),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(D.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw $}throw G}}M.stat=V;async function O(q){try{const{stat:N,symbolicLink:G}=await M.stat(q);return N.isFile()&&G?.dangling!==!0}catch(N){}return!1}M.existsFile=O;async function W(q){try{const{stat:N,symbolicLink:G}=await M.stat(q);return N.isDirectory()&&G?.dangling!==!0}catch(N){}return!1}M.existsDirectory=W})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new C.ResourceQueue;function s(M,V,O){return t.queueFor(P.URI.file(M),R.extUriBiasedIgnorePathCase).queue(()=>{const W=l(O);return new Promise((q,N)=>c(M,V,W,G=>G?N(G):q()))})}let d=!0;function c(M,V,O,W){if(!d)return m.writeFile(M,V,{mode:O.mode,flag:O.flag},W);m.open(M,O.flag,O.mode,(q,N)=>{if(q)return W(q);m.writeFile(N,V,G=>{if(G)return m.close(N,()=>W(G));m.fdatasync(N,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),d=!1),m.close(N,H=>W(H))))})})}function f(M,V,O){const W=l(O);if(!d)return m.writeFileSync(M,V,{mode:W.mode,flag:W.flag});const q=m.openSync(M,W.flag,W.mode);try{m.writeFileSync(q,V);try{m.fdatasyncSync(q)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),d=!1}}finally{m.closeSync(q)}}e.writeFileSync=f;function l(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function b(M,V){if(M===V)return;async function O(W){try{const q=await e.Promises.lstat(W);if(q.isDirectory()||q.isSymbolicLink())return;await e.Promises.utimes(W,q.atime,new Date)}catch(q){}}try{await e.Promises.rename(M,V),await O(V)}catch(W){if(M.toLowerCase()!==V.toLowerCase()&&W.code==="EXDEV"||M.endsWith("."))await T(M,V,{preserveSymlinks:!1}),await h(M,E.MOVE),await O(V);else throw W}}async function T(M,V,O){return U(M,V,{root:{source:M,target:V},options:O,handledSourcePaths:new Set})}const A=511;async function U(M,V,O){if(O.handledSourcePaths.has(M))return;O.handledSourcePaths.add(M);const{stat:W,symbolicLink:q}=await n.stat(M);if(q){if(O.options.preserveSymlinks)try{return await x(M,V,O)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(q.dangling)return}return W.isDirectory()?B(M,V,W.mode&A,O):L(M,V,W.mode&A)}async function B(M,V,O,W){await e.Promises.mkdir(V,{recursive:!0,mode:O});const q=await w(M);for(const N of q)await U((0,S.join)(M,N),(0,S.join)(V,N),W)}async function L(M,V,O){await e.Promises.copyFile(M,V),await e.Promises.chmod(V,O)}async function x(M,V,O){let W=await e.Promises.readlink(M);(0,i.isEqualOrParent)(W,O.root.source,!D.isLinux)&&(W=(0,S.join)(O.root.target,W.substr(O.root.source.length+1))),await e.Promises.symlink(W,V)}e.Promises=new class{get access(){return(0,y.promisify)(m.access)}get stat(){return(0,y.promisify)(m.stat)}get lstat(){return(0,y.promisify)(m.lstat)}get utimes(){return(0,y.promisify)(m.utimes)}get read(){return(0,y.promisify)(m.read)}get readFile(){return(0,y.promisify)(m.readFile)}get write(){return(0,y.promisify)(m.write)}get appendFile(){return(0,y.promisify)(m.appendFile)}get fdatasync(){return(0,y.promisify)(m.fdatasync)}get truncate(){return(0,y.promisify)(m.truncate)}get rename(){return(0,y.promisify)(m.rename)}get copyFile(){return(0,y.promisify)(m.copyFile)}get open(){return(0,y.promisify)(m.open)}get close(){return(0,y.promisify)(m.close)}get symlink(){return(0,y.promisify)(m.symlink)}get readlink(){return(0,y.promisify)(m.readlink)}get chmod(){return(0,y.promisify)(m.chmod)}get mkdir(){return(0,y.promisify)(m.mkdir)}get unlink(){return(0,y.promisify)(m.unlink)}get rmdir(){return(0,y.promisify)(m.rmdir)}get realpath(){return(0,y.promisify)(m.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return o}get writeFile(){return s}get rm(){return h}get move(){return b}get copy(){return T}}}),define(pe[104],ve([0,1,60,9,8,28]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function i(R){const P=(0,F.dirname)(R);if(R===P)return R;const u=((0,F.basename)(R)||R).toLowerCase();try{const h=(0,C.readdirSync)(P).filter(p=>p.toLowerCase()===u);if(h.length===1){const p=i(P);if(p)return(0,F.join)(p,h[0])}else if(h.length>1){const p=h.indexOf(u);if(p>=0){const v=i(P);if(v)return(0,F.join)(v,h[p])}}}catch(E){}return null}e.realcaseSync=i;async function k(R){try{return await C.Promises.realpath(R)}catch(P){const u=D(R);return await C.Promises.access(u,m.constants.R_OK),u}}e.realpath=k;function S(R){try{return m.realpathSync(R)}catch(P){const u=D(R);return m.accessSync(u,m.constants.R_OK),u}}e.realpathSync=S;function D(R){return(0,y.rtrim)((0,F.normalize)(R),F.sep)}});var je=this&&this.__decorate||function(Y,e,m,F){var y=arguments.length,C=y<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,m):F,i;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(Y,e,m,F);else for(var k=Y.length-1;k>=0;k--)(i=Y[k])&&(C=(y<3?i(C):y>3?i(e,m,C):i(e,m))||C);return y>3&&C&&Object.defineProperty(e,m,C),C};define(pe[105],ve([0,1,16,18,22,21,57,15,3,6,59,8,13]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function h(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function v(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var I;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(I||(I={}));class w{constructor(N){this.buffer=N,this.pos=0}read(N){const G=this.buffer.slice(this.pos,this.pos+N);return this.pos+=G.byteLength,G}}class a{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var r;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(r||(r={}));function g(q){const N=y.VSBuffer.alloc(4);return N.writeUInt32BE(q,0),N}function o(q){return q.read(4).readUInt32BE(0)}function _(q){const N=y.VSBuffer.alloc(1);return N.writeUInt8(q,0),N}const n={Undefined:_(r.Undefined),String:_(r.String),Buffer:_(r.Buffer),VSBuffer:_(r.VSBuffer),Array:_(r.Array),Object:_(r.Object)},t=typeof Buffer!="undefined";function s(q,N){if(typeof N=="undefined")q.write(n.Undefined);else if(typeof N=="string"){const G=y.VSBuffer.fromString(N);q.write(n.String),q.write(g(G.byteLength)),q.write(G)}else if(t&&Buffer.isBuffer(N)){const G=y.VSBuffer.wrap(N);q.write(n.Buffer),q.write(g(G.byteLength)),q.write(G)}else if(N instanceof y.VSBuffer)q.write(n.VSBuffer),q.write(g(N.byteLength)),q.write(N);else if(Array.isArray(N)){q.write(n.Array),q.write(g(N.length));for(const G of N)s(q,G)}else{const G=y.VSBuffer.fromString(JSON.stringify(N));q.write(n.Object),q.write(g(G.byteLength)),q.write(G)}}function d(q){switch(q.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return q.read(o(q)).toString();case r.Buffer:return q.read(o(q)).buffer;case r.VSBuffer:return q.read(o(q));case r.Array:{const G=o(q),$=[];for(let H=0;H<G;H++)$.push(d(q));return $}case r.Object:return JSON.parse(q.read(o(q)).toString())}}class c{constructor(N,G,$=null,H=1e3){this.protocol=N,this.ctx=G,this.logger=$,this.timeoutDelay=H,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(j=>this.onRawMessage(j)),this.sendResponse({type:200})}registerChannel(N,G){this.channels.set(N,G),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const G=this.send([N.type]);this.logger&&this.logger.logOutgoing(G,0,1,v(N.type));return}case 201:case 202:case 204:case 203:{const G=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(G,N.id,1,v(N.type),N.data);return}}}send(N,G=void 0){const $=new a;return s($,N),s($,G),this.sendBuffer($.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(G){return 0}}onRawMessage(N){const G=new w(N),$=d(G),H=d(G),j=$[0];switch(j){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],1,`${h(j)}: ${$[2]}.${$[3]}`,H),this.onPromise({type:j,id:$[1],channelName:$[2],name:$[3],arg:H});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],1,`${h(j)}: ${$[2]}.${$[3]}`,H),this.onEventListen({type:j,id:$[1],channelName:$[2],name:$[3],arg:H});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],1,`${h(j)}`),this.disposeActiveRequest({type:j,id:$[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],1,`${h(j)}`),this.disposeActiveRequest({type:j,id:$[1]})}}onPromise(N){const G=this.channels.get(N.channelName);if(!G){this.collectPendingRequest(N);return}const $=new C.CancellationTokenSource;let H;try{H=G.call(this.ctx,N.name,N.arg,$.token)}catch(fe){H=Promise.reject(fe)}const j=N.id;H.then(fe=>{this.sendResponse({id:j,data:fe,type:201}),this.activeRequests.delete(N.id)},fe=>{fe instanceof Error?this.sendResponse({id:j,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.sendResponse({id:j,data:fe,type:203}),this.activeRequests.delete(N.id)});const ie=(0,D.toDisposable)(()=>$.cancel());this.activeRequests.set(N.id,ie)}onEventListen(N){const G=this.channels.get(N.channelName);if(!G){this.collectPendingRequest(N);return}const $=N.id,j=G.listen(this.ctx,N.name,N.arg)(ie=>this.sendResponse({id:$,data:ie,type:204}));this.activeRequests.set(N.id,j)}disposeActiveRequest(N){const G=this.activeRequests.get(N.id);G&&(G.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let G=this.pendingRequests.get(N.channelName);G||(G=[],this.pendingRequests.set(N.channelName,G));const $=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);G.push({request:N,timeoutTimer:$})}flushPendingRequests(N){const G=this.pendingRequests.get(N);if(G){for(const $ of G)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var f;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class l{constructor(N,G=null){this.protocol=N,this.isDisposed=!1,this.state=I.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=G}getChannel(N){const G=this;return{call($,H,j){return G.isDisposed?Promise.reject(k.canceled()):G.requestPromise(N,$,H,j)},listen($,H){return G.isDisposed?Promise.reject(k.canceled()):G.requestEvent(N,$,H)}}}requestPromise(N,G,$,H=C.CancellationToken.None){const j=this.lastRequestId++,fe={id:j,type:100,channelName:N,name:G,arg:$};if(H.isCancellationRequested)return Promise.reject(k.canceled());let ye;return new Promise((Be,We)=>{if(H.isCancellationRequested)return We(k.canceled());const ze=()=>{const he=Z=>{switch(Z.type){case 201:this.handlers.delete(j),Be(Z.data);break;case 202:this.handlers.delete(j);const oe=new Error(Z.data.message);oe.stack=Z.data.stack,oe.name=Z.data.name,We(oe);break;case 203:this.handlers.delete(j),We(Z.data);break}};this.handlers.set(j,he),this.sendRequest(fe)};let Q=null;this.state===I.Idle?ze():(Q=(0,F.createCancelablePromise)(he=>this.whenInitialized()),Q.then(()=>{Q=null,ze()}));const ee=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:j,type:101}),We(k.canceled())},re=H.onCancellationRequested(ee);ye=(0,D.combinedDisposable)((0,D.toDisposable)(ee),re),this.activeRequests.add(ye)}).finally(()=>{this.activeRequests.delete(ye)})}requestEvent(N,G,$){const H=this.lastRequestId++,ie={id:H,type:102,channelName:N,name:G,arg:$};let fe=null;const ye=new S.Emitter({onFirstListenerAdd:()=>{fe=(0,F.createCancelablePromise)(Be=>this.whenInitialized()),fe.then(()=>{fe=null,this.activeRequests.add(ye),this.sendRequest(ie)})},onLastListenerRemove:()=>{fe?(fe.cancel(),fe=null):(this.activeRequests.delete(ye),this.sendRequest({id:H,type:103}))}}),Ie=Be=>ye.fire(Be.data);return this.handlers.set(H,Ie),ye.event}sendRequest(N){switch(N.type){case 100:case 102:{const G=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(G,N.id,0,`${h(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const G=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(G,N.id,0,h(N.type));return}}}send(N,G=void 0){const $=new a;return s($,N),s($,G),this.sendBuffer($.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(G){return 0}}onBuffer(N){const G=new w(N),$=d(G),H=d(G),j=$[0];switch(j){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,v(j)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,$[1],0,v(j),H),this.onResponse({type:$[0],id:$[1],data:H})}}onResponse(N){if(N.type===200){this.state=I.Idle,this._onDidInitialize.fire();return}const G=this.handlers.get(N.id);G&&G(N)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===I.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}je([i.memoize],l.prototype,"onDidInitializePromise",null),e.ChannelClient=l;class b{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:G,onDidClientDisconnect:$})=>{S.Event.once(G.onMessage)(j=>{const ie=new w(j),fe=d(ie),ye=new c(G,fe),Ie=new l(G);this.channels.forEach((We,ze)=>ye.registerChannel(ze,We));const Be={channelServer:ye,channelClient:Ie,ctx:fe};this._connections.add(Be),this._onDidAddConnection.fire(Be),$(()=>{ye.dispose(),Ie.dispose(),this._connections.delete(Be),this._onDidRemoveConnection.fire(Be)})})})}get connections(){const N=[];return this._connections.forEach(G=>N.push(G)),N}getChannel(N,G){const $=this;return{call(H,j,ie){let fe;if((0,u.isFunction)(G)){let Ie=(0,m.getRandomElement)($.connections.filter(G));fe=Ie?Promise.resolve(Ie):S.Event.toPromise(S.Event.filter($.onDidAddConnection,G))}else fe=G.routeCall($,H,j);const ye=fe.then(Ie=>Ie.channelClient.getChannel(N));return A(ye).call(H,j,ie)},listen(H,j){if((0,u.isFunction)(G))return $.getMulticastEvent(N,G,H,j);const ie=G.routeEvent($,H,j).then(fe=>fe.channelClient.getChannel(N));return A(ie).listen(H,j)}}}getMulticastEvent(N,G,$,H){const j=this;let ie=new D.DisposableStore;const fe=new S.Emitter({onFirstListenerAdd:()=>{ie=new D.DisposableStore;const ye=new S.EventMultiplexer,Ie=new Map,Be=ze=>{const ee=ze.channelClient.getChannel(N).listen($,H),re=ye.add(ee);Ie.set(ze,re)},We=ze=>{const Q=Ie.get(ze);!Q||(Q.dispose(),Ie.delete(ze))};j.connections.filter(G).forEach(Be),S.Event.filter(j.onDidAddConnection,G)(Be,void 0,ie),j.onDidRemoveConnection(We,void 0,ie),ye.event(fe.fire,fe,ie),ie.add(ye)},onLastListenerRemove:()=>{ie.dispose()}});return fe.event}registerChannel(N,G){this.channels.set(N,G),this._connections.forEach($=>{$.channelServer.registerChannel(N,G)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=b;class T{constructor(N,G,$=null){const H=new a;s(H,G),N.send(H.buffer),this.channelClient=new l(N,$),this.channelServer=new c(N,G,$)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,G){this.channelServer.registerChannel(N,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function A(q){return{call(N,G,$){return q.then(H=>H.call(N,G,$))},listen(N,G){const $=new S.Relay;return q.then(H=>$.input=H.listen(N,G)),$.event}}}e.getDelayedChannel=A;function U(q){let N=!1;return{call(G,$,H){return N?q.call(G,$,H):(0,F.timeout)(0).then(()=>N=!0).then(()=>q.call(G,$,H))},listen(G,$){if(N)return q.listen(G,$);const H=new S.Relay;return(0,F.timeout)(0).then(()=>N=!0).then(()=>H.input=q.listen(G,$)),H.event}}}e.getNextTickChannel=U;class B{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const G of N.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await S.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=B;var L;(function(q){function N(j,ie){const fe=j,ye=ie&&ie.disableMarshalling,Ie=new Map;for(const Be in fe)$(Be)&&Ie.set(Be,S.Event.buffer(fe[Be],!0));return new class{listen(Be,We,ze){const Q=Ie.get(We);if(Q)return Q;if(H(We)){const ee=fe[We];if(typeof ee=="function")return ee.call(fe,ze)}throw new Error(`Event not found: ${We}`)}call(Be,We,ze){const Q=fe[We];if(typeof Q=="function"){if(!ye&&Array.isArray(ze))for(let ee=0;ee<ze.length;ee++)ze[ee]=(0,R.revive)(ze[ee]);return Q.apply(fe,ze)}throw new Error(`Method not found: ${We}`)}}}q.fromService=N;function G(j,ie){const fe=ie&&ie.disableMarshalling;return new Proxy({},{get(ye,Ie){if(typeof Ie=="string")return ie?.properties?.has(Ie)?ie.properties.get(Ie):H(Ie)?function(Be){return j.listen(Ie,Be)}:$(Ie)?j.listen(Ie):async function(...Be){let We;ie&&!(0,u.isUndefinedOrNull)(ie.context)?We=[ie.context,...Be]:We=Be;const ze=await j.call(Ie,We);return fe?ze:(0,R.revive)(ze)};throw new Error(`Property not found: ${String(Ie)}`)}})}q.toService=G;function $(j){return j[0]==="o"&&j[1]==="n"&&P.isUpperAsciiLetter(j.charCodeAt(2))}function H(j){return/^onDynamic/.test(j)&&P.isUpperAsciiLetter(j.charCodeAt(9))}})(L=e.ProxyChannel||(e.ProxyChannel={}));const x=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let N=q.toString();if(N!=="[object Object]")return N}return q}function V(q){return Array.isArray(q)?q.map(M):M(q)}function O(q,N,G,$,H,j,ie){ie=V(ie);const fe=x[H],ye=fe[$%fe.length];let Ie=[`%c[${q}]%c[${String(N).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String($).padStart(5," ")} - ${j}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(j)?(Ie=Ie.concat(ie),Ie.push(")")):Ie.push(ie),console.log.apply(console,Ie)}e.logWithColors=O;class W{constructor(N,G){this._outgoingPrefix=N,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,G,$,H,j){this._totalOutgoing+=N,O(this._outgoingPrefix,this._totalOutgoing,N,G,$,H,j)}logIncoming(N,G,$,H,j){this._totalIncoming+=N,O(this._incomingPrefix,this._totalIncoming,N,G,$,H,j)}}e.IPCLogger=W}),define(pe[106],ve([0,1,22,3,6,105]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var i;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(i=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let d=0;function c(l,b){if(!s.has(l)){const T=String(++d);s.set(l,T)}return s.get(l)}function f(l,b,T,A){if(!t.enableDiagnostics)return;const U=c(l,b);if(A instanceof m.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const B=m.VSBuffer.alloc(A.byteLength);B.set(A),t.records.push({timestamp:Date.now(),id:U,label:b,type:T,buff:B})}else t.records.push({timestamp:Date.now(),id:U,label:b,type:T,data:A})}t.traceSocketEvent=f})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let D=null;function R(){return D||(D=m.VSBuffer.alloc(0)),D}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,d){if(s===0)return R();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const b=this._chunks[0];return d&&(this._chunks.shift(),this._totalLength-=s),b}if(this._chunks[0].byteLength>s){const b=this._chunks[0].slice(0,s);return d&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),b}let c=m.VSBuffer.alloc(s),f=0,l=0;for(;s>0;){const b=this._chunks[l];if(b.byteLength>s){const T=b.slice(0,s);c.set(T,f),f+=s,d&&(this._chunks[l]=b.slice(s),this._totalLength-=s),s-=s}else c.set(b,f),f+=b.byteLength,d?(this._chunks.shift(),this._totalLength-=b.byteLength):l++,s-=b.byteLength}return c}}e.ChunkStream=P;var u;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(u||(u={}));function E(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var h;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(s,d,c,f){this.type=s,this.id=d,this.ack=c,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends y.Disposable{constructor(s){super();this._onMessage=this._register(new F.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const d=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=d.readUInt32BE(9),this._state.messageType=d.readUInt8(0),this._state.id=d.readUInt32BE(1),this._state.ack=d.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:E(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,f=this._state.id,l=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",d),this._onMessage.fire(new p(c,f,l,d)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class I{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=m.VSBuffer.alloc(13);d.writeUInt8(s.type,0),d.writeUInt32BE(s.id,1),d.writeUInt32BE(s.ack,5),d.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:E(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(d,s.data)}_bufferAdd(s,d){const c=this._totalLength===0;return this._data.push(s,d),this._totalLength+=s.byteLength+d.byteLength,c}_bufferTake(){const s=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,d){this._bufferAdd(s,d)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class w extends y.Disposable{constructor(s){super();this._onMessage=new F.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new I(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(d=>{d.type===1&&this._onMessage.fire(d.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new p(1,0,0,s))}}e.Protocol=w;class a extends C.IPCClient{constructor(s,d,c=null){super(s,d,c);this.protocol=s}static fromSocket(s,d){return new a(new w(s),d)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=a;class r{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new F.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=r;class g{constructor(s){this.data=s,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],d=0,c=this._first;for(;c;)s[d++]=c.data,c=c.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const d=new g(s);if(!this._first){this._first=d,this._last=d;return}this._last.next=d,this._last=d}}class _{constructor(){this.lastRuns=[];const s=Date.now();for(let d=0;d<_._HISTORY_LENGTH;d++)this.lastRuns[d]=s-1e3*d;setInterval(()=>{for(let d=_._HISTORY_LENGTH;d>=1;d--)this.lastRuns[d]=this.lastRuns[d-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return _._INSTANCE||(_._INSTANCE=new _),_._INSTANCE}load(){const s=Date.now(),d=(1+_._HISTORY_LENGTH)*1e3;let c=0;for(let f=0;f<_._HISTORY_LENGTH;f++)s-this.lastRuns[f]<=d&&c++;return 1-c/_._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}_._HISTORY_LENGTH=10,_._INSTANCE=null;class n{constructor(s,d=null,c=_.getInstance()){this._onControlMessage=new r,this.onControlMessage=this._onControlMessage.event,this._onMessage=new r,this.onMessage=this._onMessage.event,this._onDidDispose=new r,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new r,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new r,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),d&&this._socketReader.acceptChunk(d)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,y.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new p(5,0,0,R());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new p(7,0,0,R());this._socketWriter.write(s)}sendResume(){const s=new p(8,0,0,R());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,d){this._isReconnecting=!0,this._socketDisposables=(0,y.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(d)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new p(3,0,this._incomingAckId,R());this._socketWriter.write(s);const d=this._outgoingUnackMsg.toArray();for(let c=0,f=d.length;c<f;c++)this._socketWriter.write(d[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const d=this._outgoingUnackMsg.peek();if(d&&d.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const d=Date.now();d-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=d,this._socketWriter.write(new p(6,0,0,R())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const d=this._outgoingUnackMsg.toArray();for(let c=0,f=d.length;c<f;c++)this._socketWriter.write(d[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const d=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new p(1,d,this._incomingAckId,s);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(s){const d=new p(2,0,0,s);this._socketWriter.write(d)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),d=Date.now()-s.writtenTime,c=Date.now()-this._socketReader.lastReadTime,f=Date.now()-this._lastSocketTimeoutTime;if(d>=2e4&&c>=2e4&&f>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const l=Math.max(2e4-d,2e4-c,2e4-f,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},l)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new p(3,0,this._incomingAckId,R());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(pe[107],ve([0,1,98]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class F{constructor(k){let S=(0,m.toUint8)(k);this._defaultValue=S,this._asciiMap=F._createAsciiMap(S),this._map=new Map}static _createAsciiMap(k){let S=new Uint8Array(256);for(let D=0;D<256;D++)S[D]=k;return S}set(k,S){let D=(0,m.toUint8)(S);k>=0&&k<256?this._asciiMap[k]=D:this._map.set(k,D)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=F;var y;(function(i){i[i.False=0]="False",i[i.True=1]="True"})(y||(y={}));class C{constructor(){this._actual=new F(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=C}),define(pe[143],ve([0,1,107]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(i){i[i.Regular=0]="Regular",i[i.Whitespace=1]="Whitespace",i[i.WordSeparator=2]="WordSeparator"})(F=e.WordCharacterClass||(e.WordCharacterClass={}));class y extends m.CharacterClassifier{constructor(k){super(0);for(let S=0,D=k.length;S<D;S++)this.set(k.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=y;function C(i){let k={};return S=>(k.hasOwnProperty(S)||(k[S]=i(S)),k[S])}e.getMapForWordSeparators=C(i=>new y(i))}),define(pe[49],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(y,C){this.lineNumber=y,this.column=C}with(y=this.lineNumber,C=this.column){return y===this.lineNumber&&C===this.column?this:new m(y,C)}delta(y=0,C=0){return this.with(this.lineNumber+y,this.column+C)}equals(y){return m.equals(this,y)}static equals(y,C){return!y&&!C?!0:!!y&&!!C&&y.lineNumber===C.lineNumber&&y.column===C.column}isBefore(y){return m.isBefore(this,y)}static isBefore(y,C){return y.lineNumber<C.lineNumber?!0:C.lineNumber<y.lineNumber?!1:y.column<C.column}isBeforeOrEqual(y){return m.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,C){return y.lineNumber<C.lineNumber?!0:C.lineNumber<y.lineNumber?!1:y.column<=C.column}static compare(y,C){let i=y.lineNumber|0,k=C.lineNumber|0;if(i===k){let S=y.column|0,D=C.column|0;return S-D}return i-k}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new m(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}}e.Position=m}),define(pe[41],ve([0,1,49]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class F{constructor(C,i,k,S){C>k||C===k&&i>S?(this.startLineNumber=k,this.startColumn=S,this.endLineNumber=C,this.endColumn=i):(this.startLineNumber=C,this.startColumn=i,this.endLineNumber=k,this.endColumn=S)}isEmpty(){return F.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return F.containsPosition(this,C)}static containsPosition(C,i){return!(i.lineNumber<C.startLineNumber||i.lineNumber>C.endLineNumber||i.lineNumber===C.startLineNumber&&i.column<C.startColumn||i.lineNumber===C.endLineNumber&&i.column>C.endColumn)}static strictContainsPosition(C,i){return!(i.lineNumber<C.startLineNumber||i.lineNumber>C.endLineNumber||i.lineNumber===C.startLineNumber&&i.column<=C.startColumn||i.lineNumber===C.endLineNumber&&i.column>=C.endColumn)}containsRange(C){return F.containsRange(this,C)}static containsRange(C,i){return!(i.startLineNumber<C.startLineNumber||i.endLineNumber<C.startLineNumber||i.startLineNumber>C.endLineNumber||i.endLineNumber>C.endLineNumber||i.startLineNumber===C.startLineNumber&&i.startColumn<C.startColumn||i.endLineNumber===C.endLineNumber&&i.endColumn>C.endColumn)}strictContainsRange(C){return F.strictContainsRange(this,C)}static strictContainsRange(C,i){return!(i.startLineNumber<C.startLineNumber||i.endLineNumber<C.startLineNumber||i.startLineNumber>C.endLineNumber||i.endLineNumber>C.endLineNumber||i.startLineNumber===C.startLineNumber&&i.startColumn<=C.startColumn||i.endLineNumber===C.endLineNumber&&i.endColumn>=C.endColumn)}plusRange(C){return F.plusRange(this,C)}static plusRange(C,i){let k,S,D,R;return i.startLineNumber<C.startLineNumber?(k=i.startLineNumber,S=i.startColumn):i.startLineNumber===C.startLineNumber?(k=i.startLineNumber,S=Math.min(i.startColumn,C.startColumn)):(k=C.startLineNumber,S=C.startColumn),i.endLineNumber>C.endLineNumber?(D=i.endLineNumber,R=i.endColumn):i.endLineNumber===C.endLineNumber?(D=i.endLineNumber,R=Math.max(i.endColumn,C.endColumn)):(D=C.endLineNumber,R=C.endColumn),new F(k,S,D,R)}intersectRanges(C){return F.intersectRanges(this,C)}static intersectRanges(C,i){let k=C.startLineNumber,S=C.startColumn,D=C.endLineNumber,R=C.endColumn,P=i.startLineNumber,u=i.startColumn,E=i.endLineNumber,h=i.endColumn;return k<P?(k=P,S=u):k===P&&(S=Math.max(S,u)),D>E?(D=E,R=h):D===E&&(R=Math.min(R,h)),k>D||k===D&&S>R?null:new F(k,S,D,R)}equalsRange(C){return F.equalsRange(this,C)}static equalsRange(C,i){return!!C&&!!i&&C.startLineNumber===i.startLineNumber&&C.startColumn===i.startColumn&&C.endLineNumber===i.endLineNumber&&C.endColumn===i.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(C){return new m.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(C){return new m.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,i){return new F(this.startLineNumber,this.startColumn,C,i)}setStartPosition(C,i){return new F(C,i,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(C){return new F(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,i=C){return new F(C.lineNumber,C.column,i.lineNumber,i.column)}static lift(C){return C?new F(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,i){return!(C.endLineNumber<i.startLineNumber||C.endLineNumber===i.startLineNumber&&C.endColumn<i.startColumn||i.endLineNumber<C.startLineNumber||i.endLineNumber===C.startLineNumber&&i.endColumn<C.startColumn)}static areIntersecting(C,i){return!(C.endLineNumber<i.startLineNumber||C.endLineNumber===i.startLineNumber&&C.endColumn<=i.startColumn||i.endLineNumber<C.startLineNumber||i.endLineNumber===C.startLineNumber&&i.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,i){if(C&&i){const D=C.startLineNumber|0,R=i.startLineNumber|0;if(D===R){const P=C.startColumn|0,u=i.startColumn|0;if(P===u){const E=C.endLineNumber|0,h=i.endLineNumber|0;if(E===h){const p=C.endColumn|0,v=i.endColumn|0;return p-v}return E-h}return P-u}return D-R}return(C?1:0)-(i?1:0)}static compareRangesUsingEnds(C,i){return C.endLineNumber===i.endLineNumber?C.endColumn===i.endColumn?C.startLineNumber===i.startLineNumber?C.startColumn-i.startColumn:C.startLineNumber-i.startLineNumber:C.endColumn-i.endColumn:C.endLineNumber-i.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=F}),define(pe[144],ve([0,1,49,41]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var y;(function(i){i[i.LTR=0]="LTR",i[i.RTL=1]="RTL"})(y=e.SelectionDirection||(e.SelectionDirection={}));class C extends F.Range{constructor(k,S,D,R){super(k,S,D,R);this.selectionStartLineNumber=k,this.selectionStartColumn=S,this.positionLineNumber=D,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return C.selectionsEqual(this,k)}static selectionsEqual(k,S){return k.selectionStartLineNumber===S.selectionStartLineNumber&&k.selectionStartColumn===S.selectionStartColumn&&k.positionLineNumber===S.positionLineNumber&&k.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,S){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,k,S):new C(k,S,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new m.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,S){return this.getDirection()===0?new C(k,S,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,k,S)}static fromPositions(k,S=k){return new C(k.lineNumber,k.column,S.lineNumber,S.column)}static fromRange(k,S){return S===0?new C(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new C(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new C(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,S){if(k&&!S||!k&&S)return!1;if(!k&&!S)return!0;if(k.length!==S.length)return!1;for(let D=0,R=k.length;D<R;D++)if(!this.selectionsEqual(k[D],S[D]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,S,D,R,P){return P===0?new C(k,S,D,R):new C(D,R,k,S)}}e.Selection=C}),define(pe[108],ve([0,1,25]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var F;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(F=e.OverviewRulerLane||(e.OverviewRulerLane={}));var y;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(y=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var i;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(i=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace),this.bracketPairColorizationOptions=v.bracketPairColorizationOptions}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,v.bracketPairColorizationOptions)}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class D{constructor(v,I){this._findMatchBrand=void 0,this.range=v,this.matches=I}}e.FindMatch=D;var R;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(R=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var P;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None"})(P=e.PositionAffinity||(e.PositionAffinity={}));var u;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u=e.ModelConstants||(e.ModelConstants={}));class E{constructor(v,I,w,a,r,g){this.identifier=v,this.range=I,this.text=w,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=r,this._isTracked=g}}e.ValidAnnotatedEditOperation=E;class h{constructor(v,I,w){this.reverseEdits=v,this.changes=I,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=h}),define(pe[145],ve([0,1,8,143,49,41,108]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class S{constructor(a,r,g,o){this.searchString=a,this.isRegex=r,this.matchCase=g,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=D(this.searchString):a=this.searchString.indexOf(`
`)>=0;let r=null;try{r=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(o){return null}if(!r)return null;let g=!this.isRegex&&!a;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new R(r,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=S;function D(w){if(!w||w.length===0)return!1;for(let a=0,r=w.length;a<r;a++)if(w.charCodeAt(a)===92){if(a++,a>=r)break;const o=w.charCodeAt(a);if(o===110||o===114||o===87)return!0}return!1}e.isMultilineRegexSource=D;class R{constructor(a,r,g){this.regex=a,this.wordSeparators=r,this.simpleSearch=g}}e.SearchData=R;function P(w,a,r){if(!r)return new i.FindMatch(w,null);let g=[];for(let o=0,_=a.length;o<_;o++)g[o]=a[o];return new i.FindMatch(w,g)}e.createFindMatch=P;class u{constructor(a){let r=[],g=0;for(let o=0,_=a.length;o<_;o++)a.charCodeAt(o)===10&&(r[g++]=o);this._lineFeedsOffsets=r}findLineFeedCountBeforeOffset(a){const r=this._lineFeedsOffsets;let g=0,o=r.length-1;if(o===-1||a<=r[0])return 0;for(;g<o;){const _=g+((o-g)/2>>0);r[_]>=a?o=_-1:r[_+1]>=a?(g=_,o=_):g=_+1}return g+1}}class E{static findMatches(a,r,g,o,_){const n=r.parseSearchRequest();return n?n.regex.multiline?this._doFindMatchesMultiline(a,g,new I(n.wordSeparators,n.regex),o,_):this._doFindMatchesLineByLine(a,g,n,o,_):[]}static _getMultilineMatchRange(a,r,g,o,_,n){let t,s=0;o?(s=o.findLineFeedCountBeforeOffset(_),t=r+_+s):t=r+_;let d;if(o){let b=o.findLineFeedCountBeforeOffset(_+n.length)-s;d=t+n.length+b}else d=t+n.length;const c=a.getPositionAt(t),f=a.getPositionAt(d);return new C.Range(c.lineNumber,c.column,f.lineNumber,f.column)}static _doFindMatchesMultiline(a,r,g,o,_){const n=a.getOffsetAt(r.getStartPosition()),t=a.getValueInRange(r,1),s=a.getEOL()===`\r
`?new u(t):null,d=[];let c=0,f;for(g.reset(0);f=g.next(t);)if(d[c++]=P(this._getMultilineMatchRange(a,n,t,s,f.index,f[0]),f,o),c>=_)return d;return d}static _doFindMatchesLineByLine(a,r,g,o,_){const n=[];let t=0;if(r.startLineNumber===r.endLineNumber){const d=a.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return t=this._findMatchesInLine(g,d,r.startLineNumber,r.startColumn-1,t,n,o,_),n}const s=a.getLineContent(r.startLineNumber).substring(r.startColumn-1);t=this._findMatchesInLine(g,s,r.startLineNumber,r.startColumn-1,t,n,o,_);for(let d=r.startLineNumber+1;d<r.endLineNumber&&t<_;d++)t=this._findMatchesInLine(g,a.getLineContent(d),d,0,t,n,o,_);if(t<_){const d=a.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);t=this._findMatchesInLine(g,d,r.endLineNumber,0,t,n,o,_)}return n}static _findMatchesInLine(a,r,g,o,_,n,t,s){const d=a.wordSeparators;if(!t&&a.simpleSearch){const l=a.simpleSearch,b=l.length,T=r.length;let A=-b;for(;(A=r.indexOf(l,A+b))!==-1;)if((!d||v(d,r,T,A,b))&&(n[_++]=new i.FindMatch(new C.Range(g,A+1+o,g,A+1+b+o),null),_>=s))return _;return _}const c=new I(a.wordSeparators,a.regex);let f;c.reset(0);do if(f=c.next(r),f&&(n[_++]=P(new C.Range(g,f.index+1+o,g,f.index+1+f[0].length+o),f,t),_>=s))return _;while(f);return _}static findNextMatch(a,r,g,o){const _=r.parseSearchRequest();if(!_)return null;const n=new I(_.wordSeparators,_.regex);return _.regex.multiline?this._doFindNextMatchMultiline(a,g,n,o):this._doFindNextMatchLineByLine(a,g,n,o)}static _doFindNextMatchMultiline(a,r,g,o){const _=new y.Position(r.lineNumber,1),n=a.getOffsetAt(_),t=a.getLineCount(),s=a.getValueInRange(new C.Range(_.lineNumber,_.column,t,a.getLineMaxColumn(t)),1),d=a.getEOL()===`\r
`?new u(s):null;g.reset(r.column-1);let c=g.next(s);return c?P(this._getMultilineMatchRange(a,n,s,d,c.index,c[0]),c,o):r.lineNumber!==1||r.column!==1?this._doFindNextMatchMultiline(a,new y.Position(1,1),g,o):null}static _doFindNextMatchLineByLine(a,r,g,o){const _=a.getLineCount(),n=r.lineNumber,t=a.getLineContent(n),s=this._findFirstMatchInLine(g,t,n,r.column,o);if(s)return s;for(let d=1;d<=_;d++){const c=(n+d-1)%_,f=a.getLineContent(c+1),l=this._findFirstMatchInLine(g,f,c+1,1,o);if(l)return l}return null}static _findFirstMatchInLine(a,r,g,o,_){a.reset(o-1);const n=a.next(r);return n?P(new C.Range(g,n.index+1,g,n.index+1+n[0].length),n,_):null}static findPreviousMatch(a,r,g,o){const _=r.parseSearchRequest();if(!_)return null;const n=new I(_.wordSeparators,_.regex);return _.regex.multiline?this._doFindPreviousMatchMultiline(a,g,n,o):this._doFindPreviousMatchLineByLine(a,g,n,o)}static _doFindPreviousMatchMultiline(a,r,g,o){const _=this._doFindMatchesMultiline(a,new C.Range(1,1,r.lineNumber,r.column),g,o,10*k);if(_.length>0)return _[_.length-1];const n=a.getLineCount();return r.lineNumber!==n||r.column!==a.getLineMaxColumn(n)?this._doFindPreviousMatchMultiline(a,new y.Position(n,a.getLineMaxColumn(n)),g,o):null}static _doFindPreviousMatchLineByLine(a,r,g,o){const _=a.getLineCount(),n=r.lineNumber,t=a.getLineContent(n).substring(0,r.column-1),s=this._findLastMatchInLine(g,t,n,o);if(s)return s;for(let d=1;d<=_;d++){const c=(_+n-d-1)%_,f=a.getLineContent(c+1),l=this._findLastMatchInLine(g,f,c+1,o);if(l)return l}return null}static _findLastMatchInLine(a,r,g,o){let _=null,n;for(a.reset(0);n=a.next(r);)_=P(new C.Range(g,n.index+1,g,n.index+1+n[0].length),n,o);return _}}e.TextModelSearch=E;function h(w,a,r,g,o){if(g===0)return!0;const _=a.charCodeAt(g-1);if(w.get(_)!==0||_===13||_===10)return!0;if(o>0){const n=a.charCodeAt(g);if(w.get(n)!==0)return!0}return!1}function p(w,a,r,g,o){if(g+o===r)return!0;const _=a.charCodeAt(g+o);if(w.get(_)!==0||_===13||_===10)return!0;if(o>0){const n=a.charCodeAt(g+o-1);if(w.get(n)!==0)return!0}return!1}function v(w,a,r,g,o){return h(w,a,r,g,o)&&p(w,a,r,g,o)}e.isValidMatch=v;class I{constructor(a,r){this._wordSeparators=a,this._searchRegex=r,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const r=a.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===r||(g=this._searchRegex.exec(a),!g))return null;const o=g.index,_=g[0].length;if(o===this._prevMatchStartIndex&&_===this._prevMatchLength){if(_===0){m.getNextCodePoint(a,r,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=o,this._prevMatchLength=_,!this._wordSeparators||v(this._wordSeparators,a,r,o,_))return g}while(g);return null}}e.Searcher=I}),define(pe[109],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(k=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const D of e.USUAL_WORD_SEPARATORS)k.indexOf(D)>=0||(S+="\\"+D);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=m();function F(k){let S=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)S=k;else{let D="g";k.ignoreCase&&(D+="i"),k.multiline&&(D+="m"),k.unicode&&(D+="u"),S=new RegExp(k.source,D)}return S.lastIndex=0,S}e.ensureValidWordDefinition=F;const y={maxLen:1e3,windowSize:15,timeBudget:150};function C(k,S,D,R,P=y){if(D.length>P.maxLen){let v=k-P.maxLen/2;return v<0?v=0:R+=v,D=D.substring(v,k+P.maxLen/2),C(k,S,D,R,P)}const u=Date.now(),E=k-1-R;let h=-1,p=null;for(let v=1;!(Date.now()-u>=P.timeBudget);v++){const I=E-P.windowSize*v;S.lastIndex=Math.max(0,I);const w=i(S,D,E,h);if(!w&&p||(p=w,I<=0))break;h=I}if(p){let v={word:p[0],startColumn:R+1+p.index,endColumn:R+1+p.index+p[0].length};return S.lastIndex=0,v}return null}e.getWordAtText=C;function i(k,S,D,R){let P;for(;P=k.exec(S);){const u=P.index||0;if(u<=D&&k.lastIndex>=D)return P;if(R>0&&u>R)return null}return null}}),define(pe[146],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(i){i[i.None=0]="None",i[i.Indent=1]="Indent",i[i.IndentOutdent=2]="IndentOutdent",i[i.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class F{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let S=0,D=k.notIn.length;S<D;S++)switch(k.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}shouldAutoClose(k,S){if(k.getTokenCount()===0)return!0;const D=k.findTokenIndexAtOffset(S-2),R=k.getStandardTokenType(D);return this.isOK(R)}_findNeutralCharacterInRange(k,S){for(let D=k;D<=S;D++){const R=String.fromCharCode(D);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=F;class y{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of k)C(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),C(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),C(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),C(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&C(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=y;function C(i,k,S){i.has(k)?i.get(k).push(S):i.set(k,[S])}}),define(pe[82],ve([0,1,31,9]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(C,i,k,S){if(Array.isArray(C)){let D=0;for(const R of C){const P=y(R,i,k,S);if(P===10)return P;P>D&&(D=P)}return D}else{if(typeof C=="string")return S?C==="*"?5:C===k?10:0:0;if(C){const{language:D,pattern:R,scheme:P,hasAccessToAllModels:u}=C;if(!S&&!u)return 0;let E=0;if(P)if(P===i.scheme)E=10;else if(P==="*")E=5;else return 0;if(D)if(D===k)E=10;else if(D==="*")E=Math.max(E,5);else return 0;if(R){let h;if(typeof R=="string"?h=R:h={...R,base:(0,F.normalize)(R.base)},h===i.fsPath||(0,m.match)(h,i.fsPath))E=10;else return 0}return E}else return 0}}e.score=y}),define(pe[147],ve([0,1,107]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var F;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(F=e.State||(e.State={}));class y{constructor(h,p,v){const I=new Uint8Array(h*p);for(let w=0,a=h*p;w<a;w++)I[w]=v;this._data=I,this.rows=h,this.cols=p}get(h,p){return this._data[h*this.cols+p]}set(h,p,v){this._data[h*this.cols+p]=v}}e.Uint8Matrix=y;class C{constructor(h){let p=0,v=0;for(let w=0,a=h.length;w<a;w++){let[r,g,o]=h[w];g>p&&(p=g),r>v&&(v=r),o>v&&(v=o)}p++,v++;let I=new y(v,p,0);for(let w=0,a=h.length;w<a;w++){let[r,g,o]=h[w];I.set(r,g,o)}this._states=I,this._maxCharCode=p}nextState(h,p){return p<0||p>=this._maxCharCode?0:this._states.get(h,p)}}e.StateMachine=C;let i=null;function k(){return i===null&&(i=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),i}var S;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let D=null;function R(){if(D===null){D=new m.CharacterClassifier(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<E.length;p++)D.set(E.charCodeAt(p),1);const h=".,;";for(let p=0;p<h.length;p++)D.set(h.charCodeAt(p),2)}return D}class P{static _createLink(h,p,v,I,w){let a=w-1;do{const r=p.charCodeAt(a);if(h.get(r)!==2)break;a--}while(a>I);if(I>0){const r=p.charCodeAt(I-1),g=p.charCodeAt(a);(r===40&&g===41||r===91&&g===93||r===123&&g===125)&&a--}return{range:{startLineNumber:v,startColumn:I+1,endLineNumber:v,endColumn:a+2},url:p.substring(I,a+1)}}static computeLinks(h,p=k()){const v=R();let I=[];for(let w=1,a=h.getLineCount();w<=a;w++){const r=h.getLineContent(w),g=r.length;let o=0,_=0,n=0,t=1,s=!1,d=!1,c=!1,f=!1;for(;o<g;){let l=!1;const b=r.charCodeAt(o);if(t===13){let T;switch(b){case 40:s=!0,T=0;break;case 41:T=s?0:1;break;case 91:c=!0,d=!0,T=0;break;case 93:c=!1,T=d?0:1;break;case 123:f=!0,T=0;break;case 125:T=f?0:1;break;case 39:T=n===34||n===96?0:1;break;case 34:T=n===39||n===96?0:1;break;case 96:T=n===39||n===34?0:1;break;case 42:T=n===42?1:0;break;case 124:T=n===124?1:0;break;case 32:T=c?0:1;break;default:T=v.get(b)}T===1&&(I.push(P._createLink(v,r,w,_,o)),l=!0)}else if(t===12){let T;b===91?(d=!0,T=0):T=v.get(b),T===1?l=!0:t=13}else t=p.nextState(t,b),t===0&&(l=!0);l&&(t=1,s=!1,d=!1,f=!1,_=o+1,n=b),o++}t===13&&I.push(P._createLink(v,r,w,_,g))}return I}}e.LinkComputer=P;function u(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:P.computeLinks(E)}e.computeLinks=u}),define(pe[148],ve([0,1,3,6]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class y{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(i){this._onDidChange.fire({changedLanguages:i,changedColorMap:!1})}register(i,k){return this._map.set(i,k),this.fire([i]),(0,F.toDisposable)(()=>{this._map.get(i)===k&&(this._map.delete(i),this.fire([i]))})}registerPromise(i,k){let S=null,D=!1;return this._promises.set(i,k.then(R=>{this._promises.delete(i),!(D||!R)&&(S=this.register(i,R))})),(0,F.toDisposable)(()=>{D=!0,S&&S.dispose()})}getPromise(i){const k=this.get(i);if(k)return Promise.resolve(k);const S=this._promises.get(i);return S?S.then(D=>this.get(i)):null}get(i){return this._map.get(i)||null}setColorMap(i){this._colorMap=i,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=y}),define(pe[110],ve([0,1,22,12]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(y||(y={}));function C(P){for(let u=0,E=P.length;u<E;u+=4){const h=P[u+0],p=P[u+1],v=P[u+2],I=P[u+3];P[u+0]=I,P[u+1]=v,P[u+2]=p,P[u+3]=h}}function i(P){const u=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return F.isLittleEndian()||C(u),m.VSBuffer.wrap(u)}function k(P){const u=P.buffer;if(F.isLittleEndian()||C(u),u.byteOffset%4==0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const E=new Uint8Array(u.byteLength);return E.set(u),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function S(P){const u=new Uint32Array(D(P));let E=0;if(u[E++]=P.id,P.type==="full")u[E++]=1,u[E++]=P.data.length,u.set(P.data,E),E+=P.data.length;else{u[E++]=2,u[E++]=P.deltas.length;for(const h of P.deltas)u[E++]=h.start,u[E++]=h.deleteCount,h.data?(u[E++]=h.data.length,u.set(h.data,E),E+=h.data.length):u[E++]=0}return i(u)}e.encodeSemanticTokensDto=S;function D(P){let u=0;if(u+=1+1,P.type==="full")u+=1+P.data.length;else{u+=1,u+=(1+1+1)*P.deltas.length;for(const E of P.deltas)E.data&&(u+=E.data.length)}return u}function R(P){const u=k(P);let E=0;const h=u[E++];if(u[E++]===1){const w=u[E++],a=u.subarray(E,E+w);return E+=w,{id:h,type:"full",data:a}}const v=u[E++];let I=[];for(let w=0;w<v;w++){const a=u[E++],r=u[E++],g=u[E++];let o;g>0&&(o=u.subarray(E,E+g),E+=g),I[w]={start:a,deleteCount:r,data:o}}return{id:h,type:"delta",deltas:I}}e.decodeSemanticTokensDto=R}),define(pe[111],ve([0,1,16,98]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class y{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,D){S=(0,F.toUint32)(S);const R=this.values,P=this.prefixSum,u=D.length;return u===0?!1:(this.values=new Uint32Array(R.length+u),this.values.set(R.subarray(0,S),0),this.values.set(R.subarray(S),S+u),this.values.set(D,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,D){return S=(0,F.toUint32)(S),D=(0,F.toUint32)(D),this.values[S]===D?!1:(this.values[S]=D,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,D){S=(0,F.toUint32)(S),D=(0,F.toUint32)(D);const R=this.values,P=this.prefixSum;if(S>=R.length)return!1;let u=R.length-S;return D>=u&&(D=u),D===0?!1:(this.values=new Uint32Array(R.length-D),this.values.set(R.subarray(0,S),0),this.values.set(R.subarray(S+D),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,F.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),S>=this.values.length&&(S=this.values.length-1);for(let R=D;R<=S;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let D=0,R=this.values.length-1,P=0,u=0,E=0;for(;D<=R;)if(P=D+(R-D)/2|0,u=this.prefixSum[P],E=u-this.values[P],S<E)R=P-1;else if(S>=u)D=P+1;else break;return new i(P,S-E)}}e.PrefixSumComputer=y;class C{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const D=this._indexBySum[S],R=D>0?this._prefixSum[D-1]:0;return new i(D,S-R)}removeValues(S,D){this._values.splice(S,D),this._invalidate(S)}insertValues(S,D){this._values=(0,m.arrayInsert)(this._values,S,D),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,D=this._values.length;S<D;S++){const R=this._values[S],P=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=P+R;for(let u=0;u<R;u++)this._indexBySum[P+u]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,D){this._values[S]!==D&&(this._values[S]=D,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=C;class i{constructor(S,D){this.index=S,this.remainder=D,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=D}}e.PrefixSumIndexOfResult=i}),define(pe[149],ve([0,1,8,49,111]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(k,S,D,R){this._uri=k,this._lines=S,this._eol=D,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const S=k.changes;for(const D of S)this._acceptDeleteRange(D.range),this._acceptInsertText(new F.Position(D.range.startLineNumber,D.range.startColumn),D.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,S=this._lines.length,D=new Uint32Array(S);for(let R=0;R<S;R++)D[R]=this._lines[R].length+k;this._lineStarts=new y.PrefixSumComputer(D)}}_setLineText(k,S){this._lines[k]=S,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,S){if(S.length===0)return;let D=(0,m.splitLines)(S);if(D.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+D[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}D[D.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+D[0]);let R=new Uint32Array(D.length-1);for(let P=1;P<D.length;P++)this._lines.splice(k.lineNumber+P-1,0,D[P]),R[P-1]=D[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,R)}}e.MirrorTextModel=C}),define(pe[150],ve([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(pe[151],ve([0,1,150]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const F=60,y=F*60,C=y*24,i=C*7,k=C*30,S=C*365;function D(P,u){typeof P!="number"&&(P=P.getTime());const E=Math.round((new Date().getTime()-P)/1e3);if(E<-30)return(0,m.localize)(0,null,D(new Date().getTime()+E*1e3,!1));if(E<30)return(0,m.localize)(1,null);let h;return E<F?(h=E,u?h===1?(0,m.localize)(2,null,h):(0,m.localize)(3,null,h):h===1?(0,m.localize)(4,null,h):(0,m.localize)(5,null,h)):E<y?(h=Math.floor(E/F),u?h===1?(0,m.localize)(6,null,h):(0,m.localize)(7,null,h):h===1?(0,m.localize)(8,null,h):(0,m.localize)(9,null,h)):E<C?(h=Math.floor(E/y),u?h===1?(0,m.localize)(10,null,h):(0,m.localize)(11,null,h):h===1?(0,m.localize)(12,null,h):(0,m.localize)(13,null,h)):E<i?(h=Math.floor(E/C),u?h===1?(0,m.localize)(14,null,h):(0,m.localize)(15,null,h):h===1?(0,m.localize)(16,null,h):(0,m.localize)(17,null,h)):E<k?(h=Math.floor(E/i),u?h===1?(0,m.localize)(18,null,h):(0,m.localize)(19,null,h):h===1?(0,m.localize)(20,null,h):(0,m.localize)(21,null,h)):E<S?(h=Math.floor(E/k),u?h===1?(0,m.localize)(22,null,h):(0,m.localize)(23,null,h):h===1?(0,m.localize)(24,null,h):(0,m.localize)(25,null,h)):(h=Math.floor(E/S),u?h===1?(0,m.localize)(26,null,h):(0,m.localize)(27,null,h):h===1?(0,m.localize)(28,null,h):(0,m.localize)(29,null,h))}e.fromNow=D;function R(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(pe[152],ve([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(pe[50],ve([0,1,16,13,152]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(D,R){return R&&(D.stack||D.stacktrace)?y.localize(0,null,k(D),i(D.stack)||i(D.stacktrace)):k(D)}function i(D){return Array.isArray(D)?D.join(`
`):D}function k(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?y.localize(1,null,D.message):D.message||y.localize(2,null)}function S(D=null,R=!1){if(!D)return y.localize(3,null);if(Array.isArray(D)){const P=m.coalesce(D),u=S(P[0],R);return P.length>1?y.localize(4,null,u,P.length):u}if(F.isString(D))return D;if(D.detail){const P=D.detail;if(P.error)return C(P.error,R);if(P.exception)return C(P.exception,R)}return D.stack?C(D,R):D.message?D.message:y.localize(5,null)}e.toErrorMessage=S}),define(pe[153],ve([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(pe[112],ve([0,1,37,30,10,25,9,12,40,94,13,142,28,153]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function h(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(o,_){if(k.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};_&&(n.cwd=_);const t=m.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],n);return new Promise(s=>{t.once("error",d=>{s({success:!1,error:d})}),t.once("exit",(d,c)=>{s(d===0?{success:!0}:{success:!1,code:d!==null?d:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?h(n.status):1})}else if(k.isLinux||k.isMacintosh)try{const n=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{m.execFile(n,[o.pid.toString()],{encoding:"utf8",shell:!0},(s,d,c)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function v(o){!o||(delete o.DEBUG,k.isMacintosh&&delete o.DYLD_LIBRARY_PATH,k.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function I(o=S.env){return o.comspec||"cmd.exe"}e.getWindowsShell=I;class w{constructor(_,n,t,s){if(n!==void 0&&t!==void 0&&s!==void 0)this.cmd=_,this.args=n,this.shell=t,this.options=s;else{const d=_;this.cmd=d.command,this.shell=d.isShellCommand,this.args=d.args.slice(0),this.options=d.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const d=Object.create(null);Object.keys(S.env).forEach(c=>{d[c]=S.env[c]}),Object.keys(this.options.env).forEach(c=>{d[c]=this.options.env[c]}),this.options.env=d}}getSanitizedCommand(){let _=this.cmd.toLowerCase();const n=_.lastIndexOf(i.sep);return n!==-1&&(_=_.substring(n+1)),w.WellKnowCommands[_]?_:"other"}start(_){return k.isWindows&&(this.options&&this.options.cwd&&F.isUNC(this.options.cwd)||!this.options&&F.isUNC(S.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(n=>{let t,s;const d=new Promise((c,f)=>{t=c,s=f});if(n){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=m.exec(c,this.options,(f,l,b)=>{this.childProcess=null;const T=f;T&&T.killed?s({killed:this.terminateRequested,stdout:l.toString(),stderr:b.toString()}):this.handleExec(t,_,f,l,b)})}else{let c=null;const f=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,t,_,s);const b={terminated:this.terminateRequested};R.isNumber(l)&&(b.cmdCode=l),t(b)};if(this.shell&&k.isWindows){const l=C.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let b=!1,T=!1;const A=[];let U=this.ensureQuotes(this.cmd);A.push(U.value),b=U.quoted,this.args&&this.args.forEach(L=>{U=this.ensureQuotes(L),A.push(U.value),T=T&&U.quoted});const B=["/s","/c"];b?T?B.push('"'+A.join(" ")+'"'):A.length>1?B.push('"'+A[0]+'" '+A.slice(1).join(" ")):B.push('"'+A[0]+'"'):B.push(A.join(" ")),c=m.spawn(I(),B,l)}else this.cmd&&(c=m.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(R.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",l=>{this.childProcess=null,s({terminated:this.terminateRequested,error:l})}),c.pid&&(this.childProcess.on("close",f),this.handleSpawn(c,t,_,s,!0)))}return d})}handleClose(_,n,t,s){}ensureQuotes(_){return w.regexp.test(_)?{value:'"'+_+'"',quoted:!0}:{value:_,quoted:_.length>0&&_[0]==='"'&&_[_.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(_=>_.pid,_=>-1):new Promise(_=>{this.pidResolve=_})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(_=>(this.terminateRequested=!0,p(_,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),_=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(_=>{if(!this.shell||!k.isWindows)return _(!1);const n=m.spawn(I(),["/s","/c"]);n.on("error",t=>_(!0)),n.on("exit",t=>_(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class a extends w{constructor(_,n,t,s){super(_,n,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(_,n,t,s,d){[s,d].forEach((c,f)=>{const l=new P.LineDecoder;l.write(c).forEach(A=>{n({line:A,source:f===0?0:1})});const T=l.end();T&&n({line:T,source:f===0?0:1})}),_({terminated:this.terminateRequested,error:t})}handleSpawn(_,n,t,s,d){const c=new P.LineDecoder,f=new P.LineDecoder;_.stdout.on("data",l=>{c.write(l).forEach(T=>t({line:T,source:0}))}),_.stderr.on("data",l=>{f.write(l).forEach(T=>t({line:T,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=f}handleClose(_,n,t,s){const d=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;d&&t({line:d,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}e.LineProcess=a;function r(o){let _=[],n=!1;const t=function(s){if(n){_.push(s);return}(!o.send(s,c=>{if(c&&console.error(c),n=!1,_.length>0){const f=_.slice(0);_=[],f.forEach(l=>t(l))}})||k.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=r;var g;(function(o){async function _(n,t,s){if(i.isAbsolute(n))return n;if(t===void 0&&(t=S.cwd()),i.dirname(n)!=="."||(s===void 0&&R.isString(S.env.PATH)&&(s=S.env.PATH.split(i.delimiter)),s===void 0||s.length===0))return i.join(t,n);async function c(f){if(await u.Promises.exists(f)){let l;try{l=await u.Promises.stat(f)}catch(b){b.message.startsWith("EACCES")&&(l=await u.Promises.lstat(f))}return l?!l.isDirectory():!1}return!1}for(let f of s){let l;if(i.isAbsolute(f)?l=i.join(f,n):l=i.join(t,f,n),await c(l))return l;let b=l+".com";if(await c(b)||(b=l+".exe",await c(b)))return b}return i.join(t,n)}o.findExecutable=_})(g=e.win32||(e.win32={}))}),define(pe[154],ve([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(pe[113],ve([0,1,154,12,109,16,25]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(k=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(ne){this._values=ne}hasChanged(ne){return this._values[ne]}}e.ConfigurationChangedEvent=S;class D{constructor(){this._values=[]}_read(ne){return this._values[ne]}get(ne){return this._values[ne]}_write(ne,ge){this._values[ne]=ge}}e.ValidatedEditorOptions=D;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class P{constructor(ne,ge,te,Ee){this.id=ne,this.name=ge,this.defaultValue=te,this.schema=Ee}applyUpdate(ne,ge){return E(ne,ge)}compute(ne,ge,te){return te}}class u{constructor(ne,ge){this.newValue=ne,this.didChange=ge}}e.ApplyUpdateResult=u;function E(J,ne){if(typeof J!="object"||typeof ne!="object"||!J||!ne)return new u(ne,J!==ne);if(Array.isArray(J)||Array.isArray(ne)){const te=Array.isArray(J)&&Array.isArray(ne)&&C.equals(J,ne);return new u(ne,te)}let ge=!1;for(let te in ne)if(ne.hasOwnProperty(te)){const Ee=E(J[te],ne[te]);Ee.didChange&&(J[te]=Ee.newValue,ge=!0)}return new u(J,ge)}class h{constructor(ne){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0}applyUpdate(ne,ge){return E(ne,ge)}validate(ne){return this.defaultValue}}class p{constructor(ne,ge,te,Ee){this.id=ne,this.name=ge,this.defaultValue=te,this.schema=Ee}applyUpdate(ne,ge){return E(ne,ge)}validate(ne){return typeof ne=="undefined"?this.defaultValue:ne}compute(ne,ge,te){return te}}function v(J,ne){return typeof J=="undefined"?ne:J==="false"?!1:Boolean(J)}e.boolean=v;class I extends p{constructor(ne,ge,te,Ee=void 0){typeof Ee!="undefined"&&(Ee.type="boolean",Ee.default=te),super(ne,ge,te,Ee)}validate(ne){return v(ne,this.defaultValue)}}function w(J,ne,ge,te){if(typeof J=="undefined")return ne;let Ee=parseInt(J,10);return isNaN(Ee)?ne:(Ee=Math.max(ge,Ee),Ee=Math.min(te,Ee),Ee|0)}e.clampedInt=w;class a extends p{constructor(ne,ge,te,Ee,Le,Oe=void 0){typeof Oe!="undefined"&&(Oe.type="integer",Oe.default=te,Oe.minimum=Ee,Oe.maximum=Le),super(ne,ge,te,Oe),this.minimum=Ee,this.maximum=Le}static clampedInt(ne,ge,te,Ee){return w(ne,ge,te,Ee)}validate(ne){return a.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}class r extends p{constructor(ne,ge,te,Ee,Le){typeof Le!="undefined"&&(Le.type="number",Le.default=te),super(ne,ge,te,Le),this.validationFn=Ee}static clamp(ne,ge,te){return ne<ge?ge:ne>te?te:ne}static float(ne,ge){if(typeof ne=="number")return ne;if(typeof ne=="undefined")return ge;const te=parseFloat(ne);return isNaN(te)?ge:te}validate(ne){return this.validationFn(r.float(ne,this.defaultValue))}}class g extends p{static string(ne,ge){return typeof ne!="string"?ge:ne}constructor(ne,ge,te,Ee=void 0){typeof Ee!="undefined"&&(Ee.type="string",Ee.default=te),super(ne,ge,te,Ee)}validate(ne){return g.string(ne,this.defaultValue)}}function o(J,ne,ge){return typeof J!="string"||ge.indexOf(J)===-1?ne:J}e.stringSet=o;class _ extends p{constructor(ne,ge,te,Ee,Le=void 0){typeof Le!="undefined"&&(Le.type="string",Le.enum=Ee,Le.default=te),super(ne,ge,te,Le),this._allowedValues=Ee}validate(ne){return o(ne,this.defaultValue,this._allowedValues)}}class n extends P{constructor(ne,ge,te,Ee,Le,Oe,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="string",Xe.enum=Le,Xe.default=Ee),super(ne,ge,te,Xe),this._allowedValues=Le,this._convert=Oe}validate(ne){return typeof ne!="string"?this.defaultValue:this._allowedValues.indexOf(ne)===-1?this.defaultValue:this._convert(ne)}}function t(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,ge,te){return te===0?ne.accessibilitySupport:te}}class d extends P{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:m.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{insertSpace:v(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function f(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(l=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function b(J){switch(J){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function T(J){switch(J){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class A extends h{constructor(){super(127)}compute(ne,ge,te){const Ee=["monaco-editor"];return ge.get(33)&&Ee.push(ge.get(33)),ne.extraEditorClassName&&Ee.push(ne.extraEditorClassName),ge.get(65)==="default"?Ee.push("mouse-default"):ge.get(65)==="copy"&&Ee.push("mouse-copy"),ge.get(99)&&Ee.push("showUnused"),ge.get(125)&&Ee.push("showDeprecated"),Ee.join(" ")}}class U extends I{constructor(){super(32,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(ne,ge,te){return te&&ne.emptySelectionClipboard}}class B extends P{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ne.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:m.localize(16,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:m.localize(18,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{cursorMoveOnType:v(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ne.seedSearchStringFromSelection=="boolean"?ne.seedSearchStringFromSelection?"always":"never":o(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":o(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(ge.loop,this.defaultValue.loop)}}}class L extends P{constructor(){super(44,"fontLigatures",L.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(ne){return typeof ne=="undefined"?this.defaultValue:typeof ne=="string"?ne==="false"?L.OFF:ne==="true"?L.ON:ne:Boolean(ne)?L.ON:L.OFF}}e.EditorFontLigatures=L,L.OFF='"liga" off, "calt" off',L.ON='"liga" on, "calt" on';class x extends h{constructor(){super(43)}compute(ne,ge,te){return ne.fontInfo}}class M extends p{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(ne){let ge=r.float(ne,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:r.clamp(ge,6,100)}compute(ne,ge,te){return ne.fontInfo.fontSize}}class V extends P{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(a.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}V.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],V.MINIMUM_VALUE=1,V.MAXIMUM_VALUE=1e3;class O extends P{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},te=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...ge},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...ge},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:te,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:te,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:te,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:te,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:te,description:m.localize(38,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{multiple:o(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??o(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??o(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??o(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??o(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??o(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class W extends P{constructor(){const ne={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:ne.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:m.localize(41,null)},"editor.hover.above":{type:"boolean",default:ne.above,description:m.localize(42,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{enabled:v(ge.enabled,this.defaultValue.enabled),delay:a.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:v(ge.sticky,this.defaultValue.sticky),above:v(ge.above,this.defaultValue.above)}}}var q;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(q=e.RenderMinimap||(e.RenderMinimap={}));class N extends h{constructor(){super(130)}compute(ne,ge,te){return N.computeLayout(ge,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio})}static computeContainedMinimapLineCount(ne){const ge=ne.height/ne.lineHeight,te=ne.scrollBeyondLastLine?ge-1:0,Ee=(ne.viewLineCount+te)/(ne.pixelRatio*ne.height),Le=Math.floor(ne.viewLineCount/Ee);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:te,desiredRatio:Ee,minimapLineCount:Le}}static _computeMinimapLayout(ne,ge){const te=ne.outerWidth,Ee=ne.outerHeight,Le=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Le*Ee),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ee};const Oe=ge.stableMinimapLayoutInput,Xe=Oe&&ne.outerHeight===Oe.outerHeight&&ne.lineHeight===Oe.lineHeight&&ne.typicalHalfwidthCharacterWidth===Oe.typicalHalfwidthCharacterWidth&&ne.pixelRatio===Oe.pixelRatio&&ne.scrollBeyondLastLine===Oe.scrollBeyondLastLine&&ne.minimap.enabled===Oe.minimap.enabled&&ne.minimap.side===Oe.minimap.side&&ne.minimap.size===Oe.minimap.size&&ne.minimap.showSlider===Oe.minimap.showSlider&&ne.minimap.renderCharacters===Oe.minimap.renderCharacters&&ne.minimap.maxColumn===Oe.minimap.maxColumn&&ne.minimap.scale===Oe.minimap.scale&&ne.verticalScrollbarWidth===Oe.verticalScrollbarWidth&&ne.isViewportWrapping===Oe.isViewportWrapping,Te=ne.lineHeight,ke=ne.typicalHalfwidthCharacterWidth,Se=ne.scrollBeyondLastLine,le=ne.minimap.renderCharacters;let ue=Le>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const we=ne.minimap.maxColumn,_e=ne.minimap.size,Fe=ne.minimap.side,Ke=ne.verticalScrollbarWidth,$e=ne.viewLineCount,Qe=ne.remainingWidth,st=ne.isViewportWrapping,at=le?2:3;let de=Math.floor(Le*Ee);const Ce=de/Le;let ce=!1,X=!1,De=at*ue,Re=ue/Le,Ze=1;if(_e==="fill"||_e==="fit"){const{typicalViewportLineCount:vt,extraLinesBeyondLastLine:St,desiredRatio:Ot,minimapLineCount:It}=N.computeContainedMinimapLineCount({viewLineCount:$e,scrollBeyondLastLine:Se,height:Ee,lineHeight:Te,pixelRatio:Le});if($e/It>1)ce=!0,X=!0,ue=1,De=1,Re=ue/Le;else{let Lt=!1,_t=ue+1;if(_e==="fit"){const Mt=Math.ceil(($e+St)*De);st&&Xe&&Qe<=ge.stableFitRemainingWidth?(Lt=!0,_t=ge.stableFitMaxMinimapScale):Lt=Mt>de}if(_e==="fill"||Lt){ce=!0;const Mt=ue;De=Math.min(Te*Le,Math.max(1,Math.floor(1/Ot))),st&&Xe&&Qe<=ge.stableFitRemainingWidth&&(_t=ge.stableFitMaxMinimapScale),ue=Math.min(_t,Math.max(1,Math.floor(De/at))),ue>Mt&&(Ze=Math.min(2,ue/Mt)),Re=ue/Le/Ze,de=Math.ceil(Math.max(vt,$e+St)*De),st?(ge.stableMinimapLayoutInput=ne,ge.stableFitRemainingWidth=Qe,ge.stableFitMaxMinimapScale=ue):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const qe=Math.floor(we*Re),dt=Math.min(qe,Math.max(0,Math.floor((Qe-Ke-2)*Re/(ke+Re)))+e.MINIMAP_GUTTER_WIDTH);let wt=Math.floor(Le*dt);const yt=wt/Le;wt=Math.floor(wt*Ze);const bt=le?1:2,ft=Fe==="left"?0:te-dt-Ke;return{renderMinimap:bt,minimapLeft:ft,minimapWidth:dt,minimapHeightIsEditorHeight:ce,minimapIsSampling:X,minimapScale:ue,minimapLineHeight:De,minimapCanvasInnerWidth:wt,minimapCanvasInnerHeight:de,minimapCanvasOuterWidth:yt,minimapCanvasOuterHeight:Ce}}static computeLayout(ne,ge){const te=ge.outerWidth|0,Ee=ge.outerHeight|0,Le=ge.lineHeight|0,Oe=ge.lineNumbersDigitCount|0,Xe=ge.typicalHalfwidthCharacterWidth,Te=ge.maxDigitWidth,ke=ge.pixelRatio,Se=ge.viewLineCount,le=ne.get(122),ue=le==="inherit"?ne.get(121):le,we=ue==="inherit"?ne.get(117):ue,_e=ne.get(120),Fe=ne.get(2),Ke=ge.isDominatedByLongLines,$e=ne.get(49),Qe=ne.get(59).renderType!==0,st=ne.get(60),at=ne.get(93),de=ne.get(64),Ce=ne.get(91),ce=Ce.verticalScrollbarSize,X=Ce.verticalHasArrows,De=Ce.arrowSize,Re=Ce.horizontalScrollbarSize,Ze=ne.get(57),qe=ne.get(37);let dt;if(typeof Ze=="string"&&/^\d+(\.\d+)?ch$/.test(Ze)){const Wt=parseFloat(Ze.substr(0,Ze.length-2));dt=a.clampedInt(Wt*Xe,0,0,1e3)}else dt=a.clampedInt(Ze,0,0,1e3);qe&&(dt+=16);let wt=0;if(Qe){const Wt=Math.max(Oe,st);wt=Math.round(Wt*Te)}let yt=0;$e&&(yt=Le);let bt=0,ft=bt+yt,vt=ft+wt,St=vt+dt;const Ot=te-yt-wt-dt;let It=!1,Tt=!1,Lt=-1;Fe!==2&&(ue==="inherit"&&Ke?(It=!0,Tt=!0):we==="on"||we==="bounded"?Tt=!0:we==="wordWrapColumn"&&(Lt=_e));const _t=N._computeMinimapLayout({outerWidth:te,outerHeight:Ee,lineHeight:Le,typicalHalfwidthCharacterWidth:Xe,pixelRatio:ke,scrollBeyondLastLine:at,minimap:de,verticalScrollbarWidth:ce,viewLineCount:Se,remainingWidth:Ot,isViewportWrapping:Tt},ge.memory||new R);_t.renderMinimap!==0&&_t.minimapLeft===0&&(bt+=_t.minimapWidth,ft+=_t.minimapWidth,vt+=_t.minimapWidth,St+=_t.minimapWidth);const Mt=Ot-_t.minimapWidth,Nt=Math.max(1,Math.floor((Mt-ce-2)/Xe)),Et=X?De:0;return Tt&&(Lt=Math.max(1,Nt),we==="bounded"&&(Lt=Math.min(Lt,_e))),{width:te,height:Ee,glyphMarginLeft:bt,glyphMarginWidth:yt,lineNumbersLeft:ft,lineNumbersWidth:wt,decorationsLeft:vt,decorationsWidth:dt,contentLeft:St,contentWidth:Mt,minimap:_t,viewportColumn:Nt,isWordWrapMinified:It,isViewportWrapping:Tt,wrappingColumn:Lt,verticalScrollbarWidth:ce,horizontalScrollbarHeight:Re,overviewRuler:{top:Et,width:ce,height:Ee-2*Et,right:0}}}}e.EditorLayoutInfoComputer=N;class G extends P{constructor(){const ne={enabled:!0};super(56,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"boolean",default:ne.enabled,description:m.localize(43,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:v(ne.enabled,this.defaultValue.enabled)}}}class $ extends P{constructor(){const ne={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"boolean",default:ne.enabled,description:m.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,markdownDescription:m.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,markdownDescription:m.localize(46,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{enabled:v(ge.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(ge.fontFamily,this.defaultValue.fontFamily)}}}class H extends r{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ne=>r.clamp(ne,0,150),{markdownDescription:m.localize(47,null)})}compute(ne,ge,te){return ne.fontInfo.lineHeight}}class j extends P{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:m.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(49,null),m.localize(50,null),m.localize(51,null)],default:ne.size,description:m.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:m.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:m.localize(54,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:m.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:m.localize(57,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{enabled:v(ge.enabled,this.defaultValue.enabled),size:o(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:o(ge.side,this.defaultValue.side,["right","left"]),showSlider:o(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(ge.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(ge.scale,1,1,3),maxColumn:a.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ie(J){return J==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class fe extends P{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(59,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{top:a.clampedInt(ge.top,0,0,1e3),bottom:a.clampedInt(ge.bottom,0,0,1e3)}}}class ye extends P{constructor(){const ne={enabled:!0,cycle:!1};super(75,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:m.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:m.localize(61,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{enabled:v(ge.enabled,this.defaultValue.enabled),cycle:v(ge.cycle,this.defaultValue.cycle)}}}class Ie extends h{constructor(){super(128)}compute(ne,ge,te){return ne.pixelRatio}}class Be extends P{constructor(){const ne={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",ne,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ne.strings,description:m.localize(62,null)},comments:{type:"boolean",default:ne.comments,description:m.localize(63,null)},other:{type:"boolean",default:ne.other,description:m.localize(64,null)}}}],default:ne,description:m.localize(65,null)});this.defaultValue=ne}validate(ne){if(typeof ne=="boolean")return ne;if(ne&&typeof ne=="object"){const ge=ne,te={other:v(ge.other,this.defaultValue.other),comments:v(ge.comments,this.defaultValue.comments),strings:v(ge.strings,this.defaultValue.strings)};return te.other&&te.comments&&te.strings?!0:!te.other&&!te.comments&&!te.strings?!1:te}return this.defaultValue}}var We;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(We=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ze extends P{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null),m.localize(69,null)],default:"on",description:m.localize(70,null)})}validate(ne){let ge=this.defaultValue.renderType,te=this.defaultValue.renderFn;return typeof ne!="undefined"&&(typeof ne=="function"?(ge=4,te=ne):ne==="interval"?ge=3:ne==="relative"?ge=2:ne==="on"?ge=1:ge=0),{renderType:ge,renderFn:te}}}function Q(J){const ne=J.get(86);return ne==="editable"?J.get(80):ne!=="on"}e.filterValidationDecorations=Q;class ee extends P{constructor(){const ne=[],ge={type:"number",description:m.localize(71,null)};super(90,"rulers",ne,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:m.localize(72,null),format:"color-hex"}}}]},default:ne,description:m.localize(73,null)})}validate(ne){if(Array.isArray(ne)){let ge=[];for(let te of ne)if(typeof te=="number")ge.push({column:a.clampedInt(te,0,0,1e4),color:null});else if(te&&typeof te=="object"){const Ee=te;ge.push({column:a.clampedInt(Ee.column,0,0,1e4),color:Ee.color})}return ge.sort((te,Ee)=>te.column-Ee.column),ge}return this.defaultValue}}function re(J,ne){if(typeof J!="string")return ne;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class he extends P{constructor(){const ne={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",ne,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(74,null),m.localize(75,null),m.localize(76,null)],default:"auto",description:m.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(78,null),m.localize(79,null),m.localize(80,null)],default:"auto",description:m.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ne.verticalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ne.horizontalScrollbarSize,description:m.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ne.scrollByPage,description:m.localize(84,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne,te=a.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ee=a.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:re(ge.vertical,this.defaultValue.vertical),horizontal:re(ge.horizontal,this.defaultValue.horizontal),useShadows:v(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:te,horizontalSliderSize:a.clampedInt(ge.horizontalSliderSize,te,0,1e3),verticalScrollbarSize:Ee,verticalSliderSize:a.clampedInt(ge.verticalSliderSize,Ee,0,1e3),scrollByPage:v(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments"};class Z extends P{constructor(){const ne={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,allowedCharacters:{}};super(112,"unicodeHighlight",ne,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.nonBasicASCII,description:m.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ne.invisibleCharacters,description:m.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ne.ambiguousCharacters,description:m.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.includeComments,description:m.localize(88,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ne.allowedCharacters,description:m.localize(89,null),additionalProperties:{type:"boolean"}}})}applyUpdate(ne,ge){let te=!1;ge.allowedCharacters&&(i.equals(ne.allowedCharacters,ge.allowedCharacters)||(ne={...ne,allowedCharacters:ge.allowedCharacters},te=!0));const Ee=super.applyUpdate(ne,ge);return te?new u(Ee.newValue,!0):Ee}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{nonBasicASCII:Ve(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:v(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:v(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ve(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateAllowedCharacters(ne.allowedCharacters,this.defaultValue.allowedCharacters)}}validateAllowedCharacters(ne,ge){if(typeof ne!="object"||!ne)return ge;const te={};for(const[Ee,Le]of Object.entries(ne))Le===!0&&(te[Ee]=!0);return te}}class oe extends P{constructor(){const ne={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",ne,{"editor.inlineSuggest.enabled":{type:"boolean",default:ne.enabled,description:m.localize(90,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{enabled:v(ge.enabled,this.defaultValue.enabled),mode:o(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class be extends P{constructor(){const ne={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ne,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ne.enabled,description:m.localize(91,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:v(ne.enabled,this.defaultValue.enabled)}}}class Me extends P{constructor(){const ne={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ne,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(92,null),m.localize(93,null),m.localize(94,null)],default:ne.bracketPairs,description:m.localize(95,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(96,null),m.localize(97,null),m.localize(98,null)],default:ne.bracketPairsHorizontal,description:m.localize(99,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ne.highlightActiveBracketPair,description:m.localize(100,null)},"editor.guides.indentation":{type:"boolean",default:ne.indentation,description:m.localize(101,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ne.highlightActiveIndentation,description:m.localize(102,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{bracketPairs:Ve(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ve(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:v(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:v(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:v(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Ve(J,ne,ge){const te=ge.indexOf(J);return te===-1?ne:ge[te]}class Ge extends P{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(103,null),m.localize(104,null)],default:ne.insertMode,description:m.localize(105,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:m.localize(106,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:m.localize(107,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:m.localize(108,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:m.localize(109,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:m.localize(110,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:m.localize(111,null)},"editor.suggest.preview":{type:"boolean",default:ne.preview,description:m.localize(112,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:m.localize(113,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(114,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(115,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(132,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(133,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(134,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(135,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(136,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(137,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(138,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(139,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(140,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(141,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(142,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(143,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(144,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{insertMode:o(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(ge.showIcons,this.defaultValue.showIcons),showStatusBar:v(ge.showStatusBar,this.defaultValue.showStatusBar),preview:v(ge.preview,this.defaultValue.preview),previewMode:o(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:v(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(ge.showMethods,this.defaultValue.showMethods),showFunctions:v(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:v(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:v(ge.showDeprecated,this.defaultValue.showDeprecated),showFields:v(ge.showFields,this.defaultValue.showFields),showVariables:v(ge.showVariables,this.defaultValue.showVariables),showClasses:v(ge.showClasses,this.defaultValue.showClasses),showStructs:v(ge.showStructs,this.defaultValue.showStructs),showInterfaces:v(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:v(ge.showModules,this.defaultValue.showModules),showProperties:v(ge.showProperties,this.defaultValue.showProperties),showEvents:v(ge.showEvents,this.defaultValue.showEvents),showOperators:v(ge.showOperators,this.defaultValue.showOperators),showUnits:v(ge.showUnits,this.defaultValue.showUnits),showValues:v(ge.showValues,this.defaultValue.showValues),showConstants:v(ge.showConstants,this.defaultValue.showConstants),showEnums:v(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:v(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(ge.showKeywords,this.defaultValue.showKeywords),showWords:v(ge.showWords,this.defaultValue.showWords),showColors:v(ge.showColors,this.defaultValue.showColors),showFiles:v(ge.showFiles,this.defaultValue.showFiles),showReferences:v(ge.showReferences,this.defaultValue.showReferences),showFolders:v(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:v(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(ge.showSnippets,this.defaultValue.showSnippets),showUsers:v(ge.showUsers,this.defaultValue.showUsers),showIssues:v(ge.showIssues,this.defaultValue.showIssues)}}}class Je extends P{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(145,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class tt extends h{constructor(){super(129)}compute(ne,ge,te){return ge.get(80)?!0:ne.tabFocusMode}}var ot;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(ot=e.WrappingIndent||(e.WrappingIndent={}));function et(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class it extends h{constructor(){super(131)}compute(ne,ge,te){const Ee=ge.get(130);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:Ee.isWordWrapMinified,isViewportWrapping:Ee.isViewportWrapping,wrappingColumn:Ee.wrappingColumn}}}const ct="Consolas, 'Courier New', monospace",pt="Menlo, Monaco, 'Courier New', monospace",Pt="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?pt:F.isLinux?Pt:ct,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Ue(J){return e.editorOptionsRegistry[J.id]=J,J}var Rt;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.autoClosingDelete=6]="autoClosingDelete",J[J.autoClosingOvertype=7]="autoClosingOvertype",J[J.autoClosingQuotes=8]="autoClosingQuotes",J[J.autoIndent=9]="autoIndent",J[J.automaticLayout=10]="automaticLayout",J[J.autoSurround=11]="autoSurround",J[J.bracketPairColorization=12]="bracketPairColorization",J[J.guides=13]="guides",J[J.codeLens=14]="codeLens",J[J.codeLensFontFamily=15]="codeLensFontFamily",J[J.codeLensFontSize=16]="codeLensFontSize",J[J.colorDecorators=17]="colorDecorators",J[J.columnSelection=18]="columnSelection",J[J.comments=19]="comments",J[J.contextmenu=20]="contextmenu",J[J.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",J[J.cursorBlinking=22]="cursorBlinking",J[J.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",J[J.cursorStyle=24]="cursorStyle",J[J.cursorSurroundingLines=25]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",J[J.cursorWidth=27]="cursorWidth",J[J.disableLayerHinting=28]="disableLayerHinting",J[J.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",J[J.domReadOnly=30]="domReadOnly",J[J.dragAndDrop=31]="dragAndDrop",J[J.emptySelectionClipboard=32]="emptySelectionClipboard",J[J.extraEditorClassName=33]="extraEditorClassName",J[J.fastScrollSensitivity=34]="fastScrollSensitivity",J[J.find=35]="find",J[J.fixedOverflowWidgets=36]="fixedOverflowWidgets",J[J.folding=37]="folding",J[J.foldingStrategy=38]="foldingStrategy",J[J.foldingHighlight=39]="foldingHighlight",J[J.foldingImportsByDefault=40]="foldingImportsByDefault",J[J.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=42]="fontFamily",J[J.fontInfo=43]="fontInfo",J[J.fontLigatures=44]="fontLigatures",J[J.fontSize=45]="fontSize",J[J.fontWeight=46]="fontWeight",J[J.formatOnPaste=47]="formatOnPaste",J[J.formatOnType=48]="formatOnType",J[J.glyphMargin=49]="glyphMargin",J[J.gotoLocation=50]="gotoLocation",J[J.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",J[J.hover=52]="hover",J[J.inDiffEditor=53]="inDiffEditor",J[J.inlineSuggest=54]="inlineSuggest",J[J.letterSpacing=55]="letterSpacing",J[J.lightbulb=56]="lightbulb",J[J.lineDecorationsWidth=57]="lineDecorationsWidth",J[J.lineHeight=58]="lineHeight",J[J.lineNumbers=59]="lineNumbers",J[J.lineNumbersMinChars=60]="lineNumbersMinChars",J[J.linkedEditing=61]="linkedEditing",J[J.links=62]="links",J[J.matchBrackets=63]="matchBrackets",J[J.minimap=64]="minimap",J[J.mouseStyle=65]="mouseStyle",J[J.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=67]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",J[J.multiCursorModifier=69]="multiCursorModifier",J[J.multiCursorPaste=70]="multiCursorPaste",J[J.occurrencesHighlight=71]="occurrencesHighlight",J[J.overviewRulerBorder=72]="overviewRulerBorder",J[J.overviewRulerLanes=73]="overviewRulerLanes",J[J.padding=74]="padding",J[J.parameterHints=75]="parameterHints",J[J.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",J[J.quickSuggestions=78]="quickSuggestions",J[J.quickSuggestionsDelay=79]="quickSuggestionsDelay",J[J.readOnly=80]="readOnly",J[J.renameOnType=81]="renameOnType",J[J.renderControlCharacters=82]="renderControlCharacters",J[J.renderFinalNewline=83]="renderFinalNewline",J[J.renderLineHighlight=84]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=86]="renderValidationDecorations",J[J.renderWhitespace=87]="renderWhitespace",J[J.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",J[J.roundedSelection=89]="roundedSelection",J[J.rulers=90]="rulers",J[J.scrollbar=91]="scrollbar",J[J.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=93]="scrollBeyondLastLine",J[J.scrollPredominantAxis=94]="scrollPredominantAxis",J[J.selectionClipboard=95]="selectionClipboard",J[J.selectionHighlight=96]="selectionHighlight",J[J.selectOnLineNumbers=97]="selectOnLineNumbers",J[J.showFoldingControls=98]="showFoldingControls",J[J.showUnused=99]="showUnused",J[J.snippetSuggestions=100]="snippetSuggestions",J[J.smartSelect=101]="smartSelect",J[J.smoothScrolling=102]="smoothScrolling",J[J.stickyTabStops=103]="stickyTabStops",J[J.stopRenderingLineAfter=104]="stopRenderingLineAfter",J[J.suggest=105]="suggest",J[J.suggestFontSize=106]="suggestFontSize",J[J.suggestLineHeight=107]="suggestLineHeight",J[J.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",J[J.suggestSelection=109]="suggestSelection",J[J.tabCompletion=110]="tabCompletion",J[J.tabIndex=111]="tabIndex",J[J.unicodeHighlighting=112]="unicodeHighlighting",J[J.unusualLineTerminators=113]="unusualLineTerminators",J[J.useShadowDOM=114]="useShadowDOM",J[J.useTabStops=115]="useTabStops",J[J.wordSeparators=116]="wordSeparators",J[J.wordWrap=117]="wordWrap",J[J.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=120]="wordWrapColumn",J[J.wordWrapOverride1=121]="wordWrapOverride1",J[J.wordWrapOverride2=122]="wordWrapOverride2",J[J.wrappingIndent=123]="wrappingIndent",J[J.wrappingStrategy=124]="wrappingStrategy",J[J.showDeprecated=125]="showDeprecated",J[J.inlayHints=126]="inlayHints",J[J.editorClassName=127]="editorClassName",J[J.pixelRatio=128]="pixelRatio",J[J.tabFocusMode=129]="tabFocusMode",J[J.layoutInfo=130]="layoutInfo",J[J.wrappingInfo=131]="wrappingInfo"})(Rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new I(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(146,null)})),acceptSuggestionOnEnter:Ue(new _(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(147,null),""],markdownDescription:m.localize(148,null)})),accessibilitySupport:Ue(new s),accessibilityPageSize:Ue(new a(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(149,null)})),ariaLabel:Ue(new g(4,"ariaLabel",m.localize(150,null))),autoClosingBrackets:Ue(new _(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(151,null),m.localize(152,null),""],description:m.localize(153,null)})),autoClosingDelete:Ue(new _(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(154,null),""],description:m.localize(155,null)})),autoClosingOvertype:Ue(new _(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(156,null),""],description:m.localize(157,null)})),autoClosingQuotes:Ue(new _(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(158,null),m.localize(159,null),""],description:m.localize(160,null)})),autoIndent:Ue(new n(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],t,{enumDescriptions:[m.localize(161,null),m.localize(162,null),m.localize(163,null),m.localize(164,null),m.localize(165,null)],description:m.localize(166,null)})),automaticLayout:Ue(new I(10,"automaticLayout",!1)),autoSurround:Ue(new _(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(167,null),m.localize(168,null),m.localize(169,null),""],description:m.localize(170,null)})),bracketPairColorization:Ue(new be),bracketPairGuides:Ue(new Me),stickyTabStops:Ue(new I(103,"stickyTabStops",!1,{description:m.localize(171,null)})),codeLens:Ue(new I(14,"codeLens",!0,{description:m.localize(172,null)})),codeLensFontFamily:Ue(new g(15,"codeLensFontFamily","",{description:m.localize(173,null)})),codeLensFontSize:Ue(new a(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(174,null)})),colorDecorators:Ue(new I(17,"colorDecorators",!0,{description:m.localize(175,null)})),columnSelection:Ue(new I(18,"columnSelection",!1,{description:m.localize(176,null)})),comments:Ue(new d),contextmenu:Ue(new I(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new I(21,"copyWithSyntaxHighlighting",!0,{description:m.localize(177,null)})),cursorBlinking:Ue(new n(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:m.localize(178,null)})),cursorSmoothCaretAnimation:Ue(new I(23,"cursorSmoothCaretAnimation",!1,{description:m.localize(179,null)})),cursorStyle:Ue(new n(24,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:m.localize(180,null)})),cursorSurroundingLines:Ue(new a(25,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(181,null)})),cursorSurroundingLinesStyle:Ue(new _(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(182,null),m.localize(183,null)],description:m.localize(184,null)})),cursorWidth:Ue(new a(27,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(185,null)})),disableLayerHinting:Ue(new I(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new I(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new I(30,"domReadOnly",!1)),dragAndDrop:Ue(new I(31,"dragAndDrop",!0,{description:m.localize(186,null)})),emptySelectionClipboard:Ue(new U),extraEditorClassName:Ue(new g(33,"extraEditorClassName","")),fastScrollSensitivity:Ue(new r(34,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:m.localize(187,null)})),find:Ue(new B),fixedOverflowWidgets:Ue(new I(36,"fixedOverflowWidgets",!1)),folding:Ue(new I(37,"folding",!0,{description:m.localize(188,null)})),foldingStrategy:Ue(new _(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(189,null),m.localize(190,null)],description:m.localize(191,null)})),foldingHighlight:Ue(new I(39,"foldingHighlight",!0,{description:m.localize(192,null)})),foldingImportsByDefault:Ue(new I(40,"foldingImportsByDefault",!1,{description:m.localize(193,null)})),unfoldOnClickAfterEndOfLine:Ue(new I(41,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(194,null)})),fontFamily:Ue(new g(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(195,null)})),fontInfo:Ue(new x),fontLigatures2:Ue(new L),fontSize:Ue(new M),fontWeight:Ue(new V),formatOnPaste:Ue(new I(47,"formatOnPaste",!1,{description:m.localize(196,null)})),formatOnType:Ue(new I(48,"formatOnType",!1,{description:m.localize(197,null)})),glyphMargin:Ue(new I(49,"glyphMargin",!0,{description:m.localize(198,null)})),gotoLocation:Ue(new O),hideCursorInOverviewRuler:Ue(new I(51,"hideCursorInOverviewRuler",!1,{description:m.localize(199,null)})),hover:Ue(new W),inDiffEditor:Ue(new I(53,"inDiffEditor",!1)),letterSpacing:Ue(new r(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>r.clamp(J,-5,20),{description:m.localize(200,null)})),lightbulb:Ue(new G),lineDecorationsWidth:Ue(new p(57,"lineDecorationsWidth",10)),lineHeight:Ue(new H),lineNumbers:Ue(new ze),lineNumbersMinChars:Ue(new a(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new I(61,"linkedEditing",!1,{description:m.localize(201,null)})),links:Ue(new I(62,"links",!0,{description:m.localize(202,null)})),matchBrackets:Ue(new _(63,"matchBrackets","always",["always","near","never"],{description:m.localize(203,null)})),minimap:Ue(new j),mouseStyle:Ue(new _(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new r(66,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:m.localize(204,null)})),mouseWheelZoom:Ue(new I(67,"mouseWheelZoom",!1,{markdownDescription:m.localize(205,null)})),multiCursorMergeOverlapping:Ue(new I(68,"multiCursorMergeOverlapping",!0,{description:m.localize(206,null)})),multiCursorModifier:Ue(new n(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ie,{markdownEnumDescriptions:[m.localize(207,null),m.localize(208,null)],markdownDescription:m.localize(209,null)})),multiCursorPaste:Ue(new _(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(210,null),m.localize(211,null)],markdownDescription:m.localize(212,null)})),occurrencesHighlight:Ue(new I(71,"occurrencesHighlight",!0,{description:m.localize(213,null)})),overviewRulerBorder:Ue(new I(72,"overviewRulerBorder",!0,{description:m.localize(214,null)})),overviewRulerLanes:Ue(new a(73,"overviewRulerLanes",3,0,3)),padding:Ue(new fe),parameterHints:Ue(new ye),peekWidgetDefaultFocus:Ue(new _(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(215,null),m.localize(216,null)],description:m.localize(217,null)})),definitionLinkOpensInPeek:Ue(new I(77,"definitionLinkOpensInPeek",!1,{description:m.localize(218,null)})),quickSuggestions:Ue(new Be),quickSuggestionsDelay:Ue(new a(79,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(219,null)})),readOnly:Ue(new I(80,"readOnly",!1)),renameOnType:Ue(new I(81,"renameOnType",!1,{description:m.localize(220,null),markdownDeprecationMessage:m.localize(221,null)})),renderControlCharacters:Ue(new I(82,"renderControlCharacters",!0,{description:m.localize(222,null),restricted:!0})),renderFinalNewline:Ue(new I(83,"renderFinalNewline",!0,{description:m.localize(223,null)})),renderLineHighlight:Ue(new _(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(224,null)],description:m.localize(225,null)})),renderLineHighlightOnlyWhenFocus:Ue(new I(85,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(226,null)})),renderValidationDecorations:Ue(new _(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new _(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(227,null),m.localize(228,null),m.localize(229,null),""],description:m.localize(230,null)})),revealHorizontalRightPadding:Ue(new a(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ue(new I(89,"roundedSelection",!0,{description:m.localize(231,null)})),rulers:Ue(new ee),scrollbar:Ue(new he),scrollBeyondLastColumn:Ue(new a(92,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(232,null)})),scrollBeyondLastLine:Ue(new I(93,"scrollBeyondLastLine",!0,{description:m.localize(233,null)})),scrollPredominantAxis:Ue(new I(94,"scrollPredominantAxis",!0,{description:m.localize(234,null)})),selectionClipboard:Ue(new I(95,"selectionClipboard",!0,{description:m.localize(235,null),included:F.isLinux})),selectionHighlight:Ue(new I(96,"selectionHighlight",!0,{description:m.localize(236,null)})),selectOnLineNumbers:Ue(new I(97,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new _(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),showUnused:Ue(new I(99,"showUnused",!0,{description:m.localize(240,null)})),showDeprecated:Ue(new I(125,"showDeprecated",!0,{description:m.localize(241,null)})),inlayHints:Ue(new $),snippetSuggestions:Ue(new _(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(242,null),m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),smartSelect:Ue(new Je),smoothScrolling:Ue(new I(102,"smoothScrolling",!1,{description:m.localize(247,null)})),stopRenderingLineAfter:Ue(new a(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new Ge),inlineSuggest:Ue(new oe),suggestFontSize:Ue(new a(106,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(248,null)})),suggestLineHeight:Ue(new a(107,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(249,null)})),suggestOnTriggerCharacters:Ue(new I(108,"suggestOnTriggerCharacters",!0,{description:m.localize(250,null)})),suggestSelection:Ue(new _(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),tabCompletion:Ue(new _(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(255,null),m.localize(256,null),m.localize(257,null)],description:m.localize(258,null)})),tabIndex:Ue(new a(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new Z),unusualLineTerminators:Ue(new _(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(259,null),m.localize(260,null),m.localize(261,null)],description:m.localize(262,null)})),useShadowDOM:Ue(new I(114,"useShadowDOM",!0)),useTabStops:Ue(new I(115,"useTabStops",!0,{description:m.localize(263,null)})),wordSeparators:Ue(new g(116,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:m.localize(264,null)})),wordWrap:Ue(new _(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(265,null),m.localize(266,null),m.localize(267,null),m.localize(268,null)],description:m.localize(269,null)})),wordWrapBreakAfterCharacters:Ue(new g(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new g(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new a(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(270,null)})),wordWrapOverride1:Ue(new _(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new _(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ue(new n(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],et,{enumDescriptions:[m.localize(271,null),m.localize(272,null),m.localize(273,null),m.localize(274,null)],description:m.localize(275,null)})),wrappingStrategy:Ue(new _(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(276,null),m.localize(277,null)],description:m.localize(278,null)})),editorClassName:Ue(new A),pixelRatio:Ue(new Ie),tabFocusMode:Ue(new tt),layoutInfo:Ue(new N),wrappingInfo:Ue(new it)}}),define(pe[155],ve([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[156],ve([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[157],ve([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[158],ve([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(pe[159],ve([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(pe[160],ve([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(pe[161],ve([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(pe[162],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(pe[163],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(pe[164],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(pe[165],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(pe[166],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(pe[167],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(pe[168],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(pe[169],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(pe[170],ve([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(pe[171],ve([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(pe[172],ve([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(pe[173],ve([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(pe[174],ve([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(pe[175],ve([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(pe[176],ve([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[177],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(i){i[i.ACTIVATE=1]="ACTIVATE",i[i.RESTORE=2]="RESTORE",i[i.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var F;(function(i){i[i.PICK=0]="PICK",i[i.DISABLED=1]="DISABLED",i[i.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var y;(function(i){i[i.API=0]="API",i[i.USER=1]="USER"})(y=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(i){i[i.Center=0]="Center",i[i.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",i[i.NearTop=2]="NearTop",i[i.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(pe[178],ve([0,1,157]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function C(u){return u=u.trim(),u==="*"||F.test(u)}e.isValidVersionStr=C;function i(u){if(!C(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=u.match(F);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=i;function k(u){if(!u)return null;let E=u.majorBase,h=u.majorMustEqual,p=u.minorBase,v=u.minorMustEqual,I=u.patchBase,w=u.patchMustEqual;u.hasCaret&&(E===0||(v=!1),w=!1);let a=0;if(u.preRelease){const r=y.exec(u.preRelease);if(r){const[,g,o,_]=r;a=Date.UTC(Number(g),Number(o)-1,Number(_))}}return{majorBase:E,majorMustEqual:h,minorBase:p,minorMustEqual:v,patchBase:I,patchMustEqual:w,isMinimum:u.hasGreaterEquals,notBefore:a}}e.normalizeVersion=k;function S(u,E,h){let p;typeof u=="string"?p=k(i(u)):p=u;let v;E instanceof Date?v=E.getTime():typeof E=="string"&&(v=new Date(E).getTime());let I;if(typeof h=="string"?I=k(i(h)):I=h,!p||!I)return!1;let w=p.majorBase,a=p.minorBase,r=p.patchBase,g=I.majorBase,o=I.minorBase,_=I.patchBase,n=I.notBefore,t=I.majorMustEqual,s=I.minorMustEqual,d=I.patchMustEqual;return I.isMinimum?w>g?!0:w<g?!1:a>o?!0:a<o||v&&v<n?!1:r>=_:(w===1&&g===0&&(!t||!s||!d)&&(g=1,o=0,_=0,t=!0,s=!1,d=!1),w<g?!1:w>g?!t:a<o?!1:a>o?!s:r<_?!1:r>_?!d:!(v&&v<n))}e.isValidVersion=S;function D(u,E,h,p){return h.isBuiltin||typeof h.main=="undefined"?!0:P(u,E,h.engines.vscode,p)}e.isValidExtensionVersion=D;function R(u,E,h){return u==="*"||P(E,h,u)}e.isEngineValid=R;function P(u,E,h,p=[]){let v=k(i(h));if(!v)return p.push(m.localize(0,null,h)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return p.push(m.localize(1,null,h)),!1}else if(!v.majorMustEqual)return p.push(m.localize(2,null,h)),!1;return S(u,E,v)?!0:(p.push(m.localize(3,null,u,h)),!1)}}),define(pe[114],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(y,C=[],i=!1){this.ctor=y,this.staticArguments=C,this.supportsDelayedInstantiation=i}}e.SyncDescriptor=m}),define(pe[83],ve([0,1,114]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function y(i,k,S){k instanceof m.SyncDescriptor||(k=new m.SyncDescriptor(k,[],S)),F.push([i,k])}e.registerSingleton=y;function C(){return F}e.getSingletonServiceDescriptors=C}),define(pe[179],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=m;class F{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let i of this._nodes.values())i.outgoing.size===0&&C.push(i);return C}insertEdge(C,i){const k=this.lookupOrInsertNode(C),S=this.lookupOrInsertNode(i);k.outgoing.set(this._hashFn(i),S),S.incoming.set(this._hashFn(C),k)}removeNode(C){const i=this._hashFn(C);this._nodes.delete(i);for(let k of this._nodes.values())k.outgoing.delete(i),k.incoming.delete(i)}lookupOrInsertNode(C){const i=this._hashFn(C);let k=this._nodes.get(i);return k||(k=new m(C),this._nodes.set(i,k)),k}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[i,k]of this._nodes)C.push(`${i}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,i]of this._nodes){const k=new Set([C]),S=this._findCycle(i,k);if(S)return S}}_findCycle(C,i){for(let[k,S]of C.outgoing){if(i.has(k))return[...i,k].join(" -> ");i.add(k);const D=this._findCycle(S,i);if(D)return D;i.delete(k)}}}e.Graph=F}),define(pe[4],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(i){i.serviceIds=new Map,i.DI_TARGET="$di$target",i.DI_DEPENDENCIES="$di$dependencies";function k(S){return S[i.DI_DEPENDENCIES]||[]}i.getServiceDependencies=k})(m=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function F(i,k,S,D){k[m.DI_TARGET]===k?k[m.DI_DEPENDENCIES].push({id:i,index:S,optional:D}):(k[m.DI_DEPENDENCIES]=[{id:i,index:S,optional:D}],k[m.DI_TARGET]=k)}function y(i){if(m.serviceIds.has(i))return m.serviceIds.get(i);const k=function(S,D,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(k,S,R,!1)};return k.toString=()=>i,m.serviceIds.set(i,k),k}e.createDecorator=y;function C(i){return i}e.refineServiceDecorator=C}),define(pe[180],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function F(y){return!y.isTooLargeForSyncing()&&!y.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(pe[181],ve([0,1,3,47,6,24,77,82,180]),function(Y,e,m,F,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function D(p){return typeof p=="string"?!1:Array.isArray(p)?p.every(D):!!p.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(v,I){let w={selector:v,provider:I,_score:-1,_time:this._clock++};return this._entries.push(w),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,y.toDisposable)(()=>{if(w){let a=this._entries.indexOf(w);a>=0&&(this._entries.splice(a,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),w=void 0)}})}has(v){return this.all(v).length>0}all(v){if(!v)return[];this._updateScores(v);const I=[];for(let w of this._entries)w._score>0&&I.push(w.provider);return I}ordered(v){const I=[];return this._orderedForEach(v,w=>I.push(w.provider)),I}orderedGroups(v){const I=[];let w,a;return this._orderedForEach(v,r=>{w&&a===r._score?w.push(r.provider):(a=r._score,w=[r.provider],I.push(w))}),I}_orderedForEach(v,I){if(!!v){this._updateScores(v);for(const w of this._entries)w._score>0&&I(w)}}_updateScores(v){let I={uri:v.uri.toString(),language:v.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===I.language&&this._lastCandidate.uri===I.uri)){this._lastCandidate=I;for(let w of this._entries)if(w._score=(0,k.score)(w.selector,v.uri,v.getLanguageId(),(0,S.shouldSynchronizeModel)(v)),D(w.selector)&&w._score>0){for(let a of this._entries)a._score=0;w._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(v,I){return v._score<I._score?1:v._score>I._score?-1:v._time<I._time?1:v._time>I._time?-1:0}}e.LanguageFeatureRegistry=R;const P=new WeakMap;let u=0;function E(p){let v=P.get(p);return v===void 0&&(v=++u,P.set(p,v)),v}class h{constructor(v,I,w=Number.MAX_SAFE_INTEGER){this._registry=v,this.min=I,this.max=w,this._cache=new C.LRUCache(50,.7)}_key(v){return v.id+this._registry.all(v).reduce((I,w)=>(0,F.doHash)(E(w),I),0)}_clamp(v){return v===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(v*1.3)))}get(v){const I=this._key(v),w=this._cache.get(I);return this._clamp(w?.value)}update(v,I){const w=this._key(v);let a=this._cache.get(w);return a||(a=new i.MovingAverage,this._cache.set(w,a)),a.update(I),this.get(v)}}e.LanguageFeatureRequestDelays=h}),define(pe[84],ve([0,1,2,41,181,148,78]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(l){l[l.Null=0]="Null",l[l.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var S;(function(l){l[l.NotSet=-1]="NotSet",l[l.None=0]="None",l[l.Italic=1]="Italic",l[l.Bold=2]="Bold",l[l.Underline=4]="Underline"})(S=e.FontStyle||(e.FontStyle={}));var D;(function(l){l[l.None=0]="None",l[l.DefaultForeground=1]="DefaultForeground",l[l.DefaultBackground=2]="DefaultBackground"})(D=e.ColorId||(e.ColorId={}));var R;(function(l){l[l.Other=0]="Other",l[l.Comment=1]="Comment",l[l.String=2]="String",l[l.RegEx=4]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var P;(function(l){l[l.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",l[l.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",l[l.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",l[l.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",l[l.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",l[l.ITALIC_MASK=2048]="ITALIC_MASK",l[l.BOLD_MASK=4096]="BOLD_MASK",l[l.UNDERLINE_MASK=8192]="UNDERLINE_MASK",l[l.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",l[l.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",l[l.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",l[l.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",l[l.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",l[l.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",l[l.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",l[l.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",l[l.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",l[l.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(P=e.MetadataConsts||(e.MetadataConsts={}));class u{static getLanguageId(b){return(b&255)>>>0}static getTokenType(b){return(b&1792)>>>8}static getFontStyle(b){return(b&14336)>>>11}static getForeground(b){return(b&8372224)>>>14}static getBackground(b){return(b&4286578688)>>>23}static getClassNameFromMetadata(b){let T=this.getForeground(b),A="mtk"+T,U=this.getFontStyle(b);return U&1&&(A+=" mtki"),U&2&&(A+=" mtkb"),U&4&&(A+=" mtku"),A}static getInlineStyleFromMetadata(b,T){const A=this.getForeground(b),U=this.getFontStyle(b);let B=`color: ${T[A]};`;return U&1&&(B+="font-style: italic;"),U&2&&(B+="font-weight: bold;"),U&4&&(B+="text-decoration: underline;"),B}}e.TokenMetadata=u;var E;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(E=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let l=Object.create(null);return l[0]="symbol-method",l[1]="symbol-function",l[2]="symbol-constructor",l[3]="symbol-field",l[4]="symbol-variable",l[5]="symbol-class",l[6]="symbol-struct",l[7]="symbol-interface",l[8]="symbol-module",l[9]="symbol-property",l[10]="symbol-event",l[11]="symbol-operator",l[12]="symbol-unit",l[13]="symbol-value",l[14]="symbol-constant",l[15]="symbol-enum",l[16]="symbol-enum-member",l[17]="symbol-keyword",l[27]="symbol-snippet",l[18]="symbol-text",l[19]="symbol-color",l[20]="symbol-file",l[21]="symbol-reference",l[22]="symbol-customcolor",l[23]="symbol-folder",l[24]="symbol-type-parameter",l[25]="account",l[26]="issues",function(b){const T=l[b];let A=T&&i.iconRegistry.get(T);return A||(console.info("No codicon found for CompletionItemKind "+b),A=i.Codicon.symbolProperty),A.classNames}}(),e.completionKindFromString=function(){let l=Object.create(null);return l.method=0,l.function=1,l.constructor=2,l.field=3,l.variable=4,l.class=5,l.struct=6,l.interface=7,l.module=8,l.property=9,l.event=10,l.operator=11,l.unit=12,l.value=13,l.constant=14,l.enum=15,l["enum-member"]=16,l.enumMember=16,l.keyword=17,l.snippet=27,l.text=18,l.color=19,l.file=20,l.reference=21,l.customcolor=22,l.folder=23,l["type-parameter"]=24,l.typeParameter=24,l.account=25,l.issue=26,function(b,T){let A=l[b];return typeof A=="undefined"&&!T&&(A=9),A}}();var h;(function(l){l[l.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var v;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var I;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(I=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var w;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var a;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(a=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var r;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(r=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(l){return l&&m.URI.isUri(l.uri)&&F.Range.isIRange(l.range)&&(F.Range.isIRange(l.originSelectionRange)||F.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=g;var o;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(o=e.SymbolKind||(e.SymbolKind={}));var _;(function(l){l[l.Deprecated=1]="Deprecated"})(_=e.SymbolTag||(e.SymbolTag={}));var n;(function(l){const b=new Map;b.set("file",0),b.set("module",1),b.set("namespace",2),b.set("package",3),b.set("class",4),b.set("method",5),b.set("property",6),b.set("field",7),b.set("constructor",8),b.set("enum",9),b.set("interface",10),b.set("function",11),b.set("variable",12),b.set("constant",13),b.set("string",14),b.set("number",15),b.set("boolean",16),b.set("array",17),b.set("object",18),b.set("key",19),b.set("null",20),b.set("enum-member",21),b.set("struct",22),b.set("event",23),b.set("operator",24),b.set("type-parameter",25);const T=new Map;T.set(0,"file"),T.set(1,"module"),T.set(2,"namespace"),T.set(3,"package"),T.set(4,"class"),T.set(5,"method"),T.set(6,"property"),T.set(7,"field"),T.set(8,"constructor"),T.set(9,"enum"),T.set(10,"interface"),T.set(11,"function"),T.set(12,"variable"),T.set(13,"constant"),T.set(14,"string"),T.set(15,"number"),T.set(16,"boolean"),T.set(17,"array"),T.set(18,"object"),T.set(19,"key"),T.set(20,"null"),T.set(21,"enum-member"),T.set(22,"struct"),T.set(23,"event"),T.set(24,"operator"),T.set(25,"type-parameter");function A(L){return b.get(L)}l.fromString=A;function U(L){return T.get(L)}l.toString=U;function B(L,x){const M=T.get(L);let V=M&&i.iconRegistry.get("symbol-"+M);return V||(console.info("No codicon found for SymbolKind "+L),V=i.Codicon.symbolProperty),`${x?"inline":"block"} ${V.classNames}`}l.toCssClassName=B})(n=e.SymbolKinds||(e.SymbolKinds={}));class t{constructor(b){this.value=b}}e.FoldingRangeKind=t,t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region");var s;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var c;(function(l){l[l.Other=0]="Other",l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new y.LanguageFeatureRegistry,e.RenameProviderRegistry=new y.LanguageFeatureRegistry,e.CompletionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new y.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new y.LanguageFeatureRegistry,e.HoverProviderRegistry=new y.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new y.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new y.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new y.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new y.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new y.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.LinkProviderRegistry=new y.LanguageFeatureRegistry,e.ColorProviderRegistry=new y.LanguageFeatureRegistry,e.SelectionRangeRegistry=new y.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var f;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(f=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(pe[115],ve([0,1,13,2,4]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function C(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof F.URI)}e.isConfigurationOverrides=C;function i(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||m.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof F.URI)}e.isConfigurationUpdateOverrides=i;var k;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=S;function D(v,I){const w=Object.create(null);for(let a in v)R(w,a,v[a],I);return w}e.toValuesTree=D;function R(v,I,w,a){const r=I.split("."),g=r.pop();let o=v;for(let _=0;_<r.length;_++){let n=r[_],t=o[n];switch(typeof t){case"undefined":t=o[n]=Object.create(null);break;case"object":break;default:a(`Ignoring ${I} as ${r.slice(0,_+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[g]=w}catch(_){a(`Ignoring ${I} as ${r.join(".")} is ${JSON.stringify(o)}`)}else a(`Ignoring ${I} as ${r.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=R;function P(v,I){const w=I.split(".");u(v,w)}e.removeFromValueTree=P;function u(v,I){const w=I.shift();if(I.length===0){delete v[w];return}if(Object.keys(v).indexOf(w)!==-1){const a=v[w];typeof a=="object"&&!Array.isArray(a)&&(u(a,I),Object.keys(a).length===0&&delete v[w])}}function E(v,I,w){function a(o,_){let n=o;for(const t of _){if(typeof n!="object"||n===null)return;n=n[t]}return n}const r=I.split("."),g=a(v,r);return typeof g=="undefined"?w:g}e.getConfigurationValue=E;function h(v,I,w){Object.keys(I).forEach(a=>{a!=="__proto__"&&(a in v?m.isObject(v[a])&&m.isObject(I[a])?h(v[a],I[a],w):w&&(v[a]=I[a]):v[a]=I[a])})}e.merge=h;function p(v,I,w){const a=v.inspect(I),r=v.inspect(w);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:a.defaultValue}e.getMigratedSettingValue=p}),define(pe[61],ve([0,1,12,8,4]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=m.userAgent||"";const i=new Map;i.set("false",!1),i.set("true",!0),i.set("isMac",m.isMacintosh),i.set("isLinux",m.isLinux),i.set("isWindows",m.isWindows),i.set("isWeb",m.isWeb),i.set("isMacNative",m.isMacintosh&&!m.isWeb),i.set("isEdge",C.indexOf("Edg/")>=0),i.set("isFirefox",C.indexOf("Firefox")>=0),i.set("isChrome",C.indexOf("Chrome")>=0),i.set("isSafari",C.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var S;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class D{static false(){return u.INSTANCE}static true(){return E.INSTANCE}static has(L){return h.create(L)}static equals(L,x){return p.create(L,x)}static notEquals(L,x){return w.create(L,x)}static regex(L,x){return t.create(L,x)}static in(L,x){return v.create(L,x)}static not(L){return a.create(L)}static and(...L){return c.create(L,null)}static or(...L){return f.create(L,null,!0)}static greater(L,x){return g.create(L,x)}static greaterEquals(L,x){return o.create(L,x)}static smaller(L,x){return _.create(L,x)}static smallerEquals(L,x){return n.create(L,x)}static deserialize(L,x=!1){if(!!L)return this._deserializeOrExpression(L,x)}static _deserializeOrExpression(L,x){let M=L.split("||");return f.create(M.map(V=>this._deserializeAndExpression(V,x)),null,!0)}static _deserializeAndExpression(L,x){let M=L.split("&&");return c.create(M.map(V=>this._deserializeOne(V,x)),null)}static _deserializeOne(L,x){if(L=L.trim(),L.indexOf("!=")>=0){let M=L.split("!=");return w.create(M[0].trim(),this._deserializeValue(M[1],x))}if(L.indexOf("==")>=0){let M=L.split("==");return p.create(M[0].trim(),this._deserializeValue(M[1],x))}if(L.indexOf("=~")>=0){let M=L.split("=~");return t.create(M[0].trim(),this._deserializeRegexValue(M[1],x))}if(L.indexOf(" in ")>=0){let M=L.split(" in ");return v.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const M=L.split(">=");return o.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const M=L.split(">");return g.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const M=L.split("<=");return n.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const M=L.split("<");return _.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(L)?a.create(L.substr(1).trim()):h.create(L)}static _deserializeValue(L,x){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;let M=/^'([^']*)'$/.exec(L);return M?M[1].trim():L}static _deserializeRegexValue(L,x){if((0,F.isFalsyOrWhitespace)(L)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=L.indexOf("/"),V=L.lastIndexOf("/");if(M===V||M<0){if(x)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}let O=L.slice(M+1,V),W=L[V+1]==="i"?"i":"";try{return new RegExp(O,W)}catch(q){if(x)throw new Error(`bad regexp-value '${L}', parse error: ${q}`);return console.warn(`bad regexp-value '${L}', parse error: ${q}`),null}}}e.ContextKeyExpr=D;function R(B,L){const x=B?B.substituteConstants():void 0,M=L?L.substituteConstants():void 0;return!x&&!M?!0:!x||!M?!1:x.equals(M)}e.expressionsAreEqualWithConstantSubstitution=R;function P(B,L){return B.cmp(L)}class u{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=u,u.INSTANCE=new u;class E{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return u.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class h{constructor(L,x){this.key=L,this.negated=x,this.type=2}static create(L,x=null){const M=i.get(L);return typeof M=="boolean"?M?E.INSTANCE:u.INSTANCE:new h(L,x)}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=i.get(this.key);return typeof L=="boolean"?L?E.INSTANCE:u.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class p{constructor(L,x,M){this.key=L,this.value=x,this.negated=M,this.type=4}static create(L,x,M=null){if(typeof x=="boolean")return x?h.create(L,M):a.create(L,M);const V=i.get(L);return typeof V=="boolean"?x===(V?"true":"false")?E.INSTANCE:u.INSTANCE:new p(L,x,M)}cmp(L){return L.type!==this.type?this.type-L.type:T(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=i.get(this.key);if(typeof L=="boolean"){const x=L?"true":"false";return this.value===x?E.INSTANCE:u.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class v{constructor(L,x){this.key=L,this.valueKey=x,this.type=10,this.negated=null}static create(L,x){return new v(L,x)}cmp(L){return L.type!==this.type?this.type-L.type:T(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const x=L.getValue(this.valueKey),M=L.getValue(this.key);return Array.isArray(x)?x.indexOf(M)>=0:typeof M=="string"&&typeof x=="object"&&x!==null?k.call(x,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=I.create(this)),this.negated}}e.ContextKeyInExpr=v;class I{constructor(L){this._actual=L,this.type=11}static create(L){return new I(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new I(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotInExpr=I;class w{constructor(L,x,M){this.key=L,this.value=x,this.negated=M,this.type=5}static create(L,x,M=null){if(typeof x=="boolean")return x?a.create(L,M):h.create(L,M);const V=i.get(L);return typeof V=="boolean"?x===(V?"true":"false")?u.INSTANCE:E.INSTANCE:new w(L,x,M)}cmp(L){return L.type!==this.type?this.type-L.type:T(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=i.get(this.key);if(typeof L=="boolean"){const x=L?"true":"false";return this.value===x?u.INSTANCE:E.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class a{constructor(L,x){this.key=L,this.negated=x,this.type=3}static create(L,x=null){const M=i.get(L);return typeof M=="boolean"?M?u.INSTANCE:E.INSTANCE:new a(L,x)}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=i.get(this.key);return typeof L=="boolean"?L?u.INSTANCE:E.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=a;function r(B,L){if(typeof B=="string"){const x=parseFloat(B);isNaN(x)||(B=x)}return typeof B=="string"||typeof B=="number"?L(B):u.INSTANCE}class g{constructor(L,x,M){this.key=L,this.value=x,this.negated=M,this.type=12}static create(L,x,M=null){return r(x,V=>new g(L,V,M))}cmp(L){return L.type!==this.type?this.type-L.type:T(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=g;class o{constructor(L,x,M){this.key=L,this.value=x,this.negated=M,this.type=13}static create(L,x,M=null){return r(x,V=>new o(L,V,M))}cmp(L){return L.type!==this.type?this.type-L.type:T(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=o;class _{constructor(L,x,M){this.key=L,this.value=x,this.negated=M,this.type=14}static create(L,x,M=null){return r(x,V=>new _(L,V,M))}cmp(L){return L.type!==this.type?this.type-L.type:T(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=_;class n{constructor(L,x,M){this.key=L,this.value=x,this.negated=M,this.type=15}static create(L,x,M=null){return r(x,V=>new n(L,V,M))}cmp(L){return L.type!==this.type?this.type-L.type:T(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(L,x){this.key=L,this.regexp=x,this.type=7,this.negated=null}static create(L,x){return new t(L,x)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const x=this.regexp?this.regexp.source:"",M=L.regexp?L.regexp.source:"";return x<M?-1:x>M?1:0}equals(L){if(L.type===this.type){const x=this.regexp?this.regexp.source:"",M=L.regexp?L.regexp.source:"";return this.key===L.key&&x===M}return!1}substituteConstants(){return this}evaluate(L){let x=L.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{constructor(L){this._actual=L,this.type=8}static create(L){return new s(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new s(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function d(B){let L=null;for(let x=0,M=B.length;x<M;x++){const V=B[x].substituteConstants();if(B[x]!==V&&L===null){L=[];for(let O=0;O<x;O++)L[O]=B[O]}L!==null&&(L[x]=V)}return L===null?B:L}class c{constructor(L,x){this.expr=L,this.negated=x,this.type=6}static create(L,x){return c._normalizeArr(L,x)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let x=0,M=this.expr.length;x<M;x++){const V=P(this.expr[x],L.expr[x]);if(V!==0)return V}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let x=0,M=this.expr.length;x<M;x++)if(!this.expr[x].equals(L.expr[x]))return!1;return!0}return!1}substituteConstants(){const L=d(this.expr);return L===this.expr?this:c.create(L,this.negated)}evaluate(L){for(let x=0,M=this.expr.length;x<M;x++)if(!this.expr[x].evaluate(L))return!1;return!0}static _normalizeArr(L,x){const M=[];let V=!1;for(const O of L)if(!!O){if(O.type===1){V=!0;continue}if(O.type===0)return u.INSTANCE;if(O.type===6){M.push(...O.expr);continue}M.push(O)}if(M.length===0&&V)return E.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(P);for(let O=1;O<M.length;O++)M[O-1].equals(M[O])&&(M.splice(O,1),O--);if(M.length===1)return M[0];for(;M.length>1;){const O=M[M.length-1];if(O.type!==9)break;M.pop();const W=M.pop(),q=M.length===0,N=f.create(O.expr.map(G=>c.create([G,W],null)),null,q);N&&(M.push(N),M.sort(P))}return M.length===1?M[0]:new c(M,x)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(let x of this.expr)L.push(...x.keys());return L}map(L){return new c(this.expr.map(x=>x.map(L)),null)}negate(){if(!this.negated){const L=[];for(let x of this.expr)L.push(x.negate());this.negated=f.create(L,this,!0)}return this.negated}}class f{constructor(L,x){this.expr=L,this.negated=x,this.type=9}static create(L,x,M){return f._normalizeArr(L,x,M)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let x=0,M=this.expr.length;x<M;x++){const V=P(this.expr[x],L.expr[x]);if(V!==0)return V}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let x=0,M=this.expr.length;x<M;x++)if(!this.expr[x].equals(L.expr[x]))return!1;return!0}return!1}substituteConstants(){const L=d(this.expr);return L===this.expr?this:f.create(L,this.negated,!1)}evaluate(L){for(let x=0,M=this.expr.length;x<M;x++)if(this.expr[x].evaluate(L))return!0;return!1}static _normalizeArr(L,x,M){let V=[],O=!1;if(L){for(let W=0,q=L.length;W<q;W++){const N=L[W];if(!!N){if(N.type===0){O=!0;continue}if(N.type===1)return E.INSTANCE;if(N.type===9){V=V.concat(N.expr);continue}V.push(N)}}if(V.length===0&&O)return u.INSTANCE;V.sort(P)}if(V.length!==0){if(V.length===1)return V[0];for(let W=1;W<V.length;W++)V[W-1].equals(V[W])&&(V.splice(W,1),W--);if(V.length===1)return V[0];if(M){for(let W=0;W<V.length;W++)for(let q=W+1;q<V.length;q++)A(V[W],V[q])&&(V.splice(q,1),q--);if(V.length===1)return V[0]}return new f(V,x)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(let x of this.expr)L.push(...x.keys());return L}map(L){return new f(this.expr.map(x=>x.map(L)),null)}negate(){if(!this.negated){let L=[];for(let x of this.expr)L.push(x.negate());for(;L.length>1;){const x=L.shift(),M=L.shift(),V=[];for(const W of U(x))for(const q of U(M))V.push(c.create([W,q],null));const O=L.length===0;L.unshift(f.create(V,null,O))}this.negated=L[0]}return this.negated}}class l extends h{constructor(L,x,M){super(L,null);this._defaultValue=x,typeof M=="object"?l._info.push({...M,key:L}):M!==!0&&l._info.push({key:L,description:M,type:x!=null?typeof x:void 0})}static all(){return l._info.values()}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return p.create(this.key,L)}notEqualsTo(L){return w.create(this.key,L)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function b(B,L){return B<L?-1:B>L?1:0}function T(B,L,x,M){return B<x?-1:B>x?1:L<M?-1:L>M?1:0}function A(B,L){if(L.type===6&&B.type!==9&&B.type!==6){for(const V of L.expr)if(B.equals(V))return!0}const x=B.negate(),M=U(x).concat(U(L));M.sort(P);for(let V=0;V<M.length;V++){const W=M[V].negate();for(let q=V+1;q<M.length;q++){const N=M[q];if(W.equals(N))return!0}}return!1}e.implies=A;function U(B){return B.type===9?B.expr:[B]}}),define(pe[182],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(pe[183],ve([0,1,10,156,4]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(a){a.WIN32_X64="win32-x64",a.WIN32_IA32="win32-ia32",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function i(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=i;function k(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function S(a,r){switch(a){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function D(a,r){return r==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function R(a,r,g){return D(r,g)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===g?!0:P(g).includes(a)}e.isTargetPlatformCompatible=R;function P(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function u(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=u;var E;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var h;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var p;(function(a){a.Install="install",a.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var v;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService");var I;(function(a){a.Unsupported="Unsupported",a.UnsupportedPreRelease="UnsupportedPreRelease",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal"})(I=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(r,g){super(r);this.code=g,this.name=g}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,F.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,F.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,y.createDecorator)("IExtensionManagementCLIService")}),define(pe[184],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(pe[185],ve([0,1,37,10,9,12,94,28,112,158,184]),function(Y,e,m,F,y,C,i,k,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=D.localize(0,null);class u{async getDefaultTerminalForPlatforms(){return{windows:E.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class E extends u{openTerminal(r,g){return this.spawnTerminal(m,r,S.getWindowsShell(),g)}spawnTerminal(r,g,o,_){const n=g.windowsExec||E.getDefaultTerminalWindows();_&&_[1]===":"&&(_=_[0].toUpperCase()+_.substr(1));const t=y.basename(n).toLowerCase();if(t==="cmder"||t==="cmder.exe")return r.spawn(n,_?[_]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return n.indexOf(" ")>=0&&s.push('""'),s.push(n),(t==="wt"||t==="wt.exe")&&s.push("-d ."),new Promise((d,c)=>{const f=v(process),l=r.spawn(o,s,{cwd:_,env:f});l.on("error",c),l.on("exit",()=>d())})}runInTerminal(r,g,o,_,n){const t="windowsExec"in n&&n.windowsExec?n.windowsExec:E.getDefaultTerminalWindows();return new Promise((s,d)=>{const c=`"${g} - ${P}"`,f=`""${o.join('" "')}" & pause"`,l=["/c","start",c,"/wait",t,"/c",f],b=Object.assign({},v(process),_);Object.keys(b).filter(U=>b[U]===null).forEach(U=>delete b[U]);const T={cwd:g,env:b,windowsVerbatimArguments:!0};m.spawn(E.CMD,l,T).on("error",U=>{d(I(U))}),s(void 0)})}static getDefaultTerminalWindows(){if(!E._DEFAULT_TERMINAL_WINDOWS){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");E._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return E._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=E,E.CMD="cmd.exe";class h extends u{openTerminal(r,g){return this.spawnTerminal(m,r,g)}runInTerminal(r,g,o,_,n){const t=n.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((s,d)=>{if(t===R.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const c=t===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",l=[F.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,Y).fsPath,"-t",r||P,"-w",g];for(let A of o)l.push("-a"),l.push(A);if(_){const A=Object.assign({},v(process),_);for(let U in A){const B=A[U];B===null?(l.push("-u"),l.push(U)):(l.push("-e"),l.push(`${U}=${B}`))}}let b="";const T=m.spawn(h.OSASCRIPT,l);T.on("error",A=>{d(I(A))}),T.stderr.on("data",A=>{b+=A.toString()}),T.on("exit",A=>{if(A===0)s(void 0);else if(b){const U=b.split(`
`,1);d(new Error(U[0]))}else d(new Error(D.localize(1,null,c,A)))})}else d(new Error(D.localize(2,null,t)))})}spawnTerminal(r,g,o){const _=g.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((n,t)=>{const s=["-a",_];o&&s.push(o);const d=v(process),c=r.spawn("/usr/bin/open",s,{cwd:o,env:d});c.on("error",t),c.on("exit",()=>n())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class p extends u{openTerminal(r,g){return this.spawnTerminal(m,r,g)}runInTerminal(r,g,o,_,n){const t=n.linuxExec?Promise.resolve(n.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((s,d)=>{let c=[];t.then(f=>{f.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const l=`${w(o)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;c.push(`''${l}''`);const b=Object.assign({},v(process),_);Object.keys(b).filter(B=>b[B]===null).forEach(B=>delete b[B]);const T={cwd:g,env:b};let A="";const U=m.spawn(f,c,T);U.on("error",B=>{d(I(B))}),U.stderr.on("data",B=>{A+=B.toString()}),U.on("exit",B=>{if(B===0)s(void 0);else if(A){const L=A.split(`
`,1);d(new Error(L[0]))}else d(new Error(D.localize(4,null,f,B)))})})})}static async getDefaultTerminalLinuxReady(){if(!p._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)p._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const r=await k.Promises.exists("/etc/debian_version");p._DEFAULT_TERMINAL_LINUX_READY=new Promise(g=>{r?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(r,g,o){const _=g.linuxExec?Promise.resolve(g.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,t)=>{_.then(s=>{const d=v(process),c=r.spawn(s,[],{cwd:o,env:d});c.on("error",t),c.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=p,p.WAIT_MESSAGE=D.localize(3,null);function v(a){const r={...a.env};return(0,i.sanitizeProcessEnvironment)(r),r}function I(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(D.localize(5,null,a.path)):a}function w(a){let r="";for(let g of a)g.indexOf(" ")>=0?r+='"'+g+'"':r+=g,r+=" ";return r}}),define(pe[42],ve([0,1,24,9,8,13,2,159,4]),function(Y,e,m,F,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function D(M){return M.create===!0}e.isFileOpenForWriteOptions=D;var R;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var P;(function(M){M[M.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var u;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(u=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=E;function h(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=h;function p(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function v(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=v;var I;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(V,O){super(V);this.code=O}}e.FileSystemProviderError=w;function a(M,V){const O=new w(M.toString(),V);return g(O,V),O}e.createFileSystemProviderError=a;function r(M){return M||a((0,k.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=r;function g(M,V){return M.name=V?`${V} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=g;function o(M){if(!M)return I.Unknown;if(M instanceof w)return M.code;const V=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!V)return I.Unknown;switch(V[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=o;function _(M){if(M instanceof f)return M.fileOperationResult;switch(o(M)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=_;var n;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(V,O,W){this.resource=V,this.operation=O,this.target=W}isOperation(V){return this.operation===V}}e.FileOperationEvent=t;var s;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class d{constructor(V,O){this.added=void 0,this.updated=void 0,this.deleted=void 0;const W=new Map;for(const q of V){const N=W.get(q.type);N?N.push([q.resource,q]):W.set(q.type,[[q.resource,q]])}for(const[q,N]of W)switch(q){case 1:this.added=m.TernarySearchTree.forUris(()=>O),this.added.fill(N);break;case 0:this.updated=m.TernarySearchTree.forUris(()=>O),this.updated.fill(N);break;case 2:this.deleted=m.TernarySearchTree.forUris(()=>O),this.deleted.fill(N);break}}contains(V,...O){return this.doContains(V,{includeChildren:!1},...O)}affects(V,...O){return this.doContains(V,{includeChildren:!0},...O)}doContains(V,O,...W){if(!V)return!1;const q=W.length>0;return!!((!q||W.includes(1))&&(this.added?.get(V)||O.includeChildren&&this.added?.findSuperstr(V))||(!q||W.includes(0))&&(this.updated?.get(V)||O.includeChildren&&this.updated?.findSuperstr(V))||(!q||W.includes(2))&&(this.deleted?.findSubstr(V)||O.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function c(M,V,O){return!M||!V||M===V||V.length>M.length?!1:(V.charAt(V.length-1)!==F.sep&&(V+=F.sep),O?(0,y.startsWithIgnoreCase)(M,V):M.indexOf(V)===0)}e.isParent=c;class f extends Error{constructor(V,O,W){super(V);this.fileOperationResult=O,this.options=W}}e.FileOperationError=f;class l extends f{constructor(V,O,W){super(V,2,W);this.stat=O}}e.NotModifiedSinceFileOperationError=l;var b;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(b=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function A(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=A;async function U(M,V){if(!V.hasProvider(i.URI.from({scheme:M.scheme})))return new Promise(O=>{const W=V.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===M.scheme&&q.added&&(W.dispose(),O())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(V){return(0,C.isNumber)(V)||(V=0),V<B.KB?(0,k.localize)(1,null,V.toFixed(0)):V<B.MB?(0,k.localize)(2,null,(V/B.KB).toFixed(2)):V<B.GB?(0,k.localize)(3,null,(V/B.MB).toFixed(2)):V<B.TB?(0,k.localize)(4,null,(V/B.GB).toFixed(2)):(0,k.localize)(5,null,(V/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var L;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(L=e.Arch||(e.Arch={}));function x(M){return{maxFileSize:M===0?300*B.MB:16*B.GB,maxHeapSize:M===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=x}),define(pe[85],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...y){this._entries=new Map;for(let[C,i]of y)this.set(C,i)}set(y,C){const i=this._entries.get(y);return this._entries.set(y,C),i}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=m}),define(pe[186],ve([0,1,18,15,114,179,4,85]),function(Y,e,m,F,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class D extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class R{constructor(h=new k.ServiceCollection,p=!1,v){this._activeInstantiations=new Set,this._services=h,this._strict=p,this._parent=v,this._services.set(i.IInstantiationService,this)}createChild(h){return new R(h,this._strict,this)}invokeFunction(h,...p){let v=u.traceInvocation(h),I=!1;try{return h({get:a=>{if(I)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(a,v);if(!r)throw new Error(`[invokeFunction] unknown service '${a}'`);return r}},...p)}finally{I=!0,v.stop()}}createInstance(h,...p){let v,I;return h instanceof y.SyncDescriptor?(v=u.traceCreation(h.ctor),I=this._createInstance(h.ctor,h.staticArguments.concat(p),v)):(v=u.traceCreation(h),I=this._createInstance(h,p,v)),v.stop(),I}_createInstance(h,p=[],v){let I=i._util.getServiceDependencies(h).sort((r,g)=>r.index-g.index),w=[];for(const r of I){let g=this._getOrCreateServiceInstance(r.id,v);if(!g&&this._strict&&!r.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${r.id}.`);w.push(g)}let a=I.length>0?I[0].index:p.length;if(p.length!==a){console.warn(`[createInstance] First service dependency of ${h.name} at position ${a+1} conflicts with ${p.length} static arguments`);let r=a-p.length;r>0?p=p.concat(new Array(r)):p=p.slice(0,a)}return new h(...[...p,...w])}_setServiceInstance(h,p){if(this._services.get(h)instanceof y.SyncDescriptor)this._services.set(h,p);else if(this._parent)this._parent._setServiceInstance(h,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let p=this._services.get(h);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):p}_getOrCreateServiceInstance(h,p){let v=this._getServiceInstanceOrDescriptor(h);return v instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,v,p.branch(h,!0)):(p.branch(h,!1),v)}_safeCreateAndCacheServiceInstance(h,p,v){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,p,v)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,p,v){const I=new C.Graph(r=>r.id.toString());let w=0;const a=[{id:h,desc:p,_trace:v}];for(;a.length;){const r=a.pop();if(I.lookupOrInsertNode(r),w++>1e3)throw new D(I);for(let g of i._util.getServiceDependencies(r.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(g.id);if(!o&&!g.optional&&console.warn(`[createInstance] ${h} depends on ${g.id} which is NOT registered.`),o instanceof y.SyncDescriptor){const _={id:g.id,desc:o,_trace:r._trace.branch(g.id,!0)};I.insertEdge(r,_),a.push(_)}}}for(;;){const r=I.roots();if(r.length===0){if(!I.isEmpty())throw new D(I);break}for(const{data:g}of r){if(this._getServiceInstanceOrDescriptor(g.id)instanceof y.SyncDescriptor){const _=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,_)}I.removeNode(g)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,p,v=[],I,w){if(this._services.get(h)instanceof y.SyncDescriptor)return this._createServiceInstance(p,v,I,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,p,v,I,w);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(h,p=[],v,I){if(v){const w=new m.IdleValue(()=>this._createInstance(h,p,I));return new Proxy(Object.create(null),{get(a,r){if(r in a)return a[r];let g=w.value,o=g[r];return typeof o!="function"||(o=o.bind(g),a[r]=o),o},set(a,r,g){return w.value[r]=g,!0}})}else return this._createInstance(h,p,I)}}e.InstantiationService=R;var P;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(P||(P={}));class u{constructor(h,p){this.type=h,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return S?new u(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):u._None}static traceCreation(h){return S?new u(0,h.name):u._None}branch(h,p){let v=new u(2,h.toString());return this._dep.push([h,p,v]),v}stop(){let h=Date.now()-this._start;u._totals+=h;let p=!1;function v(w,a){let r=[],g=new Array(w+1).join("	");for(const[o,_,n]of a._dep)if(_&&n){p=!0,r.push(`${g}CREATES -> ${o}`);let t=v(w+1,n);t&&r.push(t)}else r.push(`${g}uses -> ${o}`);return r.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${u._totals.toFixed(2)}ms)`];(h>2||p)&&console.log(I.join(`
`))}}u._None=new class extends u{constructor(){super(-1,null)}stop(){}branch(){return this}},u._totals=0}),define(pe[11],ve([0,1,50,3,6,12,4]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,i.createDecorator)("logService"),e.ILoggerService=(0,i.createDecorator)("loggerService");function k(){return new Date().toISOString()}var S;(function(_){_[_.Trace=0]="Trace",_[_.Debug=1]="Debug",_[_.Info=2]="Info",_[_.Warning=3]="Warning",_[_.Error=4]="Error",_[_.Critical=5]="Critical",_[_.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function D(_,n,t){switch(n){case S.Trace:_.trace(t);break;case S.Debug:_.debug(t);break;case S.Info:_.info(t);break;case S.Warning:_.warn(t);break;case S.Error:_.error(t);break;case S.Critical:_.critical(t);break;default:throw new Error("Invalid log level")}}e.log=D;function R(_){let n="";for(let t=0;t<_.length;t++){let s=_[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch(d){}n+=(t>0?" ":"")+s}return n}e.format=R;class P extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class u extends P{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(S.Trace)&&this.log(S.Trace,R([n,...t]))}debug(n,...t){this.checkLogLevel(S.Debug)&&this.log(S.Debug,R([n,...t]))}info(n,...t){this.checkLogLevel(S.Info)&&this.log(S.Info,R([n,...t]))}warn(n,...t){this.checkLogLevel(S.Warning)&&this.log(S.Warning,R([n,...t]))}error(n,...t){if(this.checkLogLevel(S.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(S.Error,R(s))}else this.log(S.Error,R([n,...t]))}critical(n,...t){this.checkLogLevel(S.Critical)&&this.log(S.Critical,R([n,...t]))}flush(){}}e.AbstractMessageLogger=u;class E extends P{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!C.isWindows}trace(n,...t){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}debug(n,...t){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}info(n,...t){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}warn(n,...t){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,n,...t):console.warn(`[main ${k()}]`,n,...t))}error(n,...t){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,n,...t):console.error(`[main ${k()}]`,n,...t))}critical(n,...t){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,n,...t):console.error(`[main ${k()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class h extends P{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class p extends P{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,m.toErrorMessage)(n,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class v extends P{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const s of this.logServices)s.trace(n,...t)}debug(n,...t){for(const s of this.logServices)s.debug(n,...t)}info(n,...t){for(const s of this.logServices)s.info(n,...t)}warn(n,...t){for(const s of this.logServices)s.warn(n,...t)}error(n,...t){for(const s of this.logServices)s.error(n,...t)}critical(n,...t){for(const s of this.logServices)s.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=v;class I extends y.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=I;class w extends y.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,t?.always?S.Trace:this.logLevel,t),this.loggers.set(n.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class a{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(n){}getLevel(){return S.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=a;function r(_){if(_.verbose)return S.Trace;if(typeof _.logLevel=="string"){const n=g(_.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function g(_){switch(_){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=g;function o(_){switch(_){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=o}),define(pe[187],ve([0,1,42,11]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function y(k,S,D,R,P){try{const u=await new Promise((h,p)=>{Y(["spdlog"],h,p)});u.setFlushOn(F.LogLevel.Trace);const E=await u.createAsyncRotatingLogger(k,S,D,R);return P&&E.clearFormatters(),E}catch(u){console.error(u)}return null}function C(k,S,D){switch(S){case F.LogLevel.Trace:k.trace(D);break;case F.LogLevel.Debug:k.debug(D);break;case F.LogLevel.Info:k.info(D);break;case F.LogLevel.Warning:k.warn(D);break;case F.LogLevel.Error:k.error(D);break;case F.LogLevel.Critical:k.critical(D);break;default:throw new Error("Invalid log level")}}class i extends F.AbstractMessageLogger{constructor(S,D,R,P,u){super();this.buffer=[],this.setLevel(u),this._loggerCreationPromise=this._createSpdLogLogger(S,D,R,P),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}async _createSpdLogLogger(S,D,R,P){const u=R?6:1,E=30/u*m.ByteSize.MB,h=await y(S,D,E,u,P);if(h){this._logger=h,this._logger.setLevel(this.getLevel());for(const{level:p,message:v}of this.buffer)C(this._logger,p,v);this.buffer=[]}}log(S,D){this._logger?C(this._logger,S,D):this.getLevel()<=S&&this.buffer.push({level:S,message:D})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=i}),define(pe[116],ve([0,1,48,160,4]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var i;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(i=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function D(h,p){return p-h}S.compare=D;const R=Object.create(null);R[S.Error]=(0,F.localize)(0,null),R[S.Warning]=(0,F.localize)(1,null),R[S.Info]=(0,F.localize)(2,null);function P(h){return R[h]||""}S.toString=P;function u(h){switch(h){case m.default.Error:return S.Error;case m.default.Warning:return S.Warning;case m.default.Info:return S.Info;case m.default.Ignore:return S.Hint}}S.fromSeverity=u;function E(h){switch(h){case S.Error:return m.default.Error;case S.Warning:return m.default.Warning;case S.Info:return m.default.Info;case S.Hint:return m.default.Ignore}}S.toSeverity=E}(i=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(S){const D="";function R(u){return P(u,!0)}S.makeKey=R;function P(u,E){let h=[D];return u.source?h.push(u.source.replace("\xA6","\\\xA6")):h.push(D),u.code?typeof u.code=="string"?h.push(u.code.replace("\xA6","\\\xA6")):h.push(u.code.value.replace("\xA6","\\\xA6")):h.push(D),u.severity!==void 0&&u.severity!==null?h.push(i.toString(u.severity)):h.push(D),u.message&&E?h.push(u.message.replace("\xA6","\\\xA6")):h.push(D),u.startLineNumber!==void 0&&u.startLineNumber!==null?h.push(u.startLineNumber.toString()):h.push(D),u.startColumn!==void 0&&u.startColumn!==null?h.push(u.startColumn.toString()):h.push(D),u.endLineNumber!==void 0&&u.endLineNumber!==null?h.push(u.endLineNumber.toString()):h.push(D),u.endColumn!==void 0&&u.endColumn!==null?h.push(u.endColumn.toString()):h.push(D),h.push(D),h.join("\xA6")}S.makeKeyOptionalMessage=P})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(pe[188],ve([0,1,3,48,4]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,y.createDecorator)("notificationService");var C;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var i;(function(D){D[D.OFF=0]="OFF",D[D.SILENT=1]="SILENT",D[D.ERROR=2]="ERROR"})(i=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new S,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=k;class S{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=S}),define(pe[189],ve([0,1,6,8,2,4]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function i(S,D){return y.URI.isUri(S)?(0,F.equalsIgnoreCase)(S.scheme,D):(0,F.startsWithIgnoreCase)(S,D+":")}e.matchesScheme=i;function k(S,...D){return D.some(R=>i(S,R))}e.matchesSomeScheme=k}),define(pe[190],ve([0,1,10,12,40,23]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let i;if(typeof F.globals.vscode!="undefined"&&typeof F.globals.vscode.context!="undefined"){const k=F.globals.vscode.context.configuration();if(k)i=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const k=(0,C.dirname)(m.FileAccess.asFileUri("",Y));i=Y.__$__nodeRequire((0,C.joinPath)(k,"product.json").fsPath);const S=Y.__$__nodeRequire((0,C.joinPath)(k,"package.json").fsPath);y.env.VSCODE_DEV&&Object.assign(i,{nameShort:`${i.nameShort} Dev`,nameLong:`${i.nameLong} Dev`,dataFolderName:`${i.dataFolderName}-dev`}),Object.assign(i,{version:S.version})}else i={},Object.keys(i).length===0&&Object.assign(i,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=i});var He=this&&this.__param||function(Y,e){return function(m,F){e(m,F,Y)}};define(pe[117],ve([0,1,18,21,6,4]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var i;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(i=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let S=class extends y.Disposable{constructor(P,u){super();this.deferred=new m.DeferredPromise,u.withProgress(P,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,y.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};S=je([He(1,e.IProgressService)],S),e.UnmanagedProgress=S;class D extends y.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new y.DisposableStore)}start(P){this.stop();const u=++this.currentOperationId,E=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{u===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,y.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,y.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,y.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:u,token:E.token,stop:()=>this.doStop(u),isCurrent:()=>this.currentOperationId===u}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(pe[51],ve([0,1,56,13]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.data=new Map}add(i,k){m.ok(F.isString(i)),m.ok(F.isObject(k)),m.ok(!this.data.has(i),"There is already an extension with this id"),this.data.set(i,k)}knows(i){return this.data.has(i)}as(i){return this.data.get(i)||null}}e.Registry=new y}),define(pe[191],ve([0,1,3,51]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class C{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,D){this.schemasById[y(S)]=D,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const i=new C;F.Registry.add(e.Extensions.JSONContribution,i)}),define(pe[118],ve([0,1,16,3,13,155,191,51]),function(Y,e,m,F,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=k.Registry.as(i.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(g,o=!0){this.registerConfigurations([g],o)}registerConfigurations(g,o=!0){const _=this.doRegisterConfigurations(g,o);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:_})}deregisterConfigurations(g){const o=this.doDeregisterConfigurations(g);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:g,remove:o}){const _=[];_.push(...this.doDeregisterConfigurations(o)),_.push(...this.doRegisterConfigurations(g,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,m.distinct)(_)})}registerDefaultConfigurations(g){const o=[],_=[];for(const{overrides:n,source:t}of g)for(const s in n)if(o.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const d={...this.configurationDefaultsOverrides.get(s)?.value||{},...n[s]};this.configurationDefaultsOverrides.set(s,{source:t,value:d});const c={type:"object",default:d,description:C.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:d,source:y.isString(t)?void 0:t};_.push(...h(s)),this.configurationProperties[s]=c,this.defaultLanguageConfigurationOverridesNode.properties[s]=c}else{this.configurationDefaultsOverrides.set(s,{value:n[s],source:t});const d=this.configurationProperties[s];d&&(this.updatePropertyDefaultValue(s,d),this.updateSchema(s,d))}this.registerOverrideIdentifiers(_),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(g){const o=[];for(const{overrides:_,source:n}of g)for(const t in _){const s=this.configurationDefaultsOverrides.get(t),d=y.isString(n)?n:n?.id,c=y.isString(s?.source)?s?.source:s?.source?.id;if(d===c)if(o.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const f=this.configurationProperties[t];f&&(this.updatePropertyDefaultValue(t,f),this.updateSchema(t,f))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const o of g)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(g,o){const _=[];return g.forEach(n=>{_.push(...this.validateAndRegisterProperties(n,o,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),_}doDeregisterConfigurations(g){const o=[],_=n=>{if(n.properties)for(const t in n.properties)o.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>_(t))};for(const n of g){_(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return o}validateAndRegisterProperties(g,o=!0,_,n,t=3){t=y.isUndefinedOrNull(g.scope)?t:g.scope;let s=[],d=g.properties;if(d)for(let f in d){if(o&&w(f)){delete d[f];continue}const l=d[f];if(l.source=_,l.defaultDefaultValue=d[f].default,this.updatePropertyDefaultValue(f,l),e.OVERRIDE_PROPERTY_REGEX.test(f)?l.scope=void 0:(l.scope=y.isUndefinedOrNull(l.scope)?t:l.scope,l.restricted=y.isUndefinedOrNull(l.restricted)?!!n?.includes(f):l.restricted),d[f].hasOwnProperty("included")&&!d[f].included){this.excludedConfigurationProperties[f]=d[f],delete d[f];continue}else this.configurationProperties[f]=d[f];!d[f].deprecationMessage&&d[f].markdownDeprecationMessage&&(d[f].deprecationMessage=d[f].markdownDeprecationMessage),s.push(f)}let c=g.allOf;if(c)for(let f of c)s.push(...this.validateAndRegisterProperties(f,o,_,n,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(g){const o=_=>{let n=_.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let t=_.allOf;t&&t.forEach(o)};o(g)}updateSchema(g,o){switch(e.allSettings.properties[g]=o,o.scope){case 1:e.applicationSettings.properties[g]=o;break;case 2:e.machineSettings.properties[g]=o;break;case 6:e.machineOverridableSettings.properties[g]=o;break;case 3:e.windowSettings.properties[g]=o;break;case 4:e.resourceSettings.properties[g]=o;break;case 5:e.resourceSettings.properties[g]=o,this.resourceLanguageSettingsSchema.properties[g]=o;break}}removeFromSchema(g,o){switch(delete e.allSettings.properties[g],o.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g],delete this.resourceLanguageSettingsSchema.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const o=`[${g}]`,_={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,_),e.allSettings.properties[o]=_,e.applicationSettings.properties[o]=_,e.machineSettings.properties[o]=_,e.machineOverridableSettings.properties[o]=_,e.windowSettings.properties[o]=_,e.resourceSettings.properties[o]=_}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const g={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,o){const _=this.configurationDefaultsOverrides.get(g);let n=_?.value,t=_?.source;y.isUndefined(n)&&(n=o.defaultDefaultValue,t=void 0),y.isUndefined(n)&&(n=v(o.type)),o.default=n,o.defaultValueSource=t}}const u="\\[([^\\]]+)\\]",E=new RegExp(u,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(r){const g=[];if(e.OVERRIDE_PROPERTY_REGEX.test(r)){let o=E.exec(r);for(;o?.length;){const _=o[1].trim();_&&g.push(_),o=E.exec(r)}}return(0,m.distinct)(g)}e.overrideIdentifiersFromKey=h;function p(r){return r.reduce((g,o)=>`${g}[${o}]`,"")}e.keyFromOverrideIdentifiers=p;function v(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const I=new P;k.Registry.add(e.Extensions.Configuration,I);function w(r){return r.trim()?e.OVERRIDE_PROPERTY_REGEX.test(r)?C.localize(7,null,r):I.getConfigurationProperties()[r]!==void 0?C.localize(8,null,r):null:C.localize(6,null)}e.validateProperty=w;function a(){const r=[],g=I.getConfigurationProperties();for(const o of Object.keys(g))r.push([o,g[o].scope]);return r.push(["launch",4]),r.push(["task",4]),r}e.getScopes=a}),define(pe[192],ve([0,1,16,3,58,6,24,25,13,2,115,118,51]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(n={},t=[],s=[]){this._contents=n,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,R.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const s=this.getContentsForOverrideIdentifer(t);return s?n?(0,R.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const s of this.overrides)s.identifiers.includes(n)&&t.push(...s.keys);return m.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return m.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=k.deepClone(this.contents),s=k.deepClone(this.overrides),d=[...this.keys];for(const c of n){this.mergeContents(t,c.contents);for(const f of c.overrides){const[l]=s.filter(b=>m.equals(b.identifiers,f.identifiers));l?(this.mergeContents(l.contents,f.contents),l.keys.push(...f.keys),l.keys=m.distinct(l.keys)):s.push(k.deepClone(f))}for(const f of c.keys)d.indexOf(f)===-1&&d.push(f)}return new E(t,d,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const d of m.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[d],f=t[d];f&&(typeof c=="object"&&typeof f=="object"?(c=k.deepClone(c),this.mergeContents(c,f)):c=f),s[d]=c}return new E(s,this.keys,this.overrides)}mergeContents(n,t){for(const s of Object.keys(t)){if(s in n&&S.isObject(n[s])&&S.isObject(t[s])){this.mergeContents(n[s],t[s]);continue}n[s]=k.deepClone(t[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?k.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,s=null;const d=c=>{c&&(s?this.mergeContents(s,c):s=k.deepClone(c))};for(const c of this.overrides)m.equals(c.identifiers,[n])?t=c.contents:c.identifiers.includes(n)&&d(c.contents);return d(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,R.addToValueTree)(this.contents,n,t,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,R.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let s=0;s<t;s++)n.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=E;class h extends E{constructor(n={}){const t=u.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(t),d=Object.create(null),c=[];for(const f in t){const l=n[f],b=l!==void 0?l:t[f].default;(0,R.addToValueTree)(d,f,b,T=>console.error(`Conflict in default settings: ${T}`))}for(const f of Object.keys(d))P.OVERRIDE_PROPERTY_REGEX.test(f)&&c.push({identifiers:(0,P.overrideIdentifiersFromKey)(f),keys:Object.keys(d[f]),contents:(0,R.toValuesTree)(d[f],l=>console.error(`Conflict in default settings file: ${l}`))});super(d,s,c)}}e.DefaultConfigurationModel=h;class p{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!S.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:s,keys:d,overrides:c,restricted:f}=this.doParseRaw(n,t);this._configurationModel=new E(s,d,c),this._restrictedConfigurations=f||[]}doParseContent(n){let t={},s=null,d=[],c=[],f=[];function l(T){Array.isArray(d)?d.push(T):s!==null&&(d[s]=T)}let b={onObjectBegin:()=>{let T={};l(T),c.push(d),d=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{d=c.pop()},onArrayBegin:()=>{let T=[];l(T),c.push(d),d=T,s=null},onArrayEnd:()=>{d=c.pop()},onLiteralValue:l,onError:(T,A,U)=>{f.push({error:T,offset:A,length:U})}};if(n)try{y.visit(n,b),t=d[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return t}doParseRaw(n,t){const s=u.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),d=this.filter(n,s,!0,t);n=d.raw;const c=(0,R.toValuesTree)(n,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),f=Object.keys(n),l=this.toOverrides(n,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:c,keys:f,overrides:l,restricted:d.restricted}}filter(n,t,s,d){if(!d?.scopes&&!d?.skipRestricted)return{raw:n,restricted:[]};const c={},f=[];for(let l in n)if(P.OVERRIDE_PROPERTY_REGEX.test(l)&&s){const b=this.filter(n[l],t,!1,d);c[l]=b.raw,f.push(...b.restricted)}else{const b=t[l],T=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&f.push(l),(T===void 0||d.scopes===void 0||d.scopes.includes(T))&&(d.skipRestricted&&b?.restricted||(c[l]=n[l]))}return{raw:c,restricted:f}}toOverrides(n,t){const s=[];for(const d of Object.keys(n))if(P.OVERRIDE_PROPERTY_REGEX.test(d)){const c={};for(const f in n[d])c[f]=n[d][f];s.push({identifiers:(0,P.overrideIdentifiersFromKey)(d),keys:Object.keys(c),contents:(0,R.toValuesTree)(c,t)})}return s}}e.ConfigurationModelParser=p;class v extends C.Disposable{constructor(n,t,s,d){super();this.userSettingsResource=n,this.scopes=t,this.fileService=d,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class I{constructor(n,t,s=new E,d=new E,c=new i.ResourceMap,f=new E,l=new i.ResourceMap,b=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=d,this._folderConfigurations=c,this._memoryConfiguration=f,this._memoryConfigurationByResource=l,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new i.ResourceMap,this._userConfiguration=null}getValue(n,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(n)}updateValue(n,t,s={}){let d;s.resource?(d=this._memoryConfigurationByResource.get(s.resource),d||(d=new E,this._memoryConfigurationByResource.set(s.resource,d))):d=this._memoryConfiguration,t===void 0?d.removeValue(n):d.setValue(n,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,s){const d=this.getConsolidateConfigurationModel(t,s),c=this.getFolderConfigurationModelForResource(t.resource,s),f=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,l=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),b=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),T=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),A=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),U=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,B=c?t.overrideIdentifier?c.freeze().override(t.overrideIdentifier).getValue(n):c.freeze().getValue(n):void 0,L=t.overrideIdentifier?f.override(t.overrideIdentifier).getValue(n):f.getValue(n),x=d.getValue(n),M=m.distinct(m.flatten(d.overrides.map(V=>V.identifiers))).filter(V=>d.getOverrideValue(n,V)!==void 0);return{defaultValue:l,userValue:b,userLocalValue:T,userRemoteValue:A,workspaceValue:U,workspaceFolderValue:B,memoryValue:L,value:x,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:c?.freeze().getValue(n),override:t.overrideIdentifier?c?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:L!==void 0?{value:f.getValue(n),override:t.overrideIdentifier?f.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const s=[];if(!t){const{added:d,updated:c,removed:f}=g(this._defaultConfiguration,n);t=[...d,...c,...f]}for(const d of t)for(const c of(0,P.overrideIdentifiersFromKey)(d)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(c),l=n.getKeysForOverrideIdentifier(c),b=[...l.filter(T=>f.indexOf(T)===-1),...f.filter(T=>l.indexOf(T)===-1),...f.filter(T=>!k.equals(this._defaultConfiguration.override(c).getValue(T),n.override(c).getValue(T)))];s.push([c,b])}return this.updateDefaultConfiguration(n),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:s,removed:d,overrides:c}=g(this.localUserConfiguration,n),f=[...t,...s,...d];return f.length&&this.updateLocalUserConfiguration(n),{keys:f,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:s,removed:d,overrides:c}=g(this.remoteUserConfiguration,n);let f=[...t,...s,...d];return f.length&&this.updateRemoteUserConfiguration(n),{keys:f,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:s,removed:d,overrides:c}=g(this.workspaceConfiguration,n);let f=[...t,...s,...d];return f.length&&this.updateWorkspaceConfiguration(n),{keys:f,overrides:c}}compareAndUpdateFolderConfiguration(n,t){const s=this.folderConfigurations.get(n),{added:d,updated:c,removed:f,overrides:l}=g(s,t);let b=[...d,...c,...f];return(b.length||!s)&&this.updateFolderConfiguration(n,t),{keys:b,overrides:l}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:d,removed:c,overrides:f}=g(t,void 0);return{keys:[...s,...d,...c],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let s=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const d=t.getFolder(n);d&&(s=this.getFolderConsolidatedConfiguration(d.uri)||s);const c=this._memoryConfigurationByResource.get(n);c&&(s=s.merge(c))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(n);d?(t=s.merge(d),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=s}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const s=t.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:s,overrides:d,keys:c}=this._folderConfigurations.get(t);return n.push([t,{contents:s,overrides:d,keys:c}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(d=>t.add(d))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),d=this.parseConfigurationModel(n.workspace),c=n.folders.reduce((f,l)=>(f.set(D.URI.revive(l[0]),this.parseConfigurationModel(l[1])),f),new i.ResourceMap);return new I(t,s,new E,d,c,new E,new i.ResourceMap,!1)}static parseConfigurationModel(n){return new E(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=I;function w(..._){if(_.length===0)return{keys:[],overrides:[]};if(_.length===1)return _[0];const n=new Set,t=new Map;for(const d of _)d.keys.forEach(c=>n.add(c)),d.overrides.forEach(([c,f])=>{const l=(0,i.getOrSet)(t,c,new Set);f.forEach(b=>l.add(b))});const s=[];return t.forEach((d,c)=>s.push([c,[...d.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=w;class a{constructor(n,t,s,d){this.change=n,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=d,this._previousConfiguration=void 0;const c=new Set;n.keys.forEach(l=>c.add(l)),n.overrides.forEach(([,l])=>l.forEach(b=>c.add(b))),this.affectedKeys=[...c.values()];const f=new E;this.affectedKeys.forEach(l=>f.setValue(l,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,d=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!k.equals(s,d)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let s=(0,R.toValuesTree)({[t]:!0},()=>{}),d;for(;typeof s=="object"&&(d=Object.keys(s)[0]);){if(n=n[d],!n)return!1;s=s[d]}return!0}}e.ConfigurationChangeEvent=a;class r extends a{constructor(n,t,s,d){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=s,this.sourceConfig=d}}e.AllKeysConfigurationChangeEvent=r;function g(_,n){const{added:t,removed:s,updated:d}=o(n,_),c=[],f=_?.getAllOverrideIdentifiers()||[],l=n?.getAllOverrideIdentifiers()||[];if(n){const b=l.filter(T=>!f.includes(T));for(const T of b)c.push([T,n.getKeysForOverrideIdentifier(T)])}if(_){const b=f.filter(T=>!l.includes(T));for(const T of b)c.push([T,_.getKeysForOverrideIdentifier(T)])}if(n&&_){for(const b of f)if(l.includes(b)){const T=o({contents:_.getOverrideValue(void 0,b)||{},keys:_.getKeysForOverrideIdentifier(b)},{contents:n.getOverrideValue(void 0,b)||{},keys:n.getKeysForOverrideIdentifier(b)});c.push([b,[...T.added,...T.removed,...T.updated]])}}return{added:t,removed:s,updated:d,overrides:c}}function o(_,n){const t=_?n?_.keys.filter(c=>n.keys.indexOf(c)===-1):[..._.keys]:[],s=n?_?n.keys.filter(c=>_.keys.indexOf(c)===-1):[...n.keys]:[],d=[];if(_&&n){for(const c of n.keys)if(_.keys.indexOf(c)!==-1){const f=(0,R.getConfigurationValue)(n.contents,c),l=(0,R.getConfigurationValue)(_.contents,c);k.equals(f,l)||d.push(c)}}return{added:t,removed:s,updated:d}}}),define(pe[119],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var F;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class y extends Error{constructor(i,k=F.Unknown,S){super(i);this._message=i,this._code=k,this._detail=S,this.isHandled=k===F.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype)}static isTemporarilyNotAvailable(i){return i instanceof y&&i._code===F.TemporarilyNotAvailable}static isNoResolverFound(i){return i instanceof y&&i._code===F.NoResolverFound}static isHandled(i){return i instanceof y&&i.isHandled}}e.RemoteAuthorityResolverError=y}),define(pe[62],ve([0,1,10]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(D){return D.scheme===m.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=F;function y(D){if(!D)return;const R=D.indexOf("+");return R<0?D:D.substr(0,R)}e.getRemoteName=y;function C(D){return D.scheme!==m.Schemas.file&&D.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=C;function i(D){if(D.folders.length)return D.folders.every(R=>C(R.uri))?D.folders[0].uri:void 0;if(D.configuration&&C(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=i;function k(D){return i(D)?.scheme}e.getVirtualWorkspaceScheme=k;function S(D){return i(D)!==void 0}e.isVirtualWorkspace=S}),define(pe[27],ve([0,1,8,4,62]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.getWorkspaceSupportTypeMessage=C;function i(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=i,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class S{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,h){if(typeof E=="undefined"||E===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof E=="string"||typeof h=="string"){let p=typeof E=="string"?E:E.value,v=typeof h=="string"?h:h.value;return m.equalsIgnoreCase(p,v)}return E._lower===h._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=S;function D(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function R(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function P(u,E){if(E){const h=`onResolveRemoteAuthority:${(0,y.getRemoteName)(E)}`;return u.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=P,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(pe[193],ve([0,1,8,27]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function y(h,p){return h.uuid&&p.uuid?h.uuid===p.uuid:h.id===p.id?!0:(0,m.compareIgnoreCase)(h.id,p.id)===0}e.areSameExtensions=y;class C{constructor(p,v){this.version=v,this.id=p.id,this.uuid=p.uuid}key(){return`${this.id}-${this.version}`}equals(p){return p instanceof C?y(this,p)&&this.version===p.version:!1}}e.ExtensionIdentifierWithVersion=C;function i(h,p){return`${h}.${p}`}e.getExtensionId=i;function k(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function S(h,p){return k(i(h,p))}e.getGalleryExtensionId=S;function D(h,p){const v=[],I=w=>{for(const a of v)if(a.some(r=>y(p(r),p(w))))return a;return null};for(const w of h){const a=I(w);a?a.push(w):v.push([w])}return v}e.groupByExtension=D;function R(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function P(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function u(h){const p=new Set;if(h.malicious)for(const v of h.malicious)p.add(v.id);return p}e.getMaliciousExtensionsSet=u;function E(h,p){const v=[],I=p.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const w=I.shift();if(w&&v.every(a=>!y(a.identifier,{id:w}))){const a=h.filter(r=>y(r.identifier,{id:w}));a.length===1&&(v.push(a[0]),I.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=E}),define(pe[120],ve([0,1,3,12,4,11]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var i;(function(h){h.Http="http",h.Https="https"})(i=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=P;function u(h,p){return p?p!==1&&h<1024:!F.isWindows&&h<1024}e.isPortPrivileged=u;let E=class{constructor(p){this.logService=p,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p,v){return this._tunnelProvider=p,p?(this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const p=[],v=Array.from(this._tunnels.values());for(let I of v){const w=Array.from(I.values());for(let a of w){const r=await a.value;r&&p.push(r)}}return p}async dispose(){for(const p of this._tunnels.values()){for(const{value:v}of p.values())await v.then(I=>I?.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,v,I,w,a=!1,r=k.Private,g){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${I} on local port ${w}.`),!p)return;v||(v="localhost");const o=this.retainOrCreateTunnel(p,v,I,w,a,r,g);return o?o.then(_=>{if(!_){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,I);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(_);return(_.tunnelRemoteHost!==v||_.tunnelRemotePort!==I)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const v=this._tunnels.get(p.tunnelRemoteHost);if(v){const I=v.get(p.tunnelRemotePort);I&&(I.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,I))}}}}async tryDisposeTunnel(p,v,I){if(I.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${v}.`);const w=I.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(v),w}}async closeTunnel(p,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${v} `);const I=this._tunnels.get(p);if(I&&I.has(v)){const w=I.get(v);w.refcount=0,await this.tryDisposeTunnel(p,v,w)}}addTunnelToMap(p,v,I){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(v,{refcount:1,value:I})}async removeEmptyTunnelFromMap(p,v){const I=this._tunnels.get(p);I&&(await I.get(v)||I.delete(v),I.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,v){let I=[p];R(p)?(I.push(...e.LOCALHOST_ADDRESSES),I.push(...e.ALL_INTERFACES_ADDRESSES)):P(p)&&I.push(...e.ALL_INTERFACES_ADDRESSES);const w=I.map(a=>this._tunnels.get(a));for(const a of w){const r=a?.get(v);if(r)return r}}canTunnel(p){return!!D(p)}createWithProvider(p,v,I,w,a,r,g){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${I} on local port ${w}.`);const _={elevationRequired:a?u(w===void 0?I:w):!1},n={remoteAddress:{host:v,port:I},localAddressPort:w,privacy:r,public:r!==k.Private,protocol:g},t=p.forwardPort(n,_);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(v,I,t),t}};E=je([He(0,C.ILogService)],E),e.AbstractTunnelService=E}),define(pe[194],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{constructor(){this.validators=new Map}vsda(){return new Promise((y,C)=>Y(["vsda"],y,C))}async createNewMessage(y){try{const C=await this.vsda(),i=new C.validator;if(i){const k=String(m._nextId++);return this.validators.set(k,i),{id:k,data:i.createNewMessage(y)}}}catch(C){}return{id:"",data:y}}async validate(y,C){if(!y.id)return!0;const i=this.validators.get(y.id);if(!i)return!1;this.validators.delete(y.id);try{return i.validate(C)==="ok"}catch(k){return!1}}async sign(y){try{const C=await this.vsda(),i=new C.signer;if(i)return i.sign(y)}catch(C){}return y}}e.SignService=m,m._nextId=1}),define(pe[195],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(y){this._callback=y,this._terminalBufferMap=new Map}dispose(){for(const y of this._terminalBufferMap.values())y.dispose()}startBuffering(y,C,i=5){let k;return k=C(S=>{const D=typeof S=="string"?S:S.data;let R=this._terminalBufferMap.get(y);if(R){R.data.push(D);return}const P=setTimeout(()=>this.flushBuffer(y),i);R={data:[D],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(y),k.dispose()}},this._terminalBufferMap.set(y,R)}),k}stopBuffering(y){const C=this._terminalBufferMap.get(y);C&&C.dispose()}flushBuffer(y){const C=this._terminalBufferMap.get(y);C&&(this._terminalBufferMap.delete(y),this._callback(y,C.data.join("")))}}e.TerminalDataBufferer=m}),define(pe[196],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(pe[86],ve([0,1,78,3,6,4,51,196]),function(Y,e,m,F,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var S;(function(v){function I(w){return w&&typeof w=="object"&&typeof w.id=="string"}v.isThemeColor=I})(S=e.ThemeColor||(e.ThemeColor={}));function D(v){return{id:v}}e.themeColorFromId=D;var R;(function(v){function I(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||S.isThemeColor(n.color))}v.isThemeIcon=I;const w=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function a(n){const t=w.exec(n);if(!t)return;let[,s]=t;return{id:s}}v.fromString=a;function r(n,t){let s=n.id;const d=s.lastIndexOf("~");return d!==-1&&(s=s.substring(0,d)),t&&(s=`${s}~${t}`),{id:s}}v.modify=r;function g(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}v.getModifier=g;function o(n,t){return n.id===t.id&&n.color?.id===t.color?.id}v.isEqual=o;function _(n,t){return{id:n.id,color:t?D(t):void 0}}v.asThemeIcon=_,v.asClassNameArray=m.CSSIcon.asClassNameArray,v.asClassName=m.CSSIcon.asClassName,v.asCSSSelector=m.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function P(v){switch(v){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class u{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new F.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,y.toDisposable)(()=>{const w=this.themingParticipants.indexOf(I);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new u;i.Registry.add(e.Extensions.ThemingContribution,E);function h(v){return E.onColorThemeChange(v)}e.registerThemingParticipant=h;class p extends y.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,w){let a=this.theme.getColor(I);return a&&w&&(a=w(a,this.theme)),a?a.toString():null}}e.Themable=p}),define(pe[43],ve([0,1,24,23,2,4]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var i;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(i=e.WorkbenchState||(e.WorkbenchState={}));function k(u){const E=u;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.isWorkspace=k;function S(u){const E=u;return!!(E&&typeof E=="object"&&y.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.isWorkspaceFolder=S;class D{constructor(E,h,p,v,I){this._id=E,this._transient=p,this._configuration=v,this._ignorePathCasing=I,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(E){this._id=E.id,this._configuration=E.configuration,this._transient=E.transient,this._ignorePathCasing=E._ignorePathCasing,this.folders=E.folders}get folders(){return this._folders}set folders(E){this._folders=E,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(E){this._configuration=E}getFolder(E){return E&&this._foldersMap.findSubstr(E.with({scheme:E.scheme,authority:E.authority,path:E.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const E of this.folders)this._foldersMap.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=D;class R{constructor(E,h){this.raw=h,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,F.joinPath)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function P(u){return new R({uri:u,index:0,name:(0,F.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=P}),define(pe[197],ve([0,1,30,58,139,80,10,9,12,23,2,161,4,62,43]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const p=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(O){return(typeof O=="string"?(0,k.extname)(O):(0,D.extname)(O))===p}e.hasWorkspaceFileExtension=v,e.IWorkspacesService=(0,u.createDecorator)("workspacesService");function I(O){return O.hasOwnProperty("workspace")}e.isRecentWorkspace=I;function w(O){return O.hasOwnProperty("folderUri")}e.isRecentFolder=w;function a(O){return O.hasOwnProperty("fileUri")}e.isRecentFile=a;function r(O){return O&&O.hasOwnProperty("folderUri")}e.isFolderBackupInfo=r;function g(O){return O&&O.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=g;function o(O){const W=O;return typeof W?.id=="string"&&R.URI.isUri(W.uri)}e.isSingleFolderWorkspaceIdentifier=o;function _(O){if(O.configuration)return{id:O.id,configPath:O.configuration};if(O.folders.length===1)return{id:O.id,uri:O.folders[0].uri}}e.toWorkspaceIdentifier=_;function n(O){const W=O;return typeof W?.id=="string"&&R.URI.isUri(W.configPath)}e.isWorkspaceIdentifier=n;function t(O){const W=O;if(W?.uri)return{id:W.id,uri:R.URI.revive(W.uri)};const q=O;if(q?.configPath)return{id:q.id,configPath:R.URI.revive(q.configPath)};if(O?.id)return{id:O.id}}e.reviveIdentifier=t;function s(O,W){return D.extUriBiasedIgnorePathCase.isEqualOrParent(O,W.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function d(O){return c(O)||f(O)}e.isStoredWorkspaceFolder=d;function c(O){const W=O;return typeof W?.path=="string"&&(!W.name||typeof W.name=="string")}e.isRawFileWorkspaceFolder=c;function f(O){const W=O;return typeof W?.uri=="string"&&(!W.name||typeof W.name=="string")}e.isRawUriWorkspaceFolder=f;function l(O,W,q,N,G=!S.isWindows,$){if(O.scheme!==N.scheme)return{name:q,uri:O.toString(!0)};let H=W?void 0:$.relativePath(N,O);if(H!==void 0)H.length===0?H=".":S.isWindows&&O.scheme===i.Schemas.file&&!G&&(H=H.replace(/\//g,"\\"));else if(O.scheme===i.Schemas.file)H=O.fsPath,S.isWindows&&(H=(0,C.normalizeDriveLetter)(H),G&&(H=(0,m.toSlashes)(H)));else{if(!$.isEqualAuthority(O.authority,N.authority))return{name:q,uri:O.toString(!0)};H=O.path}return{name:q,path:H}}e.getStoredWorkspaceFolder=l;function b(O,W,q){let N=[],G=new Set;const $=q.dirname(W);for(let H of O){let j;if(c(H))H.path&&(j=q.resolvePath($,H.path));else if(f(H))try{j=R.URI.parse(H.uri),j.path[0]!=="/"&&(j=j.with({path:"/"+j.path}))}catch(ie){console.warn(ie)}if(j){let ie=q.getComparisonKey(j);if(!G.has(ie)){G.add(ie);const fe=H.name||q.basenameOrAuthority(j);N.push(new h.WorkspaceFolder({uri:j,name:fe,index:N.length},H))}}}return N}e.toWorkspaceFolders=b;function T(O,W,q,N,G){let $=A(W,O);const H=G.dirname(W),j=G.dirname(N),ie=[],fe=U($.folders);for(const We of $.folders){const ze=c(We)?G.resolvePath(H,We.path):R.URI.parse(We.uri);let Q;q?Q=!1:Q=!c(We)||(0,k.isAbsolute)(We.path),ie.push(l(ze,Q,We.name,j,fe,G))}const ye={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},Ie=y.setProperty(O,["folders"],ie,ye);let Be=y.applyEdits(O,Ie);return(0,D.isEqualAuthority)($.remoteAuthority,(0,E.getRemoteAuthority)(N))&&(Be=y.applyEdits(Be,y.removeProperty(Be,["remoteAuthority"],ye))),Be}e.rewriteWorkspaceFileForNewLocation=T;function A(O,W){let q=F.parse(W);if(q&&Array.isArray(q.folders))q.folders=q.folders.filter(N=>d(N));else throw new Error(`${O} looks like an invalid workspace file.`);return q}function U(O){return S.isWindows?O.some(W=>c(W)&&W.path.indexOf("/")>=0):!0}e.useSlashForPath=U;function B(O){return O.workspace&&typeof O.workspace=="object"&&typeof O.workspace.id=="string"&&typeof O.workspace.configPath=="string"}function L(O){return typeof O.folderUri=="string"}function x(O){return typeof O.fileUri=="string"}function M(O,W){const q={workspaces:[],files:[]};if(O){const N=function($,H){for(let j=0;j<$.length;j++)try{H($[j],j)}catch(ie){W.warn(`Error restoring recent entry ${JSON.stringify($[j])}: ${ie.toString()}. Skip entry.`)}},G=O;if(Array.isArray(G.entries))N(G.entries,$=>{const H=$.label,j=$.remoteAuthority;B($)?q.workspaces.push({label:H,remoteAuthority:j,workspace:{id:$.workspace.id,configPath:R.URI.parse($.workspace.configPath)}}):L($)?q.workspaces.push({label:H,remoteAuthority:j,folderUri:R.URI.parse($.folderUri)}):x($)&&q.files.push({label:H,remoteAuthority:j,fileUri:R.URI.parse($.fileUri)})});else{const $=O;Array.isArray($.workspaces3)&&N($.workspaces3,(H,j)=>{const ie=Array.isArray($.workspaceLabels)&&$.workspaceLabels[j]||void 0;typeof H=="object"&&typeof H.id=="string"&&typeof H.configURIPath=="string"?q.workspaces.push({label:ie,workspace:{id:H.id,configPath:R.URI.parse(H.configURIPath)}}):typeof H=="string"&&q.workspaces.push({label:ie,folderUri:R.URI.parse(H)})}),Array.isArray($.files2)&&N($.files2,(H,j)=>{const ie=Array.isArray($.fileLabels)&&$.fileLabels[j]||void 0;typeof H=="string"&&q.files.push({label:ie,fileUri:R.URI.parse(H)})})}}return q}e.restoreRecentlyOpened=M;function V(O){const W={entries:[]};for(const q of O.workspaces)w(q)?W.entries.push({folderUri:q.folderUri.toString(),label:q.label,remoteAuthority:q.remoteAuthority}):W.entries.push({workspace:{id:q.workspace.id,configPath:q.workspace.configPath.toString()},label:q.label,remoteAuthority:q.remoteAuthority});for(const q of O.files)W.entries.push({fileUri:q.fileUri.toString(),label:q.label,remoteAuthority:q.remoteAuthority});return W}e.toStoreData=V}),define(pe[87],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(y){this.id=y,this._data=new Map,this._idPool=1}add(y){const C=this._idPool++;return this._data.set(C,y),this.logDebugInfo(),C}get(y,C){return this._data.has(y)?this._data.get(y)[C]:void 0}delete(y){this._data.delete(y),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(pe[44],ve([0,1,10,23,4]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new F.ExtUri(k=>{const S=this._providerInfo.get(k.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(k,S){S===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,S)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(pe[26],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(pe[198],ve([0,1,18]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(i,k,S){this._deferredPromises=new Map,this._id=i,this._shared=k,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(D=>(this._value=D,this)),this._storageListener=this._storage.onDidChangeStorage(D=>{D.shared===this._shared&&D.key===this._id&&(this._value=D.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const D=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of D.values())R.complete()}catch(R){for(const P of D.values())P.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,i])=>i!==void 0).map(([i])=>i)}get whenReady(){return this._init}get(i,k){let S=this._value[i];return typeof S=="undefined"&&(S=k),S}update(i,k){this._value[i]=k;let S=this._deferredPromises.get(i);if(S!==void 0)return S.p;const D=new m.DeferredPromise;return this._deferredPromises.set(i,D),this._scheduler.isScheduled()||this._scheduler.schedule(),D.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class y extends F{constructor(i,k){super(i.identifier.value,!0,k);this._extension=i}setKeysForSync(i){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},i)}}e.ExtensionGlobalMemento=y}),define(pe[199],ve([0,1,3,2,11]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(k,S){this._logService=k,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,S,D){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(k)).acceptModelChanged(S.value,D)}$acceptDirtyStateChanged(k,S){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(k)).acceptDirty(S)}$acceptModelSaved(k){const S=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(k));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(k,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,S);const D=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(k));D.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:D.apiNotebook})}};C=je([He(0,y.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(pe[14],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class F{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=F});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,F,y){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(pe[200],ve([0,1,27,3]),function(Y,e,m,F){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(k,S){y.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(k.identifier),nt(this,y,S,"f"),Ne(this,y,"f").onDidChangePassword(D=>{D.extensionId===this._id&&this._onDidChange.fire({key:D.key})})}get(k){return Ne(this,y,"f").get(this._id,k)}store(k,S){return Ne(this,y,"f").store(this._id,k,S)}delete(k){return Ne(this,y,"f").delete(this._id,k)}}e.ExtensionSecrets=C,y=new WeakMap}),define(pe[121],ve([0,1,4,3]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class y{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(i){this._enabled=i}$onDidChangeTelemetryEnabled(i){this._enabled=i,this._onDidChangeTelemetryEnabled.fire(i)}}e.ExtHostTelemetry=y,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(pe[63],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(w){w[w.Upsert=0]="Upsert",w[w.RemoveChild=1]="RemoveChild",w[w.Invalidated=2]="Invalidated",w[w.SetProp=3]="SetProp",w[w.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,y=(w,a)=>{const r={controllerId:a};return F.set(w,r),r};e.createPrivateApiFor=y;const C=w=>F.get(w);e.getPrivateApiFor=C;const i=(w,a,r,g)=>{let o=r;return{enumerable:!0,configurable:!1,get(){return o},set(_){if(!g(o,_)){const n=o;o=_,w.listener?.({op:3,key:a,value:_,previous:n})}}}},k=(w,a)=>w===a,S={range:(w,a)=>w===a?!0:!w||!a?!1:w.isEqual(a),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(w,a)=>!(w.length!==a.length||w.some(r=>!a.find(g=>r.id===g.id)))},D=Object.keys(S),R=(w,a)=>({range:i(w,"range",void 0,S.range),label:i(w,"label",a,S.label),description:i(w,"description",void 0,S.description),canResolveChildren:i(w,"canResolveChildren",!1,S.canResolveChildren),busy:i(w,"busy",!1,S.busy),error:i(w,"error",void 0,S.error),tags:i(w,"tags",[],S.tags)}),P=(w,a)=>{const r=new Map;for(const g of D)S[g](w[g],a[g])||r.set(g,a[g]);return r};e.diffTestItems=P;class u extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=u;class E extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class h extends Error{constructor(a,r,g){super(`TestItem with ID "${a}" is from controller "${r}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=h;const p=w=>{const a=(0,e.getPrivateApiFor)(w);let r=new Map;return{get size(){return r.size},forEach(g,o){for(const _ of r.values())g.call(o,_,this)},replace(g){const o=new Map,_=new Set(r.keys()),n={op:4,ops:[]};for(const t of g){if(!(t instanceof v))throw new E(t.id);const s=(0,e.getPrivateApiFor)(t).controllerId;if(s!==a.controllerId)throw new h(t.id,s,a.controllerId);if(o.has(t.id))throw new u(t.id);o.set(t.id,t),_.delete(t.id),n.ops.push({op:0,item:t})}for(const t of _.keys())n.ops.push({op:1,id:t});a.listener?.(n),r=o},add(g){if(!(g instanceof v))throw new E(g.id);r.set(g.id,g),a.listener?.({op:0,item:g})},delete(g){r.delete(g)&&a.listener?.({op:1,id:g})},get(g){return r.get(g)},toJSON(){return Array.from(r.values())},[Symbol.iterator](){return r.values()}}};class v{constructor(a,r,g,o){if(r.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(r)} symbol`);const _=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:r,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return _.parent instanceof I?void 0:_.parent}},children:{value:p(this),enumerable:!0,writable:!1},...R(_,g)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class I extends v{constructor(a,r){super(a,a,r,void 0)}}e.TestItemRootImpl=I}),define(pe[52],ve([0,1,4,120,3,14]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var i;(function(S){function D(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?F.TunnelPrivacyId.Public:F.TunnelPrivacyId.Private),protocol:P.protocol}}S.fromApiTunnel=D;function R(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==F.TunnelPrivacyId.ConstantPrivate&&P.privacy!==F.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}S.fromServiceTunnel=R})(i=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let k=class{constructor(D){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,R){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,R){return{dispose:()=>{}}}async $providePortAttributes(D,R,P,u,E){return[]}async $forwardPort(D,R){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=je([He(0,C.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,F,y){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(pe[7],ve([0,1,16,15,97,24,101,8,13,2,32,42,119]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u){"use strict";var E,h,p,v,I,w,a,r,g,o,_,n,t,s,d,c,f,l,b,T;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(K){function z(){return Reflect.construct(K,arguments,this.constructor)}return Object.defineProperty(z,"name",Object.getOwnPropertyDescriptor(K,"name")),Object.setPrototypeOf(z,K),Object.setPrototypeOf(z.prototype,K.prototype),z}let U=I=class{constructor(z){E.set(this,void 0),nt(this,E,z,"f")}static from(...z){let ae=z;return new I(function(){if(ae){for(const Pe of ae)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();ae=void 0}})}dispose(){typeof Ne(this,E,"f")=="function"&&(Ne(this,E,"f").call(this),nt(this,E,void 0,"f"))}};E=new WeakMap,U=I=je([A],U),e.Disposable=U;let B=w=class{constructor(z,ae){if(z<0)throw(0,F.illegalArgument)("line must be non-negative");if(ae<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=z,this._character=ae}static Min(...z){if(z.length===0)throw new TypeError;let ae=z[0];for(let Pe=1;Pe<z.length;Pe++){const Ye=z[Pe];Ye.isBefore(ae)&&(ae=Ye)}return ae}static Max(...z){if(z.length===0)throw new TypeError;let ae=z[0];for(let Pe=1;Pe<z.length;Pe++){const Ye=z[Pe];Ye.isAfter(ae)&&(ae=Ye)}return ae}static isPosition(z){if(!z)return!1;if(z instanceof w)return!0;let{line:ae,character:Pe}=z;return typeof ae=="number"&&typeof Pe=="number"}get line(){return this._line}get character(){return this._character}isBefore(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<z._character}isBeforeOrEqual(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<=z._character}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this._line===z._line&&this._character===z._character}compareTo(z){return this._line<z._line?-1:this._line>z.line?1:this._character<z._character?-1:this._character>z._character?1:0}translate(z,ae=0){if(z===null||ae===null)throw(0,F.illegalArgument)();let Pe;return typeof z=="undefined"?Pe=0:typeof z=="number"?Pe=z:(Pe=typeof z.lineDelta=="number"?z.lineDelta:0,ae=typeof z.characterDelta=="number"?z.characterDelta:0),Pe===0&&ae===0?this:new w(this.line+Pe,this.character+ae)}with(z,ae=this.character){if(z===null||ae===null)throw(0,F.illegalArgument)();let Pe;return typeof z=="undefined"?Pe=this.line:typeof z=="number"?Pe=z:(Pe=typeof z.line=="number"?z.line:this.line,ae=typeof z.character=="number"?z.character:this.character),Pe===this.line&&ae===this.character?this:new w(Pe,ae)}toJSON(){return{line:this.line,character:this.character}}};B=w=je([A],B),e.Position=B;let L=a=class{constructor(z,ae,Pe,Ye){let rt,lt;if(typeof z=="number"&&typeof ae=="number"&&typeof Pe=="number"&&typeof Ye=="number"?(rt=new B(z,ae),lt=new B(Pe,Ye)):z instanceof B&&ae instanceof B&&(rt=z,lt=ae),!rt||!lt)throw new Error("Invalid arguments");rt.isBefore(lt)?(this._start=rt,this._end=lt):(this._start=lt,this._end=rt)}static isRange(z){return z instanceof a?!0:z?B.isPosition(z.start)&&B.isPosition(z.end):!1}get start(){return this._start}get end(){return this._end}contains(z){return z instanceof a?this.contains(z._start)&&this.contains(z._end):z instanceof B?!(z.isBefore(this._start)||this._end.isBefore(z)):!1}isEqual(z){return this._start.isEqual(z._start)&&this._end.isEqual(z._end)}intersection(z){const ae=B.Max(z.start,this._start),Pe=B.Min(z.end,this._end);if(!ae.isAfter(Pe))return new a(ae,Pe)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const ae=B.Min(z.start,this._start),Pe=B.Max(z.end,this.end);return new a(ae,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(z,ae=this.end){if(z===null||ae===null)throw(0,F.illegalArgument)();let Pe;return z?B.isPosition(z)?Pe=z:(Pe=z.start||this.start,ae=z.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&ae.isEqual(this.end)?this:new a(Pe,ae)}toJSON(){return[this.start,this.end]}};L=a=je([A],L),e.Range=L;let x=r=class extends L{constructor(z,ae,Pe,Ye){let rt,lt;if(typeof z=="number"&&typeof ae=="number"&&typeof Pe=="number"&&typeof Ye=="number"?(rt=new B(z,ae),lt=new B(Pe,Ye)):z instanceof B&&ae instanceof B&&(rt=z,lt=ae),!rt||!lt)throw new Error("Invalid arguments");super(rt,lt);this._anchor=rt,this._active=lt}static isSelection(z){return z instanceof r?!0:z?L.isRange(z)&&B.isPosition(z.anchor)&&B.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=r=je([A],x),e.Selection=x;class M{constructor(z,ae,Pe){if(typeof z!="string"||z.length===0)throw(0,F.illegalArgument)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,F.illegalArgument)("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,F.illegalArgument)("connectionToken");this.host=z,this.port=Math.round(ae),this.connectionToken=Pe}}e.ResolvedAuthority=M;class V extends Error{constructor(z,ae=u.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(z);this._message=z,this._code=ae,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(z,ae){return new V(z,u.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(z){return new V(z,u.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var O;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(O=e.EndOfLine||(e.EndOfLine={}));var W;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let q=g=class{constructor(z,ae){this._range=z,this._newText=ae}static isTextEdit(z){return z instanceof g?!0:z?L.isRange(z)&&typeof z.newText=="string":!1}static replace(z,ae){return new g(z,ae)}static insert(z,ae){return g.replace(new L(z,z),ae)}static delete(z){return g.replace(z,"")}static setEndOfLine(z){const ae=new g(new L(new B(0,0),new B(0,0)),"");return ae.newEol=z,ae}get range(){return this._range}set range(z){if(z&&!L.isRange(z))throw(0,F.illegalArgument)("range");this._range=z}get newText(){return this._newText||""}set newText(z){if(z&&typeof z!="string")throw(0,F.illegalArgument)("newText");this._newText=z}get newEol(){return this._newEol}set newEol(z){if(z&&typeof z!="number")throw(0,F.illegalArgument)("newEol");this._newEol=z}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};q=g=je([A],q),e.TextEdit=q;var N;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace"})(N=e.FileEditType||(e.FileEditType={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(z,ae,Pe,Ye){this._edits.push({_type:1,from:z,to:ae,options:Pe,metadata:Ye})}createFile(z,ae,Pe){this._edits.push({_type:1,from:void 0,to:z,options:ae,metadata:Pe})}deleteFile(z,ae,Pe){this._edits.push({_type:1,from:z,to:void 0,options:ae,metadata:Pe})}replaceNotebookMetadata(z,ae,Pe){this._edits.push({_type:3,metadata:Pe,uri:z,edit:{editType:5,metadata:ae},notebookMetadata:ae})}replaceNotebookCells(z,ae,Pe,Ye,rt){let lt,ht,kt=[],Ft;if(xe.isNotebookRange(ae)&&xt.isNotebookCellDataArray(Pe)&&!xt.isNotebookCellDataArray(Ye)?(lt=ae.start,ht=ae.end,kt=Pe,Ft=Ye):typeof ae=="number"&&typeof Pe=="number"&&xt.isNotebookCellDataArray(Ye)&&(lt=ae,ht=Pe,kt=Ye,Ft=rt),lt===void 0||ht===void 0)throw new Error("Invalid arguments");(lt!==ht||kt.length>0)&&this._edits.push({_type:5,uri:z,index:lt,count:ht-lt,cells:kt,metadata:Ft})}replaceNotebookCellMetadata(z,ae,Pe,Ye){this._edits.push({_type:3,metadata:Ye,uri:z,edit:{editType:8,index:ae,metadata:Pe}})}replace(z,ae,Pe,Ye){this._edits.push({_type:2,uri:z,edit:new q(ae,Pe),metadata:Ye})}insert(z,ae,Pe,Ye){this.replace(z,new L(ae,ae),Pe,Ye)}delete(z,ae,Pe){this.replace(z,ae,"",Pe)}has(z){return this._edits.some(ae=>ae._type===2&&ae.uri.toString()===z.toString())}set(z,ae){if(ae)for(const Pe of ae)Pe&&this._edits.push({_type:2,uri:z,edit:Pe});else{for(let Pe=0;Pe<this._edits.length;Pe++){const Ye=this._edits[Pe];Ye._type===2&&Ye.uri.toString()===z.toString()&&(this._edits[Pe]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get(z){const ae=[];for(let Pe of this._edits)Pe._type===2&&Pe.uri.toString()===z.toString()&&ae.push(Pe.edit);return ae}entries(){const z=new C.ResourceMap;for(let ae of this._edits)if(ae._type===2){let Pe=z.get(ae.uri);Pe||(Pe=[ae.uri,[]],z.set(ae.uri,Pe)),Pe[1].push(ae.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};G=je([A],G),e.WorkspaceEdit=G;let $=o=class{constructor(z){this._tabstop=1,this.value=z||""}static isSnippetString(z){return z instanceof o?!0:z?typeof z.value=="string":!1}static _escape(z){return z.replace(/\$|}|\\/g,"\\$&")}appendText(z){return this.value+=o._escape(z),this}appendTabstop(z=this._tabstop++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,ae=this._tabstop++){if(typeof z=="function"){const Pe=new o;Pe._tabstop=this._tabstop,z(Pe),this._tabstop=Pe._tabstop,z=Pe.value}else z=o._escape(z);return this.value+="${",this.value+=ae,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,ae=this._tabstop++){const Pe=z.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(z,ae){if(typeof ae=="function"){const Pe=new o;Pe._tabstop=this._tabstop,ae(Pe),this._tabstop=Pe._tabstop,ae=Pe.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};$=o=je([A],$),e.SnippetString=$;var H;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(H=e.DiagnosticTag||(e.DiagnosticTag={}));var j;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(j=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ie=_=class{constructor(z,ae){if(this.uri=z,ae)if(ae instanceof L)this.range=ae;else if(ae instanceof B)this.range=new L(ae,ae);else throw new Error("Illegal argument")}static isLocation(z){return z instanceof _?!0:z?L.isRange(z.range)&&D.URI.isUri(z.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ie=_=je([A],ie),e.Location=ie;let fe=class{constructor(z,ae){this.location=z,this.message=ae}static is(z){return z?typeof z.message=="string"&&z.location&&L.isRange(z.location.range)&&D.URI.isUri(z.location.uri):!1}static isEqual(z,ae){return z===ae?!0:!z||!ae?!1:z.message===ae.message&&z.location.range.isEqual(ae.location.range)&&z.location.uri.toString()===ae.location.uri.toString()}};fe=je([A],fe),e.DiagnosticRelatedInformation=fe;let ye=class{constructor(z,ae,Pe=j.Error){if(!L.isRange(z))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=z,this.message=ae,this.severity=Pe}toJSON(){return{severity:j[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,ae){return z===ae?!0:!z||!ae?!1:z.message===ae.message&&z.severity===ae.severity&&z.code===ae.code&&z.severity===ae.severity&&z.source===ae.source&&z.range.isEqual(ae.range)&&(0,m.equals)(z.tags,ae.tags)&&(0,m.equals)(z.relatedInformation,ae.relatedInformation,fe.isEqual)}};ye=je([A],ye),e.Diagnostic=ye;let Ie=class{constructor(z,ae){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=ae}};Ie=je([A],Ie),e.Hover=Ie;var Be;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(Be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor(z,ae=Be.Text){this.range=z,this.kind=ae}toJSON(){return{range:this.range,kind:Be[this.kind]}}};We=je([A],We),e.DocumentHighlight=We;var ze;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(ze=e.SymbolKind||(e.SymbolKind={}));var Q;(function(K){K[K.Deprecated=1]="Deprecated"})(Q=e.SymbolTag||(e.SymbolTag={}));let ee=n=class{constructor(z,ae,Pe,Ye,rt){this.name=z,this.kind=ae,this.containerName=rt,typeof Pe=="string"&&(this.containerName=Pe),Ye instanceof ie?this.location=Ye:Pe instanceof L&&(this.location=new ie(Ye,Pe)),n.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ze[this.kind],location:this.location,containerName:this.containerName}}};ee=n=je([A],ee),e.SymbolInformation=ee;let re=t=class{constructor(z,ae,Pe,Ye,rt){this.name=z,this.detail=ae,this.kind=Pe,this.range=Ye,this.selectionRange=rt,this.children=[],t.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children&&z.children.forEach(t.validate)}};re=t=je([A],re),e.DocumentSymbol=re;var he;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(he=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Z=class{constructor(z,ae){this.title=z,this.kind=ae}};Z=je([A],Z),e.CodeAction=Z;let oe=s=class{constructor(z){this.value=z}append(z){return new s(this.value?this.value+s.sep+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+s.sep)}};oe.sep=".",oe=s=je([A],oe),e.CodeActionKind=oe,oe.Empty=new oe(""),oe.QuickFix=oe.Empty.append("quickfix"),oe.Refactor=oe.Empty.append("refactor"),oe.RefactorExtract=oe.Refactor.append("extract"),oe.RefactorInline=oe.Refactor.append("inline"),oe.RefactorRewrite=oe.Refactor.append("rewrite"),oe.Source=oe.Empty.append("source"),oe.SourceOrganizeImports=oe.Source.append("organizeImports"),oe.SourceFixAll=oe.Source.append("fixAll");let be=class{constructor(z,ae){if(this.range=z,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};be=je([A],be),e.SelectionRange=be;class Me{constructor(z,ae,Pe,Ye,rt,lt){this.kind=z,this.name=ae,this.detail=Pe,this.uri=Ye,this.range=rt,this.selectionRange=lt}}e.CallHierarchyItem=Me;class Ve{constructor(z,ae){this.fromRanges=ae,this.from=z}}e.CallHierarchyIncomingCall=Ve;class Ge{constructor(z,ae){this.fromRanges=ae,this.to=z}}e.CallHierarchyOutgoingCall=Ge;var Je;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(Je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let tt=class{constructor(z,ae){this.range=z,this.command=ae}get isResolved(){return!!this.command}};tt=je([A],tt),e.CodeLens=tt;let ot=d=class{constructor(z,ae=!1){h.set(this,void 0),nt(this,h,new y.MarkdownString(z,{supportThemeIcons:ae}),"f")}static isMarkdownString(z){return z instanceof d?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}get value(){return Ne(this,h,"f").value}set value(z){Ne(this,h,"f").value=z}get isTrusted(){return Ne(this,h,"f").isTrusted}set isTrusted(z){Ne(this,h,"f").isTrusted=z}get supportThemeIcons(){return Ne(this,h,"f").supportThemeIcons}set supportThemeIcons(z){Ne(this,h,"f").supportThemeIcons=z}get supportHtml(){return Ne(this,h,"f").supportHtml}set supportHtml(z){Ne(this,h,"f").supportHtml=z}appendText(z){return Ne(this,h,"f").appendText(z),this}appendMarkdown(z){return Ne(this,h,"f").appendMarkdown(z),this}appendCodeblock(z,ae){return Ne(this,h,"f").appendCodeblock(ae??"",z),this}};h=new WeakMap,ot=d=je([A],ot),e.MarkdownString=ot;let et=class{constructor(z,ae){this.label=z,this.documentation=ae}};et=je([A],et),e.ParameterInformation=et;let it=class{constructor(z,ae){this.label=z,this.documentation=ae,this.parameters=[]}};it=je([A],it),e.SignatureInformation=it;let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ct=je([A],ct),e.SignatureHelp=ct;var pt;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(pt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Pt;(function(K){K[K.Other=0]="Other",K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(Pt=e.InlayHintKind||(e.InlayHintKind={}));let Ue=class{constructor(z,ae,Pe){this.text=z,this.position=ae,this.kind=Pe}};Ue=je([A],Ue),e.InlayHint=Ue;var Rt;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Rt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var ne;(function(K){K[K.Deprecated=1]="Deprecated"})(ne=e.CompletionItemTag||(e.CompletionItemTag={}));let ge=class{constructor(z,ae){this.label=z,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&J[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ge=je([A],ge),e.CompletionItem=ge;let te=class{constructor(z=[],ae=!1){this.items=z,this.isIncomplete=ae}};te=je([A],te),e.CompletionList=te;let Ee=class{constructor(z,ae,Pe){this.text=z,this.range=ae,this.command=Pe}};Ee=je([A],Ee),e.InlineSuggestion=Ee;let Le=class{constructor(z){this.items=z}};Le=je([A],Le),e.InlineSuggestions=Le;var Oe;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(Oe=e.ViewColumn||(e.ViewColumn={}));var Xe;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(Xe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Te;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(Te=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ke;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Se;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Se=e.TextEditorRevealType||(e.TextEditorRevealType={}));var le;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(le=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var we;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(we=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(K){function z(ae){switch(ae){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=z}(le=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let _e=class{constructor(z,ae){if(ae&&!D.URI.isUri(ae))throw(0,F.illegalArgument)("target");if(!L.isRange(z)||z.isEmpty)throw(0,F.illegalArgument)("range");this.range=z,this.target=ae}};_e=je([A],_e),e.DocumentLink=_e;let Fe=class{constructor(z,ae,Pe,Ye){this.red=z,this.green=ae,this.blue=Pe,this.alpha=Ye}};Fe=je([A],Fe),e.Color=Fe;let Ke=class{constructor(z,ae){if(ae&&!(ae instanceof Fe))throw(0,F.illegalArgument)("color");if(!L.isRange(z)||z.isEmpty)throw(0,F.illegalArgument)("range");this.range=z,this.color=ae}};Ke=je([A],Ke),e.ColorInformation=Ke;let $e=class{constructor(z){if(!z||typeof z!="string")throw(0,F.illegalArgument)("label");this.label=z}};$e=je([A],$e),e.ColorPresentation=$e;var Qe;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(Qe=e.ColorFormat||(e.ColorFormat={}));var st;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(st=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class at{constructor(z,ae,Pe){if(this.startIndex=z,this.length=ae,this.tooltip=Pe,typeof z!="number"||z<0)throw(0,F.illegalArgument)("startIndex");if(typeof ae!="number"||ae<1)throw(0,F.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=at;var de;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(de=e.TerminalLocation||(e.TerminalLocation={}));class Ce{constructor(z){this.options=z,typeof z!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=Ce;var ce;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var X;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(X=e.TaskPanelKind||(e.TaskPanelKind={}));let De=c=class{constructor(z,ae){if(this.label=ae,typeof z!="string"||typeof ae!="string")throw(0,F.illegalArgument)("name");this._id=z}static from(z){switch(z){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};De.Clean=new c("clean","Clean"),De.Build=new c("build","Build"),De.Rebuild=new c("rebuild","Rebuild"),De.Test=new c("test","Test"),De=c=je([A],De),e.TaskGroup=De;function Re(K){let z="";for(let ae=0;ae<K.length;ae++)z+=K[ae].replace(/,/g,",,")+",";return z}let Ze=class{constructor(z,ae,Pe){if(typeof z!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=z,ae!==void 0&&(Array.isArray(ae)?(this._args=ae,this._options=Pe):this._options=ae)}get process(){return this._process}set process(z){if(typeof z!="string")throw(0,F.illegalArgument)("process");this._process=z}get args(){return this._args}set args(z){Array.isArray(z)||(z=[]),this._args=z}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("process"),this._process!==void 0&&z.push(this._process),this._args&&this._args.length>0)for(let ae of this._args)z.push(ae);return Re(z)}};Ze=je([A],Ze),e.ProcessExecution=Ze;let qe=class{constructor(z,ae,Pe){if(this._args=[],Array.isArray(ae)){if(!z)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,F.illegalArgument)("command");this._command=z,this._args=ae,this._options=Pe}else{if(typeof z!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=z,this._options=ae}}get commandLine(){return this._commandLine}set commandLine(z){if(typeof z!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=z}get command(){return this._command?this._command:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,F.illegalArgument)("command");this._command=z}get args(){return this._args}set args(z){this._args=z||[]}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("shell"),this._commandLine!==void 0&&z.push(this._commandLine),this._command!==void 0&&z.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ae of this._args)z.push(typeof ae=="string"?ae:ae.value);return Re(z)}};qe=je([A],qe),e.ShellExecution=qe;var dt;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(dt=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class yt{constructor(z){this._callback=z}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(z){this._callback=z}get callback(){return this._callback}}e.CustomExecution=yt;let bt=f=class{constructor(z,ae,Pe,Ye,rt,lt){this.__deprecated=!1,this._definition=this.definition=z;let ht;typeof ae=="string"?(this._name=this.name=ae,this._source=this.source=Pe,this.execution=Ye,ht=rt,this.__deprecated=!0):ae===wt.Global||ae===wt.Workspace?(this.target=ae,this._name=this.name=Pe,this._source=this.source=Ye,this.execution=rt,ht=lt):(this.target=ae,this._name=this.name=Pe,this._source=this.source=Ye,this.execution=rt,ht=lt),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(z){this.__id=z}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(z){if(z==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=z}get scope(){return this._scope}set target(z){this.clear(),this._scope=z}get name(){return this._name}set name(z){if(typeof z!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=z}get execution(){return this._execution}set execution(z){z===null&&(z=void 0),this.clear(),this._execution=z;const ae=this._definition.type;(f.EmptyType===ae||f.ProcessType===ae||f.ShellType===ae||f.ExtensionCallbackType===ae)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(z){if(Array.isArray(z))this.clear(),this._problemMatchers=z,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.clear(),this._isBackground=z}get source(){return this._source}set source(z){if(typeof z!="string"||z.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=z}get group(){return this._group}set group(z){z===null&&(z=void 0),this.clear(),this._group=z}get detail(){return this._detail}set detail(z){z===null&&(z=void 0),this._detail=z}get presentationOptions(){return this._presentationOptions}set presentationOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._presentationOptions=z}get runOptions(){return this._runOptions}set runOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._runOptions=z}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=f=je([A],bt),e.Task=bt;var ft;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(z,ae=St.None){this.collapsibleState=ae,D.URI.isUri(z)?this.resourceUri=z:this.label=z}};vt=je([A],vt),e.TreeItem=vt;var St;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(St=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ot=class{constructor(z){this._value=z}async asString(){return JSON.stringify(this._value)}};Ot=je([A],Ot),e.TreeDataTransferItem=Ot;let It=class{constructor(){this._items=new Map}get(z){return this._items.get(z)}set(z,ae){this._items.set(z,ae)}forEach(z){this._items.forEach(z)}};It=je([A],It),e.TreeDataTransfer=It;let Tt=class{constructor(z,ae){this.id=z,this.color=ae}};Tt=je([A],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let Lt=class{constructor(z){this.id=z}};Lt=je([A],Lt),e.ThemeColor=Lt;var _t;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(_t=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Mt=class{constructor(z,ae){if(typeof z!="string"&&(!z||!D.URI.isUri(z)&&!D.URI.isUri(z.uri)))throw(0,F.illegalArgument)("base");if(typeof ae!="string")throw(0,F.illegalArgument)("pattern");typeof z=="string"?(this.baseFolder=D.URI.file(z),this.base=z):D.URI.isUri(z)?(this.baseFolder=z,this.base=z.fsPath):(this.baseFolder=z.uri,this.base=z.uri.fsPath),this.pattern=ae}};Mt=je([A],Mt),e.RelativePattern=Mt;let Nt=class{constructor(z,ae,Pe,Ye){this.enabled=typeof z=="boolean"?z:!0,typeof ae=="string"&&(this.condition=ae),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Nt=je([A],Nt),e.Breakpoint=Nt;let Et=class extends Nt{constructor(z,ae,Pe,Ye,rt){super(ae,Pe,Ye,rt);if(z===null)throw(0,F.illegalArgument)("location");this.location=z}};Et=je([A],Et),e.SourceBreakpoint=Et;let Wt=class extends Nt{constructor(z,ae,Pe,Ye,rt){super(ae,Pe,Ye,rt);this.functionName=z}};Wt=je([A],Wt),e.FunctionBreakpoint=Wt;let jt=class extends Nt{constructor(z,ae,Pe,Ye,rt,lt,ht){super(Ye,rt,lt,ht);if(!ae)throw(0,F.illegalArgument)("dataId");this.label=z,this.dataId=ae,this.canPersist=Pe}};jt=je([A],jt),e.DataBreakpoint=jt;let si=class{constructor(z,ae,Pe){this.command=z,this.args=ae||[],this.options=Pe}};si=je([A],si),e.DebugAdapterExecutable=si;let oi=class{constructor(z,ae){this.port=z,this.host=ae}};oi=je([A],oi),e.DebugAdapterServer=oi;let At=class{constructor(z){this.path=z}};At=je([A],At),e.DebugAdapterNamedPipeServer=At;let Xt=class{constructor(z){this.implementation=z}};Xt=je([A],Xt),e.DebugAdapterInlineImplementation=Xt;let ai=class{constructor(z,ae){this.range=z,this.expression=ae}};ai=je([A],ai),e.EvaluatableExpression=ai;var Yt;(function(K){K[K.Automatic=0]="Automatic",K[K.Explicit=1]="Explicit"})(Yt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Vt=class{constructor(z,ae){this.range=z,this.text=ae}};Vt=je([A],Vt),e.InlineValueText=Vt;let gt=class{constructor(z,ae,Pe=!0){this.range=z,this.variableName=ae,this.caseSensitiveLookup=Pe}};gt=je([A],gt),e.InlineValueVariableLookup=gt;let ci=class{constructor(z,ae){this.range=z,this.expression=ae}};ci=je([A],ci),e.InlineValueEvaluatableExpression=ci;let Ut=class{constructor(z,ae){this.frameId=z,this.stoppedLocation=ae}};Ut=je([A],Ut),e.InlineValueContext=Ut;var qt;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(qt=e.FileChangeType||(e.FileChangeType={}));let Jt=l=class extends Error{constructor(z,ae=P.FileSystemProviderErrorCode.Unknown,Pe){super(D.URI.isUri(z)?z.toString(!0):z);this.code=Pe?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,ae),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,l.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists(z){return new l(z,P.FileSystemProviderErrorCode.FileExists,l.FileExists)}static FileNotFound(z){return new l(z,P.FileSystemProviderErrorCode.FileNotFound,l.FileNotFound)}static FileNotADirectory(z){return new l(z,P.FileSystemProviderErrorCode.FileNotADirectory,l.FileNotADirectory)}static FileIsADirectory(z){return new l(z,P.FileSystemProviderErrorCode.FileIsADirectory,l.FileIsADirectory)}static NoPermissions(z){return new l(z,P.FileSystemProviderErrorCode.NoPermissions,l.NoPermissions)}static Unavailable(z){return new l(z,P.FileSystemProviderErrorCode.Unavailable,l.Unavailable)}};Jt=l=je([A],Jt),e.FileSystemError=Jt;let li=class{constructor(z,ae,Pe){this.start=z,this.end=ae,this.kind=Pe}};li=je([A],li),e.FoldingRange=li;var fi;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor(z,ae=[]){this.tokenTypes=z,this.tokenModifiers=ae}}e.SemanticTokensLegend=Zt;function _i(K){return typeof K=="undefined"||(0,S.isStringArray)(K)}class Gt{constructor(z){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,z){this._hasLegend=!0;for(let ae=0,Pe=z.tokenTypes.length;ae<Pe;ae++)this._tokenTypeStrToInt.set(z.tokenTypes[ae],ae);for(let ae=0,Pe=z.tokenModifiers.length;ae<Pe;ae++)this._tokenModifierStrToInt.set(z.tokenModifiers[ae],ae)}}push(z,ae,Pe,Ye,rt){if(typeof z=="number"&&typeof ae=="number"&&typeof Pe=="number"&&typeof Ye=="number"&&(typeof rt=="number"||typeof rt=="undefined"))return typeof rt=="undefined"&&(rt=0),this._pushEncoded(z,ae,Pe,Ye,rt);if(L.isRange(z)&&typeof ae=="string"&&_i(Pe))return this._push(z,ae,Pe);throw(0,F.illegalArgument)()}_push(z,ae,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ae))throw new Error("`tokenType` is not in the provided legend");const Ye=z.start.line,rt=z.start.character,lt=z.end.character-z.start.character,ht=this._tokenTypeStrToInt.get(ae);let kt=0;if(Pe)for(const Ft of Pe){if(!this._tokenModifierStrToInt.has(Ft))throw new Error("`tokenModifier` is not in the provided legend");const Bt=this._tokenModifierStrToInt.get(Ft);kt|=1<<Bt>>>0}this._pushEncoded(Ye,rt,lt,ht,kt)}_pushEncoded(z,ae,Pe,Ye,rt){if(this._dataIsSortedAndDeltaEncoded&&(z<this._prevLine||z===this._prevLine&&ae<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Ft=0,Bt=0;for(let $t=0;$t<kt;$t++){let Ht=this._data[5*$t],di=this._data[5*$t+1];Ht===0?(Ht=Ft,di+=Bt):Ht+=Ft,this._data[5*$t]=Ht,this._data[5*$t+1]=di,Ft=Ht,Bt=di}}let lt=z,ht=ae;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=rt,this._prevLine=z,this._prevChar=ae}static _sortAndDeltaEncode(z){let ae=[];const Pe=z.length/5|0;for(let ht=0;ht<Pe;ht++)ae[ht]=ht;ae.sort((ht,kt)=>{const Ft=z[5*ht],Bt=z[5*kt];if(Ft===Bt){const $t=z[5*ht+1],Ht=z[5*kt+1];return $t-Ht}return Ft-Bt});const Ye=new Uint32Array(z.length);let rt=0,lt=0;for(let ht=0;ht<Pe;ht++){const kt=5*ae[ht],Ft=z[kt+0],Bt=z[kt+1],$t=z[kt+2],Ht=z[kt+3],di=z[kt+4],$i=Ft-rt,Xi=$i===0?Bt-lt:Bt,hi=5*ht;Ye[hi+0]=$i,Ye[hi+1]=Xi,Ye[hi+2]=$t,Ye[hi+3]=Ht,Ye[hi+4]=di,rt=Ft,lt=Bt}return Ye}build(z){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),z):new Kt(Gt._sortAndDeltaEncode(this._data),z)}}e.SemanticTokensBuilder=Gt;class Kt{constructor(z,ae){this.resultId=ae,this.data=z}}e.SemanticTokens=Kt;class Si{constructor(z,ae,Pe){this.start=z,this.deleteCount=ae,this.data=Pe}}e.SemanticTokensEdit=Si;class Ci{constructor(z,ae){this.resultId=ae,this.edits=z}}e.SemanticTokensEdits=Ci;var Qt;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(Qt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(K){K[K.Initial=1]="Initial",K[K.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Tt("arrow-left")},ei=je([A],ei),e.QuickInputButtons=ei;var Di;(function(K){K[K.Default=1]="Default",K[K.Separator=2]="Separator"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor(z,ae,Pe){this.badge=z,this.tooltip=ae,this.color=Pe}static validate(z){if(z.badge){let ae=(0,k.nextCharLength)(z.badge,0);if(ae<z.badge.length&&(ae+=(0,k.nextCharLength)(z.badge,ae)),z.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor(z){this.kind=z}};ti=je([A],ti),e.ColorTheme=ti;var gi;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class xe{constructor(z,ae){if(z<0)throw(0,F.illegalArgument)("start must be positive");if(ae<0)throw(0,F.illegalArgument)("end must be positive");z<=ae?(this._start=z,this._end=ae):(this._start=ae,this._end=z)}static isNotebookRange(z){return z instanceof xe?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(z){let ae=this._start,Pe=this._end;return z.start!==void 0&&(ae=z.start),z.end!==void 0&&(Pe=z.end),ae===this._start&&Pe===this._end?this:new xe(ae,Pe)}}e.NotebookRange=xe;class xt{constructor(z,ae,Pe,Ye,rt,lt,ht){this.kind=z,this.value=ae,this.languageId=Pe,this.mime=Ye,this.outputs=rt??[],this.metadata=lt,this.executionSummary=ht,xt.validate(this)}static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(ae=>xt.isNotebookCellData(ae))}static isNotebookCellData(z){return!0}}e.NotebookCellData=xt;class pi{constructor(z){this.cells=z}}e.NotebookData=pi;class mt{constructor(z,ae){this.data=z,this.mime=ae;const Pe=(0,i.normalizeMimeType)(ae,!0);if(!Pe)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem(z){return z instanceof mt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const ae={name:z.name,message:z.message,stack:z.stack};return mt.json(ae,"application/vnd.code.notebook.error")}static stdout(z){return mt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return mt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,ae="application/octet-stream"){return new mt(z,ae)}static text(z,ae=i.Mimes.text){const Pe=Ne(mt,p,"f",v).encode(String(z));return new mt(Pe,ae)}static json(z,ae="application/json"){const Pe=JSON.stringify(z,void 0,"	");return mt.text(Pe,ae)}}e.NotebookCellOutputItem=mt,p=mt,v={value:new TextEncoder};class ii{constructor(z,ae,Pe){this.items=ii.ensureUniqueMimeTypes(z,!0),typeof ae=="string"?(this.id=ae,this.metadata=Pe):(this.id=(0,R.generateUuid)(),this.metadata=ae??Pe)}static isNotebookCellOutput(z){return z instanceof ii?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&(0,S.isArray)(z.items)}static ensureUniqueMimeTypes(z,ae=!1){const Pe=new Set,Ye=new Set;for(let rt=0;rt<z.length;rt++){const lt=z[rt],ht=(0,i.normalizeMimeType)(lt.mime);if(!Pe.has(ht)){Pe.add(ht);continue}Ye.add(rt),ae&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ye.size===0?z:z.filter((rt,lt)=>!Ye.has(lt))}}e.NotebookCellOutput=ii;var Ii;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var wi;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(wi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor(z,ae){this.text=z,this.alignment=ae}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor(z,ae=[]){this.uri=z,this.provides=(0,m.asArray)(ae)}}e.NotebookRendererScript=Ri;let ni=class{constructor(z,ae){this.label=z,this.timestamp=ae}};ni=je([A],ni),e.TimelineItem=ni;var Li;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(Li=e.ExtensionMode||(e.ExtensionMode={}));var Fi;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(Fi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Mi;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=4]="RegEx"})(Mi=e.StandardTokenType||(e.StandardTokenType={}));class Oi{constructor(z,ae){this.ranges=z,this.wordPattern=ae}}e.LinkedEditingRanges=Oi;class Ni{constructor(z,ae){this._port=z,this._autoForwardAction=ae}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var se;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(se=e.TestResultState||(e.TestResultState={}));var me;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(me=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ae=class{constructor(z=void 0,ae=void 0,Pe=void 0){this.include=z,this.exclude=ae,this.profile=Pe}};Ae=je([A],Ae),e.TestRunRequest=Ae;let ut=b=class{constructor(z){this.message=z}static diff(z,ae,Pe){const Ye=new b(z);return Ye.expectedOutput=ae,Ye.actualOutput=Pe,Ye}};ut=b=je([A],ut),e.TestMessage=ut;let Ct=class{constructor(z){this.id=z}};Ct=je([A],Ct),e.TestTag=Ct;let Dt=class{constructor(z,ae){this.covered=z,this.total=ae}};Dt=je([A],Dt),e.CoveredCount=Dt;let Ui=T=class{constructor(z,ae,Pe,Ye){this.uri=z,this.statementCoverage=ae,this.branchCoverage=Pe,this.functionCoverage=Ye}static fromDetails(z,ae){const Pe=new Dt(0,0),Ye=new Dt(0,0),rt=new Dt(0,0);for(const ht of ae)if("branches"in ht){Pe.total+=1,Pe.covered+=ht.executionCount>0?1:0;for(const kt of ht.branches)Ye.total+=1,Ye.covered+=kt.executionCount>0?1:0}else rt.total+=1,rt.covered+=ht.executionCount>0?1:0;const lt=new T(z,Pe,Ye.total>0?Ye:void 0,rt.total>0?rt:void 0);return lt.detailedCoverage=ae,lt}};Ui=T=je([A],Ui),e.FileCoverage=Ui;let xi=class{constructor(z,ae,Pe=[]){this.executionCount=z,this.location=ae,this.branches=Pe}};xi=je([A],xi),e.StatementCoverage=xi;let Bi=class{constructor(z,ae){this.executionCount=z,this.location=ae}};Bi=je([A],Bi),e.BranchCoverage=Bi;let Wi=class{constructor(z,ae){this.executionCount=z,this.location=ae}};Wi=je([A],Wi),e.FunctionCoverage=Wi;var qi;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ki;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(z,ae,Pe,Ye,rt,lt){this.kind=z,this.name=ae,this.detail=Pe,this.uri=Ye,this.range=rt,this.selectionRange=lt}}e.TypeHierarchyItem=Qi}),define(pe[122],ve([0,1,56,10,8,149,109,7,16]),function(Y,e,m,F,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const D=new Map;function R(h,p){p?D.set(h,p):D.delete(h)}e.setWordDefinitionFor=R;function P(h){return D.get(h)}e.getWordDefinitionFor=P;class u extends C.MirrorTextModel{constructor(p,v,I,w,a,r,g,o){super(v,I,w,a);this._proxy=p,this._languageId=r,this._isDirty=g,this._notebook=o,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(p){return(0,S.equals)(this._lines,p)}get document(){if(!this._document){const p=this;this._document={get uri(){return p._uri},get fileName(){return p._uri.fsPath},get isUntitled(){return p._uri.scheme===F.Schemas.untitled},get languageId(){return p._languageId},get version(){return p._versionId},get isClosed(){return p._isDisposed},get isDirty(){return p._isDirty},get notebook(){return p._notebook},save(){return p._save()},getText(v){return v?p._getTextInRange(v):p.getText()},get eol(){return p._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return p._lines.length},lineAt(v){return p._lineAt(v)},offsetAt(v){return p._offsetAt(v)},positionAt(v){return p._positionAt(v)},validateRange(v){return p._validateRange(v)},validatePosition(v){return p._validatePosition(v)},getWordRangeAtPosition(v,I){return p._getWordRangeAtPosition(v,I)}}}return Object.freeze(this._document)}_acceptLanguageId(p){(0,m.ok)(!this._isDisposed),this._languageId=p}_acceptIsDirty(p){(0,m.ok)(!this._isDisposed),this._isDirty=p}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(p){const v=this._validateRange(p);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const I=this._eol,w=v.start.line,a=v.end.line,r=[];r.push(this._lines[w].substring(v.start.character));for(let g=w+1;g<a;g++)r.push(this._lines[g]);return r.push(this._lines[a].substring(0,v.end.character)),r.join(I)}_lineAt(p){let v;if(p instanceof k.Position?v=p.line:typeof p=="number"&&(v=p),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new E(v,this._lines[v],v===this._lines.length-1)}_offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getPrefixSum(p.line-1)+p.character}_positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(p),I=this._lines[v.index].length;return new k.Position(v.index,Math.min(v.remainder,I))}_validateRange(p){if(!(p instanceof k.Range))throw new Error("Invalid argument");const v=this._validatePosition(p.start),I=this._validatePosition(p.end);return v===p.start&&I===p.end?p:new k.Range(v.line,v.character,I.line,I.character)}_validatePosition(p){if(!(p instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return p.with(0,0);let{line:v,character:I}=p,w=!1;if(v<0)v=0,I=0,w=!0;else if(v>=this._lines.length)v=this._lines.length-1,I=this._lines[v].length,w=!0;else{const a=this._lines[v].length;I<0?(I=0,w=!0):I>a&&(I=a,w=!0)}return w?new k.Position(v,I):p}_getWordRangeAtPosition(p,v){const I=this._validatePosition(p);if(!v)v=P(this._languageId);else if((0,y.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const w=(0,i.getWordAtText)(I.character+1,(0,i.ensureValidWordDefinition)(v),this._lines[I.line],0);if(w)return new k.Range(I.line,w.startColumn-1,I.line,w.endColumn-1)}}e.ExtHostDocumentData=u;class E{constructor(p,v,I){this._line=p,this._text=v,this._isLastLine=I}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(pe[201],ve([0,1,7,3,111,6,82,24,2,32]),function(Y,e,m,F,y,C,i,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(u,E,h,p){this._notebook=h,this._selector=p,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,D.generateUuid)()}),this._init(),this._disposables.add(E.onDidChangeDocument(I=>{const w=this._cellUris.get(I.document.uri);w!==void 0&&(this._cellLengths.setValue(w,this._cells[w].document.getText().length+1),this._cellLines.setValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=I=>{I===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(u.onDidChangeNotebookCells(I=>v(I.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const u=[],E=[];for(const h of this._notebook.getCells())h.kind===m.NotebookCellKind.Code&&(!this._selector||(0,i.score)(this._selector,h.document.uri,h.document.languageId,!0))&&(this._cellUris.set(h.document.uri,this._cells.length),this._cells.push(h),u.push(h.document.getText().length+1),E.push(h.document.lineCount));this._cellLengths=new y.PrefixSumComputer(new Uint32Array(u)),this._cellLines=new y.PrefixSumComputer(new Uint32Array(E))}get version(){return this._versionId}getText(u){if(!u){let w="";for(const a of this._cells)w+=a.document.getText()+`
`;return w=w.slice(0,-1),w}if(u.isEmpty)return"";const E=this.locationAt(u.start),h=this.locationAt(u.end),p=this._cellUris.get(E.uri),v=this._cellUris.get(h.uri);if(p===void 0||v===void 0)return"";if(p===v)return this._cells[p].document.getText(new m.Range(E.range.start,h.range.end));const I=[this._cells[p].document.getText(new m.Range(E.range.start,new m.Position(this._cells[p].document.lineCount,0)))];for(let w=p+1;w<v;w++)I.push(this._cells[w].document.getText());return I.push(this._cells[v].document.getText(new m.Range(new m.Position(0,0),h.range.end))),I.join(`
`)}offsetAt(u){const E=this._cellLines.getIndexOf(u.line),h=this._cellLengths.getPrefixSum(E.index-1),p=this._cells[E.index].document.offsetAt(u.with(E.remainder));return h+p}positionAt(u){if(typeof u=="number"){const h=this._cellLengths.getIndexOf(u),p=this._cellLines.getPrefixSum(h.index-1);return this._cells[h.index].document.positionAt(h.remainder).translate(p)}const E=this._cellUris.get(u.uri);if(E!==void 0){const h=this._cellLines.getPrefixSum(E-1);return new m.Position(h+u.range.start.line,u.range.start.character)}return new m.Position(0,0)}locationAt(u){m.Range.isRange(u)||(u=new m.Range(u,u));const E=this._cellLines.getIndexOf(u.start.line);let h=E;u.isEmpty||(h=this._cellLines.getIndexOf(u.end.line));const p=new m.Position(E.remainder,u.start.character),v=new m.Position(h.remainder,u.end.character),I=new m.Range(p,v),w=this._cells[E.index];return new m.Location(w.document.uri,w.document.validateRange(I))}contains(u){return this._cellUris.has(u)}validateRange(u){const E=this.validatePosition(u.start),h=this.validatePosition(u.end);return u.with(E,h)}validatePosition(u){const E=this._cellLines.getIndexOf(u.line),h=new m.Position(E.remainder,u.character),p=this._cells[E.index].document.validatePosition(h),v=this._cellLines.getPrefixSum(E.index-1);return new m.Position(v+p.line,p.character)}}e.ExtHostNotebookConcatDocument=R}),define(pe[202],ve([0,1,7,14,3]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(k){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new y.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let S=k==="light"?m.ColorThemeKind.Light:k==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=je([He(0,F.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(pe[64],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class F{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=i=>i,this.transformOutgoing=i=>i,this.transformOutgoingURI=i=>i,this.transformOutgoingScheme=i=>i)}}e.URITransformerService=F}),define(pe[203],ve([0,1,22]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(S){let D=this.buffers.indexOf(S);return D<0&&(D=this.buffers.length,this.buffers.push(S)),D}}function y(k,S){if(S.serializeBuffersForPostMessage){const D=new F,R=(E,h)=>{if(h instanceof ArrayBuffer){const p=D.add(h);return{$$vscode_array_buffer_reference$$:!0,index:p}}else if(ArrayBuffer.isView(h)){const p=C(h);if(p){const v=D.add(h.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:p,byteLength:h.byteLength,byteOffset:h.byteOffset}}}}return h},P=JSON.stringify(k,R),u=D.buffers.map(E=>{const h=new Uint8Array(E);return m.VSBuffer.wrap(h)});return{message:P,buffers:u}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=y;function C(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function i(k,S){const D=S.map(u=>{const E=new ArrayBuffer(u.byteLength);return new Uint8Array(E).set(u.buffer),E}),R=S.length?(u,E)=>{if(typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const h=E,{index:p}=h,v=D[p];if(h.view)switch(h.view.type){case 1:return new Int8Array(v,h.view.byteOffset,h.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,h.view.byteOffset,h.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,h.view.byteOffset,h.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,h.view.byteOffset,h.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,h.view.byteOffset,h.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,h.view.byteOffset,h.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,h.view.byteOffset,h.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,h.view.byteOffset,h.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,h.view.byteOffset,h.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,h.view.byteOffset,h.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,h.view.byteOffset,h.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return E}:void 0;return{message:JSON.parse(k,R),arrayBuffers:D}}e.deserializeWebviewMessage=i}),define(pe[204],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(F){function y(i){const k=new Map;return i.types.forEach((S,D)=>{k.set(S,{asString:async()=>i.items[D].asString})}),k}F.toITreeDataTransfer=y;async function C(i){const k={types:[],items:[]},S=Array.from(i.entries());for(const D of S)k.types.push(D[0]),k.items.push({asString:await D[1].asString()});return k}F.toTreeDataTransferDTO=C})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(pe[88],ve([0,1,10,2]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function y(k,S){return k.scheme===m.Schemas.http||k.scheme===m.Schemas.https?k:(S&&S.authority&&S.isRemote&&k.scheme===m.Schemas.file&&(k=F.URI.from({scheme:m.Schemas.vscodeRemote,authority:S.authority,path:k.path})),F.URI.from({scheme:m.Schemas.https,authority:`${k.scheme}+${C(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=y;function C(k){return k.replace(/./g,S=>{const D=S.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?S:"-"+D.toString(16).padStart(4,"0")})}function i(k){return k.replace(/-([0-9a-f]{4})/g,(S,D)=>String.fromCharCode(parseInt(D,16)))}e.decodeAuthority=i}),define(pe[205],ve([0,1,3,6,88]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(k,S,D){this._proxy=k,this._editors=S,this._initData=D,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const R=S.getVisibleTextEditors();for(const P of this._insets.values())R.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,S,D,R,P){let u;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===k){u=a;break}if(!u)throw new Error("not a visible editor");const E=this,h=this._handlePool++,p=new m.Emitter,v=new m.Emitter,I=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,y.asWebviewUri)(a,E._initData.remote)}get cspSource(){return y.webviewGenericCspSource}set options(a){this._options=a,E._proxy.$setOptions(h,a)}get options(){return this._options}set html(a){this._html=a,E._proxy.$setHtml(h,a)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(a){return E._proxy.$postMessage(h,a)}},w=new class{constructor(){this.editor=k,this.line=S,this.height=D,this.webview=I,this.onDidDispose=v.event}dispose(){E._insets.has(h)&&(E._insets.delete(h),E._proxy.$disposeEditorInset(h),v.fire(),v.dispose(),p.dispose())}};return this._proxy.$createEditorInset(h,u.id,u.value.document.uri,S+1,D,R||{},P.identifier,P.extensionLocation),this._insets.set(h,{editor:k,inset:w,onDidReceiveMessage:p}),w}$onDidDispose(k){const S=this._insets.get(k);S&&S.inset.dispose()}$onDidReceiveMessage(k,S){const D=this._insets.get(k);D&&D.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=C}),define(pe[206],ve([0,1,171,13,2,6,4,61,51,42,16,10]),function(Y,e,m,F,y,C,i,k,S,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,m.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,m.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,m.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,m.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,m.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,m.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function u(L,x,M){for(const V of M.visibleEditorPanes)if(V.group.id===x&&L.matches(V.input))return V.getViewState()}e.findViewStateForEditor=u;function E(L){if(g(L))return!1;const x=L;return y.URI.isUri(x?.resource)}e.isResourceEditorInput=E;function h(L){if(g(L))return!1;const x=L;return x?.original!==void 0&&x.modified!==void 0}e.isResourceDiffEditorInput=h;function p(L){if(g(L)||h(L))return!1;const x=L;return x?.primary!==void 0&&x.secondary!==void 0}e.isResourceSideBySideEditorInput=p;function v(L){if(g(L))return!1;const x=L;return x?x.resource===void 0||x.resource.scheme===P.Schemas.untitled||x.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=v;var I;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(I=e.Verbosity||(e.Verbosity={}));var w;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(w=e.SaveReason||(e.SaveReason={}));var a;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription"})(a=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends C.Disposable{}e.AbstractEditorInput=r;function g(L){return L instanceof r}e.isEditorInput=g;function o(L){const x=L;return y.URI.isUri(x?.preferredResource)}function _(L){const x=L;return g(x?.primary)&&g(x?.secondary)}e.isSideBySideEditorInput=_;function n(L){const x=L;return g(x?.modified)&&g(x?.original)}e.isDiffEditorInput=n;function t(L){return g(L?.editor)}e.isEditorInputWithOptions=t;function s(L){const x=L;return t(L)&&x?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function d(L){const x=L;return typeof x?.groupId=="number"&&g(x.editor)}e.isEditorIdentifier=d;var c;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(c=e.EditorCloseContext||(e.EditorCloseContext={}));var f;(function(L){L[L.GROUP_ACTIVE=0]="GROUP_ACTIVE",L[L.GROUP_INDEX=1]="GROUP_INDEX",L[L.GROUP_LOCKED=2]="GROUP_LOCKED",L[L.EDITOR_OPEN=3]="EDITOR_OPEN",L[L.EDITOR_CLOSE=4]="EDITOR_CLOSE",L[L.EDITOR_MOVE=5]="EDITOR_MOVE",L[L.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",L[L.EDITOR_LABEL=7]="EDITOR_LABEL",L[L.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",L[L.EDITOR_PIN=9]="EDITOR_PIN",L[L.EDITOR_STICKY=10]="EDITOR_STICKY",L[L.EDITOR_DIRTY=11]="EDITOR_DIRTY",L[L.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(f=e.GroupChangeKind||(e.GroupChangeKind={}));var l;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(l=e.SideBySideEditor||(e.SideBySideEditor={}));class b{getOriginalUri(x,M){if(!x)return;if(M?.supportSideBySide){const{primary:O,secondary:W}=this.getSideEditors(x);if(O&&W){if(M?.supportSideBySide===l.BOTH)return{primary:this.getOriginalUri(O,{filterByScheme:M.filterByScheme}),secondary:this.getOriginalUri(W,{filterByScheme:M.filterByScheme})};if(M?.supportSideBySide===l.ANY)return this.getOriginalUri(O,{filterByScheme:M.filterByScheme})??this.getOriginalUri(W,{filterByScheme:M.filterByScheme});x=M.supportSideBySide===l.PRIMARY?O:W}}if(h(x)||p(x))return;const V=o(x)?x.preferredResource:x.resource;return!V||!M||!M.filterByScheme?V:this.filterUri(V,M.filterByScheme)}getSideEditors(x){return _(x)||p(x)?{primary:x.primary,secondary:x.secondary}:n(x)||h(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,M){if(!x)return;if(M?.supportSideBySide){const{primary:O,secondary:W}=this.getSideEditors(x);if(O&&W){if(M?.supportSideBySide===l.BOTH)return{primary:this.getCanonicalUri(O,{filterByScheme:M.filterByScheme}),secondary:this.getCanonicalUri(W,{filterByScheme:M.filterByScheme})};if(M?.supportSideBySide===l.ANY)return this.getCanonicalUri(O,{filterByScheme:M.filterByScheme})??this.getCanonicalUri(W,{filterByScheme:M.filterByScheme});x=M.supportSideBySide===l.PRIMARY?O:W}}if(h(x)||p(x))return;const V=x.resource;return!V||!M||!M.filterByScheme?V:this.filterUri(V,M.filterByScheme)}filterUri(x,M){if(Array.isArray(M)){if(M.some(V=>x.scheme===V))return x}else if(M===x.scheme)return x}}e.EditorResourceAccessor=new b;var T;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(T=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(x){const M=this.instantiationService=x.get(i.IInstantiationService);for(const[V,O]of this.editorSerializerConstructors)this.createEditorSerializer(V,O,M);this.editorSerializerConstructors.clear()}createEditorSerializer(x,M,V){const O=V.createInstance(M);this.editorSerializerInstances.set(x,O)}registerFileEditorFactory(x){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=x}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(x,M){if(this.editorSerializerConstructors.has(x)||this.editorSerializerInstances.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.instantiationService?this.createEditorSerializer(x,M,this.instantiationService):this.editorSerializerConstructors.set(x,M),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(x),this.editorSerializerInstances.delete(x)})}getEditorSerializer(x){return this.editorSerializerInstances.get(typeof x=="string"?x:x.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new A);async function U(L,x){if(!L||!L.length)return[];const M=await Promise.all(L.map(async V=>{const O=y.URI.revive(V.fileUri);if(!O||!await x.canHandleResource(O))return;let q=V.exists,N=V.type;if(typeof q!="boolean"||typeof N!="number")try{N=(await x.resolve(O)).isDirectory?D.FileType.Directory:D.FileType.Unknown,q=!0}catch{q=!1}if(!q&&V.openOnlyIfExists||N===D.FileType.Directory)return;const G={selection:q?V.selection:void 0,pinned:!0,override:V.editorOverrideId};let $;return q?$={resource:O,options:G}:$={resource:O,options:G,forceUntitled:!0},$}));return(0,R.coalesce)(M)}e.pathsToEditors=U;var B;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(pe[123],ve([0,1,3,18,172]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,S,D,R){const P={command:k};if(S&&Object.keys(S).length>0&&(P.arguments=S),this.internalSend("request",P),typeof R=="number"){const u=setTimeout(()=>{clearTimeout(u);const E=this.pendingRequests.get(P.seq);if(E){this.pendingRequests.delete(P.seq);const h={type:"response",seq:0,request_seq:P.seq,success:!1,command:k,message:(0,y.localize)(0,null,R,k)};E(h)}},R)}return D&&this.pendingRequests.set(P.seq,D),P.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,S){return k.type!=="event"||S.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,F.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const S=k,D=this.pendingRequests.get(S.request_seq);D&&(this.pendingRequests.delete(S.request_seq),D(S));break}}}internalSend(k,S){S.type=k,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((S,D)=>k.set(D,S)),await(0,F.timeout)(500),k.forEach((S,D)=>{S({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(D)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(pe[207],ve([0,1,8,2,9,25,10]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function S(n,t,s){return n.replace(k,function(d,c){return t&&c.length>0&&c[0]!=="_"?d:s&&s.hasOwnProperty(c)?s[c]:d})}e.formatPII=S;function D(n){const t={};for(const s of Object.keys(n))s.startsWith("!")||(t[s]=n[s]);return t}e.filterExceptionsFromTelemetry=D;function R(n){return n.configuration.request==="attach"&&!P(n)&&(!n.parentSession||R(n.parentSession))}e.isSessionAttach=R;function P(n){let t=n.configuration.type;if(!!t)return t==="vslsShare"&&(t=n.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(t,"extensionhost")||(0,m.equalsIgnoreCase)(t,"pwa-extensionhost")?n:n.parentSession?P(n.parentSession):void 0}e.getExtensionHostDebugSession=P;function u(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=u;function E(n,t,s){let d,c=0,f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,l=null;for(;l=f.exec(n);){let b=l.index+1,T=b+l[0].length;if(b<=t&&T>=s){d=l[0],c=b;break}}if(d){let b=/\w+/g,T=null;for(;(T=b.exec(d))&&!(T.index+1+c+T[0].length>=s););T&&(d=d.substring(0,b.lastIndex))}return d?{start:c,end:c+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=E;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(n){return!!(n&&n.match(h))}e.isUri=p;function v(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(p(n.path))return F.URI.parse(n.path);if((0,y.isAbsolute)(n.path))return F.URI.file(n.path)}return n.path}function I(n){if(typeof n.path=="object"){const t=F.URI.revive(n.path);if(t)return t.scheme===i.Schemas.file?t.fsPath:t.toString()}return n.path}function w(n,t){const s=t?v:I,d=(0,C.deepClone)(n);return r(d,(c,f)=>{c&&f&&(f.path=s(f))}),d}e.convertToDAPaths=w;function a(n,t){const s=t?v:I,d=(0,C.deepClone)(n);return r(d,(c,f)=>{!c&&f&&(f.path=s(f))}),d}e.convertToVSCPaths=a;function r(n,t){switch(n.type){case"event":const s=n;switch(s.event){case"output":t(!1,s.body.source);break;case"loadedSource":t(!1,s.body.source);break;case"breakpoint":t(!1,s.body.breakpoint.source);break;default:break}break;case"request":const d=n;switch(d.command){case"setBreakpoints":t(!0,d.arguments.source);break;case"breakpointLocations":t(!0,d.arguments.source);break;case"source":t(!0,d.arguments.source);break;case"gotoTargets":t(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(f=>t(!1,f));break;default:break}break;case"response":const c=n;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(f=>t(!1,f.source));break;case"loadedSources":c.body.sources.forEach(f=>t(!1,f));break;case"scopes":c.body.scopes.forEach(f=>t(!1,f.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(f=>t(!1,f.source));break;case"setBreakpoints":c.body.breakpoints.forEach(f=>t(!1,f.source));break;default:break}break}}function g(n){return n.filter(t=>!t.presentation?.hidden).sort((t,s)=>t.presentation?s.presentation?t.presentation.group?s.presentation.group?t.presentation.group!==s.presentation.group?t.presentation.group.localeCompare(s.presentation.group):o(t.presentation.order,s.presentation.order):-1:s.presentation.group?1:o(t.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=g;function o(n,t){return typeof n!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:n-t}async function _(n,t){const s=n.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorMode});if(s!=="none"&&(await t.saveAll(),s==="allEditorsInActiveGroup")){const d=t.activeEditorPane;d&&await t.save({editor:d.input,groupId:d.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=_}),define(pe[208],ve([0,1,28,37,173,124,9,8,25,12,183,123]),function(Y,e,m,F,y,C,i,k,S,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class u extends P.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(w,a){this.outputStream=a,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,w.on("data",r=>this.handleData(r))}sendMessage(w){if(this.outputStream){const a=JSON.stringify(w);this.outputStream.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${u.TWO_CRLF}${a}`,"utf8")}}handleData(w){for(this.rawData=Buffer.concat([this.rawData,w]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const a=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(r){this._onError.fire(new Error((r.message||r)+`
`+a))}continue}}else{const a=this.rawData.indexOf(u.TWO_CRLF);if(a!==-1){const g=this.rawData.toString("utf8",0,a).split(u.HEADER_LINESEPARATOR);for(const o of g){const _=o.split(u.HEADER_FIELDSEPARATOR);_[0]==="Content-Length"&&(this.contentLength=Number(_[1]))}this.rawData=this.rawData.slice(a+u.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=u,u.TWO_CRLF=`\r
\r
`,u.HEADER_LINESEPARATOR=/\r?\n/,u.HEADER_FIELDSEPARATOR=/: */;class E extends u{startSession(){return new Promise((w,a)=>{let r=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),w(),r=!0}),this.socket.on("close",()=>{r?this._onError.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.socket.on("error",g=>{r?this._onError.fire(g):a(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class h extends E{constructor(w){super();this.adapterServer=w}createConnection(w){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",w)}}e.SocketDebugAdapter=h;class p extends E{constructor(w){super();this.adapterServer=w}createConnection(w){return C.createConnection(this.adapterServer.path,w)}}e.NamedPipeDebugAdapter=p;class v extends u{constructor(w,a,r){super();this.adapterExecutable=w,this.debugType=a,this.outputService=r}async startSession(){const w=this.adapterExecutable.command,a=this.adapterExecutable.args,r=this.adapterExecutable.options||{};try{if(w)if(i.isAbsolute(w)){if(!await m.Promises.exists(w))throw new Error(y.localize(0,null,w))}else w.indexOf("/")<0&&w.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.debugType));let g=process.env;if(r.env&&Object.keys(r.env).length>0&&(g=S.mixin(S.deepClone(process.env),r.env)),w==="node")if(Array.isArray(a)&&a.length>0){const _=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:g,execArgv:_?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(n.cwd=r.cwd);const t=F.fork(a[0],a.slice(1),n);if(!t.pid)throw new Error(y.localize(2,null,a[0]));this.serverProcess=t}else throw new Error(y.localize(3,null));else{const _={env:g};r.cwd&&(_.cwd=r.cwd),this.serverProcess=F.spawn(w,a,_)}this.serverProcess.on("error",_=>{this._onError.fire(_)}),this.serverProcess.on("exit",(_,n)=>{this._onExit.fire(_)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",_=>{this._onError.fire(_)}),this.serverProcess.stdin.on("error",_=>{this._onError.fire(_)});const o=this.outputService;if(o){const _=n=>n.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",n=>{const t=o.getChannel(R.ExtensionsChannelId);t&&t.append(_(n))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),D.isWindows?new Promise((w,a)=>{const r=F.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,o,_){if(g)return a(g)});r.on("exit",w),r.on("error",a)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(w,a){if(!w)return;const r=Object.create(null);w.runtime&&(w.runtime.indexOf("./")===0?r.runtime=i.join(a,w.runtime):r.runtime=w.runtime),w.runtimeArgs&&(r.runtimeArgs=w.runtimeArgs),w.program&&(i.isAbsolute(w.program)?r.program=w.program:r.program=i.join(a,w.program)),w.args&&(r.args=w.args);const g=w;return g.win&&(r.win=v.extract(g.win,a)),g.winx86&&(r.winx86=v.extract(g.winx86,a)),g.windows&&(r.windows=v.extract(g.windows,a)),g.osx&&(r.osx=v.extract(g.osx,a)),g.linux&&(r.linux=v.extract(g.linux,a)),r}static platformAdapterExecutable(w,a){let r=Object.create(null);a=a.toLowerCase();for(const s of w)if(s.contributes){const d=s.contributes.debuggers;d&&d.length>0&&d.filter(c=>typeof c.type=="string"&&k.equalsIgnoreCase(c.type,a)).forEach(c=>{const f=v.extract(c,s.extensionLocation.fsPath);r=S.mixin(r,f,s.isBuiltin)})}let g;D.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=r.winx86||r.win||r.windows:D.isWindows?g=r.win||r.windows:D.isMacintosh?g=r.osx:D.isLinux&&(g=r.linux),g=g||r;let o=g.program||r.program;const _=g.args||r.args;let n=g.runtime||r.runtime;const t=g.runtimeArgs||r.runtimeArgs;if(n)return{type:"executable",command:n,args:(t||[]).concat(typeof o=="string"?[o]:[]).concat(_||[])};if(o)return{type:"executable",command:o,args:_||[]}}}e.ExecutableDebugAdapter=v}),define(pe[209],ve([0,1,37,12,30,185]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function i(u,E){return new Promise((h,p)=>{let v="";const I=m.spawn(u,E);I.pid&&I.stdout.on("data",w=>{v+=w.toString()}),I.on("error",w=>{p(w)}),I.on("close",w=>{h(v)})})}let k;function S(u,E){if(!k)if(F.isWindows)k=new C.WindowsExternalTerminalService;else if(F.isMacintosh)k=new C.MacExternalTerminalService;else if(F.isLinux)k=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const h=E.getConfiguration("terminal");return k.runInTerminal(u.title,u.cwd,u.args,u.env||{},h.external||{})}e.runInExternalTerminal=S;async function D(u){if(u)if(F.isWindows){const E=await new Promise((h,p)=>{Y(["windows-process-tree"],h,p)});return new Promise(h=>{E.getProcessTree(u,p=>{h(p.children.length>0)})})}else return i("/usr/bin/pgrep",["-lP",String(u)]).then(E=>{const h=E.trim();return!(h.length===0||h.indexOf(" tmux")>=0)},E=>!0);return Promise.resolve(!0)}e.hasChildProcesses=D;var R;(function(u){u[u.cmd=0]="cmd",u[u.powershell=1]="powershell",u[u.bash=2]="bash"})(R||(R={}));function P(u,E,h,p){u=u.trim().toLowerCase();let v;u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0?v=1:u.indexOf("cmd.exe")>=0?v=0:u.indexOf("bash")>=0?v=2:F.isWindows?v=0:v=2;let I,w=" ";switch(v){case 1:if(I=r=>(r=r.replace(/\'/g,"''"),r.length>0&&r.charAt(r.length-1)==="\\"?`'${r}\\'`:`'${r}'`),h){const r=(0,y.getDriveLetter)(h);r&&(w+=`${r}:; `),w+=`cd ${I(h)}; `}if(p)for(let r in p){const g=p[r];g===null?w+=`Remove-Item env:${r}; `:w+=`\${env:${r}}='${g}'; `}if(E.length>0){const r=I(E.shift());w+=r[0]==="'"?`& ${r} `:`${r} `;for(let g of E)w+=`${I(g)} `}break;case 0:if(I=r=>(r=r.replace(/\"/g,'""'),r.indexOf(" ")>=0||r.indexOf('"')>=0||r.length===0?`"${r}"`:r),h){const r=(0,y.getDriveLetter)(h);r&&(w+=`${r}: && `),w+=`cd ${I(h)} && `}if(p){w+='cmd /C "';for(let r in p){let g=p[r];g===null?w+=`set "${r}=" && `:(g=g.replace(/[\^\&\|\<\>]/g,o=>`^${o}`),w+=`set "${r}=${g}" && `)}}for(let r of E)w+=`${I(r)} `;p&&(w+='"');break;case 2:I=r=>(r=r.replace(/(["'\\\$])/g,"\\$1"),r.indexOf(" ")>=0||r.indexOf(";")>=0||r.length===0?`"${r}"`:r);const a=r=>/[^\w@%\/+=,.:^-]/.test(r)?`'${r.replace(/'/g,"'\\''")}'`:r;if(h&&(w+=`cd ${I(h)} ; `),p){w+="/usr/bin/env";for(let r in p){const g=p[r];g===null?w+=` -u ${a(r)}`:w+=` ${a(`${r}=${g}`)}`}w+=" "}for(let r of E)w+=`${I(r)} `;break}return w}e.prepareCommand=P}),define(pe[125],ve([0,1,31,76,101,10,9,12,61]),function(Y,e,m,F,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(b){b[b.Markup=1]="Markup",b[b.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",y.Mimes.latex,y.Mimes.markdown,"image/png","image/jpeg",y.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[y.Mimes.latex,y.Mimes.markdown,"application/json",y.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(b){b[b.Running=1]="Running",b[b.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var P;(function(b){b[b.Pending=2]="Pending",b[b.Executing=3]="Executing"})(P=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var u;(function(b){b[b.WithHardKernelDependency=0]="WithHardKernelDependency",b[b.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",b[b.Pure=2]="Pure",b[b.Never=3]="Never"})(u=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(b){b.Always="always",b.Never="never",b.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(b){b[b.ModelChange=1]="ModelChange",b[b.Move=2]="Move",b[b.ChangeLanguage=5]="ChangeLanguage",b[b.Initialize=6]="Initialize",b[b.ChangeCellMetadata=7]="ChangeCellMetadata",b[b.Output=8]="Output",b[b.OutputItem=9]="OutputItem",b[b.ChangeCellContent=10]="ChangeCellContent",b[b.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",b[b.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",b[b.ChangeCellMime=13]="ChangeCellMime",b[b.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var p;(function(b){b[b.Handle=0]="Handle",b[b.Index=1]="Index"})(p=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(b){b[b.Replace=1]="Replace",b[b.Output=2]="Output",b[b.Metadata=3]="Metadata",b[b.CellLanguage=4]="CellLanguage",b[b.DocumentMetadata=5]="DocumentMetadata",b[b.Move=6]="Move",b[b.OutputItems=7]="OutputItems",b[b.PartialMetadata=8]="PartialMetadata",b[b.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var I;(function(b){b.scheme=C.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function A(V,O){return V.with({scheme:b.scheme,fragment:`ch${O.toString().padStart(7,"0")}${V.scheme!==C.Schemas.file?V.scheme:""}`})}b.generate=A;function U(V){if(V.scheme!==b.scheme)return;const O=T.exec(V.fragment);return O?{handle:Number(O[1]),notebook:V.with({scheme:V.fragment.substr(O[0].length)||C.Schemas.file,fragment:null})}:void 0}b.parse=U;function B(V,O,W){return V.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`ch${O.toString().padStart(7,"0")},${W??""},${V.scheme!==C.Schemas.file?V.scheme:""}`})}b.generateCellOutputUri=B;function L(V){if(V.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const O=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(V.fragment);if(!O)return;const W=Number(O[1]),q=O[2]&&O[2]!==""?O[2]:void 0,N=O[3];return{handle:W,outputId:q,notebook:V.with({scheme:N||C.Schemas.file,fragment:null})}}b.parseCellOutputUri=L;function x(V,O,W){return V.with({scheme:W,fragment:`ch${O.toString().padStart(7,"0")}${V.scheme!==C.Schemas.file?V.scheme:""}`})}b.generateCellUri=x;function M(V,O){if(V.scheme!==O)return;const W=T.exec(V.fragment);return W?{handle:Number(W[1]),notebook:V.with({scheme:V.fragment.substr(W[0].length)||C.Schemas.file,fragment:null})}:void 0}b.parseCellUri=M})(I=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function a(b){return w.get(b)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=a;function r(b){return w.get(b)?.supportedByCore??!1}e.mimeTypeSupportedByCore=r;function g(b){return w.get(b)?.mergeable??!1}e.mimeTypeIsMergeable=g;const o=b=>k.isWindows?b.replace(/\//g,"\\"):b;class _{constructor(T=[],A=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=A,this.order=[...new Set(T)].map(U=>({pattern:U,matches:m.parse(o(U))}))}sort(T){const A=new Map(F.Iterable.map(T,B=>[B,o(B)]));let U=[];for(const{matches:B}of this.order)for(const[L,x]of A)if(B(x)){U.push(L),A.delete(L);break}return A.size&&(U=U.concat([...A.keys()].sort((B,L)=>this.defaultOrder.indexOf(B)-this.defaultOrder.indexOf(L)))),U}prioritize(T,A){const U=this.findIndex(T);if(U===-1){this.order.unshift({pattern:T,matches:m.parse(o(T))});return}const B=new Set(A.map(x=>this.findIndex(x,U)));B.delete(-1);const L=Array.from(B).sort();this.order.splice(U+1,0,...L.map(x=>this.order[x]));for(let x=L.length-1;x>=0;x--)this.order.splice(L[x],1)}toArray(){return this.order.map(T=>T.pattern)}findIndex(T,A=this.order.length){const U=o(T);for(let B=0;B<A;B++)if(this.order[B].matches(U))return B;return-1}}e.MimeTypeDisplayOrder=_;function n(b,T,A,U=(B,L)=>B===L){const B=[];function L(V,O,W){if(O===0&&W.length===0)return;const q=B[B.length-1];q&&q.start+q.deleteCount===V?(q.deleteCount+=O,q.toInsert.push(...W)):B.push({start:V,deleteCount:O,toInsert:W})}let x=0,M=0;for(;;){if(x===b.length){L(x,0,T.slice(M));break}if(M===T.length){L(x,b.length-x,[]);break}const V=b[x],O=T[M];if(U(V,O)){x+=1,M+=1;continue}A(O)?(L(x,1,[]),x+=1):(L(x,0,[O]),M+=1)}return B}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(b){b.default="default",b.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(b){const T=b;return!!((typeof T.include=="string"||m.isRelativePattern(T.include))&&(typeof T.exclude=="string"||m.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=s;function d(b,T,A){if(Array.isArray(b.viewType)&&b.viewType.indexOf(T)>=0||b.viewType===T)return!0;if(b.filenamePattern){let U=s(b.filenamePattern)?b.filenamePattern.include:b.filenamePattern,B=s(b.filenamePattern)?b.filenamePattern.exclude:void 0;if(m.match(U,(0,i.basename)(A.fsPath).toLowerCase()))return!(B&&m.match(B,(0,i.basename)(A.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class c{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let A=0;A<this.textModel.cells.length;A++)T[A]=this.textModel.cells[A].getHashValue();return T}}e.CellSequence=c,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var f;(function(b){b[b.Left=1]="Left",b[b.Right=2]="Right"})(f=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class l{static create(T){return`${l._prefix}${T}`}static parse(T){if(T.startsWith(l._prefix))return T.substr(l._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=l,l._prefix="notebook/"}),define(pe[210],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState",y[y.Complete=4]="Complete"})(F=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(pe[211],ve([0,1,4,61]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new F.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new F.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new F.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,m.createDecorator)(e.OUTPUT_SERVICE_ID);var y;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(y=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(pe[212],ve([0,1,175,4,61]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new y.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new y.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new y.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(pe[213],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=m;function F(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=F}),define(pe[126],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var F;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable"})(F=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var y;(function(P){P[P.Error=0]="Error",P[P.Info=1]="Info"})(y=e.TestMessageType||(e.TestMessageType={}));var C;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const i=(P,u)=>{u.expand!==void 0&&(P.expand=u.expand),u.item!==void 0&&(P.item=P.item?Object.assign(P.item,u.item):u.item)};e.applyTestItemUpdate=i;var k;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var S;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.Remove=2]="Remove",P[P.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",P[P.Retire=4]="Retire",P[P.AddTag=5]="AddTag",P[P.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class D{add(u){}update(u){}remove(u,E){}complete(){}}e.IncrementalChangeCollector=D;class R{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(u){const E=this.createChangeCollector();for(const h of u)switch(h[0]){case 0:{const p=h[1];if(p.parent){if(this.items.has(p.parent)){const v=this.items.get(p.parent);v.children.add(p.item.extId);const I=this.createItem(p,v);this.items.set(p.item.extId,I),E.add(I)}}else{const v=this.createItem(p);this.roots.add(v),this.items.set(p.item.extId,v),E.add(v)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=h[1],v=this.items.get(p.extId);if(!v)break;p.expand!==void 0&&(v.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(v,p),E.update(v);break}case 2:{const p=this.items.get(h[1]);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const v=[[h[1]]];for(;v.length;)for(const I of v.pop()){const w=this.items.get(I);w&&(v.push(w.children),this.items.delete(I),E.remove(w,w!==p),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h[1]);break;case 3:this.updatePendingRoots(h[1]);break;case 5:this._tags.set(h[1].id,h[1]);break;case 6:this._tags.delete(h[1]);break}E.complete()}retireTest(u){}updatePendingRoots(u){this.pendingRootCount+=u}createChangeCollector(){return new D}}e.AbstractIncrementalTestCollection=R}),define(pe[89],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(C){C.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var F;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(F=e.TestPosition||(e.TestPosition={}));class y{constructor(i,k=i.length){if(this.path=i,this.viewEnd=k,i.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(i,k,S=i.parent){if(i.id===k)return new y([k]);let D=[i.id];for(let R=S;R&&R.id!==k;R=R.parent)D.push(R.id);return D.push(k),new y(D.reverse())}static isRoot(i){return!i.includes("\0")}static fromString(i){return new y(i.split("\0"))}static join(i,k){return new y([...i.path,k])}static joinToString(i,k){return i.toString()+"\0"+k}static compare(i,k){return i===k?0:k.startsWith(i+"\0")?2:i.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new y(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let i=1;i<=this.viewEnd;i++)yield new y(this.path,i)}compare(i){if(typeof i=="string")return y.compare(this.toString(),i);for(let k=0;k<i.viewEnd&&k<this.viewEnd;k++)if(i.path[k]!==this.path[k])return 1;return i.viewEnd>this.viewEnd?2:i.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let i=1;i<this.viewEnd;i++)this.stringifed+="\0",this.stringifed+=this.path[i]}return this.stringifed}}e.TestId=y}),define(pe[214],ve([0,1,9,40,13,25,12,80,176]),function(Y,e,m,F,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(P,u,E){this._contributedVariables=new Map,this._context=P,this._labelService=u,E&&(this._envVariablesPromise=E.then(h=>this.prepareEnv(h)))}prepareEnv(P){if(i.isWindows){const u=Object.create(null);return Object.keys(P).forEach(E=>{u[E.toLowerCase()]=P[E]}),u}return P}resolveWithEnvironment(P,u,E){return this.recursiveResolve(this.prepareEnv(P),u?u.uri:void 0,E)}async resolveAsync(P,u){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,u)}async resolveAnyBase(P,u,E,h){const p=C.deepClone(u);return i.isWindows&&p.windows?Object.keys(p.windows).forEach(v=>p[v]=p.windows[v]):i.isMacintosh&&p.osx?Object.keys(p.osx).forEach(v=>p[v]=p.osx[v]):i.isLinux&&p.linux&&Object.keys(p.linux).forEach(v=>p[v]=p.linux[v]),delete p.windows,delete p.osx,delete p.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,p,E,h)}async resolveAnyAsync(P,u,E){return this.resolveAnyBase(P,u,E)}async resolveAnyMap(P,u,E){const h=new Map;return{newConfig:await this.resolveAnyBase(P,u,E,h),resolvedVariables:h}}resolveWithInteractionReplace(P,u,E,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,u,E,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,u){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,u)}recursiveResolve(P,u,E,h,p){if(y.isString(E))return this.resolveString(P,u,E,h,p);if(y.isArray(E))return E.map(v=>this.recursiveResolve(P,u,v,h,p));if(y.isObject(E)){let v=Object.create(null);return Object.keys(E).forEach(I=>{const w=this.resolveString(P,u,I,h,p);v[w]=this.recursiveResolve(P,u,E[I],h,p)}),v}return E}resolveString(P,u,E,h,p){return E.replace(D.VARIABLE_REGEXP,(I,w)=>{if(w.includes(D.VARIABLE_LHS))return I;let a=this.evaluateSingleVariable(P,I,w,u,h);return p&&p.set(w,a),a!==I&&y.isString(a)&&a.match(D.VARIABLE_REGEXP)&&(a=this.resolveString(P,u,a,h,p)),a})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,u,E,h,p){let v;const I=E.split(":");I.length>1&&(E=I[0],v=I[1]);const w=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error((0,S.localize)(0,null,u))},a=()=>{const g=w();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error((0,S.localize)(1,null,u,m.basename(g)))},r=()=>{if(v){const g=this._context.getFolderUri(v);if(g)return g;throw new Error((0,S.localize)(2,null,u,v))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,u)):new Error((0,S.localize)(4,null,u))};switch(E){case"env":if(v){if(P){const g=P[i.isWindows?v.toLowerCase():v];if(y.isString(g))return g}return""}throw new Error((0,S.localize)(5,null,u));case"config":if(v){const g=this._context.getConfigurationValue(h,v);if(y.isUndefinedOrNull(g))throw new Error((0,S.localize)(6,null,u,v));if(y.isObject(g))throw new Error((0,S.localize)(7,null,u,v));return g}throw new Error((0,S.localize)(8,null,u));case"command":return this.resolveFromMap(u,v,p,"command");case"input":return this.resolveFromMap(u,v,p,"input");default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(r()));case"cwd":return h||v?(0,k.normalizeDriveLetter)(this.fsPath(r())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(r()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error((0,S.localize)(9,null,u));case"selectedText":const o=this._context.getSelectedText();if(o)return o;throw new Error((0,S.localize)(10,null,u));case"file":return w();case"fileWorkspaceFolder":return a();case"relativeFile":return h||v?m.relative(this.fsPath(r()),w()):w();case"relativeFileDirname":const _=m.dirname(w());if(h||v){const d=m.relative(this.fsPath(r()),_);return d.length===0?".":d}return _;case"fileDirname":return m.dirname(w());case"fileExtname":return m.extname(w());case"fileBasename":return m.basename(w());case"fileBasenameNoExtension":const n=m.basename(w());return n.slice(0,n.length-m.extname(n).length);case"fileDirnameBasename":return m.basename(m.dirname(w()));case"execPath":const t=this._context.getExecPath();return t||u;case"execInstallFolder":const s=this._context.getAppRoot();return s||u;case"pathSeparator":return m.sep;default:try{const d=v?`${E}:${v}`:E;return this.resolveFromMap(u,d,p,void 0)}catch(d){return u}}}}resolveFromMap(P,u,E,h){if(u&&E){const p=h===void 0?E[u]:E[h+":"+u];if(typeof p=="string")return p;throw new Error((0,S.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(pe[127],ve([0,1,4,206]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var y;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var C;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var i;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(i=e.GroupLocation||(e.GroupLocation={}));var k;(function(h){h[h.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function D(h){const p=h;return(0,F.isEditorInput)(p?.editor)&&(0,F.isEditorInput)(p?.replacement)}e.isEditorReplacement=D;var R;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(P=e.OpenEditorContext||(e.OpenEditorContext={}));function u(h){const p=h;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=u;function E(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(pe[215],ve([0,1,4,127]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(C){const i=C;return typeof C=="number"||(0,F.isEditorGroup)(i)}e.isPreferredGroup=y}),define(pe[17],ve([0,1,16,22,97,290,59,25,13,2,41,84,177,116,63,125,89,215,7]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(de){function Ce(X){const{selectionStartLineNumber:De,selectionStartColumn:Re,positionLineNumber:Ze,positionColumn:qe}=X,dt=new w.Position(De-1,Re-1),wt=new w.Position(Ze-1,qe-1);return new w.Selection(dt,wt)}de.to=Ce;function ce(X){const{anchor:De,active:Re}=X;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}de.from=ce})(a=e.Selection||(e.Selection={}));var r;(function(de){function Ce(X){if(!X)return;const{start:De,end:Re}=X;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}de.from=Ce;function ce(X){if(!X)return;const{startLineNumber:De,startColumn:Re,endLineNumber:Ze,endColumn:qe}=X;return new w.Range(De-1,Re-1,Ze-1,qe-1)}de.to=ce})(r=e.Range||(e.Range={}));var g;(function(de){function Ce(ce){switch(ce){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}de.to=Ce})(g=e.TokenType||(e.TokenType={}));var o;(function(de){function Ce(X){return new w.Position(X.lineNumber-1,X.column-1)}de.to=Ce;function ce(X){return{lineNumber:X.line+1,column:X.character+1}}de.from=ce})(o=e.Position||(e.Position={}));var _;(function(de){function Ce(De,Re){return(0,m.coalesce)((0,m.asArray)(De).map(Ze=>ce(Ze,Re)))}de.from=Ce;function ce(De,Re){if(typeof De=="string")return{$serialized:!0,language:De};if(De)return{$serialized:!0,language:De.language,scheme:X(De.scheme,Re),pattern:typeof De.pattern=="undefined"?void 0:J.from(De.pattern),exclusive:De.exclusive}}function X(De,Re){return Re&&typeof De=="string"?Re.transformOutgoingScheme(De):De}})(_=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(de){function Ce(X){switch(X){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}de.from=Ce;function ce(X){switch(X){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}de.to=ce})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(de){function Ce(X){let De;return X.code&&((0,S.isString)(X.code)||(0,S.isNumber)(X.code)?De=String(X.code):De={value:String(X.code.value),target:X.code.target}),{...r.from(X.range),message:X.message,source:X.source,code:De,severity:d.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(s.from),tags:Array.isArray(X.tags)?(0,m.coalesce)(X.tags.map(n.from)):void 0}}de.from=Ce;function ce(X){const De=new w.Diagnostic(r.to(X),X.message,d.to(X.severity));return De.source=X.source,De.code=(0,S.isString)(X.code)?X.code:X.code?.value,De.relatedInformation=X.relatedInformation&&X.relatedInformation.map(s.to),De.tags=X.tags&&(0,m.coalesce)(X.tags.map(n.to)),De}de.to=ce})(t=e.Diagnostic||(e.Diagnostic={}));var s;(function(de){function Ce(X){return{...r.from(X.location.range),message:X.message,resource:X.location.uri}}de.from=Ce;function ce(X){return new w.DiagnosticRelatedInformation(new w.Location(X.resource,r.to(X)),X.message)}de.to=ce})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var d;(function(de){function Ce(X){switch(X){case w.DiagnosticSeverity.Error:return E.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return E.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return E.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return E.MarkerSeverity.Hint}return E.MarkerSeverity.Error}de.from=Ce;function ce(X){switch(X){case E.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case E.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case E.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case E.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}de.to=ce})(d=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(de){function Ce(X){return typeof X=="number"&&X>=w.ViewColumn.One?X-1:X===w.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}de.from=Ce;function ce(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}de.to=ce})(c=e.ViewColumn||(e.ViewColumn={}));function f(de){return typeof de.range!="undefined"}function l(de){return de.length===0?!0:!!f(de[0])}e.isDecorationOptionsArr=l;var b;(function(de){function Ce(qe){return qe.map(de.from)}de.fromMany=Ce;function ce(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function X(qe){let dt;if(ce(qe)){const{language:ft,value:vt}=qe;dt={value:"```"+ft+`
`+vt+"\n```\n"}}else w.MarkdownString.isMarkdownString(qe)?dt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml}:typeof qe=="string"?dt={value:qe}:dt={value:""};const wt=Object.create(null);dt.uris=wt;const yt=ft=>{try{let vt=D.URI.parse(ft,!0);vt=vt.with({query:De(vt.query,wt)}),wt[ft]=vt}catch(vt){}return""},bt=new C.Renderer;return bt.link=yt,bt.image=ft=>yt(y.parseHrefAndDimensions(ft).href),C(dt.value,{renderer:bt}),dt}de.from=X;function De(qe,dt){if(!qe)return qe;let wt;try{wt=(0,i.parse)(qe)}catch(bt){}if(!wt)return qe;let yt=!1;return wt=(0,k.cloneAndChange)(wt,bt=>{if(D.URI.isUri(bt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[ft]=bt,yt=!0,ft}else return}),yt?JSON.stringify(wt):qe}function Re(qe){const dt=new w.MarkdownString(qe.value,qe.supportThemeIcons);return dt.isTrusted=qe.isTrusted,dt.supportHtml=qe.supportHtml,dt}de.to=Re;function Ze(qe){if(!!qe)return typeof qe=="string"?qe:de.from(qe)}de.fromStrict=Ze})(b=e.MarkdownString||(e.MarkdownString={}));function T(de){return l(de)?de.map(Ce=>({range:r.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?b.fromMany(Ce.hoverMessage):Ce.hoverMessage?b.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):de.map(Ce=>({range:r.from(Ce)}))}e.fromRangeOrRangeWithMessage=T;function A(de){return typeof de=="undefined"?de:typeof de=="string"?D.URI.file(de):de}e.pathOrURIToURI=A;var U;(function(de){function Ce(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?A(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}de.from=Ce})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(de){function Ce(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?A(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?U.from(ce.before):void 0,after:ce.after?U.from(ce.after):void 0}}de.from=Ce})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var L;(function(de){function Ce(ce){if(typeof ce=="undefined")return ce;switch(ce){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}de.from=Ce})(L=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(de){function Ce(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?L.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?B.from(ce.light):void 0,dark:ce.dark?B.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?A(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?U.from(ce.before):void 0,after:ce.after?U.from(ce.after):void 0}}de.from=Ce})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var M;(function(de){function Ce(X){return{text:X.newText,eol:X.newEol&&ct.from(X.newEol),range:r.from(X.range)}}de.from=Ce;function ce(X){const De=new w.TextEdit(r.to(X.range),X.text);return De.newEol=typeof X.eol=="undefined"?void 0:ct.to(X.eol),De}de.to=ce})(M=e.TextEdit||(e.TextEdit={}));var V;(function(de){function Ce(X,De,Re){const Ze={edits:[]};if(X instanceof w.WorkspaceEdit)for(let qe of X._allEntries())if(qe._type===1)Ze.edits.push({_type:1,oldUri:qe.from,newUri:qe.to,options:qe.options,metadata:qe.metadata});else if(qe._type===2){const dt=De?.getDocument(qe.uri);Ze.edits.push({_type:2,resource:qe.uri,edit:M.from(qe.edit),modelVersionId:dt?.version,metadata:qe.metadata})}else qe._type===3?Ze.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,edit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Re?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version}):qe._type===5&&Ze.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,notebookVersionId:Re?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Oe.from)}});return Ze}de.from=Ce;function ce(X){const De=new w.WorkspaceEdit;for(const Re of X.edits)Re.edit?De.replace(D.URI.revive(Re.resource),r.to(Re.edit.range),Re.edit.text):De.renameFile(D.URI.revive(Re.oldUri),D.URI.revive(Re.newUri),Re.options);return De}de.to=ce})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var O;(function(de){const Ce=Object.create(null);Ce[w.SymbolKind.File]=0,Ce[w.SymbolKind.Module]=1,Ce[w.SymbolKind.Namespace]=2,Ce[w.SymbolKind.Package]=3,Ce[w.SymbolKind.Class]=4,Ce[w.SymbolKind.Method]=5,Ce[w.SymbolKind.Property]=6,Ce[w.SymbolKind.Field]=7,Ce[w.SymbolKind.Constructor]=8,Ce[w.SymbolKind.Enum]=9,Ce[w.SymbolKind.Interface]=10,Ce[w.SymbolKind.Function]=11,Ce[w.SymbolKind.Variable]=12,Ce[w.SymbolKind.Constant]=13,Ce[w.SymbolKind.String]=14,Ce[w.SymbolKind.Number]=15,Ce[w.SymbolKind.Boolean]=16,Ce[w.SymbolKind.Array]=17,Ce[w.SymbolKind.Object]=18,Ce[w.SymbolKind.Key]=19,Ce[w.SymbolKind.Null]=20,Ce[w.SymbolKind.EnumMember]=21,Ce[w.SymbolKind.Struct]=22,Ce[w.SymbolKind.Event]=23,Ce[w.SymbolKind.Operator]=24,Ce[w.SymbolKind.TypeParameter]=25;function ce(De){return typeof Ce[De]=="number"?Ce[De]:6}de.from=ce;function X(De){for(const Re in Ce)if(Ce[Re]===De)return Number(Re);return w.SymbolKind.Property}de.to=X})(O=e.SymbolKind||(e.SymbolKind={}));var W;(function(de){function Ce(X){switch(X){case w.SymbolTag.Deprecated:return 1}}de.from=Ce;function ce(X){switch(X){case 1:return w.SymbolTag.Deprecated}}de.to=ce})(W=e.SymbolTag||(e.SymbolTag={}));var q;(function(de){function Ce(X){return{name:X.name,kind:O.from(X.kind),tags:X.tags&&X.tags.map(W.from),containerName:X.containerName,location:j.from(X.location)}}de.from=Ce;function ce(X){const De=new w.SymbolInformation(X.name,O.to(X.kind),X.containerName,j.to(X.location));return De.tags=X.tags&&X.tags.map(W.to),De}de.to=ce})(q=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var N;(function(de){function Ce(X){const De={name:X.name||"!!MISSING: name!!",detail:X.detail,range:r.from(X.range),selectionRange:r.from(X.selectionRange),kind:O.from(X.kind),tags:X.tags?.map(W.from)??[]};return X.children&&(De.children=X.children.map(Ce)),De}de.from=Ce;function ce(X){const De=new w.DocumentSymbol(X.name,X.detail,O.to(X.kind),r.to(X.range),r.to(X.selectionRange));return(0,m.isNonEmptyArray)(X.tags)&&(De.tags=X.tags.map(W.to)),X.children&&(De.children=X.children.map(ce)),De}de.to=ce})(N=e.DocumentSymbol||(e.DocumentSymbol={}));var G;(function(de){function Ce(X){const De=new w.CallHierarchyItem(O.to(X.kind),X.name,X.detail||"",D.URI.revive(X.uri),r.to(X.range),r.to(X.selectionRange));return De._sessionId=X._sessionId,De._itemId=X._itemId,De}de.to=Ce;function ce(X,De,Re){if(De=De??X._sessionId,Re=Re??X._itemId,De===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Re,name:X.name,detail:X.detail,kind:O.from(X.kind),uri:X.uri,range:r.from(X.range),selectionRange:r.from(X.selectionRange),tags:X.tags?.map(W.from)}}de.from=ce})(G=e.CallHierarchyItem||(e.CallHierarchyItem={}));var $;(function(de){function Ce(ce){return new w.CallHierarchyIncomingCall(G.to(ce.from),ce.fromRanges.map(X=>r.to(X)))}de.to=Ce})($=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var H;(function(de){function Ce(ce){return new w.CallHierarchyOutgoingCall(G.to(ce.to),ce.fromRanges.map(X=>r.to(X)))}de.to=Ce})(H=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var j;(function(de){function Ce(X){return{range:X.range&&r.from(X.range),uri:X.uri}}de.from=Ce;function ce(X){return new w.Location(D.URI.revive(X.uri),r.to(X.range))}de.to=ce})(j=e.location||(e.location={}));var ie;(function(de){function Ce(X){const De=X,Re=X;return{originSelectionRange:De.originSelectionRange?r.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Re.uri,range:r.from(De.targetRange?De.targetRange:Re.range),targetSelectionRange:De.targetSelectionRange?r.from(De.targetSelectionRange):void 0}}de.from=Ce;function ce(X){return{targetUri:D.URI.revive(X.uri),targetRange:r.to(X.range),targetSelectionRange:X.targetSelectionRange?r.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?r.to(X.originSelectionRange):void 0}}de.to=ce})(ie=e.DefinitionLink||(e.DefinitionLink={}));var fe;(function(de){function Ce(X){return{range:r.from(X.range),contents:b.fromMany(X.contents)}}de.from=Ce;function ce(X){return new w.Hover(X.contents.map(b.to),r.to(X.range))}de.to=ce})(fe=e.Hover||(e.Hover={}));var ye;(function(de){function Ce(X){return{range:r.from(X.range),expression:X.expression}}de.from=Ce;function ce(X){return new w.EvaluatableExpression(r.to(X.range),X.expression)}de.to=ce})(ye=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ie;(function(de){function Ce(X){if(X instanceof w.InlineValueText)return{type:"text",range:r.from(X.range),text:X.text};if(X instanceof w.InlineValueVariableLookup)return{type:"variable",range:r.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:r.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}de.from=Ce;function ce(X){switch(X.type){case"text":return{range:r.to(X.range),text:X.text};case"variable":return{range:r.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:r.to(X.range),expression:X.expression}}}de.to=ce})(Ie=e.InlineValue||(e.InlineValue={}));var Be;(function(de){function Ce(X){return{frameId:X.frameId,stoppedLocation:r.from(X.stoppedLocation)}}de.from=Ce;function ce(X){return new w.InlineValueContext(X.frameId,r.to(X.stoppedLocation))}de.to=ce})(Be=e.InlineValueContext||(e.InlineValueContext={}));var We;(function(de){function Ce(X){return{range:r.from(X.range),kind:X.kind}}de.from=Ce;function ce(X){return new w.DocumentHighlight(r.to(X.range),X.kind)}de.to=ce})(We=e.DocumentHighlight||(e.DocumentHighlight={}));var ze;(function(de){function Ce(ce){switch(ce){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}de.to=Ce})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Q;(function(de){function Ce(ce){return{triggerKind:ze.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}de.to=Ce})(Q=e.CompletionContext||(e.CompletionContext={}));var ee;(function(de){function Ce(X){switch(X){case w.CompletionItemTag.Deprecated:return 1}}de.from=Ce;function ce(X){switch(X){case 1:return w.CompletionItemTag.Deprecated}}de.to=ce})(ee=e.CompletionItemTag||(e.CompletionItemTag={}));var re;(function(de){const Ce=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function ce(Re){return Ce.get(Re)??9}de.from=ce;const X=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function De(Re){return X.get(Re)??w.CompletionItemKind.Property}de.to=De})(re=e.CompletionItemKind||(e.CompletionItemKind={}));var he;(function(de){function Ce(ce,X){const De=new w.CompletionItem(ce.label);return De.insertText=ce.insertText,De.kind=re.to(ce.kind),De.tags=ce.tags?.map(ee.to),De.detail=ce.detail,De.documentation=y.isMarkdownString(ce.documentation)?b.to(ce.documentation):ce.documentation,De.sortText=ce.sortText,De.filterText=ce.filterText,De.preselect=ce.preselect,De.commitCharacters=ce.commitCharacters,R.Range.isIRange(ce.range)?De.range=r.to(ce.range):typeof ce.range=="object"&&(De.range={inserting:r.to(ce.range.insert),replacing:r.to(ce.range.replace)}),De.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?De.insertText=new w.SnippetString(ce.insertText):(De.insertText=ce.insertText,De.textEdit=De.range instanceof w.Range?new w.TextEdit(De.range,De.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(De.additionalTextEdits=ce.additionalTextEdits.map(Re=>M.to(Re))),De.command=X&&ce.command?X.fromInternal(ce.command):void 0,De}de.to=Ce})(he=e.CompletionItem||(e.CompletionItem={}));var Z;(function(de){function Ce(X){return{label:X.label,documentation:X.documentation?b.fromStrict(X.documentation):void 0}}de.from=Ce;function ce(X){return{label:X.label,documentation:y.isMarkdownString(X.documentation)?b.to(X.documentation):X.documentation}}de.to=ce})(Z=e.ParameterInformation||(e.ParameterInformation={}));var oe;(function(de){function Ce(X){return{label:X.label,documentation:X.documentation?b.fromStrict(X.documentation):void 0,parameters:Array.isArray(X.parameters)?X.parameters.map(Z.from):[],activeParameter:X.activeParameter}}de.from=Ce;function ce(X){return{label:X.label,documentation:y.isMarkdownString(X.documentation)?b.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(Z.to):[],activeParameter:X.activeParameter}}de.to=ce})(oe=e.SignatureInformation||(e.SignatureInformation={}));var be;(function(de){function Ce(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(oe.from):[]}}de.from=Ce;function ce(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(oe.to):[]}}de.to=ce})(be=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(de){function Ce(X){return{text:X.text,position:o.from(X.position),kind:Ve.from(X.kind??w.InlayHintKind.Other),whitespaceBefore:X.whitespaceBefore,whitespaceAfter:X.whitespaceAfter}}de.from=Ce;function ce(X){const De=new w.InlayHint(X.text,o.to(X.position),Ve.to(X.kind));return De.whitespaceAfter=X.whitespaceAfter,De.whitespaceBefore=X.whitespaceBefore,De}de.to=ce})(Me=e.InlayHint||(e.InlayHint={}));var Ve;(function(de){function Ce(X){return X}de.from=Ce;function ce(X){return X}de.to=ce})(Ve=e.InlayHintKind||(e.InlayHintKind={}));var Ge;(function(de){function Ce(X){return{range:r.from(X.range),url:X.target,tooltip:X.tooltip}}de.from=Ce;function ce(X){let De;if(X.url)try{De=typeof X.url=="string"?D.URI.parse(X.url,!0):D.URI.revive(X.url)}catch(Re){}return new w.DocumentLink(r.to(X.range),De)}de.to=ce})(Ge=e.DocumentLink||(e.DocumentLink={}));var Je;(function(de){function Ce(X){const De=new w.ColorPresentation(X.label);return X.textEdit&&(De.textEdit=M.to(X.textEdit)),X.additionalTextEdits&&(De.additionalTextEdits=X.additionalTextEdits.map(Re=>M.to(Re))),De}de.to=Ce;function ce(X){return{label:X.label,textEdit:X.textEdit?M.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(De=>M.from(De)):void 0}}de.from=ce})(Je=e.ColorPresentation||(e.ColorPresentation={}));var tt;(function(de){function Ce(X){return new w.Color(X[0],X[1],X[2],X[3])}de.to=Ce;function ce(X){return[X.red,X.green,X.blue,X.alpha]}de.from=ce})(tt=e.Color||(e.Color={}));var ot;(function(de){function Ce(X){return{range:r.from(X.range)}}de.from=Ce;function ce(X){return new w.SelectionRange(r.to(X.range))}de.to=ce})(ot=e.SelectionRange||(e.SelectionRange={}));var et;(function(de){function Ce(ce){switch(ce){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}de.to=Ce})(et=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var it;(function(de){function Ce(X){switch(X){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}de.from=Ce;function ce(X){switch(X){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}de.to=ce})(it=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ct;(function(de){function Ce(X){if(X===w.EndOfLine.CRLF)return 1;if(X===w.EndOfLine.LF)return 0}de.from=Ce;function ce(X){if(X===1)return w.EndOfLine.CRLF;if(X===0)return w.EndOfLine.LF}de.to=ce})(ct=e.EndOfLine||(e.EndOfLine={}));var pt;(function(de){function Ce(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}de.from=Ce})(pt=e.ProgressLocation||(e.ProgressLocation={}));var Pt;(function(de){function Ce(ce){const X={start:ce.start+1,end:ce.end+1};return ce.kind&&(X.kind=Ue.from(ce.kind)),X}de.from=Ce})(Pt=e.FoldingRange||(e.FoldingRange={}));var Ue;(function(de){function Ce(ce){if(ce)switch(ce){case w.FoldingRangeKind.Comment:return P.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return P.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return P.FoldingRangeKind.Region}}de.from=Ce})(Ue=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Rt;(function(de){function Ce(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?r.from(ce.selection):void 0,override:typeof ce.override=="boolean"?u.EditorResolution.DISABLED:void 0}}de.from=Ce})(Rt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var J;(function(de){function Ce(X){return X instanceof w.RelativePattern||typeof X=="string"?X:ce(X)?new w.RelativePattern(X.base,X.pattern):X}de.from=Ce;function ce(X){const De=X;return De&&typeof De.base=="string"&&typeof De.pattern=="string"}})(J=e.GlobPattern||(e.GlobPattern={}));var ne;(function(de){function Ce(ce){if(ce){if(Array.isArray(ce))return ce.map(Ce);if(typeof ce=="string")return ce;{const X=ce;return{language:X.language,scheme:X.scheme,pattern:typeof X.pattern=="undefined"?void 0:J.from(X.pattern),exclusive:X.exclusive}}}else return}de.from=Ce})(ne=e.LanguageSelector||(e.LanguageSelector={}));var ge;(function(de){function Ce(X){return{start:X.start,end:X.end}}de.from=Ce;function ce(X){return new w.NotebookRange(X.start,X.end)}de.to=ce})(ge=e.NotebookRange||(e.NotebookRange={}));var te;(function(de){function Ce(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}de.to=Ce;function ce(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}de.from=ce})(te=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ee;(function(de){function Ce(X){switch(X){case w.NotebookCellKind.Markup:return p.CellKind.Markup;case w.NotebookCellKind.Code:default:return p.CellKind.Code}}de.from=Ce;function ce(X){switch(X){case p.CellKind.Markup:return w.NotebookCellKind.Markup;case p.CellKind.Code:default:return w.NotebookCellKind.Code}}de.to=ce})(Ee=e.NotebookCellKind||(e.NotebookCellKind={}));var Le;(function(de){function Ce(X){const De={metadata:X.metadata??Object.create(null),cells:[]};for(let Re of X.cells)w.NotebookCellData.validate(Re),De.cells.push(Oe.from(Re));return De}de.from=Ce;function ce(X){const De=new w.NotebookData(X.cells.map(Oe.to));return(0,S.isEmptyObject)(X.metadata)||(De.metadata=X.metadata),De}de.to=ce})(Le=e.NotebookData||(e.NotebookData={}));var Oe;(function(de){function Ce(X){return{cellKind:Ee.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:te.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(Te.from):[]}}de.from=Ce;function ce(X){return new w.NotebookCellData(Ee.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(Te.to):void 0,X.metadata,X.internalMetadata?te.to(X.internalMetadata):void 0)}de.to=ce})(Oe=e.NotebookCellData||(e.NotebookCellData={}));var Xe;(function(de){function Ce(X){return{mime:X.mime,valueBytes:F.VSBuffer.wrap(X.data)}}de.from=Ce;function ce(X){return new w.NotebookCellOutputItem(X.valueBytes.buffer,X.mime)}de.to=ce})(Xe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Te;(function(de){function Ce(X){return{outputId:X.id,items:X.items.map(Xe.from),metadata:X.metadata}}de.from=Ce;function ce(X){const De=X.items.map(Xe.to);return new w.NotebookCellOutput(De,X.outputId,X.metadata)}de.to=ce})(Te=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ke;(function(de){function Ce(Re){if(Re!=null){if(Re instanceof w.RelativePattern||typeof Re=="string")return Re;if(De(Re))return new w.RelativePattern(Re.base,Re.pattern);if(X(Re))return{include:J.from(Re.include)||void 0,exclude:J.from(Re.exclude)||void 0}}}de.from=Ce;function ce(Re){return typeof Re=="string"?Re:De(Re)?{base:Re.base,pattern:Re.pattern}:{include:Re.include,exclude:Re.exclude}}de.to=ce;function X(Re){const Ze=Re,qe=J.from(Ze.include);if(!(qe&&qe instanceof w.RelativePattern||typeof qe=="string"))return!1;const dt=J.from(Ze.exclude);return!!(dt&&dt instanceof w.RelativePattern||typeof dt=="string")}function De(Re){const Ze=Re;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(ke=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Se;(function(de){function Ce(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?U.from(ce.top):void 0}}de.from=Ce})(Se=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var le;(function(de){function Ce(ce,X,De){const Re=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Re,De),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}de.from=Ce})(le=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(de){function Ce(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}de.from=Ce})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var we;(function(de){function Ce(X){return{uri:X.uri,provides:X.provides}}de.from=Ce;function ce(X){return new w.NotebookRendererScript(D.URI.revive(X.uri),X.provides)}de.to=ce})(we=e.NotebookRendererScript||(e.NotebookRendererScript={}));var _e;(function(de){function Ce(X){return{message:b.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location?j.from(X.location):void 0}}de.from=Ce;function ce(X){const De=new w.TestMessage(typeof X.message=="string"?X.message:b.to(X.message));return De.actualOutput=X.actual,De.expectedOutput=X.expected,De.location=X.location?j.to(X.location):void 0,De}de.to=ce})(_e=e.TestMessage||(e.TestMessage={}));var Fe;(function(de){let Ce;(function(ce){ce.Delimiter="\0"})(Ce||(Ce={})),de.namespace=(ce,X)=>ce+"\0"+X,de.denamespace=ce=>{const X=ce.indexOf("\0");return{ctrlId:ce.slice(0,X),tagId:ce.slice(X+1)}}})(Fe=e.TestTag||(e.TestTag={}));var Ke;(function(de){function Ce(Re){const Ze=(0,h.getPrivateApiFor)(Re).controllerId;return{extId:v.TestId.fromExtHostTestItem(Re,Ze).toString(),label:Re.label,uri:Re.uri,tags:Re.tags.map(qe=>Fe.namespace(Ze,qe.id)),range:r.from(Re.range)||null,description:Re.description||null,error:Re.error&&b.fromStrict(Re.error)||null}}de.from=Ce;function ce(Re){return{parent:void 0,error:void 0,id:v.TestId.fromString(Re.extId).localId,label:Re.label,uri:D.URI.revive(Re.uri),tags:(Re.tags||[]).map(Ze=>{const{tagId:qe}=Fe.denamespace(Ze);return new w.TestTag(qe)}),range:r.to(Re.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Re.description||void 0}}de.toPlain=ce;function X(Re){const Ze=v.TestId.fromString(Re.extId),qe=new h.TestItemImpl(Ze.controllerId,Ze.localId,Re.label,D.URI.revive(Re.uri));return qe.range=r.to(Re.range||void 0),qe.description=Re.description||void 0,qe}function De(Re){let Ze;for(const qe of Re.tests){const dt=X(qe.item);(0,h.getPrivateApiFor)(dt).parent=Ze,Ze=dt}return Ze}de.toItemFromContext=De})(Ke=e.TestItem||(e.TestItem={})),function(de){function Ce(X){return{id:X.id}}de.from=Ce;function ce(X){return new w.TestTag(X.id)}de.to=ce}(Fe=e.TestTag||(e.TestTag={}));var $e;(function(de){const Ce=(X,De)=>{const Re={...Ke.toPlain(X.item),parent:void 0,taskStates:X.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(qe=>qe.type===0).map(_e.to)})),children:X.children.map(Ze=>De.get(Ze)).filter(S.isDefined).map(Ze=>Ce(Ze,De))};for(const Ze of Re.children)Ze.parent=Re;return Re};function ce(X){const De=[],Re=new Map;for(const Ze of X.items)Re.set(Ze.item.extId,Ze),X.request.targets.some(qe=>qe.controllerId===Ze.controllerId&&qe.testIds.includes(Ze.item.extId))&&De.push(Ze);return{completedAt:X.completedAt,results:De.map(Ze=>Ce(Ze,Re))}}de.to=ce})($e=e.TestResults||(e.TestResults={}));var Qe;(function(de){function Ce(Re){return{covered:Re.covered,total:Re.covered}}function ce(Re){return"line"in Re?o.from(Re):r.from(Re)}function X(Re){return"branches"in Re?{count:Re.executionCount,location:ce(Re.location),type:1,branches:Re.branches.length?Re.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ce(Ze.location)})):void 0}:{type:0,count:Re.executionCount,location:ce(Re.location)}}de.fromDetailed=X;function De(Re){return{uri:Re.uri,statement:Ce(Re.statementCoverage),branch:Re.branchCoverage&&Ce(Re.branchCoverage),function:Re.functionCoverage&&Ce(Re.functionCoverage),details:Re.detailedCoverage?.map(X)}}de.fromFile=De})(Qe=e.TestCoverage||(e.TestCoverage={}));var st;(function(de){function Ce(ce){switch(ce){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}de.to=Ce})(st=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var at;(function(de){function Ce(X){const De=new w.TypeHierarchyItem(O.to(X.kind),X.name,X.detail||"",D.URI.revive(X.uri),r.to(X.range),r.to(X.selectionRange));return De._sessionId=X._sessionId,De._itemId=X._itemId,De}de.to=Ce;function ce(X,De,Re){if(De=De??X._sessionId,Re=Re??X._itemId,De===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Re,kind:O.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:r.from(X.range),selectionRange:r.from(X.selectionRange),tags:X.tags?.map(W.from)}}de.from=ce})(at=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(pe[216],ve([0,1,2,15,7,17,93]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(D,R,P,u={timeout:1500,errors:3}){this._logService=D,this._documents=R,this._mainThreadBulkEdits=P,this._thresholds=u,this._callbacks=new i.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(D){return(R,P,u)=>{const h={dispose:this._callbacks.push([R,P,D])};return Array.isArray(u)&&u.push(h),h}}async $participateInSave(D,R){const P=m.URI.revive(D);let u=!1;const E=setTimeout(()=>u=!0,this._thresholds.timeout),h=[];try{for(let p of[...this._callbacks]){if(u)break;const v=this._documents.getDocument(P),I=await this._deliverEventAsyncAndBlameBadListeners(p,{document:v,reason:C.TextDocumentSaveReason.to(R)});h.push(I)}}finally{clearTimeout(E)}return h}_deliverEventAsyncAndBlameBadListeners([D,R,P],u){const E=this._badListeners.get(D);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,D,R,u).then(()=>!0,h=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const p=this._badListeners.get(D);this._badListeners.set(D,p?p+1:1),typeof p=="number"&&p>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(D,R,P,u){const E=[],h=Date.now(),{document:p,reason:v}=u,{version:I}=p,w=Object.freeze({document:p,reason:v,waitUntil(a){if(Object.isFrozen(E))throw(0,F.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(a))}});try{R.apply(P,[w])}catch(a){return Promise.reject(a)}return Object.freeze(E),new Promise((a,r)=>{const g=setTimeout(()=>r(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(o=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(g),a(o)}).catch(o=>{clearTimeout(g),r(o)})}).then(a=>{const r={edits:[]};for(const g of a)if(Array.isArray(g)&&g.every(o=>o instanceof y.TextEdit))for(const{newText:o,newEol:_,range:n}of g)r.edits.push({_type:2,resource:p.uri,edit:{range:n&&C.Range.from(n),text:o,eol:_&&C.EndOfLine.from(_)}});if(r.edits.length!==0)return I===p.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(pe[217],ve([0,1,3,31,2,17,7]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(R,P,u,E,h){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,u&&(this._config+=1),E&&(this._config+=2),h&&(this._config+=4);const p=(0,F.parse)(P),v=R(I=>{if(!u)for(let w of I.created){const a=y.URI.revive(w);p(a.fsPath)&&this._onDidCreate.fire(a)}if(!E)for(let w of I.changed){const a=y.URI.revive(w);p(a.fsPath)&&this._onDidChange.fire(a)}if(!h)for(let w of I.deleted){const a=y.URI.revive(w);p(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=i.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(R,P,u){this._logService=P,this._extHostDocumentsAndEditors=u,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(R,P,u,E){return new k(this._onFileSystemEvent.event,R,P,u,E)}$onFileEvent(R){this._onFileSystemEvent.fire(R)}$onDidRunFileOperation(R,P){switch(R){case 2:this._onDidRenameFile.fire(Object.freeze({files:P.map(u=>({oldUri:y.URI.revive(u.source),newUri:y.URI.revive(u.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:P.map(u=>y.URI.revive(u.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:P.map(u=>y.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(R){return this._createWillExecuteEvent(R,this._onWillRenameFile)}getOnWillCreateFileEvent(R){return this._createWillExecuteEvent(R,this._onWillCreateFile)}getOnWillDeleteFileEvent(R){return this._createWillExecuteEvent(R,this._onWillDeleteFile)}_createWillExecuteEvent(R,P){return(u,E,h)=>{const p=function(I){u.call(E,I)};return p.extension=R,P.event(p,void 0,h)}}async $onWillRunFileOperation(R,P,u,E){switch(R){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:P.map(h=>({oldUri:y.URI.revive(h.source),newUri:y.URI.revive(h.target)}))},u,E);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:P.map(h=>y.URI.revive(h.target))},u,E);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:P.map(h=>y.URI.revive(h.target))},u,E)}}async _fireWillEvent(R,P,u,E){const h=new Set,p=[];if(await R.fireAsync(P,E,async(I,w)=>{const a=Date.now(),r=await Promise.resolve(I);r instanceof i.WorkspaceEdit&&(p.push(r),h.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-a>u&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),E.isCancellationRequested||p.length===0)return;const v={edits:[]};for(let I of p){let{edits:w}=C.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(w)}return{edit:v,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=S}),define(pe[218],ve([0,1,10,25,2,17,7,125]),function(Y,e,m,F,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(u,E,h,p){this.start=u,this.deletedCount=E,this.deletedItems=h,this.items=p}static asApiEvents(u){return u.map(E=>({start:E.start,deletedCount:E.deletedCount,deletedItems:E.deletedItems,items:E.items.map(h=>h.apiCell)}))}}class D{constructor(u,E,h){this.notebook=u,this._extHostDocument=E,this._cellData=h,this.handle=h.handle,this.uri=y.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=h.internalMetadata??{},this._metadata=Object.freeze(h.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(h.internalMetadata??{}))}static asModelAddData(u,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:u}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const u=this,E=this._extHostDocument.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return u.notebook.getCellIndex(u)},notebook:u.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:E.document,get mime(){return u._mime},set mime(h){u._mime=h},get outputs(){return u._outputs.slice(0)},get metadata(){return u._metadata},get executionSummary(){return u._previousResult}})}return this._apiCell}setOutputs(u){this._outputs=u.map(C.NotebookCellOutput.to)}setOutputItems(u,E,h){const p=h.map(C.NotebookCellOutputItem.to),v=this._outputs.find(I=>I.id===u);v&&(E||(v.items.length=0),v.items.push(...p))}setMetadata(u){this._metadata=Object.freeze(u)}setInternalMetadata(u){this._internalMetadata=u,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(u))}setMime(u){}}e.ExtHostCell=D;class R{constructor(u,E,h,p,v,I){this._proxy=u,this._textDocumentsAndEditors=E,this._textDocuments=h,this._emitter=p,this.uri=v,this.handle=R._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=I.viewType,this._metadata=Object.freeze(I.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,I.cells]],!0),this._versionId=I.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const u=this;this._notebook={get uri(){return u.uri},get version(){return u._versionId},get notebookType(){return u._notebookType},get isDirty(){return u._isDirty},get isUntitled(){return u.uri.scheme===m.Schemas.untitled},get isClosed(){return u._disposed},get metadata(){return u._metadata},get cellCount(){return u._cells.length},cellAt(E){return E=u._validateIndex(E),u._cells[E].apiCell},getCells(E){return(E?u._getCells(E):u._cells).map(p=>p.apiCell)},save(){return u._save()}}}return this._notebook}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(u){u.metadata&&(this._metadata=Object.freeze({...this._metadata,...u.metadata}))}acceptDirty(u){this._isDirty=u}acceptModelChanged(u,E){this._versionId=u.versionId,this._isDirty=E;for(const h of u.rawEvents)h.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===k.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(h.index,h.metadata):h.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(h.index,h.internalMetadata)}_validateIndex(u){return u=u|0,u<0?0:u>=this._cells.length?this._cells.length-1:u}_validateRange(u){let E=u.start|0,h=u.end|0;return E<0&&(E=0),h>this._cells.length&&(h=this._cells.length),u.with({start:E,end:h})}_getCells(u){u=this._validateRange(u);const E=[];for(let h=u.start;h<u.end;h++)E.push(this._cells[h]);return E}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(u,E){if(this._disposed)return;const h=[],p=[],v=[];u.reverse().forEach(I=>{const a=I[2].map(o=>{const _=new D(this,this._textDocumentsAndEditors,o);return E||p.push(D.asModelAddData(this.apiNotebook,o)),_}),r=new S(I[0],I[1],[],a),g=this._cells.splice(I[0],I[1],...a);for(const o of g)v.push(o.uri),r.deletedItems.push(o.apiCell);h.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:v}),E||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(h)}))}_moveCell(u,E){const h=this._cells.splice(u,1);this._cells.splice(E,0,...h);const p=[new S(u,1,h.map(v=>v.apiCell),[]),new S(E,0,[],h)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(p)}))}_setCellOutputs(u,E){const h=this._cells[u];h.setOutputs(E),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_setCellOutputItems(u,E,h,p){const v=this._cells[u];v.setOutputItems(E,h,p),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(u,E){const h=this._cells[u];h.apiCell.document.languageId!==E&&this._textDocuments.$acceptModelModeChanged(h.uri,E)}_changeCellMime(u,E){const h=this._cells[u];h.apiCell.mime=E}_changeCellMetadata(u,E){const h=this._cells[u],p=h.apiCell.metadata;h.setMetadata(E);const v=h.apiCell.metadata;(0,F.equals)(p,v)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:h.apiCell}))}_changeCellInternalMetadata(u,E){const h=this._cells[u],p=h.internalMetadata;if(h.setInternalMetadata(E),p.runState!==E.runState){const v=E.runState??i.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:h.apiCell,state:v}))}}getCellFromApiCell(u){return this._cells.find(E=>E.apiCell===u)}getCellFromIndex(u){return this._cells[u]}getCell(u){return this._cells.find(E=>E.handle===u)}getCellIndex(u){return this._cells.indexOf(u)}}e.ExtHostNotebookDocument=R,R._handlePool=0}),define(pe[128],ve([0,1,7,17,15]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,D){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:D})}replaceCells(S,D,R){this._throwIfFinalized(),!(S===D&&R.length===0)&&this._collectedEdits.push({editType:1,index:S,count:D-S,cells:R.map(F.NotebookCellData.from)})}}class i{constructor(S,D,R,P,u,E){this.id=S,this._proxy=D,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._visibleRanges=P,this._viewColumn=E}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(D){if(!Array.isArray(D)||!D.every(m.NotebookRange.isNotebookRange))throw(0,y.illegalArgument)("selections");S._selections=D,S._trySetSelections(D)},get visibleRanges(){return S._visibleRanges},revealRange(D,R){S._proxy.$tryRevealRange(S.id,F.NotebookRange.from(D),R??m.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(D){const R=new C(this.document.version);return D(R),S._applyEdit(R.finalize())},setDecorations(D,R){return S.setDecorations(D,R)}},i.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(F.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const D=[];let R=-1;for(let P=0;P<S.cellEdits.length;P++){if(R<0){D.push(S.cellEdits[P]),R++;continue}const E=D[R],h=S.cellEdits[P];if(E.editType===1&&h.editType===1&&E.index===h.index){E.cells.push(...S.cellEdits[P].cells),E.count+=S.cellEdits[P].count;continue}D.push(S.cellEdits[P]),R++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,D)}setDecorations(S,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return D.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(D),S.key)}}e.ExtHostNotebookEditor=i,i.apiEditorsToExtHost=new WeakMap}),define(pe[219],ve([0,1,17,117,164,21,57,15]),function(Y,e,m,F,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(u){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=u}async withProgress(u,E,h){const p=this._handles++,{title:v,location:I,cancellable:w}=E,a={label:(0,y.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this._proxy.$startProgress(p,{location:m.ProgressLocation.from(I),title:v,source:a,cancellable:w},u).catch(k.onUnexpectedExternalError),this._withProgress(p,h,!!w)}_withProgress(u,E,h){let p;h&&(p=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(u,p));const v=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),p&&p.dispose()};let I;try{I=E(new R(this._proxy,u),h&&p?p.token:C.CancellationToken.None)}catch(w){throw v(u),w}return I.then(w=>v(u),w=>v(u)),I}$acceptProgressCanceled(u){const E=this._mapHandleToCancellationSource.get(u);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(u))}}e.ExtHostProgress=S;function D(P,u){return P.message=u.message,typeof u.increment=="number"&&(typeof P.increment=="number"?P.increment+=u.increment:P.increment=u.increment),P}class R extends F.Progress{constructor(u,E){super(h=>this.throttledReport(h));this._proxy=u,this._handle=E}throttledReport(u){this._proxy.$progressReport(this._handle,u)}}je([(0,i.throttle)(100,(P,u)=>D(P,u),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(pe[129],ve([0,1,56,15,75,17,7]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(u,E,h){const p=k._Keys.nextId();u.$registerTextEditorDecorationType(E.identifier,p,C.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:p,dispose(){u.$removeTextEditorDecorationType(p)}})}}e.TextEditorDecorationType=k,k._Keys=new y.IdGenerator("TextEditorDecorationType");class S{constructor(u,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,E){this._throwIfFinalized();let h=null;if(u instanceof i.Position)h=new i.Range(u,u);else if(u instanceof i.Range)h=u;else throw new Error("Unrecognized location");this._pushEdit(h,E,!1)}insert(u,E){this._throwIfFinalized(),this._pushEdit(new i.Range(u,u),E,!0)}delete(u){this._throwIfFinalized();let E=null;if(u instanceof i.Range)E=u;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(u,E,h){const p=this._document.validateRange(u);this._collectedEdits.push({range:p,text:E,forceMoveMarkers:h})}setEndOfLine(u){if(this._throwIfFinalized(),u!==i.EndOfLine.LF&&u!==i.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=u}}e.TextEditorEdit=S;class D{constructor(u,E,h,p){this._proxy=u,this._id=E,this._accept(h),this._logService=p;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(I){v._setTabSize(I)},get insertSpaces(){return v._insertSpaces},set insertSpaces(I){v._setInsertSpaces(I)},get cursorStyle(){return v._cursorStyle},set cursorStyle(I){v._setCursorStyle(I)},get lineNumbers(){return v._lineNumbers},set lineNumbers(I){v._setLineNumbers(I)}}}_accept(u){this._tabSize=u.tabSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(u){const E=this._validateTabSize(u);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:Boolean(u)}_setInsertSpaces(u){const E=this._validateInsertSpaces(u);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(u)})))}assign(u){const E={};let h=!1;if(typeof u.tabSize!="undefined"){const p=this._validateTabSize(u.tabSize);p==="auto"?(h=!0,E.tabSize=p):typeof p=="number"&&this._tabSize!==p&&(this._tabSize=p,h=!0,E.tabSize=p)}if(typeof u.insertSpaces!="undefined"){const p=this._validateInsertSpaces(u.insertSpaces);p==="auto"?(h=!0,E.insertSpaces=p):this._insertSpaces!==p&&(this._insertSpaces=p,h=!0,E.insertSpaces=p)}typeof u.cursorStyle!="undefined"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,h=!0,E.cursorStyle=u.cursorStyle),typeof u.lineNumbers!="undefined"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,h=!0,E.lineNumbers=C.TextEditorLineNumbersStyle.from(u.lineNumbers)),h&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(u,E){E.catch(h=>{this._logService.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this._logService.warn(h)})}}e.ExtHostTextEditorOptions=D;class R{constructor(u,E,h,p,v,I,w,a){this.id=u,this._proxy=E,this._logService=h,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new D(this._proxy,this.id,I,h),this._visibleRanges=w,this._viewColumn=a;const r=this;this.value=Object.freeze({get document(){return p.getValue()},set document(g){throw(0,F.readonly)("document")},get selection(){return r._selections&&r._selections[0]},set selection(g){if(!(g instanceof i.Selection))throw(0,F.illegalArgument)("selection");r._selections=[g],r._trySetSelection()},get selections(){return r._selections},set selections(g){if(!Array.isArray(g)||g.some(o=>!(o instanceof i.Selection)))throw(0,F.illegalArgument)("selections");r._selections=g,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(g){throw(0,F.readonly)("visibleRanges")},get options(){return r._options.value},set options(g){r._disposed||r._options.assign(g)},get viewColumn(){return r._viewColumn},set viewColumn(g){throw(0,F.readonly)("viewColumn")},edit(g,o={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const _=new S(p.getValue(),o);return g(_),r._applyEdit(_)},insertSnippet(g,o,_={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!o||Array.isArray(o)&&o.length===0)n=r._selections.map(t=>C.Range.from(t));else if(o instanceof i.Position){const{lineNumber:t,column:s}=C.Position.from(o);n=[{startLineNumber:t,startColumn:s,endLineNumber:t,endColumn:s}]}else if(o instanceof i.Range)n=[C.Range.from(o)];else{n=[];for(const t of o)if(t instanceof i.Range)n.push(C.Range.from(t));else{const{lineNumber:s,column:d}=C.Position.from(t);n.push({startLineNumber:s,startColumn:d,endLineNumber:s,endColumn:d})}}return E.$tryInsertSnippet(u,g.value,n,_)},setDecorations(g,o){const _=o.length===0;_&&!r._hasDecorationsForKey.has(g.key)||(_?r._hasDecorationsForKey.delete(g.key):r._hasDecorationsForKey.add(g.key),r._runOnProxy(()=>{if(C.isDecorationOptionsArr(o))return E.$trySetDecorations(u,g.key,C.fromRangeOrRangeWithMessage(o));{const n=new Array(4*o.length);for(let t=0,s=o.length;t<s;t++){const d=o[t];n[4*t]=d.start.line+1,n[4*t+1]=d.start.character+1,n[4*t+2]=d.end.line+1,n[4*t+3]=d.end.character+1}return E.$trySetDecorationsFast(u,g.key,n)}}))},revealRange(g,o){r._runOnProxy(()=>E.$tryRevealRange(u,C.Range.from(g),o||i.TextEditorRevealType.Default))},show(g){E.$tryShowEditor(u,C.ViewColumn.from(g))},hide(){E.$tryHideEditor(u)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,m.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,m.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,m.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,m.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const E=u.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const h=E.edits.map(v=>v.range);h.sort((v,I)=>v.end.line===I.end.line?v.end.character===I.end.character?v.start.line===I.start.line?v.start.character-I.start.character:v.start.line-I.start.line:v.end.character-I.end.character:v.end.line-I.end.line);for(let v=0,I=h.length-1;v<I;v++){const w=h[v].end;if(h[v+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=E.edits.map(v=>({range:C.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,p,{setEndOfLine:typeof E.setEndOfLine=="number"?C.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=R}),define(pe[220],ve([0,1,167,23,2,3,6,18,7,13,16,17,21,204]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(I,w){if((0,D.isString)(I))return{label:I};if(I&&typeof I=="object"&&typeof I.label=="string"){let a;return Array.isArray(I.highlights)&&(a=I.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),a=a.length?a:void 0),{label:I.label,highlights:a}}}class p{constructor(w,a,r){this._proxy=w,this.commands=a,this.logService=r,this.treeViews=new Map;function g(o){return o&&o.$treeViewId&&o.$treeItemHandle}a.registerArgumentProcessor({processArgument:o=>g(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(_=>g(_)?this.convertArgument(_):_):o})}registerTreeDataProvider(w,a,r){const g=this.createTreeView(w,{treeDataProvider:a},r);return{dispose:()=>g.dispose()}}createTreeView(w,a,r){if(!a||!a.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=a.dragAndDropController?.supportedMimeTypes,o=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!a.showCollapseAll,canSelectMany:!!a.canSelectMany,dragAndDropMimeTypes:g}),_=this.createExtHostTreeView(w,a,r);return{get onDidCollapseElement(){return _.onDidCollapseElement},get onDidExpandElement(){return _.onDidExpandElement},get selection(){return _.selectedElements},get onDidChangeSelection(){return _.onDidChangeSelection},get visible(){return _.visible},get onDidChangeVisibility(){return _.onDidChangeVisibility},get message(){return _.message},set message(n){_.message=n},get title(){return _.title},set title(n){_.title=n},get description(){return _.description},set description(n){_.description=n},reveal:(n,t)=>_.reveal(n,t),dispose:async()=>{await o,this.treeViews.delete(w),_.dispose()}}}$getChildren(w,a){const r=this.treeViews.get(w);return r?r.getChildren(a):Promise.reject(new Error((0,m.localize)(0,null,w)))}async $onDrop(w,a,r,g,o){const _=this.treeViews.get(w);if(!_)return Promise.reject(new Error((0,m.localize)(1,null,w)));const n=E.TreeDataTransferConverter.toITreeDataTransfer(a);if(g===w&&o){const t=await _.onWillDrop(o);t&&t.forEach((s,d)=>{s&&n.set(d,s)})}return _.onDrop(n,r)}async $hasResolve(w){const a=this.treeViews.get(w);if(!a)throw new Error((0,m.localize)(2,null,w));return a.hasResolve}$resolve(w,a,r){const g=this.treeViews.get(w);if(!g)throw new Error((0,m.localize)(3,null,w));return g.resolveTreeItem(a,r)}$setExpanded(w,a,r){const g=this.treeViews.get(w);if(!g)throw new Error((0,m.localize)(4,null,w));g.setExpanded(a,r)}$setSelection(w,a){const r=this.treeViews.get(w);if(!r)throw new Error((0,m.localize)(5,null,w));r.setSelection(a)}$setVisible(w,a){const r=this.treeViews.get(w);if(!r)throw new Error((0,m.localize)(6,null,w));r.setVisible(a)}createExtHostTreeView(w,a,r){const g=new v(w,a,this._proxy,this.commands.converter,this.logService,r);return this.treeViews.set(w,g),g}convertArgument(w){const a=this.treeViews.get(w.$treeViewId);return a?a.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=p;class v extends i.Disposable{constructor(w,a,r,g,o,_){super();if(this.viewId=w,this.proxy=r,this.commands=g,this.logService=o,this.extension=_,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new u.CancellationTokenSource,_.contributes&&_.contributes.views)for(const s in _.contributes.views)for(const d of _.contributes.views[s])d.id===w&&(this._title=d.name);this.dataProvider=a.treeDataProvider,this.dndController=a.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(s=>this._onDidChangeData.fire({message:!1,element:s}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let n,t;this._register(C.Event.debounce(this._onDidChangeData.event,(s,d)=>(s||(s={message:!1,elements:[]}),d.element!==!1&&(n||(n=new Promise(c=>t=c),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(d.element)?s.elements.push(...d.element):s.elements.push(d.element)),d.message&&(s.message=!0),s),200,!0)(({message:s,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const c=t;return n=null,this.refresh(d).then(()=>c())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,D.isUndefinedOrNull)(w))}async getChildren(w){const a=w?this.getExtensionElement(w):void 0;if(w&&!a)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(w);return r||(r=await this.fetchChildrenNodes(a)),r?r.map(g=>g.item):void 0}getExtensionElement(w){return this.elements.get(w)}reveal(w,a){a=a||{select:!0,focus:!1};const r=(0,D.isUndefinedOrNull)(a.select)?!0:a.select,g=(0,D.isUndefinedOrNull)(a.focus)?!1:a.focus,o=(0,D.isUndefinedOrNull)(a.expand)?!1:a.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(_=>this.resolveTreeNode(w,_[_.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:_.map(t=>t.item)},{select:r,focus:g,expand:o})),_=>this.logService.error(_)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:g,expand:o})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,a){const r=this.getExtensionElement(w);r&&(a?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelection(w){(0,R.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(w){const a=[];for(const r of w){const g=this.getExtensionElement(r);g&&a.push(g)}if(!(!this.dndController?.onWillDrop||a.length===0))return this.dndController.onWillDrop(a)}async onDrop(w,a){const r=this.getExtensionElement(a);if(!!r)return(0,k.asPromise)(()=>this.dndController?.onDrop(w,r))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,a){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(w);if(r){const g=this.nodes.get(r);if(g){const o=await this.dataProvider.resolveTreeItem(g.extensionItem,r,a)??g.extensionItem;return g.item.tooltip=this.getTooltip(o.tooltip),g.item.command=this.getCommand(g.disposableStore,o.command),g.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(a=>a?this.resolveUnknownParentChain(a).then(r=>this.resolveTreeNode(a,r[r.length-1]).then(g=>(r.push(g),r))):Promise.resolve([]))}resolveParent(w){const a=this.nodes.get(w);return a?Promise.resolve(a.parent?this.elements.get(a.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,a){const r=this.nodes.get(w);return r?Promise.resolve(r):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(g=>this.createHandle(w,g,a,!0)).then(g=>this.getChildren(a?a.item.handle:void 0).then(()=>{const o=this.getExtensionElement(g);if(o){const _=this.nodes.get(o);if(_)return Promise.resolve(_)}throw new Error(`Cannot resolve tree item for element ${g}`)}))}getChildrenNodes(w){if(w){let a;if(typeof w=="string"){const r=this.getExtensionElement(w);a=r?this.nodes.get(r):void 0}else a=w;return a&&a.children||void 0}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const a=new u.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=w?this.nodes.get(w):void 0,g=await this.dataProvider.getChildren(w);if(a.token.isCancellationRequested)return;const o=await Promise.all((0,R.coalesce)(g||[]).map(async _=>{const n=await this.dataProvider.getTreeItem(_);return n&&!a.token.isCancellationRequested?this.createAndRegisterTreeNode(_,n,r):null}));return a.token.isCancellationRequested?void 0:(0,R.coalesce)(o)}finally{a.dispose()}}refresh(w){if(w.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new u.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(w);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const a=new Set,r=w.map(o=>this.nodes.get(o));for(const o of r)if(o&&!a.has(o.item.handle)){let _=o;for(;_&&_.parent&&r.findIndex(n=>_&&_.parent&&n&&n.item.handle===_.parent.item.handle)===-1;){const n=this.elements.get(_.parent.item.handle);_=n?this.nodes.get(n):void 0}_&&!_.parent&&a.add(o.item.handle)}const g=[];return a.forEach(o=>{const _=this.elements.get(o);if(_){const n=this.nodes.get(_);n&&(!n.parent||!a.has(n.parent.item.handle))&&g.push(o)}}),g}refreshHandles(w){const a={};return Promise.all(w.map(r=>this.refreshNode(r).then(g=>{g&&(a[r]=g.item)}))).then(()=>Object.keys(a).length?this.proxy.$refresh(this.viewId,a):void 0)}refreshNode(w){const a=this.getExtensionElement(w);if(a){const r=this.nodes.get(a);if(r)return this.clearChildren(a),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(g=>{if(g){const o=this.createTreeNode(a,g,r.parent);return this.updateNodeCache(a,o,r,r.parent),r.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,a,r){const g=this.createTreeNode(w,a,r);if(a.id&&this.elements.has(g.item.handle))throw new Error((0,m.localize)(7,null,a.id));return this.addNodeToCache(w,g),this.addNodeToParentCache(g,r),g}getTooltip(w){return S.MarkdownString.isMarkdownString(w)?P.MarkdownString.from(w):w}getCommand(w,a){return a?this.commands.toInternal(a,w):void 0}createTreeNode(w,a,r){const g=new i.DisposableStore,o=this.createHandle(w,a,r),_=this.getLightIconPath(a);return{item:{handle:o,parentHandle:r?r.item.handle:void 0,label:h(a.label,this.extension),description:a.description,resourceUri:a.resourceUri,tooltip:this.getTooltip(a.tooltip),command:this.getCommand(g,a.command),contextValue:a.contextValue,icon:_,iconDark:this.getDarkIconPath(a)||_,themeIcon:this.getThemeIcon(a),collapsibleState:(0,D.isUndefinedOrNull)(a.collapsibleState)?S.TreeItemCollapsibleState.None:a.collapsibleState,accessibilityInformation:a.accessibilityInformation},extensionItem:a,parent:r,children:void 0,disposableStore:g,dispose(){g.dispose()}}}getThemeIcon(w){return w.iconPath instanceof S.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:a,label:r,resourceUri:g},o,_){if(a)return`${v.ID_HANDLE_PREFIX}/${a}`;const n=h(r,this.extension),t=o?o.item.handle:v.LABEL_HANDLE_PREFIX;let s=n?n.label:g?(0,F.basename)(g):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const d=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,c=this.getChildrenNodes(o)||[];let f,l=0;do{if(f=`${t}/${l}:${s}`,_||!this.elements.has(f)||d===f)break;l++}while(l<=c.length);return f}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof S.ThemeIcon))return typeof w.iconPath=="string"||y.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof S.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return y.URI.isUri(w)?w:y.URI.file(w)}addNodeToCache(w,a){this.elements.set(a.item.handle,w),this.nodes.set(w,a)}updateNodeCache(w,a,r,g){this.elements.delete(a.item.handle),this.nodes.delete(w),a.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(w,a);const o=this.getChildrenNodes(g)||[],_=o.filter(n=>n.item.handle===r.item.handle)[0];_&&o.splice(o.indexOf(_),1,a)}addNodeToParentCache(w,a){a?(a.children||(a.children=[]),a.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const a=this.nodes.get(w);if(a){if(a.children)for(const r of a.children){const g=this.elements.get(r.item.handle);g&&this.clear(g)}a.children=void 0}}else this.clearAll()}clear(w){const a=this.nodes.get(w);if(a){if(a.children)for(const r of a.children){const g=this.elements.get(r.item.handle);g&&this.clear(g)}this.nodes.delete(w),this.elements.delete(a.item.handle),a.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(pe[221],ve([0,1,18,3,6,13,63,17,126,89]),function(Y,e,m,F,y,C,i,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends y.Disposable{constructor(u){super();this.controllerId=u,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new i.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(u){this._resolveHandler=u;for(const E of this.tree.values())this.updateExpandability(E)}collectDiff(){const u=this.diff;return this.diff=[],u}pushDiff(u){const E=this.diff[this.diff.length-1];if(E&&u[0]===1){if(E[0]===1&&E[1].extId===u[1].extId){(0,S.applyTestItemUpdate)(E[1],u[1]);return}if(E[0]===0&&E[1].item.extId===u[1].extId){(0,S.applyTestItemUpdate)(E[1],u[1]);return}}this.diff.push(u),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(u,E){const h=this.tree.get(u);if(!!h){if((h.expandLevels===void 0||E>h.expandLevels)&&(h.expandLevels=E),h.expand===1){const p=this.resolveChildren(h);return p.isOpen()?this.expandChildren(h,E-1):p.wait().then(()=>this.expandChildren(h,E-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.expandChildren(h,E-1)):this.expandChildren(h,E-1)}}dispose(){for(const u of this.tree.values())(0,i.getPrivateApiFor)(u.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(u,E){switch(E.op){case 2:this.pushDiff([4,u.fullId.toString()]);break;case 1:this.removeItem(D.TestId.joinToString(u.fullId,E.id));break;case 0:this.upsertItem(E.item,u);break;case 4:for(const w of E.ops)this.onTestItemEvent(u,w);break;case 3:const{key:h,value:p,previous:v}=E,I=u.fullId.toString();switch(h){case"canResolveChildren":this.updateExpandability(u);break;case"tags":this.diffTagRefs(p,v,I);break;case"range":this.pushDiff([1,{extId:I,item:{range:k.Range.from(p)}}]);break;case"error":this.pushDiff([1,{extId:I,item:{error:k.MarkdownString.fromStrict(p)||null}}]);break;default:this.pushDiff([1,{extId:I,item:{[h]:p??null}}]);break}break;default:(0,C.assertNever)(E)}}upsertItem(u,E){if(!(u instanceof i.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${u.id} did not`);const h=D.TestId.fromExtHostTestItem(u,this.root.id,E?.actual),p=(0,i.getPrivateApiFor)(u);p.parent&&p.parent!==E?.actual&&p.parent.children.delete(u.id);let v=this.tree.get(h.toString());if(!v){v={fullId:h,actual:u,parent:E?h.parentId:null,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},u.tags.forEach(this.incrementTagRefs,this),this.tree.set(v.fullId.toString(),v),this.setItemParent(u,E),this.pushDiff([0,{parent:v.parent&&v.parent.toString(),controllerId:this.controllerId,expand:v.expand,item:k.TestItem.from(u)}]),this.connectItemAndChildren(u,v,E);return}if(v.actual===u){this.connectItem(u,v,E);return}const I=v.actual.children,w=v.actual,a=(0,i.diffTestItems)(w,u);(0,i.getPrivateApiFor)(w).listener=void 0,v.actual=u,v.expand=0;for(const[r,g]of a)this.onTestItemEvent(v,{op:3,key:r,value:g,previous:w[r]});this.connectItemAndChildren(u,v,E);for(const r of I)u.children.get(r.id)||this.removeItem(D.TestId.joinToString(h,r.id))}diffTagRefs(u,E,h){const p=new Set(E.map(v=>v.id));for(const v of u)p.delete(v.id)||this.incrementTagRefs(v);this.pushDiff([1,{extId:h,item:{tags:u.map(v=>k.TestTag.namespace(this.controllerId,v.id))}}]),p.forEach(this.decrementTagRefs,this)}incrementTagRefs(u){const E=this.tags.get(u.id);E?E.refCount++:(this.tags.set(u.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,u.id),ctrlLabel:this.root.label}]))}decrementTagRefs(u){const E=this.tags.get(u);E&&!--E.refCount&&(this.tags.delete(u),this.pushDiff([6,k.TestTag.namespace(this.controllerId,u)]))}setItemParent(u,E){(0,i.getPrivateApiFor)(u).parent=E&&E.actual!==this.root?E.actual:void 0}connectItem(u,E,h){this.setItemParent(u,h);const p=(0,i.getPrivateApiFor)(u);p.parent=h?.actual,p.listener=v=>this.onTestItemEvent(E,v),this.updateExpandability(E)}connectItemAndChildren(u,E,h){this.connectItem(u,E,h);for(const p of u.children)this.upsertItem(p,E)}updateExpandability(u){let E;this._resolveHandler?u.resolveBarrier?E=u.resolveBarrier.isOpen()?3:2:E=u.actual.canResolveChildren?1:0:E=0,E!==u.expand&&(u.expand=E,this.pushDiff([1,{extId:u.fullId.toString(),expand:E}]),E===1&&u.expandLevels!==void 0&&this.resolveChildren(u))}expandChildren(u,E){if(E<0)return;const h=[];for(const p of u.actual.children){const v=this.expand(D.TestId.joinToString(u.fullId,p.id),E);(0,m.isThenable)(v)&&h.push(v)}if(h.length)return Promise.all(h).then(()=>{})}resolveChildren(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this._resolveHandler){const v=new m.Barrier;return v.open(),v}u.expand=2,this.pushExpandStateUpdate(u);const E=u.resolveBarrier=new m.Barrier,h=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),u.actual!==this.root&&(u.actual.error=v.stack||v.message||String(v))};let p;try{p=this._resolveHandler(u.actual===this.root?void 0:u.actual)}catch(v){h(v)}return(0,m.isThenable)(p)?p.catch(h).then(()=>{E.open(),this.updateExpandability(u)}):(E.open(),this.updateExpandability(u)),u.resolveBarrier}pushExpandStateUpdate(u){this.pushDiff([1,{extId:u.fullId.toString(),expand:u.expand}])}removeItem(u){const E=this.tree.get(u);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff([2,u]);const h=[E];for(;h.length;){const p=h.pop();if(!!p){(0,i.getPrivateApiFor)(p.actual).listener=void 0;for(const v of p.actual.tags)this.decrementTagRefs(v.id);this.tree.delete(p.fullId.toString());for(const v of p.actual.children)h.push(this.tree.get(D.TestId.joinToString(p.fullId,v.id)))}}}flushDiff(){const u=this.collectDiff();u.length&&this.diffOpEmitter.fire(u)}}e.SingleUseTestCollection=R}),define(pe[222],ve([0,1,4,182]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(F.IEnvironmentService)}),define(pe[223],ve([0,1,27,3,9]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=C;class i{constructor(R){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let P of R.activationEvents)P==="onUri"&&(P=`onUri:${m.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(R)}}keepOnly(R){const P=new Set;R.forEach(u=>P.add(m.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>P.has(m.ExtensionIdentifier.toKey(u.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,P){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const u=i._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(u.map(E=>E.identifier)),P.length>0){const E=new Set;P.forEach(h=>E.add(m.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>!E.has(m.ExtensionIdentifier.toKey(h.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(u)}static _findLoopingExtensions(R){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,I){this.addNode(v),this.addNode(I),this._arcs.has(v)?this._arcs.get(v).push(I):this._arcs.set(v,[I])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,I){const w=P.getArcs(v);for(let a=0;a<w.length;a++)if(!I.has(w[a]))return!1;return!0}getNodes(){return this._nodesArr}};let u=new Map;for(let v of R){const I=m.ExtensionIdentifier.toKey(v.identifier);if(u.set(I,v),v.extensionDependencies)for(let w of v.extensionDependencies){const a=m.ExtensionIdentifier.toKey(w);P.addArc(I,a)}}let E=new Set;P.getNodes().filter(v=>P.getArcs(v).length===0).forEach(v=>E.add(v));let h=P.getNodes().filter(v=>!E.has(v)),p;do{p=!1;for(let v=0;v<h.length;v++){const I=h[v];P.hasOnlyGoodArcs(I,E)&&(h.splice(v,1),v--,E.add(I),p=!0)}}while(p);return h.map(v=>u.get(v))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const P=this._activationMap.get(R);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const P=this._extensionsMap.get(m.ExtensionIdentifier.toKey(R));return P||void 0}}e.ExtensionDescriptionRegistry=i;var k;(function(D){D[D.Builtin=0]="Builtin",D[D.User=1]="User",D[D.Dev=2]="Dev"})(k||(k={}));function S(D,R){const P=D.isBuiltin?0:D.isUnderDevelopment?2:1,u=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(P!==u)return P-u;const E=y.posix.basename(D.extensionLocation.path),h=y.posix.basename(R.extensionLocation.path);return E<h?-1:E>h?1:0}}),define(pe[224],ve([0,1,22]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var y;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(y=e.MessageType||(e.MessageType={}));function C(k){const S=m.VSBuffer.alloc(1);switch(k){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=C;function i(k,S){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=i}),define(pe[29],ve([0,1,3,2,4,27,193]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");var k;(function(r){r[r.None=0]="None",r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(r){switch(r){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class D{constructor(g){this.dependency=g}}e.MissingExtensionDependency=D;var R;(function(r){r[r.LocalProcess=0]="LocalProcess",r[r.LocalWebWorker=1]="LocalWebWorker",r[r.Remote=2]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function P(r){switch(r){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=P;function u(r,g){return r.enabledApiProposals?r.enabledApiProposals.includes(g):!1}e.isProposedApiEnabled=u;function E(r,g){if(!u(r,g))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=E;class h{constructor(g,o,_,n){this.codeLoadingTime=g,this.activateCallTime=o,this.activateResolvedTime=_,this.activationReason=n}}e.ActivationTimes=h;class p{constructor(g,o){this.description=g,this.value=o}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var v;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(v=e.ActivationKind||(e.ActivationKind={}));function I(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,i.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation}}e.toExtension=I;function w(r,g){return{identifier:new C.ExtensionIdentifier(r.identifier.id),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!g,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid}}e.toExtensionDescription=w;class a{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(g){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(g,o){return Promise.resolve()}_onWillActivateExtension(g){}_onDidActivateExtension(g,o,_,n,t){}_onDidActivateExtensionError(g,o){}_onExtensionRuntimeError(g,o){}_onExtensionHostExit(g){}}e.NullExtensionService=a}),define(pe[225],ve([0,1,15,27,29,11]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const i=Promise.resolve(void 0);class k{constructor(p,v,I,w){this.startup=p,this.codeLoadingTime=v,this.activateCallTime=I,this.activateResolvedTime=w}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class S{constructor(p){this._startup=p,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(p,v){return p===-1||v===-1?-1:v-p}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class D{constructor(p,v,I,w,a,r){this.activationFailed=p,this.activationFailedError=v,this.activationTimes=I,this.module=w,this.exports=a,this.subscriptions=r}}e.ActivatedExtension=D;class R extends D{constructor(p){super(!1,null,p,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class P extends D{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=P;class u extends D{constructor(p){super(!0,p,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=u;let E=class{constructor(p,v,I,w,a){this._logService=a,this._isDisposed=!1,this._registry=p,this._resolvedExtensionsSet=new Set,v.forEach(r=>this._resolvedExtensionsSet.add(F.ExtensionIdentifier.toKey(r))),this._hostExtensionsMap=new Map,I.forEach(r=>this._hostExtensionsMap.set(F.ExtensionIdentifier.toKey(r),r)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(p){const v=F.ExtensionIdentifier.toKey(p);return this._activatedExtensions.has(v)}getActivatedExtension(p){const v=F.ExtensionIdentifier.toKey(p),I=this._activatedExtensions.get(v);if(!I)throw new Error("Extension `"+p.value+"` is not known or not activated");return I}activateByEvent(p,v){if(this._alreadyActivatedEvents[p])return i;const I=this._registry.getExtensionDescriptionsForActivationEvent(p);return this._activateExtensions(I.map(w=>({id:w.identifier,reason:{startup:v,extensionId:w.identifier,activationEvent:p}}))).then(()=>{this._alreadyActivatedEvents[p]=!0})}activateById(p,v){const I=this._registry.getExtensionDescription(p);if(!I)throw new Error("Extension `"+p+"` is not known");return this._activateExtensions([{id:I.identifier,reason:v}])}_handleActivateRequest(p,v,I){if(this._hostExtensionsMap.has(F.ExtensionIdentifier.toKey(p.id))){v[F.ExtensionIdentifier.toKey(p.id)]=p;return}const w=this._registry.getExtensionDescription(p.id);if(!w){const g=new Error(`Cannot activate unknown extension '${p.id.value}'`);this._host.onExtensionActivationError(p.id,g,new y.MissingExtensionDependency(p.id.value)),this._activatedExtensions.set(F.ExtensionIdentifier.toKey(p.id),new u(g));return}const a=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let r=!0;for(let g=0,o=a.length;g<o;g++){const _=a[g];if(this._resolvedExtensionsSet.has(F.ExtensionIdentifier.toKey(_)))continue;const n=this._activatedExtensions.get(F.ExtensionIdentifier.toKey(_));if(n&&!n.activationFailed)continue;if(n&&n.activationFailed){const c=w.displayName||w.identifier.value,f=this._registry.getExtensionDescription(_),l=f&&f.displayName||_,b=new Error(`Cannot activate the '${c}' extension because its dependency '${l}' failed to activate`);b.detail=n.activationFailedError,this._host.onExtensionActivationError(w.identifier,b,null),this._activatedExtensions.set(F.ExtensionIdentifier.toKey(w.identifier),new u(b));return}if(this._hostExtensionsMap.has(F.ExtensionIdentifier.toKey(_))){r=!1,v[F.ExtensionIdentifier.toKey(_)]={id:this._hostExtensionsMap.get(F.ExtensionIdentifier.toKey(_)),reason:p.reason};continue}const t=this._registry.getExtensionDescription(_);if(t){if(!t.main&&!t.browser)continue;r=!1,v[F.ExtensionIdentifier.toKey(_)]={id:t.identifier,reason:p.reason};continue}const s=w.displayName||w.identifier.value,d=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${_}'`);this._host.onExtensionActivationError(w.identifier,d,new y.MissingExtensionDependency(_)),this._activatedExtensions.set(F.ExtensionIdentifier.toKey(w.identifier),new u(d));return}r?v[F.ExtensionIdentifier.toKey(w.identifier)]=p:I.push(p)}_activateExtensions(p){if(p.length===0||(p=p.filter(a=>!this._activatedExtensions.has(F.ExtensionIdentifier.toKey(a.id))),p.length===0))return Promise.resolve(void 0);const v=Object.create(null),I=[];for(let a=0,r=p.length;a<r;a++)this._handleActivateRequest(p[a],v,I);for(let a=0,r=I.length;a<r;a++){const g=F.ExtensionIdentifier.toKey(I[a].id);v[g]&&delete v[g]}const w=Object.keys(v).map(a=>v[a]);return I.length===0?Promise.all(w.map(a=>this._activateExtension(a.id,a.reason))).then(a=>{}):this._activateExtensions(w).then(a=>this._activateExtensions(I))}_activateExtension(p,v){const I=F.ExtensionIdentifier.toKey(p);if(this._activatedExtensions.has(I))return Promise.resolve(void 0);const w=this._activatingExtensions.get(I);if(w)return w;const a=this._host.actualActivateExtension(p,v).then(void 0,r=>{const g=new Error;return r&&r.name&&(g.name=r.name),r&&r.message?g.message=`Activating extension '${p.value}' failed: ${r.message}.`:g.message=`Activating extension '${p.value}' failed: ${r}.`,r&&r.stack&&(g.stack=r.stack),this._isDisposed&&m.isPromiseCanceledError(r)?new u(r):(this._host.onExtensionActivationError(p,g,null),this._logService.error(`Activating extension ${p.value} failed due to an error:`),this._logService.error(r),new u(r))}).then(r=>{this._activatedExtensions.set(I,r),this._activatingExtensions.delete(I)});return this._activatingExtensions.set(I,a),a}};E=je([He(4,C.ILogService)],E),e.ExtensionsActivator=E}),define(pe[226],ve([0,1,11,26,29]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends m.LogService{constructor(k,S){super(k.createLogger(S.logFile,{name:y.ExtensionHostLogFileName}))}};C=je([He(0,m.ILoggerService),He(1,F.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(pe[227],ve([0,1,15]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,i)=>{this._actualOk=C,this._actualErr=i,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,m.onUnexpectedError)(C))}then(C,i){return this._ensureActual().then(C,i)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=F}),define(pe[53],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(D,R){this._proxyIdentifierBrand=void 0,this.isMain=D,this.sid=R,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const F=[];function y(S){const D=new m(!0,S);return F[D.nid]=D,D}e.createMainContextProxyIdentifier=y;function C(S){const D=new m(!1,S);return F[D.nid]=D,D}e.createExtHostContextProxyIdentifier=C;function i(S){return F[S].sid}e.getStringIdentifierForProxy=i;class k{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=k}),define(pe[5],ve([0,1,59,2,53]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var i;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(i=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var D;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(D=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var u;(function(a){a.name="$ident";function r(o,_){return Object.defineProperty(o,a.name,{value:_,enumerable:!0}),o}a.mixin=r;function g(o){return o[a.name]}a.of=g})(u=e.ObjectIdentifier||(e.ObjectIdentifier={}));class E{static mixin(r){return r._id=E._n++,r}}e.IdObject=E,E._n=0;var h;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function I(a){if(a&&a.edits)for(const r of a.edits)typeof r.resource=="object"?r.resource=F.URI.revive(r.resource):(r.newUri=F.URI.revive(r.newUri),r.oldUri=F.URI.revive(r.oldUri)),r.metadata&&r.metadata.iconPath&&(r.metadata=(0,m.revive)(r.metadata));return a}e.reviveWorkspaceEditDto=I;var w;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,y.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,y.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,y.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(pe[90],ve([0,1,5,3,4]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(k){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,S){return this._proxy.$getPassword(k,S)}store(k,S,D){return this._proxy.$setPassword(k,S,D)}delete(k,S){return this._proxy.$deletePassword(k,S)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")}),define(pe[65],ve([0,1,4,11,5,14]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let i=class{constructor(S,D){this._extHostLogService=D,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(y.MainContext.MainThreadTelemetry)}report(S,D,R){const P=this.getUsageKey(S,D);this._reportedUsages.has(P)||(this._reportedUsages.add(P),D.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:S}))}getUsageKey(S,D){return`${S}-${D.identifier.value}`}};i=je([He(0,C.IExtHostRpcService),He(1,F.ILogService)],i),e.ExtHostApiDeprecationService=i,e.NullApiDeprecationService=Object.freeze(new class{report(k,S,D){}})}),define(pe[228],ve([0,1,3,5,7,27]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class i{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,D,R,P={}){const u=C.ExtensionIdentifier.toKey(S.identifier),E=this._inFlightRequests.get(u)||[],h=[...R].sort().join(" ");let p=E.find(v=>v.scopes===h);if(p)return p.result;{const v=this._getSession(S,u,D,R,P);p={scopes:h,result:v},E.push(p),this._inFlightRequests.set(u,E);try{await v}finally{const I=E.findIndex(w=>w.scopes===h);I>-1&&(E.splice(I),this._inFlightRequests.set(u,E))}return v}}async _getSession(S,D,R,P,u={}){await this._proxy.$ensureProvider(R);const E=S.displayName||S.name;return this._proxy.$getSession(R,P,D,E,u)}async removeSession(S,D){const R=this._authenticationProviders.get(S);return R?R.provider.removeSession(D):this._proxy.$removeSession(S,D)}registerAuthenticationProvider(S,D,R,P){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:D,provider:R,options:P??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===S)||this._providers.push({id:S,label:D});const u=R.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(S,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,D,P?.supportsMultipleAccounts??!1),new y.Disposable(()=>{u.dispose(),this._authenticationProviders.delete(S);const E=this._providers.findIndex(h=>h.id===S);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,D){const R=this._authenticationProviders.get(S);if(R)return Promise.resolve(R.provider.createSession(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,D){const R=this._authenticationProviders.get(S);if(R)return Promise.resolve(R.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,D){const R=this._authenticationProviders.get(S);if(R)return Promise.resolve(R.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,D){return this._onDidChangeSessions.fire({provider:{id:S,label:D}}),Promise.resolve()}}e.ExtHostAuthentication=i}),define(pe[229],ve([0,1,5,14,17]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(k,S){this._extHostDocumentsAndEditors=S,this._proxy=k.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const S=y.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};C=je([He(0,F.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(pe[230],ve([0,1,5]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(C){const i=C.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return i.$readText()},writeText(k){return i.$writeText(k)}})}}e.ExtHostClipboard=F}),define(pe[38],ve([0,1,13,7,17,25,5,16,11,59,41,49,2,6,4,14,63,22,53,50]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(s,d){this._commands=new Map,this._apiCommands=new Map,this._proxy=s.getProxy(i.MainContext.MainThreadCommands),this._logService=d,this.converter=new g(this,c=>{const f=this._apiCommands.get(c);return f?.result===_.Void?f:void 0},d),this._argumentProcessors=[{processArgument(c){return(0,D.revive)(c)}},{processArgument(c){return(0,C.cloneAndChange)(c,function(f){if(R.Range.isIRange(f))return y.Range.to(f);if(P.Position.isIPosition(f))return y.Position.to(f);if(R.Range.isIRange(f.range)&&u.URI.isUri(f.uri))return y.location.to(f);if(f instanceof I.VSBuffer)return f.buffer.buffer;if(!Array.isArray(f))return f})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const d=this.registerCommand(!1,s.id,async(...c)=>{const f=s.args.map((b,T)=>{if(!b.validate(c[T]))throw new Error(`Invalid argument '${b.name}' when running '${s.id}', received: ${c[T]}`);return b.convert(c[T])}),l=await this.executeCommand(s.internalId,...f);return s.result.convert(l,c,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new F.Disposable(()=>{d.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,d,c,f,l,b){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:c,thisArg:f,description:l,extension:b}),s&&this._proxy.$registerCommand(d),new F.Disposable(()=>{this._commands.delete(d)&&s&&this._proxy.$unregisterCommand(d)})}executeCommand(s,...d){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,d,!0)}async _doExecuteCommand(s,d,c){if(this._commands.has(s))return this._executeContributedCommand(s,d,!1);{let f=!1;const l=(0,C.cloneAndChange)(d,function(b){if(b instanceof F.Position)return y.Position.from(b);if(b instanceof F.Range)return y.Range.from(b);if(b instanceof F.Location)return y.location.from(b);if(F.NotebookRange.isNotebookRange(b))return y.NotebookRange.from(b);if(b instanceof ArrayBuffer)return f=!0,I.VSBuffer.wrap(new Uint8Array(b));if(b instanceof Uint8Array)return f=!0,I.VSBuffer.wrap(b);if(!Array.isArray(b))return b});try{const b=await this._proxy.$executeCommand(s,f?new w.SerializableObjectWithBuffers(l):l,c);return(0,D.revive)(b)}catch(b){if(b instanceof Error&&b.message==="$executeCommand:retry")return this._doExecuteCommand(s,d,!1);throw b}}}async _executeContributedCommand(s,d,c){const f=this._commands.get(s);if(!f)throw new Error("Unknown command");let{callback:l,thisArg:b,description:T}=f;if(T)for(let A=0;A<T.args.length;A++)try{(0,m.validateConstraint)(d[A],T.args[A].constraint)}catch(U){throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${T.args[A].name}' - ${T.args[A].description}`)}try{return await l.apply(b,d)}catch(A){if(s===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...d);U&&(s=U.command)}throw this._logService.error(A,s,f.extension?.identifier),c?new class extends Error{constructor(){super((0,a.toErrorMessage)(A));this.id=s,this.source=f.extension?.displayName??f.extension?.name}}:A}}$executeContributedCommand(s,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(d=d.map(c=>this._argumentProcessors.reduce((f,l)=>l.processArgument(f),c)),this._executeContributedCommand(s,d,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),this._proxy.$getCommands().then(d=>(s&&(d=d.filter(c=>c[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(let[d,c]of this._commands){let{description:f}=c;f&&(s[d]=f)}return Promise.resolve(s)}};r=je([He(0,p.IExtHostRpcService),He(1,S.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class g{constructor(s,d,c){this._commands=s,this._lookupApiCommand=d,this._logService=c,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,d){if(!s)return;const c={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return c;const f=this._lookupApiCommand(s.command);if(f)c.id=f.internalId,c.arguments=f.args.map((l,b)=>l.convert(s.arguments&&s.arguments[b]));else if((0,k.isNonEmptyArray)(s.arguments)){const l=++this._cachIdPool;this._cache.set(l,s),d.add((0,E.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),c.$ident=l,c.id=this.delegatingCommandId,c.arguments=[l],this._logService.trace("CommandsConverter#CREATE",s.command,l)}return c}fromInternal(s){const d=i.ObjectIdentifier.of(s);return typeof d=="number"?this._cache.get(d):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const d=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=g;class o{constructor(s,d,c,f){this.name=s,this.description=d,this.validate=c,this.convert=f}optional(){return new o(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,d){return new o(s??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=o,o.Uri=new o("uri","Uri of a text document",t=>u.URI.isUri(t),t=>t),o.Position=new o("position","A position in a text document",t=>F.Position.isPosition(t),y.Position.from),o.Range=new o("range","A range in a text document",t=>F.Range.isRange(t),y.Range.from),o.Selection=new o("selection","A selection in a text document",t=>F.Selection.isSelection(t),y.Selection.from),o.Number=new o("number","",t=>typeof t=="number",t=>t),o.String=new o("string","",t=>typeof t=="string",t=>t),o.CallHierarchyItem=new o("item","A call hierarchy item",t=>t instanceof F.CallHierarchyItem,y.CallHierarchyItem.from),o.TypeHierarchyItem=new o("item","A type hierarchy item",t=>t instanceof F.TypeHierarchyItem,y.TypeHierarchyItem.from),o.TestItem=new o("testItem","A VS Code TestItem",t=>t instanceof v.TestItemImpl,y.TestItem.from);class _{constructor(s,d){this.description=s,this.convert=d}}e.ApiCommandResult=_,_.Void=new _("no result",t=>t);class n{constructor(s,d,c,f,l){this.id=s,this.internalId=d,this.description=c,this.args=f,this.result=l}}e.ApiCommand=n}),define(pe[231],ve([0,1,17,7,84,38,16,110]),function(Y,e,m,F,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",R(m.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,E)=>{if((0,i.isFalsyOrEmpty)(u))return;class h extends F.SymbolInformation{static to(v){const I=new h(v.name,m.SymbolKind.to(v.kind),v.containerName||"",new F.Location(E[0],m.Range.to(v.range)));return I.detail=v.detail,I.range=I.location.range,I.selectionRange=m.Range.to(v.selectionRange),I.children=v.children?v.children.map(h.to):[],I}}return u.map(h.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new C.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(m.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",R(m.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",R(m.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(E=>F.Position.isPosition(E)),u=>u.map(m.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(E=>{let h;for(const p of E.reverse())h=new F.SelectionRange(m.Range.to(p),h);return h}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(m.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(m.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(m.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(m.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",u=>{if(!!u)return{range:m.Range.to(u.range),placeholder:u.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return m.WorkspaceEdit.to(u)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(m.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new F.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const E=(0,k.decodeSemanticTokensDto)(u);if(E.type==="full")return new F.SemanticTokens(E.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new F.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const E=(0,k.decodeSemanticTokensDto)(u);if(E.type==="full")return new F.SemanticTokens(E.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,E,h)=>{if(!u)return new F.CompletionList([]);const p=u.suggestions.map(v=>m.CompletionItem.to(v,h));return new F.CompletionList(p,u.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return m.SignatureHelp.to(u)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,E,h)=>R(p=>new F.CodeLens(m.Range.to(p.range),p.command&&h.fromInternal(p.command)))(u))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>F.Range.isRange(u),u=>F.Selection.isSelection(u)?m.Selection.from(u):m.Range.from(u)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,E,h)=>R(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(p.command)}else{const v=new F.CodeAction(p.title,p.kind?new F.CodeActionKind(p.kind):void 0);return p.edit&&(v.edit=m.WorkspaceEdit.to(p.edit)),p.command&&(v.command=h.fromInternal(p.command)),v.isPreferred=p.isPreferred,v}})(u))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(E=>new F.ColorInformation(m.Range.to(E.range),m.Color.to(E.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",u=>u instanceof F.Color,m.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:m.Range.from(u.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(m.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",u=>u.map(m.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",R(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(E=>m.NotebookExclusiveDocumentPattern.to(E))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(m.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[m.ViewColumn.from(u.viewColumn),m.TextEditorOpenOptions.from(u)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[m.ViewColumn.from(u.viewColumn),m.TextEditorOpenOptions.from(u)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[m.ViewColumn.from(u.viewColumn),m.TextEditorOpenOptions.from(u)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class D{static register(E){S.forEach(E.registerApiCommand,E)}}e.ExtHostApiCommands=D;function R(u){return E=>{if(Array.isArray(E))return E.map(u)}}function P(u){if(!Array.isArray(u))return;const E=[];for(const h of u)y.isLocationLink(h)?E.push(m.DefinitionLink.to(h)):E.push(m.location.to(h));return E}}),define(pe[232],ve([0,1,18,57,3,6,2,84,27,17,7,5]),function(Y,e,m,F,y,C,i,k,S,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function u(E,h,p){const v=E.getProxy(P.MainContext.MainThreadComments);class I{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const s=this._commentControllers.get(t.handle);return s||t}else if(t&&t.$mid===7){const s=this._commentControllers.get(t.commentControlHandle);if(!s)return t;const d=s.getCommentThread(t.commentThreadHandle);return d||t}else if(t&&t.$mid===8){const s=this._commentControllers.get(t.thread.commentControlHandle);if(!s)return t;const d=s.getCommentThread(t.thread.commentThreadHandle);return d?{thread:d,text:t.text}:t}else if(t&&t.$mid===9){const s=this._commentControllers.get(t.thread.commentControlHandle);if(!s)return t;const d=s.getCommentThread(t.thread.commentThreadHandle);if(!d)return t;let c=t.commentUniqueId,f=d.getCommentByUniqueId(c);return f||t}else if(t&&t.$mid===10){const s=this._commentControllers.get(t.thread.commentControlHandle);if(!s)return t;const d=s.getCommentThread(t.thread.commentThreadHandle);if(!d)return t;let c=t.text,f=t.commentUniqueId,l=d.getCommentByUniqueId(f);return l?(l.body=c,l):t}return t}})}createCommentController(t,s,d){const c=I.handlePool++,f=new a(t,c,s,d);this._commentControllers.set(f.handle,f);const l=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(t.identifier))||[];return l.push(f),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(t.identifier),l),f.value}$createCommentThreadTemplate(t,s,d){const c=this._commentControllers.get(t);!c||c.$createCommentThreadTemplate(s,d)}async $updateCommentThreadTemplate(t,s,d){const c=this._commentControllers.get(t);!c||c.$updateCommentThreadTemplate(s,d)}$deleteCommentThread(t,s){const d=this._commentControllers.get(t);d&&d.$deleteCommentThread(s)}$provideCommentingRanges(t,s,d){const c=this._commentControllers.get(t);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const f=p.getDocument(i.URI.revive(s));return(0,m.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(f,d)).then(l=>l?l.map(b=>D.Range.from(b)):void 0)}$toggleReaction(t,s,d,c,f){const l=this._commentControllers.get(t);return!l||!l.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const b=l.getCommentThread(s);if(b){const T=b.getCommentByUniqueId(c.uniqueIdInThread);if(l!==void 0&&T&&l.reactionHandler)return l.reactionHandler(T,o(f))}return Promise.resolve(void 0)})}dispose(){}}I.handlePool=0;class w{constructor(t,s,d,c,f,l,b){this._commentControllerHandle=s,this._id=d,this._uri=c,this._range=f,this._comments=l,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new y.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),v.$createCommentThread(s,this.handle,this._id,this._uri,D.Range.from(this._range),b),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=l,this._localDisposables.push({dispose:()=>{v.$deleteCommentThread(s,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(A){T.range=A},get comments(){return T.comments},set comments(A){T.comments=A},get collapsibleState(){return T.collapsibleState},set collapsibleState(A){T.collapsibleState=A},get canReply(){return T.canReply},set canReply(A){T.canReply=A},get contextValue(){return T.contextValue},set contextValue(A){T.contextValue=A},get label(){return T.label},set label(A){T.label=A},dispose:()=>{T.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const t=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),s={};t("range")&&(s.range=D.Range.from(this._range)),t("label")&&(s.label=this.label),t("contextValue")&&(s.contextValue=this.contextValue??null),t("comments")&&(s.comments=this._comments.map(d=>r(this,d,this._commentsMap))),t("collapsibleState")&&(s.collapseState=_(this._collapseState)),t("canReply")&&(s.canReply=this.canReply),this.modifications={},v.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,s)}getCommentByUniqueId(t){for(let s of this._commentsMap){let d=s[0],c=s[1];if(t===c)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}w._handlePool=0,je([(0,F.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(t,s,d,c){this._extension=t,this._handle=s,this._id=d,this._label=c,this._threads=new Map,v.$registerCommentController(this.handle,d,c);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(l){f.options=l},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(l){f.commentingRangeProvider=l},get reactionHandler(){return f.reactionHandler},set reactionHandler(l){f.reactionHandler=l},createCommentThread(l,b,T){return f.createCommentThread(l,b,T).value},dispose:()=>{f.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{v.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,v.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,v.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,v.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,s,d,c){if(typeof t=="string"){const f=new w(this.id,this.handle,t,s,d,c,this._extension.identifier);return this._threads.set(f.handle,f),f}else{const f=new w(this.id,this.handle,void 0,t,s,d,this._extension.identifier);return this._threads.set(f.handle,f),f}}$createCommentThreadTemplate(t,s){const d=new w(this.id,this.handle,void 0,i.URI.revive(t),D.Range.to(s),[],this._extension.identifier);return d.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(t,s){let d=this._threads.get(t);d&&(d.range=D.Range.to(s))}$deleteCommentThread(t){let s=this._threads.get(t);s&&s.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function r(n,t,s){let d=s.get(t);d||(d=++n.commentHandle,s.set(t,d));const c=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:d,body:D.MarkdownString.from(t.body),userName:t.author.name,userIconPath:c,label:t.label,commentReactions:t.reactions?t.reactions.map(f=>g(f)):void 0}}function g(n){return{label:n.label,iconPath:n.iconPath?D.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function o(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?i.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function _(n){if(n!==void 0)switch(n){case R.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new I}e.createExtHostComments=u}),define(pe[130],ve([0,1,2,5,7,4,14,11,16,8,9]),function(Y,e,m,F,y,C,i,k,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class bi{constructor(E,h){this._logService=h,this._provider=new Map,this._proxy=E.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,h){const p=bi._handlePool++;this._provider.set(p,{provider:E,extensionId:h}),this._proxy.$registerDecorationProvider(p,h.value);const v=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(I=>{if(!I){this._proxy.$onDidChange(p,null);return}let w=(0,S.asArray)(I);if(w.length<=bi._maxEventSize){this._proxy.$onDidChange(p,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",h.value,w.length);const a=w.map(o=>({uri:o,rank:(0,D.count)(o.path,"/")})),r=(0,S.groupBy)(a,(o,_)=>o.rank-_.rank||(0,D.compare)(o.uri.path,_.uri.path));let g=[];e:for(let o of r){let _;for(let n of o){let t=(0,R.dirname)(n.uri.path);if(_!==t&&(_=t,g.push(n.uri)>=bi._maxEventSize))break e}}this._proxy.$onDidChange(p,g)});return new y.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(p),this._provider.delete(p)})}async $provideDecorations(E,h,p){if(!this._provider.has(E))return Object.create(null);const v=Object.create(null),{provider:I,extensionId:w}=this._provider.get(E);return await Promise.all(h.map(async a=>{try{const{uri:r,id:g}=a,o=await Promise.resolve(I.provideFileDecoration(m.URI.revive(r),p));if(!o)return;try{y.FileDecoration.validate(o),v[g]=[o.propagate,o.tooltip,o.badge,o.color]}catch(_){this._logService.warn(`INVALID decoration from extension '${w.value}': ${_}`)}}catch(r){this._logService.error(r)}})),v}};P._handlePool=0,P._maxEventSize=250,P=je([He(0,i.IExtHostRpcService),He(1,k.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,F,y){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(pe[233],ve([0,1,162,116,2,5,7,17,3,11,24,44]),function(Y,e,m,F,y,C,i,k,S,D,R,P){"use strict";var u,E,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class p{constructor(w,a,r,g,o,_){this._name=w,this._owner=a,this._maxDiagnosticsPerFile=r,u.set(this,void 0),E.set(this,void 0),h.set(this,void 0),this._isDisposed=!1,nt(this,h,new R.ResourceMap(n=>g.getComparisonKey(n)),"f"),nt(this,u,o,"f"),nt(this,E,_,"f")}dispose(){this._isDisposed||(Ne(this,E,"f").fire([...Ne(this,h,"f").keys()]),Ne(this,u,"f")&&Ne(this,u,"f").$clear(this._owner),Ne(this,h,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(w,a){if(!w){this.clear();return}this._checkDisposed();let r=[];if(y.URI.isUri(w)){if(!a){this.delete(w);return}Ne(this,h,"f").set(w,a.slice()),r=[w]}else if(Array.isArray(w)){r=[];let o;w=[...w].sort(p._compareIndexedTuplesByUri);for(const _ of w){const[n,t]=_;if((!o||n.toString()!==o.toString())&&(o&&Ne(this,h,"f").get(o).length===0&&Ne(this,h,"f").delete(o),o=n,r.push(n),Ne(this,h,"f").set(n,[])),t){const s=Ne(this,h,"f").get(n);s&&s.push(...t)}else{const s=Ne(this,h,"f").get(n);s&&(s.length=0)}}}if(Ne(this,E,"f").fire(r),!Ne(this,u,"f"))return;const g=[];for(let o of r){let _=[];const n=Ne(this,h,"f").get(o);if(n)if(n.length>this._maxDiagnosticsPerFile){_=[];const t=[i.DiagnosticSeverity.Error,i.DiagnosticSeverity.Warning,i.DiagnosticSeverity.Information,i.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(let d of n)if(d.severity===t[s]&&_.push(k.Diagnostic.from(d))===this._maxDiagnosticsPerFile)break e;_.push({severity:F.MarkerSeverity.Info,message:(0,m.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:_[_.length-1].startLineNumber,startColumn:_[_.length-1].startColumn,endLineNumber:_[_.length-1].endLineNumber,endColumn:_[_.length-1].endColumn})}else _=n.map(t=>k.Diagnostic.from(t));g.push([o,_])}Ne(this,u,"f").$changeMany(this._owner,g)}delete(w){this._checkDisposed(),Ne(this,E,"f").fire([w]),Ne(this,h,"f").delete(w),Ne(this,u,"f")&&Ne(this,u,"f").$changeMany(this._owner,[[w,void 0]])}clear(){this._checkDisposed(),Ne(this,E,"f").fire([...Ne(this,h,"f").keys()]),Ne(this,h,"f").clear(),Ne(this,u,"f")&&Ne(this,u,"f").$clear(this._owner)}forEach(w,a){this._checkDisposed();for(let r of Ne(this,h,"f").keys())w.apply(a,[r,this.get(r),this])}get(w){this._checkDisposed();const a=Ne(this,h,"f").get(w);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(w){return this._checkDisposed(),Array.isArray(Ne(this,h,"f").get(w))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(w,a){return w[0].toString()<a[0].toString()?-1:w[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=p,u=new WeakMap,E=new WeakMap,h=new WeakMap;let v=class ri{constructor(w,a,r){this._logService=a,this._fileSystemInfoService=r,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=w.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(w){const a=new R.ResourceMap;for(const r of w)a.set(r,r);return{uris:Object.freeze(Array.from(a.values()))}}createDiagnosticCollection(w,a){const{_collections:r,_proxy:g,_onDidChangeDiagnostics:o,_logService:_,_fileSystemInfoService:n}=this,t=new class{$changeMany(c,f){g.$changeMany(c,f),_.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,c,f.length===0?"CLEARING":f)}$clear(c){g.$clear(c),_.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,c)}dispose(){g.dispose()}};let s;if(!a)a="_generated_diagnostic_collection_name_#"+ri._idPool++,s=a;else if(!r.has(a))s=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do s=a+ri._idPool++;while(r.has(s))}return new class extends p{constructor(){super(a,s,ri._maxDiagnosticsPerFile,n.extUri,t,o);r.set(s,this)}dispose(){super.dispose(),r.delete(s)}}}getDiagnostics(w){if(w)return this._getDiagnostics(w);{const a=new Map,r=[];for(const g of this._collections.values())g.forEach((o,_)=>{let n=a.get(o.toString());typeof n=="undefined"&&(n=r.length,a.set(o.toString(),n),r.push([o,[]])),r[n][1]=r[n][1].concat(..._)});return r}}_getDiagnostics(w){let a=[];for(let r of this._collections.values())r.has(w)&&(a=a.concat(r.get(w)));return a}$acceptMarkersChange(w){if(!this._mirrorCollection){const a="_generated_mirror",r=new p(a,a,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(a,r),this._mirrorCollection=r}for(const[a,r]of w)this._mirrorCollection.set(y.URI.revive(a),r.map(k.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=je([He(1,D.ILogService),He(2,P.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(pe[234],ve([0,1,2,5]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(i){this._proxy=i.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(i){return this._proxy.$showOpenDialog(i).then(k=>k?k.map(S=>m.URI.revive(S)):void 0)}showSaveDialog(i){return this._proxy.$showSaveDialog(i).then(k=>k?m.URI.revive(k):void 0)}}e.ExtHostDialogs=y}),define(pe[235],ve([0,1,15,2,7,5,10,21,8]),function(Y,e,m,F,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class D{constructor(P,u,E){this._documentsAndEditors=u,this._logService=E,this._documentContentProviders=new Map,this._proxy=P.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,u){if(Object.keys(i.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const E=D._handlePool++;this._documentContentProviders.set(E,u),this._proxy.$registerTextContentProvider(E,P);let h;return typeof u.onDidChange=="function"&&(h=u.onDidChange(p=>{if(p.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(p)&&this.$provideTextDocumentContent(E,p).then(v=>{if(!v&&typeof v!="string")return;const I=this._documentsAndEditors.getDocument(p);if(!I)return;const w=(0,S.splitLines)(v);if(!I.equalLines(w))return this._proxy.$onVirtualDocumentChange(p,v)},m.onUnexpectedError)})),new y.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(P,u){const E=this._documentContentProviders.get(P);return E?Promise.resolve(E.provideTextDocumentContent(F.URI.revive(u),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=D,D._handlePool=0}),define(pe[236],ve([0,1,3,6,2,5,122,17,13,25,7]),function(Y,e,m,F,y,C,i,k,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(E,h){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(p=>{for(const v of p)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(p=>{for(const v of p)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const h=this._documentsAndEditors.getDocument(E);if(h)return h}getDocument(E){const h=this.getDocumentData(E);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return h.document}ensureDocumentData(E){const h=this._documentsAndEditors.getDocument(E);if(h)return Promise.resolve(h);let p=this._documentLoader.get(E.toString());return p||(p=this._proxy.$tryOpenDocument(E).then(v=>{this._documentLoader.delete(E.toString());const I=y.URI.revive(v);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(I))},v=>(this._documentLoader.delete(E.toString()),Promise.reject(v))),this._documentLoader.set(E.toString(),p)),p}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(h=>y.URI.revive(h))}$acceptModelModeChanged(E,h){const p=y.URI.revive(E),v=this._documentsAndEditors.getDocument(p);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(h),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(E){const h=y.URI.revive(E),p=this._documentsAndEditors.getDocument(h);if(!p)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(p.document)}$acceptDirtyStateChanged(E,h){const p=y.URI.revive(E),v=this._documentsAndEditors.getDocument(p);if(!v)throw new Error("unknown document");v._acceptIsDirty(h),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,h,p){const v=y.URI.revive(E),I=this._documentsAndEditors.getDocument(v);if(!I)throw new Error("unknown document");I._acceptIsDirty(p),I.onEvents(h);let w;h.isUndoing?w=R.TextDocumentChangeReason.Undo:h.isRedoing&&(w=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,D.deepFreeze)({document:I.document,contentChanges:h.changes.map(a=>({range:k.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:w}))}setWordDefinitionFor(E,h){(0,i.setWordDefinitionFor)(E,h)}}e.ExtHostDocuments=P}),define(pe[45],ve([0,1,56,3,6,2,4,5,122,14,129,17,11,24,10,76,140]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class I{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(r,g){this._extHostRpc=r,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const g=[],o=[],_=[];if(r.removedDocuments)for(const n of r.removedDocuments){const t=C.URI.revive(n),s=this._documents.get(t);s?.unref()&&(this._documents.delete(t),g.push(s.value))}if(r.addedDocuments)for(const n of r.addedDocuments){const t=C.URI.revive(n.uri);let s=this._documents.get(t);if(s&&t.scheme!==h.Schemas.vscodeNotebookCell&&t.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);s||(s=new I(new S.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),t,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(t,s),o.push(s.value)),s.ref()}if(r.removedEditors)for(const n of r.removedEditors){const t=this._editors.get(n);this._editors.delete(n),t&&_.push(t)}if(r.addedEditors)for(const n of r.addedEditors){const t=C.URI.revive(n.documentUri);m.ok(this._documents.has(t),`document '${t}' does not exist`),m.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const s=this._documents.get(t).value,d=new R.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>s.document),n.selections.map(P.Selection.to),n.options,n.visibleRanges.map(c=>P.Range.to(c)),typeof n.editorPosition=="number"?P.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,d)}r.newActiveEditor!==void 0&&(m.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,y.dispose)(g),(0,y.dispose)(_),r.removedDocuments&&this._onDidRemoveDocuments.fire(g),r.addedDocuments&&this._onDidAddDocuments.fire(o),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return p.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return r?g:g?.value}allEditors(){return[...this._editors.values()]}};w=je([He(0,D.IExtHostRpcService),He(1,u.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,i.createDecorator)("IExtHostDocumentsAndEditors")}),define(pe[54],ve([0,1,17,5,2,3,4,14,18]),function(Y,e,m,F,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,i.createDecorator)("IExtHostEditorTabs");let D=class{constructor(P){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new C.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=P.getProxy(F.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(P){let u=-1;this._tabs=P.map((h,p)=>(h.isActive&&(u=p),Object.freeze({label:h.label,viewColumn:m.ViewColumn.to(h.viewColumn),index:p,resource:y.URI.revive(h.resource),additionalResourcesAndViewIds:h.additionalResourcesAndViewIds.map(({resource:v,viewId:I})=>({resource:y.URI.revive(v),viewId:I})),viewId:h.editorId,isActive:h.isActive,move:async(v,I)=>{this._proxy.$moveTab(h,v,m.ViewColumn.from(I)),await(0,S.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(h),await(0,S.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((h,p)=>h.viewColumn===p.viewColumn?h.index-p.index:h.viewColumn-p.viewColumn);const E=this._activeTab;this._activeTab=u===-1?void 0:this._tabs[u],this._activeTab!==E&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};D=je([He(0,k.IExtHostRpcService)],D),e.ExtHostEditorTabs=D}),define(pe[237],ve([0,1,2,5,6,7,17,147,8,22,29]),function(Y,e,m,F,y,C,i,k,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const p=this._schemes.indexOf(h);p>=0&&(this._schemes.splice(p,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),p=[];let v,I,w=14,a=14;for(const r of h){let g=v?(0,S.commonPrefixLength)(v,r):0;for(g===0?I=1:I=a;g<r.length;g++)g+1===r.length?(w=a,a=9):a+=1,p.push([I,r.toUpperCase().charCodeAt(g),a]),p.push([I,r.toLowerCase().charCodeAt(g),a]),I=a;v=r,a=w}p.push([9,58,10]),p.push([10,47,12]),this._stateMachine=new k.StateMachine(p)}}provideDocumentLinks(h){this._initStateMachine();const p=[],v=k.LinkComputer.computeLinks({getLineContent(I){return h.lineAt(I-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const I of v){const w=i.DocumentLink.to(I);w.target&&p.push(w)}return p}}class u{constructor(h,p){this._extHostLanguageFeatures=p,this._linkProvider=new P,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,p,v,I={}){if(this._registeredSchemes.has(p))throw new Error(`a provider for the scheme '${p}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(p),this._registeredSchemes.add(p),this._fsProvider.set(w,v);let a=2;I.isCaseSensitive&&(a+=1024),I.isReadonly&&(a+=2048),typeof v.copy=="function"&&(a+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&((0,R.checkProposedApiEnabled)(h,"fsChunks"),a+=4),this._proxy.$registerFileSystemProvider(w,p,a).catch(g=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${p}`),console.error(g)});const r=v.onDidChangeFile(g=>{const o=[];for(const _ of g){let{uri:n,type:t}=_;if(n.scheme!==p)continue;let s;switch(t){case C.FileChangeType.Changed:s=0;break;case C.FileChangeType.Created:s=1;break;case C.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:n,type:s})}this._proxy.$onFileSystemChange(w,o)});return(0,y.toDisposable)(()=>{r.dispose(),this._linkProvider.delete(p),this._registeredSchemes.delete(p),this._fsProvider.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(h){const{type:p,ctime:v,mtime:I,size:w,permissions:a}=h;return{type:p,ctime:v,mtime:I,size:w,permissions:a}}$stat(h,p){return Promise.resolve(this._getFsProvider(h).stat(m.URI.revive(p))).then(v=>u._asIStat(v))}$readdir(h,p){return Promise.resolve(this._getFsProvider(h).readDirectory(m.URI.revive(p)))}$readFile(h,p){return Promise.resolve(this._getFsProvider(h).readFile(m.URI.revive(p))).then(v=>D.VSBuffer.wrap(v))}$writeFile(h,p,v,I){return Promise.resolve(this._getFsProvider(h).writeFile(m.URI.revive(p),v.buffer,I))}$delete(h,p,v){return Promise.resolve(this._getFsProvider(h).delete(m.URI.revive(p),v))}$rename(h,p,v,I){return Promise.resolve(this._getFsProvider(h).rename(m.URI.revive(p),m.URI.revive(v),I))}$copy(h,p,v,I){const w=this._getFsProvider(h);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(m.URI.revive(p),m.URI.revive(v),I))}$mkdir(h,p){return Promise.resolve(this._getFsProvider(h).createDirectory(m.URI.revive(p)))}$watch(h,p,v,I){const w=this._getFsProvider(h).watch(m.URI.revive(v),I);this._watches.set(p,w)}$unwatch(h,p){const v=this._watches.get(p);v&&(v.dispose(),this._watches.delete(p))}$open(h,p,v){const I=this._getFsProvider(h);if(!I.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(I.open(m.URI.revive(p),v))}$close(h,p){const v=this._getFsProvider(h);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(p))}$read(h,p,v,I){const w=this._getFsProvider(h);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const a=D.VSBuffer.alloc(I);return Promise.resolve(w.read(p,v,a.buffer,0,I)).then(r=>a.slice(0,r))}$write(h,p,v,I){const w=this._getFsProvider(h);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(p,v,I.buffer,0,I.byteLength))}_getFsProvider(h){const p=this._fsProvider.get(h);if(!p){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return p}}e.ExtHostFileSystem=u}),define(pe[66],ve([0,1,5,42,7,22,4,14,44,6]),function(Y,e,m,F,y,C,i,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class zt{constructor(u,E){this._fileSystemProvider=new Map,this._proxy=u.getProxy(m.MainContext.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(p){try{const v=h._fileSystemProvider.get(p.scheme);if(!v)return await h._proxy.$stat(p);await h._proxy.$ensureActivation(p.scheme);const I=await v.stat(p);return{type:I.type,ctime:I.ctime,mtime:I.mtime,size:I.size,permissions:I.permissions}}catch(v){zt._handleError(v)}},async readDirectory(p){try{const v=h._fileSystemProvider.get(p.scheme);return v?(await h._proxy.$ensureActivation(p.scheme),(await v.readDirectory(p)).slice()):await h._proxy.$readdir(p)}catch(v){return zt._handleError(v)}},async createDirectory(p){try{return await h._proxy.$mkdir(p)}catch(v){return zt._handleError(v)}},async readFile(p){try{const v=h._fileSystemProvider.get(p.scheme);return v?(await h._proxy.$ensureActivation(p.scheme),(await v.readFile(p)).slice()):(await h._proxy.$readFile(p)).buffer}catch(v){return zt._handleError(v)}},async writeFile(p,v){try{return await h._proxy.$writeFile(p,C.VSBuffer.wrap(v))}catch(I){return zt._handleError(I)}},async delete(p,v){try{const I=h._fileSystemProvider.get(p.scheme);return I?(await h._proxy.$ensureActivation(p.scheme),await I.delete(p,{recursive:!1,...v})):await h._proxy.$delete(p,{recursive:!1,useTrash:!1,...v})}catch(I){return zt._handleError(I)}},async rename(p,v,I){try{return await h._proxy.$rename(p,v,{overwrite:!1,...I})}catch(w){return zt._handleError(w)}},async copy(p,v,I){try{return await h._proxy.$copy(p,v,{overwrite:!1,...I})}catch(w){return zt._handleError(w)}},isWritableFileSystem(p){const v=E.getCapabilities(p);if(typeof v=="number")return!(v&2048)}})}static _handleError(u){if(u instanceof y.FileSystemError)throw u;if(!(u instanceof Error))throw new y.FileSystemError(String(u));if(u.name==="ENOPRO")throw y.FileSystemError.Unavailable(u.message);switch(u.name){case F.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(u.message);case F.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(u.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(u.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(u.message);case F.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(u.message);case F.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(u.message);default:throw new y.FileSystemError(u.message,u.name)}}addFileSystemProvider(u,E){return this._fileSystemProvider.set(u,E),(0,D.toDisposable)(()=>this._fileSystemProvider.delete(u))}};R=je([He(0,k.IExtHostRpcService),He(1,S.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,i.createDecorator)("IExtHostConsumerFileSystem")}),define(pe[238],ve([0,1,2,38]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(i,k,S,D){this._extHostNotebooks=k,this._textDocumentsAndEditors=S,this._commands=D;const R=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",P=>!0,P=>P),new F.ApiCommandArgument("resource","Interactive resource Uri",P=>!0,P=>P),new F.ApiCommandArgument("controllerId","Notebook controller Id",P=>!0,P=>P),new F.ApiCommandArgument("title","Interactive editor title",P=>!0,P=>P)],new F.ApiCommandResult("Notebook and input URI",P=>{if(P.notebookEditorId!==void 0){const u=this._extHostNotebooks.getEditorById(P.notebookEditorId);return{notebookUri:m.URI.revive(P.notebookUri),inputUri:m.URI.revive(P.inputUri),notebookEditor:u.apiEditor}}return{notebookUri:m.URI.revive(P.notebookUri),inputUri:m.URI.revive(P.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(i,k,S,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:S,uri:i,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(i,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[i]})}}e.ExtHostInteractive=y}),define(pe[239],ve([0,1,6,5]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(i){this._handlePool=0,this._proxy=i.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(i){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,i),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=y}),define(pe[240],ve([0,1,2,25,17,7,5,8,41,16,13,144,6,110,75,87,46,15,3]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideDocumentSymbols(Q,ee){const re=this._documents.getDocument(Q),he=await this._provider.provideDocumentSymbols(re,ee);if(!(0,D.isFalsyOrEmpty)(he))return he[0]instanceof C.DocumentSymbol?he.map(y.DocumentSymbol.from):a._asDocumentSymbolTree(he)}static _asDocumentSymbolTree(Q){Q=Q.slice(0).sort((he,Z)=>{let oe=he.location.range.start.compareTo(Z.location.range.start);return oe===0&&(oe=Z.location.range.end.compareTo(he.location.range.end)),oe});const ee=[],re=[];for(const he of Q){const Z={name:he.name||"!!MISSING: name!!",kind:y.SymbolKind.from(he.kind),tags:he.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:he.containerName,range:y.Range.from(he.location.range),selectionRange:y.Range.from(he.location.range),children:[]};for(;;){if(re.length===0){re.push(Z),ee.push(Z);break}const oe=re[re.length-1];if(S.Range.containsRange(oe.range,Z.range)&&!S.Range.equalsRange(oe.range,Z.range)){oe.children&&oe.children.push(Z),re.push(Z);break}re.pop()}}return ee}}class r{constructor(Q,ee,re){this._documents=Q,this._commands=ee,this._provider=re,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(Q,ee){const re=this._documents.getDocument(Q),he=await this._provider.provideCodeLenses(re,ee);if(!he||ee.isCancellationRequested)return;const Z=this._cache.add(he),oe=new u.DisposableStore;this._disposables.set(Z,oe);const be={cacheId:Z,lenses:[]};for(let Me=0;Me<he.length;Me++)be.lenses.push({cacheId:[Z,Me],range:y.Range.from(he[Me].range),command:this._commands.toInternal(he[Me].command,oe)});return be}async resolveCodeLens(Q,ee){const re=Q.cacheId&&this._cache.get(...Q.cacheId);if(!re)return;let he;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?he=re:he=await this._provider.resolveCodeLens(re,ee),he||(he=re),ee.isCancellationRequested)return;const Z=Q.cacheId&&this._disposables.get(Q.cacheId[0]);if(!!Z)return Q.command=this._commands.toInternal(he.command??r._badCmd,Z),Q}releaseCodeLenses(Q){this._disposables.get(Q)?.dispose(),this._disposables.delete(Q),this._cache.delete(Q)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function g(ze){return Array.isArray(ze)?ze.map(y.DefinitionLink.from):ze?[y.DefinitionLink.from(ze)]:[]}class o{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideDefinition(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.provideDefinition(he,Z,re);return g(oe)}}class _{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideDeclaration(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.provideDeclaration(he,Z,re);return g(oe)}}class n{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideImplementation(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.provideImplementation(he,Z,re);return g(oe)}}class t{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideTypeDefinition(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.provideTypeDefinition(he,Z,re);return g(oe)}}class s{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideHover(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.provideHover(he,Z,re);if(!(!oe||(0,D.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=he.getWordRangeAtPosition(Z)),oe.range||(oe.range=new C.Range(Z,Z)),y.Hover.from(oe)}}class d{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideEvaluatableExpression(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.provideEvaluatableExpression(he,Z,re);if(oe)return y.EvaluatableExpression.from(oe)}}class c{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideInlineValues(Q,ee,re,he){const Z=this._documents.getDocument(Q),oe=await this._provider.provideInlineValues(Z,y.Range.to(ee),y.InlineValueContext.to(re),he);if(Array.isArray(oe))return oe.map(be=>y.InlineValue.from(be))}}class f{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideDocumentHighlights(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.provideDocumentHighlights(he,Z,re);if(Array.isArray(oe))return oe.map(y.DocumentHighlight.from)}}class l{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideLinkedEditingRanges(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.provideLinkedEditingRanges(he,Z,re);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,D.coalesce)(oe.ranges.map(y.Range.from)),wordPattern:oe.wordPattern}}}class b{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideReferences(Q,ee,re,he){const Z=this._documents.getDocument(Q),oe=y.Position.to(ee),be=await this._provider.provideReferences(Z,oe,re,he);if(Array.isArray(be))return be.map(y.location.from)}}class T{constructor(Q,ee,re,he,Z,oe,be){this._documents=Q,this._commands=ee,this._diagnostics=re,this._provider=he,this._logService=Z,this._extension=oe,this._apiDeprecation=be,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(Q,ee,re,he){const Z=this._documents.getDocument(Q),oe=P.Selection.isISelection(ee)?y.Selection.to(ee):y.Range.to(ee),be=[];for(const ot of this._diagnostics.getDiagnostics(Q))if(oe.intersection(ot.range)&&be.push(ot)>T._maxCodeActionsPerFile)break;const Me={diagnostics:be,only:re.only?new C.CodeActionKind(re.only):void 0,triggerKind:y.CodeActionTriggerKind.to(re.trigger)},Ve=await this._provider.provideCodeActions(Z,oe,Me,he);if(!(0,D.isNonEmptyArray)(Ve)||he.isCancellationRequested)return;const Ge=this._cache.add(Ve),Je=new u.DisposableStore;this._disposables.set(Ge,Je);const tt=[];for(let ot=0;ot<Ve.length;ot++){const et=Ve[ot];!et||(T._isCommand(et)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:et.title,command:this._commands.toInternal(et,Je)})):(Me.only&&(et.kind?Me.only.contains(et.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[Ge,ot],title:et.title,command:et.command&&this._commands.toInternal(et.command,Je),diagnostics:et.diagnostics&&et.diagnostics.map(y.Diagnostic.from),edit:et.edit&&y.WorkspaceEdit.from(et.edit),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,disabled:et.disabled?.reason})))}return{cacheId:Ge,actions:tt}}async resolveCodeAction(Q,ee){const[re,he]=Q,Z=this._cache.get(re,he);if(!Z||T._isCommand(Z)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(Z,ee)??Z;return oe?.edit?y.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(Q){this._disposables.get(Q)?.dispose(),this._disposables.delete(Q),this._cache.delete(Q)}static _isCommand(Q){return typeof Q.command=="string"&&typeof Q.title=="string"}}T._maxCodeActionsPerFile=1e3;class A{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideDocumentFormattingEdits(Q,ee,re){const he=this._documents.getDocument(Q),Z=await this._provider.provideDocumentFormattingEdits(he,ee,re);if(Array.isArray(Z))return Z.map(y.TextEdit.from)}}class U{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideDocumentRangeFormattingEdits(Q,ee,re,he){const Z=this._documents.getDocument(Q),oe=y.Range.to(ee),be=await this._provider.provideDocumentRangeFormattingEdits(Z,oe,re,he);if(Array.isArray(be))return be.map(y.TextEdit.from)}}class B{constructor(Q,ee){this._documents=Q,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(Q,ee,re,he,Z){const oe=this._documents.getDocument(Q),be=y.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(oe,be,re,he,Z);if(Array.isArray(Me))return Me.map(y.TextEdit.from)}}class L{constructor(Q,ee){this._provider=Q,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(Q,ee){const re=i.IdObject.mixin({symbols:[]}),he=await this._provider.provideWorkspaceSymbols(Q,ee);if((0,D.isNonEmptyArray)(he))for(const Z of he){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const oe=i.IdObject.mixin(y.WorkspaceSymbol.from(Z));this._symbolCache.set(oe._id,Z),re.symbols.push(oe)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(Q,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return Q;const re=this._symbolCache.get(Q._id);if(re){const he=await this._provider.resolveWorkspaceSymbol(re,ee);return he&&(0,F.mixin)(Q,y.WorkspaceSymbol.from(he),!0)}}releaseWorkspaceSymbols(Q){const ee=this._resultCache.get(Q);if(ee){for(let[re,he]=ee;re<=he;re++)this._symbolCache.delete(re);this._resultCache.delete(Q)}}}class x{constructor(Q,ee,re){this._documents=Q,this._provider=ee,this._logService=re}static supportsResolving(Q){return typeof Q.prepareRename=="function"}async provideRenameEdits(Q,ee,re,he){const Z=this._documents.getDocument(Q),oe=y.Position.to(ee);try{const be=await this._provider.provideRenameEdits(Z,oe,re,he);return be?y.WorkspaceEdit.from(be):void 0}catch(be){const Me=x._asMessage(be);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(be)}}async resolveRenameLocation(Q,ee,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const he=this._documents.getDocument(Q),Z=y.Position.to(ee);try{const oe=await this._provider.prepareRename(he,Z,re);let be,Me;if(C.Range.isRange(oe)?(be=oe,Me=he.getText(oe)):(0,R.isObject)(oe)&&(be=oe.range,Me=oe.placeholder),!be||!Me)return;if(be.start.line>Z.line||be.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(be),text:Me}}catch(oe){const be=x._asMessage(oe);return be?{rejectReason:be,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(Q){return typeof Q=="string"?Q:Q instanceof Error&&typeof Q.message=="string"?Q.message:void 0}}class M{constructor(Q,ee){this.resultId=Q,this.tokens=ee}}class V{constructor(Q,ee){this._documents=Q,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(Q,ee,re){const he=this._documents.getDocument(Q),Z=ee!==0?this._previousResults.get(ee):null;let oe=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(he,Z.resultId,re):await this._provider.provideDocumentSemanticTokens(he,re);return Z&&this._previousResults.delete(ee),oe?(oe=V._fixProvidedSemanticTokens(oe),this._send(V._convertToEdits(Z,oe),oe)):null}async releaseDocumentSemanticColoring(Q){this._previousResults.delete(Q)}static _fixProvidedSemanticTokens(Q){return V._isSemanticTokens(Q)?V._isCorrectSemanticTokens(Q)?Q:new C.SemanticTokens(new Uint32Array(Q.data),Q.resultId):V._isSemanticTokensEdits(Q)?V._isCorrectSemanticTokensEdits(Q)?Q:new C.SemanticTokensEdits(Q.edits.map(ee=>new C.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),Q.resultId):Q}static _isSemanticTokens(Q){return Q&&!!Q.data}static _isCorrectSemanticTokens(Q){return Q.data instanceof Uint32Array}static _isSemanticTokensEdits(Q){return Q&&Array.isArray(Q.edits)}static _isCorrectSemanticTokensEdits(Q){for(const ee of Q.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(Q,ee){if(!V._isSemanticTokens(ee)||!Q||!Q.tokens)return ee;const re=Q.tokens,he=re.length,Z=ee.data,oe=Z.length;let be=0;const Me=Math.min(he,oe);for(;be<Me&&re[be]===Z[be];)be++;if(be===he&&be===oe)return new C.SemanticTokensEdits([],ee.resultId);let Ve=0;const Ge=Me-be;for(;Ve<Ge&&re[he-Ve-1]===Z[oe-Ve-1];)Ve++;return new C.SemanticTokensEdits([{start:be,deleteCount:he-be-Ve,data:Z.subarray(be,oe-Ve)}],ee.resultId)}_send(Q,ee){if(V._isSemanticTokens(Q)){const re=this._nextResultId++;return this._previousResults.set(re,new M(Q.resultId,Q.data)),(0,E.encodeSemanticTokensDto)({id:re,type:"full",data:Q.data})}if(V._isSemanticTokensEdits(Q)){const re=this._nextResultId++;return V._isSemanticTokens(ee)?this._previousResults.set(re,new M(ee.resultId,ee.data)):this._previousResults.set(re,new M(Q.resultId)),(0,E.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(Q.edits||[]).map(he=>({start:he.start,deleteCount:he.deleteCount,data:he.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class O{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideDocumentRangeSemanticTokens(Q,ee,re){const he=this._documents.getDocument(Q),Z=await this._provider.provideDocumentRangeSemanticTokens(he,y.Range.to(ee),re);return Z?this._send(Z):null}_send(Q){return(0,E.encodeSemanticTokensDto)({id:0,type:"full",data:Q.data})}}e.DocumentRangeSemanticTokensAdapter=O;class W{constructor(Q,ee,re,he,Z){this._documents=Q,this._commands=ee,this._provider=re,this._apiDeprecation=he,this._extension=Z,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(Q){return typeof Q.resolveCompletionItem=="function"}async provideCompletionItems(Q,ee,re,he){const Z=this._documents.getDocument(Q),oe=y.Position.to(ee),be=Z.getWordRangeAtPosition(oe)||new C.Range(oe,oe),Me=be.with({end:oe}),Ve=new v.StopWatch(!0),Ge=await this._provider.provideCompletionItems(Z,oe,he,y.CompletionContext.to(re));if(!Ge||he.isCancellationRequested)return;const Je=Array.isArray(Ge)?new C.CompletionList(Ge):Ge,tt=W.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),ot=new u.DisposableStore;this._disposables.set(tt,ot);const et=[],it={x:tt,b:et,a:{replace:y.Range.from(be),insert:y.Range.from(Me)},c:Je.isIncomplete||void 0,d:Ve.elapsed()};for(let ct=0;ct<Je.items.length;ct++){const pt=Je.items[ct],Pt=this._convertCompletionItem(pt,[tt,ct],Me,be);et.push(Pt)}return it}async resolveCompletionItem(Q,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...Q);if(!re)return;const he=await this._provider.resolveCompletionItem(re,ee);if(!!he)return this._convertCompletionItem(he,Q)}releaseCompletionItems(Q){this._disposables.get(Q)?.dispose(),this._disposables.delete(Q),this._cache.delete(Q)}_convertCompletionItem(Q,ee,re,he){const Z=this._disposables.get(ee[0]);if(!Z)throw Error("DisposableStore is missing...");const oe={x:ee,a:Q.label,b:Q.kind!==void 0?y.CompletionItemKind.from(Q.kind):void 0,n:Q.tags&&Q.tags.map(y.CompletionItemTag.from),c:Q.detail,d:typeof Q.documentation=="undefined"?void 0:y.MarkdownString.fromStrict(Q.documentation),e:Q.sortText!==Q.label?Q.sortText:void 0,f:Q.filterText!==Q.label?Q.filterText:void 0,g:Q.preselect||void 0,i:Q.keepWhitespace?1:0,k:Q.commitCharacters,l:Q.additionalTextEdits&&Q.additionalTextEdits.map(y.TextEdit.from),m:this._commands.toInternal(Q.command,Z)};Q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=Q.textEdit.newText):typeof Q.insertText=="string"?oe.h=Q.insertText:Q.insertText instanceof C.SnippetString&&(oe.h=Q.insertText.value,oe.i|=4);let be;return Q.textEdit?be=Q.textEdit.range:Q.range&&(be=Q.range),C.Range.isRange(be)?oe.j=y.Range.from(be):be&&(!re?.isEqual(be.inserting)||!he?.isEqual(be.replacing))&&(oe.j={insert:y.Range.from(be.inserting),replace:y.Range.from(be.replacing)}),oe}}class q{constructor(Q,ee,re){this._documents=Q,this._provider=ee,this._commands=re,this._cache=new p.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(Q,ee,re,he){const Z=this._documents.getDocument(Q),oe=y.Position.to(ee),be=await this._provider.provideInlineCompletionItems(Z,oe,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:y.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text,isSnippetText:re.selectedSuggestionInfo.isSnippetText,completionKind:y.CompletionItemKind.to(re.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:re.triggerKind},he);if(!be||he.isCancellationRequested)return;const Me=(0,R.isArray)(be)?{items:be}:be,Ve=this._cache.add(Me.items);let Ge;return{pid:Ve,items:Me.items.map((Je,tt)=>{let ot;return Je.command&&(Ge||(Ge=new u.DisposableStore,this._disposables.set(Ve,Ge)),ot=this._commands.toInternal(Je.command,Ge)),{text:Je.text,range:Je.range?y.Range.from(Je.range):void 0,command:ot,idx:tt}})}}disposeCompletions(Q){this._cache.delete(Q);const ee=this._disposables.get(Q);ee&&ee.clear(),this._disposables.delete(Q)}handleDidShowCompletionItem(Q,ee){const re=this._cache.get(Q,ee);re&&N.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class N{constructor(){this._onDidShowCompletionItemEmitter=new w.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(Q){let ee=N.map.get(Q);return ee||(ee=new N,N.map.set(Q,ee)),ee}fireOnDidShowCompletionItem(Q){this._onDidShowCompletionItemEmitter.fire(Q)}}e.InlineCompletionController=N,N.map=new WeakMap;class G{constructor(Q,ee){this._documents=Q,this._provider=ee,this._cache=new p.Cache("SignatureHelp")}async provideSignatureHelp(Q,ee,re,he){const Z=this._documents.getDocument(Q),oe=y.Position.to(ee),be=this.reviveContext(re),Me=await this._provider.provideSignatureHelp(Z,oe,he,be);if(Me){const Ve=this._cache.add([Me]);return{...y.SignatureHelp.from(Me),id:Ve}}}reviveContext(Q){let ee;if(Q.activeSignatureHelp){const re=y.SignatureHelp.to(Q.activeSignatureHelp),he=this._cache.get(Q.activeSignatureHelp.id,0);he?(ee=he,ee.activeSignature=re.activeSignature,ee.activeParameter=re.activeParameter):ee=re}return{...Q,activeSignatureHelp:ee}}releaseSignatureHelp(Q){this._cache.delete(Q)}}class ${constructor(Q,ee){this._documents=Q,this._provider=ee}async provideInlayHints(Q,ee,re){const he=this._documents.getDocument(Q),Z=await this._provider.provideInlayHints(he,y.Range.to(ee),re);return Z?{hints:Z.map(y.InlayHint.from)}:void 0}}class H{constructor(Q,ee){this._documents=Q,this._provider=ee,this._cache=new p.Cache("DocumentLink")}async provideLinks(Q,ee){const re=this._documents.getDocument(Q),he=await this._provider.provideDocumentLinks(re,ee);if(!(!Array.isArray(he)||he.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:he.filter(H._validateLink).map(y.DocumentLink.from)};{const Z=this._cache.add(he),oe={links:[],id:Z};for(let be=0;be<he.length;be++){if(!H._validateLink(he[be]))continue;const Me=y.DocumentLink.from(he[be]);Me.cacheId=[Z,be],oe.links.push(Me)}return oe}}}static _validateLink(Q){return Q.target&&Q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(Q,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...Q);if(!re)return;const he=await this._provider.resolveDocumentLink(re,ee);if(!(!he||!H._validateLink(he)))return y.DocumentLink.from(he)}releaseLinks(Q){this._cache.delete(Q)}}class j{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideColors(Q,ee){const re=this._documents.getDocument(Q),he=await this._provider.provideDocumentColors(re,ee);return Array.isArray(he)?he.map(oe=>({color:y.Color.from(oe.color),range:y.Range.from(oe.range)})):[]}async provideColorPresentations(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Range.to(ee.range),oe=y.Color.to(ee.color),be=await this._provider.provideColorPresentations(oe,{document:he,range:Z},re);if(!!Array.isArray(be))return be.map(y.ColorPresentation.from)}}class ie{constructor(Q,ee){this._documents=Q,this._provider=ee}async provideFoldingRanges(Q,ee,re){const he=this._documents.getDocument(Q),Z=await this._provider.provideFoldingRanges(he,ee,re);if(!!Array.isArray(Z))return Z.map(y.FoldingRange.from)}}class fe{constructor(Q,ee,re){this._documents=Q,this._provider=ee,this._logService=re}async provideSelectionRanges(Q,ee,re){const he=this._documents.getDocument(Q),Z=ee.map(y.Position.to),oe=await this._provider.provideSelectionRanges(he,Z,re);if(!(0,D.isNonEmptyArray)(oe))return[];if(oe.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const be=[];for(let Me=0;Me<Z.length;Me++){const Ve=[];be.push(Ve);let Ge=Z[Me],Je=oe[Me];for(;;){if(!Je.range.contains(Ge))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(y.SelectionRange.from(Je)),!Je.parent)break;Ge=Je.range,Je=Je.parent}}return be}}class ye{constructor(Q,ee){this._documents=Q,this._provider=ee,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.prepareCallHierarchy(he,Z,re);if(!oe)return;const be=this._idPool.nextId();return this._cache.set(be,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(be,Me)):[this._cacheAndConvertItem(be,oe)]}async provideCallsTo(Q,ee,re){const he=this._itemFromCache(Q,ee);if(!he)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(he,re);if(!!Z)return Z.map(oe=>({from:this._cacheAndConvertItem(Q,oe.from),fromRanges:oe.fromRanges.map(be=>y.Range.from(be))}))}async provideCallsFrom(Q,ee,re){const he=this._itemFromCache(Q,ee);if(!he)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(he,re);if(!!Z)return Z.map(oe=>({to:this._cacheAndConvertItem(Q,oe.to),fromRanges:oe.fromRanges.map(be=>y.Range.from(be))}))}releaseSession(Q){this._cache.delete(Q)}_cacheAndConvertItem(Q,ee){const re=this._cache.get(Q),he=y.CallHierarchyItem.from(ee,Q,re.size.toString(36));return re.set(he._itemId,ee),he}_itemFromCache(Q,ee){return this._cache.get(Q)?.get(ee)}}class Ie{constructor(Q,ee){this._documents=Q,this._provider=ee,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(Q,ee,re){const he=this._documents.getDocument(Q),Z=y.Position.to(ee),oe=await this._provider.prepareTypeHierarchy(he,Z,re);if(!oe)return;const be=this._idPool.nextId();return this._cache.set(be,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(be,Me)):[this._cacheAndConvertItem(be,oe)]}async provideSupertypes(Q,ee,re){const he=this._itemFromCache(Q,ee);if(!he)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(he,re);if(!!Z)return Z.map(oe=>this._cacheAndConvertItem(Q,oe))}async provideSubtypes(Q,ee,re){const he=this._itemFromCache(Q,ee);if(!he)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(he,re);if(!!Z)return Z.map(oe=>this._cacheAndConvertItem(Q,oe))}releaseSession(Q){this._cache.delete(Q)}_cacheAndConvertItem(Q,ee){const re=this._cache.get(Q),he=y.TypeHierarchyItem.from(ee,Q,re.size.toString(36));return re.set(he._itemId,ee),he}_itemFromCache(Q,ee){return this._cache.get(Q)?.get(ee)}}class Be{constructor(Q,ee){this.adapter=Q,this.extension=ee}}class We{constructor(Q,ee,re,he,Z,oe,be){this._adapter=new Map,this._uriTransformer=ee,this._proxy=Q.getProxy(i.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=he,this._diagnostics=Z,this._logService=oe,this._apiDeprecation=be}_transformDocumentSelector(Q){return y.DocumentSelector.from(Q,this._uriTransformer)}_createDisposable(Q){return new C.Disposable(()=>{this._adapter.delete(Q),this._proxy.$unregister(Q)})}_nextHandle(){return We._handlePool++}_withAdapter(Q,ee,re,he,Z=!1){const oe=this._adapter.get(Q);if(!oe)return Promise.resolve(he);if(oe.adapter instanceof ee){let be;oe.extension&&(be=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=re(oe.adapter,oe.extension),Ve=oe.extension;return Ve&&Promise.resolve(Me).then(()=>this._logService.trace(`[${Ve.identifier.value}] provider DONE after ${Date.now()-be}ms`),Ge=>{Z&&Ge instanceof I.CancellationError||(this._logService.error(`[${Ve.identifier.value}] provider FAILED`),this._logService.error(Ge))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(Q,ee){const re=this._nextHandle();return this._adapter.set(re,new Be(Q,ee)),re}static _extLabel(Q){return Q.displayName||Q.name}registerDocumentSymbolProvider(Q,ee,re,he){const Z=this._addNewAdapter(new a(this._documents,re),Q),oe=he&&he.label||We._extLabel(Q);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(ee),oe),this._createDisposable(Z)}$provideDocumentSymbols(Q,ee,re){return this._withAdapter(Q,a,he=>he.provideDocumentSymbols(m.URI.revive(ee),re),void 0)}registerCodeLensProvider(Q,ee,re){const he=this._nextHandle(),Z=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(he,new Be(new r(this._documents,this._commands.converter,re),Q)),this._proxy.$registerCodeLensSupport(he,this._transformDocumentSelector(ee),Z);let oe=this._createDisposable(he);if(Z!==void 0){const be=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Z));oe=C.Disposable.from(oe,be)}return oe}$provideCodeLenses(Q,ee,re){return this._withAdapter(Q,r,he=>he.provideCodeLenses(m.URI.revive(ee),re),void 0)}$resolveCodeLens(Q,ee,re){return this._withAdapter(Q,r,he=>he.resolveCodeLens(ee,re),void 0)}$releaseCodeLenses(Q,ee){this._withAdapter(Q,r,re=>Promise.resolve(re.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(Q,ee,re){const he=this._addNewAdapter(new o(this._documents,re),Q);return this._proxy.$registerDefinitionSupport(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideDefinition(Q,ee,re,he){return this._withAdapter(Q,o,Z=>Z.provideDefinition(m.URI.revive(ee),re,he),[])}registerDeclarationProvider(Q,ee,re){const he=this._addNewAdapter(new _(this._documents,re),Q);return this._proxy.$registerDeclarationSupport(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideDeclaration(Q,ee,re,he){return this._withAdapter(Q,_,Z=>Z.provideDeclaration(m.URI.revive(ee),re,he),[])}registerImplementationProvider(Q,ee,re){const he=this._addNewAdapter(new n(this._documents,re),Q);return this._proxy.$registerImplementationSupport(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideImplementation(Q,ee,re,he){return this._withAdapter(Q,n,Z=>Z.provideImplementation(m.URI.revive(ee),re,he),[])}registerTypeDefinitionProvider(Q,ee,re){const he=this._addNewAdapter(new t(this._documents,re),Q);return this._proxy.$registerTypeDefinitionSupport(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideTypeDefinition(Q,ee,re,he){return this._withAdapter(Q,t,Z=>Z.provideTypeDefinition(m.URI.revive(ee),re,he),[])}registerHoverProvider(Q,ee,re,he){const Z=this._addNewAdapter(new s(this._documents,re),Q);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideHover(Q,ee,re,he){return this._withAdapter(Q,s,Z=>Z.provideHover(m.URI.revive(ee),re,he),void 0)}registerEvaluatableExpressionProvider(Q,ee,re,he){const Z=this._addNewAdapter(new d(this._documents,re),Q);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideEvaluatableExpression(Q,ee,re,he){return this._withAdapter(Q,d,Z=>Z.provideEvaluatableExpression(m.URI.revive(ee),re,he),void 0)}registerInlineValuesProvider(Q,ee,re,he){const Z=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new c(this._documents,re),Q);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(ee),Z);let be=this._createDisposable(oe);if(Z!==void 0){const Me=re.onDidChangeInlineValues(Ve=>this._proxy.$emitInlineValuesEvent(Z));be=C.Disposable.from(be,Me)}return be}$provideInlineValues(Q,ee,re,he,Z){return this._withAdapter(Q,c,oe=>oe.provideInlineValues(m.URI.revive(ee),re,he,Z),void 0)}registerDocumentHighlightProvider(Q,ee,re){const he=this._addNewAdapter(new f(this._documents,re),Q);return this._proxy.$registerDocumentHighlightProvider(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideDocumentHighlights(Q,ee,re,he){return this._withAdapter(Q,f,Z=>Z.provideDocumentHighlights(m.URI.revive(ee),re,he),void 0)}registerLinkedEditingRangeProvider(Q,ee,re){const he=this._addNewAdapter(new l(this._documents,re),Q);return this._proxy.$registerLinkedEditingRangeProvider(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideLinkedEditingRanges(Q,ee,re,he){return this._withAdapter(Q,l,async Z=>{const oe=await Z.provideLinkedEditingRanges(m.URI.revive(ee),re,he);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?We._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(Q,ee,re){const he=this._addNewAdapter(new b(this._documents,re),Q);return this._proxy.$registerReferenceSupport(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideReferences(Q,ee,re,he,Z){return this._withAdapter(Q,b,oe=>oe.provideReferences(m.URI.revive(ee),re,he,Z),void 0)}registerCodeActionProvider(Q,ee,re,he){const Z=new u.DisposableStore,oe=this._addNewAdapter(new T(this._documents,this._commands.converter,this._diagnostics,re,this._logService,Q,this._apiDeprecation),Q);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(ee),{providedKinds:he?.providedCodeActionKinds?.map(be=>be.value),documentation:he?.documentation?.map(be=>({kind:be.kind.value,command:this._commands.converter.toInternal(be.command,Z)}))},We._extLabel(Q),Boolean(re.resolveCodeAction)),Z.add(this._createDisposable(oe)),Z}$provideCodeActions(Q,ee,re,he,Z){return this._withAdapter(Q,T,oe=>oe.provideCodeActions(m.URI.revive(ee),re,he,Z),void 0)}$resolveCodeAction(Q,ee,re){return this._withAdapter(Q,T,he=>he.resolveCodeAction(ee,re),void 0)}$releaseCodeActions(Q,ee){this._withAdapter(Q,T,re=>Promise.resolve(re.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(Q,ee,re){const he=this._addNewAdapter(new A(this._documents,re),Q);return this._proxy.$registerDocumentFormattingSupport(he,this._transformDocumentSelector(ee),Q.identifier,Q.displayName||Q.name),this._createDisposable(he)}$provideDocumentFormattingEdits(Q,ee,re,he){return this._withAdapter(Q,A,Z=>Z.provideDocumentFormattingEdits(m.URI.revive(ee),re,he),void 0)}registerDocumentRangeFormattingEditProvider(Q,ee,re){const he=this._addNewAdapter(new U(this._documents,re),Q);return this._proxy.$registerRangeFormattingSupport(he,this._transformDocumentSelector(ee),Q.identifier,Q.displayName||Q.name),this._createDisposable(he)}$provideDocumentRangeFormattingEdits(Q,ee,re,he,Z){return this._withAdapter(Q,U,oe=>oe.provideDocumentRangeFormattingEdits(m.URI.revive(ee),re,he,Z),void 0)}registerOnTypeFormattingEditProvider(Q,ee,re,he){const Z=this._addNewAdapter(new B(this._documents,re),Q);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(ee),he,Q.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(Q,ee,re,he,Z,oe){return this._withAdapter(Q,B,be=>be.provideOnTypeFormattingEdits(m.URI.revive(ee),re,he,Z,oe),void 0)}registerWorkspaceSymbolProvider(Q,ee){const re=this._addNewAdapter(new L(ee,this._logService),Q);return this._proxy.$registerNavigateTypeSupport(re,typeof ee.resolveWorkspaceSymbol=="function"),this._createDisposable(re)}$provideWorkspaceSymbols(Q,ee,re){return this._withAdapter(Q,L,he=>he.provideWorkspaceSymbols(ee,re),{symbols:[]})}$resolveWorkspaceSymbol(Q,ee,re){return this._withAdapter(Q,L,he=>he.resolveWorkspaceSymbol(ee,re),void 0)}$releaseWorkspaceSymbols(Q,ee){this._withAdapter(Q,L,re=>re.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(Q,ee,re){const he=this._addNewAdapter(new x(this._documents,re,this._logService),Q);return this._proxy.$registerRenameSupport(he,this._transformDocumentSelector(ee),x.supportsResolving(re)),this._createDisposable(he)}$provideRenameEdits(Q,ee,re,he,Z){return this._withAdapter(Q,x,oe=>oe.provideRenameEdits(m.URI.revive(ee),re,he,Z),void 0)}$resolveRenameLocation(Q,ee,re,he){return this._withAdapter(Q,x,Z=>Z.resolveRenameLocation(m.URI.revive(ee),re,he),void 0)}registerDocumentSemanticTokensProvider(Q,ee,re,he){const Z=this._nextHandle(),oe=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new Be(new V(this._documents,re),Q)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(ee),he,oe);let be=this._createDisposable(Z);if(oe){const Me=re.onDidChangeSemanticTokens(Ve=>this._proxy.$emitDocumentSemanticTokensEvent(oe));be=C.Disposable.from(be,Me)}return be}$provideDocumentSemanticTokens(Q,ee,re,he){return this._withAdapter(Q,V,Z=>Z.provideDocumentSemanticTokens(m.URI.revive(ee),re,he),null,!0)}$releaseDocumentSemanticTokens(Q,ee){this._withAdapter(Q,V,re=>re.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(Q,ee,re,he){const Z=this._addNewAdapter(new O(this._documents,re),Q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(ee),he),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(Q,ee,re,he){return this._withAdapter(Q,O,Z=>Z.provideDocumentRangeSemanticTokens(m.URI.revive(ee),re,he),null,!0)}registerCompletionItemProvider(Q,ee,re,he){const Z=this._addNewAdapter(new W(this._documents,this._commands.converter,re,this._apiDeprecation,Q),Q);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(ee),he,W.supportsResolving(re),`${Q.identifier.value}(${he.join("")})`),this._createDisposable(Z)}$provideCompletionItems(Q,ee,re,he,Z){return this._withAdapter(Q,W,oe=>oe.provideCompletionItems(m.URI.revive(ee),re,he,Z),void 0)}$resolveCompletionItem(Q,ee,re){return this._withAdapter(Q,W,he=>he.resolveCompletionItem(ee,re),void 0)}$releaseCompletionItems(Q,ee){this._withAdapter(Q,W,re=>re.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(Q,ee,re){const he=this._addNewAdapter(new q(this._documents,re,this._commands.converter),Q);return this._proxy.$registerInlineCompletionsSupport(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideInlineCompletions(Q,ee,re,he,Z){return this._withAdapter(Q,q,oe=>oe.provideInlineCompletions(m.URI.revive(ee),re,he,Z),void 0)}$handleInlineCompletionDidShow(Q,ee,re){this._withAdapter(Q,q,async he=>{he.handleDidShowCompletionItem(ee,re)},void 0)}$freeInlineCompletionsList(Q,ee){this._withAdapter(Q,q,async re=>{re.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(Q,ee,re,he){const Z=Array.isArray(he)?{triggerCharacters:he,retriggerCharacters:[]}:he,oe=this._addNewAdapter(new G(this._documents,re),Q);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(ee),Z),this._createDisposable(oe)}$provideSignatureHelp(Q,ee,re,he,Z){return this._withAdapter(Q,G,oe=>oe.provideSignatureHelp(m.URI.revive(ee),re,he,Z),void 0)}$releaseSignatureHelp(Q,ee){this._withAdapter(Q,G,re=>re.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(Q,ee,re){const he=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new $(this._documents,re),Q);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(ee),he);let oe=this._createDisposable(Z);if(he!==void 0){const be=re.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(he));oe=C.Disposable.from(oe,be)}return oe}$provideInlayHints(Q,ee,re,he){return this._withAdapter(Q,$,Z=>Z.provideInlayHints(m.URI.revive(ee),re,he),void 0)}registerDocumentLinkProvider(Q,ee,re){const he=this._addNewAdapter(new H(this._documents,re),Q);return this._proxy.$registerDocumentLinkProvider(he,this._transformDocumentSelector(ee),typeof re.resolveDocumentLink=="function"),this._createDisposable(he)}$provideDocumentLinks(Q,ee,re){return this._withAdapter(Q,H,he=>he.provideLinks(m.URI.revive(ee),re),void 0)}$resolveDocumentLink(Q,ee,re){return this._withAdapter(Q,H,he=>he.resolveLink(ee,re),void 0)}$releaseDocumentLinks(Q,ee){this._withAdapter(Q,H,re=>re.releaseLinks(ee),void 0)}registerColorProvider(Q,ee,re){const he=this._addNewAdapter(new j(this._documents,re),Q);return this._proxy.$registerDocumentColorProvider(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideDocumentColors(Q,ee,re){return this._withAdapter(Q,j,he=>he.provideColors(m.URI.revive(ee),re),[])}$provideColorPresentations(Q,ee,re,he){return this._withAdapter(Q,j,Z=>Z.provideColorPresentations(m.URI.revive(ee),re,he),void 0)}registerFoldingRangeProvider(Q,ee,re){const he=this._nextHandle(),Z=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(he,new Be(new ie(this._documents,re),Q)),this._proxy.$registerFoldingRangeProvider(he,this._transformDocumentSelector(ee),Z);let oe=this._createDisposable(he);if(Z!==void 0){const be=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));oe=C.Disposable.from(oe,be)}return oe}$provideFoldingRanges(Q,ee,re,he){return this._withAdapter(Q,ie,Z=>Z.provideFoldingRanges(m.URI.revive(ee),re,he),void 0)}registerSelectionRangeProvider(Q,ee,re){const he=this._addNewAdapter(new fe(this._documents,re,this._logService),Q);return this._proxy.$registerSelectionRangeProvider(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$provideSelectionRanges(Q,ee,re,he){return this._withAdapter(Q,fe,Z=>Z.provideSelectionRanges(m.URI.revive(ee),re,he),[])}registerCallHierarchyProvider(Q,ee,re){const he=this._addNewAdapter(new ye(this._documents,re),Q);return this._proxy.$registerCallHierarchyProvider(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$prepareCallHierarchy(Q,ee,re,he){return this._withAdapter(Q,ye,Z=>Promise.resolve(Z.prepareSession(m.URI.revive(ee),re,he)),void 0)}$provideCallHierarchyIncomingCalls(Q,ee,re,he){return this._withAdapter(Q,ye,Z=>Z.provideCallsTo(ee,re,he),void 0)}$provideCallHierarchyOutgoingCalls(Q,ee,re,he){return this._withAdapter(Q,ye,Z=>Z.provideCallsFrom(ee,re,he),void 0)}$releaseCallHierarchy(Q,ee){this._withAdapter(Q,ye,re=>Promise.resolve(re.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(Q,ee,re){const he=this._addNewAdapter(new Ie(this._documents,re),Q);return this._proxy.$registerTypeHierarchyProvider(he,this._transformDocumentSelector(ee)),this._createDisposable(he)}$prepareTypeHierarchy(Q,ee,re,he){return this._withAdapter(Q,Ie,Z=>Promise.resolve(Z.prepareSession(m.URI.revive(ee),re,he)),void 0)}$provideTypeHierarchySupertypes(Q,ee,re,he){return this._withAdapter(Q,Ie,Z=>Z.provideSupertypes(ee,re,he),void 0)}$provideTypeHierarchySubtypes(Q,ee,re,he){return this._withAdapter(Q,Ie,Z=>Z.provideSubtypes(ee,re,he),void 0)}$releaseTypeHierarchy(Q,ee){this._withAdapter(Q,Ie,re=>Promise.resolve(re.releaseSession(ee)),void 0)}static _serializeRegExp(Q){return{pattern:Q.source,flags:(0,k.regExpFlags)(Q)}}static _serializeIndentationRule(Q){return{decreaseIndentPattern:We._serializeRegExp(Q.decreaseIndentPattern),increaseIndentPattern:We._serializeRegExp(Q.increaseIndentPattern),indentNextLinePattern:Q.indentNextLinePattern?We._serializeRegExp(Q.indentNextLinePattern):void 0,unIndentedLinePattern:Q.unIndentedLinePattern?We._serializeRegExp(Q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(Q){return{beforeText:We._serializeRegExp(Q.beforeText),afterText:Q.afterText?We._serializeRegExp(Q.afterText):void 0,previousLineText:Q.previousLineText?We._serializeRegExp(Q.previousLineText):void 0,action:Q.action}}static _serializeOnEnterRules(Q){return Q.map(We._serializeOnEnterRule)}setLanguageConfiguration(Q,ee,re){let{wordPattern:he}=re;if(he&&(0,k.regExpLeadsToEndlessLoop)(he))throw new Error(`Invalid language configuration: wordPattern '${he}' is not allowed to match the empty string.`);he?this._documents.setWordDefinitionFor(ee,he):this._documents.setWordDefinitionFor(ee,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",Q,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",Q,"Do not use.");const Z=this._nextHandle(),oe={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?We._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?We._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?We._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,ee,oe),this._createDisposable(Z)}$setWordDefinitions(Q){for(const ee of Q)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=We,We._handlePool=0}),define(pe[241],ve([0,1,5,17,7,48,18,6]),function(Y,e,m,F,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(R,P,u,E){this._documents=P,this._commands=u,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,P){await this._proxy.$changeLanguage(R,P);const u=this._documents.getDocumentData(R);if(!u)throw new Error(`document '${R.toString}' NOT found`);return u.document}async tokenAtPosition(R,P){const u=R.version,E=F.Position.from(P),h=await this._proxy.$tokensAtPosition(R.uri,E),p={type:y.StandardTokenType.Other,range:R.getWordRangeAtPosition(P)??new y.Range(P.line,P.character,P.line,P.character)};if(!h)return p;const v={range:F.Range.to(h.range),type:F.TokenType.to(h.type)};return!v.range.contains(P)||u!==R.version?p:v}createLanguageStatusItem(R,P,u){const E=this._handlePool++,h=this._proxy,p=this._ids,v=`${R.identifier.value}/${P}`;if(p.has(v))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);p.add(v);const I={selector:u,id:P,name:R.displayName??R.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let w,a=new k.DisposableStore;const r=()=>{w?.dispose(),w=(0,i.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(E,{id:v,name:I.name??R.displayName??R.name,source:R.displayName??R.name,selector:F.DocumentSelector.from(I.selector,this._uriTransformer),label:I.text,detail:I.detail??"",severity:I.severity===y.LanguageStatusSeverity.Error?C.default.Error:I.severity===y.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:I.command&&this._commands.toInternal(I.command,a),accessibilityInfo:I.accessibilityInformation,busy:I.busy})},0)},g={dispose(){a.dispose(),w?.dispose(),h.$removeLanguageStatus(E),p.delete(v)},get id(){return I.id},get name(){return I.name},set name(o){I.name=o,r()},get selector(){return I.selector},set selector(o){I.selector=o,r()},get text(){return I.text},set text(o){I.text=o,r()},get detail(){return I.detail},set detail(o){I.detail=o,r()},get severity(){return I.severity},set severity(o){I.severity=o,r()},get accessibilityInformation(){return I.accessibilityInformation},set accessibilityInformation(o){I.accessibilityInformation=o,r()},get command(){return I.command},set command(o){I.command=o,r()},get busy(){return I.busy},set busy(o){I.busy=o,r()}};return r(),g}}e.ExtHostLanguages=S}),define(pe[131],ve([0,1,11,5,26,14,3]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends m.AbstractLoggerService{constructor(R,P){const u=new i.Emitter;super(P.logLevel,u.event);this._proxy=R.getProxy(F.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(u)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,P,u){return new S(this._proxy,R,P,u)}};k=je([He(0,C.IExtHostRpcService),He(1,y.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class S extends m.AbstractMessageLogger{constructor(R,P,u,E){super(E?.always);this.proxy=R,this.file=P,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.proxy.$createLogger(P,E).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,P){const u=[[R,P]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(R){this.proxy.$log(this.file,R)}}}),define(pe[242],ve([0,1,5,11,29]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(k){return k&&k.title}let i=class{constructor(S,D){this._logService=D,this._proxy=S.getProxy(m.MainContext.MainThreadMessageService)}showMessage(S,D,R,P,u){const E={extension:S};let h;typeof P=="string"||C(P)?h=[P,...u]:(E.modal=P?.modal,E.useCustom=P?.useCustom,E.detail=P?.detail,h=u),E.useCustom&&(0,y.checkProposedApiEnabled)(S,"resolvers");const p=[];for(let v=0;v<h.length;v++){const I=h[v];if(typeof I=="string")p.push({title:I,handle:v,isCloseAffordance:!1});else if(typeof I=="object"){let{title:w,isCloseAffordance:a}=I;p.push({title:w,isCloseAffordance:!!a,handle:v})}else this._logService.warn("Invalid message item:",I)}return this._proxy.$showMessage(D,R,E,p).then(v=>{if(typeof v=="number")return h[v]})}};i=je([He(1,F.ILogService)],i),e.ExtHostMessageService=i}),define(pe[243],ve([0,1,22,3,47,6,24,8,13,2,87,5,17,7,53,218,128]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class I{constructor(a,r,g,o,_){this._textDocumentsAndEditors=g,this._textDocuments=o,this._extensionStoragePaths=_,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new i.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(P.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(P.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(P.MainContext.MainThreadNotebookEditors),this._commandsConverter=r.converter,r.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===12){const t=n.notebookEditor?.notebookUri,s=n.cell.handle,c=this._documents.get(t)?.getCell(s);if(c)return c.apiCell}return n}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const r=this._editors.get(a);if(!r)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return r}getIdByEditor(a){for(const[r,g]of this._editors)if(g.apiEditor===a)return r}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,r){const g=this._documents.get(a);if(!g&&!r)throw new Error(`NO notebook document for '${a}'`);return g}_getProviderData(a){const r=this._notebookContentProviders.get(a);if(!r)throw new Error(`NO provider for '${a}'`);return r}registerNotebookContentProvider(a,r,g,o,_){if((0,k.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(r))throw new Error(`Notebook provider for '${r}' already registered`);this._notebookContentProviders.set(r,{extension:a,provider:g});let n;return g.onDidChangeNotebookContentOptions&&(n=g.onDidChangeNotebookContentOptions(()=>{const t=u.NotebookDocumentContentOptions.from(g.options);this._notebookProxy.$updateNotebookProviderOptions(r,t)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},r,u.NotebookDocumentContentOptions.from(o),I._convertNotebookRegistrationData(a,_)),new E.Disposable(()=>{n?.dispose(),this._notebookContentProviders.delete(r),this._notebookProxy.$unregisterNotebookProvider(r)})}static _convertNotebookRegistrationData(a,r){if(!r)return;const g=r.filenamePattern.map(o=>u.NotebookExclusiveDocumentPattern.from(o)).filter(o=>o!==void 0);if(r.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${r.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:r.displayName,filenamePattern:g,exclusive:r.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,r,g){const o=I._notebookStatusBarItemProviderHandlePool++,_=typeof g.onDidChangeCellStatusBarItems=="function"?I._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(o,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(o,_,r);let n;return _!==void 0&&(n=g.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(_))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(o),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(o,_),n&&n.dispose()})}async createNotebookDocument(a){const r=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&u.NotebookData.from(a.content)});return D.URI.revive(r)}async openNotebookDocument(a){const r=this._documents.get(a);if(r)return r.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(a),o=this._documents.get(D.URI.revive(g));return(0,S.assertIsDefined)(o?.apiNotebook)}async showNotebookDocument(a,r){D.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let g;typeof r=="object"?g={position:u.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus,selections:r.selections&&r.selections.map(u.NotebookRange.from),pinned:typeof r.preview=="boolean"?!r.preview:void 0}:g={preserveFocus:!1};const o=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,g),_=o&&this._editors.get(o)?.apiEditor;if(_)return _;throw o?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,r,g,o){const _=this._notebookStatusBarItemProviders.get(a),n=D.URI.revive(r),t=this._documents.get(n);if(!t||!_)return;const s=t.getCellFromIndex(g);if(!s)return;const d=await _.provideCellStatusBarItems(s.apiCell,o);if(!d)return;const c=new C.DisposableStore,f=this._statusBarCache.add([c]),b=(Array.isArray(d)?d:[d]).map(T=>u.NotebookStatusBarItem.from(T,this._commandsConverter,c));return{cacheId:f,items:b}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,r,g,o,_){if((0,k.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,g),this._notebookProxy.$registerNotebookSerializer(n,{id:a.identifier,location:a.extensionLocation},r,u.NotebookDocumentContentOptions.from(o),I._convertNotebookRegistrationData(a,_)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(a,r,g){const o=this._notebookSerializer.get(a);if(!o)throw new Error("NO serializer found");const _=await o.deserializeNotebook(r.buffer,g);return new h.SerializableObjectWithBuffers(u.NotebookData.from(_))}async $notebookToData(a,r,g){const o=this._notebookSerializer.get(a);if(!o)throw new Error("NO serializer found");const _=await o.serializeNotebook(u.NotebookData.to(r.value),g);return m.VSBuffer.wrap(_)}async $openNotebook(a,r,g,o,_){const{provider:n}=this._getProviderData(a),t=await n.openNotebook(D.URI.revive(r),{backupId:g,untitledDocumentData:o?.buffer},_);return new h.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(u.NotebookCellData.from)})}async $saveNotebook(a,r,g){const o=this.getNotebookDocument(D.URI.revive(r)),{provider:_}=this._getProviderData(a);return await _.saveNotebook(o.apiNotebook,g),!0}async $saveNotebookAs(a,r,g,o){const _=this.getNotebookDocument(D.URI.revive(r)),{provider:n}=this._getProviderData(a);return await n.saveNotebookAs(D.URI.revive(g),_.apiNotebook,o),!0}async $backupNotebook(a,r,g){const o=this.getNotebookDocument(D.URI.revive(r)),_=this._getProviderData(a),n=this._extensionStoragePaths.workspaceValue(_.extension)??this._extensionStoragePaths.globalValue(_.extension),t=String((0,y.hash)([o.uri.toString(),this._backupIdPool++])),s=D.URI.joinPath(n,t),d=await _.provider.backupNotebook(o.apiNotebook,{destination:s},g);return o.updateBackup(d),d.id}_createExtHostEditor(a,r,g){if(this._editors.has(r))throw new Error(`editor with id ALREADY EXSIST: ${r}`);const o=new v.ExtHostNotebookEditor(r,this._notebookEditorsProxy,a,g.visibleRanges.map(u.NotebookRange.to),g.selections.map(u.NotebookRange.to),typeof g.viewColumn=="number"?u.ViewColumn.to(g.viewColumn):void 0);this._editors.set(r,o)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const g of a.value.removedDocuments){const o=D.URI.revive(g),_=this._documents.get(o);_&&(_.dispose(),this._documents.delete(o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:_.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(_.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===o.toString()&&this._editors.delete(n.id)}if(a.value.addedDocuments){const g=[];for(const o of a.value.addedDocuments){const _=D.URI.revive(o.uri);if(this._documents.has(_))throw new Error(`adding EXISTING notebook ${_} `);const n=this,t=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(s){n._onDidChangeNotebookCells.fire(s)},emitCellOutputsChange(s){n._onDidChangeCellOutputs.fire(s)},emitCellMetadataChange(s){n._onDidChangeCellMetadata.fire(s)},emitCellExecutionStateChange(s){n._onDidChangeCellExecutionState.fire(s)}},_,o);g.push(...o.cells.map(s=>p.ExtHostCell.asModelAddData(t.apiNotebook,s))),this._documents.get(_)?.dispose(),this._documents.set(_,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(a.value.addedEditors)for(const g of a.value.addedEditors){if(this._editors.has(g.id))return;const o=D.URI.revive(g.documentUri),_=this._documents.get(o);_&&this._createExtHostEditor(_,g.id,g)}const r=[];if(a.value.removedEditors)for(const g of a.value.removedEditors){const o=this._editors.get(g);o&&(this._editors.delete(g),this._activeNotebookEditor?.id===o.id&&(this._activeNotebookEditor=void 0),r.push(o))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(o=>this._editors.get(o)).filter(o=>!!o);const g=new Set;this._visibleNotebookEditors.forEach(o=>g.add(o.id));for(const o of this._editors.values()){const _=g.has(o.id);o._acceptVisibility(_)}this._visibleNotebookEditors=[...this._editors.values()].map(o=>o).filter(o=>o.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=I,I._notebookStatusBarItemProviderHandlePool=0}),define(pe[244],ve([0,1,3,75,11,5,14,17]),function(Y,e,m,F,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(P,u){const E=S._Keys.nextId();P.$registerNotebookEditorDecorationType(E,k.NotebookDecorationRenderOptions.from(u)),this.value={key:E,dispose(){P.$removeNotebookEditorDecorationType(E)}}}}S._Keys=new F.IdGenerator("NotebookEditorDecorationType");let D=class{constructor(P,u,E){this._logService=P,this._extHostRpc=u,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(P){return new S(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),P).value}$acceptEditorPropertiesChanged(P,u){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,u);const E=this._notebooksAndEditors.getEditorById(P);u.visibleRanges&&E._acceptVisibleRanges(u.visibleRanges.ranges.map(k.NotebookRange.to)),u.selections&&E._acceptSelections(u.selections.selections.map(k.NotebookRange.to)),u.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),u.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const u in P)this._notebooksAndEditors.getEditorById(u)._acceptViewColumn(k.ViewColumn.to(P[u]))}};D=je([He(0,y.ILogService),He(1,i.IExtHostRpcService)],D),e.ExtHostNotebookEditors=D}),define(pe[245],ve([0,1,16,18,21,3,6,24,2,27,11,5,38,17,7,88,210,29,53]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let a=class{constructor(n,t,s,d,c){this._initData=t,this._extHostNotebook=s,this._commands=d,this._logService=c,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=n.getProxy(P.MainContext.MainThreadNotebookKernels);const f=new u.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.ApiCommandArgument("options","Select kernel options",l=>!0,l=>{if(l&&"notebookEditor"in l&&"id"in l){const b=this._extHostNotebook.getIdByEditor(l.notebookEditor);return{id:l.id,extension:l.extension,notebookEditorId:b}}else if(l&&"notebookEditor"in l){const b=this._extHostNotebook.getIdByEditor(l.notebookEditor);if(b===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${l.notebookEditor.document.uri.toString()}`);return{notebookEditorId:b}}return l})],u.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(n,t,s,d,c,f){for(let G of this._kernelData.values())if(G.controller.id===t&&D.ExtensionIdentifier.equals(n.identifier,G.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const l=this._handlePool++,b=this;this._logService.trace(`NotebookController[${l}], CREATED by ${n.identifier.value}, ${t}`);const T=()=>console.warn(`NO execute handler from notebook controller '${x.id}' of extension: '${n.identifier}'`);let A=!1;const U=new i.DisposableStore,B=new C.Emitter,L=new C.Emitter,x={id:`${n.identifier.value}/${t}`,notebookType:s,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:d||n.identifier.value,preloads:f?f.map(E.NotebookRendererScript.from):[]};let M=c??T,V;this._proxy.$addKernel(l,x).catch(G=>{console.log(G),A=!0});let O=0;const W=()=>{if(A)return;const G=++O;Promise.resolve().then(()=>{G===O&&this._proxy.$updateKernel(l,x)})},q=new k.ResourceMap,N={get id(){return t},get notebookType(){return x.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return x.label},set label(G){x.label=G??n.displayName??n.name,W()},get detail(){return x.detail??""},set detail(G){x.detail=G,W()},get description(){return x.description??""},set description(G){x.description=G,W()},get kind(){return(0,I.checkProposedApiEnabled)(n,"notebookControllerKind"),x.kind??""},set kind(G){(0,I.checkProposedApiEnabled)(n,"notebookControllerKind"),x.kind=G,W()},get supportedLanguages(){return x.supportedLanguages},set supportedLanguages(G){x.supportedLanguages=G,W()},get supportsExecutionOrder(){return x.supportsExecutionOrder??!1},set supportsExecutionOrder(G){x.supportsExecutionOrder=G,W()},get rendererScripts(){return x.preloads?x.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return M},set executeHandler(G){M=G??T},get interruptHandler(){return V},set interruptHandler(G){V=G,x.supportsInterrupt=Boolean(G),W()},createNotebookCellExecution(G){if(A)throw new Error("notebook controller is DISPOSED");if(!q.has(G.notebook.uri))throw b._logService.trace(`NotebookController[${l}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(q.keys()).map($=>$.toString())),new Error(`notebook controller is NOT associated to notebook: ${G.notebook.uri.toString()}`);return b._createNotebookCellExecution(G)},dispose:()=>{A||(this._logService.trace(`NotebookController[${l}], DISPOSED`),A=!0,this._kernelData.delete(l),U.dispose(),B.dispose(),L.dispose(),this._proxy.$removeKernel(l))},updateNotebookAffinity(G,$){b._proxy.$updateNotebookPriority(l,G.uri,$)},onDidReceiveMessage:L.event,postMessage(G,$){return(0,I.checkProposedApiEnabled)(n,"notebookMessaging"),b._proxy.$postMessage(l,$&&b._extHostNotebook.getIdByEditor($),G)},asWebviewUri(G){return(0,I.checkProposedApiEnabled)(n,"notebookMessaging"),(0,p.asWebviewUri)(G,b._initData.remote)}};return this._kernelData.set(l,{extensionId:n.identifier,controller:N,onDidReceiveMessage:L,onDidChangeSelection:B,associatedNotebooks:q}),N}$acceptNotebookAssociation(n,t,s){const d=this._kernelData.get(n);if(d){const c=this._extHostNotebook.getNotebookDocument(S.URI.revive(t));s?d.associatedNotebooks.set(c.uri,!0):d.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,c.uri.toString(),s),d.onDidChangeSelection.fire({selected:s,notebook:c.apiNotebook})}}async $executeCells(n,t,s){const d=this._kernelData.get(n);if(!d)return;const c=this._extHostNotebook.getNotebookDocument(S.URI.revive(t)),f=[];for(let l of s){const b=c.getCell(l);b&&f.push(b.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,c.uri.toString(),f.length),await d.controller.executeHandler.call(d.controller,f,c.apiNotebook,d.controller)}catch(l){this._logService.error(`NotebookController[${n}] execute cells FAILED`,l),console.error(l)}}async $cancelCells(n,t,s){const d=this._kernelData.get(n);if(!d)return;const c=this._extHostNotebook.getNotebookDocument(S.URI.revive(t));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,c.apiNotebook);else for(let f of s){const l=c.getCell(f);l&&this._activeExecutions.get(l.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,t,s){const d=this._kernelData.get(n);if(!d)return;const c=this._extHostNotebook.getEditorById(t);d.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:s}))}_createNotebookCellExecution(n){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const d=new g(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,d);const c=d.onDidChangeState(()=>{d.state===r.Resolved&&(d.dispose(),c.dispose(),this._activeExecutions.delete(s.uri))});return d.asApiObject()}};a=je([He(4,R.ILogService)],a),e.ExtHostNotebookKernels=a;var r;(function(_){_[_.Init=0]="Init",_[_.Started=1]="Started",_[_.Resolved=2]="Resolved"})(r||(r={}));class g extends i.Disposable{constructor(n,t,s){super();this._document=n,this._cell=t,this._proxy=s,this._handle=g.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._collector=new o(10,d=>this.update(d)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const t=Array.isArray(n)?n:[n];return this._proxy.$updateExecutions(new w.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let t=this._cell;if(n&&(t=this._document.getCellFromApiCell(n)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(n){return n.map(t=>{const s=h.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return s===t.items?E.NotebookCellOutput.from(t):E.NotebookCellOutput.from({items:s,id:t.id,metadata:t.metadata})})}async updateOutputs(n,t,s){const d=this.cellIndexToHandle(t),c=this.validateAndConvertOutputs((0,m.asArray)(n));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:d,append:s,outputs:c})}async updateOutputItems(n,t,s){return n=h.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(n),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:n.map(E.NotebookCellOutputItem.from),outputId:t.id,append:s})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(s){n._executionOrder=s,n.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,executionOrder:n._executionOrder}])},start(s){if(n._state===r.Resolved||n._state===r.Started)throw new Error("Cannot call start again");n._state=r.Started,n._onDidChangeState.fire(),n.update({editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,runStartTime:s})},end(s,d){if(n._state===r.Resolved)throw new Error("Cannot call resolve twice");n._state=r.Resolved,n._onDidChangeState.fire(),n.updateSoon({editType:v.CellExecutionUpdateType.Complete,executionHandle:n._handle,runEndTime:d,lastRunSuccess:s}),n._collector.flush(),n._proxy.$removeExecution(n._handle)},clearOutput(s){return n.verifyStateForOutput(),n.updateOutputs([],s,!1)},appendOutput(s,d){return n.verifyStateForOutput(),n.updateOutputs(s,d,!0)},replaceOutput(s,d){return n.verifyStateForOutput(),n.updateOutputs(s,d,!1)},appendOutputItems(s,d){return n.verifyStateForOutput(),n.updateOutputItems(s,d,!0)},replaceOutputItems(s,d){return n.verifyStateForOutput(),n.updateOutputItems(s,d,!1)}})}}g.HANDLE=0;class o{constructor(n,t){this.delay=n,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new F.DeferredPromise,this.startedTimer=Date.now(),(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>n.complete())}}}),define(pe[246],ve([0,1,3,5,128,29]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class i{constructor(S,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,D,R){const P=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(D)?.fire({editor:P.apiEditor,message:R})}createRendererMessaging(S,D){if(!S.contributes?.notebookRenderer?.some(E=>E.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);const R=(0,C.isProposedApiEnabled)(S,"notebookEditor"),P=new WeakMap;return{onDidReceiveMessage:(E,h,p)=>{const v=R?E:I=>{const w={};P.set(w,I.editor),E({editor:w,message:I.message})};return this.getOrCreateEmitterFor(D).event(v,h,p)},postMessage:(E,h)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(E)&&([E,h]=[h,E]);const p=R?h:P.get(h),v=p&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(p);return this.proxy.$postMessage(v?.id,D,E)}}}getOrCreateEmitterFor(S){let D=this._rendererMessageEmitters.get(S);return D||(D=new m.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,D),D)}}e.ExtHostNotebookRenderers=i}),define(pe[132],ve([0,1,5,6,4,14,11,211,66,26,44,151,22]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class E extends F.Disposable{constructor(v,I,w,a){super();this.id=v,this.name=I,this.logger=w,this.proxy=a,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(v){this.append(v+`
`)}append(v){this.write(v),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const v=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,v)}replace(v){const I=this.offset;this.write(v),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,I),this.visible&&this.logger.flush()}show(v,I){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof v=="boolean"?v:I))}hide(){this.proxy.$close(this.id)}write(v){this.offset+=u.VSBuffer.fromString(v).byteLength,this.logger.info(v)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=E;let h=class{constructor(v,I,w,a,r){this.extHostFileSystem=w,this.extHostFileSystemInfo=a,this.loggerService=r,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=v.getProxy(m.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(I.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.visibleChannelId=v;for(const[I,w]of this.channels)w.visible=I===this.visibleChannelId}createOutputChannel(v,I){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const w=this.doCreateOutputChannel(v,I);return w.then(a=>{this.channels.set(a.id,a),a.visible=a.id===this.visibleChannelId}),this.createExtHostOutputChannel(v,w)}async doCreateOutputChannel(v,I){const w=await this.createOutputDirectory(),a=this.extHostFileSystemInfo.extUri.joinPath(w,`${this.namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.loggerService.createLogger(a,{always:!0,donotRotate:!0,donotUseFormatters:!0}),g=await this.proxy.$register(v,!1,a,I.identifier.value);return new E(g,v,r,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(v,I){let w=!1;const a=()=>{if(w)throw new Error("Channel has been closed")};return{get name(){return v},append(r){a(),I.then(g=>g.append(r))},appendLine(r){a(),I.then(g=>g.appendLine(r))},clear(){a(),I.then(r=>r.clear())},replace(r){a(),I.then(g=>g.replace(r))},show(r,g){a(),I.then(o=>o.show(r,g))},hide(){a(),I.then(r=>r.hide())},dispose(){w=!0,I.then(r=>r.dispose())}}}};h=je([He(0,C.IExtHostRpcService),He(1,D.IExtHostInitDataService),He(2,S.IExtHostConsumerFileSystem),He(3,R.IExtHostFileSystemInfo),He(4,i.ILoggerService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(pe[247],ve([0,1,18,21,3,6,5,2,7,15,16,48,86,29]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(p,v,I){const w=p.getProxy(i.MainContext.MainThreadQuickOpen);class a{constructor(c,f){this._sessions=new Map,this._instances=0,this._workspace=c,this._commands=f}showQuickPick(c,f,l=F.CancellationToken.None){this._onDidSelectItem=void 0;const b=Promise.resolve(c),T=++this._instances,A=w.$show(T,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},l),U={},B=A.then(()=>U);return Promise.race([B,b]).then(L=>{if(L!==U)return b.then(x=>{const M=[];for(let V=0;V<x.length;V++){const O=x[V];typeof O=="string"?M.push({label:O,handle:V}):O.kind===S.QuickPickItemKind.Separator?M.push({type:"separator",label:O.label}):M.push({label:O.label,description:O.description,detail:O.detail,picked:O.picked,alwaysShow:O.alwaysShow,handle:V})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=V=>{f.onDidSelectItem(x[V])}),w.$setItems(T,M),A.then(V=>{if(typeof V=="number")return x[V];if(Array.isArray(V))return V.map(O=>x[O])})})}).then(void 0,L=>{if(!(0,D.isPromiseCanceledError)(L))return w.$setError(T,L),Promise.reject(L)})}$onItemSelected(c){this._onDidSelectItem&&this._onDidSelectItem(c)}showInput(c,f=F.CancellationToken.None){return this._validateInput=c?c.validateInput:void 0,w.$input(c,typeof this._validateInput=="function",f).then(void 0,l=>{if(!(0,D.isPromiseCanceledError)(l))return Promise.reject(l)})}$validateInput(c){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(c)):Promise.resolve(void 0)}async showWorkspaceFolderPick(c,f=F.CancellationToken.None){const l=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!l)return;const b=await this._workspace.getWorkspaceFolders2();if(!!b)return b.find(T=>T.uri.toString()===l.uri.toString())}createQuickPick(c){const f=new t(c,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(c){const f=new s(c,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}$onDidChangeValue(c,f){const l=this._sessions.get(c);l&&l._fireDidChangeValue(f)}$onDidAccept(c){const f=this._sessions.get(c);f&&f._fireDidAccept()}$onDidChangeActive(c,f){const l=this._sessions.get(c);l instanceof t&&l._fireDidChangeActive(f)}$onDidChangeSelection(c,f){const l=this._sessions.get(c);l instanceof t&&l._fireDidChangeSelection(f)}$onDidTriggerButton(c,f){const l=this._sessions.get(c);l&&l._fireDidTriggerButton(f)}$onDidTriggerItemButton(c,f,l){const b=this._sessions.get(c);b instanceof t&&b._fireDidTriggerItemButton(f,l)}$onDidHide(c){const f=this._sessions.get(c);f&&f._fireDidHide()}}class r{constructor(c,f){this._extensionId=c,this._onDidDispose=f,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new y.Emitter,this._onDidChangeValueEmitter=new y.Emitter,this._onDidTriggerButtonEmitter=new y.Emitter,this._onDidHideEmitter=new y.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(c){this._title=c,this.update({title:c})}get step(){return this._steps}set step(c){this._steps=c,this.update({step:c})}get totalSteps(){return this._totalSteps}set totalSteps(c){this._totalSteps=c,this.update({totalSteps:c})}get enabled(){return this._enabled}set enabled(c){this._enabled=c,this.update({enabled:c})}get busy(){return this._busy}set busy(c){this._busy=c,this.update({busy:c})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(c){this._ignoreFocusOut=c,this.update({ignoreFocusOut:c})}get value(){return this._value}set value(c){this._value=c,this.update({value:c})}get placeholder(){return this._placeholder}set placeholder(c){this._placeholder=c,this.update({placeholder:c})}get buttons(){return this._buttons}set buttons(c){this._buttons=c.slice(),this._handlesToButtons.clear(),c.forEach((f,l)=>{const b=f===S.QuickInputButtons.Back?-1:l;this._handlesToButtons.set(b,f)}),this.update({buttons:c.map((f,l)=>({...n(f),tooltip:f.tooltip,handle:f===S.QuickInputButtons.Back?-1:l}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(c){this._value=c,this._onDidChangeValueEmitter.fire(c)}_fireDidTriggerButton(c){const f=this._handlesToButtons.get(c);f&&this._onDidTriggerButtonEmitter.fire(f)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),w.$dispose(this._id))}update(c){if(!this._disposed){for(const f of Object.keys(c)){const l=c[f];this._pendingUpdate[f]=l===void 0?null:l}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){w.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}r._nextId=1;function g(d){if(d instanceof S.ThemeIcon)return{id:d.id};const c=_(d),f=o(d);return{dark:typeof c=="string"?k.URI.file(c):c,light:typeof f=="string"?k.URI.file(f):f}}function o(d){return typeof d=="object"&&"light"in d?d.light:d}function _(d){return typeof d=="object"&&"dark"in d?d.dark:d}function n(d){const c=g(d.iconPath);let f,l;return"id"in c?l=u.ThemeIcon.asClassName(c):f=c,{iconPath:f,iconClass:l}}class t extends r{constructor(c,f){super(c.identifier,f);this.extension=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new y.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new y.Emitter,this._onDidTriggerItemButtonEmitter=new y.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(c){c.some(l=>l.kind!==void 0)&&(0,E.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=c.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),c.forEach((l,b)=>{this._handlesToItems.set(b,l),this._itemsToHandles.set(l,b)});const f=[];for(let l=0;l<c.length;l++){const b=c[l];b.kind===S.QuickPickItemKind.Separator?f.push({type:"separator",label:b.label}):f.push({handle:l,label:b.label,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,buttons:b.buttons?.map((T,A)=>({...n(T),tooltip:T.tooltip,handle:A}))})}this.update({items:f})}get canSelectMany(){return this._canSelectMany}set canSelectMany(c){this._canSelectMany=c,this.update({canSelectMany:c})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(c){this._matchOnDescription=c,this.update({matchOnDescription:c})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(c){this._matchOnDetail=c,this.update({matchOnDetail:c})}get sortByLabel(){return this._sortByLabel}set sortByLabel(c){this._sortByLabel=c,this.update({sortByLabel:c})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(c){this._keepScrollPosition=c,this.update({keepScrollPosition:c})}get activeItems(){return this._activeItems}set activeItems(c){this._activeItems=c.filter(f=>this._itemsToHandles.has(f)),this.update({activeItems:this._activeItems.map(f=>this._itemsToHandles.get(f))})}get selectedItems(){return this._selectedItems}set selectedItems(c){this._selectedItems=c.filter(f=>this._itemsToHandles.has(f)),this.update({selectedItems:this._selectedItems.map(f=>this._itemsToHandles.get(f))})}_fireDidChangeActive(c){const f=(0,R.coalesce)(c.map(l=>this._handlesToItems.get(l)));this._activeItems=f,this._onDidChangeActiveEmitter.fire(f)}_fireDidChangeSelection(c){const f=(0,R.coalesce)(c.map(l=>this._handlesToItems.get(l)));this._selectedItems=f,this._onDidChangeSelectionEmitter.fire(f)}_fireDidTriggerItemButton(c,f){const l=this._handlesToItems.get(c);if(!l||!l.buttons||!l.buttons.length)return;const b=l.buttons[f];b&&this._onDidTriggerItemButtonEmitter.fire({button:b,item:l})}}class s extends r{constructor(c,f){super(c,f);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(c){this._password=c,this.update({password:c})}get prompt(){return this._prompt}set prompt(c){this._prompt=c,this.update({prompt:c})}get validationMessage(){return this._validationMessage}set validationMessage(c){this._validationMessage=c,this.update({validationMessage:c,severity:c?P.default.Error:P.default.Ignore})}}return new a(v,I)}e.createExtHostQuickOpen=h}),define(pe[248],ve([0,1,2,3,57,6,18,5,16,99,11,27,86,17,29]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function p(d){if(d)return typeof d.iconPath=="string"?m.URI.file(d.iconPath):m.URI.isUri(d.iconPath)||u.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function v(d,c){if(!d.iconPath&&!c.iconPath)return 0;if(d.iconPath){if(!c.iconPath)return 1}else return-1;const f=typeof d.iconPath=="string"?d.iconPath:m.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,l=typeof c.iconPath=="string"?c.iconPath:m.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id;return(0,D.comparePaths)(f,l)}function I(d,c){let f=0;if(d.strikeThrough!==c.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==c.faded)return d.faded?1:-1;if(d.tooltip!==c.tooltip)return(d.tooltip||"").localeCompare(c.tooltip||"");if(f=v(d,c),f!==0)return f;if(d.light&&c.light)f=v(d.light,c.light);else{if(d.light)return 1;if(c.light)return-1}if(f!==0)return f;if(d.dark&&c.dark)f=v(d.dark,c.dark);else{if(d.dark)return 1;if(c.dark)return-1}return f}function w(d,c){if(d.command!==c.command)return d.command<c.command?-1:1;if(d.title!==c.title)return d.title<c.title?-1:1;if(d.tooltip!==c.tooltip){if(d.tooltip!==void 0&&c.tooltip!==void 0)return d.tooltip<c.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(d.arguments===c.arguments)return 0;if(d.arguments)if(c.arguments){if(d.arguments.length!==c.arguments.length)return d.arguments.length-c.arguments.length}else return 1;else return-1;for(let f=0;f<d.arguments.length;f++){const l=d.arguments[f],b=c.arguments[f];if(l!==b)return l<b?-1:1}return 0}function a(d,c){let f=(0,D.comparePaths)(d.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(f!==0)return f;if(d.command&&c.command)f=w(d.command,c.command);else{if(d.command)return 1;if(c.command)return-1}if(f!==0)return f;if(d.decorations&&c.decorations)f=I(d.decorations,c.decorations);else{if(d.decorations)return 1;if(c.decorations)return-1}return f}function r(d,c){for(let f=0;f<d.length;f++)if(d[f]!==c[f])return!1;return!0}function g(d,c){return d.command===c.command&&d.title===c.title&&d.tooltip===c.tooltip&&(d.arguments&&c.arguments?r(d.arguments,c.arguments):d.arguments===c.arguments)}function o(d,c){return(0,S.equals)(d,c,g)}class _{constructor(c,f,l){this._extension=c,this._proxy=f,this._sourceControlHandle=l,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(c){this._proxy.$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(c){if((0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,c))}showValidationMessage(c,f){(0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,c,f)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=_;class n{constructor(c,f,l,b,T){this._proxy=c,this._commands=f,this._sourceControlHandle=l,this._id=b,this._label=T,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,f){const l=this._resourceStatesCommandsMap.get(c);return l?(0,i.asPromise)(()=>this._commands.executeCommand(l.command,...l.arguments||[],f)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const c=[...this._resourceStates].sort(a),l=(0,S.sortedDiff)(this._resourceSnapshot,c,a).map(A=>{const U=A.toInsert.map(B=>{const L=this._resourceHandlePool++;this._resourceStatesMap.set(L,B);const x=B.resourceUri;let M;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const ie=new C.DisposableStore;M=this._commands.converter.toInternal(B.command,ie),this._resourceStatesDisposablesMap.set(L,ie)}else this._resourceStatesCommandsMap.set(L,B.command);const V=p(B.decorations),O=B.decorations&&p(B.decorations.light)||V,W=B.decorations&&p(B.decorations.dark)||V,q=[O,W],N=B.decorations&&B.decorations.tooltip||"",G=B.decorations&&!!B.decorations.strikeThrough,$=B.decorations&&!!B.decorations.faded,H=B.contextValue||"";return{rawResource:[L,x,q,N,G,$,H,M],handle:L}});return{start:A.start,deleteCount:A.deleteCount,toInsert:U}}),b=l.map(({start:A,deleteCount:U,toInsert:B})=>[A,U,B.map(L=>L.rawResource)]),T=l.reverse();for(const{start:A,deleteCount:U,toInsert:B}of T){const L=B.map(M=>M.handle),x=this._handlesSnapshot.splice(A,U,...L);for(const M of x)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=c,b}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class t{constructor(c,f,l,b,T,A){this._extension=c,this._proxy=f,this._commands=l,this._id=b,this._label=T,this._rootUri=A,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new C.MutableDisposable,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new _(c,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,b,T,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,this._proxy.$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,this._proxy.$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=c;const f=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:f})}get actionButton(){return(0,h.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(c){(0,h.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new C.DisposableStore,this._actionButton=c;const f=c!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:f??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(this._statusBarCommands&&c&&o(this._statusBarCommands,c))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=c;const f=(c||[]).map(l=>this._commands.converter.toInternal(l,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:f})}get selected(){return this._selected}createResourceGroup(c,f){const l=new n(this._proxy,this._commands,this.handle,c,f),b=F.Event.once(l.onDidDispose)(()=>this.createdResourceGroups.delete(l));return this.createdResourceGroups.set(l,b),this.eventuallyAddResourceGroups(),l}eventuallyAddResourceGroups(){const c=[],f=[];for(const[l,b]of this.createdResourceGroups){b.dispose();const T=l.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(l),this.eventuallyUpdateResourceStates()});F.Event.once(l.onDidDispose)(()=>{this.updatedResourceGroups.delete(l),T.dispose(),this._groups.delete(l.handle),this._proxy.$unregisterGroup(this.handle,l.handle)}),c.push([l.handle,l.id,l.label,l.features]);const A=l._takeResourceStateSnapshot();A.length>0&&f.push([l.handle,A]),this._groups.set(l.handle,l)}this._proxy.$registerGroups(this.handle,c,f),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(f=>{const l=f._takeResourceStateSnapshot();l.length!==0&&c.push([f.handle,l])}),c.length>0&&this._proxy.$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}t._handlePool=0,je([(0,y.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),je([(0,y.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let s=class Hi{constructor(c,f,l){this._commands=f,this.logService=l,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=c.getProxy(k.MainContext.MainThreadSCM),this._telemetry=c.getProxy(k.MainContext.MainThreadTelemetry),f.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===3){const T=this._sourceControls.get(b.sourceControlHandle);if(!T)return b;const A=T.getResourceGroup(b.groupHandle);return A?A.getResourceState(b.handle):b}else if(b&&b.$mid===4){const T=this._sourceControls.get(b.sourceControlHandle);return T?T.getResourceGroup(b.groupHandle):b}else if(b&&b.$mid===5){const T=this._sourceControls.get(b.handle);return T||b}return b}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,f,l,b){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,f,l,b),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const T=Hi._handlePool++,A=new t(c,this._proxy,this._commands,f,l,b);this._sourceControls.set(T,A);const U=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(c.identifier))||[];return U.push(A),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(c.identifier),U),A}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const f=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(c.identifier)),l=f&&f[f.length-1];return l&&l.inputBox}$provideOriginalResource(c,f,l){const b=m.URI.revive(f);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,b.toString());const T=this._sourceControls.get(c);return!T||!T.quickDiffProvider||!T.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,i.asPromise)(()=>T.quickDiffProvider.provideOriginalResource(b,l)).then(A=>A||null)}$onInputBoxValueChange(c,f){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const l=this._sourceControls.get(c);return l&&l.inputBox.$onInputBoxValueChange(f),Promise.resolve(void 0)}$executeResourceCommand(c,f,l,b){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,f,l);const T=this._sourceControls.get(c);if(!T)return Promise.resolve(void 0);const A=T.getResourceGroup(f);return A?A.$executeResourceCommand(l,b):Promise.resolve(void 0)}$validateInput(c,f,l){this.logService.trace("ExtHostSCM#$validateInput",c);const b=this._sourceControls.get(c);return!b||!b.inputBox.validateInput?Promise.resolve(void 0):(0,i.asPromise)(()=>b.inputBox.validateInput(f,l)).then(T=>{if(!T)return Promise.resolve(void 0);const A=E.MarkdownString.fromStrict(T.message);return A?Promise.resolve([A,T.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(c){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&this._sourceControls.get(c)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};s._handlePool=0,s=je([He(2,R.ILogService)],s),e.ExtHostSCM=s});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,F,y){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(pe[249],ve([0,1,7,5,165,6,17,13]),function(Y,e,m,F,y,C,i,k){"use strict";var S,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(h,p,v,I,w=m.StatusBarAlignment.Left,a){S.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,nt(this,S,h,"f"),nt(this,D,p,"f"),this._entryId=R.ID_GEN++,this._extension=v,this._id=I,this._alignment=w,this._priority=this.validatePriority(a)}validatePriority(h){if(!!(0,k.isNumber)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!R.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Ne(this,D,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Ne(this,D,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ne(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let p;this._name?p=this._name:p=(0,y.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const I=this._tooltip?i.MarkdownString.fromStrict(this._tooltip):void 0;Ne(this,S,"f").$setEntry(this._entryId,h,p,this._text,I,this._command?.internal,v,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,S=new WeakMap,D=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class P{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,y.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const p={message:h};return this._messages.unshift(p),this._update(),new m.Disposable(()=>{const v=this._messages.indexOf(p);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class u{constructor(h,p){this._proxy=h.getProxy(F.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new P(this)}createStatusBarEntry(h,p,v,I){return new R(this._proxy,this._commands,h,p,v,I)}setStatusBarMessage(h,p){const v=this._statusMessage.setMessage(h);let I;return typeof p=="number"?I=setTimeout(()=>v.dispose(),p):typeof p!="undefined"&&p.then(()=>v.dispose(),()=>v.dispose()),new m.Disposable(()=>{v.dispose(),clearTimeout(I)})}}e.ExtHostStatusBar=u}),define(pe[91],ve([0,1,5,3,4]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(k){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,S){this._proxy.$registerExtensionStorageKeysToSync(k,S)}getValue(k,S,D){return this._proxy.$getValue(k,S).then(R=>R||D)}setValue(k,S,D){return this._proxy.$setValue(k,S,D)}$acceptValue(k,S,D){this._onDidChangeStorage.fire({shared:k,key:S,value:D})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(pe[67],ve([0,1,4,26,11,66,2]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let k=class{constructor(D,R,P){this._logService=R,this._extHostFileSystem=P,this._workspace=D.workspace??void 0,this._environment=D.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(D){return i.URI.joinPath(this._environment.workspaceStorageHome,D)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const D=this._workspace.id,R=await this._getWorkspaceStorageURI(D);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(i.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:i.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(P){this._logService.error("[ExtHostStorage]",P);return}}workspaceValue(D){if(this._value)return i.URI.joinPath(this._value,D.identifier.value)}globalValue(D){return i.URI.joinPath(this._environment.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=je([He(0,F.IExtHostInitDataService),He(1,y.ILogService),He(2,C.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(pe[34],ve([0,1,3,5,4,2,14,6,7,166,15,213,21,32,195,86,13,18]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class w{constructor(d,c,f,l){this._proxy=d,this._id=c,this._creationOptions=f,this._name=l,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(T=>this._pidPromiseComplete=T);const b=this;this.value={get name(){return b._name||""},get processId(){return b._pidPromise},get creationOptions(){return b._creationOptions},get exitStatus(){return b._exitStatus},get state(){return b._state},sendText(T,A=!0){b._checkDisposed(),b._proxy.$sendText(b._id,T,A)},show(T){b._checkDisposed(),b._proxy.$show(b._id,T)},hide(){b._checkDisposed(),b._proxy.$hide(b._id)},dispose(){b._disposed||(b._disposed=!0,b._proxy.$dispose(b._id))},get dimensions(){if(!(b._cols===void 0||b._rows===void 0))return{columns:b._cols,rows:b._rows}}}}async create(d,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:d.name,shellPath:(0,v.withNullAsUndefined)(d.shellPath),shellArgs:(0,v.withNullAsUndefined)(d.shellArgs),cwd:(0,v.withNullAsUndefined)(d.cwd),env:(0,v.withNullAsUndefined)(d.env),icon:(0,v.withNullAsUndefined)(n(d.iconPath)),color:p.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:(0,v.withNullAsUndefined)(d.message),strictEnv:(0,v.withNullAsUndefined)(d.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(d.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(d.location,c?.resolvedExtHostIdentifier)})}async createExtensionTerminal(d,c,f,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,color:p.ThemeColor.isThemeColor(l)?l.id:void 0,location:this._serializeParentTerminal(d,c)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(d,c){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in d?{viewColumn:d.viewColumn,preserveFocus:d.preserveFocus}:void 0:d}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(d){this._name=d}setExitCode(d){this._exitStatus=Object.freeze({code:d})}setDimensions(d,c){return d===this._cols&&c===this._rows||d===0||c===0?!1:(this._cols=d,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(d){this._pidPromiseComplete?(this._pidPromiseComplete(d),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==d&&(this._pidPromise=Promise.resolve(d))})}}e.ExtHostTerminal=w;class a{constructor(d){this._pty=d,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new m.Emitter,this._onDidChangeProperty=new m.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(d){this._pty.handleInput?.(d)}resize(d,c){this._pty.setDimensions?.({columns:d,rows:c})}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(d){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(d||void 0),d&&this._pty.setDimensions?.(d),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=a;let r=1,g=class extends k.Disposable{constructor(d,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new h.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(d),this._register({dispose:()=>{for(const[f,l]of this._terminalProcesses)l.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(d=>d.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(d,c){const f=new w(this._proxy,(0,E.generateUuid)(),d,d.name),l=new a(d.pty);return f.createExtensionTerminal(d.location,this._serializeParentTerminal(d,c).resolvedExtHostIdentifier,n(d.iconPath),t(d.color)).then(b=>{const T=this._setupExtHostProcessListeners(b,l);this._terminalProcessDisposables[b]=T}),this._terminals.push(f),f.value}_serializeParentTerminal(d,c){if(c=c||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const f=d.location.parentTerminal;if(f){const l=this._terminals.find(b=>b.value===f);l&&(c.resolvedExtHostIdentifier=l._id)}}else d.location&&typeof d.location!="object"?c.location=d.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(d,c){if(!this._getTerminalById(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const l=new a(c),b=this._setupExtHostProcessListeners(d,l);this._terminalProcessDisposables[d]=b}async $acceptActiveTerminalChanged(d){const c=this._activeTerminal;if(d===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(d);f&&(this._activeTerminal=f,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(d,c){const f=this._getTerminalById(d);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:c})}async $acceptTerminalDimensions(d,c,f){const l=this._getTerminalById(d);l&&l.setDimensions(c,f)&&this._onDidChangeTerminalDimensions.fire({terminal:l.value,dimensions:l.value.dimensions})}async $acceptTerminalMaximumDimensions(d,c,f){this._terminalProcesses.get(d)?.resize(c,f)}async $acceptTerminalTitleChange(d,c){const f=this._getTerminalById(d);f&&(f.name=c)}async $acceptTerminalClosed(d,c){const f=this._getTerminalObjectIndexById(this._terminals,d);if(f!==null){const l=this._terminals.splice(f,1)[0];l.setExitCode(c),this._onDidCloseTerminal.fire(l.value)}}$acceptTerminalOpened(d,c,f,l){if(c){const A=this._getTerminalObjectIndexById(this._terminals,c);if(A!==null){this._terminals[A]._id=d,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const b={name:l.name,shellPath:l.executable,shellArgs:l.args,cwd:typeof l.cwd=="string"?l.cwd:C.URI.revive(l.cwd),env:l.env,hideFromUser:l.hideFromUser},T=new w(this._proxy,d,b,f);this._terminals.push(T),this._onDidOpenTerminal.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(d,c){const f=this._getTerminalById(d);f&&f._setProcessId(c)}async $startExtensionTerminal(d,c){const f=this._getTerminalById(d);if(!f)return{message:(0,D.localize)(0,null,d)};f.isOpen||await new Promise(b=>{const T=this.onDidOpenTerminal(async A=>{A===f.value&&(T.dispose(),b())})});const l=this._terminalProcesses.get(d);l?l.startSendingEvents(c):this._extensionTerminalAwaitingStart[d]={initialDimensions:c}}_setupExtHostProcessListeners(d,c){const f=new k.DisposableStore;f.add(c.onProcessReady(b=>this._proxy.$sendProcessReady(d,b.pid,b.cwd))),f.add(c.onDidChangeProperty(b=>this._proxy.$sendProcessProperty(d,b))),this._bufferer.startBuffering(d,c.onProcessData),f.add(c.onProcessExit(b=>this._onProcessExit(d,b))),this._terminalProcesses.set(d,c);const l=this._extensionTerminalAwaitingStart[d];return l&&c instanceof a&&(c.startSendingEvents(l.initialDimensions),delete this._extensionTerminalAwaitingStart[d]),f}$acceptProcessAckDataEvent(d,c){this._terminalProcesses.get(d)?.acknowledgeDataEvent(c)}$acceptProcessInput(d,c){this._terminalProcesses.get(d)?.input(c)}$acceptTerminalInteraction(d){const c=this._getTerminalById(d);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(d,c,f){try{this._terminalProcesses.get(d)?.resize(c,f)}catch(l){if(l.code!=="EPIPE"&&l.code!=="ERR_IPC_CHANNEL_CLOSED")throw l}}$acceptProcessShutdown(d,c){this._terminalProcesses.get(d)?.shutdown(c)}$acceptProcessRequestInitialCwd(d){this._terminalProcesses.get(d)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(d,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(d){this._terminalProcesses.get(d)?.getCwd().then(c=>this._proxy.$sendProcessProperty(d,{type:"cwd",value:c}))}$acceptProcessRequestLatency(d){return d}registerLinkProvider(d){return this._linkProviders.add(d),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(d),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(d,c,f){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,f),this._proxy.$registerProfileProvider(c,d.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(d,c){const f=new u.CancellationTokenSource().token;let l=await this._profileProviders.get(d)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(l&&!("options"in l)&&(l={options:l}),!l||!("options"in l))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in l.options){this.createExtensionTerminal(l.options,c);return}this.createTerminalFromOptions(l.options,c)}}async $provideLinks(d,c){const f=this._getTerminalById(d);if(!f)return[];this._terminalLinkCache.delete(d);const l=this._terminalLinkCancellationSource.get(d);l&&l.dispose(!0);const b=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(d,b);const T=[],A={terminal:f.value,line:c},U=[];for(const x of this._linkProviders)U.push(I.Promises.withAsyncBody(async M=>{b.token.onCancellationRequested(()=>M({provider:x,links:[]}));const V=await x.provideTerminalLinks(A,b.token)||[];b.token.isCancellationRequested||M({provider:x,links:V})}));const B=await Promise.all(U);if(b.token.isCancellationRequested)return[];const L=new Map;for(const x of B)x&&x.links.length>0&&T.push(...x.links.map(M=>{const V={id:r++,startIndex:M.startIndex,length:M.length,label:M.tooltip};return L.set(V.id,{provider:x.provider,link:M}),V}));return this._terminalLinkCache.set(d,L),T}$activateLink(d,c){const f=this._terminalLinkCache.get(d)?.get(c);!f||f.provider.handleTerminalLink(f.link)}_onProcessExit(d,c){this._bufferer.stopBuffering(d),this._terminalProcesses.delete(d),delete this._extensionTerminalAwaitingStart[d];const f=this._terminalProcessDisposables[d];f&&(f.dispose(),delete this._terminalProcessDisposables[d]),this._proxy.$sendProcessExit(d,c)}_getTerminalById(d){return this._getTerminalObjectById(this._terminals,d)}_getTerminalObjectById(d,c){const f=this._getTerminalObjectIndexById(d,c);return f!==null?d[f]:null}_getTerminalObjectIndexById(d,c){let f=null;return d.some((l,b)=>l._id===c?(f=b,!0):!1),f}getEnvironmentVariableCollection(d){let c=this._environmentVariableCollections.get(d.identifier.value);return c||(c=new o,this._setEnvironmentVariableCollection(d.identifier.value,c)),c}_syncEnvironmentVariableCollection(d,c){const f=(0,P.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(d,c.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(d){d.forEach(c=>{const f=c[0],l=new o(c[1]);this._setEnvironmentVariableCollection(f,l)})}$acceptDefaultProfile(d,c){this._defaultProfile=d,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(d,c){this._environmentVariableCollections.set(d,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(d,c)})}};g=je([He(1,i.IExtHostRpcService)],g),e.BaseExtHostTerminalService=g;class o{constructor(d){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(d)}get persistent(){return this._persistent}set persistent(d){this._persistent=d,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(d,c){this._setIfDiffers(d,{value:c,type:S.EnvironmentVariableMutatorType.Replace})}append(d,c){this._setIfDiffers(d,{value:c,type:S.EnvironmentVariableMutatorType.Append})}prepend(d,c){this._setIfDiffers(d,{value:c,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(d,c){const f=this.map.get(d);(!f||f.value!==c.value||f.type!==c.type)&&(this.map.set(d,c),this._onDidChangeCollection.fire())}get(d){return this.map.get(d)}forEach(d,c){this.map.forEach((f,l)=>d.call(c,l,f,this))}delete(d){this.map.delete(d),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=o;let _=class extends g{constructor(d){super(!1,d)}createTerminal(d,c,f){throw new R.NotSupportedError}createTerminalFromOptions(d,c){throw new R.NotSupportedError}};_=je([He(0,i.IExtHostRpcService)],_),e.WorkerExtHostTerminalService=_;function n(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function t(s){return p.ThemeColor.isThemeColor(s)?s:void 0}});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,F,y){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(pe[250],ve([0,1,16,22,21,3,74,47,6,25,13,32,5,14,63,17,7,221,126,89]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I,w,a){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let g=class{constructor(A,U){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(u.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new _(this.proxy),U.registerArgumentProcessor({processArgument:B=>B?.$mid===13?p.TestItem.toItemFromContext(B):B})}createTestController(A,U){if(this.controllers.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const B=new S.DisposableStore,L=B.add(new I.SingleUseTestCollection(A));L.root.label=U;const x=new Map,M=this.proxy,V={items:L.root.children,get label(){return U},set label(W){U=W,L.root.label=W,M.$updateControllerLabel(A,U)},get id(){return A},createRunProfile:(W,q,N,G,$)=>{let H=(0,k.hash)(W);for(;x.has(H);)H++;const j=new l(this.proxy,A,H,W,q,N,G,$);return x.set(H,j),j},createTestItem(W,q,N){return new h.TestItemImpl(A,W,q,N)},createTestRun:(W,q,N=!0)=>this.runTracker.createTestRun(A,L,W,q,N),set resolveHandler(W){L.resolveHandler=W},get resolveHandler(){return L.resolveHandler},dispose:()=>{B.dispose()}};V.createRunConfiguration=V.createRunProfile,M.$registerTestController(A,U),B.add((0,S.toDisposable)(()=>M.$unregisterTestController(A)));const O={controller:V,collection:L,profiles:x};return this.controllers.set(A,O),B.add((0,S.toDisposable)(()=>this.controllers.delete(A))),B.add(L.onDidGenerateDiff(W=>M.$publishDiff(A,W))),V}createTestObserver(){return this.observer.checkout()}async runTests(A,U=y.CancellationToken.None){const B=n(A);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const L=this.controllers.get(B.controllerId);if(!L)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:A.include?.map(x=>x.id)??[L.collection.root.id],profileGroup:b[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:A.exclude?.map(x=>x.id)},U)}$provideFileCoverage(A,U,B){return(0,m.mapFind)(this.runTracker.trackers,x=>x.id===A?x.getCoverage(U):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(A,U,B,L){return(0,m.mapFind)(this.runTracker.trackers,M=>M.id===A?M.getCoverage(U):void 0)?.resolveFileCoverage(B,L)??Promise.resolve([])}$configureRunProfile(A,U){this.controllers.get(A)?.profiles.get(U)?.configureHandler?.()}$publishTestResults(A){this.results=Object.freeze(A.map(U=>(0,D.deepFreeze)(p.TestResults.to(U))).concat(this.results).sort((U,B)=>B.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(A,U){const B=this.controllers.get(a.TestId.fromString(A).controllerId)?.collection;B&&(await B.expand(A,U<0?Infinity:U),B.flushDiff())}$acceptDiff(A){this.observer.applyDiff(A)}async $runControllerTests(A,U){const B=this.controllers.get(A.controllerId);if(!B)return;const{collection:L,profiles:x}=B,M=x.get(A.profileId);if(!M)return;const V=A.testIds.map(N=>L.tree.get(N)).filter(R.isDefined),O=A.excludeExtIds.map(N=>B.collection.tree.get(N)).filter(R.isDefined).filter(N=>V.some(G=>G.fullId.compare(N.fullId)===2));if(!V.length)return;const W=new v.TestRunRequest(V.some(N=>N.actual instanceof h.TestItemRootImpl)?void 0:V.map(N=>N.actual),O.map(N=>N.actual),M),q=this.runTracker.prepareForMainThreadTestRun(W,t.fromInternal(A,B.collection),U);try{await M.runHandler(W,U)}finally{q.isRunning&&!U.isCancellationRequested&&await C.Event.toPromise(q.onEnd),q.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(A)}};g=je([He(0,E.IExtHostRpcService)],g),e.ExtHostTesting=g;class o extends S.Disposable{constructor(A,U,B){super();this.dto=A,this.proxy=U,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(B)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:L}of this.tasks.values())L.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(A){return this.tasks.get(A)?.coverage}createRun(A){const U=this.dto.id,B=this.dto.controllerId,L=(0,P.generateUuid)(),x=new s(this.proxy,U,L),M=q=>(N,...G)=>{if(O){console.warn(`Setting the state of test "${N.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(N)||(this.ensureTestIsKnown(N),q(N,...G))},V=(q,N)=>{const G=N instanceof Array?N.map(p.TestMessage.from):[p.TestMessage.from(N)];if(q.uri&&q.range){const $={range:p.Range.from(q.range),uri:q.uri};for(const H of G)H.location=H.location||$}this.proxy.$appendTestMessagesInRun(U,L,a.TestId.fromExtHostTestItem(q,B).toString(),G)};let O=!1;const W={isPersisted:this.dto.isPersisted,token:this.cts.token,name:A,get coverageProvider(){return x.coverageProvider},set coverageProvider(q){x.coverageProvider=q},enqueued:M(q=>{this.proxy.$updateTestStateInRun(U,L,a.TestId.fromExtHostTestItem(q,B).toString(),1)}),skipped:M(q=>{this.proxy.$updateTestStateInRun(U,L,a.TestId.fromExtHostTestItem(q,B).toString(),5)}),started:M(q=>{this.proxy.$updateTestStateInRun(U,L,a.TestId.fromExtHostTestItem(q,B).toString(),2)}),errored:M((q,N,G)=>{V(q,N),this.proxy.$updateTestStateInRun(U,L,a.TestId.fromExtHostTestItem(q,B).toString(),6,G)}),failed:M((q,N,G)=>{V(q,N),this.proxy.$updateTestStateInRun(U,L,a.TestId.fromExtHostTestItem(q,B).toString(),4,G)}),passed:M((q,N)=>{this.proxy.$updateTestStateInRun(U,L,a.TestId.fromExtHostTestItem(q,this.dto.controllerId).toString(),3,N)}),appendOutput:(q,N,G)=>{O||(G&&(this.dto.isIncluded(G)?this.ensureTestIsKnown(G):G=void 0),this.proxy.$appendOutputToRun(U,L,F.VSBuffer.fromString(q),N&&p.location.from(N),G&&a.TestId.fromExtHostTestItem(G,B).toString()))},end:()=>{O||(O=!0,this.proxy.$finishedTestRunTask(U,L),this.tasks.delete(L),this.isRunning||this.dispose())}};return this.tasks.set(L,{run:W,coverage:x}),this.proxy.$startedTestRunTask(U,{id:L,name:A,running:!0}),W}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(A){if(!(A instanceof h.TestItemImpl))throw new h.InvalidTestItemError(A.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(A,this.dto.controllerId).toString()))return;const U=[],B=this.dto.colllection.root;for(;;){const L=p.TestItem.from(A);if(U.unshift(L),this.sharedTestIds.has(L.extId)||(this.sharedTestIds.add(L.extId),A===B))break;A=A.parent||B}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,U)}}class _{constructor(A){this.proxy=A,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(A,U,B){return this.getTracker(A,U,B)}cancelRunById(A){for(const U of this.tracked.values())if(U.id===A){U.dispose();return}}cancelAllRuns(){for(const A of this.tracked.values())A.dispose()}createTestRun(A,U,B,L,x){const M=this.tracked.get(B);if(M)return M.createRun(L);const V=t.fromPublic(A,U,B,x),O=n(B);this.proxy.$startedExtensionTestRun({controllerId:A,profile:O&&{group:b[O.kind],id:O.profileId},exclude:B.exclude?.map(q=>q.id)??[],id:V.id,include:B.include?.map(q=>q.id)??[U.root.id],persist:x});const W=this.getTracker(B,V);return W.onEnd(()=>this.proxy.$finishedExtensionTestRun(V.id)),W.createRun(L)}getTracker(A,U,B){const L=new o(U,this.proxy,B);return this.tracked.set(A,L),L.onEnd(()=>this.tracked.delete(A)),L}}e.TestRunCoordinator=_;const n=T=>{if(!!T.profile){if(!(T.profile instanceof l))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class t{constructor(A,U,B,L,x,M){this.controllerId=A,this.id=U,this.isPersisted=x,this.colllection=M,this.includePrefix=B.map(V=>V+"\0"),this.excludePrefix=L.map(V=>V+"\0")}static fromPublic(A,U,B,L){return new t(A,(0,P.generateUuid)(),B.include?.map(x=>a.TestId.fromExtHostTestItem(x,A).toString())??[A],B.exclude?.map(x=>a.TestId.fromExtHostTestItem(x,A).toString())??[],L,U)}static fromInternal(A,U){return new t(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,U)}isIncluded(A){const U=a.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const B of this.excludePrefix)if(U===B||U.startsWith(B))return!1;for(const B of this.includePrefix)if(U===B||U.startsWith(B))return!0;return!1}}e.TestRunDto=t;class s{constructor(A,U,B){this.proxy=A,this.runId=U,this.taskId=B}set coverageProvider(A){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this._coverageProvider=A,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(A){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(A))());try{return(await this.fileCoverage)?.map(p.TestCoverage.fromFile)??[]}catch(U){throw this.fileCoverage=void 0,U}}async resolveFileCoverage(A,U){const B=await this.fileCoverage;let L=B?.[A];return!this._coverageProvider||!B||!L?[]:(L.detailedCoverage||(L=B[A]=await this._coverageProvider.resolveFileCoverage?.(L,U)??L),L.detailedCoverage?.map(p.TestCoverage.fromDetailed)??[])}}class d extends w.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,p.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:U,removed:B}=this;return{get added(){return[...A].map(L=>L.revived)},get updated(){return[...U].map(L=>L.revived)},get removed(){return[...B].map(L=>L.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,U){return{...A,revived:p.TestItem.toPlain(A.item),depth:U?U.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=c;class f{constructor(A){this.proxy=A}checkout(){this.current||(this.current=this.createObserverData());const A=this.current;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(U=>U.revived)},dispose:(0,i.once)(()=>{--A.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(A){return this.current?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.current?.tests.apply(A)}createObserverData(){const A=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:A}}}class l{constructor(A,U,B,L,x,M,V=!1,O=void 0){this.controllerId=U,this.profileId=B,this._label=L,this.kind=x,this.runHandler=M,this._isDefault=V,this._tag=O,r.set(this,void 0),nt(this,r,A,"f");const W=b[x];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Ne(this,r,"f").$publishTestRunProfile({profileId:B,controllerId:U,tag:O?p.TestTag.namespace(this.controllerId,O.id):null,label:L,group:W,isDefault:V,hasConfigurationHandler:!1})}get label(){return this._label}set label(A){A!==this._label&&(this._label=A,Ne(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this._isDefault}set isDefault(A){A!==this._isDefault&&(this._isDefault=A,Ne(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Ne(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?p.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(A){A!==this._configureHandler&&(this._configureHandler=A,Ne(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}dispose(){Ne(this,r,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=l,r=new WeakMap;const b={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(pe[251],ve([0,1,3,16,5,129,17,7]),function(Y,e,m,F,y,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(R,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(y.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(u=>this._onDidChangeVisibleTextEditors.fire(u)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(u=>this._onDidChangeActiveTextEditor.fire(u))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const P=this._extHostDocumentsAndEditors.allEditors();return R?P:P.map(u=>u.value)}async showTextDocument(R,P,u){let E;typeof P=="number"?E={position:i.ViewColumn.from(P),preserveFocus:u}:typeof P=="object"?E={position:i.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?i.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:E={preserveFocus:!1};const h=await this._proxy.$tryShowTextDocument(R.uri,E),p=h&&this._extHostDocumentsAndEditors.getEditor(h);if(p)return p.value;throw h?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,P){return new C.TextEditorDecorationType(this._proxy,R,P).value}$acceptEditorPropertiesChanged(R,P){const u=this._extHostDocumentsAndEditors.getEditor(R);if(!u)throw new Error("unknown text editor");if(P.options&&u._acceptOptions(P.options),P.selections){const E=P.selections.selections.map(i.Selection.to);u._acceptSelections(E)}if(P.visibleRanges){const E=F.coalesce(P.visibleRanges.map(i.Range.to));u._acceptVisibleRanges(E)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:u.value,options:{...P.options,lineNumbers:i.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const E=k.TextEditorSelectionChangeKind.fromValue(P.selections.source),h=P.selections.selections.map(i.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:u.value,selections:h,kind:E})}if(P.visibleRanges){const E=F.coalesce(P.visibleRanges.map(i.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:u.value,visibleRanges:E})}}$acceptEditorPositionData(R){for(const P in R){const u=this._extHostDocumentsAndEditors.getEditor(P);if(!u)throw new Error("Unknown text editor");const E=i.ViewColumn.to(R[P]);u.value.viewColumn!==E&&(u._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:u.value,viewColumn:E}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=S}),define(pe[252],ve([0,1,2,4,5,6,7]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class k{constructor(R,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(y.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===11){const E=u.uri===void 0?void 0:m.URI.revive(u.uri);return this._itemsBySourceAndUriMap.get(u.source)?.get(S(E))?.get(u.handle)}return u}})}async $getTimeline(R,P,u,E,h){return this._providers.get(R)?.provideTimeline(m.URI.revive(P),u,E,h)}registerTimelineProvider(R,P,u,E){const h=new C.DisposableStore,p=this.convertTimelineItem(P.id,E,h).bind(this);let v;P.onDidChange&&(v=P.onDidChange(w=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:P.id}),this));const I=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...P,scheme:R,onDidChange:void 0,async provideTimeline(w,a,r,g){g?.resetCache&&(h.clear(),I.get(P.id)?.clear());const o=await P.provideTimeline(w,a,r);if(o==null)return;const _=p(w,g);return{...o,source:P.id,items:o.items.map(_)}},dispose(){for(const w of I.values())w.get(P.id)?.clear();v?.dispose(),h.dispose()}})}convertTimelineItem(R,P,u){return(E,h)=>{let p;if(h?.cacheResults){let v=this._itemsBySourceAndUriMap.get(R);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(R,v));const I=S(E);p=v.get(I),p===void 0&&(p=new Map,v.set(I,p))}return v=>{const{iconPath:I,...w}=v,a=`${R}|${v.id??v.timestamp}`;p?.set(a,v);let r,g,o;return v.iconPath&&(I instanceof i.ThemeIcon?o={id:I.id,color:I.color}:m.URI.isUri(I)?(r=I,g=I):{light:r,dark:g}=I),{...w,id:w.id??void 0,handle:a,source:R,command:v.command?P.toInternal(v.command,u):void 0,icon:r,iconDark:g,themeIcon:o,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,C.toDisposable)(()=>{for(const u of this._itemsBySourceAndUriMap.values())u.get(R.id)?.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=k;function S(D){return D?.toString()}}),define(pe[253],ve([0,1,6,10,2,5]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class i{constructor(S){this._openers=new Map,this._proxy=S.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,D,R,P){if(this._openers.has(D))throw new Error(`Opener with id '${D}' already registered`);const u=P.schemes.find(E=>!i.supportedSchemes.has(E));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(D,R),this._proxy.$registerUriOpener(D,P.schemes,S,P.label),(0,m.toDisposable)(()=>{this._openers.delete(D),this._proxy.$unregisterUriOpener(D)})}async $canOpenUri(S,D,R){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener with id: ${S}`);const u=y.URI.revive(D);return P.canOpenExternalUri(u,R)}async $openUri(S,D,R){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener id: '${S}'`);return P.openExternalUri(y.URI.revive(D.resolvedUri),{sourceUri:y.URI.revive(D.sourceUri)},R)}}e.ExtHostUriOpeners=i,i.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(pe[254],ve([0,1,5,2,6,15,27]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(D){this.handles=new Set,this.handlers=new Map,this._proxy=D.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(D,R){if(this.handles.has(i.ExtensionIdentifier.toKey(D)))throw new Error(`Protocol handler already registered for extension ${D}`);const P=k.HandlePool++;return this.handles.add(i.ExtensionIdentifier.toKey(D)),this.handlers.set(P,R),this._proxy.$registerUriHandler(P,D),(0,y.toDisposable)(()=>{this.handles.delete(i.ExtensionIdentifier.toKey(D)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(D,R){const P=this.handlers.get(D);if(!P)return Promise.resolve(void 0);try{P.handleUri(F.URI.revive(R))}catch(u){(0,C.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(D){return F.URI.revive(await this._proxy.$createAppUri(D))}}e.ExtHostUrls=k,k.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,F,y){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(pe[68],ve([0,1,3,10,2,178,203,88,5]),function(Y,e,m,F,y,C,i,k,S){"use strict";var D,R,P,u,E,h,p,v,I,w,a,r;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(f,l,b,T,A,U,B){D.set(this,void 0),R.set(this,void 0),P.set(this,void 0),u.set(this,void 0),E.set(this,void 0),h.set(this,void 0),p.set(this,""),v.set(this,void 0),I.set(this,!1),w.set(this,!1),a.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new m.Emitter),this._onDidDispose=Ne(this,r,"f").event,nt(this,D,f,"f"),nt(this,R,l,"f"),nt(this,v,b,"f"),nt(this,u,T,"f"),nt(this,E,A,"f"),nt(this,h,U,"f"),nt(this,a,o(U),"f"),nt(this,P,B,"f")}dispose(){nt(this,I,!0,"f"),Ne(this,r,"f").fire(),Ne(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return nt(this,w,!0,"f"),(0,k.asWebviewUri)(f,Ne(this,u,"f").remote)}get cspSource(){const f=Ne(this,h,"f").extensionLocation;if(f.scheme===F.Schemas.https||f.scheme===F.Schemas.http){let l=f.toString();return l.endsWith("/")||(l+="/"),l+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ne(this,p,"f")}set html(f){this.assertNotDisposed(),Ne(this,p,"f")!==f&&(nt(this,p,f,"f"),!Ne(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(nt(this,w,!0,"f"),Ne(this,P,"f").report("Webview vscode-resource: uris",Ne(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,R,"f").$setHtml(Ne(this,D,"f"),f))}get options(){return this.assertNotDisposed(),Ne(this,v,"f")}set options(f){this.assertNotDisposed(),Ne(this,R,"f").$setOptions(Ne(this,D,"f"),t(Ne(this,h,"f"),Ne(this,E,"f"),f)),nt(this,v,f,"f")}async postMessage(f){if(Ne(this,I,"f"))return!1;const l=(0,i.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:Ne(this,a,"f")});return Ne(this,R,"f").$postMessage(Ne(this,D,"f"),l.message,...l.buffers)}assertNotDisposed(){if(Ne(this,I,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,D=new WeakMap,R=new WeakMap,P=new WeakMap,u=new WeakMap,E=new WeakMap,h=new WeakMap,p=new WeakMap,v=new WeakMap,I=new WeakMap,w=new WeakMap,a=new WeakMap,r=new WeakMap;function o(c){try{const f=(0,C.normalizeVersion)((0,C.parseVersion)(c.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;class _{constructor(f,l,b,T,A){this.initData=l,this.workspace=b,this._logService=T,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=f.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(f,l,...b){const T=this.getWebview(f);if(T){const{message:A}=(0,i.deserializeWebviewMessage)(l,b);T._onMessageEmitter.fire(A)}}$onMissingCsp(f,l){this._logService.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,l,b){const T=new g(f,this._webviewProxy,s(l),this.initData,this.workspace,b,this._deprecationService);return this._webviews.set(f,T),T._onDidDispose(()=>{this._webviews.delete(f)}),T}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=_;function n(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=n;function t(c,f,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||d(c,f)}}e.serializeWebviewOptions=t;function s(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(f=>y.URI.from(f))}}e.reviveOptions=s;function d(c,f){return[...(f?.getWorkspaceFolders()||[]).map(l=>l.uri),c.extensionLocation]}}),define(pe[255],ve([0,1,21,47,6,10,23,2,17,68,87,5,7]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(o,_){this.document=o,this._storagePath=_,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(o){return this._edits.add([o])}async undo(o,_){await this.getEdit(o).undo(),_||this.disposeBackup()}async redo(o,_){await this.getEdit(o).redo(),_||this.disposeBackup()}disposeEdits(o){for(const _ of o)this._edits.delete(_)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const o=r(this.document.uri)+this._backupCounter++;return(0,i.joinPath)(this._storagePath,o)}updateBackup(o){this._backup?.delete(),this._backup=o}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(o){const _=this._edits.get(o,0);if(!_)throw new Error("No edit found");return _}}class h{constructor(){this._documents=new Map}get(o,_){return this._documents.get(this.key(o,_))}add(o,_,n){const t=this.key(o,_.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${o} resource:${_.uri}`);const s=new E(_,n);return this._documents.set(t,s),s}delete(o,_){const n=this.key(o,_.uri);this._documents.delete(n)}key(o,_){return`${o}@@@${_}`}}var p;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(p||(p={}));class v{constructor(){this._providers=new Map}addTextProvider(o,_,n){return this.add(0,o,_,n)}addCustomProvider(o,_,n){return this.add(1,o,_,n)}get(o){return this._providers.get(o)}add(o,_,n,t){if(this._providers.has(_))throw new Error(`Provider for viewType:${_} already registered`);return this._providers.set(_,{type:o,extension:n,provider:t}),new u.Disposable(()=>this._providers.delete(_))}}class I{constructor(o,_,n,t,s){this._extHostDocuments=_,this._extensionStoragePaths=n,this._extHostWebview=t,this._extHostWebviewPanels=s,this._editorProviders=new v,this._documents=new h,this._proxy=o.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,_,n,t){const s=new y.DisposableStore;return w(n)?(s.add(this._editorProviders.addTextProvider(_,o,n)),this._proxy.$registerTextEditorProvider((0,D.toExtensionData)(o),_,t.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,D.shouldSerializeBuffersForPostMessage)(o))):(s.add(this._editorProviders.addCustomProvider(_,o,n)),this.supportEditing(n)&&s.add(n.onDidChangeCustomDocument(d=>{const c=this.getCustomDocumentEntry(_,d.document.uri);if(a(d)){const f=c.addEdit(d);this._proxy.$onDidEdit(d.document.uri,_,f,d.label)}else this._proxy.$onContentChange(d.document.uri,_)})),this._proxy.$registerCustomEditorProvider((0,D.toExtensionData)(o),_,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,D.shouldSerializeBuffersForPostMessage)(o))),u.Disposable.from(s,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(_)}))}async $createCustomDocument(o,_,n,t,s){const d=this._editorProviders.get(_);if(!d)throw new Error(`No provider found for '${_}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${_}'`);const c=k.URI.revive(o),f=await d.provider.openCustomDocument(c,{backupId:n,untitledDocumentData:t?.buffer},s);let l;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(l=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(_,f,l),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(o,_){const n=this._editorProviders.get(_);if(!n)throw new Error(`No provider found for '${_}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${_}'`);const t=k.URI.revive(o),{document:s}=this.getCustomDocumentEntry(_,t);this._documents.delete(_,s),s.dispose()}async $resolveWebviewEditor(o,_,n,t,s,d){const c=this._editorProviders.get(n);if(!c)throw new Error(`No provider found for '${n}'`);const f=S.ViewColumn.to(s),l=this._extHostWebview.createNewWebview(_,t.webviewOptions,c.extension),b=this._extHostWebviewPanels.createNewWebviewPanel(_,n,t.title,f,t.panelOptions,l),T=k.URI.revive(o);switch(c.type){case 1:{const{document:A}=this.getCustomDocumentEntry(n,T);return c.provider.resolveCustomEditor(A,b,d)}case 0:{const A=this._extHostDocuments.getDocument(T);return c.provider.resolveCustomTextEditor(A,b,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,_,n){this.getCustomDocumentEntry(_,o).disposeEdits(n)}async $onMoveCustomEditor(o,_,n){const t=this._editorProviders.get(n);if(!t)throw new Error(`No provider found for '${n}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const s=this._extHostWebviewPanels.getWebviewPanel(o);if(!s)throw new Error("No webview found");const d=k.URI.revive(_),c=this._extHostDocuments.getDocument(d);await t.provider.moveCustomTextEditor(c,s,m.CancellationToken.None)}async $undo(o,_,n,t){return this.getCustomDocumentEntry(_,o).undo(n,t)}async $redo(o,_,n,t){return this.getCustomDocumentEntry(_,o).redo(n,t)}async $revert(o,_,n){const t=this.getCustomDocumentEntry(_,o);await this.getCustomEditorProvider(_).revertCustomDocument(t.document,n),t.disposeBackup()}async $onSave(o,_,n){const t=this.getCustomDocumentEntry(_,o);await this.getCustomEditorProvider(_).saveCustomDocument(t.document,n),t.disposeBackup()}async $onSaveAs(o,_,n,t){const s=this.getCustomDocumentEntry(_,o);return this.getCustomEditorProvider(_).saveCustomDocumentAs(s.document,k.URI.revive(n),t)}async $backup(o,_,n){const t=this.getCustomDocumentEntry(_,o),d=await this.getCustomEditorProvider(_).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},n);return t.updateBackup(d),d.id}getCustomDocumentEntry(o,_){const n=this._documents.get(o,k.URI.revive(_));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(o){const n=this._editorProviders.get(o)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(o){return!!o.onDidChangeCustomDocument}}e.ExtHostCustomEditors=I;function w(g){return typeof g.resolveCustomTextEditor=="function"}function a(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function r(g){const o=g.scheme===C.Schemas.file||g.scheme===C.Schemas.untitled?g.fsPath:g.toString();return(0,F.hash)(o)+""}});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,F,y){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(pe[256],ve([0,1,3,6,2,32,17,68,5,7]),function(Y,e,m,F,y,C,i,k,S,D){"use strict";var R,P,u,E,h,p,v,I,w,a,r,g,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class _ extends F.Disposable{constructor(d,c,f,l,b,T,A){super();R.set(this,void 0),P.set(this,void 0),u.set(this,void 0),E.set(this,void 0),h.set(this,void 0),p.set(this,void 0),v.set(this,void 0),I.set(this,void 0),w.set(this,!0),a.set(this,!0),r.set(this,!1),g.set(this,this._register(new m.Emitter)),this.onDidDispose=Ne(this,g,"f").event,o.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Ne(this,o,"f").event,nt(this,R,d,"f"),nt(this,P,c,"f"),nt(this,u,f,"f"),nt(this,h,T,"f"),nt(this,I,b,"f"),nt(this,p,l,"f"),nt(this,E,A,"f")}dispose(){Ne(this,r,"f")||(nt(this,r,!0,"f"),Ne(this,g,"f").fire(),Ne(this,P,"f").$disposeWebview(Ne(this,R,"f")),Ne(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ne(this,E,"f")}get viewType(){return this.assertNotDisposed(),Ne(this,u,"f")}get title(){return this.assertNotDisposed(),Ne(this,p,"f")}set title(d){this.assertNotDisposed(),Ne(this,p,"f")!==d&&(nt(this,p,d,"f"),Ne(this,P,"f").$setTitle(Ne(this,R,"f"),d))}get iconPath(){return this.assertNotDisposed(),Ne(this,v,"f")}set iconPath(d){this.assertNotDisposed(),Ne(this,v,"f")!==d&&(nt(this,v,d,"f"),Ne(this,P,"f").$setIconPath(Ne(this,R,"f"),y.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Ne(this,h,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ne(this,I,"f")=="number"&&Ne(this,I,"f")<0))return Ne(this,I,"f")}get active(){return this.assertNotDisposed(),Ne(this,a,"f")}get visible(){return this.assertNotDisposed(),Ne(this,w,"f")}_updateViewState(d){Ne(this,r,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(nt(this,a,d.active,"f"),nt(this,w,d.visible,"f"),nt(this,I,d.viewColumn,"f"),Ne(this,o,"f").fire({webviewPanel:this}))}reveal(d,c){this.assertNotDisposed(),Ne(this,P,"f").$reveal(Ne(this,R,"f"),{viewColumn:d?i.ViewColumn.from(d):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Ne(this,r,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,P=new WeakMap,u=new WeakMap,E=new WeakMap,h=new WeakMap,p=new WeakMap,v=new WeakMap,I=new WeakMap,w=new WeakMap,a=new WeakMap,r=new WeakMap,g=new WeakMap,o=new WeakMap;class n{constructor(d,c,f){this.webviews=c,this.workspace=f,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(d,c,f,l,b={}){const T=typeof l=="object"?l.viewColumn:l,A={viewColumn:i.ViewColumn.from(T),preserveFocus:typeof l=="object"&&!!l.preserveFocus},U=(0,k.shouldSerializeBuffersForPostMessage)(d),B=n.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(d),B,c,{title:f,panelOptions:t(b),webviewOptions:(0,k.serializeWebviewOptions)(d,this.workspace,b),serializeBuffersForPostMessage:U},A);const L=this.webviews.createNewWebview(B,b,d);return this.createNewWebviewPanel(B,c,f,T,b,L)}$onDidChangeWebviewPanelViewStates(d){const c=Object.keys(d);c.sort((f,l)=>{const b=d[f],T=d[l];return b.active?1:T.active?-1:+b.visible-+T.visible});for(const f of c){const l=this.getWebviewPanel(f);if(!l)continue;const b=d[f];l._updateViewState({active:b.active,visible:b.visible,viewColumn:i.ViewColumn.to(b.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,c,f){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:f,extension:d}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(d)}),new D.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(d,c,f,l){const b=this._serializers.get(c);if(!b)throw new Error(`No serializer found for '${c}'`);const{serializer:T,extension:A}=b,U=this.webviews.createNewWebview(d,f.webviewOptions,A),B=this.createNewWebviewPanel(d,c,f.title,l,f.panelOptions,U);await T.deserializeWebviewPanel(B,f.state)}createNewWebviewPanel(d,c,f,l,b,T){const A=new _(d,this._proxy,c,f,l,b,T);return this._webviewPanels.set(d,A),A}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=n;function t(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,F,y){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(pe[257],ve([0,1,3,6,68,5,7]),function(Y,e,m,F,y,C,i){"use strict";var k,S,D,R,P,u,E,h,p,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class I extends F.Disposable{constructor(r,g,o,_,n,t){super();k.set(this,void 0),S.set(this,void 0),D.set(this,void 0),R.set(this,void 0),P.set(this,!1),u.set(this,void 0),E.set(this,void 0),h.set(this,void 0),p.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Ne(this,p,"f").event,v.set(this,this._register(new m.Emitter)),this.onDidDispose=Ne(this,v,"f").event,nt(this,D,o,"f"),nt(this,E,_,"f"),nt(this,k,r,"f"),nt(this,S,g,"f"),nt(this,R,n,"f"),nt(this,u,t,"f")}dispose(){Ne(this,P,"f")||(nt(this,P,!0,"f"),Ne(this,v,"f").fire(),Ne(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ne(this,E,"f")}set title(r){this.assertNotDisposed(),Ne(this,E,"f")!==r&&(nt(this,E,r,"f"),Ne(this,S,"f").$setWebviewViewTitle(Ne(this,k,"f"),r))}get description(){return this.assertNotDisposed(),Ne(this,h,"f")}set description(r){this.assertNotDisposed(),Ne(this,h,"f")!==r&&(nt(this,h,r,"f"),Ne(this,S,"f").$setWebviewViewDescription(Ne(this,k,"f"),r))}get visible(){return Ne(this,u,"f")}get webview(){return Ne(this,R,"f")}get viewType(){return Ne(this,D,"f")}_setVisible(r){r===Ne(this,u,"f")||Ne(this,P,"f")||(nt(this,u,r,"f"),Ne(this,p,"f").fire())}show(r){this.assertNotDisposed(),Ne(this,S,"f").$show(Ne(this,k,"f"),!!r)}assertNotDisposed(){if(Ne(this,P,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,S=new WeakMap,D=new WeakMap,R=new WeakMap,P=new WeakMap,u=new WeakMap,E=new WeakMap,h=new WeakMap,p=new WeakMap,v=new WeakMap;class w{constructor(r,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,g,o,_){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:o,extension:r}),this._proxy.$registerWebviewViewProvider((0,y.toExtensionData)(r),g,{retainContextWhenHidden:_?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new i.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(r,g,o,_,n){const t=this._viewProviders.get(g);if(!t)throw new Error(`No view provider found for '${g}'`);const{provider:s,extension:d}=t,c=this._extHostWebview.createNewWebview(r,{},d),f=new I(r,this._proxy,g,o,c,!0);this._webviewViews.set(r,f),await s.resolveWebviewView(f,{state:_},n)}async $onDidChangeWebviewViewVisibility(r,g){this.getWebviewView(r)._setVisible(g)}async $disposeWebviewView(r){const g=this.getWebviewView(r);this._webviewViews.delete(r),g.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const g=this._webviewViews.get(r);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=w}),define(pe[133],ve([0,1,3,5,2,10,8,4,14]),function(Y,e,m,F,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class zi{constructor(P){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=zi.InitialState,this._proxy=P.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(u=>this.$onDidChangeWindowFocus(u))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state={...this._state,focused:P},this._onDidChangeWindowState.fire(this._state))}openUri(P,u){let E;if(typeof P=="string"){E=P;try{P=y.URI.parse(P)}catch(h){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,i.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,E,u)}async asExternalUri(P,u){if((0,i.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(P,u);return y.URI.from(E)}};D.InitialState={focused:!0},D=je([He(0,S.IExtHostRpcService)],D),e.ExtHostWindow=D,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(pe[258],ve([0,1,9,81,32,38,6,5,2,14]),function(Y,e,m,F,y,C,i,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends i.Disposable{constructor(u,E){super();const h=u.getProxy(k.MainContext.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async p=>{const v=S.URI.file((0,m.join)((0,F.tmpdir)(),(0,y.generateUuid)()));return await h.$download(p,v),v})}};R=je([He(0,D.IExtHostRpcService),He(1,C.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(pe[259],ve([0,1,131,10,187,32]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class i extends m.ExtHostLoggerService{doCreateLogger(S,D,R){return S.scheme===F.Schemas.file?new y.SpdLogLogger(R?.name||(0,C.generateUuid)(),S.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,D):super.doCreateLogger(S,D,R)}}e.ExtHostLoggerService=i}),define(pe[260],ve([0,1,60,9,2,67,6,10,18,28]),function(Y,e,m,F,y,C,i,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(o){const _=await super._getWorkspaceStorageURI(o);if(_.scheme!==k.Schemas.file)return _;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${_.fsPath}.`),_;const n=_.fsPath;let t=0;do{let s;t===0?s=n:s=/[/\\]$/.test(n)?`${n.substr(0,n.length-1)}-${t}`:`${n}-${t}`,await P(s);const d=F.join(s,"vscode.lock"),c=await p(this._logService,d,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),y.URI.file(s);t++}while(t<10);return _}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function P(g){try{await D.Promises.stat(g);return}catch{}try{await D.Promises.mkdir(g,{recursive:!0})}catch{}}const u=1e3,E=10*60*1e3;class h extends i.Disposable{constructor(o,_){super();this.logService=o,this.filename=_,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const n=await v(o,_);(!n||n.pid!==process.pid)&&(o.info(`Lock '${_}': The lock was lost unexpectedly.`),this._timer.cancel());try{await D.Promises.utimes(_,new Date,new Date)}catch(t){o.error(t),o.info(`Lock '${_}': Could not update mtime.`)}},u)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch(o){}}async setWillRelease(o){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const _={pid:process.pid,willReleaseAt:Date.now()+o};await D.Promises.writeFile(this.filename,JSON.stringify(_),{flag:"w"})}catch(_){this.logService.error(_)}}}async function p(g,o,_){try{const t={pid:process.pid,willReleaseAt:0};await D.Promises.writeFile(o,JSON.stringify(t),{flag:"wx"})}catch(t){g.error(t)}const n=await v(g,o);return!n||n.pid!==process.pid?_?(g.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),a(g,o)):(g.info(`Lock '${o}': Lock acquired.`),new h(g,o))}async function v(g,o){let _;try{_=await D.Promises.readFile(o)}catch(n){return g.error(n),null}try{return JSON.parse(String(_))}catch(n){return g.error(n),null}}async function I(g,o){let _;try{_=await D.Promises.stat(o)}catch(n){return g.error(n),0}return _.mtime.getTime()}function w(g){try{return process.kill(g,0),!0}catch(o){return!1}}async function a(g,o){const _=await v(g,o);if(!_)return g.info(`Lock '${o}': Could not read pid of lock holder.`),r(g,o);if(_.willReleaseAt){let c=_.willReleaseAt-Date.now();if(c<5e3){for(c>0?g.info(`Lock '${o}': The lockfile is scheduled to be released in ${c} ms.`):g.info(`Lock '${o}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,S.timeout)(Math.min(100,c)),await I(g,o)===0)return r(g,o);c=_.willReleaseAt-Date.now()}return r(g,o)}}if(!w(_.pid))return g.info(`Lock '${o}': The pid ${_.pid} appears to be gone.`),r(g,o);const n=await I(g,o),t=Date.now()-n;if(t<=E)return g.info(`Lock '${o}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;g.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const s=await I(g,o),d=Date.now()-s;return d<=E?(g.info(`Lock '${o}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(g.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),r(g,o))}async function r(g,o){g.info(`Lock '${o}': Deleting a stale lock.`);try{await D.Promises.unlink(o)}catch(_){}return p(g,o,!0)}}),define(pe[261],ve([0,1,32,14,34]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends y.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,S,D){return this.createTerminalFromOptions({name:k,shellPath:S,shellArgs:D})}createTerminalFromOptions(k,S){const D=new y.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),k,k.name);return this._terminals.push(D),D.create(k,this._serializeParentTerminal(k,S)),D.value}};C=je([He(0,F.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(pe[262],ve([0,1,5,14,170,6,26,2,37,23,28,7,12,52,3,120,77,11]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(f,l,b){this.remoteAddress=f,this.localAddress=l,this._dispose=b,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function a(c){const f=c.trim().split(`
`),l=[];return f.forEach(T=>{const A=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);A&&A.length>=3&&l.push({pid:parseInt(A[1],10),socket:parseInt(A[2],10)})}),l.reduce((T,A)=>(T[A.socket]=A,T),{})}e.getSockets=a;function r(...c){const f=[].concat(...c.map(o));return[...new Map(f.filter(l=>l.st==="0A").map(l=>{const b=l.local_address.split(":");return{socket:parseInt(l.inode,10),ip:g(b[0]),port:parseInt(b[1],16)}}).map(l=>[l.ip+":"+l.port,l])).values()]}e.loadListeningPorts=r;function g(c){let f="";if(c.length===8)for(let l=c.length-2;l>=0;l-=2)f+=parseInt(c.substr(l,2),16),l!==0&&(f+=".");else for(let l=c.length-4;l>=0;l-=4)f+=parseInt(c.substr(l,4),16).toString(16),l!==0&&(f+=":");return f}e.parseIpAddress=g;function o(c){const f=c.trim().split(`
`),l=f.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return f.map(T=>T.trim().split(/\s+/).reduce((A,U,B)=>(A[l[B]||B]=U,A),{}))}e.loadConnectionTable=o;function _(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/vs/server/main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function n(c){const f=c.trim().split(`
`),l=[];return f.forEach(b=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(b);T&&T.length>=4&&l.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),l}e.getRootProcesses=n;async function t(c,f,l){const b=l.reduce((A,U)=>(A[U.pid]=U,A),{}),T=[];return c.forEach(({socket:A,ip:U,port:B})=>{const L=f[A]?f[A].pid:void 0,x=L?b[L]?.cmd:void 0;L&&x&&!_(x)&&T.push({host:U,port:B,detail:x,pid:L})}),T}e.findPorts=t;function s(c,f,l){const b=new Map,T=n(f);for(const A of c){const U=l.get(A.port);if(U){b.set(A.port,U);continue}const B=T.find(L=>L.cmd.includes(`${A.port}`));if(B){let L=B,x;do x=T.find(M=>M.ppid===L.pid),x&&(L=x);while(x);b.set(A.port,{host:A.ip,port:A.port,pid:L.pid,detail:L.cmd,ppid:L.ppid})}else b.set(A.port,{host:A.ip,port:A.port,ppid:Number.MAX_VALUE})}return b}e.tryFindRootPorts=s;let d=class extends C.Disposable{constructor(f,l,b){super();this.logService=b,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=f.getProxy(m.MainContext.MainThreadTunnelService),u.isLinux&&l.remote.isRemote&&l.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(f,l){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${l.remoteAddress.host}:${l.remoteAddress.port}.`);const b=await this._proxy.$openTunnel(l,f.displayName);if(b){const T=new w(b.remoteAddress,b.localAddress,()=>this._proxy.$closeTunnel(b.remoteAddress));return this._register(T),T}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(f){return Math.max(f*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(f,l){const b=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(b,{selector:f,provider:l}),this._proxy.$registerPortsAttributesProvider(f,b),new P.Disposable(()=>{this._portAttributesProviders.delete(b),this._proxy.$unregisterPortsAttributesProvider(b)})}async $providePortAttributes(f,l,b,T,A){const U=[];for(const L of f){const x=this._portAttributesProviders.get(L);if(!x)return[];U.push(...await Promise.all(l.map(async M=>x.provider.providePortAttributes(M,b,T,A))))}const B=U.filter(L=>!!L);return B.length>0?B.map(L=>({autoForwardAction:L.autoForwardAction,port:L.port})):[]}async $registerCandidateFinder(f){if(f&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=f;let l=new v.MovingAverage,b;for(;this._candidateFindingEnabled;){const T=new Date().getTime(),A=(await this.findCandidatePorts()).filter(B=>(0,p.isLocalhost)(B.host)||(0,p.isAllInterfaces)(B.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${A.map(B=>B.port).join(", ")}`);const U=new Date().getTime()-T;l.update(U),(!b||JSON.stringify(b)!==JSON.stringify(A))&&(b=A,await this._proxy.$onFoundNewCandidates(b)),await new Promise(B=>setTimeout(()=>B(),this.calculateDelay(l.value)))}}async setTunnelExtensionFunctions(f){if(f){if(f.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this._showCandidatePort=f.showCandidatePort,this._proxy.$setCandidateFilter()),f.tunnelFactory){this._forwardPortProvider=f.tunnelFactory;let l=f.tunnelFeatures?.privacyOptions??[];f.tunnelFeatures?.public&&l.length===0&&(l=[{id:"private",label:y.localize(0,null),themeIcon:"lock"},{id:"public",label:y.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!f.tunnelFeatures?.elevation,public:!!f.tunnelFeatures?.public,privacyOptions:l})}}else this._forwardPortProvider=void 0;return(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(f,l){if(this._extensionTunnels.has(f.host)){const b=this._extensionTunnels.get(f.host);b.has(f.port)&&(l&&b.get(f.port).disposeListener.dispose(),await b.get(f.port).tunnel.dispose(),b.delete(f.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(f,l){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const b=this._forwardPortProvider(f,l);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),b!==void 0){const T=await b;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(f.remoteAddress.host)||this._extensionTunnels.set(f.remoteAddress.host,new Map);const A=this._register(T.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(T.remoteAddress))));return this._extensionTunnels.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:T,disposeListener:A}),E.TunnelDto.fromApiTunnel(T)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(b){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(f){const l=await Promise.all(f.map(T=>this._showCandidatePort(T.host,T.port,T.detail??""))),b=f.filter((T,A)=>l[A]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(T=>T.port).join(", ")} to ${b.map(T=>T.port).join(", ")}`),b}async findCandidatePorts(){let f="",l="";try{f=await R.Promises.readFile("/proc/net/tcp","utf8"),l=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch(O){}const b=r(f,l),T=await new Promise(O=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(W,q,N)=>{O(q)})}),A=a(T),U=await R.Promises.readdir("/proc"),B=[];for(let O of U)try{const W=Number(O),q=D.joinPath(k.URI.file("/proc"),O);if((await R.Promises.stat(q.fsPath)).isDirectory()&&!isNaN(W)){const G=await R.Promises.readlink(D.joinPath(q,"cwd").fsPath),$=await R.Promises.readFile(D.joinPath(q,"cmdline").fsPath,"utf8");B.push({pid:W,cwd:G,cmd:$})}}catch(W){}const L=[],x=b.filter(O=>{const W=A[O.socket];return W||L.push(O),W}),M=t(x,A,B);let V;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${L.length}`),L.length>0){const O=await new Promise(W=>{(0,S.exec)("ps -F -A -l | grep root",(q,N,G)=>{W(N)})});this._foundRootPorts=s(L,O,this._foundRootPorts),V=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${V.join(", ")}`)}return M.then(O=>V?O.concat(V):O)}};d=je([He(0,F.IExtHostRpcService),He(1,i.IExtHostInitDataService),He(2,I.ILogService)],d),e.ExtHostTunnelService=d}),define(pe[263],ve([0,1,18,22,21,15,3,6,102,227,53]),function(Y,e,m,F,y,C,i,k,S,D,R){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function u(b,T){try{return JSON.stringify(b,T)}catch(A){return"null"}}const E="$$ref$$",h={[E]:-1};class p{constructor(T,A){this.jsonString=T,this.referencedBuffers=A}}function v(b,T=null,A=!1){const U=[];return{jsonString:(A?u:JSON.stringify)(b,(L,x)=>{if(typeof x=="undefined")return h;if(typeof x=="object"){if(x instanceof F.VSBuffer){const M=U.push(x)-1;return{[E]:M}}if(T)return T(L,x)}return x}),referencedBuffers:U}}e.stringifyJsonWithBufferRefs=v;function I(b,T,A){return JSON.parse(b,(U,B)=>{if(B){const L=B[E];if(typeof L=="number")return T[L];if(A&&B.$mid===1)return A.transformIncoming(B)}return B})}e.parseJsonAndRestoreBufferRefs=I;function w(b,T){return JSON.stringify(b,T)}function a(b){return b?(T,A)=>A&&A.$mid===1?b.transformOutgoing(A):A:null}var r;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(r=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const o=()=>{},_=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class t extends k.Disposable{constructor(T,A=null,U=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new i.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=A,this._uriTransformer=U,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let B=0,L=R.ProxyIdentifier.count;B<L;B++)this._locals[B]=null,this._proxies[B]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(B=>this._receiveOneMessage(B))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{this._pendingRPCReplies[T].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,S.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:A,sid:U}=T;return this._proxies[A]||(this._proxies[A]=this._createProxy(A,U)),this._proxies[A]}_createProxy(T,A){let U={get:(B,L)=>(typeof L=="string"&&!B[L]&&L.charCodeAt(0)===36&&(B[L]=(...x)=>this._remoteCall(T,L,x)),L===n?A:B[L])};return new Proxy(Object.create(null),U)}set(T,A){return this._locals[T.nid]=A,A}assertRegistered(T){for(let A=0,U=T.length;A<U;A++){const B=T[A];if(!this._locals[B.nid])throw new Error(`Missing actor ${B.sid} (isMain: ${B.isMain})`)}}_receiveOneMessage(T){if(this._isDisposed)return;const A=T.byteLength,U=s.read(T,0),B=U.readUInt8(),L=U.readUInt32();switch(B){case 1:case 2:{let{rpcId:x,method:M,args:V}=c.deserializeRequestJSONArgs(U);this._uriTransformer&&(V=(0,S.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(A,L,x,M,V,B===2);break}case 3:case 4:{let{rpcId:x,method:M,args:V}=c.deserializeRequestMixedArgs(U);this._uriTransformer&&(V=(0,S.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(A,L,x,M,V,B===4);break}case 5:{this._logger&&this._logger.logIncoming(A,L,0,"ack"),this._onDidReceiveAcknowledge(L);break}case 6:{this._receiveCancel(A,L);break}case 7:{this._receiveReply(A,L,void 0);break}case 9:{let x=c.deserializeReplyOKJSON(U);this._uriTransformer&&(x=(0,S.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(A,L,x);break}case 10:{const x=c.deserializeReplyOKJSONWithBuffers(U,this._uriTransformer);this._receiveReply(A,L,x);break}case 8:{let x=c.deserializeReplyOKVSBuffer(U);this._receiveReply(A,L,x);break}case 11:{let x=c.deserializeReplyErrError(U);this._uriTransformer&&(x=(0,S.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(A,L,x);break}case 12:{this._receiveReplyErr(A,L,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,A,U,B,L,x){this._logger&&this._logger.logIncoming(T,A,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(U)}.${B}(`,L);const M=String(A);let V,O;if(x){const q=new y.CancellationTokenSource;L.push(q.token),V=this._invokeHandler(U,B,L),O=()=>q.cancel()}else V=this._invokeHandler(U,B,L),O=o;this._cancelInvokedHandlers[M]=O;const W=c.serializeAcknowledged(A);this._logger&&this._logger.logOutgoing(W.byteLength,A,1,"ack"),this._protocol.send(W),V.then(q=>{delete this._cancelInvokedHandlers[M];const N=c.serializeReplyOK(A,q,this._uriReplacer);this._logger&&this._logger.logOutgoing(N.byteLength,A,1,"reply:",q),this._protocol.send(N)},q=>{delete this._cancelInvokedHandlers[M];const N=c.serializeReplyErr(A,q);this._logger&&this._logger.logOutgoing(N.byteLength,A,1,"replyErr:",q),this._protocol.send(N)})}_receiveCancel(T,A){this._logger&&this._logger.logIncoming(T,A,1,"receiveCancel");const U=String(A);this._cancelInvokedHandlers[U]&&this._cancelInvokedHandlers[U]()}_receiveReply(T,A,U){this._logger&&this._logger.logIncoming(T,A,0,"receiveReply:",U);const B=String(A);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const L=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B],L.resolveOk(U)}_receiveReplyErr(T,A,U){this._logger&&this._logger.logIncoming(T,A,0,"receiveReplyErr:",U);const B=String(A);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const L=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B];let x;U&&(U.$isError?(x=new Error,x.name=U.name,x.message=U.message,x.stack=U.stack):x=U),L.resolveErr(x)}_invokeHandler(T,A,U){try{return Promise.resolve(this._doInvokeHandler(T,A,U))}catch(B){return Promise.reject(B)}}_doInvokeHandler(T,A,U){const B=this._locals[T];if(!B)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(T));let L=B[A];if(typeof L!="function")throw new Error("Unknown method "+A+" on actor "+(0,R.getStringIdentifierForProxy)(T));return L.apply(B,U)}_remoteCall(T,A,U){if(this._isDisposed)return Promise.reject(C.canceled());let B=null;if(U.length>0&&y.CancellationToken.isCancellationToken(U[U.length-1])&&(B=U.pop()),B&&B.isCancellationRequested)return Promise.reject(C.canceled());const L=c.serializeRequestArguments(U,this._uriReplacer),x=++this._lastMessageId,M=String(x),V=new D.LazyPromise;B&&B.onCancellationRequested(()=>{const W=c.serializeCancel(x);this._logger&&this._logger.logOutgoing(W.byteLength,x,0,"cancel"),this._protocol.send(c.serializeCancel(x))}),this._pendingRPCReplies[M]=V,this._onWillSendRequest(x);const O=c.serializeRequest(x,T,A,L,!!B);return this._logger&&this._logger.logOutgoing(O.byteLength,x,0,`request: ${(0,R.getStringIdentifierForProxy)(T)}.${A}(`,U),this._protocol.send(O),V}}e.RPCProtocol=t,P=_,t.UNRESPONSIVE_TIME=3*1e3;class s{constructor(T,A){this._buff=T,this._offset=A}static alloc(T,A,U){let B=new s(F.VSBuffer.alloc(U+1+4),0);return B.writeUInt8(T),B.writeUInt32(A),B}static read(T,A){return new s(T,A)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const U=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,U}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,U}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,A}static sizeMixedArray(T){let A=0;A+=1;for(let U=0,B=T.length;U<B;U++){const L=T[U];switch(A+=1,L.type){case 1:A+=this.sizeLongString(L.value);break;case 2:A+=this.sizeVSBuffer(L.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(L.value);for(let x=0;x<L.buffers.length;++x)A+=this.sizeVSBuffer(L.buffers[x]);break;case 4:break}}return A}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let A=0,U=T.length;A<U;A++){const B=T[A];switch(B.type){case 1:this.writeUInt8(1),this.writeLongString(B.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(B.value);break;case 3:this.writeUInt8(3),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let L=0;L<B.buffers.length;++L)this.writeBuffer(B.buffers[L]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;let A=new Array(T);for(let U=0;U<T;U++)switch(this.readUInt8()){case 1:A[U]=this.readLongString();break;case 2:A[U]=this.readVSBuffer();break;case 3:const L=this.readUInt32(),x=this.readLongString(),M=[];for(let V=0;V<L;++V)M.push(this.readVSBuffer());A[U]=new R.SerializableObjectWithBuffers(I(x,M,null));break;case 4:A[U]=void 0;break}return A}}s.sizeUInt32=4;var d;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(d||(d={}));class c{static _useMixedArgSerialization(T){for(let A=0,U=T.length;A<U;A++)if(T[A]instanceof F.VSBuffer||T[A]instanceof R.SerializableObjectWithBuffers||typeof T[A]=="undefined")return!0;return!1}static serializeRequestArguments(T,A){if(this._useMixedArgSerialization(T)){const U=[];for(let B=0,L=T.length;B<L;B++){const x=T[B];if(x instanceof F.VSBuffer)U[B]={type:2,value:x};else if(typeof x=="undefined")U[B]={type:4};else if(x instanceof R.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:V}=v(x.value,A);U[B]={type:3,value:F.VSBuffer.fromString(M),buffers:V}}else U[B]={type:1,value:F.VSBuffer.fromString(w(x,A))}}return{type:1,args:U}}return{type:0,args:w(T,A)}}static serializeRequest(T,A,U,B,L){switch(B.type){case 0:return this._requestJSONArgs(T,A,U,B.args,L);case 1:return this._requestMixedArgs(T,A,U,B.args,L)}}static _requestJSONArgs(T,A,U,B,L){const x=F.VSBuffer.fromString(U),M=F.VSBuffer.fromString(B);let V=0;V+=s.sizeUInt8(),V+=s.sizeShortString(x),V+=s.sizeLongString(M);let O=s.alloc(L?2:1,T,V);return O.writeUInt8(A),O.writeShortString(x),O.writeLongString(M),O.buffer}static deserializeRequestJSONArgs(T){const A=T.readUInt8(),U=T.readShortString(),B=T.readLongString();return{rpcId:A,method:U,args:JSON.parse(B)}}static _requestMixedArgs(T,A,U,B,L){const x=F.VSBuffer.fromString(U);let M=0;M+=s.sizeUInt8(),M+=s.sizeShortString(x),M+=s.sizeMixedArray(B);let V=s.alloc(L?4:3,T,M);return V.writeUInt8(A),V.writeShortString(x),V.writeMixedArray(B),V.buffer}static deserializeRequestMixedArgs(T){const A=T.readUInt8(),U=T.readShortString(),B=T.readMixedArray(),L=new Array(B.length);for(let x=0,M=B.length;x<M;x++){const V=B[x];typeof V=="string"?L[x]=JSON.parse(V):L[x]=V}return{rpcId:A,method:U,args:L}}static serializeAcknowledged(T){return s.alloc(5,T,0).buffer}static serializeCancel(T){return s.alloc(6,T,0).buffer}static serializeReplyOK(T,A,U){if(typeof A=="undefined")return this._serializeReplyOKEmpty(T);if(A instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(T,A);if(A instanceof R.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:L}=v(A.value,U,!0);return this._serializeReplyOKJSONWithBuffers(T,B,L)}else return this._serializeReplyOKJSON(T,u(A,U))}static _serializeReplyOKEmpty(T){return s.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,A){let U=0;U+=s.sizeVSBuffer(A);let B=s.alloc(8,T,U);return B.writeVSBuffer(A),B.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,A){const U=F.VSBuffer.fromString(A);let B=0;B+=s.sizeLongString(U);let L=s.alloc(9,T,B);return L.writeLongString(U),L.buffer}static _serializeReplyOKJSONWithBuffers(T,A,U){const B=F.VSBuffer.fromString(A);let L=0;L+=s.sizeUInt32,L+=s.sizeLongString(B);for(const M of U)L+=s.sizeVSBuffer(M);let x=s.alloc(10,T,L);x.writeUInt32(U.length),x.writeLongString(B);for(const M of U)x.writeBuffer(M);return x.buffer}static deserializeReplyOKJSON(T){const A=T.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(T,A){const U=T.readUInt32(),B=T.readLongString(),L=[];for(let x=0;x<U;++x)L.push(T.readVSBuffer());return new R.SerializableObjectWithBuffers(I(B,L,A))}static serializeReplyErr(T,A){return A?this._serializeReplyErrEror(T,A):this._serializeReplyErrEmpty(T)}static _serializeReplyErrEror(T,A){const U=F.VSBuffer.fromString(u(C.transformErrorForSerialization(A),null));let B=0;B+=s.sizeLongString(U);let L=s.alloc(11,T,B);return L.writeLongString(U),L.buffer}static deserializeReplyErrError(T){const A=T.readLongString();return JSON.parse(A)}static _serializeReplyErrEmpty(T){return s.alloc(12,T,0).buffer}}var f;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var l;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(l||(l={}))}),define(pe[264],ve([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(pe[265],ve([0,1,10,9,12,2,4,62,43,222,264]),function(Y,e,m,F,y,C,i,k,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,i.createDecorator)("pathService");let P=class Vi{constructor(E,h,p,v){this.localUserHome=E,this.remoteAgentService=h,this.environmentService=p,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||y.OS)(),this.resolveUserHome=(async()=>{const I=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=I?.userHome||E})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(E,h){if(E.remoteAuthority)return m.Schemas.vscodeRemote;const p=(0,k.getVirtualWorkspaceScheme)(h.getWorkspace());if(p)return p;const v=h.getWorkspace().folders[0];if(v)return v.uri.scheme;const I=h.getWorkspace().configuration;return I?I.scheme:m.Schemas.file}async userHome(E){return E?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(E=>E===1?F.win32:F.posix)}async fileURI(E){let h="";if(await this.resolveOS===1&&(E=E.replace(/\\/g,"/")),E[0]==="/"&&E[1]==="/"){const v=E.indexOf("/",2);v===-1?(h=E.substring(2),E="/"):(h=E.substring(2,v),E=E.substring(v)||"/")}return C.URI.from({scheme:m.Schemas.file,authority:h,path:E,query:"",fragment:""})}};P=je([He(1,R.IRemoteAgentService),He(2,D.IWorkbenchEnvironmentService),He(3,S.IWorkspaceContextService)],P),e.AbstractPathService=P}),define(pe[69],ve([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(i,k){this.line=i,this.character=k}isBefore(i){return!1}isBeforeOrEqual(i){return!1}isAfter(i){return!1}isAfterOrEqual(i){return!1}isEqual(i){return!1}compareTo(i){return 0}translate(i,k){return new m(0,0)}with(i){return new m(0,0)}}e.Position=m;class F{constructor(i,k,S,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(i,k),this.end=new m(S,D)}contains(i){return!1}isEqual(i){return!1}intersection(i){}union(i){return new F(0,0,0,0)}with(i){return new F(0,0,0,0)}}e.Range=F;var y;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(pe[33],ve([0,1,16,31,25,30,8,4,9,15,69,13]),function(Y,e,m,F,y,C,i,k,S,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const u="\u27EA ",E=" characters skipped \u27EB",h=(u.length+E.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var p;(function(W){W[W.file=0]="file",W[W.text=1]="text"})(p=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(W){W[W.File=1]="File",W[W.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function I(W){return!!W.preview}e.resultIsMatch=I;function w(W){return!!W.resource}e.isFileMatch=w;function a(W){return!!W.message}e.isProgressMessage=a;var r;(function(W){W[W.Normal=0]="Normal",W[W.NewSearchStarted=1]="NewSearchStarted"})(r=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(q){this.resource=q,this.results=[]}}e.FileMatch=g;class o{constructor(q,N,G){this.ranges=N;const $=Array.isArray(N)?N:[N];if(G&&G.matchLines===1&&_($)){q=(0,i.getNLines)(q,G.matchLines);let H="",j=0,ie=0;const fe=Math.floor(G.charsPerLine/5),ye=[];for(const Ie of $){const Be=Math.max(Ie.startColumn-fe,0),We=Ie.startColumn+G.charsPerLine;if(Be>ie+fe+h){const ze=u+(Be-ie)+E;H+=ze+q.slice(Be,We),j+=Be-(ie+ze.length)}else H+=q.slice(ie,We);ye.push(new t(0,Ie.startColumn-j,Ie.endColumn-j)),ie=We}this.preview={text:H,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const H=Array.isArray(N)?N[0].startLineNumber:N.startLineNumber;this.preview={text:q,matches:(0,m.mapArrayOrNot)(N,j=>new n(j.startLineNumber-H,j.startColumn,j.endLineNumber-H,j.endColumn))}}}}e.TextSearchMatch=o;function _(W){const q=W[0].startLineNumber;for(const N of W)if(N.startLineNumber!==q||N.endLineNumber!==q)return!1;return!0}class n{constructor(q,N,G,$){this.startLineNumber=q,this.startColumn=N,this.endLineNumber=G,this.endColumn=$}}e.SearchRange=n;class t extends n{constructor(q,N,G){super(q,N,q,G)}}e.OneLineRange=t;var s;(function(W){W.Default="default",W.FileNames="fileNames",W.Type="type",W.Modified="modified",W.CountDescending="countDescending",W.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function d(W,q=!0){const N=W&&W.files&&W.files.exclude,G=q&&W&&W.search&&W.search.exclude;if(!N&&!G)return;if(!N||!G)return N||G;let $=Object.create(null);return $=y.mixin($,y.deepClone(N)),$=y.mixin($,y.deepClone(G),!0),$}e.getExcludes=d;function c(W,q){return W.excludePattern&&F.match(W.excludePattern,q)?!1:W.includePattern||W.usingSearchPaths?W.includePattern&&F.match(W.includePattern,q)?!0:W.usingSearchPaths?!!W.folderQueries&&W.folderQueries.some(N=>{const G=N.folder.fsPath;if(C.isEqualOrParent(q,G)){const $=S.relative(G,q);return!N.includePattern||!!F.match(N.includePattern,$)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var f;(function(W){W[W.unknownEncoding=1]="unknownEncoding",W[W.regexParseError=2]="regexParseError",W[W.globParseError=3]="globParseError",W[W.invalidLiteral=4]="invalidLiteral",W[W.rgProcessError=5]="rgProcessError",W[W.other=6]="other",W[W.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class l extends Error{constructor(q,N){super(q);this.code=N}}e.SearchError=l;function b(W){const q=W.message;if((0,D.isPromiseCanceledError)(W))return new l(q,f.canceled);try{const N=JSON.parse(q);return new l(N.message,N.code)}catch(N){return new l(q,f.other)}}e.deserializeSearchError=b;function T(W){const q={message:W.message,code:W.code};return new Error(JSON.stringify(q))}e.serializeSearchError=T;function A(W){return W.type==="error"?!0:W.type==="success"}e.isSerializedSearchComplete=A;function U(W){return W.type==="success"}e.isSerializedSearchSuccess=U;function B(W){return!!W.path}e.isSerializedFileMatch=B;function L(W,q){const N=W.searchPath?W.searchPath:W.relativePath;return(0,i.fuzzyContains)(N,q)}e.isFilePatternMatch=L;class x{constructor(q){this.path=q,this.results=[]}addMatch(q){this.results.push(q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function M(W,q){const N={...W||{},...q||{}};return Object.keys(N).filter(G=>{const $=N[G];return typeof $=="boolean"&&$})}e.resolvePatternsForProvider=M;class V{constructor(q,N){this._parsedIncludeExpression=null,this._excludeExpression={...q.excludePattern||{},...N.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let G=q.includePattern;N.includePattern&&(G?G={...G,...N.includePattern}:G=N.includePattern),G&&(this._parsedIncludeExpression=F.parse(G))}matchesExcludesSync(q,N,G){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(q,N,G))}includedInQuerySync(q,N,G){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(q,N,G)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(q,N,G))}includedInQuery(q,N,G){const $=this._parsedExcludeExpression(q,N,G),H=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(q,N,G):!0;return(0,P.isPromise)($)?$.then(j=>j?!1:H()):H()}hasSiblingExcludeClauses(){return O(this._excludeExpression)}}e.QueryGlobTester=V;function O(W){for(const q in W)if(typeof W[q]!="boolean")return!0;return!1}}),define(pe[35],ve([0,1,16,18,21,3,24,10,77,23,8,13,2,168,4,11,188,43,44,26,14,7,33,5]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I,w,a,r,g,o,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(T,A,U){return new D.ExtUri(B=>c(B,U)).isEqual(T,A)}function t(T,A,U){return n(T.uri,A.uri,U)?0:(0,R.compare)(T.uri.toString(),A.uri.toString())}function s(T,A,U){return T.index!==A.index?T.index<A.index?-1:1:n(T.uri,A.uri,U)?(0,R.compare)(T.name,A.name):(0,R.compare)(T.uri.toString(),A.uri.toString())}function d(T,A,U,B){const L=T.slice(0).sort((M,V)=>U(M,V,B)),x=A.slice(0).sort((M,V)=>U(M,V,B));return(0,m.delta)(L,x,(M,V)=>U(M,V,B))}function c(T,A){const U=A.getCapabilities(T.scheme);return!(U&&U&1024)}class f extends I.Workspace{constructor(A,U,B,L,x,M,V){super(A,B.map(O=>new I.WorkspaceFolder(O)),L,x,V);this._name=U,this._isUntitled=M,this._workspaceFolders=[],this._structure=i.TernarySearchTree.forUris(V),B.forEach(O=>{this._workspaceFolders.push(O),this._structure.set(O.uri,O)})}static toExtHostWorkspace(A,U,B,L){if(!A)return{workspace:null,added:[],removed:[]};const{id:x,name:M,folders:V,configuration:O,transient:W,isUntitled:q}=A,N=[],G=U;U?V.forEach((ie,fe)=>{const ye=u.URI.revive(ie.uri),Ie=f._findFolder(B||U,ye,L);Ie?(Ie.name=ie.name,Ie.index=ie.index,N.push(Ie)):N.push({uri:ye,name:ie.name,index:fe})}):N.push(...V.map(({uri:ie,name:fe,index:ye})=>({uri:u.URI.revive(ie),name:fe,index:ye}))),N.sort((ie,fe)=>ie.index<fe.index?-1:1);const $=new f(x,M,N,!!W,O?u.URI.revive(O):null,!!q,ie=>c(ie,L)),{added:H,removed:j}=d(G?G.workspaceFolders:[],$.workspaceFolders,t,L);return{workspace:$,added:H,removed:j}}static _findFolder(A,U,B){for(let L=0;L<A.folders.length;L++){const x=A.workspaceFolders[L];if(n(x.uri,U,B))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(A,U){return U&&this._structure.get(A)&&(A=(0,D.dirname)(A)),this._structure.findSubstr(A)}resolveWorkspaceFolder(A){return this._structure.get(A)}}let l=class{constructor(A,U,B,L){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=L,this._extHostFileSystemInfo=B,this._requestIdProvider=new S.Counter,this._barrier=new F.Barrier,this._proxy=A.getProxy(_.MainContext.MainThreadWorkspace),this._messageService=A.getProxy(_.MainContext.MainThreadMessageService);const x=U.workspace;this._confirmedWorkspace=x?new f(x.id,x.name,[],!!x.transient,x.configuration?u.URI.revive(x.configuration):null,!!x.isUntitled,M=>c(M,B)):void 0}$initializeWorkspace(A,U){this._trusted=U,this.$acceptWorkspaceData(A),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:k.Schemas.untitled,path:(0,D.basename)((0,D.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(A,U,B,...L){const x=[];if(Array.isArray(L)&&L.forEach(q=>{u.URI.isUri(q.uri)&&!x.some(N=>n(N.uri,q.uri,this._extHostFileSystemInfo))&&x.push({uri:q.uri,name:q.name||(0,D.basenameOrAuthority)(q.uri)})}),this._unconfirmedWorkspace||[U,B].some(q=>typeof q!="number"||q<0)||B===0&&x.length===0)return!1;const M=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+B>M.length)return!1;const V=M.slice(0);V.splice(U,B,...x.map(q=>({uri:q.uri,name:q.name||(0,D.basenameOrAuthority)(q.uri),index:void 0})));for(let q=0;q<V.length;q++){const N=V[q];if(V.some((G,$)=>$!==q&&n(N.uri,G.uri,this._extHostFileSystemInfo)))return!1}V.forEach((q,N)=>q.index=N);const{added:O,removed:W}=d(M,V,s,this._extHostFileSystemInfo);if(O.length===0&&W.length===0)return!1;if(this._proxy){const q=A.displayName||A.name;this._proxy.$updateWorkspaceFolders(q,U,B,x).then(void 0,N=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,E.localize)(0,null,q,N.toString()),{extension:A},[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(A,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,U)}async getWorkspaceFolder2(A,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,U)}async resolveWorkspaceFolder(A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(A)}getPath(){if(!this._actualWorkspace)return;const{folders:A}=this._actualWorkspace;if(A.length!==0)return A[0].uri.fsPath}getRelativePath(A,U){let B,L="";if(typeof A=="string"?(B=u.URI.file(A),L=A):typeof A!="undefined"&&(B=A,L=A.fsPath),!B)return L;const x=this.getWorkspaceFolder(B,!0);if(!x)return L;typeof U=="undefined"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let M=(0,D.relativePath)(x.uri,B);return U&&x.name&&(M=`${x.name}/${M}`),M}trySetWorkspaceFolders(A){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:A,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(A){const{workspace:U,added:B,removed:L}=f.toExtHostWorkspace(A,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:L}))}findFiles(A,U,B,L,x=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${L.value}, entryPoint: findFiles`);let M;if(U===null?M=!1:U&&(typeof U=="string"?M=U:M=U.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:O}=b(A);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)(V),(0,P.withUndefinedAsNull)(O),(0,P.withUndefinedAsNull)(M),(0,P.withUndefinedAsNull)(B),x).then(W=>Array.isArray(W)?W.map(q=>u.URI.revive(q)):[])}async findTextInFiles(A,U,B,L,x=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${L.value}, entryPoint: findTextInFiles`);const M=this._requestIdProvider.getNext(),V=typeof U.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:O,folder:W}=b(U.include),q=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,N={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:V,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:O,excludePattern:q},G=!1;if(this._activeSearchCallbacks[M]=$=>{if(G)return;const H=u.URI.revive($.resource);$.results.forEach(j=>{(0,o.resultIsMatch)(j)?B({uri:H,preview:{text:j.preview.text,matches:(0,m.mapArrayOrNot)(j.preview.matches,ie=>new g.Range(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,m.mapArrayOrNot)(j.ranges,ie=>new g.Range(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):B({uri:H,text:j.text,lineNumber:j.lineNumber})})},x.isCancellationRequested)return{};try{const $=await this._proxy.$startTextSearch(A,(0,P.withUndefinedAsNull)(W),N,M,x);return delete this._activeSearchCallbacks[M],$||{}}catch($){throw delete this._activeSearchCallbacks[M],$}}$handleTextSearchResult(A,U){this._activeSearchCallbacks[U]&&this._activeSearchCallbacks[U](A)}saveAll(A){return this._proxy.$saveAll(A)}resolveProxy(A){return this._proxy.$resolveProxy(A)}get trusted(){return this._trusted}requestWorkspaceTrust(A){return this._proxy.$requestWorkspaceTrust(A)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};l=je([He(0,r.IExtHostRpcService),He(1,a.IExtHostInitDataService),He(2,w.IExtHostFileSystemInfo),He(3,p.ILogService)],l),e.ExtHostWorkspace=l,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function b(T){let A,U;return T&&(typeof T=="string"?A=T:(A=T.pattern,U=T.baseFolder||u.URI.file(T.base))),{includePattern:A,folder:U}}}),define(pe[36],ve([0,1,25,3,35,5,7,192,118,13,18,4,14,11,2]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function p(_,n){if(n){const t=n.split(".");let s=_;for(let d=0;s&&d<t.length;d++)s=s[t[d]];return s}}function v(_){return _ instanceof h.URI}function I(_){return _&&_.uri instanceof h.URI&&_.languageId&&typeof _.languageId=="string"}function w(_){return _&&!_.uri&&_.languageId&&typeof _.languageId=="string"}function a(_){return _&&_.uri instanceof h.URI&&(!_.name||typeof _.name=="string")&&(!_.index||typeof _.index=="number")}function r(_){if(v(_))return{resource:_};if(I(_))return{resource:_.uri,overrideIdentifier:_.languageId};if(w(_))return{overrideIdentifier:_.languageId};if(a(_))return{resource:_.uri};if(_===null)return{resource:null}}let g=class{constructor(n,t,s){this._proxy=n.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=s,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new o(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,t){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(n,t))}};g=je([He(0,u.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,E.ILogService)],g),e.ExtHostConfiguration=g;class o{constructor(n,t,s,d){this._onDidChangeConfiguration=new F.Emitter,this._proxy=n,this._logService=d,this._extHostWorkspace=t,this._configuration=k.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,t){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,s))}getConfiguration(n,t,s){const d=r(t)||{},c=this._toReadonlyValue(n?p(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,d,s?.identifier);function f(b){if(b==null)return null;if(typeof b=="boolean")return b?1:4;switch(b){case i.ConfigurationTarget.Global:return 1;case i.ConfigurationTarget.Workspace:return 4;case i.ConfigurationTarget.WorkspaceFolder:return 5}}const l={has(b){return typeof p(c,b)!="undefined"},get:(b,T)=>{this._validateConfigurationAccess(n?`${n}.${b}`:b,d,s?.identifier);let A=p(c,b);if(typeof A=="undefined")A=T;else{let U;const B=(L,x)=>{let M;const V=()=>{U=U||(0,m.deepClone)(c),M=M||p(U,x)};return(0,D.isObject)(L)?new Proxy(L,{get:(O,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return V(),()=>M;if(U)return M=M||p(U,x),M[W];const q=O[W];return typeof W=="string"?B(q,`${x}.${W}`):q},set:(O,W,q)=>(V(),M&&(M[W]=q),!0),deleteProperty:(O,W)=>(V(),M&&delete M[W],!0),defineProperty:(O,W,q)=>(V(),M&&Object.defineProperty(M,W,q),!0)}):L};A=B(A,b)}return A},update:(b,T,A,U)=>{b=n?`${n}.${b}`:b;const B=f(A);return T!==void 0?this._proxy.$updateConfigurationOption(B,b,T,d,U):this._proxy.$removeConfigurationOption(B,b,d,U)},inspect:b=>{b=n?`${n}.${b}`:b;const T=(0,m.deepClone)(this._configuration.inspect(b,d,this._extHostWorkspace.workspace));if(T)return{key:b,defaultValue:T.default?.value,globalValue:T.user?.value,workspaceValue:T.workspace?.value,workspaceFolderValue:T.workspaceFolder?.value,defaultLanguageValue:T.default?.override,globalLanguageValue:T.user?.override,workspaceLanguageValue:T.workspace?.override,workspaceFolderLanguageValue:T.workspaceFolder?.override,languageIds:T.overrideIdentifiers}}};return typeof c=="object"&&(0,m.mixin)(l,c,!1),Object.freeze(l)}_toReadonlyValue(n){const t=s=>(0,D.isObject)(s)?new Proxy(s,{get:(d,c)=>t(d[c]),set:(d,c,f)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(d,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(d,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return t(n)}_validateConfigurationAccess(n,t,s){const d=S.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),c=s?`[${s.value}] `:"";if(d===4){typeof t?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){t?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,t){const s=new k.ConfigurationChangeEvent(n,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,c)=>s.affectsConfiguration(d,r(c))})}_toMap(n){return n.reduce((t,s)=>(t.set(s[0],s[1]),t),new Map)}}e.ExtHostConfigProvider=o,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,F,y){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(pe[70],ve([0,1,2,18,3,5,7,35,45,36,21,34,14,26,4,10,12,11,65,212,15]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I,w,a,r){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var o;(function(x){function M(O){if(O!=null)return O}x.from=M;function V(O){if(O!=null)return O}x.to=V})(o=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var _;(function(x){function M(O){if(O!=null)return O}x.from=M;function V(O){if(O!=null)return O}x.to=V})(_=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(x){function M(O){if(O!=null)return O}x.from=M;function V(O){if(O!=null)return O}x.to=V})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function(x){function M(W){if(W){const q=W;return q&&!!q.process}else return!1}x.is=M;function V(W){if(W==null)return;const q={process:W.process,args:W.args};return W.options&&(q.options=n.from(W.options)),q}x.from=V;function O(W){if(W!=null)return new i.ProcessExecution(W.process,W.args,W.options)}x.to=O})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(x){function M(O){if(O!=null)return O}x.from=M;function V(O){if(O!=null)return O}x.to=V})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(x){function M(W){if(W){const q=W;return q&&(!!q.commandLine||!!q.command)}else return!1}x.is=M;function V(W){if(W==null)return;const q={};return W.commandLine!==void 0?q.commandLine=W.commandLine:(q.command=W.command,q.args=W.args),W.options&&(q.options=s.from(W.options)),q}x.from=V;function O(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new i.ShellExecution(W.commandLine,W.options):new i.ShellExecution(W.command,W.args?W.args:[],W.options)}x.to=O})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(x){function M(W){if(W){let q=W;return q&&q.customExecution==="customExecution"}else return!1}x.is=M;function V(W){return{customExecution:"customExecution"}}x.from=V;function O(W,q){return q.get(W)}x.to=O})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var f;(function(x){function M(V,O){let W;return V.scope!==void 0&&typeof V.scope!="number"?W=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===i.TaskScope.Workspace&&O&&O.workspaceFile?W=O.workspaceFile:W=a.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:W}}x.from=M})(f=e.TaskHandleDTO||(e.TaskHandleDTO={}));var l;(function(x){function M(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}x.from=M})(l=e.TaskGroupDTO||(e.TaskGroupDTO={}));var b;(function(x){function M(W,q){if(W==null)return[];const N=[];for(let G of W){const $=V(G,q);$&&N.push($)}return N}x.fromMany=M;function V(W,q){if(W==null)return;let N;W.execution instanceof i.ProcessExecution?N=t.from(W.execution):W.execution instanceof i.ShellExecution?N=d.from(W.execution):W.execution&&W.execution instanceof i.CustomExecution&&(N=c.from(W.execution));const G=o.from(W.definition);let $;return W.scope?typeof W.scope=="number"?$=W.scope:$=W.scope.uri:$=i.TaskScope.Workspace,!G||!$?void 0:{_id:W._id,definition:G,name:W.name,source:{extensionId:q.identifier.value,label:W.source,scope:$},execution:N,isBackground:W.isBackground,group:l.from(W.group),presentationOptions:_.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}x.from=V;async function O(W,q,N){if(W==null)return;let G;t.is(W.execution)?G=t.to(W.execution):d.is(W.execution)?G=d.to(W.execution):c.is(W.execution)&&(G=c.to(W._id,N));const $=o.to(W.definition);let H;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?H=W.source.scope:H=await q.resolveWorkspaceFolder(m.URI.revive(W.source.scope)):H=i.TaskScope.Workspace),!$||!H)return;const j=new i.Task($,H,W.name,W.source.label,G,W.problemMatchers);return W.isBackground!==void 0&&(j.isBackground=W.isBackground),W.group!==void 0&&(j.group=i.TaskGroup.from(W.group._id),j.group&&W.group.isDefault&&(j.group=new i.TaskGroup(j.group.id,j.group.label),W.group.isDefault&&(j.group.isDefault=W.group.isDefault))),W.presentationOptions&&(j.presentationOptions=_.to(W.presentationOptions)),W._id&&(j._id=W._id),W.detail&&(j.detail=W.detail),j}x.to=O})(b=e.TaskDTO||(e.TaskDTO={}));var T;(function(x){function M(O){return O}x.from=M;function V(O){if(!!O)return Object.assign(Object.create(null),O)}x.to=V})(T=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(M,V,O){this._id=V,this._task=O,g.set(this,void 0),nt(this,g,M,"f")}get task(){return this._task}terminate(){Ne(this,g,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}g=new WeakMap;var U;(function(x){function M(V){return{id:V._id,task:void 0}}x.from=M})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(M,V,O,W,q,N,G,$){this._onDidExecuteTask=new y.Emitter,this._onDidTerminateTask=new y.Emitter,this._onDidTaskProcessStarted=new y.Emitter,this._onDidTaskProcessEnded=new y.Emitter,this._proxy=M.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=O,this._editorService=W,this._configurationService=q,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=G,this._deprecationService=$,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(M,V,O){if(!O)return new i.Disposable(()=>{});const W=this.nextHandle();return this._handlers.set(W,{type:V,provider:O,extension:M}),this._proxy.$registerTaskProvider(W,V),new i.Disposable(()=>{this._handlers.delete(W),this._proxy.$unregisterTaskProvider(W)})}registerTaskSystem(M,V){this._proxy.$registerTaskSystem(M,V)}fetchTasks(M){return this._proxy.$fetchTasks(T.from(M)).then(async V=>{const O=[];for(let W of V){const q=await b.to(W,this._workspaceProvider,this._providedCustomExecutions2);q&&O.push(q)}return O})}get taskExecutions(){const M=[];return this._taskExecutions.forEach(V=>M.push(V)),M}terminateTask(M){if(!(M instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(M._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(M,V,O){const W=this._providedCustomExecutions2.get(M.id);W&&(this._activeCustomExecutions2.set(M.id,W),this._terminalService.attachPtyToTerminal(V,await W.callback(O))),this._lastStartedTask=M.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(M)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(M){const V=await this.getTaskExecution(M);this._taskExecutionPromises.delete(M.id),this._taskExecutions.delete(M.id),this.customExecutionComplete(M),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(M){const V=await this.getTaskExecution(M.id);this._onDidTaskProcessStarted.fire({execution:V,processId:M.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(M){const V=await this.getTaskExecution(M.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:M.exitCode})}$provideTasks(M,V){const O=this._handlers.get(M);if(!O)return Promise.reject(new Error("no handler found"));const W=[],q=(0,F.asPromise)(()=>O.provider.provideTasks(R.CancellationToken.None)).then(N=>this.provideTasksInternal(V,W,O,N));return new Promise(N=>{q.then(G=>{Promise.all(W).then(()=>{N(G)})})})}async $resolveTask(M,V){const O=this._handlers.get(M);if(!O)return Promise.reject(new Error("no handler found"));if(V.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${O.type}].`);const W=await b.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const q=await O.provider.resolveTask(W,R.CancellationToken.None);if(!q)return;this.checkDeprecation(q,O);const N=b.from(q,O.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(N.execution)&&await this.addCustomExecution(N,q,!0),await this.resolveTaskInternal(N)}nextHandle(){return this._handleCounter++}async addCustomExecution(M,V,O){const W=await this._proxy.$createTaskId(M);!O&&!this._providedCustomExecutions2.has(W)&&(this._notProvidedCustomExecutions.add(W),this._activeCustomExecutions2.set(W,V.execution)),this._providedCustomExecutions2.set(W,V.execution)}async getTaskExecution(M,V){if(typeof M=="string"){const q=this._taskExecutionPromises.get(M);if(!q)throw new Error("Unexpected: The specified task is missing an execution");return q}let O=this._taskExecutionPromises.get(M.id);if(O)return O;const W=new Promise((q,N)=>{function G($,H,j){j?q(new A($,H.id,j)):N("Unexpected: Task does not exist.")}V?G(this,M,V):b.to(M.task,this._workspaceProvider,this._providedCustomExecutions2).then($=>G(this,M,$))});return this._taskExecutionPromises.set(M.id,W),W.then(q=>(this._taskExecutions.set(M.id,q),q),q=>Promise.reject(q))}checkDeprecation(M,V){M._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(M){this._activeCustomExecutions2.get(M.id)&&this._activeCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.has(M.id)&&this._lastStartedTask!==M.id&&(this._providedCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.delete(M.id));let O=this._notProvidedCustomExecutions.values(),W=O.next();for(;!W.done;)!this._activeCustomExecutions2.has(W.value)&&this._lastStartedTask!==W.value&&(this._providedCustomExecutions2.delete(W.value),this._notProvidedCustomExecutions.delete(W.value)),W=O.next()}};B=je([He(0,u.IExtHostRpcService),He(1,E.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,I.ILogService),He(7,w.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let L=class extends B{constructor(M,V,O,W,q,N,G,$){super(M,V,O,W,q,N,G,$);this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(M,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const O=b.from(V,M);if(O===void 0)throw new Error("Task is not valid");if(c.is(O.execution))await this.addCustomExecution(O,V,!1);else throw new r.NotSupportedError;const W=await this.getTaskExecution(await this._proxy.$getTaskExecution(O),V);return this._proxy.$executeTask(O).catch(q=>{throw new Error(q)}),W}provideTasksInternal(M,V,O,W){const q=[];if(W)for(let N of W){this.checkDeprecation(N,O),(!N.definition||!M[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const G=b.from(N,O.extension);G&&c.is(G.execution)?(q.push(G),V.push(this.addCustomExecution(G,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:q,extension:O.extension}}async resolveTaskInternal(M){if(c.is(M.execution))return M;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(M,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,V,O){}};L=je([He(0,u.IExtHostRpcService),He(1,E.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,I.ILogService),He(7,w.IExtHostApiDeprecationService)],L),e.WorkerExtHostTask=L,e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(pe[266],ve([0,1,16,73,31,80,24,10,9,23,8,13,2,145,174,115,43,127,265,33]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let r=class{constructor(f,l,b,T){this.configurationService=f,this.workspaceContextService=l,this.editorGroupsService=b,this.pathService=T}text(f,l,b={}){f=this.getContentPattern(f,b);const T=this.configurationService.getValue(),A=l&&l.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(l?.map(v.toWorkspaceFolder),b),type:2,contentPattern:f,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:T.search.usePCRE2||A||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles}}getContentPattern(f,l){const b=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const T={...f,wordSeparators:b.editor.wordSeparators};return this.isCaseSensitive(f,l)&&(T.isCaseSensitive=!0),this.isMultiline(f)&&(T.isMultiline=!0),T}file(f,l={}){return{...this.commonQuery(f,l),type:1,filePattern:l.filePattern?l.filePattern.trim():l.filePattern,exists:l.exists,sortByScore:l.sortByScore,cacheKey:l.cacheKey}}handleIncludeExclude(f,l){return f?(f=Array.isArray(f)?f.map(t):t(f),l?this.parseSearchPaths(f):{pattern:o(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],l={}){const b=this.handleIncludeExclude(l.includePattern,l.expandPatterns),T=this.handleIncludeExclude(l.excludePattern,l.expandPatterns),A=f.length>1,U=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,l,T)):f.map(x=>this.getFolderQueryForRoot(x,l,T,A))).filter(x=>!!x),B={_reason:l._reason,folderQueries:U,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:l.extraFileResources,excludePattern:T.pattern,includePattern:b.pattern,onlyOpenEditors:l.onlyOpenEditors,maxResults:l.maxResults};if(l.onlyOpenEditors){const M=m.coalesce(m.flatten(this.editorGroupsService.groups.map(O=>O.editors.map(W=>W.resource)))).filter(O=>(0,a.pathIncludedInQuery)(B,O.fsPath)),V=this.commonQueryFromFileList(M);return{...B,...V}}const L=l.extraFileResources&&l.extraFileResources.filter(x=>(0,a.pathIncludedInQuery)(B,x.fsPath));return B.extraFileResources=L&&L.length?L:void 0,B}commonQueryFromFileList(f){const l=[],b=new i.ResourceMap,T={};let A=!1;return f.forEach(U=>{if(U.scheme===k.Schemas.walkThrough)return;if((0,D.isAbsolutePath)(U)){const L=this.workspaceContextService.getWorkspaceFolder(U)?.uri??U.with({path:S.dirname(U.fsPath)});let x=b.get(L);x||(A=!0,x={folder:L,includePattern:{}},l.push(x),b.set(L,x));const M=S.relative(L.fsPath,U.fsPath);(0,P.assertIsDefined)(x.includePattern)[M.replace(/\\/g,"/")]=!0}else U.fsPath&&(A=!0,T[U.fsPath]=!0)}),{folderQueries:l,includePattern:T,usingSearchPaths:!0,excludePattern:A?void 0:{"**/*":!0}}}isCaseSensitive(f,l){if(l.isSmartCase){if(f.isRegExp){if(R.containsUppercaseCharacter(f.pattern,!0))return!0}else if(R.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,E.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const l=V=>S.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),T=(Array.isArray(f)?f:_(f)).map(V=>{const O=this.pathService.resolvedUserHome;return O?(0,C.untildify)(V,O.scheme===k.Schemas.file?O.fsPath:O.path):V}),A=F.groupBy(T,V=>l(V)?"searchPaths":"exprSegments"),U=(A.exprSegments||[]).map(V=>R.rtrim(V,"/")).map(V=>R.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),n(V))),B={},L=this.expandSearchPathPatterns(A.searchPaths||[]);L&&L.length&&(B.searchPaths=L);const x=m.flatten(U),M=o(...x);return M&&(B.pattern=M),B}getExcludesForFolder(f,l){return l.disregardExcludeSettings?void 0:(0,a.getExcludes)(f,!l.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const l=m.flatten(f.map(T=>{let{pathPortion:A,globPortion:U}=g(T);U&&(U=s(U));const B=this.expandOneSearchPath(A);return m.flatten(B.map(L=>this.resolveOneSearchPathPattern(L,U)))})),b=new Map;return l.forEach(T=>{const A=T.searchPath.toString(),U=b.get(A);U?T.pattern&&(U.pattern=U.pattern||{},U.pattern[T.pattern]=!0):b.set(A,{searchPath:T.searchPath,pattern:T.pattern?o(T.pattern):void 0})}),Array.from(b.values())}expandOneSearchPath(f){if(S.isAbsolute(f)){const l=this.workspaceContextService.getWorkspace().folders;return l[0]&&l[0].uri.scheme!==k.Schemas.file?[{searchPath:l[0].uri.with({path:f})}]:[{searchPath:u.URI.file(S.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const l=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=t(f),f.startsWith("../")||f===".."){const T=S.posix.resolve(l.path,f);return[{searchPath:l.with({path:T})}]}const b=s(f);return[{searchPath:l,pattern:b}]}else{if(f==="./"||f===".\\")return[];{const l=f.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(A=>{const U=l.match(new RegExp(`^${R.escapeRegExpCharacters(A.name)}(?:/(.*)|$)`));return U?{match:U,folder:A}:null}).filter(P.isDefined);if(T.length)return T.map(A=>{const U=A.match[1];return{searchPath:A.folder.uri,pattern:U&&s(U)}});{const A=f.match(/\.[\/\\](.+)[\/\\]?/),U=A?A[1]:f,B=h.localize(0,null,U);throw new Error(B)}}}}resolveOneSearchPathPattern(f,l){const b=f.pattern&&l?`${f.pattern}/${l}`:f.pattern||l,T=[{searchPath:f.searchPath,pattern:b}];return b&&!b.endsWith("**")&&T.push({searchPath:f.searchPath,pattern:b+"/**"}),T}getFolderQueryForSearchPath(f,l,b){const T=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(f.searchPath),l,b,!1);return T?{...T,includePattern:f.pattern}:null}getFolderQueryForRoot(f,l,b,T){let A;const U=u.URI.isUri(f)?f:f.uri;if(b.searchPaths){const V=b.searchPaths.filter(O=>(0,D.isEqual)(O.searchPath,U))[0];if(V&&!V.pattern)return null;V&&(A=V.pattern)}const B=this.configurationService.getValue({resource:U}),x={...this.getExcludesForFolder(B,l)||{},...A||{}},M=u.URI.isUri(f)?(0,D.basename)(f):f.name;return{folder:U,folderName:T?M:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof l.disregardIgnoreFiles=="boolean"?l.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof l.disregardGlobalIgnoreFiles=="boolean"?l.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof l.ignoreSymlinks=="boolean"?l.ignoreSymlinks:!B.search.followSymlinks}}};r=je([He(0,p.IConfigurationService),He(1,v.IWorkspaceContextService),He(2,I.IEditorGroupsService),He(3,w.IPathService)],r),e.QueryBuilder=r;function g(c){const f=c.match(/[\*\{\}\(\)\[\]\?]/);if(f){const l=f.index,b=c.substr(0,l).match(/[/|\\][^/\\]*$/);if(b){let T=c.substr(0,b.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:c.substr((b.index||0)+1)}}}return{pathPortion:c}}function o(...c){return c.length?c.reduce((f,l)=>(f[l]=!0,f),Object.create(null)):void 0}function _(c){return y.splitGlobAware(c,",").map(f=>f.trim()).filter(f=>!!f.length)}function n(c){return[`**/${c}/**`,`**/${c}`].map(l=>l.replace(/\*\*\/\*\*/g,"**"))}function t(c){return c.replace(/\\/g,"/")}function s(c){return t(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(c,f){c=m.distinct(c,T=>T.toString());const l=[],b=f.getWorkspace();return c&&c.forEach(T=>{let A;if(f.getWorkbenchState()===2)A=(0,D.relativePath)(b.folders[0].uri,T),A&&A!=="."&&(A="./"+A);else{const U=f.getWorkspaceFolder(T);if(U){const B=U.name;if(b.folders.filter(x=>x.name===B).length===1){const x=(0,D.relativePath)(U.uri,T);x===""?A=`./${U.name}`:A=`./${U.name}/${x}`}else A=T.fsPath}}A&&l.push(A)}),l}e.resolveResourcesForSearchIncludes=d}),define(pe[267],ve([0,1,23,2,21,15,4,266,33,43]),function(Y,e,m,F,y,C,i,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function P(p,v){const I=v.activationEvents;if(!I)return Promise.resolve(void 0);const w=[],a=[];for(const t of I)if(/^workspaceContains:/.test(t)){const s=t.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||p.forceUsingSearch?a.push(s):w.push(s)}if(w.length===0&&a.length===0)return Promise.resolve(void 0);let r;const g=new Promise((t,s)=>{r=t}),o=t=>r({activationEvent:t}),_=Promise.all(w.map(t=>u(p,t,o))).then(()=>{}),n=E(p,v.identifier,a,o);return Promise.all([_,n]).then(()=>{r(void 0)}),g}e.checkActivateWorkspaceContainsExtension=P;async function u(p,v,I){for(const w of p.folders)if(await p.exists(m.joinPath(F.URI.revive(w),v))){I(`workspaceContains:${v}`);return}}async function E(p,v,I,w){if(I.length===0)return Promise.resolve(void 0);const a=new y.CancellationTokenSource,r=p.checkExists(p.folders,I,a.token),g=setTimeout(async()=>{a.cancel(),p.logService.info(`Not activating extension '${v.value}': Timed out while searching for 'workspaceContains' pattern ${I.join(",")}`)},R);let o=!1;try{o=await r}catch(_){C.isPromiseCanceledError(_)||C.onUnexpectedError(_)}a.dispose(),clearTimeout(g),o&&w(`workspaceContains:${I.join(",")}`)}function h(p,v,I,w){const a=p.get(i.IInstantiationService),r=p.get(S.ISearchService),o=a.createInstance(k.QueryBuilder).file(v.map(_=>(0,D.toWorkspaceFolder)(F.URI.revive(_))),{_reason:"checkExists",includePattern:I,exists:!0});return r.fileSearch(o,w).then(_=>!!_.limitHit,_=>C.isPromiseCanceledError(_)?!1:Promise.reject(_))}e.checkGlobFileExists=h});var nt=this&&this.__classPrivateFieldSet||function(Y,e,m,F,y){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,F){if(m==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?F:m==="a"?F.call(Y):F?F.value:e.get(Y)};define(pe[39],ve([0,1,163,9,71,23,18,6,24,2,11,5,36,225,91,35,29,223,15,27,22,198,7,119,4,26,67,14,85,52,34,3,267,90,200,10]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I,w,a,r,g,o,_,n,t,s,d,c,f,l,b,T,A,U,B){"use strict";var L,x,M;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let V=class ji extends k.Disposable{constructor(N,G,$,H,j,ie,fe,ye,Ie,Be){super();this._onDidChangeRemoteConnectionData=this._register(new b.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=G,this._extHostContext=$,this._initData=fe,this._extHostWorkspace=H,this._extHostConfiguration=j,this._logService=ie,this._extHostTunnelService=Ie,this._extHostTerminalService=Be,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new i.Barrier,this._readyToStartExtensionHost=new i.Barrier,this._readyToRunExtensions=new i.Barrier,this._eagerExtensionsActivated=new i.Barrier,this._registry=new I.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new h.ExtHostStorage(this._extHostContext),this._secretState=new A.ExtHostSecretState(this._extHostContext),this._storagePath=ye,this._instaService=N.createChild(new c.ServiceCollection([h.IExtHostStorage,this._storage],[A.IExtHostSecretState,this._secretState]));const We=new Set;this._initData.hostExtensions.forEach(ze=>We.add(a.ExtensionIdentifier.toKey(ze))),this._activator=this._register(new E.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,Q,ee)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,w.transformErrorForSerialization(Q),ee)},actualActivateExtension:async(ze,Q)=>{if(We.has(a.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,Q),new E.HostExtension;const ee=this._registry.getExtensionDescription(ze);return this._activateExtension(ee,Q)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),y.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(N){w.onUnexpectedError(N)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let N=[];try{N=this._registry.getAllExtensionDescriptions().map(j=>j.identifier).filter(j=>this.isActivated(j)).map(j=>this._deactivate(j))}catch(G){}await Promise.all(N)}isActivated(N){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(N):!1}_activateByEvent(N,G){return this._activator.activateByEvent(N,G)}_activateById(N,G){return this._activator.activateById(N,G)}activateByIdWithErrors(N,G){return this._activateById(N,G).then(()=>{const $=this._activator.getActivatedExtension(N);if($.activationFailed)return Promise.reject($.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(N=>this._registry)}getExtensionExports(N){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(N).exports:null}async _realPathExtensionUri(N){if(N.scheme!==B.Schemas.file)return N;const G=await this._hostUtils.realpath(N.fsPath);return D.URI.file(G)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const N=S.TernarySearchTree.forUris(G=>C.extUriBiasedIgnorePathCase.ignorePathCasing(G));for(const G of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(G)){const $=await this._realPathExtensionUri(G.extensionLocation);N.set($,G)}return N})()),this._extensionPathIndex}_deactivate(N){let G=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(N))return G;const $=this._activator.getActivatedExtension(N);if(!$)return G;try{typeof $.module.deactivate=="function"&&(G=Promise.resolve($.module.deactivate()).then(void 0,H=>(this._logService.error(H),Promise.resolve(void 0))))}catch(H){this._logService.error(H)}try{(0,k.dispose)($.subscriptions)}catch(H){this._logService.error(H)}return G}async _activateExtension(N,G){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier),this._doActivateExtension(N,G).then($=>{const H=$.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(N.identifier,H.codeLoadingTime,H.activateCallTime,H.activateResolvedTime,G),this._logExtensionActivationTimes(N,G,"success",H),$},$=>{throw this._logExtensionActivationTimes(N,G,"failure"),$})}_logExtensionActivationTimes(N,G,$,H){const j=O(N,G);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...j,...H||{},outcome:$})}_doActivateExtension(N,G){const $=O(N,G);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",$);const H=this._getEntryPoint(N);if(!H)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${N.identifier.value}, startup: ${G.startup}, activationEvent: '${G.activationEvent}'${N.identifier.value!==G.extensionId.value?`, root cause: ${G.extensionId.value}`:""}`),this._logService.flush();const j=new E.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this._loadCommonJSModule(N.identifier,(0,C.joinPath)(N.extensionLocation,H),j),this._loadExtensionContext(N)]).then(ie=>(y.mark(`code/extHost/willActivateExtension/${N.identifier.value}`),ji._callActivate(this._logService,N.identifier,ie[0],ie[1],j))).then(ie=>(y.mark(`code/extHost/didActivateExtension/${N.identifier.value}`),ie))}_loadExtensionContext(N){const G=new g.ExtensionGlobalMemento(N,this._storage),$=new g.ExtensionMemento(N.identifier.value,!1,this._storage),H=new U.ExtensionSecrets(N,this._secretState),j=N.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,ie=this._initData.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${N.identifier.value}`),Promise.all([G.whenReady,$.whenReady,this._storagePath.whenReady]).then(()=>{const fe=this;let ye;return Object.freeze({globalState:G,workspaceState:$,secrets:H,subscriptions:[],get extensionUri(){return N.extensionLocation},get extensionPath(){return N.extensionLocation.fsPath},asAbsolutePath(Ie){return F.join(N.extensionLocation.fsPath,Ie)},get storagePath(){return fe._storagePath.workspaceValue(N)?.fsPath},get globalStoragePath(){return fe._storagePath.globalValue(N).fsPath},get logPath(){return F.join(fe._initData.logsLocation.fsPath,N.identifier.value)},get logUri(){return D.URI.joinPath(fe._initData.logsLocation,N.identifier.value)},get storageUri(){return fe._storagePath.workspaceValue(N)},get globalStorageUri(){return fe._storagePath.globalValue(N)},get extensionMode(){return j},get extension(){return ye===void 0&&(ye=new W(fe,N.identifier,N,ie)),ye},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(N,"extensionRuntime"),fe.extensionRuntime},get environmentVariableCollection(){return fe._extHostTerminalService.getEnvironmentVariableCollection(N)}})})}static _callActivate(N,G,$,H,j){return $=$||{activate:void 0,deactivate:void 0},this._callActivateOptional(N,G,$,H,j).then(ie=>new E.ActivatedExtension(!1,null,j.build(),$,ie,H.subscriptions))}static _callActivateOptional(N,G,$,H,j){if(typeof $.activate=="function")try{j.activateCallStart(),N.trace(`ExtensionService#_callActivateOptional ${G.value}`);const ie=typeof global=="object"?global:self,fe=$.activate.apply(ie,[H]);return j.activateCallStop(),j.activateResolveStart(),Promise.resolve(fe).then(ye=>(j.activateResolveStop(),ye))}catch(ie){return Promise.reject(ie)}else return Promise.resolve($)}_activateOneStartupFinished(N,G){this._activateById(N.identifier,{startup:!1,extensionId:N.identifier,activationEvent:G}).then(void 0,$=>{this._logService.error($)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(y.getMarks());for(const N of this._registry.getAllExtensionDescriptions())if(N.activationEvents)for(const G of N.activationEvents)G==="onStartupFinished"&&this._activateOneStartupFinished(N,G)}_handleEagerExtensions(){const N=this._activateByEvent("*",!0).then(void 0,j=>{this._logService.error(j)});this._register(this._extHostWorkspace.onDidChangeWorkspace(j=>this._handleWorkspaceContainsEagerExtensions(j.added)));const G=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],$=this._handleWorkspaceContainsEagerExtensions(G),H=Promise.all([N,$]).then(()=>{});return Promise.race([H,(0,i.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),H}_handleWorkspaceContainsEagerExtensions(N){return N.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(G=>this._handleWorkspaceContainsEagerExtension(N,G))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(N,G){if(this.isActivated(G.identifier))return;const $=!this._initData.remote.isRemote&&!!this._initData.remote.authority,H={logService:this._logService,folders:N.map(ie=>ie.uri),forceUsingSearch:$,exists:ie=>this._hostUtils.exists(ie.fsPath),checkExists:(ie,fe,ye)=>this._mainThreadWorkspaceProxy.$checkExists(ie,fe,ye)},j=await(0,T.checkActivateWorkspaceContainsExtension)(H,G);if(!!j)return this._activateById(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:j.activationEvent}).then(void 0,ie=>this._logService.error(ie))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(N){throw console.error(N),N}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:N,extensionTestsLocationURI:G}=this._initData.environment;if(!N||!G)throw new Error(m.localize(0,null));const $=await this._loadCommonJSModule(null,G,new E.ExtensionActivationTimesBuilder(!1));if(!$||typeof $.run!="function")throw new Error(m.localize(1,null,G.toString()));return new Promise((H,j)=>{const ie=(Ie,Be)=>{Ie?j(Ie):H(typeof Be=="number"&&Be>0?1:0)},fe=(0,C.originalFSPath)(G),ye=$.run(fe,ie);ye&&ye.then&&ye.then(()=>{H(0)}).catch(Ie=>{j(Ie.toString())})})}async $extensionTestsExit(N){this._logService.info(`Extension host terminating: test runner requested exit with code ${N}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${N}`),this._logService.flush(),this._hostUtils.exit(N)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(N,G){return this._resolvers[N]=G,(0,k.toDisposable)(()=>{delete this._resolvers[N]})}async _activateAndGetResolver(N){const G=N.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const $=N.substr(0,G);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${$}`,!1),{authorityPrefix:$,resolver:this._resolvers[$]}}async $resolveAuthority(N,G){const{authorityPrefix:$,resolver:H}=await this._activateAndGetResolver(N);if(!H)return{type:"error",error:{code:_.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${$}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(H)),y.mark(`code/extHost/willResolveAuthority/${$}`);const j=await H.resolve(N,{resolveAttempt:G});y.mark(`code/extHost/didResolveAuthorityOK/${$}`);const ie={authority:N,host:j.host,port:j.port,connectionToken:j.connectionToken},fe={extensionHostEnv:j.extensionHostEnv,isTrusted:j.isTrusted,authenticationSession:j.authenticationSessionForInitializingExtensions?{id:j.authenticationSessionForInitializingExtensions.id,providerId:j.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ie,options:fe,tunnelInformation:{environmentTunnels:j.environmentTunnels}}}}catch(j){if(y.mark(`code/extHost/didResolveAuthorityError/${$}`),j instanceof o.RemoteAuthorityResolverError)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j}}async $getCanonicalURI(N,G){const{authorityPrefix:$,resolver:H}=await this._activateAndGetResolver(N);if(!H)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${$}`);const j=D.URI.revive(G);if(typeof H.getCanonicalURI=="undefined")return j;const ie=await(0,i.asPromise)(()=>H.getCanonicalURI(j));return ie||j}$startExtensionHost(N){return this._registry.keepOnly(N),this._startExtensionHost()}$activateByEvent(N,G){return G===1?this._activateByEvent(N,!1):this._readyToRunExtensions.wait().then($=>this._activateByEvent(N,!1))}async $activate(N,G){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(N)?(await this._activateById(N,G),!0):!1}async $deltaExtensions(N,G){N.forEach(H=>H.extensionLocation=D.URI.revive(H.extensionLocation));const $=await this.getExtensionPathIndex();return await Promise.all(G.map(async H=>{const j=this._registry.getExtensionDescription(H);j&&$.delete(await this._realPathExtensionUri(j.extensionLocation))})),await Promise.all(N.map(async H=>{const j=await this._realPathExtensionUri(H.extensionLocation);$.set(j,H)})),this._registry.deltaExtensions(N,G),Promise.resolve(void 0)}async $test_latency(N){return N}async $test_up(N){return N.byteLength}async $test_down(N){let G=r.VSBuffer.alloc(N),$=Math.random()%256;for(let H=0;H<N;H++)G.writeUInt8($,H);return G}async $updateRemoteConnectionData(N){this._remoteConnectionData=N,this._onDidChangeRemoteConnectionData.fire()}};V=je([He(0,n.IInstantiationService),He(1,e.IHostUtils),He(2,d.IExtHostRpcService),He(3,p.IExtHostWorkspace),He(4,u.IExtHostConfiguration),He(5,R.ILogService),He(6,t.IExtHostInitDataService),He(7,s.IExtensionStoragePaths),He(8,f.IExtHostTunnelService),He(9,l.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function O(q,N){return{id:q.identifier.value,name:q.name,extensionVersion:q.version,publisherDisplayName:q.publisher,activationEvents:q.activationEvents?q.activationEvents.join(","):null,isBuiltin:q.isBuiltin,reason:N.activationEvent,reasonId:N.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class W{constructor(N,G,$,H){L.set(this,void 0),x.set(this,void 0),M.set(this,void 0),nt(this,L,N,"f"),nt(this,x,G,"f"),nt(this,M,$.identifier,"f"),this.id=$.identifier.value,this.extensionUri=$.extensionLocation,this.extensionPath=F.normalize((0,C.originalFSPath)($.extensionLocation)),this.packageJSON=$,this.extensionKind=H}get isActive(){return Ne(this,L,"f").isActivated(Ne(this,M,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ne(this,L,"f").getExtensionExports(Ne(this,M,"f"))}activate(){return Ne(this,L,"f").activateByIdWithErrors(Ne(this,M,"f"),{startup:!1,extensionId:Ne(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,L=new WeakMap,x=new WeakMap,M=new WeakMap}),define(pe[55],ve([0,1,9,2,3,18,5,7,123,35,39,45,214,36,207,14,4,13,40,54]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let r=class{constructor(c,f,l,b,T,A){this._workspaceService=f,this._extensionService=l,this._editorsService=b,this._configurationService=T,this._editorTabs=A,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new y.Emitter,this._onDidTerminateDebugSession=new y.Emitter,this._onDidChangeActiveDebugSession=new y.Emitter,this._onDidReceiveDebugSessionCustomEvent=new y.Emitter,this._debugServiceProxy=c.getProxy(i.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new y.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new o(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(U=>{U.onDidChange(B=>{this.registerAllDebugTypes(U)}),this.registerAllDebugTypes(U)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,f){const l=c;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let b=`debug:${encodeURIComponent(l.path||"")}`,T="?";return f&&(b+=`${T}session=${encodeURIComponent(f.id)}`,T="&"),b+=`${T}ref=${l.sourceReference}`,F.URI.parse(b)}else{if(l.path)return F.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const f=[];for(const l of c.getAllExtensionDescriptions())if(l.contributes){const b=l.contributes.debuggers;if(b&&b.length>0)for(const T of b)(0,h.isDebuggerMainContribution)(T)&&f.push(T.type)}this._debugServiceProxy.$registerDebugTypes(f)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(f=>c.push(f)),c}addBreakpoints(c){this.startBreakpoints();const f=c.filter(T=>{const A=T.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,T),!0)});this.fireBreakpointChanges(f,[],[]);const l=[],b=new Map;for(const T of f)if(T instanceof k.SourceBreakpoint){let A=b.get(T.location.uri.toString());A||(A={type:"sourceMulti",uri:T.location.uri,lines:[]},b.set(T.location.uri.toString(),A),l.push(A)),A.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof k.FunctionBreakpoint&&l.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(l)}removeBreakpoints(c){this.startBreakpoints();const f=c.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],f,[]);const l=f.filter(A=>A instanceof k.SourceBreakpoint).map(A=>A.id),b=f.filter(A=>A instanceof k.FunctionBreakpoint).map(A=>A.id),T=f.filter(A=>A instanceof k.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(l,b,T)}startDebugging(c,f,l){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,f,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,debugUI:l.debugUI,suppressSaveBeforeStart:l.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,f,l){if(!f)return new k.Disposable(()=>{});const b=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:b,provider:f}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,l,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,b),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==f),this._debugServiceProxy.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(c,f,l){if(!l)return new k.Disposable(()=>{});if(!this.definesDebugType(c,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.getAdapterDescriptorFactoryByType(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:f,handle:b,factory:l}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(f,b),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==l),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(c,f){if(!f)return new k.Disposable(()=>{});const l=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:l,factory:f}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(b=>b.factory!==f)})}async $runInTerminal(c,f){return Promise.resolve(void 0)}async $substituteVariables(c,f){if(!this._variableResolver){const[T,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,A)}let l;const b=await this.getFolder(c);return b&&(l={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(l,f)}createDebugAdapter(c,f){if(c.type==="implementation")return new t(c.implementation)}createSignService(){}async $startDASession(c,f){const l=this,b=await this.getSession(f);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(b.type),b).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const A=this.convertToDto(T),U=this.createDebugAdapter(A,b);if(!U)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const B=U;return this._debugAdapters.set(c,B),this.getDebugAdapterTrackers(b).then(L=>(L&&this._debugAdaptersTrackers.set(c,L),B.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const M=x,V={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const O=await this._signService.sign(M.arguments.value);V.body={signature:O},B.sendResponse(V)}else throw new Error("no signer")}catch(O){V.success=!1,V.message=O.message,B.sendResponse(V)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(x),x=(0,h.convertToVSCPaths)(x,!0),l._debugServiceProxy.$acceptDAMessage(c,x)}),B.onError(x=>{L&&L.onError&&L.onError(x),this._debugServiceProxy.$acceptDAError(c,x.name,x.message,x.stack)}),B.onExit(x=>{L&&L.onExit&&L.onExit((0,I.withNullAsUndefined)(x),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,I.withNullAsUndefined)(x),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),B.startSession()))})}$sendDAMessage(c,f){f=(0,h.convertToDAPaths)(f,!1);const l=this._debugAdaptersTrackers.get(c);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(f);const b=this._debugAdapters.get(c);b&&b.sendMessage(f)}$stopDASession(c){const f=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),f&&f.onWillStopSession&&f.onWillStopSession();const l=this._debugAdapters.get(c);return this._debugAdapters.delete(c),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const f=[],l=[],b=[];if(c.added)for(const T of c.added){const A=T.id;if(A&&!this._breakpoints.has(A)){let U;if(T.type==="function")U=new k.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")U=new k.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const B=F.URI.revive(T.uri);U=new k.SourceBreakpoint(new k.Location(B,new k.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}U._id=A,this._breakpoints.set(A,U),f.push(U)}}if(c.removed)for(const T of c.removed){const A=this._breakpoints.get(T);A&&(this._breakpoints.delete(T),l.push(A))}if(c.changed){for(const T of c.changed)if(T.id){const A=this._breakpoints.get(T.id);if(A){if(A instanceof k.FunctionBreakpoint&&T.type==="function"){const U=A;U.enabled=T.enabled,U.condition=T.condition,U.hitCondition=T.hitCondition,U.logMessage=T.logMessage,U.functionName=T.functionName}else if(A instanceof k.SourceBreakpoint&&T.type==="source"){const U=A;U.enabled=T.enabled,U.condition=T.condition,U.hitCondition=T.hitCondition,U.logMessage=T.logMessage,U.location=new k.Location(F.URI.revive(T.uri),new k.Position(T.line,T.character))}b.push(A)}}}this.fireBreakpointChanges(f,l,b)}$provideDebugConfigurations(c,f,l){return(0,C.asPromise)(async()=>{const b=this.getConfigProviderByHandle(c);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(f);return b.provideDebugConfigurations(T,l)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(c,f,l,b){return(0,C.asPromise)(async()=>{const T=this.getConfigProviderByHandle(c);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(f);return T.resolveDebugConfiguration(A,l,b)})}$resolveDebugConfigurationWithSubstitutedVariables(c,f,l,b){return(0,C.asPromise)(async()=>{const T=this.getConfigProviderByHandle(c);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(f);return T.resolveDebugConfigurationWithSubstitutedVariables(A,l,b)})}async $provideDebugAdapter(c,f){const l=this.getAdapterDescriptorFactoryByHandle(c);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.getSession(f);return this.getAdapterDescriptor(l,b).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(c){const f=await this.getSession(c);this._onDidStartDebugSession.fire(f)}async $acceptDebugSessionTerminated(c){const f=await this.getSession(c);f&&(this._onDidTerminateDebugSession.fire(f),this._debugSessions.delete(f.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,f){const l=await this.getSession(c);l&&l._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(c,f){const b={session:await this.getSession(c),event:f.event,body:f.body};this._onDidReceiveDebugSessionCustomEvent.fire(b)}convertToDto(c){if(c instanceof k.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof k.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const f=this._adapterFactories.filter(l=>l.type===c);if(f.length>0)return f[0].factory}getAdapterDescriptorFactoryByHandle(c){const f=this._adapterFactories.filter(l=>l.handle===c);if(f.length>0)return f[0].factory}getConfigProviderByHandle(c){const f=this._configProviders.filter(l=>l.handle===c);if(f.length>0)return f[0].provider}definesDebugType(c,f){if(c.contributes){const l=c.contributes.debuggers;if(l&&l.length>0){for(const b of l)if(b.label&&b.type&&b.type===f)return!0}}return!1}getDebugAdapterTrackers(c){const l=c.configuration.type,b=this._trackerFactories.filter(T=>T.type===l||T.type==="*").map(T=>(0,C.asPromise)(()=>T.factory.createDebugAdapterTracker(c)).then(A=>A,A=>null));return Promise.race([Promise.all(b).then(T=>{const A=T.filter(U=>!!U);if(A.length>0)return new n(A)}),new Promise((T,A)=>{const U=setTimeout(()=>{clearTimeout(U),A(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(c,f){const l=f.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new k.DebugAdapterServer(l));if(c){const T=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>c.createDebugAdapterDescriptor(f,this.daExecutableFromPackage(f,T))).then(A=>{if(A)return A})}const b=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(f,b))}daExecutableFromPackage(c,f){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,f,l){(c.length>0||f.length>0||l.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:f,changed:l}))}async getSession(c){if(c)if(typeof c=="string"){const f=this._debugSessions.get(c);if(f)return f}else{let f=this._debugSessions.get(c.id);if(!f){const l=await this.getFolder(c.folderUri),b=c.parent?this._debugSessions.get(c.parent):void 0;f=new g(this._debugServiceProxy,c.id,c.type,c.name,l,c.configuration,b),this._debugSessions.set(f.id,f),this._debugServiceProxy.$sessionCached(f.id)}return f}throw new Error("cannot find session")}getFolder(c){if(c){const f=F.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}};r=je([He(0,p.IExtHostRpcService),He(1,D.IExtHostWorkspace),He(2,R.IExtHostExtensionService),He(3,P.IExtHostDocumentsAndEditors),He(4,E.IExtHostConfiguration),He(5,a.IExtHostEditorTabs)],r),e.ExtHostDebugServiceBase=r;class g{constructor(c,f,l,b,T,A,U){this._debugServiceProxy=c,this._id=f,this._type=l,this._name=b,this._workspaceFolder=T,this._configuration=A,this._parentSession=U}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,f){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,f)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=g;class o{constructor(c){this.value=Object.freeze({append(f){c.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.ExtHostDebugConsole=o;class _ extends u.AbstractVariableResolverService{constructor(c,f,l,b,T){function A(){if(f){const U=f.activeEditor();if(U)return U.document.uri;const B=b.tabs.filter(L=>L.isActive);if(B.length>0){const L=B[0].resource;return L&&(L.primary||L.secondary)?L.primary??L.secondary:B[0].resource}}}super({getFolderUri:U=>{const B=c.filter(L=>L.name===U);if(B&&B.length>0)return B[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(U,B)=>l.getConfiguration(void 0,U).get(B),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const U=A();if(U)return m.normalize(U.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const U=A();if(U){const B=T.getWorkspaceFolder(U);if(B)return m.normalize(B.uri.fsPath)}}},getSelectedText:()=>{if(f){const U=f.activeEditor();if(U&&!U.selection.isEmpty)return U.document.getText(U.selection)}},getLineNumber:()=>{if(f){const U=f.activeEditor();if(U)return String(U.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=_;class n{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(f=>f.onError?f.onError(c):void 0)}onExit(c,f){this.trackers.forEach(l=>l.onExit?l.onExit(c,f):void 0)}}class t extends S.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends r{constructor(c,f,l,b,T,A){super(c,f,l,b,T,A)}createVariableResolver(c,f,l){return new _(c,f,l,this._editorTabs)}};s=je([He(0,p.IExtHostRpcService),He(1,D.IExtHostWorkspace),He(2,R.IExtHostExtensionService),He(3,P.IExtHostDocumentsAndEditors),He(4,E.IExtHostConfiguration),He(5,a.IExtHostEditorTabs)],s),e.WorkerExtHostDebugService=s}),define(pe[268],ve([0,1,71,2,5,36,29,27,14,26,4,39,40,11]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(a,r,g,o,_,n,t){this._apiFactory=a,this._extensionRegistry=r,this._instaService=g,this._extHostConfiguration=o,this._extHostExtensionService=_,this._initData=n,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new p(this._apiFactory,r,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(v,r)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(I,r,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let r of a.nodeModuleName)this._factories.set(r,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(r=>a.alternativeModuleName(r))}};h=je([He(2,R.IInstantiationService),He(3,C.IExtHostConfiguration),He(4,P.IExtHostExtensionService),He(5,D.IExtHostInitDataService),He(6,E.ILogService)],h),e.RequireInterceptor=h;class p{constructor(a,r,g,o,_){this._apiFactory=a,this._extensionPaths=r,this._extensionRegistry=g,this._configProvider=o,this._logService=_,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,r){const g=this._extensionPaths.findSubstr(r);if(g){let o=this._extApiImpl.get(k.ExtensionIdentifier.toKey(g.identifier));return o||(o=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(g.identifier),o)),o}if(!this._defaultApiImpl){let o="";this._extensionPaths.forEach((_,n)=>o+=`	${n} -> ${_.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${o}`),this._defaultApiImpl=this._apiFactory(i.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(a,r,g){this._extensionPaths=a,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(y.MainContext.MainThreadTelemetry);const{environment:o}=g,_=r.getProxy(y.MainContext.MainThreadKeytar);if(o.appRoot){let n=o.appRoot.fsPath;u.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,t)=>_.$getPassword(n,t),setPassword:(n,t,s)=>_.$setPassword(n,t,s),deletePassword:(n,t)=>_.$deletePassword(n,t),findPassword:n=>_.$findPassword(n),findCredentials(n){return _.$findCredentials(n)}}}load(a,r){const g=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:g?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(a){const r=a.length;if(r<=7||!this.alternativeNames)return;const g=r-7;if((a.charAt(g)==="/"||a.charAt(g)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};v=je([He(1,S.IExtHostRpcService),He(2,D.IExtHostInitDataService)],v);let I=class{constructor(a,r,g){this._extensionPaths=a,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(y.MainContext.MainThreadTelemetry);const o=g.getProxy(y.MainContext.MainThreadWindow);this._impl=(_,n)=>{const t=F.URI.parse(_);return n?this.callOriginal(_,n):t.scheme==="http"||t.scheme==="https"?o.$openUri(t,_,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?o.$openUri(t,_,{}):this.callOriginal(_,n)}}load(a,r,g){const o=this._extensionPaths.findSubstr(r);return o&&(this._extensionId=o.identifier.value,this.sendShimmingTelemetry()),this._original=g(a),this._impl}callOriginal(a,r){return this.sendNoForwardTelemetry(),this._original(a,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};I=je([He(2,S.IExtHostRpcService)],I)}),define(pe[269],ve([0,1,169,12,7,208,35,39,45,36,34,14,55,194,18,209,54]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let I=class extends u.ExtHostDebugServiceBase{constructor(r,g,o,_,n,t,s){super(r,g,o,_,n,s);this._terminalService=t,this._integratedTerminalInstances=new w}createDebugAdapter(r,g){switch(r.type){case"server":return new C.SocketDebugAdapter(r);case"pipeServer":return new C.NamedPipeDebugAdapter(r);case"executable":return new C.ExecutableDebugAdapter(r,g.type)}return super.createDebugAdapter(r,g)}daExecutableFromPackage(r,g){const o=C.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),r.type);if(o)return new y.DebugAdapterExecutable(o.command,o.args,o.options)}createSignService(){return new E.SignService}async $runInTerminal(r,g){if(r.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(A=>{this._integratedTerminalInstances.onTerminalClosed(A)}));const o=await this._configurationService.getConfigProvider(),_=this._terminalService.getDefaultShell(!0),n=this._terminalService.getDefaultShellArgs(!0),t=r.title||m.localize(0,null),s=JSON.stringify({shell:_,shellArgs:n});let d=await this._integratedTerminalInstances.checkout(s,t),c,f=!1;if(d)c=r.cwd;else{const A={shellPath:_,shellArgs:n,cwd:r.cwd,name:t,iconPath:new y.ThemeIcon("debug")};f=!0,d=this._terminalService.createTerminalFromOptions(A,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(d,s)}d.show(!0);const l=await d.processId;f?await new Promise(A=>setTimeout(A,1e3)):o.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(_.indexOf("powershell")>=0||_.indexOf("pwsh")>=0||_.indexOf("cmd.exe")>=0?d.sendText("cls"):_.indexOf("bash")>=0?d.sendText("clear"):F.isWindows?d.sendText("cls"):d.sendText("clear"));const b=(0,p.prepareCommand)(_,r.args,c,r.env);d.sendText(b);const T=this.onDidTerminateDebugSession(A=>{A.id===g&&(this._integratedTerminalInstances.free(d),T.dispose())});return l}else if(r.kind==="external")return(0,p.runInExternalTerminal)(r,await this._configurationService.getConfigProvider());return super.$runInTerminal(r,g)}createVariableResolver(r,g,o){return new u.ExtHostVariableResolverService(r,g,o,this._editorTabs,this._workspaceService)}};I=je([He(0,P.IExtHostRpcService),He(1,i.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,S.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,R.IExtHostTerminalService),He(6,v.IExtHostEditorTabs)],I),e.ExtHostDebugService=I;class w{constructor(){this._terminalInstances=new Map}async checkout(r,g){const _=[...this._terminalInstances.entries()].map(([n,t])=>(0,h.createCancelablePromise)(async s=>{if(n.name!==g||t.lastUsedAt!==-1&&await(0,p.hasChildProcesses)(await n.processId))return null;const d=Date.now();return t.lastUsedAt+w.minUseDelay>d||s.isCancellationRequested||t.config!==r?null:(t.lastUsedAt=d,n)}));return await(0,h.firstParallel)(_,n=>!!n)}insert(r,g){this._terminalInstances.set(r,{lastUsedAt:Date.now(),config:g})}free(r){const g=this._terminalInstances.get(r);g&&(g.lastUsedAt=-1)}onTerminalClosed(r){this._terminalInstances.delete(r)}}w.minUseDelay=1e3}),define(pe[270],ve([0,1,9,2,112,35,55,45,36,43,34,14,26,70,10,11,65,54,23,81]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let r=class extends E.ExtHostTaskBase{constructor(o,_,n,t,s,d,c,f,l){super(o,_,n,t,s,d,c,f);this.workspaceService=n,this.editorTabs=l,_.remote.isRemote&&_.remote.authority?this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:_.remote.authority,platform:process.platform}):this.registerTaskSystem(h.Schemas.file,{scheme:h.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,_){const n=_;if(!_.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const t=E.TaskHandleDTO.from(n,this.workspaceService),s=await this._proxy.$getTaskExecution(t);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const d=await this.getTaskExecution(s,_);return this._proxy.$executeTask(t).catch(()=>{}),d}else{const t=E.TaskDTO.from(_,o);if(t===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,_,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),_);return this._proxy.$executeTask(t).catch(()=>{}),s}}provideTasksInternal(o,_,n,t){const s=[];if(t)for(let d of t){this.checkDeprecation(d,n),(!d.definition||!o[d.definition.type])&&this._logService.warn(`The task [${d.source}, ${d.name}] uses an undefined task type. The task will be ignored in the future.`);const c=E.TaskDTO.from(d,n.extension);c&&(s.push(c),E.CustomExecutionDTO.is(c.execution)&&_.push(this.addCustomExecution(c,d,!0)))}return{tasks:s,extension:n.extension}}async resolveTaskInternal(o){return o}async getVariableResolver(o){if(this._variableResolver===void 0){const _=await this._configurationService.getConfigProvider();this._variableResolver=new i.ExtHostVariableResolverService(o,this._editorService,_,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(o){let _=o&&o.length>0?o[0]:void 0;if(!_){const n=F.URI.file((0,a.homedir)());_=new D.WorkspaceFolder({uri:n,name:w.basename(n),index:0})}return{uri:_.uri,name:_.name,index:_.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,_){const n=F.URI.revive(o),t={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(n),d=await this._workspaceProvider.getWorkspaceFolders2()??[],c=await this.getVariableResolver(d),f=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(d);for(let l of _.variables)t.variables[l]=await c.resolveAsync(f,l);if(_.process!==void 0){let l;if(_.process.path!==void 0){l=_.process.path.split(m.delimiter);for(let b=0;b<l.length;b++)l[b]=await c.resolveAsync(f,l[b])}t.process=await y.win32.findExecutable(await c.resolveAsync(f,_.process.name),_.process.cwd!==void 0?await c.resolveAsync(f,_.process.cwd):void 0,l)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(o,_,n){return y.win32.findExecutable(o,_,n)}};r=je([He(0,P.IExtHostRpcService),He(1,u.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,k.IExtHostDocumentsAndEditors),He(4,S.IExtHostConfiguration),He(5,R.IExtHostTerminalService),He(6,p.ILogService),He(7,v.IExtHostApiDeprecationService),He(8,I.IExtHostEditorTabs)],r),e.ExtHostTask=r}),define(pe[271],ve([0,1,18,15,71,6,2,5,263,11,83,85,26,186,14,64,39,34]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(r,g,o,_){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=o,this._rpcProtocol=new S.RPCProtocol(r,null,_),g=w._transform(g,this._rpcProtocol);const n=new P.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());n.set(u.IExtHostInitDataService,{_serviceBrand:void 0,...g}),n.set(h.IExtHostRpcService,new h.ExtHostRpcService(this._rpcProtocol)),n.set(p.IURITransformerService,new p.URITransformerService(_)),n.set(v.IHostUtils,o);const t=new E.InstantiationService(n,!0);this._disposables.add(t.invokeFunction(f=>f.get(I.IExtHostTerminalService))),this._disposables.add(t.invokeFunction(f=>f.get(v.IExtHostExtensionService))),this._logService=t.invokeFunction(f=>f.get(D.ILogService)),y.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=t.invokeFunction(f=>f.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const s=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(l,b)=>{let T="",A,U;for(const B of b)T+=`
	at ${B.toString()}`,U=B.getFileName(),!A&&U&&(A=f.findSubstr(i.URI.file(U)));return s.set(l,A),`${l.name||"Error"}: ${l.message||""}${T}`}});const d=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),c=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(f=>{const l=F.transformErrorForSerialization(f),b=s.get(f);b?d.$onExtensionRuntimeError(b.identifier,l):c.$onUnexpectedError(l)})}terminate(r){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${r}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(o=>{this._logService.error(o)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();Promise.race([(0,m.timeout)(5e3),g]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(r,g){r.extensions.forEach(_=>_.extensionLocation=i.URI.revive(g.transformIncomingURIs(_.extensionLocation))),r.environment.appRoot=i.URI.revive(g.transformIncomingURIs(r.environment.appRoot));const o=r.environment.extensionDevelopmentLocationURI;return o&&(r.environment.extensionDevelopmentLocationURI=o.map(_=>i.URI.revive(g.transformIncomingURIs(_)))),r.environment.extensionTestsLocationURI=i.URI.revive(g.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=i.URI.revive(g.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=i.URI.revive(g.transformIncomingURIs(r.environment.workspaceStorageHome)),r.logsLocation=i.URI.revive(g.transformIncomingURIs(r.logsLocation)),r.logFile=i.URI.revive(g.transformIncomingURIs(r.logFile)),r.workspace=g.transformIncomingURIs(r.workspace),r}}e.ExtensionHostMain=w}),define(pe[272],ve([0,1,9,21,50,31,23,46,33]),function(Y,e,m,F,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class D{constructor(u,E,h){this.config=u,this.provider=E,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=u.filePattern,this.includePattern=u.includePattern&&C.parse(u.includePattern),this.maxResults=u.maxResults||void 0,this.exists=u.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=u.excludePattern&&C.parse(u.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(u=>u.cancel()),this.activeCancellationTokens=new Set}search(u){const E=this.config.folderQueries||[];return new Promise((h,p)=>{const v=I=>{this.resultCount++,u(I)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(I=>{const w=I.toString(),a=m.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,a)||this.matchFile(v,{base:I,basename:a})}),Promise.all(E.map(I=>this.searchInFolder(I,v))).then(I=>{h({limitHit:this.isLimitHit,stats:I[0]||void 0})},I=>{p(new Error((0,y.toErrorMessage)(I)))})})}async searchInFolder(u,E){const h=new F.CancellationTokenSource,p=this.getSearchOptionsForFolder(u),v=this.initDirectoryTree(),I=new S.QueryGlobTester(this.config,u),w=!I.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(h),a=k.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},p,h.token),g=a.elapsed(),o=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(_=>{const n=m.posix.relative(u.folder.path,_.path);if(w){const t=m.basename(_.path);this.matchFile(E,{base:u.folder,relativePath:n,basename:t});return}this.addDirectoryEntries(v,u.folder,n,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,I,E),{providerTime:g,postProcessTime:o.elapsed()})}finally{h.dispose(),this.activeCancellationTokens.delete(h)}}getSearchOptionsForFolder(u){const E=(0,S.resolvePatternsForProvider)(this.config.includePattern,u.includePattern),h=(0,S.resolvePatternsForProvider)(this.config.excludePattern,u.excludePattern);return{folder:u.folder,excludes:h,includes:E,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries({pathToEntries:u},E,h,p){if(h===this.filePattern){const I=m.basename(this.filePattern);this.matchFile(p,{base:E,relativePath:this.filePattern,basename:I})}function v(I){const w=m.basename(I),a=m.dirname(I);let r=u[a];r||(r=u[a]=[],v(a)),r.push({base:E,relativePath:I,basename:w})}v(h)}matchDirectoryTree({rootEntries:u,pathToEntries:E},h,p){const v=this,I=this.filePattern;function w(a){const r=C.hasSiblingFn(()=>a.map(g=>g.basename));for(let g=0,o=a.length;g<o;g++){const _=a[g],{relativePath:n,basename:t}=_;if(h.matchesExcludesSync(n,t,I!==t?r:void 0))continue;const s=E[n];if(s)w(s);else{if(n===I)continue;v.matchFile(p,_)}if(v.isLimitHit)break}}w(u)}matchFile(u,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||u(E))}}class R{constructor(){this.sessions=new Map}fileSearch(u,E,h,p){const v=this.getSessionTokenSource(u.cacheKey),I=new D(u,E,v&&v.token);let w=0;const a=r=>{w+=r.length,h(r.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(I,R.BATCH_SIZE,a,p).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:r.stats}}))}clearCache(u){const E=this.getSessionTokenSource(u);E&&E.cancel()}getSessionTokenSource(u){if(!!u)return this.sessions.has(u)||this.sessions.set(u,new F.CancellationTokenSource),this.sessions.get(u)}rawMatchToSearchItem(u){return u.relativePath?{resource:i.joinPath(u.base,u.relativePath)}:{resource:u.base}}doSearch(u,E,h,p){p.onCancellationRequested(()=>{u.cancel()});const v=w=>{w&&(I.push(w),E>0&&I.length>=E&&(h(I),I=[]))};let I=[];return u.search(v).then(w=>(I.length&&h(I),w),w=>(I.length&&h(I),Promise.reject(w)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(pe[134],ve([0,1,16,21,50,31,10,9,23,13,2,33]),function(Y,e,m,F,y,C,i,k,S,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class u{constructor(a,r,g,o){this.query=a,this.provider=r,this.fileUtils=g,this.processType=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,r){const g=this.query.folderQueries||[],o=new F.CancellationTokenSource;return r.onCancellationRequested(()=>o.cancel()),new Promise((_,n)=>{this.collector=new h(a);let t=!1;const s=(d,c)=>{if(!t&&!this.isLimitHit){const f=this.resultSize(d);v(d)&&typeof this.query.maxResults=="number"&&this.resultCount+f>this.query.maxResults&&(this.isLimitHit=!0,t=!0,o.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const l=this.resultSize(d);this.resultCount+=l,(l>0||!v(d))&&this.collector.add(d,c)}};Promise.all(g.map((d,c)=>this.searchInFolder(d,f=>s(f,c),o.token))).then(d=>{o.dispose(),this.collector.flush();const c=d.some(f=>!!f&&!!f.limitHit);_({limitHit:this.isLimitHit||c,messages:(0,m.flatten)(d.map(f=>f?.message?(0,D.isArray)(f.message)?f.message:[f.message]:[])),stats:{type:this.processType}})},d=>{o.dispose();const c=(0,y.toErrorMessage)(d);n(new Error(c))})})}resultSize(a){return v(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,r){const g=Array.isArray(a.ranges)?a.ranges:[a.ranges],o=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:g.slice(0,r),preview:{matches:o.slice(0,r),text:a.preview.text},uri:a.uri}}async searchInFolder(a,r,g){const o=new P.QueryGlobTester(this.query,a),_=[],n={report:d=>{if(!this.validateProviderResult(d))return;const c=a.folder.scheme===i.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(d.uri))):void 0,f=S.relativePath(a.folder,d.uri);if(f){const l=o.includedInQuery(f,k.basename(f),c);(0,D.isPromise)(l)?_.push(l.then(b=>{b&&r(d)})):l&&r(d)}}},t=this.getSearchOptionsForFolder(a),s=await this.provider.provideTextSearchResults(E(this.query.contentPattern),t,n,g);return _.length&&await Promise.all(_),s}validateProviderResult(a){if(v(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const r=(0,P.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),g=(0,P.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),o={folder:R.URI.from(a.folder),excludes:g,includes:r,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return o.usePCRE2=this.query.usePCRE2,o}}e.TextSearchManager=u;function E(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class h{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new I(512,r=>this.sendItems(r))}add(a,r){this._currentFileMatch&&(this._currentFolderIdx!==r||!S.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=r,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(p(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=h;function p(w){return v(w)?{preview:{matches:(0,m.mapArrayOrNot)(w.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:w.preview.text},ranges:(0,m.mapArrayOrNot)(w.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function v(w){return!!w.preview}e.extensionResultIsMatch=v;class I{constructor(a,r){this.maxBatchSize=a,this.cb=r,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,r){!a||this.addItemToBatch(a,r)}addItems(a,r){!a||this.addItemsToBatch(a,r)}addItemToBatch(a,r){this.batch.push(a),this.batchSize+=r,this.onUpdate()}addItemsToBatch(a,r){this.batch=this.batch.concat(a),this.batchSize+=r,this.onUpdate()}onUpdate(){this.totalNumberCompleted<I.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},I.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=I,I.TIMEOUT=4e3,I.START_BATCH_AFTER_COUNT=50}),define(pe[72],ve([0,1,6,5,4,272,14,64,11,2,134]),function(Y,e,m,F,y,C,i,k,S,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let P=class{constructor(p,v,I){this.extHostRpc=p,this._uriTransformer=v,this._logService=I,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}registerTextSearchProvider(p,v){if(this._textSearchUsedSchemes.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this._textSearchUsedSchemes.add(p);const I=this._handlePool++;return this._textSearchProvider.set(I,v),this._proxy.$registerTextSearchProvider(I,this._transformScheme(p)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(p),this._textSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}registerFileSearchProvider(p,v){if(this._fileSearchUsedSchemes.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this._fileSearchUsedSchemes.add(p);const I=this._handlePool++;return this._fileSearchProvider.set(I,v),this._proxy.$registerFileSearchProvider(I,this._transformScheme(p)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(p),this._fileSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}$provideFileSearchResults(p,v,I,w){const a=u(I),r=this._fileSearchProvider.get(p);if(r)return this._fileSearchManager.fileSearch(a,r,g=>{this._proxy.$handleFileMatch(p,v,g.map(o=>o.resource))},w);throw new Error("unknown provider: "+p)}$clearCache(p){return this._fileSearchManager.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,v,I,w){const a=this._textSearchProvider.get(p);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const r=u(I);return this.createTextSearchManager(r,a).search(o=>this._proxy.$handleTextMatch(p,v,o),w)}$enableExtensionHostSearch(){}createTextSearchManager(p,v){return new R.TextSearchManager(p,v,{readdir:I=>Promise.resolve([]),toCanonicalName:I=>I},"textSearchProvider")}};P=je([He(0,i.IExtHostRpcService),He(1,k.IURITransformerService),He(2,S.ILogService)],P),e.ExtHostSearch=P;function u(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(E),extraFileResources:h.extraFileResources&&h.extraFileResources.map(p=>D.URI.revive(p))}}e.reviveQuery=u;function E(h){return{...h,folder:D.URI.revive(h.folder)}}}),define(pe[273],ve([0,1,21,15,3,48,2,113,108,146,82,42,5,231,230,38,232,36,233,234,235,216,236,45,39,237,217,240,241,242,132,219,247,248,249,91,34,251,220,17,7,254,68,133,35,73,205,239,62,130,70,55,72,11,64,14,26,243,202,52,65,228,252,201,67,66,257,255,256,229,44,250,253,90,54,121,245,69,246,10,189,244,199,238,6,29]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I,w,a,r,g,o,_,n,t,s,d,c,f,l,b,T,A,U,B,L,x,M,V,O,W,q,N,G,$,H,j,ie,fe,ye,Ie,Be,We,ze,Q,ee,re,he,Z,oe,be,Me,Ve,Ge,Je,tt,ot,et,it,ct,pt,Pt,Ue,Rt,J,ne,ge,te,Ee,Le,Oe,Xe,Te,ke,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function le(ue){const we=ue.get(ee.IExtHostInitDataService),_e=ue.get(ct.IExtHostFileSystemInfo),Fe=ue.get(Je.IExtHostConsumerFileSystem),Ke=ue.get(n.IExtHostExtensionService),$e=ue.get(G.IExtHostWorkspace),Qe=ue.get(J.IExtHostTelemetry),st=ue.get(I.IExtHostConfiguration),at=ue.get(ze.IURITransformerService),de=ue.get(Q.IExtHostRpcService),Ce=ue.get(B.IExtHostStorage),ce=ue.get(Ge.IExtensionStoragePaths),X=ue.get(We.ILoggerService),De=ue.get(We.ILogService),Re=ue.get(Z.IExtHostTunnelService),Ze=ue.get(oe.IExtHostApiDeprecationService),qe=ue.get(N.IExtHostWindow),dt=ue.get(Ue.IExtHostSecretState),wt=ue.get(Rt.IExtHostEditorTabs);de.set(u.ExtHostContext.ExtHostFileSystemInfo,_e),de.set(u.ExtHostContext.ExtHostLogLevelServiceShape,X),de.set(u.ExtHostContext.ExtHostWorkspace,$e),de.set(u.ExtHostContext.ExtHostConfiguration,st),de.set(u.ExtHostContext.ExtHostExtensionService,Ke),de.set(u.ExtHostContext.ExtHostStorage,Ce),de.set(u.ExtHostContext.ExtHostTunnelService,Re),de.set(u.ExtHostContext.ExtHostWindow,qe),de.set(u.ExtHostContext.ExtHostSecretState,dt),de.set(u.ExtHostContext.ExtHostTelemetry,Qe),de.set(u.ExtHostContext.ExtHostEditorTabs,wt);const yt=de.set(u.ExtHostContext.ExtHostDecorations,ue.get(fe.IExtHostDecorations)),bt=de.set(u.ExtHostContext.ExtHostDocumentsAndEditors,ue.get(_.IExtHostDocumentsAndEditors)),ft=de.set(u.ExtHostContext.ExtHostCommands,ue.get(p.IExtHostCommands)),vt=de.set(u.ExtHostContext.ExtHostTerminalService,ue.get(L.IExtHostTerminalService)),St=de.set(u.ExtHostContext.ExtHostDebugService,ue.get(Ie.IExtHostDebugService)),Ot=de.set(u.ExtHostContext.ExtHostSearch,ue.get(Be.IExtHostSearch)),It=de.set(u.ExtHostContext.ExtHostTask,ue.get(ye.IExtHostTask)),Tt=de.set(u.ExtHostContext.ExtHostOutputService,ue.get(l.IExtHostOutputService)),Lt=de.set(u.ExtHostContext.ExtHostUrls,new W.ExtHostUrls(de)),_t=de.set(u.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(de,bt)),Mt=de.set(u.ExtHostContext.ExtHostDocumentContentProviders,new r.ExtHostDocumentContentProvider(de,bt,De)),Nt=de.set(u.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(De,_t,de.getProxy(u.MainContext.MainThreadBulkEdits))),Et=de.set(u.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(de,ft,bt,_t,ce)),Wt=de.set(u.ExtHostContext.ExtHostNotebookDocuments,new Xe.ExtHostNotebookDocuments(De,Et)),jt=de.set(u.ExtHostContext.ExtHostNotebookEditors,new Oe.ExtHostNotebookEditors(De,de,Et)),si=de.set(u.ExtHostContext.ExtHostNotebookKernels,new ne.ExtHostNotebookKernels(de,we,Et,ft,De)),oi=de.set(u.ExtHostContext.ExtHostNotebookRenderers,new te.ExtHostNotebookRenderers(de,Et)),At=de.set(u.ExtHostContext.ExtHostEditors,new x.ExtHostEditors(de,bt)),Xt=de.set(u.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(de.getProxy(u.MainContext.MainThreadTreeViews),ft,De)),ai=de.set(u.ExtHostContext.ExtHostEditorInsets,new H.ExtHostEditorInsets(de.getProxy(u.MainContext.MainThreadEditorInsets),At,we)),Yt=de.set(u.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(de,De,_e)),Vt=de.set(u.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(de,_t,ft.converter,at)),gt=de.set(u.ExtHostContext.ExtHostLanguageFeatures,new d.ExtHostLanguageFeatures(de,at,_t,ft,Yt,De,Ze)),ci=de.set(u.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(de,gt)),Ut=de.set(u.ExtHostContext.ExtHostFileSystemEventService,new s.ExtHostFileSystemEventService(de,De,bt)),qt=de.set(u.ExtHostContext.ExtHostQuickOpen,(0,T.createExtHostQuickOpen)(de,$e,ft)),Jt=de.set(u.ExtHostContext.ExtHostSCM,new A.ExtHostSCM(de,ft,De)),li=de.set(u.ExtHostContext.ExtHostComments,(0,v.createExtHostComments)(de,ft,_t)),fi=de.set(u.ExtHostContext.ExtHostProgress,new b.ExtHostProgress(de.getProxy(u.MainContext.MainThreadProgress))),Ei=de.set(u.ExtHostContext.ExtHosLabelService,new j.ExtHostLabelService(de)),mi=de.set(u.ExtHostContext.ExtHostTheming,new he.ExtHostTheming(de)),Zt=de.set(u.ExtHostContext.ExtHostAuthentication,new be.ExtHostAuthentication(de)),_i=de.set(u.ExtHostContext.ExtHostTimeline,new Me.ExtHostTimeline(de,ft)),Gt=de.set(u.ExtHostContext.ExtHostWebviews,new q.ExtHostWebviews(de,{remote:we.remote},$e,De,Ze)),Kt=de.set(u.ExtHostContext.ExtHostWebviewPanels,new et.ExtHostWebviewPanels(de,Gt,$e)),Si=de.set(u.ExtHostContext.ExtHostCustomEditors,new ot.ExtHostCustomEditors(de,_t,ce,Gt,Kt)),Ci=de.set(u.ExtHostContext.ExtHostWebviewViews,new tt.ExtHostWebviewViews(de,Gt)),Qt=de.set(u.ExtHostContext.ExtHostTesting,new pt.ExtHostTesting(de,ft)),yi=de.set(u.ExtHostContext.ExtHostUriOpeners,new Pt.ExtHostUriOpeners(de));de.set(u.ExtHostContext.ExtHostInteractive,new Te.ExtHostInteractive(de,Et,bt,ft));const ei=(0,$.values)(u.ExtHostContext);de.assertRegistered(ei);const Di=new it.ExtHostBulkEdits(de,bt),ki=new h.ExtHostClipboard(de),ui=new f.ExtHostMessageService(de,De),ti=new a.ExtHostDialogs(de),gi=new U.ExtHostStatusBar(de,ft.converter);return E.ExtHostApiCommands.register(ft),function(xe,xt,pi){const mt=function(){let se=!xe.isUnderDevelopment;function me(){se||(De.info(`Extension '${xe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Ae(ut){if(Array.isArray(ut))ut.forEach(Ae);else if(typeof ut=="string")me();else{const Ct=ut;typeof Ct.scheme=="undefined"&&me(),typeof Ct.exclusive=="boolean"&&(0,Se.checkProposedApiEnabled)(xe,"documentFiltersExclusive")}return ut}}(),ii={getSession(se,me,Ae){return Zt.getSession(xe,se,me,Ae)},async hasSession(se,me){return(0,Se.checkProposedApiEnabled)(xe,"authSession"),!!await Zt.getSession(xe,se,me,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(se,me,Ae,ut){return Zt.registerAuthenticationProvider(se,me,Ae,ut)}},Ii={registerCommand(se,me,Ae){return ft.registerCommand(!0,se,me,Ae,void 0,xe)},registerTextEditorCommand(se,me,Ae){return ft.registerCommand(!0,se,(...ut)=>{const Ct=At.getActiveTextEditor();if(!Ct){De.warn("Cannot execute "+se+" because there is no active text editor.");return}return Ct.edit(Dt=>{me.apply(Ae,[Ct,Dt,...ut])}).then(Dt=>{Dt||De.warn("Edits from command "+se+" were not applied.")},Dt=>{De.warn("An error occurred while running command "+se,Dt)})},void 0,void 0,xe)},registerDiffInformationCommand:(se,me,Ae)=>((0,Se.checkProposedApiEnabled)(xe,"diffCommand"),ft.registerCommand(!0,se,async(...ut)=>{const Ct=bt.activeEditor(!0);if(!Ct){De.warn("Cannot execute "+se+" because there is no active text editor.");return}const Dt=await At.getDiffInformation(Ct.id);me.apply(Ae,[Dt,...ut])},void 0,void 0,xe)),executeCommand(se,...me){return ft.executeCommand(se,...me)},getCommands(se=!1){return ft.getCommands(se)}},vi={get machineId(){return we.telemetryInfo.machineId},get sessionId(){return we.telemetryInfo.sessionId},get language(){return we.environment.appLanguage},get appName(){return we.environment.appName},get appRoot(){return we.environment.appRoot?.fsPath??""},get appHost(){return we.environment.appHost},get uriScheme(){return we.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return Qe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Qe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const se=Date.now()-new Date(we.telemetryInfo.firstSessionDate).getTime();return isNaN(se)?!1:se<1e3*60*60*24},openExternal(se,me){return qe.openUri(se,{allowTunneling:!!we.remote.authority,allowContributedOpeners:me?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===we.environment.appUriScheme)return Lt.createAppUri(se);try{return await qe.asExternalUri(se,{allowTunneling:!!we.remote.authority})}catch(me){if((0,Le.matchesScheme)(se,Ee.Schemas.http)||(0,Le.matchesScheme)(se,Ee.Schemas.https))return se;throw me}},get remoteName(){return(0,ie.getRemoteName)(we.remote.authority)},get remoteAuthority(){return(0,Se.checkProposedApiEnabled)(xe,"resolvers"),we.remote.authority},get uiKind(){return we.uiKind}};we.environment.extensionTestsLocationURI||Object.freeze(vi);const wi=we.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,Pi={createTestController(se,me){return Qt.createTestController(se,me)},createTestObserver(){return(0,Se.checkProposedApiEnabled)(xe,"testObserver"),Qt.createTestObserver()},runTests(se){return(0,Se.checkProposedApiEnabled)(xe,"testObserver"),Qt.runTests(se)},get onDidChangeTestResults(){return(0,Se.checkProposedApiEnabled)(xe,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,Se.checkProposedApiEnabled)(xe,"testObserver"),Qt.results}},Ti={getExtension(se){const me=xt.getExtensionDescription(se);if(me)return new n.Extension(Ke,xe.identifier,me,wi)},get all(){return xt.getAllExtensionDescriptions().map(se=>new n.Extension(Ke,xe.identifier,se,wi))},get onDidChange(){return xt.onDidChange}},Ai={createDiagnosticCollection(se){return Yt.createDiagnosticCollection(xe.identifier,se)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:se=>Yt.getDiagnostics(se),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(se,me){return Vt.changeLanguage(se.uri,me)},match(se,me){return(0,R.score)(V.LanguageSelector.from(se),me.uri,me.languageId,!0)},registerCodeActionsProvider(se,me,Ae){return gt.registerCodeActionProvider(xe,mt(se),me,Ae)},registerCodeLensProvider(se,me){return gt.registerCodeLensProvider(xe,mt(se),me)},registerDefinitionProvider(se,me){return gt.registerDefinitionProvider(xe,mt(se),me)},registerDeclarationProvider(se,me){return gt.registerDeclarationProvider(xe,mt(se),me)},registerImplementationProvider(se,me){return gt.registerImplementationProvider(xe,mt(se),me)},registerTypeDefinitionProvider(se,me){return gt.registerTypeDefinitionProvider(xe,mt(se),me)},registerHoverProvider(se,me){return gt.registerHoverProvider(xe,mt(se),me,xe.identifier)},registerEvaluatableExpressionProvider(se,me){return gt.registerEvaluatableExpressionProvider(xe,mt(se),me,xe.identifier)},registerInlineValuesProvider(se,me){return gt.registerInlineValuesProvider(xe,mt(se),me,xe.identifier)},registerDocumentHighlightProvider(se,me){return gt.registerDocumentHighlightProvider(xe,mt(se),me)},registerLinkedEditingRangeProvider(se,me){return gt.registerLinkedEditingRangeProvider(xe,mt(se),me)},registerReferenceProvider(se,me){return gt.registerReferenceProvider(xe,mt(se),me)},registerRenameProvider(se,me){return gt.registerRenameProvider(xe,mt(se),me)},registerDocumentSymbolProvider(se,me,Ae){return gt.registerDocumentSymbolProvider(xe,mt(se),me,Ae)},registerWorkspaceSymbolProvider(se){return gt.registerWorkspaceSymbolProvider(xe,se)},registerDocumentFormattingEditProvider(se,me){return gt.registerDocumentFormattingEditProvider(xe,mt(se),me)},registerDocumentRangeFormattingEditProvider(se,me){return gt.registerDocumentRangeFormattingEditProvider(xe,mt(se),me)},registerOnTypeFormattingEditProvider(se,me,Ae,...ut){return gt.registerOnTypeFormattingEditProvider(xe,mt(se),me,[Ae].concat(ut))},registerDocumentSemanticTokensProvider(se,me,Ae){return gt.registerDocumentSemanticTokensProvider(xe,mt(se),me,Ae)},registerDocumentRangeSemanticTokensProvider(se,me,Ae){return gt.registerDocumentRangeSemanticTokensProvider(xe,mt(se),me,Ae)},registerSignatureHelpProvider(se,me,Ae,...ut){return typeof Ae=="object"?gt.registerSignatureHelpProvider(xe,mt(se),me,Ae):gt.registerSignatureHelpProvider(xe,mt(se),me,typeof Ae=="undefined"?[]:[Ae,...ut])},registerCompletionItemProvider(se,me,...Ae){return gt.registerCompletionItemProvider(xe,mt(se),me,Ae)},registerInlineCompletionItemProvider(se,me){return(0,Se.checkProposedApiEnabled)(xe,"inlineCompletions"),gt.registerInlineCompletionsProvider(xe,mt(se),me)},registerDocumentLinkProvider(se,me){return gt.registerDocumentLinkProvider(xe,mt(se),me)},registerColorProvider(se,me){return gt.registerColorProvider(xe,mt(se),me)},registerFoldingRangeProvider(se,me){return gt.registerFoldingRangeProvider(xe,mt(se),me)},registerSelectionRangeProvider(se,me){return gt.registerSelectionRangeProvider(xe,se,me)},registerCallHierarchyProvider(se,me){return gt.registerCallHierarchyProvider(xe,se,me)},registerTypeHierarchyProvider(se,me){return gt.registerTypeHierarchyProvider(xe,se,me)},setLanguageConfiguration:(se,me)=>gt.setLanguageConfiguration(xe,se,me),getTokenInformationAtPosition(se,me){return(0,Se.checkProposedApiEnabled)(xe,"tokenInformation"),Vt.tokenAtPosition(se,me)},registerInlayHintsProvider(se,me){return(0,Se.checkProposedApiEnabled)(xe,"inlayHints"),gt.registerInlayHintsProvider(xe,se,me)},createLanguageStatusItem(se,me){return(0,Se.checkProposedApiEnabled)(xe,"languageStatus"),Vt.createLanguageStatusItem(xe,se,me)}},Ri={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(se,me,Ae){const ut=await(i.URI.isUri(se)?Promise.resolve(ni.openTextDocument(se)):Promise.resolve(se));return At.showTextDocument(ut,me,Ae)},createTextEditorDecorationType(se){return At.createTextEditorDecorationType(xe,se)},onDidChangeActiveTextEditor(se,me,Ae){return At.onDidChangeActiveTextEditor(se,me,Ae)},onDidChangeVisibleTextEditors(se,me,Ae){return At.onDidChangeVisibleTextEditors(se,me,Ae)},onDidChangeTextEditorSelection(se,me,Ae){return At.onDidChangeTextEditorSelection(se,me,Ae)},onDidChangeTextEditorOptions(se,me,Ae){return At.onDidChangeTextEditorOptions(se,me,Ae)},onDidChangeTextEditorVisibleRanges(se,me,Ae){return At.onDidChangeTextEditorVisibleRanges(se,me,Ae)},onDidChangeTextEditorViewColumn(se,me,Ae){return At.onDidChangeTextEditorViewColumn(se,me,Ae)},onDidCloseTerminal(se,me,Ae){return vt.onDidCloseTerminal(se,me,Ae)},onDidOpenTerminal(se,me,Ae){return vt.onDidOpenTerminal(se,me,Ae)},onDidChangeActiveTerminal(se,me,Ae){return vt.onDidChangeActiveTerminal(se,me,Ae)},onDidChangeTerminalDimensions(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"terminalDimensions"),vt.onDidChangeTerminalDimensions(se,me,Ae)},onDidChangeTerminalState(se,me,Ae){return vt.onDidChangeTerminalState(se,me,Ae)},onDidWriteTerminalData(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(se,me,Ae)},get state(){return qe.state},onDidChangeWindowState(se,me,Ae){return qe.onDidChangeWindowState(se,me,Ae)},showInformationMessage(se,...me){return ui.showMessage(xe,C.default.Info,se,me[0],me.slice(1))},showWarningMessage(se,...me){return ui.showMessage(xe,C.default.Warning,se,me[0],me.slice(1))},showErrorMessage(se,...me){return ui.showMessage(xe,C.default.Error,se,me[0],me.slice(1))},showQuickPick(se,me,Ae){return Array.isArray(se)&&se.some(ut=>ut.kind!==void 0)&&(0,Se.checkProposedApiEnabled)(xe,"quickPickSeparators"),qt.showQuickPick(se,me,Ae)},showWorkspaceFolderPick(se){return qt.showWorkspaceFolderPick(se)},showInputBox(se,me){return qt.showInput(se,me)},showOpenDialog(se){return ti.showOpenDialog(se)},showSaveDialog(se){return ti.showSaveDialog(se)},createStatusBarItem(se,me,Ae){let ut,Ct,Dt;return typeof se=="string"?(ut=se,Ct=me,Dt=Ae):(Ct=se,Dt=me),gi.createStatusBarEntry(xe,ut,Ct,Dt)},setStatusBarMessage(se,me){return gi.setStatusBarMessage(se,me)},withScmProgress(se){return Ze.report("window.withScmProgress",xe,"Use 'withProgress' instead."),fi.withProgress(xe,{location:O.ProgressLocation.SourceControl},(me,Ae)=>se({report(ut){}}))},withProgress(se,me){return fi.withProgress(xe,se,me)},createOutputChannel(se){return Tt.createOutputChannel(se,xe)},createWebviewPanel(se,me,Ae,ut){return Kt.createWebviewPanel(xe,se,me,Ae,ut)},createWebviewTextEditorInset(se,me,Ae,ut){return(0,Se.checkProposedApiEnabled)(xe,"editorInsets"),ai.createWebviewEditorInset(se,me,Ae,ut,xe)},createTerminal(se,me,Ae){return typeof se=="object"?"pty"in se?vt.createExtensionTerminal(se):vt.createTerminalFromOptions(se):vt.createTerminal(se,me,Ae)},registerTerminalLinkProvider(se){return vt.registerLinkProvider(se)},registerTerminalProfileProvider(se,me){return vt.registerProfileProvider(xe,se,me)},registerTreeDataProvider(se,me){return Xt.registerTreeDataProvider(se,me,xe)},createTreeView(se,me){return Xt.createTreeView(se,me,xe)},registerWebviewPanelSerializer:(se,me)=>Kt.registerWebviewPanelSerializer(xe,se,me),registerCustomEditorProvider:(se,me,Ae={})=>Si.registerCustomEditorProvider(xe,se,me,Ae),registerFileDecorationProvider(se){return yt.registerFileDecorationProvider(se,xe.identifier)},registerUriHandler(se){return Lt.registerUriHandler(xe.identifier,se)},createQuickPick(){return qt.createQuickPick(xe)},createInputBox(){return qt.createInputBox(xe.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(se,me,Ae){return mi.onDidChangeActiveColorTheme(se,me,Ae)},registerWebviewViewProvider(se,me,Ae){return Ci.registerWebviewViewProvider(xe,se,me,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(se,me,Ae)},get visibleNotebookEditors(){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),jt.onDidChangeNotebookEditorSelection(se,me,Ae)},onDidChangeNotebookEditorVisibleRanges(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),jt.onDidChangeNotebookEditorVisibleRanges(se,me,Ae)},showNotebookDocument(se,me){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Et.showNotebookDocument(se,me)},registerExternalUriOpener(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"externalUriOpener"),yi.registerExternalUriOpener(xe.identifier,se,me,Ae)},get tabs(){return(0,Se.checkProposedApiEnabled)(xe,"tabs"),wt.tabs},get activeTab(){return(0,Se.checkProposedApiEnabled)(xe,"tabs"),wt.activeTab},get onDidChangeTabs(){return(0,Se.checkProposedApiEnabled)(xe,"tabs"),wt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,Se.checkProposedApiEnabled)(xe,"tabs"),wt.onDidChangeActiveTab},getInlineCompletionItemController(se){return(0,Se.checkProposedApiEnabled)(xe,"inlineCompletions"),d.InlineCompletionController.get(se)}},ni={get rootPath(){return Ze.report("workspace.rootPath",xe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),$e.getPath()},set rootPath(se){throw F.readonly()},getWorkspaceFolder(se){return $e.getWorkspaceFolder(se)},get workspaceFolders(){return $e.getWorkspaceFolders()},get name(){return $e.name},set name(se){throw F.readonly()},get workspaceFile(){return $e.workspaceFile},set workspaceFile(se){throw F.readonly()},updateWorkspaceFolders:(se,me,...Ae)=>$e.updateWorkspaceFolders(xe,se,me||0,...Ae),onDidChangeWorkspaceFolders:function(se,me,Ae){return $e.onDidChangeWorkspace(se,me,Ae)},asRelativePath:(se,me)=>$e.getRelativePath(se,me),findFiles:(se,me,Ae,ut)=>$e.findFiles(V.GlobPattern.from(se),V.GlobPattern.from(me),Ae,xe.identifier,ut),findTextInFiles:(se,me,Ae,ut)=>{(0,Se.checkProposedApiEnabled)(xe,"findTextInFiles");let Ct,Dt;return typeof me=="object"?(Ct=me,Dt=Ae):(Ct={},Dt=me,ut=Ae),$e.findTextInFiles(se,Ct||{},Dt,xe.identifier,ut)},saveAll:se=>$e.saveAll(se),applyEdit(se){return Di.applyWorkspaceEdit(se)},createFileSystemWatcher:(se,me,Ae,ut)=>Ut.createFileSystemWatcher(V.GlobPattern.from(se),me,Ae,ut),get textDocuments(){return _t.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw F.readonly()},openTextDocument(se){let me;const Ae=se;if(typeof se=="string")me=Promise.resolve(i.URI.file(se));else if(i.URI.isUri(se))me=Promise.resolve(se);else if(!Ae||typeof Ae=="object")me=_t.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(ut=>_t.ensureDocumentData(ut).then(Ct=>Ct.document))},onDidOpenTextDocument:(se,me,Ae)=>_t.onDidAddDocument(se,me,Ae),onDidCloseTextDocument:(se,me,Ae)=>_t.onDidRemoveDocument(se,me,Ae),onDidChangeTextDocument:(se,me,Ae)=>_t.onDidChangeDocument(se,me,Ae),onDidSaveTextDocument:(se,me,Ae)=>_t.onDidSaveDocument(se,me,Ae),onWillSaveTextDocument:(se,me,Ae)=>Nt.getOnWillSaveTextDocumentEvent(xe)(se,me,Ae),get notebookDocuments(){return Et.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,me){let Ae;if(i.URI.isUri(se))Ae=se,await Et.openNotebookDocument(se);else if(typeof se=="string")Ae=i.URI.revive(await Et.createNotebookDocument({viewType:se,content:me}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(se,me,Ae,ut){return Et.registerNotebookSerializer(xe,se,me,Ae,(0,Se.isProposedApiEnabled)(xe,"notebookLiveShare")?ut:void 0)},registerNotebookContentProvider:(se,me,Ae,ut)=>((0,Se.checkProposedApiEnabled)(xe,"notebookContentProvider"),Et.registerNotebookContentProvider(xe,se,me,Ae,(0,Se.isProposedApiEnabled)(xe,"notebookLiveShare")?ut:void 0)),onDidChangeConfiguration:(se,me,Ae)=>pi.onDidChangeConfiguration(se,me,Ae),getConfiguration(se,me){return me=arguments.length===1?void 0:me,pi.getConfiguration(se,me,xe)},registerTextDocumentContentProvider(se,me){return Mt.registerTextDocumentContentProvider(se,me)},registerTaskProvider:(se,me)=>(Ze.report("window.registerTaskProvider",xe,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(xe,se,me)),registerFileSystemProvider(se,me,Ae){return(0,ke.combinedDisposable)(ci.registerFileSystemProvider(xe,se,me,Ae),Fe.addFileSystemProvider(se,me))},get fs(){return Fe.value},registerFileSearchProvider:(se,me)=>((0,Se.checkProposedApiEnabled)(xe,"fileSearchProvider"),Ot.registerFileSearchProvider(se,me)),registerTextSearchProvider:(se,me)=>((0,Se.checkProposedApiEnabled)(xe,"textSearchProvider"),Ot.registerTextSearchProvider(se,me)),registerRemoteAuthorityResolver:(se,me)=>((0,Se.checkProposedApiEnabled)(xe,"resolvers"),Ke.registerRemoteAuthorityResolver(se,me)),registerResourceLabelFormatter:se=>((0,Se.checkProposedApiEnabled)(xe,"resolvers"),Ei.$registerResourceLabelFormatter(se)),onDidCreateFiles:(se,me,Ae)=>Ut.onDidCreateFile(se,me,Ae),onDidDeleteFiles:(se,me,Ae)=>Ut.onDidDeleteFile(se,me,Ae),onDidRenameFiles:(se,me,Ae)=>Ut.onDidRenameFile(se,me,Ae),onWillCreateFiles:(se,me,Ae)=>Ut.getOnWillCreateFileEvent(xe)(se,me,Ae),onWillDeleteFiles:(se,me,Ae)=>Ut.getOnWillDeleteFileEvent(xe)(se,me,Ae),onWillRenameFiles:(se,me,Ae)=>Ut.getOnWillRenameFileEvent(xe)(se,me,Ae),openTunnel:se=>((0,Se.checkProposedApiEnabled)(xe,"resolvers"),Re.openTunnel(xe,se).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,Se.checkProposedApiEnabled)(xe,"resolvers"),Re.getTunnels()},onDidChangeTunnels:(se,me,Ae)=>((0,Se.checkProposedApiEnabled)(xe,"resolvers"),Re.onDidChangeTunnels(se,me,Ae)),registerPortAttributesProvider:(se,me)=>((0,Se.checkProposedApiEnabled)(xe,"portsAttributes"),Re.registerPortsAttributesProvider(se,me)),registerTimelineProvider:(se,me)=>((0,Se.checkProposedApiEnabled)(xe,"timeline"),_i.registerTimelineProvider(se,me,xe.identifier,ft.converter)),get isTrusted(){return $e.trusted},requestWorkspaceTrust:se=>((0,Se.checkProposedApiEnabled)(xe,"workspaceTrust"),$e.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,me,Ae)=>$e.onDidGrantWorkspaceTrust(se,me,Ae)},Li={get inputBox(){return Ze.report("scm.inputBox",xe,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(xe)},createSourceControl(se,me,Ae){return Jt.createSourceControl(xe,se,me,Ae)}},Fi={createCommentController(se,me){return li.createCommentController(xe,se,me)}},Mi={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},onDidStartDebugSession(se,me,Ae){return St.onDidStartDebugSession(se,me,Ae)},onDidTerminateDebugSession(se,me,Ae){return St.onDidTerminateDebugSession(se,me,Ae)},onDidChangeActiveDebugSession(se,me,Ae){return St.onDidChangeActiveDebugSession(se,me,Ae)},onDidReceiveDebugSessionCustomEvent(se,me,Ae){return St.onDidReceiveDebugSessionCustomEvent(se,me,Ae)},onDidChangeBreakpoints(se,me,Ae){return St.onDidChangeBreakpoints(se,me,Ae)},registerDebugConfigurationProvider(se,me,Ae){return St.registerDebugConfigurationProvider(se,me,Ae||O.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,me){return St.registerDebugAdapterDescriptorFactory(xe,se,me)},registerDebugAdapterTrackerFactory(se,me){return St.registerDebugAdapterTrackerFactory(se,me)},startDebugging(se,me,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?St.startDebugging(se,me,{parentSession:Ae}):St.startDebugging(se,me,Ae||{})},stopDebugging(se){return St.stopDebugging(se)},addBreakpoints(se){return St.addBreakpoints(se)},removeBreakpoints(se){return St.removeBreakpoints(se)},asDebugSourceUri(se,me){return St.asDebugSourceUri(se,me)}},Oi={registerTaskProvider:(se,me)=>It.registerTaskProvider(xe,se,me),fetchTasks:se=>It.fetchTasks(se),executeTask:se=>It.executeTask(xe,se),get taskExecutions(){return It.taskExecutions},onDidStartTask:(se,me,Ae)=>It.onDidStartTask(se,me,Ae),onDidEndTask:(se,me,Ae)=>It.onDidEndTask(se,me,Ae),onDidStartTaskProcess:(se,me,Ae)=>It.onDidStartTaskProcess(se,me,Ae),onDidEndTaskProcess:(se,me,Ae)=>It.onDidEndTaskProcess(se,me,Ae)},Ni={createNotebookController(se,me,Ae,ut,Ct){return si.createNotebookController(xe,se,me,Ae,ut,(0,Se.isProposedApiEnabled)(xe,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(se,me)=>Et.registerNotebookCellStatusBarItemProvider(xe,se,me),get onDidSaveNotebookDocument(){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Wt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(se){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditorDecorationType"),jt.createNotebookEditorDecorationType(se)},createRendererMessaging(se){return oi.createRendererMessaging(xe,se)},onDidChangeNotebookDocumentMetadata(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Wt.onDidChangeNotebookDocumentMetadata(se,me,Ae)},onDidChangeNotebookCells(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Et.onDidChangeNotebookCells(se,me,Ae)},onDidChangeNotebookCellExecutionState(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"notebookCellExecutionState"),Et.onDidChangeNotebookCellExecutionState(se,me,Ae)},onDidChangeCellOutputs(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Et.onDidChangeCellOutputs(se,me,Ae)},onDidChangeCellMetadata(se,me,Ae){return(0,Se.checkProposedApiEnabled)(xe,"notebookEditor"),Et.onDidChangeCellMetadata(se,me,Ae)},createConcatTextDocument(se,me){return(0,Se.checkProposedApiEnabled)(xe,"notebookConcatTextDocument"),new Ve.ExtHostNotebookConcatDocument(Et,_t,se,me)}};return{version:we.version,authentication:ii,commands:Ii,comments:Fi,debug:Mi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Li,tasks:Oi,tests:Pi,window:Ri,workspace:ni,Breakpoint:O.Breakpoint,CallHierarchyIncomingCall:O.CallHierarchyIncomingCall,CallHierarchyItem:O.CallHierarchyItem,CallHierarchyOutgoingCall:O.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:u.CandidatePortSource,CodeAction:O.CodeAction,CodeActionKind:O.CodeActionKind,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.CodeLens,Color:O.Color,ColorInformation:O.ColorInformation,ColorPresentation:O.ColorPresentation,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CompletionItem:O.CompletionItem,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.CompletionList,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.CustomExecution,DebugAdapterExecutable:O.DebugAdapterExecutable,DebugAdapterInlineImplementation:O.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:O.DebugAdapterNamedPipeServer,DebugAdapterServer:O.DebugAdapterServer,DebugConfigurationProviderTriggerKind:O.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.Diagnostic,DiagnosticRelatedInformation:O.DiagnosticRelatedInformation,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.Disposable,DocumentHighlight:O.DocumentHighlight,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.DocumentLink,DocumentSymbol:O.DocumentSymbol,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.EvaluatableExpression,InlineValueText:O.InlineValueText,InlineValueVariableLookup:O.InlineValueVariableLookup,InlineValueEvaluatableExpression:O.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:O.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.FileDecoration,FileSystemError:O.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:O.FoldingRange,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.FunctionBreakpoint,InlineCompletionItem:O.InlineSuggestion,InlineCompletionList:O.InlineSuggestions,Hover:O.Hover,IndentAction:D.IndentAction,Location:O.Location,MarkdownString:O.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:O.ParameterInformation,PortAutoForwardAction:O.PortAutoForwardAction,Position:O.Position,ProcessExecution:O.ProcessExecution,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.QuickInputButtons,Range:O.Range,RelativePattern:O.RelativePattern,Selection:O.Selection,SelectionRange:O.SelectionRange,SemanticTokens:O.SemanticTokens,SemanticTokensBuilder:O.SemanticTokensBuilder,SemanticTokensEdit:O.SemanticTokensEdit,SemanticTokensEdits:O.SemanticTokensEdits,SemanticTokensLegend:O.SemanticTokensLegend,ShellExecution:O.ShellExecution,ShellQuoting:O.ShellQuoting,SignatureHelp:O.SignatureHelp,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.SignatureInformation,SnippetString:O.SnippetString,SourceBreakpoint:O.SourceBreakpoint,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.SymbolInformation,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.Task,TaskGroup:O.TaskGroup,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TerminalLink:O.TerminalLink,TerminalLocation:O.TerminalLocation,TerminalProfile:O.TerminalProfile,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,TextDocumentChangeReason:O.TextDocumentChangeReason,ThemeColor:O.ThemeColor,ThemeIcon:O.ThemeIcon,TreeItem:O.TreeItem,TreeItemCollapsibleState:O.TreeItemCollapsibleState,TypeHierarchyItem:O.TypeHierarchyItem,UIKind:u.UIKind,Uri:i.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.WorkspaceEdit,InlayHint:O.InlayHint,InlayHintKind:O.InlayHintKind,RemoteAuthorityResolverError:O.RemoteAuthorityResolverError,ResolvedAuthority:O.ResolvedAuthority,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.TimelineItem,NotebookRange:O.NotebookRange,NotebookCellKind:O.NotebookCellKind,NotebookCellExecutionState:O.NotebookCellExecutionState,NotebookCellData:O.NotebookCellData,NotebookData:O.NotebookData,NotebookRendererScript:O.NotebookRendererScript,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.NotebookCellOutput,NotebookCellOutputItem:O.NotebookCellOutputItem,NotebookCellStatusBarItem:O.NotebookCellStatusBarItem,NotebookControllerAffinity:O.NotebookControllerAffinity,PortAttributes:O.PortAttributes,LinkedEditingRanges:O.LinkedEditingRanges,TestResultState:O.TestResultState,TestRunRequest:O.TestRunRequest,TestMessage:O.TestMessage,TestTag:O.TestTag,TestRunProfileKind:O.TestRunProfileKind,TextSearchCompleteMessageType:ge.TextSearchCompleteMessageType,TreeDataTransfer:O.TreeDataTransfer,TreeDataTransferItem:O.TreeDataTransferItem,CoveredCount:O.CoveredCount,FileCoverage:O.FileCoverage,StatementCoverage:O.StatementCoverage,BranchCoverage:O.BranchCoverage,FunctionCoverage:O.FunctionCoverage,WorkspaceTrustState:O.WorkspaceTrustState,LanguageStatusSeverity:O.LanguageStatusSeverity,QuickPickItemKind:O.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=le}),define(pe[274],ve([0,1,83,132,35,130,36,38,45,34,70,55,72,91,52,65,133,66,44,90,121,54,131,11,226]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I,w,a,r,g,o,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(_.ILoggerService,o.ExtHostLoggerService),(0,m.registerSingleton)(_.ILogService,n.ExtHostLogService),(0,m.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,m.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,m.registerSingleton)(i.IExtHostConfiguration,i.ExtHostConfiguration),(0,m.registerSingleton)(I.IExtHostConsumerFileSystem,I.ExtHostConsumerFileSystem),(0,m.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,m.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,m.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo),(0,m.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,m.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch),(0,m.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage),(0,m.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,m.registerSingleton)(D.IExtHostTerminalService,D.WorkerExtHostTerminalService),(0,m.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,m.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,m.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace),(0,m.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,m.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry),(0,m.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs)}),define(pe[92],ve([0,1,16,11,33,69]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function i(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=i;function k(P,u,E,h){const p=(0,m.mapArrayOrNot)(E,S),v=new y.TextSearchMatch(u,p,h),I=v.preview.matches;return{ranges:(0,m.mapArrayOrNot)(p,D),uri:P,preview:{text:v.preview.text,matches:(0,m.mapArrayOrNot)(I,D)}}}e.createTextSearchResult=k;function S(P){return new y.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function D(P){return new C.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let R=class{constructor(u,E){this.prefix=u,this.logService=E}appendLine(u){this.logService.debug(`${this.prefix}#search`,u)}};R=je([He(1,F.ILogService)],R),e.OutputChannel=R}),define(pe[275],ve([0,1,95,22]),function(Y,e,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function y(o){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(_=>_===o)}e.isUTFEncoding=y,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,i=512,k=512*8,S=512*128;class D{constructor(_){this.iconvLiteDecoder=_}static async create(_){let n;if(_!==e.UTF8)n=(await new Promise((s,d)=>{Y(["iconv-lite-umd"],s,d)})).getDecoder(E(_));else{const t=new TextDecoder;n={write(s){return t.decode(s,{stream:!0})},end(){return t.decode()}}}return new D(n)}write(_){return this.iconvLiteDecoder.write(_)}end(){return this.iconvLiteDecoder.end()}}function R(o,_){const n=_.minBytesRequiredForDetection??_.guessEncoding?k:i;return new Promise((t,s)=>{const d=(0,m.newWriteableStream)(T=>T.join("")),c=[];let f=0,l;const b=async()=>{try{const T=await g({buffer:F.VSBuffer.concat(c),bytesRead:f},_.guessEncoding);T.encoding=await _.overwriteEncoding(T.encoding),l=await D.create(T.encoding);const A=l.write(F.VSBuffer.concat(c).buffer);d.write(A),c.length=0,f=0,t({stream:d,detected:T})}catch(T){s(T)}};(0,m.listenStream)(o,{onData:async T=>{l?d.write(l.write(T.buffer)):(c.push(T),f+=T.byteLength,f>=n&&(o.pause(),await b(),setTimeout(()=>o.resume())))},onError:T=>d.error(T),onEnd:async()=>{l||await b(),d.end(l?.end())}})})}e.toDecodeStream=R;async function P(o,_,n){const s=(await new Promise((f,l)=>{Y(["iconv-lite-umd"],f,l)})).getEncoder(E(_),n);let d=!1,c=!1;return{read(){if(c)return null;const f=o.read();if(typeof f!="string"){if(c=!0,!d&&n?.addBOM)switch(_){case e.UTF8:case e.UTF8_with_bom:return F.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const l=s.end();return l&&l.length>0?(d=!0,F.VSBuffer.wrap(l)):null}return d=!0,F.VSBuffer.wrap(s.write(f))}}}e.toEncodeReadable=P;async function u(o){return(await new Promise((n,t)=>{Y(["iconv-lite-umd"],n,t)})).encodingExists(E(o))}e.encodingExists=u;function E(o){return o===e.UTF8_with_bom||o===null?e.UTF8:o}e.toNodeEncoding=E;function h(o,_){if(!o||_<e.UTF16be_BOM.length)return null;const n=o.readUInt8(0),t=o.readUInt8(1);if(n===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(_<e.UTF8_BOM.length)return null;const s=o.readUInt8(2);return n===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&s===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=h;const p=["ascii","utf-16","utf-32"];async function v(o){const _=await new Promise((c,f)=>{Y(["jschardet"],c,f)}),n=o.slice(0,S),t=a(n.buffer),s=_.detect(t);if(!s||!s.encoding)return null;const d=s.encoding.toLowerCase();return 0<=p.indexOf(d)?null:w(s.encoding)}const I={ibm866:"cp866",big5:"cp950"};function w(o){const _=o.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return I[_]||_}function a(o){let _="";for(let n=0;n<o.length;n++)_+=String.fromCharCode(o[n]);return _}function r(o){switch(o){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const _=o.match(/windows(\d+)/);return _?"windows-"+_[1]:o}}e.toCanonicalName=r;function g({buffer:o,bytesRead:_},n){let t=h(o,_),s=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&o){let d=!0,c=!0,f=!1;for(let l=0;l<_&&l<C;l++){const b=l%2==1,T=o.readUInt8(l)===0;if(T&&(f=!0),d&&(b&&!T||!b&&T)&&(d=!1),c&&(b&&T||!b&&!T)&&(c=!1),T&&!d&&!c)break}f&&(d?t=e.UTF16le:c?t=e.UTF16be:s=!0)}return n&&!s&&!t&&o?v(o.slice(0,_)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:s,encoding:t}}e.detectEncodingFromBuffer=g,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(pe[135],ve([0,1,275,28,134]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends y.TextSearchManager{constructor(k,S,D=F,R="searchProcess"){super(k,S,{readdir:P=>D.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,m.toCanonicalName)(P)},R)}}e.NativeTextSearchManager=C}),define(pe[276],ve([0,1,277,291,292,2,293]),function(Y,e,m,F,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(P,u,E,h,p,v){const I=v.environment.useHostProxy,w=typeof I=="boolean"?I:!v.remote.isRemote,a=(0,i.createProxyResolver)({resolveProxy:g=>P.resolveProxy(g),getHttpProxySetting:()=>u.getConfiguration("http").get("proxy"),log:(g,o,..._)=>{switch(g){case i.LogLevel.Trace:h.trace(o,..._);break;case i.LogLevel.Debug:h.debug(o,..._);break;case i.LogLevel.Info:h.info(o,..._);break;case i.LogLevel.Warning:h.warn(o,..._);break;case i.LogLevel.Error:h.error(o,..._);break;case i.LogLevel.Critical:h.critical(o,..._);break;case i.LogLevel.Off:break;default:n(g,o,_);break}function n(t,s,...d){h.error("Unknown log level",t),h.error(s,...d)}},getLogLevel:()=>h.getLevel(),proxyResolveTelemetry:g=>{p.$publicLog2("resolveProxy",g)},useHostProxy:w,env:process.env}),r=S(u,a);return R(E,r)}e.connectProxyResolver=k;function S(P,u){const E={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(p=>{E.config=P.getConfiguration("http").get("proxySupport")||"off"});const h={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(p=>{h.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,i.createHttpPatch)(m,u,{config:"off"},h,!0)),on:Object.assign({},m,(0,i.createHttpPatch)(m,u,{config:"on"},h,!0)),override:Object.assign({},m,(0,i.createHttpPatch)(m,u,{config:"override"},h,!0)),onRequest:Object.assign({},m,(0,i.createHttpPatch)(m,u,E,h,!0)),default:Object.assign(m,(0,i.createHttpPatch)(m,u,E,h,!1))},https:{off:Object.assign({},F,(0,i.createHttpPatch)(F,u,{config:"off"},h,!0)),on:Object.assign({},F,(0,i.createHttpPatch)(F,u,{config:"on"},h,!0)),override:Object.assign({},F,(0,i.createHttpPatch)(F,u,{config:"override"},h,!0)),onRequest:Object.assign({},F,(0,i.createHttpPatch)(F,u,E,h,!0)),default:Object.assign(F,(0,i.createHttpPatch)(F,u,E,h,!1))},tls:Object.assign(y,(0,i.createTlsPatch)(y))}}const D=new Map;function R(P,u){return P.getExtensionPathIndex().then(E=>{const h=Y.__$__nodeRequire("module"),p=h._load;h._load=function(I,w,a){if(I==="tls")return u.tls;if(I!=="http"&&I!=="https")return p.apply(this,arguments);const r=u[I],g=E.findSubstr(C.URI.file(w.filename));let o=D.get(g);if(o||D.set(g,o={}),!o[I]){let _=r.default;o[I]={..._}}return o[I]}})}}),define(pe[278],ve([0,1,37,9,79,30,12,8,92,279]),function(Y,e,m,F,y,C,i,k,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(a,r,g,o){const _=u(a,r,g,o),n=r.folder.fsPath;return{cmd:m.spawn(R,_.args,{cwd:n}),rgDiskPath:R,siblingClauses:_.siblingClauses,rgArgs:_,cwd:n}}e.spawnRipgrepCmd=P;function u(a,r,g,o){const _=["--files","--hidden","--case-sensitive"];h([r],g,!1).forEach(t=>{const s=(0,S.anchorGlob)(t);if(_.push("-g",s),i.isMacintosh){const d=(0,y.normalizeNFD)(s);d!==s&&_.push("-g",d)}});const n=E([r],o,void 0,!1);return n.globArgs.forEach(t=>{const s=`!${(0,S.anchorGlob)(t)}`;if(_.push("-g",s),i.isMacintosh){const d=(0,y.normalizeNFD)(s);d!==s&&_.push("-g",d)}}),r.disregardIgnoreFiles!==!1?_.push("--no-ignore"):_.push("--no-ignore-parent"),r.ignoreSymlinks||_.push("--follow"),a.exists&&_.push("--quiet"),_.push("--no-config"),r.disregardGlobalIgnoreFiles&&_.push("--no-ignore-global"),{args:_,siblingClauses:n.siblingClauses}}function E(a,r,g,o=!0){const _=[];let n={};return a.forEach(t=>{const s=Object.assign({},t.excludePattern||{},r||{}),d=p(s,o?t.folder.fsPath:void 0,g);_.push(...d.globArgs),d.siblingClauses&&(n=Object.assign(n,d.siblingClauses))}),{globArgs:_,siblingClauses:n}}e.foldersToRgExcludeGlobs=E;function h(a,r,g=!0){const o=[];return a.forEach(_=>{const n=Object.assign({},r||{},_.includePattern||{}),t=p(n,g?_.folder.fsPath:void 0);o.push(...t.globArgs)}),o}e.foldersToIncludeGlobs=h;function p(a,r,g){const o=[],_={};return Object.keys(a).forEach(n=>{if(g&&g.has(n)||!n)return;const t=a[n];n=I(r?v(r,n):n),n.startsWith("\\\\")?n="\\\\"+n.substr(2).replace(/\\/g,"/"):n=n.replace(/\\/g,"/"),typeof t=="boolean"&&t?(n.startsWith("\\\\")&&(n+="**"),o.push(w(n))):t&&t.when&&(_[n]=t)}),{globArgs:o,siblingClauses:_}}function v(a,r){return F.isAbsolute(r)?r:F.join(a,r)}e.getAbsoluteGlob=v;function I(a){return a=k.rtrim(a,"\\"),k.rtrim(a,"/")}function w(a){return C.getRoot(a).toLowerCase()==="c:/"?a.replace(/^c:[/\\]/i,"/"):a}e.fixDriveC=w}),define(pe[280],ve([0,1,37,60,9,103,16,50,31,79,30,12,46,8,13,28,33,278,100]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const a=new Set;process.on("exit",()=>{a.forEach(n=>n())});class r{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&S.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,w.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&S.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(s=>{const d=Object.assign({},s.excludePattern||{},this.config.excludePattern||{}),c=s.folder.fsPath;t.folderQueries.map(f=>f.folder.fsPath).filter(f=>f!==c).forEach(f=>{(0,R.isEqualOrParent)(f,c)&&(d[y.relative(c,f)]=!0)}),this.folderExcludePatterns.set(c,new o(d,c))})}cancel(){this.isCanceled=!0,a.forEach(t=>t())}walk(t,s,d,c,f){if(this.fileWalkSW=u.StopWatch.create(!1),this.isCanceled)return f(null,this.isLimitHit);s.forEach(l=>{const b=y.basename(l.fsPath);this.globalExcludePattern&&this.globalExcludePattern(l.fsPath,b)||this.matchFile(d,{relativePath:l.fsPath,searchPath:void 0})}),this.cmdSW=u.StopWatch.create(!1),this.parallel(t,(l,b)=>{this.call(this.cmdTraversal,this,l,d,c,T=>{if(T){const A=(0,k.toErrorMessage)(T);console.error(A),this.errors.push(A),b(T,void 0)}else b(null,void 0)})},(l,b)=>{this.fileWalkSW.stop();const T=l?i.coalesce(l)[0]:null;f(T,this.isLimitHit)})}parallel(t,s,d){const c=new Array(t.length),f=new Array(t.length);let l=!1,b=0;if(t.length===0)return d(null,[]);t.forEach((T,A)=>{s(T,(U,B)=>{if(U?(l=!0,c[A]=null,f[A]=U):(c[A]=B,f[A]=null),++b===t.length)return d(l?f:null,c)})})}call(t,s,...d){try{t.apply(s,d)}catch(c){d[d.length-1](c)}}cmdTraversal(t,s,d,c){const f=t.folder.fsPath,l=P.isMacintosh;let b;const T=()=>b&&b.kill();a.add(T);let A=O=>{a.delete(T),A=()=>{},c(O)},U="";const B=this.initDirectoryTree();let L;const x=(0,I.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);b=x.cmd,L=!Object.keys(x.siblingClauses).length;const M=x.rgArgs.args.map(O=>O.match(/^-/)?O:`'${O}'`).join(" ");let V=`${x.rgDiskPath} ${M}
 - cwd: ${x.cwd}`;x.rgArgs.siblingClauses&&(V+=`
 - Sibling clauses: ${JSON.stringify(x.rgArgs.siblingClauses)}`),d({message:V}),this.cmdResultCount=0,this.collectStdout(b,"utf8",d,(O,W,q)=>{if(O){A(O);return}if(this.isLimitHit){A();return}const G=(U+(l?D.normalizeNFC(W||""):W)).split(`
`);if(q){const $=G.length;G[$-1]=G[$-1].trim(),G[$-1]||G.pop()}else U=G.pop()||"";if(G.length&&G[0].indexOf(`
`)!==-1){A(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=G.length,L){for(const $ of G)if(this.matchFile(s,{base:f,relativePath:$,searchPath:this.getSearchPath(t,$)}),this.isLimitHit){T();break}(q||this.isLimitHit)&&A();return}this.addDirectoryEntries(t,B,f,G,s),q&&(this.matchDirectoryTree(B,f,s),A())})}spawnFindCmd(t){const s=this.folderExcludePatterns.get(t.folder.fsPath),d=s.getBasenameTerms(),c=s.getPathTerms(),f=["-L","."];if(d.length||c.length){f.push("-not","(","(");for(const l of d)f.push("-name",l),f.push("-o");for(const l of c)f.push("-path",l),f.push("-o");f.pop(),f.push(")","-prune",")")}return f.push("-type","f"),m.spawn("find",f,{cwd:t.folder.fsPath})}readStdout(t,s,d){let c="";this.collectStdout(t,s,()=>{},(f,l,b)=>{if(f){d(f);return}c+=l,b&&d(null,c)})}collectStdout(t,s,d,c){let f=(T,A,U)=>{(T||U)&&(f=()=>{},this.cmdSW&&this.cmdSW.stop()),c(T,A,U)},l=!1;t.stdout?(this.forwardData(t.stdout,s,f),t.stdout.once("data",()=>l=!0)):d({message:"stdout is null"});let b;t.stderr?b=this.collectData(t.stderr):d({message:"stderr is null"}),t.on("error",T=>{f(T)}),t.on("close",T=>{let A;!l&&(A=this.decodeData(b,s))&&_(A)?f(new Error(`command failed with error code ${T}: ${this.decodeData(b,s)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),f(null,"",!0))})}forwardData(t,s,d){const c=new C.StringDecoder(s);return t.on("data",f=>{d(null,c.write(f))}),c}collectData(t){const s=[];return t.on("data",d=>{s.push(d)}),s}decodeData(t,s){const d=new C.StringDecoder(s);return t.map(c=>d.write(c)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:s},d,c,f){c.indexOf(this.filePattern)!==-1&&this.matchFile(f,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const l=b=>{const T=y.basename(b),A=y.dirname(b);let U=s[A];U||(U=s[A]=[],l(A)),U.push({base:d,relativePath:b,basename:T,searchPath:this.getSearchPath(t,b)})};c.forEach(l)}matchDirectoryTree({rootEntries:t,pathToEntries:s},d,c){const f=this,l=this.folderExcludePatterns.get(d),b=this.filePattern;function T(A){f.directoriesWalked++;const U=S.hasSiblingFn(()=>A.map(B=>B.basename));for(let B=0,L=A.length;B<L;B++){const x=A[B],{relativePath:M,basename:V}=x;if(l.test(M,V,b!==V?U:void 0))continue;const O=s[M];if(O)T(O);else{if(f.filesWalked++,M===b)continue;f.matchFile(c,x)}if(f.isLimitHit)break}}T(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,s,d,c,f){const l=t.folder,b=S.hasSiblingFn(()=>d);this.parallel(d,(T,A)=>{if(this.isCanceled||this.isLimitHit)return A(null);const U=s?[s,T].join(y.sep):T;if(this.folderExcludePatterns.get(t.folder.fsPath).test(U,T,this.config.filePattern!==T?b:void 0))return A(null);const B=[l.fsPath,U].join(y.sep);F.lstat(B,(L,x)=>{if(L||this.isCanceled||this.isLimitHit)return A(null);this.statLinkIfNeeded(B,x,(M,V)=>M||this.isCanceled||this.isLimitHit?A(null):V.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(B,x,(O,W)=>O||this.isCanceled||this.isLimitHit||(W=W||"",this.walkedPaths[W])?A(null):(this.walkedPaths[W]=!0,p.Promises.readdir(B).then(q=>{if(this.isCanceled||this.isLimitHit)return A(null);this.doWalk(t,U,q,c,N=>A(N||null))},q=>{A(null)})))):(this.filesWalked++,U===this.filePattern||this.maxFilesize&&h.isNumber(V.size)&&V.size>this.maxFilesize||this.matchFile(c,{base:l.fsPath,relativePath:U,searchPath:this.getSearchPath(t,U)}),A(null,void 0)))})},T=>{const A=T&&i.coalesce(T);return f(A&&A.length>0?A[0]:void 0)})}matchFile(t,s){this.isFileMatch(s)&&(!this.includePattern||this.includePattern(s.relativePath,y.basename(s.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(s))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,v.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,s,d){return s.isSymbolicLink()?F.stat(t,d):d(null,s)}realPathIfNeeded(t,s,d){return s.isSymbolicLink()?F.realpath(t,(c,f)=>c?d(c):d(null,f)):d(null,t)}getSearchPath(t,s){return t.folderName?y.join(t.folderName,s):s}}e.FileWalker=r;class g{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new r(t)}search(t,s,d){this.walker.walk(this.folderQueries,this.extraFiles,t,s,(c,f)=>{d(c,{limitHit:f,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class o{constructor(t,s){this.expression=t,this.root=s,this.init(t)}init(t){let s,d;Object.keys(t).filter(c=>t[c]).forEach(c=>{y.isAbsolute(c)?(s=s||S.getEmptyExpression(),s[c]=t[c]):(d=d||S.getEmptyExpression(),d[c]=t[c])}),this.absoluteParsedExpr=s&&S.parse(s,{trimForExclusions:!0}),this.relativeParsedExpr=d&&S.parse(d,{trimForExclusions:!0})}test(t,s,d){return this.relativeParsedExpr&&this.relativeParsedExpr(t,s,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(y.join(this.root,t),s,d)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...S.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...S.getPathTerms(this.relativeParsedExpr)),t}}function _(n){const t=n.trim().split(`
`),s=t[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return E.uppercaseFirstLetter(t[t.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}e.rgErrorMsgForDisplay=_}),define(pe[136],ve([0,1,37,294,103,16,73,31,9,8,2,33,69,295,279,92]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const v=h.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class I{constructor(l){this.outputChannel=l}provideTextSearchResults(l,b,T,A){return this.outputChannel.appendLine(`provideTextSearchResults ${l.pattern}, ${JSON.stringify({...b,folder:b.folder.toString()})}`),new Promise((U,B)=>{A.onCancellationRequested(()=>N());const L=_(l,b),x=b.folder.fsPath,M=L.map(ie=>ie.match(/^-/)?ie:`'${ie}'`).join(" ");this.outputChannel.appendLine(`${v} ${M}
 - cwd: ${x}`);let V=m.spawn(v,L,{cwd:x});V.on("error",ie=>{console.error(ie),this.outputChannel.appendLine("Error: "+(ie&&ie.message)),B((0,P.serializeSearchError)(new P.SearchError(ie&&ie.message,P.SearchErrorCode.rgProcessError)))});let O=!1;const W=new r(b.maxResults,x,b.previewOptions);W.on("result",ie=>{O=!0,$="",T.report(ie)});let q=!1;const N=()=>{q=!0,V&&V.kill(),W&&W.cancel()};let G=!1;W.on("hitLimit",()=>{G=!0,N()});let $="";V.stdout.on("data",ie=>{W.handleData(ie),O||($+=ie)});let H=!1;V.stdout.once("data",()=>H=!0);let j="";V.stderr.on("data",ie=>{const fe=ie.toString();this.outputChannel.appendLine(fe),j+=fe}),V.on("close",()=>{if(this.outputChannel.appendLine(H?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(O?"Got result from parser":"No result from parser"),$&&this.outputChannel.appendLine(`Got data without result: ${$}`),this.outputChannel.appendLine(""),q)U({limitHit:G});else{W.flush(),V=null;let ie;j&&!H&&(ie=w(j))?B((0,P.serializeSearchError)(new P.SearchError(ie.message,ie.code))):U({limitHit:G})}})})}}e.RipgrepTextSearchEngine=I;function w(f){const l=f.split(`
`),b=l[0].trim();if(l.some(A=>A.startsWith("regex parse error")))return new P.SearchError(a(l),P.SearchErrorCode.regexParseError);const T=b.match(/grep config error: unknown encoding: (.*)/);if(T)return new P.SearchError(`Unknown encoding: ${T[1]}`,P.SearchErrorCode.unknownEncoding);if(b.startsWith("error parsing glob"))return new P.SearchError(b.charAt(0).toUpperCase()+b.substr(1),P.SearchErrorCode.globParseError);if(b.startsWith("the literal"))return new P.SearchError(b.charAt(0).toUpperCase()+b.substr(1),P.SearchErrorCode.invalidLiteral);if(b.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(b,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=w;function a(f){const l=["Regex parse error"],b=f.filter(T=>T.startsWith("PCRE2:"));if(b.length>=1){const T=b[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const A=T.split(":")[1];l.push(":"+A)}}return l.join("")}e.buildRegexParseError=a;class r extends F.EventEmitter{constructor(l,b,T){super();this.maxResults=l,this.rootFolder=b,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new y.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(l,b){return super.on(l,b),this}handleData(l){if(this.isDone)return;const b=typeof l=="string"?l:this.stringDecoder.write(l);this.handleDecodedData(b)}handleDecodedData(l){let b=l.indexOf(`
`);const T=this.remainder+l;if(b>=0)b+=this.remainder.length;else{this.remainder=T;return}let A=0;for(;b>=0;)this.handleLine(T.substring(A,b).trim()),A=b+1,b=T.indexOf(`
`,A);this.remainder=T.substring(A)}handleLine(l){if(this.isDone||!l)return;let b;try{b=JSON.parse(l)}catch(T){throw new Error(`malformed line from rg: ${l}`)}if(b.type==="match"){const T=g(b.data.path),A=R.URI.file(S.join(this.rootFolder,T)),U=this.createTextSearchMatch(b.data,A);this.onResult(U),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(b.type==="context"){const T=g(b.data.path),A=R.URI.file(S.join(this.rootFolder,T));this.createTextSearchContext(b.data,A).forEach(B=>this.onResult(B))}}createTextSearchMatch(l,b){const T=l.line_number-1,A=g(l.lines),U=Buffer.from(A);let B=0,L=0,x=T;l.submatches.length===0&&l.submatches.push(A.length?{start:0,end:1,match:{text:A[0]}}:{start:0,end:0,match:{text:""}});const M=(0,C.coalesce)(l.submatches.map((V,O)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const W=g(V.match),q=U.slice(B,V.start).toString().length,N=L+q,G=o(W),$=x,H=G.numLines+$,j=G.numLines>0?G.lastLineLength:G.lastLineLength+N;return B=V.end,L=j,x=H,new u.Range($,N,H,j)}));return(0,p.createTextSearchResult)(b,A,M,this.previewOptions)}createTextSearchContext(l,b){const T=g(l.lines),A=l.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((U,B)=>({text:U,uri:b,lineNumber:A+B}))}onResult(l){this.emit("result",l)}}e.RipgrepParser=r;function g(f){return f.bytes?Buffer.from(f.bytes,"base64").toString():f.text}function o(f){const l=/\n/g;let b=0,T=-1,A;for(;A=l.exec(f);)b++,T=A.index;const U=T>=0?f.length-T-1:f.length;return{numLines:b,lastLineLength:U}}function _(f,l){const b=["--hidden"];b.push(f.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:A}=(0,i.groupBy)(l.includes,B=>B.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(A&&A.length){const B=new Set;A.forEach(L=>{B.add(L)}),b.push("-g","!*"),B.forEach(L=>{n(L).map(p.anchorGlob).forEach(x=>{b.push("-g",x)})})}T&&T.length&&T.forEach(B=>{b.push("-g",B)}),l.excludes.map(p.anchorGlob).forEach(B=>b.push("-g",`!${B}`)),l.maxFileSize&&b.push("--max-filesize",l.maxFileSize+""),l.useIgnoreFiles?b.push("--no-ignore-parent"):b.push("--no-ignore"),l.followSymlinks&&b.push("--follow"),l.encoding&&l.encoding!=="utf8"&&b.push("--encoding",l.encoding),f.pattern==="--"&&(f.isRegExp=!0,f.pattern="\\-\\-"),f.isMultiline&&!f.isRegExp&&(f.pattern=(0,D.escapeRegExpCharacters)(f.pattern),f.isRegExp=!0),l.usePCRE2&&b.push("--pcre2"),b.push("--crlf"),f.isRegExp&&(f.pattern=t(f.pattern),b.push("--auto-hybrid-regex"));let U;if(f.isWordMatch){const L=(0,D.createRegExp)(f.pattern,!!f.isRegExp,{wholeWord:f.isWordMatch}).source.replace(/\\\//g,"/");b.push("--regexp",L)}else if(f.isRegExp){let B=d(f.pattern);B=c(B),b.push("--regexp",B)}else U=f.pattern,b.push("--fixed-strings");return b.push("--no-config"),l.useGlobalIgnoreFiles||b.push("--no-ignore-global"),b.push("--json"),f.isMultiline&&b.push("--multiline"),l.beforeContext&&b.push("--before-context",l.beforeContext+""),l.afterContext&&b.push("--after-context",l.afterContext+""),b.push("--"),U&&b.push(U),b.push("."),b}function n(f){const l=(0,k.splitGlobAware)(f,"/");return l.map((b,T)=>l.slice(0,T+1).join("/"))}e.spreadGlobComponents=n;function t(f){const l=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;f.match(l);)f=f.replace(l,"$1\\x{$2}");const b=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;f.match(b);)f=f.replace(b,"$1\\x{$2}");return f}e.unicodeEscapesToPCRE2=t;const s=f=>f.type==="Assertion"&&f.kind==="lookbehind";function d(f){let l;try{l=new E.RegExpParser().parsePattern(f)}catch{return f}let b="",T=0;const A=(L,x,M)=>{b+=f.slice(T,L)+M,T=x},U=[];return new E.RegExpVisitor({onCharacterEnter(L){if(L.raw!=="\\n")return;const x=U[0];if(!x)A(L.start,L.end,"\\r?\\n");else if(!U.some(s))if(x.type==="CharacterClass")if(x.negate){const M=f.slice(x.start+2,L.start)+f.slice(L.end,x.end-1);if(x.parent?.type==="Quantifier"){const V=x.parent;A(V.start,V.end,(M?`[^${M}]`:".")+(V.greedy?"+":"*"))}else A(x.start,x.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=f.slice(x.start+1,L.start)+f.slice(L.end,x.end-1);A(x.start,x.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else x.type==="Quantifier"&&A(L.start,L.end,"(?:\\r?\\n)")},onQuantifierEnter(L){U.unshift(L)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(L){U.unshift(L)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(L){U.unshift(L)},onCharacterClassLeave(){U.shift()},onAssertionEnter(L){s(L)&&U.push(L)},onAssertionLeave(L){U[0]===L&&U.shift()}}).visit(l),b+=f.slice(T),b}e.fixRegexNewline=d;function c(f){return f.replace(/\n/g,"\\r?\\n")}e.fixNewline=c}),define(pe[281],ve([0,1,21,136,117,10]),function(Y,e,m,F,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class i{constructor(D){this.outputChannel=D,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(D,R,P,u){const E=new F.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===C.Schemas.userData){const h={...R,folder:R.folder.with({scheme:C.Schemas.file})},p=new y.Progress(v=>P.report({...v,uri:v.uri.with({scheme:R.folder.scheme})}));return this.withToken(u,v=>E.provideTextSearchResults(D,h,p,v))}else return this.withToken(u,h=>E.provideTextSearchResults(D,R,P,h))}async withToken(D,R){const P=k(D);this.inProgress.add(P);const u=await R(P.token);return this.inProgress.delete(P),u}dispose(){this.inProgress.forEach(D=>D.cancel())}}e.RipgrepSearchProvider=i;function k(S){const D=new m.CancellationTokenSource;return S.onCancellationRequested(()=>D.cancel()),D}}),define(pe[282],ve([0,1,28,136,135]),function(Y,e,m,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(S){this.query=S}search(S,D,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(E){R({message:E})}},u=new y.NativeTextSearchManager(this.query,new F.RipgrepTextSearchEngine(P),m);return new Promise((E,h)=>u.search(p=>{D(p.map(i))},S).then(p=>E({limitHit:p.limitHit,type:"success",stats:p.stats}),h))}}e.TextSearchEngineAdapter=C;function i(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((S,D)=>{if(D.ranges){const R=D;return S+(Array.isArray(R.ranges)?R.ranges.length:1)}else return S+1},0)}}}),define(pe[283],ve([0,1,16,18,15,3,100,9,46,2,42,33,280,282]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class h{constructor(r="searchProcess"){this.processType=r,this.caches=Object.create(null)}fileSearch(r){let g;const o=I(r),_=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,F.createCancelablePromise)(n=>this.doFileSearchWithEngine(u.Engine,o,t=>_.fire(t),n)),g.then(n=>_.fire(n),n=>_.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return _.event}textSearch(r){let g;const o=I(r),_=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,F.createCancelablePromise)(n=>this.ripgrepTextSearch(o,t=>_.fire(t),n)),g.then(n=>_.fire(n),n=>_.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return _.event}ripgrepTextSearch(r,g,o){return r.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new E.TextSearchEngineAdapter(r).search(o,g,g)}doFileSearch(r,g,o){return this.doFileSearchWithEngine(u.Engine,r,g,o)}doFileSearchWithEngine(r,g,o,_,n=h.BATCH_SIZE){let t=0;const s=c=>{Array.isArray(c)?(t+=c.length,o(c.map(f=>this.rawMatchToSearchItem(f)))):c.relativePath?(t++,o(this.rawMatchToSearchItem(c))):o(c)};if(g.sortByScore){let c=this.trySortedSearchFromCache(g,s,_);if(!c){const f=g.maxResults?Object.assign({},g,{maxResults:null}):g,l=new r(f);c=this.doSortedSearch(l,g,o,s,_)}return new Promise((f,l)=>{c.then(([b,T])=>{const A=T.map(U=>this.rawMatchToSearchItem(U));this.sendProgress(A,o,n),f(b)},l)})}const d=new r(g);return this.doSearch(d,s,n,_).then(c=>({limitHit:c.limitHit,type:"success",stats:{detailStats:c.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(r){return{path:r.base?(0,k.join)(r.base,r.relativePath):r.relativePath}}doSortedSearch(r,g,o,_,n){const t=new C.Emitter;let s=(0,F.createCancelablePromise)(c=>{let f=[];const l=b=>{Array.isArray(b)?f=b:(_(b),t.fire(b))};return this.doSearch(r,l,-1,c).then(b=>[b,f])}),d;if(g.cacheKey){d=this.getOrCreateCache(g.cacheKey);const c={promise:s,event:t.event,resolved:!1};d.resultsToSearchCache[g.filePattern||""]=c,s.then(()=>{c.resolved=!0},f=>{delete d.resultsToSearchCache[g.filePattern||""]}),s=this.preventCancellation(s)}return s.then(([c,f])=>{const l=d?d.scorerCache:Object.create(null),b=(typeof g.maxResults!="number"||g.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(g,f,l,n).then(T=>{const A=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:c.stats,sortingTime:A,fromCache:!1,type:this.processType,workspaceFolderCount:g.folderQueries.length,resultCount:T.length},messages:c.messages,limitHit:c.limitHit||typeof g.maxResults=="number"&&f.length>g.maxResults},T]})})}getOrCreateCache(r){const g=this.caches[r];return g||(this.caches[r]=new p)}trySortedSearchFromCache(r,g,o){const _=r.cacheKey&&this.caches[r.cacheKey];if(!_)return;const n=this.getResultsFromCache(_,r.filePattern||"",g,o);if(n)return n.then(([t,s,d])=>{const c=S.StopWatch.create(!1);return this.sortResults(r,s,_.scorerCache,o).then(f=>{const l=c.elapsed(),b={fromCache:!0,detailStats:d,type:this.processType,resultCount:s.length,sortingTime:l};return[{type:"success",limitHit:t.limitHit||typeof r.maxResults=="number"&&s.length>r.maxResults,stats:b},f]})})}sortResults(r,g,o,_){const n=(0,i.prepareQuery)(r.filePattern||""),t=(d,c)=>(0,i.compareItemsByFuzzyScore)(d,c,n,!0,v,o),s=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return m.topAsync(g,t,s,1e4,_)}sendProgress(r,g,o){if(o&&o>0)for(let _=0;_<r.length;_+=o)g(r.slice(_,_+o));else g(r)}getResultsFromCache(r,g,o,_){const n=S.StopWatch.create(!1),t=g.indexOf(k.sep)>=0;let s;for(const l in r.resultsToSearchCache)if(g.startsWith(l)){if(t&&l.indexOf(k.sep)<0&&l!=="")continue;const b=r.resultsToSearchCache[l];s={promise:this.preventCancellation(b.promise),event:b.event,resolved:b.resolved};break}if(!s)return null;const d=n.elapsed(),c=S.StopWatch.create(!1),f=s.event(o);return _&&_.onCancellationRequested(()=>{f.dispose()}),s.promise.then(([l,b])=>{if(_&&_.isCancellationRequested)throw(0,y.canceled)();const T=[],A=(0,i.prepareQuery)(g).normalizedLowercase;for(const U of b)!(0,P.isFilePatternMatch)(U,A)||T.push(U);return[l,T,{cacheWasResolved:s.resolved,cacheLookupTime:d,cacheFilterTime:c.elapsed(),cacheEntryCount:b.length}]})}doSearch(r,g,o,_){return new Promise((n,t)=>{let s=[];_&&_.onCancellationRequested(()=>r.cancel()),r.search(d=>{d&&(o?(s.push(d),o>0&&s.length>=o&&(g(s),s=[])):g(d))},d=>{g(d)},(d,c)=>{s.length&&g(s),d?t(d):n(c)})})}clearCache(r){return delete this.caches[r],Promise.resolve(void 0)}preventCancellation(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,o){return r.then(g,o)}catch(g){return this.then(void 0,g)}finally(g){return r.finally(g)}}}}e.SearchService=h,h.BATCH_SIZE=512;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const v=new class{getItemLabel(a){return(0,k.basename)(a.relativePath)}getItemDescription(a){return(0,k.dirname)(a.relativePath)}getItemPath(a){return a.relativePath}};function I(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(w),extraFileResources:a.extraFileResources&&a.extraFileResources.map(r=>D.URI.revive(r))}}function w(a){return{...a,folder:D.URI.revive(a.folder)}}}),define(pe[284],ve([0,1,6,10,2,28,11,26,14,72,64,33,283,281,92,135]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let v=class extends D.ExtHostSearch{constructor(w,a,r,g){super(w,r,g);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const o=new h.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(F.Schemas.userData,new E.RipgrepSearchProvider(o)),a.remote.isRemote&&a.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const w=new h.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(F.Schemas.file,new E.RipgrepSearchProvider(w)),this.registerInternalFileSearchProvider(F.Schemas.file,new u.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(w,a){const r=this._handlePool++;return this._internalFileSearchProvider=a,this._internalFileSearchHandle=r,this._proxy.$registerFileSearchProvider(r,this._transformScheme(w)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(w,a,r,g){const o=(0,D.reviveQuery)(r);return w===this._internalFileSearchHandle?this.doInternalFileSearch(w,a,o,g):super.$provideFileSearchResults(w,a,r,g)}doInternalFileSearch(w,a,r,g){const o=_=>{if((0,P.isSerializedFileMatch)(_)&&(_=[_]),Array.isArray(_)){this._proxy.$handleFileMatch(w,a,_.map(n=>y.URI.file(n.path)));return}_.message&&this._logService.debug("ExtHostSearch",_.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(r,o,g)}$clearCache(w){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(w),super.$clearCache(w)}createTextSearchManager(w,a){return new p.NativeTextSearchManager(w,a,void 0,"textSearchProvider")}};v=je([He(0,S.IExtHostRpcService),He(1,k.IExtHostInitDataService),He(2,R.IURITransformerService),He(3,i.ILogService)],v),e.NativeExtHostSearch=v}),define(pe[137],ve([0,1,296,124,81,22,15,3,6,9,12,32,105,106,297]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(b,T=""){this.debugLabel=T,this.socket=b,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,i.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}traceSocketEvent(b,T){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,T)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(b){const T=A=>{this.traceSocketEvent("read",A),b(C.VSBuffer.wrap(A))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(b){const T=A=>{this.traceSocketEvent("close",{hadError:A}),b({type:0,hadError:A,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(b){const T=()=>{this.traceSocketEvent("nodeEndReceived"),b()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(b){if(!this.socket.destroyed)try{this.traceSocketEvent("write",b),this.socket.write(b.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,i.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,i.onUnexpectedError)(T)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((b,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),b();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),b()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=p;var v;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var I;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(I||(I={}));class w extends S.Disposable{constructor(b,T,A,U){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=b,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:A?.byteLength||0,recordInflateBytes:U}),this._flowManager=this._register(new a(this,T,A,U,this._onData,(B,L)=>this._write(B,L))),this._register(this._flowManager.onError(B=>{console.error(B),(0,i.onUnexpectedError)(B),this._onClose.fire({type:0,hadError:!0,error:B})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(B=>this._acceptChunk(B))),this._register(this.socket.onClose(B=>this._onClose.fire(B)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(b,T){this.socket.traceSocketEvent(b,T)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this._onData.event(b)}onClose(b){return this._onClose.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){this._flowManager.writeMessage(b)}_write(b,T){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",b);let A=2;b.byteLength<126?A+=0:b.byteLength<2**16?A+=2:A+=8;const U=C.VSBuffer.alloc(A);if(T?U.writeUInt8(194,0):U.writeUInt8(130,0),b.byteLength<126)U.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){U.writeUInt8(126,1);let B=1;U.writeUInt8(b.byteLength>>>8&255,++B),U.writeUInt8(b.byteLength>>>0&255,++B)}else{U.writeUInt8(127,1);let B=1;U.writeUInt8(0,++B),U.writeUInt8(0,++B),U.writeUInt8(0,++B),U.writeUInt8(0,++B),U.writeUInt8(b.byteLength>>>24&255,++B),U.writeUInt8(b.byteLength>>>16&255,++B),U.writeUInt8(b.byteLength>>>8&255,++B),U.writeUInt8(b.byteLength>>>0&255,++B)}this.socket.write(C.VSBuffer.concat([U,b]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(b){if(b.byteLength!==0){for(this._incomingData.acceptChunk(b);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const T=this._incomingData.peek(this._state.readLen),A=T.readUInt8(0),U=(A&128)>>>7,B=(A&64)>>>6,L=T.readUInt8(1),x=(L&128)>>>7,M=L&127;this._state.state=2,this._state.readLen=2+(x?4:0)+(M===126?2:0)+(M===127?8:0),this._state.fin=U,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(B)),this._state.firstFrameOfMessage=Boolean(U),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const T=this._incomingData.read(this._state.readLen),A=T.readUInt8(1),U=(A&128)>>>7;let B=A&127,L=1;B===126?B=T.readUInt8(++L)*2**8+T.readUInt8(++L):B===127&&(B=T.readUInt8(++L)*0+T.readUInt8(++L)*0+T.readUInt8(++L)*0+T.readUInt8(++L)*0+T.readUInt8(++L)*2**24+T.readUInt8(++L)*2**16+T.readUInt8(++L)*2**8+T.readUInt8(++L));let x=0;U&&(x=T.readUInt8(++L)*2**24+T.readUInt8(++L)*2**16+T.readUInt8(++L)*2**8+T.readUInt8(++L)),this._state.state=3,this._state.readLen=B,this._state.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const T=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",T),o(T,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",T),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(T,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class a extends S.Disposable{constructor(b,T,A,U,B,L){super();this._tracer=b,this._onData=B,this._writeFn=L,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,T?(this._zlibInflateStream=this._register(new r(this._tracer,U,A,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(x=>this._onError.fire(x))),this._register(this._zlibDeflateStream.onError(x=>this._onError.fire(x)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(b){this._writeQueue.push(b),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const b=this._writeQueue.shift();if(this._zlibDeflateStream){const T=await this._deflateMessage(this._zlibDeflateStream,b);this._writeFn(T,!0)}else this._writeFn(b,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(b,T){return new Promise((A,U)=>{b.write(T),b.flush(B=>A(B))})}acceptFrame(b,T,A){this._readQueue.push({data:b,isCompressed:T,isLastFrameOfMessage:A}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const b=this._readQueue.shift();if(this._zlibInflateStream&&b.isCompressed){const T=await this._inflateFrame(this._zlibInflateStream,b.data,b.isLastFrameOfMessage);this._onData.fire(T)}else this._onData.fire(b.data)}this._isProcessingReadQueue=!1}}_inflateFrame(b,T,A){return new Promise((U,B)=>{b.write(T),A&&b.write(C.VSBuffer.fromByteArray([0,0,255,255])),b.flush(L=>U(L))})}}class r extends S.Disposable{constructor(b,T,A,U){super();this._tracer=b,this._recordInflateBytes=T,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=h.createInflateRaw(U),this._zlibInflate.on("error",B=>{this._tracer.traceSocketEvent("zlibInflateError",{message:B?.message,code:B?.code}),this._onError.fire(B)}),this._zlibInflate.on("data",B=>{this._tracer.traceSocketEvent("zlibInflateData",B),this._pendingInflateData.push(C.VSBuffer.wrap(B))}),A&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(b){this._recordInflateBytes&&this._recordedInflateBytes.push(b.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",b),this._zlibInflate.write(b.buffer)}flush(b){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const T=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,b(T)})}}class g extends S.Disposable{constructor(b,T){super();this._tracer=b,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this._onError.fire(A)}),this._zlibDeflate.on("data",A=>{this._tracer.traceSocketEvent("zlibDeflateData",A),this._pendingDeflateData.push(C.VSBuffer.wrap(A))})}write(b){this._tracer.traceSocketEvent("zlibDeflateWrite",b.buffer),this._zlibDeflate.write(b.buffer)}flush(b){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let T=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.byteLength-4),b(T)})}}function o(l,b){if(b===0)return;let T=l.byteLength>>>2;for(let M=0;M<T;M++){const V=l.readUInt32BE(M*4);l.writeUInt32BE(V^b,M*4)}let A=T*4,U=l.byteLength-A;const B=b>>>24&255,L=b>>>16&255,x=b>>>8&255;U>=1&&l.writeUInt8(l.readUInt8(A)^B,A),U>=2&&l.writeUInt8(l.readUInt8(A+1)^L,A+1),U>=3&&l.writeUInt8(l.readUInt8(A+2)^x,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const _={[2]:107,[1]:103};function n(){const l=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let b;return e.XDG_RUNTIME_DIR?b=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):b=(0,D.join)((0,y.tmpdir)(),`vscode-ipc-${l}.sock`),s(b),b}e.createRandomIPCHandle=n;function t(l,b,T){const A=(0,m.createHash)("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${T}-${b}-sock`;let U;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${T}-${b}.sock`):U=(0,D.join)(l,`${T}-${b}.sock`),s(U),U}e.createStaticIPCHandle=t;function s(l){const b=_[R.platform];typeof b=="number"&&l.length>=b&&console.warn(`WARNING: IPC handle "${l}" is longer than ${b} chars, try a shorter --user-data-dir`)}class d extends u.IPCServer{constructor(b){super(d.toClientConnectionEvent(b));this.server=b}static toClientConnectionEvent(b){const T=k.Event.fromNodeEventEmitter(b,"connection");return k.Event.map(T,A=>({protocol:new E.Protocol(new p(A,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=d;function c(l){return new Promise((b,T)=>{const A=(0,F.createServer)();A.on("error",T),A.listen(l,()=>{A.removeListener("error",T),b(new d(A))})})}e.serve=c;function f(l,b){return new Promise((T,A)=>{const U=(0,F.createConnection)(l,()=>{U.removeListener("error",A),T(E.Client.fromSocket(new p(U,`ipc-client${b}`),b))});U.once("error",A)})}e.connect=f}),define(pe[285],ve([0,1,137,277,60,38,2,197,11]),function(Y,e,m,F,y,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(u,E,h){this._commands=u,this.logService=E,this._ipcHandlePath=h,this._server=F.createServer((p,v)=>this.onRequest(p,v)),this.setup().catch(p=>(E.error(p),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",u=>this.logService.error(u))}catch(u){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(u,E){const h=[];u.setEncoding("utf8"),u.on("data",p=>h.push(p)),u.on("end",()=>{const p=JSON.parse(h.join(""));switch(p.type){case"open":this.open(p,E);break;case"openExternal":this.openExternal(p,E);break;case"status":this.getStatus(p,E);break;case"extensionManagement":this.manageExtensions(p,E).catch(this.logService.error);break;default:E.writeHead(404),E.write(`Unknown message type: ${p.type}`,v=>{v&&this.logService.error(v)}),E.end();break}})}open(u,E){const{fileURIs:h,folderURIs:p,forceNewWindow:v,diffMode:I,addMode:w,forceReuseWindow:a,gotoLineMode:r,waitMarkerFilePath:g,remoteAuthority:o}=u,_=[];if(Array.isArray(p))for(const d of p)try{_.push({folderUri:i.URI.parse(d)})}catch(c){}if(Array.isArray(h))for(const d of h)try{(0,k.hasWorkspaceFileExtension)(d)?_.push({workspaceUri:i.URI.parse(d)}):_.push({fileUri:i.URI.parse(d)})}catch(c){}const n=g?i.URI.file(g):void 0,s={forceNewWindow:v,diffMode:I,addMode:w,gotoLineMode:r,forceReuseWindow:a,preferNewWindow:!a&&!n&&!w,waitMarkerFileURI:n,remoteAuthority:o};this._commands.executeCommand("_remoteCLI.windowOpen",_,s),E.writeHead(200),E.end()}async openExternal(u,E){for(const h of u.uris){const p=i.URI.parse(h),v=p.scheme==="file"?p:h;await this._commands.executeCommand("_remoteCLI.openExternal",v)}E.writeHead(200),E.end()}async manageExtensions(u,E){try{const h=I=>I?.map(w=>/\.vsix$/i.test(w)?i.URI.parse(w):w),p={list:u.list,install:h(u.install),uninstall:h(u.uninstall),force:u.force},v=await this._commands.executeCommand("_remoteCLI.manageExtensions",p);E.writeHead(200),E.write(v)}catch(h){E.writeHead(500),E.write(String(h),p=>{p&&this.logService.error(p)})}E.end()}async getStatus(u,E){try{const h=await this._commands.executeCommand("_remoteCLI.getSystemStatus");E.writeHead(200),E.write(h),E.end()}catch(h){E.writeHead(500),E.write(String(h),p=>{p&&this.logService.error(p)}),E.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&y.existsSync(this._ipcHandlePath)&&y.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=D;let R=class extends D{constructor(u,E){super(u,E,(0,m.createRandomIPCHandle)())}};R=je([He(0,C.IExtHostCommands),He(1,S.ILogService)],R),e.CLIServer=R}),define(pe[286],ve([0,1,71,273,268,5,276,39,258,2,10,7,285,104]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends y.RequireInterceptor{_installInterceptor(){const I=this,w=Y.__$__nodeRequire("module"),a=w._load;w._load=function(g,o,_){for(let n of I._alternatives){let t=n(g);if(t){g=t;break}}return I._factories.has(g)?I._factories.get(g).load(g,D.URI.file((0,E.realpathSync)(o.filename)),n=>a.apply(this,[n,o,_])):a.apply(this,arguments)}}}class p extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const I=this._instaService.invokeFunction(F.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const o=this._instaService.createInstance(u.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}await this._instaService.createInstance(h,I,this._registry).install(),m.mark("code/extHost/didInitAPI");const a=await this._extHostConfiguration.getConfigProvider();await(0,i.connectProxyResolver)(this._extHostWorkspace,a,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const r=process.send,g=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...o)=>o.length===0||!o[0]||o[0].type!=="__$console"?r.apply(process,o):(g.$logExtensionHostMessage(o[0]),!1)}_getEntryPoint(I){return I.main}_loadCommonJSModule(I,w,a){if(w.scheme!==R.Schemas.file)throw new Error(`Cannot load URI: '${w}', must be of file-scheme`);let r=null;a.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${w.toString(!0)}`),this._logService.flush();try{I&&m.mark(`code/extHost/willLoadExtensionCode/${I.value}`),r=Y.__$__nodeRequire(w.fsPath)}catch(g){return Promise.reject(g)}finally{I&&m.mark(`code/extHost/didLoadExtensionCode/${I.value}`),a.codeLoadingStop()}return Promise.resolve(r)}async $setRemoteEnvironment(I){if(!!this._initData.remote.isRemote)for(const w in I){const a=I[w];a===null?delete process.env[w]:process.env[w]=a}}}e.ExtHostExtensionService=p}),define(pe[287],ve([0,1,83,261,270,269,284,286,262,55,39,72,70,34,52,67,260,259,11]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(R.IExtHostExtensionService,k.ExtHostExtensionService),(0,m.registerSingleton)(w.ILoggerService,I.ExtHostLoggerService),(0,m.registerSingleton)(p.IExtensionStoragePaths,v.ExtensionStoragePaths),(0,m.registerSingleton)(D.IExtHostDebugService,C.ExtHostDebugService),(0,m.registerSingleton)(P.IExtHostSearch,i.NativeExtHostSearch),(0,m.registerSingleton)(u.IExtHostTask,y.ExtHostTask),(0,m.registerSingleton)(E.IExtHostTerminalService,F.ExtHostTerminalService),(0,m.registerSingleton)(h.IExtHostTunnelService,S.ExtHostTunnelService)}),define(pe[288],ve([0,1,124,298,71,15,106,137,190,224,271,22,102,28,104,18,113,274,287]),function(Y,e,m,F,y,C,i,k,S,D,R,P,u,E,h,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let s=0;s<process.execArgv.length;s++)process.execArgv[s]==="--inspect-port=0"&&(process.execArgv.splice(s,1),s--)}();const I=F(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=Y.__$__nodeRequire("module"),s=t._load;t._load=function(d){if(d==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return s.apply(this,arguments)}})();const w=process.exit.bind(process);function a(t){process.exit=function(s){if(t)w(s);else{const d=new Error("An extension called process.exit() and this was prevented.");console.warn(d.stack)}},process.crash=function(){const s=new Error("An extension called process.crash() and this was prevented.");console.warn(s.stack)}}let r=function(t){w()};function g(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,s)=>{let d=null,c=setTimeout(()=>{r("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const f=108e5,l=3e5,b=new p.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (1)"),f),T=new p.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (2)"),l);process.on("message",(U,B)=>{if(U&&U.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const L=P.VSBuffer.wrap(Buffer.from(U.initialDataChunk,"base64"));let x;if(U.skipWebSocketFrames)x=new k.NodeSocket(B,"extHost-socket");else{const M=P.VSBuffer.wrap(Buffer.from(U.inflateBytes,"base64"));x=new k.WebSocketNodeSocket(new k.NodeSocket(B,"extHost-socket"),U.permessageDeflate,M,!1)}d?(b.cancel(),T.cancel(),d.beginAcceptReconnection(x,L),d.endAcceptReconnection(),d.sendResume()):(clearTimeout(c),d=new i.PersistentProtocol(x,L),d.sendResume(),d.onDidDispose(()=>r("renderer disconnected")),t(d),d.onSocketClose(()=>{b.schedule()}))}if(U&&U.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;b.isScheduled()&&T.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(A)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((s,d)=>{const c=m.createConnection(t,()=>{c.removeListener("error",d),s(new i.PersistentProtocol(new k.NodeSocket(c,"extHost-renderer")))});c.once("error",d),c.on("close",()=>{r("renderer closed the socket")})})}}async function o(){const t=await g();return new class{constructor(){this._onMessage=new i.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(s=>{(0,D.isMessageOfType)(s,2)?(this._terminating=!0,r("received terminate message from renderer")):this._onMessage.fire(s)})}send(s){this._terminating||t.send(s)}drain(){return t.drain()}}}function _(t){return new Promise(s=>{const d=t.onMessage(c=>{d.dispose();const f=JSON.parse(c.toString()),l=f.commit,b=S.default.commit;l&&b&&l!==b&&w(55);let T=0;setInterval(function(){try{process.kill(f.parentPid,0),T=0}catch(U){U&&U.code==="EPERM"?(T++,T>=3&&r(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${U.message} (code: ${U.code}) (errno: ${U.errno})`)):r(`parent process ${f.parentPid} does not exist anymore: ${U.message} (code: ${U.code}) (errno: ${U.errno})`)}},1e3);let A;try{A=Y.__$__nodeRequire("native-watchdog"),A.start(f.parentPid)}catch(U){(0,C.onUnexpectedError)(U)}t.send((0,D.createMessageOfType)(0)),s({protocol:t,initData:f})});t.send((0,D.createMessageOfType)(1))})}async function n(){const t=[];process.on("unhandledRejection",(T,A)=>{t.push(A),setTimeout(()=>{const U=t.indexOf(A);U>=0&&A.catch(B=>{t.splice(U,1),(0,C.isPromiseCanceledError)(B)||(console.warn(`rejected promise not handled within 1 second: ${B}`),B&&B.stack&&console.warn(`stack trace: ${B.stack}`),T&&(0,C.onUnexpectedError)(T))})},1e3)}),process.on("rejectionHandled",T=>{const A=t.indexOf(T);A>=0&&t.splice(A,1)}),process.on("uncaughtException",function(T){(0,C.onUnexpectedError)(T)}),y.mark("code/extHost/willConnectToRenderer");const s=await o();y.mark("code/extHost/didConnectToRenderer");const d=await _(s);y.mark("code/extHost/didWaitForInitData");const{initData:c}=d;a(!!c.environment.extensionTestsLocationURI),c.environment.useHostProxy=I.useHostProxy!==void 0?I.useHostProxy!=="false":void 0,c.environment.skipWorkspaceStorageLock=(0,v.boolean)(I.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(A){w(A)}exists(A){return E.Promises.exists(A)}realpath(A){return(0,h.realpath)(A)}};let l=null;if(c.remote.authority&&I.uriTransformerPath)try{const A=Y.__$__nodeRequire(I.uriTransformerPath)(c.remote.authority);l=new u.URITransformer(A)}catch(T){console.error(T)}const b=new R.ExtensionHostMain(d.protocol,c,f,l);r=T=>b.terminate(T)}e.startExtensionHostProcess=n}),define(pe[299],ve([0,1,288]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(F=>console.log(F))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/658e5c951e45a6df3591f82a3961cec49924ed9a/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
